#
# TABLE STRUCTURE FOR: acc_coa
#

DROP TABLE IF EXISTS `acc_coa`;

CREATE TABLE `acc_coa` (
  `HeadCode` varchar(50) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci NOT NULL,
  `HeadName` varchar(100) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci NOT NULL,
  `PHeadName` varchar(50) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci NOT NULL,
  `HeadLevel` int NOT NULL,
  `IsActive` tinyint(1) NOT NULL,
  `IsTransaction` tinyint(1) NOT NULL,
  `IsGL` tinyint(1) NOT NULL,
  `HeadType` char(1) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci NOT NULL,
  `IsBudget` tinyint(1) NOT NULL,
  `IsDepreciation` tinyint(1) NOT NULL,
  `customer_id` int DEFAULT NULL,
  `supplier_id` int DEFAULT NULL,
  `DepreciationRate` decimal(18,2) NOT NULL,
  `CreateBy` varchar(50) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci NOT NULL,
  `CreateDate` datetime NOT NULL,
  `UpdateBy` varchar(50) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci NOT NULL,
  `UpdateDate` datetime NOT NULL,
  PRIMARY KEY (`HeadName`),
  KEY `HeadCode` (`HeadCode`),
  KEY `customer_id` (`customer_id`),
  KEY `supplier_id` (`supplier_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000001', '1-Ashraf surgoda', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 1, '0.00', '1', '2024-01-24 14:20:39', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000001', '1-Cash Sale', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 1, NULL, '0.00', '1', '2024-01-23 16:54:00', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000008', '10-Memon LAD Light', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 10, '0.00', '1', '2024-01-27 16:16:31', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000009', '10-Zahid somoro', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 10, NULL, '0.00', '1', '2024-02-21 14:08:06', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000009', '11-Chilton Safan', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 11, '0.00', '1', '2024-01-28 10:48:05', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000011', '12-M.D.M Mill', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 12, NULL, '0.00', '1', '2024-02-21 14:10:18', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000012', '13-National Spining', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 13, NULL, '0.00', '1', '2024-02-21 14:13:55', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000011', '13-Olympic Sargodah', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 13, '0.00', '1', '2024-01-28 11:35:38', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000012', '14-ARY Sargodah', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 14, '0.00', '1', '2024-01-28 12:12:46', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000013', '14-C.E.P.T.C Kotri', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 14, NULL, '0.00', '1', '2024-02-21 14:14:59', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000013', '15-Al Mezan Sargodah', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 15, '0.00', '1', '2024-01-28 13:50:09', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000014', '15-Ashfaq Electric ', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 15, NULL, '0.00', '1', '2024-02-21 14:16:12', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000015', '16-Ahmed Electric ', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 16, NULL, '0.00', '1', '2024-02-21 14:17:10', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000014', '16-Asim Sargodah', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 16, '0.00', '1', '2024-01-28 14:03:52', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000016', '17-Abdul Qadir Electric ', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 17, NULL, '0.00', '1', '2024-02-21 14:18:16', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000017', '18-Deluxe Electric', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 18, NULL, '0.00', '1', '2024-02-21 14:19:27', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000016', '18-Perfect Sargodah', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 18, '0.00', '1', '2024-01-28 14:07:37', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000017', '19-E M Sargodah', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 19, '0.00', '1', '2024-01-28 14:39:02', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000018', '19-Feroz Bihar Colony  ', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 19, NULL, '0.00', '1', '2024-02-21 14:21:05', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000002', '2-Arslan LED', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 2, '0.00', '1', '2024-01-24 14:39:42', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000002', '2-Walking Customer', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 2, NULL, '0.00', '1', '2024-01-23 17:38:03', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000019', '20-M.Z Electric', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 20, NULL, '0.00', '1', '2024-02-21 14:22:19', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000018', '20-Sonex Sargodah', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 20, '0.00', '1', '2024-01-28 14:40:14', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000020', '21-M.K Electric ', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 21, NULL, '0.00', '1', '2024-02-21 14:22:58', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000021', '22-M.S Electric', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 22, NULL, '0.00', '1', '2024-02-21 14:24:15', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000020', '22-Sahar Al Fazal Sargodah', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 22, '0.00', '1', '2024-01-28 15:02:32', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000021', '23-Burq Sargodah', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 23, '0.00', '1', '2024-01-28 15:20:23', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000022', '23-Sattar Mallah Electric', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 23, NULL, '0.00', '1', '2024-02-21 14:25:03', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000022', '24-Fareed Qasim', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 24, '0.00', '1', '2024-01-29 14:39:55', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000023', '24-Mustufa Arif', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 24, NULL, '0.00', '1', '2024-02-22 12:15:24', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000023', '25-Aijaz PCV Karachi', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 25, '0.00', '1', '2024-01-30 14:46:43', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000024', '25-Eman Electric', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 25, NULL, '0.00', '1', '2024-02-22 12:45:02', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000025', '26-Ahmed kazi', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 26, NULL, '0.00', '1', '2024-02-22 14:12:43', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000024', '26-Jawaid Wire', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 26, '0.00', '1', '2024-01-30 16:11:07', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000025', '27-Haji salman Karachi', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 27, '0.00', '1', '2024-01-31 14:43:53', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000026', '27-Memon Light  ', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 27, NULL, '0.00', '1', '2024-02-22 14:13:35', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000026', '28-Fizan Wire', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 28, '0.00', '1', '2024-01-31 15:47:57', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000027', '28-Khalid Marfat ', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 28, NULL, '0.00', '1', '2024-02-22 14:14:29', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000027', '29-G.One LED Light', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 29, '0.00', '1', '2024-02-01 15:00:06', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000028', '29-M.K Electric', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 29, NULL, '0.00', '1', '2024-02-22 14:15:25', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000003', '3-Pak E \\ S Khi', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 3, '0.00', '1', '2024-01-24 15:02:37', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000029', '30-Master Pipe', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 30, NULL, '0.00', '1', '2024-02-22 14:19:21', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000028', '30-Moin PVC Karachi', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 30, '0.00', '1', '2024-02-01 16:05:09', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000029', '31-Arfeen Wire (Million)', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 31, '0.00', '1', '2024-02-03 14:28:32', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000030', '31-Razak H.M', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 31, NULL, '0.00', '1', '2024-02-22 14:21:53', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000030', '32-Millat Traders Loose Item', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 32, '0.00', '1', '2024-02-05 15:44:44', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000031', '32-Saffan Chilton ', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 32, NULL, '0.00', '1', '2024-02-24 12:05:07', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000032', '33-Ahmed Qazi', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 33, NULL, '0.00', '1', '2024-02-24 12:05:37', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000031', '33-Emaan Light House', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 33, '0.00', '1', '2024-02-07 15:58:07', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000032', '34-Chilton Traders Karachi', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 34, '0.00', '1', '2024-02-07 16:33:53', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000033', '34-Waleed Sale Man ', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 34, NULL, '0.00', '1', '2024-02-24 12:06:29', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000034', '35-Faheem hussnain', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 35, NULL, '0.00', '1', '2024-02-25 11:26:27', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000033', '35-Hameed Panel', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 35, '0.00', '1', '2024-02-07 16:34:48', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000034', '36-Fawad Wire', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 36, '0.00', '1', '2024-02-07 16:35:35', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000035', '36-Naeem Siyaal', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 36, NULL, '0.00', '1', '2024-02-25 11:27:48', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000035', '37-New Shahid Pipe', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 37, '0.00', '1', '2024-02-07 16:36:33', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000036', '37-Usmaan Bhai', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 37, NULL, '0.00', '1', '2024-02-25 11:28:25', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000037', '38-Adil qasam chowk', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 38, NULL, '0.00', '1', '2024-02-25 11:29:16', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000036', '38-HUawei ', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 38, '0.00', '1', '2024-02-07 16:37:33', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000038', '39-Azam Channa ', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 39, NULL, '0.00', '1', '2024-02-27 10:09:17', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000037', '39-Riaz Delux', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 39, '0.00', '1', '2024-02-07 16:38:26', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000004', '4-Qureshi pipe wala', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 4, '0.00', '1', '2024-01-24 15:27:10', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000039', '40-G.1 LED', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 40, NULL, '0.00', '1', '2024-03-05 10:27:33', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000038', '40-Paremount General', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 40, '0.00', '1', '2024-02-07 16:41:56', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000040', '41-Abdul Manaan ', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 41, NULL, '0.00', '1', '2024-03-06 08:20:39', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000039', '41-Muneer Shop', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 41, '0.00', '1', '2024-02-07 16:43:58', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000040', '42-Haji Salman Karachi', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 42, '0.00', '1', '2024-02-07 16:45:04', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000041', '42-M.Ameen', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 42, NULL, '0.00', '1', '2024-03-14 12:12:26', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000042', '43-Dawood Center Auto Bhan', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 43, NULL, '0.00', '1', '2024-03-20 11:08:00', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000041', '43-Royal Electri Karachi', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 43, '0.00', '1', '2024-02-07 16:46:29', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000043', '44-Hamza Electric Store ', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 44, NULL, '0.00', '1', '2024-03-23 12:06:22', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000042', '44-Sindh Electri Hyderabad', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 44, '0.00', '1', '2024-02-07 16:47:05', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000044', '45-shahid H.M ', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 45, NULL, '0.00', '1', '2024-03-23 15:37:33', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000043', '45-Zahid Soomro Kotri', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 45, '0.00', '1', '2024-02-07 16:48:05', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000044', '46-Naeem Pant', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 46, '0.00', '1', '2024-02-07 16:48:43', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000045', '46-Zahid Sale item', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 46, NULL, '0.00', '1', '2024-03-30 11:59:18', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000045', '47-Haroon Pant', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 47, '0.00', '1', '2024-02-07 16:49:14', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000046', '47-Zakki Sahab ', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 47, NULL, '0.00', '1', '2024-03-30 14:45:20', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000047', '48-Ali Bhai', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 48, NULL, '0.00', '1', '2024-04-04 15:11:51', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000046', '48-S.K Fan', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 48, '0.00', '1', '2024-02-07 16:49:58', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000048', '49-Cafe 7/11 ', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 49, NULL, '0.00', '1', '2024-04-08 10:30:16', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000047', '49-Cash Item ', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 49, '0.00', '1', '2024-02-13 14:54:06', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000004', '5-Credit Customer', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 5, NULL, '0.00', '1', '2024-02-20 14:33:58', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000048', '50-Abdul Hammed Panel wala', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 50, '0.00', '1', '2024-02-18 07:53:51', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000049', '50-Haji Salman', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 50, NULL, '0.00', '1', '2024-04-08 12:28:36', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000050', '51-Arif Electriction ', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 51, NULL, '0.00', '1', '2024-04-15 07:37:30', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000049', '51-F Ali Iddress Karachi', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 51, '0.00', '1', '2024-02-19 08:22:20', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000050', '52-M.S Electric Purchase ', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 52, '0.00', '1', '2024-02-24 15:02:12', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000051', '52-Riyaz Marfat ', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 52, NULL, '0.00', '1', '2024-04-16 08:58:59', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000052', '53-Dawood Super Mart', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 53, NULL, '0.00', '1', '2024-04-24 10:00:23', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000051', '53-Delux Electric Purchase ', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 53, '0.00', '1', '2024-03-04 09:53:33', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000053', '54-Alfa Sale ', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 54, NULL, '0.00', '1', '2024-04-25 12:43:09', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000052', '54-Majid Fan Rod ', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 54, '0.00', '1', '2024-03-11 09:27:34', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000053', '55-M.K Electric Purchase', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 55, '0.00', '1', '2024-03-11 09:29:58', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000054', '55-Mamu Jee', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 55, NULL, '0.00', '1', '2024-05-02 13:10:37', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000055', '56-S.E Light', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 56, NULL, '0.00', '1', '2024-05-07 09:56:28', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000054', '56-Sale Return ', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 56, '0.00', '1', '2024-03-14 07:54:03', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000056', '57-breez Chemical Mill', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 57, NULL, '0.00', '1', '2024-05-09 15:33:14', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000055', '57-M.Ali Doctor', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 57, '0.00', '1', '2024-03-24 16:22:48', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000056', '58-Abdul Qadir Purchase ', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 58, '0.00', '1', '2024-03-26 15:34:01', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000057', '58-Shano Contactor', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 58, NULL, '0.00', '1', '2024-05-12 13:10:54', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000058', '59-Chilton karachi ', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 59, NULL, '0.00', '1', '2024-05-14 15:36:10', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000057', '59-Yayha Karachi', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 59, '0.00', '1', '2024-04-02 15:50:44', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000005', '6-H.M CABLES', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 6, NULL, '0.00', '1', '2024-02-20 15:35:45', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000059', '60-Nadeem Bhai ', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 60, NULL, '0.00', '1', '2024-05-14 15:38:25', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000058', '60-Usman S.E ', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 60, '0.00', '1', '2024-04-07 07:41:21', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000059', '61-M.Z Purchase ', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 61, '0.00', '1', '2024-04-24 10:15:06', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000060', '62-Alfa Purchase ', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 62, '0.00', '1', '2024-04-25 12:25:58', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000061', '63-Universal Karachi', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 63, '0.00', '1', '2024-05-01 12:21:09', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000062', '65-Abdul Aziz Shikh', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 65, '0.00', '1', '2024-05-30 06:31:33', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('102030000006', '7-Faizan Basti ', 'Customer Receivable', 4, 1, 1, 0, 'A', 0, 0, 7, NULL, '0.00', '1', '2024-02-21 14:07:00', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000005', '7-P.V.C Mix item', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 7, '0.00', '1', '2024-01-27 14:40:54', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000006', '8-Akram PVC', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 8, '0.00', '1', '2024-01-27 15:06:21', '', '0000-00-00 00:00:00');
INSERT INTO `acc_coa` (`HeadCode`, `HeadName`, `PHeadName`, `HeadLevel`, `IsActive`, `IsTransaction`, `IsGL`, `HeadType`, `IsBudget`, `IsDepreciation`, `customer_id`, `supplier_id`, `DepreciationRate`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`) VALUES ('502000007', '9-Nasir Electric', 'Account Payable', 3, 1, 1, 0, 'L', 0, 0, NULL, 9, '0.00', '1', '2024-01-27 15:23:09', '', '0000-00-00 00:00:00');


#
# TABLE STRUCTURE FOR: acc_transaction
#

DROP TABLE IF EXISTS `acc_transaction`;

CREATE TABLE `acc_transaction` (
  `ID` int NOT NULL AUTO_INCREMENT,
  `VNo` varchar(50) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `Vtype` varchar(50) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `VDate` date DEFAULT NULL,
  `COAID` varchar(50) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci NOT NULL,
  `Narration` text CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci,
  `Debit` decimal(18,2) DEFAULT NULL,
  `Credit` decimal(18,2) DEFAULT NULL,
  `IsPosted` char(10) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `CreateBy` varchar(50) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `CreateDate` datetime DEFAULT NULL,
  `UpdateBy` varchar(50) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `UpdateDate` datetime DEFAULT NULL,
  `IsAppove` char(10) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  UNIQUE KEY `ID` (`ID`),
  KEY `COAID` (`COAID`)
) ENGINE=InnoDB AUTO_INCREMENT=7054 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1, '20240124145509', 'Purchase', '2023-12-31', '10107', 'Inventory Debit For Supplier Ashraf surgoda', '26880.00', '0.00', '1', '1', '2024-01-24 14:55:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2, '20240124145509', 'Purchase', '2023-12-31', '502000001', 'Supplier .Ashraf surgoda', '0.00', '26880.00', '1', '1', '2024-01-24 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3, '20240124145509', 'Purchase', '2023-12-31', '402', 'Company Credit For  Ashraf surgoda', '26880.00', '0.00', '1', '1', '2024-01-24 14:55:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (23, 'A3T5KT2DQS', 'PR Balance', '2024-01-25', '502000005', 'supplier debit For P.V.C Mix Item', '0.00', '30350.00', '1', '1', '2024-01-25 15:15:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (24, 'A3T5KT2DQS', 'PR Balance', '2024-01-25', '10107', 'Inventory credit For  P.V.C Mix Item', '30350.00', '0.00', '1', '1', '2024-01-25 15:15:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (25, 'HORIUJS9UU', 'PR Balance', '2024-01-27', '502000005', 'supplier debit For P.V.C Mix Item', '0.00', '30350.00', '1', '1', '2024-01-27 14:34:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (26, 'HORIUJS9UU', 'PR Balance', '2024-01-27', '10107', 'Inventory credit For  P.V.C Mix Item', '30350.00', '0.00', '1', '1', '2024-01-27 14:34:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (27, 'BXRMILQTIZ', 'PR Balance', '2024-01-27', '502000005', 'supplier debit For P.V.C Mix item', '0.00', '30350.00', '1', '1', '2024-01-27 14:40:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (28, 'BXRMILQTIZ', 'PR Balance', '2024-01-27', '10107', 'Inventory credit For  P.V.C Mix item', '30350.00', '0.00', '1', '1', '2024-01-27 14:40:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (34, '5DQ5V4T98C', 'PR Balance', '2024-01-27', '502000006', 'supplier debit For Akram PVC', '0.00', '90000.00', '1', '1', '2024-01-27 15:06:21', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (35, '5DQ5V4T98C', 'PR Balance', '2024-01-27', '10107', 'Inventory credit For  Akram PVC', '90000.00', '0.00', '1', '1', '2024-01-27 15:06:21', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (39, 'SYC9FM1LA4', 'PR Balance', '2024-01-27', '502000007', 'supplier debit For Nasir Electric', '0.00', '47450.00', '1', '1', '2024-01-27 15:23:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (40, 'SYC9FM1LA4', 'PR Balance', '2024-01-27', '10107', 'Inventory credit For  Nasir Electric', '47450.00', '0.00', '1', '1', '2024-01-27 15:23:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (66, '20240127150504', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier P.V.C Mix item', '30350.00', '0.00', '1', '1', '2024-01-27 15:48:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (67, '20240127150504', 'Purchase', '2023-12-31', '502000005', 'Supplier -P.V.C Mix item', '0.00', '30350.00', '1', '1', '2024-01-27 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (68, '20240127150504', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierP.V.C Mix item', '30350.00', '0.00', '1', '1', '2024-01-27 15:48:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (69, '20240127150504', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier P.V.C Mix item', '0.00', '30350.00', '1', '1', '2024-01-27 15:48:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (70, '20240127150504', 'Purchase', '2023-12-31', '502000005', 'Supplier . P.V.C Mix item', '30350.00', '0.00', '1', '1', '2024-01-27 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (93, '20240127161005', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier Nasir Electric', '47450.00', '0.00', '1', '1', '2024-01-28 11:54:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (94, '20240127161005', 'Purchase', '2023-12-31', '502000007', 'Supplier -Nasir Electric', '0.00', '47450.00', '1', '1', '2024-01-28 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (95, '20240127161005', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierNasir Electric', '47450.00', '0.00', '1', '1', '2024-01-28 11:54:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (96, '20240127161005', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier Nasir Electric', '0.00', '0.00', '1', '1', '2024-01-28 11:54:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (97, '20240127161005', 'Purchase', '2023-12-31', '502000007', 'Supplier . Nasir Electric', '0.00', '0.00', '1', '1', '2024-01-28 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (108, '20240128104627', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier Memon LAD Light', '210085.00', '0.00', '1', '1', '2024-01-28 11:56:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (109, '20240128104627', 'Purchase', '2023-12-31', '502000008', 'Supplier -Memon LAD Light', '0.00', '210085.00', '1', '1', '2024-01-28 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (110, '20240128104627', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierMemon LAD Light', '210085.00', '0.00', '1', '1', '2024-01-28 11:56:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (111, '20240128104627', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier Memon LAD Light', '0.00', '0.00', '1', '1', '2024-01-28 11:56:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (112, '20240128104627', 'Purchase', '2023-12-31', '502000008', 'Supplier . Memon LAD Light', '0.00', '0.00', '1', '1', '2024-01-28 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (478, '20240131153527', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier Haji salman Karachi', '79750.00', '0.00', '1', '1', '2024-02-12 16:11:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (479, '20240131153527', 'Purchase', '2023-12-31', '502000025', 'Supplier -Haji salman Karachi', '0.00', '79750.00', '1', '1', '2024-02-12 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (480, '20240131153527', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierHaji salman Karachi', '79750.00', '0.00', '1', '1', '2024-02-12 16:11:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (481, '20240131153527', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier Haji salman Karachi', '0.00', '0.00', '1', '1', '2024-02-12 16:11:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (482, '20240131153527', 'Purchase', '2023-12-31', '502000025', 'Supplier . Haji salman Karachi', '0.00', '0.00', '1', '1', '2024-02-12 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (574, '20240130155908', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier ARY Sargodah', '15870.00', '0.00', '1', '1', '2024-02-14 10:07:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (575, '20240130155908', 'Purchase', '2023-12-31', '502000012', 'Supplier -ARY Sargodah', '0.00', '15870.00', '1', '1', '2024-02-14 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (576, '20240130155908', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierARY Sargodah', '15870.00', '0.00', '1', '1', '2024-02-14 10:07:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (577, '20240130155908', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier ARY Sargodah', '0.00', '0.00', '1', '1', '2024-02-14 10:07:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (578, '20240130155908', 'Purchase', '2023-12-31', '502000012', 'Supplier . ARY Sargodah', '0.00', '0.00', '1', '1', '2024-02-14 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (702, '20240210161624', 'Purchase', '2024-01-01', '10107', 'Inventory Devit Supplier Emaan Light House', '38250.00', '0.00', '1', '1', '2024-02-17 16:26:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (703, '20240210161624', 'Purchase', '2024-01-01', '502000031', 'Supplier -Emaan Light House', '0.00', '38250.00', '1', '1', '2024-02-17 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (704, '20240210161624', 'Purchase', '2024-01-01', '402', 'Company Credit For SupplierEmaan Light House', '38250.00', '0.00', '1', '1', '2024-02-17 16:26:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (705, '20240210161624', 'Purchase', '2024-01-01', '1020101', 'Cash in Hand For Supplier Emaan Light House', '0.00', '0.00', '1', '1', '2024-02-17 16:26:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (706, '20240210161624', 'Purchase', '2024-01-01', '502000031', 'Supplier . Emaan Light House', '0.00', '0.00', '1', '1', '2024-02-17 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (707, '20240210151559', 'Purchase', '2024-01-01', '10107', 'Inventory Devit Supplier Emaan Light House', '76311.00', '0.00', '1', '1', '2024-02-17 16:27:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (708, '20240210151559', 'Purchase', '2024-01-01', '502000031', 'Supplier -Emaan Light House', '0.00', '76311.00', '1', '1', '2024-02-17 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (709, '20240210151559', 'Purchase', '2024-01-01', '402', 'Company Credit For SupplierEmaan Light House', '76311.00', '0.00', '1', '1', '2024-02-17 16:27:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (710, '20240210151559', 'Purchase', '2024-01-01', '1020101', 'Cash in Hand For Supplier Emaan Light House', '0.00', '0.00', '1', '1', '2024-02-17 16:27:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (711, '20240210151559', 'Purchase', '2024-01-01', '502000031', 'Supplier . Emaan Light House', '0.00', '0.00', '1', '1', '2024-02-17 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (712, '20240210154644', 'Purchase', '2024-01-01', '10107', 'Inventory Devit Supplier Emaan Light House', '7612.00', '0.00', '1', '1', '2024-02-17 16:28:19', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (713, '20240210154644', 'Purchase', '2024-01-01', '502000031', 'Supplier -Emaan Light House', '0.00', '7612.00', '1', '1', '2024-02-17 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (714, '20240210154644', 'Purchase', '2024-01-01', '402', 'Company Credit For SupplierEmaan Light House', '7612.00', '0.00', '1', '1', '2024-02-17 16:28:19', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (715, '20240210154644', 'Purchase', '2024-01-01', '1020101', 'Cash in Hand For Supplier Emaan Light House', '0.00', '0.00', '1', '1', '2024-02-17 16:28:19', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (716, '20240210154644', 'Purchase', '2024-01-01', '502000031', 'Supplier . Emaan Light House', '0.00', '0.00', '1', '1', '2024-02-17 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (725, '20240217164057', 'Purchase', '2024-01-01', '10107', 'Inventory Devit Supplier S.K Fan', '126000.00', '0.00', '1', '1', '2024-02-17 16:41:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (726, '20240217164057', 'Purchase', '2024-01-01', '502000046', 'Supplier -S.K Fan', '0.00', '126000.00', '1', '1', '2024-02-17 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (727, '20240217164057', 'Purchase', '2024-01-01', '402', 'Company Credit For SupplierS.K Fan', '126000.00', '0.00', '1', '1', '2024-02-17 16:41:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (728, '20240217164057', 'Purchase', '2024-01-01', '1020101', 'Cash in Hand For Supplier S.K Fan', '0.00', '0.00', '1', '1', '2024-02-17 16:41:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (729, '20240217164057', 'Purchase', '2024-01-01', '502000046', 'Supplier . S.K Fan', '0.00', '0.00', '1', '1', '2024-02-17 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (730, '20240217152346', 'Purchase', '2024-01-01', '10107', 'Inventory Devit Supplier Haroon Pant', '441900.00', '0.00', '1', '1', '2024-02-17 16:42:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (731, '20240217152346', 'Purchase', '2024-01-01', '502000045', 'Supplier -Haroon Pant', '0.00', '441900.00', '1', '1', '2024-02-17 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (732, '20240217152346', 'Purchase', '2024-01-01', '402', 'Company Credit For SupplierHaroon Pant', '441900.00', '0.00', '1', '1', '2024-02-17 16:42:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (733, '20240217152346', 'Purchase', '2024-01-01', '1020101', 'Cash in Hand For Supplier Haroon Pant', '0.00', '0.00', '1', '1', '2024-02-17 16:42:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (734, '20240217152346', 'Purchase', '2024-01-01', '502000045', 'Supplier . Haroon Pant', '0.00', '0.00', '1', '1', '2024-02-17 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (735, '20240217154738', 'Purchase', '2024-01-01', '10107', 'Inventory Devit Supplier Riaz Delux', '10750.00', '0.00', '1', '1', '2024-02-17 16:43:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (736, '20240217154738', 'Purchase', '2024-01-01', '502000037', 'Supplier -Riaz Delux', '0.00', '10750.00', '1', '1', '2024-02-17 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (737, '20240217154738', 'Purchase', '2024-01-01', '402', 'Company Credit For SupplierRiaz Delux', '10750.00', '0.00', '1', '1', '2024-02-17 16:43:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (738, '20240217154738', 'Purchase', '2024-01-01', '1020101', 'Cash in Hand For Supplier Riaz Delux', '0.00', '0.00', '1', '1', '2024-02-17 16:43:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (739, '20240217154738', 'Purchase', '2024-01-01', '502000037', 'Supplier . Riaz Delux', '0.00', '0.00', '1', '1', '2024-02-17 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (740, '20240217153045', 'Purchase', '2024-01-01', '10107', 'Inventory Devit Supplier Naeem Pant', '30000.00', '0.00', '1', '1', '2024-02-17 16:43:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (741, '20240217153045', 'Purchase', '2024-01-01', '502000044', 'Supplier -Naeem Pant', '0.00', '30000.00', '1', '1', '2024-02-17 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (742, '20240217153045', 'Purchase', '2024-01-01', '402', 'Company Credit For SupplierNaeem Pant', '30000.00', '0.00', '1', '1', '2024-02-17 16:43:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (743, '20240217153045', 'Purchase', '2024-01-01', '1020101', 'Cash in Hand For Supplier Naeem Pant', '0.00', '0.00', '1', '1', '2024-02-17 16:43:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (744, '20240217153045', 'Purchase', '2024-01-01', '502000044', 'Supplier . Naeem Pant', '0.00', '0.00', '1', '1', '2024-02-17 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (745, '20240217153659', 'Purchase', '2024-01-01', '10107', 'Inventory Devit Supplier Sindh Electri Hyderabad', '158000.00', '0.00', '1', '1', '2024-02-17 16:43:50', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (746, '20240217153659', 'Purchase', '2024-01-01', '502000042', 'Supplier -Sindh Electri Hyderabad', '0.00', '158000.00', '1', '1', '2024-02-17 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (747, '20240217153659', 'Purchase', '2024-01-01', '402', 'Company Credit For SupplierSindh Electri Hyderabad', '158000.00', '0.00', '1', '1', '2024-02-17 16:43:50', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (748, '20240217153659', 'Purchase', '2024-01-01', '1020101', 'Cash in Hand For Supplier Sindh Electri Hyderabad', '0.00', '0.00', '1', '1', '2024-02-17 16:43:50', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (749, '20240217153659', 'Purchase', '2024-01-01', '502000042', 'Supplier . Sindh Electri Hyderabad', '0.00', '0.00', '1', '1', '2024-02-17 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (781, '20240201145453', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier Fizan Wire', '123946.00', '0.00', '1', '1', '2024-02-18 09:09:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (782, '20240201145453', 'Purchase', '2023-12-31', '502000026', 'Supplier -Fizan Wire', '0.00', '123946.00', '1', '1', '2024-02-18 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (783, '20240201145453', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierFizan Wire', '123946.00', '0.00', '1', '1', '2024-02-18 09:09:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (784, '20240201145453', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier Fizan Wire', '0.00', '0.00', '1', '1', '2024-02-18 09:09:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (785, '20240201145453', 'Purchase', '2023-12-31', '502000026', 'Supplier . Fizan Wire', '0.00', '0.00', '1', '1', '2024-02-18 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (816, '20240214120913', 'Purchase', '2024-01-01', '10107', 'Inventory Devit Supplier Royal Electri Karachi', '124880.00', '0.00', '1', '1', '2024-02-18 09:32:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (817, '20240214120913', 'Purchase', '2024-01-01', '502000041', 'Supplier -Royal Electri Karachi', '0.00', '124880.00', '1', '1', '2024-02-18 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (818, '20240214120913', 'Purchase', '2024-01-01', '402', 'Company Credit For SupplierRoyal Electri Karachi', '124880.00', '0.00', '1', '1', '2024-02-18 09:32:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (819, '20240214120913', 'Purchase', '2024-01-01', '1020101', 'Cash in Hand For Supplier Royal Electri Karachi', '0.00', '0.00', '1', '1', '2024-02-18 09:32:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (820, '20240214120913', 'Purchase', '2024-01-01', '502000041', 'Supplier . Royal Electri Karachi', '0.00', '0.00', '1', '1', '2024-02-18 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (958, '5845776228', 'INV', '2024-02-18', '10107', 'Inventory credit For Invoice No1000', '0.00', '2260.00', '1', '1', '2024-02-18 15:20:19', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (959, '5845776228', 'INV', '2024-02-18', '102030000002', 'Customer debit For Invoice No -  1000 Customer Walking Customer', '2525.00', '0.00', '1', '1', '2024-02-18 15:20:19', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (960, '5845776228', 'INVOICE', '2024-02-18', '303', 'Sale Income For Invoice NO - 1000 Customer Walking Customer', '0.00', '2525.00', '1', '1', '2024-02-18 15:20:19', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (971, '6124985648', 'INV', '2024-02-18', '10107', 'Inventory credit For Invoice No1001', '0.00', '500.00', '1', '1', '2024-02-18 15:33:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (972, '6124985648', 'INV', '2024-02-18', '102030000002', 'Customer debit For Invoice No -  1001 Customer Walking Customer', '600.00', '0.00', '1', '1', '2024-02-18 15:33:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (973, '6124985648', 'INVOICE', '2024-02-18', '303', 'Sale Income For Invoice NO - 1001 Customer Walking Customer', '0.00', '600.00', '1', '1', '2024-02-18 15:33:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1085, '4977174268', 'INV', '2024-02-19', '10107', 'Inventory credit For Invoice No1002', '0.00', '4240.00', '1', '1', '2024-02-19 11:36:21', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1086, '4977174268', 'INVOICE', '2024-02-19', '303', 'Sale Income From Invoice NO - 1002 Customer Walking Customer', '0.00', '2370.00', '1', '1', '2024-02-19 11:36:21', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1087, '4977174268', 'INV', '2024-02-19', '102030000002', 'Customer debit For Invoice NO - 1002 customer-  Walking Customer', '2370.00', '0.00', '1', '1', '2024-02-19 11:36:21', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1098, '20240128145546', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier Sonex Sargodah', '33020.00', '0.00', '1', '1', '2024-02-19 11:39:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1099, '20240128145546', 'Purchase', '2023-12-31', '502000018', 'Supplier -Sonex Sargodah', '0.00', '33020.00', '1', '1', '2024-02-19 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1100, '20240128145546', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierSonex Sargodah', '33020.00', '0.00', '1', '1', '2024-02-19 11:39:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1101, '20240128145546', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier Sonex Sargodah', '0.00', '0.00', '1', '1', '2024-02-19 11:39:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1102, '20240128145546', 'Purchase', '2023-12-31', '502000018', 'Supplier . Sonex Sargodah', '0.00', '0.00', '1', '1', '2024-02-19 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1118, '4612744893', 'INV', '2024-02-19', '10107', 'Inventory credit For Invoice No1003', '0.00', '5910.00', '1', '1', '2024-02-19 12:02:15', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1119, '4612744893', 'INV', '2024-02-19', '102030000002', 'Customer debit For Invoice No -  1003 Customer Walking Customer', '5550.00', '0.00', '1', '1', '2024-02-19 12:02:15', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1120, '4612744893', 'INVOICE', '2024-02-19', '303', 'Sale Income For Invoice NO - 1003 Customer Walking Customer', '0.00', '5550.00', '1', '1', '2024-02-19 12:02:15', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1121, '2567782964', 'INV', '2024-02-19', '10107', 'Inventory credit For Invoice No1004', '0.00', '43551.00', '1', '1', '2024-02-19 12:14:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1122, '2567782964', 'INV', '2024-02-19', '102030000002', 'Customer debit For Invoice No -  1004 Customer Walking Customer', '31510.00', '0.00', '1', '1', '2024-02-19 12:14:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1123, '2567782964', 'INVOICE', '2024-02-19', '303', 'Sale Income For Invoice NO - 1004 Customer Walking Customer', '0.00', '31510.00', '1', '1', '2024-02-19 12:14:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1124, '9779858312', 'INV', '2024-02-19', '10107', 'Inventory credit For Invoice No1005', '0.00', '26190.00', '1', '1', '2024-02-19 12:30:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1125, '9779858312', 'INV', '2024-02-19', '102030000002', 'Customer debit For Invoice No -  1005 Customer Walking Customer', '10640.00', '0.00', '1', '1', '2024-02-19 12:30:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1126, '9779858312', 'INVOICE', '2024-02-19', '303', 'Sale Income For Invoice NO - 1005 Customer Walking Customer', '0.00', '10640.00', '1', '1', '2024-02-19 12:30:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1130, '3284257142', 'INV', '2024-02-19', '10107', 'Inventory credit For Invoice No1006', '0.00', '8040.00', '1', '1', '2024-02-19 12:36:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1131, '3284257142', 'INVOICE', '2024-02-19', '303', 'Sale Income From Invoice NO - 1006 Customer Walking Customer', '0.00', '5996.00', '1', '1', '2024-02-19 12:36:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1132, '3284257142', 'INV', '2024-02-19', '102030000002', 'Customer debit For Invoice NO - 1006 customer-  Walking Customer', '5996.00', '0.00', '1', '1', '2024-02-19 12:36:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1133, '9175169491', 'INV', '2024-02-19', '10107', 'Inventory credit For Invoice No1007', '0.00', '2700.00', '1', '1', '2024-02-19 12:39:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1134, '9175169491', 'INV', '2024-02-19', '102030000002', 'Customer debit For Invoice No -  1007 Customer Walking Customer', '2500.00', '0.00', '1', '1', '2024-02-19 12:39:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1135, '9175169491', 'INVOICE', '2024-02-19', '303', 'Sale Income For Invoice NO - 1007 Customer Walking Customer', '0.00', '2500.00', '1', '1', '2024-02-19 12:39:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1147, '8115955164', 'INV', '2024-02-19', '10107', 'Inventory credit For Invoice No1009', '0.00', '5290.00', '1', '1', '2024-02-19 13:14:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1148, '8115955164', 'INV', '2024-02-19', '102030000002', 'Customer debit For Invoice No -  1009 Customer Walking Customer', '3300.00', '0.00', '1', '1', '2024-02-19 13:14:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1149, '8115955164', 'INVOICE', '2024-02-19', '303', 'Sale Income For Invoice NO - 1009 Customer Walking Customer', '0.00', '3300.00', '1', '1', '2024-02-19 13:14:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1150, '6448414167', 'INV', '2024-02-19', '10107', 'Inventory credit For Invoice No1010', '0.00', '4000.00', '1', '1', '2024-02-19 13:18:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1151, '6448414167', 'INV', '2024-02-19', '102030000002', 'Customer debit For Invoice No -  1010 Customer Walking Customer', '5000.00', '0.00', '1', '1', '2024-02-19 13:18:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1152, '6448414167', 'INVOICE', '2024-02-19', '303', 'Sale Income For Invoice NO - 1010 Customer Walking Customer', '0.00', '5000.00', '1', '1', '2024-02-19 13:18:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1153, '7816741612', 'INV', '2024-02-19', '10107', 'Inventory credit For Invoice No1011', '0.00', '23487.00', '1', '1', '2024-02-19 13:22:02', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1154, '7816741612', 'INV', '2024-02-19', '102030000002', 'Customer debit For Invoice No -  1011 Customer Walking Customer', '23100.00', '0.00', '1', '1', '2024-02-19 13:22:02', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1155, '7816741612', 'INVOICE', '2024-02-19', '303', 'Sale Income For Invoice NO - 1011 Customer Walking Customer', '0.00', '23100.00', '1', '1', '2024-02-19 13:22:02', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1159, '5669212287', 'INV', '2024-02-19', '10107', 'Inventory credit For Invoice No1008', '0.00', '426967.00', '1', '1', '2024-02-19 13:36:05', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1160, '5669212287', 'INVOICE', '2024-02-19', '303', 'Sale Income From Invoice NO - 1008 Customer Walking Customer', '0.00', '111260.00', '1', '1', '2024-02-19 13:36:05', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1161, '5669212287', 'INV', '2024-02-19', '102030000002', 'Customer debit For Invoice NO - 1008 customer-  Walking Customer', '111260.00', '0.00', '1', '1', '2024-02-19 13:36:05', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1180, '4995667463', 'INV', '2024-02-19', '10107', 'Inventory credit For Invoice No1012', '0.00', '28408.00', '1', '1', '2024-02-19 13:41:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1181, '4995667463', 'INVOICE', '2024-02-19', '303', 'Sale Income From Invoice NO - 1012 Customer Walking Customer', '0.00', '24320.00', '1', '1', '2024-02-19 13:41:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1182, '4995667463', 'INV', '2024-02-19', '102030000002', 'Customer debit For Invoice NO - 1012 customer-  Walking Customer', '24320.00', '0.00', '1', '1', '2024-02-19 13:41:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1191, '20240205171507', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier Arfeen Wire (Million)', '89600.00', '0.00', '1', '1', '2024-02-19 13:53:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1192, '20240205171507', 'Purchase', '2023-12-31', '502000029', 'Supplier -Arfeen Wire (Million)', '0.00', '89600.00', '1', '1', '2024-02-19 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1193, '20240205171507', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierArfeen Wire (Million)', '89600.00', '0.00', '1', '1', '2024-02-19 13:53:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1194, '20240205171507', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier Arfeen Wire (Million)', '0.00', '0.00', '1', '1', '2024-02-19 13:53:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1195, '20240205171507', 'Purchase', '2023-12-31', '502000029', 'Supplier . Arfeen Wire (Million)', '0.00', '0.00', '1', '1', '2024-02-19 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1199, '7328171614', 'INV', '2024-02-19', '10107', 'Inventory credit For Invoice No1013', '0.00', '157367.00', '1', '1', '2024-02-19 14:12:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1200, '7328171614', 'INVOICE', '2024-02-19', '303', 'Sale Income From Invoice NO - 1013 Customer Walking Customer', '0.00', '50310.00', '1', '1', '2024-02-19 14:12:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1201, '7328171614', 'INV', '2024-02-19', '102030000002', 'Customer debit For Invoice NO - 1013 customer-  Walking Customer', '50310.00', '0.00', '1', '1', '2024-02-19 14:12:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1202, '6686419811', 'INV', '2024-02-19', '10107', 'Inventory credit For Invoice No1014', '0.00', '10541.00', '1', '1', '2024-02-19 14:21:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1203, '6686419811', 'INV', '2024-02-19', '102030000002', 'Customer debit For Invoice No -  1014 Customer Walking Customer', '6780.00', '0.00', '1', '1', '2024-02-19 14:21:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1204, '6686419811', 'INVOICE', '2024-02-19', '303', 'Sale Income For Invoice NO - 1014 Customer Walking Customer', '0.00', '6780.00', '1', '1', '2024-02-19 14:21:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1208, '4856684174', 'INV', '2024-02-19', '10107', 'Inventory credit For Invoice No1015', '0.00', '11498.00', '1', '1', '2024-02-19 14:36:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1209, '4856684174', 'INVOICE', '2024-02-19', '303', 'Sale Income From Invoice NO - 1015 Customer Walking Customer', '0.00', '7650.00', '1', '1', '2024-02-19 14:36:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1210, '4856684174', 'INV', '2024-02-19', '102030000002', 'Customer debit For Invoice NO - 1015 customer-  Walking Customer', '7650.00', '0.00', '1', '1', '2024-02-19 14:36:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1211, '1826916967', 'INV', '2024-02-19', '10107', 'Inventory credit For Invoice No1016', '0.00', '755.00', '1', '1', '2024-02-19 14:41:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1212, '1826916967', 'INV', '2024-02-19', '102030000002', 'Customer debit For Invoice No -  1016 Customer Walking Customer', '910.00', '0.00', '1', '1', '2024-02-19 14:41:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1213, '1826916967', 'INVOICE', '2024-02-19', '303', 'Sale Income For Invoice NO - 1016 Customer Walking Customer', '0.00', '910.00', '1', '1', '2024-02-19 14:41:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1214, '5976692598', 'INV', '2024-02-19', '10107', 'Inventory credit For Invoice No1017', '0.00', '6250.00', '1', '1', '2024-02-19 14:50:25', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1215, '5976692598', 'INV', '2024-02-19', '102030000002', 'Customer debit For Invoice No -  1017 Customer Walking Customer', '2500.00', '0.00', '1', '1', '2024-02-19 14:50:25', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1216, '5976692598', 'INVOICE', '2024-02-19', '303', 'Sale Income For Invoice NO - 1017 Customer Walking Customer', '0.00', '2500.00', '1', '1', '2024-02-19 14:50:25', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1217, '3371369953', 'INV', '2024-02-19', '10107', 'Inventory credit For Invoice No1018', '0.00', '95716.00', '1', '1', '2024-02-19 14:55:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1218, '3371369953', 'INV', '2024-02-19', '102030000002', 'Customer debit For Invoice No -  1018 Customer Walking Customer', '19820.00', '0.00', '1', '1', '2024-02-19 14:55:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1219, '3371369953', 'INVOICE', '2024-02-19', '303', 'Sale Income For Invoice NO - 1018 Customer Walking Customer', '0.00', '19820.00', '1', '1', '2024-02-19 14:55:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1233, '7976724629', 'INV', '2024-02-20', '10107', 'Inventory credit For Invoice No1019', '0.00', '46716.00', '1', '1', '2024-02-20 07:43:26', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1234, '7976724629', 'INVOICE', '2024-02-20', '303', 'Sale Income From Invoice NO - 1019 Customer Walking Customer', '0.00', '15520.00', '1', '1', '2024-02-20 07:43:26', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1235, '7976724629', 'INV', '2024-02-20', '102030000002', 'Customer debit For Invoice NO - 1019 customer-  Walking Customer', '15520.00', '0.00', '1', '1', '2024-02-20 07:43:26', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1269, '1249729836', 'INV', '2024-02-20', '10107', 'Inventory credit For Invoice No1020', '0.00', '677616.00', '1', '1', '2024-02-20 08:30:22', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1270, '1249729836', 'INVOICE', '2024-02-20', '303', 'Sale Income From Invoice NO - 1020 Customer Walking Customer', '0.00', '50010.00', '1', '1', '2024-02-20 08:30:22', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1271, '1249729836', 'INV', '2024-02-20', '102030000002', 'Customer debit For Invoice NO - 1020 customer-  Walking Customer', '50010.00', '0.00', '1', '1', '2024-02-20 08:30:22', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1280, '9759274115', 'INV', '2024-02-20', '10107', 'Inventory credit For Invoice No1021', '0.00', '20260.00', '1', '1', '2024-02-20 08:34:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1281, '9759274115', 'INVOICE', '2024-02-20', '303', 'Sale Income From Invoice NO - 1021 Customer Walking Customer', '0.00', '11010.00', '1', '1', '2024-02-20 08:34:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1282, '9759274115', 'INV', '2024-02-20', '102030000002', 'Customer debit For Invoice NO - 1021 customer-  Walking Customer', '11010.00', '0.00', '1', '1', '2024-02-20 08:34:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1289, '7677745934', 'INV', '2024-02-20', '10107', 'Inventory credit For Invoice No1022', '0.00', '20455.00', '1', '1', '2024-02-20 08:49:50', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1290, '7677745934', 'INVOICE', '2024-02-20', '303', 'Sale Income From Invoice NO - 1022 Customer Walking Customer', '0.00', '7960.00', '1', '1', '2024-02-20 08:49:50', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1291, '7677745934', 'INV', '2024-02-20', '102030000002', 'Customer debit For Invoice NO - 1022 customer-  Walking Customer', '7960.00', '0.00', '1', '1', '2024-02-20 08:49:50', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1311, '6139664445', 'INV', '2024-02-20', '10107', 'Inventory credit For Invoice No1024', '0.00', '35050.00', '1', '1', '2024-02-20 09:06:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1312, '6139664445', 'INV', '2024-02-20', '102030000002', 'Customer debit For Invoice No -  1024 Customer Walking Customer', '24740.00', '0.00', '1', '1', '2024-02-20 09:06:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1313, '6139664445', 'INVOICE', '2024-02-20', '303', 'Sale Income For Invoice NO - 1024 Customer Walking Customer', '0.00', '24740.00', '1', '1', '2024-02-20 09:06:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1314, '9814175468', 'INV', '2024-02-20', '10107', 'Inventory credit For Invoice No1025', '0.00', '260.00', '1', '1', '2024-02-20 09:08:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1315, '9814175468', 'INV', '2024-02-20', '102030000002', 'Customer debit For Invoice No -  1025 Customer Walking Customer', '400.00', '0.00', '1', '1', '2024-02-20 09:08:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1316, '9814175468', 'INVOICE', '2024-02-20', '303', 'Sale Income For Invoice NO - 1025 Customer Walking Customer', '0.00', '400.00', '1', '1', '2024-02-20 09:08:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1317, '8729851784', 'INV', '2024-02-20', '10107', 'Inventory credit For Invoice No1026', '0.00', '2060.00', '1', '1', '2024-02-20 09:09:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1318, '8729851784', 'INV', '2024-02-20', '102030000002', 'Customer debit For Invoice No -  1026 Customer Walking Customer', '2400.00', '0.00', '1', '1', '2024-02-20 09:09:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1319, '8729851784', 'INVOICE', '2024-02-20', '303', 'Sale Income For Invoice NO - 1026 Customer Walking Customer', '0.00', '2400.00', '1', '1', '2024-02-20 09:09:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1326, '4651242384', 'INV', '2024-02-20', '10107', 'Inventory credit For Invoice No1023', '0.00', '135094.00', '1', '1', '2024-02-20 09:37:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1327, '4651242384', 'INVOICE', '2024-02-20', '303', 'Sale Income From Invoice NO - 1023 Customer Walking Customer', '0.00', '19980.00', '1', '1', '2024-02-20 09:37:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1328, '4651242384', 'INV', '2024-02-20', '102030000002', 'Customer debit For Invoice NO - 1023 customer-  Walking Customer', '19980.00', '0.00', '1', '1', '2024-02-20 09:37:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1353, '7644324833', 'INV', '2024-02-20', '10107', 'Inventory credit For Invoice No1029', '0.00', '65157.00', '1', '1', '2024-02-20 10:13:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1354, '7644324833', 'INVOICE', '2024-02-20', '303', 'Sale Income From Invoice NO - 1029 Customer Walking Customer', '0.00', '55610.00', '1', '1', '2024-02-20 10:13:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1355, '7644324833', 'INV', '2024-02-20', '102030000002', 'Customer debit For Invoice NO - 1029 customer-  Walking Customer', '55610.00', '0.00', '1', '1', '2024-02-20 10:13:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1356, '1345623824', 'INV', '2024-02-20', '10107', 'Inventory credit For Invoice No1030', '0.00', '379779.00', '1', '1', '2024-02-20 10:16:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1357, '1345623824', 'INV', '2024-02-20', '102030000002', 'Customer debit For Invoice No -  1030 Customer Walking Customer', '10730.00', '0.00', '1', '1', '2024-02-20 10:16:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1358, '1345623824', 'INVOICE', '2024-02-20', '303', 'Sale Income For Invoice NO - 1030 Customer Walking Customer', '0.00', '10730.00', '1', '1', '2024-02-20 10:16:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1359, '5144393325', 'INV', '2024-02-20', '10107', 'Inventory credit For Invoice No1031', '0.00', '1750.00', '1', '1', '2024-02-20 10:17:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1360, '5144393325', 'INV', '2024-02-20', '102030000002', 'Customer debit For Invoice No -  1031 Customer Walking Customer', '2000.00', '0.00', '1', '1', '2024-02-20 10:17:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1361, '5144393325', 'INVOICE', '2024-02-20', '303', 'Sale Income For Invoice NO - 1031 Customer Walking Customer', '0.00', '2000.00', '1', '1', '2024-02-20 10:17:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1378, '4148625191', 'INV', '2024-02-20', '10107', 'Inventory credit For Invoice No1032', '0.00', '204373.00', '1', '1', '2024-02-20 10:59:05', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1379, '4148625191', 'INVOICE', '2024-02-20', '303', 'Sale Income From Invoice NO - 1032 Customer Walking Customer', '0.00', '177720.00', '1', '1', '2024-02-20 10:59:05', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1380, '4148625191', 'INV', '2024-02-20', '102030000002', 'Customer debit For Invoice NO - 1032 customer-  Walking Customer', '177720.00', '0.00', '1', '1', '2024-02-20 10:59:05', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1392, '4365216877', 'INV', '2024-02-20', '10107', 'Inventory credit For Invoice No1033', '0.00', '257386.00', '1', '1', '2024-02-20 12:20:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1393, '4365216877', 'INVOICE', '2024-02-20', '303', 'Sale Income From Invoice NO - 1033 Customer Walking Customer', '0.00', '88130.00', '1', '1', '2024-02-20 12:20:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1394, '4365216877', 'INV', '2024-02-20', '102030000002', 'Customer debit For Invoice NO - 1033 customer-  Walking Customer', '88130.00', '0.00', '1', '1', '2024-02-20 12:20:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1395, '4863552591', 'INV', '2024-02-20', '10107', 'Inventory credit For Invoice No1034', '0.00', '1690.00', '1', '1', '2024-02-20 12:24:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1396, '4863552591', 'INV', '2024-02-20', '102030000002', 'Customer debit For Invoice No -  1034 Customer Walking Customer', '1500.00', '0.00', '1', '1', '2024-02-20 12:24:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1397, '4863552591', 'INVOICE', '2024-02-20', '303', 'Sale Income For Invoice NO - 1034 Customer Walking Customer', '0.00', '1500.00', '1', '1', '2024-02-20 12:24:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1398, '1589449478', 'INV', '2024-02-20', '10107', 'Inventory credit For Invoice No1035', '0.00', '56791.00', '1', '1', '2024-02-20 12:29:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1399, '1589449478', 'INV', '2024-02-20', '102030000002', 'Customer debit For Invoice No -  1035 Customer Walking Customer', '10700.00', '0.00', '1', '1', '2024-02-20 12:29:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1400, '1589449478', 'INVOICE', '2024-02-20', '303', 'Sale Income For Invoice NO - 1035 Customer Walking Customer', '0.00', '10700.00', '1', '1', '2024-02-20 12:29:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1401, '4687811218', 'INV', '2024-02-20', '10107', 'Inventory credit For Invoice No1036', '0.00', '56791.00', '1', '1', '2024-02-20 12:30:10', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1402, '4687811218', 'INV', '2024-02-20', '102030000002', 'Customer debit For Invoice No -  1036 Customer Walking Customer', '10700.00', '0.00', '1', '1', '2024-02-20 12:30:10', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1403, '4687811218', 'INVOICE', '2024-02-20', '303', 'Sale Income For Invoice NO - 1036 Customer Walking Customer', '0.00', '10700.00', '1', '1', '2024-02-20 12:30:10', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1448, '1246899298', 'INV', '2024-02-21', '10107', 'Inventory credit For Invoice No1039', '0.00', '22300.00', '1', '1', '2024-02-21 09:22:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1449, '1246899298', 'INV', '2024-02-21', '102030000005', 'Customer debit For Invoice No -  1039 Customer H.M CABLES', '9440.00', '0.00', '1', '1', '2024-02-21 09:22:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1450, '1246899298', 'INVOICE', '2024-02-21', '303', 'Sale Income For Invoice NO - 1039 Customer H.M CABLES', '0.00', '9440.00', '1', '1', '2024-02-21 09:22:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1454, '9619147336', 'INV', '2024-02-21', '10107', 'Inventory credit For Invoice No1037', '0.00', '69715.00', '1', '1', '2024-02-21 09:35:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1455, '9619147336', 'INVOICE', '2024-02-21', '303', 'Sale Income From Invoice NO - 1037 Customer Walking Customer', '0.00', '50140.00', '1', '1', '2024-02-21 09:35:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1456, '9619147336', 'INV', '2024-02-21', '102030000002', 'Customer debit For Invoice NO - 1037 customer-  Walking Customer', '50140.00', '0.00', '1', '1', '2024-02-21 09:35:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1460, '6671999227', 'INV', '2024-02-21', '10107', 'Inventory credit For Invoice No1041', '0.00', '3250.00', '1', '1', '2024-02-21 09:43:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1461, '6671999227', 'INV', '2024-02-21', '102030000005', 'Customer debit For Invoice No -  1041 Customer H.M CABLES', '11500.00', '0.00', '1', '1', '2024-02-21 09:43:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1462, '6671999227', 'INVOICE', '2024-02-21', '303', 'Sale Income For Invoice NO - 1041 Customer H.M CABLES', '0.00', '11500.00', '1', '1', '2024-02-21 09:43:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1463, '6776515978', 'INV', '2024-02-21', '10107', 'Inventory credit For Invoice No1042', '0.00', '24600.00', '1', '1', '2024-02-21 09:45:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1464, '6776515978', 'INV', '2024-02-21', '102030000005', 'Customer debit For Invoice No -  1042 Customer H.M CABLES', '31800.00', '0.00', '1', '1', '2024-02-21 09:45:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1465, '6776515978', 'INVOICE', '2024-02-21', '303', 'Sale Income For Invoice NO - 1042 Customer H.M CABLES', '0.00', '31800.00', '1', '1', '2024-02-21 09:45:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1466, '5329238352', 'INV', '2024-02-21', '10107', 'Inventory credit For Invoice No1043', '0.00', '2430.00', '1', '1', '2024-02-21 09:49:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1467, '5329238352', 'INV', '2024-02-21', '102030000005', 'Customer debit For Invoice No -  1043 Customer H.M CABLES', '3550.00', '0.00', '1', '1', '2024-02-21 09:49:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1468, '5329238352', 'INVOICE', '2024-02-21', '303', 'Sale Income For Invoice NO - 1043 Customer H.M CABLES', '0.00', '3550.00', '1', '1', '2024-02-21 09:49:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1469, '3187145389', 'INV', '2024-02-21', '10107', 'Inventory credit For Invoice No1044', '0.00', '89600.00', '1', '1', '2024-02-21 09:53:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1470, '3187145389', 'INV', '2024-02-21', '102030000005', 'Customer debit For Invoice No -  1044 Customer H.M CABLES', '29800.00', '0.00', '1', '1', '2024-02-21 09:53:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1471, '3187145389', 'INVOICE', '2024-02-21', '303', 'Sale Income For Invoice NO - 1044 Customer H.M CABLES', '0.00', '29800.00', '1', '1', '2024-02-21 09:53:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1472, '9741378871', 'INV', '2024-02-21', '10107', 'Inventory credit For Invoice No1045', '0.00', '21120.00', '1', '1', '2024-02-21 10:07:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1473, '9741378871', 'INV', '2024-02-21', '102030000005', 'Customer debit For Invoice No -  1045 Customer H.M CABLES', '25660.00', '0.00', '1', '1', '2024-02-21 10:07:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1474, '9741378871', 'INVOICE', '2024-02-21', '303', 'Sale Income For Invoice NO - 1045 Customer H.M CABLES', '0.00', '25660.00', '1', '1', '2024-02-21 10:07:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1478, '4732574941', 'INV', '2024-02-21', '10107', 'Inventory credit For Invoice No1040', '0.00', '35650.00', '1', '1', '2024-02-21 10:19:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1479, '4732574941', 'INVOICE', '2024-02-21', '303', 'Sale Income From Invoice NO - 1040 Customer H.M CABLES', '0.00', '45050.00', '1', '1', '2024-02-21 10:19:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1480, '4732574941', 'INV', '2024-02-21', '102030000005', 'Customer debit For Invoice NO - 1040 customer-  H.M CABLES', '45050.00', '0.00', '1', '1', '2024-02-21 10:19:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1484, '3215962328', 'INV', '2024-02-21', '10107', 'Inventory credit For Invoice No1046', '0.00', '538068.00', '1', '1', '2024-02-21 10:37:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1485, '3215962328', 'INVOICE', '2024-02-21', '303', 'Sale Income From Invoice NO - 1046 Customer H.M CABLES', '0.00', '30540.00', '1', '1', '2024-02-21 10:37:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1486, '3215962328', 'INV', '2024-02-21', '102030000005', 'Customer debit For Invoice NO - 1046 customer-  H.M CABLES', '30540.00', '0.00', '1', '1', '2024-02-21 10:37:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1487, '1844216916', 'INV', '2024-02-21', '10107', 'Inventory credit For Invoice No1047', '0.00', '24900.00', '1', '1', '2024-02-21 10:39:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1488, '1844216916', 'INV', '2024-02-21', '102030000005', 'Customer debit For Invoice No -  1047 Customer H.M CABLES', '31800.00', '0.00', '1', '1', '2024-02-21 10:39:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1489, '1844216916', 'INVOICE', '2024-02-21', '303', 'Sale Income For Invoice NO - 1047 Customer H.M CABLES', '0.00', '31800.00', '1', '1', '2024-02-21 10:39:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1490, '5337563468', 'INV', '2024-02-21', '10107', 'Inventory credit For Invoice No1048', '0.00', '15590.00', '1', '1', '2024-02-21 10:52:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1491, '5337563468', 'INV', '2024-02-21', '102030000005', 'Customer debit For Invoice No -  1048 Customer H.M CABLES', '18450.00', '0.00', '1', '1', '2024-02-21 10:52:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1492, '5337563468', 'INVOICE', '2024-02-21', '303', 'Sale Income For Invoice NO - 1048 Customer H.M CABLES', '0.00', '18450.00', '1', '1', '2024-02-21 10:52:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1493, '2824924738', 'INV', '2024-02-21', '10107', 'Inventory credit For Invoice No1049', '0.00', '16830.00', '1', '1', '2024-02-21 10:54:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1494, '2824924738', 'INV', '2024-02-21', '102030000005', 'Customer debit For Invoice No -  1049 Customer H.M CABLES', '12090.00', '0.00', '1', '1', '2024-02-21 10:54:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1495, '2824924738', 'INVOICE', '2024-02-21', '303', 'Sale Income For Invoice NO - 1049 Customer H.M CABLES', '0.00', '12090.00', '1', '1', '2024-02-21 10:54:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1502, '6524154835', 'INV', '2024-02-21', '10107', 'Inventory credit For Invoice No1050', '0.00', '28945.00', '1', '1', '2024-02-21 12:13:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1503, '6524154835', 'INVOICE', '2024-02-21', '303', 'Sale Income From Invoice NO - 1050 Customer H.M CABLES', '0.00', '-224240.00', '1', '1', '2024-02-21 12:13:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1504, '6524154835', 'INV', '2024-02-21', '102030000005', 'Customer debit For Invoice NO - 1050 customer-  H.M CABLES', '25440.00', '0.00', '1', '1', '2024-02-21 12:13:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1508, '2892979613', 'INV', '2024-02-21', '10107', 'Inventory credit For Invoice No1051', '0.00', '24709.00', '1', '1', '2024-02-21 12:17:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1509, '2892979613', 'INVOICE', '2024-02-21', '303', 'Sale Income From Invoice NO - 1051 Customer H.M CABLES', '0.00', '25590.00', '1', '1', '2024-02-21 12:17:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1510, '2892979613', 'INV', '2024-02-21', '102030000005', 'Customer debit For Invoice NO - 1051 customer-  H.M CABLES', '25590.00', '0.00', '1', '1', '2024-02-21 12:17:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1514, '3895873329', 'INV', '2024-02-21', '10107', 'Inventory credit For Invoice No1052', '0.00', '188640.00', '1', '1', '2024-02-21 13:27:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1515, '3895873329', 'INVOICE', '2024-02-21', '303', 'Sale Income From Invoice NO - 1052 Customer H.M CABLES', '0.00', '126680.00', '1', '1', '2024-02-21 13:27:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1516, '3895873329', 'INV', '2024-02-21', '102030000005', 'Customer debit For Invoice NO - 1052 customer-  H.M CABLES', '126680.00', '0.00', '1', '1', '2024-02-21 13:27:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1517, '2769281188', 'INV', '2024-02-21', '10107', 'Inventory credit For Invoice No1053', '0.00', '30000.00', '1', '1', '2024-02-21 13:29:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1518, '2769281188', 'INV', '2024-02-21', '102030000005', 'Customer debit For Invoice No -  1053 Customer H.M CABLES', '50000.00', '0.00', '1', '1', '2024-02-21 13:29:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1519, '2769281188', 'INVOICE', '2024-02-21', '303', 'Sale Income For Invoice NO - 1053 Customer H.M CABLES', '0.00', '50000.00', '1', '1', '2024-02-21 13:29:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1520, '3928135646', 'INV', '2024-02-21', '10107', 'Inventory credit For Invoice No1054', '0.00', '162000.00', '1', '1', '2024-02-21 13:32:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1521, '3928135646', 'INV', '2024-02-21', '102030000005', 'Customer debit For Invoice No -  1054 Customer H.M CABLES', '182600.00', '0.00', '1', '1', '2024-02-21 13:32:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1522, '3928135646', 'INVOICE', '2024-02-21', '303', 'Sale Income For Invoice NO - 1054 Customer H.M CABLES', '0.00', '182600.00', '1', '1', '2024-02-21 13:32:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1523, '2496582565', 'INV', '2024-02-21', '10107', 'Inventory credit For Invoice No1055', '0.00', '1600.00', '1', '1', '2024-02-21 13:35:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1524, '2496582565', 'INV', '2024-02-21', '102030000005', 'Customer debit For Invoice No -  1055 Customer H.M CABLES', '2700.00', '0.00', '1', '1', '2024-02-21 13:35:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1525, '2496582565', 'INVOICE', '2024-02-21', '303', 'Sale Income For Invoice NO - 1055 Customer H.M CABLES', '0.00', '2700.00', '1', '1', '2024-02-21 13:35:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1529, '5243247132', 'INV', '2024-02-21', '10107', 'Inventory credit For Invoice No1057', '0.00', '38245.00', '1', '1', '2024-02-21 13:52:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1530, '5243247132', 'INV', '2024-02-21', '102030000005', 'Customer debit For Invoice No -  1057 Customer H.M CABLES', '10760.00', '0.00', '1', '1', '2024-02-21 13:52:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1531, '5243247132', 'INVOICE', '2024-02-21', '303', 'Sale Income For Invoice NO - 1057 Customer H.M CABLES', '0.00', '10760.00', '1', '1', '2024-02-21 13:52:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1532, '1537578668', 'INV', '2024-02-21', '10107', 'Inventory credit For Invoice No1058', '0.00', '4650.00', '1', '1', '2024-02-21 13:56:31', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1533, '1537578668', 'INV', '2024-02-21', '102030000005', 'Customer debit For Invoice No -  1058 Customer H.M CABLES', '5700.00', '0.00', '1', '1', '2024-02-21 13:56:31', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1534, '1537578668', 'INVOICE', '2024-02-21', '303', 'Sale Income For Invoice NO - 1058 Customer H.M CABLES', '0.00', '5700.00', '1', '1', '2024-02-21 13:56:31', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1535, '7242458569', 'INV', '2024-02-21', '10107', 'Inventory credit For Invoice No1059', '0.00', '16000.00', '1', '1', '2024-02-21 13:58:22', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1536, '7242458569', 'INV', '2024-02-21', '102030000005', 'Customer debit For Invoice No -  1059 Customer H.M CABLES', '19000.00', '0.00', '1', '1', '2024-02-21 13:58:22', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1537, '7242458569', 'INVOICE', '2024-02-21', '303', 'Sale Income For Invoice NO - 1059 Customer H.M CABLES', '0.00', '19000.00', '1', '1', '2024-02-21 13:58:22', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1538, '8155338425', 'INV', '2024-02-21', '10107', 'Inventory credit For Invoice No1060', '0.00', '4650.00', '1', '1', '2024-02-21 13:58:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1539, '8155338425', 'INV', '2024-02-21', '102030000005', 'Customer debit For Invoice No -  1060 Customer H.M CABLES', '5700.00', '0.00', '1', '1', '2024-02-21 13:58:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1540, '8155338425', 'INVOICE', '2024-02-21', '303', 'Sale Income For Invoice NO - 1060 Customer H.M CABLES', '0.00', '5700.00', '1', '1', '2024-02-21 13:58:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1554, '4495791598', 'INV', '2024-02-21', '10107', 'Inventory credit For Invoice No1062', '0.00', '2680.00', '1', '1', '2024-02-21 15:54:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1555, '4495791598', 'INV', '2024-02-21', '102030000005', 'Customer debit For Invoice No -  1062 Customer H.M CABLES', '3370.00', '0.00', '1', '1', '2024-02-21 15:54:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1556, '4495791598', 'INVOICE', '2024-02-21', '303', 'Sale Income For Invoice NO - 1062 Customer H.M CABLES', '0.00', '3370.00', '1', '1', '2024-02-21 15:54:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1570, '9184796385', 'INV', '2024-02-21', '10107', 'Inventory credit For Invoice No1061', '0.00', '11460.00', '1', '1', '2024-02-21 16:12:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1571, '9184796385', 'INVOICE', '2024-02-21', '303', 'Sale Income From Invoice NO - 1061 Customer H.M CABLES', '0.00', '11730.00', '1', '1', '2024-02-21 16:12:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1572, '9184796385', 'INV', '2024-02-21', '102030000005', 'Customer debit For Invoice NO - 1061 customer-  H.M CABLES', '11730.00', '0.00', '1', '1', '2024-02-21 16:12:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1573, '2153462153', 'INV', '2024-02-21', '10107', 'Inventory credit For Invoice No1063', '0.00', '500.00', '1', '1', '2024-02-21 16:13:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1574, '2153462153', 'INVOICE', '2024-02-21', '303', 'Sale Income From Invoice NO - 1063 Customer H.M CABLES', '0.00', '560.00', '1', '1', '2024-02-21 16:13:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1575, '2153462153', 'INV', '2024-02-21', '102030000005', 'Customer debit For Invoice NO - 1063 customer-  H.M CABLES', '560.00', '0.00', '1', '1', '2024-02-21 16:13:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1589, '1389596898', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1064', '0.00', '22330.00', '1', '1', '2024-02-22 08:15:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1590, '1389596898', 'INVOICE', '2024-02-22', '303', 'Sale Income From Invoice NO - 1064 Customer M.D.M Mill', '0.00', '25650.00', '1', '1', '2024-02-22 08:15:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1591, '1389596898', 'INV', '2024-02-22', '102030000011', 'Customer debit For Invoice NO - 1064 customer-  M.D.M Mill', '25650.00', '0.00', '1', '1', '2024-02-22 08:15:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1592, '2976925275', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1065', '0.00', '9600.00', '1', '1', '2024-02-22 08:17:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1593, '2976925275', 'INV', '2024-02-22', '102030000011', 'Customer debit For Invoice No -  1065 Customer M.D.M Mill', '22800.00', '0.00', '1', '1', '2024-02-22 08:17:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1594, '2976925275', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1065 Customer M.D.M Mill', '0.00', '22800.00', '1', '1', '2024-02-22 08:17:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1595, '9441918497', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1066', '0.00', '8110.00', '1', '1', '2024-02-22 08:27:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1596, '9441918497', 'INV', '2024-02-22', '102030000011', 'Customer debit For Invoice No -  1066 Customer M.D.M Mill', '6260.00', '0.00', '1', '1', '2024-02-22 08:27:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1597, '9441918497', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1066 Customer M.D.M Mill', '0.00', '6260.00', '1', '1', '2024-02-22 08:27:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1606, '7267276659', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1067', '0.00', '12080.00', '1', '1', '2024-02-22 08:40:16', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1607, '7267276659', 'INVOICE', '2024-02-22', '303', 'Sale Income From Invoice NO - 1067 Customer M.D.M Mill', '0.00', '11400.00', '1', '1', '2024-02-22 08:40:16', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1608, '7267276659', 'INV', '2024-02-22', '102030000011', 'Customer debit For Invoice NO - 1067 customer-  M.D.M Mill', '11400.00', '0.00', '1', '1', '2024-02-22 08:40:16', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1609, '9363166494', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1068', '0.00', '126000.00', '1', '1', '2024-02-22 08:42:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1610, '9363166494', 'INV', '2024-02-22', '102030000011', 'Customer debit For Invoice No -  1068 Customer M.D.M Mill', '156600.00', '0.00', '1', '1', '2024-02-22 08:42:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1611, '9363166494', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1068 Customer M.D.M Mill', '0.00', '156600.00', '1', '1', '2024-02-22 08:42:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1612, '9644382867', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1069', '0.00', '24136.00', '1', '1', '2024-02-22 08:49:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1613, '9644382867', 'INV', '2024-02-22', '102030000022', 'Customer debit For Invoice No -  1069 Customer Sattar Mallah Electric', '24600.00', '0.00', '1', '1', '2024-02-22 08:49:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1614, '9644382867', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1069 Customer Sattar Mallah Electric', '0.00', '24600.00', '1', '1', '2024-02-22 08:49:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1631, '1961533534', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1070', '0.00', '58228.00', '1', '1', '2024-02-22 09:21:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1632, '1961533534', 'INVOICE', '2024-02-22', '303', 'Sale Income From Invoice NO - 1070 Customer Sattar Mallah Electric', '0.00', '32490.00', '1', '1', '2024-02-22 09:21:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1633, '1961533534', 'INV', '2024-02-22', '102030000022', 'Customer debit For Invoice NO - 1070 customer-  Sattar Mallah Electric', '32490.00', '0.00', '1', '1', '2024-02-22 09:21:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1634, '7978897387', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1071', '0.00', '8628.00', '1', '1', '2024-02-22 09:30:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1635, '7978897387', 'INV', '2024-02-22', '102030000022', 'Customer debit For Invoice No -  1071 Customer Sattar Mallah Electric', '5160.00', '0.00', '1', '1', '2024-02-22 09:30:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1636, '7978897387', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1071 Customer Sattar Mallah Electric', '0.00', '5160.00', '1', '1', '2024-02-22 09:30:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1640, '1694367774', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1073', '0.00', '42640.00', '1', '1', '2024-02-22 09:59:25', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1641, '1694367774', 'INV', '2024-02-22', '102030000022', 'Customer debit For Invoice No -  1073 Customer Sattar Mallah Electric', '23036.00', '0.00', '1', '1', '2024-02-22 09:59:25', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1642, '1694367774', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1073 Customer Sattar Mallah Electric', '0.00', '23036.00', '1', '1', '2024-02-22 09:59:25', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1643, '7318964635', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1074', '0.00', '2300.00', '1', '1', '2024-02-22 10:02:17', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1644, '7318964635', 'INV', '2024-02-22', '102030000006', 'Customer debit For Invoice No -  1074 Customer Faizan Basti ', '2400.00', '0.00', '1', '1', '2024-02-22 10:02:17', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1645, '7318964635', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1074 Customer Faizan Basti ', '0.00', '2400.00', '1', '1', '2024-02-22 10:02:17', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1646, '6569258597', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1075', '0.00', '11800.00', '1', '1', '2024-02-22 10:04:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1647, '6569258597', 'INV', '2024-02-22', '102030000006', 'Customer debit For Invoice No -  1075 Customer Faizan Basti ', '13260.00', '0.00', '1', '1', '2024-02-22 10:04:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1648, '6569258597', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1075 Customer Faizan Basti ', '0.00', '13260.00', '1', '1', '2024-02-22 10:04:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1649, '7317117295', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1076', '0.00', '5830.00', '1', '1', '2024-02-22 10:06:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1650, '7317117295', 'INV', '2024-02-22', '102030000006', 'Customer debit For Invoice No -  1076 Customer Faizan Basti ', '5332.00', '0.00', '1', '1', '2024-02-22 10:06:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1651, '7317117295', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1076 Customer Faizan Basti ', '0.00', '5332.00', '1', '1', '2024-02-22 10:06:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1652, '3346761442', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1077', '0.00', '3720.00', '1', '1', '2024-02-22 10:07:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1653, '3346761442', 'INV', '2024-02-22', '102030000006', 'Customer debit For Invoice No -  1077 Customer Faizan Basti ', '3720.00', '0.00', '1', '1', '2024-02-22 10:07:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1654, '3346761442', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1077 Customer Faizan Basti ', '0.00', '3720.00', '1', '1', '2024-02-22 10:07:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1655, '6777296441', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1078', '0.00', '13050.00', '1', '1', '2024-02-22 10:09:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1656, '6777296441', 'INV', '2024-02-22', '102030000006', 'Customer debit For Invoice No -  1078 Customer Faizan Basti ', '10400.00', '0.00', '1', '1', '2024-02-22 10:09:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1657, '6777296441', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1078 Customer Faizan Basti ', '0.00', '10400.00', '1', '1', '2024-02-22 10:09:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1661, '5633688734', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1080', '0.00', '1210.00', '1', '1', '2024-02-22 10:12:15', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1662, '5633688734', 'INV', '2024-02-22', '102030000006', 'Customer debit For Invoice No -  1080 Customer Faizan Basti ', '1630.00', '0.00', '1', '1', '2024-02-22 10:12:15', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1663, '5633688734', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1080 Customer Faizan Basti ', '0.00', '1630.00', '1', '1', '2024-02-22 10:12:15', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1664, '1145742434', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1081', '0.00', '8300.00', '1', '1', '2024-02-22 10:15:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1665, '1145742434', 'INV', '2024-02-22', '102030000006', 'Customer debit For Invoice No -  1081 Customer Faizan Basti ', '7930.00', '0.00', '1', '1', '2024-02-22 10:15:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1666, '1145742434', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1081 Customer Faizan Basti ', '0.00', '7930.00', '1', '1', '2024-02-22 10:15:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1667, '5345941923', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1082', '0.00', '9100.00', '1', '1', '2024-02-22 10:19:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1668, '5345941923', 'INV', '2024-02-22', '102030000006', 'Customer debit For Invoice No -  1082 Customer Faizan Basti ', '8850.00', '0.00', '1', '1', '2024-02-22 10:19:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1669, '5345941923', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1082 Customer Faizan Basti ', '0.00', '8850.00', '1', '1', '2024-02-22 10:19:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1670, '8647385565', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1083', '0.00', '42350.00', '1', '1', '2024-02-22 10:27:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1671, '8647385565', 'INV', '2024-02-22', '102030000009', 'Customer debit For Invoice No -  1083 Customer Zahid somoro', '42800.00', '0.00', '1', '1', '2024-02-22 10:27:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1672, '8647385565', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1083 Customer Zahid somoro', '0.00', '42800.00', '1', '1', '2024-02-22 10:27:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1673, '1512229224', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1084', '0.00', '21702.00', '1', '1', '2024-02-22 10:29:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1674, '1512229224', 'INV', '2024-02-22', '102030000009', 'Customer debit For Invoice No -  1084 Customer Zahid somoro', '22000.00', '0.00', '1', '1', '2024-02-22 10:29:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1675, '1512229224', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1084 Customer Zahid somoro', '0.00', '22000.00', '1', '1', '2024-02-22 10:29:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1676, '5198483319', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1085', '0.00', '20951.00', '1', '1', '2024-02-22 10:31:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1677, '5198483319', 'INV', '2024-02-22', '102030000009', 'Customer debit For Invoice No -  1085 Customer Zahid somoro', '21200.00', '0.00', '1', '1', '2024-02-22 10:31:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1678, '5198483319', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1085 Customer Zahid somoro', '0.00', '21200.00', '1', '1', '2024-02-22 10:31:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1679, '1247375455', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1086', '0.00', '11844.00', '1', '1', '2024-02-22 10:31:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1680, '1247375455', 'INV', '2024-02-22', '102030000009', 'Customer debit For Invoice No -  1086 Customer Zahid somoro', '12000.00', '0.00', '1', '1', '2024-02-22 10:31:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1681, '1247375455', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1086 Customer Zahid somoro', '0.00', '12000.00', '1', '1', '2024-02-22 10:31:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1682, '8442146984', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1087', '0.00', '17766.00', '1', '1', '2024-02-22 10:32:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1683, '8442146984', 'INV', '2024-02-22', '102030000009', 'Customer debit For Invoice No -  1087 Customer Zahid somoro', '18000.00', '0.00', '1', '1', '2024-02-22 10:32:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1684, '8442146984', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1087 Customer Zahid somoro', '0.00', '18000.00', '1', '1', '2024-02-22 10:32:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1685, '6457347775', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1088', '0.00', '2560.00', '1', '1', '2024-02-22 10:33:43', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1686, '6457347775', 'INV', '2024-02-22', '102030000009', 'Customer debit For Invoice No -  1088 Customer Zahid somoro', '3280.00', '0.00', '1', '1', '2024-02-22 10:33:43', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1687, '6457347775', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1088 Customer Zahid somoro', '0.00', '3280.00', '1', '1', '2024-02-22 10:33:43', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1688, '8951465191', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1089', '0.00', '18214.00', '1', '1', '2024-02-22 10:35:10', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1689, '8951465191', 'INV', '2024-02-22', '102030000009', 'Customer debit For Invoice No -  1089 Customer Zahid somoro', '18400.00', '0.00', '1', '1', '2024-02-22 10:35:10', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1690, '8951465191', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1089 Customer Zahid somoro', '0.00', '18400.00', '1', '1', '2024-02-22 10:35:10', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1691, '3846623832', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1090', '0.00', '45049.00', '1', '1', '2024-02-22 10:38:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1692, '3846623832', 'INV', '2024-02-22', '102030000017', 'Customer debit For Invoice No -  1090 Customer Deluxe Electric', '45100.00', '0.00', '1', '1', '2024-02-22 10:38:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1693, '3846623832', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1090 Customer Deluxe Electric', '0.00', '45100.00', '1', '1', '2024-02-22 10:38:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1694, '7939478389', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1091', '0.00', '2625.00', '1', '1', '2024-02-22 10:39:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1695, '7939478389', 'INV', '2024-02-22', '102030000017', 'Customer debit For Invoice No -  1091 Customer Deluxe Electric', '2750.00', '0.00', '1', '1', '2024-02-22 10:39:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1696, '7939478389', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1091 Customer Deluxe Electric', '0.00', '2750.00', '1', '1', '2024-02-22 10:39:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1697, '9574331962', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1092', '0.00', '35894.00', '1', '1', '2024-02-22 10:41:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1698, '9574331962', 'INV', '2024-02-22', '102030000017', 'Customer debit For Invoice No -  1092 Customer Deluxe Electric', '37000.00', '0.00', '1', '1', '2024-02-22 10:41:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1699, '9574331962', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1092 Customer Deluxe Electric', '0.00', '37000.00', '1', '1', '2024-02-22 10:41:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1700, '4474956213', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1093', '0.00', '33259.00', '1', '1', '2024-02-22 10:45:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1701, '4474956213', 'INV', '2024-02-22', '102030000017', 'Customer debit For Invoice No -  1093 Customer Deluxe Electric', '40700.00', '0.00', '1', '1', '2024-02-22 10:45:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1702, '4474956213', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1093 Customer Deluxe Electric', '0.00', '40700.00', '1', '1', '2024-02-22 10:45:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1703, '5827966316', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1094', '0.00', '30282.00', '1', '1', '2024-02-22 12:00:15', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1704, '5827966316', 'INV', '2024-02-22', '102030000017', 'Customer debit For Invoice No -  1094 Customer Deluxe Electric', '35166.00', '0.00', '1', '1', '2024-02-22 12:00:15', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1705, '5827966316', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1094 Customer Deluxe Electric', '0.00', '35166.00', '1', '1', '2024-02-22 12:00:15', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1706, '3629774983', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1095', '0.00', '30282.00', '1', '1', '2024-02-22 12:01:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1707, '3629774983', 'INV', '2024-02-22', '102030000017', 'Customer debit For Invoice No -  1095 Customer Deluxe Electric', '37300.00', '0.00', '1', '1', '2024-02-22 12:01:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1708, '3629774983', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1095 Customer Deluxe Electric', '0.00', '37300.00', '1', '1', '2024-02-22 12:01:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1709, '7537392644', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1096', '0.00', '720.00', '1', '1', '2024-02-22 12:03:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1710, '7537392644', 'INV', '2024-02-22', '102030000017', 'Customer debit For Invoice No -  1096 Customer Deluxe Electric', '780.00', '0.00', '1', '1', '2024-02-22 12:03:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1711, '7537392644', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1096 Customer Deluxe Electric', '0.00', '780.00', '1', '1', '2024-02-22 12:03:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1712, '5814974916', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1097', '0.00', '12292.00', '1', '1', '2024-02-22 12:12:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1713, '5814974916', 'INV', '2024-02-22', '102030000017', 'Customer debit For Invoice No -  1097 Customer Deluxe Electric', '17400.00', '0.00', '1', '1', '2024-02-22 12:12:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1714, '5814974916', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1097 Customer Deluxe Electric', '0.00', '17400.00', '1', '1', '2024-02-22 12:12:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1715, '3887523765', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1098', '0.00', '161990.00', '1', '1', '2024-02-22 12:29:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1716, '3887523765', 'INV', '2024-02-22', '102030000023', 'Customer debit For Invoice No -  1098 Customer Mustufa Arif', '43350.00', '0.00', '1', '1', '2024-02-22 12:29:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1717, '3887523765', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1098 Customer Mustufa Arif', '0.00', '43350.00', '1', '1', '2024-02-22 12:29:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1736, '3978519419', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1105', '0.00', '8740.00', '1', '1', '2024-02-22 12:37:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1737, '3978519419', 'INV', '2024-02-22', '102030000023', 'Customer debit For Invoice No -  1105 Customer Mustufa Arif', '7600.00', '0.00', '1', '1', '2024-02-22 12:37:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1738, '3978519419', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1105 Customer Mustufa Arif', '0.00', '7600.00', '1', '1', '2024-02-22 12:37:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1739, '1216835466', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1104', '0.00', '0.00', '1', '1', '2024-02-22 12:41:43', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1740, '1216835466', 'INVOICE', '2024-02-22', '303', 'Sale Income From Invoice NO - 1104 Customer Mustufa Arif', '0.00', '0.00', '1', '1', '2024-02-22 12:41:43', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1741, '1216835466', 'INV', '2024-02-22', '102030000023', 'Customer debit For Invoice NO - 1104 customer-  Mustufa Arif', '0.00', '0.00', '1', '1', '2024-02-22 12:41:43', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1760, '3174111365', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1109', '0.00', '1087680.00', '1', '1', '2024-02-22 13:47:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1761, '3174111365', 'INV', '2024-02-22', '102030000012', 'Customer debit For Invoice No -  1109 Customer National Spining', '216420.00', '0.00', '1', '1', '2024-02-22 13:47:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1762, '3174111365', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1109 Customer National Spining', '0.00', '216420.00', '1', '1', '2024-02-22 13:47:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1763, '6686827297', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1110', '0.00', '44000.00', '1', '1', '2024-02-22 13:49:16', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1764, '6686827297', 'INV', '2024-02-22', '102030000012', 'Customer debit For Invoice No -  1110 Customer National Spining', '70000.00', '0.00', '1', '1', '2024-02-22 13:49:16', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1765, '6686827297', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1110 Customer National Spining', '0.00', '70000.00', '1', '1', '2024-02-22 13:49:16', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1766, '5956241346', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1111', '0.00', '31680.00', '1', '1', '2024-02-22 13:50:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1767, '5956241346', 'INV', '2024-02-22', '102030000012', 'Customer debit For Invoice No -  1111 Customer National Spining', '37200.00', '0.00', '1', '1', '2024-02-22 13:50:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1768, '5956241346', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1111 Customer National Spining', '0.00', '37200.00', '1', '1', '2024-02-22 13:50:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1769, '5917543216', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1112', '0.00', '15850.00', '1', '1', '2024-02-22 13:53:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1770, '5917543216', 'INV', '2024-02-22', '102030000012', 'Customer debit For Invoice No -  1112 Customer National Spining', '18780.00', '0.00', '1', '1', '2024-02-22 13:53:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1771, '5917543216', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1112 Customer National Spining', '0.00', '18780.00', '1', '1', '2024-02-22 13:53:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1772, '8875543688', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1113', '0.00', '4954.00', '1', '1', '2024-02-22 13:57:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1773, '8875543688', 'INV', '2024-02-22', '102030000012', 'Customer debit For Invoice No -  1113 Customer National Spining', '8400.00', '0.00', '1', '1', '2024-02-22 13:57:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1774, '8875543688', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1113 Customer National Spining', '0.00', '8400.00', '1', '1', '2024-02-22 13:57:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1775, '1353652854', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1114', '0.00', '2980.00', '1', '1', '2024-02-22 13:59:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1776, '1353652854', 'INV', '2024-02-22', '102030000024', 'Customer debit For Invoice No -  1114 Customer Eman Electric', '2880.00', '0.00', '1', '1', '2024-02-22 13:59:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1777, '1353652854', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1114 Customer Eman Electric', '0.00', '2880.00', '1', '1', '2024-02-22 13:59:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1781, '2558616487', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1116', '0.00', '13318.00', '1', '1', '2024-02-22 14:27:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1782, '2558616487', 'INV', '2024-02-22', '102030000027', 'Customer debit For Invoice No -  1116 Customer Khalid Marfat ', '14560.00', '0.00', '1', '1', '2024-02-22 14:27:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1783, '2558616487', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1116 Customer Khalid Marfat ', '0.00', '14560.00', '1', '1', '2024-02-22 14:27:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1784, '5312784753', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1117', '0.00', '3400.00', '1', '1', '2024-02-22 14:28:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1785, '5312784753', 'INV', '2024-02-22', '102030000013', 'Customer debit For Invoice No -  1117 Customer C.E.P.T.C Kotri', '3920.00', '0.00', '1', '1', '2024-02-22 14:28:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1786, '5312784753', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1117 Customer C.E.P.T.C Kotri', '0.00', '3920.00', '1', '1', '2024-02-22 14:28:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1787, '9453311658', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1118', '0.00', '38432.00', '1', '1', '2024-02-22 14:33:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1788, '9453311658', 'INV', '2024-02-22', '102030000026', 'Customer debit For Invoice No -  1118 Customer Memon Light  ', '59800.00', '0.00', '1', '1', '2024-02-22 14:33:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1789, '9453311658', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1118 Customer Memon Light  ', '0.00', '59800.00', '1', '1', '2024-02-22 14:33:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1790, '1224191136', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1119', '0.00', '29610.00', '1', '1', '2024-02-22 14:34:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1791, '1224191136', 'INV', '2024-02-22', '102030000026', 'Customer debit For Invoice No -  1119 Customer Memon Light  ', '59220.00', '0.00', '1', '1', '2024-02-22 14:34:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1792, '1224191136', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1119 Customer Memon Light  ', '0.00', '59220.00', '1', '1', '2024-02-22 14:34:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1793, '2784477898', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1120', '0.00', '40920.00', '1', '1', '2024-02-22 14:36:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1794, '2784477898', 'INV', '2024-02-22', '102030000026', 'Customer debit For Invoice No -  1120 Customer Memon Light  ', '41500.00', '0.00', '1', '1', '2024-02-22 14:36:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1795, '2784477898', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1120 Customer Memon Light  ', '0.00', '41500.00', '1', '1', '2024-02-22 14:36:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1796, '5821247238', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1121', '0.00', '270970.00', '1', '1', '2024-02-22 14:38:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1797, '5821247238', 'INV', '2024-02-22', '102030000026', 'Customer debit For Invoice No -  1121 Customer Memon Light  ', '275170.00', '0.00', '1', '1', '2024-02-22 14:38:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1798, '5821247238', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1121 Customer Memon Light  ', '0.00', '275170.00', '1', '1', '2024-02-22 14:38:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1799, '8636229268', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1122', '0.00', '43022.00', '1', '1', '2024-02-22 14:41:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1800, '8636229268', 'INV', '2024-02-22', '102030000029', 'Customer debit For Invoice No -  1122 Customer Master Pipe', '43477.00', '0.00', '1', '1', '2024-02-22 14:41:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1801, '8636229268', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1122 Customer Master Pipe', '0.00', '43477.00', '1', '1', '2024-02-22 14:41:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1808, '9721211439', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1124', '0.00', '89916.00', '1', '1', '2024-02-22 15:02:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1809, '9721211439', 'INVOICE', '2024-02-22', '303', 'Sale Income From Invoice NO - 1124 Customer Abdul Qadir Electric ', '0.00', '93000.00', '1', '1', '2024-02-22 15:02:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1810, '9721211439', 'INV', '2024-02-22', '102030000016', 'Customer debit For Invoice NO - 1124 customer-  Abdul Qadir Electric ', '93000.00', '0.00', '1', '1', '2024-02-22 15:02:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1811, '5445939478', 'INV', '2024-02-22', '10107', 'Inventory credit For Invoice No1125', '0.00', '367770.00', '1', '1', '2024-02-22 15:11:21', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1812, '5445939478', 'INV', '2024-02-22', '102030000020', 'Customer debit For Invoice No -  1125 Customer M.K Electric ', '287610.00', '0.00', '1', '1', '2024-02-22 15:11:21', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1813, '5445939478', 'INVOICE', '2024-02-22', '303', 'Sale Income For Invoice NO - 1125 Customer M.K Electric ', '0.00', '287610.00', '1', '1', '2024-02-22 15:11:21', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1814, '7438387912', 'INV', '2024-02-24', '10107', 'Inventory credit For Invoice No1126', '0.00', '23100.00', '1', '1', '2024-02-24 11:48:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1815, '7438387912', 'INV', '2024-02-24', '102030000018', 'Customer debit For Invoice No -  1126 Customer Feroz Bihar Colony  ', '24200.00', '0.00', '1', '1', '2024-02-24 11:48:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1816, '7438387912', 'INVOICE', '2024-02-24', '303', 'Sale Income For Invoice NO - 1126 Customer Feroz Bihar Colony  ', '0.00', '24200.00', '1', '1', '2024-02-24 11:48:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1827, '6659953793', 'INV', '2024-02-24', '10107', 'Inventory credit For Invoice No1127', '0.00', '53504.00', '1', '1', '2024-02-24 12:11:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1828, '6659953793', 'INV', '2024-02-24', '102030000033', 'Customer debit For Invoice No -  1127 Customer Waleed Sale Man ', '52500.00', '0.00', '1', '1', '2024-02-24 12:11:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1829, '6659953793', 'INVOICE', '2024-02-24', '303', 'Sale Income For Invoice NO - 1127 Customer Waleed Sale Man ', '0.00', '52500.00', '1', '1', '2024-02-24 12:11:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1830, '1345872945', 'INV', '2024-02-24', '10107', 'Inventory credit For Invoice No1128', '0.00', '41170.00', '1', '1', '2024-02-24 12:18:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1831, '1345872945', 'INV', '2024-02-24', '102030000025', 'Customer debit For Invoice No -  1128 Customer Ahmed kazi', '43300.00', '0.00', '1', '1', '2024-02-24 12:18:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1832, '1345872945', 'INVOICE', '2024-02-24', '303', 'Sale Income For Invoice NO - 1128 Customer Ahmed kazi', '0.00', '43300.00', '1', '1', '2024-02-24 12:18:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1833, '9837819267', 'INV', '2024-02-24', '10107', 'Inventory credit For Invoice No1129', '0.00', '14986.00', '1', '1', '2024-02-24 12:20:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1834, '9837819267', 'INV', '2024-02-24', '102030000031', 'Customer debit For Invoice No -  1129 Customer Saffan Chilton ', '15220.00', '0.00', '1', '1', '2024-02-24 12:20:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1835, '9837819267', 'INVOICE', '2024-02-24', '303', 'Sale Income For Invoice NO - 1129 Customer Saffan Chilton ', '0.00', '15220.00', '1', '1', '2024-02-24 12:20:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1836, '8421377642', 'INV', '2024-02-24', '10107', 'Inventory credit For Invoice No1130', '0.00', '21522.00', '1', '1', '2024-02-24 12:22:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1837, '8421377642', 'INV', '2024-02-24', '102030000021', 'Customer debit For Invoice No -  1130 Customer M.S Electric', '20800.00', '0.00', '1', '1', '2024-02-24 12:22:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1838, '8421377642', 'INVOICE', '2024-02-24', '303', 'Sale Income For Invoice NO - 1130 Customer M.S Electric', '0.00', '20800.00', '1', '1', '2024-02-24 12:22:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1847, '1775667854', 'INV', '2024-02-24', '10107', 'Inventory credit For Invoice No1123', '0.00', '14100.00', '1', '1', '2024-02-24 12:32:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1848, '1775667854', 'INVOICE', '2024-02-24', '303', 'Sale Income From Invoice NO - 1123 Customer Razak H.M', '0.00', '14150.00', '1', '1', '2024-02-24 12:32:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1849, '1775667854', 'INV', '2024-02-24', '102030000030', 'Customer debit For Invoice NO - 1123 customer-  Razak H.M', '14150.00', '0.00', '1', '1', '2024-02-24 12:32:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1850, '3455599945', 'INV', '2024-02-24', '10107', 'Inventory credit For Invoice No1131', '0.00', '43404.00', '1', '1', '2024-02-24 12:38:15', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1851, '3455599945', 'INV', '2024-02-24', '102030000018', 'Customer debit For Invoice No -  1131 Customer Feroz Bihar Colony  ', '45800.00', '0.00', '1', '1', '2024-02-24 12:38:15', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1852, '3455599945', 'INVOICE', '2024-02-24', '303', 'Sale Income For Invoice NO - 1131 Customer Feroz Bihar Colony  ', '0.00', '45800.00', '1', '1', '2024-02-24 12:38:15', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1858, '4299693644', 'INV', '2024-02-24', '10107', 'Inventory credit For Invoice No1115', '0.00', '8331.00', '1', '1', '2024-02-24 12:44:17', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1859, '4299693644', 'INVOICE', '2024-02-24', '303', 'Sale Income From Invoice NO - 1115 Customer Eman Electric', '0.00', '9220.00', '1', '1', '2024-02-24 12:44:17', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1860, '4299693644', 'INV', '2024-02-24', '102030000024', 'Customer debit For Invoice NO - 1115 customer-  Eman Electric', '9220.00', '0.00', '1', '1', '2024-02-24 12:44:17', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1864, '2687949442', 'INV', '2024-02-24', '10107', 'Inventory credit For Invoice No1108', '0.00', '13220.00', '1', '1', '2024-02-24 12:53:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1865, '2687949442', 'INVOICE', '2024-02-24', '303', 'Sale Income From Invoice NO - 1108 Customer M.Z Electric', '0.00', '9880.00', '1', '1', '2024-02-24 12:53:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1866, '2687949442', 'INV', '2024-02-24', '102030000019', 'Customer debit For Invoice NO - 1108 customer-  M.Z Electric', '9880.00', '0.00', '1', '1', '2024-02-24 12:53:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1875, '4876678161', 'INV', '2024-02-24', '10107', 'Inventory credit For Invoice No1106', '0.00', '5640.00', '1', '1', '2024-02-24 12:57:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1876, '4876678161', 'INVOICE', '2024-02-24', '303', 'Sale Income From Invoice NO - 1106 Customer Eman Electric', '0.00', '5350.00', '1', '1', '2024-02-24 12:57:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1877, '4876678161', 'INV', '2024-02-24', '102030000024', 'Customer debit For Invoice NO - 1106 customer-  Eman Electric', '5350.00', '0.00', '1', '1', '2024-02-24 12:57:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1899, '6845814617', 'INV', '2024-02-24', '10107', 'Inventory credit For Invoice No1107', '0.00', '6360.00', '1', '1', '2024-02-24 13:12:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1900, '6845814617', 'INVOICE', '2024-02-24', '303', 'Sale Income From Invoice NO - 1107 Customer Ahmed Electric ', '0.00', '7160.00', '1', '1', '2024-02-24 13:12:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1901, '6845814617', 'INV', '2024-02-24', '102030000015', 'Customer debit For Invoice NO - 1107 customer-  Ahmed Electric ', '7160.00', '0.00', '1', '1', '2024-02-24 13:12:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1907, '2212879286', 'INV', '2024-02-24', '10107', 'Inventory credit For Invoice No1072', '0.00', '23784.00', '1', '1', '2024-02-24 13:30:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1908, '2212879286', 'INVOICE', '2024-02-24', '303', 'Sale Income From Invoice NO - 1072 Customer Faizan Basti ', '0.00', '11620.00', '1', '1', '2024-02-24 13:30:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1909, '2212879286', 'INV', '2024-02-24', '102030000006', 'Customer debit For Invoice NO - 1072 customer-  Faizan Basti ', '11620.00', '0.00', '1', '1', '2024-02-24 13:30:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1958, '4247718784', 'INV', '2024-02-24', '10107', 'Inventory credit For Invoice No1103', '0.00', '0.00', '1', '1', '2024-02-24 15:52:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1959, '4247718784', 'INVOICE', '2024-02-24', '303', 'Sale Income From Invoice NO - 1103 Customer Mustufa Arif', '0.00', '0.00', '1', '1', '2024-02-24 15:52:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1960, '4247718784', 'INV', '2024-02-24', '102030000023', 'Customer debit For Invoice NO - 1103 customer-  Mustufa Arif', '0.00', '0.00', '1', '1', '2024-02-24 15:52:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1961, '5137841171', 'INV', '2024-02-24', '10107', 'Inventory credit For Invoice No1099', '0.00', '0.00', '1', '1', '2024-02-24 15:53:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1962, '5137841171', 'INVOICE', '2024-02-24', '303', 'Sale Income From Invoice NO - 1099 Customer Mustufa Arif', '0.00', '0.00', '1', '1', '2024-02-24 15:53:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1963, '5137841171', 'INV', '2024-02-24', '102030000023', 'Customer debit For Invoice NO - 1099 customer-  Mustufa Arif', '0.00', '0.00', '1', '1', '2024-02-24 15:53:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1970, '7435381842', 'INV', '2024-02-24', '10107', 'Inventory credit For Invoice No1102', '0.00', '0.00', '1', '1', '2024-02-24 15:55:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1971, '7435381842', 'INVOICE', '2024-02-24', '303', 'Sale Income From Invoice NO - 1102 Customer Mustufa Arif', '0.00', '0.00', '1', '1', '2024-02-24 15:55:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1972, '7435381842', 'INV', '2024-02-24', '102030000023', 'Customer debit For Invoice NO - 1102 customer-  Mustufa Arif', '0.00', '0.00', '1', '1', '2024-02-24 15:55:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1973, '3491818584', 'INV', '2024-02-24', '10107', 'Inventory credit For Invoice No1101', '0.00', '0.00', '1', '1', '2024-02-24 15:59:43', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1974, '3491818584', 'INVOICE', '2024-02-24', '303', 'Sale Income From Invoice NO - 1101 Customer Mustufa Arif', '0.00', '0.00', '1', '1', '2024-02-24 15:59:43', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1975, '3491818584', 'INV', '2024-02-24', '102030000023', 'Customer debit For Invoice NO - 1101 customer-  Mustufa Arif', '0.00', '0.00', '1', '1', '2024-02-24 15:59:43', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1985, '9293972658', 'INV', '2024-02-24', '10107', 'Inventory credit For Invoice No1100', '0.00', '0.00', '1', '1', '2024-02-24 16:02:25', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1986, '9293972658', 'INVOICE', '2024-02-24', '303', 'Sale Income From Invoice NO - 1100 Customer Mustufa Arif', '0.00', '0.00', '1', '1', '2024-02-24 16:02:25', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (1987, '9293972658', 'INV', '2024-02-24', '102030000023', 'Customer debit For Invoice NO - 1100 customer-  Mustufa Arif', '0.00', '0.00', '1', '1', '2024-02-24 16:02:25', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2009, '7315183996', 'INV', '2024-02-25', '10107', 'Inventory credit For Invoice No1132', '0.00', '426250.00', '1', '1', '2024-02-25 08:13:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2010, '7315183996', 'INVOICE', '2024-02-25', '303', 'Sale Income From Invoice NO - 1132 Customer H.M CABLES', '0.00', '247040.00', '1', '1', '2024-02-25 08:13:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2011, '7315183996', 'INV', '2024-02-25', '102030000005', 'Customer debit For Invoice NO - 1132 customer-  H.M CABLES', '247040.00', '0.00', '1', '1', '2024-02-25 08:13:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2012, '3261562757', 'INV', '2024-02-25', '10107', 'Inventory credit For Invoice No1133', '0.00', '136575.00', '1', '1', '2024-02-25 08:19:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2013, '3261562757', 'INV', '2024-02-25', '102030000005', 'Customer debit For Invoice No -  1133 Customer H.M CABLES', '154700.00', '0.00', '1', '1', '2024-02-25 08:19:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2014, '3261562757', 'INVOICE', '2024-02-25', '303', 'Sale Income For Invoice NO - 1133 Customer H.M CABLES', '0.00', '154700.00', '1', '1', '2024-02-25 08:19:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2018, '6295972662', 'INV', '2024-02-25', '10107', 'Inventory credit For Invoice No1135', '0.00', '9116.00', '1', '1', '2024-02-25 08:27:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2019, '6295972662', 'INV', '2024-02-25', '102030000005', 'Customer debit For Invoice No -  1135 Customer H.M CABLES', '11120.00', '0.00', '1', '1', '2024-02-25 08:27:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2020, '6295972662', 'INVOICE', '2024-02-25', '303', 'Sale Income For Invoice NO - 1135 Customer H.M CABLES', '0.00', '11120.00', '1', '1', '2024-02-25 08:27:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2026, '6258163824', 'INV', '2024-02-25', '10107', 'Inventory credit For Invoice No1136', '0.00', '32000.00', '1', '1', '2024-02-25 08:34:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2027, '6258163824', 'INV', '2024-02-25', '102030000005', 'Customer debit For Invoice No -  1136 Customer H.M CABLES', '38000.00', '0.00', '1', '1', '2024-02-25 08:34:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2028, '6258163824', 'INVOICE', '2024-02-25', '303', 'Sale Income For Invoice NO - 1136 Customer H.M CABLES', '0.00', '38000.00', '1', '1', '2024-02-25 08:34:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2029, '5148215591', 'INV', '2024-02-25', '10107', 'Inventory credit For Invoice No1137', '0.00', '309977.00', '1', '1', '2024-02-25 08:45:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2030, '5148215591', 'INV', '2024-02-25', '102030000005', 'Customer debit For Invoice No -  1137 Customer H.M CABLES', '30230.00', '0.00', '1', '1', '2024-02-25 08:45:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2031, '5148215591', 'INVOICE', '2024-02-25', '303', 'Sale Income For Invoice NO - 1137 Customer H.M CABLES', '0.00', '30230.00', '1', '1', '2024-02-25 08:45:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2032, '3911836699', 'INV', '2024-02-25', '10107', 'Inventory credit For Invoice No1138', '0.00', '1500.00', '1', '1', '2024-02-25 08:47:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2033, '3911836699', 'INV', '2024-02-25', '102030000005', 'Customer debit For Invoice No -  1138 Customer H.M CABLES', '1900.00', '0.00', '1', '1', '2024-02-25 08:47:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2034, '3911836699', 'INVOICE', '2024-02-25', '303', 'Sale Income For Invoice NO - 1138 Customer H.M CABLES', '0.00', '1900.00', '1', '1', '2024-02-25 08:47:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2035, '1753277465', 'INV', '2024-02-25', '10107', 'Inventory credit For Invoice No1139', '0.00', '63240.00', '1', '1', '2024-02-25 09:00:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2036, '1753277465', 'INV', '2024-02-25', '102030000005', 'Customer debit For Invoice No -  1139 Customer H.M CABLES', '80230.00', '0.00', '1', '1', '2024-02-25 09:00:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2037, '1753277465', 'INVOICE', '2024-02-25', '303', 'Sale Income For Invoice NO - 1139 Customer H.M CABLES', '0.00', '80230.00', '1', '1', '2024-02-25 09:00:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2038, '1413256793', 'INV', '2024-02-25', '10107', 'Inventory credit For Invoice No1140', '0.00', '12880.00', '1', '1', '2024-02-25 09:03:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2039, '1413256793', 'INV', '2024-02-25', '102030000005', 'Customer debit For Invoice No -  1140 Customer H.M CABLES', '14750.00', '0.00', '1', '1', '2024-02-25 09:03:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2040, '1413256793', 'INVOICE', '2024-02-25', '303', 'Sale Income For Invoice NO - 1140 Customer H.M CABLES', '0.00', '14750.00', '1', '1', '2024-02-25 09:03:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2046, '20240218112422', 'Purchase', '2024-02-01', '10107', 'Inventory Devit Supplier Zahid Soomro Kotri', '163360.00', '0.00', '1', '1', '2024-02-25 09:10:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2047, '20240218112422', 'Purchase', '2024-02-01', '502000043', 'Supplier -Zahid Soomro Kotri', '0.00', '163360.00', '1', '1', '2024-02-25 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2048, '20240218112422', 'Purchase', '2024-02-01', '402', 'Company Credit For SupplierZahid Soomro Kotri', '163360.00', '0.00', '1', '1', '2024-02-25 09:10:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2049, '20240218112422', 'Purchase', '2024-02-01', '1020101', 'Cash in Hand For Supplier Zahid Soomro Kotri', '0.00', '0.00', '1', '1', '2024-02-25 09:10:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2050, '20240218112422', 'Purchase', '2024-02-01', '502000043', 'Supplier . Zahid Soomro Kotri', '0.00', '0.00', '1', '1', '2024-02-25 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2051, '1556349912', 'INV', '2024-02-25', '10107', 'Inventory credit For Invoice No1134', '0.00', '4915.00', '1', '1', '2024-02-25 09:12:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2052, '1556349912', 'INVOICE', '2024-02-25', '303', 'Sale Income From Invoice NO - 1134 Customer H.M CABLES', '0.00', '4090.00', '1', '1', '2024-02-25 09:12:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2053, '1556349912', 'INV', '2024-02-25', '102030000005', 'Customer debit For Invoice NO - 1134 customer-  H.M CABLES', '4090.00', '0.00', '1', '1', '2024-02-25 09:12:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2054, '2823655468', 'INV', '2024-02-25', '10107', 'Inventory credit For Invoice No1141', '0.00', '3400.00', '1', '1', '2024-02-25 09:13:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2055, '2823655468', 'INV', '2024-02-25', '102030000005', 'Customer debit For Invoice No -  1141 Customer H.M CABLES', '5500.00', '0.00', '1', '1', '2024-02-25 09:13:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2056, '2823655468', 'INVOICE', '2024-02-25', '303', 'Sale Income For Invoice NO - 1141 Customer H.M CABLES', '0.00', '5500.00', '1', '1', '2024-02-25 09:13:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2063, '9844494798', 'INV', '2024-02-25', '10107', 'Inventory credit For Invoice No1143', '0.00', '11721.00', '1', '1', '2024-02-25 09:24:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2064, '9844494798', 'INVOICE', '2024-02-25', '303', 'Sale Income From Invoice NO - 1143 Customer Deluxe Electric', '0.00', '12220.00', '1', '1', '2024-02-25 09:24:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2065, '9844494798', 'INV', '2024-02-25', '102030000017', 'Customer debit For Invoice NO - 1143 customer-  Deluxe Electric', '12220.00', '0.00', '1', '1', '2024-02-25 09:24:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2066, '5993242736', 'INV', '2024-02-25', '10107', 'Inventory credit For Invoice No1144', '0.00', '12276.00', '1', '1', '2024-02-25 09:26:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2067, '5993242736', 'INV', '2024-02-25', '102030000025', 'Customer debit For Invoice No -  1144 Customer Ahmed kazi', '12900.00', '0.00', '1', '1', '2024-02-25 09:26:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2068, '5993242736', 'INVOICE', '2024-02-25', '303', 'Sale Income For Invoice NO - 1144 Customer Ahmed kazi', '0.00', '12900.00', '1', '1', '2024-02-25 09:26:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2081, '5862996656', 'INV', '2024-02-25', '10107', 'Inventory credit For Invoice No1149', '0.00', '6731.00', '1', '1', '2024-02-25 09:38:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2082, '5862996656', 'INV', '2024-02-25', '102030000026', 'Customer debit For Invoice No -  1149 Customer Memon Light  ', '7200.00', '0.00', '1', '1', '2024-02-25 09:38:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2083, '5862996656', 'INVOICE', '2024-02-25', '303', 'Sale Income For Invoice NO - 1149 Customer Memon Light  ', '0.00', '7200.00', '1', '1', '2024-02-25 09:38:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2090, '8583371169', 'INV', '2024-02-25', '10107', 'Inventory credit For Invoice No1152', '0.00', '27330.00', '1', '1', '2024-02-25 09:47:50', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2091, '8583371169', 'INV', '2024-02-25', '102030000009', 'Customer debit For Invoice No -  1152 Customer Zahid somoro', '18000.00', '0.00', '1', '1', '2024-02-25 09:47:50', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2092, '8583371169', 'INVOICE', '2024-02-25', '303', 'Sale Income For Invoice NO - 1152 Customer Zahid somoro', '0.00', '18000.00', '1', '1', '2024-02-25 09:47:50', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2093, '2635796229', 'INV', '2024-02-25', '10107', 'Inventory credit For Invoice No1153', '0.00', '67988.00', '1', '1', '2024-02-25 09:52:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2094, '2635796229', 'INV', '2024-02-25', '102030000006', 'Customer debit For Invoice No -  1153 Customer Faizan Basti ', '20020.00', '0.00', '1', '1', '2024-02-25 09:52:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2095, '2635796229', 'INVOICE', '2024-02-25', '303', 'Sale Income For Invoice NO - 1153 Customer Faizan Basti ', '0.00', '20020.00', '1', '1', '2024-02-25 09:52:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2096, '6266215734', 'INV', '2024-02-25', '10107', 'Inventory credit For Invoice No1154', '0.00', '185027.00', '1', '1', '2024-02-25 09:56:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2097, '6266215734', 'INV', '2024-02-25', '102030000017', 'Customer debit For Invoice No -  1154 Customer Deluxe Electric', '43825.00', '0.00', '1', '1', '2024-02-25 09:56:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2098, '6266215734', 'INVOICE', '2024-02-25', '303', 'Sale Income For Invoice NO - 1154 Customer Deluxe Electric', '0.00', '43825.00', '1', '1', '2024-02-25 09:56:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2102, '2947285344', 'INV', '2024-02-25', '10107', 'Inventory credit For Invoice No1156', '0.00', '8883.00', '1', '1', '2024-02-25 09:59:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2103, '2947285344', 'INV', '2024-02-25', '102030000020', 'Customer debit For Invoice No -  1156 Customer M.K Electric ', '8700.00', '0.00', '1', '1', '2024-02-25 09:59:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2104, '2947285344', 'INVOICE', '2024-02-25', '303', 'Sale Income For Invoice NO - 1156 Customer M.K Electric ', '0.00', '8700.00', '1', '1', '2024-02-25 09:59:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2105, '1197737314', 'INV', '2024-02-25', '10107', 'Inventory credit For Invoice No1157', '0.00', '68073.00', '1', '1', '2024-02-25 10:03:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2106, '1197737314', 'INV', '2024-02-25', '102030000017', 'Customer debit For Invoice No -  1157 Customer Deluxe Electric', '62300.00', '0.00', '1', '1', '2024-02-25 10:03:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2107, '1197737314', 'INVOICE', '2024-02-25', '303', 'Sale Income For Invoice NO - 1157 Customer Deluxe Electric', '0.00', '62300.00', '1', '1', '2024-02-25 10:03:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2114, '7979943364', 'INV', '2024-02-25', '10107', 'Inventory credit For Invoice No1158', '0.00', '116683.00', '1', '1', '2024-02-25 10:14:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2115, '7979943364', 'INVOICE', '2024-02-25', '303', 'Sale Income From Invoice NO - 1158 Customer M.K Electric ', '0.00', '70850.00', '1', '1', '2024-02-25 10:14:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2116, '7979943364', 'INV', '2024-02-25', '102030000020', 'Customer debit For Invoice NO - 1158 customer-  M.K Electric ', '70850.00', '0.00', '1', '1', '2024-02-25 10:14:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2117, '4611418728', 'INV', '2024-02-25', '10107', 'Inventory credit For Invoice No1159', '0.00', '3720.00', '1', '1', '2024-02-25 10:17:01', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2118, '4611418728', 'INV', '2024-02-25', '102030000019', 'Customer debit For Invoice No -  1159 Customer M.Z Electric', '5200.00', '0.00', '1', '1', '2024-02-25 10:17:01', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2119, '4611418728', 'INVOICE', '2024-02-25', '303', 'Sale Income For Invoice NO - 1159 Customer M.Z Electric', '0.00', '5200.00', '1', '1', '2024-02-25 10:17:01', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2123, '7638831343', 'INV', '2024-02-25', '10107', 'Inventory credit For Invoice No1160', '0.00', '3720.00', '1', '1', '2024-02-25 10:24:05', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2124, '7638831343', 'INVOICE', '2024-02-25', '303', 'Sale Income From Invoice NO - 1160 Customer M.Z Electric', '0.00', '5200.00', '1', '1', '2024-02-25 10:24:05', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2125, '7638831343', 'INV', '2024-02-25', '102030000019', 'Customer debit For Invoice NO - 1160 customer-  M.Z Electric', '5200.00', '0.00', '1', '1', '2024-02-25 10:24:05', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2126, '9149799129', 'INV', '2024-02-25', '10107', 'Inventory credit For Invoice No1161', '0.00', '209262.00', '1', '1', '2024-02-25 10:32:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2127, '9149799129', 'INV', '2024-02-25', '102030000031', 'Customer debit For Invoice No -  1161 Customer Saffan Chilton ', '160809.00', '0.00', '1', '1', '2024-02-25 10:32:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2128, '9149799129', 'INVOICE', '2024-02-25', '303', 'Sale Income For Invoice NO - 1161 Customer Saffan Chilton ', '0.00', '160809.00', '1', '1', '2024-02-25 10:32:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2129, '9259517748', 'INV', '2024-02-25', '10107', 'Inventory credit For Invoice No1162', '0.00', '180594.00', '1', '1', '2024-02-25 10:32:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2130, '9259517748', 'INV', '2024-02-25', '102030000031', 'Customer debit For Invoice No -  1162 Customer Saffan Chilton ', '159240.00', '0.00', '1', '1', '2024-02-25 10:32:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2131, '9259517748', 'INVOICE', '2024-02-25', '303', 'Sale Income For Invoice NO - 1162 Customer Saffan Chilton ', '0.00', '159240.00', '1', '1', '2024-02-25 10:32:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2132, '2832617851', 'INV', '2024-02-25', '10107', 'Inventory credit For Invoice No1163', '0.00', '115878.00', '1', '1', '2024-02-25 10:48:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2133, '2832617851', 'INV', '2024-02-25', '102030000006', 'Customer debit For Invoice No -  1163 Customer Faizan Basti ', '20300.00', '0.00', '1', '1', '2024-02-25 10:48:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2134, '2832617851', 'INVOICE', '2024-02-25', '303', 'Sale Income For Invoice NO - 1163 Customer Faizan Basti ', '0.00', '20300.00', '1', '1', '2024-02-25 10:48:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2141, '4722732758', 'INV', '2024-02-25', '10107', 'Inventory credit For Invoice No1165', '0.00', '331905.00', '1', '1', '2024-02-25 11:06:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2142, '4722732758', 'INV', '2024-02-25', '102030000017', 'Customer debit For Invoice No -  1165 Customer Deluxe Electric', '19675.00', '0.00', '1', '1', '2024-02-25 11:06:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2143, '4722732758', 'INVOICE', '2024-02-25', '303', 'Sale Income For Invoice NO - 1165 Customer Deluxe Electric', '0.00', '19675.00', '1', '1', '2024-02-25 11:06:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2144, '7327496538', 'INV', '2024-02-25', '10107', 'Inventory credit For Invoice No1166', '0.00', '33694.00', '1', '1', '2024-02-25 11:09:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2145, '7327496538', 'INV', '2024-02-25', '102030000009', 'Customer debit For Invoice No -  1166 Customer Zahid somoro', '24600.00', '0.00', '1', '1', '2024-02-25 11:09:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2146, '7327496538', 'INVOICE', '2024-02-25', '303', 'Sale Income For Invoice NO - 1166 Customer Zahid somoro', '0.00', '24600.00', '1', '1', '2024-02-25 11:09:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2153, '2347643624', 'INV', '2024-02-25', '10107', 'Inventory credit For Invoice No1169', '0.00', '7682.00', '1', '1', '2024-02-25 11:22:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2154, '2347643624', 'INV', '2024-02-25', '102030000028', 'Customer debit For Invoice No -  1169 Customer M.K Electric', '7580.00', '0.00', '1', '1', '2024-02-25 11:22:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2155, '2347643624', 'INVOICE', '2024-02-25', '303', 'Sale Income For Invoice NO - 1169 Customer M.K Electric', '0.00', '7580.00', '1', '1', '2024-02-25 11:22:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2262, '8461482622', 'INV', '2024-02-27', '10107', 'Inventory credit For Invoice No1155', '0.00', '6873.00', '1', '1', '2024-02-27 09:25:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2263, '8461482622', 'INVOICE', '2024-02-27', '303', 'Sale Income From Invoice NO - 1155 Customer M.Z Electric', '0.00', '7250.00', '1', '1', '2024-02-27 09:25:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2264, '8461482622', 'INV', '2024-02-27', '102030000019', 'Customer debit For Invoice NO - 1155 customer-  M.Z Electric', '7250.00', '0.00', '1', '1', '2024-02-27 09:25:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2268, '20240124145800', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier Arslan LED', '71200.00', '0.00', '1', '1', '2024-02-27 09:31:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2269, '20240124145800', 'Purchase', '2023-12-31', '502000002', 'Supplier -Arslan LED', '0.00', '71200.00', '1', '1', '2024-02-27 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2270, '20240124145800', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierArslan LED', '71200.00', '0.00', '1', '1', '2024-02-27 09:31:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2271, '20240124145800', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier Arslan LED', '0.00', '0.00', '1', '1', '2024-02-27 09:31:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2272, '20240124145800', 'Purchase', '2023-12-31', '502000002', 'Supplier . Arslan LED', '0.00', '0.00', '1', '1', '2024-02-27 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2293, '5217114917', 'INV', '2024-02-27', '10107', 'Inventory credit For Invoice No1167', '0.00', '5070.00', '1', '1', '2024-02-27 10:32:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2294, '5217114917', 'INVOICE', '2024-02-27', '303', 'Sale Income From Invoice NO - 1167 Customer Faizan Basti ', '0.00', '4920.00', '1', '1', '2024-02-27 10:32:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2295, '5217114917', 'INV', '2024-02-27', '102030000006', 'Customer debit For Invoice NO - 1167 customer-  Faizan Basti ', '4920.00', '0.00', '1', '1', '2024-02-27 10:32:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2308, '5891635397', 'INV', '2024-02-27', '10107', 'Inventory credit For Invoice No1174', '0.00', '63178.00', '1', '1', '2024-02-27 10:45:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2309, '5891635397', 'INVOICE', '2024-02-27', '303', 'Sale Income From Invoice NO - 1174 Customer Azam Channa ', '0.00', '36010.00', '1', '1', '2024-02-27 10:45:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2310, '5891635397', 'INV', '2024-02-27', '102030000038', 'Customer debit For Invoice NO - 1174 customer-  Azam Channa ', '36010.00', '0.00', '1', '1', '2024-02-27 10:45:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2353, '6262367751', 'INV', '2024-02-27', '10107', 'Inventory credit For Invoice No1175', '0.00', '111312.00', '1', '1', '2024-02-27 13:25:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2354, '6262367751', 'INV', '2024-02-27', '102030000017', 'Customer debit For Invoice No -  1175 Customer Deluxe Electric', '67125.00', '0.00', '1', '1', '2024-02-27 13:25:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2355, '6262367751', 'INVOICE', '2024-02-27', '303', 'Sale Income For Invoice NO - 1175 Customer Deluxe Electric', '0.00', '67125.00', '1', '1', '2024-02-27 13:25:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2356, '3817238736', 'INV', '2024-02-27', '10107', 'Inventory credit For Invoice No1176', '0.00', '33243.00', '1', '1', '2024-02-27 13:50:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2357, '3817238736', 'INV', '2024-02-27', '102030000009', 'Customer debit For Invoice No -  1176 Customer Zahid somoro', '37200.00', '0.00', '1', '1', '2024-02-27 13:50:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2358, '3817238736', 'INVOICE', '2024-02-27', '303', 'Sale Income For Invoice NO - 1176 Customer Zahid somoro', '0.00', '37200.00', '1', '1', '2024-02-27 13:50:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2359, '4626259438', 'INV', '2024-02-27', '10107', 'Inventory credit For Invoice No1177', '0.00', '12292.00', '1', '1', '2024-02-27 13:51:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2360, '4626259438', 'INV', '2024-02-27', '102030000020', 'Customer debit For Invoice No -  1177 Customer M.K Electric ', '12400.00', '0.00', '1', '1', '2024-02-27 13:51:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2361, '4626259438', 'INVOICE', '2024-02-27', '303', 'Sale Income For Invoice NO - 1177 Customer M.K Electric ', '0.00', '12400.00', '1', '1', '2024-02-27 13:51:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2362, '2752246514', 'INV', '2024-02-27', '10107', 'Inventory credit For Invoice No1178', '0.00', '13010.00', '1', '1', '2024-02-27 13:59:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2363, '2752246514', 'INV', '2024-02-27', '102030000009', 'Customer debit For Invoice No -  1178 Customer Zahid somoro', '9450.00', '0.00', '1', '1', '2024-02-27 13:59:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2364, '2752246514', 'INVOICE', '2024-02-27', '303', 'Sale Income For Invoice NO - 1178 Customer Zahid somoro', '0.00', '9450.00', '1', '1', '2024-02-27 13:59:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2368, '6727539696', 'INV', '2024-02-27', '10107', 'Inventory credit For Invoice No1180', '0.00', '6731.00', '1', '1', '2024-02-27 14:05:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2369, '6727539696', 'INV', '2024-02-27', '102030000009', 'Customer debit For Invoice No -  1180 Customer Zahid somoro', '7300.00', '0.00', '1', '1', '2024-02-27 14:05:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2370, '6727539696', 'INVOICE', '2024-02-27', '303', 'Sale Income For Invoice NO - 1180 Customer Zahid somoro', '0.00', '7300.00', '1', '1', '2024-02-27 14:05:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2371, '1358638581', 'INV', '2024-02-27', '10107', 'Inventory credit For Invoice No1181', '0.00', '12210.00', '1', '1', '2024-02-27 14:09:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2372, '1358638581', 'INV', '2024-02-27', '102030000011', 'Customer debit For Invoice No -  1181 Customer M.D.M Mill', '13700.00', '0.00', '1', '1', '2024-02-27 14:09:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2373, '1358638581', 'INVOICE', '2024-02-27', '303', 'Sale Income For Invoice NO - 1181 Customer M.D.M Mill', '0.00', '13700.00', '1', '1', '2024-02-27 14:09:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2392, '9555192325', 'INV', '2024-02-27', '10107', 'Inventory credit For Invoice No1142', '0.00', '88830.00', '1', '1', '2024-02-27 15:20:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2393, '9555192325', 'INVOICE', '2024-02-27', '303', 'Sale Income From Invoice NO - 1142 Customer Ashfaq Electric ', '0.00', '90000.00', '1', '1', '2024-02-27 15:20:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2394, '9555192325', 'INV', '2024-02-27', '102030000014', 'Customer debit For Invoice NO - 1142 customer-  Ashfaq Electric ', '90000.00', '0.00', '1', '1', '2024-02-27 15:20:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2410, '3233778328', 'INV', '2024-02-28', '10107', 'Inventory credit For Invoice No1146', '0.00', '21442.00', '1', '1', '2024-02-28 07:43:02', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2411, '3233778328', 'INVOICE', '2024-02-28', '303', 'Sale Income From Invoice NO - 1146 Customer Eman Electric', '0.00', '15680.00', '1', '1', '2024-02-28 07:43:02', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2412, '3233778328', 'INV', '2024-02-28', '102030000024', 'Customer debit For Invoice NO - 1146 customer-  Eman Electric', '15680.00', '0.00', '1', '1', '2024-02-28 07:43:02', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2440, '8668857166', 'INV', '2024-02-28', '10107', 'Inventory credit For Invoice No1190', '0.00', '66750.00', '1', '1', '2024-02-28 09:19:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2441, '8668857166', 'INV', '2024-02-28', '102030000002', 'Customer debit For Invoice No -  1190 Customer Walking Customer', '33197.00', '0.00', '1', '1', '2024-02-28 09:19:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2442, '8668857166', 'INVOICE', '2024-02-28', '303', 'Sale Income For Invoice NO - 1190 Customer Walking Customer', '0.00', '33197.00', '1', '1', '2024-02-28 09:19:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2472, '5233818293', 'INV', '2024-02-28', '10107', 'Inventory credit For Invoice No1195', '0.00', '22233.00', '1', '1', '2024-02-28 10:45:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2473, '5233818293', 'INV', '2024-02-28', '102030000002', 'Customer debit For Invoice No -  1195 Customer Walking Customer', '14900.00', '0.00', '1', '1', '2024-02-28 10:45:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2474, '5233818293', 'INVOICE', '2024-02-28', '303', 'Sale Income For Invoice NO - 1195 Customer Walking Customer', '0.00', '14900.00', '1', '1', '2024-02-28 10:45:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2501, '3317182685', 'INV', '2024-02-28', '10107', 'Inventory credit For Invoice No1199', '0.00', '3480.00', '1', '1', '2024-02-28 12:52:01', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2502, '3317182685', 'INV', '2024-02-28', '102030000002', 'Customer debit For Invoice No -  1199 Customer Walking Customer', '3630.00', '0.00', '1', '1', '2024-02-28 12:52:01', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2503, '3317182685', 'INVOICE', '2024-02-28', '303', 'Sale Income For Invoice NO - 1199 Customer Walking Customer', '0.00', '3630.00', '1', '1', '2024-02-28 12:52:01', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2510, '20240218074400', 'Purchase', '2024-01-01', '10107', 'Inventory Devit Supplier Chilton Traders Karachi', '45800.00', '0.00', '1', '1', '2024-02-29 07:03:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2511, '20240218074400', 'Purchase', '2024-01-01', '502000032', 'Supplier -Chilton Traders Karachi', '0.00', '45800.00', '1', '1', '2024-02-29 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2512, '20240218074400', 'Purchase', '2024-01-01', '402', 'Company Credit For SupplierChilton Traders Karachi', '45800.00', '0.00', '1', '1', '2024-02-29 07:03:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2513, '20240218074400', 'Purchase', '2024-01-01', '1020101', 'Cash in Hand For Supplier Chilton Traders Karachi', '0.00', '0.00', '1', '1', '2024-02-29 07:03:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2514, '20240218074400', 'Purchase', '2024-01-01', '502000032', 'Supplier . Chilton Traders Karachi', '0.00', '0.00', '1', '1', '2024-02-29 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2521, '2724633553', 'INV', '2024-02-29', '10107', 'Inventory credit For Invoice No1027', '0.00', '53375.00', '1', '1', '2024-02-29 07:13:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2522, '2724633553', 'INVOICE', '2024-02-29', '303', 'Sale Income From Invoice NO - 1027 Customer Walking Customer', '0.00', '72150.00', '1', '1', '2024-02-29 07:13:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2523, '2724633553', 'INV', '2024-02-29', '102030000002', 'Customer debit For Invoice NO - 1027 customer-  Walking Customer', '72150.00', '0.00', '1', '1', '2024-02-29 07:13:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2547, '9994122257', 'INV', '2024-02-29', '10107', 'Inventory credit For Invoice No1202', '0.00', '13304.00', '1', '1', '2024-02-29 08:14:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2548, '9994122257', 'INV', '2024-02-29', '102030000002', 'Customer debit For Invoice No -  1202 Customer Walking Customer', '29700.00', '0.00', '1', '1', '2024-02-29 08:14:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2549, '9994122257', 'INVOICE', '2024-02-29', '303', 'Sale Income For Invoice NO - 1202 Customer Walking Customer', '0.00', '29700.00', '1', '1', '2024-02-29 08:14:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2553, '2185662296', 'INV', '2024-02-29', '10107', 'Inventory credit For Invoice No1203', '0.00', '49206.00', '1', '1', '2024-02-29 11:35:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2554, '2185662296', 'INVOICE', '2024-02-29', '303', 'Sale Income From Invoice NO - 1203 Customer Walking Customer', '0.00', '26525.00', '1', '1', '2024-02-29 11:35:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2555, '2185662296', 'INV', '2024-02-29', '102030000002', 'Customer debit For Invoice NO - 1203 customer-  Walking Customer', '26525.00', '0.00', '1', '1', '2024-02-29 11:35:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2559, '6284454277', 'INV', '2024-02-29', '10107', 'Inventory credit For Invoice No1184', '0.00', '4200.00', '1', '1', '2024-02-29 11:53:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2560, '6284454277', 'INVOICE', '2024-02-29', '303', 'Sale Income From Invoice NO - 1184 Customer Walking Customer', '0.00', '4320.00', '1', '1', '2024-02-29 11:53:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2561, '6284454277', 'INV', '2024-02-29', '102030000002', 'Customer debit For Invoice NO - 1184 customer-  Walking Customer', '4320.00', '0.00', '1', '1', '2024-02-29 11:53:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2576, '1981932215', 'INV', '2024-02-29', '10107', 'Inventory credit For Invoice No1196', '0.00', '27662.00', '1', '1', '2024-02-29 12:31:31', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2577, '1981932215', 'INVOICE', '2024-02-29', '303', 'Sale Income From Invoice NO - 1196 Customer Walking Customer', '0.00', '38030.00', '1', '1', '2024-02-29 12:31:31', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2578, '1981932215', 'INV', '2024-02-29', '102030000002', 'Customer debit For Invoice NO - 1196 customer-  Walking Customer', '38030.00', '0.00', '1', '1', '2024-02-29 12:31:31', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2611, '20240219100856', 'Purchase', '2024-02-01', '10107', 'Inventory Devit Supplier Memon LAD Light', '375560.00', '0.00', '1', '1', '2024-02-29 13:25:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2612, '20240219100856', 'Purchase', '2024-02-01', '502000008', 'Supplier -Memon LAD Light', '0.00', '375560.00', '1', '1', '2024-02-29 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2613, '20240219100856', 'Purchase', '2024-02-01', '402', 'Company Credit For SupplierMemon LAD Light', '375560.00', '0.00', '1', '1', '2024-02-29 13:25:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2614, '20240219100856', 'Purchase', '2024-02-01', '1020101', 'Cash in Hand For Supplier Memon LAD Light', '0.00', '0.00', '1', '1', '2024-02-29 13:25:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2615, '20240219100856', 'Purchase', '2024-02-01', '502000008', 'Supplier . Memon LAD Light', '0.00', '0.00', '1', '1', '2024-02-29 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2616, '20240302094323', 'Purchase', '2024-02-29', '10107', 'Inventory Debit For Supplier New Shahid Pipe', '61750.00', '0.00', '1', '1', '2024-03-02 09:43:23', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2617, '20240302094323', 'Purchase', '2024-02-29', '502000035', 'Supplier .New Shahid Pipe', '0.00', '61750.00', '1', '1', '2024-03-02 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2618, '20240302094323', 'Purchase', '2024-02-29', '402', 'Company Credit For  New Shahid Pipe', '61750.00', '0.00', '1', '1', '2024-03-02 09:43:23', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2624, '20240124154656', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier Qureshi pipe wala', '152500.00', '0.00', '1', '1', '2024-03-02 09:44:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2625, '20240124154656', 'Purchase', '2023-12-31', '502000004', 'Supplier -Qureshi pipe wala', '0.00', '152500.00', '1', '1', '2024-03-02 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2626, '20240124154656', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierQureshi pipe wala', '152500.00', '0.00', '1', '1', '2024-03-02 09:44:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2627, '20240124154656', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier Qureshi pipe wala', '0.00', '0.00', '1', '1', '2024-03-02 09:44:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2628, '20240124154656', 'Purchase', '2023-12-31', '502000004', 'Supplier . Qureshi pipe wala', '0.00', '0.00', '1', '1', '2024-03-02 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2663, '7551413551', 'INV', '2024-03-02', '10107', 'Inventory credit For Invoice No1204', '0.00', '65019.00', '1', '1', '2024-03-02 10:34:19', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2664, '7551413551', 'INVOICE', '2024-03-02', '303', 'Sale Income From Invoice NO - 1204 Customer Walking Customer', '0.00', '23740.00', '1', '1', '2024-03-02 10:34:19', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2665, '7551413551', 'INV', '2024-03-02', '102030000002', 'Customer debit For Invoice NO - 1204 customer-  Walking Customer', '23740.00', '0.00', '1', '1', '2024-03-02 10:34:19', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2666, '2184931446', 'INV', '2024-03-02', '10107', 'Inventory credit For Invoice No1179', '0.00', '25150.00', '1', '1', '2024-03-02 10:41:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2667, '2184931446', 'INVOICE', '2024-03-02', '303', 'Sale Income From Invoice NO - 1179 Customer Faizan Basti ', '0.00', '20800.00', '1', '1', '2024-03-02 10:41:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2668, '2184931446', 'INV', '2024-03-02', '102030000006', 'Customer debit For Invoice NO - 1179 customer-  Faizan Basti ', '20800.00', '0.00', '1', '1', '2024-03-02 10:41:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2672, '20240130154304', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier Aijaz PCV Karachi', '207610.00', '0.00', '1', '1', '2024-03-02 10:49:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2673, '20240130154304', 'Purchase', '2023-12-31', '502000023', 'Supplier -Aijaz PCV Karachi', '0.00', '207610.00', '1', '1', '2024-03-02 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2674, '20240130154304', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierAijaz PCV Karachi', '207610.00', '0.00', '1', '1', '2024-03-02 10:49:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2675, '20240130154304', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier Aijaz PCV Karachi', '0.00', '0.00', '1', '1', '2024-03-02 10:49:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2676, '20240130154304', 'Purchase', '2023-12-31', '502000023', 'Supplier . Aijaz PCV Karachi', '0.00', '0.00', '1', '1', '2024-03-02 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2683, '8439691471', 'INV', '2024-03-02', '10107', 'Inventory credit For Invoice No1206', '0.00', '322889.00', '1', '1', '2024-03-02 11:56:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2684, '8439691471', 'INV', '2024-03-02', '102030000026', 'Customer debit For Invoice No -  1206 Customer Memon Light  ', '12360.00', '0.00', '1', '1', '2024-03-02 11:56:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2685, '8439691471', 'INVOICE', '2024-03-02', '303', 'Sale Income For Invoice NO - 1206 Customer Memon Light  ', '0.00', '12360.00', '1', '1', '2024-03-02 11:56:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2700, '8411284899', 'INV', '2024-03-02', '10107', 'Inventory credit For Invoice No1208', '0.00', '127990.00', '1', '1', '2024-03-02 12:25:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2701, '8411284899', 'INVOICE', '2024-03-02', '303', 'Sale Income From Invoice NO - 1208 Customer Deluxe Electric', '0.00', '132000.00', '1', '1', '2024-03-02 12:25:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2702, '8411284899', 'INV', '2024-03-02', '102030000017', 'Customer debit For Invoice NO - 1208 customer-  Deluxe Electric', '132000.00', '0.00', '1', '1', '2024-03-02 12:25:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2703, '8876911595', 'INV', '2024-03-02', '10107', 'Inventory credit For Invoice No1209', '0.00', '13070.00', '1', '1', '2024-03-02 12:34:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2704, '8876911595', 'INV', '2024-03-02', '102030000012', 'Customer debit For Invoice No -  1209 Customer National Spining', '10500.00', '0.00', '1', '1', '2024-03-02 12:34:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2705, '8876911595', 'INVOICE', '2024-03-02', '303', 'Sale Income For Invoice NO - 1209 Customer National Spining', '0.00', '10500.00', '1', '1', '2024-03-02 12:34:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2706, '9518822344', 'INV', '2024-03-02', '10107', 'Inventory credit For Invoice No1210', '0.00', '20450.00', '1', '1', '2024-03-02 12:38:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2707, '9518822344', 'INV', '2024-03-02', '102030000006', 'Customer debit For Invoice No -  1210 Customer Faizan Basti ', '10580.00', '0.00', '1', '1', '2024-03-02 12:38:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2708, '9518822344', 'INVOICE', '2024-03-02', '303', 'Sale Income For Invoice NO - 1210 Customer Faizan Basti ', '0.00', '10580.00', '1', '1', '2024-03-02 12:38:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2709, '6853249324', 'INV', '2024-03-02', '10107', 'Inventory credit For Invoice No1211', '0.00', '19436.00', '1', '1', '2024-03-02 12:45:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2710, '6853249324', 'INV', '2024-03-02', '102030000016', 'Customer debit For Invoice No -  1211 Customer Abdul Qadir Electric ', '48450.00', '0.00', '1', '1', '2024-03-02 12:45:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2711, '6853249324', 'INVOICE', '2024-03-02', '303', 'Sale Income For Invoice NO - 1211 Customer Abdul Qadir Electric ', '0.00', '48450.00', '1', '1', '2024-03-02 12:45:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2712, '2813146579', 'INV', '2024-03-02', '10107', 'Inventory credit For Invoice No1212', '0.00', '25733.00', '1', '1', '2024-03-02 12:56:50', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2713, '2813146579', 'INV', '2024-03-02', '102030000006', 'Customer debit For Invoice No -  1212 Customer Faizan Basti ', '27600.00', '0.00', '1', '1', '2024-03-02 12:56:50', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2714, '2813146579', 'INVOICE', '2024-03-02', '303', 'Sale Income For Invoice NO - 1212 Customer Faizan Basti ', '0.00', '27600.00', '1', '1', '2024-03-02 12:56:50', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2728, '20240225073613', 'Purchase', '2024-02-22', '10107', 'Inventory Devit Supplier Arfeen Wire (Million)', '320572.00', '0.00', '1', '1', '2024-03-02 13:38:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2729, '20240225073613', 'Purchase', '2024-02-22', '502000029', 'Supplier -Arfeen Wire (Million)', '0.00', '320572.00', '1', '1', '2024-03-02 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2730, '20240225073613', 'Purchase', '2024-02-22', '402', 'Company Credit For SupplierArfeen Wire (Million)', '320572.00', '0.00', '1', '1', '2024-03-02 13:38:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2731, '20240225073613', 'Purchase', '2024-02-22', '1020101', 'Cash in Hand For Supplier Arfeen Wire (Million)', '0.00', '0.00', '1', '1', '2024-03-02 13:38:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2732, '20240225073613', 'Purchase', '2024-02-22', '502000029', 'Supplier . Arfeen Wire (Million)', '0.00', '0.00', '1', '1', '2024-03-02 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2739, '1515783136', 'INV', '2024-03-02', '10107', 'Inventory credit For Invoice No1213', '0.00', '120663.00', '1', '1', '2024-03-02 13:48:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2740, '1515783136', 'INVOICE', '2024-03-02', '303', 'Sale Income From Invoice NO - 1213 Customer Memon Light  ', '0.00', '101485.00', '1', '1', '2024-03-02 13:48:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2741, '1515783136', 'INV', '2024-03-02', '102030000026', 'Customer debit For Invoice NO - 1213 customer-  Memon Light  ', '101485.00', '0.00', '1', '1', '2024-03-02 13:48:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2745, '3487797747', 'INV', '2024-03-02', '10107', 'Inventory credit For Invoice No1215', '0.00', '92430.00', '1', '1', '2024-03-02 14:00:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2746, '3487797747', 'INV', '2024-03-02', '102030000016', 'Customer debit For Invoice No -  1215 Customer Abdul Qadir Electric ', '73600.00', '0.00', '1', '1', '2024-03-02 14:00:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2747, '3487797747', 'INVOICE', '2024-03-02', '303', 'Sale Income For Invoice NO - 1215 Customer Abdul Qadir Electric ', '0.00', '73600.00', '1', '1', '2024-03-02 14:00:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2748, '2767374889', 'INV', '2024-03-02', '10107', 'Inventory credit For Invoice No1216', '0.00', '113875.00', '1', '1', '2024-03-02 14:10:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2749, '2767374889', 'INV', '2024-03-02', '102030000031', 'Customer debit For Invoice No -  1216 Customer Saffan Chilton ', '75158.00', '0.00', '1', '1', '2024-03-02 14:10:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2750, '2767374889', 'INVOICE', '2024-03-02', '303', 'Sale Income For Invoice NO - 1216 Customer Saffan Chilton ', '0.00', '75158.00', '1', '1', '2024-03-02 14:10:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2751, '4739166969', 'INV', '2024-03-02', '10107', 'Inventory credit For Invoice No1217', '0.00', '22805.00', '1', '1', '2024-03-02 14:14:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2752, '4739166969', 'INV', '2024-03-02', '102030000020', 'Customer debit For Invoice No -  1217 Customer M.K Electric ', '3200.00', '0.00', '1', '1', '2024-03-02 14:14:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2753, '4739166969', 'INVOICE', '2024-03-02', '303', 'Sale Income For Invoice NO - 1217 Customer M.K Electric ', '0.00', '3200.00', '1', '1', '2024-03-02 14:14:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2757, '6197141427', 'INV', '2024-03-03', '10107', 'Inventory credit For Invoice No1183', '0.00', '11475.00', '1', '1', '2024-03-03 07:28:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2758, '6197141427', 'INVOICE', '2024-03-03', '303', 'Sale Income From Invoice NO - 1183 Customer Walking Customer', '0.00', '9560.00', '1', '1', '2024-03-03 07:28:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2759, '6197141427', 'INV', '2024-03-03', '102030000002', 'Customer debit For Invoice NO - 1183 customer-  Walking Customer', '9560.00', '0.00', '1', '1', '2024-03-03 07:28:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2760, '8517813777', 'INV', '2024-03-03', '10107', 'Inventory credit For Invoice No1186', '0.00', '153493.00', '1', '1', '2024-03-03 07:37:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2761, '8517813777', 'INVOICE', '2024-03-03', '303', 'Sale Income From Invoice NO - 1186 Customer Walking Customer', '0.00', '46974.00', '1', '1', '2024-03-03 07:37:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2762, '8517813777', 'INV', '2024-03-03', '102030000002', 'Customer debit For Invoice NO - 1186 customer-  Walking Customer', '46974.00', '0.00', '1', '1', '2024-03-03 07:37:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2778, '3655828734', 'INV', '2024-03-03', '10107', 'Inventory credit For Invoice No1200', '0.00', '90994.00', '1', '1', '2024-03-03 08:36:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2779, '3655828734', 'INVOICE', '2024-03-03', '303', 'Sale Income From Invoice NO - 1200 Customer Walking Customer', '0.00', '33140.00', '1', '1', '2024-03-03 08:36:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2780, '3655828734', 'INV', '2024-03-03', '102030000002', 'Customer debit For Invoice NO - 1200 customer-  Walking Customer', '33140.00', '0.00', '1', '1', '2024-03-03 08:36:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2795, '7446617154', 'INV', '2024-03-03', '10107', 'Inventory credit For Invoice No1187', '0.00', '3680.00', '1', '1', '2024-03-03 08:54:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2796, '7446617154', 'INVOICE', '2024-03-03', '303', 'Sale Income From Invoice NO - 1187 Customer Walking Customer', '0.00', '5600.00', '1', '1', '2024-03-03 08:54:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2797, '7446617154', 'INV', '2024-03-03', '102030000002', 'Customer debit For Invoice NO - 1187 customer-  Walking Customer', '5600.00', '0.00', '1', '1', '2024-03-03 08:54:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2817, '9845441218', 'INV', '2024-03-03', '10107', 'Inventory credit For Invoice No1189', '0.00', '126640.00', '1', '1', '2024-03-03 09:49:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2818, '9845441218', 'INVOICE', '2024-03-03', '303', 'Sale Income From Invoice NO - 1189 Customer Walking Customer', '0.00', '32950.00', '1', '1', '2024-03-03 09:49:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2819, '9845441218', 'INV', '2024-03-03', '102030000002', 'Customer debit For Invoice NO - 1189 customer-  Walking Customer', '32950.00', '0.00', '1', '1', '2024-03-03 09:49:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2820, '8588781131', 'INV', '2024-03-03', '10107', 'Inventory credit For Invoice No1192', '0.00', '110670.00', '1', '1', '2024-03-03 09:55:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2821, '8588781131', 'INVOICE', '2024-03-03', '303', 'Sale Income From Invoice NO - 1192 Customer Walking Customer', '0.00', '47930.00', '1', '1', '2024-03-03 09:55:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2822, '8588781131', 'INV', '2024-03-03', '102030000002', 'Customer debit For Invoice NO - 1192 customer-  Walking Customer', '47930.00', '0.00', '1', '1', '2024-03-03 09:55:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2823, '2737884135', 'INV', '2024-03-03', '10107', 'Inventory credit For Invoice No1193', '0.00', '97494.00', '1', '1', '2024-03-03 10:02:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2824, '2737884135', 'INVOICE', '2024-03-03', '303', 'Sale Income From Invoice NO - 1193 Customer Walking Customer', '0.00', '55589.00', '1', '1', '2024-03-03 10:02:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2825, '2737884135', 'INV', '2024-03-03', '102030000002', 'Customer debit For Invoice NO - 1193 customer-  Walking Customer', '55589.00', '0.00', '1', '1', '2024-03-03 10:02:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2856, '1115919194', 'INV', '2024-03-03', '10107', 'Inventory credit For Invoice No1194', '0.00', '313769.00', '1', '1', '2024-03-03 12:34:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2857, '1115919194', 'INVOICE', '2024-03-03', '303', 'Sale Income From Invoice NO - 1194 Customer Walking Customer', '0.00', '127105.00', '1', '1', '2024-03-03 12:34:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2858, '1115919194', 'INV', '2024-03-03', '102030000002', 'Customer debit For Invoice NO - 1194 customer-  Walking Customer', '127105.00', '0.00', '1', '1', '2024-03-03 12:34:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2859, '2744992295', 'INV', '2024-03-03', '10107', 'Inventory credit For Invoice No1038', '0.00', '34736.00', '1', '1', '2024-03-03 12:56:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2860, '2744992295', 'INVOICE', '2024-03-03', '303', 'Sale Income From Invoice NO - 1038 Customer Walking Customer', '0.00', '30720.00', '1', '1', '2024-03-03 12:56:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2861, '2744992295', 'INV', '2024-03-03', '102030000002', 'Customer debit For Invoice NO - 1038 customer-  Walking Customer', '30720.00', '0.00', '1', '1', '2024-03-03 12:56:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2862, '5323971621', 'INV', '2024-03-03', '10107', 'Inventory credit For Invoice No1185', '0.00', '1619.00', '1', '1', '2024-03-03 12:58:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2863, '5323971621', 'INVOICE', '2024-03-03', '303', 'Sale Income From Invoice NO - 1185 Customer Walking Customer', '0.00', '1710.00', '1', '1', '2024-03-03 12:58:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2864, '5323971621', 'INV', '2024-03-03', '102030000002', 'Customer debit For Invoice NO - 1185 customer-  Walking Customer', '1710.00', '0.00', '1', '1', '2024-03-03 12:58:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2865, '7214457359', 'INV', '2024-03-03', '10107', 'Inventory credit For Invoice No1188', '0.00', '85078.00', '1', '1', '2024-03-03 13:03:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2866, '7214457359', 'INVOICE', '2024-03-03', '303', 'Sale Income From Invoice NO - 1188 Customer Walking Customer', '0.00', '32136.00', '1', '1', '2024-03-03 13:03:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2867, '7214457359', 'INV', '2024-03-03', '102030000002', 'Customer debit For Invoice NO - 1188 customer-  Walking Customer', '32136.00', '0.00', '1', '1', '2024-03-03 13:03:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2873, '7567791142', 'INV', '2024-03-03', '10107', 'Inventory credit For Invoice No1191', '0.00', '2440.00', '1', '1', '2024-03-03 13:08:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2874, '7567791142', 'INVOICE', '2024-03-03', '303', 'Sale Income From Invoice NO - 1191 Customer Walking Customer', '0.00', '2900.00', '1', '1', '2024-03-03 13:08:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2875, '7567791142', 'INV', '2024-03-03', '102030000002', 'Customer debit For Invoice NO - 1191 customer-  Walking Customer', '2900.00', '0.00', '1', '1', '2024-03-03 13:08:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2886, '20240303134455', 'Purchase', '2024-03-02', '10107', 'Inventory Debit For Supplier Cash Item ', '20600.00', '0.00', '1', '1', '2024-03-03 13:44:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2887, '20240303134455', 'Purchase', '2024-03-02', '502000047', 'Supplier .Cash Item ', '0.00', '20600.00', '1', '1', '2024-03-03 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2888, '20240303134455', 'Purchase', '2024-03-02', '402', 'Company Credit For  Cash Item ', '20600.00', '0.00', '1', '1', '2024-03-03 13:44:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2904, '20240219101430', 'Purchase', '2024-02-01', '10107', 'Inventory Devit Supplier Akram PVC', '6336.00', '0.00', '1', '1', '2024-03-04 08:43:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2905, '20240219101430', 'Purchase', '2024-02-01', '502000006', 'Supplier -Akram PVC', '0.00', '6336.00', '1', '1', '2024-03-04 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2906, '20240219101430', 'Purchase', '2024-02-01', '402', 'Company Credit For SupplierAkram PVC', '6336.00', '0.00', '1', '1', '2024-03-04 08:43:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2907, '20240219101430', 'Purchase', '2024-02-01', '1020101', 'Cash in Hand For Supplier Akram PVC', '0.00', '0.00', '1', '1', '2024-03-04 08:43:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2908, '20240219101430', 'Purchase', '2024-02-01', '502000006', 'Supplier . Akram PVC', '0.00', '0.00', '1', '1', '2024-03-04 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2909, '20240127152129', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier Akram PVC', '94560.00', '0.00', '1', '1', '2024-03-04 08:45:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2910, '20240127152129', 'Purchase', '2023-12-31', '502000006', 'Supplier -Akram PVC', '0.00', '94560.00', '1', '1', '2024-03-04 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2911, '20240127152129', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierAkram PVC', '94560.00', '0.00', '1', '1', '2024-03-04 08:45:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2912, '20240127152129', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier Akram PVC', '0.00', '0.00', '1', '1', '2024-03-04 08:45:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2913, '20240127152129', 'Purchase', '2023-12-31', '502000006', 'Supplier . Akram PVC', '0.00', '0.00', '1', '1', '2024-03-04 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2914, '3213317312', 'INV', '2024-03-04', '10107', 'Inventory credit For Invoice No1221', '0.00', '27177.00', '1', '1', '2024-03-04 08:46:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2915, '3213317312', 'INVOICE', '2024-03-04', '303', 'Sale Income From Invoice NO - 1221 Customer Deluxe Electric', '0.00', '17250.00', '1', '1', '2024-03-04 08:46:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2916, '3213317312', 'INV', '2024-03-04', '102030000017', 'Customer debit For Invoice NO - 1221 customer-  Deluxe Electric', '17250.00', '0.00', '1', '1', '2024-03-04 08:46:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2917, '2152271745', 'INV', '2024-03-04', '10107', 'Inventory credit For Invoice No1222', '0.00', '68325.00', '1', '1', '2024-03-04 08:50:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2918, '2152271745', 'INV', '2024-03-04', '102030000031', 'Customer debit For Invoice No -  1222 Customer Saffan Chilton ', '45095.00', '0.00', '1', '1', '2024-03-04 08:50:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2919, '2152271745', 'INVOICE', '2024-03-04', '303', 'Sale Income For Invoice NO - 1222 Customer Saffan Chilton ', '0.00', '45095.00', '1', '1', '2024-03-04 08:50:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2920, '6726515132', 'INV', '2024-03-04', '10107', 'Inventory credit For Invoice No1223', '0.00', '14242.00', '1', '1', '2024-03-04 08:56:22', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2921, '6726515132', 'INV', '2024-03-04', '102030000024', 'Customer debit For Invoice No -  1223 Customer Eman Electric', '14500.00', '0.00', '1', '1', '2024-03-04 08:56:22', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2922, '6726515132', 'INVOICE', '2024-03-04', '303', 'Sale Income For Invoice NO - 1223 Customer Eman Electric', '0.00', '14500.00', '1', '1', '2024-03-04 08:56:22', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2934, '20240304101147', 'Purchase', '2024-03-04', '10107', 'Inventory Debit For Supplier Delux Electric', '14735.00', '0.00', '1', '1', '2024-03-04 10:11:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2935, '20240304101147', 'Purchase', '2024-03-04', '502000051', 'Supplier .Delux Electric', '0.00', '14735.00', '1', '1', '2024-03-04 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2936, '20240304101147', 'Purchase', '2024-03-04', '402', 'Company Credit For  Delux Electric', '14735.00', '0.00', '1', '1', '2024-03-04 10:11:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2946, '5218857126', 'INV', '2024-03-05', '10107', 'Inventory credit For Invoice No1226', '0.00', '900.00', '1', '1', '2024-03-05 08:13:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2947, '5218857126', 'INV', '2024-03-05', '102030000012', 'Customer debit For Invoice No -  1226 Customer National Spining', '1500.00', '0.00', '1', '1', '2024-03-05 08:13:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2948, '5218857126', 'INVOICE', '2024-03-05', '303', 'Sale Income For Invoice NO - 1226 Customer National Spining', '0.00', '1500.00', '1', '1', '2024-03-05 08:13:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2954, '8125379816', 'INV', '2024-03-05', '10107', 'Inventory credit For Invoice No1028', '0.00', '234847.00', '1', '1', '2024-03-05 08:43:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2955, '8125379816', 'INVOICE', '2024-03-05', '303', 'Sale Income From Invoice NO - 1028 Customer Walking Customer', '0.00', '78805.00', '1', '1', '2024-03-05 08:43:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2956, '8125379816', 'INV', '2024-03-05', '102030000002', 'Customer debit For Invoice NO - 1028 customer-  Walking Customer', '78805.00', '0.00', '1', '1', '2024-03-05 08:43:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2960, '9793391551', 'INV', '2024-03-05', '10107', 'Inventory credit For Invoice No1198', '0.00', '136660.00', '1', '1', '2024-03-05 09:28:01', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2961, '9793391551', 'INVOICE', '2024-03-05', '303', 'Sale Income From Invoice NO - 1198 Customer Walking Customer', '0.00', '42705.00', '1', '1', '2024-03-05 09:28:01', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2962, '9793391551', 'INV', '2024-03-05', '102030000002', 'Customer debit For Invoice NO - 1198 customer-  Walking Customer', '42705.00', '0.00', '1', '1', '2024-03-05 09:28:01', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2966, '3978355951', 'INV', '2024-03-05', '10107', 'Inventory credit For Invoice No1201', '0.00', '77832.00', '1', '1', '2024-03-05 09:39:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2967, '3978355951', 'INVOICE', '2024-03-05', '303', 'Sale Income From Invoice NO - 1201 Customer Walking Customer', '0.00', '53600.00', '1', '1', '2024-03-05 09:39:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2968, '3978355951', 'INV', '2024-03-05', '102030000002', 'Customer debit For Invoice NO - 1201 customer-  Walking Customer', '53600.00', '0.00', '1', '1', '2024-03-05 09:39:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2969, '2968574474', 'INV', '2024-03-05', '10107', 'Inventory credit For Invoice No1197', '0.00', '9320.00', '1', '1', '2024-03-05 09:43:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2970, '2968574474', 'INVOICE', '2024-03-05', '303', 'Sale Income From Invoice NO - 1197 Customer Walking Customer', '0.00', '9100.00', '1', '1', '2024-03-05 09:43:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2971, '2968574474', 'INV', '2024-03-05', '102030000002', 'Customer debit For Invoice NO - 1197 customer-  Walking Customer', '9100.00', '0.00', '1', '1', '2024-03-05 09:43:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2975, '2943739531', 'INV', '2024-03-05', '10107', 'Inventory credit For Invoice No1205', '0.00', '59548.00', '1', '1', '2024-03-05 10:02:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2976, '2943739531', 'INVOICE', '2024-03-05', '303', 'Sale Income From Invoice NO - 1205 Customer Deluxe Electric', '0.00', '61000.00', '1', '1', '2024-03-05 10:02:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2977, '2943739531', 'INV', '2024-03-05', '102030000017', 'Customer debit For Invoice NO - 1205 customer-  Deluxe Electric', '61000.00', '0.00', '1', '1', '2024-03-05 10:02:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2981, '6754142711', 'INV', '2024-03-05', '10107', 'Inventory credit For Invoice No1168', '0.00', '286673.00', '1', '1', '2024-03-05 10:14:02', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2982, '6754142711', 'INVOICE', '2024-03-05', '303', 'Sale Income From Invoice NO - 1168 Customer M.Z Electric', '0.00', '22050.00', '1', '1', '2024-03-05 10:14:02', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2983, '6754142711', 'INV', '2024-03-05', '102030000019', 'Customer debit For Invoice NO - 1168 customer-  M.Z Electric', '22050.00', '0.00', '1', '1', '2024-03-05 10:14:02', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2987, '20240218132207', 'Purchase', '2024-02-01', '10107', 'Inventory Devit Supplier Emaan Light House', '132796.00', '0.00', '1', '1', '2024-03-05 10:22:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2988, '20240218132207', 'Purchase', '2024-02-01', '502000031', 'Supplier -Emaan Light House', '0.00', '132796.00', '1', '1', '2024-03-05 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2989, '20240218132207', 'Purchase', '2024-02-01', '402', 'Company Credit For SupplierEmaan Light House', '132796.00', '0.00', '1', '1', '2024-03-05 10:22:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2990, '20240218132207', 'Purchase', '2024-02-01', '1020101', 'Cash in Hand For Supplier Emaan Light House', '0.00', '0.00', '1', '1', '2024-03-05 10:22:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2991, '20240218132207', 'Purchase', '2024-02-01', '502000031', 'Supplier . Emaan Light House', '0.00', '0.00', '1', '1', '2024-03-05 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2992, '1181438141', 'INV', '2024-03-05', '10107', 'Inventory credit For Invoice No1173', '0.00', '16434.00', '1', '1', '2024-03-05 10:26:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2993, '1181438141', 'INVOICE', '2024-03-05', '303', 'Sale Income From Invoice NO - 1173 Customer Naeem Siyaal', '0.00', '16500.00', '1', '1', '2024-03-05 10:26:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (2994, '1181438141', 'INV', '2024-03-05', '102030000035', 'Customer debit For Invoice NO - 1173 customer-  Naeem Siyaal', '16500.00', '0.00', '1', '1', '2024-03-05 10:26:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3003, '3653113769', 'INV', '2024-03-05', '10107', 'Inventory credit For Invoice No1227', '0.00', '4241.00', '1', '1', '2024-03-05 10:51:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3004, '3653113769', 'INVOICE', '2024-03-05', '303', 'Sale Income From Invoice NO - 1227 Customer G.1 LED', '0.00', '4700.00', '1', '1', '2024-03-05 10:51:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3005, '3653113769', 'INV', '2024-03-05', '102030000039', 'Customer debit For Invoice NO - 1227 customer-  G.1 LED', '4700.00', '0.00', '1', '1', '2024-03-05 10:51:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3012, '20240306081108', 'Purchase', '2024-03-06', '10107', 'Inventory Devit Supplier Delux Electric', '14561.00', '0.00', '1', '1', '2024-03-06 08:17:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3013, '20240306081108', 'Purchase', '2024-03-06', '502000051', 'Supplier -Delux Electric', '0.00', '14561.00', '1', '1', '2024-03-06 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3014, '20240306081108', 'Purchase', '2024-03-06', '402', 'Company Credit For SupplierDelux Electric', '14561.00', '0.00', '1', '1', '2024-03-06 08:17:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3015, '20240306081108', 'Purchase', '2024-03-06', '1020101', 'Cash in Hand For Supplier Delux Electric', '0.00', '0.00', '1', '1', '2024-03-06 08:17:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3016, '20240306081108', 'Purchase', '2024-03-06', '502000051', 'Supplier . Delux Electric', '0.00', '0.00', '1', '1', '2024-03-06 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3017, '3286836845', 'INV', '2024-03-06', '10107', 'Inventory credit For Invoice No1228', '0.00', '28396.00', '1', '1', '2024-03-06 08:31:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3018, '3286836845', 'INV', '2024-03-06', '102030000040', 'Customer debit For Invoice No -  1228 Customer Abdul Manaan ', '22940.00', '0.00', '1', '1', '2024-03-06 08:31:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3019, '3286836845', 'INVOICE', '2024-03-06', '303', 'Sale Income For Invoice NO - 1228 Customer Abdul Manaan ', '0.00', '22940.00', '1', '1', '2024-03-06 08:31:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3020, '4247543232', 'INV', '2024-03-06', '10107', 'Inventory credit For Invoice No1229', '0.00', '28400.00', '1', '1', '2024-03-06 08:34:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3021, '4247543232', 'INV', '2024-03-06', '102030000005', 'Customer debit For Invoice No -  1229 Customer H.M CABLES', '32000.00', '0.00', '1', '1', '2024-03-06 08:34:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3022, '4247543232', 'INVOICE', '2024-03-06', '303', 'Sale Income For Invoice NO - 1229 Customer H.M CABLES', '0.00', '32000.00', '1', '1', '2024-03-06 08:34:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3036, '3755764352', 'INV', '2024-03-06', '10107', 'Inventory credit For Invoice No1231', '0.00', '5808.00', '1', '1', '2024-03-06 09:05:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3037, '3755764352', 'INV', '2024-03-06', '102030000005', 'Customer debit For Invoice No -  1231 Customer H.M CABLES', '9360.00', '0.00', '1', '1', '2024-03-06 09:05:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3038, '3755764352', 'INVOICE', '2024-03-06', '303', 'Sale Income For Invoice NO - 1231 Customer H.M CABLES', '0.00', '9360.00', '1', '1', '2024-03-06 09:05:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3039, '7279214426', 'INV', '2024-03-06', '10107', 'Inventory credit For Invoice No1232', '0.00', '10000.00', '1', '1', '2024-03-06 09:06:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3040, '7279214426', 'INV', '2024-03-06', '102030000005', 'Customer debit For Invoice No -  1232 Customer H.M CABLES', '13400.00', '0.00', '1', '1', '2024-03-06 09:06:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3041, '7279214426', 'INVOICE', '2024-03-06', '303', 'Sale Income For Invoice NO - 1232 Customer H.M CABLES', '0.00', '13400.00', '1', '1', '2024-03-06 09:06:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3042, '2181869592', 'INV', '2024-03-06', '10107', 'Inventory credit For Invoice No1233', '0.00', '60447.00', '1', '1', '2024-03-06 09:41:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3043, '2181869592', 'INV', '2024-03-06', '102030000024', 'Customer debit For Invoice No -  1233 Customer Eman Electric', '47900.00', '0.00', '1', '1', '2024-03-06 09:41:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3044, '2181869592', 'INVOICE', '2024-03-06', '303', 'Sale Income For Invoice NO - 1233 Customer Eman Electric', '0.00', '47900.00', '1', '1', '2024-03-06 09:41:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3045, '2433914368', 'INV', '2024-03-06', '10107', 'Inventory credit For Invoice No1234', '0.00', '409605.00', '1', '1', '2024-03-06 10:03:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3046, '2433914368', 'INV', '2024-03-06', '102030000026', 'Customer debit For Invoice No -  1234 Customer Memon Light  ', '15920.00', '0.00', '1', '1', '2024-03-06 10:03:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3047, '2433914368', 'INVOICE', '2024-03-06', '303', 'Sale Income For Invoice NO - 1234 Customer Memon Light  ', '0.00', '15920.00', '1', '1', '2024-03-06 10:03:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3051, '20240306115339', 'Purchase', '2024-03-06', '10107', 'Inventory Debit For Supplier Cash Item ', '6000.00', '0.00', '1', '1', '2024-03-06 11:53:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3052, '20240306115339', 'Purchase', '2024-03-06', '502000047', 'Supplier .Cash Item ', '0.00', '6000.00', '1', '1', '2024-03-06 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3053, '20240306115339', 'Purchase', '2024-03-06', '402', 'Company Credit For  Cash Item ', '6000.00', '0.00', '1', '1', '2024-03-06 11:53:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3060, '5892378914', 'INV', '2024-03-06', '10107', 'Inventory credit For Invoice No1219', '0.00', '109845.00', '1', '1', '2024-03-06 14:21:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3061, '5892378914', 'INVOICE', '2024-03-06', '303', 'Sale Income From Invoice NO - 1219 Customer Abdul Qadir Electric ', '0.00', '75480.00', '1', '1', '2024-03-06 14:21:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3062, '5892378914', 'INV', '2024-03-06', '102030000016', 'Customer debit For Invoice NO - 1219 customer-  Abdul Qadir Electric ', '75480.00', '0.00', '1', '1', '2024-03-06 14:21:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3063, '20240128140222', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier Al Mezan Sargodah', '43245.00', '0.00', '1', '1', '2024-03-06 14:22:21', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3064, '20240128140222', 'Purchase', '2023-12-31', '502000013', 'Supplier -Al Mezan Sargodah', '0.00', '43245.00', '1', '1', '2024-03-06 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3065, '20240128140222', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierAl Mezan Sargodah', '43245.00', '0.00', '1', '1', '2024-03-06 14:22:21', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3066, '20240128140222', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier Al Mezan Sargodah', '0.00', '0.00', '1', '1', '2024-03-06 14:22:21', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3067, '20240128140222', 'Purchase', '2023-12-31', '502000013', 'Supplier . Al Mezan Sargodah', '0.00', '0.00', '1', '1', '2024-03-06 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3068, '3529147678', 'INV', '2024-03-06', '10107', 'Inventory credit For Invoice No1220', '0.00', '18313.00', '1', '1', '2024-03-06 14:35:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3069, '3529147678', 'INVOICE', '2024-03-06', '303', 'Sale Income From Invoice NO - 1220 Customer Faizan Basti ', '0.00', '8160.00', '1', '1', '2024-03-06 14:35:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3070, '3529147678', 'INV', '2024-03-06', '102030000006', 'Customer debit For Invoice NO - 1220 customer-  Faizan Basti ', '8160.00', '0.00', '1', '1', '2024-03-06 14:35:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3071, '2625175392', 'INV', '2024-03-09', '10107', 'Inventory credit For Invoice No1236', '0.00', '7201.00', '1', '1', '2024-03-09 15:05:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3072, '2625175392', 'INV', '2024-03-09', '102030000002', 'Customer debit For Invoice No -  1236 Customer Walking Customer', '10050.00', '0.00', '1', '1', '2024-03-09 15:05:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3073, '2625175392', 'INVOICE', '2024-03-09', '303', 'Sale Income For Invoice NO - 1236 Customer Walking Customer', '0.00', '10050.00', '1', '1', '2024-03-09 15:05:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3091, '20240311094742', 'Purchase', '2024-03-07', '10107', 'Inventory Debit For Supplier Majid Fan Rod ', '6000.00', '0.00', '1', '1', '2024-03-11 09:47:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3092, '20240311094742', 'Purchase', '2024-03-07', '502000052', 'Supplier .Majid Fan Rod ', '0.00', '6000.00', '1', '1', '2024-03-11 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3093, '20240311094742', 'Purchase', '2024-03-07', '402', 'Company Credit For  Majid Fan Rod ', '6000.00', '0.00', '1', '1', '2024-03-11 09:47:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3106, '20240311101927', 'Purchase', '2024-03-09', '10107', 'Inventory Devit Supplier Chilton Traders Karachi', '178104.00', '0.00', '1', '1', '2024-03-11 14:13:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3107, '20240311101927', 'Purchase', '2024-03-09', '502000032', 'Supplier -Chilton Traders Karachi', '0.00', '178104.00', '1', '1', '2024-03-11 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3108, '20240311101927', 'Purchase', '2024-03-09', '402', 'Company Credit For SupplierChilton Traders Karachi', '178104.00', '0.00', '1', '1', '2024-03-11 14:13:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3109, '20240311101927', 'Purchase', '2024-03-09', '1020101', 'Cash in Hand For Supplier Chilton Traders Karachi', '0.00', '0.00', '1', '1', '2024-03-11 14:13:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3110, '20240311101927', 'Purchase', '2024-03-09', '502000032', 'Supplier . Chilton Traders Karachi', '0.00', '0.00', '1', '1', '2024-03-11 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3135, '20240304150336', 'Purchase', '2024-03-04', '10107', 'Inventory Devit Supplier Cash Item ', '28400.00', '0.00', '1', '1', '2024-03-12 11:21:05', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3136, '20240304150336', 'Purchase', '2024-03-04', '502000047', 'Supplier -Cash Item ', '0.00', '28400.00', '1', '1', '2024-03-12 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3137, '20240304150336', 'Purchase', '2024-03-04', '402', 'Company Credit For SupplierCash Item ', '28400.00', '0.00', '1', '1', '2024-03-12 11:21:05', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3138, '20240304150336', 'Purchase', '2024-03-04', '1020101', 'Cash in Hand For Supplier Cash Item ', '0.00', '0.00', '1', '1', '2024-03-12 11:21:05', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3139, '20240304150336', 'Purchase', '2024-03-04', '502000047', 'Supplier . Cash Item ', '0.00', '0.00', '1', '1', '2024-03-12 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3143, '2968542394', 'INV', '2024-03-12', '10107', 'Inventory credit For Invoice No1243', '0.00', '39679.00', '1', '1', '2024-03-12 11:39:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3144, '2968542394', 'INV', '2024-03-12', '102030000017', 'Customer debit For Invoice No -  1243 Customer Deluxe Electric', '42025.00', '0.00', '1', '1', '2024-03-12 11:39:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3145, '2968542394', 'INVOICE', '2024-03-12', '303', 'Sale Income For Invoice NO - 1243 Customer Deluxe Electric', '0.00', '42025.00', '1', '1', '2024-03-12 11:39:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3205, '20240311101341', 'Purchase', '2024-03-10', '10107', 'Inventory Devit Supplier Delux Electric Purchase ', '98633.00', '0.00', '1', '1', '2024-03-13 08:30:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3206, '20240311101341', 'Purchase', '2024-03-10', '502000051', 'Supplier -Delux Electric Purchase ', '0.00', '98633.00', '1', '1', '2024-03-13 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3207, '20240311101341', 'Purchase', '2024-03-10', '402', 'Company Credit For SupplierDelux Electric Purchase ', '98633.00', '0.00', '1', '1', '2024-03-13 08:30:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3208, '20240311101341', 'Purchase', '2024-03-10', '1020101', 'Cash in Hand For Supplier Delux Electric Purchase ', '0.00', '0.00', '1', '1', '2024-03-13 08:30:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3209, '20240311101341', 'Purchase', '2024-03-10', '502000051', 'Supplier . Delux Electric Purchase ', '0.00', '0.00', '1', '1', '2024-03-13 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3221, '8143852489', 'INV', '2024-03-13', '10107', 'Inventory credit For Invoice No1240', '0.00', '20620.00', '1', '1', '2024-03-13 08:51:31', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3222, '8143852489', 'INVOICE', '2024-03-13', '303', 'Sale Income From Invoice NO - 1240 Customer Walking Customer', '0.00', '20145.00', '1', '1', '2024-03-13 08:51:31', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3223, '8143852489', 'INV', '2024-03-13', '102030000002', 'Customer debit For Invoice NO - 1240 customer-  Walking Customer', '20145.00', '0.00', '1', '1', '2024-03-13 08:51:31', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3233, '20240219081530', 'Purchase', '2024-02-01', '10107', 'Inventory Devit Supplier Paremount General', '19790.00', '0.00', '1', '1', '2024-03-13 09:35:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3234, '20240219081530', 'Purchase', '2024-02-01', '502000038', 'Supplier -Paremount General', '0.00', '19790.00', '1', '1', '2024-03-13 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3235, '20240219081530', 'Purchase', '2024-02-01', '402', 'Company Credit For SupplierParemount General', '19790.00', '0.00', '1', '1', '2024-03-13 09:35:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3236, '20240219081530', 'Purchase', '2024-02-01', '1020101', 'Cash in Hand For Supplier Paremount General', '0.00', '0.00', '1', '1', '2024-03-13 09:35:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3237, '20240219081530', 'Purchase', '2024-02-01', '502000038', 'Supplier . Paremount General', '0.00', '0.00', '1', '1', '2024-03-13 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3246, '9445627595', 'INV', '2024-03-13', '10107', 'Inventory credit For Invoice No1241', '0.00', '194907.00', '1', '1', '2024-03-13 09:54:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3247, '9445627595', 'INVOICE', '2024-03-13', '303', 'Sale Income From Invoice NO - 1241 Customer Walking Customer', '0.00', '74254.00', '1', '1', '2024-03-13 09:54:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3248, '9445627595', 'INV', '2024-03-13', '102030000002', 'Customer debit For Invoice NO - 1241 customer-  Walking Customer', '74254.00', '0.00', '1', '1', '2024-03-13 09:54:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3249, '1797695428', 'INV', '2024-03-13', '10107', 'Inventory credit For Invoice No1249', '0.00', '94903.00', '1', '1', '2024-03-13 10:10:19', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3250, '1797695428', 'INV', '2024-03-13', '102030000002', 'Customer debit For Invoice No -  1249 Customer Walking Customer', '14550.00', '0.00', '1', '1', '2024-03-13 10:10:19', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3251, '1797695428', 'INVOICE', '2024-03-13', '303', 'Sale Income For Invoice NO - 1249 Customer Walking Customer', '0.00', '14550.00', '1', '1', '2024-03-13 10:10:19', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3252, '1999134661', 'INV', '2024-03-13', '10107', 'Inventory credit For Invoice No1218', '0.00', '28207.00', '1', '1', '2024-03-13 11:05:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3253, '1999134661', 'INVOICE', '2024-03-13', '303', 'Sale Income From Invoice NO - 1218 Customer Walking Customer', '0.00', '28450.00', '1', '1', '2024-03-13 11:05:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3254, '1999134661', 'INV', '2024-03-13', '102030000002', 'Customer debit For Invoice NO - 1218 customer-  Walking Customer', '28450.00', '0.00', '1', '1', '2024-03-13 11:05:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3255, '3798734435', 'INV', '2024-03-13', '10107', 'Inventory credit For Invoice No1224', '0.00', '1320.00', '1', '1', '2024-03-13 11:05:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3256, '3798734435', 'INVOICE', '2024-03-13', '303', 'Sale Income From Invoice NO - 1224 Customer Walking Customer', '0.00', '1640.00', '1', '1', '2024-03-13 11:05:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3257, '3798734435', 'INV', '2024-03-13', '102030000002', 'Customer debit For Invoice NO - 1224 customer-  Walking Customer', '1640.00', '0.00', '1', '1', '2024-03-13 11:05:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3258, '1995273414', 'INV', '2024-03-13', '10107', 'Inventory credit For Invoice No1225', '0.00', '4035.00', '1', '1', '2024-03-13 11:06:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3259, '1995273414', 'INVOICE', '2024-03-13', '303', 'Sale Income From Invoice NO - 1225 Customer Walking Customer', '0.00', '4550.00', '1', '1', '2024-03-13 11:06:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3260, '1995273414', 'INV', '2024-03-13', '102030000002', 'Customer debit For Invoice NO - 1225 customer-  Walking Customer', '4550.00', '0.00', '1', '1', '2024-03-13 11:06:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3269, '6637133796', 'INV', '2024-03-13', '10107', 'Inventory credit For Invoice No1237', '0.00', '3440.00', '1', '1', '2024-03-13 11:13:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3270, '6637133796', 'INVOICE', '2024-03-13', '303', 'Sale Income From Invoice NO - 1237 Customer Walking Customer', '0.00', '4000.00', '1', '1', '2024-03-13 11:13:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3271, '6637133796', 'INV', '2024-03-13', '102030000002', 'Customer debit For Invoice NO - 1237 customer-  Walking Customer', '4000.00', '0.00', '1', '1', '2024-03-13 11:13:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3272, '1371539249', 'INV', '2024-03-13', '10107', 'Inventory credit For Invoice No1238', '0.00', '11466.00', '1', '1', '2024-03-13 11:16:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3273, '1371539249', 'INVOICE', '2024-03-13', '303', 'Sale Income From Invoice NO - 1238 Customer Walking Customer', '0.00', '7840.00', '1', '1', '2024-03-13 11:16:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3274, '1371539249', 'INV', '2024-03-13', '102030000002', 'Customer debit For Invoice NO - 1238 customer-  Walking Customer', '7840.00', '0.00', '1', '1', '2024-03-13 11:16:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3275, '4738635783', 'INV', '2024-03-13', '10107', 'Inventory credit For Invoice No1239', '0.00', '25831.00', '1', '1', '2024-03-13 11:29:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3276, '4738635783', 'INVOICE', '2024-03-13', '303', 'Sale Income From Invoice NO - 1239 Customer Walking Customer', '0.00', '25100.00', '1', '1', '2024-03-13 11:29:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3277, '4738635783', 'INV', '2024-03-13', '102030000002', 'Customer debit For Invoice NO - 1239 customer-  Walking Customer', '25100.00', '0.00', '1', '1', '2024-03-13 11:29:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3286, '20240218143236', 'Purchase', '2024-02-01', '10107', 'Inventory Devit Supplier G.One LED Light', '435590.00', '0.00', '1', '1', '2024-03-14 08:26:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3287, '20240218143236', 'Purchase', '2024-02-01', '502000027', 'Supplier -G.One LED Light', '0.00', '435590.00', '1', '1', '2024-03-14 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3288, '20240218143236', 'Purchase', '2024-02-01', '402', 'Company Credit For SupplierG.One LED Light', '435590.00', '0.00', '1', '1', '2024-03-14 08:26:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3289, '20240218143236', 'Purchase', '2024-02-01', '1020101', 'Cash in Hand For Supplier G.One LED Light', '0.00', '0.00', '1', '1', '2024-03-14 08:26:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3290, '20240218143236', 'Purchase', '2024-02-01', '502000027', 'Supplier . G.One LED Light', '0.00', '0.00', '1', '1', '2024-03-14 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3291, '20240313074325', 'Purchase', '2024-03-13', '10107', 'Inventory Devit Supplier G.One LED Light', '69100.00', '0.00', '1', '1', '2024-03-14 08:27:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3292, '20240313074325', 'Purchase', '2024-03-13', '502000027', 'Supplier -G.One LED Light', '0.00', '69100.00', '1', '1', '2024-03-14 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3293, '20240313074325', 'Purchase', '2024-03-13', '402', 'Company Credit For SupplierG.One LED Light', '69100.00', '0.00', '1', '1', '2024-03-14 08:27:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3294, '20240313074325', 'Purchase', '2024-03-13', '1020101', 'Cash in Hand For Supplier G.One LED Light', '0.00', '0.00', '1', '1', '2024-03-14 08:27:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3295, '20240313074325', 'Purchase', '2024-03-13', '502000027', 'Supplier . G.One LED Light', '0.00', '0.00', '1', '1', '2024-03-14 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3299, '9294923342', 'INV', '2024-03-14', '10107', 'Inventory credit For Invoice No1251', '0.00', '13442.00', '1', '1', '2024-03-14 08:43:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3300, '9294923342', 'INV', '2024-03-14', '102030000002', 'Customer debit For Invoice No -  1251 Customer Walking Customer', '33930.00', '0.00', '1', '1', '2024-03-14 08:43:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3301, '9294923342', 'INVOICE', '2024-03-14', '303', 'Sale Income For Invoice NO - 1251 Customer Walking Customer', '0.00', '33930.00', '1', '1', '2024-03-14 08:43:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3307, '6172987557', 'INV', '2024-03-14', '10107', 'Inventory credit For Invoice No1252', '0.00', '32412.00', '1', '1', '2024-03-14 09:11:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3308, '6172987557', 'INV', '2024-03-14', '102030000006', 'Customer debit For Invoice No -  1252 Customer Faizan Basti ', '11820.00', '0.00', '1', '1', '2024-03-14 09:11:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3309, '6172987557', 'INVOICE', '2024-03-14', '303', 'Sale Income For Invoice NO - 1252 Customer Faizan Basti ', '0.00', '11820.00', '1', '1', '2024-03-14 09:11:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3318, '20240311102140', 'Purchase', '2024-03-09', '10107', 'Inventory Devit Supplier Arfeen Wire (Million)', '44958.00', '0.00', '1', '1', '2024-03-14 09:22:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3319, '20240311102140', 'Purchase', '2024-03-09', '502000029', 'Supplier -Arfeen Wire (Million)', '0.00', '44958.00', '1', '1', '2024-03-14 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3320, '20240311102140', 'Purchase', '2024-03-09', '402', 'Company Credit For SupplierArfeen Wire (Million)', '44958.00', '0.00', '1', '1', '2024-03-14 09:22:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3321, '20240311102140', 'Purchase', '2024-03-09', '1020101', 'Cash in Hand For Supplier Arfeen Wire (Million)', '0.00', '0.00', '1', '1', '2024-03-14 09:22:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3322, '20240311102140', 'Purchase', '2024-03-09', '502000029', 'Supplier . Arfeen Wire (Million)', '0.00', '0.00', '1', '1', '2024-03-14 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3323, '8676718682', 'INV', '2024-03-14', '10107', 'Inventory credit For Invoice No1253', '0.00', '25463.00', '1', '1', '2024-03-14 09:24:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3324, '8676718682', 'INVOICE', '2024-03-14', '303', 'Sale Income From Invoice NO - 1253 Customer Memon Light  ', '0.00', '36720.00', '1', '1', '2024-03-14 09:24:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3325, '8676718682', 'INV', '2024-03-14', '102030000026', 'Customer debit For Invoice NO - 1253 customer-  Memon Light  ', '36720.00', '0.00', '1', '1', '2024-03-14 09:24:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3338, '2124638789', 'INV', '2024-03-14', '10107', 'Inventory credit For Invoice No1254', '0.00', '402159.00', '1', '1', '2024-03-14 09:58:15', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3339, '2124638789', 'INVOICE', '2024-03-14', '303', 'Sale Income From Invoice NO - 1254 Customer Deluxe Electric', '0.00', '96975.00', '1', '1', '2024-03-14 09:58:15', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3340, '2124638789', 'INV', '2024-03-14', '102030000017', 'Customer debit For Invoice NO - 1254 customer-  Deluxe Electric', '96975.00', '0.00', '1', '1', '2024-03-14 09:58:15', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3350, '6343288937', 'INV', '2024-03-14', '10107', 'Inventory credit For Invoice No1256', '0.00', '10596.00', '1', '1', '2024-03-14 11:14:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3351, '6343288937', 'INVOICE', '2024-03-14', '303', 'Sale Income From Invoice NO - 1256 Customer M.D.M Mill', '0.00', '9080.00', '1', '1', '2024-03-14 11:14:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3352, '6343288937', 'INV', '2024-03-14', '102030000011', 'Customer debit For Invoice NO - 1256 customer-  M.D.M Mill', '9080.00', '0.00', '1', '1', '2024-03-14 11:14:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3359, '2588954467', 'INV', '2024-03-14', '10107', 'Inventory credit For Invoice No1258', '0.00', '10734.00', '1', '1', '2024-03-14 12:23:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3360, '2588954467', 'INV', '2024-03-14', '102030000041', 'Customer debit For Invoice No -  1258 Customer M.Ameen', '11550.00', '0.00', '1', '1', '2024-03-14 12:23:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3361, '2588954467', 'INVOICE', '2024-03-14', '303', 'Sale Income For Invoice NO - 1258 Customer M.Ameen', '0.00', '11550.00', '1', '1', '2024-03-14 12:23:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3395, '3799993359', 'INV', '2024-03-16', '10107', 'Inventory credit For Invoice No1259', '0.00', '12209.00', '1', '1', '2024-03-16 11:23:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3396, '3799993359', 'INV', '2024-03-16', '102030000002', 'Customer debit For Invoice No -  1259 Customer Walking Customer', '12340.00', '0.00', '1', '1', '2024-03-16 11:23:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3397, '3799993359', 'INVOICE', '2024-03-16', '303', 'Sale Income For Invoice NO - 1259 Customer Walking Customer', '0.00', '12340.00', '1', '1', '2024-03-16 11:23:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3401, '3897865422', 'INV', '2024-03-16', '10107', 'Inventory credit For Invoice No1250', '0.00', '430.00', '1', '1', '2024-03-16 11:33:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3402, '3897865422', 'INVOICE', '2024-03-16', '303', 'Sale Income From Invoice NO - 1250 Customer Mustufa Arif', '0.00', '-246480.00', '1', '1', '2024-03-16 11:33:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3403, '3897865422', 'INV', '2024-03-16', '102030000023', 'Customer debit For Invoice NO - 1250 customer-  Mustufa Arif', '0.00', '0.00', '1', '1', '2024-03-16 11:33:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3404, '20240316092326', 'Purchase', '2024-03-16', '10107', 'Inventory Devit Supplier Sale Return ', '19695.00', '0.00', '1', '1', '2024-03-16 12:06:50', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3405, '20240316092326', 'Purchase', '2024-03-16', '502000054', 'Supplier -Sale Return ', '0.00', '19695.00', '1', '1', '2024-03-16 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3406, '20240316092326', 'Purchase', '2024-03-16', '402', 'Company Credit For SupplierSale Return ', '19695.00', '0.00', '1', '1', '2024-03-16 12:06:50', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3407, '20240316092326', 'Purchase', '2024-03-16', '1020101', 'Cash in Hand For Supplier Sale Return ', '0.00', '0.00', '1', '1', '2024-03-16 12:06:50', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3408, '20240316092326', 'Purchase', '2024-03-16', '502000054', 'Supplier . Sale Return ', '0.00', '0.00', '1', '1', '2024-03-16 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3415, '6333182967', 'INV', '2024-03-17', '10107', 'Inventory credit For Invoice No1246', '0.00', '0.00', '1', '1', '2024-03-17 07:30:26', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3416, '6333182967', 'INVOICE', '2024-03-17', '303', 'Sale Income From Invoice NO - 1246 Customer Mustufa Arif', '0.00', '-219860.00', '1', '1', '2024-03-17 07:30:26', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3417, '6333182967', 'INV', '2024-03-17', '102030000023', 'Customer debit For Invoice NO - 1246 customer-  Mustufa Arif', '0.00', '0.00', '1', '1', '2024-03-17 07:30:26', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3418, '2855145682', 'INV', '2024-03-17', '10107', 'Inventory credit For Invoice No1261', '0.00', '439750.00', '1', '1', '2024-03-17 08:05:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3419, '2855145682', 'INV', '2024-03-17', '102030000031', 'Customer debit For Invoice No -  1261 Customer Saffan Chilton ', '388750.00', '0.00', '1', '1', '2024-03-17 08:05:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3420, '2855145682', 'INVOICE', '2024-03-17', '303', 'Sale Income For Invoice NO - 1261 Customer Saffan Chilton ', '0.00', '388750.00', '1', '1', '2024-03-17 08:05:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3424, '7418519547', 'INV', '2024-03-17', '10107', 'Inventory credit For Invoice No1079', '0.00', '0.00', '1', '1', '2024-03-17 10:57:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3425, '7418519547', 'INVOICE', '2024-03-17', '303', 'Sale Income From Invoice NO - 1079 Customer Mustufa Arif', '0.00', '-209968.00', '1', '1', '2024-03-17 10:57:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3426, '7418519547', 'INV', '2024-03-17', '102030000023', 'Customer debit For Invoice NO - 1079 customer-  Mustufa Arif', '0.00', '0.00', '1', '1', '2024-03-17 10:57:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3472, '20240306080604', 'Purchase', '2024-03-05', '10107', 'Inventory Devit Supplier Arfeen Wire (Million)', '0.00', '0.00', '1', '1', '2024-03-18 09:51:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3473, '20240306080604', 'Purchase', '2024-03-05', '502000029', 'Supplier -Arfeen Wire (Million)', '0.00', '0.00', '1', '1', '2024-03-18 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3474, '20240306080604', 'Purchase', '2024-03-05', '402', 'Company Credit For SupplierArfeen Wire (Million)', '0.00', '0.00', '1', '1', '2024-03-18 09:51:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3475, '20240306080604', 'Purchase', '2024-03-05', '1020101', 'Cash in Hand For Supplier Arfeen Wire (Million)', '0.00', '0.00', '1', '1', '2024-03-18 09:51:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3476, '20240306080604', 'Purchase', '2024-03-05', '502000029', 'Supplier . Arfeen Wire (Million)', '0.00', '0.00', '1', '1', '2024-03-18 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3525, '7123693583', 'INV', '2024-03-19', '10107', 'Inventory credit For Invoice No1260', '0.00', '68482.00', '1', '1', '2024-03-19 08:29:31', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3526, '7123693583', 'INVOICE', '2024-03-19', '303', 'Sale Income From Invoice NO - 1260 Customer Walking Customer', '0.00', '51460.00', '1', '1', '2024-03-19 08:29:31', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3527, '7123693583', 'INV', '2024-03-19', '102030000002', 'Customer debit For Invoice NO - 1260 customer-  Walking Customer', '51460.00', '0.00', '1', '1', '2024-03-19 08:29:31', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3552, '20240319123514', 'Purchase', '2024-03-16', '10107', 'Inventory Debit For Supplier Arslan LED', '22800.00', '0.00', '1', '1', '2024-03-19 12:35:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3553, '20240319123514', 'Purchase', '2024-03-16', '502000002', 'Supplier .Arslan LED', '0.00', '22800.00', '1', '1', '2024-03-19 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3554, '20240319123514', 'Purchase', '2024-03-16', '402', 'Company Credit For  Arslan LED', '22800.00', '0.00', '1', '1', '2024-03-19 12:35:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3572, '20240319161245', 'Purchase', '2024-03-18', '10107', 'Inventory Debit For Supplier Cash Item ', '38240.00', '0.00', '1', '1', '2024-03-19 16:12:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3573, '20240319161245', 'Purchase', '2024-03-18', '502000047', 'Supplier .Cash Item ', '0.00', '38240.00', '1', '1', '2024-03-19 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3574, '20240319161245', 'Purchase', '2024-03-18', '402', 'Company Credit For  Cash Item ', '38240.00', '0.00', '1', '1', '2024-03-19 16:12:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3581, '20240320073005', 'Purchase', '2024-03-19', '10107', 'Inventory Devit Supplier Cash Item ', '53220.00', '0.00', '1', '1', '2024-03-20 07:52:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3582, '20240320073005', 'Purchase', '2024-03-19', '502000047', 'Supplier -Cash Item ', '0.00', '53220.00', '1', '1', '2024-03-20 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3583, '20240320073005', 'Purchase', '2024-03-19', '402', 'Company Credit For SupplierCash Item ', '53220.00', '0.00', '1', '1', '2024-03-20 07:52:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3584, '20240320073005', 'Purchase', '2024-03-19', '1020101', 'Cash in Hand For Supplier Cash Item ', '0.00', '0.00', '1', '1', '2024-03-20 07:52:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3585, '20240320073005', 'Purchase', '2024-03-19', '502000047', 'Supplier . Cash Item ', '0.00', '0.00', '1', '1', '2024-03-20 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3586, '20240320075630', 'Purchase', '2024-03-19', '10107', 'Inventory Debit For Supplier Chilton Traders Karachi', '92000.00', '0.00', '1', '1', '2024-03-20 07:56:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3587, '20240320075630', 'Purchase', '2024-03-19', '502000032', 'Supplier .Chilton Traders Karachi', '0.00', '92000.00', '1', '1', '2024-03-20 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3588, '20240320075630', 'Purchase', '2024-03-19', '402', 'Company Credit For  Chilton Traders Karachi', '92000.00', '0.00', '1', '1', '2024-03-20 07:56:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3598, '2985475614', 'INV', '2024-03-20', '10107', 'Inventory credit For Invoice No1267', '0.00', '953.00', '1', '1', '2024-03-20 09:13:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3599, '2985475614', 'INV', '2024-03-20', '102030000011', 'Customer debit For Invoice No -  1267 Customer M.D.M Mill', '1170.00', '0.00', '1', '1', '2024-03-20 09:13:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3600, '2985475614', 'INVOICE', '2024-03-20', '303', 'Sale Income For Invoice NO - 1267 Customer M.D.M Mill', '0.00', '1170.00', '1', '1', '2024-03-20 09:13:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3601, '3689542297', 'INV', '2024-03-20', '10107', 'Inventory credit For Invoice No1268', '0.00', '1190.00', '1', '1', '2024-03-20 09:16:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3602, '3689542297', 'INV', '2024-03-20', '102030000041', 'Customer debit For Invoice No -  1268 Customer M.Ameen', '1170.00', '0.00', '1', '1', '2024-03-20 09:16:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3603, '3689542297', 'INVOICE', '2024-03-20', '303', 'Sale Income For Invoice NO - 1268 Customer M.Ameen', '0.00', '1170.00', '1', '1', '2024-03-20 09:16:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3604, '9855185474', 'INV', '2024-03-20', '10107', 'Inventory credit For Invoice No1269', '0.00', '600.00', '1', '1', '2024-03-20 09:19:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3605, '9855185474', 'INV', '2024-03-20', '102030000002', 'Customer debit For Invoice No -  1269 Customer Walking Customer', '700.00', '0.00', '1', '1', '2024-03-20 09:19:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3606, '9855185474', 'INVOICE', '2024-03-20', '303', 'Sale Income For Invoice NO - 1269 Customer Walking Customer', '0.00', '700.00', '1', '1', '2024-03-20 09:19:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3607, '3253157469', 'INV', '2024-03-20', '10107', 'Inventory credit For Invoice No1270', '0.00', '14805.00', '1', '1', '2024-03-20 09:21:26', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3608, '3253157469', 'INV', '2024-03-20', '102030000031', 'Customer debit For Invoice No -  1270 Customer Saffan Chilton ', '22775.00', '0.00', '1', '1', '2024-03-20 09:21:26', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3609, '3253157469', 'INVOICE', '2024-03-20', '303', 'Sale Income For Invoice NO - 1270 Customer Saffan Chilton ', '0.00', '22775.00', '1', '1', '2024-03-20 09:21:26', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3613, '20240320092434', 'Purchase', '2024-03-20', '10107', 'Inventory Devit Supplier New Shahid Pipe', '43600.00', '0.00', '1', '1', '2024-03-20 09:26:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3614, '20240320092434', 'Purchase', '2024-03-20', '502000035', 'Supplier -New Shahid Pipe', '0.00', '43600.00', '1', '1', '2024-03-20 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3615, '20240320092434', 'Purchase', '2024-03-20', '402', 'Company Credit For SupplierNew Shahid Pipe', '43600.00', '0.00', '1', '1', '2024-03-20 09:26:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3616, '20240320092434', 'Purchase', '2024-03-20', '1020101', 'Cash in Hand For Supplier New Shahid Pipe', '0.00', '0.00', '1', '1', '2024-03-20 09:26:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3617, '20240320092434', 'Purchase', '2024-03-20', '502000035', 'Supplier . New Shahid Pipe', '0.00', '0.00', '1', '1', '2024-03-20 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3618, '5241153453', 'INV', '2024-03-20', '10107', 'Inventory credit For Invoice No1271', '0.00', '11500.00', '1', '1', '2024-03-20 09:29:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3619, '5241153453', 'INV', '2024-03-20', '102030000026', 'Customer debit For Invoice No -  1271 Customer Memon Light  ', '12000.00', '0.00', '1', '1', '2024-03-20 09:29:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3620, '5241153453', 'INVOICE', '2024-03-20', '303', 'Sale Income For Invoice NO - 1271 Customer Memon Light  ', '0.00', '12000.00', '1', '1', '2024-03-20 09:29:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3621, '4636966543', 'INV', '2024-03-20', '10107', 'Inventory credit For Invoice No1272', '0.00', '4580.00', '1', '1', '2024-03-20 09:39:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3622, '4636966543', 'INV', '2024-03-20', '102030000009', 'Customer debit For Invoice No -  1272 Customer Zahid somoro', '5480.00', '0.00', '1', '1', '2024-03-20 09:39:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3623, '4636966543', 'INVOICE', '2024-03-20', '303', 'Sale Income For Invoice NO - 1272 Customer Zahid somoro', '0.00', '5480.00', '1', '1', '2024-03-20 09:39:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3627, '9432582367', 'INV', '2024-03-20', '10107', 'Inventory credit For Invoice No1273', '0.00', '316928.00', '1', '1', '2024-03-20 10:04:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3628, '9432582367', 'INVOICE', '2024-03-20', '303', 'Sale Income From Invoice NO - 1273 Customer Deluxe Electric', '0.00', '95135.00', '1', '1', '2024-03-20 10:04:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3629, '9432582367', 'INV', '2024-03-20', '102030000017', 'Customer debit For Invoice NO - 1273 customer-  Deluxe Electric', '95135.00', '0.00', '1', '1', '2024-03-20 10:04:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3633, '20240219094915', 'Purchase', '2024-02-01', '10107', 'Inventory Devit Supplier Cash Item ', '177133.00', '0.00', '1', '1', '2024-03-20 11:15:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3634, '20240219094915', 'Purchase', '2024-02-01', '502000047', 'Supplier -Cash Item ', '0.00', '177133.00', '1', '1', '2024-03-20 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3635, '20240219094915', 'Purchase', '2024-02-01', '402', 'Company Credit For SupplierCash Item ', '177133.00', '0.00', '1', '1', '2024-03-20 11:15:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3636, '20240219094915', 'Purchase', '2024-02-01', '1020101', 'Cash in Hand For Supplier Cash Item ', '0.00', '0.00', '1', '1', '2024-03-20 11:15:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3637, '20240219094915', 'Purchase', '2024-02-01', '502000047', 'Supplier . Cash Item ', '0.00', '0.00', '1', '1', '2024-03-20 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3638, '9272887417', 'INV', '2024-03-20', '10107', 'Inventory credit For Invoice No1274', '0.00', '51432.00', '1', '1', '2024-03-20 11:16:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3639, '9272887417', 'INVOICE', '2024-03-20', '303', 'Sale Income From Invoice NO - 1274 Customer Dawood Center Auto Bhan', '0.00', '53600.00', '1', '1', '2024-03-20 11:16:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3640, '9272887417', 'INV', '2024-03-20', '102030000042', 'Customer debit For Invoice NO - 1274 customer-  Dawood Center Auto Bhan', '53600.00', '0.00', '1', '1', '2024-03-20 11:16:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3652, '20240320123450', 'Purchase', '2024-03-20', '10107', 'Inventory Devit Supplier G.One LED Light', '117250.00', '0.00', '1', '1', '2024-03-20 12:43:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3653, '20240320123450', 'Purchase', '2024-03-20', '502000027', 'Supplier -G.One LED Light', '0.00', '117250.00', '1', '1', '2024-03-20 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3654, '20240320123450', 'Purchase', '2024-03-20', '402', 'Company Credit For SupplierG.One LED Light', '117250.00', '0.00', '1', '1', '2024-03-20 12:43:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3655, '20240320123450', 'Purchase', '2024-03-20', '1020101', 'Cash in Hand For Supplier G.One LED Light', '0.00', '0.00', '1', '1', '2024-03-20 12:43:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3656, '20240320123450', 'Purchase', '2024-03-20', '502000027', 'Supplier . G.One LED Light', '0.00', '0.00', '1', '1', '2024-03-20 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3665, '20240321101318', 'Purchase', '2024-03-21', '10107', 'Inventory Debit For Supplier Arslan LED', '8000.00', '0.00', '1', '1', '2024-03-21 10:13:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3666, '20240321101318', 'Purchase', '2024-03-21', '502000002', 'Supplier .Arslan LED', '0.00', '8000.00', '1', '1', '2024-03-21 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3667, '20240321101318', 'Purchase', '2024-03-21', '402', 'Company Credit For  Arslan LED', '8000.00', '0.00', '1', '1', '2024-03-21 10:13:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3668, '20240321101603', 'Purchase', '2024-03-21', '10107', 'Inventory Debit For Supplier Cash Item ', '820.00', '0.00', '1', '1', '2024-03-21 10:16:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3669, '20240321101603', 'Purchase', '2024-03-21', '502000047', 'Supplier .Cash Item ', '0.00', '820.00', '1', '1', '2024-03-21 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3670, '20240321101603', 'Purchase', '2024-03-21', '402', 'Company Credit For  Cash Item ', '820.00', '0.00', '1', '1', '2024-03-21 10:16:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3677, '20240321102419', 'Purchase', '2024-03-21', '10107', 'Inventory Devit Supplier Haji Salman Karachi', '86425.00', '0.00', '1', '1', '2024-03-21 10:53:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3678, '20240321102419', 'Purchase', '2024-03-21', '502000040', 'Supplier -Haji Salman Karachi', '0.00', '86425.00', '1', '1', '2024-03-21 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3679, '20240321102419', 'Purchase', '2024-03-21', '402', 'Company Credit For SupplierHaji Salman Karachi', '86425.00', '0.00', '1', '1', '2024-03-21 10:53:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3680, '20240321102419', 'Purchase', '2024-03-21', '1020101', 'Cash in Hand For Supplier Haji Salman Karachi', '0.00', '0.00', '1', '1', '2024-03-21 10:53:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3681, '20240321102419', 'Purchase', '2024-03-21', '502000040', 'Supplier . Haji Salman Karachi', '0.00', '0.00', '1', '1', '2024-03-21 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3682, '6128491668', 'INV', '2024-03-21', '10107', 'Inventory credit For Invoice No1145', '0.00', '8630.00', '1', '1', '2024-03-21 11:10:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3683, '6128491668', 'INVOICE', '2024-03-21', '303', 'Sale Income From Invoice NO - 1145 Customer Faizan Basti ', '0.00', '7840.00', '1', '1', '2024-03-21 11:10:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3684, '6128491668', 'INV', '2024-03-21', '102030000006', 'Customer debit For Invoice NO - 1145 customer-  Faizan Basti ', '7840.00', '0.00', '1', '1', '2024-03-21 11:10:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3685, '4167744585', 'INV', '2024-03-21', '10107', 'Inventory credit For Invoice No1147', '0.00', '8512.00', '1', '1', '2024-03-21 11:14:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3686, '4167744585', 'INVOICE', '2024-03-21', '303', 'Sale Income From Invoice NO - 1147 Customer M.Z Electric', '0.00', '5370.00', '1', '1', '2024-03-21 11:14:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3687, '4167744585', 'INV', '2024-03-21', '102030000019', 'Customer debit For Invoice NO - 1147 customer-  M.Z Electric', '5370.00', '0.00', '1', '1', '2024-03-21 11:14:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3691, '1916531934', 'INV', '2024-03-21', '10107', 'Inventory credit For Invoice No1150', '0.00', '2980.00', '1', '1', '2024-03-21 11:22:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3692, '1916531934', 'INVOICE', '2024-03-21', '303', 'Sale Income From Invoice NO - 1150 Customer Zahid somoro', '0.00', '2960.00', '1', '1', '2024-03-21 11:22:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3693, '1916531934', 'INV', '2024-03-21', '102030000009', 'Customer debit For Invoice NO - 1150 customer-  Zahid somoro', '2960.00', '0.00', '1', '1', '2024-03-21 11:22:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3694, '3828982476', 'INV', '2024-03-21', '10107', 'Inventory credit For Invoice No1151', '0.00', '42160.00', '1', '1', '2024-03-21 11:23:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3695, '3828982476', 'INVOICE', '2024-03-21', '303', 'Sale Income From Invoice NO - 1151 Customer Deluxe Electric', '0.00', '4690.00', '1', '1', '2024-03-21 11:23:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3696, '3828982476', 'INV', '2024-03-21', '102030000017', 'Customer debit For Invoice NO - 1151 customer-  Deluxe Electric', '4690.00', '0.00', '1', '1', '2024-03-21 11:23:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3697, '4177459154', 'INV', '2024-03-21', '10107', 'Inventory credit For Invoice No1172', '0.00', '15765.00', '1', '1', '2024-03-21 11:32:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3698, '4177459154', 'INVOICE', '2024-03-21', '303', 'Sale Income From Invoice NO - 1172 Customer Adil qasam chowk', '0.00', '12180.00', '1', '1', '2024-03-21 11:32:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3699, '4177459154', 'INV', '2024-03-21', '102030000037', 'Customer debit For Invoice NO - 1172 customer-  Adil qasam chowk', '12180.00', '0.00', '1', '1', '2024-03-21 11:32:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3700, '7122648312', 'INV', '2024-03-21', '10107', 'Inventory credit For Invoice No1171', '0.00', '360073.00', '1', '1', '2024-03-21 12:12:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3701, '7122648312', 'INVOICE', '2024-03-21', '303', 'Sale Income From Invoice NO - 1171 Customer Usmaan Bhai', '0.00', '268990.00', '1', '1', '2024-03-21 12:12:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3702, '7122648312', 'INV', '2024-03-21', '102030000036', 'Customer debit For Invoice NO - 1171 customer-  Usmaan Bhai', '268990.00', '0.00', '1', '1', '2024-03-21 12:12:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3703, '9653111997', 'INV', '2024-03-21', '10107', 'Inventory credit For Invoice No1164', '0.00', '8320.00', '1', '1', '2024-03-21 12:19:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3704, '9653111997', 'INVOICE', '2024-03-21', '303', 'Sale Income From Invoice NO - 1164 Customer M.D.M Mill', '0.00', '12600.00', '1', '1', '2024-03-21 12:19:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3705, '9653111997', 'INV', '2024-03-21', '102030000011', 'Customer debit For Invoice NO - 1164 customer-  M.D.M Mill', '12600.00', '0.00', '1', '1', '2024-03-21 12:19:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3706, '8243172374', 'INV', '2024-03-21', '10107', 'Inventory credit For Invoice No1170', '0.00', '377804.00', '1', '1', '2024-03-21 12:25:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3707, '8243172374', 'INVOICE', '2024-03-21', '303', 'Sale Income From Invoice NO - 1170 Customer Faheem hussnain', '0.00', '355000.00', '1', '1', '2024-03-21 12:25:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3708, '8243172374', 'INV', '2024-03-21', '102030000034', 'Customer debit For Invoice NO - 1170 customer-  Faheem hussnain', '355000.00', '0.00', '1', '1', '2024-03-21 12:25:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3709, '5566655768', 'INV', '2024-03-21', '10107', 'Inventory credit For Invoice No1182', '0.00', '66410.00', '1', '1', '2024-03-21 12:34:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3710, '5566655768', 'INVOICE', '2024-03-21', '303', 'Sale Income From Invoice NO - 1182 Customer M.D.M Mill', '0.00', '145720.00', '1', '1', '2024-03-21 12:34:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3711, '5566655768', 'INV', '2024-03-21', '102030000011', 'Customer debit For Invoice NO - 1182 customer-  M.D.M Mill', '145720.00', '0.00', '1', '1', '2024-03-21 12:34:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3712, '3266869518', 'INV', '2024-03-21', '10107', 'Inventory credit For Invoice No1207', '0.00', '7336.00', '1', '1', '2024-03-21 12:41:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3713, '3266869518', 'INVOICE', '2024-03-21', '303', 'Sale Income From Invoice NO - 1207 Customer Faizan Basti ', '0.00', '6910.00', '1', '1', '2024-03-21 12:41:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3714, '3266869518', 'INV', '2024-03-21', '102030000006', 'Customer debit For Invoice NO - 1207 customer-  Faizan Basti ', '6910.00', '0.00', '1', '1', '2024-03-21 12:41:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3715, '7317298758', 'INV', '2024-03-21', '10107', 'Inventory credit For Invoice No1214', '0.00', '34087.00', '1', '1', '2024-03-21 12:59:26', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3716, '7317298758', 'INVOICE', '2024-03-21', '303', 'Sale Income From Invoice NO - 1214 Customer Deluxe Electric', '0.00', '20500.00', '1', '1', '2024-03-21 12:59:26', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3717, '7317298758', 'INV', '2024-03-21', '102030000017', 'Customer debit For Invoice NO - 1214 customer-  Deluxe Electric', '20500.00', '0.00', '1', '1', '2024-03-21 12:59:26', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3723, '3718624612', 'INV', '2024-03-23', '10107', 'Inventory credit For Invoice No1235', '0.00', '38555.00', '1', '1', '2024-03-23 07:50:50', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3724, '3718624612', 'INVOICE', '2024-03-23', '303', 'Sale Income From Invoice NO - 1235 Customer M.Z Electric', '0.00', '21900.00', '1', '1', '2024-03-23 07:50:50', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3725, '3718624612', 'INV', '2024-03-23', '102030000019', 'Customer debit For Invoice NO - 1235 customer-  M.Z Electric', '21900.00', '0.00', '1', '1', '2024-03-23 07:50:50', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3726, '6863289674', 'INV', '2024-03-23', '10107', 'Inventory credit For Invoice No1244', '0.00', '5030.00', '1', '1', '2024-03-23 08:06:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3727, '6863289674', 'INVOICE', '2024-03-23', '303', 'Sale Income From Invoice NO - 1244 Customer Faizan Basti ', '0.00', '4740.00', '1', '1', '2024-03-23 08:06:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3728, '6863289674', 'INV', '2024-03-23', '102030000006', 'Customer debit For Invoice NO - 1244 customer-  Faizan Basti ', '4740.00', '0.00', '1', '1', '2024-03-23 08:06:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3729, '5225826333', 'INV', '2024-03-23', '10107', 'Inventory credit For Invoice No1245', '0.00', '14986.00', '1', '1', '2024-03-23 08:08:10', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3730, '5225826333', 'INVOICE', '2024-03-23', '303', 'Sale Income From Invoice NO - 1245 Customer M.S Electric', '0.00', '14500.00', '1', '1', '2024-03-23 08:08:10', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3731, '5225826333', 'INV', '2024-03-23', '102030000021', 'Customer debit For Invoice NO - 1245 customer-  M.S Electric', '14500.00', '0.00', '1', '1', '2024-03-23 08:08:10', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3737, '2839568685', 'INV', '2024-03-23', '10107', 'Inventory credit For Invoice No1247', '0.00', '15005.00', '1', '1', '2024-03-23 08:19:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3738, '2839568685', 'INVOICE', '2024-03-23', '303', 'Sale Income From Invoice NO - 1247 Customer Abdul Qadir Electric ', '0.00', '6000.00', '1', '1', '2024-03-23 08:19:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3739, '2839568685', 'INV', '2024-03-23', '102030000016', 'Customer debit For Invoice NO - 1247 customer-  Abdul Qadir Electric ', '6000.00', '0.00', '1', '1', '2024-03-23 08:19:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3753, '5725871419', 'INV', '2024-03-23', '10107', 'Inventory credit For Invoice No1248', '0.00', '84536.00', '1', '1', '2024-03-23 08:56:17', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3754, '5725871419', 'INVOICE', '2024-03-23', '303', 'Sale Income From Invoice NO - 1248 Customer Mustufa Arif', '0.00', '195530.00', '1', '1', '2024-03-23 08:56:17', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3755, '5725871419', 'INV', '2024-03-23', '102030000023', 'Customer debit For Invoice NO - 1248 customer-  Mustufa Arif', '195530.00', '0.00', '1', '1', '2024-03-23 08:56:17', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3766, '9495862115', 'INV', '2024-03-23', '10107', 'Inventory credit For Invoice No1255', '0.00', '17920.00', '1', '1', '2024-03-23 09:21:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3767, '9495862115', 'INVOICE', '2024-03-23', '303', 'Sale Income From Invoice NO - 1255 Customer M.S Electric', '0.00', '11980.00', '1', '1', '2024-03-23 09:21:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3768, '9495862115', 'INV', '2024-03-23', '102030000021', 'Customer debit For Invoice NO - 1255 customer-  M.S Electric', '11980.00', '0.00', '1', '1', '2024-03-23 09:21:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3772, '7976169977', 'INV', '2024-03-23', '10107', 'Inventory credit For Invoice No1257', '0.00', '238679.00', '1', '1', '2024-03-23 09:52:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3773, '7976169977', 'INVOICE', '2024-03-23', '303', 'Sale Income From Invoice NO - 1257 Customer Sattar Mallah Electric', '0.00', '76980.00', '1', '1', '2024-03-23 09:52:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3774, '7976169977', 'INV', '2024-03-23', '102030000022', 'Customer debit For Invoice NO - 1257 customer-  Sattar Mallah Electric', '76980.00', '0.00', '1', '1', '2024-03-23 09:52:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3780, '8614186355', 'INV', '2024-03-23', '10107', 'Inventory credit For Invoice No1264', '0.00', '29474.00', '1', '1', '2024-03-23 10:07:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3781, '8614186355', 'INVOICE', '2024-03-23', '303', 'Sale Income From Invoice NO - 1264 Customer Faizan Basti ', '0.00', '13540.00', '1', '1', '2024-03-23 10:07:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3782, '8614186355', 'INV', '2024-03-23', '102030000006', 'Customer debit For Invoice NO - 1264 customer-  Faizan Basti ', '13540.00', '0.00', '1', '1', '2024-03-23 10:07:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3783, '5543697839', 'INV', '2024-03-23', '10107', 'Inventory credit For Invoice No1265', '0.00', '40491.00', '1', '1', '2024-03-23 11:25:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3784, '5543697839', 'INVOICE', '2024-03-23', '303', 'Sale Income From Invoice NO - 1265 Customer M.D.M Mill', '0.00', '61980.00', '1', '1', '2024-03-23 11:25:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3785, '5543697839', 'INV', '2024-03-23', '102030000011', 'Customer debit For Invoice NO - 1265 customer-  M.D.M Mill', '61980.00', '0.00', '1', '1', '2024-03-23 11:25:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3786, '2624183513', 'INV', '2024-03-23', '10107', 'Inventory credit For Invoice No1266', '0.00', '3195.00', '1', '1', '2024-03-23 11:32:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3787, '2624183513', 'INVOICE', '2024-03-23', '303', 'Sale Income From Invoice NO - 1266 Customer M.D.M Mill', '0.00', '10440.00', '1', '1', '2024-03-23 11:32:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3788, '2624183513', 'INV', '2024-03-23', '102030000011', 'Customer debit For Invoice NO - 1266 customer-  M.D.M Mill', '10440.00', '0.00', '1', '1', '2024-03-23 11:32:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3789, '3648649638', 'INV', '2024-03-23', '10107', 'Inventory credit For Invoice No1148', '0.00', '6300.00', '1', '1', '2024-03-23 11:45:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3790, '3648649638', 'INVOICE', '2024-03-23', '303', 'Sale Income From Invoice NO - 1148 Customer M.S Electric', '0.00', '6000.00', '1', '1', '2024-03-23 11:45:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3791, '3648649638', 'INV', '2024-03-23', '102030000021', 'Customer debit For Invoice NO - 1148 customer-  M.S Electric', '6000.00', '0.00', '1', '1', '2024-03-23 11:45:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3792, '7748257852', 'INV', '2024-03-23', '10107', 'Inventory credit For Invoice No1275', '0.00', '11188.00', '1', '1', '2024-03-23 12:16:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3793, '7748257852', 'INV', '2024-03-23', '102030000043', 'Customer debit For Invoice No -  1275 Customer Hamza Electric Store ', '12570.00', '0.00', '1', '1', '2024-03-23 12:16:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3794, '7748257852', 'INVOICE', '2024-03-23', '303', 'Sale Income For Invoice NO - 1275 Customer Hamza Electric Store ', '0.00', '12570.00', '1', '1', '2024-03-23 12:16:04', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3795, '2698538637', 'INV', '2024-03-23', '10107', 'Inventory credit For Invoice No1276', '0.00', '860.00', '1', '1', '2024-03-23 12:24:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3796, '2698538637', 'INV', '2024-03-23', '102030000020', 'Customer debit For Invoice No -  1276 Customer M.K Electric ', '900.00', '0.00', '1', '1', '2024-03-23 12:24:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3797, '2698538637', 'INVOICE', '2024-03-23', '303', 'Sale Income For Invoice NO - 1276 Customer M.K Electric ', '0.00', '900.00', '1', '1', '2024-03-23 12:24:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3801, '9329421995', 'INV', '2024-03-23', '10107', 'Inventory credit For Invoice No1278', '0.00', '30470.00', '1', '1', '2024-03-23 12:43:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3802, '9329421995', 'INV', '2024-03-23', '102030000002', 'Customer debit For Invoice No -  1278 Customer Walking Customer', '26820.00', '0.00', '1', '1', '2024-03-23 12:43:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3803, '9329421995', 'INVOICE', '2024-03-23', '303', 'Sale Income For Invoice NO - 1278 Customer Walking Customer', '0.00', '26820.00', '1', '1', '2024-03-23 12:43:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3804, '7473123694', 'INV', '2024-03-23', '10107', 'Inventory credit For Invoice No1277', '0.00', '3741.00', '1', '1', '2024-03-23 12:45:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3805, '7473123694', 'INVOICE', '2024-03-23', '303', 'Sale Income From Invoice NO - 1277 Customer Eman Electric', '0.00', '3950.00', '1', '1', '2024-03-23 12:45:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3806, '7473123694', 'INV', '2024-03-23', '102030000024', 'Customer debit For Invoice NO - 1277 customer-  Eman Electric', '3950.00', '0.00', '1', '1', '2024-03-23 12:45:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3812, '9997275465', 'INV', '2024-03-23', '10107', 'Inventory credit For Invoice No1279', '0.00', '64012.00', '1', '1', '2024-03-23 12:57:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3813, '9997275465', 'INV', '2024-03-23', '102030000016', 'Customer debit For Invoice No -  1279 Customer Abdul Qadir Electric ', '44300.00', '0.00', '1', '1', '2024-03-23 12:57:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3814, '9997275465', 'INVOICE', '2024-03-23', '303', 'Sale Income For Invoice NO - 1279 Customer Abdul Qadir Electric ', '0.00', '44300.00', '1', '1', '2024-03-23 12:57:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3818, '3826793642', 'INV', '2024-03-23', '10107', 'Inventory credit For Invoice No1281', '0.00', '660.00', '1', '1', '2024-03-23 13:06:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3819, '3826793642', 'INV', '2024-03-23', '102030000041', 'Customer debit For Invoice No -  1281 Customer M.Ameen', '660.00', '0.00', '1', '1', '2024-03-23 13:06:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3820, '3826793642', 'INVOICE', '2024-03-23', '303', 'Sale Income For Invoice NO - 1281 Customer M.Ameen', '0.00', '660.00', '1', '1', '2024-03-23 13:06:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3831, '5672426756', 'INV', '2024-03-23', '10107', 'Inventory credit For Invoice No1280', '0.00', '36619.00', '1', '1', '2024-03-23 15:35:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3832, '5672426756', 'INVOICE', '2024-03-23', '303', 'Sale Income From Invoice NO - 1280 Customer Deluxe Electric', '0.00', '37700.00', '1', '1', '2024-03-23 15:35:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3833, '5672426756', 'INV', '2024-03-23', '102030000017', 'Customer debit For Invoice NO - 1280 customer-  Deluxe Electric', '37700.00', '0.00', '1', '1', '2024-03-23 15:35:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3847, '20240128151840', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier Sahar Al Fazal Sargodah', '75630.00', '0.00', '1', '1', '2024-03-24 10:20:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3848, '20240128151840', 'Purchase', '2023-12-31', '502000020', 'Supplier -Sahar Al Fazal Sargodah', '0.00', '75630.00', '1', '1', '2024-03-24 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3849, '20240128151840', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierSahar Al Fazal Sargodah', '75630.00', '0.00', '1', '1', '2024-03-24 10:20:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3850, '20240128151840', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier Sahar Al Fazal Sargodah', '0.00', '0.00', '1', '1', '2024-03-24 10:20:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3851, '20240128151840', 'Purchase', '2023-12-31', '502000020', 'Supplier . Sahar Al Fazal Sargodah', '0.00', '0.00', '1', '1', '2024-03-24 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3852, '20240314145625', 'Purchase', '2024-03-14', '10107', 'Inventory Devit Supplier Sale Return ', '26285.00', '0.00', '1', '1', '2024-03-24 10:22:10', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3853, '20240314145625', 'Purchase', '2024-03-14', '502000054', 'Supplier -Sale Return ', '0.00', '26285.00', '1', '1', '2024-03-24 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3854, '20240314145625', 'Purchase', '2024-03-14', '402', 'Company Credit For SupplierSale Return ', '26285.00', '0.00', '1', '1', '2024-03-24 10:22:10', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3855, '20240314145625', 'Purchase', '2024-03-14', '1020101', 'Cash in Hand For Supplier Sale Return ', '0.00', '0.00', '1', '1', '2024-03-24 10:22:10', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3856, '20240314145625', 'Purchase', '2024-03-14', '502000054', 'Supplier . Sale Return ', '0.00', '0.00', '1', '1', '2024-03-24 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3906, '20240324162105', 'Purchase', '2024-03-24', '10107', 'Inventory Debit For Supplier Memon LAD Light', '76900.00', '0.00', '1', '1', '2024-03-24 16:21:05', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3907, '20240324162105', 'Purchase', '2024-03-24', '502000008', 'Supplier .Memon LAD Light', '0.00', '76900.00', '1', '1', '2024-03-24 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3908, '20240324162105', 'Purchase', '2024-03-24', '402', 'Company Credit For  Memon LAD Light', '76900.00', '0.00', '1', '1', '2024-03-24 16:21:05', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3909, '20240324162713', 'Purchase', '2024-03-24', '10107', 'Inventory Debit For Supplier M.Ali Doctor', '4550.00', '0.00', '1', '1', '2024-03-24 16:27:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3910, '20240324162713', 'Purchase', '2024-03-24', '502000055', 'Supplier .M.Ali Doctor', '0.00', '4550.00', '1', '1', '2024-03-24 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3911, '20240324162713', 'Purchase', '2024-03-24', '402', 'Company Credit For  M.Ali Doctor', '4550.00', '0.00', '1', '1', '2024-03-24 16:27:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3915, '20240320074828', 'Purchase', '2024-03-19', '10107', 'Inventory Devit Supplier Delux Electric Purchase ', '14084.00', '0.00', '1', '1', '2024-03-25 07:57:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3916, '20240320074828', 'Purchase', '2024-03-19', '502000051', 'Supplier -Delux Electric Purchase ', '0.00', '14084.00', '1', '1', '2024-03-25 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3917, '20240320074828', 'Purchase', '2024-03-19', '402', 'Company Credit For SupplierDelux Electric Purchase ', '14084.00', '0.00', '1', '1', '2024-03-25 07:57:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3918, '20240320074828', 'Purchase', '2024-03-19', '1020101', 'Cash in Hand For Supplier Delux Electric Purchase ', '0.00', '0.00', '1', '1', '2024-03-25 07:57:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3919, '20240320074828', 'Purchase', '2024-03-19', '502000051', 'Supplier . Delux Electric Purchase ', '0.00', '0.00', '1', '1', '2024-03-25 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3941, '1747957241', 'INV', '2024-03-25', '10107', 'Inventory credit For Invoice No1284', '0.00', '466504.00', '1', '1', '2024-03-25 08:12:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3942, '1747957241', 'INVOICE', '2024-03-25', '303', 'Sale Income From Invoice NO - 1284 Customer M.D.M Mill', '0.00', '316770.00', '1', '1', '2024-03-25 08:12:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3943, '1747957241', 'INV', '2024-03-25', '102030000011', 'Customer debit For Invoice NO - 1284 customer-  M.D.M Mill', '316770.00', '0.00', '1', '1', '2024-03-25 08:12:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3983, '2733712729', 'INV', '2024-03-25', '10107', 'Inventory credit For Invoice No1285', '0.00', '8615.00', '1', '1', '2024-03-25 10:57:16', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3984, '2733712729', 'INVOICE', '2024-03-25', '303', 'Sale Income From Invoice NO - 1285 Customer Walking Customer', '0.00', '8920.00', '1', '1', '2024-03-25 10:57:16', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (3985, '2733712729', 'INV', '2024-03-25', '102030000002', 'Customer debit For Invoice NO - 1285 customer-  Walking Customer', '8920.00', '0.00', '1', '1', '2024-03-25 10:57:16', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4006, '3586992742', 'INV', '2024-03-25', '10107', 'Inventory credit For Invoice No1289', '0.00', '431652.00', '1', '1', '2024-03-25 14:53:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4007, '3586992742', 'INVOICE', '2024-03-25', '303', 'Sale Income From Invoice NO - 1289 Customer Walking Customer', '0.00', '57010.00', '1', '1', '2024-03-25 14:53:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4008, '3586992742', 'INV', '2024-03-25', '102030000002', 'Customer debit For Invoice NO - 1289 customer-  Walking Customer', '57010.00', '0.00', '1', '1', '2024-03-25 14:53:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4018, '5434657383', 'INV', '2024-03-27', '10107', 'Inventory credit For Invoice No1282', '0.00', '89580.00', '1', '1', '2024-03-27 08:24:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4019, '5434657383', 'INVOICE', '2024-03-27', '303', 'Sale Income From Invoice NO - 1282 Customer shahid H.M ', '0.00', '40060.00', '1', '1', '2024-03-27 08:24:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4020, '5434657383', 'INV', '2024-03-27', '102030000044', 'Customer debit For Invoice NO - 1282 customer-  shahid H.M ', '40060.00', '0.00', '1', '1', '2024-03-27 08:24:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4021, '9123418226', 'INV', '2024-03-27', '10107', 'Inventory credit For Invoice No1242', '0.00', '6600.00', '1', '1', '2024-03-27 08:25:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4022, '9123418226', 'INVOICE', '2024-03-27', '303', 'Sale Income From Invoice NO - 1242 Customer H.M CABLES', '0.00', '8360.00', '1', '1', '2024-03-27 08:25:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4023, '9123418226', 'INV', '2024-03-27', '102030000005', 'Customer debit For Invoice NO - 1242 customer-  H.M CABLES', '8360.00', '0.00', '1', '1', '2024-03-27 08:25:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4024, '6658398886', 'INV', '2024-03-27', '10107', 'Inventory credit For Invoice No1290', '0.00', '3410.00', '1', '1', '2024-03-27 08:27:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4025, '6658398886', 'INV', '2024-03-27', '102030000005', 'Customer debit For Invoice No -  1290 Customer H.M CABLES', '4180.00', '0.00', '1', '1', '2024-03-27 08:27:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4026, '6658398886', 'INVOICE', '2024-03-27', '303', 'Sale Income For Invoice NO - 1290 Customer H.M CABLES', '0.00', '4180.00', '1', '1', '2024-03-27 08:27:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4030, '2817362753', 'INV', '2024-03-27', '10107', 'Inventory credit For Invoice No1292', '0.00', '13400.00', '1', '1', '2024-03-27 09:01:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4031, '2817362753', 'INV', '2024-03-27', '102030000005', 'Customer debit For Invoice No -  1292 Customer H.M CABLES', '20300.00', '0.00', '1', '1', '2024-03-27 09:01:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4032, '2817362753', 'INVOICE', '2024-03-27', '303', 'Sale Income For Invoice NO - 1292 Customer H.M CABLES', '0.00', '20300.00', '1', '1', '2024-03-27 09:01:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4033, '2925755632', 'INV', '2024-03-27', '10107', 'Inventory credit For Invoice No1293', '0.00', '4650.00', '1', '1', '2024-03-27 09:02:43', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4034, '2925755632', 'INV', '2024-03-27', '102030000005', 'Customer debit For Invoice No -  1293 Customer H.M CABLES', '5700.00', '0.00', '1', '1', '2024-03-27 09:02:43', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4035, '2925755632', 'INVOICE', '2024-03-27', '303', 'Sale Income For Invoice NO - 1293 Customer H.M CABLES', '0.00', '5700.00', '1', '1', '2024-03-27 09:02:43', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4039, '2465779867', 'INV', '2024-03-27', '10107', 'Inventory credit For Invoice No1294', '0.00', '12292.00', '1', '1', '2024-03-27 09:54:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4040, '2465779867', 'INV', '2024-03-27', '102030000026', 'Customer debit For Invoice No -  1294 Customer Memon Light  ', '12500.00', '0.00', '1', '1', '2024-03-27 09:54:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4041, '2465779867', 'INVOICE', '2024-03-27', '303', 'Sale Income For Invoice NO - 1294 Customer Memon Light  ', '0.00', '12500.00', '1', '1', '2024-03-27 09:54:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4042, '7855113342', 'INV', '2024-03-27', '10107', 'Inventory credit For Invoice No1295', '0.00', '26209.00', '1', '1', '2024-03-27 10:05:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4043, '7855113342', 'INV', '2024-03-27', '102030000039', 'Customer debit For Invoice No -  1295 Customer G.1 LED', '14500.00', '0.00', '1', '1', '2024-03-27 10:05:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4044, '7855113342', 'INVOICE', '2024-03-27', '303', 'Sale Income For Invoice NO - 1295 Customer G.1 LED', '0.00', '14500.00', '1', '1', '2024-03-27 10:05:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4045, '5929568811', 'INV', '2024-03-27', '10107', 'Inventory credit For Invoice No1296', '0.00', '15933.00', '1', '1', '2024-03-27 10:08:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4046, '5929568811', 'INV', '2024-03-27', '102030000017', 'Customer debit For Invoice No -  1296 Customer Deluxe Electric', '16300.00', '0.00', '1', '1', '2024-03-27 10:08:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4047, '5929568811', 'INVOICE', '2024-03-27', '303', 'Sale Income For Invoice NO - 1296 Customer Deluxe Electric', '0.00', '16300.00', '1', '1', '2024-03-27 10:08:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4054, '4937312758', 'INV', '2024-03-27', '10107', 'Inventory credit For Invoice No1283', '0.00', '105115.00', '1', '1', '2024-03-27 11:28:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4055, '4937312758', 'INVOICE', '2024-03-27', '303', 'Sale Income From Invoice NO - 1283 Customer Memon Light  ', '0.00', '14000.00', '1', '1', '2024-03-27 11:28:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4056, '4937312758', 'INV', '2024-03-27', '102030000026', 'Customer debit For Invoice NO - 1283 customer-  Memon Light  ', '14000.00', '0.00', '1', '1', '2024-03-27 11:28:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4073, '3675182878', 'INV', '2024-03-27', '10107', 'Inventory credit For Invoice No1300', '0.00', '60400.00', '1', '1', '2024-03-27 12:05:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4074, '3675182878', 'INV', '2024-03-27', '102030000031', 'Customer debit For Invoice No -  1300 Customer Saffan Chilton ', '60000.00', '0.00', '1', '1', '2024-03-27 12:05:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4075, '3675182878', 'INVOICE', '2024-03-27', '303', 'Sale Income For Invoice NO - 1300 Customer Saffan Chilton ', '0.00', '60000.00', '1', '1', '2024-03-27 12:05:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4079, '20240321103010', 'Purchase', '2024-03-21', '10107', 'Inventory Devit Supplier Abdul Hammed Panel wala', '36050.00', '0.00', '1', '1', '2024-03-27 12:35:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4080, '20240321103010', 'Purchase', '2024-03-21', '502000048', 'Supplier -Abdul Hammed Panel wala', '0.00', '36050.00', '1', '1', '2024-03-27 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4081, '20240321103010', 'Purchase', '2024-03-21', '402', 'Company Credit For SupplierAbdul Hammed Panel wala', '36050.00', '0.00', '1', '1', '2024-03-27 12:35:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4082, '20240321103010', 'Purchase', '2024-03-21', '1020101', 'Cash in Hand For Supplier Abdul Hammed Panel wala', '0.00', '0.00', '1', '1', '2024-03-27 12:35:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4083, '20240321103010', 'Purchase', '2024-03-21', '502000048', 'Supplier . Abdul Hammed Panel wala', '0.00', '0.00', '1', '1', '2024-03-27 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4084, '9631931262', 'INV', '2024-03-27', '10107', 'Inventory credit For Invoice No1301', '0.00', '237117.00', '1', '1', '2024-03-27 12:39:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4085, '9631931262', 'INVOICE', '2024-03-27', '303', 'Sale Income From Invoice NO - 1301 Customer Zahid somoro', '0.00', '172700.00', '1', '1', '2024-03-27 12:39:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4086, '9631931262', 'INV', '2024-03-27', '102030000009', 'Customer debit For Invoice NO - 1301 customer-  Zahid somoro', '172700.00', '0.00', '1', '1', '2024-03-27 12:39:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4087, '8381957215', 'INV', '2024-03-27', '10107', 'Inventory credit For Invoice No1302', '0.00', '22164.00', '1', '1', '2024-03-27 12:49:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4088, '8381957215', 'INV', '2024-03-27', '102030000017', 'Customer debit For Invoice No -  1302 Customer Deluxe Electric', '23160.00', '0.00', '1', '1', '2024-03-27 12:49:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4089, '8381957215', 'INVOICE', '2024-03-27', '303', 'Sale Income For Invoice NO - 1302 Customer Deluxe Electric', '0.00', '23160.00', '1', '1', '2024-03-27 12:49:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4111, '5744799622', 'INV', '2024-03-27', '10107', 'Inventory credit For Invoice No1291', '0.00', '43252.50', '1', '1', '2024-03-27 15:35:50', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4112, '5744799622', 'INVOICE', '2024-03-27', '303', 'Sale Income From Invoice NO - 1291 Customer H.M CABLES', '0.00', '29080.00', '1', '1', '2024-03-27 15:35:50', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4113, '5744799622', 'INV', '2024-03-27', '102030000005', 'Customer debit For Invoice NO - 1291 customer-  H.M CABLES', '29080.00', '0.00', '1', '1', '2024-03-27 15:35:50', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4114, '20240320121954', 'Purchase', '2024-03-20', '10107', 'Inventory Devit Supplier Zahid Soomro Kotri', '42520.00', '0.00', '1', '1', '2024-03-27 15:47:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4115, '20240320121954', 'Purchase', '2024-03-20', '502000043', 'Supplier -Zahid Soomro Kotri', '0.00', '42520.00', '1', '1', '2024-03-27 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4116, '20240320121954', 'Purchase', '2024-03-20', '402', 'Company Credit For SupplierZahid Soomro Kotri', '42520.00', '0.00', '1', '1', '2024-03-27 15:47:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4117, '20240320121954', 'Purchase', '2024-03-20', '1020101', 'Cash in Hand For Supplier Zahid Soomro Kotri', '0.00', '0.00', '1', '1', '2024-03-27 15:47:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4118, '20240320121954', 'Purchase', '2024-03-20', '502000043', 'Supplier . Zahid Soomro Kotri', '0.00', '0.00', '1', '1', '2024-03-27 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4122, '20240319160121', 'Purchase', '2024-03-17', '10107', 'Inventory Devit Supplier Cash Item ', '20700.00', '0.00', '1', '1', '2024-03-27 15:56:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4123, '20240319160121', 'Purchase', '2024-03-17', '502000047', 'Supplier -Cash Item ', '0.00', '20700.00', '1', '1', '2024-03-27 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4124, '20240319160121', 'Purchase', '2024-03-17', '402', 'Company Credit For SupplierCash Item ', '20700.00', '0.00', '1', '1', '2024-03-27 15:56:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4125, '20240319160121', 'Purchase', '2024-03-17', '1020101', 'Cash in Hand For Supplier Cash Item ', '0.00', '0.00', '1', '1', '2024-03-27 15:56:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4126, '20240319160121', 'Purchase', '2024-03-17', '502000047', 'Supplier . Cash Item ', '0.00', '0.00', '1', '1', '2024-03-27 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4127, '3253633293', 'INV', '2024-03-27', '10107', 'Inventory credit For Invoice No1303', '0.00', '7750.00', '1', '1', '2024-03-27 15:58:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4128, '3253633293', 'INVOICE', '2024-03-27', '303', 'Sale Income From Invoice NO - 1303 Customer H.M CABLES', '0.00', '9500.00', '1', '1', '2024-03-27 15:58:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4129, '3253633293', 'INV', '2024-03-27', '102030000005', 'Customer debit For Invoice NO - 1303 customer-  H.M CABLES', '9500.00', '0.00', '1', '1', '2024-03-27 15:58:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4130, '20240327160150', 'Purchase', '2024-03-27', '10107', 'Inventory Debit For Supplier Cash Item ', '11200.00', '0.00', '1', '1', '2024-03-27 16:01:50', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4131, '20240327160150', 'Purchase', '2024-03-27', '502000047', 'Supplier .Cash Item ', '0.00', '11200.00', '1', '1', '2024-03-27 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4132, '20240327160150', 'Purchase', '2024-03-27', '402', 'Company Credit For  Cash Item ', '11200.00', '0.00', '1', '1', '2024-03-27 16:01:50', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4133, '6194973291', 'INV', '2024-03-27', '10107', 'Inventory credit For Invoice No1304', '0.00', '11200.00', '1', '1', '2024-03-27 16:03:02', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4134, '6194973291', 'INV', '2024-03-27', '102030000005', 'Customer debit For Invoice No -  1304 Customer H.M CABLES', '14400.00', '0.00', '1', '1', '2024-03-27 16:03:02', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4135, '6194973291', 'INVOICE', '2024-03-27', '303', 'Sale Income For Invoice NO - 1304 Customer H.M CABLES', '0.00', '14400.00', '1', '1', '2024-03-27 16:03:02', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4139, '5777367333', 'INV', '2024-03-27', '10107', 'Inventory credit For Invoice No1305', '0.00', '900.00', '1', '1', '2024-03-27 16:14:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4140, '5777367333', 'INVOICE', '2024-03-27', '303', 'Sale Income From Invoice NO - 1305 Customer M.Z Electric', '0.00', '2000.00', '1', '1', '2024-03-27 16:14:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4141, '5777367333', 'INV', '2024-03-27', '102030000019', 'Customer debit For Invoice NO - 1305 customer-  M.Z Electric', '2000.00', '0.00', '1', '1', '2024-03-27 16:14:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4158, '20240327125544', 'Purchase', '2024-03-27', '10107', 'Inventory Devit Supplier Chilton Traders Karachi', '106400.00', '0.00', '1', '1', '2024-03-28 08:23:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4159, '20240327125544', 'Purchase', '2024-03-27', '502000032', 'Supplier -Chilton Traders Karachi', '0.00', '106400.00', '1', '1', '2024-03-28 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4160, '20240327125544', 'Purchase', '2024-03-27', '402', 'Company Credit For SupplierChilton Traders Karachi', '106400.00', '0.00', '1', '1', '2024-03-28 08:23:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4161, '20240327125544', 'Purchase', '2024-03-27', '1020101', 'Cash in Hand For Supplier Chilton Traders Karachi', '0.00', '0.00', '1', '1', '2024-03-28 08:23:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4162, '20240327125544', 'Purchase', '2024-03-27', '502000032', 'Supplier . Chilton Traders Karachi', '0.00', '0.00', '1', '1', '2024-03-28 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4171, '4493439377', 'INV', '2024-03-28', '10107', 'Inventory credit For Invoice No1299', '0.00', '398179.00', '1', '1', '2024-03-28 10:56:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4172, '4493439377', 'INVOICE', '2024-03-28', '303', 'Sale Income From Invoice NO - 1299 Customer Khalid Marfat ', '0.00', '67350.00', '1', '1', '2024-03-28 10:56:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4173, '4493439377', 'INV', '2024-03-28', '102030000027', 'Customer debit For Invoice NO - 1299 customer-  Khalid Marfat ', '67350.00', '0.00', '1', '1', '2024-03-28 10:56:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4174, '9922541324', 'INV', '2024-03-28', '10107', 'Inventory credit For Invoice No1298', '0.00', '6462.00', '1', '1', '2024-03-28 10:58:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4175, '9922541324', 'INVOICE', '2024-03-28', '303', 'Sale Income From Invoice NO - 1298 Customer Zahid somoro', '0.00', '6550.00', '1', '1', '2024-03-28 10:58:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4176, '9922541324', 'INV', '2024-03-28', '102030000009', 'Customer debit For Invoice NO - 1298 customer-  Zahid somoro', '6550.00', '0.00', '1', '1', '2024-03-28 10:58:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4177, '1231988793', 'INV', '2024-03-28', '10107', 'Inventory credit For Invoice No1307', '0.00', '11640.00', '1', '1', '2024-03-28 12:20:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4178, '1231988793', 'INV', '2024-03-28', '102030000002', 'Customer debit For Invoice No -  1307 Customer Walking Customer', '8000.00', '0.00', '1', '1', '2024-03-28 12:20:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4179, '1231988793', 'INVOICE', '2024-03-28', '303', 'Sale Income For Invoice NO - 1307 Customer Walking Customer', '0.00', '8000.00', '1', '1', '2024-03-28 12:20:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4199, '6677889362', 'INV', '2024-03-28', '10107', 'Inventory credit For Invoice No1308', '0.00', '21952.00', '1', '1', '2024-03-28 15:08:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4200, '6677889362', 'INVOICE', '2024-03-28', '303', 'Sale Income From Invoice NO - 1308 Customer Walking Customer', '0.00', '14850.00', '1', '1', '2024-03-28 15:08:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4201, '6677889362', 'INV', '2024-03-28', '102030000002', 'Customer debit For Invoice NO - 1308 customer-  Walking Customer', '14850.00', '0.00', '1', '1', '2024-03-28 15:08:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4205, '20240326154004', 'Purchase', '2024-03-26', '10107', 'Inventory Devit Supplier Abdul Qadir Purchase ', '16900.00', '0.00', '1', '1', '2024-03-28 15:24:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4206, '20240326154004', 'Purchase', '2024-03-26', '502000056', 'Supplier -Abdul Qadir Purchase ', '0.00', '16900.00', '1', '1', '2024-03-28 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4207, '20240326154004', 'Purchase', '2024-03-26', '402', 'Company Credit For SupplierAbdul Qadir Purchase ', '16900.00', '0.00', '1', '1', '2024-03-28 15:24:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4208, '20240326154004', 'Purchase', '2024-03-26', '1020101', 'Cash in Hand For Supplier Abdul Qadir Purchase ', '0.00', '0.00', '1', '1', '2024-03-28 15:24:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4209, '20240326154004', 'Purchase', '2024-03-26', '502000056', 'Supplier . Abdul Qadir Purchase ', '0.00', '0.00', '1', '1', '2024-03-28 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4232, '20240330073127', 'Purchase', '2024-03-28', '10107', 'Inventory Debit For Supplier Cash Item ', '30600.00', '0.00', '1', '1', '2024-03-30 07:31:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4233, '20240330073127', 'Purchase', '2024-03-28', '502000047', 'Supplier .Cash Item ', '0.00', '30600.00', '1', '1', '2024-03-30 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4234, '20240330073127', 'Purchase', '2024-03-28', '402', 'Company Credit For  Cash Item ', '30600.00', '0.00', '1', '1', '2024-03-30 07:31:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4235, '20240330073749', 'Purchase', '2024-03-28', '10107', 'Inventory Debit For Supplier Abdul Qadir Purchase ', '3350.00', '0.00', '1', '1', '2024-03-30 07:37:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4236, '20240330073749', 'Purchase', '2024-03-28', '502000056', 'Supplier .Abdul Qadir Purchase ', '0.00', '3350.00', '1', '1', '2024-03-30 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4237, '20240330073749', 'Purchase', '2024-03-28', '402', 'Company Credit For  Abdul Qadir Purchase ', '3350.00', '0.00', '1', '1', '2024-03-30 07:37:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4254, '2684671283', 'INV', '2024-03-30', '10107', 'Inventory credit For Invoice No1262', '0.00', '90312.50', '1', '1', '2024-03-30 09:49:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4255, '2684671283', 'INVOICE', '2024-03-30', '303', 'Sale Income From Invoice NO - 1262 Customer Walking Customer', '0.00', '35398.00', '1', '1', '2024-03-30 09:49:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4256, '2684671283', 'INV', '2024-03-30', '102030000002', 'Customer debit For Invoice NO - 1262 customer-  Walking Customer', '35398.00', '0.00', '1', '1', '2024-03-30 09:49:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4278, '7681616844', 'INV', '2024-03-30', '10107', 'Inventory credit For Invoice No1311', '0.00', '386067.00', '1', '1', '2024-03-30 12:12:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4279, '7681616844', 'INVOICE', '2024-03-30', '303', 'Sale Income From Invoice NO - 1311 Customer Zahid Sale item', '0.00', '0.00', '1', '1', '2024-03-30 12:12:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4280, '7681616844', 'INV', '2024-03-30', '102030000045', 'Customer debit For Invoice NO - 1311 customer-  Zahid Sale item', '0.00', '0.00', '1', '1', '2024-03-30 12:12:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4321, '20240214131722', 'Purchase', '2024-01-01', '10107', 'Inventory Devit Supplier Zahid Soomro Kotri', '142269.00', '0.00', '1', '1', '2024-03-30 12:54:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4322, '20240214131722', 'Purchase', '2024-01-01', '502000043', 'Supplier -Zahid Soomro Kotri', '0.00', '142269.00', '1', '1', '2024-03-30 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4323, '20240214131722', 'Purchase', '2024-01-01', '402', 'Company Credit For SupplierZahid Soomro Kotri', '142269.00', '0.00', '1', '1', '2024-03-30 12:54:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4324, '20240214131722', 'Purchase', '2024-01-01', '1020101', 'Cash in Hand For Supplier Zahid Soomro Kotri', '0.00', '0.00', '1', '1', '2024-03-30 12:54:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4325, '20240214131722', 'Purchase', '2024-01-01', '502000043', 'Supplier . Zahid Soomro Kotri', '0.00', '0.00', '1', '1', '2024-03-30 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4326, '20240330131005', 'Purchase', '2024-03-30', '10107', 'Inventory Debit For Supplier Zahid Soomro Kotri', '16350.00', '0.00', '1', '1', '2024-03-30 13:10:05', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4327, '20240330131005', 'Purchase', '2024-03-30', '502000043', 'Supplier .Zahid Soomro Kotri', '0.00', '16350.00', '1', '1', '2024-03-30 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4328, '20240330131005', 'Purchase', '2024-03-30', '402', 'Company Credit For  Zahid Soomro Kotri', '16350.00', '0.00', '1', '1', '2024-03-30 13:10:05', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4362, '20240331160955', 'Purchase', '2024-03-31', '10107', 'Inventory Debit For Supplier Delux Electric Purchase ', '16972.00', '0.00', '1', '1', '2024-03-31 16:09:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4363, '20240331160955', 'Purchase', '2024-03-31', '502000051', 'Supplier .Delux Electric Purchase ', '0.00', '16972.00', '1', '1', '2024-03-31 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4364, '20240331160955', 'Purchase', '2024-03-31', '402', 'Company Credit For  Delux Electric Purchase ', '16972.00', '0.00', '1', '1', '2024-03-31 16:09:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4387, '20240401072026', 'Purchase', '2024-03-31', '10107', 'Inventory Debit For Supplier Emaan Light House', '8626.00', '0.00', '1', '1', '2024-04-01 07:20:26', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4388, '20240401072026', 'Purchase', '2024-03-31', '502000031', 'Supplier .Emaan Light House', '0.00', '8626.00', '1', '1', '2024-04-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4389, '20240401072026', 'Purchase', '2024-03-31', '402', 'Company Credit For  Emaan Light House', '8626.00', '0.00', '1', '1', '2024-04-01 07:20:26', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4390, '20240401072301', 'Purchase', '2024-03-31', '10107', 'Inventory Debit For Supplier Qureshi pipe wala', '96000.00', '0.00', '1', '1', '2024-04-01 07:23:01', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4391, '20240401072301', 'Purchase', '2024-03-31', '502000004', 'Supplier .Qureshi pipe wala', '0.00', '96000.00', '1', '1', '2024-04-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4392, '20240401072301', 'Purchase', '2024-03-31', '402', 'Company Credit For  Qureshi pipe wala', '96000.00', '0.00', '1', '1', '2024-04-01 07:23:01', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4393, '20240401074101', 'Purchase', '2024-03-31', '10107', 'Inventory Debit For Supplier Cash Item ', '6470.00', '0.00', '1', '1', '2024-04-01 07:41:01', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4394, '20240401074101', 'Purchase', '2024-03-31', '502000047', 'Supplier .Cash Item ', '0.00', '6470.00', '1', '1', '2024-04-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4395, '20240401074101', 'Purchase', '2024-03-31', '402', 'Company Credit For  Cash Item ', '6470.00', '0.00', '1', '1', '2024-04-01 07:41:01', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4399, '20240128150010', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier E M Sargodah', '73276.00', '0.00', '1', '1', '2024-04-01 07:47:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4400, '20240128150010', 'Purchase', '2023-12-31', '502000017', 'Supplier -E M Sargodah', '0.00', '73276.00', '1', '1', '2024-04-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4401, '20240128150010', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierE M Sargodah', '73276.00', '0.00', '1', '1', '2024-04-01 07:47:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4402, '20240128150010', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier E M Sargodah', '0.00', '0.00', '1', '1', '2024-04-01 07:47:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4403, '20240128150010', 'Purchase', '2023-12-31', '502000017', 'Supplier . E M Sargodah', '0.00', '0.00', '1', '1', '2024-04-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4407, '20240218081020', 'Purchase', '2024-01-01', '10107', 'Inventory Devit Supplier Abdul Hammed Panel wala', '83550.00', '0.00', '1', '1', '2024-04-01 07:53:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4408, '20240218081020', 'Purchase', '2024-01-01', '502000048', 'Supplier -Abdul Hammed Panel wala', '0.00', '83550.00', '1', '1', '2024-04-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4409, '20240218081020', 'Purchase', '2024-01-01', '402', 'Company Credit For SupplierAbdul Hammed Panel wala', '83550.00', '0.00', '1', '1', '2024-04-01 07:53:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4410, '20240218081020', 'Purchase', '2024-01-01', '1020101', 'Cash in Hand For Supplier Abdul Hammed Panel wala', '0.00', '0.00', '1', '1', '2024-04-01 07:53:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4411, '20240218081020', 'Purchase', '2024-01-01', '502000048', 'Supplier . Abdul Hammed Panel wala', '0.00', '0.00', '1', '1', '2024-04-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4431, '20240213150708', 'Purchase', '2024-01-01', '10107', 'Inventory Devit Supplier Cash Item ', '168120.00', '0.00', '1', '1', '2024-04-01 08:14:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4432, '20240213150708', 'Purchase', '2024-01-01', '502000047', 'Supplier -Cash Item ', '0.00', '168120.00', '1', '1', '2024-04-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4433, '20240213150708', 'Purchase', '2024-01-01', '402', 'Company Credit For SupplierCash Item ', '168120.00', '0.00', '1', '1', '2024-04-01 08:14:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4434, '20240213150708', 'Purchase', '2024-01-01', '1020101', 'Cash in Hand For Supplier Cash Item ', '0.00', '0.00', '1', '1', '2024-04-01 08:14:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4435, '20240213150708', 'Purchase', '2024-01-01', '502000047', 'Supplier . Cash Item ', '0.00', '0.00', '1', '1', '2024-04-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4436, '4275369827', 'INV', '2024-04-01', '10107', 'Inventory credit For Invoice No1312', '0.00', '165468.50', '1', '1', '2024-04-01 08:16:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4437, '4275369827', 'INVOICE', '2024-04-01', '303', 'Sale Income From Invoice NO - 1312 Customer Zakki Sahab ', '0.00', '97340.00', '1', '1', '2024-04-01 08:16:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4438, '4275369827', 'INV', '2024-04-01', '102030000046', 'Customer debit For Invoice NO - 1312 customer-  Zakki Sahab ', '97340.00', '0.00', '1', '1', '2024-04-01 08:16:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4445, '4167923813', 'INV', '2024-04-01', '10107', 'Inventory credit For Invoice No1313', '0.00', '185217.00', '1', '1', '2024-04-01 08:35:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4446, '4167923813', 'INVOICE', '2024-04-01', '303', 'Sale Income From Invoice NO - 1313 Customer Abdul Qadir Electric ', '0.00', '36400.00', '1', '1', '2024-04-01 08:35:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4447, '4167923813', 'INV', '2024-04-01', '102030000016', 'Customer debit For Invoice NO - 1313 customer-  Abdul Qadir Electric ', '36400.00', '0.00', '1', '1', '2024-04-01 08:35:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4451, '20240224152146', 'Purchase', '2024-02-01', '10107', 'Inventory Devit Supplier Fizan Wire', '47460.00', '0.00', '1', '1', '2024-04-01 08:55:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4452, '20240224152146', 'Purchase', '2024-02-01', '502000026', 'Supplier -Fizan Wire', '0.00', '47460.00', '1', '1', '2024-04-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4453, '20240224152146', 'Purchase', '2024-02-01', '402', 'Company Credit For SupplierFizan Wire', '47460.00', '0.00', '1', '1', '2024-04-01 08:55:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4454, '20240224152146', 'Purchase', '2024-02-01', '1020101', 'Cash in Hand For Supplier Fizan Wire', '0.00', '0.00', '1', '1', '2024-04-01 08:55:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4455, '20240224152146', 'Purchase', '2024-02-01', '502000026', 'Supplier . Fizan Wire', '0.00', '0.00', '1', '1', '2024-04-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4461, '5791754729', 'INV', '2024-04-01', '10107', 'Inventory credit For Invoice No1314', '0.00', '8996.00', '1', '1', '2024-04-01 09:17:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4462, '5791754729', 'INVOICE', '2024-04-01', '303', 'Sale Income From Invoice NO - 1314 Customer Abdul Qadir Electric ', '0.00', '15635.00', '1', '1', '2024-04-01 09:17:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4463, '5791754729', 'INV', '2024-04-01', '102030000016', 'Customer debit For Invoice NO - 1314 customer-  Abdul Qadir Electric ', '15635.00', '0.00', '1', '1', '2024-04-01 09:17:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4467, '1512924365', 'INV', '2024-04-01', '10107', 'Inventory credit For Invoice No1315', '0.00', '58928.00', '1', '1', '2024-04-01 09:30:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4468, '1512924365', 'INVOICE', '2024-04-01', '303', 'Sale Income From Invoice NO - 1315 Customer Deluxe Electric', '0.00', '60560.00', '1', '1', '2024-04-01 09:30:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4469, '1512924365', 'INV', '2024-04-01', '102030000017', 'Customer debit For Invoice NO - 1315 customer-  Deluxe Electric', '60560.00', '0.00', '1', '1', '2024-04-01 09:30:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4470, '4698376251', 'INV', '2024-04-01', '10107', 'Inventory credit For Invoice No1316', '0.00', '24192.00', '1', '1', '2024-04-01 09:40:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4471, '4698376251', 'INV', '2024-04-01', '102030000009', 'Customer debit For Invoice No -  1316 Customer Zahid somoro', '25420.00', '0.00', '1', '1', '2024-04-01 09:40:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4472, '4698376251', 'INVOICE', '2024-04-01', '303', 'Sale Income For Invoice NO - 1316 Customer Zahid somoro', '0.00', '25420.00', '1', '1', '2024-04-01 09:40:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4486, '7732694976', 'INV', '2024-04-01', '10107', 'Inventory credit For Invoice No1318', '0.00', '2070.00', '1', '1', '2024-04-01 11:01:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4487, '7732694976', 'INV', '2024-04-01', '102030000041', 'Customer debit For Invoice No -  1318 Customer M.Ameen', '1660.00', '0.00', '1', '1', '2024-04-01 11:01:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4488, '7732694976', 'INVOICE', '2024-04-01', '303', 'Sale Income For Invoice NO - 1318 Customer M.Ameen', '0.00', '1660.00', '1', '1', '2024-04-01 11:01:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4489, '6597638334', 'INV', '2024-04-01', '10107', 'Inventory credit For Invoice No1319', '0.00', '4700.00', '1', '1', '2024-04-01 11:05:05', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4490, '6597638334', 'INV', '2024-04-01', '102030000016', 'Customer debit For Invoice No -  1319 Customer Abdul Qadir Electric ', '5640.00', '0.00', '1', '1', '2024-04-01 11:05:05', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4491, '6597638334', 'INVOICE', '2024-04-01', '303', 'Sale Income For Invoice NO - 1319 Customer Abdul Qadir Electric ', '0.00', '5640.00', '1', '1', '2024-04-01 11:05:05', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4492, '6212555628', 'INV', '2024-04-01', '10107', 'Inventory credit For Invoice No1320', '0.00', '7410.00', '1', '1', '2024-04-01 11:11:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4493, '6212555628', 'INV', '2024-04-01', '102030000006', 'Customer debit For Invoice No -  1320 Customer Faizan Basti ', '4670.00', '0.00', '1', '1', '2024-04-01 11:11:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4494, '6212555628', 'INVOICE', '2024-04-01', '303', 'Sale Income For Invoice NO - 1320 Customer Faizan Basti ', '0.00', '4670.00', '1', '1', '2024-04-01 11:11:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4495, '4131963676', 'INV', '2024-04-01', '10107', 'Inventory credit For Invoice No1321', '0.00', '3936.00', '1', '1', '2024-04-01 11:12:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4496, '4131963676', 'INV', '2024-04-01', '102030000020', 'Customer debit For Invoice No -  1321 Customer M.K Electric ', '4000.00', '0.00', '1', '1', '2024-04-01 11:12:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4497, '4131963676', 'INVOICE', '2024-04-01', '303', 'Sale Income For Invoice NO - 1321 Customer M.K Electric ', '0.00', '4000.00', '1', '1', '2024-04-01 11:12:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4503, '4224926148', 'INV', '2024-04-01', '10107', 'Inventory credit For Invoice No1317', '0.00', '24056.00', '1', '1', '2024-04-01 11:16:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4504, '4224926148', 'INVOICE', '2024-04-01', '303', 'Sale Income From Invoice NO - 1317 Customer M.S Electric', '0.00', '13005.00', '1', '1', '2024-04-01 11:16:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4505, '4224926148', 'INV', '2024-04-01', '102030000021', 'Customer debit For Invoice NO - 1317 customer-  M.S Electric', '13005.00', '0.00', '1', '1', '2024-04-01 11:16:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4506, '2271855841', 'INV', '2024-04-01', '10107', 'Inventory credit For Invoice No1306', '0.00', '10635.00', '1', '1', '2024-04-01 11:19:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4507, '2271855841', 'INVOICE', '2024-04-01', '303', 'Sale Income From Invoice NO - 1306 Customer Sattar Mallah Electric', '0.00', '9290.00', '1', '1', '2024-04-01 11:19:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4508, '2271855841', 'INV', '2024-04-01', '102030000022', 'Customer debit For Invoice NO - 1306 customer-  Sattar Mallah Electric', '9290.00', '0.00', '1', '1', '2024-04-01 11:19:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4509, '6821617226', 'INV', '2024-04-01', '10107', 'Inventory credit For Invoice No1322', '0.00', '52800.00', '1', '1', '2024-04-01 11:29:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4510, '6821617226', 'INV', '2024-04-01', '102030000005', 'Customer debit For Invoice No -  1322 Customer H.M CABLES', '38200.00', '0.00', '1', '1', '2024-04-01 11:29:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4511, '6821617226', 'INVOICE', '2024-04-01', '303', 'Sale Income For Invoice NO - 1322 Customer H.M CABLES', '0.00', '38200.00', '1', '1', '2024-04-01 11:29:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4522, '6865261646', 'INV', '2024-04-01', '10107', 'Inventory credit For Invoice No1324', '0.00', '32000.00', '1', '1', '2024-04-01 11:37:25', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4523, '6865261646', 'INV', '2024-04-01', '102030000005', 'Customer debit For Invoice No -  1324 Customer H.M CABLES', '38000.00', '0.00', '1', '1', '2024-04-01 11:37:25', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4524, '6865261646', 'INVOICE', '2024-04-01', '303', 'Sale Income For Invoice NO - 1324 Customer H.M CABLES', '0.00', '38000.00', '1', '1', '2024-04-01 11:37:25', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4525, '9652589483', 'INV', '2024-04-01', '10107', 'Inventory credit For Invoice No1230', '0.00', '22800.00', '1', '1', '2024-04-01 11:41:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4526, '9652589483', 'INVOICE', '2024-04-01', '303', 'Sale Income From Invoice NO - 1230 Customer H.M CABLES', '0.00', '37800.00', '1', '1', '2024-04-01 11:41:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4527, '9652589483', 'INV', '2024-04-01', '102030000005', 'Customer debit For Invoice NO - 1230 customer-  H.M CABLES', '37800.00', '0.00', '1', '1', '2024-04-01 11:41:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4530, '20240320152200', 'Purchase', '2024-03-20', '10107', 'Inventory Devit Supplier Sale Return ', '38000.00', '0.00', '1', '1', '2024-04-01 13:01:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4531, '20240320152200', 'Purchase', '2024-03-20', '502000054', 'Supplier -Sale Return ', '0.00', '38000.00', '1', '1', '2024-04-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4532, '20240320152200', 'Purchase', '2024-03-20', '402', 'Company Credit For SupplierSale Return ', '38000.00', '0.00', '1', '1', '2024-04-01 13:01:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4533, '20240320152200', 'Purchase', '2024-03-20', '1020101', 'Cash in Hand For Supplier Sale Return ', '0.00', '0.00', '1', '1', '2024-04-01 13:01:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4534, '20240320152200', 'Purchase', '2024-03-20', '502000054', 'Supplier . Sale Return ', '0.00', '0.00', '1', '1', '2024-04-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4540, '20240205145350', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier Arfeen Wire (Million)', '297401.00', '0.00', '1', '1', '2024-04-01 15:10:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4541, '20240205145350', 'Purchase', '2023-12-31', '502000029', 'Supplier -Arfeen Wire (Million)', '0.00', '297401.00', '1', '1', '2024-04-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4542, '20240205145350', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierArfeen Wire (Million)', '297401.00', '0.00', '1', '1', '2024-04-01 15:10:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4543, '20240205145350', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier Arfeen Wire (Million)', '0.00', '0.00', '1', '1', '2024-04-01 15:10:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4544, '20240205145350', 'Purchase', '2023-12-31', '502000029', 'Supplier . Arfeen Wire (Million)', '0.00', '0.00', '1', '1', '2024-04-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4555, '20240203150856', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier Arfeen Wire (Million)', '321600.00', '0.00', '1', '1', '2024-04-01 15:19:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4556, '20240203150856', 'Purchase', '2023-12-31', '502000029', 'Supplier -Arfeen Wire (Million)', '0.00', '321600.00', '1', '1', '2024-04-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4557, '20240203150856', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierArfeen Wire (Million)', '321600.00', '0.00', '1', '1', '2024-04-01 15:19:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4558, '20240203150856', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier Arfeen Wire (Million)', '0.00', '0.00', '1', '1', '2024-04-01 15:19:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4559, '20240203150856', 'Purchase', '2023-12-31', '502000029', 'Supplier . Arfeen Wire (Million)', '0.00', '0.00', '1', '1', '2024-04-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4595, '20240218121742', 'Purchase', '2024-02-01', '10107', 'Inventory Devit Supplier Fareed Qasim', '738339.00', '0.00', '1', '1', '2024-04-01 17:08:17', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4596, '20240218121742', 'Purchase', '2024-02-01', '502000022', 'Supplier -Fareed Qasim', '0.00', '738339.00', '1', '1', '2024-04-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4597, '20240218121742', 'Purchase', '2024-02-01', '402', 'Company Credit For SupplierFareed Qasim', '738339.00', '0.00', '1', '1', '2024-04-01 17:08:17', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4598, '20240218121742', 'Purchase', '2024-02-01', '1020101', 'Cash in Hand For Supplier Fareed Qasim', '0.00', '0.00', '1', '1', '2024-04-01 17:08:17', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4599, '20240218121742', 'Purchase', '2024-02-01', '502000022', 'Supplier . Fareed Qasim', '0.00', '0.00', '1', '1', '2024-04-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4600, '20240129154322', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier Fareed Qasim', '1996120.00', '0.00', '1', '1', '2024-04-01 17:10:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4601, '20240129154322', 'Purchase', '2023-12-31', '502000022', 'Supplier -Fareed Qasim', '0.00', '1996120.00', '1', '1', '2024-04-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4602, '20240129154322', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierFareed Qasim', '1996120.00', '0.00', '1', '1', '2024-04-01 17:10:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4603, '20240129154322', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier Fareed Qasim', '0.00', '0.00', '1', '1', '2024-04-01 17:10:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4604, '20240129154322', 'Purchase', '2023-12-31', '502000022', 'Supplier . Fareed Qasim', '0.00', '0.00', '1', '1', '2024-04-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4625, '20240128113240', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier Chilton Safan', '809650.00', '0.00', '1', '1', '2024-04-02 11:06:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4626, '20240128113240', 'Purchase', '2023-12-31', '502000009', 'Supplier -Chilton Safan', '0.00', '809650.00', '1', '1', '2024-04-02 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4627, '20240128113240', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierChilton Safan', '809650.00', '0.00', '1', '1', '2024-04-02 11:06:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4628, '20240128113240', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier Chilton Safan', '0.00', '0.00', '1', '1', '2024-04-02 11:06:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4629, '20240128113240', 'Purchase', '2023-12-31', '502000009', 'Supplier . Chilton Safan', '0.00', '0.00', '1', '1', '2024-04-02 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4670, '20240319123802', 'Purchase', '2024-03-16', '10107', 'Inventory Devit Supplier Chilton Traders Karachi', '260000.00', '0.00', '1', '1', '2024-04-02 15:41:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4671, '20240319123802', 'Purchase', '2024-03-16', '502000032', 'Supplier -Chilton Traders Karachi', '0.00', '260000.00', '1', '1', '2024-04-02 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4672, '20240319123802', 'Purchase', '2024-03-16', '402', 'Company Credit For SupplierChilton Traders Karachi', '260000.00', '0.00', '1', '1', '2024-04-02 15:41:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4673, '20240319123802', 'Purchase', '2024-03-16', '1020101', 'Cash in Hand For Supplier Chilton Traders Karachi', '0.00', '0.00', '1', '1', '2024-04-02 15:41:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4674, '20240319123802', 'Purchase', '2024-03-16', '502000032', 'Supplier . Chilton Traders Karachi', '0.00', '0.00', '1', '1', '2024-04-02 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4675, '20240325082455', 'Purchase', '2024-03-25', '10107', 'Inventory Devit Supplier Pak E \\ S Khi', '0.00', '0.00', '1', '1', '2024-04-02 16:12:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4676, '20240325082455', 'Purchase', '2024-03-25', '502000003', 'Supplier -Pak E \\ S Khi', '0.00', '0.00', '1', '1', '2024-04-02 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4677, '20240325082455', 'Purchase', '2024-03-25', '402', 'Company Credit For SupplierPak E \\ S Khi', '0.00', '0.00', '1', '1', '2024-04-02 16:12:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4678, '20240325082455', 'Purchase', '2024-03-25', '1020101', 'Cash in Hand For Supplier Pak E \\ S Khi', '0.00', '0.00', '1', '1', '2024-04-02 16:12:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4679, '20240325082455', 'Purchase', '2024-03-25', '502000003', 'Supplier . Pak E \\ S Khi', '0.00', '0.00', '1', '1', '2024-04-02 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4680, '20240219084954', 'Purchase', '2024-02-01', '10107', 'Inventory Devit Supplier Pak E \\ S Khi', '0.00', '0.00', '1', '1', '2024-04-02 16:16:21', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4681, '20240219084954', 'Purchase', '2024-02-01', '502000003', 'Supplier -Pak E \\ S Khi', '0.00', '0.00', '1', '1', '2024-04-02 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4682, '20240219084954', 'Purchase', '2024-02-01', '402', 'Company Credit For SupplierPak E \\ S Khi', '0.00', '0.00', '1', '1', '2024-04-02 16:16:21', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4683, '20240219084954', 'Purchase', '2024-02-01', '1020101', 'Cash in Hand For Supplier Pak E \\ S Khi', '0.00', '0.00', '1', '1', '2024-04-02 16:16:21', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4684, '20240219084954', 'Purchase', '2024-02-01', '502000003', 'Supplier . Pak E \\ S Khi', '0.00', '0.00', '1', '1', '2024-04-02 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4763, '20240124152118', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier Pak E \\ S Khi', '142910.00', '0.00', '1', '1', '2024-04-03 08:03:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4764, '20240124152118', 'Purchase', '2023-12-31', '502000003', 'Supplier -Pak E \\ S Khi', '0.00', '142910.00', '1', '1', '2024-04-03 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4765, '20240124152118', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierPak E \\ S Khi', '142910.00', '0.00', '1', '1', '2024-04-03 08:03:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4766, '20240124152118', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier Pak E \\ S Khi', '0.00', '0.00', '1', '1', '2024-04-03 08:03:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4767, '20240124152118', 'Purchase', '2023-12-31', '502000003', 'Supplier . Pak E \\ S Khi', '0.00', '0.00', '1', '1', '2024-04-03 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4773, '20240131144117', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier Jawaid Wire', '66780.00', '0.00', '1', '1', '2024-04-03 08:50:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4774, '20240131144117', 'Purchase', '2023-12-31', '502000024', 'Supplier -Jawaid Wire', '0.00', '66780.00', '1', '1', '2024-04-03 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4775, '20240131144117', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierJawaid Wire', '66780.00', '0.00', '1', '1', '2024-04-03 08:50:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4776, '20240131144117', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier Jawaid Wire', '0.00', '0.00', '1', '1', '2024-04-03 08:50:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4777, '20240131144117', 'Purchase', '2023-12-31', '502000024', 'Supplier . Jawaid Wire', '0.00', '0.00', '1', '1', '2024-04-03 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4783, '20240402162259', 'Purchase', '2024-04-02', '10107', 'Inventory Devit Supplier Yayha Karachi', '537515.00', '0.00', '1', '1', '2024-04-03 11:23:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4784, '20240402162259', 'Purchase', '2024-04-02', '502000057', 'Supplier -Yayha Karachi', '0.00', '537515.00', '1', '1', '2024-04-03 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4785, '20240402162259', 'Purchase', '2024-04-02', '402', 'Company Credit For SupplierYayha Karachi', '537515.00', '0.00', '1', '1', '2024-04-03 11:23:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4786, '20240402162259', 'Purchase', '2024-04-02', '1020101', 'Cash in Hand For Supplier Yayha Karachi', '0.00', '0.00', '1', '1', '2024-04-03 11:23:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4787, '20240402162259', 'Purchase', '2024-04-02', '502000057', 'Supplier . Yayha Karachi', '0.00', '0.00', '1', '1', '2024-04-03 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4813, '20240404072442', 'Purchase', '2024-04-03', '10107', 'Inventory Devit Supplier Cash Item ', '263600.00', '0.00', '1', '1', '2024-04-04 07:27:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4814, '20240404072442', 'Purchase', '2024-04-03', '502000047', 'Supplier -Cash Item ', '0.00', '263600.00', '1', '1', '2024-04-04 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4815, '20240404072442', 'Purchase', '2024-04-03', '402', 'Company Credit For SupplierCash Item ', '263600.00', '0.00', '1', '1', '2024-04-04 07:27:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4816, '20240404072442', 'Purchase', '2024-04-03', '1020101', 'Cash in Hand For Supplier Cash Item ', '0.00', '0.00', '1', '1', '2024-04-04 07:27:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4817, '20240404072442', 'Purchase', '2024-04-03', '502000047', 'Supplier . Cash Item ', '0.00', '0.00', '1', '1', '2024-04-04 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4823, '5732915468', 'INV', '2024-04-04', '10107', 'Inventory credit For Invoice No1288', '0.00', '18403.50', '1', '1', '2024-04-04 08:37:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4824, '5732915468', 'INVOICE', '2024-04-04', '303', 'Sale Income From Invoice NO - 1288 Customer Walking Customer', '0.00', '13280.00', '1', '1', '2024-04-04 08:37:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4825, '5732915468', 'INV', '2024-04-04', '102030000002', 'Customer debit For Invoice NO - 1288 customer-  Walking Customer', '13280.00', '0.00', '1', '1', '2024-04-04 08:37:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4829, '3668139334', 'INV', '2024-04-04', '10107', 'Inventory credit For Invoice No1326', '0.00', '17315.00', '1', '1', '2024-04-04 09:43:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4830, '3668139334', 'INV', '2024-04-04', '102030000002', 'Customer debit For Invoice No -  1326 Customer Walking Customer', '19360.00', '0.00', '1', '1', '2024-04-04 09:43:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4831, '3668139334', 'INVOICE', '2024-04-04', '303', 'Sale Income For Invoice NO - 1326 Customer Walking Customer', '0.00', '19360.00', '1', '1', '2024-04-04 09:43:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4835, '3373792943', 'INV', '2024-04-04', '10107', 'Inventory credit For Invoice No1327', '0.00', '10170.00', '1', '1', '2024-04-04 10:54:19', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4836, '3373792943', 'INVOICE', '2024-04-04', '303', 'Sale Income From Invoice NO - 1327 Customer Walking Customer', '0.00', '7280.00', '1', '1', '2024-04-04 10:54:19', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4837, '3373792943', 'INV', '2024-04-04', '102030000002', 'Customer debit For Invoice NO - 1327 customer-  Walking Customer', '7280.00', '0.00', '1', '1', '2024-04-04 10:54:19', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4852, '20240331164423', 'Purchase', '2024-03-31', '10107', 'Inventory Devit Supplier G.One LED Light', '136010.00', '0.00', '1', '1', '2024-04-04 12:05:23', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4853, '20240331164423', 'Purchase', '2024-03-31', '502000027', 'Supplier -G.One LED Light', '0.00', '136010.00', '1', '1', '2024-04-04 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4854, '20240331164423', 'Purchase', '2024-03-31', '402', 'Company Credit For SupplierG.One LED Light', '136010.00', '0.00', '1', '1', '2024-04-04 12:05:23', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4855, '20240331164423', 'Purchase', '2024-03-31', '1020101', 'Cash in Hand For Supplier G.One LED Light', '0.00', '0.00', '1', '1', '2024-04-04 12:05:23', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4856, '20240331164423', 'Purchase', '2024-03-31', '502000027', 'Supplier . G.One LED Light', '0.00', '0.00', '1', '1', '2024-04-04 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4857, '1299158818', 'INV', '2024-04-04', '10107', 'Inventory credit For Invoice No1329', '0.00', '12380.00', '1', '1', '2024-04-04 15:08:02', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4858, '1299158818', 'INV', '2024-04-04', '102030000016', 'Customer debit For Invoice No -  1329 Customer Abdul Qadir Electric ', '14200.00', '0.00', '1', '1', '2024-04-04 15:08:02', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4859, '1299158818', 'INVOICE', '2024-04-04', '303', 'Sale Income For Invoice NO - 1329 Customer Abdul Qadir Electric ', '0.00', '14200.00', '1', '1', '2024-04-04 15:08:02', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4868, '20240311102859', 'Purchase', '2024-03-10', '10107', 'Inventory Devit Supplier M.K Electric Purchase', '14300.00', '0.00', '1', '1', '2024-04-04 15:41:17', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4869, '20240311102859', 'Purchase', '2024-03-10', '502000053', 'Supplier -M.K Electric Purchase', '0.00', '14300.00', '1', '1', '2024-04-04 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4870, '20240311102859', 'Purchase', '2024-03-10', '402', 'Company Credit For SupplierM.K Electric Purchase', '14300.00', '0.00', '1', '1', '2024-04-04 15:41:17', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4871, '20240311102859', 'Purchase', '2024-03-10', '1020101', 'Cash in Hand For Supplier M.K Electric Purchase', '0.00', '0.00', '1', '1', '2024-04-04 15:41:17', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4872, '20240311102859', 'Purchase', '2024-03-10', '502000053', 'Supplier . M.K Electric Purchase', '0.00', '0.00', '1', '1', '2024-04-04 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4876, '20240404154945', 'Purchase', '2024-04-04', '10107', 'Inventory Debit For Supplier Cash Item ', '31160.00', '0.00', '1', '1', '2024-04-04 15:49:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4877, '20240404154945', 'Purchase', '2024-04-04', '502000047', 'Supplier .Cash Item ', '0.00', '31160.00', '1', '1', '2024-04-04 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4878, '20240404154945', 'Purchase', '2024-04-04', '402', 'Company Credit For  Cash Item ', '31160.00', '0.00', '1', '1', '2024-04-04 15:49:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4879, '20240404160614', 'Purchase', '2024-04-04', '10107', 'Inventory Debit For Supplier Fareed Qasim', '991248.00', '0.00', '1', '1', '2024-04-04 16:06:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4880, '20240404160614', 'Purchase', '2024-04-04', '502000022', 'Supplier .Fareed Qasim', '0.00', '991248.00', '1', '1', '2024-04-04 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4881, '20240404160614', 'Purchase', '2024-04-04', '402', 'Company Credit For  Fareed Qasim', '991248.00', '0.00', '1', '1', '2024-04-04 16:06:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4885, '5173269616', 'INV', '2024-04-06', '10107', 'Inventory credit For Invoice No1331', '0.00', '31160.00', '1', '1', '2024-04-06 07:26:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4886, '5173269616', 'INV', '2024-04-06', '102030000005', 'Customer debit For Invoice No -  1331 Customer H.M CABLES', '38060.00', '0.00', '1', '1', '2024-04-06 07:26:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4887, '5173269616', 'INVOICE', '2024-04-06', '303', 'Sale Income For Invoice NO - 1331 Customer H.M CABLES', '0.00', '38060.00', '1', '1', '2024-04-06 07:26:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4929, '20240406152118', 'Purchase', '2024-04-06', '10107', 'Inventory Debit For Supplier Burq Sargodah', '23240.00', '0.00', '1', '1', '2024-04-06 15:21:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4930, '20240406152118', 'Purchase', '2024-04-06', '502000021', 'Supplier .Burq Sargodah', '0.00', '23240.00', '1', '1', '2024-04-06 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4931, '20240406152118', 'Purchase', '2024-04-06', '402', 'Company Credit For  Burq Sargodah', '23240.00', '0.00', '1', '1', '2024-04-06 15:21:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4932, '20240406152913', 'Purchase', '2024-04-06', '10107', 'Inventory Debit For Supplier M.K Electric Purchase', '5150.00', '0.00', '1', '1', '2024-04-06 15:29:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4933, '20240406152913', 'Purchase', '2024-04-06', '502000053', 'Supplier .M.K Electric Purchase', '0.00', '5150.00', '1', '1', '2024-04-06 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4934, '20240406152913', 'Purchase', '2024-04-06', '402', 'Company Credit For  M.K Electric Purchase', '5150.00', '0.00', '1', '1', '2024-04-06 15:29:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4938, '20240407074527', 'Purchase', '2024-04-06', '10107', 'Inventory Debit For Supplier Usman S.E ', '19500.00', '0.00', '1', '1', '2024-04-07 07:45:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4939, '20240407074527', 'Purchase', '2024-04-06', '502000058', 'Supplier .Usman S.E ', '0.00', '19500.00', '1', '1', '2024-04-07 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4940, '20240407074527', 'Purchase', '2024-04-06', '402', 'Company Credit For  Usman S.E ', '19500.00', '0.00', '1', '1', '2024-04-07 07:45:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4941, '8429856221', 'INV', '2024-04-07', '10107', 'Inventory credit For Invoice No1297', '0.00', '52620.00', '1', '1', '2024-04-07 08:07:02', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4942, '8429856221', 'INVOICE', '2024-04-07', '303', 'Sale Income From Invoice NO - 1297 Customer Faizan Basti ', '0.00', '39460.00', '1', '1', '2024-04-07 08:07:02', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4943, '8429856221', 'INV', '2024-04-07', '102030000006', 'Customer debit For Invoice NO - 1297 customer-  Faizan Basti ', '39460.00', '0.00', '1', '1', '2024-04-07 08:07:02', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4961, '2135868574', 'INV', '2024-04-07', '10107', 'Inventory credit For Invoice No1056', '0.00', '0.00', '1', '1', '2024-04-07 10:22:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4962, '2135868574', 'INVOICE', '2024-04-07', '303', 'Sale Income From Invoice NO - 1056 Customer Mustufa Arif', '0.00', '0.00', '1', '1', '2024-04-07 10:22:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4963, '2135868574', 'INV', '2024-04-07', '102030000023', 'Customer debit For Invoice NO - 1056 customer-  Mustufa Arif', '0.00', '0.00', '1', '1', '2024-04-07 10:22:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4964, '1938912735', 'INV', '2024-04-07', '10107', 'Inventory credit For Invoice No1333', '0.00', '0.00', '1', '1', '2024-04-07 10:24:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4965, '1938912735', 'INVOICE', '2024-04-07', '303', 'Sale Income From Invoice NO - 1333 Customer Mustufa Arif', '0.00', '0.00', '1', '1', '2024-04-07 10:24:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4966, '1938912735', 'INV', '2024-04-07', '102030000023', 'Customer debit For Invoice NO - 1333 customer-  Mustufa Arif', '0.00', '0.00', '1', '1', '2024-04-07 10:24:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4975, '20240324153957', 'Purchase', '2024-04-07', '10107', 'Inventory Devit Supplier Arfeen Wire (Million)', '198280.00', '0.00', '1', '1', '2024-04-08 08:14:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4976, '20240324153957', 'Purchase', '2024-04-07', '502000029', 'Supplier -Arfeen Wire (Million)', '0.00', '198280.00', '1', '1', '2024-04-08 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4977, '20240324153957', 'Purchase', '2024-04-07', '402', 'Company Credit For SupplierArfeen Wire (Million)', '198280.00', '0.00', '1', '1', '2024-04-08 08:14:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4978, '20240324153957', 'Purchase', '2024-04-07', '1020101', 'Cash in Hand For Supplier Arfeen Wire (Million)', '0.00', '0.00', '1', '1', '2024-04-08 08:14:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4979, '20240324153957', 'Purchase', '2024-04-07', '502000029', 'Supplier . Arfeen Wire (Million)', '0.00', '0.00', '1', '1', '2024-04-08 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4991, '2166655947', 'INV', '2024-04-08', '10107', 'Inventory credit For Invoice No1335', '0.00', '402904.20', '1', '1', '2024-04-08 10:14:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4992, '2166655947', 'INVOICE', '2024-04-08', '303', 'Sale Income From Invoice NO - 1335 Customer Abdul Qadir Electric ', '0.00', '238120.00', '1', '1', '2024-04-08 10:14:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4993, '2166655947', 'INV', '2024-04-08', '102030000016', 'Customer debit For Invoice NO - 1335 customer-  Abdul Qadir Electric ', '238120.00', '0.00', '1', '1', '2024-04-08 10:14:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4994, '2375654761', 'INV', '2024-04-08', '10107', 'Inventory credit For Invoice No1336', '0.00', '235509.30', '1', '1', '2024-04-08 10:28:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4995, '2375654761', 'INV', '2024-04-08', '102030000014', 'Customer debit For Invoice No -  1336 Customer Ashfaq Electric ', '83900.00', '0.00', '1', '1', '2024-04-08 10:28:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (4996, '2375654761', 'INVOICE', '2024-04-08', '303', 'Sale Income For Invoice NO - 1336 Customer Ashfaq Electric ', '0.00', '83900.00', '1', '1', '2024-04-08 10:28:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5003, '8628978864', 'INV', '2024-04-08', '10107', 'Inventory credit For Invoice No1338', '0.00', '15464.00', '1', '1', '2024-04-08 11:58:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5004, '8628978864', 'INV', '2024-04-08', '102030000019', 'Customer debit For Invoice No -  1338 Customer M.Z Electric', '13160.00', '0.00', '1', '1', '2024-04-08 11:58:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5005, '8628978864', 'INVOICE', '2024-04-08', '303', 'Sale Income For Invoice NO - 1338 Customer M.Z Electric', '0.00', '13160.00', '1', '1', '2024-04-08 11:58:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5006, '5481418892', 'INV', '2024-04-08', '10107', 'Inventory credit For Invoice No1339', '0.00', '73490.00', '1', '1', '2024-04-08 12:07:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5007, '5481418892', 'INV', '2024-04-08', '102030000043', 'Customer debit For Invoice No -  1339 Customer Hamza Electric Store ', '5860.00', '0.00', '1', '1', '2024-04-08 12:07:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5008, '5481418892', 'INVOICE', '2024-04-08', '303', 'Sale Income For Invoice NO - 1339 Customer Hamza Electric Store ', '0.00', '5860.00', '1', '1', '2024-04-08 12:07:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5009, '4913417498', 'INV', '2024-04-08', '10107', 'Inventory credit For Invoice No1340', '0.00', '12500.00', '1', '1', '2024-04-08 12:09:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5010, '4913417498', 'INV', '2024-04-08', '102030000031', 'Customer debit For Invoice No -  1340 Customer Saffan Chilton ', '12500.00', '0.00', '1', '1', '2024-04-08 12:09:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5011, '4913417498', 'INVOICE', '2024-04-08', '303', 'Sale Income For Invoice NO - 1340 Customer Saffan Chilton ', '0.00', '12500.00', '1', '1', '2024-04-08 12:09:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5012, '5268985181', 'INV', '2024-04-08', '10107', 'Inventory credit For Invoice No1341', '0.00', '86707.70', '1', '1', '2024-04-08 12:22:10', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5013, '5268985181', 'INV', '2024-04-08', '102030000017', 'Customer debit For Invoice No -  1341 Customer Deluxe Electric', '97800.00', '0.00', '1', '1', '2024-04-08 12:22:10', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5014, '5268985181', 'INVOICE', '2024-04-08', '303', 'Sale Income For Invoice NO - 1341 Customer Deluxe Electric', '0.00', '97800.00', '1', '1', '2024-04-08 12:22:10', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5015, '9849939218', 'INV', '2024-04-08', '10107', 'Inventory credit For Invoice No1342', '0.00', '3250.00', '1', '1', '2024-04-08 12:25:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5016, '9849939218', 'INV', '2024-04-08', '102030000024', 'Customer debit For Invoice No -  1342 Customer Eman Electric', '4050.00', '0.00', '1', '1', '2024-04-08 12:25:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5017, '9849939218', 'INVOICE', '2024-04-08', '303', 'Sale Income For Invoice NO - 1342 Customer Eman Electric', '0.00', '4050.00', '1', '1', '2024-04-08 12:25:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5018, '4695875524', 'INV', '2024-04-08', '10107', 'Inventory credit For Invoice No1343', '0.00', '9200.00', '1', '1', '2024-04-08 12:30:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5019, '4695875524', 'INV', '2024-04-08', '102030000049', 'Customer debit For Invoice No -  1343 Customer Haji Salman', '8400.00', '0.00', '1', '1', '2024-04-08 12:30:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5020, '4695875524', 'INVOICE', '2024-04-08', '303', 'Sale Income For Invoice NO - 1343 Customer Haji Salman', '0.00', '8400.00', '1', '1', '2024-04-08 12:30:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5032, '20240409075717', 'Purchase', '2024-04-08', '10107', 'Inventory Debit For Supplier Zahid Soomro Kotri', '12400.00', '0.00', '1', '1', '2024-04-09 07:57:17', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5033, '20240409075717', 'Purchase', '2024-04-08', '502000043', 'Supplier .Zahid Soomro Kotri', '0.00', '12400.00', '1', '1', '2024-04-09 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5034, '20240409075717', 'Purchase', '2024-04-08', '402', 'Company Credit For  Zahid Soomro Kotri', '12400.00', '0.00', '1', '1', '2024-04-09 07:57:17', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5035, '20240408094723', 'Purchase', '2024-04-08', '10107', 'Inventory Devit Supplier Sale Return ', '47600.00', '0.00', '1', '1', '2024-04-09 08:06:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5036, '20240408094723', 'Purchase', '2024-04-08', '502000054', 'Supplier -Sale Return ', '0.00', '47600.00', '1', '1', '2024-04-09 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5037, '20240408094723', 'Purchase', '2024-04-08', '402', 'Company Credit For SupplierSale Return ', '47600.00', '0.00', '1', '1', '2024-04-09 08:06:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5038, '20240408094723', 'Purchase', '2024-04-08', '1020101', 'Cash in Hand For Supplier Sale Return ', '0.00', '0.00', '1', '1', '2024-04-09 08:06:42', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5039, '20240408094723', 'Purchase', '2024-04-08', '502000054', 'Supplier . Sale Return ', '0.00', '0.00', '1', '1', '2024-04-09 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5040, '2216479258', 'INV', '2024-04-09', '10107', 'Inventory credit For Invoice No1345', '0.00', '12400.00', '1', '1', '2024-04-09 08:08:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5041, '2216479258', 'INV', '2024-04-09', '102030000005', 'Customer debit For Invoice No -  1345 Customer H.M CABLES', '15200.00', '0.00', '1', '1', '2024-04-09 08:08:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5042, '2216479258', 'INVOICE', '2024-04-09', '303', 'Sale Income For Invoice NO - 1345 Customer H.M CABLES', '0.00', '15200.00', '1', '1', '2024-04-09 08:08:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5057, '20240331161838', 'Purchase', '2024-03-31', '10107', 'Inventory Devit Supplier Abdul Qadir Purchase ', '5625.00', '0.00', '1', '1', '2024-04-09 11:38:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5058, '20240331161838', 'Purchase', '2024-03-31', '502000056', 'Supplier -Abdul Qadir Purchase ', '0.00', '5625.00', '1', '1', '2024-04-09 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5059, '20240331161838', 'Purchase', '2024-03-31', '402', 'Company Credit For SupplierAbdul Qadir Purchase ', '5625.00', '0.00', '1', '1', '2024-04-09 11:38:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5060, '20240331161838', 'Purchase', '2024-03-31', '1020101', 'Cash in Hand For Supplier Abdul Qadir Purchase ', '0.00', '0.00', '1', '1', '2024-04-09 11:38:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5061, '20240331161838', 'Purchase', '2024-03-31', '502000056', 'Supplier . Abdul Qadir Purchase ', '0.00', '0.00', '1', '1', '2024-04-09 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5070, '20240409144517', 'Purchase', '2024-04-09', '10107', 'Inventory Debit For Supplier F Ali Iddress Karachi', '32000.00', '0.00', '1', '1', '2024-04-09 14:45:17', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5071, '20240409144517', 'Purchase', '2024-04-09', '502000049', 'Supplier .F Ali Iddress Karachi', '0.00', '32000.00', '1', '1', '2024-04-09 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5072, '20240409144517', 'Purchase', '2024-04-09', '402', 'Company Credit For  F Ali Iddress Karachi', '32000.00', '0.00', '1', '1', '2024-04-09 14:45:17', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5073, '20240409144806', 'Purchase', '2024-04-09', '10107', 'Inventory Debit For Supplier Zahid Soomro Kotri', '9300.00', '0.00', '1', '1', '2024-04-09 14:48:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5074, '20240409144806', 'Purchase', '2024-04-09', '502000043', 'Supplier .Zahid Soomro Kotri', '0.00', '9300.00', '1', '1', '2024-04-09 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5075, '20240409144806', 'Purchase', '2024-04-09', '402', 'Company Credit For  Zahid Soomro Kotri', '9300.00', '0.00', '1', '1', '2024-04-09 14:48:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5076, '6839949824', 'INV', '2024-04-09', '10107', 'Inventory credit For Invoice No1346', '0.00', '9300.00', '1', '1', '2024-04-09 14:51:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5077, '6839949824', 'INV', '2024-04-09', '102030000005', 'Customer debit For Invoice No -  1346 Customer H.M CABLES', '11400.00', '0.00', '1', '1', '2024-04-09 14:51:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5078, '6839949824', 'INVOICE', '2024-04-09', '303', 'Sale Income For Invoice NO - 1346 Customer H.M CABLES', '0.00', '11400.00', '1', '1', '2024-04-09 14:51:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5079, '4823786759', 'INV', '2024-04-09', '10107', 'Inventory credit For Invoice No1347', '0.00', '6589.50', '1', '1', '2024-04-09 15:33:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5080, '4823786759', 'INV', '2024-04-09', '102030000002', 'Customer debit For Invoice No -  1347 Customer Walking Customer', '9410.00', '0.00', '1', '1', '2024-04-09 15:33:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5081, '4823786759', 'INVOICE', '2024-04-09', '303', 'Sale Income For Invoice NO - 1347 Customer Walking Customer', '0.00', '9410.00', '1', '1', '2024-04-09 15:33:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5085, '20240409092240', 'Purchase', '2024-04-09', '10107', 'Inventory Devit Supplier Abdul Qadir Purchase ', '120000.00', '0.00', '1', '1', '2024-04-14 07:30:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5086, '20240409092240', 'Purchase', '2024-04-09', '502000056', 'Supplier -Abdul Qadir Purchase ', '0.00', '120000.00', '1', '1', '2024-04-14 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5087, '20240409092240', 'Purchase', '2024-04-09', '402', 'Company Credit For SupplierAbdul Qadir Purchase ', '120000.00', '0.00', '1', '1', '2024-04-14 07:30:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5088, '20240409092240', 'Purchase', '2024-04-09', '1020101', 'Cash in Hand For Supplier Abdul Qadir Purchase ', '0.00', '0.00', '1', '1', '2024-04-14 07:30:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5089, '20240409092240', 'Purchase', '2024-04-09', '502000056', 'Supplier . Abdul Qadir Purchase ', '0.00', '0.00', '1', '1', '2024-04-14 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5093, '20240414075501', 'Purchase', '2024-04-13', '10107', 'Inventory Debit For Supplier Qureshi pipe wala', '25400.00', '0.00', '1', '1', '2024-04-14 07:55:01', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5094, '20240414075501', 'Purchase', '2024-04-13', '502000004', 'Supplier .Qureshi pipe wala', '0.00', '25400.00', '1', '1', '2024-04-14 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5095, '20240414075501', 'Purchase', '2024-04-13', '402', 'Company Credit For  Qureshi pipe wala', '25400.00', '0.00', '1', '1', '2024-04-14 07:55:01', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5131, '4648594853', 'INV', '2024-04-14', '10107', 'Inventory credit For Invoice No1349', '0.00', '82652.17', '1', '1', '2024-04-14 10:04:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5132, '4648594853', 'INVOICE', '2024-04-14', '303', 'Sale Income From Invoice NO - 1349 Customer Walking Customer', '0.00', '51200.00', '1', '1', '2024-04-14 10:04:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5133, '4648594853', 'INV', '2024-04-14', '102030000002', 'Customer debit For Invoice NO - 1349 customer-  Walking Customer', '51200.00', '0.00', '1', '1', '2024-04-14 10:04:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5134, '6586445994', 'INV', '2024-04-14', '10107', 'Inventory credit For Invoice No1350', '0.00', '3602.00', '1', '1', '2024-04-14 12:20:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5135, '6586445994', 'INV', '2024-04-14', '102030000039', 'Customer debit For Invoice No -  1350 Customer G.1 LED', '3000.00', '0.00', '1', '1', '2024-04-14 12:20:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5136, '6586445994', 'INVOICE', '2024-04-14', '303', 'Sale Income For Invoice NO - 1350 Customer G.1 LED', '0.00', '3000.00', '1', '1', '2024-04-14 12:20:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5137, '1196229697', 'INV', '2024-04-14', '10107', 'Inventory credit For Invoice No1351', '0.00', '9438.10', '1', '1', '2024-04-14 12:22:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5138, '1196229697', 'INV', '2024-04-14', '102030000031', 'Customer debit For Invoice No -  1351 Customer Saffan Chilton ', '10700.00', '0.00', '1', '1', '2024-04-14 12:22:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5139, '1196229697', 'INVOICE', '2024-04-14', '303', 'Sale Income For Invoice NO - 1351 Customer Saffan Chilton ', '0.00', '10700.00', '1', '1', '2024-04-14 12:22:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5140, '7873299185', 'INV', '2024-04-14', '10107', 'Inventory credit For Invoice No1352', '0.00', '16321.00', '1', '1', '2024-04-14 12:25:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5141, '7873299185', 'INV', '2024-04-14', '102030000006', 'Customer debit For Invoice No -  1352 Customer Faizan Basti ', '17000.00', '0.00', '1', '1', '2024-04-14 12:25:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5142, '7873299185', 'INVOICE', '2024-04-14', '303', 'Sale Income For Invoice NO - 1352 Customer Faizan Basti ', '0.00', '17000.00', '1', '1', '2024-04-14 12:25:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5170, '1954183663', 'INV', '2024-04-14', '10107', 'Inventory credit For Invoice No1348', '0.00', '59710.67', '1', '1', '2024-04-14 13:22:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5171, '1954183663', 'INVOICE', '2024-04-14', '303', 'Sale Income From Invoice NO - 1348 Customer Walking Customer', '0.00', '36370.00', '1', '1', '2024-04-14 13:22:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5172, '1954183663', 'INV', '2024-04-14', '102030000002', 'Customer debit For Invoice NO - 1348 customer-  Walking Customer', '36370.00', '0.00', '1', '1', '2024-04-14 13:22:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5173, '5176459998', 'INV', '2024-04-14', '10107', 'Inventory credit For Invoice No1344', '0.00', '309622.37', '1', '1', '2024-04-14 13:40:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5174, '5176459998', 'INVOICE', '2024-04-14', '303', 'Sale Income From Invoice NO - 1344 Customer Walking Customer', '0.00', '88640.00', '1', '1', '2024-04-14 13:40:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5175, '5176459998', 'INV', '2024-04-14', '102030000002', 'Customer debit For Invoice NO - 1344 customer-  Walking Customer', '88640.00', '0.00', '1', '1', '2024-04-14 13:40:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5220, '6792891529', 'INV', '2024-04-14', '10107', 'Inventory credit For Invoice No1334', '0.00', '289569.70', '1', '1', '2024-04-14 15:17:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5221, '6792891529', 'INVOICE', '2024-04-14', '303', 'Sale Income From Invoice NO - 1334 Customer Walking Customer', '0.00', '60150.00', '1', '1', '2024-04-14 15:17:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5222, '6792891529', 'INV', '2024-04-14', '102030000002', 'Customer debit For Invoice NO - 1334 customer-  Walking Customer', '60150.00', '0.00', '1', '1', '2024-04-14 15:17:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5234, '20240404162219', 'Purchase', '2024-04-04', '10107', 'Inventory Devit Supplier Delux Electric Purchase ', '14320.00', '0.00', '1', '1', '2024-04-15 08:25:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5235, '20240404162219', 'Purchase', '2024-04-04', '502000051', 'Supplier -Delux Electric Purchase ', '0.00', '14320.00', '1', '1', '2024-04-15 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5236, '20240404162219', 'Purchase', '2024-04-04', '402', 'Company Credit For SupplierDelux Electric Purchase ', '14320.00', '0.00', '1', '1', '2024-04-15 08:25:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5237, '20240404162219', 'Purchase', '2024-04-04', '1020101', 'Cash in Hand For Supplier Delux Electric Purchase ', '0.00', '0.00', '1', '1', '2024-04-15 08:25:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5238, '20240404162219', 'Purchase', '2024-04-04', '502000051', 'Supplier . Delux Electric Purchase ', '0.00', '0.00', '1', '1', '2024-04-15 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5258, '4979853171', 'INV', '2024-04-15', '10107', 'Inventory credit For Invoice No1353', '0.00', '121526.33', '1', '1', '2024-04-15 09:03:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5259, '4979853171', 'INVOICE', '2024-04-15', '303', 'Sale Income From Invoice NO - 1353 Customer Arif Electriction ', '0.00', '69000.00', '1', '1', '2024-04-15 09:03:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5260, '4979853171', 'INV', '2024-04-15', '102030000050', 'Customer debit For Invoice NO - 1353 customer-  Arif Electriction ', '69000.00', '0.00', '1', '1', '2024-04-15 09:03:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5283, '20240319124136', 'Purchase', '2024-03-17', '10107', 'Inventory Devit Supplier Paremount General', '20200.00', '0.00', '1', '1', '2024-04-15 10:40:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5284, '20240319124136', 'Purchase', '2024-03-17', '502000038', 'Supplier -Paremount General', '0.00', '20200.00', '1', '1', '2024-04-15 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5285, '20240319124136', 'Purchase', '2024-03-17', '402', 'Company Credit For SupplierParemount General', '20200.00', '0.00', '1', '1', '2024-04-15 10:40:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5286, '20240319124136', 'Purchase', '2024-03-17', '1020101', 'Cash in Hand For Supplier Paremount General', '0.00', '0.00', '1', '1', '2024-04-15 10:40:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5287, '20240319124136', 'Purchase', '2024-03-17', '502000038', 'Supplier . Paremount General', '0.00', '0.00', '1', '1', '2024-04-15 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5296, '20240415122939', 'Purchase', '2024-04-15', '10107', 'Inventory Debit For Supplier Cash Item ', '28190.00', '0.00', '1', '1', '2024-04-15 12:29:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5297, '20240415122939', 'Purchase', '2024-04-15', '502000047', 'Supplier .Cash Item ', '0.00', '28190.00', '1', '1', '2024-04-15 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5298, '20240415122939', 'Purchase', '2024-04-15', '402', 'Company Credit For  Cash Item ', '28190.00', '0.00', '1', '1', '2024-04-15 12:29:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5299, '20240406155718', 'Purchase', '2024-04-06', '10107', 'Inventory Devit Supplier Cash Item ', '19130.00', '0.00', '1', '1', '2024-04-15 12:31:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5300, '20240406155718', 'Purchase', '2024-04-06', '502000047', 'Supplier -Cash Item ', '0.00', '19130.00', '1', '1', '2024-04-15 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5301, '20240406155718', 'Purchase', '2024-04-06', '402', 'Company Credit For SupplierCash Item ', '19130.00', '0.00', '1', '1', '2024-04-15 12:31:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5302, '20240406155718', 'Purchase', '2024-04-06', '1020101', 'Cash in Hand For Supplier Cash Item ', '0.00', '0.00', '1', '1', '2024-04-15 12:31:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5303, '20240406155718', 'Purchase', '2024-04-06', '502000047', 'Supplier . Cash Item ', '0.00', '0.00', '1', '1', '2024-04-15 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5313, '8841984599', 'INV', '2024-04-15', '10107', 'Inventory credit For Invoice No1354', '0.00', '51126.90', '1', '1', '2024-04-15 13:03:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5314, '8841984599', 'INVOICE', '2024-04-15', '303', 'Sale Income From Invoice NO - 1354 Customer Walking Customer', '0.00', '22610.00', '1', '1', '2024-04-15 13:03:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5315, '8841984599', 'INV', '2024-04-15', '102030000002', 'Customer debit For Invoice NO - 1354 customer-  Walking Customer', '22610.00', '0.00', '1', '1', '2024-04-15 13:03:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5324, '20240415132224', 'Purchase', '2024-04-15', '10107', 'Inventory Devit Supplier G.One LED Light', '83750.00', '0.00', '1', '1', '2024-04-15 13:29:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5325, '20240415132224', 'Purchase', '2024-04-15', '502000027', 'Supplier -G.One LED Light', '0.00', '83750.00', '1', '1', '2024-04-15 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5326, '20240415132224', 'Purchase', '2024-04-15', '402', 'Company Credit For SupplierG.One LED Light', '83750.00', '0.00', '1', '1', '2024-04-15 13:29:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5327, '20240415132224', 'Purchase', '2024-04-15', '1020101', 'Cash in Hand For Supplier G.One LED Light', '0.00', '0.00', '1', '1', '2024-04-15 13:29:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5328, '20240415132224', 'Purchase', '2024-04-15', '502000027', 'Supplier . G.One LED Light', '0.00', '0.00', '1', '1', '2024-04-15 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5332, '20240331163555', 'Purchase', '2024-03-31', '10107', 'Inventory Devit Supplier Abdul Hammed Panel wala', '18300.00', '0.00', '1', '1', '2024-04-15 13:53:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5333, '20240331163555', 'Purchase', '2024-03-31', '502000048', 'Supplier -Abdul Hammed Panel wala', '0.00', '18300.00', '1', '1', '2024-04-15 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5334, '20240331163555', 'Purchase', '2024-03-31', '402', 'Company Credit For SupplierAbdul Hammed Panel wala', '18300.00', '0.00', '1', '1', '2024-04-15 13:53:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5335, '20240331163555', 'Purchase', '2024-03-31', '1020101', 'Cash in Hand For Supplier Abdul Hammed Panel wala', '0.00', '0.00', '1', '1', '2024-04-15 13:53:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5336, '20240331163555', 'Purchase', '2024-03-31', '502000048', 'Supplier . Abdul Hammed Panel wala', '0.00', '0.00', '1', '1', '2024-04-15 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5384, '7653135536', 'INV', '2024-04-16', '10107', 'Inventory credit For Invoice No1355', '0.00', '54666.50', '1', '1', '2024-04-16 09:32:26', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5385, '7653135536', 'INVOICE', '2024-04-16', '303', 'Sale Income From Invoice NO - 1355 Customer Riyaz Marfat ', '0.00', '75050.00', '1', '1', '2024-04-16 09:32:26', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5386, '7653135536', 'INV', '2024-04-16', '102030000051', 'Customer debit For Invoice NO - 1355 customer-  Riyaz Marfat ', '75050.00', '0.00', '1', '1', '2024-04-16 09:32:26', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5393, '7865327862', 'INV', '2024-04-16', '10107', 'Inventory credit For Invoice No1356', '0.00', '97800.00', '1', '1', '2024-04-16 12:28:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5394, '7865327862', 'INV', '2024-04-16', '102030000005', 'Customer debit For Invoice No -  1356 Customer H.M CABLES', '79400.00', '0.00', '1', '1', '2024-04-16 12:28:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5395, '7865327862', 'INVOICE', '2024-04-16', '303', 'Sale Income For Invoice NO - 1356 Customer H.M CABLES', '0.00', '79400.00', '1', '1', '2024-04-16 12:28:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5417, '20240406124316', 'Purchase', '2024-04-06', '10107', 'Inventory Devit Supplier Chilton Traders Karachi', '9516.00', '0.00', '1', '1', '2024-04-16 14:01:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5418, '20240406124316', 'Purchase', '2024-04-06', '502000032', 'Supplier -Chilton Traders Karachi', '0.00', '9516.00', '1', '1', '2024-04-16 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5419, '20240406124316', 'Purchase', '2024-04-06', '402', 'Company Credit For SupplierChilton Traders Karachi', '9516.00', '0.00', '1', '1', '2024-04-16 14:01:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5420, '20240406124316', 'Purchase', '2024-04-06', '1020101', 'Cash in Hand For Supplier Chilton Traders Karachi', '0.00', '0.00', '1', '1', '2024-04-16 14:01:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5421, '20240406124316', 'Purchase', '2024-04-06', '502000032', 'Supplier . Chilton Traders Karachi', '0.00', '0.00', '1', '1', '2024-04-16 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5422, '3395545996', 'INV', '2024-04-16', '10107', 'Inventory credit For Invoice No1357', '0.00', '25244.77', '1', '1', '2024-04-16 14:12:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5423, '3395545996', 'INVOICE', '2024-04-16', '303', 'Sale Income From Invoice NO - 1357 Customer Walking Customer', '0.00', '24430.00', '1', '1', '2024-04-16 14:12:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5424, '3395545996', 'INV', '2024-04-16', '102030000002', 'Customer debit For Invoice NO - 1357 customer-  Walking Customer', '24430.00', '0.00', '1', '1', '2024-04-16 14:12:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5425, '1948967738', 'INV', '2024-04-16', '10107', 'Inventory credit For Invoice No1332', '0.00', '98085.55', '1', '1', '2024-04-16 14:29:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5426, '1948967738', 'INVOICE', '2024-04-16', '303', 'Sale Income From Invoice NO - 1332 Customer Walking Customer', '0.00', '81550.00', '1', '1', '2024-04-16 14:29:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5427, '1948967738', 'INV', '2024-04-16', '102030000002', 'Customer debit For Invoice NO - 1332 customer-  Walking Customer', '81550.00', '0.00', '1', '1', '2024-04-16 14:29:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5438, '3454739466', 'INV', '2024-04-17', '10107', 'Inventory credit For Invoice No1358', '0.00', '510719.10', '1', '1', '2024-04-17 10:31:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5439, '3454739466', 'INV', '2024-04-17', '102030000017', 'Customer debit For Invoice No -  1358 Customer Deluxe Electric', '377880.00', '0.00', '1', '1', '2024-04-17 10:31:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5440, '3454739466', 'INVOICE', '2024-04-17', '303', 'Sale Income For Invoice NO - 1358 Customer Deluxe Electric', '0.00', '377880.00', '1', '1', '2024-04-17 10:31:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5441, '20240417115239', 'Purchase', '2024-04-17', '10107', 'Inventory Debit For Supplier Zahid Soomro Kotri', '6300.00', '0.00', '1', '1', '2024-04-17 11:52:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5442, '20240417115239', 'Purchase', '2024-04-17', '502000043', 'Supplier .Zahid Soomro Kotri', '0.00', '6300.00', '1', '1', '2024-04-17 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5443, '20240417115239', 'Purchase', '2024-04-17', '402', 'Company Credit For  Zahid Soomro Kotri', '6300.00', '0.00', '1', '1', '2024-04-17 11:52:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5444, '1897354479', 'INV', '2024-04-17', '10107', 'Inventory credit For Invoice No1359', '0.00', '6375.00', '1', '1', '2024-04-17 11:59:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5445, '1897354479', 'INV', '2024-04-17', '102030000005', 'Customer debit For Invoice No -  1359 Customer H.M CABLES', '8200.00', '0.00', '1', '1', '2024-04-17 11:59:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5446, '1897354479', 'INVOICE', '2024-04-17', '303', 'Sale Income For Invoice NO - 1359 Customer H.M CABLES', '0.00', '8200.00', '1', '1', '2024-04-17 11:59:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5447, '1971361776', 'INV', '2024-04-17', '10107', 'Inventory credit For Invoice No1323', '0.00', '17533.33', '1', '1', '2024-04-17 12:05:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5448, '1971361776', 'INVOICE', '2024-04-17', '303', 'Sale Income From Invoice NO - 1323 Customer H.M CABLES', '0.00', '28050.00', '1', '1', '2024-04-17 12:05:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5449, '1971361776', 'INV', '2024-04-17', '102030000005', 'Customer debit For Invoice NO - 1323 customer-  H.M CABLES', '28050.00', '0.00', '1', '1', '2024-04-17 12:05:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5450, '1971361776', 'INV', '2024-04-17', '102030000005', 'Customer credit for Paid Amount For Invoice No -1323 Customer H.M CABLES', '0.00', '1555300.00', '1', '1', '2024-04-17 12:05:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5451, '1971361776', 'INV', '2024-04-17', '1020101', 'Cash in Hand for sale for Invoice No -1323 Customer H.M CABLES', '1555300.00', '0.00', '1', '1', '2024-04-17 12:05:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5452, '1331473321', 'INV', '2024-04-17', '10107', 'Inventory credit For Invoice No1360', '0.00', '25200.00', '1', '1', '2024-04-17 12:09:25', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5453, '1331473321', 'INV', '2024-04-17', '102030000005', 'Customer debit For Invoice No -  1360 Customer H.M CABLES', '31800.00', '0.00', '1', '1', '2024-04-17 12:09:25', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5454, '1331473321', 'INVOICE', '2024-04-17', '303', 'Sale Income For Invoice NO - 1360 Customer H.M CABLES', '0.00', '31800.00', '1', '1', '2024-04-17 12:09:25', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5455, '5989899254', 'INV', '2024-04-17', '10107', 'Inventory credit For Invoice No1337', '0.00', '157591.67', '1', '1', '2024-04-17 12:30:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5456, '5989899254', 'INVOICE', '2024-04-17', '303', 'Sale Income From Invoice NO - 1337 Customer Cafe 7/11 ', '0.00', '82295.00', '1', '1', '2024-04-17 12:30:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5457, '5989899254', 'INV', '2024-04-17', '102030000048', 'Customer debit For Invoice NO - 1337 customer-  Cafe 7/11 ', '82295.00', '0.00', '1', '1', '2024-04-17 12:30:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5482, '20240416122251', 'Purchase', '2024-04-16', '10107', 'Inventory Devit Supplier Cash Item ', '59820.00', '0.00', '1', '1', '2024-04-17 14:14:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5483, '20240416122251', 'Purchase', '2024-04-16', '502000047', 'Supplier -Cash Item ', '0.00', '59820.00', '1', '1', '2024-04-17 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5484, '20240416122251', 'Purchase', '2024-04-16', '402', 'Company Credit For SupplierCash Item ', '59820.00', '0.00', '1', '1', '2024-04-17 14:14:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5485, '20240416122251', 'Purchase', '2024-04-16', '1020101', 'Cash in Hand For Supplier Cash Item ', '0.00', '0.00', '1', '1', '2024-04-17 14:14:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5486, '20240416122251', 'Purchase', '2024-04-16', '502000047', 'Supplier . Cash Item ', '0.00', '0.00', '1', '1', '2024-04-17 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5487, '8951253458', 'INV', '2024-04-17', '10107', 'Inventory credit For Invoice No1328', '0.00', '51034.87', '1', '1', '2024-04-17 14:45:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5488, '8951253458', 'INVOICE', '2024-04-17', '303', 'Sale Income From Invoice NO - 1328 Customer Walking Customer', '0.00', '40080.00', '1', '1', '2024-04-17 14:45:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5489, '8951253458', 'INV', '2024-04-17', '102030000002', 'Customer debit For Invoice NO - 1328 customer-  Walking Customer', '40080.00', '0.00', '1', '1', '2024-04-17 14:45:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5496, '20240418073307', 'Purchase', '2024-04-17', '10107', 'Inventory Debit For Supplier Cash Item ', '9170.00', '0.00', '1', '1', '2024-04-18 07:33:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5497, '20240418073307', 'Purchase', '2024-04-17', '502000047', 'Supplier .Cash Item ', '0.00', '9170.00', '1', '1', '2024-04-18 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5498, '20240418073307', 'Purchase', '2024-04-17', '402', 'Company Credit For  Cash Item ', '9170.00', '0.00', '1', '1', '2024-04-18 07:33:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5499, '3687215118', 'INV', '2024-04-18', '10107', 'Inventory credit For Invoice No1362', '0.00', '8400.00', '1', '1', '2024-04-18 07:36:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5500, '3687215118', 'INV', '2024-04-18', '102030000005', 'Customer debit For Invoice No -  1362 Customer H.M CABLES', '10800.00', '0.00', '1', '1', '2024-04-18 07:36:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5501, '3687215118', 'INVOICE', '2024-04-18', '303', 'Sale Income For Invoice NO - 1362 Customer H.M CABLES', '0.00', '10800.00', '1', '1', '2024-04-18 07:36:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5502, '3352983635', 'INV', '2024-04-18', '10107', 'Inventory credit For Invoice No1363', '0.00', '47012.50', '1', '1', '2024-04-18 07:38:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5503, '3352983635', 'INV', '2024-04-18', '102030000016', 'Customer debit For Invoice No -  1363 Customer Abdul Qadir Electric ', '47500.00', '0.00', '1', '1', '2024-04-18 07:38:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5504, '3352983635', 'INVOICE', '2024-04-18', '303', 'Sale Income For Invoice NO - 1363 Customer Abdul Qadir Electric ', '0.00', '47500.00', '1', '1', '2024-04-18 07:38:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5505, '7953851285', 'INV', '2024-04-18', '10107', 'Inventory credit For Invoice No1364', '0.00', '3936.00', '1', '1', '2024-04-18 07:42:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5506, '7953851285', 'INV', '2024-04-18', '102030000020', 'Customer debit For Invoice No -  1364 Customer M.K Electric ', '4200.00', '0.00', '1', '1', '2024-04-18 07:42:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5507, '7953851285', 'INVOICE', '2024-04-18', '303', 'Sale Income For Invoice NO - 1364 Customer M.K Electric ', '0.00', '4200.00', '1', '1', '2024-04-18 07:42:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5508, '6742371245', 'INV', '2024-04-18', '10107', 'Inventory credit For Invoice No1365', '0.00', '19880.00', '1', '1', '2024-04-18 07:47:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5509, '6742371245', 'INV', '2024-04-18', '102030000012', 'Customer debit For Invoice No -  1365 Customer National Spining', '30700.00', '0.00', '1', '1', '2024-04-18 07:47:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5510, '6742371245', 'INVOICE', '2024-04-18', '303', 'Sale Income For Invoice NO - 1365 Customer National Spining', '0.00', '30700.00', '1', '1', '2024-04-18 07:47:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5511, '2634181175', 'INV', '2024-04-18', '10107', 'Inventory credit For Invoice No1330', '0.00', '110857.00', '1', '1', '2024-04-18 08:01:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5512, '2634181175', 'INVOICE', '2024-04-18', '303', 'Sale Income From Invoice NO - 1330 Customer Ali Bhai', '0.00', '72300.00', '1', '1', '2024-04-18 08:01:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5513, '2634181175', 'INV', '2024-04-18', '102030000047', 'Customer debit For Invoice NO - 1330 customer-  Ali Bhai', '72300.00', '0.00', '1', '1', '2024-04-18 08:01:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5514, '9826454685', 'INV', '2024-04-18', '10107', 'Inventory credit For Invoice No1366', '0.00', '461200.00', '1', '1', '2024-04-18 08:04:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5515, '9826454685', 'INV', '2024-04-18', '102030000047', 'Customer debit For Invoice No -  1366 Customer Ali Bhai', '356000.00', '0.00', '1', '1', '2024-04-18 08:04:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5516, '9826454685', 'INVOICE', '2024-04-18', '303', 'Sale Income For Invoice NO - 1366 Customer Ali Bhai', '0.00', '356000.00', '1', '1', '2024-04-18 08:04:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5520, '4181161449', 'INV', '2024-04-18', '10107', 'Inventory credit For Invoice No1361', '0.00', '67623.92', '1', '1', '2024-04-18 08:59:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5521, '4181161449', 'INVOICE', '2024-04-18', '303', 'Sale Income From Invoice NO - 1361 Customer Walking Customer', '0.00', '53285.00', '1', '1', '2024-04-18 08:59:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5522, '4181161449', 'INV', '2024-04-18', '102030000002', 'Customer debit For Invoice NO - 1361 customer-  Walking Customer', '53285.00', '0.00', '1', '1', '2024-04-18 08:59:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5529, '20240414075130', 'Purchase', '2024-04-13', '10107', 'Inventory Devit Supplier Abdul Qadir Purchase ', '15100.00', '0.00', '1', '1', '2024-04-18 15:13:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5530, '20240414075130', 'Purchase', '2024-04-13', '502000056', 'Supplier -Abdul Qadir Purchase ', '0.00', '15100.00', '1', '1', '2024-04-18 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5531, '20240414075130', 'Purchase', '2024-04-13', '402', 'Company Credit For SupplierAbdul Qadir Purchase ', '15100.00', '0.00', '1', '1', '2024-04-18 15:13:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5532, '20240414075130', 'Purchase', '2024-04-13', '1020101', 'Cash in Hand For Supplier Abdul Qadir Purchase ', '0.00', '0.00', '1', '1', '2024-04-18 15:13:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5533, '20240414075130', 'Purchase', '2024-04-13', '502000056', 'Supplier . Abdul Qadir Purchase ', '0.00', '0.00', '1', '1', '2024-04-18 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5537, '5253343437', 'INV', '2024-04-20', '10107', 'Inventory credit For Invoice No1369', '0.00', '41605.00', '1', '1', '2024-04-20 07:56:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5538, '5253343437', 'INV', '2024-04-20', '102030000005', 'Customer debit For Invoice No -  1369 Customer H.M CABLES', '19000.00', '0.00', '1', '1', '2024-04-20 07:56:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5539, '5253343437', 'INVOICE', '2024-04-20', '303', 'Sale Income For Invoice NO - 1369 Customer H.M CABLES', '0.00', '19000.00', '1', '1', '2024-04-20 07:56:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5540, '8378298814', 'INV', '2024-04-20', '10107', 'Inventory credit For Invoice No1370', '0.00', '5876.20', '1', '1', '2024-04-20 08:03:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5541, '8378298814', 'INV', '2024-04-20', '102030000026', 'Customer debit For Invoice No -  1370 Customer Memon Light  ', '6200.00', '0.00', '1', '1', '2024-04-20 08:03:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5542, '8378298814', 'INVOICE', '2024-04-20', '303', 'Sale Income For Invoice NO - 1370 Customer Memon Light  ', '0.00', '6200.00', '1', '1', '2024-04-20 08:03:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5549, '7943379429', 'INV', '2024-04-20', '10107', 'Inventory credit For Invoice No1368', '0.00', '0.00', '1', '1', '2024-04-20 08:17:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5550, '7943379429', 'INVOICE', '2024-04-20', '303', 'Sale Income From Invoice NO - 1368 Customer Mustufa Arif', '0.00', '0.00', '1', '1', '2024-04-20 08:17:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5551, '7943379429', 'INV', '2024-04-20', '102030000023', 'Customer debit For Invoice NO - 1368 customer-  Mustufa Arif', '0.00', '0.00', '1', '1', '2024-04-20 08:17:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5567, '4754231575', 'INV', '2024-04-20', '10107', 'Inventory credit For Invoice No1367', '0.00', '70453.10', '1', '1', '2024-04-20 08:57:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5568, '4754231575', 'INVOICE', '2024-04-20', '303', 'Sale Income From Invoice NO - 1367 Customer Walking Customer', '0.00', '39860.00', '1', '1', '2024-04-20 08:57:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5569, '4754231575', 'INV', '2024-04-20', '102030000002', 'Customer debit For Invoice NO - 1367 customer-  Walking Customer', '39860.00', '0.00', '1', '1', '2024-04-20 08:57:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5570, '4187574224', 'INV', '2024-04-20', '10107', 'Inventory credit For Invoice No1371', '0.00', '11095.00', '1', '1', '2024-04-20 09:08:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5571, '4187574224', 'INV', '2024-04-20', '102030000002', 'Customer debit For Invoice No -  1371 Customer Walking Customer', '18320.00', '0.00', '1', '1', '2024-04-20 09:08:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5572, '4187574224', 'INVOICE', '2024-04-20', '303', 'Sale Income For Invoice NO - 1371 Customer Walking Customer', '0.00', '18320.00', '1', '1', '2024-04-20 09:08:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5597, '2343991432', 'INV', '2024-04-20', '10107', 'Inventory credit For Invoice No1325', '0.00', '173077.83', '1', '1', '2024-04-20 13:43:05', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5598, '2343991432', 'INVOICE', '2024-04-20', '303', 'Sale Income From Invoice NO - 1325 Customer Walking Customer', '0.00', '41865.00', '1', '1', '2024-04-20 13:43:05', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5599, '2343991432', 'INV', '2024-04-20', '102030000002', 'Customer debit For Invoice NO - 1325 customer-  Walking Customer', '41865.00', '0.00', '1', '1', '2024-04-20 13:43:05', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5600, '20240403121740', 'Purchase', '2024-04-03', '10107', 'Inventory Devit Supplier Chilton Traders Karachi', '9928.00', '0.00', '1', '1', '2024-04-20 13:44:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5601, '20240403121740', 'Purchase', '2024-04-03', '502000032', 'Supplier -Chilton Traders Karachi', '0.00', '9928.00', '1', '1', '2024-04-20 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5602, '20240403121740', 'Purchase', '2024-04-03', '402', 'Company Credit For SupplierChilton Traders Karachi', '9928.00', '0.00', '1', '1', '2024-04-20 13:44:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5603, '20240403121740', 'Purchase', '2024-04-03', '1020101', 'Cash in Hand For Supplier Chilton Traders Karachi', '0.00', '0.00', '1', '1', '2024-04-20 13:44:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5604, '20240403121740', 'Purchase', '2024-04-03', '502000032', 'Supplier . Chilton Traders Karachi', '0.00', '0.00', '1', '1', '2024-04-20 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5608, '20240421120511', 'Purchase', '2024-04-21', '10107', 'Inventory Devit Supplier Abdul Qadir Purchase ', '173400.00', '0.00', '1', '1', '2024-04-21 12:20:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5609, '20240421120511', 'Purchase', '2024-04-21', '502000056', 'Supplier -Abdul Qadir Purchase ', '0.00', '173400.00', '1', '1', '2024-04-21 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5610, '20240421120511', 'Purchase', '2024-04-21', '402', 'Company Credit For SupplierAbdul Qadir Purchase ', '173400.00', '0.00', '1', '1', '2024-04-21 12:20:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5611, '20240421120511', 'Purchase', '2024-04-21', '1020101', 'Cash in Hand For Supplier Abdul Qadir Purchase ', '0.00', '0.00', '1', '1', '2024-04-21 12:20:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5612, '20240421120511', 'Purchase', '2024-04-21', '502000056', 'Supplier . Abdul Qadir Purchase ', '0.00', '0.00', '1', '1', '2024-04-21 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5613, '20240421122720', 'Purchase', '2024-04-21', '10107', 'Inventory Debit For Supplier Cash Item ', '83520.00', '0.00', '1', '1', '2024-04-21 12:27:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5614, '20240421122720', 'Purchase', '2024-04-21', '502000047', 'Supplier .Cash Item ', '0.00', '83520.00', '1', '1', '2024-04-21 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5615, '20240421122720', 'Purchase', '2024-04-21', '402', 'Company Credit For  Cash Item ', '83520.00', '0.00', '1', '1', '2024-04-21 12:27:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5616, '20240421124629', 'Purchase', '2024-04-21', '10107', 'Inventory Debit For Supplier F Ali Iddress Karachi', '94000.00', '0.00', '1', '1', '2024-04-21 12:46:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5617, '20240421124629', 'Purchase', '2024-04-21', '502000049', 'Supplier .F Ali Iddress Karachi', '0.00', '94000.00', '1', '1', '2024-04-21 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5618, '20240421124629', 'Purchase', '2024-04-21', '402', 'Company Credit For  F Ali Iddress Karachi', '94000.00', '0.00', '1', '1', '2024-04-21 12:46:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5622, '20240421160133', 'Purchase', '2024-04-21', '10107', 'Inventory Debit For Supplier G.One LED Light', '1900.00', '0.00', '1', '1', '2024-04-21 16:01:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5623, '20240421160133', 'Purchase', '2024-04-21', '502000027', 'Supplier .G.One LED Light', '0.00', '1900.00', '1', '1', '2024-04-21 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5624, '20240421160133', 'Purchase', '2024-04-21', '402', 'Company Credit For  G.One LED Light', '1900.00', '0.00', '1', '1', '2024-04-21 16:01:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5625, '2696397343', 'INV', '2024-04-21', '10107', 'Inventory credit For Invoice No1373', '0.00', '64000.00', '1', '1', '2024-04-21 16:15:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5626, '2696397343', 'INV', '2024-04-21', '102030000005', 'Customer debit For Invoice No -  1373 Customer H.M CABLES', '76000.00', '0.00', '1', '1', '2024-04-21 16:15:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5627, '2696397343', 'INVOICE', '2024-04-21', '303', 'Sale Income For Invoice NO - 1373 Customer H.M CABLES', '0.00', '76000.00', '1', '1', '2024-04-21 16:15:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5641, '20240420075013', 'Purchase', '2024-04-18', '10107', 'Inventory Devit Supplier Abdul Hammed Panel wala', '9800.00', '0.00', '1', '1', '2024-04-22 09:08:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5642, '20240420075013', 'Purchase', '2024-04-18', '502000048', 'Supplier -Abdul Hammed Panel wala', '0.00', '9800.00', '1', '1', '2024-04-22 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5643, '20240420075013', 'Purchase', '2024-04-18', '402', 'Company Credit For SupplierAbdul Hammed Panel wala', '9800.00', '0.00', '1', '1', '2024-04-22 09:08:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5644, '20240420075013', 'Purchase', '2024-04-18', '1020101', 'Cash in Hand For Supplier Abdul Hammed Panel wala', '0.00', '0.00', '1', '1', '2024-04-22 09:08:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5645, '20240420075013', 'Purchase', '2024-04-18', '502000048', 'Supplier . Abdul Hammed Panel wala', '0.00', '0.00', '1', '1', '2024-04-22 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5654, '20240128142633', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier Asim Sargodah', '80500.00', '0.00', '1', '1', '2024-04-22 09:30:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5655, '20240128142633', 'Purchase', '2023-12-31', '502000014', 'Supplier -Asim Sargodah', '0.00', '80500.00', '1', '1', '2024-04-22 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5656, '20240128142633', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierAsim Sargodah', '80500.00', '0.00', '1', '1', '2024-04-22 09:30:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5657, '20240128142633', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier Asim Sargodah', '0.00', '0.00', '1', '1', '2024-04-22 09:30:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5658, '20240128142633', 'Purchase', '2023-12-31', '502000014', 'Supplier . Asim Sargodah', '0.00', '0.00', '1', '1', '2024-04-22 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5680, '1929867449', 'INV', '2024-04-22', '10107', 'Inventory credit For Invoice No1372', '0.00', '108221.00', '1', '1', '2024-04-22 10:57:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5681, '1929867449', 'INVOICE', '2024-04-22', '303', 'Sale Income From Invoice NO - 1372 Customer Walking Customer', '0.00', '74720.00', '1', '1', '2024-04-22 10:57:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5682, '1929867449', 'INV', '2024-04-22', '102030000002', 'Customer debit For Invoice NO - 1372 customer-  Walking Customer', '74720.00', '0.00', '1', '1', '2024-04-22 10:57:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5688, '20240128141713', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier Perfect Sargodah', '44450.00', '0.00', '1', '1', '2024-04-22 11:02:25', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5689, '20240128141713', 'Purchase', '2023-12-31', '502000016', 'Supplier -Perfect Sargodah', '0.00', '44450.00', '1', '1', '2024-04-22 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5690, '20240128141713', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierPerfect Sargodah', '44450.00', '0.00', '1', '1', '2024-04-22 11:02:25', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5691, '20240128141713', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier Perfect Sargodah', '0.00', '0.00', '1', '1', '2024-04-22 11:02:25', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5692, '20240128141713', 'Purchase', '2023-12-31', '502000016', 'Supplier . Perfect Sargodah', '0.00', '0.00', '1', '1', '2024-04-22 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5698, '7592546738', 'INV', '2024-04-22', '10107', 'Inventory credit For Invoice No1374', '0.00', '332.00', '1', '1', '2024-04-22 11:22:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5699, '7592546738', 'INV', '2024-04-22', '102030000002', 'Customer debit For Invoice No -  1374 Customer Walking Customer', '300.00', '0.00', '1', '1', '2024-04-22 11:22:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5700, '7592546738', 'INVOICE', '2024-04-22', '303', 'Sale Income For Invoice NO - 1374 Customer Walking Customer', '0.00', '300.00', '1', '1', '2024-04-22 11:22:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5704, '20240422120615', 'Purchase', '2024-04-22', '10107', 'Inventory Debit For Supplier E M Sargodah', '42314.00', '0.00', '1', '1', '2024-04-22 12:06:15', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5705, '20240422120615', 'Purchase', '2024-04-22', '502000017', 'Supplier .E M Sargodah', '0.00', '42314.00', '1', '1', '2024-04-22 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5706, '20240422120615', 'Purchase', '2024-04-22', '402', 'Company Credit For  E M Sargodah', '42314.00', '0.00', '1', '1', '2024-04-22 12:06:15', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5715, '20240224143946', 'Purchase', '2024-02-24', '10107', 'Inventory Devit Supplier Haji Salman Karachi', '25000.00', '0.00', '1', '1', '2024-04-22 12:47:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5716, '20240224143946', 'Purchase', '2024-02-24', '502000040', 'Supplier -Haji Salman Karachi', '0.00', '25000.00', '1', '1', '2024-04-22 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5717, '20240224143946', 'Purchase', '2024-02-24', '402', 'Company Credit For SupplierHaji Salman Karachi', '25000.00', '0.00', '1', '1', '2024-04-22 12:47:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5718, '20240224143946', 'Purchase', '2024-02-24', '1020101', 'Cash in Hand For Supplier Haji Salman Karachi', '0.00', '0.00', '1', '1', '2024-04-22 12:47:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5719, '20240224143946', 'Purchase', '2024-02-24', '502000040', 'Supplier . Haji Salman Karachi', '0.00', '0.00', '1', '1', '2024-04-22 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5720, '20240420101648', 'Purchase', '2024-04-20', '10107', 'Inventory Devit Supplier Chilton Traders Karachi', '42104.00', '0.00', '1', '1', '2024-04-22 12:48:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5721, '20240420101648', 'Purchase', '2024-04-20', '502000032', 'Supplier -Chilton Traders Karachi', '0.00', '42104.00', '1', '1', '2024-04-22 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5722, '20240420101648', 'Purchase', '2024-04-20', '402', 'Company Credit For SupplierChilton Traders Karachi', '42104.00', '0.00', '1', '1', '2024-04-22 12:48:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5723, '20240420101648', 'Purchase', '2024-04-20', '1020101', 'Cash in Hand For Supplier Chilton Traders Karachi', '0.00', '0.00', '1', '1', '2024-04-22 12:48:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5724, '20240420101648', 'Purchase', '2024-04-20', '502000032', 'Supplier . Chilton Traders Karachi', '0.00', '0.00', '1', '1', '2024-04-22 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5728, '7225778361', 'INV', '2024-04-22', '10107', 'Inventory credit For Invoice No1375', '0.00', '319251.00', '1', '1', '2024-04-22 12:53:10', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5729, '7225778361', 'INVOICE', '2024-04-22', '303', 'Sale Income From Invoice NO - 1375 Customer Arif Electriction ', '0.00', '276172.00', '1', '1', '2024-04-22 12:53:10', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5730, '7225778361', 'INV', '2024-04-22', '102030000050', 'Customer debit For Invoice NO - 1375 customer-  Arif Electriction ', '276172.00', '0.00', '1', '1', '2024-04-22 12:53:10', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5734, '5411671834', 'INV', '2024-04-22', '10107', 'Inventory credit For Invoice No1377', '0.00', '70942.00', '1', '1', '2024-04-22 12:59:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5735, '5411671834', 'INV', '2024-04-22', '102030000016', 'Customer debit For Invoice No -  1377 Customer Abdul Qadir Electric ', '20600.00', '0.00', '1', '1', '2024-04-22 12:59:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5736, '5411671834', 'INVOICE', '2024-04-22', '303', 'Sale Income For Invoice NO - 1377 Customer Abdul Qadir Electric ', '0.00', '20600.00', '1', '1', '2024-04-22 12:59:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5737, '5613664541', 'INV', '2024-04-22', '10107', 'Inventory credit For Invoice No1378', '0.00', '2250.00', '1', '1', '2024-04-22 13:09:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5738, '5613664541', 'INV', '2024-04-22', '102030000024', 'Customer debit For Invoice No -  1378 Customer Eman Electric', '2200.00', '0.00', '1', '1', '2024-04-22 13:09:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5739, '5613664541', 'INVOICE', '2024-04-22', '303', 'Sale Income For Invoice NO - 1378 Customer Eman Electric', '0.00', '2200.00', '1', '1', '2024-04-22 13:09:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5740, '1464127388', 'INV', '2024-04-22', '10107', 'Inventory credit For Invoice No1379', '0.00', '187733.97', '1', '1', '2024-04-22 13:26:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5741, '1464127388', 'INV', '2024-04-22', '102030000017', 'Customer debit For Invoice No -  1379 Customer Deluxe Electric', '132020.00', '0.00', '1', '1', '2024-04-22 13:26:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5742, '1464127388', 'INVOICE', '2024-04-22', '303', 'Sale Income For Invoice NO - 1379 Customer Deluxe Electric', '0.00', '132020.00', '1', '1', '2024-04-22 13:26:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5743, '7252192761', 'INV', '2024-04-22', '10107', 'Inventory credit For Invoice No1380', '0.00', '16530.00', '1', '1', '2024-04-22 13:41:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5744, '7252192761', 'INV', '2024-04-22', '102030000006', 'Customer debit For Invoice No -  1380 Customer Faizan Basti ', '11700.00', '0.00', '1', '1', '2024-04-22 13:41:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5745, '7252192761', 'INVOICE', '2024-04-22', '303', 'Sale Income For Invoice NO - 1380 Customer Faizan Basti ', '0.00', '11700.00', '1', '1', '2024-04-22 13:41:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5746, '2238345531', 'INV', '2024-04-22', '10107', 'Inventory credit For Invoice No1381', '0.00', '88081.50', '1', '1', '2024-04-22 13:46:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5747, '2238345531', 'INV', '2024-04-22', '102030000017', 'Customer debit For Invoice No -  1381 Customer Deluxe Electric', '86800.00', '0.00', '1', '1', '2024-04-22 13:46:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5748, '2238345531', 'INVOICE', '2024-04-22', '303', 'Sale Income For Invoice NO - 1381 Customer Deluxe Electric', '0.00', '86800.00', '1', '1', '2024-04-22 13:46:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5749, '20240422151035', 'Purchase', '2024-04-22', '10107', 'Inventory Debit For Supplier Cash Item ', '1768.00', '0.00', '1', '1', '2024-04-22 15:10:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5750, '20240422151035', 'Purchase', '2024-04-22', '502000047', 'Supplier .Cash Item ', '0.00', '1768.00', '1', '1', '2024-04-22 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5751, '20240422151035', 'Purchase', '2024-04-22', '402', 'Company Credit For  Cash Item ', '1768.00', '0.00', '1', '1', '2024-04-22 15:10:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5758, '7455412952', 'INV', '2024-04-22', '10107', 'Inventory credit For Invoice No1382', '0.00', '218817.67', '1', '1', '2024-04-22 15:30:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5759, '7455412952', 'INVOICE', '2024-04-22', '303', 'Sale Income From Invoice NO - 1382 Customer Walking Customer', '0.00', '28630.00', '1', '1', '2024-04-22 15:30:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5760, '7455412952', 'INV', '2024-04-22', '102030000002', 'Customer debit For Invoice NO - 1382 customer-  Walking Customer', '28630.00', '0.00', '1', '1', '2024-04-22 15:30:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5761, '20240423112445', 'Purchase', '2024-04-23', '10107', 'Inventory Debit For Supplier Cash Item ', '25150.00', '0.00', '1', '1', '2024-04-23 11:24:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5762, '20240423112445', 'Purchase', '2024-04-23', '502000047', 'Supplier .Cash Item ', '0.00', '25150.00', '1', '1', '2024-04-23 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5763, '20240423112445', 'Purchase', '2024-04-23', '402', 'Company Credit For  Cash Item ', '25150.00', '0.00', '1', '1', '2024-04-23 11:24:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5764, '20240423120446', 'Purchase', '2024-04-23', '10107', 'Inventory Debit For Supplier Sale Return ', '6980.00', '0.00', '1', '1', '2024-04-23 12:04:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5765, '20240423120446', 'Purchase', '2024-04-23', '502000054', 'Supplier .Sale Return ', '0.00', '6980.00', '1', '1', '2024-04-23 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5766, '20240423120446', 'Purchase', '2024-04-23', '402', 'Company Credit For  Sale Return ', '6980.00', '0.00', '1', '1', '2024-04-23 12:04:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5767, '20240423120732', 'Purchase', '2024-04-23', '10107', 'Inventory Debit For Supplier Sale Return ', '25150.00', '0.00', '1', '1', '2024-04-23 12:07:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5768, '20240423120732', 'Purchase', '2024-04-23', '502000054', 'Supplier .Sale Return ', '0.00', '25150.00', '1', '1', '2024-04-23 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5769, '20240423120732', 'Purchase', '2024-04-23', '402', 'Company Credit For  Sale Return ', '25150.00', '0.00', '1', '1', '2024-04-23 12:07:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5773, '20240424091801', 'Purchase', '2024-04-23', '10107', 'Inventory Debit For Supplier Cash Item ', '39850.00', '0.00', '1', '1', '2024-04-24 09:18:01', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5774, '20240424091801', 'Purchase', '2024-04-23', '502000047', 'Supplier .Cash Item ', '0.00', '39850.00', '1', '1', '2024-04-24 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5775, '20240424091801', 'Purchase', '2024-04-23', '402', 'Company Credit For  Cash Item ', '39850.00', '0.00', '1', '1', '2024-04-24 09:18:01', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5779, '8997478542', 'INV', '2024-04-24', '10107', 'Inventory credit For Invoice No1383', '0.00', '5882.00', '1', '1', '2024-04-24 09:53:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5780, '8997478542', 'INVOICE', '2024-04-24', '303', 'Sale Income From Invoice NO - 1383 Customer Walking Customer', '0.00', '7430.00', '1', '1', '2024-04-24 09:53:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5781, '8997478542', 'INV', '2024-04-24', '102030000002', 'Customer debit For Invoice NO - 1383 customer-  Walking Customer', '7430.00', '0.00', '1', '1', '2024-04-24 09:53:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5785, '20240424105426', 'Purchase', '2024-04-24', '10107', 'Inventory Debit For Supplier M.Z Purchase ', '7400.00', '0.00', '1', '1', '2024-04-24 10:54:26', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5786, '20240424105426', 'Purchase', '2024-04-24', '502000059', 'Supplier .M.Z Purchase ', '0.00', '7400.00', '1', '1', '2024-04-24 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5787, '20240424105426', 'Purchase', '2024-04-24', '402', 'Company Credit For  M.Z Purchase ', '7400.00', '0.00', '1', '1', '2024-04-24 10:54:26', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5788, '20240423125430', 'Purchase', '2024-04-23', '10107', 'Inventory Devit Supplier M.K Electric Purchase', '71802.00', '0.00', '1', '1', '2024-04-24 10:55:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5789, '20240423125430', 'Purchase', '2024-04-23', '502000053', 'Supplier -M.K Electric Purchase', '0.00', '71802.00', '1', '1', '2024-04-24 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5790, '20240423125430', 'Purchase', '2024-04-23', '402', 'Company Credit For SupplierM.K Electric Purchase', '71802.00', '0.00', '1', '1', '2024-04-24 10:55:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5791, '20240423125430', 'Purchase', '2024-04-23', '1020101', 'Cash in Hand For Supplier M.K Electric Purchase', '0.00', '0.00', '1', '1', '2024-04-24 10:55:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5792, '20240423125430', 'Purchase', '2024-04-23', '502000053', 'Supplier . M.K Electric Purchase', '0.00', '0.00', '1', '1', '2024-04-24 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5793, '7981551788', 'INV', '2024-04-24', '10107', 'Inventory credit For Invoice No1384', '0.00', '22772.00', '1', '1', '2024-04-24 10:59:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5794, '7981551788', 'INVOICE', '2024-04-24', '303', 'Sale Income From Invoice NO - 1384 Customer Dawood Super Mart', '0.00', '15950.00', '1', '1', '2024-04-24 10:59:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5795, '7981551788', 'INV', '2024-04-24', '102030000052', 'Customer debit For Invoice NO - 1384 customer-  Dawood Super Mart', '15950.00', '0.00', '1', '1', '2024-04-24 10:59:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5796, '20240316123506', 'Purchase', '2024-03-04', '10107', 'Inventory Devit Supplier Chilton Safan', '2253750.00', '0.00', '1', '1', '2024-04-24 11:03:22', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5797, '20240316123506', 'Purchase', '2024-03-04', '502000009', 'Supplier -Chilton Safan', '0.00', '2253750.00', '1', '1', '2024-04-24 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5798, '20240316123506', 'Purchase', '2024-03-04', '402', 'Company Credit For SupplierChilton Safan', '2253750.00', '0.00', '1', '1', '2024-04-24 11:03:22', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5799, '20240316123506', 'Purchase', '2024-03-04', '1020101', 'Cash in Hand For Supplier Chilton Safan', '0.00', '0.00', '1', '1', '2024-04-24 11:03:22', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5800, '20240316123506', 'Purchase', '2024-03-04', '502000009', 'Supplier . Chilton Safan', '0.00', '0.00', '1', '1', '2024-04-24 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5801, '8413576871', 'INV', '2024-04-24', '10107', 'Inventory credit For Invoice No1385', '0.00', '8800.00', '1', '1', '2024-04-24 11:04:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5802, '8413576871', 'INV', '2024-04-24', '102030000039', 'Customer debit For Invoice No -  1385 Customer G.1 LED', '9500.00', '0.00', '1', '1', '2024-04-24 11:04:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5803, '8413576871', 'INVOICE', '2024-04-24', '303', 'Sale Income For Invoice NO - 1385 Customer G.1 LED', '0.00', '9500.00', '1', '1', '2024-04-24 11:04:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5804, '20240219101122', 'Purchase', '2024-03-12', '10107', 'Inventory Devit Supplier S.K Fan', '34900.00', '0.00', '1', '1', '2024-04-24 11:06:43', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5805, '20240219101122', 'Purchase', '2024-03-12', '502000046', 'Supplier -S.K Fan', '0.00', '34900.00', '1', '1', '2024-04-24 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5806, '20240219101122', 'Purchase', '2024-03-12', '402', 'Company Credit For SupplierS.K Fan', '34900.00', '0.00', '1', '1', '2024-04-24 11:06:43', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5807, '20240219101122', 'Purchase', '2024-03-12', '1020101', 'Cash in Hand For Supplier S.K Fan', '0.00', '0.00', '1', '1', '2024-04-24 11:06:43', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5808, '20240219101122', 'Purchase', '2024-03-12', '502000046', 'Supplier . S.K Fan', '0.00', '0.00', '1', '1', '2024-04-24 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5809, '5236541338', 'INV', '2024-04-24', '10107', 'Inventory credit For Invoice No1386', '0.00', '11900.00', '1', '1', '2024-04-24 11:08:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5810, '5236541338', 'INV', '2024-04-24', '102030000052', 'Customer debit For Invoice No -  1386 Customer Dawood Super Mart', '12800.00', '0.00', '1', '1', '2024-04-24 11:08:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5811, '5236541338', 'INVOICE', '2024-04-24', '303', 'Sale Income For Invoice NO - 1386 Customer Dawood Super Mart', '0.00', '12800.00', '1', '1', '2024-04-24 11:08:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5815, '8827832273', 'INV', '2024-04-24', '10107', 'Inventory credit For Invoice No1388', '0.00', '36146.80', '1', '1', '2024-04-24 11:26:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5816, '8827832273', 'INV', '2024-04-24', '102030000009', 'Customer debit For Invoice No -  1388 Customer Zahid somoro', '30400.00', '0.00', '1', '1', '2024-04-24 11:26:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5817, '8827832273', 'INVOICE', '2024-04-24', '303', 'Sale Income For Invoice NO - 1388 Customer Zahid somoro', '0.00', '30400.00', '1', '1', '2024-04-24 11:26:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5818, '2279338767', 'INV', '2024-04-24', '10107', 'Inventory credit For Invoice No1387', '0.00', '25815.30', '1', '1', '2024-04-24 11:30:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5819, '2279338767', 'INVOICE', '2024-04-24', '303', 'Sale Income From Invoice NO - 1387 Customer Deluxe Electric', '0.00', '7900.00', '1', '1', '2024-04-24 11:30:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5820, '2279338767', 'INV', '2024-04-24', '102030000017', 'Customer debit For Invoice NO - 1387 customer-  Deluxe Electric', '7900.00', '0.00', '1', '1', '2024-04-24 11:30:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5824, '20240128115259', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier Olympic Sargodah', '26960.00', '0.00', '1', '1', '2024-04-24 11:49:23', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5825, '20240128115259', 'Purchase', '2023-12-31', '502000011', 'Supplier -Olympic Sargodah', '0.00', '26960.00', '1', '1', '2024-04-24 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5826, '20240128115259', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierOlympic Sargodah', '26960.00', '0.00', '1', '1', '2024-04-24 11:49:23', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5827, '20240128115259', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier Olympic Sargodah', '0.00', '0.00', '1', '1', '2024-04-24 11:49:23', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5828, '20240128115259', 'Purchase', '2023-12-31', '502000011', 'Supplier . Olympic Sargodah', '0.00', '0.00', '1', '1', '2024-04-24 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5829, '9958959772', 'INV', '2024-04-24', '10107', 'Inventory credit For Invoice No1389', '0.00', '8171.00', '1', '1', '2024-04-24 11:50:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5830, '9958959772', 'INVOICE', '2024-04-24', '303', 'Sale Income From Invoice NO - 1389 Customer Dawood Super Mart', '0.00', '9060.00', '1', '1', '2024-04-24 11:50:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5831, '9958959772', 'INV', '2024-04-24', '102030000052', 'Customer debit For Invoice NO - 1389 customer-  Dawood Super Mart', '9060.00', '0.00', '1', '1', '2024-04-24 11:50:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5850, '20240425085739', 'Purchase', '2024-04-24', '10107', 'Inventory Debit For Supplier Sale Return ', '14300.00', '0.00', '1', '1', '2024-04-25 08:57:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5851, '20240425085739', 'Purchase', '2024-04-24', '502000054', 'Supplier .Sale Return ', '0.00', '14300.00', '1', '1', '2024-04-25 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5852, '20240425085739', 'Purchase', '2024-04-24', '402', 'Company Credit For  Sale Return ', '14300.00', '0.00', '1', '1', '2024-04-25 08:57:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5853, '20240425090059', 'Purchase', '2024-04-24', '10107', 'Inventory Debit For Supplier Chilton Safan', '156000.00', '0.00', '1', '1', '2024-04-25 09:00:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5854, '20240425090059', 'Purchase', '2024-04-24', '502000009', 'Supplier .Chilton Safan', '0.00', '156000.00', '1', '1', '2024-04-25 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5855, '20240425090059', 'Purchase', '2024-04-24', '402', 'Company Credit For  Chilton Safan', '156000.00', '0.00', '1', '1', '2024-04-25 09:00:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5864, '7143127461', 'INV', '2024-04-25', '10107', 'Inventory credit For Invoice No1390', '0.00', '244936.10', '1', '1', '2024-04-25 10:09:21', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5865, '7143127461', 'INVOICE', '2024-04-25', '303', 'Sale Income From Invoice NO - 1390 Customer Walking Customer', '0.00', '176860.00', '1', '1', '2024-04-25 10:09:21', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5866, '7143127461', 'INV', '2024-04-25', '102030000002', 'Customer debit For Invoice NO - 1390 customer-  Walking Customer', '176860.00', '0.00', '1', '1', '2024-04-25 10:09:21', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5876, '20240425123443', 'Purchase', '2024-04-25', '10107', 'Inventory Devit Supplier Alfa Purchase ', '5600.00', '0.00', '1', '1', '2024-04-25 12:50:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5877, '20240425123443', 'Purchase', '2024-04-25', '502000060', 'Supplier -Alfa Purchase ', '0.00', '5600.00', '1', '1', '2024-04-25 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5878, '20240425123443', 'Purchase', '2024-04-25', '402', 'Company Credit For SupplierAlfa Purchase ', '5600.00', '0.00', '1', '1', '2024-04-25 12:50:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5879, '20240425123443', 'Purchase', '2024-04-25', '1020101', 'Cash in Hand For Supplier Alfa Purchase ', '0.00', '0.00', '1', '1', '2024-04-25 12:50:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5880, '20240425123443', 'Purchase', '2024-04-25', '502000060', 'Supplier . Alfa Purchase ', '0.00', '0.00', '1', '1', '2024-04-25 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5881, '20240425130633', 'Purchase', '2024-04-25', '10107', 'Inventory Debit For Supplier Arfeen Wire (Million)', '87716.00', '0.00', '1', '1', '2024-04-25 13:06:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5882, '20240425130633', 'Purchase', '2024-04-25', '502000029', 'Supplier .Arfeen Wire (Million)', '0.00', '87716.00', '1', '1', '2024-04-25 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5883, '20240425130633', 'Purchase', '2024-04-25', '402', 'Company Credit For  Arfeen Wire (Million)', '87716.00', '0.00', '1', '1', '2024-04-25 13:06:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5884, '20240416121046', 'Purchase', '2024-04-16', '10107', 'Inventory Devit Supplier Arfeen Wire (Million)', '1032340.00', '0.00', '1', '1', '2024-04-25 13:08:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5885, '20240416121046', 'Purchase', '2024-04-16', '502000029', 'Supplier -Arfeen Wire (Million)', '0.00', '1032340.00', '1', '1', '2024-04-25 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5886, '20240416121046', 'Purchase', '2024-04-16', '402', 'Company Credit For SupplierArfeen Wire (Million)', '1032340.00', '0.00', '1', '1', '2024-04-25 13:08:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5887, '20240416121046', 'Purchase', '2024-04-16', '1020101', 'Cash in Hand For Supplier Arfeen Wire (Million)', '0.00', '0.00', '1', '1', '2024-04-25 13:08:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5888, '20240416121046', 'Purchase', '2024-04-16', '502000029', 'Supplier . Arfeen Wire (Million)', '0.00', '0.00', '1', '1', '2024-04-25 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5895, '20240427092247', 'Purchase', '2024-04-25', '10107', 'Inventory Devit Supplier Yayha Karachi', '172400.00', '0.00', '1', '1', '2024-04-27 09:26:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5896, '20240427092247', 'Purchase', '2024-04-25', '502000057', 'Supplier -Yayha Karachi', '0.00', '172400.00', '1', '1', '2024-04-27 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5897, '20240427092247', 'Purchase', '2024-04-25', '402', 'Company Credit For SupplierYayha Karachi', '172400.00', '0.00', '1', '1', '2024-04-27 09:26:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5898, '20240427092247', 'Purchase', '2024-04-25', '1020101', 'Cash in Hand For Supplier Yayha Karachi', '0.00', '0.00', '1', '1', '2024-04-27 09:26:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5899, '20240427092247', 'Purchase', '2024-04-25', '502000057', 'Supplier . Yayha Karachi', '0.00', '0.00', '1', '1', '2024-04-27 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5900, '20240427093052', 'Purchase', '2024-04-25', '10107', 'Inventory Debit For Supplier Chilton Traders Karachi', '70132.00', '0.00', '1', '1', '2024-04-27 09:30:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5901, '20240427093052', 'Purchase', '2024-04-25', '502000032', 'Supplier .Chilton Traders Karachi', '0.00', '70132.00', '1', '1', '2024-04-27 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5902, '20240427093052', 'Purchase', '2024-04-25', '402', 'Company Credit For  Chilton Traders Karachi', '70132.00', '0.00', '1', '1', '2024-04-27 09:30:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5903, '20240427093547', 'Purchase', '2024-04-27', '10107', 'Inventory Debit For Supplier Zahid Soomro Kotri', '83000.00', '0.00', '1', '1', '2024-04-27 09:35:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5904, '20240427093547', 'Purchase', '2024-04-27', '502000043', 'Supplier .Zahid Soomro Kotri', '0.00', '83000.00', '1', '1', '2024-04-27 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5905, '20240427093547', 'Purchase', '2024-04-27', '402', 'Company Credit For  Zahid Soomro Kotri', '83000.00', '0.00', '1', '1', '2024-04-27 09:35:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5906, '20240427094225', 'Purchase', '2024-04-27', '10107', 'Inventory Debit For Supplier Haroon Pant', '47895.00', '0.00', '1', '1', '2024-04-27 09:42:25', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5907, '20240427094225', 'Purchase', '2024-04-27', '502000045', 'Supplier .Haroon Pant', '0.00', '47895.00', '1', '1', '2024-04-27 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5908, '20240427094225', 'Purchase', '2024-04-27', '402', 'Company Credit For  Haroon Pant', '47895.00', '0.00', '1', '1', '2024-04-27 09:42:25', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5909, '4469798727', 'INV', '2024-04-27', '10107', 'Inventory credit For Invoice No1392', '0.00', '2700.00', '1', '1', '2024-04-27 09:46:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5910, '4469798727', 'INVOICE', '2024-04-27', '303', 'Sale Income From Invoice NO - 1392 Customer Alfa Sale ', '0.00', '2700.00', '1', '1', '2024-04-27 09:46:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5911, '4469798727', 'INV', '2024-04-27', '102030000053', 'Customer debit For Invoice NO - 1392 customer-  Alfa Sale ', '2700.00', '0.00', '1', '1', '2024-04-27 09:46:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5912, '3499562843', 'INV', '2024-04-27', '10107', 'Inventory credit For Invoice No1391', '0.00', '104814.50', '1', '1', '2024-04-27 09:53:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5913, '3499562843', 'INVOICE', '2024-04-27', '303', 'Sale Income From Invoice NO - 1391 Customer Walking Customer', '0.00', '37930.00', '1', '1', '2024-04-27 09:53:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5914, '3499562843', 'INV', '2024-04-27', '102030000002', 'Customer debit For Invoice NO - 1391 customer-  Walking Customer', '37930.00', '0.00', '1', '1', '2024-04-27 09:53:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5933, '9818532272', 'INV', '2024-04-27', '10107', 'Inventory credit For Invoice No1393', '0.00', '58040.75', '1', '1', '2024-04-27 10:40:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5934, '9818532272', 'INVOICE', '2024-04-27', '303', 'Sale Income From Invoice NO - 1393 Customer Walking Customer', '0.00', '48000.00', '1', '1', '2024-04-27 10:40:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5935, '9818532272', 'INV', '2024-04-27', '102030000002', 'Customer debit For Invoice NO - 1393 customer-  Walking Customer', '48000.00', '0.00', '1', '1', '2024-04-27 10:40:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5939, '6311557677', 'INV', '2024-04-27', '10107', 'Inventory credit For Invoice No1394', '0.00', '82322.00', '1', '1', '2024-04-27 10:55:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5940, '6311557677', 'INV', '2024-04-27', '102030000016', 'Customer debit For Invoice No -  1394 Customer Abdul Qadir Electric ', '88683.00', '0.00', '1', '1', '2024-04-27 10:55:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5941, '6311557677', 'INVOICE', '2024-04-27', '303', 'Sale Income For Invoice NO - 1394 Customer Abdul Qadir Electric ', '0.00', '88683.00', '1', '1', '2024-04-27 10:55:49', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5950, '9414891438', 'INV', '2024-04-27', '10107', 'Inventory credit For Invoice No1395', '0.00', '80666.00', '1', '1', '2024-04-27 11:15:15', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5951, '9414891438', 'INVOICE', '2024-04-27', '303', 'Sale Income From Invoice NO - 1395 Customer Abdul Qadir Electric ', '0.00', '79178.00', '1', '1', '2024-04-27 11:15:15', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5952, '9414891438', 'INV', '2024-04-27', '102030000016', 'Customer debit For Invoice NO - 1395 customer-  Abdul Qadir Electric ', '79178.00', '0.00', '1', '1', '2024-04-27 11:15:15', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5953, '4787487136', 'INV', '2024-04-27', '10107', 'Inventory credit For Invoice No1396', '0.00', '2200.00', '1', '1', '2024-04-27 11:18:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5954, '4787487136', 'INV', '2024-04-27', '102030000016', 'Customer debit For Invoice No -  1396 Customer Abdul Qadir Electric ', '2800.00', '0.00', '1', '1', '2024-04-27 11:18:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5955, '4787487136', 'INVOICE', '2024-04-27', '303', 'Sale Income For Invoice NO - 1396 Customer Abdul Qadir Electric ', '0.00', '2800.00', '1', '1', '2024-04-27 11:18:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5956, '1789273916', 'INV', '2024-04-27', '10107', 'Inventory credit For Invoice No1397', '0.00', '90144.60', '1', '1', '2024-04-27 11:22:50', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5957, '1789273916', 'INV', '2024-04-27', '102030000031', 'Customer debit For Invoice No -  1397 Customer Saffan Chilton ', '134855.00', '0.00', '1', '1', '2024-04-27 11:22:50', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5958, '1789273916', 'INVOICE', '2024-04-27', '303', 'Sale Income For Invoice NO - 1397 Customer Saffan Chilton ', '0.00', '134855.00', '1', '1', '2024-04-27 11:22:50', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5959, '5253653148', 'INV', '2024-04-27', '10107', 'Inventory credit For Invoice No1398', '0.00', '9000.00', '1', '1', '2024-04-27 12:09:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5960, '5253653148', 'INV', '2024-04-27', '102030000016', 'Customer debit For Invoice No -  1398 Customer Abdul Qadir Electric ', '10000.00', '0.00', '1', '1', '2024-04-27 12:09:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5961, '5253653148', 'INVOICE', '2024-04-27', '303', 'Sale Income For Invoice NO - 1398 Customer Abdul Qadir Electric ', '0.00', '10000.00', '1', '1', '2024-04-27 12:09:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5962, '8257478766', 'INV', '2024-04-27', '10107', 'Inventory credit For Invoice No1399', '0.00', '132912.50', '1', '1', '2024-04-27 12:13:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5963, '8257478766', 'INV', '2024-04-27', '102030000017', 'Customer debit For Invoice No -  1399 Customer Deluxe Electric', '118950.00', '0.00', '1', '1', '2024-04-27 12:13:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5964, '8257478766', 'INVOICE', '2024-04-27', '303', 'Sale Income For Invoice NO - 1399 Customer Deluxe Electric', '0.00', '118950.00', '1', '1', '2024-04-27 12:13:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5965, '6294569947', 'INV', '2024-04-27', '10107', 'Inventory credit For Invoice No1400', '0.00', '8200.00', '1', '1', '2024-04-27 12:14:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5966, '6294569947', 'INV', '2024-04-27', '102030000024', 'Customer debit For Invoice No -  1400 Customer Eman Electric', '8800.00', '0.00', '1', '1', '2024-04-27 12:14:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5967, '6294569947', 'INVOICE', '2024-04-27', '303', 'Sale Income For Invoice NO - 1400 Customer Eman Electric', '0.00', '8800.00', '1', '1', '2024-04-27 12:14:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5968, '5534821822', 'INV', '2024-04-27', '10107', 'Inventory credit For Invoice No1401', '0.00', '29801.00', '1', '1', '2024-04-27 12:18:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5969, '5534821822', 'INV', '2024-04-27', '102030000028', 'Customer debit For Invoice No -  1401 Customer M.K Electric', '7500.00', '0.00', '1', '1', '2024-04-27 12:18:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5970, '5534821822', 'INVOICE', '2024-04-27', '303', 'Sale Income For Invoice NO - 1401 Customer M.K Electric', '0.00', '7500.00', '1', '1', '2024-04-27 12:18:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5971, '1651433367', 'INV', '2024-04-27', '10107', 'Inventory credit For Invoice No1402', '0.00', '140560.00', '1', '1', '2024-04-27 12:23:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5972, '1651433367', 'INV', '2024-04-27', '102030000005', 'Customer debit For Invoice No -  1402 Customer H.M CABLES', '69550.00', '0.00', '1', '1', '2024-04-27 12:23:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5973, '1651433367', 'INVOICE', '2024-04-27', '303', 'Sale Income For Invoice NO - 1402 Customer H.M CABLES', '0.00', '69550.00', '1', '1', '2024-04-27 12:23:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5977, '20240425091617', 'Purchase', '2024-04-24', '10107', 'Inventory Devit Supplier Cash Item ', '11610.00', '0.00', '1', '1', '2024-04-27 12:30:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5978, '20240425091617', 'Purchase', '2024-04-24', '502000047', 'Supplier -Cash Item ', '0.00', '11610.00', '1', '1', '2024-04-27 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5979, '20240425091617', 'Purchase', '2024-04-24', '402', 'Company Credit For SupplierCash Item ', '11610.00', '0.00', '1', '1', '2024-04-27 12:30:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5980, '20240425091617', 'Purchase', '2024-04-24', '1020101', 'Cash in Hand For Supplier Cash Item ', '0.00', '0.00', '1', '1', '2024-04-27 12:30:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5981, '20240425091617', 'Purchase', '2024-04-24', '502000047', 'Supplier . Cash Item ', '0.00', '0.00', '1', '1', '2024-04-27 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5982, '3851685395', 'INV', '2024-04-27', '10107', 'Inventory credit For Invoice No1403', '0.00', '4376.00', '1', '1', '2024-04-27 12:31:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5983, '3851685395', 'INVOICE', '2024-04-27', '303', 'Sale Income From Invoice NO - 1403 Customer H.M CABLES', '0.00', '5120.00', '1', '1', '2024-04-27 12:31:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5984, '3851685395', 'INV', '2024-04-27', '102030000005', 'Customer debit For Invoice NO - 1403 customer-  H.M CABLES', '5120.00', '0.00', '1', '1', '2024-04-27 12:31:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5985, '6876312951', 'INV', '2024-04-27', '10107', 'Inventory credit For Invoice No1404', '0.00', '83000.00', '1', '1', '2024-04-27 12:36:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5986, '6876312951', 'INV', '2024-04-27', '102030000005', 'Customer debit For Invoice No -  1404 Customer H.M CABLES', '88000.00', '0.00', '1', '1', '2024-04-27 12:36:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (5987, '6876312951', 'INVOICE', '2024-04-27', '303', 'Sale Income For Invoice NO - 1404 Customer H.M CABLES', '0.00', '88000.00', '1', '1', '2024-04-27 12:36:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6009, '20240213163024', 'Purchase', '2024-01-01', '10107', 'Inventory Devit Supplier Paremount General', '11310.00', '0.00', '1', '1', '2024-04-28 09:10:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6010, '20240213163024', 'Purchase', '2024-01-01', '502000038', 'Supplier -Paremount General', '0.00', '11310.00', '1', '1', '2024-04-28 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6011, '20240213163024', 'Purchase', '2024-01-01', '402', 'Company Credit For SupplierParemount General', '11310.00', '0.00', '1', '1', '2024-04-28 09:10:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6012, '20240213163024', 'Purchase', '2024-01-01', '1020101', 'Cash in Hand For Supplier Paremount General', '0.00', '0.00', '1', '1', '2024-04-28 09:10:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6013, '20240213163024', 'Purchase', '2024-01-01', '502000038', 'Supplier . Paremount General', '0.00', '0.00', '1', '1', '2024-04-28 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6024, '5651135711', 'INV', '2024-04-28', '10107', 'Inventory credit For Invoice No1405', '0.00', '11396.30', '1', '1', '2024-04-28 09:18:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6025, '5651135711', 'INVOICE', '2024-04-28', '303', 'Sale Income From Invoice NO - 1405 Customer Walking Customer', '0.00', '22300.00', '1', '1', '2024-04-28 09:18:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6026, '5651135711', 'INV', '2024-04-28', '102030000002', 'Customer debit For Invoice NO - 1405 customer-  Walking Customer', '22300.00', '0.00', '1', '1', '2024-04-28 09:18:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6030, '20240425141147', 'Purchase', '2024-04-25', '10107', 'Inventory Devit Supplier Chilton Traders Karachi', '176391.00', '0.00', '1', '1', '2024-04-28 10:00:19', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6031, '20240425141147', 'Purchase', '2024-04-25', '502000032', 'Supplier -Chilton Traders Karachi', '0.00', '176391.00', '1', '1', '2024-04-28 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6032, '20240425141147', 'Purchase', '2024-04-25', '402', 'Company Credit For SupplierChilton Traders Karachi', '176391.00', '0.00', '1', '1', '2024-04-28 10:00:19', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6033, '20240425141147', 'Purchase', '2024-04-25', '1020101', 'Cash in Hand For Supplier Chilton Traders Karachi', '0.00', '0.00', '1', '1', '2024-04-28 10:00:19', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6034, '20240425141147', 'Purchase', '2024-04-25', '502000032', 'Supplier . Chilton Traders Karachi', '0.00', '0.00', '1', '1', '2024-04-28 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6038, '4883297114', 'INV', '2024-04-28', '10107', 'Inventory credit For Invoice No1310', '0.00', '351824.92', '1', '1', '2024-04-28 11:22:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6039, '4883297114', 'INVOICE', '2024-04-28', '303', 'Sale Income From Invoice NO - 1310 Customer Walking Customer', '0.00', '65255.00', '1', '1', '2024-04-28 11:22:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6040, '4883297114', 'INV', '2024-04-28', '102030000002', 'Customer debit For Invoice NO - 1310 customer-  Walking Customer', '65255.00', '0.00', '1', '1', '2024-04-28 11:22:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6050, '20240324160052', 'Purchase', '2024-03-24', '10107', 'Inventory Devit Supplier Royal Electri Karachi', '45780.00', '0.00', '1', '1', '2024-04-28 14:05:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6051, '20240324160052', 'Purchase', '2024-03-24', '502000041', 'Supplier -Royal Electri Karachi', '0.00', '45780.00', '1', '1', '2024-04-28 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6052, '20240324160052', 'Purchase', '2024-03-24', '402', 'Company Credit For SupplierRoyal Electri Karachi', '45780.00', '0.00', '1', '1', '2024-04-28 14:05:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6053, '20240324160052', 'Purchase', '2024-03-24', '1020101', 'Cash in Hand For Supplier Royal Electri Karachi', '0.00', '0.00', '1', '1', '2024-04-28 14:05:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6054, '20240324160052', 'Purchase', '2024-03-24', '502000041', 'Supplier . Royal Electri Karachi', '0.00', '0.00', '1', '1', '2024-04-28 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6055, '6185919946', 'INV', '2024-04-28', '10107', 'Inventory credit For Invoice No1406', '0.00', '8153.75', '1', '1', '2024-04-28 14:07:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6056, '6185919946', 'INVOICE', '2024-04-28', '303', 'Sale Income From Invoice NO - 1406 Customer Dawood Center Auto Bhan', '0.00', '7700.00', '1', '1', '2024-04-28 14:07:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6057, '6185919946', 'INV', '2024-04-28', '102030000042', 'Customer debit For Invoice NO - 1406 customer-  Dawood Center Auto Bhan', '7700.00', '0.00', '1', '1', '2024-04-28 14:07:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6058, '20240428134254', 'Purchase', '2024-04-28', '10107', 'Inventory Devit Supplier Cash Item ', '44340.00', '0.00', '1', '1', '2024-04-29 08:58:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6059, '20240428134254', 'Purchase', '2024-04-28', '502000047', 'Supplier -Cash Item ', '0.00', '44340.00', '1', '1', '2024-04-29 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6060, '20240428134254', 'Purchase', '2024-04-28', '402', 'Company Credit For SupplierCash Item ', '44340.00', '0.00', '1', '1', '2024-04-29 08:58:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6061, '20240428134254', 'Purchase', '2024-04-28', '1020101', 'Cash in Hand For Supplier Cash Item ', '0.00', '0.00', '1', '1', '2024-04-29 08:58:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6062, '20240428134254', 'Purchase', '2024-04-28', '502000047', 'Supplier . Cash Item ', '0.00', '0.00', '1', '1', '2024-04-29 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6063, '2243328791', 'INV', '2024-04-29', '10107', 'Inventory credit For Invoice No1309', '0.00', '89342.00', '1', '1', '2024-04-29 09:10:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6064, '2243328791', 'INVOICE', '2024-04-29', '303', 'Sale Income From Invoice NO - 1309 Customer Walking Customer', '0.00', '46600.00', '1', '1', '2024-04-29 09:10:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6065, '2243328791', 'INV', '2024-04-29', '102030000002', 'Customer debit For Invoice NO - 1309 customer-  Walking Customer', '46600.00', '0.00', '1', '1', '2024-04-29 09:10:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6066, '8398991967', 'INV', '2024-04-29', '10107', 'Inventory credit For Invoice No1287', '0.00', '29670.92', '1', '1', '2024-04-29 09:26:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6067, '8398991967', 'INVOICE', '2024-04-29', '303', 'Sale Income From Invoice NO - 1287 Customer Walking Customer', '0.00', '21800.00', '1', '1', '2024-04-29 09:26:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6068, '8398991967', 'INV', '2024-04-29', '102030000002', 'Customer debit For Invoice NO - 1287 customer-  Walking Customer', '21800.00', '0.00', '1', '1', '2024-04-29 09:26:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6084, '6351564964', 'INV', '2024-04-29', '10107', 'Inventory credit For Invoice No1286', '0.00', '5304.60', '1', '1', '2024-04-29 10:02:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6085, '6351564964', 'INVOICE', '2024-04-29', '303', 'Sale Income From Invoice NO - 1286 Customer Walking Customer', '0.00', '5040.00', '1', '1', '2024-04-29 10:02:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6086, '6351564964', 'INV', '2024-04-29', '102030000002', 'Customer debit For Invoice NO - 1286 customer-  Walking Customer', '5040.00', '0.00', '1', '1', '2024-04-29 10:02:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6087, '6667973681', 'INV', '2024-04-29', '10107', 'Inventory credit For Invoice No1263', '0.00', '150467.10', '1', '1', '2024-04-29 10:18:23', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6088, '6667973681', 'INVOICE', '2024-04-29', '303', 'Sale Income From Invoice NO - 1263 Customer Walking Customer', '0.00', '74380.00', '1', '1', '2024-04-29 10:18:23', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6089, '6667973681', 'INV', '2024-04-29', '102030000002', 'Customer debit For Invoice NO - 1263 customer-  Walking Customer', '74380.00', '0.00', '1', '1', '2024-04-29 10:18:23', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6113, '20240430093515', 'Purchase', '2024-04-29', '10107', 'Inventory Devit Supplier Zahid Soomro Kotri', '15800.00', '0.00', '1', '1', '2024-04-30 12:10:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6114, '20240430093515', 'Purchase', '2024-04-29', '502000043', 'Supplier -Zahid Soomro Kotri', '0.00', '15800.00', '1', '1', '2024-04-30 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6115, '20240430093515', 'Purchase', '2024-04-29', '402', 'Company Credit For SupplierZahid Soomro Kotri', '15800.00', '0.00', '1', '1', '2024-04-30 12:10:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6116, '20240430093515', 'Purchase', '2024-04-29', '1020101', 'Cash in Hand For Supplier Zahid Soomro Kotri', '0.00', '0.00', '1', '1', '2024-04-30 12:10:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6117, '20240430093515', 'Purchase', '2024-04-29', '502000043', 'Supplier . Zahid Soomro Kotri', '0.00', '0.00', '1', '1', '2024-04-30 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6118, '9947344679', 'INV', '2024-04-30', '10107', 'Inventory credit For Invoice No1407', '0.00', '42341.00', '1', '1', '2024-04-30 12:19:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6119, '9947344679', 'INV', '2024-04-30', '102030000017', 'Customer debit For Invoice No -  1407 Customer Deluxe Electric', '23550.00', '0.00', '1', '1', '2024-04-30 12:19:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6120, '9947344679', 'INVOICE', '2024-04-30', '303', 'Sale Income For Invoice NO - 1407 Customer Deluxe Electric', '0.00', '23550.00', '1', '1', '2024-04-30 12:19:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6121, '6352547424', 'INV', '2024-04-30', '10107', 'Inventory credit For Invoice No1408', '0.00', '17795.00', '1', '1', '2024-04-30 12:24:02', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6122, '6352547424', 'INV', '2024-04-30', '102030000017', 'Customer debit For Invoice No -  1408 Customer Deluxe Electric', '7370.00', '0.00', '1', '1', '2024-04-30 12:24:02', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6123, '6352547424', 'INVOICE', '2024-04-30', '303', 'Sale Income For Invoice NO - 1408 Customer Deluxe Electric', '0.00', '7370.00', '1', '1', '2024-04-30 12:24:02', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6124, '8958612741', 'INV', '2024-04-30', '10107', 'Inventory credit For Invoice No1409', '0.00', '21950.83', '1', '1', '2024-04-30 12:51:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6125, '8958612741', 'INV', '2024-04-30', '102030000005', 'Customer debit For Invoice No -  1409 Customer H.M CABLES', '22770.00', '0.00', '1', '1', '2024-04-30 12:51:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6126, '8958612741', 'INVOICE', '2024-04-30', '303', 'Sale Income For Invoice NO - 1409 Customer H.M CABLES', '0.00', '22770.00', '1', '1', '2024-04-30 12:51:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6127, '1292926993', 'INV', '2024-04-30', '10107', 'Inventory credit For Invoice No1410', '0.00', '60131.53', '1', '1', '2024-04-30 13:27:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6128, '1292926993', 'INV', '2024-04-30', '102030000002', 'Customer debit For Invoice No -  1410 Customer Walking Customer', '43330.00', '0.00', '1', '1', '2024-04-30 13:27:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6129, '1292926993', 'INVOICE', '2024-04-30', '303', 'Sale Income For Invoice NO - 1410 Customer Walking Customer', '0.00', '43330.00', '1', '1', '2024-04-30 13:27:59', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6130, '8221687361', 'INV', '2024-04-30', '10107', 'Inventory credit For Invoice No1411', '0.00', '63536.67', '1', '1', '2024-04-30 13:52:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6131, '8221687361', 'INV', '2024-04-30', '102030000002', 'Customer debit For Invoice No -  1411 Customer Walking Customer', '62850.00', '0.00', '1', '1', '2024-04-30 13:52:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6132, '8221687361', 'INVOICE', '2024-04-30', '303', 'Sale Income For Invoice NO - 1411 Customer Walking Customer', '0.00', '62850.00', '1', '1', '2024-04-30 13:52:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6133, '20240501090900', 'Purchase', '2024-04-30', '10107', 'Inventory Debit For Supplier M.K Electric Purchase', '3055.00', '0.00', '1', '1', '2024-05-01 09:09:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6134, '20240501090900', 'Purchase', '2024-04-30', '502000053', 'Supplier .M.K Electric Purchase', '0.00', '3055.00', '1', '1', '2024-05-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6135, '20240501090900', 'Purchase', '2024-04-30', '402', 'Company Credit For  M.K Electric Purchase', '3055.00', '0.00', '1', '1', '2024-05-01 09:09:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6136, '1459596594', 'INV', '2024-05-01', '10107', 'Inventory credit For Invoice No1412', '0.00', '91749.80', '1', '1', '2024-05-01 09:49:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6137, '1459596594', 'INV', '2024-05-01', '102030000017', 'Customer debit For Invoice No -  1412 Customer Deluxe Electric', '93600.00', '0.00', '1', '1', '2024-05-01 09:49:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6138, '1459596594', 'INVOICE', '2024-05-01', '303', 'Sale Income For Invoice NO - 1412 Customer Deluxe Electric', '0.00', '93600.00', '1', '1', '2024-05-01 09:49:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6139, '9727844627', 'INV', '2024-05-01', '10107', 'Inventory credit For Invoice No1413', '0.00', '12500.00', '1', '1', '2024-05-01 09:51:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6140, '9727844627', 'INV', '2024-05-01', '102030000042', 'Customer debit For Invoice No -  1413 Customer Dawood Center Auto Bhan', '17500.00', '0.00', '1', '1', '2024-05-01 09:51:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6141, '9727844627', 'INVOICE', '2024-05-01', '303', 'Sale Income For Invoice NO - 1413 Customer Dawood Center Auto Bhan', '0.00', '17500.00', '1', '1', '2024-05-01 09:51:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6142, '20240501122409', 'Purchase', '2024-05-01', '10107', 'Inventory Debit For Supplier Universal Karachi', '165000.00', '0.00', '1', '1', '2024-05-01 12:24:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6143, '20240501122409', 'Purchase', '2024-05-01', '502000061', 'Supplier .Universal Karachi', '0.00', '165000.00', '1', '1', '2024-05-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6144, '20240501122409', 'Purchase', '2024-05-01', '402', 'Company Credit For  Universal Karachi', '165000.00', '0.00', '1', '1', '2024-05-01 12:24:09', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6145, '20240501124216', 'Purchase', '2024-05-01', '10107', 'Inventory Debit For Supplier Sale Return ', '13550.00', '0.00', '1', '1', '2024-05-01 12:42:16', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6146, '20240501124216', 'Purchase', '2024-05-01', '502000054', 'Supplier .Sale Return ', '0.00', '13550.00', '1', '1', '2024-05-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6147, '20240501124216', 'Purchase', '2024-05-01', '402', 'Company Credit For  Sale Return ', '13550.00', '0.00', '1', '1', '2024-05-01 12:42:16', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6148, '20240501133112', 'Purchase', '2024-05-01', '10107', 'Inventory Debit For Supplier F Ali Iddress Karachi', '41350.00', '0.00', '1', '1', '2024-05-01 13:31:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6149, '20240501133112', 'Purchase', '2024-05-01', '502000049', 'Supplier .F Ali Iddress Karachi', '0.00', '41350.00', '1', '1', '2024-05-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6150, '20240501133112', 'Purchase', '2024-05-01', '402', 'Company Credit For  F Ali Iddress Karachi', '41350.00', '0.00', '1', '1', '2024-05-01 13:31:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6151, '20240501133131', 'Purchase', '2024-05-01', '10107', 'Inventory Debit For Supplier F Ali Iddress Karachi', '41340.00', '0.00', '1', '1', '2024-05-01 13:31:31', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6152, '20240501133131', 'Purchase', '2024-05-01', '502000049', 'Supplier .F Ali Iddress Karachi', '0.00', '41340.00', '1', '1', '2024-05-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6153, '20240501133131', 'Purchase', '2024-05-01', '402', 'Company Credit For  F Ali Iddress Karachi', '41340.00', '0.00', '1', '1', '2024-05-01 13:31:31', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6154, '20240306120253', 'Purchase', '2024-03-06', '10107', 'Inventory Devit Supplier Moin PVC Karachi', '49320.00', '0.00', '1', '1', '2024-05-01 13:32:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6155, '20240306120253', 'Purchase', '2024-03-06', '502000028', 'Supplier -Moin PVC Karachi', '0.00', '49320.00', '1', '1', '2024-05-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6156, '20240306120253', 'Purchase', '2024-03-06', '402', 'Company Credit For SupplierMoin PVC Karachi', '49320.00', '0.00', '1', '1', '2024-05-01 13:32:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6157, '20240306120253', 'Purchase', '2024-03-06', '1020101', 'Cash in Hand For Supplier Moin PVC Karachi', '0.00', '0.00', '1', '1', '2024-05-01 13:32:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6158, '20240306120253', 'Purchase', '2024-03-06', '502000028', 'Supplier . Moin PVC Karachi', '0.00', '0.00', '1', '1', '2024-05-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6159, '20240403122257', 'Purchase', '2024-04-03', '10107', 'Inventory Devit Supplier Moin PVC Karachi', '4840.00', '0.00', '1', '1', '2024-05-01 13:33:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6160, '20240403122257', 'Purchase', '2024-04-03', '502000028', 'Supplier -Moin PVC Karachi', '0.00', '4840.00', '1', '1', '2024-05-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6161, '20240403122257', 'Purchase', '2024-04-03', '402', 'Company Credit For SupplierMoin PVC Karachi', '4840.00', '0.00', '1', '1', '2024-05-01 13:33:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6162, '20240403122257', 'Purchase', '2024-04-03', '1020101', 'Cash in Hand For Supplier Moin PVC Karachi', '0.00', '0.00', '1', '1', '2024-05-01 13:33:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6163, '20240403122257', 'Purchase', '2024-04-03', '502000028', 'Supplier . Moin PVC Karachi', '0.00', '0.00', '1', '1', '2024-05-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6164, '20240501133724', 'Purchase', '2024-05-01', '10107', 'Inventory Debit For Supplier Moin PVC Karachi', '8400.00', '0.00', '1', '1', '2024-05-01 13:37:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6165, '20240501133724', 'Purchase', '2024-05-01', '502000028', 'Supplier .Moin PVC Karachi', '0.00', '8400.00', '1', '1', '2024-05-01 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6166, '20240501133724', 'Purchase', '2024-05-01', '402', 'Company Credit For  Moin PVC Karachi', '8400.00', '0.00', '1', '1', '2024-05-01 13:37:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6167, '20240502085246', 'Purchase', '2024-05-02', '10107', 'Inventory Debit For Supplier Haji salman Karachi', '20000.00', '0.00', '1', '1', '2024-05-02 08:52:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6168, '20240502085246', 'Purchase', '2024-05-02', '502000025', 'Supplier .Haji salman Karachi', '0.00', '20000.00', '1', '1', '2024-05-02 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6169, '20240502085246', 'Purchase', '2024-05-02', '402', 'Company Credit For  Haji salman Karachi', '20000.00', '0.00', '1', '1', '2024-05-02 08:52:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6170, '20240502085541', 'Purchase', '2024-05-02', '10107', 'Inventory Debit For Supplier Chilton Safan', '178500.00', '0.00', '1', '1', '2024-05-02 08:55:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6171, '20240502085541', 'Purchase', '2024-05-02', '502000009', 'Supplier .Chilton Safan', '0.00', '178500.00', '1', '1', '2024-05-02 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6172, '20240502085541', 'Purchase', '2024-05-02', '402', 'Company Credit For  Chilton Safan', '178500.00', '0.00', '1', '1', '2024-05-02 08:55:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6173, '9688352243', 'INV', '2024-05-02', '10107', 'Inventory credit For Invoice No1414', '0.00', '471900.00', '1', '1', '2024-05-02 09:18:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6174, '9688352243', 'INV', '2024-05-02', '102030000016', 'Customer debit For Invoice No -  1414 Customer Abdul Qadir Electric ', '192700.00', '0.00', '1', '1', '2024-05-02 09:18:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6175, '9688352243', 'INVOICE', '2024-05-02', '303', 'Sale Income For Invoice NO - 1414 Customer Abdul Qadir Electric ', '0.00', '192700.00', '1', '1', '2024-05-02 09:18:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6176, '9912837861', 'INV', '2024-05-02', '10107', 'Inventory credit For Invoice No1415', '0.00', '128812.00', '1', '1', '2024-05-02 09:24:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6177, '9912837861', 'INV', '2024-05-02', '102030000026', 'Customer debit For Invoice No -  1415 Customer Memon Light  ', '133892.00', '0.00', '1', '1', '2024-05-02 09:24:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6178, '9912837861', 'INVOICE', '2024-05-02', '303', 'Sale Income For Invoice NO - 1415 Customer Memon Light  ', '0.00', '133892.00', '1', '1', '2024-05-02 09:24:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6185, '20240502095310', 'Purchase', '2024-05-02', '10107', 'Inventory Debit For Supplier Universal Karachi', '9820.00', '0.00', '1', '1', '2024-05-02 09:53:10', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6186, '20240502095310', 'Purchase', '2024-05-02', '502000061', 'Supplier .Universal Karachi', '0.00', '9820.00', '1', '1', '2024-05-02 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6187, '20240502095310', 'Purchase', '2024-05-02', '402', 'Company Credit For  Universal Karachi', '9820.00', '0.00', '1', '1', '2024-05-02 09:53:10', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6191, '9152678989', 'INV', '2024-05-02', '10107', 'Inventory credit For Invoice No1418', '0.00', '506646.00', '1', '1', '2024-05-02 11:02:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6192, '9152678989', 'INV', '2024-05-02', '102030000002', 'Customer debit For Invoice No -  1418 Customer Walking Customer', '38350.00', '0.00', '1', '1', '2024-05-02 11:02:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6193, '9152678989', 'INVOICE', '2024-05-02', '303', 'Sale Income For Invoice NO - 1418 Customer Walking Customer', '0.00', '38350.00', '1', '1', '2024-05-02 11:02:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6197, '20240502121023', 'Purchase', '2024-05-02', '10107', 'Inventory Debit For Supplier Fawad Wire', '47420.00', '0.00', '1', '1', '2024-05-02 12:10:23', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6198, '20240502121023', 'Purchase', '2024-05-02', '502000034', 'Supplier .Fawad Wire', '0.00', '47420.00', '1', '1', '2024-05-02 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6199, '20240502121023', 'Purchase', '2024-05-02', '402', 'Company Credit For  Fawad Wire', '47420.00', '0.00', '1', '1', '2024-05-02 12:10:23', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6203, '5213434265', 'INV', '2024-05-02', '10107', 'Inventory credit For Invoice No1416', '0.00', '208623.67', '1', '1', '2024-05-02 13:08:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6204, '5213434265', 'INVOICE', '2024-05-02', '303', 'Sale Income From Invoice NO - 1416 Customer Saffan Chilton ', '0.00', '176707.00', '1', '1', '2024-05-02 13:08:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6205, '5213434265', 'INV', '2024-05-02', '102030000031', 'Customer debit For Invoice NO - 1416 customer-  Saffan Chilton ', '176707.00', '0.00', '1', '1', '2024-05-02 13:08:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6206, '6341328237', 'INV', '2024-05-02', '10107', 'Inventory credit For Invoice No1420', '0.00', '70132.00', '1', '1', '2024-05-02 13:11:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6207, '6341328237', 'INV', '2024-05-02', '102030000054', 'Customer debit For Invoice No -  1420 Customer Mamu Jee', '72000.00', '0.00', '1', '1', '2024-05-02 13:11:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6208, '6341328237', 'INVOICE', '2024-05-02', '303', 'Sale Income For Invoice NO - 1420 Customer Mamu Jee', '0.00', '72000.00', '1', '1', '2024-05-02 13:11:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6209, '1521546399', 'INV', '2024-05-02', '10107', 'Inventory credit For Invoice No1421', '0.00', '367269.10', '1', '1', '2024-05-02 13:21:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6210, '1521546399', 'INV', '2024-05-02', '102030000017', 'Customer debit For Invoice No -  1421 Customer Deluxe Electric', '331500.00', '0.00', '1', '1', '2024-05-02 13:21:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6211, '1521546399', 'INVOICE', '2024-05-02', '303', 'Sale Income For Invoice NO - 1421 Customer Deluxe Electric', '0.00', '331500.00', '1', '1', '2024-05-02 13:21:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6222, '20240502125329', 'Purchase', '2024-05-02', '10107', 'Inventory Devit Supplier Fareed Qasim', '3704075.00', '0.00', '1', '1', '2024-05-02 14:08:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6223, '20240502125329', 'Purchase', '2024-05-02', '502000022', 'Supplier -Fareed Qasim', '0.00', '3704075.00', '1', '1', '2024-05-02 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6224, '20240502125329', 'Purchase', '2024-05-02', '402', 'Company Credit For SupplierFareed Qasim', '3704075.00', '0.00', '1', '1', '2024-05-02 14:08:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6225, '20240502125329', 'Purchase', '2024-05-02', '1020101', 'Cash in Hand For Supplier Fareed Qasim', '0.00', '0.00', '1', '1', '2024-05-02 14:08:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6226, '20240502125329', 'Purchase', '2024-05-02', '502000022', 'Supplier . Fareed Qasim', '0.00', '0.00', '1', '1', '2024-05-02 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6236, '20240326154749', 'Purchase', '2024-03-26', '10107', 'Inventory Devit Supplier Delux Electric Purchase ', '62100.00', '0.00', '1', '1', '2024-05-04 13:19:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6237, '20240326154749', 'Purchase', '2024-03-26', '502000051', 'Supplier -Delux Electric Purchase ', '0.00', '62100.00', '1', '1', '2024-05-04 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6238, '20240326154749', 'Purchase', '2024-03-26', '402', 'Company Credit For SupplierDelux Electric Purchase ', '62100.00', '0.00', '1', '1', '2024-05-04 13:19:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6239, '20240326154749', 'Purchase', '2024-03-26', '1020101', 'Cash in Hand For Supplier Delux Electric Purchase ', '0.00', '0.00', '1', '1', '2024-05-04 13:19:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6240, '20240326154749', 'Purchase', '2024-03-26', '502000051', 'Supplier . Delux Electric Purchase ', '0.00', '0.00', '1', '1', '2024-05-04 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6241, '9695696422', 'INV', '2024-05-04', '10107', 'Inventory credit For Invoice No1422', '0.00', '22042.13', '1', '1', '2024-05-04 13:29:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6242, '9695696422', 'INVOICE', '2024-05-04', '303', 'Sale Income From Invoice NO - 1422 Customer Walking Customer', '0.00', '19400.00', '1', '1', '2024-05-04 13:29:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6243, '9695696422', 'INV', '2024-05-04', '102030000002', 'Customer debit For Invoice NO - 1422 customer-  Walking Customer', '19400.00', '0.00', '1', '1', '2024-05-04 13:29:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6244, '20240504134344', 'Purchase', '2024-05-04', '10107', 'Inventory Debit For Supplier Zahid Soomro Kotri', '1500.00', '0.00', '1', '1', '2024-05-04 13:43:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6245, '20240504134344', 'Purchase', '2024-05-04', '502000043', 'Supplier .Zahid Soomro Kotri', '0.00', '1500.00', '1', '1', '2024-05-04 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6246, '20240504134344', 'Purchase', '2024-05-04', '402', 'Company Credit For  Zahid Soomro Kotri', '1500.00', '0.00', '1', '1', '2024-05-04 13:43:44', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6247, '8717124365', 'INV', '2024-05-04', '10107', 'Inventory credit For Invoice No1423', '0.00', '1500.00', '1', '1', '2024-05-04 13:51:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6248, '8717124365', 'INV', '2024-05-04', '102030000005', 'Customer debit For Invoice No -  1423 Customer H.M CABLES', '1800.00', '0.00', '1', '1', '2024-05-04 13:51:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6249, '8717124365', 'INVOICE', '2024-05-04', '303', 'Sale Income For Invoice NO - 1423 Customer H.M CABLES', '0.00', '1800.00', '1', '1', '2024-05-04 13:51:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6253, '20240415104929', 'Purchase', '2024-04-15', '10107', 'Inventory Devit Supplier Delux Electric Purchase ', '41856.00', '0.00', '1', '1', '2024-05-05 10:54:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6254, '20240415104929', 'Purchase', '2024-04-15', '502000051', 'Supplier -Delux Electric Purchase ', '0.00', '41856.00', '1', '1', '2024-05-05 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6255, '20240415104929', 'Purchase', '2024-04-15', '402', 'Company Credit For SupplierDelux Electric Purchase ', '41856.00', '0.00', '1', '1', '2024-05-05 10:54:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6256, '20240415104929', 'Purchase', '2024-04-15', '1020101', 'Cash in Hand For Supplier Delux Electric Purchase ', '0.00', '0.00', '1', '1', '2024-05-05 10:54:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6257, '20240415104929', 'Purchase', '2024-04-15', '502000051', 'Supplier . Delux Electric Purchase ', '0.00', '0.00', '1', '1', '2024-05-05 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6264, '20240505121803', 'Purchase', '2024-05-05', '10107', 'Inventory Debit For Supplier Olympic Sargodah', '102244.00', '0.00', '1', '1', '2024-05-05 12:18:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6265, '20240505121803', 'Purchase', '2024-05-05', '502000011', 'Supplier .Olympic Sargodah', '0.00', '102244.00', '1', '1', '2024-05-05 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6266, '20240505121803', 'Purchase', '2024-05-05', '402', 'Company Credit For  Olympic Sargodah', '102244.00', '0.00', '1', '1', '2024-05-05 12:18:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6301, '5482914316', 'INV', '2024-05-05', '10107', 'Inventory credit For Invoice No1427', '0.00', '20983.39', '1', '1', '2024-05-05 16:01:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6302, '5482914316', 'INV', '2024-05-05', '102030000002', 'Customer debit For Invoice No -  1427 Customer Walking Customer', '17540.00', '0.00', '1', '1', '2024-05-05 16:01:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6303, '5482914316', 'INVOICE', '2024-05-05', '303', 'Sale Income For Invoice NO - 1427 Customer Walking Customer', '0.00', '17540.00', '1', '1', '2024-05-05 16:01:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6304, '20240201155743', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier G.One LED Light', '204765.00', '0.00', '1', '1', '2024-05-06 10:34:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6305, '20240201155743', 'Purchase', '2023-12-31', '502000027', 'Supplier -G.One LED Light', '0.00', '204765.00', '1', '1', '2024-05-06 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6306, '20240201155743', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierG.One LED Light', '204765.00', '0.00', '1', '1', '2024-05-06 10:34:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6307, '20240201155743', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier G.One LED Light', '0.00', '0.00', '1', '1', '2024-05-06 10:34:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6308, '20240201155743', 'Purchase', '2023-12-31', '502000027', 'Supplier . G.One LED Light', '0.00', '0.00', '1', '1', '2024-05-06 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6312, '20240506104755', 'Purchase', '2024-05-06', '10107', 'Inventory Debit For Supplier Emaan Light House', '1544.00', '0.00', '1', '1', '2024-05-06 10:47:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6313, '20240506104755', 'Purchase', '2024-05-06', '502000031', 'Supplier .Emaan Light House', '0.00', '1544.00', '1', '1', '2024-05-06 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6314, '20240506104755', 'Purchase', '2024-05-06', '402', 'Company Credit For  Emaan Light House', '1544.00', '0.00', '1', '1', '2024-05-06 10:47:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6315, '20240506104201', 'Purchase', '2024-05-06', '10107', 'Inventory Devit Supplier G.One LED Light', '126150.00', '0.00', '1', '1', '2024-05-06 10:56:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6316, '20240506104201', 'Purchase', '2024-05-06', '502000027', 'Supplier -G.One LED Light', '0.00', '126150.00', '1', '1', '2024-05-06 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6317, '20240506104201', 'Purchase', '2024-05-06', '402', 'Company Credit For SupplierG.One LED Light', '126150.00', '0.00', '1', '1', '2024-05-06 10:56:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6318, '20240506104201', 'Purchase', '2024-05-06', '1020101', 'Cash in Hand For Supplier G.One LED Light', '0.00', '0.00', '1', '1', '2024-05-06 10:56:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6319, '20240506104201', 'Purchase', '2024-05-06', '502000027', 'Supplier . G.One LED Light', '0.00', '0.00', '1', '1', '2024-05-06 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6320, '5736277861', 'INV', '2024-05-06', '10107', 'Inventory credit For Invoice No1419', '0.00', '133606.86', '1', '1', '2024-05-06 11:05:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6321, '5736277861', 'INVOICE', '2024-05-06', '303', 'Sale Income From Invoice NO - 1419 Customer Walking Customer', '0.00', '41485.00', '1', '1', '2024-05-06 11:05:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6322, '5736277861', 'INV', '2024-05-06', '102030000002', 'Customer debit For Invoice NO - 1419 customer-  Walking Customer', '41485.00', '0.00', '1', '1', '2024-05-06 11:05:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6329, '9859657466', 'INV', '2024-05-06', '10107', 'Inventory credit For Invoice No1428', '0.00', '52025.88', '1', '1', '2024-05-06 11:40:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6330, '9859657466', 'INV', '2024-05-06', '102030000002', 'Customer debit For Invoice No -  1428 Customer Walking Customer', '46350.00', '0.00', '1', '1', '2024-05-06 11:40:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6331, '9859657466', 'INVOICE', '2024-05-06', '303', 'Sale Income For Invoice NO - 1428 Customer Walking Customer', '0.00', '46350.00', '1', '1', '2024-05-06 11:40:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6335, '20240403120907', 'Purchase', '2024-04-01', '10107', 'Inventory Devit Supplier Fawad Wire', '42600.00', '0.00', '1', '1', '2024-05-06 12:13:15', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6336, '20240403120907', 'Purchase', '2024-04-01', '502000034', 'Supplier -Fawad Wire', '0.00', '42600.00', '1', '1', '2024-05-06 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6337, '20240403120907', 'Purchase', '2024-04-01', '402', 'Company Credit For SupplierFawad Wire', '42600.00', '0.00', '1', '1', '2024-05-06 12:13:15', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6338, '20240403120907', 'Purchase', '2024-04-01', '1020101', 'Cash in Hand For Supplier Fawad Wire', '0.00', '0.00', '1', '1', '2024-05-06 12:13:15', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6339, '20240403120907', 'Purchase', '2024-04-01', '502000034', 'Supplier . Fawad Wire', '0.00', '0.00', '1', '1', '2024-05-06 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6340, '9266641739', 'INV', '2024-05-06', '10107', 'Inventory credit For Invoice No1429', '0.00', '393181.00', '1', '1', '2024-05-06 12:15:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6341, '9266641739', 'INVOICE', '2024-05-06', '303', 'Sale Income From Invoice NO - 1429 Customer Sattar Mallah Electric', '0.00', '89000.00', '1', '1', '2024-05-06 12:15:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6342, '9266641739', 'INV', '2024-05-06', '102030000022', 'Customer debit For Invoice NO - 1429 customer-  Sattar Mallah Electric', '89000.00', '0.00', '1', '1', '2024-05-06 12:15:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6374, '20240505121954', 'Purchase', '2024-05-05', '10107', 'Inventory Devit Supplier Cash Item ', '11740.00', '0.00', '1', '1', '2024-05-07 08:38:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6375, '20240505121954', 'Purchase', '2024-05-05', '502000047', 'Supplier -Cash Item ', '0.00', '11740.00', '1', '1', '2024-05-07 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6376, '20240505121954', 'Purchase', '2024-05-05', '402', 'Company Credit For SupplierCash Item ', '11740.00', '0.00', '1', '1', '2024-05-07 08:38:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6377, '20240505121954', 'Purchase', '2024-05-05', '1020101', 'Cash in Hand For Supplier Cash Item ', '0.00', '0.00', '1', '1', '2024-05-07 08:38:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6378, '20240505121954', 'Purchase', '2024-05-05', '502000047', 'Supplier . Cash Item ', '0.00', '0.00', '1', '1', '2024-05-07 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6379, '20240505110122', 'Purchase', '2024-05-05', '10107', 'Inventory Devit Supplier Delux Electric Purchase ', '187498.00', '0.00', '1', '1', '2024-05-07 09:29:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6380, '20240505110122', 'Purchase', '2024-05-05', '502000051', 'Supplier -Delux Electric Purchase ', '0.00', '187498.00', '1', '1', '2024-05-07 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6381, '20240505110122', 'Purchase', '2024-05-05', '402', 'Company Credit For SupplierDelux Electric Purchase ', '187498.00', '0.00', '1', '1', '2024-05-07 09:29:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6382, '20240505110122', 'Purchase', '2024-05-05', '1020101', 'Cash in Hand For Supplier Delux Electric Purchase ', '0.00', '0.00', '1', '1', '2024-05-07 09:29:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6383, '20240505110122', 'Purchase', '2024-05-05', '502000051', 'Supplier . Delux Electric Purchase ', '0.00', '0.00', '1', '1', '2024-05-07 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6384, '1547115985', 'INV', '2024-05-07', '10107', 'Inventory credit For Invoice No1417', '0.00', '7021.00', '1', '1', '2024-05-07 09:32:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6385, '1547115985', 'INVOICE', '2024-05-07', '303', 'Sale Income From Invoice NO - 1417 Customer Dawood Super Mart', '0.00', '7720.00', '1', '1', '2024-05-07 09:32:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6386, '1547115985', 'INV', '2024-05-07', '102030000052', 'Customer debit For Invoice NO - 1417 customer-  Dawood Super Mart', '7720.00', '0.00', '1', '1', '2024-05-07 09:32:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6387, '5866451357', 'INV', '2024-05-07', '10107', 'Inventory credit For Invoice No1430', '0.00', '307038.10', '1', '1', '2024-05-07 09:41:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6388, '5866451357', 'INVOICE', '2024-05-07', '303', 'Sale Income From Invoice NO - 1430 Customer Deluxe Electric', '0.00', '41180.00', '1', '1', '2024-05-07 09:41:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6389, '5866451357', 'INV', '2024-05-07', '102030000017', 'Customer debit For Invoice NO - 1430 customer-  Deluxe Electric', '41180.00', '0.00', '1', '1', '2024-05-07 09:41:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6390, '9277318726', 'INV', '2024-05-07', '10107', 'Inventory credit For Invoice No1431', '0.00', '2990.00', '1', '1', '2024-05-07 09:52:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6391, '9277318726', 'INVOICE', '2024-05-07', '303', 'Sale Income From Invoice NO - 1431 Customer Memon Light  ', '0.00', '-670337.00', '1', '1', '2024-05-07 09:52:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6392, '9277318726', 'INV', '2024-05-07', '102030000026', 'Customer debit For Invoice NO - 1431 customer-  Memon Light  ', '3100.00', '0.00', '1', '1', '2024-05-07 09:52:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6393, '8199273583', 'INV', '2024-05-07', '10107', 'Inventory credit For Invoice No1432', '0.00', '2938.10', '1', '1', '2024-05-07 09:58:01', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6394, '8199273583', 'INV', '2024-05-07', '102030000055', 'Customer debit For Invoice No -  1432 Customer S.E Light', '3000.00', '0.00', '1', '1', '2024-05-07 09:58:01', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6395, '8199273583', 'INVOICE', '2024-05-07', '303', 'Sale Income For Invoice NO - 1432 Customer S.E Light', '0.00', '3000.00', '1', '1', '2024-05-07 09:58:01', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6396, '3293275968', 'INV', '2024-05-07', '10107', 'Inventory credit For Invoice No1433', '0.00', '1341790.00', '1', '1', '2024-05-07 10:03:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6397, '3293275968', 'INV', '2024-05-07', '102030000042', 'Customer debit For Invoice No -  1433 Customer Dawood Center Auto Bhan', '112600.00', '0.00', '1', '1', '2024-05-07 10:03:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6398, '3293275968', 'INVOICE', '2024-05-07', '303', 'Sale Income For Invoice NO - 1433 Customer Dawood Center Auto Bhan', '0.00', '112600.00', '1', '1', '2024-05-07 10:03:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6399, '2926266512', 'INV', '2024-05-07', '10107', 'Inventory credit For Invoice No1376', '0.00', '0.00', '1', '1', '2024-05-07 10:13:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6400, '2926266512', 'INVOICE', '2024-05-07', '303', 'Sale Income From Invoice NO - 1376 Customer Arif Electriction ', '0.00', '0.00', '1', '1', '2024-05-07 10:13:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6401, '2926266512', 'INV', '2024-05-07', '102030000050', 'Customer debit For Invoice NO - 1376 customer-  Arif Electriction ', '0.00', '0.00', '1', '1', '2024-05-07 10:13:58', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6402, '20240507103746', 'Purchase', '2024-05-06', '10107', 'Inventory Debit For Supplier Chilton Traders Karachi', '70132.00', '0.00', '1', '1', '2024-05-07 10:37:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6403, '20240507103746', 'Purchase', '2024-05-06', '502000032', 'Supplier .Chilton Traders Karachi', '0.00', '70132.00', '1', '1', '2024-05-07 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6404, '20240507103746', 'Purchase', '2024-05-06', '402', 'Company Credit For  Chilton Traders Karachi', '70132.00', '0.00', '1', '1', '2024-05-07 10:37:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6405, '6727268952', 'INV', '2024-05-08', '10107', 'Inventory credit For Invoice No1434', '0.00', '107345.33', '1', '1', '2024-05-08 09:24:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6406, '6727268952', 'INV', '2024-05-08', '102030000014', 'Customer debit For Invoice No -  1434 Customer Ashfaq Electric ', '121600.00', '0.00', '1', '1', '2024-05-08 09:24:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6407, '6727268952', 'INVOICE', '2024-05-08', '303', 'Sale Income For Invoice NO - 1434 Customer Ashfaq Electric ', '0.00', '121600.00', '1', '1', '2024-05-08 09:24:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6408, '9192112764', 'INV', '2024-05-08', '10107', 'Inventory credit For Invoice No1435', '0.00', '35066.00', '1', '1', '2024-05-08 09:25:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6409, '9192112764', 'INV', '2024-05-08', '102030000054', 'Customer debit For Invoice No -  1435 Customer Mamu Jee', '36000.00', '0.00', '1', '1', '2024-05-08 09:25:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6410, '9192112764', 'INVOICE', '2024-05-08', '303', 'Sale Income For Invoice NO - 1435 Customer Mamu Jee', '0.00', '36000.00', '1', '1', '2024-05-08 09:25:14', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6411, '20240508110100', 'Purchase', '2024-05-08', '10107', 'Inventory Debit For Supplier Universal Karachi', '181500.00', '0.00', '1', '1', '2024-05-08 11:01:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6412, '20240508110100', 'Purchase', '2024-05-08', '502000061', 'Supplier .Universal Karachi', '0.00', '181500.00', '1', '1', '2024-05-08 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6413, '20240508110100', 'Purchase', '2024-05-08', '402', 'Company Credit For  Universal Karachi', '181500.00', '0.00', '1', '1', '2024-05-08 11:01:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6417, '20240204162308', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier Arfeen Wire (Million)', '1686807.00', '0.00', '1', '1', '2024-05-08 12:14:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6418, '20240204162308', 'Purchase', '2023-12-31', '502000029', 'Supplier -Arfeen Wire (Million)', '0.00', '1686807.00', '1', '1', '2024-05-08 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6419, '20240204162308', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierArfeen Wire (Million)', '1686807.00', '0.00', '1', '1', '2024-05-08 12:14:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6420, '20240204162308', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier Arfeen Wire (Million)', '0.00', '0.00', '1', '1', '2024-05-08 12:14:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6421, '20240204162308', 'Purchase', '2023-12-31', '502000029', 'Supplier . Arfeen Wire (Million)', '0.00', '0.00', '1', '1', '2024-05-08 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6427, '20240427104625', 'Purchase', '2024-04-27', '10107', 'Inventory Devit Supplier M.K Electric Purchase', '0.00', '0.00', '1', '1', '2024-05-08 13:01:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6428, '20240427104625', 'Purchase', '2024-04-27', '502000053', 'Supplier -M.K Electric Purchase', '0.00', '0.00', '1', '1', '2024-05-08 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6429, '20240427104625', 'Purchase', '2024-04-27', '402', 'Company Credit For SupplierM.K Electric Purchase', '0.00', '0.00', '1', '1', '2024-05-08 13:01:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6430, '20240427104625', 'Purchase', '2024-04-27', '1020101', 'Cash in Hand For Supplier M.K Electric Purchase', '0.00', '0.00', '1', '1', '2024-05-08 13:01:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6431, '20240427104625', 'Purchase', '2024-04-27', '502000053', 'Supplier . M.K Electric Purchase', '0.00', '0.00', '1', '1', '2024-05-08 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6455, '9512576366', 'INV', '2024-05-08', '10107', 'Inventory credit For Invoice No1436', '0.00', '6623.06', '1', '1', '2024-05-08 13:48:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6456, '9512576366', 'INVOICE', '2024-05-08', '303', 'Sale Income From Invoice NO - 1436 Customer Walking Customer', '0.00', '3850.00', '1', '1', '2024-05-08 13:48:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6457, '9512576366', 'INV', '2024-05-08', '102030000002', 'Customer debit For Invoice NO - 1436 customer-  Walking Customer', '3850.00', '0.00', '1', '1', '2024-05-08 13:48:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6472, '20240229132112', 'Purchase', '2024-02-01', '10107', 'Inventory Devit Supplier Moin PVC Karachi', '11040.00', '0.00', '1', '1', '2024-05-09 09:29:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6473, '20240229132112', 'Purchase', '2024-02-01', '502000028', 'Supplier -Moin PVC Karachi', '0.00', '11040.00', '1', '1', '2024-05-09 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6474, '20240229132112', 'Purchase', '2024-02-01', '402', 'Company Credit For SupplierMoin PVC Karachi', '11040.00', '0.00', '1', '1', '2024-05-09 09:29:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6475, '20240229132112', 'Purchase', '2024-02-01', '1020101', 'Cash in Hand For Supplier Moin PVC Karachi', '0.00', '0.00', '1', '1', '2024-05-09 09:29:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6476, '20240229132112', 'Purchase', '2024-02-01', '502000028', 'Supplier . Moin PVC Karachi', '0.00', '0.00', '1', '1', '2024-05-09 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6495, '3942454311', 'INV', '2024-05-09', '10107', 'Inventory credit For Invoice No1437', '0.00', '170463.08', '1', '1', '2024-05-09 10:30:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6496, '3942454311', 'INVOICE', '2024-05-09', '303', 'Sale Income From Invoice NO - 1437 Customer Walking Customer', '0.00', '51813.00', '1', '1', '2024-05-09 10:30:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6497, '3942454311', 'INV', '2024-05-09', '102030000002', 'Customer debit For Invoice NO - 1437 customer-  Walking Customer', '51813.00', '0.00', '1', '1', '2024-05-09 10:30:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6502, '20240509085309', 'Purchase', '2024-05-09', '10107', 'Inventory Devit Supplier Chilton Traders Karachi', '39552.00', '0.00', '1', '1', '2024-05-09 15:07:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6503, '20240509085309', 'Purchase', '2024-05-09', '502000032', 'Supplier -Chilton Traders Karachi', '0.00', '39552.00', '1', '1', '2024-05-09 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6504, '20240509085309', 'Purchase', '2024-05-09', '402', 'Company Credit For SupplierChilton Traders Karachi', '39552.00', '0.00', '1', '1', '2024-05-09 15:07:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6505, '20240509085309', 'Purchase', '2024-05-09', '1020101', 'Cash in Hand For Supplier Chilton Traders Karachi', '0.00', '0.00', '1', '1', '2024-05-09 15:07:12', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6506, '20240509085309', 'Purchase', '2024-05-09', '502000032', 'Supplier . Chilton Traders Karachi', '0.00', '0.00', '1', '1', '2024-05-09 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6507, '1187151677', 'INV', '2024-05-09', '10107', 'Inventory credit For Invoice No1438', '0.00', '1920.00', '1', '1', '2024-05-09 15:13:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6508, '1187151677', 'INV', '2024-05-09', '102030000011', 'Customer debit For Invoice No -  1438 Customer M.D.M Mill', '4200.00', '0.00', '1', '1', '2024-05-09 15:13:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6509, '1187151677', 'INVOICE', '2024-05-09', '303', 'Sale Income For Invoice NO - 1438 Customer M.D.M Mill', '0.00', '4200.00', '1', '1', '2024-05-09 15:13:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6510, '7938173624', 'INV', '2024-05-09', '10107', 'Inventory credit For Invoice No1439', '0.00', '77330.00', '1', '1', '2024-05-09 15:28:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6511, '7938173624', 'INV', '2024-05-09', '102030000011', 'Customer debit For Invoice No -  1439 Customer M.D.M Mill', '51570.00', '0.00', '1', '1', '2024-05-09 15:28:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6512, '7938173624', 'INVOICE', '2024-05-09', '303', 'Sale Income For Invoice NO - 1439 Customer M.D.M Mill', '0.00', '51570.00', '1', '1', '2024-05-09 15:28:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6518, NULL, 'INV', '2024-05-09', '10107', 'Inventory credit For Invoice No', '0.00', '0.00', '1', '1', '2024-05-09 15:52:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6519, NULL, 'INVOICE', '2024-05-09', '303', 'Sale Income From Invoice NO -  Customer ', '0.00', '0.00', '1', '1', '2024-05-09 15:52:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6523, '2415214152', 'INV', '2024-05-09', '10107', 'Inventory credit For Invoice No1441', '0.00', '317948.60', '1', '1', '2024-05-09 16:04:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6524, '2415214152', 'INV', '2024-05-09', '102030000016', 'Customer debit For Invoice No -  1441 Customer Abdul Qadir Electric ', '333000.00', '0.00', '1', '1', '2024-05-09 16:04:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6525, '2415214152', 'INVOICE', '2024-05-09', '303', 'Sale Income For Invoice NO - 1441 Customer Abdul Qadir Electric ', '0.00', '333000.00', '1', '1', '2024-05-09 16:04:53', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6529, '20240511090102', 'Purchase', '2024-05-09', '10107', 'Inventory Devit Supplier Abdul Qadir Purchase ', '41000.00', '0.00', '1', '1', '2024-05-11 09:07:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6530, '20240511090102', 'Purchase', '2024-05-09', '502000056', 'Supplier -Abdul Qadir Purchase ', '0.00', '41000.00', '1', '1', '2024-05-11 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6531, '20240511090102', 'Purchase', '2024-05-09', '402', 'Company Credit For SupplierAbdul Qadir Purchase ', '41000.00', '0.00', '1', '1', '2024-05-11 09:07:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6532, '20240511090102', 'Purchase', '2024-05-09', '1020101', 'Cash in Hand For Supplier Abdul Qadir Purchase ', '0.00', '0.00', '1', '1', '2024-05-11 09:07:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6533, '20240511090102', 'Purchase', '2024-05-09', '502000056', 'Supplier . Abdul Qadir Purchase ', '0.00', '0.00', '1', '1', '2024-05-11 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6534, '20240511091033', 'Purchase', '2024-05-11', '10107', 'Inventory Debit For Supplier Chilton Traders Karachi', '72641.00', '0.00', '1', '1', '2024-05-11 09:10:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6535, '20240511091033', 'Purchase', '2024-05-11', '502000032', 'Supplier .Chilton Traders Karachi', '0.00', '72641.00', '1', '1', '2024-05-11 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6536, '20240511091033', 'Purchase', '2024-05-11', '402', 'Company Credit For  Chilton Traders Karachi', '72641.00', '0.00', '1', '1', '2024-05-11 09:10:33', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6537, '2515197159', 'INV', '2024-05-11', '10107', 'Inventory credit For Invoice No1442', '0.00', '19765.61', '1', '1', '2024-05-11 09:57:22', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6538, '2515197159', 'INV', '2024-05-11', '102030000002', 'Customer debit For Invoice No -  1442 Customer Walking Customer', '55590.00', '0.00', '1', '1', '2024-05-11 09:57:22', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6539, '2515197159', 'INVOICE', '2024-05-11', '303', 'Sale Income For Invoice NO - 1442 Customer Walking Customer', '0.00', '55590.00', '1', '1', '2024-05-11 09:57:22', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6540, '5942324735', 'INV', '2024-05-11', '10107', 'Inventory credit For Invoice No1443', '0.00', '427630.44', '1', '1', '2024-05-11 12:17:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6541, '5942324735', 'INV', '2024-05-11', '102030000002', 'Customer debit For Invoice No -  1443 Customer Walking Customer', '143190.00', '0.00', '1', '1', '2024-05-11 12:17:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6542, '5942324735', 'INVOICE', '2024-05-11', '303', 'Sale Income For Invoice NO - 1443 Customer Walking Customer', '0.00', '143190.00', '1', '1', '2024-05-11 12:17:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6543, '6973986361', 'INV', '2024-05-11', '10107', 'Inventory credit For Invoice No1444', '0.00', '986.00', '1', '1', '2024-05-11 13:56:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6544, '6973986361', 'INV', '2024-05-11', '102030000054', 'Customer debit For Invoice No -  1444 Customer Mamu Jee', '1000.00', '0.00', '1', '1', '2024-05-11 13:56:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6545, '6973986361', 'INVOICE', '2024-05-11', '303', 'Sale Income For Invoice NO - 1444 Customer Mamu Jee', '0.00', '1000.00', '1', '1', '2024-05-11 13:56:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6546, '20240415103944', 'Purchase', '2024-04-15', '10107', 'Inventory Devit Supplier Paremount General', '8230.00', '0.00', '1', '1', '2024-05-11 14:45:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6547, '20240415103944', 'Purchase', '2024-04-15', '502000038', 'Supplier -Paremount General', '0.00', '8230.00', '1', '1', '2024-05-11 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6548, '20240415103944', 'Purchase', '2024-04-15', '402', 'Company Credit For SupplierParemount General', '8230.00', '0.00', '1', '1', '2024-05-11 14:45:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6549, '20240415103944', 'Purchase', '2024-04-15', '1020101', 'Cash in Hand For Supplier Paremount General', '0.00', '0.00', '1', '1', '2024-05-11 14:45:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6550, '20240415103944', 'Purchase', '2024-04-15', '502000038', 'Supplier . Paremount General', '0.00', '0.00', '1', '1', '2024-05-11 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6551, '9746361644', 'INV', '2024-05-11', '10107', 'Inventory credit For Invoice No1424', '0.00', '163617.69', '1', '1', '2024-05-11 15:18:19', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6552, '9746361644', 'INVOICE', '2024-05-11', '303', 'Sale Income From Invoice NO - 1424 Customer Walking Customer', '0.00', '68770.00', '1', '1', '2024-05-11 15:18:19', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6553, '9746361644', 'INV', '2024-05-11', '102030000002', 'Customer debit For Invoice NO - 1424 customer-  Walking Customer', '68770.00', '0.00', '1', '1', '2024-05-11 15:18:19', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6554, '6655196876', 'INV', '2024-05-11', '10107', 'Inventory credit For Invoice No1425', '0.00', '263441.11', '1', '1', '2024-05-11 15:51:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6555, '6655196876', 'INVOICE', '2024-05-11', '303', 'Sale Income From Invoice NO - 1425 Customer Walking Customer', '0.00', '91470.00', '1', '1', '2024-05-11 15:51:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6556, '6655196876', 'INV', '2024-05-11', '102030000002', 'Customer debit For Invoice NO - 1425 customer-  Walking Customer', '91470.00', '0.00', '1', '1', '2024-05-11 15:51:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6557, '20240403112716', 'Purchase', '2024-04-03', '10107', 'Inventory Devit Supplier Akram PVC', '90396.00', '0.00', '1', '1', '2024-05-11 15:55:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6558, '20240403112716', 'Purchase', '2024-04-03', '502000006', 'Supplier -Akram PVC', '0.00', '90396.00', '1', '1', '2024-05-11 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6559, '20240403112716', 'Purchase', '2024-04-03', '402', 'Company Credit For SupplierAkram PVC', '90396.00', '0.00', '1', '1', '2024-05-11 15:55:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6560, '20240403112716', 'Purchase', '2024-04-03', '1020101', 'Cash in Hand For Supplier Akram PVC', '0.00', '0.00', '1', '1', '2024-05-11 15:55:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6561, '20240403112716', 'Purchase', '2024-04-03', '502000006', 'Supplier . Akram PVC', '0.00', '0.00', '1', '1', '2024-05-11 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6570, '20240512083938', 'Purchase', '2024-05-11', '10107', 'Inventory Debit For Supplier Sale Return ', '10500.00', '0.00', '1', '1', '2024-05-12 08:39:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6571, '20240512083938', 'Purchase', '2024-05-11', '502000054', 'Supplier .Sale Return ', '0.00', '10500.00', '1', '1', '2024-05-12 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6572, '20240512083938', 'Purchase', '2024-05-11', '402', 'Company Credit For  Sale Return ', '10500.00', '0.00', '1', '1', '2024-05-12 08:39:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6573, '20240512090322', 'Purchase', '2024-05-11', '10107', 'Inventory Debit For Supplier Jawaid Wire', '5800.00', '0.00', '1', '1', '2024-05-12 09:03:22', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6574, '20240512090322', 'Purchase', '2024-05-11', '502000024', 'Supplier .Jawaid Wire', '0.00', '5800.00', '1', '1', '2024-05-12 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6575, '20240512090322', 'Purchase', '2024-05-11', '402', 'Company Credit For  Jawaid Wire', '5800.00', '0.00', '1', '1', '2024-05-12 09:03:22', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6584, '20240319154902', 'Purchase', '2024-03-17', '10107', 'Inventory Devit Supplier Jawaid Wire', '57600.00', '0.00', '1', '1', '2024-05-12 10:17:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6585, '20240319154902', 'Purchase', '2024-03-17', '502000024', 'Supplier -Jawaid Wire', '0.00', '57600.00', '1', '1', '2024-05-12 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6586, '20240319154902', 'Purchase', '2024-03-17', '402', 'Company Credit For SupplierJawaid Wire', '57600.00', '0.00', '1', '1', '2024-05-12 10:17:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6587, '20240319154902', 'Purchase', '2024-03-17', '1020101', 'Cash in Hand For Supplier Jawaid Wire', '0.00', '0.00', '1', '1', '2024-05-12 10:17:55', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6588, '20240319154902', 'Purchase', '2024-03-17', '502000024', 'Supplier . Jawaid Wire', '0.00', '0.00', '1', '1', '2024-05-12 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6589, '20240203141705', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier Moin PVC Karachi', '296170.00', '0.00', '1', '1', '2024-05-12 11:03:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6590, '20240203141705', 'Purchase', '2023-12-31', '502000028', 'Supplier -Moin PVC Karachi', '0.00', '296170.00', '1', '1', '2024-05-12 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6591, '20240203141705', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierMoin PVC Karachi', '296170.00', '0.00', '1', '1', '2024-05-12 11:03:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6592, '20240203141705', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier Moin PVC Karachi', '0.00', '0.00', '1', '1', '2024-05-12 11:03:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6593, '20240203141705', 'Purchase', '2023-12-31', '502000028', 'Supplier . Moin PVC Karachi', '0.00', '0.00', '1', '1', '2024-05-12 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6602, '4199745195', 'INV', '2024-05-12', '10107', 'Inventory credit For Invoice No1426', '0.00', '0.00', '1', '1', '2024-05-12 11:37:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6603, '4199745195', 'INVOICE', '2024-05-12', '303', 'Sale Income From Invoice NO - 1426 Customer Mustufa Arif', '0.00', '-246480.00', '1', '1', '2024-05-12 11:37:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6604, '4199745195', 'INV', '2024-05-12', '102030000023', 'Customer debit For Invoice NO - 1426 customer-  Mustufa Arif', '0.00', '0.00', '1', '1', '2024-05-12 11:37:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6613, '6879251196', 'INV', '2024-05-12', '10107', 'Inventory credit For Invoice No1445', '0.00', '225021.04', '1', '1', '2024-05-12 12:36:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6614, '6879251196', 'INVOICE', '2024-05-12', '303', 'Sale Income From Invoice NO - 1445 Customer Walking Customer', '0.00', '115630.00', '1', '1', '2024-05-12 12:36:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6615, '6879251196', 'INV', '2024-05-12', '102030000002', 'Customer debit For Invoice NO - 1445 customer-  Walking Customer', '115630.00', '0.00', '1', '1', '2024-05-12 12:36:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6622, '20240219083123', 'Purchase', '2024-02-01', '10107', 'Inventory Devit Supplier F Ali Iddress Karachi', '162970.00', '0.00', '1', '1', '2024-05-12 13:45:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6623, '20240219083123', 'Purchase', '2024-02-01', '502000049', 'Supplier -F Ali Iddress Karachi', '0.00', '162970.00', '1', '1', '2024-05-12 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6624, '20240219083123', 'Purchase', '2024-02-01', '402', 'Company Credit For SupplierF Ali Iddress Karachi', '162970.00', '0.00', '1', '1', '2024-05-12 13:45:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6625, '20240219083123', 'Purchase', '2024-02-01', '1020101', 'Cash in Hand For Supplier F Ali Iddress Karachi', '0.00', '0.00', '1', '1', '2024-05-12 13:45:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6626, '20240219083123', 'Purchase', '2024-02-01', '502000049', 'Supplier . F Ali Iddress Karachi', '0.00', '0.00', '1', '1', '2024-05-12 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6632, '20240205154059', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier Arfeen Wire (Million)', '436300.00', '0.00', '1', '1', '2024-05-12 13:58:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6633, '20240205154059', 'Purchase', '2023-12-31', '502000029', 'Supplier -Arfeen Wire (Million)', '0.00', '436300.00', '1', '1', '2024-05-12 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6634, '20240205154059', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierArfeen Wire (Million)', '436300.00', '0.00', '1', '1', '2024-05-12 13:58:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6635, '20240205154059', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier Arfeen Wire (Million)', '0.00', '0.00', '1', '1', '2024-05-12 13:58:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6636, '20240205154059', 'Purchase', '2023-12-31', '502000029', 'Supplier . Arfeen Wire (Million)', '0.00', '0.00', '1', '1', '2024-05-12 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6642, '3258566874', 'INV', '2024-05-12', '10107', 'Inventory credit For Invoice No1447', '0.00', '32581.61', '1', '1', '2024-05-12 14:59:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6643, '3258566874', 'INVOICE', '2024-05-12', '303', 'Sale Income From Invoice NO - 1447 Customer Shano Contactor', '0.00', '14900.00', '1', '1', '2024-05-12 14:59:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6644, '3258566874', 'INV', '2024-05-12', '102030000057', 'Customer debit For Invoice NO - 1447 customer-  Shano Contactor', '14900.00', '0.00', '1', '1', '2024-05-12 14:59:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6655, '20240512083036', 'Purchase', '2024-05-11', '10107', 'Inventory Devit Supplier Cash Item ', '11700.00', '0.00', '1', '1', '2024-05-12 15:21:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6656, '20240512083036', 'Purchase', '2024-05-11', '502000047', 'Supplier -Cash Item ', '0.00', '11700.00', '1', '1', '2024-05-12 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6657, '20240512083036', 'Purchase', '2024-05-11', '402', 'Company Credit For SupplierCash Item ', '11700.00', '0.00', '1', '1', '2024-05-12 15:21:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6658, '20240512083036', 'Purchase', '2024-05-11', '1020101', 'Cash in Hand For Supplier Cash Item ', '0.00', '0.00', '1', '1', '2024-05-12 15:21:45', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6659, '20240512083036', 'Purchase', '2024-05-11', '502000047', 'Supplier . Cash Item ', '0.00', '0.00', '1', '1', '2024-05-12 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6681, '1435241757', 'INV', '2024-05-13', '10107', 'Inventory credit For Invoice No1448', '0.00', '51247.08', '1', '1', '2024-05-13 11:06:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6682, '1435241757', 'INVOICE', '2024-05-13', '303', 'Sale Income From Invoice NO - 1448 Customer Walking Customer', '0.00', '20550.00', '1', '1', '2024-05-13 11:06:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6683, '1435241757', 'INV', '2024-05-13', '102030000002', 'Customer debit For Invoice NO - 1448 customer-  Walking Customer', '20550.00', '0.00', '1', '1', '2024-05-13 11:06:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6697, '20240513121625', 'Purchase', '2024-05-13', '10107', 'Inventory Debit For Supplier M.K Electric Purchase', '13550.00', '0.00', '1', '1', '2024-05-13 12:16:25', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6698, '20240513121625', 'Purchase', '2024-05-13', '502000053', 'Supplier .M.K Electric Purchase', '0.00', '13550.00', '1', '1', '2024-05-13 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6699, '20240513121625', 'Purchase', '2024-05-13', '402', 'Company Credit For  M.K Electric Purchase', '13550.00', '0.00', '1', '1', '2024-05-13 12:16:25', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6700, '20240513122220', 'Purchase', '2024-05-13', '10107', 'Inventory Debit For Supplier Arfeen Wire (Million)', '45000.00', '0.00', '1', '1', '2024-05-13 12:22:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6701, '20240513122220', 'Purchase', '2024-05-13', '502000029', 'Supplier .Arfeen Wire (Million)', '0.00', '45000.00', '1', '1', '2024-05-13 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6702, '20240513122220', 'Purchase', '2024-05-13', '402', 'Company Credit For  Arfeen Wire (Million)', '45000.00', '0.00', '1', '1', '2024-05-13 12:22:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6711, '20240513123234', 'Purchase', '2024-05-13', '10107', 'Inventory Devit Supplier G.One LED Light', '36150.00', '0.00', '1', '1', '2024-05-13 12:39:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6712, '20240513123234', 'Purchase', '2024-05-13', '502000027', 'Supplier -G.One LED Light', '0.00', '36150.00', '1', '1', '2024-05-13 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6713, '20240513123234', 'Purchase', '2024-05-13', '402', 'Company Credit For SupplierG.One LED Light', '36150.00', '0.00', '1', '1', '2024-05-13 12:39:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6714, '20240513123234', 'Purchase', '2024-05-13', '1020101', 'Cash in Hand For Supplier G.One LED Light', '0.00', '0.00', '1', '1', '2024-05-13 12:39:06', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6715, '20240513123234', 'Purchase', '2024-05-13', '502000027', 'Supplier . G.One LED Light', '0.00', '0.00', '1', '1', '2024-05-13 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6716, '20240513124438', 'Purchase', '2024-05-13', '10107', 'Inventory Debit For Supplier Usman S.E ', '2520.00', '0.00', '1', '1', '2024-05-13 12:44:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6717, '20240513124438', 'Purchase', '2024-05-13', '502000058', 'Supplier .Usman S.E ', '0.00', '2520.00', '1', '1', '2024-05-13 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6718, '20240513124438', 'Purchase', '2024-05-13', '402', 'Company Credit For  Usman S.E ', '2520.00', '0.00', '1', '1', '2024-05-13 12:44:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6719, '1217289937', 'INV', '2024-05-13', '10107', 'Inventory credit For Invoice No1449', '0.00', '1000.00', '1', '1', '2024-05-13 13:10:16', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6720, '1217289937', 'INV', '2024-05-13', '102030000052', 'Customer debit For Invoice No -  1449 Customer Dawood Super Mart', '2000.00', '0.00', '1', '1', '2024-05-13 13:10:16', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6721, '1217289937', 'INVOICE', '2024-05-13', '303', 'Sale Income For Invoice NO - 1449 Customer Dawood Super Mart', '0.00', '2000.00', '1', '1', '2024-05-13 13:10:16', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6722, '1471919258', 'INV', '2024-05-13', '10107', 'Inventory credit For Invoice No1450', '0.00', '11500.00', '1', '1', '2024-05-13 13:12:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6723, '1471919258', 'INV', '2024-05-13', '102030000026', 'Customer debit For Invoice No -  1450 Customer Memon Light  ', '12500.00', '0.00', '1', '1', '2024-05-13 13:12:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6724, '1471919258', 'INVOICE', '2024-05-13', '303', 'Sale Income For Invoice NO - 1450 Customer Memon Light  ', '0.00', '12500.00', '1', '1', '2024-05-13 13:12:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6725, '2714463447', 'INV', '2024-05-13', '10107', 'Inventory credit For Invoice No1451', '0.00', '4134.00', '1', '1', '2024-05-13 13:14:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6726, '2714463447', 'INV', '2024-05-13', '102030000020', 'Customer debit For Invoice No -  1451 Customer M.K Electric ', '4300.00', '0.00', '1', '1', '2024-05-13 13:14:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6727, '2714463447', 'INVOICE', '2024-05-13', '303', 'Sale Income For Invoice NO - 1451 Customer M.K Electric ', '0.00', '4300.00', '1', '1', '2024-05-13 13:14:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6728, '8246258379', 'INV', '2024-05-13', '10107', 'Inventory credit For Invoice No1452', '0.00', '262351.10', '1', '1', '2024-05-13 13:35:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6729, '8246258379', 'INV', '2024-05-13', '102030000017', 'Customer debit For Invoice No -  1452 Customer Deluxe Electric', '237350.00', '0.00', '1', '1', '2024-05-13 13:35:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6730, '8246258379', 'INVOICE', '2024-05-13', '303', 'Sale Income For Invoice NO - 1452 Customer Deluxe Electric', '0.00', '237350.00', '1', '1', '2024-05-13 13:35:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6731, '2173489285', 'INV', '2024-05-13', '10107', 'Inventory credit For Invoice No1453', '0.00', '25500.00', '1', '1', '2024-05-13 13:37:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6732, '2173489285', 'INV', '2024-05-13', '102030000005', 'Customer debit For Invoice No -  1453 Customer H.M CABLES', '31800.00', '0.00', '1', '1', '2024-05-13 13:37:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6733, '2173489285', 'INVOICE', '2024-05-13', '303', 'Sale Income For Invoice NO - 1453 Customer H.M CABLES', '0.00', '31800.00', '1', '1', '2024-05-13 13:37:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6737, '20240514100037', 'Purchase', '2024-05-13', '10107', 'Inventory Debit For Supplier Cash Item ', '13000.00', '0.00', '1', '1', '2024-05-14 10:00:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6738, '20240514100037', 'Purchase', '2024-05-13', '502000047', 'Supplier .Cash Item ', '0.00', '13000.00', '1', '1', '2024-05-14 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6739, '20240514100037', 'Purchase', '2024-05-13', '402', 'Company Credit For  Cash Item ', '13000.00', '0.00', '1', '1', '2024-05-14 10:00:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6753, '1614719538', 'INV', '2024-05-14', '10107', 'Inventory credit For Invoice No1440', '0.00', '68762.67', '1', '1', '2024-05-14 10:16:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6754, '1614719538', 'INVOICE', '2024-05-14', '303', 'Sale Income From Invoice NO - 1440 Customer breez Chemical Mill', '0.00', '16550.00', '1', '1', '2024-05-14 10:16:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6755, '1614719538', 'INV', '2024-05-14', '102030000056', 'Customer debit For Invoice NO - 1440 customer-  breez Chemical Mill', '16550.00', '0.00', '1', '1', '2024-05-14 10:16:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6756, '20240331163350', 'Purchase', '2024-03-31', '10107', 'Inventory Devit Supplier M.S Electric Purchase ', '16518.00', '0.00', '1', '1', '2024-05-14 10:47:01', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6757, '20240331163350', 'Purchase', '2024-03-31', '502000050', 'Supplier -M.S Electric Purchase ', '0.00', '16518.00', '1', '1', '2024-05-14 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6758, '20240331163350', 'Purchase', '2024-03-31', '402', 'Company Credit For SupplierM.S Electric Purchase ', '16518.00', '0.00', '1', '1', '2024-05-14 10:47:01', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6759, '20240331163350', 'Purchase', '2024-03-31', '1020101', 'Cash in Hand For Supplier M.S Electric Purchase ', '0.00', '0.00', '1', '1', '2024-05-14 10:47:01', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6760, '20240331163350', 'Purchase', '2024-03-31', '502000050', 'Supplier . M.S Electric Purchase ', '0.00', '0.00', '1', '1', '2024-05-14 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6761, '7771648352', 'INV', '2024-05-14', '10107', 'Inventory credit For Invoice No1454', '0.00', '5400.00', '1', '1', '2024-05-14 10:50:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6762, '7771648352', 'INV', '2024-05-14', '102030000052', 'Customer debit For Invoice No -  1454 Customer Dawood Super Mart', '5900.00', '0.00', '1', '1', '2024-05-14 10:50:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6763, '7771648352', 'INVOICE', '2024-05-14', '303', 'Sale Income For Invoice NO - 1454 Customer Dawood Super Mart', '0.00', '5900.00', '1', '1', '2024-05-14 10:50:37', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6764, '20240513113659', 'Purchase', '2024-05-13', '10107', 'Inventory Devit Supplier Fizan Wire', '24840.00', '0.00', '1', '1', '2024-05-14 11:07:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6765, '20240513113659', 'Purchase', '2024-05-13', '502000026', 'Supplier -Fizan Wire', '0.00', '24840.00', '1', '1', '2024-05-14 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6766, '20240513113659', 'Purchase', '2024-05-13', '402', 'Company Credit For SupplierFizan Wire', '24840.00', '0.00', '1', '1', '2024-05-14 11:07:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6767, '20240513113659', 'Purchase', '2024-05-13', '1020101', 'Cash in Hand For Supplier Fizan Wire', '0.00', '0.00', '1', '1', '2024-05-14 11:07:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6768, '20240513113659', 'Purchase', '2024-05-13', '502000026', 'Supplier . Fizan Wire', '0.00', '0.00', '1', '1', '2024-05-14 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6769, '8482417873', 'INV', '2024-05-14', '10107', 'Inventory credit For Invoice No1446', '0.00', '316077.00', '1', '1', '2024-05-14 11:11:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6770, '8482417873', 'INVOICE', '2024-05-14', '303', 'Sale Income From Invoice NO - 1446 Customer M.Z Electric', '0.00', '30600.00', '1', '1', '2024-05-14 11:11:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6771, '8482417873', 'INV', '2024-05-14', '102030000019', 'Customer debit For Invoice NO - 1446 customer-  M.Z Electric', '30600.00', '0.00', '1', '1', '2024-05-14 11:11:48', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6775, '7425241919', 'INV', '2024-05-14', '10107', 'Inventory credit For Invoice No1455', '0.00', '11557.08', '1', '1', '2024-05-14 14:31:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6776, '7425241919', 'INVOICE', '2024-05-14', '303', 'Sale Income From Invoice NO - 1455 Customer Sattar Mallah Electric', '0.00', '12380.00', '1', '1', '2024-05-14 14:31:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6777, '7425241919', 'INV', '2024-05-14', '102030000022', 'Customer debit For Invoice NO - 1455 customer-  Sattar Mallah Electric', '12380.00', '0.00', '1', '1', '2024-05-14 14:31:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6786, '20240514093845', 'Purchase', '2024-05-13', '10107', 'Inventory Devit Supplier Paremount General', '3600.00', '0.00', '1', '1', '2024-05-14 15:15:26', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6787, '20240514093845', 'Purchase', '2024-05-13', '502000038', 'Supplier -Paremount General', '0.00', '3600.00', '1', '1', '2024-05-14 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6788, '20240514093845', 'Purchase', '2024-05-13', '402', 'Company Credit For SupplierParemount General', '3600.00', '0.00', '1', '1', '2024-05-14 15:15:26', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6789, '20240514093845', 'Purchase', '2024-05-13', '1020101', 'Cash in Hand For Supplier Paremount General', '0.00', '0.00', '1', '1', '2024-05-14 15:15:26', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6790, '20240514093845', 'Purchase', '2024-05-13', '502000038', 'Supplier . Paremount General', '0.00', '0.00', '1', '1', '2024-05-14 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6791, '2269286568', 'INV', '2024-05-14', '10107', 'Inventory credit For Invoice No1456', '0.00', '94209.22', '1', '1', '2024-05-14 15:22:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6792, '2269286568', 'INVOICE', '2024-05-14', '303', 'Sale Income From Invoice NO - 1456 Customer Walking Customer', '0.00', '60400.00', '1', '1', '2024-05-14 15:22:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6793, '2269286568', 'INV', '2024-05-14', '102030000002', 'Customer debit For Invoice NO - 1456 customer-  Walking Customer', '60400.00', '0.00', '1', '1', '2024-05-14 15:22:47', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6794, '7132322579', 'INV', '2024-05-14', '10107', 'Inventory credit For Invoice No1457', '0.00', '8400.00', '1', '1', '2024-05-14 15:36:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6795, '7132322579', 'INV', '2024-05-14', '102030000058', 'Customer debit For Invoice No -  1457 Customer Chilton karachi ', '9600.00', '0.00', '1', '1', '2024-05-14 15:36:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6796, '7132322579', 'INVOICE', '2024-05-14', '303', 'Sale Income For Invoice NO - 1457 Customer Chilton karachi ', '0.00', '9600.00', '1', '1', '2024-05-14 15:36:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6797, '20240514155936', 'Purchase', '2024-05-14', '10107', 'Inventory Debit For Supplier Cash Item ', '28000.00', '0.00', '1', '1', '2024-05-14 15:59:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6798, '20240514155936', 'Purchase', '2024-05-14', '502000047', 'Supplier .Cash Item ', '0.00', '28000.00', '1', '1', '2024-05-14 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6799, '20240514155936', 'Purchase', '2024-05-14', '402', 'Company Credit For  Cash Item ', '28000.00', '0.00', '1', '1', '2024-05-14 15:59:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6800, '7531931292', 'INV', '2024-05-14', '10107', 'Inventory credit For Invoice No1458', '0.00', '28495.00', '1', '1', '2024-05-14 16:03:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6801, '7531931292', 'INV', '2024-05-14', '102030000059', 'Customer debit For Invoice No -  1458 Customer Nadeem Bhai ', '31710.00', '0.00', '1', '1', '2024-05-14 16:03:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6802, '7531931292', 'INVOICE', '2024-05-14', '303', 'Sale Income For Invoice NO - 1458 Customer Nadeem Bhai ', '0.00', '31710.00', '1', '1', '2024-05-14 16:03:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6803, '9425431332', 'INV', '2024-05-14', '10107', 'Inventory credit For Invoice No1459', '0.00', '1000.00', '1', '1', '2024-05-14 16:09:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6804, '9425431332', 'INV', '2024-05-14', '102030000052', 'Customer debit For Invoice No -  1459 Customer Dawood Super Mart', '2000.00', '0.00', '1', '1', '2024-05-14 16:09:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6805, '9425431332', 'INVOICE', '2024-05-14', '303', 'Sale Income For Invoice NO - 1459 Customer Dawood Super Mart', '0.00', '2000.00', '1', '1', '2024-05-14 16:09:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6806, '2441147954', 'INV', '2024-05-14', '10107', 'Inventory credit For Invoice No1460', '0.00', '13400.00', '1', '1', '2024-05-14 16:12:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6807, '2441147954', 'INV', '2024-05-14', '102030000042', 'Customer debit For Invoice No -  1460 Customer Dawood Center Auto Bhan', '15400.00', '0.00', '1', '1', '2024-05-14 16:12:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6808, '2441147954', 'INVOICE', '2024-05-14', '303', 'Sale Income For Invoice NO - 1460 Customer Dawood Center Auto Bhan', '0.00', '15400.00', '1', '1', '2024-05-14 16:12:51', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6809, '5141413266', 'INV', '2024-05-15', '10107', 'Inventory credit For Invoice No1461', '0.00', '73148.73', '1', '1', '2024-05-15 09:52:21', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6810, '5141413266', 'INV', '2024-05-15', '102030000002', 'Customer debit For Invoice No -  1461 Customer Walking Customer', '33900.00', '0.00', '1', '1', '2024-05-15 09:52:21', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6811, '5141413266', 'INVOICE', '2024-05-15', '303', 'Sale Income For Invoice NO - 1461 Customer Walking Customer', '0.00', '33900.00', '1', '1', '2024-05-15 09:52:21', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6822, '20240515120704', 'Purchase', '2024-05-15', '10107', 'Inventory Debit For Supplier Royal Electri Karachi', '50460.00', '0.00', '1', '1', '2024-05-15 12:07:05', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6823, '20240515120704', 'Purchase', '2024-05-15', '502000041', 'Supplier .Royal Electri Karachi', '0.00', '50460.00', '1', '1', '2024-05-15 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6824, '20240515120704', 'Purchase', '2024-05-15', '402', 'Company Credit For  Royal Electri Karachi', '50460.00', '0.00', '1', '1', '2024-05-15 12:07:05', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6825, '20240515133441', 'Purchase', '2024-05-15', '10107', 'Inventory Debit For Supplier Cash Item ', '5760.20', '0.00', '1', '1', '2024-05-15 13:34:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6826, '20240515133441', 'Purchase', '2024-05-15', '502000047', 'Supplier .Cash Item ', '0.00', '5760.20', '1', '1', '2024-05-15 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6827, '20240515133441', 'Purchase', '2024-05-15', '402', 'Company Credit For  Cash Item ', '5760.20', '0.00', '1', '1', '2024-05-15 13:34:41', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6831, '20240515133628', 'Purchase', '2024-05-15', '10107', 'Inventory Devit Supplier Moin PVC Karachi', '17200.00', '0.00', '1', '1', '2024-05-15 13:39:01', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6832, '20240515133628', 'Purchase', '2024-05-15', '502000028', 'Supplier -Moin PVC Karachi', '0.00', '17200.00', '1', '1', '2024-05-15 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6833, '20240515133628', 'Purchase', '2024-05-15', '402', 'Company Credit For SupplierMoin PVC Karachi', '17200.00', '0.00', '1', '1', '2024-05-15 13:39:01', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6834, '20240515133628', 'Purchase', '2024-05-15', '1020101', 'Cash in Hand For Supplier Moin PVC Karachi', '0.00', '0.00', '1', '1', '2024-05-15 13:39:01', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6835, '20240515133628', 'Purchase', '2024-05-15', '502000028', 'Supplier . Moin PVC Karachi', '0.00', '0.00', '1', '1', '2024-05-15 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6836, '20240515135425', 'Purchase', '2024-05-15', '10107', 'Inventory Debit For Supplier Akram PVC', '17160.00', '0.00', '1', '1', '2024-05-15 13:54:25', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6837, '20240515135425', 'Purchase', '2024-05-15', '502000006', 'Supplier .Akram PVC', '0.00', '17160.00', '1', '1', '2024-05-15 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6838, '20240515135425', 'Purchase', '2024-05-15', '402', 'Company Credit For  Akram PVC', '17160.00', '0.00', '1', '1', '2024-05-15 13:54:25', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6839, '20240515140556', 'Purchase', '2024-05-15', '10107', 'Inventory Debit For Supplier Sale Return ', '12930.00', '0.00', '1', '1', '2024-05-15 14:05:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6840, '20240515140556', 'Purchase', '2024-05-15', '502000054', 'Supplier .Sale Return ', '0.00', '12930.00', '1', '1', '2024-05-15 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6841, '20240515140556', 'Purchase', '2024-05-15', '402', 'Company Credit For  Sale Return ', '12930.00', '0.00', '1', '1', '2024-05-15 14:05:56', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6842, '4629916718', 'INV', '2024-05-15', '10107', 'Inventory credit For Invoice No1462', '0.00', '11268.00', '1', '1', '2024-05-15 15:30:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6843, '4629916718', 'INV', '2024-05-15', '102030000016', 'Customer debit For Invoice No -  1462 Customer Abdul Qadir Electric ', '12520.00', '0.00', '1', '1', '2024-05-15 15:30:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6844, '4629916718', 'INVOICE', '2024-05-15', '303', 'Sale Income For Invoice NO - 1462 Customer Abdul Qadir Electric ', '0.00', '12520.00', '1', '1', '2024-05-15 15:30:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6845, '9233426983', 'INV', '2024-05-15', '10107', 'Inventory credit For Invoice No1463', '0.00', '194835.00', '1', '1', '2024-05-15 15:40:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6846, '9233426983', 'INV', '2024-05-15', '102030000026', 'Customer debit For Invoice No -  1463 Customer Memon Light  ', '181792.00', '0.00', '1', '1', '2024-05-15 15:40:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6847, '9233426983', 'INVOICE', '2024-05-15', '303', 'Sale Income For Invoice NO - 1463 Customer Memon Light  ', '0.00', '181792.00', '1', '1', '2024-05-15 15:40:27', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6848, '3543812978', 'INV', '2024-05-15', '10107', 'Inventory credit For Invoice No1464', '0.00', '163150.00', '1', '1', '2024-05-15 15:45:23', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6849, '3543812978', 'INV', '2024-05-15', '102030000017', 'Customer debit For Invoice No -  1464 Customer Deluxe Electric', '137040.00', '0.00', '1', '1', '2024-05-15 15:45:23', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6850, '3543812978', 'INVOICE', '2024-05-15', '303', 'Sale Income For Invoice NO - 1464 Customer Deluxe Electric', '0.00', '137040.00', '1', '1', '2024-05-15 15:45:23', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6854, '4751468166', 'INV', '2024-05-15', '10107', 'Inventory credit For Invoice No1466', '0.00', '5316.67', '1', '1', '2024-05-15 16:04:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6855, '4751468166', 'INV', '2024-05-15', '102030000057', 'Customer debit For Invoice No -  1466 Customer Shano Contactor', '3090.00', '0.00', '1', '1', '2024-05-15 16:04:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6856, '4751468166', 'INVOICE', '2024-05-15', '303', 'Sale Income For Invoice NO - 1466 Customer Shano Contactor', '0.00', '3090.00', '1', '1', '2024-05-15 16:04:11', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6857, '20240516133700', 'Purchase', '2024-05-16', '10107', 'Inventory Debit For Supplier M.K Electric Purchase', '7790.00', '0.00', '1', '1', '2024-05-16 13:37:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6858, '20240516133700', 'Purchase', '2024-05-16', '502000053', 'Supplier .M.K Electric Purchase', '0.00', '7790.00', '1', '1', '2024-05-16 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6859, '20240516133700', 'Purchase', '2024-05-16', '402', 'Company Credit For  M.K Electric Purchase', '7790.00', '0.00', '1', '1', '2024-05-16 13:37:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6863, '20240518091329', 'Purchase', '2024-05-16', '10107', 'Inventory Debit For Supplier Sale Return ', '4500.00', '0.00', '1', '1', '2024-05-18 09:13:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6864, '20240518091329', 'Purchase', '2024-05-16', '502000054', 'Supplier .Sale Return ', '0.00', '4500.00', '1', '1', '2024-05-18 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6865, '20240518091329', 'Purchase', '2024-05-16', '402', 'Company Credit For  Sale Return ', '4500.00', '0.00', '1', '1', '2024-05-18 09:13:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6869, '4525769244', 'INV', '2024-05-18', '10107', 'Inventory credit For Invoice No1468', '0.00', '145215.83', '1', '1', '2024-05-18 11:56:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6870, '4525769244', 'INV', '2024-05-18', '102030000002', 'Customer debit For Invoice No -  1468 Customer Walking Customer', '43920.00', '0.00', '1', '1', '2024-05-18 11:56:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6871, '4525769244', 'INVOICE', '2024-05-18', '303', 'Sale Income For Invoice NO - 1468 Customer Walking Customer', '0.00', '43920.00', '1', '1', '2024-05-18 11:56:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6877, '20240428083925', 'Purchase', '2024-04-27', '10107', 'Inventory Devit Supplier Fawad Wire', '15600.00', '0.00', '1', '1', '2024-05-18 12:48:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6878, '20240428083925', 'Purchase', '2024-04-27', '502000034', 'Supplier -Fawad Wire', '0.00', '15600.00', '1', '1', '2024-05-18 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6879, '20240428083925', 'Purchase', '2024-04-27', '402', 'Company Credit For SupplierFawad Wire', '15600.00', '0.00', '1', '1', '2024-05-18 12:48:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6880, '20240428083925', 'Purchase', '2024-04-27', '1020101', 'Cash in Hand For Supplier Fawad Wire', '0.00', '0.00', '1', '1', '2024-05-18 12:48:39', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6881, '20240428083925', 'Purchase', '2024-04-27', '502000034', 'Supplier . Fawad Wire', '0.00', '0.00', '1', '1', '2024-05-18 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6885, '1712444644', 'INV', '2024-05-18', '10107', 'Inventory credit For Invoice No1465', '0.00', '0.00', '1', '1', '2024-05-18 12:52:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6886, '1712444644', 'INVOICE', '2024-05-18', '303', 'Sale Income From Invoice NO - 1465 Customer Mustufa Arif', '0.00', '-231580.00', '1', '1', '2024-05-18 12:52:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6887, '1712444644', 'INV', '2024-05-18', '102030000023', 'Customer debit For Invoice NO - 1465 customer-  Mustufa Arif', '0.00', '0.00', '1', '1', '2024-05-18 12:52:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6888, '9112277419', 'INV', '2024-05-18', '10107', 'Inventory credit For Invoice No1467', '0.00', '37162.86', '1', '1', '2024-05-18 12:55:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6889, '9112277419', 'INVOICE', '2024-05-18', '303', 'Sale Income From Invoice NO - 1467 Customer Walking Customer', '0.00', '36380.00', '1', '1', '2024-05-18 12:55:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6890, '9112277419', 'INV', '2024-05-18', '102030000002', 'Customer debit For Invoice NO - 1467 customer-  Walking Customer', '36380.00', '0.00', '1', '1', '2024-05-18 12:55:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6899, '9815267139', 'INV', '2024-05-18', '10107', 'Inventory credit For Invoice No1469', '0.00', '42842.00', '1', '1', '2024-05-18 14:08:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6900, '9815267139', 'INVOICE', '2024-05-18', '303', 'Sale Income From Invoice NO - 1469 Customer Mamu Jee', '0.00', '17840.00', '1', '1', '2024-05-18 14:08:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6901, '9815267139', 'INV', '2024-05-18', '102030000054', 'Customer debit For Invoice NO - 1469 customer-  Mamu Jee', '17840.00', '0.00', '1', '1', '2024-05-18 14:08:07', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6902, '8532293273', 'INV', '2024-05-18', '10107', 'Inventory credit For Invoice No1470', '0.00', '39973.00', '1', '1', '2024-05-18 14:14:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6903, '8532293273', 'INV', '2024-05-18', '102030000016', 'Customer debit For Invoice No -  1470 Customer Abdul Qadir Electric ', '48650.00', '0.00', '1', '1', '2024-05-18 14:14:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6904, '8532293273', 'INVOICE', '2024-05-18', '303', 'Sale Income For Invoice NO - 1470 Customer Abdul Qadir Electric ', '0.00', '48650.00', '1', '1', '2024-05-18 14:14:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6905, '9827253319', 'INV', '2024-05-19', '10107', 'Inventory credit For Invoice No1471', '0.00', '16688.00', '1', '1', '2024-05-19 08:20:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6906, '9827253319', 'INV', '2024-05-19', '102030000016', 'Customer debit For Invoice No -  1471 Customer Abdul Qadir Electric ', '19600.00', '0.00', '1', '1', '2024-05-19 08:20:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6907, '9827253319', 'INVOICE', '2024-05-19', '303', 'Sale Income For Invoice NO - 1471 Customer Abdul Qadir Electric ', '0.00', '19600.00', '1', '1', '2024-05-19 08:20:03', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6908, '20240519083354', 'Purchase', '2024-05-18', '10107', 'Inventory Debit For Supplier Cash Item ', '23500.00', '0.00', '1', '1', '2024-05-19 08:33:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6909, '20240519083354', 'Purchase', '2024-05-18', '502000047', 'Supplier .Cash Item ', '0.00', '23500.00', '1', '1', '2024-05-19 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6910, '20240519083354', 'Purchase', '2024-05-18', '402', 'Company Credit For  Cash Item ', '23500.00', '0.00', '1', '1', '2024-05-19 08:33:54', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6911, '20240519084115', 'Purchase', '2024-05-19', '10107', 'Inventory Debit For Supplier Chilton Traders Karachi', '279000.00', '0.00', '1', '1', '2024-05-19 08:41:15', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6912, '20240519084115', 'Purchase', '2024-05-19', '502000032', 'Supplier .Chilton Traders Karachi', '0.00', '279000.00', '1', '1', '2024-05-19 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6913, '20240519084115', 'Purchase', '2024-05-19', '402', 'Company Credit For  Chilton Traders Karachi', '279000.00', '0.00', '1', '1', '2024-05-19 08:41:15', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6914, '20240519092005', 'Purchase', '2024-05-19', '10107', 'Inventory Debit For Supplier Sale Return ', '15517.00', '0.00', '1', '1', '2024-05-19 09:20:05', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6915, '20240519092005', 'Purchase', '2024-05-19', '502000054', 'Supplier .Sale Return ', '0.00', '15517.00', '1', '1', '2024-05-19 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6916, '20240519092005', 'Purchase', '2024-05-19', '402', 'Company Credit For  Sale Return ', '15517.00', '0.00', '1', '1', '2024-05-19 09:20:05', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6925, '20240129142817', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier Burq Sargodah', '187760.00', '0.00', '1', '1', '2024-05-19 10:51:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6926, '20240129142817', 'Purchase', '2023-12-31', '502000021', 'Supplier -Burq Sargodah', '0.00', '187760.00', '1', '1', '2024-05-19 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6927, '20240129142817', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierBurq Sargodah', '187760.00', '0.00', '1', '1', '2024-05-19 10:51:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6928, '20240129142817', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier Burq Sargodah', '0.00', '0.00', '1', '1', '2024-05-19 10:51:28', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6929, '20240129142817', 'Purchase', '2023-12-31', '502000021', 'Supplier . Burq Sargodah', '0.00', '0.00', '1', '1', '2024-05-19 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6935, '20240506145001', 'Purchase', '2024-05-06', '10107', 'Inventory Devit Supplier Millat Traders Loose Item', '36980.00', '0.00', '1', '1', '2024-05-19 11:58:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6936, '20240506145001', 'Purchase', '2024-05-06', '502000030', 'Supplier -Millat Traders Loose Item', '0.00', '36980.00', '1', '1', '2024-05-19 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6937, '20240506145001', 'Purchase', '2024-05-06', '402', 'Company Credit For SupplierMillat Traders Loose Item', '36980.00', '0.00', '1', '1', '2024-05-19 11:58:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6938, '20240506145001', 'Purchase', '2024-05-06', '1020101', 'Cash in Hand For Supplier Millat Traders Loose Item', '0.00', '0.00', '1', '1', '2024-05-19 11:58:30', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6939, '20240506145001', 'Purchase', '2024-05-06', '502000030', 'Supplier . Millat Traders Loose Item', '0.00', '0.00', '1', '1', '2024-05-19 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6940, '20240518090409', 'Purchase', '2024-05-16', '10107', 'Inventory Devit Supplier Abdul Hammed Panel wala', '17600.00', '0.00', '1', '1', '2024-05-19 12:02:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6941, '20240518090409', 'Purchase', '2024-05-16', '502000048', 'Supplier -Abdul Hammed Panel wala', '0.00', '17600.00', '1', '1', '2024-05-19 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6942, '20240518090409', 'Purchase', '2024-05-16', '402', 'Company Credit For SupplierAbdul Hammed Panel wala', '17600.00', '0.00', '1', '1', '2024-05-19 12:02:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6943, '20240518090409', 'Purchase', '2024-05-16', '1020101', 'Cash in Hand For Supplier Abdul Hammed Panel wala', '0.00', '0.00', '1', '1', '2024-05-19 12:02:36', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6944, '20240518090409', 'Purchase', '2024-05-16', '502000048', 'Supplier . Abdul Hammed Panel wala', '0.00', '0.00', '1', '1', '2024-05-19 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6945, '6261171199', 'INV', '2024-05-19', '10107', 'Inventory credit For Invoice No1472', '0.00', '133675.97', '1', '1', '2024-05-19 12:15:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6946, '6261171199', 'INVOICE', '2024-05-19', '303', 'Sale Income From Invoice NO - 1472 Customer Walking Customer', '0.00', '80270.00', '1', '1', '2024-05-19 12:15:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6947, '6261171199', 'INV', '2024-05-19', '102030000002', 'Customer debit For Invoice NO - 1472 customer-  Walking Customer', '80270.00', '0.00', '1', '1', '2024-05-19 12:15:35', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6948, '9163299722', 'INV', '2024-05-19', '10107', 'Inventory credit For Invoice No1473', '0.00', '21858.00', '1', '1', '2024-05-19 12:28:17', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6949, '9163299722', 'INV', '2024-05-19', '102030000021', 'Customer debit For Invoice No -  1473 Customer M.S Electric', '14830.00', '0.00', '1', '1', '2024-05-19 12:28:17', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6950, '9163299722', 'INVOICE', '2024-05-19', '303', 'Sale Income For Invoice NO - 1473 Customer M.S Electric', '0.00', '14830.00', '1', '1', '2024-05-19 12:28:17', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6951, '1223415297', 'INV', '2024-05-19', '10107', 'Inventory credit For Invoice No1474', '0.00', '21858.00', '1', '1', '2024-05-19 13:54:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6952, '1223415297', 'INV', '2024-05-19', '102030000021', 'Customer debit For Invoice No -  1474 Customer M.S Electric', '14830.00', '0.00', '1', '1', '2024-05-19 13:54:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6953, '1223415297', 'INVOICE', '2024-05-19', '303', 'Sale Income For Invoice NO - 1474 Customer M.S Electric', '0.00', '14830.00', '1', '1', '2024-05-19 13:54:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6954, '20240519141002', 'Purchase', '2024-05-19', '10107', 'Inventory Debit For Supplier Memon LAD Light', '110000.00', '0.00', '1', '1', '2024-05-19 14:10:02', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6955, '20240519141002', 'Purchase', '2024-05-19', '502000008', 'Supplier .Memon LAD Light', '0.00', '110000.00', '1', '1', '2024-05-19 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6956, '20240519141002', 'Purchase', '2024-05-19', '402', 'Company Credit For  Memon LAD Light', '110000.00', '0.00', '1', '1', '2024-05-19 14:10:02', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6957, '20240520091034', 'Purchase', '2024-05-19', '10107', 'Inventory Debit For Supplier M.S Electric Purchase ', '17950.00', '0.00', '1', '1', '2024-05-20 09:10:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6958, '20240520091034', 'Purchase', '2024-05-19', '502000050', 'Supplier .M.S Electric Purchase ', '0.00', '17950.00', '1', '1', '2024-05-20 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6959, '20240520091034', 'Purchase', '2024-05-19', '402', 'Company Credit For  M.S Electric Purchase ', '17950.00', '0.00', '1', '1', '2024-05-20 09:10:34', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6960, '20240520091552', 'Purchase', '2024-05-19', '10107', 'Inventory Debit For Supplier Jawaid Wire', '22000.00', '0.00', '1', '1', '2024-05-20 09:15:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6961, '20240520091552', 'Purchase', '2024-05-19', '502000024', 'Supplier .Jawaid Wire', '0.00', '22000.00', '1', '1', '2024-05-20 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6962, '20240520091552', 'Purchase', '2024-05-19', '402', 'Company Credit For  Jawaid Wire', '22000.00', '0.00', '1', '1', '2024-05-20 09:15:52', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6963, '20240520111840', 'Purchase', '2024-05-19', '10107', 'Inventory Debit For Supplier M.K Electric Purchase', '75420.00', '0.00', '1', '1', '2024-05-20 11:18:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6964, '20240520111840', 'Purchase', '2024-05-19', '502000053', 'Supplier .M.K Electric Purchase', '0.00', '75420.00', '1', '1', '2024-05-20 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6965, '20240520111840', 'Purchase', '2024-05-19', '402', 'Company Credit For  M.K Electric Purchase', '75420.00', '0.00', '1', '1', '2024-05-20 11:18:40', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6969, '20240521080304', 'Purchase', '2024-05-20', '10107', 'Inventory Devit Supplier Zahid Soomro Kotri', '3200.00', '0.00', '1', '1', '2024-05-21 08:13:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6970, '20240521080304', 'Purchase', '2024-05-20', '502000043', 'Supplier -Zahid Soomro Kotri', '0.00', '3200.00', '1', '1', '2024-05-21 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6971, '20240521080304', 'Purchase', '2024-05-20', '402', 'Company Credit For SupplierZahid Soomro Kotri', '3200.00', '0.00', '1', '1', '2024-05-21 08:13:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6972, '20240521080304', 'Purchase', '2024-05-20', '1020101', 'Cash in Hand For Supplier Zahid Soomro Kotri', '0.00', '0.00', '1', '1', '2024-05-21 08:13:08', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6973, '20240521080304', 'Purchase', '2024-05-20', '502000043', 'Supplier . Zahid Soomro Kotri', '0.00', '0.00', '1', '1', '2024-05-21 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6977, '20240521081618', 'Purchase', '2024-05-20', '10107', 'Inventory Devit Supplier Paremount General', '3380.00', '0.00', '1', '1', '2024-05-21 08:22:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6978, '20240521081618', 'Purchase', '2024-05-20', '502000038', 'Supplier -Paremount General', '0.00', '3380.00', '1', '1', '2024-05-21 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6979, '20240521081618', 'Purchase', '2024-05-20', '402', 'Company Credit For SupplierParemount General', '3380.00', '0.00', '1', '1', '2024-05-21 08:22:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6980, '20240521081618', 'Purchase', '2024-05-20', '1020101', 'Cash in Hand For Supplier Paremount General', '0.00', '0.00', '1', '1', '2024-05-21 08:22:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6981, '20240521081618', 'Purchase', '2024-05-20', '502000038', 'Supplier . Paremount General', '0.00', '0.00', '1', '1', '2024-05-21 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6982, '20240521082619', 'Purchase', '2024-05-20', '10107', 'Inventory Debit For Supplier Abdul Qadir Purchase ', '10900.00', '0.00', '1', '1', '2024-05-21 08:26:19', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6983, '20240521082619', 'Purchase', '2024-05-20', '502000056', 'Supplier .Abdul Qadir Purchase ', '0.00', '10900.00', '1', '1', '2024-05-21 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6984, '20240521082619', 'Purchase', '2024-05-20', '402', 'Company Credit For  Abdul Qadir Purchase ', '10900.00', '0.00', '1', '1', '2024-05-21 08:26:19', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6985, '20240521083132', 'Purchase', '2024-05-20', '10107', 'Inventory Debit For Supplier Cash Item ', '14500.00', '0.00', '1', '1', '2024-05-21 08:31:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6986, '20240521083132', 'Purchase', '2024-05-20', '502000047', 'Supplier .Cash Item ', '0.00', '14500.00', '1', '1', '2024-05-21 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6987, '20240521083132', 'Purchase', '2024-05-20', '402', 'Company Credit For  Cash Item ', '14500.00', '0.00', '1', '1', '2024-05-21 08:31:32', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6988, '20240521083413', 'Purchase', '2024-05-21', '10107', 'Inventory Debit For Supplier Chilton Traders Karachi', '14400.00', '0.00', '1', '1', '2024-05-21 08:34:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6989, '20240521083413', 'Purchase', '2024-05-21', '502000032', 'Supplier .Chilton Traders Karachi', '0.00', '14400.00', '1', '1', '2024-05-21 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6990, '20240521083413', 'Purchase', '2024-05-21', '402', 'Company Credit For  Chilton Traders Karachi', '14400.00', '0.00', '1', '1', '2024-05-21 08:34:13', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6994, '20240408075159', 'Purchase', '2024-04-07', '10107', 'Inventory Devit Supplier Fizan Wire', '56635.00', '0.00', '1', '1', '2024-05-21 09:46:31', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6995, '20240408075159', 'Purchase', '2024-04-07', '502000026', 'Supplier -Fizan Wire', '0.00', '56635.00', '1', '1', '2024-05-21 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6996, '20240408075159', 'Purchase', '2024-04-07', '402', 'Company Credit For SupplierFizan Wire', '56635.00', '0.00', '1', '1', '2024-05-21 09:46:31', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6997, '20240408075159', 'Purchase', '2024-04-07', '1020101', 'Cash in Hand For Supplier Fizan Wire', '0.00', '0.00', '1', '1', '2024-05-21 09:46:31', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6998, '20240408075159', 'Purchase', '2024-04-07', '502000026', 'Supplier . Fizan Wire', '0.00', '0.00', '1', '1', '2024-05-21 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (6999, '20240128122919', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier ARY Sargodah', '181350.00', '0.00', '1', '1', '2024-05-21 09:50:43', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7000, '20240128122919', 'Purchase', '2023-12-31', '502000012', 'Supplier -ARY Sargodah', '0.00', '181350.00', '1', '1', '2024-05-21 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7001, '20240128122919', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierARY Sargodah', '181350.00', '0.00', '1', '1', '2024-05-21 09:50:43', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7002, '20240128122919', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier ARY Sargodah', '0.00', '0.00', '1', '1', '2024-05-21 09:50:43', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7003, '20240128122919', 'Purchase', '2023-12-31', '502000012', 'Supplier . ARY Sargodah', '0.00', '0.00', '1', '1', '2024-05-21 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7004, '20240224141452', 'Purchase', '2024-02-01', '10107', 'Inventory Devit Supplier E M Sargodah', '91806.00', '0.00', '1', '1', '2024-05-21 09:54:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7005, '20240224141452', 'Purchase', '2024-02-01', '502000017', 'Supplier -E M Sargodah', '0.00', '91806.00', '1', '1', '2024-05-21 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7006, '20240224141452', 'Purchase', '2024-02-01', '402', 'Company Credit For SupplierE M Sargodah', '91806.00', '0.00', '1', '1', '2024-05-21 09:54:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7007, '20240224141452', 'Purchase', '2024-02-01', '1020101', 'Cash in Hand For Supplier E M Sargodah', '0.00', '0.00', '1', '1', '2024-05-21 09:54:57', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7008, '20240224141452', 'Purchase', '2024-02-01', '502000017', 'Supplier . E M Sargodah', '0.00', '0.00', '1', '1', '2024-05-21 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7009, '20240422114228', 'Purchase', '2024-04-22', '10107', 'Inventory Devit Supplier Perfect Sargodah', '37804.00', '0.00', '1', '1', '2024-05-21 09:57:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7010, '20240422114228', 'Purchase', '2024-04-22', '502000016', 'Supplier -Perfect Sargodah', '0.00', '37804.00', '1', '1', '2024-05-21 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7011, '20240422114228', 'Purchase', '2024-04-22', '402', 'Company Credit For SupplierPerfect Sargodah', '37804.00', '0.00', '1', '1', '2024-05-21 09:57:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7012, '20240422114228', 'Purchase', '2024-04-22', '1020101', 'Cash in Hand For Supplier Perfect Sargodah', '0.00', '0.00', '1', '1', '2024-05-21 09:57:24', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7013, '20240422114228', 'Purchase', '2024-04-22', '502000016', 'Supplier . Perfect Sargodah', '0.00', '0.00', '1', '1', '2024-05-21 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7019, '20240521101546', 'Purchase', '2024-05-21', '10107', 'Inventory Debit For Supplier Sale Return ', '44000.00', '0.00', '1', '1', '2024-05-21 10:15:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7020, '20240521101546', 'Purchase', '2024-05-21', '502000054', 'Supplier .Sale Return ', '0.00', '44000.00', '1', '1', '2024-05-21 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7021, '20240521101546', 'Purchase', '2024-05-21', '402', 'Company Credit For  Sale Return ', '44000.00', '0.00', '1', '1', '2024-05-21 10:15:46', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7022, '4745111666', 'INV', '2024-05-21', '10107', 'Inventory credit For Invoice No1475', '0.00', '122861.21', '1', '1', '2024-05-21 10:25:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7023, '4745111666', 'INVOICE', '2024-05-21', '303', 'Sale Income From Invoice NO - 1475 Customer Walking Customer', '0.00', '95560.00', '1', '1', '2024-05-21 10:25:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7024, '4745111666', 'INV', '2024-05-21', '102030000002', 'Customer debit For Invoice NO - 1475 customer-  Walking Customer', '95560.00', '0.00', '1', '1', '2024-05-21 10:25:20', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7025, '20240205160956', 'Purchase', '2023-12-31', '10107', 'Inventory Devit Supplier Millat Traders Loose Item', '145946.00', '0.00', '1', '1', '2024-05-21 10:27:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7026, '20240205160956', 'Purchase', '2023-12-31', '502000030', 'Supplier -Millat Traders Loose Item', '0.00', '145946.00', '1', '1', '2024-05-21 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7027, '20240205160956', 'Purchase', '2023-12-31', '402', 'Company Credit For SupplierMillat Traders Loose Item', '145946.00', '0.00', '1', '1', '2024-05-21 10:27:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7028, '20240205160956', 'Purchase', '2023-12-31', '1020101', 'Cash in Hand For Supplier Millat Traders Loose Item', '0.00', '0.00', '1', '1', '2024-05-21 10:27:18', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7029, '20240205160956', 'Purchase', '2023-12-31', '502000030', 'Supplier . Millat Traders Loose Item', '0.00', '0.00', '1', '1', '2024-05-21 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7030, '9131447689', 'INV', '2024-05-21', '10107', 'Inventory credit For Invoice No1476', '0.00', '40438.00', '1', '1', '2024-05-21 11:08:22', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7031, '9131447689', 'INV', '2024-05-21', '102030000002', 'Customer debit For Invoice No -  1476 Customer Walking Customer', '9810.00', '0.00', '1', '1', '2024-05-21 11:08:22', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7032, '9131447689', 'INVOICE', '2024-05-21', '303', 'Sale Income For Invoice NO - 1476 Customer Walking Customer', '0.00', '9810.00', '1', '1', '2024-05-21 11:08:22', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7041, '20240530060328', 'Purchase', '2024-05-21', '10107', 'Inventory Devit Supplier Cash Item ', '8800.00', '0.00', '1', '1', '2024-05-30 06:24:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7042, '20240530060328', 'Purchase', '2024-05-21', '502000047', 'Supplier -Cash Item ', '0.00', '8800.00', '1', '1', '2024-05-30 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7043, '20240530060328', 'Purchase', '2024-05-21', '402', 'Company Credit For SupplierCash Item ', '8800.00', '0.00', '1', '1', '2024-05-30 06:24:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7044, '20240530060328', 'Purchase', '2024-05-21', '1020101', 'Cash in Hand For Supplier Cash Item ', '0.00', '0.00', '1', '1', '2024-05-30 06:24:29', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7045, '20240530060328', 'Purchase', '2024-05-21', '502000047', 'Supplier . Cash Item ', '0.00', '0.00', '1', '1', '2024-05-30 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7049, '20240530062723', 'Purchase', '2024-05-22', '10107', 'Inventory Devit Supplier Chilton Traders Karachi', '295200.00', '0.00', '1', '1', '2024-05-30 09:08:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7050, '20240530062723', 'Purchase', '2024-05-22', '502000032', 'Supplier -Chilton Traders Karachi', '0.00', '295200.00', '1', '1', '2024-05-30 00:00:00', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7051, '20240530062723', 'Purchase', '2024-05-22', '402', 'Company Credit For SupplierChilton Traders Karachi', '295200.00', '0.00', '1', '1', '2024-05-30 09:08:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7052, '20240530062723', 'Purchase', '2024-05-22', '1020101', 'Cash in Hand For Supplier Chilton Traders Karachi', '0.00', '0.00', '1', '1', '2024-05-30 09:08:38', NULL, NULL, '1');
INSERT INTO `acc_transaction` (`ID`, `VNo`, `Vtype`, `VDate`, `COAID`, `Narration`, `Debit`, `Credit`, `IsPosted`, `CreateBy`, `CreateDate`, `UpdateBy`, `UpdateDate`, `IsAppove`) VALUES (7053, '20240530062723', 'Purchase', '2024-05-22', '502000032', 'Supplier . Chilton Traders Karachi', '0.00', '0.00', '1', '1', '2024-05-30 00:00:00', NULL, NULL, '1');


#
# TABLE STRUCTURE FOR: app_setting
#

DROP TABLE IF EXISTS `app_setting`;

CREATE TABLE `app_setting` (
  `id` int NOT NULL AUTO_INCREMENT,
  `localhserver` varchar(250) DEFAULT NULL,
  `onlineserver` varchar(250) DEFAULT NULL,
  `hotspot` varchar(250) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3;

INSERT INTO `app_setting` (`id`, `localhserver`, `onlineserver`, `hotspot`) VALUES (1, 'http://millattraders.com/saleserp', 'http://millattraders.com/saleserp', 'http://millattraders.com/saleserp');


#
# TABLE STRUCTURE FOR: attendance
#

DROP TABLE IF EXISTS `attendance`;

CREATE TABLE `attendance` (
  `att_id` int NOT NULL AUTO_INCREMENT,
  `employee_id` int NOT NULL,
  `date` date NOT NULL,
  `sign_in` varchar(30) NOT NULL,
  `sign_out` varchar(30) NOT NULL,
  `staytime` varchar(30) NOT NULL,
  PRIMARY KEY (`att_id`),
  KEY `employee_id` (`employee_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

#
# TABLE STRUCTURE FOR: bank_add
#

DROP TABLE IF EXISTS `bank_add`;

CREATE TABLE `bank_add` (
  `id` int NOT NULL AUTO_INCREMENT,
  `bank_id` varchar(255) NOT NULL,
  `bank_name` varchar(255) NOT NULL,
  `ac_name` varchar(250) DEFAULT NULL,
  `ac_number` varchar(250) DEFAULT NULL,
  `branch` varchar(250) DEFAULT NULL,
  `signature_pic` varchar(250) DEFAULT NULL,
  `status` int DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

#
# TABLE STRUCTURE FOR: company_information
#

DROP TABLE IF EXISTS `company_information`;

CREATE TABLE `company_information` (
  `company_id` varchar(250) NOT NULL,
  `company_name` varchar(50) NOT NULL,
  `email` varchar(50) NOT NULL,
  `address` text NOT NULL,
  `mobile` varchar(50) NOT NULL,
  `website` varchar(50) NOT NULL,
  `status` int NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

INSERT INTO `company_information` (`company_id`, `company_name`, `email`, `address`, `mobile`, `website`, `status`) VALUES ('1', 'MILLAT TRADERS', 'millattraders@gmail.com', 'Old Rahat Cinema Road Hyderabad', '03433669338', 'https://www.millattraders.com/', 1);


#
# TABLE STRUCTURE FOR: currency_tbl
#

DROP TABLE IF EXISTS `currency_tbl`;

CREATE TABLE `currency_tbl` (
  `id` int NOT NULL AUTO_INCREMENT,
  `currency_name` varchar(50) NOT NULL,
  `icon` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3;

INSERT INTO `currency_tbl` (`id`, `currency_name`, `icon`) VALUES (1, 'Dollar', '$');
INSERT INTO `currency_tbl` (`id`, `currency_name`, `icon`) VALUES (2, 'BDT', '৳');
INSERT INTO `currency_tbl` (`id`, `currency_name`, `icon`) VALUES (3, 'PAKISTANI', 'PKR');


#
# TABLE STRUCTURE FOR: customer_information
#

DROP TABLE IF EXISTS `customer_information`;

CREATE TABLE `customer_information` (
  `customer_id` bigint NOT NULL AUTO_INCREMENT,
  `customer_name` varchar(255) DEFAULT NULL,
  `customer_address` varchar(255) NOT NULL,
  `address2` text NOT NULL,
  `customer_mobile` varchar(100) NOT NULL,
  `customer_email` varchar(100) DEFAULT NULL,
  `email_address` varchar(200) DEFAULT NULL,
  `contact` varchar(100) DEFAULT NULL,
  `phone` varchar(50) DEFAULT NULL,
  `fax` varchar(100) DEFAULT NULL,
  `city` text,
  `state` text,
  `zip` varchar(50) DEFAULT NULL,
  `country` varchar(250) DEFAULT NULL,
  `status` int NOT NULL COMMENT '1=paid,2=credit',
  `create_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `create_by` varchar(30) DEFAULT NULL,
  PRIMARY KEY (`customer_id`),
  KEY `customer_id` (`customer_id`)
) ENGINE=MyISAM AUTO_INCREMENT=61 DEFAULT CHARSET=utf8mb3;

INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('1', 'Cash Sale', '  ', '', '01', '', '', '', '', 'fax', '', '', '', '', 2, '2024-01-23 21:54:00', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('2', 'Walking Customer', '', '', '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, '2024-01-23 22:38:03', NULL);
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('7', 'Faizan Basti ', '', '', '03133912345', '', '', '', '', '', '', '', '', '', 1, '2024-02-21 19:07:00', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('5', 'Credit Customer', '', '', '02', '', '', '', '', '', '', '', '', '', 2, '2024-02-20 19:33:58', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('6', 'H.M CABLES', '', '', '03053902175', 'hmcable9@gmail.com', '', '', '0223870706', '', '', '', '', '', 1, '2024-02-20 20:35:45', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('26', 'Ahmed kazi', '', '', '03333548292', '', '', '', '', '', '', '', '', '', 1, '2024-02-22 19:12:43', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('24', 'Mustufa Arif', '', '', '03332611331', '', '', '', '', '', '', '', '', '', 1, '2024-02-22 17:15:24', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('10', 'Zahid somoro', '', '', '031238281892', '', '', '', '', '', '', '', '', '', 1, '2024-02-21 19:08:06', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('25', 'Eman Electric', '', '', '0222787875', '', '', '', '', '', '', '', '', '', 1, '2024-02-22 17:45:02', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('12', 'M.D.M Mill', '', '', '03472518628', '', '', '', '', '', '', '', '', '', 1, '2024-02-21 19:10:18', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('13', 'National Spining', '', '', '03353317120', '', '', '', '', '', '', '', '', '', 1, '2024-02-21 19:13:55', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('14', 'C.E.P.T.C Kotri', '', '', '03343317120', '', '', '', '', '', '', '', '', '', 1, '2024-02-21 19:14:59', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('15', 'Ashfaq Electric ', '', '', '03153666300', '', '', '', '', '', '', '', '', '', 1, '2024-02-21 19:16:12', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('16', 'Ahmed Electric ', '', '', '03332820367', '', '', '', '', '', '', '', '', '', 1, '2024-02-21 19:17:10', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('17', 'Abdul Qadir Electric ', '', '', '03163758180', '', '', '', '', '', '', '', '', '', 1, '2024-02-21 19:18:16', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('18', 'Deluxe Electric', '', '', '03313637625', '', '', '', '', '', '', '', '', '', 1, '2024-02-21 19:19:27', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('19', 'Feroz Bihar Colony  ', '', '', '03003442590', '', '', '', '', '', '', '', '', '', 1, '2024-02-21 19:21:05', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('20', 'M.Z Electric', '', '', '03213674084', '', '', '', '', '', '', '', '', '', 1, '2024-02-21 19:22:19', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('21', 'M.K Electric ', '', '', '0222728027', '', '', '', '', '', '', '', '', '', 1, '2024-02-21 19:22:58', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('22', 'M.S Electric', '', '', '03233000462', '', '', '', '', '', '', '', '', '', 1, '2024-02-21 19:24:15', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('23', 'Sattar Mallah Electric', '', '', '03196851650', '', '', '', '', '', '', '', '', '', 1, '2024-02-21 19:25:03', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('27', 'Memon Light  ', '', '', '0341440445', '', '', '', '', '', '', '', '', '', 1, '2024-02-22 19:13:35', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('28', 'Khalid Marfat ', '', '', '03133587094', '', '', '', '', '', '', '', '', '', 1, '2024-02-22 19:14:29', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('29', 'M.K Electric', '', '', '0222728027', '', '', '', '', '', '', '', '', '', 1, '2024-02-22 19:15:25', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('30', 'Master Pipe', '', '', '03123240516', '', '', '', '', '', '', '', '', '', 1, '2024-02-22 19:19:21', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('31', 'Razak H.M', '', '', '03123640921', '', '', '', '', '', '', '', '', '', 1, '2024-02-22 19:21:53', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('32', 'Saffan Chilton ', '', '', '03133310784', '', '', '', '', '', '', '', '', '', 1, '2024-02-24 17:05:07', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('33', 'Ahmed Qazi', '', '', '03133587094', '', '', '', '', '', '', '', '', '', 2, '2024-02-24 17:05:37', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('34', 'Waleed Sale Man ', '', '', '03133587094', '', '', '', '', '', '', '', '', '', 1, '2024-02-24 17:06:29', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('35', 'Faheem hussnain', '', '', '03009319215', '', '', '', '', '', '', '', '', '', 1, '2024-02-25 16:26:27', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('36', 'Naeem Siyaal', '', '', '03158038836', '', '', '', '', '', '', '', '', '', 1, '2024-02-25 16:27:48', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('37', 'Usmaan Bhai', '', '', '03133587094', '', '', '', '', '', '', '', '', '', 1, '2024-02-25 16:28:25', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('38', 'Adil qasam chowk', '', '', '03133587094', '', '', '', '', '', '', '', '', '', 1, '2024-02-25 16:29:16', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('39', 'Azam Channa ', '', '', '03133587094', '', '', '', '', '', '', '', '', '', 1, '2024-02-27 15:09:17', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('40', 'G.1 LED', '', '', '03133587094', '', '', '', '', '', '', '', '', '', 1, '2024-03-05 15:27:33', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('41', 'Abdul Manaan ', '', '', '03121318656', '', '', '', '', '', '', '', '', '', 1, '2024-03-06 13:20:39', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('42', 'M.Ameen', '', '', '03433667066', '', '', '', '', '', '', '', '', '', 1, '2024-03-14 17:12:26', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('43', 'Dawood Center Auto Bhan', '', '', '03433643351', '', '', '', '', '', '', '', '', '', 1, '2024-03-20 16:08:00', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('44', 'Hamza Electric Store ', '', '', '03133775789', '', '', '', '', '', '', '', '', '', 1, '2024-03-23 17:06:22', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('45', 'shahid H.M ', '', '', '03133787094', '', '', '', '', '', '', '', '', '', 1, '2024-03-23 20:37:33', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('46', 'Zahid Sale item', '', '', '03173998131', '', '', '', '', '', '', '', '', '', 1, '2024-03-30 16:59:18', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('47', 'Zakki Sahab ', '', '', '03133787094', '', '', '', '', '', '', '', '', '', 1, '2024-03-30 19:45:20', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('48', 'Ali Bhai', '', '', '03133787094', '', '', '', '', '', '', '', '', '', 1, '2024-04-04 20:11:51', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('49', 'Cafe 7/11 ', '', '', '03133310784', '', '', '', '', '', '', '', '', '', 1, '2024-04-08 15:30:16', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('50', 'Haji Salman', '', '', '03133310784', '', '', '', '', '', '', '', '', '', 1, '2024-04-08 17:28:36', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('51', 'Arif Electriction ', '', '', '03133587094', '', '', '', '', '', '', '', '', '', 1, '2024-04-15 12:37:30', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('52', 'Riyaz Marfat ', '', '', '03133587094', '', '', '', '', '', '', '', '', '', 1, '2024-04-16 13:58:59', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('53', 'Dawood Super Mart', '', '', '03133787094', '', '', '', '', '', '', '', '', '', 1, '2024-04-24 15:00:23', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('54', 'Alfa Sale ', '', '', '033333333', '', '', '', '', '', '', '', '', '', 2, '2024-04-25 17:43:09', '1');
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('55', 'Mamu Jee', '', '', '03333333333', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, '2024-05-02 18:10:37', NULL);
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('56', 'S.E Light', '', '', '033333333', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, '2024-05-07 14:56:28', NULL);
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('57', 'breez Chemical Mill', ' ', '', '033333333', '', '', '', '', 'fax', '', '', '', '', 1, '2024-05-09 20:33:14', NULL);
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('58', 'Shano Contactor', '', '', '0000000000', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, '2024-05-12 18:10:54', NULL);
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('59', 'Chilton karachi ', '', '', '00000000000', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, '2024-05-14 20:36:10', NULL);
INSERT INTO `customer_information` (`customer_id`, `customer_name`, `customer_address`, `address2`, `customer_mobile`, `customer_email`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `status`, `create_date`, `create_by`) VALUES ('60', 'Nadeem Bhai ', '', '', '0000000', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, '2024-05-14 20:38:25', NULL);


#
# TABLE STRUCTURE FOR: daily_banking_add
#

DROP TABLE IF EXISTS `daily_banking_add`;

CREATE TABLE `daily_banking_add` (
  `banking_id` varchar(255) NOT NULL,
  `date` datetime DEFAULT NULL,
  `bank_id` varchar(100) DEFAULT NULL,
  `deposit_type` varchar(255) DEFAULT NULL,
  `transaction_type` varchar(255) DEFAULT NULL,
  `description` text,
  `amount` int DEFAULT NULL,
  `status` int DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

#
# TABLE STRUCTURE FOR: daily_closing
#

DROP TABLE IF EXISTS `daily_closing`;

CREATE TABLE `daily_closing` (
  `closing_id` varchar(255) NOT NULL,
  `last_day_closing` float NOT NULL,
  `cash_in` float NOT NULL,
  `cash_out` float NOT NULL,
  `date` varchar(250) NOT NULL,
  `amount` float NOT NULL,
  `adjustment` float DEFAULT NULL,
  `status` int NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

#
# TABLE STRUCTURE FOR: designation
#

DROP TABLE IF EXISTS `designation`;

CREATE TABLE `designation` (
  `id` int NOT NULL AUTO_INCREMENT,
  `designation` varchar(150) NOT NULL,
  `details` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

#
# TABLE STRUCTURE FOR: email_config
#

DROP TABLE IF EXISTS `email_config`;

CREATE TABLE `email_config` (
  `id` int NOT NULL AUTO_INCREMENT,
  `protocol` text NOT NULL,
  `smtp_host` text NOT NULL,
  `smtp_port` text NOT NULL,
  `smtp_user` varchar(35) NOT NULL,
  `smtp_pass` varchar(35) NOT NULL,
  `mailtype` varchar(30) DEFAULT NULL,
  `isinvoice` tinyint NOT NULL,
  `isservice` tinyint NOT NULL,
  `isquotation` tinyint NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3;

INSERT INTO `email_config` (`id`, `protocol`, `smtp_host`, `smtp_port`, `smtp_user`, `smtp_pass`, `mailtype`, `isinvoice`, `isservice`, `isquotation`) VALUES (1, 'ssmtp', 'ssl://ssmtp.gmail.com', '25', 'demo@gmail.com', 'demo123456', 'html', 0, 0, 0);


#
# TABLE STRUCTURE FOR: employee_history
#

DROP TABLE IF EXISTS `employee_history`;

CREATE TABLE `employee_history` (
  `id` int NOT NULL AUTO_INCREMENT,
  `first_name` varchar(50) NOT NULL,
  `last_name` varchar(50) NOT NULL,
  `designation` varchar(100) NOT NULL,
  `phone` varchar(50) NOT NULL,
  `rate_type` int NOT NULL,
  `hrate` float NOT NULL,
  `email` varchar(50) NOT NULL,
  `blood_group` varchar(10) NOT NULL,
  `address_line_1` text NOT NULL,
  `address_line_2` text NOT NULL,
  `image` text,
  `country` varchar(50) NOT NULL,
  `city` varchar(50) NOT NULL,
  `zip` varchar(50) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

#
# TABLE STRUCTURE FOR: employee_salary_payment
#

DROP TABLE IF EXISTS `employee_salary_payment`;

CREATE TABLE `employee_salary_payment` (
  `emp_sal_pay_id` int NOT NULL AUTO_INCREMENT,
  `generate_id` int NOT NULL,
  `employee_id` varchar(50) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `total_salary` decimal(18,2) NOT NULL DEFAULT '0.00',
  `total_working_minutes` varchar(50) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `working_period` varchar(50) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `payment_due` varchar(50) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `payment_date` varchar(50) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `paid_by` varchar(50) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `salary_month` varchar(70) DEFAULT NULL,
  PRIMARY KEY (`emp_sal_pay_id`),
  KEY `employee_id` (`employee_id`),
  KEY `generate_id` (`generate_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

#
# TABLE STRUCTURE FOR: employee_salary_setup
#

DROP TABLE IF EXISTS `employee_salary_setup`;

CREATE TABLE `employee_salary_setup` (
  `e_s_s_id` int unsigned NOT NULL AUTO_INCREMENT,
  `employee_id` varchar(30) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `sal_type` varchar(30) NOT NULL,
  `salary_type_id` varchar(30) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `amount` decimal(12,2) NOT NULL DEFAULT '0.00',
  `create_date` date DEFAULT NULL,
  `update_date` datetime(6) DEFAULT NULL,
  `update_id` varchar(30) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `gross_salary` float NOT NULL,
  PRIMARY KEY (`e_s_s_id`),
  KEY `employee_id` (`employee_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

#
# TABLE STRUCTURE FOR: expense
#

DROP TABLE IF EXISTS `expense`;

CREATE TABLE `expense` (
  `id` int NOT NULL AUTO_INCREMENT,
  `date` date NOT NULL,
  `type` varchar(100) NOT NULL,
  `voucher_no` varchar(50) NOT NULL,
  `amount` float NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

#
# TABLE STRUCTURE FOR: expense_item
#

DROP TABLE IF EXISTS `expense_item`;

CREATE TABLE `expense_item` (
  `id` int NOT NULL AUTO_INCREMENT,
  `expense_item_name` varchar(200) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

#
# TABLE STRUCTURE FOR: invoice
#

DROP TABLE IF EXISTS `invoice`;

CREATE TABLE `invoice` (
  `id` int NOT NULL AUTO_INCREMENT,
  `invoice_id` bigint NOT NULL,
  `customer_id` bigint NOT NULL,
  `date` varchar(50) DEFAULT NULL,
  `total_amount` decimal(18,2) NOT NULL DEFAULT '0.00',
  `paid_amount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `due_amount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `prevous_due` decimal(20,2) NOT NULL DEFAULT '0.00',
  `shipping_cost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `invoice` bigint NOT NULL,
  `invoice_discount` decimal(10,2) DEFAULT '0.00' COMMENT 'invoice discount',
  `total_discount` decimal(10,2) DEFAULT '0.00' COMMENT 'total invoice discount',
  `total_tax` decimal(10,2) DEFAULT '0.00',
  `sales_by` varchar(50) NOT NULL,
  `invoice_details` text NOT NULL,
  `status` int NOT NULL,
  `bank_id` varchar(30) DEFAULT NULL,
  `payment_type` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `customer_id` (`customer_id`),
  KEY `invoice_id` (`invoice_id`)
) ENGINE=MyISAM AUTO_INCREMENT=478 DEFAULT CHARSET=utf8mb3;

INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (1, '5845776228', '2', '2023-12-24', '2525.00', '0.00', '2525.00', '0.00', '0.00', '1000', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (2, '6124985648', '2', '2023-12-24', '600.00', '0.00', '600.00', '0.00', '0.00', '1001', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (3, '4977174268', '2', '2023-12-25', '2370.00', '0.00', '2370.00', '0.00', '0.00', '1002', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (4, '4612744893', '2', '2023-12-25', '5550.00', '0.00', '5550.00', '0.00', '0.00', '1003', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (5, '2567782964', '2', '2023-12-26', '31510.00', '0.00', '31510.00', '0.00', '0.00', '1004', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (6, '9779858312', '2', '2023-12-27', '10640.00', '0.00', '10640.00', '0.00', '0.00', '1005', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (7, '3284257142', '2', '2023-12-28', '5996.00', '0.00', '5996.00', '0.00', '0.00', '1006', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (8, '9175169491', '2', '2023-12-30', '2500.00', '0.00', '2500.00', '0.00', '0.00', '1007', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (9, '5669212287', '2', '2023-12-31', '111260.00', '0.00', '111260.00', '0.00', '0.00', '1008', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (10, '8115955164', '2', '2024-01-01', '3300.00', '0.00', '3300.00', '0.00', '0.00', '1009', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (11, '6448414167', '2', '2024-01-02', '5000.00', '0.00', '5000.00', '0.00', '0.00', '1010', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (12, '7816741612', '2', '2024-01-03', '23100.00', '0.00', '23100.00', '0.00', '0.00', '1011', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (13, '4995667463', '2', '2024-01-04', '24320.00', '0.00', '24320.00', '0.00', '0.00', '1012', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (14, '7328171614', '2', '2024-01-06', '50310.00', '0.00', '50310.00', '0.00', '0.00', '1013', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (15, '6686419811', '2', '2024-01-07', '6780.00', '0.00', '6780.00', '0.00', '0.00', '1014', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (16, '4856684174', '2', '2024-01-08', '7650.00', '0.00', '7650.00', '0.00', '0.00', '1015', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (17, '1826916967', '2', '2024-01-09', '910.00', '0.00', '910.00', '0.00', '0.00', '1016', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (18, '5976692598', '2', '2024-01-10', '2500.00', '0.00', '2500.00', '0.00', '0.00', '1017', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (19, '3371369953', '2', '2024-01-11', '19820.00', '0.00', '19820.00', '0.00', '0.00', '1018', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (20, '7976724629', '2', '2024-01-11', '15520.00', '0.00', '15520.00', '0.00', '0.00', '1019', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (21, '1249729836', '2', '2024-01-13', '50010.00', '0.00', '50010.00', '0.00', '0.00', '1020', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (22, '9759274115', '2', '2024-01-14', '11010.00', '0.00', '11010.00', '0.00', '0.00', '1021', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (23, '7677745934', '2', '2024-01-15', '7960.00', '0.00', '7960.00', '0.00', '0.00', '1022', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (24, '4651242384', '2', '2024-01-16', '19980.00', '0.00', '19980.00', '0.00', '0.00', '1023', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (25, '6139664445', '2', '2024-01-17', '24740.00', '0.00', '24740.00', '0.00', '0.00', '1024', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (26, '9814175468', '2', '2024-01-18', '400.00', '0.00', '400.00', '0.00', '0.00', '1025', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (27, '8729851784', '2', '2024-01-20', '2400.00', '0.00', '2400.00', '0.00', '0.00', '1026', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (28, '2724633553', '2', '2024-01-21', '72150.00', '0.00', '72150.00', '0.00', '0.00', '1027', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (29, '8125379816', '2', '2024-01-22', '78805.00', '0.00', '78805.00', '0.00', '0.00', '1028', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (30, '7644324833', '2', '2024-01-23', '55610.00', '0.00', '55610.00', '0.00', '0.00', '1029', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (31, '1345623824', '2', '2024-01-24', '10730.00', '0.00', '10730.00', '0.00', '0.00', '1030', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (32, '5144393325', '2', '2024-01-25', '2000.00', '0.00', '2000.00', '0.00', '0.00', '1031', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (33, '4148625191', '2', '2024-01-27', '177720.00', '0.00', '177720.00', '0.00', '0.00', '1032', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (34, '4365216877', '2', '2024-01-28', '88130.00', '0.00', '88130.00', '0.00', '0.00', '1033', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (35, '4863552591', '2', '2024-01-29', '1500.00', '0.00', '1500.00', '0.00', '0.00', '1034', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (36, '1589449478', '2', '2024-01-31', '10700.00', '0.00', '10700.00', '0.00', '0.00', '1035', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (37, '4687811218', '2', '2024-01-30', '10700.00', '0.00', '10700.00', '0.00', '0.00', '1036', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (38, '9619147336', '2', '2024-01-31', '50140.00', '0.00', '50140.00', '0.00', '0.00', '1037', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (39, '2744992295', '2', '2024-02-01', '30720.00', '0.00', '30720.00', '0.00', '0.00', '1038', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (40, '1246899298', '6', '2024-01-03', '9440.00', '0.00', '9440.00', '0.00', '0.00', '1039', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (41, '4732574941', '6', '2024-01-04', '45050.00', '0.00', '54490.00', '9440.00', '0.00', '1040', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (42, '6671999227', '6', '2024-01-06', '11500.00', '0.00', '65990.00', '54490.00', '0.00', '1041', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (43, '6776515978', '6', '2024-01-07', '31800.00', '0.00', '97790.00', '65990.00', '0.00', '1042', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (44, '5329238352', '6', '2024-01-13', '3550.00', '0.00', '101340.00', '97790.00', '0.00', '1043', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (45, '3187145389', '6', '2024-01-13', '29800.00', '0.00', '131140.00', '101340.00', '0.00', '1044', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (46, '9741378871', '6', '2024-01-13', '25660.00', '0.00', '156800.00', '131140.00', '0.00', '1045', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (47, '3215962328', '6', '2024-01-14', '30540.00', '0.00', '187340.00', '156800.00', '0.00', '1046', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (48, '1844216916', '6', '2024-01-16', '31800.00', '0.00', '219140.00', '187340.00', '0.00', '1047', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (49, '5337563468', '6', '2024-01-16', '18450.00', '0.00', '237590.00', '219140.00', '0.00', '1048', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (50, '2824924738', '6', '2024-01-18', '12090.00', '0.00', '249680.00', '237590.00', '0.00', '1049', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (51, '6524154835', '6', '2024-01-19', '25440.00', '0.00', '25440.00', '249680.00', '0.00', '1050', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (52, '2892979613', '6', '2024-01-19', '25590.00', '0.00', '300710.00', '275120.00', '0.00', '1051', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (53, '3895873329', '6', '2024-01-20', '126680.00', '0.00', '427390.00', '300710.00', '0.00', '1052', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (54, '2769281188', '6', '2024-01-22', '50000.00', '0.00', '477390.00', '427390.00', '0.00', '1053', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (55, '3928135646', '6', '2024-01-23', '182600.00', '0.00', '659990.00', '477390.00', '0.00', '1054', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (56, '2496582565', '6', '2024-01-24', '2700.00', '0.00', '662690.00', '659990.00', '0.00', '1055', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (57, '2135868574', '24', '2024-01-04', '0.00', '0.00', '659990.00', '246480.00', '0.00', '1056', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (58, '5243247132', '6', '2024-01-24', '10760.00', '0.00', '676150.00', '665390.00', '0.00', '1057', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (59, '1537578668', '6', '2024-01-25', '5700.00', '0.00', '681850.00', '676150.00', '0.00', '1058', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (60, '7242458569', '6', '2024-01-30', '19000.00', '0.00', '700850.00', '681850.00', '0.00', '1059', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (61, '8155338425', '6', '2024-01-31', '5700.00', '0.00', '706550.00', '700850.00', '0.00', '1060', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (62, '9184796385', '6', '2024-01-31', '11730.00', '0.00', '718280.00', '706550.00', '0.00', '1061', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (63, '4495791598', '6', '2024-01-24', '3370.00', '0.00', '721650.00', '718280.00', '0.00', '1062', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (64, '2153462153', '6', '2024-01-31', '560.00', '0.00', '722210.00', '721650.00', '0.00', '1063', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (65, '1389596898', '12', '2023-12-30', '25650.00', '0.00', '25650.00', '0.00', '0.00', '1064', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (66, '2976925275', '12', '2023-12-31', '22800.00', '0.00', '48450.00', '25650.00', '0.00', '1065', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (67, '9441918497', '12', '2024-01-06', '6260.00', '0.00', '54710.00', '48450.00', '0.00', '1066', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (68, '7267276659', '12', '2024-01-09', '11400.00', '0.00', '66110.00', '54710.00', '0.00', '1067', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (69, '9363166494', '12', '2024-01-20', '156600.00', '0.00', '222710.00', '66110.00', '0.00', '1068', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (70, '9644382867', '23', '2024-01-04', '24600.00', '0.00', '24600.00', '0.00', '0.00', '1069', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (71, '1961533534', '23', '2024-01-29', '32490.00', '0.00', '57090.00', '24600.00', '0.00', '1070', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (72, '7978897387', '23', '2024-01-29', '5160.00', '0.00', '62250.00', '57090.00', '0.00', '1071', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (73, '2212879286', '7', '2024-01-06', '11620.00', '0.00', '11620.00', '0.00', '0.00', '1072', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (74, '1694367774', '23', '2024-01-06', '23036.00', '0.00', '85286.00', '62250.00', '0.00', '1073', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (75, '7318964635', '7', '2024-01-07', '2400.00', '0.00', '14200.00', '11800.00', '0.00', '1074', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (76, '6569258597', '7', '2024-01-09', '13260.00', '0.00', '27460.00', '14200.00', '0.00', '1075', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (77, '7317117295', '7', '2024-01-11', '5332.00', '0.00', '32792.00', '27460.00', '0.00', '1076', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (78, '3346761442', '7', '2024-01-13', '3720.00', '0.00', '36512.00', '32792.00', '0.00', '1077', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (79, '6777296441', '7', '2024-01-17', '10400.00', '0.00', '46912.00', '36512.00', '0.00', '1078', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (80, '7418519547', '24', '2024-01-17', '0.00', '0.00', '36512.00', '246480.00', '0.00', '1079', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (81, '5633688734', '7', '2024-01-20', '1630.00', '0.00', '58942.00', '57312.00', '0.00', '1080', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (82, '1145742434', '7', '2024-01-23', '7930.00', '0.00', '66872.00', '58942.00', '0.00', '1081', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (83, '5345941923', '7', '2024-01-28', '8850.00', '0.00', '75722.00', '66872.00', '0.00', '1082', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (84, '8647385565', '10', '2024-01-16', '42800.00', '0.00', '42800.00', '0.00', '0.00', '1083', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (85, '1512229224', '10', '2024-01-21', '22000.00', '0.00', '64800.00', '42800.00', '0.00', '1084', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (86, '5198483319', '10', '2024-01-22', '21200.00', '0.00', '86000.00', '64800.00', '0.00', '1085', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (87, '1247375455', '10', '2024-01-23', '12000.00', '0.00', '98000.00', '86000.00', '0.00', '1086', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (88, '8442146984', '10', '2024-01-27', '18000.00', '0.00', '116000.00', '98000.00', '0.00', '1087', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (89, '6457347775', '10', '2024-01-28', '3280.00', '0.00', '119280.00', '116000.00', '0.00', '1088', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (90, '8951465191', '10', '2024-01-30', '18400.00', '0.00', '137680.00', '119280.00', '0.00', '1089', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (91, '3846623832', '18', '2024-01-04', '45100.00', '0.00', '45100.00', '0.00', '0.00', '1090', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (92, '7939478389', '18', '2024-01-17', '2750.00', '0.00', '47850.00', '45100.00', '0.00', '1091', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (93, '9574331962', '18', '2024-01-21', '37000.00', '0.00', '84850.00', '47850.00', '0.00', '1092', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (94, '4474956213', '18', '2024-01-23', '40700.00', '0.00', '125550.00', '84850.00', '0.00', '1093', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (95, '5827966316', '18', '2024-01-23', '35166.00', '0.00', '160716.00', '125550.00', '0.00', '1094', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (96, '3629774983', '18', '2024-01-23', '37300.00', '0.00', '162850.00', '125550.00', '0.00', '1095', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (97, '7537392644', '18', '2024-01-25', '780.00', '0.00', '198796.00', '198016.00', '0.00', '1096', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (98, '5814974916', '18', '2024-01-31', '17400.00', '0.00', '216196.00', '198796.00', '0.00', '1097', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (99, '3887523765', '24', '2024-01-04', '43350.00', '0.00', '43350.00', '0.00', '0.00', '1098', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (100, '5137841171', '24', '2024-01-04', '0.00', '0.00', '0.00', '0.00', '0.00', '1099', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (101, '9293972658', '24', '2024-01-04', '0.00', '0.00', '0.00', '0.00', '0.00', '1100', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (102, '3491818584', '24', '2024-01-04', '0.00', '0.00', '0.00', '0.00', '0.00', '1101', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (103, '7435381842', '24', '2024-01-04', '0.00', '0.00', '0.00', '0.00', '0.00', '1102', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (104, '4247718784', '24', '2024-01-04', '0.00', '0.00', '0.00', '0.00', '0.00', '1103', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (105, '1216835466', '24', '2024-01-04', '0.00', '0.00', '0.00', '0.00', '0.00', '1104', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (106, '3978519419', '24', '2024-01-09', '7600.00', '0.00', '311050.00', '303450.00', '0.00', '1105', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (107, '4876678161', '25', '2024-01-06', '5350.00', '0.00', '5350.00', '0.00', '0.00', '1106', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (108, '6845814617', '16', '2024-01-06', '7160.00', '0.00', '7160.00', '0.00', '0.00', '1107', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (109, '2687949442', '20', '2024-01-06', '9880.00', '0.00', '9880.00', '0.00', '0.00', '1108', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (110, '3174111365', '13', '2024-01-09', '216420.00', '0.00', '216420.00', '0.00', '0.00', '1109', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (111, '6686827297', '13', '2024-01-10', '70000.00', '0.00', '286420.00', '216420.00', '0.00', '1110', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (112, '5956241346', '13', '2024-01-17', '37200.00', '0.00', '323620.00', '286420.00', '0.00', '1111', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (113, '5917543216', '13', '2024-01-18', '18780.00', '0.00', '342400.00', '323620.00', '0.00', '1112', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (114, '8875543688', '13', '2024-02-01', '8400.00', '0.00', '350800.00', '342400.00', '0.00', '1113', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (115, '1353652854', '25', '2024-01-11', '2880.00', '0.00', '5030.00', '2150.00', '0.00', '1114', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (116, '4299693644', '25', '2024-01-21', '9220.00', '0.00', '14250.00', '5030.00', '0.00', '1115', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (117, '2558616487', '28', '2024-01-06', '14560.00', '0.00', '14560.00', '0.00', '0.00', '1116', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (118, '5312784753', '14', '2024-01-07', '3920.00', '0.00', '3920.00', '0.00', '0.00', '1117', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (119, '9453311658', '27', '2024-01-11', '59800.00', '0.00', '59800.00', '0.00', '0.00', '1118', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (120, '1224191136', '27', '2024-01-16', '59220.00', '0.00', '119020.00', '59800.00', '0.00', '1119', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (121, '2784477898', '27', '2024-01-25', '41500.00', '0.00', '160520.00', '119020.00', '0.00', '1120', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (122, '5821247238', '27', '2024-01-25', '275170.00', '0.00', '435690.00', '160520.00', '0.00', '1121', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (123, '8636229268', '30', '2024-01-17', '43477.00', '0.00', '43477.00', '0.00', '0.00', '1122', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (124, '1775667854', '31', '2024-01-21', '14150.00', '0.00', '14150.00', '0.00', '0.00', '1123', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (125, '9721211439', '17', '2024-01-28', '93000.00', '0.00', '93000.00', '0.00', '0.00', '1124', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (126, '5445939478', '21', '2024-01-23', '287610.00', '0.00', '287610.00', '0.00', '0.00', '1125', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (127, '7438387912', '19', '2024-01-25', '24200.00', '0.00', '24200.00', '0.00', '0.00', '1126', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (128, '6659953793', '34', '2024-01-29', '52500.00', '0.00', '52500.00', '0.00', '0.00', '1127', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (129, '1345872945', '26', '2024-02-24', '43300.00', '0.00', '43300.00', '0.00', '0.00', '1128', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (130, '9837819267', '32', '2024-01-25', '15220.00', '0.00', '15220.00', '0.00', '0.00', '1129', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (131, '8421377642', '22', '2024-01-30', '20800.00', '0.00', '20800.00', '0.00', '0.00', '1130', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (132, '3455599945', '19', '2024-01-29', '45800.00', '0.00', '70000.00', '24200.00', '0.00', '1131', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (133, '7315183996', '6', '2024-01-01', '247040.00', '0.00', '969250.00', '722210.00', '0.00', '1132', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (134, '3261562757', '6', '2024-02-02', '154700.00', '0.00', '1123950.00', '969250.00', '0.00', '1133', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (135, '1556349912', '6', '2024-02-05', '4090.00', '0.00', '1128040.00', '1123950.00', '0.00', '1134', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (136, '6295972662', '6', '2024-02-07', '11120.00', '0.00', '1138350.00', '1127230.00', '0.00', '1135', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (137, '6258163824', '6', '2024-02-07', '38000.00', '0.00', '1176350.00', '1138350.00', '0.00', '1136', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (138, '5148215591', '6', '2024-02-11', '30230.00', '0.00', '1206580.00', '1176350.00', '0.00', '1137', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (139, '3911836699', '6', '2024-02-12', '1900.00', '0.00', '1208480.00', '1206580.00', '0.00', '1138', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (140, '1753277465', '6', '2024-02-15', '80230.00', '0.00', '1288710.00', '1208480.00', '0.00', '1139', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (141, '1413256793', '6', '2024-02-16', '14750.00', '0.00', '1303460.00', '1288710.00', '0.00', '1140', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (142, '2823655468', '6', '2024-02-19', '5500.00', '0.00', '1309770.00', '1304270.00', '0.00', '1141', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (143, '9555192325', '15', '2024-02-03', '90000.00', '0.00', '90000.00', '0.00', '0.00', '1142', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (144, '9844494798', '18', '2024-02-03', '12220.00', '0.00', '228416.00', '216196.00', '0.00', '1143', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (145, '5993242736', '26', '2024-02-03', '12900.00', '0.00', '56200.00', '43300.00', '0.00', '1144', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (146, '6128491668', '7', '2024-02-03', '7840.00', '0.00', '83382.00', '75542.00', '0.00', '1145', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (147, '3233778328', '25', '2024-02-03', '15680.00', '0.00', '33130.00', '17450.00', '0.00', '1146', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (148, '4167744585', '20', '2024-02-03', '5370.00', '0.00', '15250.00', '9880.00', '0.00', '1147', '0.00', '0.00', '0.00', '1', 'Thank You For Shopping Us ', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (149, '3648649638', '22', '2024-02-06', '6000.00', '0.00', '26800.00', '20800.00', '0.00', '1148', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (150, '5862996656', '27', '2024-02-07', '7200.00', '0.00', '442890.00', '435690.00', '0.00', '1149', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (151, '1916531934', '10', '2024-02-07', '2960.00', '0.00', '140640.00', '137680.00', '0.00', '1150', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (152, '3828982476', '18', '2024-02-07', '4690.00', '0.00', '233106.00', '228416.00', '0.00', '1151', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (153, '8583371169', '10', '2024-02-07', '18000.00', '0.00', '161040.00', '143040.00', '0.00', '1152', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (154, '2635796229', '7', '2024-02-10', '20020.00', '0.00', '103382.00', '83362.00', '0.00', '1153', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (155, '6266215734', '18', '2024-02-10', '43825.00', '0.00', '275791.00', '231966.00', '0.00', '1154', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (156, '8461482622', '20', '2024-02-10', '7250.00', '0.00', '20880.00', '13630.00', '0.00', '1155', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (157, '2947285344', '21', '2024-02-11', '8700.00', '0.00', '296310.00', '287610.00', '0.00', '1156', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (158, '1197737314', '18', '2024-02-13', '62300.00', '0.00', '338091.00', '275791.00', '0.00', '1157', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (159, '7979943364', '21', '2024-02-13', '70850.00', '0.00', '367160.00', '296310.00', '0.00', '1158', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (160, '4611418728', '20', '2024-02-13', '5200.00', '0.00', '20480.00', '15280.00', '0.00', '1159', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (161, '7638831343', '20', '2024-02-13', '5200.00', '0.00', '20480.00', '15280.00', '0.00', '1160', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (162, '9149799129', '32', '2024-02-13', '160809.00', '0.00', '176029.00', '15220.00', '0.00', '1161', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (163, '9259517748', '32', '2024-02-13', '159240.00', '0.00', '174460.00', '15220.00', '0.00', '1162', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (164, '2832617851', '7', '2024-02-14', '20300.00', '0.00', '123682.00', '103382.00', '0.00', '1163', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (165, '9653111997', '12', '2024-02-15', '12600.00', '0.00', '235310.00', '222710.00', '0.00', '1164', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (166, '4722732758', '18', '2024-02-15', '19675.00', '0.00', '357766.00', '338091.00', '0.00', '1165', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (167, '7327496538', '10', '2024-02-18', '24600.00', '0.00', '185640.00', '161040.00', '0.00', '1166', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (168, '5217114917', '7', '2024-02-18', '4920.00', '0.00', '128602.00', '123682.00', '0.00', '1167', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (169, '6754142711', '20', '2024-02-18', '22050.00', '0.00', '47730.00', '25680.00', '0.00', '1168', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (170, '2347643624', '29', '2024-02-18', '7580.00', '0.00', '7580.00', '0.00', '0.00', '1169', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (171, '8243172374', '35', '2024-02-21', '355000.00', '0.00', '355000.00', '0.00', '0.00', '1170', '4600.00', '4600.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (172, '7122648312', '37', '2024-02-12', '268990.00', '0.00', '268990.00', '0.00', '0.00', '1171', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (173, '4177459154', '38', '2024-02-04', '12180.00', '0.00', '12180.00', '0.00', '0.00', '1172', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (174, '1181438141', '36', '2024-02-18', '16500.00', '0.00', '16500.00', '0.00', '0.00', '1173', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (175, '5891635397', '39', '2024-02-13', '36010.00', '0.00', '36010.00', '0.00', '0.00', '1174', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (176, '6262367751', '18', '2024-02-21', '67125.00', '0.00', '424891.00', '357766.00', '0.00', '1175', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (177, '3817238736', '10', '2024-02-21', '37200.00', '0.00', '222840.00', '185640.00', '0.00', '1176', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (178, '4626259438', '21', '2024-02-22', '12400.00', '0.00', '379560.00', '367160.00', '0.00', '1177', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (179, '2752246514', '10', '2024-02-22', '9450.00', '0.00', '232290.00', '222840.00', '0.00', '1178', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (180, '2184931446', '7', '2024-02-22', '20800.00', '0.00', '147682.00', '126882.00', '0.00', '1179', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (181, '6727539696', '10', '2024-02-24', '7300.00', '0.00', '239590.00', '232290.00', '0.00', '1180', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (182, '1358638581', '12', '2024-02-27', '13700.00', '0.00', '249010.00', '235310.00', '0.00', '1181', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (183, '5566655768', '12', '2024-02-24', '145720.00', '0.00', '394730.00', '249010.00', '0.00', '1182', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (184, '6197141427', '2', '2024-02-03', '9560.00', '0.00', '9560.00', '0.00', '0.00', '1183', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (185, '6284454277', '2', '2024-02-04', '4320.00', '0.00', '4320.00', '0.00', '0.00', '1184', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (186, '5323971621', '2', '2024-02-05', '1710.00', '0.00', '1710.00', '0.00', '0.00', '1185', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (187, '8517813777', '2', '2024-02-06', '46974.00', '0.00', '46974.00', '0.00', '0.00', '1186', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (188, '7446617154', '2', '2024-02-07', '5600.00', '0.00', '5600.00', '0.00', '0.00', '1187', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (189, '7214457359', '2', '2024-02-10', '32136.00', '0.00', '32136.00', '0.00', '0.00', '1188', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (190, '9845441218', '2', '2024-02-11', '32950.00', '0.00', '32950.00', '0.00', '0.00', '1189', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (191, '8668857166', '2', '2024-02-12', '33197.00', '0.00', '33197.00', '0.00', '0.00', '1190', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (192, '7567791142', '2', '2024-02-13', '2900.00', '0.00', '2900.00', '0.00', '0.00', '1191', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (193, '8588781131', '2', '2024-02-14', '47930.00', '0.00', '47930.00', '0.00', '0.00', '1192', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (194, '2737884135', '2', '2024-02-15', '55589.00', '0.00', '55589.00', '0.00', '0.00', '1193', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (195, '1115919194', '2', '2024-02-17', '127105.00', '0.00', '127105.00', '0.00', '0.00', '1194', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (196, '5233818293', '2', '2024-02-18', '14900.00', '0.00', '14900.00', '0.00', '0.00', '1195', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (197, '1981932215', '2', '2024-02-19', '38030.00', '0.00', '38030.00', '0.00', '0.00', '1196', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (198, '2968574474', '2', '2024-02-20', '9100.00', '0.00', '9100.00', '0.00', '0.00', '1197', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (199, '9793391551', '2', '2024-02-21', '42705.00', '0.00', '42705.00', '0.00', '0.00', '1198', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (200, '3317182685', '2', '2024-02-22', '3630.00', '0.00', '3630.00', '0.00', '0.00', '1199', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (201, '3655828734', '2', '2024-02-24', '33140.00', '0.00', '33140.00', '0.00', '0.00', '1200', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (202, '3978355951', '2', '2024-02-25', '53600.00', '0.00', '53600.00', '0.00', '0.00', '1201', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (203, '9994122257', '2', '2024-02-27', '29700.00', '0.00', '29700.00', '0.00', '0.00', '1202', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (204, '2185662296', '2', '2024-02-28', '26525.00', '0.00', '26525.00', '0.00', '0.00', '1203', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (205, '7551413551', '2', '2024-02-29', '23740.00', '0.00', '23740.00', '0.00', '0.00', '1204', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (206, '2943739531', '18', '2024-02-24', '61000.00', '0.00', '485891.00', '424891.00', '0.00', '1205', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (207, '8439691471', '27', '2024-02-24', '12360.00', '0.00', '455250.00', '442890.00', '0.00', '1206', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (208, '3266869518', '7', '2024-02-24', '6910.00', '0.00', '156512.00', '149602.00', '0.00', '1207', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (209, '8411284899', '18', '2024-02-25', '132000.00', '0.00', '582791.00', '450791.00', '0.00', '1208', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (210, '8876911595', '13', '2024-02-27', '10500.00', '0.00', '361300.00', '350800.00', '0.00', '1209', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (211, '9518822344', '7', '2024-02-28', '10580.00', '0.00', '167092.00', '156512.00', '0.00', '1210', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (212, '6853249324', '17', '2024-02-28', '48450.00', '0.00', '141450.00', '93000.00', '0.00', '1211', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (213, '2813146579', '7', '2024-02-28', '27600.00', '0.00', '194692.00', '167092.00', '0.00', '1212', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (214, '1515783136', '27', '2024-02-28', '101485.00', '0.00', '556735.00', '455250.00', '0.00', '1213', '52280.00', '52280.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (215, '7317298758', '18', '2024-02-28', '20500.00', '0.00', '603291.00', '582791.00', '0.00', '1214', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (216, '3487797747', '17', '2024-02-28', '73600.00', '0.00', '215050.00', '141450.00', '0.00', '1215', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (217, '2767374889', '32', '2024-02-29', '75158.00', '0.00', '410427.00', '335269.00', '0.00', '1216', '38717.00', '38717.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (218, '4739166969', '21', '2024-02-29', '3200.00', '0.00', '382760.00', '379560.00', '0.00', '1217', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (219, '1999134661', '2', '2024-03-02', '28450.00', '0.00', '28450.00', '0.00', '0.00', '1218', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (220, '5892378914', '17', '2024-03-02', '75480.00', '0.00', '290530.00', '215050.00', '0.00', '1219', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (221, '3529147678', '7', '2024-03-03', '8160.00', '0.00', '202852.00', '194692.00', '0.00', '1220', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (222, '3213317312', '18', '2024-03-03', '17250.00', '0.00', '620541.00', '603291.00', '0.00', '1221', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (223, '2152271745', '32', '2024-02-03', '45095.00', '0.00', '455522.00', '410427.00', '0.00', '1222', '23230.00', '23230.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (224, '6726515132', '25', '2024-03-03', '14500.00', '0.00', '47630.00', '33130.00', '0.00', '1223', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (225, '3798734435', '2', '2024-03-03', '1640.00', '0.00', '1640.00', '0.00', '0.00', '1224', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (226, '1995273414', '2', '2024-03-04', '4550.00', '0.00', '4550.00', '0.00', '0.00', '1225', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (227, '5218857126', '13', '2024-03-04', '1500.00', '0.00', '362800.00', '361300.00', '0.00', '1226', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (228, '3653113769', '40', '2024-02-21', '4700.00', '0.00', '4700.00', '0.00', '0.00', '1227', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (229, '3286836845', '41', '2024-03-05', '22940.00', '0.00', '22940.00', '0.00', '0.00', '1228', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (230, '4247543232', '6', '2024-03-05', '32000.00', '0.00', '1341770.00', '1309770.00', '0.00', '1229', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (231, '9652589483', '6', '2024-02-25', '37800.00', '0.00', '1379570.00', '1341770.00', '0.00', '1230', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (232, '3755764352', '6', '2024-02-27', '9360.00', '0.00', '1388630.00', '1379270.00', '0.00', '1231', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (233, '7279214426', '6', '2024-02-29', '13400.00', '0.00', '1402030.00', '1388630.00', '0.00', '1232', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (234, '2181869592', '25', '2024-03-06', '47900.00', '0.00', '95530.00', '47630.00', '0.00', '1233', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (235, '2433914368', '27', '2024-03-06', '15920.00', '0.00', '572655.00', '556735.00', '0.00', '1234', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (236, '3718624612', '20', '2024-03-06', '21900.00', '0.00', '76670.00', '54770.00', '0.00', '1235', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (237, '2625175392', '2', '2024-03-05', '10050.00', '0.00', '10050.00', '0.00', '0.00', '1236', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (238, '6637133796', '2', '2024-03-06', '4000.00', '0.00', '4000.00', '0.00', '0.00', '1237', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (239, '1371539249', '2', '2024-03-07', '7840.00', '0.00', '7840.00', '0.00', '0.00', '1238', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (240, '4738635783', '2', '2024-03-09', '25100.00', '0.00', '25100.00', '0.00', '0.00', '1239', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (241, '8143852489', '2', '2024-03-10', '20145.00', '0.00', '20145.00', '0.00', '0.00', '1240', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (242, '9445627595', '2', '2024-03-11', '74254.00', '0.00', '74254.00', '0.00', '0.00', '1241', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (243, '9123418226', '6', '2024-03-07', '8360.00', '0.00', '1410390.00', '1402030.00', '0.00', '1242', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (244, '2968542394', '18', '2024-03-07', '42025.00', '0.00', '697666.00', '655641.00', '0.00', '1243', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (245, '6863289674', '7', '2024-03-07', '4740.00', '0.00', '207592.00', '202852.00', '0.00', '1244', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (246, '5225826333', '22', '2024-03-07', '14500.00', '0.00', '41120.00', '26620.00', '0.00', '1245', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (247, '6333182967', '24', '2024-03-07', '0.00', '0.00', '26620.00', '246480.00', '0.00', '1246', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (248, '2839568685', '17', '2024-03-07', '6000.00', '0.00', '296530.00', '290530.00', '0.00', '1247', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (249, '5725871419', '24', '2024-03-09', '195530.00', '0.00', '246480.00', '50950.00', '0.00', '1248', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (250, '1797695428', '2', '2024-03-12', '14550.00', '0.00', '14550.00', '0.00', '0.00', '1249', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (251, '3897865422', '24', '2024-01-04', '0.00', '0.00', '0.00', '246480.00', '0.00', '1250', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (252, '9294923342', '2', '2024-03-13', '33930.00', '0.00', '33930.00', '0.00', '0.00', '1251', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (253, '6172987557', '7', '2024-03-10', '11820.00', '0.00', '218032.00', '206212.00', '0.00', '1252', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (254, '8676718682', '27', '2024-03-10', '36720.00', '0.00', '609375.00', '572655.00', '0.00', '1253', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (255, '2124638789', '18', '2024-03-10', '96975.00', '0.00', '794641.00', '697666.00', '0.00', '1254', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (256, '9495862115', '22', '2024-03-10', '11980.00', '0.00', '67600.00', '55620.00', '0.00', '1255', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (257, '6343288937', '12', '2024-03-10', '9080.00', '0.00', '403810.00', '394730.00', '0.00', '1256', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (258, '7976169977', '23', '2024-03-11', '76980.00', '0.00', '162266.00', '85286.00', '0.00', '1257', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (259, '2588954467', '42', '2024-03-13', '11550.00', '0.00', '11550.00', '0.00', '0.00', '1258', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (260, '3799993359', '2', '2024-03-14', '12340.00', '0.00', '12340.00', '0.00', '0.00', '1259', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (261, '7123693583', '2', '2024-03-16', '51460.00', '0.00', '51460.00', '0.00', '0.00', '1260', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (262, '2855145682', '32', '2024-03-14', '388750.00', '0.00', '844272.00', '455522.00', '0.00', '1261', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (263, '2684671283', '2', '2024-03-17', '35398.00', '0.00', '35398.00', '0.00', '0.00', '1262', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (264, '6667973681', '2', '2024-03-18', '74380.00', '0.00', '74380.00', '0.00', '0.00', '1263', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (265, '8614186355', '7', '2024-03-16', '13540.00', '0.00', '221172.00', '207632.00', '0.00', '1264', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (266, '5543697839', '12', '2024-03-17', '61980.00', '0.00', '465790.00', '403810.00', '0.00', '1265', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (267, '2624183513', '12', '2024-03-17', '10440.00', '0.00', '434850.00', '424410.00', '0.00', '1266', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (268, '2985475614', '12', '2024-03-17', '1170.00', '0.00', '5070.00', '3900.00', '0.00', '1267', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (269, '3689542297', '42', '2024-03-19', '1170.00', '0.00', '12720.00', '11550.00', '0.00', '1268', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (270, '9855185474', '2', '2024-03-20', '700.00', '0.00', '2060764.00', '2060064.00', '0.00', '1269', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (271, '3253157469', '32', '2024-03-19', '22775.00', '0.00', '867047.00', '844272.00', '0.00', '1270', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (272, '5241153453', '27', '2024-03-20', '12000.00', '0.00', '621375.00', '609375.00', '0.00', '1271', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (273, '4636966543', '10', '2024-03-19', '5480.00', '0.00', '245070.00', '239590.00', '0.00', '1272', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (274, '9432582367', '18', '2024-03-19', '95135.00', '0.00', '889776.00', '794641.00', '0.00', '1273', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (275, '9272887417', '43', '2024-03-19', '53600.00', '0.00', '53600.00', '0.00', '0.00', '1274', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (276, '7748257852', '44', '2024-03-21', '12570.00', '0.00', '12570.00', '0.00', '0.00', '1275', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (277, '2698538637', '21', '2024-03-21', '900.00', '0.00', '383660.00', '382760.00', '0.00', '1276', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (278, '7473123694', '25', '2024-03-21', '3950.00', '0.00', '99480.00', '95530.00', '0.00', '1277', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (279, '9329421995', '2', '2024-03-21', '26820.00', '0.00', '26820.00', '0.00', '0.00', '1278', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (280, '9997275465', '17', '2024-03-21', '44300.00', '0.00', '340830.00', '296530.00', '0.00', '1279', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (281, '5672426756', '18', '2024-03-21', '37700.00', '0.00', '928616.00', '890916.00', '0.00', '1280', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (282, '3826793642', '42', '2024-03-21', '660.00', '0.00', '13380.00', '12720.00', '0.00', '1281', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (283, '5434657383', '45', '2024-03-07', '40060.00', '0.00', '40060.00', '0.00', '0.00', '1282', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (284, '4937312758', '27', '2024-03-24', '14000.00', '0.00', '635375.00', '621375.00', '0.00', '1283', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (285, '1747957241', '12', '2024-03-07', '316770.00', '0.00', '794170.00', '477400.00', '0.00', '1284', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (286, '2733712729', '2', '2024-03-19', '8920.00', '0.00', '8920.00', '0.00', '0.00', '1285', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (287, '6351564964', '2', '2024-03-20', '5040.00', '0.00', '5040.00', '0.00', '0.00', '1286', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (288, '8398991967', '2', '2024-03-21', '21800.00', '0.00', '21800.00', '0.00', '0.00', '1287', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (289, '5732915468', '2', '2024-03-23', '13280.00', '0.00', '13280.00', '0.00', '0.00', '1288', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (290, '3586992742', '2', '2024-03-24', '57010.00', '0.00', '57010.00', '0.00', '0.00', '1289', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (291, '6658398886', '6', '2024-03-14', '4180.00', '0.00', '1411870.00', '1407690.00', '0.00', '1290', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (292, '5744799622', '6', '2024-03-16', '29080.00', '0.00', '1440950.00', '1411870.00', '0.00', '1291', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (293, '2817362753', '6', '2024-03-17', '20300.00', '0.00', '1456510.00', '1436210.00', '0.00', '1292', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (294, '2925755632', '6', '2024-03-19', '5700.00', '0.00', '1462210.00', '1456510.00', '0.00', '1293', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (295, '2465779867', '27', '2024-03-24', '12500.00', '0.00', '647875.00', '635375.00', '0.00', '1294', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (296, '7855113342', '40', '2024-03-25', '14500.00', '0.00', '19200.00', '4700.00', '0.00', '1295', '150.00', '150.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (297, '5929568811', '18', '2024-03-25', '16300.00', '0.00', '944916.00', '928616.00', '0.00', '1296', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (298, '8429856221', '7', '2024-03-25', '39460.00', '0.00', '261832.00', '222372.00', '0.00', '1297', '60.00', '60.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (299, '9922541324', '10', '2024-03-25', '6550.00', '0.00', '249220.00', '242670.00', '0.00', '1298', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (300, '4493439377', '28', '2024-03-25', '67350.00', '0.00', '81910.00', '14560.00', '0.00', '1299', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (301, '3675182878', '32', '2024-03-26', '60000.00', '0.00', '927047.00', '867047.00', '0.00', '1300', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (302, '9631931262', '10', '2024-03-27', '172700.00', '0.00', '420420.00', '247720.00', '0.00', '1301', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (303, '8381957215', '18', '2024-03-27', '23160.00', '0.00', '968076.00', '944916.00', '0.00', '1302', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (304, '3253633293', '6', '2024-03-14', '9500.00', '0.00', '1476450.00', '1466950.00', '0.00', '1303', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (305, '6194973291', '6', '2024-03-27', '14400.00', '0.00', '1490850.00', '1476450.00', '0.00', '1304', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (306, '5777367333', '20', '2024-03-27', '2000.00', '0.00', '78850.00', '76850.00', '0.00', '1305', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (307, '2271855841', '23', '2024-03-27', '9290.00', '0.00', '171556.00', '162266.00', '0.00', '1306', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (308, '1231988793', '2', '2024-03-25', '8000.00', '0.00', '8000.00', '0.00', '0.00', '1307', '10.00', '10.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (309, '6677889362', '2', '2024-03-26', '14850.00', '0.00', '14850.00', '0.00', '0.00', '1308', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (310, '2243328791', '2', '2024-03-27', '46600.00', '0.00', '46600.00', '0.00', '0.00', '1309', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (311, '4883297114', '2', '2024-03-28', '65255.00', '0.00', '65255.00', '0.00', '0.00', '1310', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (312, '7681616844', '46', '2024-03-30', '0.00', '0.00', '0.00', '0.00', '0.00', '1311', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (313, '4275369827', '47', '2024-03-30', '97340.00', '0.00', '97340.00', '0.00', '0.00', '1312', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (314, '4167923813', '17', '2024-03-30', '36400.00', '0.00', '377230.00', '340830.00', '0.00', '1313', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (315, '5791754729', '17', '2024-03-30', '15635.00', '0.00', '392865.00', '377230.00', '0.00', '1314', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (316, '1512924365', '18', '2024-03-31', '60560.00', '0.00', '1028636.00', '968076.00', '0.00', '1315', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (317, '4698376251', '10', '2024-03-31', '25420.00', '0.00', '447340.00', '421920.00', '0.00', '1316', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (318, '4224926148', '22', '2024-03-31', '13005.00', '0.00', '66285.00', '53280.00', '0.00', '1317', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (319, '7732694976', '42', '2024-03-31', '1660.00', '0.00', '15040.00', '13380.00', '0.00', '1318', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (320, '6597638334', '17', '2024-03-31', '5640.00', '0.00', '398505.00', '392865.00', '0.00', '1319', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (321, '6212555628', '7', '2024-03-31', '4670.00', '0.00', '265962.00', '261292.00', '0.00', '1320', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (322, '4131963676', '21', '2024-03-31', '4000.00', '0.00', '387660.00', '383660.00', '0.00', '1321', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (323, '6821617226', '6', '2024-03-28', '38200.00', '0.00', '1529050.00', '1490850.00', '0.00', '1322', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (324, '1971361776', '6', '2024-03-28', '28050.00', '1555300.00', '1800.00', '1529050.00', '0.00', '1323', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (325, '6865261646', '6', '2024-03-30', '38000.00', '0.00', '38000.00', '0.00', '0.00', '1324', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (326, '2343991432', '2', '2024-03-30', '41865.00', '0.00', '2367804.00', '2325939.00', '0.00', '1325', '21.00', '21.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (327, '3668139334', '2', '2024-03-31', '19360.00', '0.00', '19360.00', '0.00', '0.00', '1326', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (328, '3373792943', '2', '2024-04-02', '7280.00', '0.00', '7280.00', '0.00', '0.00', '1327', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (329, '8951253458', '2', '2024-04-03', '40080.00', '0.00', '40080.00', '0.00', '0.00', '1328', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (330, '1299158818', '17', '2024-04-03', '14200.00', '0.00', '412705.00', '398505.00', '0.00', '1329', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (331, '2634181175', '48', '2024-04-04', '72300.00', '0.00', '72300.00', '0.00', '0.00', '1330', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (332, '5173269616', '6', '2024-04-04', '38060.00', '0.00', '76360.00', '38300.00', '0.00', '1331', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (333, '1948967738', '2', '2024-04-04', '81550.00', '0.00', '81550.00', '0.00', '0.00', '1332', '360.00', '360.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (334, '1938912735', '24', '2024-01-04', '0.00', '0.00', '246480.00', '246480.00', '0.00', '1333', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (335, '6792891529', '2', '2024-04-06', '60150.00', '0.00', '60150.00', '0.00', '0.00', '1334', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (336, '2166655947', '17', '2024-04-06', '238120.00', '0.00', '650825.00', '412705.00', '0.00', '1335', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (337, '2375654761', '15', '2024-04-06', '83900.00', '0.00', '173900.00', '90000.00', '0.00', '1336', '28.00', '28.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (338, '5989899254', '49', '2024-04-06', '82295.00', '0.00', '82295.00', '0.00', '0.00', '1337', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (339, '8628978864', '20', '2024-04-07', '13160.00', '0.00', '92010.00', '78850.00', '0.00', '1338', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (340, '5481418892', '44', '2024-04-07', '5860.00', '0.00', '18430.00', '12570.00', '0.00', '1339', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (341, '4913417498', '32', '2024-04-07', '12500.00', '0.00', '939547.00', '927047.00', '0.00', '1340', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (342, '5268985181', '18', '2024-04-08', '97800.00', '0.00', '1126436.00', '1028636.00', '0.00', '1341', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (343, '9849939218', '25', '2024-04-08', '4050.00', '0.00', '103530.00', '99480.00', '0.00', '1342', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (344, '4695875524', '50', '2024-04-08', '8400.00', '0.00', '8400.00', '0.00', '0.00', '1343', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (345, '5176459998', '2', '2024-04-07', '88640.00', '0.00', '88640.00', '0.00', '0.00', '1344', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (346, '2216479258', '6', '2024-04-08', '15200.00', '0.00', '91560.00', '76360.00', '0.00', '1345', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (347, '6839949824', '6', '2024-04-09', '11400.00', '0.00', '102960.00', '91560.00', '0.00', '1346', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (348, '4823786759', '2', '2024-04-08', '9410.00', '0.00', '9410.00', '0.00', '0.00', '1347', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (349, '1954183663', '2', '2024-04-09', '36370.00', '0.00', '36370.00', '0.00', '0.00', '1348', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (350, '4648594853', '2', '2024-04-13', '51200.00', '0.00', '51200.00', '0.00', '0.00', '1349', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (351, '6586445994', '40', '2024-04-14', '3000.00', '0.00', '22200.00', '19200.00', '0.00', '1350', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (352, '1196229697', '32', '2024-04-14', '10700.00', '0.00', '950247.00', '939547.00', '0.00', '1351', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (353, '7873299185', '7', '2024-04-14', '17000.00', '0.00', '283502.00', '266502.00', '0.00', '1352', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (354, '4979853171', '51', '2024-04-15', '69000.00', '0.00', '69000.00', '0.00', '0.00', '1353', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (355, '8841984599', '2', '2024-04-14', '22610.00', '0.00', '22610.00', '0.00', '0.00', '1354', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (356, '7653135536', '52', '2024-04-15', '75050.00', '0.00', '75050.00', '0.00', '0.00', '1355', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (357, '7865327862', '6', '2024-04-16', '79400.00', '0.00', '182360.00', '102960.00', '0.00', '1356', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (358, '3395545996', '2', '2024-04-15', '24430.00', '0.00', '24430.00', '0.00', '0.00', '1357', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (359, '3454739466', '18', '2024-04-17', '377880.00', '0.00', '1504316.00', '1126436.00', '0.00', '1358', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (360, '1897354479', '6', '2024-04-17', '8200.00', '0.00', '190560.00', '182360.00', '0.00', '1359', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (361, '1331473321', '6', '2024-04-02', '31800.00', '0.00', '224160.00', '192360.00', '0.00', '1360', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (362, '4181161449', '2', '2024-04-16', '53285.00', '0.00', '53285.00', '0.00', '0.00', '1361', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (363, '3687215118', '6', '2024-04-17', '10800.00', '0.00', '234960.00', '224160.00', '0.00', '1362', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (364, '3352983635', '17', '2024-04-17', '47500.00', '0.00', '698325.00', '650825.00', '0.00', '1363', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (365, '7953851285', '21', '2024-04-17', '4200.00', '0.00', '391860.00', '387660.00', '0.00', '1364', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (366, '6742371245', '13', '2024-04-17', '30700.00', '0.00', '393500.00', '362800.00', '0.00', '1365', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (367, '9826454685', '48', '2024-04-04', '356000.00', '0.00', '428300.00', '72300.00', '0.00', '1366', '3440.00', '3440.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (368, '4754231575', '2', '2024-04-17', '39860.00', '0.00', '39860.00', '0.00', '0.00', '1367', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (369, '7943379429', '24', '2024-01-04', '0.00', '0.00', '0.00', '246480.00', '0.00', '1368', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (370, '5253343437', '6', '2024-04-18', '19000.00', '0.00', '253960.00', '234960.00', '0.00', '1369', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (371, '8378298814', '27', '2024-04-18', '6200.00', '0.00', '654075.00', '647875.00', '0.00', '1370', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (372, '4187574224', '2', '2024-04-18', '18320.00', '0.00', '18320.00', '0.00', '0.00', '1371', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (373, '1929867449', '2', '2024-04-20', '74720.00', '0.00', '74720.00', '0.00', '0.00', '1372', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (374, '2696397343', '6', '2024-04-20', '76000.00', '0.00', '329960.00', '253960.00', '0.00', '1373', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (375, '7592546738', '2', '2024-04-20', '300.00', '0.00', '300.00', '0.00', '0.00', '1374', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (376, '7225778361', '51', '2024-04-18', '276172.00', '0.00', '345172.00', '69000.00', '0.00', '1375', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (377, '2926266512', '51', '2024-04-20', '0.00', '0.00', '345172.00', '345172.00', '0.00', '1376', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (378, '5411671834', '17', '2024-04-20', '20600.00', '0.00', '718925.00', '698325.00', '0.00', '1377', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (379, '5613664541', '25', '2024-04-21', '2200.00', '0.00', '105730.00', '103530.00', '0.00', '1378', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (380, '1464127388', '18', '2024-04-21', '132020.00', '0.00', '1636336.00', '1504316.00', '0.00', '1379', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (381, '7252192761', '7', '2024-04-21', '11700.00', '0.00', '295202.00', '283502.00', '0.00', '1380', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (382, '2238345531', '18', '2024-04-21', '86800.00', '0.00', '1723136.00', '1636336.00', '0.00', '1381', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (383, '7455412952', '2', '2024-04-21', '28630.00', '0.00', '28630.00', '0.00', '0.00', '1382', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (384, '8997478542', '2', '2024-04-22', '7430.00', '0.00', '7430.00', '0.00', '0.00', '1383', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (385, '7981551788', '53', '2024-04-21', '15950.00', '0.00', '15950.00', '0.00', '0.00', '1384', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (386, '8413576871', '40', '2024-04-21', '9500.00', '0.00', '31700.00', '22200.00', '0.00', '1385', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (387, '5236541338', '53', '2024-04-23', '12800.00', '0.00', '28750.00', '15950.00', '0.00', '1386', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (388, '2279338767', '18', '2024-04-24', '7900.00', '0.00', '1731036.00', '1723136.00', '0.00', '1387', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (389, '8827832273', '10', '2024-04-24', '30400.00', '0.00', '477740.00', '447340.00', '0.00', '1388', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (390, '9958959772', '53', '2024-04-22', '9060.00', '0.00', '37810.00', '28750.00', '0.00', '1389', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (391, '7143127461', '2', '2024-04-23', '176860.00', '0.00', '176860.00', '0.00', '0.00', '1390', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (392, '3499562843', '2', '2024-04-24', '37930.00', '0.00', '37930.00', '0.00', '0.00', '1391', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (393, '4469798727', '54', '2024-04-25', '2700.00', '0.00', '2700.00', '0.00', '0.00', '1392', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (394, '9818532272', '2', '2024-04-25', '48000.00', '0.00', '48000.00', '0.00', '0.00', '1393', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (395, '6311557677', '17', '2024-04-21', '88683.00', '0.00', '807608.00', '718925.00', '0.00', '1394', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (396, '9414891438', '17', '2024-04-23', '79178.00', '0.00', '886786.00', '807608.00', '0.00', '1395', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (397, '4787487136', '17', '2024-04-24', '2800.00', '0.00', '889586.00', '886786.00', '0.00', '1396', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (398, '1789273916', '32', '2024-04-24', '134855.00', '0.00', '1085102.00', '950247.00', '0.00', '1397', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (399, '5253653148', '17', '2024-04-27', '10000.00', '0.00', '899586.00', '889586.00', '0.00', '1398', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (400, '8257478766', '18', '2024-04-27', '118950.00', '0.00', '1849986.00', '1731036.00', '0.00', '1399', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (401, '6294569947', '25', '2024-04-27', '8800.00', '0.00', '114530.00', '105730.00', '0.00', '1400', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (402, '5534821822', '29', '2024-04-27', '7500.00', '0.00', '15080.00', '7580.00', '0.00', '1401', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (403, '1651433367', '6', '2024-04-22', '69550.00', '0.00', '399510.00', '329960.00', '0.00', '1402', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (404, '3851685395', '6', '2024-04-24', '5120.00', '0.00', '404630.00', '399510.00', '0.00', '1403', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (405, '6876312951', '6', '2024-04-26', '88000.00', '0.00', '492630.00', '404630.00', '0.00', '1404', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (406, '5651135711', '2', '2024-04-27', '22300.00', '0.00', '22300.00', '0.00', '0.00', '1405', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (407, '6185919946', '43', '2024-04-27', '7700.00', '0.00', '61300.00', '53600.00', '0.00', '1406', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (408, '9947344679', '18', '2024-04-29', '23550.00', '0.00', '1873536.00', '1849986.00', '0.00', '1407', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (409, '6352547424', '18', '2024-04-29', '7370.00', '0.00', '1880906.00', '1873536.00', '0.00', '1408', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (410, '8958612741', '6', '2024-04-29', '22770.00', '0.00', '515400.00', '492630.00', '0.00', '1409', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (411, '1292926993', '2', '2024-04-28', '43330.00', '0.00', '43330.00', '0.00', '0.00', '1410', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (412, '8221687361', '2', '2024-04-29', '62850.00', '0.00', '62850.00', '0.00', '0.00', '1411', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (413, '1459596594', '18', '2024-04-30', '93600.00', '0.00', '1974506.00', '1880906.00', '0.00', '1412', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (414, '9727844627', '43', '2024-04-30', '17500.00', '0.00', '78800.00', '61300.00', '0.00', '1413', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (415, '9688352243', '17', '2024-05-02', '192700.00', '0.00', '1092286.00', '899586.00', '0.00', '1414', '400.00', '400.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (416, '9912837861', '27', '2024-05-02', '133892.00', '0.00', '787967.00', '654075.00', '0.00', '1415', '63008.00', '63008.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (417, '5213434265', '32', '2024-05-02', '176707.00', '0.00', '1261809.00', '1085102.00', '0.00', '1416', '64508.00', '64508.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (418, '1547115985', '53', '2024-04-29', '7720.00', '0.00', '45530.00', '37810.00', '0.00', '1417', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (419, '9152678989', '2', '2024-04-30', '38350.00', '0.00', '38350.00', '0.00', '0.00', '1418', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (420, '5736277861', '2', '2024-05-01', '41485.00', '0.00', '41485.00', '0.00', '0.00', '1419', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (421, '6341328237', '55', '2024-05-02', '72000.00', '0.00', '72000.00', '0.00', '0.00', '1420', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (422, '1521546399', '18', '2024-05-02', '331500.00', '0.00', '2306006.00', '1974506.00', '0.00', '1421', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (423, '9695696422', '2', '2024-05-02', '19400.00', '0.00', '19400.00', '0.00', '0.00', '1422', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (424, '8717124365', '6', '2024-05-02', '1800.00', '0.00', '517200.00', '515400.00', '0.00', '1423', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (425, '9746361644', '2', '2024-05-04', '68770.00', '0.00', '68770.00', '0.00', '0.00', '1424', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (426, '6655196876', '2', '2024-05-04', '91470.00', '0.00', '91470.00', '0.00', '0.00', '1425', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (427, '4199745195', '24', '2024-01-04', '0.00', '0.00', '0.00', '246480.00', '0.00', '1426', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (428, '5482914316', '2', '2024-05-05', '17540.00', '0.00', '17540.00', '0.00', '0.00', '1427', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (429, '9859657466', '2', '2024-05-06', '46350.00', '0.00', '46350.00', '0.00', '0.00', '1428', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (430, '9266641739', '23', '2024-05-05', '89000.00', '0.00', '260556.00', '171556.00', '0.00', '1429', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (431, '5866451357', '18', '2024-05-06', '41180.00', '0.00', '2347186.00', '2306006.00', '0.00', '1430', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (432, '9277318726', '27', '2024-05-06', '3100.00', '0.00', '117630.00', '787967.00', '0.00', '1431', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (433, '8199273583', '56', '2024-05-06', '3000.00', '0.00', '3000.00', '0.00', '0.00', '1432', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (434, '3293275968', '43', '2024-04-20', '112600.00', '0.00', '191400.00', '78800.00', '0.00', '1433', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (435, '6727268952', '15', '2024-05-07', '121600.00', '0.00', '295500.00', '173900.00', '0.00', '1434', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (436, '9192112764', '55', '2024-05-07', '36000.00', '0.00', '108000.00', '72000.00', '0.00', '1435', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (437, '9512576366', '2', '2024-05-06', '3850.00', '0.00', '3850.00', '0.00', '0.00', '1436', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (438, '3942454311', '2', '2024-05-07', '51813.00', '0.00', '51813.00', '0.00', '0.00', '1437', '2.00', '2.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (439, '1187151677', '12', '2024-05-09', '4200.00', '0.00', '798370.00', '794170.00', '0.00', '1438', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (440, '7938173624', '12', '2024-05-09', '51570.00', '0.00', '849940.00', '798370.00', '0.00', '1439', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (441, '1614719538', '57', '2024-05-09', '16550.00', '0.00', '16550.00', '0.00', '0.00', '1440', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (442, '2415214152', '17', '2024-05-09', '333000.00', '0.00', '1425286.00', '1092286.00', '0.00', '1441', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (443, '2515197159', '2', '2024-05-08', '55590.00', '0.00', '55590.00', '0.00', '0.00', '1442', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (444, '5942324735', '2', '2024-05-09', '143190.00', '0.00', '143190.00', '0.00', '0.00', '1443', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (445, '6973986361', '55', '2024-05-07', '1000.00', '0.00', '109000.00', '108000.00', '0.00', '1444', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (446, '6879251196', '2', '2024-05-11', '115630.00', '0.00', '115630.00', '0.00', '0.00', '1445', '12.00', '12.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (447, '8482417873', '20', '2024-05-11', '30600.00', '0.00', '122610.00', '92010.00', '0.00', '1446', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (448, '3258566874', '58', '2024-05-11', '14900.00', '0.00', '14900.00', '0.00', '0.00', '1447', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (449, '1435241757', '2', '2024-05-12', '20550.00', '0.00', '20550.00', '0.00', '0.00', '1448', '20.00', '20.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (450, '1217289937', '53', '2024-05-13', '2000.00', '0.00', '47530.00', '45530.00', '0.00', '1449', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (451, '1471919258', '27', '2024-05-13', '12500.00', '0.00', '803567.00', '791067.00', '0.00', '1450', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (452, '2714463447', '21', '2024-05-13', '4300.00', '0.00', '396160.00', '391860.00', '0.00', '1451', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (453, '8246258379', '18', '2024-05-13', '237350.00', '0.00', '2584536.00', '2347186.00', '0.00', '1452', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (454, '2173489285', '6', '2024-05-09', '31800.00', '0.00', '549000.00', '517200.00', '0.00', '1453', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (455, '7771648352', '53', '2024-05-11', '5900.00', '0.00', '53430.00', '47530.00', '0.00', '1454', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (456, '7425241919', '23', '2024-05-13', '12380.00', '0.00', '272936.00', '260556.00', '0.00', '1455', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (457, '2269286568', '2', '2024-05-13', '60400.00', '0.00', '60400.00', '0.00', '0.00', '1456', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (458, '7132322579', '59', '2024-05-14', '9600.00', '0.00', '4259717.00', '4250117.00', '0.00', '1457', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (459, '7531931292', '60', '2024-05-14', '31710.00', '0.00', '31710.00', '0.00', '0.00', '1458', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (460, '9425431332', '53', '2024-05-14', '2000.00', '0.00', '55430.00', '53430.00', '0.00', '1459', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (461, '2441147954', '43', '2024-05-14', '15400.00', '0.00', '206800.00', '191400.00', '0.00', '1460', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (462, '5141413266', '2', '2024-05-14', '33900.00', '0.00', '33900.00', '0.00', '0.00', '1461', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (463, '4629916718', '17', '2024-05-15', '12520.00', '0.00', '1437806.00', '1425286.00', '0.00', '1462', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (464, '9233426983', '27', '2024-05-15', '181792.00', '0.00', '985359.00', '803567.00', '0.00', '1463', '102258.00', '102258.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (465, '3543812978', '18', '2024-05-15', '137040.00', '0.00', '2721576.00', '2584536.00', '0.00', '1464', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (466, '1712444644', '24', '2024-01-24', '0.00', '0.00', '14900.00', '246480.00', '0.00', '1465', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (467, '4751468166', '58', '2024-05-15', '3090.00', '0.00', '17990.00', '14900.00', '0.00', '1466', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (468, '9112277419', '2', '2024-05-15', '36380.00', '0.00', '36380.00', '0.00', '0.00', '1467', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (469, '4525769244', '2', '2024-05-16', '43920.00', '0.00', '43920.00', '0.00', '0.00', '1468', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (470, '9815267139', '55', '2024-05-16', '17840.00', '0.00', '126840.00', '109000.00', '0.00', '1469', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (471, '8532293273', '17', '2024-05-16', '48650.00', '0.00', '1486456.00', '1437806.00', '0.00', '1470', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (472, '9827253319', '17', '2024-04-19', '19600.00', '0.00', '1506056.00', '1486456.00', '0.00', '1471', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (473, '6261171199', '2', '2024-05-18', '80270.00', '0.00', '80270.00', '0.00', '0.00', '1472', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (474, '9163299722', '22', '2024-05-19', '14830.00', '0.00', '81115.00', '66285.00', '0.00', '1473', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (475, '1223415297', '22', '2024-05-19', '14830.00', '0.00', '81115.00', '66285.00', '0.00', '1474', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (476, '4745111666', '2', '2024-05-19', '95560.00', '0.00', '95560.00', '0.00', '0.00', '1475', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);
INSERT INTO `invoice` (`id`, `invoice_id`, `customer_id`, `date`, `total_amount`, `paid_amount`, `due_amount`, `prevous_due`, `shipping_cost`, `invoice`, `invoice_discount`, `total_discount`, `total_tax`, `sales_by`, `invoice_details`, `status`, `bank_id`, `payment_type`) VALUES (477, '9131447689', '2', '2024-05-20', '9810.00', '0.00', '9810.00', '0.00', '0.00', '1476', '0.00', '0.00', '0.00', '1', 'Thank you for shopping with us', 1, NULL, 1);


#
# TABLE STRUCTURE FOR: invoice_details
#

DROP TABLE IF EXISTS `invoice_details`;

CREATE TABLE `invoice_details` (
  `id` int NOT NULL AUTO_INCREMENT,
  `invoice_details_id` varchar(100) NOT NULL,
  `invoice_id` varchar(100) NOT NULL,
  `product_id` varchar(30) NOT NULL,
  `serial_no` varchar(30) DEFAULT NULL,
  `description` varchar(250) DEFAULT NULL,
  `quantity` decimal(10,2) DEFAULT NULL,
  `rate` decimal(10,2) DEFAULT NULL,
  `supplier_rate` float DEFAULT NULL,
  `total_price` decimal(12,2) DEFAULT NULL,
  `discount` decimal(10,2) DEFAULT NULL,
  `discount_per` varchar(15) DEFAULT NULL,
  `tax` decimal(10,2) DEFAULT NULL,
  `paid_amount` decimal(12,0) DEFAULT NULL,
  `due_amount` decimal(10,2) DEFAULT NULL,
  `status` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `invoice_id` (`invoice_id`),
  KEY `product_id` (`product_id`)
) ENGINE=MyISAM AUTO_INCREMENT=10845 DEFAULT CHARSET=utf8mb3;

INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1, '839389393983864', '5845776228', '56', NULL, '', '2.00', '1100.00', '1000', '2200.00', '0.00', '', NULL, '0', '2525.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2, '967686887555815', '5845776228', '29', NULL, '', '5.00', '45.00', '40', '225.00', '0.00', '', NULL, '0', '2525.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3, '433793495435259', '5845776228', '421', NULL, '', '2.00', '50.00', '36', '100.00', '0.00', '', NULL, '0', '2525.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4, '515976827355894', '6124985648', '709', NULL, '', '1.00', '600.00', '500', '600.00', '0.00', '', NULL, '0', '600.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (15, '275589831295255', '4977174268', '381', NULL, '', '1.00', '50.00', '400', '420.00', '0.00', '', '0.00', '0', '2370.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (14, '846997721244228', '4977174268', '709', NULL, '', '1.00', '600.00', '500', '600.00', '0.00', '', '0.00', '0', '2370.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (13, '898567895771985', '4977174268', '57', NULL, '', '9.00', '150.00', '140', '1350.00', '0.00', '', '0.00', '0', '2370.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (16, '898241372863183', '4612744893', '602', NULL, '', '1.00', '1800.00', '1500', '1800.00', '0.00', '', NULL, '0', '5550.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (17, '274489216927784', '4612744893', '490', NULL, '', '1.00', '200.00', '90', '200.00', '0.00', '', NULL, '0', '5550.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (18, '282799142971449', '4612744893', '494', NULL, '', '8.00', '300.00', '290', '2400.00', '0.00', '', NULL, '0', '5550.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (19, '651149459917255', '4612744893', '490', NULL, '', '2.00', '150.00', '90', '300.00', '0.00', '', NULL, '0', '5550.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (20, '554759811629266', '4612744893', '221', NULL, '', '1.00', '850.00', '500', '850.00', '0.00', '', NULL, '0', '5550.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (21, '482121579539139', '2567782964', '249', NULL, '', '1.00', '3000.00', '1600', '3000.00', '0.00', '', NULL, '0', '31510.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (22, '767781713126117', '2567782964', '419', NULL, '', '1.00', '7300.00', '6731', '7300.00', '0.00', '', NULL, '0', '31510.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (23, '985862782699412', '2567782964', '404', NULL, '', '6.00', '130.00', '125', '780.00', '0.00', '', NULL, '0', '31510.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (24, '848234393687766', '2567782964', '236', NULL, '', '1.00', '700.00', '920', '700.00', '0.00', '', NULL, '0', '31510.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (25, '996974799877116', '2567782964', '776', NULL, '', '6.00', '550.00', '486', '3300.00', '0.00', '', NULL, '0', '31510.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (26, '541838177328171', '2567782964', '399', NULL, '', '4.00', '275.00', '287', '1100.00', '0.00', '', NULL, '0', '31510.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (27, '972894955285838', '2567782964', '681', NULL, '', '2.00', '350.00', '310', '700.00', '0.00', '', NULL, '0', '31510.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (28, '723798943148258', '2567782964', '399', NULL, '', '2.00', '320.00', '287', '640.00', '0.00', '', NULL, '0', '31510.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (29, '253942834461868', '2567782964', '390', NULL, '', '22.00', '550.00', '560', '12100.00', '0.00', '', NULL, '0', '31510.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (30, '546615487387449', '2567782964', '698', NULL, '', '5.00', '350.00', '290', '1750.00', '0.00', '', NULL, '0', '31510.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (31, '298272421945446', '2567782964', '57', NULL, '', '1.00', '140.00', '140', '140.00', '0.00', '', NULL, '0', '31510.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (32, '526822765573292', '9779858312', '254', NULL, '', '20.00', '260.00', '230', '5200.00', '0.00', '', NULL, '0', '10640.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (33, '564137457187356', '9779858312', '251', NULL, '', '3.00', '250.00', '275', '750.00', '0.00', '', NULL, '0', '10640.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (34, '661667718864522', '9779858312', '366', NULL, '', '4.00', '60.00', '46', '240.00', '0.00', '', NULL, '0', '10640.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (35, '344263629619382', '9779858312', '678', NULL, '', '1.00', '300.00', '286', '300.00', '0.00', '', NULL, '0', '10640.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (36, '581485192368619', '9779858312', '235', NULL, '', '3.00', '1050.00', '1100', '3150.00', '0.00', '', NULL, '0', '10640.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (37, '377627555172341', '9779858312', '41', NULL, '', '8.00', '50.00', '45', '400.00', '0.00', '', NULL, '0', '10640.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (38, '815298815434397', '9779858312', '57', NULL, '', '4.00', '150.00', '140', '600.00', '0.00', '', NULL, '0', '10640.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (46, '356253728127843', '3284257142', '373', NULL, '', '1.00', '1500.00', '1500', '1500.00', '0.00', '', '0.00', '0', '5996.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (45, '667533664915413', '3284257142', '410', NULL, '', '1.00', '1800.00', '1650', '1800.00', '0.00', '', '0.00', '0', '5996.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (44, '135198835368782', '3284257142', '251', NULL, '', '2.00', '250.00', '275', '500.00', '0.00', '', '0.00', '0', '5996.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (43, '763728188872889', '3284257142', '490', NULL, '', '12.00', '183.00', '90', '2196.00', '0.00', '', '0.00', '0', '5996.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (47, '846796548571395', '9175169491', '254', NULL, '', '3.00', '200.00', '230', '600.00', '0.00', '', NULL, '0', '2500.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (48, '134153886452179', '9175169491', '253', NULL, '', '2.00', '250.00', '280', '500.00', '0.00', '', NULL, '0', '2500.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (49, '171855522334312', '9175169491', '57', NULL, '', '6.00', '150.00', '140', '900.00', '0.00', '', NULL, '0', '2500.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (50, '562268159237749', '9175169491', '241', NULL, '', '2.00', '250.00', '160', '500.00', '0.00', '', NULL, '0', '2500.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (119, '113891451557286', '5669212287', '603', NULL, '', '39.00', '320.00', '250', '12480.00', '0.00', '', '0.00', '0', '111260.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (118, '663928358686782', '5669212287', '283', NULL, '', '24.00', '40.00', '30', '960.00', '0.00', '', '0.00', '0', '111260.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (117, '184474861449985', '5669212287', '678', NULL, '', '12.00', '290.00', '286', '3480.00', '0.00', '', '0.00', '0', '111260.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (116, '122952642292298', '5669212287', '776', NULL, '', '24.00', '500.00', '486', '12000.00', '0.00', '', '0.00', '0', '111260.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (115, '615873471779433', '5669212287', '418', NULL, '', '2.00', '4300.00', '4300', '8600.00', '0.00', '', '0.00', '0', '111260.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (114, '547974748476538', '5669212287', '417', NULL, '', '3.00', '4300.00', '4300', '12900.00', '0.00', '', '0.00', '0', '111260.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (113, '973151694985756', '5669212287', '68', NULL, '', '5.00', '2150.00', '2600', '10750.00', '0.00', '', '0.00', '0', '111260.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (112, '382185969539811', '5669212287', '71', NULL, '', '5.00', '2150.00', '2250', '10750.00', '0.00', '', '0.00', '0', '111260.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (111, '547462747382147', '5669212287', '12', NULL, '', '50.00', '130.00', '135', '6500.00', '0.00', '', '0.00', '0', '111260.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (110, '171635922286377', '5669212287', '19', NULL, '', '6.00', '80.00', '70', '480.00', '0.00', '', '0.00', '0', '111260.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (109, '981134698598221', '5669212287', '473', NULL, '', '1.00', '500.00', '350', '500.00', '0.00', '', '0.00', '0', '111260.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (108, '648453613514982', '5669212287', '29', NULL, '', '6.00', '60.00', '40', '360.00', '0.00', '', '0.00', '0', '111260.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (107, '443574415325159', '5669212287', '421', NULL, '', '10.00', '60.00', '36', '600.00', '0.00', '', '0.00', '0', '111260.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (106, '275369558528271', '5669212287', '144', NULL, '', '1.00', '6300.00', '6146', '6300.00', '0.00', '', '0.00', '0', '111260.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (105, '631419955448628', '5669212287', '141', NULL, '', '1.00', '6300.00', '6146', '6300.00', '0.00', '', '0.00', '0', '111260.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (104, '923128239996347', '5669212287', '136', NULL, '', '2.00', '3050.00', '2961', '6100.00', '0.00', '', '0.00', '0', '111260.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (103, '641163846616395', '5669212287', '135', NULL, '', '4.00', '3050.00', '2961', '12200.00', '0.00', '', '0.00', '0', '111260.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (84, '234162181384552', '8115955164', '222', NULL, '', '5.00', '180.00', '230', '900.00', '0.00', '', NULL, '0', '3300.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (85, '713423429736182', '8115955164', '57', NULL, '', '10.00', '120.00', '140', '1200.00', '0.00', '', NULL, '0', '3300.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (86, '485644882175947', '8115955164', '239', NULL, '', '2.00', '400.00', '360', '800.00', '0.00', '', NULL, '0', '3300.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (87, '926879137534578', '8115955164', '694', NULL, '', '2.00', '200.00', '130', '400.00', '0.00', '', NULL, '0', '3300.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (88, '439678757222877', '6448414167', '251', NULL, '', '4.00', '250.00', '275', '1000.00', '0.00', '', NULL, '0', '5000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (89, '638643831683452', '6448414167', '401', NULL, '', '6.00', '500.00', '475', '3000.00', '0.00', '', NULL, '0', '5000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (90, '329763255314885', '6448414167', '28', NULL, '', '4.00', '150.00', '120', '600.00', '0.00', '', NULL, '0', '5000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (91, '759911862932649', '6448414167', '57', NULL, '', '2.00', '200.00', '140', '400.00', '0.00', '', NULL, '0', '5000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (92, '385984619746189', '7816741612', '135', NULL, '', '1.00', '3100.00', '2961', '3100.00', '0.00', '', NULL, '0', '23100.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (93, '949862787112821', '7816741612', '206', NULL, '', '1.00', '1900.00', '1200', '1900.00', '0.00', '', NULL, '0', '23100.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (94, '411867448784556', '7816741612', '57', NULL, '', '2.00', '150.00', '140', '300.00', '0.00', '', NULL, '0', '23100.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (95, '214898361575745', '7816741612', '303', NULL, '', '1.00', '1650.00', '1500', '1650.00', '0.00', '', NULL, '0', '23100.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (96, '425718353794821', '7816741612', '343', NULL, '', '1.00', '1650.00', '1500', '1650.00', '0.00', '', NULL, '0', '23100.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (97, '872494828237715', '7816741612', '147', NULL, '', '1.00', '14500.00', '14986', '14500.00', '0.00', '', NULL, '0', '23100.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (131, '982264386784453', '4995667463', '363', NULL, '', '3.00', '340.00', '320', '1020.00', '0.00', '', '0.00', '0', '24320.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (130, '623396777746993', '4995667463', '141', NULL, '', '1.00', '6300.00', '6146', '6300.00', '0.00', '', '0.00', '0', '24320.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (129, '821626443899344', '4995667463', '144', NULL, '', '1.00', '6300.00', '6146', '6300.00', '0.00', '', '0.00', '0', '24320.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (128, '489933145723954', '4995667463', '694', NULL, '', '2.00', '200.00', '130', '400.00', '0.00', '', '0.00', '0', '24320.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (127, '974666687416646', '4995667463', '57', NULL, '', '2.00', '150.00', '140', '300.00', '0.00', '', '0.00', '0', '24320.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (126, '663897399591753', '4995667463', '412', NULL, '', '1.00', '10000.00', '8800', '10000.00', '0.00', '', '0.00', '0', '24320.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (157, '574292484641591', '7328171614', '693', NULL, '', '2.00', '200.00', '130', '400.00', '0.00', '', '0.00', '0', '50310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (156, '993881668428611', '7328171614', '697', NULL, '', '1.00', '400.00', '400', '400.00', '0.00', '', '0.00', '0', '50310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (155, '968472347194219', '7328171614', '698', NULL, '', '4.00', '350.00', '290', '1400.00', '0.00', '', '0.00', '0', '50310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (154, '574521829522268', '7328171614', '442', NULL, '', '10.00', '140.00', '120', '1400.00', '0.00', '', '0.00', '0', '50310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (153, '124894363972692', '7328171614', '715', NULL, '', '5.00', '135.00', '120', '675.00', '0.00', '', '0.00', '0', '50310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (152, '397825487327713', '7328171614', '283', NULL, '', '1.00', '60.00', '30', '60.00', '0.00', '', '0.00', '0', '50310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (151, '595223161397594', '7328171614', '395', NULL, '', '2.00', '70.00', '50', '140.00', '0.00', '', '0.00', '0', '50310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (150, '549247268872682', '7328171614', '678', NULL, '', '1.00', '350.00', '286', '350.00', '0.00', '', '0.00', '0', '50310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (149, '368593236435689', '7328171614', '776', NULL, '', '2.00', '550.00', '486', '1100.00', '0.00', '', '0.00', '0', '50310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (148, '749121364817112', '7328171614', '726', NULL, '', '1.00', '4700.00', '4800', '4700.00', '0.00', '', '0.00', '0', '50310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (147, '225457635726388', '7328171614', '707', NULL, '', '1.00', '250.00', '150', '250.00', '0.00', '', '0.00', '0', '50310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (146, '657517693482148', '7328171614', '71', NULL, '', '1.00', '2450.00', '2250', '2450.00', '0.00', '', '0.00', '0', '50310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (158, '463729624525221', '7328171614', '67', NULL, '', '4.00', '2600.00', '2600', '10400.00', '0.00', '', '0.00', '0', '50310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (159, '217395898578677', '7328171614', '72', NULL, '', '3.00', '2600.00', '2250', '7800.00', '0.00', '', '0.00', '0', '50310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (160, '331751747575241', '7328171614', '69', NULL, '', '1.00', '5200.00', '5200', '5200.00', '0.00', '', '0.00', '0', '50310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (161, '887536492676354', '7328171614', '70', NULL, '', '1.00', '5200.00', '5200', '5200.00', '0.00', '', '0.00', '0', '50310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (162, '564298944389399', '7328171614', '387', NULL, '', '6.00', '490.00', '486', '2940.00', '0.00', '', '0.00', '0', '50310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (163, '462483396591755', '7328171614', '401', NULL, '', '6.00', '480.00', '475', '2880.00', '0.00', '', '0.00', '0', '50310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (164, '658129377397779', '7328171614', '399', NULL, '', '6.00', '280.00', '287', '1680.00', '0.00', '', '0.00', '0', '50310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (165, '638427685856997', '7328171614', '682', NULL, '', '1.00', '200.00', '250', '200.00', '0.00', '', '0.00', '0', '50310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (166, '976282556561647', '7328171614', '281', NULL, '', '7.00', '25.00', '25', '175.00', '0.00', '', '0.00', '0', '50310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (167, '918733169387693', '7328171614', '282', NULL, '', '12.00', '30.00', '32', '360.00', '0.00', '', '0.00', '0', '50310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (168, '452749681187878', '7328171614', '217', NULL, '', '1.00', '150.00', '180', '150.00', '0.00', '', '0.00', '0', '50310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (169, '379593745279776', '6686419811', '251', NULL, '', '2.00', '300.00', '275', '600.00', '0.00', '', NULL, '0', '6780.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (170, '276287493128343', '6686419811', '240', NULL, '', '2.00', '300.00', '260', '600.00', '0.00', '', NULL, '0', '6780.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (171, '859873522133459', '6686419811', '20', NULL, '', '12.00', '180.00', '115', '2160.00', '0.00', '', NULL, '0', '6780.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (172, '576239325766441', '6686419811', '497', NULL, '', '1.00', '200.00', '160', '200.00', '0.00', '', NULL, '0', '6780.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (173, '997194613866521', '6686419811', '207', NULL, '', '1.00', '1600.00', '1300', '1600.00', '0.00', '', NULL, '0', '6780.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (174, '142914258156767', '6686419811', '711', NULL, '', '1.00', '70.00', '62', '70.00', '0.00', '', NULL, '0', '6780.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (175, '195289453792295', '6686419811', '474', NULL, '', '1.00', '200.00', '100', '200.00', '0.00', '', NULL, '0', '6780.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (176, '754492964838771', '6686419811', '224', NULL, '', '1.00', '750.00', '550', '750.00', '0.00', '', NULL, '0', '6780.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (177, '416534289783943', '6686419811', '693', NULL, '', '3.00', '200.00', '130', '600.00', '0.00', '', NULL, '0', '6780.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (193, '874177596597332', '4856684174', '452 ', NULL, '', '1.00', '100.00', '292', '100.00', '0.00', '', '0.00', '0', '7650.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (192, '619544667432253', '4856684174', '263', NULL, '', '1.00', '350.00', '350', '350.00', '0.00', '', '0.00', '0', '7650.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (191, '785937424862916', '4856684174', '221', NULL, '', '1.00', '400.00', '500', '400.00', '0.00', '', '0.00', '0', '7650.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (190, '784175347599831', '4856684174', '603', NULL, '', '4.00', '200.00', '250', '800.00', '0.00', '', '0.00', '0', '7650.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (189, '313758462677353', '4856684174', '703', NULL, '', '4.00', '700.00', '900', '2800.00', '0.00', '', '0.00', '0', '7650.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (188, '682598322717165', '4856684174', '490', NULL, '', '6.00', '120.00', '90', '720.00', '0.00', '', '0.00', '0', '7650.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (187, '387215845399525', '4856684174', '404', NULL, '', '6.00', '120.00', '125', '720.00', '0.00', '', '0.00', '0', '7650.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (186, '392637921544583', '4856684174', '693', NULL, '', '2.00', '230.00', '130', '460.00', '0.00', '', '0.00', '0', '7650.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (194, '981965699468663', '4856684174', '99', NULL, '', '1.00', '300.00', '360', '300.00', '0.00', '', '0.00', '0', '7650.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (195, '667649731283262', '4856684174', '197', NULL, '', '1.00', '1000.00', '1500', '1000.00', '0.00', '', '0.00', '0', '7650.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (196, '157397334925388', '1826916967', '58', NULL, '', '1.00', '200.00', '115', '200.00', '0.00', '', NULL, '0', '910.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (197, '252127939613425', '1826916967', '699', NULL, '', '2.00', '355.00', '320', '710.00', '0.00', '', NULL, '0', '910.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (198, '617555925867992', '5976692598', '263', NULL, '', '2.00', '300.00', '350', '600.00', '0.00', '', NULL, '0', '2500.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (199, '628874689684419', '5976692598', '11', NULL, '', '17.00', '105.00', '105', '1785.00', '0.00', '', NULL, '0', '2500.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (200, '437943381354114', '5976692598', '490', NULL, '', '1.00', '115.00', '90', '115.00', '0.00', '', NULL, '0', '2500.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (201, '435988785166142', '3371369953', '19', NULL, '', '2.00', '80.00', '70', '160.00', '0.00', '', NULL, '0', '19820.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (202, '883712584166146', '3371369953', '421', NULL, '', '2.00', '60.00', '36', '120.00', '0.00', '', NULL, '0', '19820.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (203, '122723725863538', '3371369953', '29', NULL, '', '2.00', '50.00', '40', '100.00', '0.00', '', NULL, '0', '19820.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (204, '495664939836439', '3371369953', '254', NULL, '', '2.00', '250.00', '230', '500.00', '0.00', '', NULL, '0', '19820.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (205, '612645787434546', '3371369953', '63', NULL, '', '1.00', '5000.00', '4900', '5000.00', '0.00', '', NULL, '0', '19820.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (206, '913184843127287', '3371369953', '64', NULL, '', '1.00', '5000.00', '4900', '5000.00', '0.00', '', NULL, '0', '19820.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (207, '892991452625819', '3371369953', '697', NULL, '', '18.00', '430.00', '400', '7740.00', '0.00', '', NULL, '0', '19820.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (208, '571348914553264', '3371369953', '100', NULL, '', '1.00', '300.00', '300', '300.00', '0.00', '', NULL, '0', '19820.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (209, '918137679234137', '3371369953', '84', NULL, '', '2.00', '450.00', '450', '900.00', '0.00', '', NULL, '0', '19820.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (227, '133338489352491', '7976724629', '84', NULL, '', '2.00', '450.00', '450', '900.00', '0.00', '', '0.00', '0', '15520.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (226, '991642798697137', '7976724629', '100', NULL, '', '1.00', '300.00', '300', '300.00', '0.00', '', '0.00', '0', '15520.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (225, '462117447557359', '7976724629', '697', NULL, '', '8.00', '430.00', '400', '3440.00', '0.00', '', '0.00', '0', '15520.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (224, '315234468696583', '7976724629', '64', NULL, '', '1.00', '5000.00', '4900', '5000.00', '0.00', '', '0.00', '0', '15520.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (223, '937217965628367', '7976724629', '63', NULL, '', '1.00', '5000.00', '4900', '5000.00', '0.00', '', '0.00', '0', '15520.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (222, '936977523379468', '7976724629', '254', NULL, '', '2.00', '250.00', '230', '500.00', '0.00', '', '0.00', '0', '15520.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (221, '365855782776966', '7976724629', '29', NULL, '', '2.00', '50.00', '40', '100.00', '0.00', '', '0.00', '0', '15520.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (220, '715746522968734', '7976724629', '421', NULL, '', '2.00', '60.00', '36', '120.00', '0.00', '', '0.00', '0', '15520.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (219, '183518366965255', '7976724629', '19', NULL, '', '2.00', '80.00', '70', '160.00', '0.00', '', '0.00', '0', '15520.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (235, '991275555846692', '1249729836', '49', NULL, '', '1.00', '200.00', '160', '200.00', '0.00', '', '0.00', '0', '50010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (234, '937986376213583', '1249729836', '455', NULL, '', '7.00', '250.00', '230', '1750.00', '0.00', '', '0.00', '0', '50010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (233, '457761929655437', '1249729836', '454', NULL, '', '5.00', '380.00', '370', '1900.00', '0.00', '', '0.00', '0', '50010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (232, '222246756133925', '1249729836', '61', NULL, '', '40.00', '150.00', '160', '6000.00', '0.00', '', '0.00', '0', '50010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (236, '362464766861258', '1249729836', '220', NULL, '', '5.00', '200.00', '180', '1000.00', '0.00', '', '0.00', '0', '50010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (237, '184274855435962', '1249729836', '219', NULL, '', '1.00', '400.00', '380', '400.00', '0.00', '', '0.00', '0', '50010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (238, '366511792482375', '1249729836', '720', NULL, '', '1.00', '5500.00', '5500', '5500.00', '0.00', '', '0.00', '0', '50010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (239, '876733469819743', '1249729836', '57', NULL, '', '11.00', '120.00', '140', '1320.00', '0.00', '', '0.00', '0', '50010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (240, '599316591641317', '1249729836', '366', NULL, '', '4.00', '60.00', '46', '240.00', '0.00', '', '0.00', '0', '50010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (241, '568381964925828', '1249729836', '254', NULL, '', '6.00', '250.00', '230', '1500.00', '0.00', '', '0.00', '0', '50010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (242, '869954188555841', '1249729836', '407', NULL, '', '2.00', '350.00', '330', '700.00', '0.00', '', '0.00', '0', '50010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (243, '919693681688297', '1249729836', '579', NULL, '', '1.00', '2500.00', '2200', '2500.00', '0.00', '', '0.00', '0', '50010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (244, '155466913614966', '1249729836', '698', NULL, '', '3.00', '300.00', '290', '900.00', '0.00', '', '0.00', '0', '50010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (245, '477384397185238', '1249729836', '693', NULL, '', '1.00', '200.00', '130', '200.00', '0.00', '', '0.00', '0', '50010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (246, '346265766536699', '1249729836', '56', NULL, '', '1.00', '1200.00', '1000', '1200.00', '0.00', '', '0.00', '0', '50010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (247, '737874231743167', '1249729836', '148', NULL, '', '1.00', '14500.00', '14986', '14500.00', '0.00', '', '0.00', '0', '50010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (248, '272837215692646', '1249729836', '263', NULL, '', '1.00', '350.00', '350', '350.00', '0.00', '', '0.00', '0', '50010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (249, '286291295119583', '1249729836', '462', NULL, '', '1.00', '9100.00', '8650', '9100.00', '0.00', '', '0.00', '0', '50010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (250, '646145343246352', '1249729836', '572', NULL, '', '2.00', '375.00', '250', '750.00', '0.00', '', '0.00', '0', '50010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (256, '977838441612412', '9759274115', '235', NULL, '', '1.00', '1150.00', '1100', '1150.00', '0.00', '', '0.00', '0', '11010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (255, '516799392282633', '9759274115', '693', NULL, '', '10.00', '160.00', '130', '1600.00', '0.00', '', '0.00', '0', '11010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (254, '741574344529477', '9759274115', '254', NULL, '', '12.00', '230.00', '230', '2760.00', '0.00', '', '0.00', '0', '11010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (257, '687574852371844', '9759274115', '581', NULL, '', '4.00', '1200.00', '1000', '4800.00', '0.00', '', '0.00', '0', '11010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (258, '279423951748177', '9759274115', '8', NULL, '', '1.00', '550.00', '550', '550.00', '0.00', '', '0.00', '0', '11010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (259, '184615719325667', '9759274115', '264', NULL, '', '1.00', '150.00', '80', '150.00', '0.00', '', '0.00', '0', '11010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (277, '633733972124326', '7677745934', '2', NULL, '', '2.00', '220.00', '190', '440.00', '0.00', '', '0.00', '0', '7960.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (276, '131467142238997', '7677745934', '103', NULL, '', '1.00', '320.00', '320', '320.00', '0.00', '', '0.00', '0', '7960.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (275, '416881818275698', '7677745934', '659', NULL, '', '1.00', '1200.00', '1605', '1200.00', '0.00', '', '0.00', '0', '7960.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (274, '577556122456884', '7677745934', '197', NULL, '', '1.00', '1600.00', '1500', '1600.00', '0.00', '', '0.00', '0', '7960.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (273, '325743679495484', '7677745934', '490', NULL, '', '10.00', '120.00', '90', '1200.00', '0.00', '', '0.00', '0', '7960.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (272, '789835843179914', '7677745934', '57', NULL, '', '10.00', '120.00', '140', '1200.00', '0.00', '', '0.00', '0', '7960.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (278, '395968142326326', '7677745934', '127', NULL, '', '3.00', '300.00', '400', '900.00', '0.00', '', '0.00', '0', '7960.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (279, '414441179449222', '7677745934', '110', NULL, '', '1.00', '1100.00', '1296', '1100.00', '0.00', '', '0.00', '0', '7960.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (336, '748415757548717', '4651242384', '416', NULL, '', '2.00', '5300.00', '5000', '10600.00', '0.00', '', '0.00', '0', '19980.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (335, '372199586711297', '4651242384', '139', NULL, '', '1.00', '2900.00', '2961', '2900.00', '0.00', '', '0.00', '0', '19980.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (334, '184178932935468', '4651242384', '728', NULL, '', '3.00', '280.00', '260', '840.00', '0.00', '', '0.00', '0', '19980.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (333, '526254827757169', '4651242384', '57', NULL, '', '24.00', '120.00', '140', '2880.00', '0.00', '', '0.00', '0', '19980.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (332, '349574273462936', '4651242384', '579', NULL, '', '1.00', '2280.00', '2200', '2280.00', '0.00', '', '0.00', '0', '19980.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (331, '415617539539687', '4651242384', '269', NULL, '', '4.00', '120.00', '110', '480.00', '0.00', '', '0.00', '0', '19980.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (292, '744742792766774', '6139664445', '420', NULL, '', '1.00', '3700.00', '3936', '3700.00', '0.00', '', NULL, '0', '24740.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (293, '596256551617536', '6139664445', '156', NULL, '', '2.00', '3060.00', '3208', '6120.00', '0.00', '', NULL, '0', '24740.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (294, '377619983296593', '6139664445', '665', NULL, '', '2.00', '3060.00', '4935', '6120.00', '0.00', '', NULL, '0', '24740.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (295, '456896119976381', '6139664445', '663', NULL, '', '2.00', '2200.00', '3525', '4400.00', '0.00', '', NULL, '0', '24740.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (296, '614386744414836', '6139664445', '664', NULL, '', '2.00', '2200.00', '3525', '4400.00', '0.00', '', NULL, '0', '24740.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (297, '892961548464737', '9814175468', '693', NULL, '', '2.00', '200.00', '130', '400.00', '0.00', '', NULL, '0', '400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (298, '156695971178574', '8729851784', '248', NULL, '', '3.00', '400.00', '320', '1200.00', '0.00', '', NULL, '0', '2400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (299, '932992459653421', '8729851784', '251', NULL, '', '4.00', '300.00', '275', '1200.00', '0.00', '', NULL, '0', '2400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2591, '842948781743716', '2724633553', '664', NULL, '', '3.00', '2200.00', '3525', '6600.00', '0.00', '', '0.00', '0', '72150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2590, '596927831592836', '2724633553', '663', NULL, '', '3.00', '2200.00', '3525', '6600.00', '0.00', '', '0.00', '0', '72150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2589, '254227283465496', '2724633553', '660', NULL, '', '5.00', '970.00', '1605', '4850.00', '0.00', '', '0.00', '0', '72150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2588, '113212244843191', '2724633553', '659', NULL, '', '5.00', '970.00', '1605', '4850.00', '0.00', '', '0.00', '0', '72150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2587, '347671637861215', '2724633553', '158', NULL, '', '5.00', '3995.00', '4190', '19975.00', '0.00', '', '0.00', '0', '72150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2586, '844682914758455', '2724633553', '157', NULL, '', '5.00', '3995.00', '4190', '19975.00', '0.00', '', '0.00', '0', '72150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2585, '998643138742253', '2724633553', '625', NULL, '', '1.00', '50.00', '41', '50.00', '0.00', '', '0.00', '0', '72150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2584, '865815418389161', '2724633553', '57', NULL, '', '2.00', '125.00', '140', '250.00', '0.00', '', '0.00', '0', '72150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (383, '167929826192936', '7644324833', '72', NULL, '', '4.00', '2150.00', '2250', '8600.00', '0.00', '', '0.00', '0', '55610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3620, '743263543911815', '8125379816', '395', NULL, '', '4.00', '70.00', '50', '280.00', '0.00', '', '0.00', '0', '78805.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3619, '671666549988893', '8125379816', '114', NULL, '', '1.00', '500.00', '480', '500.00', '0.00', '', '0.00', '0', '78805.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3618, '861246998939375', '8125379816', '198', NULL, '', '3.00', '2000.00', '2100', '6000.00', '0.00', '', '0.00', '0', '78805.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3617, '536622253249442', '8125379816', '199', NULL, '', '3.00', '1800.00', '1900', '5400.00', '0.00', '', '0.00', '0', '78805.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3616, '432272246621285', '8125379816', '71', NULL, '', '1.00', '2300.00', '2250', '2300.00', '0.00', '', '0.00', '0', '78805.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3615, '543533672424582', '8125379816', '72', NULL, '', '2.00', '2300.00', '2250', '4600.00', '0.00', '', '0.00', '0', '78805.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3614, '951656811314478', '8125379816', '11', NULL, '', '15.00', '110.00', '105', '1650.00', '0.00', '', '0.00', '0', '78805.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3613, '543593943965273', '8125379816', '448', NULL, '', '1.00', '250.00', '120', '250.00', '0.00', '', '0.00', '0', '78805.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3612, '645645728744555', '8125379816', '625', NULL, '', '12.00', '50.00', '41', '600.00', '0.00', '', '0.00', '0', '78805.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3611, '186889236517897', '8125379816', '412', NULL, '', '1.00', '12500.00', '8800', '12500.00', '0.00', '', '0.00', '0', '78805.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3610, '123434976587619', '8125379816', '57', NULL, '', '10.00', '130.00', '140', '1300.00', '0.00', '', '0.00', '0', '78805.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3609, '653269525144698', '8125379816', '359', NULL, '', '1.00', '16600.00', '14400', '16600.00', '0.00', '', '0.00', '0', '78805.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3608, '185758884928597', '8125379816', '698', NULL, '', '10.00', '350.00', '290', '3500.00', '0.00', '', '0.00', '0', '78805.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3607, '346911662453713', '8125379816', '254', NULL, '', '10.00', '250.00', '230', '2500.00', '0.00', '', '0.00', '0', '78805.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3606, '481556942463334', '8125379816', '680', NULL, '', '4.00', '350.00', '336', '1400.00', '0.00', '', '0.00', '0', '78805.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3605, '618449875935884', '8125379816', '681', NULL, '', '4.00', '375.00', '310', '1500.00', '0.00', '', '0.00', '0', '78805.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3604, '686386648822764', '8125379816', '399', NULL, '', '15.00', '325.00', '287', '4875.00', '0.00', '', '0.00', '0', '78805.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3603, '498753433113323', '8125379816', '387', NULL, '', '19.00', '500.00', '486', '9500.00', '0.00', '', '0.00', '0', '78805.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3602, '574839982625451', '8125379816', '265', NULL, '', '1.00', '150.00', '120', '150.00', '0.00', '', '0.00', '0', '78805.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3601, '732612676212362', '8125379816', '16', NULL, '', '12.00', '125.00', '110', '1500.00', '0.00', '', '0.00', '0', '78805.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3600, '825586426854159', '8125379816', '194', NULL, '', '1.00', '1500.00', '1500', '1500.00', '0.00', '', '0.00', '0', '78805.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3599, '626439782871232', '8125379816', '213', NULL, '', '2.00', '200.00', '170', '400.00', '0.00', '', '0.00', '0', '78805.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (382, '647324991112274', '7644324833', '71', NULL, '', '5.00', '2150.00', '2250', '10750.00', '0.00', '', '0.00', '0', '55610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (384, '617441975256142', '7644324833', '411', NULL, '', '3.00', '3750.00', '3300', '11250.00', '0.00', '', '0.00', '0', '55610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (385, '133891481499685', '7644324833', '304', NULL, '', '1.00', '2200.00', '2000', '2200.00', '0.00', '', '0.00', '0', '55610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (386, '555358399826463', '7644324833', '344', NULL, '', '1.00', '2200.00', '2000', '2200.00', '0.00', '', '0.00', '0', '55610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (387, '426929958517511', '7644324833', '305', NULL, '', '1.00', '3000.00', '2900', '3000.00', '0.00', '', '0.00', '0', '55610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (388, '216857821935933', '7644324833', '345', NULL, '', '1.00', '3000.00', '2900', '3000.00', '0.00', '', '0.00', '0', '55610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (389, '864283539733492', '7644324833', '776', NULL, '', '4.00', '500.00', '486', '2000.00', '0.00', '', '0.00', '0', '55610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (390, '835362237983287', '7644324833', '678', NULL, '', '5.00', '300.00', '286', '1500.00', '0.00', '', '0.00', '0', '55610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (391, '545864851355787', '7644324833', '495', NULL, '', '1.00', '780.00', '650', '780.00', '0.00', '', '0.00', '0', '55610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (392, '318423189335773', '7644324833', '596', NULL, '', '1.00', '350.00', '336', '350.00', '0.00', '', '0.00', '0', '55610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (393, '834135962214664', '7644324833', '680', NULL, '', '1.00', '350.00', '336', '350.00', '0.00', '', '0.00', '0', '55610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (394, '346333663326486', '7644324833', '597', NULL, '', '1.00', '250.00', '250', '250.00', '0.00', '', '0.00', '0', '55610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (395, '359692873214792', '7644324833', '219', NULL, '', '1.00', '400.00', '380', '400.00', '0.00', '', '0.00', '0', '55610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (396, '718779994635147', '7644324833', '220', NULL, '', '6.00', '250.00', '180', '1500.00', '0.00', '', '0.00', '0', '55610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (397, '831446893428635', '7644324833', '675', NULL, '', '3.00', '50.00', '50', '150.00', '0.00', '', '0.00', '0', '55610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (398, '367136273621665', '7644324833', '213', NULL, '', '1.00', '200.00', '170', '200.00', '0.00', '', '0.00', '0', '55610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (399, '687562815984531', '7644324833', '60', NULL, '', '30.00', '200.00', '200', '6000.00', '0.00', '', '0.00', '0', '55610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (400, '265936958339557', '7644324833', '16', NULL, '', '8.00', '110.00', '110', '880.00', '0.00', '', '0.00', '0', '55610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (401, '245761633748245', '7644324833', '693', NULL, '', '1.00', '200.00', '130', '200.00', '0.00', '', '0.00', '0', '55610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (402, '641696785195719', '7644324833', '625', NULL, '', '1.00', '50.00', '41', '50.00', '0.00', '', '0.00', '0', '55610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (403, '641245322219526', '1345623824', '695', NULL, '', '12.00', '270.00', '280', '3240.00', '0.00', '', NULL, '0', '10730.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (404, '739674345852764', '1345623824', '58', NULL, '', '1.00', '150.00', '115', '150.00', '0.00', '', NULL, '0', '10730.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (405, '776918189264319', '1345623824', '179', NULL, '', '96.00', '30.00', '36', '2880.00', '0.00', '', NULL, '0', '10730.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (406, '854927224594746', '1345623824', '420', NULL, '', '1.00', '3760.00', '3936', '3760.00', '0.00', '', NULL, '0', '10730.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (407, '835777831611949', '1345623824', '387', NULL, '', '1.00', '550.00', '486', '550.00', '0.00', '', NULL, '0', '10730.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (408, '576953745116387', '1345623824', '675', NULL, '', '3.00', '50.00', '50', '150.00', '0.00', '', NULL, '0', '10730.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (409, '762455895748679', '5144393325', '19', NULL, '', '25.00', '80.00', '70', '2000.00', '0.00', '', NULL, '0', '2000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (470, '613249217274236', '4148625191', '679', NULL, '', '1.00', '300.00', '259', '300.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (469, '395651317212299', '4148625191', '776', NULL, '', '7.00', '650.00', '486', '4550.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (468, '961745127573834', '4148625191', '693', NULL, '', '5.00', '200.00', '130', '1000.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (467, '336663834226666', '4148625191', '699', NULL, '', '1.00', '300.00', '320', '300.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (466, '128386678466379', '4148625191', '19', NULL, '', '12.00', '100.00', '70', '1200.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (465, '564989651862846', '4148625191', '366', NULL, '', '1.00', '50.00', '46', '50.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (464, '149568735812428', '4148625191', '67', NULL, '', '5.00', '2650.00', '2600', '13250.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (463, '665322178489437', '4148625191', '68', NULL, '', '5.00', '2650.00', '2600', '13250.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (462, '327729741191341', '4148625191', '69', NULL, '', '3.00', '5800.00', '5200', '17400.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (461, '844692951379881', '4148625191', '70', NULL, '', '3.00', '5800.00', '5200', '17400.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (460, '548857425426989', '4148625191', '310', NULL, '', '2.00', '9800.00', '8700', '19600.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (459, '516946555442881', '4148625191', '350', NULL, '', '2.00', '9800.00', '8700', '19600.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (458, '152132744197124', '4148625191', '349', NULL, '', '1.00', '6800.00', '6000', '6800.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (457, '157478632738781', '4148625191', '309', NULL, '', '1.00', '6800.00', '6000', '6800.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (456, '885837968954648', '4148625191', '726', NULL, '', '2.00', '5200.00', '4800', '10400.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (455, '981971915521131', '4148625191', '727', NULL, '', '2.00', '5200.00', '4800', '10400.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (454, '931356426834123', '4148625191', '572', NULL, '', '30.00', '400.00', '250', '12000.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (453, '394338771842659', '4148625191', '698', NULL, '', '25.00', '350.00', '290', '8750.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (452, '822128337864741', '4148625191', '680', NULL, '', '4.00', '375.00', '336', '1500.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (451, '434659329628628', '4148625191', '399', NULL, '', '5.00', '350.00', '287', '1750.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (450, '798325627572243', '4148625191', '401', NULL, '', '3.00', '600.00', '475', '1800.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (471, '296749377951571', '4148625191', '600', NULL, '', '3.00', '50.00', '400', '150.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (472, '837928958396575', '4148625191', '213', NULL, '', '1.00', '250.00', '170', '250.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (473, '225137717358869', '4148625191', '603', NULL, '', '7.00', '375.00', '250', '2625.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (474, '148493185589418', '4148625191', '221', NULL, '', '1.00', '850.00', '500', '850.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (475, '365942231211852', '4148625191', '448', NULL, '', '1.00', '250.00', '120', '250.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (476, '221996651279368', '4148625191', '497', NULL, '', '1.00', '350.00', '160', '350.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (477, '334317526671489', '4148625191', '625', NULL, '', '8.00', '50.00', '41', '400.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (478, '646318193759319', '4148625191', '495', NULL, '', '1.00', '900.00', '650', '900.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (479, '354817297369547', '4148625191', '254', NULL, '', '4.00', '250.00', '230', '1000.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (480, '676679322684674', '4148625191', '693', NULL, '', '2.00', '200.00', '130', '400.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (481, '949715813117994', '4148625191', '693', NULL, '', '1.00', '165.00', '130', '165.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (482, '243724235359299', '4148625191', '448', NULL, '', '1.00', '180.00', '120', '180.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (483, '683249735918718', '4148625191', '248', NULL, '', '3.00', '700.00', '320', '2100.00', '0.00', '', '0.00', '0', '177720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (497, '318376959726294', '4365216877', '714', NULL, '', '3.00', '480.00', '325', '1440.00', '0.00', '', '0.00', '0', '88130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (496, '287752375843539', '4365216877', '407', NULL, '', '6.00', '320.00', '330', '1920.00', '0.00', '', '0.00', '0', '88130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (495, '126639754828849', '4365216877', '58', NULL, '', '12.00', '120.00', '115', '1440.00', '0.00', '', '0.00', '0', '88130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (494, '962568889628874', '4365216877', '1', NULL, '', '1.00', '430.00', '370', '430.00', '0.00', '', '0.00', '0', '88130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (493, '856247355895453', '4365216877', '494', NULL, '', '1.00', '300.00', '290', '300.00', '0.00', '', '0.00', '0', '88130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (498, '163664638873521', '4365216877', '448', NULL, '', '2.00', '115.00', '120', '230.00', '0.00', '', '0.00', '0', '88130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (499, '879942771595128', '4365216877', '497', NULL, '', '1.00', '160.00', '160', '160.00', '0.00', '', '0.00', '0', '88130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (500, '257435847617927', '4365216877', '498', NULL, '', '1.00', '170.00', '250', '170.00', '0.00', '', '0.00', '0', '88130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (501, '873825548996939', '4365216877', '419', NULL, '', '1.00', '6700.00', '6731', '6700.00', '0.00', '', '0.00', '0', '88130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (502, '312976164647413', '4365216877', '660', NULL, '', '3.00', '1000.00', '1605', '3000.00', '0.00', '', '0.00', '0', '88130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (503, '988768558217541', '4365216877', '659', NULL, '', '3.00', '1000.00', '1605', '3000.00', '0.00', '', '0.00', '0', '88130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (504, '579193217367878', '4365216877', '662', NULL, '', '3.00', '1450.00', '2395', '4350.00', '0.00', '', '0.00', '0', '88130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (505, '876745343147993', '4365216877', '661', NULL, '', '3.00', '1450.00', '2395', '4350.00', '0.00', '', '0.00', '0', '88130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (506, '484658974418489', '4365216877', '663', NULL, '', '2.00', '2150.00', '3525', '4300.00', '0.00', '', '0.00', '0', '88130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (507, '996918338926212', '4365216877', '664', NULL, '', '2.00', '2150.00', '3525', '4300.00', '0.00', '', '0.00', '0', '88130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (508, '142243961815359', '4365216877', '670', NULL, '', '3.00', '4850.00', '7885', '14550.00', '0.00', '', '0.00', '0', '88130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (509, '485318612265265', '4365216877', '669', NULL, '', '3.00', '4850.00', '7885', '14550.00', '0.00', '', '0.00', '0', '88130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (510, '425358499139486', '4365216877', '102', NULL, '', '16.00', '480.00', '450', '7680.00', '0.00', '', '0.00', '0', '88130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (511, '446123386913518', '4365216877', '57', NULL, '', '12.00', '130.00', '140', '1560.00', '0.00', '', '0.00', '0', '88130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (512, '448781815488162', '4365216877', '238', NULL, '', '12.00', '330.00', '320', '3960.00', '0.00', '', '0.00', '0', '88130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (513, '432699312252287', '4365216877', '219', NULL, '', '6.00', '540.00', '380', '3240.00', '0.00', '', '0.00', '0', '88130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (514, '778277656971621', '4365216877', '2', NULL, '', '2.00', '240.00', '190', '480.00', '0.00', '', '0.00', '0', '88130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (515, '671118995542676', '4365216877', '28', NULL, '', '6.00', '120.00', '120', '720.00', '0.00', '', '0.00', '0', '88130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (516, '662138142722867', '4365216877', '68', NULL, '', '1.00', '2650.00', '2600', '2650.00', '0.00', '', '0.00', '0', '88130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (517, '246487255714243', '4365216877', '67', NULL, '', '1.00', '2650.00', '2600', '2650.00', '0.00', '', '0.00', '0', '88130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (518, '594682558159366', '4863552591', '9', NULL, '', '2.00', '450.00', '430', '900.00', '0.00', '', NULL, '0', '1500.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (519, '344428588461457', '4863552591', '60', NULL, '', '3.00', '200.00', '200', '600.00', '0.00', '', NULL, '0', '1500.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (520, '966227341517178', '1589449478', '15', NULL, '', '6.00', '125.00', '135', '750.00', '0.00', '', NULL, '0', '10700.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (521, '562786482724972', '1589449478', '57', NULL, '', '1.00', '150.00', '140', '150.00', '0.00', '', NULL, '0', '10700.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (522, '371543186745352', '1589449478', '145', NULL, '', '1.00', '9200.00', '9331', '9200.00', '0.00', '', NULL, '0', '10700.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (523, '318182547854388', '1589449478', '269', NULL, '', '4.00', '150.00', '110', '600.00', '0.00', '', NULL, '0', '10700.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (524, '237491866822533', '4687811218', '15', NULL, '', '6.00', '125.00', '135', '750.00', '0.00', '', NULL, '0', '10700.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (525, '659935231643578', '4687811218', '57', NULL, '', '1.00', '150.00', '140', '150.00', '0.00', '', NULL, '0', '10700.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (526, '635532726596783', '4687811218', '145', NULL, '', '1.00', '9200.00', '9331', '9200.00', '0.00', '', NULL, '0', '10700.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (527, '676268254434679', '4687811218', '269', NULL, '', '4.00', '150.00', '110', '600.00', '0.00', '', NULL, '0', '10700.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (921, '684336728683258', '9619147336', '494', NULL, '', '1.00', '360.00', '290', '360.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (920, '164884688882528', '9619147336', '233', NULL, '', '2.00', '120.00', '1050', '240.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (919, '915597821292322', '9619147336', '100', NULL, '', '2.00', '320.00', '300', '640.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (918, '745171728686642', '9619147336', '272', NULL, '', '2.00', '240.00', '220', '480.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (917, '327725573577586', '9619147336', '183', NULL, '', '3.00', '200.00', '1600', '600.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (916, '948467799973266', '9619147336', '71', NULL, '', '1.00', '2500.00', '2250', '2500.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (915, '667736193578511', '9619147336', '698', NULL, '', '2.00', '200.00', '290', '400.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (914, '473981617671942', '9619147336', '136', NULL, '', '1.00', '3000.00', '2961', '3000.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (913, '217585876963623', '9619147336', '135', NULL, '', '2.00', '3000.00', '2961', '6000.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (912, '687578168779439', '9619147336', '193', NULL, '', '1.00', '4200.00', '1700', '4200.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (911, '332224421186626', '9619147336', '421', NULL, '', '2.00', '50.00', '36', '100.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (910, '246136275447642', '9619147336', '625', NULL, '', '5.00', '50.00', '41', '250.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (909, '994896922965121', '9619147336', '247', NULL, '', '1.00', '850.00', '650', '850.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (908, '725443228548578', '9619147336', '236', NULL, '', '1.00', '900.00', '920', '900.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (907, '235889964956872', '9619147336', '700', NULL, '', '50.00', '150.00', '160', '7500.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (906, '859156141184787', '9619147336', '495', NULL, '', '2.00', '600.00', '650', '1200.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (905, '576114149425855', '9619147336', '219', NULL, '', '1.00', '340.00', '380', '340.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (904, '365734741412281', '9619147336', '220', NULL, '', '7.00', '170.00', '180', '1190.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (903, '644918513878549', '9619147336', '600', NULL, '', '3.00', '50.00', '400', '150.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (902, '686385562116252', '9619147336', '213', NULL, '', '1.00', '200.00', '170', '200.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (901, '247161493817447', '9619147336', '366', NULL, '', '10.00', '50.00', '46', '500.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (900, '265429971647944', '9619147336', '448', NULL, '', '1.00', '150.00', '120', '150.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (899, '522445347413674', '9619147336', '498', NULL, '', '1.00', '200.00', '250', '200.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (898, '447113132848453', '9619147336', '725', NULL, '', '1.00', '200.00', '180', '200.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (897, '336284387768579', '9619147336', '251', NULL, '', '6.00', '280.00', '275', '1680.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (895, '474131261496579', '9619147336', '592', NULL, '', '8.00', '480.00', '482', '3840.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (896, '481394826287224', '9619147336', '67', NULL, '', '1.00', '2200.00', '2600', '2200.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3487, '741476584229231', '2744992295', '735', NULL, '', '1.00', '250.00', '150', '250.00', '0.00', '', '0.00', '0', '30720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3486, '626548647547529', '2744992295', '156', NULL, '', '1.00', '3500.00', '3208', '3500.00', '0.00', '', '0.00', '0', '30720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3485, '743241136782689', '2744992295', '155', NULL, '', '1.00', '3500.00', '3208', '3500.00', '0.00', '', '0.00', '0', '30720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3484, '731338727116679', '2744992295', '490', NULL, '', '2.00', '150.00', '90', '300.00', '0.00', '', '0.00', '0', '30720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3483, '326681728668967', '2744992295', '730', NULL, '', '54.00', '120.00', '150', '6480.00', '0.00', '', '0.00', '0', '30720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3482, '765552912739158', '2744992295', '729', NULL, '', '45.00', '100.00', '100', '4500.00', '0.00', '', '0.00', '0', '30720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3481, '111356455466578', '2744992295', '501', NULL, '', '1.00', '250.00', '240', '250.00', '0.00', '', '0.00', '0', '30720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3480, '755535984125432', '2744992295', '271', NULL, '', '1.00', '240.00', '120', '240.00', '0.00', '', '0.00', '0', '30720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3479, '311885871322215', '2744992295', '86', NULL, '', '1.00', '600.00', '390', '600.00', '0.00', '', '0.00', '0', '30720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3478, '863471846343491', '2744992295', '284', NULL, '', '4.00', '70.00', '40', '280.00', '0.00', '', '0.00', '0', '30720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (894, '216642322622727', '9619147336', '595', NULL, '', '2.00', '320.00', '323', '640.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (893, '761675417166679', '9619147336', '596', NULL, '', '3.00', '350.00', '336', '1050.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (892, '657622514138369', '9619147336', '594', NULL, '', '12.00', '280.00', '290', '3360.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (891, '181455363429498', '9619147336', '484', NULL, '', '4.00', '250.00', '275', '1000.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (890, '564536791296781', '9619147336', '593', NULL, '', '2.00', '460.00', '450', '920.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (889, '597951798552835', '9619147336', '86', NULL, '', '3.00', '600.00', '390', '1800.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (887, '231534976192447', '9619147336', '497', NULL, '', '3.00', '180.00', '160', '540.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (888, '928842586468627', '9619147336', '270', NULL, '', '2.00', '180.00', '160', '360.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (886, '726886568425633', '9619147336', '175', NULL, '', '2.00', '180.00', '125', '360.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (885, '211972299557336', '9619147336', '176', NULL, '', '2.00', '120.00', '65', '240.00', '0.00', '', '0.00', '0', '50140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (868, '621385188365381', '1246899298', '604', NULL, '', '24.00', '240.00', '175', '5760.00', '0.00', '', NULL, '0', '9440.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (869, '176449364197458', '1246899298', '424', NULL, '', '4.00', '920.00', '900', '3680.00', '0.00', '', NULL, '0', '9440.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1006, '365584673915322', '4732574941', '445', NULL, '', '1.00', '200.00', '150', '200.00', '0.00', '', '0.00', '0', '54490.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1005, '273457715858185', '4732574941', '444', NULL, '', '1.00', '300.00', '150', '300.00', '0.00', '', '0.00', '0', '54490.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1004, '897791363766894', '4732574941', '460', NULL, '', '1.00', '1000.00', '1000', '1000.00', '0.00', '', '0.00', '0', '54490.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1003, '254578412629398', '4732574941', '432', NULL, '', '1.00', '5000.00', '4000', '5000.00', '0.00', '', '0.00', '0', '54490.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1002, '733722854137868', '4732574941', '428', NULL, '', '1.00', '8000.00', '5500', '8000.00', '0.00', '', '0.00', '0', '54490.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1001, '587573753258897', '4732574941', '440', NULL, '', '1.00', '500.00', '450', '500.00', '0.00', '', '0.00', '0', '54490.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1000, '991817466367194', '4732574941', '439', NULL, '', '2.00', '250.00', '250', '500.00', '0.00', '', '0.00', '0', '54490.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (999, '421186477675788', '4732574941', '438', NULL, '', '2.00', '800.00', '300', '1600.00', '0.00', '', '0.00', '0', '54490.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (998, '282338183123494', '4732574941', '437', NULL, '', '1.00', '200.00', '200', '200.00', '0.00', '', '0.00', '0', '54490.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (997, '891575758691413', '4732574941', '436', NULL, '', '1.00', '2000.00', '1500', '2000.00', '0.00', '', '0.00', '0', '54490.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (996, '177727229919844', '4732574941', '435', NULL, '', '1.00', '150.00', '150', '150.00', '0.00', '', '0.00', '0', '54490.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (995, '535886939438256', '4732574941', '434', NULL, '', '1.00', '7000.00', '6500', '7000.00', '0.00', '', '0.00', '0', '54490.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (994, '168817554563293', '4732574941', '433', NULL, '', '1.00', '1500.00', '1050', '1500.00', '0.00', '', '0.00', '0', '54490.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (993, '993394361733831', '4732574941', '431', NULL, '', '2.00', '150.00', '150', '300.00', '0.00', '', '0.00', '0', '54490.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (992, '792335329951618', '4732574941', '430', NULL, '', '2.00', '150.00', '150', '300.00', '0.00', '', '0.00', '0', '54490.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (991, '666792462519575', '4732574941', '429', NULL, '', '1.00', '3000.00', '2000', '3000.00', '0.00', '', '0.00', '0', '54490.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (990, '824256185695661', '4732574941', '427', NULL, '', '1.00', '1500.00', '1200', '1500.00', '0.00', '', '0.00', '0', '54490.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (989, '756712427539437', '4732574941', '426', NULL, '', '1.00', '9000.00', '8000', '9000.00', '0.00', '', '0.00', '0', '54490.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (988, '643557586825395', '4732574941', '561', NULL, '', '1.00', '3000.00', '2150', '3000.00', '0.00', '', '0.00', '0', '54490.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (941, '653922791218223', '6671999227', '446', NULL, '', '6.00', '1850.00', '1450', '11100.00', '0.00', '', NULL, '0', '65990.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (942, '237252146595487', '6671999227', '443', NULL, '', '1.00', '400.00', '300', '400.00', '0.00', '', NULL, '0', '65990.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (943, '158728682154726', '6776515978', '409', NULL, '', '30.00', '1060.00', '820', '31800.00', '0.00', '', NULL, '0', '97790.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (944, '647691694873762', '5329238352', '458', NULL, '', '2.00', '75.00', '60', '150.00', '0.00', '', NULL, '0', '101340.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (945, '276646279749359', '5329238352', '456', NULL, '', '1.00', '700.00', '410', '700.00', '0.00', '', NULL, '0', '101340.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (946, '526372752774423', '5329238352', '459', NULL, '', '1.00', '1950.00', '1100', '1950.00', '0.00', '', NULL, '0', '101340.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (947, '261759622846341', '5329238352', '457', NULL, '', '1.00', '750.00', '450', '750.00', '0.00', '', NULL, '0', '101340.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (948, '649491489358576', '3187145389', '465', NULL, '', '1.00', '1200.00', '1100', '1200.00', '0.00', '', NULL, '0', '131140.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (949, '181346462678766', '3187145389', '574', NULL, '', '1.00', '17800.00', '14500', '17800.00', '0.00', '', NULL, '0', '131140.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (950, '329425752258189', '3187145389', '461', NULL, '', '6.00', '1800.00', '1500', '10800.00', '0.00', '', NULL, '0', '131140.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (951, '626434267194469', '9741378871', '527', NULL, '', '2.00', '800.00', '660', '1600.00', '0.00', '', NULL, '0', '156800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (952, '897771673179262', '9741378871', '528', NULL, '', '2.00', '700.00', '550', '1400.00', '0.00', '', NULL, '0', '156800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (953, '878563546726484', '9741378871', '529', NULL, '', '3.00', '1100.00', '850', '3300.00', '0.00', '', NULL, '0', '156800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (954, '154177318934964', '9741378871', '530', NULL, '', '1.00', '1200.00', '850', '1200.00', '0.00', '', NULL, '0', '156800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (955, '422916992333929', '9741378871', '531 ', NULL, '', '1.00', '900.00', '700', '900.00', '0.00', '', NULL, '0', '156800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (956, '255297927124946', '9741378871', '532', NULL, '', '1.00', '1850.00', '1600', '1850.00', '0.00', '', NULL, '0', '156800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (957, '388352274833995', '9741378871', '533', NULL, '', '1.00', '680.00', '480', '680.00', '0.00', '', NULL, '0', '156800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (958, '911772576243493', '9741378871', '563', NULL, '', '1.00', '450.00', '380', '450.00', '0.00', '', NULL, '0', '156800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (959, '968463278153432', '9741378871', '534', NULL, '', '1.00', '200.00', '130', '200.00', '0.00', '', NULL, '0', '156800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (960, '161898323711287', '9741378871', '535', NULL, '', '1.00', '250.00', '130', '250.00', '0.00', '', NULL, '0', '156800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (961, '875277873384685', '9741378871', '536', NULL, '', '1.00', '280.00', '180', '280.00', '0.00', '', NULL, '0', '156800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (962, '921237747513118', '9741378871', '537', NULL, '', '7.00', '220.00', '160', '1540.00', '0.00', '', NULL, '0', '156800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (963, '531313638138472', '9741378871', '538', NULL, '', '6.00', '210.00', '160', '1260.00', '0.00', '', NULL, '0', '156800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (964, '699578787544552', '9741378871', '543', NULL, '', '4.00', '50.00', '30', '200.00', '0.00', '', NULL, '0', '156800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (965, '827262514639899', '9741378871', '539', NULL, '', '1.00', '150.00', '90', '150.00', '0.00', '', NULL, '0', '156800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (966, '489438579635274', '9741378871', '540', NULL, '', '36.00', '25.00', '15', '900.00', '0.00', '', NULL, '0', '156800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (967, '414385153488853', '9741378871', '548', NULL, '', '1.00', '6000.00', '3500', '6000.00', '0.00', '', NULL, '0', '156800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (968, '229233588861967', '9741378871', '541 ', NULL, '', '2.00', '850.00', '650', '1700.00', '0.00', '', NULL, '0', '156800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (969, '524294334658723', '9741378871', '546', NULL, '', '4.00', '50.00', '35', '200.00', '0.00', '', NULL, '0', '156800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (970, '598636937932988', '9741378871', '544', NULL, '', '2.00', '600.00', '450', '1200.00', '0.00', '', NULL, '0', '156800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (971, '348922577181392', '9741378871', '545', NULL, '', '1.00', '400.00', '250', '400.00', '0.00', '', NULL, '0', '156800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1038, '912936767624175', '3215962328', '648', NULL, '', '2.00', '380.00', '300', '760.00', '0.00', '', '0.00', '0', '187340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1037, '884727239943157', '3215962328', '509', NULL, '', '1.00', '4950.00', '4600', '4950.00', '0.00', '', '0.00', '0', '187340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1036, '145273914817957', '3215962328', '510', NULL, '', '3.00', '70.00', '33', '210.00', '0.00', '', '0.00', '0', '187340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1035, '433289257425984', '3215962328', '511', NULL, '', '1.00', '9700.00', '8700', '9700.00', '0.00', '', '0.00', '0', '187340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1034, '929275497947494', '3215962328', '512', NULL, '', '10.00', '90.00', '80', '900.00', '0.00', '', '0.00', '0', '187340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1033, '311364415366783', '3215962328', '513', NULL, '', '12.00', '150.00', '140', '1800.00', '0.00', '', '0.00', '0', '187340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1032, '153562914428489', '3215962328', '497', NULL, '', '1.00', '610.00', '160', '610.00', '0.00', '', '0.00', '0', '187340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1031, '253938653497841', '3215962328', '518', NULL, '', '2.00', '650.00', '600', '1300.00', '0.00', '', '0.00', '0', '187340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1030, '592399154846793', '3215962328', '519', NULL, '', '1.00', '1200.00', '900', '1200.00', '0.00', '', '0.00', '0', '187340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1029, '387475761145299', '3215962328', '520', NULL, '', '4.00', '150.00', '120', '600.00', '0.00', '', '0.00', '0', '187340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1028, '731125996434885', '3215962328', '521', NULL, '', '4.00', '150.00', '120', '600.00', '0.00', '', '0.00', '0', '187340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1027, '127919649258563', '3215962328', '523', NULL, '', '2.00', '20.00', '10', '40.00', '0.00', '', '0.00', '0', '187340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1026, '221712391466634', '3215962328', '522', NULL, '', '60.00', '55.00', '50', '3300.00', '0.00', '', '0.00', '0', '187340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1025, '665937742163194', '3215962328', '524', NULL, '', '1.00', '950.00', '700', '950.00', '0.00', '', '0.00', '0', '187340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1024, '461324496747658', '3215962328', '525', NULL, '', '1.00', '1300.00', '1150', '1300.00', '0.00', '', '0.00', '0', '187340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1023, '392659135863961', '3215962328', '526', NULL, '', '1.00', '2320.00', '1445', '2320.00', '0.00', '', '0.00', '0', '187340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1039, '645694355282937', '1844216916', '690', NULL, '', '30.00', '1060.00', '830', '31800.00', '0.00', '', NULL, '0', '219140.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1040, '633899992644896', '5337563468', '545', NULL, '', '1.00', '400.00', '250', '400.00', '0.00', '', NULL, '0', '237590.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1041, '664833795444373', '5337563468', '534', NULL, '', '1.00', '200.00', '130', '200.00', '0.00', '', NULL, '0', '237590.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1042, '255597375412882', '5337563468', '535', NULL, '', '1.00', '250.00', '130', '250.00', '0.00', '', NULL, '0', '237590.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1043, '412679612134641', '5337563468', '536', NULL, '', '1.00', '280.00', '180', '280.00', '0.00', '', NULL, '0', '237590.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1044, '566372858745623', '5337563468', '550', NULL, '', '2.00', '210.00', '200', '420.00', '0.00', '', NULL, '0', '237590.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1045, '813932396162658', '5337563468', '552', NULL, '', '1.00', '2100.00', '1800', '2100.00', '0.00', '', NULL, '0', '237590.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1046, '295284693133431', '5337563468', '530', NULL, '', '2.00', '1200.00', '850', '2400.00', '0.00', '', NULL, '0', '237590.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1047, '995329837422582', '5337563468', '547', NULL, '', '1.00', '3950.00', '3100', '3950.00', '0.00', '', NULL, '0', '237590.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1048, '466284859441535', '5337563468', '548', NULL, '', '1.00', '6000.00', '3500', '6000.00', '0.00', '', NULL, '0', '237590.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1049, '159547455982374', '5337563468', '549', NULL, '', '1.00', '2450.00', '1700', '2450.00', '0.00', '', NULL, '0', '237590.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1050, '282472156159916', '2824924738', '469', NULL, '', '4.00', '1450.00', '1050', '5800.00', '0.00', '', NULL, '0', '249680.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1051, '159147145647912', '2824924738', '471 ', NULL, '', '1.00', '1250.00', '1180', '1250.00', '0.00', '', NULL, '0', '249680.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1052, '171722725464465', '2824924738', '470 ', NULL, '', '12.00', '70.00', '60', '840.00', '0.00', '', NULL, '0', '249680.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1053, '824451735287561', '2824924738', '468', NULL, '', '12.00', '350.00', '225', '4200.00', '0.00', '', NULL, '0', '249680.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1074, '198719374539683', '6524154835', '510', NULL, '', '3.00', '40.00', '33', '120.00', '0.00', '', '0.00', '0', '25440.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1073, '277763421653151', '6524154835', '511', NULL, '', '1.00', '9700.00', '8700', '9700.00', '0.00', '', '0.00', '0', '25440.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1072, '677675167552291', '6524154835', '558', NULL, '', '1.00', '1100.00', '800', '1100.00', '0.00', '', '0.00', '0', '25440.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1071, '932289412228825', '6524154835', '557', NULL, '', '3.00', '290.00', '230', '870.00', '0.00', '', '0.00', '0', '25440.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1070, '942239567721266', '6524154835', '556', NULL, '', '2.00', '3400.00', '3100', '6800.00', '0.00', '', '0.00', '0', '25440.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1069, '644266849864476', '6524154835', '555', NULL, '', '2.00', '1800.00', '1550', '3600.00', '0.00', '', '0.00', '0', '25440.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1068, '726488886883769', '6524154835', '554', NULL, '', '5.00', '650.00', '500', '3250.00', '0.00', '', '0.00', '0', '25440.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1088, '868971167993991', '2892979613', '554', NULL, '', '5.00', '650.00', '500', '3250.00', '0.00', '', '0.00', '0', '300710.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1087, '671122994393111', '2892979613', '555', NULL, '', '2.00', '1800.00', '1550', '3600.00', '0.00', '', '0.00', '0', '300710.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1086, '869356267157843', '2892979613', '556', NULL, '', '2.00', '3400.00', '3100', '6800.00', '0.00', '', '0.00', '0', '300710.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1085, '756318899324345', '2892979613', '557', NULL, '', '3.00', '290.00', '230', '870.00', '0.00', '', '0.00', '0', '300710.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1084, '399652948673219', '2892979613', '558', NULL, '', '1.00', '1100.00', '800', '1100.00', '0.00', '', '0.00', '0', '300710.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1083, '921119434387455', '2892979613', '511', NULL, '', '1.00', '9700.00', '8700', '9700.00', '0.00', '', '0.00', '0', '300710.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1082, '453994525785267', '2892979613', '510', NULL, '', '3.00', '40.00', '33', '120.00', '0.00', '', '0.00', '0', '300710.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1089, '411279386753693', '2892979613', '559', NULL, '', '2.00', '75.00', '50', '150.00', '0.00', '', '0.00', '0', '300710.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1091, '748881644874394', '3895873329', '712', NULL, '', '12.00', '380.00', '320', '4560.00', '0.00', '', '0.00', '0', '427390.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1092, '119627418382864', '3895873329', '566', NULL, '', '8.00', '3800.00', '2500', '30400.00', '0.00', '', '0.00', '0', '427390.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1093, '933134999188139', '3895873329', '565', NULL, '', '8.00', '3800.00', '2500', '30400.00', '0.00', '', '0.00', '0', '427390.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1094, '975416721449781', '3895873329', '469', NULL, '', '10.00', '1450.00', '1050', '14500.00', '0.00', '', '0.00', '0', '427390.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1095, '158853668315375', '3895873329', '564', NULL, '', '50.00', '430.00', '290', '21500.00', '0.00', '', '0.00', '0', '427390.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1096, '191174876422169', '3895873329', '508', NULL, '', '12.00', '380.00', '310', '4560.00', '0.00', '', '0.00', '0', '427390.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1097, '885629488411549', '3895873329', '567', NULL, '', '12.00', '1380.00', '1250', '16560.00', '0.00', '', '0.00', '0', '427390.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1098, '835893917176292', '3895873329', '568', NULL, '', '12.00', '350.00', '200', '4200.00', '0.00', '', '0.00', '0', '427390.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1099, '191356631636362', '2769281188', '570', NULL, '', '50.00', '1000.00', '600', '50000.00', '0.00', '', NULL, '0', '477390.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1100, '722156153238878', '3928135646', '475', NULL, '', '500.00', '34.00', '24', '17000.00', '0.00', '', NULL, '0', '659990.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1101, '519731967785526', '3928135646', '567', NULL, '', '120.00', '1380.00', '1250', '165600.00', '0.00', '', NULL, '0', '659990.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1102, '834625975249368', '2496582565', '425', NULL, '', '1.00', '2700.00', '1600', '2700.00', '0.00', '', NULL, '0', '662690.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6706, '322382598568826', '2135868574', '57', NULL, '', '0.00', '0.00', '140', '0.00', '0.00', '', '0.00', '0', '659990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1104, '325525465449968', '5243247132', '541 ', NULL, '', '6.00', '750.00', '650', '4500.00', '0.00', '', NULL, '0', '676150.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1105, '256521527163766', '5243247132', '537', NULL, '', '4.00', '230.00', '160', '920.00', '0.00', '', NULL, '0', '676150.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1106, '276116273955989', '5243247132', '562', NULL, '', '1.00', '1150.00', '700', '1150.00', '0.00', '', NULL, '0', '676150.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1107, '423865389612647', '5243247132', '540', NULL, '', '48.00', '25.00', '15', '1200.00', '0.00', '', NULL, '0', '676150.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1108, '662322655946434', '5243247132', '498', NULL, '', '1.00', '360.00', '250', '360.00', '0.00', '', NULL, '0', '676150.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1109, '423128924669241', '5243247132', '645', NULL, '', '1.00', '900.00', '350', '900.00', '0.00', '', NULL, '0', '676150.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1110, '522821893447786', '5243247132', '550', NULL, '', '5.00', '220.00', '200', '1100.00', '0.00', '', NULL, '0', '676150.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1111, '744614276332688', '5243247132', '551', NULL, '', '3.00', '210.00', '140', '630.00', '0.00', '', NULL, '0', '676150.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1112, '537468536948932', '1537578668', '508', NULL, '', '15.00', '380.00', '310', '5700.00', '0.00', '', NULL, '0', '681850.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1113, '491865616484265', '7242458569', '712', NULL, '', '50.00', '380.00', '320', '19000.00', '0.00', '', NULL, '0', '700850.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1114, '144921279552489', '8155338425', '508', NULL, '', '15.00', '380.00', '310', '5700.00', '0.00', '', NULL, '0', '706550.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1131, '739737827126768', '9184796385', '534', NULL, '', '2.00', '250.00', '130', '500.00', '0.00', '', '0.00', '0', '718280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1130, '853575218664754', '9184796385', '589', NULL, '', '1.00', '1950.00', '1650', '1950.00', '0.00', '', '0.00', '0', '718280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1129, '689389183367573', '9184796385', '588', NULL, '', '2.00', '280.00', '240', '560.00', '0.00', '', '0.00', '0', '718280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1128, '175914347438717', '9184796385', '591 ', NULL, '', '6.00', '390.00', '350', '2340.00', '0.00', '', '0.00', '0', '718280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1127, '559938441326873', '9184796385', '590', NULL, '', '2.00', '1600.00', '1250', '3200.00', '0.00', '', '0.00', '0', '718280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1126, '265679224974599', '9184796385', '586', NULL, '', '2.00', '290.00', '120', '580.00', '0.00', '', '0.00', '0', '718280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1125, '923453291634887', '9184796385', '585', NULL, '', '1.00', '2600.00', '2200', '2600.00', '0.00', '', '0.00', '0', '718280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1122, '667933754594626', '4495791598', '538', NULL, '', '4.00', '280.00', '160', '1120.00', '0.00', '', NULL, '0', '721650.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1123, '324387264636743', '4495791598', '528', NULL, '', '3.00', '750.00', '550', '2250.00', '0.00', '', NULL, '0', '721650.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1132, '223176964636289', '2153462153', '587', NULL, '', '2.00', '280.00', '250', '560.00', '0.00', '', '0.00', '0', '722210.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1134, '645765514843732', '1389596898', '394', NULL, '', '12.00', '480.00', '300', '5760.00', '0.00', '', '0.00', '0', '25650.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1135, '976867332692469', '1389596898', '737', NULL, '', '12.00', '480.00', '50', '5760.00', '0.00', '', '0.00', '0', '25650.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1136, '318666292425778', '1389596898', '206', NULL, '', '3.00', '1750.00', '1200', '5250.00', '0.00', '', '0.00', '0', '25650.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1137, '125717482349981', '1389596898', '272', NULL, '', '8.00', '300.00', '220', '2400.00', '0.00', '', '0.00', '0', '25650.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1138, '442619477676822', '1389596898', '279', NULL, '', '3.00', '1080.00', '260', '3240.00', '0.00', '', '0.00', '0', '25650.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1139, '467926272734911', '1389596898', '280', NULL, '', '3.00', '480.00', '360', '1440.00', '0.00', '', '0.00', '0', '25650.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1140, '416595932948331', '1389596898', '274', NULL, '', '3.00', '600.00', '360', '1800.00', '0.00', '', '0.00', '0', '25650.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1141, '889675135528381', '2976925275', '495', NULL, '', '20.00', '1020.00', '650', '20400.00', '0.00', '', NULL, '0', '48450.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1142, '724251627413518', '2976925275', '272', NULL, '', '8.00', '300.00', '220', '2400.00', '0.00', '', NULL, '0', '48450.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1143, '299487611532751', '9441918497', '57', NULL, '', '8.00', '150.00', '140', '1200.00', '0.00', '', NULL, '0', '54710.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1144, '981749627979236', '9441918497', '449', NULL, '', '2.00', '100.00', '90', '200.00', '0.00', '', NULL, '0', '54710.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1145, '292267592518329', '9441918497', '79', NULL, '', '2.00', '150.00', '120', '300.00', '0.00', '', NULL, '0', '54710.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1146, '553153337717423', '9441918497', '352', NULL, '', '1.00', '3500.00', '2800', '3500.00', '0.00', '', NULL, '0', '54710.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1147, '873233366647122', '9441918497', '451', NULL, '', '2.00', '80.00', '70', '160.00', '0.00', '', NULL, '0', '54710.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1148, '324441663746349', '9441918497', '377', NULL, '', '2.00', '360.00', '300', '720.00', '0.00', '', NULL, '0', '54710.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1149, '868633975126478', '9441918497', '270', NULL, '', '1.00', '180.00', '160', '180.00', '0.00', '', NULL, '0', '54710.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1151, '262956469384787', '7267276659', '272', NULL, '', '15.00', '300.00', '220', '4500.00', '0.00', '', '0.00', '0', '66110.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1152, '132375179717859', '7267276659', '85', NULL, '', '2.00', '1020.00', '660', '2040.00', '0.00', '', '0.00', '0', '66110.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1153, '429631326284865', '7267276659', '106', NULL, '', '9.00', '540.00', '380', '4860.00', '0.00', '', '0.00', '0', '66110.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1154, '139417964939563', '9363166494', '575', NULL, '', '36.00', '4350.00', '3500', '156600.00', '0.00', '', NULL, '0', '222710.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1155, '316112184451839', '9644382867', '136', NULL, '', '2.00', '3000.00', '2961', '6000.00', '0.00', '', NULL, '0', '24600.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1156, '571734712238545', '9644382867', '135', NULL, '', '2.00', '3000.00', '2961', '6000.00', '0.00', '', NULL, '0', '24600.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1157, '118842964965333', '9644382867', '144', NULL, '', '1.00', '6300.00', '6146', '6300.00', '0.00', '', NULL, '0', '24600.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1158, '117934935914755', '9644382867', '141', NULL, '', '1.00', '6300.00', '6146', '6300.00', '0.00', '', NULL, '0', '24600.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1170, '569782492364415', '1961533534', '86', NULL, '', '3.00', '440.00', '390', '1320.00', '0.00', '', '0.00', '0', '57090.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1169, '818179899733382', '1961533534', '95', NULL, '', '5.00', '440.00', '390', '2200.00', '0.00', '', '0.00', '0', '57090.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1168, '664376312732147', '1961533534', '194', NULL, '', '3.00', '1600.00', '1500', '4800.00', '0.00', '', '0.00', '0', '57090.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1167, '158845421545766', '1961533534', '195', NULL, '', '3.00', '1300.00', '1300', '3900.00', '0.00', '', '0.00', '0', '57090.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1171, '772896319214943', '1961533534', '489', NULL, '', '5.00', '200.00', '125', '1000.00', '0.00', '', '0.00', '0', '57090.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1172, '268682258415327', '1961533534', '85', NULL, '', '2.00', '700.00', '660', '1400.00', '0.00', '', '0.00', '0', '57090.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1173, '153531248111677', '1961533534', '116', NULL, '', '2.00', '700.00', '550', '1400.00', '0.00', '', '0.00', '0', '57090.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1174, '429624344819223', '1961533534', '78', NULL, '', '2.00', '160.00', '160', '320.00', '0.00', '', '0.00', '0', '57090.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1175, '942642381521356', '1961533534', '79', NULL, '', '8.00', '150.00', '120', '1200.00', '0.00', '', '0.00', '0', '57090.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1176, '994623435177886', '1961533534', '81', NULL, '', '4.00', '120.00', '80', '480.00', '0.00', '', '0.00', '0', '57090.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1177, '699374662634851', '1961533534', '451', NULL, '', '4.00', '90.00', '70', '360.00', '0.00', '', '0.00', '0', '57090.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1178, '989982122298234', '1961533534', '80', NULL, '', '3.00', '80.00', '80', '240.00', '0.00', '', '0.00', '0', '57090.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1179, '499619762283642', '1961533534', '254', NULL, '', '21.00', '240.00', '230', '5040.00', '0.00', '', '0.00', '0', '57090.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1180, '145214559774886', '1961533534', '179', NULL, '', '48.00', '35.00', '36', '1680.00', '0.00', '', '0.00', '0', '57090.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1181, '691912241722773', '1961533534', '11', NULL, '', '50.00', '110.00', '105', '5500.00', '0.00', '', '0.00', '0', '57090.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1182, '938829128529881', '1961533534', '175', NULL, '', '6.00', '140.00', '125', '840.00', '0.00', '', '0.00', '0', '57090.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1183, '643728642513571', '1961533534', '60', NULL, '', '3.00', '240.00', '200', '720.00', '0.00', '', '0.00', '0', '57090.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1184, '145684271114977', '1961533534', '81', NULL, '', '1.00', '90.00', '80', '90.00', '0.00', '', '0.00', '0', '57090.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1185, '358794468993742', '7978897387', '114', NULL, '', '2.00', '500.00', '480', '1000.00', '0.00', '', NULL, '0', '62250.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1186, '357579767341766', '7978897387', '113', NULL, '', '2.00', '850.00', '840', '1700.00', '0.00', '', NULL, '0', '62250.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1187, '649926994877855', '7978897387', '281', NULL, '', '48.00', '25.00', '25', '1200.00', '0.00', '', NULL, '0', '62250.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1188, '128846881264998', '7978897387', '282', NULL, '', '36.00', '35.00', '32', '1260.00', '0.00', '', NULL, '0', '62250.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1189, '736475232677513', '7978897387', '182', NULL, '', '24.00', '130.00', '90', '0.00', '0.00', '', NULL, '0', '62250.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1488, '321294848685236', '2212879286', '112', NULL, '', '2.00', '300.00', '280', '600.00', '0.00', '', '0.00', '0', '11620.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1487, '424284648553752', '2212879286', '182', NULL, '', '10.00', '100.00', '90', '1000.00', '0.00', '', '0.00', '0', '11620.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1486, '212274257717532', '2212879286', '122', NULL, '', '2.00', '300.00', '340', '600.00', '0.00', '', '0.00', '0', '11620.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1485, '761995651754946', '2212879286', '121', NULL, '', '2.00', '300.00', '300', '600.00', '0.00', '', '0.00', '0', '11620.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1484, '286545176741684', '2212879286', '92', NULL, '', '3.00', '240.00', '260', '720.00', '0.00', '', '0.00', '0', '11620.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1483, '969293225776663', '2212879286', '100', NULL, '', '3.00', '300.00', '300', '900.00', '0.00', '', '0.00', '0', '11620.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1482, '591143871529241', '2212879286', '270', NULL, '', '3.00', '180.00', '160', '540.00', '0.00', '', '0.00', '0', '11620.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1481, '591989928233251', '2212879286', '2', NULL, '', '4.00', '200.00', '190', '800.00', '0.00', '', '0.00', '0', '11620.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1480, '677351343158862', '2212879286', '494', NULL, '', '2.00', '300.00', '290', '600.00', '0.00', '', '0.00', '0', '11620.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1479, '222732186269914', '2212879286', '89', NULL, '', '2.00', '300.00', '280', '600.00', '0.00', '', '0.00', '0', '11620.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1478, '821434497142146', '2212879286', '78', NULL, '', '6.00', '170.00', '160', '1020.00', '0.00', '', '0.00', '0', '11620.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1477, '462554323161433', '2212879286', '79', NULL, '', '6.00', '150.00', '120', '900.00', '0.00', '', '0.00', '0', '11620.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1476, '237871329643779', '2212879286', '180', NULL, '', '30.00', '26.00', '27', '780.00', '0.00', '', '0.00', '0', '11620.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1475, '616798649247166', '2212879286', '126', NULL, '', '1.00', '360.00', '460', '360.00', '0.00', '', '0.00', '0', '11620.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1474, '386716484756313', '2212879286', '61', NULL, '', '10.00', '160.00', '160', '1600.00', '0.00', '', '0.00', '0', '11620.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1205, '583343965375462', '1694367774', '175', NULL, '', '6.00', '142.00', '125', '852.00', '0.00', '', NULL, '0', '85286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1206, '919922128614266', '1694367774', '177', NULL, '', '6.00', '167.00', '165', '1002.00', '0.00', '', NULL, '0', '85286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1207, '147534145341685', '1694367774', '178', NULL, '', '12.00', '59.00', '80', '708.00', '0.00', '', NULL, '0', '85286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1208, '812215935336569', '1694367774', '178', NULL, '', '6.00', '134.00', '80', '804.00', '0.00', '', NULL, '0', '85286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1209, '939268186618126', '1694367774', '101', NULL, '', '1.00', '380.00', '550', '380.00', '0.00', '', NULL, '0', '85286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1210, '533717113793813', '1694367774', '99', NULL, '', '3.00', '380.00', '360', '1140.00', '0.00', '', NULL, '0', '85286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1211, '422288919452251', '1694367774', '166', NULL, '', '1.00', '330.00', '330', '330.00', '0.00', '', NULL, '0', '85286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1212, '854268364741993', '1694367774', '284', NULL, '', '10.00', '35.00', '40', '350.00', '0.00', '', NULL, '0', '85286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1213, '348153418744591', '1694367774', '283', NULL, '', '10.00', '30.00', '30', '300.00', '0.00', '', NULL, '0', '85286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1214, '448289649451935', '1694367774', '411', NULL, '', '2.00', '3300.00', '3300', '6600.00', '0.00', '', NULL, '0', '85286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1215, '242932796112142', '1694367774', '86', NULL, '', '3.00', '440.00', '390', '1320.00', '0.00', '', NULL, '0', '85286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1216, '113876625735436', '1694367774', '494', NULL, '', '2.00', '300.00', '290', '600.00', '0.00', '', NULL, '0', '85286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1217, '751859153522894', '1694367774', '89', NULL, '', '2.00', '300.00', '280', '600.00', '0.00', '', NULL, '0', '85286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1218, '123658153853463', '1694367774', '496', NULL, '', '10.00', '50.00', '38', '500.00', '0.00', '', NULL, '0', '85286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1219, '812473159466141', '1694367774', '109', NULL, '', '3.00', '600.00', '600', '1800.00', '0.00', '', NULL, '0', '85286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1220, '875472725541841', '1694367774', '92', NULL, '', '6.00', '240.00', '260', '1440.00', '0.00', '', NULL, '0', '85286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1221, '849643112728996', '1694367774', '100', NULL, '', '6.00', '300.00', '300', '1800.00', '0.00', '', NULL, '0', '85286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1222, '351762423224697', '1694367774', '85', NULL, '', '1.00', '700.00', '660', '700.00', '0.00', '', NULL, '0', '85286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1223, '442813313443242', '1694367774', '260', NULL, '', '1.00', '850.00', '850', '850.00', '0.00', '', NULL, '0', '85286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1224, '722133897273513', '1694367774', '225', NULL, '', '2.00', '480.00', '480', '960.00', '0.00', '', NULL, '0', '85286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1225, '913235727174328', '7318964635', '221', NULL, '', '2.00', '550.00', '500', '1100.00', '0.00', '', NULL, '0', '14200.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1226, '861917938699283', '7318964635', '92', NULL, '', '5.00', '260.00', '260', '1300.00', '0.00', '', NULL, '0', '14200.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1227, '331752358587951', '6569258597', '410', NULL, '', '4.00', '1700.00', '1650', '6800.00', '0.00', '', NULL, '0', '27460.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1228, '223746734364828', '6569258597', '72', NULL, '', '1.00', '2150.00', '2250', '2150.00', '0.00', '', NULL, '0', '27460.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1229, '679362556259985', '6569258597', '71', NULL, '', '1.00', '2150.00', '2250', '2150.00', '0.00', '', NULL, '0', '27460.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1230, '683448966529945', '6569258597', '85', NULL, '', '2.00', '600.00', '660', '1200.00', '0.00', '', NULL, '0', '27460.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1231, '759356678259962', '6569258597', '2', NULL, '', '4.00', '240.00', '190', '960.00', '0.00', '', NULL, '0', '27460.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1232, '554479211493596', '7317117295', '175', NULL, '', '6.00', '142.00', '125', '852.00', '0.00', '', NULL, '0', '32792.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1233, '876459971971223', '7317117295', '103', NULL, '', '2.00', '360.00', '320', '720.00', '0.00', '', NULL, '0', '32792.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1234, '646572949372743', '7317117295', '225', NULL, '', '2.00', '480.00', '480', '960.00', '0.00', '', NULL, '0', '32792.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1235, '277468774385939', '7317117295', '61', NULL, '', '12.00', '160.00', '160', '1920.00', '0.00', '', NULL, '0', '32792.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1236, '897738624157577', '7317117295', '86', NULL, '', '2.00', '440.00', '390', '880.00', '0.00', '', NULL, '0', '32792.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1237, '777446292515262', '3346761442', '100', NULL, '', '6.00', '300.00', '300', '1800.00', '0.00', '', NULL, '0', '36512.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1238, '195898679525115', '3346761442', '225', NULL, '', '4.00', '480.00', '480', '1920.00', '0.00', '', NULL, '0', '36512.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1239, '854737257334326', '6777296441', '72', NULL, '', '1.00', '2200.00', '2250', '2200.00', '0.00', '', NULL, '0', '46912.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1240, '928619667626341', '6777296441', '71', NULL, '', '2.00', '2200.00', '2250', '4400.00', '0.00', '', NULL, '0', '46912.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1241, '935574728471224', '6777296441', '85', NULL, '', '2.00', '700.00', '660', '1400.00', '0.00', '', NULL, '0', '46912.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1242, '687356897211658', '6777296441', '89', NULL, '', '4.00', '290.00', '280', '1160.00', '0.00', '', NULL, '0', '46912.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1243, '518884198958396', '6777296441', '494', NULL, '', '4.00', '310.00', '290', '1240.00', '0.00', '', NULL, '0', '46912.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4804, '655267966767793', '7123693583', '693', NULL, '', '6.00', '130.00', '130', '780.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4803, '324472596821622', '7123693583', '888', NULL, '', '2.00', '350.00', '322', '700.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4802, '387847881698915', '7123693583', '684', NULL, '', '2.00', '400.00', '360', '800.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4801, '718515626294154', '7123693583', '697', NULL, '', '30.00', '420.00', '400', '12600.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4734, '623827685884929', '7418519547', '57', NULL, '', '0.00', '0.00', '140', '0.00', '0.00', '', '0.00', '0', '36512.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1249, '236728637664273', '5633688734', '275', NULL, '', '1.00', '130.00', '100', '130.00', '0.00', '', NULL, '0', '58942.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1250, '212317151487329', '5633688734', '276', NULL, '', '2.00', '180.00', '180', '360.00', '0.00', '', NULL, '0', '58942.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1251, '754894896979285', '5633688734', '603', NULL, '', '3.00', '270.00', '250', '810.00', '0.00', '', NULL, '0', '58942.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1252, '485729167195573', '5633688734', '266', NULL, '', '1.00', '330.00', '220', '330.00', '0.00', '', NULL, '0', '58942.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1253, '147979378283665', '1145742434', '127', NULL, '', '2.00', '300.00', '400', '600.00', '0.00', '', NULL, '0', '66872.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1254, '595155342464451', '1145742434', '109', NULL, '', '2.00', '600.00', '600', '1200.00', '0.00', '', NULL, '0', '66872.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1255, '191453817648893', '1145742434', '92', NULL, '', '6.00', '260.00', '260', '1560.00', '0.00', '', NULL, '0', '66872.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1256, '428335112987257', '1145742434', '103', NULL, '', '2.00', '340.00', '320', '680.00', '0.00', '', NULL, '0', '66872.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1257, '728646718861815', '1145742434', '114', NULL, '', '3.00', '500.00', '480', '1500.00', '0.00', '', NULL, '0', '66872.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1258, '653892325583444', '1145742434', '86', NULL, '', '3.00', '450.00', '390', '1350.00', '0.00', '', NULL, '0', '66872.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1259, '265864725141445', '1145742434', '2', NULL, '', '4.00', '260.00', '190', '1040.00', '0.00', '', NULL, '0', '66872.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1260, '158812749778726', '5345941923', '411', NULL, '', '2.00', '3400.00', '3300', '6800.00', '0.00', '', NULL, '0', '75722.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1261, '189428256268156', '5345941923', '599', NULL, '', '10.00', '95.00', '120', '950.00', '0.00', '', NULL, '0', '75722.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1262, '992791931366631', '5345941923', '598 ', NULL, '', '10.00', '110.00', '130', '1100.00', '0.00', '', NULL, '0', '75722.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1263, '946177527511417', '8647385565', '136', NULL, '', '2.00', '3000.00', '2961', '6000.00', '0.00', '', NULL, '0', '42800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1264, '665436278158141', '8647385565', '135', NULL, '', '2.00', '3000.00', '2961', '6000.00', '0.00', '', NULL, '0', '42800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1265, '144128447533538', '8647385565', '139', NULL, '', '1.00', '3000.00', '2961', '3000.00', '0.00', '', NULL, '0', '42800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1266, '547233487291416', '8647385565', '138', NULL, '', '1.00', '3000.00', '2961', '3000.00', '0.00', '', NULL, '0', '42800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1267, '829281294753478', '8647385565', '141', NULL, '', '1.00', '6200.00', '6146', '6200.00', '0.00', '', NULL, '0', '42800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1268, '296831267914655', '8647385565', '144', NULL, '', '1.00', '6200.00', '6146', '6200.00', '0.00', '', NULL, '0', '42800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1269, '637391922827827', '8647385565', '143', NULL, '', '1.00', '6200.00', '6146', '6200.00', '0.00', '', NULL, '0', '42800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1270, '877389124273315', '8647385565', '142', NULL, '', '1.00', '6200.00', '6146', '6200.00', '0.00', '', NULL, '0', '42800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1271, '315766765697487', '1512229224', '135', NULL, '', '5.00', '3000.00', '2961', '15000.00', '0.00', '', NULL, '0', '64800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1272, '931189217982578', '1512229224', '136', NULL, '', '1.00', '3000.00', '2961', '3000.00', '0.00', '', NULL, '0', '64800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1273, '166934189984326', '1512229224', '420', NULL, '', '1.00', '4000.00', '3936', '4000.00', '0.00', '', NULL, '0', '64800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1274, '138472325396428', '5198483319', '135', NULL, '', '5.00', '3000.00', '2961', '15000.00', '0.00', '', NULL, '0', '86000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1275, '829212828929445', '5198483319', '144', NULL, '', '1.00', '6200.00', '6146', '6200.00', '0.00', '', NULL, '0', '86000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1276, '223625946722744', '1247375455', '135', NULL, '', '4.00', '3000.00', '2961', '12000.00', '0.00', '', NULL, '0', '98000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1277, '685353398877127', '8442146984', '135', NULL, '', '4.00', '3000.00', '2961', '12000.00', '0.00', '', NULL, '0', '116000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1278, '678135441331698', '8442146984', '136', NULL, '', '2.00', '3000.00', '2961', '6000.00', '0.00', '', NULL, '0', '116000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1279, '422669589785298', '6457347775', '2', NULL, '', '4.00', '280.00', '190', '1120.00', '0.00', '', NULL, '0', '119280.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1280, '715641188229894', '6457347775', '493', NULL, '', '1.00', '2160.00', '1800', '2160.00', '0.00', '', NULL, '0', '119280.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1281, '882892438919627', '8951465191', '137', NULL, '', '1.00', '3000.00', '2961', '3000.00', '0.00', '', NULL, '0', '137680.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1282, '995485958599733', '8951465191', '138', NULL, '', '1.00', '3000.00', '2961', '3000.00', '0.00', '', NULL, '0', '137680.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1283, '963283393777593', '8951465191', '142', NULL, '', '1.00', '6200.00', '6146', '6200.00', '0.00', '', NULL, '0', '137680.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1284, '341793895652474', '8951465191', '143', NULL, '', '1.00', '6200.00', '6146', '6200.00', '0.00', '', NULL, '0', '137680.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1285, '124239638454137', '3846623832', '331', NULL, '', '1.00', '11700.00', '11671', '11700.00', '0.00', '', NULL, '0', '45100.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1286, '442819145693758', '3846623832', '333', NULL, '', '2.00', '16700.00', '16689', '33400.00', '0.00', '', NULL, '0', '45100.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1287, '332649889736889', '7939478389', '11', NULL, '', '25.00', '110.00', '105', '2750.00', '0.00', '', NULL, '0', '47850.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1288, '521534979669469', '9574331962', '138', NULL, '', '1.00', '3000.00', '2961', '3000.00', '0.00', '', NULL, '0', '84850.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1289, '851997723329318', '9574331962', '137', NULL, '', '1.00', '3000.00', '2961', '3000.00', '0.00', '', NULL, '0', '84850.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1290, '711368797984636', '9574331962', '148', NULL, '', '1.00', '15500.00', '14986', '15500.00', '0.00', '', NULL, '0', '84850.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1291, '679299729123732', '9574331962', '147', NULL, '', '1.00', '15500.00', '14986', '15500.00', '0.00', '', NULL, '0', '84850.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1292, '762419657777187', '4474956213', '325', NULL, '', '2.00', '3950.00', '4092', '7900.00', '0.00', '', NULL, '0', '125550.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1293, '241221642669922', '4474956213', '324', NULL, '', '2.00', '3950.00', '4092', '7900.00', '0.00', '', NULL, '0', '125550.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1294, '698271458642544', '4474956213', '327', NULL, '', '2.00', '8300.00', '8707', '16600.00', '0.00', '', NULL, '0', '125550.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1295, '864692824528113', '4474956213', '299', NULL, '', '1.00', '8300.00', '4092', '8300.00', '0.00', '', NULL, '0', '125550.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1296, '242674351132688', '5827966316', '139', NULL, '', '2.00', '3100.00', '2961', '6200.00', '0.00', '', NULL, '0', '160716.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1297, '423845592785251', '5827966316', '138', NULL, '', '2.00', '3100.00', '2961', '6200.00', '0.00', '', NULL, '0', '160716.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1298, '424155964427261', '5827966316', '144', NULL, '', '2.00', '8300.00', '6146', '16600.00', '0.00', '', NULL, '0', '160716.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1299, '582721641876737', '5827966316', '141', NULL, '', '1.00', '6166.00', '6146', '6166.00', '0.00', '', NULL, '0', '160716.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1300, '414344361474196', '3629774983', '139', NULL, '', '2.00', '3100.00', '2961', '6200.00', '0.00', '', NULL, '0', '162850.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1301, '986268232343117', '3629774983', '138', NULL, '', '2.00', '3100.00', '2961', '6200.00', '0.00', '', NULL, '0', '162850.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1302, '283931996964676', '3629774983', '144', NULL, '', '2.00', '8300.00', '6146', '16600.00', '0.00', '', NULL, '0', '162850.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1303, '559622387255535', '3629774983', '141', NULL, '', '1.00', '8300.00', '6146', '8300.00', '0.00', '', NULL, '0', '162850.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1304, '994292996113971', '7537392644', '715', NULL, '', '6.00', '130.00', '120', '780.00', '0.00', '', NULL, '0', '198796.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1305, '157192263739641', '5814974916', '141', NULL, '', '1.00', '8700.00', '6146', '8700.00', '0.00', '', NULL, '0', '216196.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1306, '866969198923545', '5814974916', '144', NULL, '', '1.00', '8700.00', '6146', '8700.00', '0.00', '', NULL, '0', '216196.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1307, '912263749619344', '3887523765', '57', NULL, '', '50.00', '150.00', '140', '7500.00', '0.00', '', NULL, '0', '43350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1308, '137776825979289', '3887523765', '703', NULL, '', '9.00', '950.00', '900', '8550.00', '0.00', '', NULL, '0', '43350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1309, '591511346229917', '3887523765', '76', NULL, '', '1.00', '10500.00', '9100', '10500.00', '0.00', '', NULL, '0', '43350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1310, '439325534466554', '3887523765', '11', NULL, '', '100.00', '130.00', '105', '13000.00', '0.00', '', NULL, '0', '43350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1311, '843412144284861', '3887523765', '714', NULL, '', '2.00', '500.00', '325', '1000.00', '0.00', '', NULL, '0', '43350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1312, '881494546714751', '3887523765', '453', NULL, '', '7.00', '400.00', '250', '2800.00', '0.00', '', NULL, '0', '43350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1526, '224663145358241', '5148215591', '613', NULL, '', '1.00', '1700.00', '1450', '1700.00', '0.00', '', NULL, '0', '1206580.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1525, '354799712528931', '5148215591', '612', NULL, '', '1.00', '350.00', '300', '350.00', '0.00', '', NULL, '0', '1206580.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1524, '297623666877828', '5148215591', '611', NULL, '', '10.00', '450.00', '300', '4500.00', '0.00', '', NULL, '0', '1206580.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1523, '719322834843532', '6258163824', '712', NULL, '', '100.00', '380.00', '320', '38000.00', '0.00', '', NULL, '0', '1176350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1493, '444212558512649', '5137841171', '57', NULL, '', '0.00', '0.00', '140', '0.00', '0.00', '', '0.00', '0', '0.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1513, '556395242761566', '3261562757', '641', NULL, '', '12.00', '350.00', '305', '4200.00', '0.00', '', NULL, '0', '1123950.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1512, '141559468971748', '3261562757', '640', NULL, '', '25.00', '280.00', '260', '7000.00', '0.00', '', NULL, '0', '1123950.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1511, '178274492349577', '3261562757', '639', NULL, '', '40.00', '190.00', '160', '7600.00', '0.00', '', NULL, '0', '1123950.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1510, '652458545111654', '3261562757', '638', NULL, '', '20.00', '4400.00', '4150', '88000.00', '0.00', '', NULL, '0', '1123950.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1509, '586217238923523', '3261562757', '792', NULL, '', '1.00', '3400.00', '3100', '3400.00', '0.00', '', NULL, '0', '1123950.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1501, '925682811789854', '9293972658', '57', NULL, '', '0.00', '0.00', '140', '0.00', '0.00', '', '0.00', '0', '0.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1508, '584735369631116', '7315183996', '', NULL, '', '1.00', '0.00', '0', '0.00', '0.00', '', '0.00', '0', '969250.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1505, '758761387893387', '7315183996', '566', NULL, '', '2.00', '3800.00', '2500', '7600.00', '0.00', '', '0.00', '0', '969250.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1506, '589949653453184', '7315183996', '565', NULL, '', '2.00', '3800.00', '2500', '7600.00', '0.00', '', '0.00', '0', '969250.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1507, '713216474334622', '7315183996', '567', NULL, '', '168.00', '1380.00', '1250', '231840.00', '0.00', '', '0.00', '0', '969250.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1497, '863579588312287', '3491818584', '57', NULL, '', '0.00', '0.00', '140', '0.00', '0.00', '', '0.00', '0', '0.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1514, '392967994219537', '3261562757', '642', NULL, '', '4.00', '7000.00', '6200', '28000.00', '0.00', '', NULL, '0', '1123950.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1515, '589115264553235', '3261562757', '643', NULL, '', '10.00', '1650.00', '1450', '16500.00', '0.00', '', NULL, '0', '1123950.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1554, '414993541698475', '1556349912', '646', NULL, '', '10.00', '250.00', '145', '2500.00', '0.00', '', '0.00', '0', '1128040.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1553, '891321322166684', '1556349912', '647', NULL, '', '2.00', '390.00', '270', '780.00', '0.00', '', '0.00', '0', '1128040.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1518, '126637317932576', '6295972662', '125', NULL, '', '4.00', '600.00', '375', '2400.00', '0.00', '', NULL, '0', '1138350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1496, '161963555716981', '7435381842', '57', NULL, '', '0.00', '0.00', '140', '0.00', '0.00', '', '0.00', '0', '0.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1519, '286185741279619', '6295972662', '270', NULL, '', '3.00', '240.00', '160', '720.00', '0.00', '', NULL, '0', '1138350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1520, '449327214299628', '6295972662', '748', NULL, '', '1.00', '600.00', '530', '600.00', '0.00', '', NULL, '0', '1138350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1521, '183762241641744', '6295972662', '56', NULL, '', '2.00', '1200.00', '1000', '2400.00', '0.00', '', NULL, '0', '1138350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1522, '614887291194687', '6295972662', '608', NULL, '', '10.00', '500.00', '418', '5000.00', '0.00', '', NULL, '0', '1138350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1492, '411958956762474', '4247718784', '57', NULL, '', '0.00', '0.00', '140', '0.00', '0.00', '', '0.00', '0', '0.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1472, '331678324679636', '6845814617', '498', NULL, '', '1.00', '400.00', '250', '400.00', '0.00', '', '0.00', '0', '7160.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1462, '971559686491876', '4876678161', '698', NULL, '', '3.00', '290.00', '290', '870.00', '0.00', '', '0.00', '0', '5350.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1461, '234357571321767', '4876678161', '705', NULL, '', '2.00', '250.00', '250', '500.00', '0.00', '', '0.00', '0', '5350.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1460, '328787851846784', '4876678161', '269', NULL, '', '2.00', '150.00', '110', '300.00', '0.00', '', '0.00', '0', '5350.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1459, '761785427987638', '4876678161', '225', NULL, '', '1.00', '480.00', '480', '480.00', '0.00', '', '0.00', '0', '5350.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1354, '542765458762842', '1216835466', '', NULL, '', '0.00', '0.00', '0', '0.00', '0.00', '', '0.00', '0', '0.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1349, '953435495477669', '3978519419', '577', NULL, '', '2.00', '1500.00', '1250', '3000.00', '0.00', '', NULL, '0', '311050.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1350, '414631612933865', '3978519419', '71', NULL, '', '1.00', '2150.00', '2250', '2150.00', '0.00', '', NULL, '0', '311050.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1351, '796287583733997', '3978519419', '72', NULL, '', '1.00', '2150.00', '2250', '2150.00', '0.00', '', NULL, '0', '311050.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1352, '147181948143683', '3978519419', '600', NULL, '', '2.00', '50.00', '400', '100.00', '0.00', '', NULL, '0', '311050.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1353, '531876437523534', '3978519419', '218', NULL, '', '1.00', '200.00', '170', '200.00', '0.00', '', NULL, '0', '311050.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1471, '414166673946628', '6845814617', '490', NULL, '', '5.00', '150.00', '90', '750.00', '0.00', '', '0.00', '0', '7160.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1454, '295453271439391', '2687949442', '283', NULL, '', '22.00', '40.00', '30', '880.00', '0.00', '', '0.00', '0', '9880.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1453, '563258583193899', '2687949442', '698', NULL, '', '20.00', '360.00', '290', '7200.00', '0.00', '', '0.00', '0', '9880.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1452, '528289856784276', '2687949442', '490', NULL, '', '2.00', '150.00', '90', '300.00', '0.00', '', '0.00', '0', '9880.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1451, '324743851976238', '2687949442', '714', NULL, '', '3.00', '500.00', '325', '1500.00', '0.00', '', '0.00', '0', '9880.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1470, '415482315425173', '6845814617', '351', NULL, '', '1.00', '3150.00', '2800', '3150.00', '0.00', '', '0.00', '0', '7160.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1374, '721924544544578', '3174111365', '504', NULL, '', '100.00', '90.00', '60', '9000.00', '0.00', '', NULL, '0', '216420.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1375, '964359462754337', '3174111365', '571', NULL, '', '4.00', '38500.00', '39500', '154000.00', '0.00', '', NULL, '0', '216420.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1376, '213397968918999', '3174111365', '502', NULL, '', '3.00', '13800.00', '10000', '41400.00', '0.00', '', NULL, '0', '216420.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1377, '834189812795512', '3174111365', '503', NULL, '', '1.00', '12020.00', '12000', '12020.00', '0.00', '', NULL, '0', '216420.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1378, '189784285482418', '6686827297', '505', NULL, '', '4.00', '17500.00', '11000', '70000.00', '0.00', '', NULL, '0', '286420.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1379, '683445549154155', '5956241346', '506', NULL, '', '24.00', '1550.00', '1320', '37200.00', '0.00', '', NULL, '0', '323620.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1380, '548659742151965', '5917543216', '466', NULL, '', '1.00', '880.00', '350', '880.00', '0.00', '', NULL, '0', '342400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1381, '348441982575852', '5917543216', '576', NULL, '', '1.00', '17900.00', '15500', '17900.00', '0.00', '', NULL, '0', '342400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1382, '345761937376392', '8875543688', '482', NULL, '', '1.00', '1600.00', '1250', '1600.00', '0.00', '', NULL, '0', '350800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1383, '735972347786896', '8875543688', '483', NULL, '', '2.00', '200.00', '100', '400.00', '0.00', '', NULL, '0', '350800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1384, '672555372414739', '8875543688', '507', NULL, '', '400.00', '7.00', '3', '2800.00', '0.00', '', NULL, '0', '350800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1385, '718991923243172', '8875543688', '711', NULL, '', '12.00', '100.00', '62', '1200.00', '0.00', '', NULL, '0', '350800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1386, '556514163967438', '8875543688', '694', NULL, '', '12.00', '200.00', '130', '2400.00', '0.00', '', NULL, '0', '350800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1387, '989662895159868', '1353652854', '584', NULL, '', '1.00', '2500.00', '2600', '2500.00', '0.00', '', NULL, '0', '5030.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1388, '944388856559211', '1353652854', '219', NULL, '', '1.00', '380.00', '380', '380.00', '0.00', '', NULL, '0', '5030.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1445, '527634374819575', '4299693644', '419', NULL, '', '1.00', '7500.00', '6731', '7500.00', '0.00', '', '0.00', '0', '14250.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1390, '472165241996649', '2558616487', '715', NULL, '', '7.00', '120.00', '120', '840.00', '0.00', '', NULL, '0', '14560.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1391, '768425543753732', '2558616487', '701', NULL, '', '8.00', '1100.00', '1080', '8800.00', '0.00', '', NULL, '0', '14560.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1392, '934222114487623', '2558616487', '387', NULL, '', '1.00', '500.00', '486', '500.00', '0.00', '', NULL, '0', '14560.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1393, '873898797524741', '2558616487', '395', NULL, '', '1.00', '70.00', '50', '70.00', '0.00', '', NULL, '0', '14560.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1394, '396239646132676', '2558616487', '374', NULL, '', '2.00', '50.00', '400', '100.00', '0.00', '', NULL, '0', '14560.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1395, '469361213137933', '2558616487', '417', NULL, '', '1.00', '4250.00', '4300', '4250.00', '0.00', '', NULL, '0', '14560.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1396, '781293653974547', '5312784753', '447', NULL, '', '4.00', '980.00', '850', '3920.00', '0.00', '', NULL, '0', '3920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1397, '545886851425282', '9453311658', '698', NULL, '', '2.00', '290.00', '290', '580.00', '0.00', '', NULL, '0', '59800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1398, '684683275923415', '9453311658', '135', NULL, '', '10.00', '2961.00', '2961', '29610.00', '0.00', '', NULL, '0', '59800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1399, '369524976573668', '9453311658', '136', NULL, '', '10.00', '2961.00', '2961', '29610.00', '0.00', '', NULL, '0', '59800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1400, '781436843366443', '1224191136', '135', NULL, '', '10.00', '2961.00', '2961', '29610.00', '0.00', '', NULL, '0', '119020.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1401, '271322183477616', '1224191136', '135', NULL, '', '10.00', '2961.00', '2961', '29610.00', '0.00', '', NULL, '0', '119020.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1402, '716642789323666', '2784477898', '299', NULL, '', '5.00', '4150.00', '4092', '20750.00', '0.00', '', NULL, '0', '160520.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1403, '527277561739437', '2784477898', '323', NULL, '', '5.00', '4150.00', '4092', '20750.00', '0.00', '', NULL, '0', '160520.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1404, '718223553117389', '5821247238', '136', NULL, '', '25.00', '3007.00', '2961', '75175.00', '0.00', '', NULL, '0', '435690.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1405, '716495583526714', '5821247238', '135', NULL, '', '25.00', '3007.00', '2961', '75175.00', '0.00', '', NULL, '0', '435690.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1406, '854595294722193', '5821247238', '141', NULL, '', '10.00', '6241.00', '6146', '62410.00', '0.00', '', NULL, '0', '435690.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1407, '873764814479162', '5821247238', '144', NULL, '', '10.00', '6241.00', '6146', '62410.00', '0.00', '', NULL, '0', '435690.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1408, '917219911226514', '8636229268', '141', NULL, '', '4.00', '6211.00', '6146', '24844.00', '0.00', '', NULL, '0', '43477.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1409, '964997511966765', '8636229268', '144', NULL, '', '3.00', '6211.00', '6146', '18633.00', '0.00', '', NULL, '0', '43477.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1438, '287958348172386', '1775667854', '241', NULL, '', '2.00', '150.00', '160', '300.00', '0.00', '', '0.00', '0', '14150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1414, '873728168143885', '9721211439', '322', NULL, '', '2.00', '15500.00', '14986', '31000.00', '0.00', '', '0.00', '0', '93000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1413, '882268194975685', '9721211439', '292', NULL, '', '4.00', '15500.00', '14986', '62000.00', '0.00', '', '0.00', '0', '93000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1415, '899359211179598', '5445939478', '289', NULL, '', '18.00', '2810.00', '2961', '50580.00', '0.00', '', NULL, '0', '287610.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1416, '862621998499587', '5445939478', '311', NULL, '', '19.00', '2810.00', '2961', '53390.00', '0.00', '', NULL, '0', '287610.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1417, '398562533339853', '5445939478', '139', NULL, '', '5.00', '2810.00', '2961', '14050.00', '0.00', '', NULL, '0', '287610.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1418, '135292993691745', '5445939478', '141', NULL, '', '5.00', '5960.00', '6146', '29800.00', '0.00', '', NULL, '0', '287610.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1419, '371371615512288', '5445939478', '144', NULL, '', '5.00', '5960.00', '6146', '29800.00', '0.00', '', NULL, '0', '287610.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1420, '625862383661129', '5445939478', '419', NULL, '', '5.00', '6950.00', '6731', '34750.00', '0.00', '', NULL, '0', '287610.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1421, '282411745531918', '5445939478', '161', NULL, '', '4.00', '4260.00', '4391', '17040.00', '0.00', '', NULL, '0', '287610.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1422, '941736772227467', '5445939478', '292', NULL, '', '2.00', '14550.00', '14986', '29100.00', '0.00', '', NULL, '0', '287610.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1423, '255534279455241', '5445939478', '322', NULL, '', '2.00', '14550.00', '14986', '29100.00', '0.00', '', NULL, '0', '287610.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1424, '639341669199172', '7438387912', '410', NULL, '', '6.00', '1700.00', '1650', '10200.00', '0.00', '', NULL, '0', '24200.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1425, '987448476271337', '7438387912', '411', NULL, '', '4.00', '3500.00', '3300', '14000.00', '0.00', '', NULL, '0', '24200.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1426, '673216342285211', '6659953793', '153', NULL, '', '3.00', '2250.00', '2292', '6750.00', '0.00', '', NULL, '0', '52500.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1427, '992693256292131', '6659953793', '154', NULL, '', '3.00', '2250.00', '2292', '6750.00', '0.00', '', NULL, '0', '52500.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1428, '487215579293445', '6659953793', '155', NULL, '', '3.00', '3100.00', '3208', '9300.00', '0.00', '', NULL, '0', '52500.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1429, '531449568195325', '6659953793', '156', NULL, '', '3.00', '3100.00', '3208', '9300.00', '0.00', '', NULL, '0', '52500.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1430, '964256823997178', '6659953793', '159', NULL, '', '2.00', '5100.00', '5126', '10200.00', '0.00', '', NULL, '0', '52500.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1431, '177689716921819', '6659953793', '160', NULL, '', '2.00', '5100.00', '5126', '10200.00', '0.00', '', NULL, '0', '52500.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1432, '511268567973531', '1345872945', '299', NULL, '', '5.00', '4300.00', '4092', '21500.00', '0.00', '', NULL, '0', '43300.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1433, '667296632899491', '1345872945', '323', NULL, '', '5.00', '4300.00', '4092', '21500.00', '0.00', '', NULL, '0', '43300.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1434, '118474987314958', '1345872945', '404', NULL, '', '2.00', '150.00', '125', '300.00', '0.00', '', NULL, '0', '43300.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1435, '457753332675656', '9837819267', '147', NULL, '', '1.00', '15220.00', '14986', '15220.00', '0.00', '', NULL, '0', '15220.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1436, '939389161219831', '8421377642', '298', NULL, '', '2.00', '10400.00', '10761', '20800.00', '0.00', '', NULL, '0', '20800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1439, '964273475342588', '1775667854', '740', NULL, '', '1.00', '13000.00', '13000', '13000.00', '0.00', '', '0.00', '0', '14150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1440, '365243564938622', '1775667854', '741', NULL, '', '1.00', '850.00', '780', '850.00', '0.00', '', '0.00', '0', '14150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1441, '812884257737135', '3455599945', '335', NULL, '', '5.00', '2500.00', '2376', '12500.00', '0.00', '', NULL, '0', '70000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1442, '597796863893692', '3455599945', '336', NULL, '', '5.00', '2500.00', '2376', '12500.00', '0.00', '', NULL, '0', '70000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1443, '549335642873855', '3455599945', '337', NULL, '', '2.00', '5200.00', '4911', '10400.00', '0.00', '', NULL, '0', '70000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1444, '644233811838493', '3455599945', '338', NULL, '', '2.00', '5200.00', '4911', '10400.00', '0.00', '', NULL, '0', '70000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1446, '548385998612313', '4299693644', '739', NULL, '', '4.00', '430.00', '400', '1720.00', '0.00', '', '0.00', '0', '14250.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1463, '897418342423179', '4876678161', '738', NULL, '', '1.00', '3200.00', '3610', '3200.00', '0.00', '', '0.00', '0', '5350.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1473, '536314124741849', '6845814617', '742', NULL, '', '26.00', '110.00', '110', '2860.00', '0.00', '', '0.00', '0', '7160.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1527, '593423474589476', '5148215591', '614', NULL, '', '1.00', '400.00', '200', '400.00', '0.00', '', NULL, '0', '1206580.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1528, '162246644463734', '5148215591', '615', NULL, '', '1.00', '5500.00', '4800', '5500.00', '0.00', '', NULL, '0', '1206580.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1529, '365929715924637', '5148215591', '637', NULL, '', '1.00', '2500.00', '2000', '2500.00', '0.00', '', NULL, '0', '1206580.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1530, '677534962774788', '5148215591', '617', NULL, '', '1.00', '750.00', '600', '750.00', '0.00', '', NULL, '0', '1206580.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1531, '933864815223323', '5148215591', '618', NULL, '', '1.00', '450.00', '300', '450.00', '0.00', '', NULL, '0', '1206580.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1532, '281218533291859', '5148215591', '619', NULL, '', '1.00', '200.00', '100', '200.00', '0.00', '', NULL, '0', '1206580.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1533, '923764539952584', '5148215591', '620', NULL, '', '24.00', '10.00', '5', '240.00', '0.00', '', NULL, '0', '1206580.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1534, '737926126787657', '5148215591', '621', NULL, '', '1.00', '5400.00', '4800', '5400.00', '0.00', '', NULL, '0', '1206580.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1535, '183272213879372', '5148215591', '622', NULL, '', '12.00', '20.00', '10', '240.00', '0.00', '', NULL, '0', '1206580.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1536, '794795793845814', '5148215591', '624', NULL, '', '1.00', '4400.00', '3700', '4400.00', '0.00', '', NULL, '0', '1206580.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1537, '894742112643847', '5148215591', '623', NULL, '', '90.00', '40.00', '26', '3600.00', '0.00', '', NULL, '0', '1206580.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1538, '197541412262892', '3911836699', '648', NULL, '', '5.00', '380.00', '300', '1900.00', '0.00', '', NULL, '0', '1208480.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1539, '678788412874468', '1753277465', '629', NULL, '', '4.00', '950.00', '700', '3800.00', '0.00', '', NULL, '0', '1288710.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1540, '829823554521483', '1753277465', '631', NULL, '', '3.00', '2400.00', '1800', '7200.00', '0.00', '', NULL, '0', '1288710.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1541, '195116845934315', '1753277465', '632', NULL, '', '2.00', '1950.00', '1480', '3900.00', '0.00', '', NULL, '0', '1288710.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1542, '449481472679261', '1753277465', '630', NULL, '', '2.00', '1600.00', '1250', '3200.00', '0.00', '', NULL, '0', '1288710.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1543, '839188549784382', '1753277465', '634', NULL, '', '4.00', '9240.00', '8240', '36960.00', '0.00', '', NULL, '0', '1288710.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1544, '783389877242219', '1753277465', '627', NULL, '', '10.00', '1250.00', '900', '12500.00', '0.00', '', NULL, '0', '1288710.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1545, '289492699526783', '1753277465', '633', NULL, '', '2.00', '2700.00', '2200', '5400.00', '0.00', '', NULL, '0', '1288710.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1546, '552315688183876', '1753277465', '628', NULL, '', '3.00', '1250.00', '900', '3750.00', '0.00', '', NULL, '0', '1288710.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1547, '797911853797547', '1753277465', '635', NULL, '', '16.00', '220.00', '120', '3520.00', '0.00', '', NULL, '0', '1288710.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1548, '618597133715858', '1413256793', '746', NULL, '', '1.00', '350.00', '200', '350.00', '0.00', '', NULL, '0', '1303460.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1549, '583154669652473', '1413256793', '745', NULL, '', '1.00', '1500.00', '1150', '1500.00', '0.00', '', NULL, '0', '1303460.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1550, '623642794794536', '1413256793', '534', NULL, '', '2.00', '250.00', '130', '500.00', '0.00', '', NULL, '0', '1303460.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1551, '176215784385499', '1413256793', '744', NULL, '', '1.00', '1600.00', '1200', '1600.00', '0.00', '', NULL, '0', '1303460.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1552, '621218852544555', '1413256793', '743', NULL, '', '1.00', '10800.00', '9000', '10800.00', '0.00', '', NULL, '0', '1303460.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1555, '435338412378123', '1556349912', '644', NULL, '', '1.00', '560.00', '500', '560.00', '0.00', '', '0.00', '0', '1128040.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1556, '994914223162941', '1556349912', '645', NULL, '', '1.00', '250.00', '350', '250.00', '0.00', '', '0.00', '0', '1128040.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1557, '347839668924966', '2823655468', '762', NULL, '', '10.00', '550.00', '340', '5500.00', '0.00', '', NULL, '0', '1309770.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2164, '966437814574857', '9555192325', '137', NULL, '', '3.00', '3000.00', '2961', '9000.00', '0.00', '', '0.00', '0', '90000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2163, '798874733377984', '9555192325', '136', NULL, '', '12.00', '3000.00', '2961', '36000.00', '0.00', '', '0.00', '0', '90000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2162, '217718566831425', '9555192325', '135', NULL, '', '15.00', '3000.00', '2961', '45000.00', '0.00', '', '0.00', '0', '90000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1562, '416171637279329', '9844494798', '420', NULL, '', '1.00', '3800.00', '3936', '3800.00', '0.00', '', '0.00', '0', '228416.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1563, '141442664919977', '9844494798', '20', NULL, '', '39.00', '130.00', '115', '5070.00', '0.00', '', '0.00', '0', '228416.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1564, '767446396153329', '9844494798', '101', NULL, '', '1.00', '600.00', '550', '600.00', '0.00', '', '0.00', '0', '228416.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1565, '995149598521779', '9844494798', '742', NULL, '', '25.00', '110.00', '110', '2750.00', '0.00', '', '0.00', '0', '228416.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1566, '423992556367415', '5993242736', '299', NULL, '', '2.00', '4300.00', '4092', '8600.00', '0.00', '', NULL, '0', '56200.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1567, '749934749453242', '5993242736', '323', NULL, '', '1.00', '4300.00', '4092', '4300.00', '0.00', '', NULL, '0', '56200.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4930, '225351345174473', '6128491668', '410', NULL, '', '2.00', '1700.00', '1650', '3400.00', '0.00', '', '0.00', '0', '83382.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4929, '787373464829578', '6128491668', '99', NULL, '', '2.00', '360.00', '360', '720.00', '0.00', '', '0.00', '0', '83382.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4928, '556744315448973', '6128491668', '749', NULL, '', '2.00', '300.00', '490', '600.00', '0.00', '', '0.00', '0', '83382.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4927, '287573483861747', '6128491668', '79', NULL, '', '6.00', '150.00', '120', '900.00', '0.00', '', '0.00', '0', '83382.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4926, '446788285425142', '6128491668', '122', NULL, '', '1.00', '300.00', '340', '300.00', '0.00', '', '0.00', '0', '83382.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4925, '151282152739336', '6128491668', '700', NULL, '', '12.00', '160.00', '160', '1920.00', '0.00', '', '0.00', '0', '83382.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2192, '953268468498688', '3233778328', '186', NULL, '', '1.00', '6000.00', '5500', '6000.00', '0.00', '', '0.00', '0', '33130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2191, '245943448493115', '3233778328', '701', NULL, '', '2.00', '1100.00', '1080', '2200.00', '0.00', '', '0.00', '0', '33130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2190, '425529871824555', '3233778328', '184', NULL, '', '1.00', '180.00', '1400', '180.00', '0.00', '', '0.00', '0', '33130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4935, '147713759488974', '4167744585', '495', NULL, '', '2.00', '720.00', '650', '1440.00', '0.00', '', '0.00', '0', '15250.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4934, '835658794449555', '4167744585', '27', NULL, '', '10.00', '40.00', '33', '400.00', '0.00', '', '0.00', '0', '15250.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4933, '315413543145223', '4167744585', '490', NULL, '', '9.00', '250.00', '85', '2250.00', '0.00', '', '0.00', '0', '15250.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4932, '845471174523158', '4167744585', '496', NULL, '', '7.00', '50.00', '38', '350.00', '0.00', '', '0.00', '0', '15250.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5157, '967284783331589', '3648649638', '985', NULL, '', '1.00', '130.00', '110', '130.00', '0.00', '', '0.00', '0', '26800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5156, '135912419155556', '3648649638', '580', NULL, '', '1.00', '5700.00', '5500', '5700.00', '0.00', '', '0.00', '0', '26800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1583, '978856418421723', '5862996656', '419', NULL, '', '1.00', '7200.00', '6731', '7200.00', '0.00', '', NULL, '0', '442890.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4943, '877724934776533', '1916531934', '132', NULL, '', '2.00', '200.00', '240', '400.00', '0.00', '', '0.00', '0', '140640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4942, '988462114956344', '1916531934', '122', NULL, '', '2.00', '320.00', '340', '640.00', '0.00', '', '0.00', '0', '140640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4941, '587366552198619', '1916531934', '99', NULL, '', '2.00', '360.00', '360', '720.00', '0.00', '', '0.00', '0', '140640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4940, '176265867342629', '1916531934', '101', NULL, '', '2.00', '600.00', '550', '1200.00', '0.00', '', '0.00', '0', '140640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4945, '471967278936233', '3828982476', '270', NULL, '', '5.00', '190.00', '160', '950.00', '0.00', '', '0.00', '0', '233106.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4944, '419737876625224', '3828982476', '579', NULL, '', '1.00', '2600.00', '2200', '2600.00', '0.00', '', '0.00', '0', '233106.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1590, '856349929437535', '8583371169', '649', NULL, '', '2.00', '3000.00', '4555', '6000.00', '0.00', '', NULL, '0', '161040.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1591, '784436341561669', '8583371169', '650', NULL, '', '2.00', '3000.00', '4555', '6000.00', '0.00', '', NULL, '0', '161040.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1592, '276277889916238', '8583371169', '653', NULL, '', '1.00', '3000.00', '4555', '3000.00', '0.00', '', NULL, '0', '161040.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1593, '996851587818984', '8583371169', '652', NULL, '', '1.00', '3000.00', '4555', '3000.00', '0.00', '', NULL, '0', '161040.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1594, '193481815828172', '2635796229', '715', NULL, '', '100.00', '124.00', '120', '12400.00', '0.00', '', NULL, '0', '103382.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1595, '134217525926728', '2635796229', '28', NULL, '', '2.00', '180.00', '120', '360.00', '0.00', '', NULL, '0', '103382.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1596, '262367274196226', '2635796229', '86', NULL, '', '2.00', '440.00', '390', '880.00', '0.00', '', NULL, '0', '103382.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1597, '154127272273964', '2635796229', '496', NULL, '', '12.00', '50.00', '38', '600.00', '0.00', '', NULL, '0', '103382.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1598, '815518793311342', '2635796229', '410', NULL, '', '2.00', '1700.00', '1650', '3400.00', '0.00', '', NULL, '0', '103382.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1599, '183442123493894', '2635796229', '109', NULL, '', '1.00', '600.00', '600', '600.00', '0.00', '', NULL, '0', '103382.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1600, '486692424113622', '2635796229', '2', NULL, '', '2.00', '240.00', '190', '480.00', '0.00', '', NULL, '0', '103382.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1601, '795434452348249', '2635796229', '192', NULL, '', '1.00', '1300.00', '1100', '1300.00', '0.00', '', NULL, '0', '103382.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1602, '673215112955713', '6266215734', '101', NULL, '', '1.00', '600.00', '550', '600.00', '0.00', '', NULL, '0', '275791.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1603, '115438247499832', '6266215734', '715', NULL, '', '25.00', '125.00', '120', '3125.00', '0.00', '', NULL, '0', '275791.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1604, '778375894415173', '6266215734', '420', NULL, '', '1.00', '4000.00', '3936', '4000.00', '0.00', '', NULL, '0', '275791.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1605, '173348514351417', '6266215734', '334', NULL, '', '1.00', '16900.00', '16689', '16900.00', '0.00', '', NULL, '0', '275791.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1606, '243264292276848', '6266215734', '141', NULL, '', '2.00', '6400.00', '6146', '12800.00', '0.00', '', NULL, '0', '275791.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1607, '358431724737516', '6266215734', '144', NULL, '', '1.00', '6400.00', '6146', '6400.00', '0.00', '', NULL, '0', '275791.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1827, '785664547313425', '8461482622', '625', NULL, '', '3.00', '50.00', '41', '150.00', '0.00', '', '0.00', '0', '20880.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1826, '734484732465343', '8461482622', '698', NULL, '', '5.00', '300.00', '290', '1500.00', '0.00', '', '0.00', '0', '20880.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1610, '265131337953484', '2947285344', '137', NULL, '', '3.00', '2900.00', '2961', '8700.00', '0.00', '', NULL, '0', '296310.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1611, '874966528572217', '1197737314', '419', NULL, '', '1.00', '7300.00', '6731', '7300.00', '0.00', '', NULL, '0', '338091.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1612, '835574572142749', '1197737314', '299', NULL, '', '1.00', '4100.00', '4092', '4100.00', '0.00', '', NULL, '0', '338091.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1613, '774283761329383', '1197737314', '141', NULL, '', '2.00', '6300.00', '6146', '12600.00', '0.00', '', NULL, '0', '338091.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1614, '196486539441581', '1197737314', '144', NULL, '', '1.00', '6300.00', '6146', '6300.00', '0.00', '', NULL, '0', '338091.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1615, '263187445514681', '1197737314', '322', NULL, '', '1.00', '16000.00', '14986', '16000.00', '0.00', '', NULL, '0', '338091.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1616, '456516864118683', '1197737314', '292', NULL, '', '1.00', '16000.00', '14986', '16000.00', '0.00', '', NULL, '0', '338091.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1628, '645826367333354', '7979943364', '649', NULL, '', '7.00', '2900.00', '4555', '20300.00', '0.00', '', '0.00', '0', '367160.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1627, '565957949553966', '7979943364', '650', NULL, '', '3.00', '2900.00', '4555', '8700.00', '0.00', '', '0.00', '0', '367160.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1626, '645211124763651', '7979943364', '653', NULL, '', '3.00', '2900.00', '4555', '8700.00', '0.00', '', '0.00', '0', '367160.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1625, '293988883811821', '7979943364', '141', NULL, '', '2.00', '6050.00', '6146', '12100.00', '0.00', '', '0.00', '0', '367160.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1629, '271488755257858', '7979943364', '292', NULL, '', '1.00', '15000.00', '14986', '15000.00', '0.00', '', '0.00', '0', '367160.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1630, '895654186396695', '7979943364', '316', NULL, '', '1.00', '6050.00', '6146', '6050.00', '0.00', '', '0.00', '0', '367160.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1631, '637434716342673', '4611418728', '272', NULL, '', '1.00', '300.00', '220', '300.00', '0.00', '', NULL, '0', '20480.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1632, '232497534486774', '4611418728', '105', NULL, '', '1.00', '500.00', '510', '500.00', '0.00', '', NULL, '0', '20480.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1633, '443987346859793', '4611418728', '213', NULL, '', '4.00', '200.00', '170', '800.00', '0.00', '', NULL, '0', '20480.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1634, '638676455833453', '4611418728', '490', NULL, '', '24.00', '150.00', '90', '3600.00', '0.00', '', NULL, '0', '20480.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1642, '334758998454144', '7638831343', '490', NULL, '', '24.00', '150.00', '90', '3600.00', '0.00', '', '0.00', '0', '20480.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1641, '953873425371765', '7638831343', '213', NULL, '', '4.00', '200.00', '170', '800.00', '0.00', '', '0.00', '0', '20480.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1640, '834485573983841', '7638831343', '105', NULL, '', '1.00', '500.00', '510', '500.00', '0.00', '', '0.00', '0', '20480.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1639, '797499582529523', '7638831343', '272', NULL, '', '1.00', '300.00', '220', '300.00', '0.00', '', '0.00', '0', '20480.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1643, '496699354911555', '9149799129', '650', NULL, '', '10.00', '3006.00', '4555', '30060.00', '0.00', '', NULL, '0', '176029.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1644, '991956597822566', '9149799129', '649', NULL, '', '10.00', '3006.00', '4555', '30060.00', '0.00', '', NULL, '0', '176029.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1645, '169474678433858', '9149799129', '652', NULL, '', '2.00', '3006.00', '4555', '6012.00', '0.00', '', NULL, '0', '176029.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1646, '143173378923276', '9149799129', '654', NULL, '', '2.00', '3006.00', '4555', '6012.00', '0.00', '', NULL, '0', '176029.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1647, '328852989837525', '9149799129', '671', NULL, '', '1.00', '3006.00', '4555', '4575.00', '0.00', '', NULL, '0', '176029.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1648, '714996685832966', '9149799129', '290', NULL, '', '5.00', '6240.00', '6146', '31200.00', '0.00', '', NULL, '0', '176029.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1649, '279455982276113', '9149799129', '316', NULL, '', '5.00', '6240.00', '6146', '31200.00', '0.00', '', NULL, '0', '176029.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1650, '542892586453743', '9149799129', '419', NULL, '', '3.00', '7230.00', '6731', '21690.00', '0.00', '', NULL, '0', '176029.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1651, '526741429757873', '9259517748', '650', NULL, '', '10.00', '3006.00', '4555', '30060.00', '0.00', '', NULL, '0', '174460.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1652, '311638197414878', '9259517748', '649', NULL, '', '10.00', '3006.00', '4555', '30060.00', '0.00', '', NULL, '0', '174460.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1653, '321812725672847', '9259517748', '652', NULL, '', '2.00', '3006.00', '4555', '6012.00', '0.00', '', NULL, '0', '174460.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1654, '622831552789819', '9259517748', '654', NULL, '', '2.00', '3006.00', '4555', '6012.00', '0.00', '', NULL, '0', '174460.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1655, '457651544421539', '9259517748', '290', NULL, '', '5.00', '6240.00', '6146', '31200.00', '0.00', '', NULL, '0', '174460.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1656, '429687838178171', '9259517748', '316', NULL, '', '5.00', '6240.00', '6146', '31200.00', '0.00', '', NULL, '0', '174460.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1657, '735584712285567', '9259517748', '419', NULL, '', '3.00', '2981.00', '6731', '21690.00', '0.00', '', NULL, '0', '174460.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1658, '547616255365745', '9259517748', '140', NULL, '', '1.00', '3006.00', '2961', '3006.00', '0.00', '', NULL, '0', '174460.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1659, '866213131162346', '2832617851', '419', NULL, '', '1.00', '7400.00', '6731', '7400.00', '0.00', '', NULL, '0', '123682.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1660, '791268234264164', '2832617851', '411', NULL, '', '1.00', '3600.00', '3300', '3600.00', '0.00', '', NULL, '0', '123682.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1661, '972538384251133', '2832617851', '71', NULL, '', '2.00', '2200.00', '2250', '4400.00', '0.00', '', NULL, '0', '123682.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1662, '367691994362874', '2832617851', '2', NULL, '', '4.00', '280.00', '190', '1120.00', '0.00', '', NULL, '0', '123682.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1663, '191267821462648', '2832617851', '711', NULL, '', '36.00', '65.00', '62', '2340.00', '0.00', '', NULL, '0', '123682.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1664, '177237399965684', '2832617851', '103', NULL, '', '2.00', '360.00', '320', '720.00', '0.00', '', NULL, '0', '123682.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1665, '431749464996465', '2832617851', '99', NULL, '', '2.00', '360.00', '360', '720.00', '0.00', '', NULL, '0', '123682.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4991, '191252718377393', '9653111997', '809', NULL, '', '60.00', '15.00', '10', '900.00', '0.00', '', '0.00', '0', '235310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4990, '735765741313223', '9653111997', '176', NULL, '', '4.00', '120.00', '65', '480.00', '0.00', '', '0.00', '0', '235310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4989, '664866755148689', '9653111997', '175', NULL, '', '3.00', '240.00', '125', '720.00', '0.00', '', '0.00', '0', '235310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4988, '872928784241229', '9653111997', '20', NULL, '', '50.00', '175.00', '115', '8750.00', '0.00', '', '0.00', '0', '235310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1672, '656993943726941', '4722732758', '715', NULL, '', '25.00', '125.00', '120', '3125.00', '0.00', '', NULL, '0', '357766.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1673, '657314363498735', '4722732758', '742', NULL, '', '25.00', '110.00', '110', '2750.00', '0.00', '', NULL, '0', '357766.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1674, '674349851242736', '4722732758', '145', NULL, '', '1.00', '9800.00', '9331', '9800.00', '0.00', '', NULL, '0', '357766.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1675, '867714927745153', '4722732758', '420', NULL, '', '1.00', '4000.00', '3936', '4000.00', '0.00', '', NULL, '0', '357766.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1676, '261541332223637', '7327496538', '649', NULL, '', '2.00', '3000.00', '4555', '6000.00', '0.00', '', NULL, '0', '185640.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1677, '248795738153216', '7327496538', '650', NULL, '', '2.00', '3000.00', '4555', '6000.00', '0.00', '', NULL, '0', '185640.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1678, '934917376191125', '7327496538', '290', NULL, '', '1.00', '6300.00', '6146', '6300.00', '0.00', '', NULL, '0', '185640.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1679, '885467425555782', '7327496538', '316', NULL, '', '1.00', '6300.00', '6146', '6300.00', '0.00', '', NULL, '0', '185640.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1971, '932455749439947', '5217114917', '100', NULL, '', '6.00', '320.00', '300', '1920.00', '0.00', '', '0.00', '0', '128602.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1970, '355633783952285', '5217114917', '494', NULL, '', '3.00', '300.00', '290', '900.00', '0.00', '', '0.00', '0', '128602.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1969, '913683149137784', '5217114917', '363', NULL, '', '3.00', '350.00', '320', '1050.00', '0.00', '', '0.00', '0', '128602.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3752, '716275142259996', '6754142711', '213', NULL, '', '2.00', '200.00', '170', '400.00', '0.00', '', '0.00', '0', '47730.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3751, '499474116313952', '6754142711', '333', NULL, '', '1.00', '16000.00', '16689', '16000.00', '0.00', '', '0.00', '0', '47730.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3750, '218434553361887', '6754142711', '700', NULL, '', '17.00', '200.00', '160', '3400.00', '0.00', '', '0.00', '0', '47730.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3749, '829597615498315', '6754142711', '490', NULL, '', '15.00', '150.00', '90', '2250.00', '0.00', '', '0.00', '0', '47730.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1687, '458991181755391', '2347643624', '161', NULL, '', '1.00', '4300.00', '4391', '4300.00', '0.00', '', NULL, '0', '7580.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1688, '119488951175593', '2347643624', '136', NULL, '', '1.00', '3000.00', '2961', '3000.00', '0.00', '', NULL, '0', '7580.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1689, '296761394485897', '2347643624', '166', NULL, '', '1.00', '280.00', '330', '280.00', '0.00', '', NULL, '0', '7580.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5016, '445194351613962', '8243172374', '731', NULL, '', '38.00', '15.00', '10', '570.00', '0.00', '', '0.00', '0', '355000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5015, '143699438927733', '8243172374', '495', NULL, '', '1.00', '900.00', '650', '900.00', '0.00', '', '0.00', '0', '355000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5014, '824861262455787', '8243172374', '738', NULL, '', '1.00', '3500.00', '3610', '3500.00', '0.00', '', '0.00', '0', '355000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5013, '584421311474192', '8243172374', '232', NULL, '', '1.00', '1020.00', '750', '1020.00', '0.00', '', '0.00', '0', '355000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5012, '494859734794622', '8243172374', '717', NULL, '', '12.00', '350.00', '270', '4200.00', '0.00', '', '0.00', '0', '355000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5011, '232167167188978', '8243172374', '716', NULL, '', '25.00', '250.00', '190', '6250.00', '0.00', '', '0.00', '0', '355000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5010, '417562846434219', '8243172374', '213', NULL, '', '1.00', '200.00', '170', '200.00', '0.00', '', '0.00', '0', '355000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5009, '872942157271214', '8243172374', '223', NULL, '', '1.00', '1350.00', '1250', '1350.00', '0.00', '', '0.00', '0', '355000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5008, '975985654962626', '8243172374', '675', NULL, '', '1.00', '50.00', '50', '50.00', '0.00', '', '0.00', '0', '355000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5007, '477659696849491', '8243172374', '600', NULL, '', '2.00', '50.00', '221', '100.00', '0.00', '', '0.00', '0', '355000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5006, '512499377838775', '8243172374', '221', NULL, '', '1.00', '700.00', '500', '700.00', '0.00', '', '0.00', '0', '355000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5005, '236273297987253', '8243172374', '603', NULL, '', '12.00', '350.00', '250', '4200.00', '0.00', '', '0.00', '0', '355000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5004, '546282161312748', '8243172374', '583', NULL, '', '1.00', '2500.00', '2300', '2500.00', '0.00', '', '0.00', '0', '355000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5003, '225357656953364', '8243172374', '412', NULL, '', '1.00', '10500.00', '8800', '10500.00', '0.00', '', '0.00', '0', '355000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5002, '117499739654274', '8243172374', '334', NULL, '', '3.00', '17500.00', '16689', '52500.00', '0.00', '', '0.00', '0', '355000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5001, '624691365949462', '8243172374', '333', NULL, '', '2.00', '17500.00', '16689', '35000.00', '0.00', '', '0.00', '0', '355000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5000, '127827161939134', '8243172374', '332', NULL, '', '3.00', '13000.00', '11671', '39000.00', '0.00', '', '0.00', '0', '355000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4999, '253648792289625', '8243172374', '331', NULL, '', '3.00', '13000.00', '11671', '39000.00', '0.00', '', '0.00', '0', '355000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4998, '166114938299726', '8243172374', '327', NULL, '', '3.00', '9500.00', '8707', '28500.00', '0.00', '', '0.00', '0', '355000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4997, '531952185494987', '8243172374', '300', NULL, '', '5.00', '9500.00', '8707', '47500.00', '0.00', '', '0.00', '0', '355000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4985, '883796511687741', '7122648312', '52', NULL, '', '6.00', '500.00', '450', '3000.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4984, '383249517138934', '7122648312', '406', NULL, '', '2.00', '325.00', '336', '650.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4983, '572629513217564', '7122648312', '389', NULL, '', '3.00', '350.00', '336', '1050.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4982, '445529974735762', '7122648312', '495', NULL, '', '2.00', '780.00', '650', '1560.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4981, '971483212578266', '7122648312', '221', NULL, '', '1.00', '650.00', '500', '650.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4980, '449465221999248', '7122648312', '70', NULL, '', '4.00', '5600.00', '5200', '22400.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4979, '719661994551561', '7122648312', '69', NULL, '', '4.00', '5600.00', '5200', '22400.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4978, '255995591894143', '7122648312', '774', NULL, '', '1.00', '500.00', '460', '500.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4977, '817724779389275', '7122648312', '698', NULL, '', '60.00', '300.00', '290', '18000.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4976, '185836378954656', '7122648312', '600', NULL, '', '3.00', '50.00', '221', '150.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4975, '558944895262432', '7122648312', '67', NULL, '', '6.00', '2600.00', '2600', '15600.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4974, '739685384677437', '7122648312', '68', NULL, '', '6.00', '2600.00', '2600', '15600.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4973, '186661261738717', '7122648312', '309', NULL, '', '3.00', '6500.00', '6000', '19500.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4972, '596496359511827', '7122648312', '349', NULL, '', '3.00', '6500.00', '6000', '19500.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4971, '213968654212179', '7122648312', '726', NULL, '', '2.00', '4800.00', '4800', '9600.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4970, '939227678468695', '7122648312', '727', NULL, '', '2.00', '4800.00', '4800', '9600.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4969, '882423848835856', '7122648312', '308', NULL, '', '2.00', '4800.00', '2700', '9600.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4968, '644411612993784', '7122648312', '348', NULL, '', '2.00', '4800.00', '2700', '9600.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4967, '592123255629185', '7122648312', '226', NULL, '', '2.00', '2800.00', '1600', '5600.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4953, '425291751238514', '4177459154', '698', NULL, '', '26.00', '350.00', '290', '9100.00', '0.00', '', '0.00', '0', '12180.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4952, '223845535958754', '4177459154', '19', NULL, '', '8.00', '100.00', '70', '800.00', '0.00', '', '0.00', '0', '12180.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4951, '383681986527972', '4177459154', '776', NULL, '', '1.00', '620.00', '486', '620.00', '0.00', '', '0.00', '0', '12180.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4950, '926951247997986', '4177459154', '678', NULL, '', '1.00', '350.00', '286', '350.00', '0.00', '', '0.00', '0', '12180.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4949, '931371589312927', '4177459154', '490', NULL, '', '3.00', '320.00', '85', '960.00', '0.00', '', '0.00', '0', '12180.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4948, '838661871777383', '4177459154', '241', NULL, '', '1.00', '200.00', '160', '200.00', '0.00', '', '0.00', '0', '12180.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3762, '759752439515265', '1181438141', '829', NULL, '', '20.00', '350.00', '280', '7000.00', '0.00', '', '0.00', '0', '16500.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3761, '988431439395296', '1181438141', '782', NULL, '', '1.00', '500.00', '451', '500.00', '0.00', '', '0.00', '0', '16500.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3477, '588437474665358', '2744992295', '776', NULL, '', '1.00', '480.00', '486', '480.00', '0.00', '', '0.00', '0', '30720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3476, '459371941578783', '2744992295', '625', NULL, '', '3.00', '50.00', '41', '150.00', '0.00', '', '0.00', '0', '30720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3475, '765459232858218', '2744992295', '448', NULL, '', '1.00', '150.00', '120', '150.00', '0.00', '', '0.00', '0', '30720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3474, '581426482988554', '2744992295', '399', NULL, '', '3.00', '320.00', '287', '960.00', '0.00', '', '0.00', '0', '30720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3473, '993851585497113', '2744992295', '417', NULL, '', '1.00', '4500.00', '4300', '4500.00', '0.00', '', '0.00', '0', '30720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3472, '562526529447144', '2744992295', '251', NULL, '', '6.00', '300.00', '275', '1800.00', '0.00', '', '0.00', '0', '30720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3471, '347376298569186', '2744992295', '772', NULL, '', '5.00', '50.00', '30', '250.00', '0.00', '', '0.00', '0', '30720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3470, '471634428171952', '2744992295', '389', NULL, '', '2.00', '350.00', '336', '700.00', '0.00', '', '0.00', '0', '30720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2189, '638678255528965', '3233778328', '419', NULL, '', '1.00', '7300.00', '6731', '7300.00', '0.00', '', '0.00', '0', '33130.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4931, '538597484542686', '4167744585', '572', NULL, '', '3.00', '250.00', '250', '750.00', '0.00', '', '0.00', '0', '15250.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1828, '251825923176941', '8461482622', '491', NULL, '', '20.00', '280.00', '190', '5600.00', '0.00', '', '0.00', '0', '20880.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4966, '346115921389352', '7122648312', '213', NULL, '', '1.00', '200.00', '170', '200.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4965, '866168569874125', '7122648312', '603', NULL, '', '10.00', '325.00', '250', '3250.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4964, '259421559142911', '7122648312', '776', NULL, '', '12.00', '525.00', '486', '6300.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4963, '657675693696329', '7122648312', '689', NULL, '', '4.00', '480.00', '286', '1920.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4962, '671847164592624', '7122648312', '678', NULL, '', '4.00', '310.00', '286', '1240.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4961, '178879878882996', '7122648312', '105', NULL, '', '1.00', '720.00', '510', '720.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4960, '865389799347324', '7122648312', '448', NULL, '', '1.00', '200.00', '120', '200.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4959, '559724978578375', '7122648312', '497', NULL, '', '1.00', '200.00', '160', '200.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4958, '157375273991491', '7122648312', '498', NULL, '', '1.00', '200.00', '250', '200.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4957, '244519464218996', '7122648312', '625', NULL, '', '10.00', '50.00', '41', '500.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4956, '424445537595893', '7122648312', '491', NULL, '', '45.00', '275.00', '190', '12375.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4955, '255712591369731', '7122648312', '350', NULL, '', '3.00', '9500.00', '8700', '28500.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4954, '562557935732172', '7122648312', '310', NULL, '', '3.00', '9500.00', '8700', '28500.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2068, '194916972432163', '5891635397', '714', NULL, '', '1.00', '400.00', '325', '400.00', '0.00', '', '0.00', '0', '36010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2067, '225366542198887', '5891635397', '395', NULL, '', '8.00', '70.00', '50', '560.00', '0.00', '', '0.00', '0', '36010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2066, '583846815199426', '5891635397', '396', NULL, '', '7.00', '60.00', '40', '420.00', '0.00', '', '0.00', '0', '36010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2065, '391368194931179', '5891635397', '678', NULL, '', '7.00', '350.00', '286', '2450.00', '0.00', '', '0.00', '0', '36010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2064, '453562422197222', '5891635397', '776', NULL, '', '4.00', '550.00', '486', '2200.00', '0.00', '', '0.00', '0', '36010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2063, '564481233782333', '5891635397', '625', NULL, '', '6.00', '50.00', '41', '300.00', '0.00', '', '0.00', '0', '36010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2062, '456475193282554', '5891635397', '270', NULL, '', '1.00', '240.00', '160', '240.00', '0.00', '', '0.00', '0', '36010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2061, '522376439148813', '5891635397', '86', NULL, '', '1.00', '540.00', '390', '540.00', '0.00', '', '0.00', '0', '36010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2060, '719769626822632', '5891635397', '221', NULL, '', '1.00', '750.00', '500', '750.00', '0.00', '', '0.00', '0', '36010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2059, '723436482419951', '5891635397', '603', NULL, '', '10.00', '375.00', '250', '3750.00', '0.00', '', '0.00', '0', '36010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2058, '925131369252298', '5891635397', '259', NULL, '', '1.00', '1650.00', '1200', '1650.00', '0.00', '', '0.00', '0', '36010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2057, '863832335794883', '5891635397', '316', NULL, '', '1.00', '6500.00', '6146', '6500.00', '0.00', '', '0.00', '0', '36010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2056, '115927265198923', '5891635397', '141', NULL, '', '1.00', '6500.00', '6146', '6500.00', '0.00', '', '0.00', '0', '36010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2055, '415959438196557', '5891635397', '289', NULL, '', '2.00', '3250.00', '2961', '6500.00', '0.00', '', '0.00', '0', '36010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2054, '194469472219145', '5891635397', '136', NULL, '', '1.00', '3250.00', '2961', '3250.00', '0.00', '', '0.00', '0', '36010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (1972, '215364674784261', '5217114917', '218', NULL, '', '6.00', '175.00', '170', '1050.00', '0.00', '', '0.00', '0', '128602.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4996, '857613425197592', '8243172374', '325', NULL, '', '1.00', '4000.00', '4092', '4000.00', '0.00', '', '0.00', '0', '355000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4995, '326677622715128', '8243172374', '323', NULL, '', '4.00', '4000.00', '4092', '16000.00', '0.00', '', '0.00', '0', '355000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4994, '541692272292942', '8243172374', '299', NULL, '', '8.00', '4000.00', '4092', '32000.00', '0.00', '', '0.00', '0', '355000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4993, '759422168334875', '8243172374', '803', NULL, '', '36.00', '585.00', '550', '21060.00', '0.00', '', '0.00', '0', '355000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4992, '955285291185921', '8243172374', '805', NULL, '', '10.00', '900.00', '830', '9000.00', '0.00', '', '0.00', '0', '355000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4987, '467724315344873', '9653111997', '759', NULL, '', '1.00', '1750.00', '1000', '1750.00', '0.00', '', '0.00', '0', '235310.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4947, '146387571658587', '4177459154', '366', NULL, '', '2.00', '75.00', '46', '150.00', '0.00', '', '0.00', '0', '12180.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2129, '184142993192867', '6262367751', '659', NULL, '', '2.00', '1300.00', '1605', '2600.00', '0.00', '', NULL, '0', '424891.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2130, '976241986544895', '6262367751', '660', NULL, '', '2.00', '1300.00', '1605', '2600.00', '0.00', '', NULL, '0', '424891.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2131, '687585265376894', '6262367751', '663', NULL, '', '1.00', '2400.00', '3525', '2400.00', '0.00', '', NULL, '0', '424891.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2132, '526395196397356', '6262367751', '664', NULL, '', '1.00', '2400.00', '3525', '2400.00', '0.00', '', NULL, '0', '424891.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2133, '417262679586495', '6262367751', '665', NULL, '', '2.00', '3300.00', '4935', '6600.00', '0.00', '', NULL, '0', '424891.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2134, '534941711443597', '6262367751', '666', NULL, '', '1.00', '3300.00', '4935', '3300.00', '0.00', '', NULL, '0', '424891.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2135, '734942788898749', '6262367751', '12', NULL, '', '25.00', '125.00', '135', '3125.00', '0.00', '', NULL, '0', '424891.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2136, '758744377311169', '6262367751', '292', NULL, '', '1.00', '16000.00', '14986', '16000.00', '0.00', '', NULL, '0', '424891.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2137, '987377988426761', '6262367751', '577', NULL, '', '1.00', '1500.00', '1250', '1500.00', '0.00', '', NULL, '0', '424891.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2138, '855568489929425', '6262367751', '299', NULL, '', '1.00', '4100.00', '4092', '4100.00', '0.00', '', NULL, '0', '424891.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2139, '278129969446478', '6262367751', '323', NULL, '', '1.00', '4100.00', '4092', '4100.00', '0.00', '', NULL, '0', '424891.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2140, '356985412352585', '6262367751', '300', NULL, '', '1.00', '9200.00', '8707', '9200.00', '0.00', '', NULL, '0', '424891.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2141, '711767394163812', '6262367751', '327', NULL, '', '1.00', '9200.00', '8707', '9200.00', '0.00', '', NULL, '0', '424891.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2142, '369478755377854', '3817238736', '289', NULL, '', '3.00', '3000.00', '2961', '9000.00', '0.00', '', NULL, '0', '222840.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2143, '241151663329137', '3817238736', '311', NULL, '', '1.00', '3000.00', '2961', '3000.00', '0.00', '', NULL, '0', '222840.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2144, '898415657722326', '3817238736', '290', NULL, '', '2.00', '6300.00', '6146', '12600.00', '0.00', '', NULL, '0', '222840.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2145, '156544647472796', '3817238736', '316', NULL, '', '2.00', '6300.00', '6146', '12600.00', '0.00', '', NULL, '0', '222840.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2146, '221463729635254', '4626259438', '290', NULL, '', '1.00', '6200.00', '6146', '6200.00', '0.00', '', NULL, '0', '379560.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2147, '535129288354235', '4626259438', '316', NULL, '', '1.00', '6200.00', '6146', '6200.00', '0.00', '', NULL, '0', '379560.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2148, '425889216589548', '2752246514', '125', NULL, '', '10.00', '360.00', '375', '3600.00', '0.00', '', NULL, '0', '232290.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2149, '516784619546295', '2752246514', '114', NULL, '', '2.00', '550.00', '480', '1100.00', '0.00', '', NULL, '0', '232290.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2150, '471292342943573', '2752246514', '113', NULL, '', '2.00', '950.00', '840', '1900.00', '0.00', '', NULL, '0', '232290.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2151, '283455944399243', '2752246514', '236', NULL, '', '2.00', '850.00', '920', '1700.00', '0.00', '', NULL, '0', '232290.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2152, '845791576113631', '2752246514', '237', NULL, '', '2.00', '575.00', '530', '1150.00', '0.00', '', NULL, '0', '232290.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2834, '118361659429166', '2184931446', '410', NULL, '', '4.00', '1700.00', '1650', '6800.00', '0.00', '', '0.00', '0', '147682.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2833, '397291372475625', '2184931446', '411', NULL, '', '1.00', '3500.00', '3300', '3500.00', '0.00', '', '0.00', '0', '147682.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2155, '157583261578745', '6727539696', '419', NULL, '', '1.00', '7300.00', '6731', '7300.00', '0.00', '', NULL, '0', '239590.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2156, '114339164817742', '1358638581', '242', NULL, '', '24.00', '550.00', '490', '13200.00', '0.00', '', NULL, '0', '249010.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2157, '329817365513532', '1358638581', '790', NULL, '', '5.00', '100.00', '90', '500.00', '0.00', '', NULL, '0', '249010.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5023, '541493417664492', '5566655768', '178', NULL, '', '8.00', '240.00', '80', '1920.00', '0.00', '', '0.00', '0', '394730.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5022, '125326476646181', '5566655768', '177', NULL, '', '16.00', '300.00', '165', '4800.00', '0.00', '', '0.00', '0', '394730.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5021, '745417626231594', '5566655768', '176', NULL, '', '8.00', '120.00', '65', '960.00', '0.00', '', '0.00', '0', '394730.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5020, '657186934641995', '5566655768', '175', NULL, '', '16.00', '240.00', '125', '3840.00', '0.00', '', '0.00', '0', '394730.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2957, '361182321564839', '6197141427', '420', NULL, '', '1.00', '3700.00', '3936', '3700.00', '0.00', '', '0.00', '0', '9560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2956, '792677858167173', '6197141427', '705', NULL, '', '6.00', '300.00', '250', '1800.00', '0.00', '', '0.00', '0', '9560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2955, '947292693814896', '6197141427', '366', NULL, '', '2.00', '50.00', '46', '100.00', '0.00', '', '0.00', '0', '9560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2954, '172637524633856', '6197141427', '813', NULL, '', '44.00', '90.00', '79', '3960.00', '0.00', '', '0.00', '0', '9560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2675, '143274351814137', '6284454277', '742', NULL, '', '24.00', '110.00', '110', '2640.00', '0.00', '', '0.00', '0', '4320.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2674, '634117648895432', '6284454277', '693', NULL, '', '12.00', '140.00', '130', '1680.00', '0.00', '', '0.00', '0', '4320.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3496, '317524956819168', '5323971621', '813', NULL, '', '5.00', '100.00', '79', '500.00', '0.00', '', '0.00', '0', '1710.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3495, '738171616439127', '5323971621', '238', NULL, '', '2.00', '350.00', '320', '700.00', '0.00', '', '0.00', '0', '1710.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3494, '999684573115624', '5323971621', '693', NULL, '', '2.00', '150.00', '130', '300.00', '0.00', '', '0.00', '0', '1710.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2972, '584238459178944', '8517813777', '68', NULL, '', '6.00', '2500.00', '2600', '15000.00', '0.00', '', '0.00', '0', '46974.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2971, '199925396939345', '8517813777', '69', NULL, '', '2.00', '5300.00', '5200', '10600.00', '0.00', '', '0.00', '0', '46974.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2970, '857319967523231', '8517813777', '77', NULL, '', '1.00', '10500.00', '9100', '10500.00', '0.00', '', '0.00', '0', '46974.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2969, '685942529218115', '8517813777', '784', NULL, '', '1.00', '250.00', '135', '250.00', '0.00', '', '0.00', '0', '46974.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2968, '546334991972455', '8517813777', '773', NULL, '', '1.00', '100.00', '80', '100.00', '0.00', '', '0.00', '0', '46974.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2967, '236191235696745', '8517813777', '693', NULL, '', '2.00', '150.00', '130', '300.00', '0.00', '', '0.00', '0', '46974.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2966, '274228613171156', '8517813777', '703', NULL, '', '2.00', '900.00', '900', '1800.00', '0.00', '', '0.00', '0', '46974.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2965, '954819569634947', '8517813777', '739', NULL, '', '2.00', '600.00', '400', '1200.00', '0.00', '', '0.00', '0', '46974.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2964, '851871198518629', '8517813777', '801 ', NULL, '', '2.00', '370.00', '350', '740.00', '0.00', '', '0.00', '0', '46974.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2963, '547981434162377', '8517813777', '200', NULL, '', '1.00', '900.00', '900', '900.00', '0.00', '', '0.00', '0', '46974.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2962, '584239827589351', '8517813777', '711', NULL, '', '24.00', '66.00', '62', '1584.00', '0.00', '', '0.00', '0', '46974.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2961, '473692235792939', '8517813777', '89', NULL, '', '1.00', '300.00', '280', '300.00', '0.00', '', '0.00', '0', '46974.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2960, '148565688596881', '8517813777', '698', NULL, '', '4.00', '300.00', '290', '1200.00', '0.00', '', '0.00', '0', '46974.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2959, '866827146817412', '8517813777', '5', NULL, '', '4.00', '500.00', '450', '2000.00', '0.00', '', '0.00', '0', '46974.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2958, '247162236911753', '8517813777', '625', NULL, '', '10.00', '50.00', '41', '500.00', '0.00', '', '0.00', '0', '46974.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3160, '482986311139957', '7446617154', '693', NULL, '', '1.00', '160.00', '130', '160.00', '0.00', '', '0.00', '0', '5600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3159, '189356865398728', '7446617154', '715', NULL, '', '3.00', '130.00', '120', '390.00', '0.00', '', '0.00', '0', '5600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3158, '879196746493126', '7446617154', '106', NULL, '', '1.00', '420.00', '380', '420.00', '0.00', '', '0.00', '0', '5600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3157, '659275648995398', '7446617154', '716', NULL, '', '7.00', '190.00', '190', '1330.00', '0.00', '', '0.00', '0', '5600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3156, '186129837139513', '7446617154', '701', NULL, '', '3.00', '1100.00', '1080', '3300.00', '0.00', '', '0.00', '0', '5600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3100, '132251819352651', '3655828734', '776', NULL, '', '3.00', '530.00', '486', '1590.00', '0.00', '', '0.00', '0', '33140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3523, '157171984468549', '7214457359', '373', NULL, '', '38.00', '20.00', '17', '760.00', '0.00', '', '0.00', '0', '32136.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3522, '187537719149422', '7214457359', '181', NULL, '', '2.00', '220.00', '165', '440.00', '0.00', '', '0.00', '0', '32136.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3521, '426466343829313', '7214457359', '179', NULL, '', '12.00', '40.00', '36', '480.00', '0.00', '', '0.00', '0', '32136.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3520, '546839443277787', '7214457359', '175', NULL, '', '1.00', '180.00', '125', '180.00', '0.00', '', '0.00', '0', '32136.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3519, '189718451676436', '7214457359', '20', NULL, '', '24.00', '130.00', '115', '3120.00', '0.00', '', '0.00', '0', '32136.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3518, '214564623714568', '7214457359', '176', NULL, '', '2.00', '108.00', '65', '216.00', '0.00', '', '0.00', '0', '32136.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3517, '771137949525873', '7214457359', '19', NULL, '', '15.00', '80.00', '70', '1200.00', '0.00', '', '0.00', '0', '32136.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3516, '188292256675784', '7214457359', '678', NULL, '', '1.00', '300.00', '286', '300.00', '0.00', '', '0.00', '0', '32136.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3515, '391225151752799', '7214457359', '283', NULL, '', '1.00', '50.00', '30', '50.00', '0.00', '', '0.00', '0', '32136.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3514, '624249326358326', '7214457359', '395', NULL, '', '2.00', '60.00', '50', '120.00', '0.00', '', '0.00', '0', '32136.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3513, '482481578722851', '7214457359', '776', NULL, '', '2.00', '550.00', '486', '1100.00', '0.00', '', '0.00', '0', '32136.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3512, '735296188666255', '7214457359', '687', NULL, '', '8.00', '290.00', '230', '2320.00', '0.00', '', '0.00', '0', '32136.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3511, '316138314447766', '7214457359', '60', NULL, '', '8.00', '250.00', '200', '2000.00', '0.00', '', '0.00', '0', '32136.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3510, '567492476516414', '7214457359', '72', NULL, '', '1.00', '2400.00', '2250', '2400.00', '0.00', '', '0.00', '0', '32136.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3509, '545964175462867', '7214457359', '71', NULL, '', '1.00', '2400.00', '2250', '2400.00', '0.00', '', '0.00', '0', '32136.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3508, '453943992948335', '7214457359', '172', NULL, '', '1.00', '300.00', '150', '300.00', '0.00', '', '0.00', '0', '32136.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3507, '272953127553191', '7214457359', '151', NULL, '', '1.00', '1800.00', '1557', '1800.00', '0.00', '', '0.00', '0', '32136.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3506, '891193863648426', '7214457359', '135', NULL, '', '1.00', '4000.00', '2961', '4000.00', '0.00', '', '0.00', '0', '32136.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3505, '125656743157944', '7214457359', '693', NULL, '', '2.00', '150.00', '130', '300.00', '0.00', '', '0.00', '0', '32136.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3504, '719543417143119', '7214457359', '108', NULL, '', '1.00', '250.00', '300', '250.00', '0.00', '', '0.00', '0', '32136.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3503, '817412111282798', '7214457359', '715', NULL, '', '2.00', '125.00', '120', '250.00', '0.00', '', '0.00', '0', '32136.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3502, '394918875173593', '7214457359', '79', NULL, '', '1.00', '150.00', '120', '150.00', '0.00', '', '0.00', '0', '32136.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3501, '662694635899534', '7214457359', '610', NULL, '', '1.00', '1050.00', '1025', '1050.00', '0.00', '', '0.00', '0', '32136.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3500, '533411915822727', '7214457359', '609', NULL, '', '2.00', '850.00', '800', '1700.00', '0.00', '', '0.00', '0', '32136.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3499, '131559966951262', '7214457359', '697', NULL, '', '7.00', '450.00', '400', '3150.00', '0.00', '', '0.00', '0', '32136.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3099, '887197723845645', '3655828734', '625', NULL, '', '1.00', '50.00', '41', '50.00', '0.00', '', '0.00', '0', '33140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3098, '513628936645889', '3655828734', '54', NULL, '', '6.00', '350.00', '255', '2100.00', '0.00', '', '0.00', '0', '33140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3097, '675756164694796', '3655828734', '55', NULL, '', '18.00', '450.00', '280', '8100.00', '0.00', '', '0.00', '0', '33140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3271, '875318421886958', '9845441218', '831', NULL, '', '1.00', '1000.00', '950', '1000.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3270, '782174549227868', '9845441218', '128', NULL, '', '2.00', '360.00', '400', '720.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3269, '278762745125458', '9845441218', '625', NULL, '', '3.00', '50.00', '41', '150.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3268, '636768765788492', '9845441218', '289', NULL, '', '1.00', '3150.00', '2961', '3150.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3267, '866454177456642', '9845441218', '311', NULL, '', '1.00', '3150.00', '2961', '3150.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3266, '569166951278951', '9845441218', '18', NULL, '', '5.00', '90.00', '75', '450.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3265, '294238523542529', '9845441218', '19', NULL, '', '7.00', '90.00', '70', '630.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3264, '269439655863162', '9845441218', '175', NULL, '', '5.00', '180.00', '125', '900.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3263, '525119418895868', '9845441218', '184', NULL, '', '2.00', '240.00', '1400', '480.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3262, '162769596766632', '9845441218', '20', NULL, '', '34.00', '120.00', '115', '4080.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3261, '392848938461536', '9845441218', '179', NULL, '', '40.00', '40.00', '36', '1600.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3260, '311941448727228', '9845441218', '751', NULL, '', '6.00', '200.00', '245', '1200.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3259, '742741724791457', '9845441218', '15', NULL, '', '15.00', '160.00', '135', '2400.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3258, '276189361967274', '9845441218', '177', NULL, '', '1.00', '240.00', '165', '240.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3257, '283791989951279', '9845441218', '238', NULL, '', '1.00', '350.00', '320', '350.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3256, '551915926688593', '9845441218', '693', NULL, '', '1.00', '200.00', '130', '200.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3255, '485722813542174', '9845441218', '602', NULL, '', '1.00', '1600.00', '1500', '1600.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3254, '921532167882222', '9845441218', '92', NULL, '', '10.00', '240.00', '260', '2400.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3253, '756167314325849', '9845441218', '123', NULL, '', '1.00', '300.00', '300', '300.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3252, '197263243186751', '9845441218', '93', NULL, '', '2.00', '360.00', '270', '720.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3251, '165894945528529', '9845441218', '99', NULL, '', '1.00', '360.00', '360', '360.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3250, '228332965223796', '9845441218', '191', NULL, '', '1.00', '1600.00', '1700', '1600.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3249, '614941661748291', '9845441218', '2', NULL, '', '2.00', '240.00', '190', '480.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3248, '118356676999576', '9845441218', '242', NULL, '', '1.00', '400.00', '490', '400.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3247, '462636263721373', '9845441218', '711', NULL, '', '2.00', '80.00', '62', '160.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3246, '528996254365822', '9845441218', '217', NULL, '', '1.00', '200.00', '180', '200.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3245, '928955784321186', '9845441218', '699', NULL, '', '6.00', '400.00', '320', '2400.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2302, '944366779985271', '8668857166', '58', NULL, '', '1.00', '150.00', '115', '150.00', '0.00', '', NULL, '0', '33197.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2303, '646736931529675', '8668857166', '693', NULL, '', '4.00', '200.00', '130', '800.00', '0.00', '', NULL, '0', '33197.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2304, '494957927782941', '8668857166', '772', NULL, '', '6.00', '50.00', '30', '300.00', '0.00', '', NULL, '0', '33197.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2305, '666442581134947', '8668857166', '413', NULL, '', '1.00', '11000.00', '7750', '11000.00', '0.00', '', NULL, '0', '33197.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2306, '469746188748899', '8668857166', '6', NULL, '', '2.00', '180.00', '150', '360.00', '0.00', '', NULL, '0', '33197.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2307, '321929496758241', '8668857166', '410', NULL, '', '1.00', '3400.00', '1650', '3400.00', '0.00', '', NULL, '0', '33197.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2308, '191769568597466', '8668857166', '404', NULL, '', '12.00', '120.00', '125', '1440.00', '0.00', '', NULL, '0', '33197.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2309, '767799971297486', '8668857166', '238', NULL, '', '3.00', '350.00', '320', '1050.00', '0.00', '', NULL, '0', '33197.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2310, '439747353938458', '8668857166', '78', NULL, '', '1.00', '170.00', '160', '170.00', '0.00', '', NULL, '0', '33197.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2311, '582544481663254', '8668857166', '19', NULL, '', '2.00', '80.00', '70', '160.00', '0.00', '', NULL, '0', '33197.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2312, '727561937139181', '8668857166', '784', NULL, '', '1.00', '250.00', '135', '250.00', '0.00', '', NULL, '0', '33197.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2313, '771977577321389', '8668857166', '289', NULL, '', '1.00', '3000.00', '2961', '3000.00', '0.00', '', NULL, '0', '33197.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2314, '295266855246771', '8668857166', '311', NULL, '', '1.00', '3000.00', '2961', '3000.00', '0.00', '', NULL, '0', '33197.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2315, '476267172886956', '8668857166', '290', NULL, '', '1.00', '6500.00', '6146', '6500.00', '0.00', '', NULL, '0', '33197.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2316, '572445531546297', '8668857166', '29', NULL, '', '5.00', '60.00', '40', '300.00', '0.00', '', NULL, '0', '33197.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2317, '819942917879396', '8668857166', '421', NULL, '', '2.00', '70.00', '36', '140.00', '0.00', '', NULL, '0', '33197.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2318, '621849162166645', '8668857166', '113', NULL, '', '1.00', '950.00', '840', '950.00', '0.00', '', NULL, '0', '33197.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2319, '953425516947275', '8668857166', '61', NULL, '', '1.00', '227.00', '160', '227.00', '0.00', '', NULL, '0', '33197.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3524, '932938511985532', '7567791142', '304', NULL, '', '1.00', '2500.00', '2000', '2500.00', '0.00', '', '0.00', '0', '2900.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3466, '272441979639142', '1115919194', '715', NULL, '', '50.00', '120.00', '120', '6000.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3290, '142188138628719', '8588781131', '289', NULL, '', '3.00', '3000.00', '2961', '9000.00', '0.00', '', '0.00', '0', '47930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3289, '715899426865946', '8588781131', '311', NULL, '', '2.00', '3000.00', '2961', '6000.00', '0.00', '', '0.00', '0', '47930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3288, '639496617213193', '8588781131', '141', NULL, '', '2.00', '6200.00', '6146', '12400.00', '0.00', '', '0.00', '0', '47930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3287, '689142778858482', '8588781131', '700', NULL, '', '36.00', '170.00', '160', '6120.00', '0.00', '', '0.00', '0', '47930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3286, '157598932136452', '8588781131', '776', NULL, '', '7.00', '520.00', '486', '3640.00', '0.00', '', '0.00', '0', '47930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3285, '389254532541714', '8588781131', '678', NULL, '', '3.00', '300.00', '286', '900.00', '0.00', '', '0.00', '0', '47930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3284, '426183639198468', '8588781131', '15', NULL, '', '12.00', '185.00', '135', '2220.00', '0.00', '', '0.00', '0', '47930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3283, '687785173631493', '8588781131', '20', NULL, '', '15.00', '140.00', '115', '2100.00', '0.00', '', '0.00', '0', '47930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3282, '775762982433518', '8588781131', '181', NULL, '', '2.00', '200.00', '165', '400.00', '0.00', '', '0.00', '0', '47930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3281, '712397714127748', '8588781131', '175', NULL, '', '3.00', '180.00', '125', '540.00', '0.00', '', '0.00', '0', '47930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3280, '289221236221528', '8588781131', '177', NULL, '', '1.00', '240.00', '165', '240.00', '0.00', '', '0.00', '0', '47930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3279, '599149377623859', '8588781131', '179', NULL, '', '22.00', '45.00', '36', '990.00', '0.00', '', '0.00', '0', '47930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3278, '943825688214955', '8588781131', '176', NULL, '', '1.00', '150.00', '65', '150.00', '0.00', '', '0.00', '0', '47930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3277, '381785391719547', '8588781131', '600', NULL, '', '2.00', '50.00', '221', '100.00', '0.00', '', '0.00', '0', '47930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3276, '751377996272187', '8588781131', '213', NULL, '', '1.00', '200.00', '170', '200.00', '0.00', '', '0.00', '0', '47930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3275, '147218212117494', '8588781131', '492', NULL, '', '1.00', '480.00', '235', '480.00', '0.00', '', '0.00', '0', '47930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3274, '481377923441348', '8588781131', '56', NULL, '', '1.00', '1200.00', '1000', '1200.00', '0.00', '', '0.00', '0', '47930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3273, '336182545745163', '8588781131', '704 ', NULL, '', '1.00', '550.00', '550', '550.00', '0.00', '', '0.00', '0', '47930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3465, '332491148227448', '1115919194', '775', NULL, '', '1.00', '25.00', '30', '25.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3306, '822197151831611', '2737884135', '705', NULL, '', '19.00', '300.00', '250', '5700.00', '0.00', '', '0.00', '0', '55589.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3305, '646659377851952', '2737884135', '813', NULL, '', '70.00', '93.00', '79', '6510.00', '0.00', '', '0.00', '0', '55589.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3304, '465839559371849', '2737884135', '366', NULL, '', '5.00', '60.00', '46', '300.00', '0.00', '', '0.00', '0', '55589.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3303, '413685563223892', '2737884135', '721', NULL, '', '2.00', '7250.00', '6250', '14500.00', '0.00', '', '0.00', '0', '55589.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3302, '425658565263487', '2737884135', '704 ', NULL, '', '3.00', '550.00', '550', '1650.00', '0.00', '', '0.00', '0', '55589.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3301, '297366236133885', '2737884135', '56', NULL, '', '1.00', '1200.00', '1000', '1200.00', '0.00', '', '0.00', '0', '55589.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3300, '542638981224176', '2737884135', '61', NULL, '', '4.00', '200.00', '160', '800.00', '0.00', '', '0.00', '0', '55589.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3299, '655267551134128', '2737884135', '805', NULL, '', '2.00', '750.00', '830', '1500.00', '0.00', '', '0.00', '0', '55589.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3298, '716585789463429', '2737884135', '693', NULL, '', '1.00', '200.00', '130', '200.00', '0.00', '', '0.00', '0', '55589.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3297, '438126672477363', '2737884135', '599', NULL, '', '1.00', '150.00', '120', '150.00', '0.00', '', '0.00', '0', '55589.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3296, '299124193476855', '2737884135', '8', NULL, '', '2.00', '600.00', '550', '1200.00', '0.00', '', '0.00', '0', '55589.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3295, '398257159475314', '2737884135', '242', NULL, '', '1.00', '550.00', '490', '550.00', '0.00', '', '0.00', '0', '55589.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3294, '435512494268774', '2737884135', '490', NULL, '', '1.00', '150.00', '90', '150.00', '0.00', '', '0.00', '0', '55589.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3293, '773195945216627', '2737884135', '701', NULL, '', '3.00', '1133.00', '1080', '3399.00', '0.00', '', '0.00', '0', '55589.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3464, '137628848296164', '1115919194', '8', NULL, '', '1.00', '550.00', '550', '550.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3463, '186477424199331', '1115919194', '497', NULL, '', '1.00', '180.00', '160', '180.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3462, '286345643473476', '1115919194', '9', NULL, '', '1.00', '400.00', '430', '400.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3461, '453423581599224', '1115919194', '772', NULL, '', '1.00', '50.00', '30', '50.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3460, '322653645843495', '1115919194', '489', NULL, '', '2.00', '240.00', '125', '480.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3459, '674897229751787', '1115919194', '300', NULL, '', '1.00', '10700.00', '8707', '10700.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3458, '225853724947439', '1115919194', '776', NULL, '', '2.00', '500.00', '486', '1000.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3457, '465453111681838', '1115919194', '604', NULL, '', '10.00', '180.00', '175', '1800.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3456, '719562685345647', '1115919194', '176', NULL, '', '3.00', '120.00', '65', '360.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3455, '854251993899745', '1115919194', '175', NULL, '', '5.00', '180.00', '125', '900.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3454, '717123419574854', '1115919194', '19', NULL, '', '30.00', '80.00', '70', '2400.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3453, '227814258924682', '1115919194', '29', NULL, '', '15.00', '60.00', '40', '900.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3452, '349823387366561', '1115919194', '421', NULL, '', '15.00', '60.00', '36', '1050.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3451, '345855871731476', '1115919194', '726', NULL, '', '2.00', '5500.00', '4800', '11000.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3447, '869875486699211', '1115919194', '141', NULL, '', '2.00', '6000.00', '6146', '12000.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3448, '328191348849513', '1115919194', '139', NULL, '', '1.00', '2900.00', '2961', '2900.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3449, '688816517728399', '1115919194', '291', NULL, '', '1.00', '9500.00', '9331', '9500.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3450, '871211596498531', '1115919194', '321', NULL, '', '1.00', '9500.00', '9331', '9500.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3446, '683947589146699', '1115919194', '140', NULL, '', '1.00', '2900.00', '2961', '2900.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3445, '659246778398562', '1115919194', '649', NULL, '', '11.00', '2900.00', '4555', '31900.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3444, '241126693413784', '1115919194', '136', NULL, '', '3.00', '2900.00', '2961', '8700.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3443, '543196455635626', '1115919194', '327', NULL, '', '1.00', '10700.00', '8707', '10700.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3442, '892439848888595', '1115919194', '625', NULL, '', '6.00', '50.00', '41', '300.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2440, '995845131257893', '5233818293', '490', NULL, '', '2.00', '250.00', '90', '500.00', '0.00', '', NULL, '0', '14900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2441, '833795655871249', '5233818293', '339', NULL, '', '1.00', '7200.00', '7381', '7200.00', '0.00', '', NULL, '0', '14900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2442, '524461214719883', '5233818293', '340', NULL, '', '1.00', '7200.00', '7381', '7200.00', '0.00', '', NULL, '0', '14900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2716, '255768159596412', '1981932215', '423', NULL, '', '2.00', '5000.00', '4100', '10000.00', '0.00', '', '0.00', '0', '38030.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2715, '547924218373882', '1981932215', '726', NULL, '', '2.00', '5500.00', '4800', '11000.00', '0.00', '', '0.00', '0', '38030.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2714, '618378492981432', '1981932215', '15', NULL, '', '15.00', '140.00', '135', '2100.00', '0.00', '', '0.00', '0', '38030.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2713, '855411422191954', '1981932215', '57', NULL, '', '6.00', '140.00', '140', '840.00', '0.00', '', '0.00', '0', '38030.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2712, '732329332851398', '1981932215', '490', NULL, '', '4.00', '140.00', '90', '560.00', '0.00', '', '0.00', '0', '38030.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2711, '582827188262224', '1981932215', '715', NULL, '', '1.00', '130.00', '120', '130.00', '0.00', '', '0.00', '0', '38030.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2710, '231121842342556', '1981932215', '773', NULL, '', '1.00', '200.00', '80', '200.00', '0.00', '', '0.00', '0', '38030.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2709, '757834894575849', '1981932215', '419', NULL, '', '1.00', '6600.00', '6731', '6600.00', '0.00', '', '0.00', '0', '38030.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3714, '548416516281275', '2968574474', '832 ', NULL, '', '1.00', '3300.00', '3200', '3300.00', '0.00', '', '0.00', '0', '9100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3713, '927843425535453', '2968574474', '497', NULL, '', '1.00', '160.00', '160', '160.00', '0.00', '', '0.00', '0', '9100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3712, '458522557958932', '2968574474', '448', NULL, '', '1.00', '120.00', '120', '120.00', '0.00', '', '0.00', '0', '9100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3711, '383661194569361', '2968574474', '2', NULL, '', '2.00', '240.00', '190', '480.00', '0.00', '', '0.00', '0', '9100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3710, '239877558534278', '2968574474', '57', NULL, '', '20.00', '115.00', '140', '2300.00', '0.00', '', '0.00', '0', '9100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3709, '562119793575276', '2968574474', '28', NULL, '', '2.00', '120.00', '120', '240.00', '0.00', '', '0.00', '0', '9100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3708, '855335431756716', '2968574474', '124', NULL, '', '2.00', '400.00', '500', '800.00', '0.00', '', '0.00', '0', '9100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3707, '579981152724695', '2968574474', '1', NULL, '', '2.00', '400.00', '370', '800.00', '0.00', '', '0.00', '0', '9100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3706, '657284933179518', '2968574474', '693', NULL, '', '5.00', '150.00', '130', '750.00', '0.00', '', '0.00', '0', '9100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3705, '323438121298395', '2968574474', '490', NULL, '', '1.00', '150.00', '90', '150.00', '0.00', '', '0.00', '0', '9100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3656, '231616924927654', '9793391551', '850', NULL, '', '3.00', '750.00', '750', '2250.00', '0.00', '', '0.00', '0', '42705.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3655, '577551451447432', '9793391551', '767', NULL, '', '1.00', '2900.00', '2500', '0.00', '0.00', '', '0.00', '0', '42705.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3654, '755132899971369', '9793391551', '763', NULL, '', '1.00', '1550.00', '1050', '1550.00', '0.00', '', '0.00', '0', '42705.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3653, '923596349534338', '9793391551', '765', NULL, '', '3.00', '550.00', '450', '1650.00', '0.00', '', '0.00', '0', '42705.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3652, '382182485628788', '9793391551', '603', NULL, '', '4.00', '350.00', '250', '1400.00', '0.00', '', '0.00', '0', '42705.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3651, '118657524683667', '9793391551', '221', NULL, '', '2.00', '750.00', '500', '1500.00', '0.00', '', '0.00', '0', '42705.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3650, '531378366833682', '9793391551', '730', NULL, '', '100.00', '180.00', '150', '18000.00', '0.00', '', '0.00', '0', '42705.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3649, '274272713126799', '9793391551', '772', NULL, '', '12.00', '30.00', '30', '360.00', '0.00', '', '0.00', '0', '42705.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3648, '878379716671918', '9793391551', '578', NULL, '', '1.00', '2550.00', '2000', '2550.00', '0.00', '', '0.00', '0', '42705.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3647, '192279687413935', '9793391551', '714', NULL, '', '1.00', '500.00', '325', '500.00', '0.00', '', '0.00', '0', '42705.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3646, '399474973387481', '9793391551', '20', NULL, '', '15.00', '150.00', '115', '2250.00', '0.00', '', '0.00', '0', '42705.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3645, '849994373422279', '9793391551', '422', NULL, '', '6.00', '60.00', '30', '360.00', '0.00', '', '0.00', '0', '42705.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3644, '692425859678888', '9793391551', '421', NULL, '', '12.00', '70.00', '36', '840.00', '0.00', '', '0.00', '0', '42705.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3643, '618693259196932', '9793391551', '786', NULL, '', '5.00', '250.00', '250', '1250.00', '0.00', '', '0.00', '0', '42705.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3642, '297933345172289', '9793391551', '784', NULL, '', '3.00', '140.00', '135', '420.00', '0.00', '', '0.00', '0', '42705.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3641, '572517288595289', '9793391551', '474', NULL, '', '5.00', '115.00', '100', '575.00', '0.00', '', '0.00', '0', '42705.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3640, '646398459776797', '9793391551', '764', NULL, '', '1.00', '3300.00', '3200', '3300.00', '0.00', '', '0.00', '0', '42705.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2515, '972985177334532', '3317182685', '693', NULL, '', '2.00', '150.00', '130', '300.00', '0.00', '', NULL, '0', '3630.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2516, '784893742627866', '3317182685', '490', NULL, '', '7.00', '140.00', '90', '980.00', '0.00', '', NULL, '0', '3630.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2517, '823222175416828', '3317182685', '704 ', NULL, '', '2.00', '575.00', '550', '1150.00', '0.00', '', NULL, '0', '3630.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2518, '135139965459284', '3317182685', '9', NULL, '', '3.00', '400.00', '430', '1200.00', '0.00', '', NULL, '0', '3630.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3096, '968495998336659', '3655828734', '687', NULL, '', '6.00', '280.00', '230', '1680.00', '0.00', '', '0.00', '0', '33140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3095, '181621416621535', '3655828734', '700', NULL, '', '5.00', '180.00', '160', '900.00', '0.00', '', '0.00', '0', '33140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3094, '612526187469959', '3655828734', '703', NULL, '', '2.00', '900.00', '900', '1800.00', '0.00', '', '0.00', '0', '33140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3093, '973721986888559', '3655828734', '697', NULL, '', '2.00', '450.00', '400', '900.00', '0.00', '', '0.00', '0', '33140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3092, '478414922551747', '3655828734', '802', NULL, '', '5.00', '300.00', '280', '1500.00', '0.00', '', '0.00', '0', '33140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3091, '927816337339469', '3655828734', '421', NULL, '', '3.00', '70.00', '36', '210.00', '0.00', '', '0.00', '0', '33140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3090, '195532458161559', '3655828734', '422', NULL, '', '4.00', '60.00', '30', '240.00', '0.00', '', '0.00', '0', '33140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3089, '968416818438117', '3655828734', '71', NULL, '', '1.00', '2350.00', '2250', '2350.00', '0.00', '', '0.00', '0', '33140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3088, '532213894369356', '3655828734', '72', NULL, '', '1.00', '2350.00', '2250', '2350.00', '0.00', '', '0.00', '0', '33140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3087, '787998547953235', '3655828734', '263', NULL, '', '1.00', '450.00', '350', '450.00', '0.00', '', '0.00', '0', '33140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3086, '498545197665324', '3655828734', '600', NULL, '', '3.00', '50.00', '221', '150.00', '0.00', '', '0.00', '0', '33140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3085, '523485158128545', '3655828734', '19', NULL, '', '3.00', '80.00', '70', '240.00', '0.00', '', '0.00', '0', '33140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3084, '395769445599688', '3655828734', '693', NULL, '', '1.00', '170.00', '130', '170.00', '0.00', '', '0.00', '0', '33140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3083, '778416799576693', '3655828734', '813', NULL, '', '70.00', '93.00', '79', '6510.00', '0.00', '', '0.00', '0', '33140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3082, '741672978322361', '3655828734', '366', NULL, '', '6.00', '75.00', '46', '450.00', '0.00', '', '0.00', '0', '33140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3701, '425735662251166', '3978355951', '498', NULL, '', '1.00', '240.00', '250', '240.00', '0.00', '', '0.00', '0', '53600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3700, '879275841435523', '3978355951', '625', NULL, '', '2.00', '50.00', '41', '100.00', '0.00', '', '0.00', '0', '53600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3699, '498431932584741', '3978355951', '819', NULL, '', '1.00', '1900.00', '1900', '1900.00', '0.00', '', '0.00', '0', '53600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3698, '928163943799417', '3978355951', '92', NULL, '', '10.00', '230.00', '260', '2300.00', '0.00', '', '0.00', '0', '53600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3697, '914535717162297', '3978355951', '194', NULL, '', '2.00', '1700.00', '1500', '3400.00', '0.00', '', '0.00', '0', '53600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3696, '856147485589235', '3978355951', '225', NULL, '', '2.00', '480.00', '480', '960.00', '0.00', '', '0.00', '0', '53600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3695, '359369181266725', '3978355951', '274', NULL, '', '2.00', '400.00', '360', '800.00', '0.00', '', '0.00', '0', '53600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3694, '984377347636186', '3978355951', '100', NULL, '', '10.00', '300.00', '300', '3000.00', '0.00', '', '0.00', '0', '53600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3693, '282683196188153', '3978355951', '599', NULL, '', '9.00', '130.00', '120', '1170.00', '0.00', '', '0.00', '0', '53600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3692, '223219973535835', '3978355951', '28', NULL, '', '5.00', '170.00', '120', '850.00', '0.00', '', '0.00', '0', '53600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3691, '839673351794645', '3978355951', '196', NULL, '', '2.00', '400.00', '380', '800.00', '0.00', '', '0.00', '0', '53600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3690, '788663282822166', '3978355951', '78', NULL, '', '6.00', '180.00', '160', '1080.00', '0.00', '', '0.00', '0', '53600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3689, '897899257549614', '3978355951', '600', NULL, '', '10.00', '40.00', '221', '400.00', '0.00', '', '0.00', '0', '53600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3688, '954677264937771', '3978355951', '218', NULL, '', '10.00', '180.00', '170', '1800.00', '0.00', '', '0.00', '0', '53600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3687, '575352568916687', '3978355951', '649', NULL, '', '3.00', '2900.00', '4555', '8700.00', '0.00', '', '0.00', '0', '53600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3686, '731278978789251', '3978355951', '650', NULL, '', '3.00', '2900.00', '4555', '8700.00', '0.00', '', '0.00', '0', '53600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2592, '862213384856325', '2724633553', '730', NULL, '', '18.00', '500.00', '150', '9000.00', '0.00', '', '0.00', '0', '72150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2609, '613348858462655', '9994122257', '625', NULL, '', '1.00', '50.00', '41', '50.00', '0.00', '', NULL, '0', '29700.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2610, '187968834496273', '9994122257', '810', NULL, '', '200.00', '100.00', '103', '20000.00', '0.00', '', NULL, '0', '29700.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2611, '796798693562646', '9994122257', '296', NULL, '', '3.00', '3000.00', '3351', '9000.00', '0.00', '', NULL, '0', '29700.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2612, '572689731914641', '9994122257', '8', NULL, '', '1.00', '650.00', '550', '650.00', '0.00', '', NULL, '0', '29700.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2708, '372136623543194', '1981932215', '420', NULL, '', '1.00', '3600.00', '3936', '3600.00', '0.00', '', '0.00', '0', '38030.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2655, '744215362658922', '2185662296', '176', NULL, '', '1.00', '120.00', '65', '120.00', '0.00', '', '0.00', '0', '26525.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2654, '643531149647448', '2185662296', '175', NULL, '', '1.00', '120.00', '125', '120.00', '0.00', '', '0.00', '0', '26525.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2653, '788987724775117', '2185662296', '421', NULL, '', '4.00', '40.00', '36', '160.00', '0.00', '', '0.00', '0', '26525.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2652, '124848915749844', '2185662296', '29', NULL, '', '6.00', '30.00', '40', '180.00', '0.00', '', '0.00', '0', '26525.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2651, '326853978617376', '2185662296', '21', NULL, '', '35.00', '140.00', '130', '4900.00', '0.00', '', '0.00', '0', '26525.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2650, '945648247228872', '2185662296', '179', NULL, '', '24.00', '40.00', '36', '960.00', '0.00', '', '0.00', '0', '26525.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2649, '314791953744632', '2185662296', '182', NULL, '', '4.00', '150.00', '90', '600.00', '0.00', '', '0.00', '0', '26525.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2648, '738914959135486', '2185662296', '496', NULL, '', '18.00', '60.00', '38', '1080.00', '0.00', '', '0.00', '0', '26525.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2647, '415429258377274', '2185662296', '81', NULL, '', '1.00', '120.00', '80', '120.00', '0.00', '', '0.00', '0', '26525.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2646, '164529377694586', '2185662296', '625', NULL, '', '4.00', '50.00', '41', '200.00', '0.00', '', '0.00', '0', '26525.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2645, '735747497222665', '2185662296', '363', NULL, '', '3.00', '350.00', '320', '1050.00', '0.00', '', '0.00', '0', '26525.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2644, '558274274219982', '2185662296', '684', NULL, '', '2.00', '400.00', '360', '800.00', '0.00', '', '0.00', '0', '26525.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2643, '354118346146754', '2185662296', '688', NULL, '', '4.00', '400.00', '360', '1600.00', '0.00', '', '0.00', '0', '26525.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2642, '855491529891333', '2185662296', '283', NULL, '', '10.00', '35.00', '30', '350.00', '0.00', '', '0.00', '0', '26525.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2641, '994869641572913', '2185662296', '715', NULL, '', '25.00', '120.00', '120', '3000.00', '0.00', '', '0.00', '0', '26525.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2640, '399163342327477', '2185662296', '58', NULL, '', '80.00', '105.00', '115', '8400.00', '0.00', '', '0.00', '0', '26525.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2639, '378689245174728', '2185662296', '693', NULL, '', '1.00', '150.00', '130', '150.00', '0.00', '', '0.00', '0', '26525.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2638, '637174351264858', '2185662296', '814', NULL, '', '3.00', '170.00', '135', '510.00', '0.00', '', '0.00', '0', '26525.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2637, '368658185146832', '2185662296', '240', NULL, '', '3.00', '280.00', '260', '840.00', '0.00', '', '0.00', '0', '26525.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2636, '555682995118139', '2185662296', '248', NULL, '', '1.00', '380.00', '320', '380.00', '0.00', '', '0.00', '0', '26525.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2635, '583911878949826', '2185662296', '699', NULL, '', '3.00', '335.00', '320', '1005.00', '0.00', '', '0.00', '0', '26525.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2717, '634687954256536', '1981932215', '715', NULL, '', '25.00', '120.00', '120', '3000.00', '0.00', '', '0.00', '0', '38030.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2831, '357398856577193', '7551413551', '830', NULL, '', '13.00', '100.00', '90', '1300.00', '0.00', '', '0.00', '0', '23740.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2830, '384713317575473', '7551413551', '577', NULL, '', '1.00', '1600.00', '1250', '1600.00', '0.00', '', '0.00', '0', '23740.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2829, '752589193945526', '7551413551', '490', NULL, '', '2.00', '150.00', '90', '300.00', '0.00', '', '0.00', '0', '23740.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2828, '623874868118878', '7551413551', '481', NULL, '', '1.00', '50.00', '390', '50.00', '0.00', '', '0.00', '0', '23740.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2827, '342647828212276', '7551413551', '829', NULL, '', '7.00', '320.00', '280', '2240.00', '0.00', '', '0.00', '0', '23740.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2826, '772588231113828', '7551413551', '495', NULL, '', '1.00', '600.00', '650', '600.00', '0.00', '', '0.00', '0', '23740.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2825, '154582532486246', '7551413551', '86', NULL, '', '1.00', '400.00', '390', '400.00', '0.00', '', '0.00', '0', '23740.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2824, '282262691213976', '7551413551', '714', NULL, '', '1.00', '400.00', '325', '400.00', '0.00', '', '0.00', '0', '23740.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2823, '466651828337347', '7551413551', '448', NULL, '', '1.00', '150.00', '120', '150.00', '0.00', '', '0.00', '0', '23740.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2822, '486752122922234', '7551413551', '175', NULL, '', '1.00', '180.00', '125', '180.00', '0.00', '', '0.00', '0', '23740.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2821, '314735216348995', '7551413551', '176', NULL, '', '1.00', '120.00', '65', '120.00', '0.00', '', '0.00', '0', '23740.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2820, '787478952828322', '7551413551', '177', NULL, '', '2.00', '240.00', '165', '480.00', '0.00', '', '0.00', '0', '23740.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2819, '834731887371228', '7551413551', '489', NULL, '', '3.00', '240.00', '125', '720.00', '0.00', '', '0.00', '0', '23740.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2818, '523593419227491', '7551413551', '625', NULL, '', '27.00', '50.00', '41', '1350.00', '0.00', '', '0.00', '0', '23740.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2817, '751358666937252', '7551413551', '122', NULL, '', '1.00', '360.00', '340', '360.00', '0.00', '', '0.00', '0', '23740.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2816, '172331764785441', '7551413551', '92', NULL, '', '3.00', '240.00', '260', '720.00', '0.00', '', '0.00', '0', '23740.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2815, '483863264467398', '7551413551', '102', NULL, '', '4.00', '480.00', '450', '1920.00', '0.00', '', '0.00', '0', '23740.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2814, '165241461713887', '7551413551', '713', NULL, '', '2.00', '400.00', '310', '800.00', '0.00', '', '0.00', '0', '23740.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2813, '494167914659983', '7551413551', '452 ', NULL, '', '2.00', '250.00', '292', '500.00', '0.00', '', '0.00', '0', '23740.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2812, '962887895671377', '7551413551', '774', NULL, '', '4.00', '400.00', '460', '1600.00', '0.00', '', '0.00', '0', '23740.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2811, '137161584545156', '7551413551', '813', NULL, '', '87.00', '90.00', '79', '7830.00', '0.00', '', '0.00', '0', '23740.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2832, '238232696928727', '7551413551', '33', NULL, '', '1.00', '120.00', '700', '120.00', '0.00', '', '0.00', '0', '23740.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2835, '252823192785965', '2184931446', '810', NULL, '', '50.00', '105.00', '103', '5250.00', '0.00', '', '0.00', '0', '147682.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2836, '322536417539988', '2184931446', '811', NULL, '', '50.00', '105.00', '103', '5250.00', '0.00', '', '0.00', '0', '147682.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5019, '959315814624242', '5566655768', '751', NULL, '', '96.00', '200.00', '245', '19200.00', '0.00', '', '0.00', '0', '394730.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5018, '371951874896758', '5566655768', '827', NULL, '', '200.00', '200.00', '115', '40000.00', '0.00', '', '0.00', '0', '394730.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5017, '174134951784621', '5566655768', '828', NULL, '', '250.00', '300.00', '155', '75000.00', '0.00', '', '0.00', '0', '394730.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3721, '868773819183547', '2943739531', '294', NULL, '', '1.00', '7500.00', '7121', '7500.00', '0.00', '', '0.00', '0', '485891.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3720, '535454273448373', '2943739531', '327', NULL, '', '1.00', '9200.00', '8707', '9200.00', '0.00', '', '0.00', '0', '485891.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2853, '495668716651235', '8439691471', '650', NULL, '', '1.00', '3000.00', '4555', '3000.00', '0.00', '', NULL, '0', '455250.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2854, '731139995955275', '8439691471', '289', NULL, '', '1.00', '3000.00', '2961', '3000.00', '0.00', '', NULL, '0', '455250.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2855, '289292467962634', '8439691471', '213', NULL, '', '3.00', '180.00', '170', '540.00', '0.00', '', NULL, '0', '455250.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2856, '225352269333831', '8439691471', '813', NULL, '', '70.00', '78.00', '79', '5460.00', '0.00', '', NULL, '0', '455250.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2857, '267464678343666', '8439691471', '498', NULL, '', '2.00', '180.00', '250', '360.00', '0.00', '', NULL, '0', '455250.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5030, '816938893648568', '3266869518', '264', NULL, '', '2.00', '120.00', '80', '240.00', '0.00', '', '0.00', '0', '156512.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5029, '551229487387875', '3266869518', '285', NULL, '', '1.00', '240.00', '240', '240.00', '0.00', '', '0.00', '0', '156512.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5028, '825134477647219', '3266869518', '99', NULL, '', '2.00', '360.00', '360', '720.00', '0.00', '', '0.00', '0', '156512.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5027, '416332852717334', '3266869518', '270', NULL, '', '4.00', '180.00', '160', '720.00', '0.00', '', '0.00', '0', '156512.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5026, '912176454133871', '3266869518', '284', NULL, '', '12.00', '45.00', '40', '540.00', '0.00', '', '0.00', '0', '156512.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5025, '218951588166144', '3266869518', '283', NULL, '', '10.00', '35.00', '30', '350.00', '0.00', '', '0.00', '0', '156512.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5024, '381642124523754', '3266869518', '295', NULL, '', '1.00', '4100.00', '3936', '4100.00', '0.00', '', '0.00', '0', '156512.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2876, '796861169547547', '8411284899', '299', NULL, '', '5.00', '4000.00', '4092', '20000.00', '0.00', '', '0.00', '0', '582791.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2875, '785985836516169', '8411284899', '323', NULL, '', '5.00', '4000.00', '4092', '20000.00', '0.00', '', '0.00', '0', '582791.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2874, '732121292475982', '8411284899', '300', NULL, '', '5.00', '9200.00', '8707', '46000.00', '0.00', '', '0.00', '0', '582791.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2873, '155475894329621', '8411284899', '327', NULL, '', '5.00', '9200.00', '8707', '46000.00', '0.00', '', '0.00', '0', '582791.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2877, '235692331351423', '8876911595', '703', NULL, '', '4.00', '950.00', '900', '3800.00', '0.00', '', NULL, '0', '361300.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2878, '946341496515535', '8876911595', '450', NULL, '', '5.00', '200.00', '150', '1000.00', '0.00', '', NULL, '0', '361300.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2879, '613674414455294', '8876911595', '102', NULL, '', '3.00', '600.00', '450', '1800.00', '0.00', '', NULL, '0', '361300.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2880, '281946451276737', '8876911595', '718', NULL, '', '10.00', '350.00', '220', '3500.00', '0.00', '', NULL, '0', '361300.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2881, '668886417514786', '8876911595', '363', NULL, '', '1.00', '400.00', '320', '400.00', '0.00', '', NULL, '0', '361300.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2882, '873917879444313', '9518822344', '410', NULL, '', '3.00', '1700.00', '1650', '5100.00', '0.00', '', NULL, '0', '167092.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2883, '748538738757967', '9518822344', '71', NULL, '', '1.00', '2200.00', '2250', '2200.00', '0.00', '', NULL, '0', '167092.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2884, '839773593388366', '9518822344', '92', NULL, '', '10.00', '260.00', '260', '2600.00', '0.00', '', NULL, '0', '167092.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2885, '945574681815989', '9518822344', '122', NULL, '', '1.00', '320.00', '340', '320.00', '0.00', '', NULL, '0', '167092.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2886, '991997526218355', '9518822344', '270', NULL, '', '2.00', '180.00', '160', '360.00', '0.00', '', NULL, '0', '167092.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2887, '684769967436681', '6853249324', '322', NULL, '', '3.00', '15500.00', '14986', '46500.00', '0.00', '', NULL, '0', '141450.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2888, '926342549387781', '6853249324', '8', NULL, '', '1.00', '650.00', '550', '650.00', '0.00', '', NULL, '0', '141450.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2889, '527948969629915', '6853249324', '207', NULL, '', '1.00', '1300.00', '1300', '1300.00', '0.00', '', NULL, '0', '141450.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2890, '668264594926457', '2813146579', '650', NULL, '', '1.00', '3000.00', '4555', '3000.00', '0.00', '', NULL, '0', '194692.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2891, '487992237839999', '2813146579', '289', NULL, '', '1.00', '3000.00', '2961', '3000.00', '0.00', '', NULL, '0', '194692.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2892, '725128112192352', '2813146579', '138', NULL, '', '1.00', '3000.00', '2961', '3000.00', '0.00', '', NULL, '0', '194692.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2893, '941792453427248', '2813146579', '143', NULL, '', '3.00', '6200.00', '6146', '18600.00', '0.00', '', NULL, '0', '194692.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2921, '368147154939786', '1515783136', '291', NULL, '', '1.00', '14355.00', '9331', '14355.00', '0.00', '', '0.00', '0', '556735.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2920, '666368463584523', '1515783136', '140', NULL, '', '2.00', '4555.00', '2961', '9110.00', '0.00', '', '0.00', '0', '556735.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2919, '762424926328967', '1515783136', '654', NULL, '', '2.00', '4555.00', '4555', '9110.00', '0.00', '', '0.00', '0', '556735.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2918, '128457884659567', '1515783136', '649', NULL, '', '3.00', '4555.00', '4555', '13665.00', '0.00', '', '0.00', '0', '556735.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2917, '358499752378999', '1515783136', '289', NULL, '', '4.00', '4555.00', '2961', '18220.00', '0.00', '', '0.00', '0', '556735.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2916, '391757226558371', '1515783136', '650', NULL, '', '3.00', '4555.00', '4555', '13665.00', '0.00', '', '0.00', '0', '556735.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2915, '432554911279784', '1515783136', '316', NULL, '', '2.00', '9455.00', '6146', '18910.00', '0.00', '', '0.00', '0', '556735.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2914, '899934918568721', '1515783136', '290', NULL, '', '6.00', '9455.00', '6146', '56730.00', '0.00', '', '0.00', '0', '556735.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5035, '323362726488191', '7317298758', '295', NULL, '', '1.00', '4200.00', '3936', '4200.00', '0.00', '', '0.00', '0', '603291.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5034, '371742632423656', '7317298758', '269', NULL, '', '16.00', '150.00', '110', '2400.00', '0.00', '', '0.00', '0', '603291.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5033, '279459521497546', '7317298758', '213', NULL, '', '1.00', '200.00', '170', '200.00', '0.00', '', '0.00', '0', '603291.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5032, '126721395212958', '7317298758', '410', NULL, '', '1.00', '1700.00', '1650', '1700.00', '0.00', '', '0.00', '0', '603291.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5031, '938682651594129', '7317298758', '649', NULL, '', '4.00', '3000.00', '2961', '12000.00', '0.00', '', '0.00', '0', '603291.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2927, '269453764413728', '3487797747', '658', NULL, '', '1.00', '29500.00', '45755', '29500.00', '0.00', '', NULL, '0', '215050.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2928, '672318165517436', '3487797747', '656', NULL, '', '1.00', '21500.00', '32455', '21500.00', '0.00', '', NULL, '0', '215050.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2929, '288414135415751', '3487797747', '8', NULL, '', '20.00', '575.00', '550', '11500.00', '0.00', '', NULL, '0', '215050.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2930, '813792537481489', '3487797747', '794', NULL, '', '2.00', '150.00', '140', '300.00', '0.00', '', NULL, '0', '215050.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2931, '929298433831958', '3487797747', '9', NULL, '', '24.00', '450.00', '430', '10800.00', '0.00', '', NULL, '0', '215050.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2932, '653178186592337', '2767374889', '650', NULL, '', '12.00', '4555.00', '4555', '54660.00', '0.00', '', NULL, '0', '410427.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2933, '593185546427885', '2767374889', '649', NULL, '', '13.00', '4555.00', '4555', '59215.00', '0.00', '', NULL, '0', '410427.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2934, '352489746846374', '4739166969', '649', NULL, '', '1.00', '3000.00', '4555', '3000.00', '0.00', '', NULL, '0', '382760.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (2935, '597128659284969', '4739166969', '367', NULL, '', '5.00', '40.00', '30', '200.00', '0.00', '', NULL, '0', '382760.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3101, '796597288491411', '3655828734', '678', NULL, '', '4.00', '350.00', '286', '1400.00', '0.00', '', '0.00', '0', '33140.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3685, '374793923914651', '3978355951', '68', NULL, '', '3.00', '2500.00', '2600', '7500.00', '0.00', '', '0.00', '0', '53600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3684, '625269563712637', '3978355951', '69', NULL, '', '1.00', '5500.00', '5200', '5500.00', '0.00', '', '0.00', '0', '53600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3683, '914169946362175', '3978355951', '693', NULL, '', '6.00', '150.00', '130', '900.00', '0.00', '', '0.00', '0', '53600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3469, '284225777813213', '2744992295', '680', NULL, '', '1.00', '350.00', '336', '350.00', '0.00', '', '0.00', '0', '30720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3498, '224136533383324', '7214457359', '806', NULL, '', '3.00', '700.00', '700', '2100.00', '0.00', '', '0.00', '0', '32136.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3244, '883932682851688', '9845441218', '404', NULL, '', '1.00', '130.00', '125', '130.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3243, '289216357958574', '9845441218', '718', NULL, '', '6.00', '250.00', '220', '1500.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3272, '974299954694496', '9845441218', '', NULL, '', '1.00', '0.00', '0', '0.00', '0.00', '', '0.00', '0', '32950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3291, '936236845688339', '8588781131', '625', NULL, '', '3.00', '50.00', '41', '150.00', '0.00', '', '0.00', '0', '47930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3292, '884653577637635', '8588781131', '263', NULL, '', '1.00', '550.00', '350', '550.00', '0.00', '', '0.00', '0', '47930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3307, '886158396678953', '2737884135', '829', NULL, '', '52.00', '280.00', '280', '14560.00', '0.00', '', '0.00', '0', '55589.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3308, '241416937285592', '2737884135', '54', NULL, '', '2.00', '350.00', '255', '700.00', '0.00', '', '0.00', '0', '55589.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3309, '163889452931768', '2737884135', '705', NULL, '', '9.00', '280.00', '250', '2520.00', '0.00', '', '0.00', '0', '55589.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3441, '662197688337979', '1115919194', '284', NULL, '', '10.00', '40.00', '40', '400.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3440, '427785645171127', '1115919194', '373', NULL, '', '15.00', '20.00', '17', '300.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3467, '268548365579812', '1115919194', '378', NULL, '', '2.00', '25.00', '20', '50.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3468, '212358946895563', '1115919194', '833', NULL, '', '4.00', '40.00', '25', '160.00', '0.00', '', '0.00', '0', '127105.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3488, '988238159797145', '2744992295', '381', NULL, '', '1.00', '50.00', '34', '50.00', '0.00', '', '0.00', '0', '30720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3489, '267553328747364', '2744992295', '836', NULL, '', '4.00', '30.00', '30', '120.00', '0.00', '', '0.00', '0', '30720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3490, '634129275874483', '2744992295', '373', NULL, '', '13.00', '10.00', '17', '130.00', '0.00', '', '0.00', '0', '30720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3491, '346934989485629', '2744992295', '380', NULL, '', '1.00', '50.00', '25', '50.00', '0.00', '', '0.00', '0', '30720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3492, '897851911683832', '2744992295', '833', NULL, '', '1.00', '30.00', '25', '30.00', '0.00', '', '0.00', '0', '30720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3493, '136758835627217', '2744992295', '776', NULL, '', '2.00', '550.00', '486', '1100.00', '0.00', '', '0.00', '0', '30720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3497, '736314331314165', '5323971621', '382', NULL, '', '3.00', '70.00', '46', '210.00', '0.00', '', '0.00', '0', '1710.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3525, '154974544644831', '7567791142', '370', NULL, '', '20.00', '20.00', '22', '400.00', '0.00', '', '0.00', '0', '2900.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4499, '844197565853487', '1999134661', '855', NULL, '', '1.00', '300.00', '285', '300.00', '0.00', '', '0.00', '0', '28450.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4498, '848959781841795', '1999134661', '856', NULL, '', '1.00', '500.00', '480', '500.00', '0.00', '', '0.00', '0', '28450.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4497, '258282175126248', '1999134661', '700', NULL, '', '9.00', '180.00', '160', '1620.00', '0.00', '', '0.00', '0', '28450.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4496, '138569799152986', '1999134661', '495', NULL, '', '1.00', '780.00', '650', '780.00', '0.00', '', '0.00', '0', '28450.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4495, '828444261515491', '1999134661', '382', NULL, '', '6.00', '390.00', '46', '2340.00', '0.00', '', '0.00', '0', '28450.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4494, '641786537374195', '1999134661', '61', NULL, '', '3.00', '170.00', '160', '510.00', '0.00', '', '0.00', '0', '28450.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4493, '894151419527367', '1999134661', '372', NULL, '', '4.00', '50.00', '40', '200.00', '0.00', '', '0.00', '0', '28450.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4492, '699696385338563', '1999134661', '707', NULL, '', '1.00', '150.00', '150', '150.00', '0.00', '', '0.00', '0', '28450.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4491, '115414171784274', '1999134661', '841', NULL, '', '1.00', '50.00', '25', '50.00', '0.00', '', '0.00', '0', '28450.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4490, '925288374939573', '1999134661', '604', NULL, '', '16.00', '155.00', '175', '2480.00', '0.00', '', '0.00', '0', '28450.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4489, '477976149545554', '1999134661', '17', NULL, '', '14.00', '155.00', '180', '2170.00', '0.00', '', '0.00', '0', '28450.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4488, '997282725739821', '1999134661', '794', NULL, '', '50.00', '135.00', '140', '6750.00', '0.00', '', '0.00', '0', '28450.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4487, '776683776747472', '1999134661', '181', NULL, '', '16.00', '180.00', '165', '2880.00', '0.00', '', '0.00', '0', '28450.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4486, '392938682987641', '1999134661', '179', NULL, '', '40.00', '40.00', '36', '1600.00', '0.00', '', '0.00', '0', '28450.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4485, '711675998645998', '1999134661', '175', NULL, '', '6.00', '180.00', '125', '1080.00', '0.00', '', '0.00', '0', '28450.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4484, '514457265981741', '1999134661', '176', NULL, '', '3.00', '120.00', '65', '360.00', '0.00', '', '0.00', '0', '28450.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4483, '965535389582565', '1999134661', '177', NULL, '', '2.00', '240.00', '165', '480.00', '0.00', '', '0.00', '0', '28450.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4482, '779615747332821', '1999134661', '178', NULL, '', '3.00', '180.00', '80', '540.00', '0.00', '', '0.00', '0', '28450.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4481, '647266371317971', '1999134661', '374', NULL, '', '4.00', '50.00', '40', '200.00', '0.00', '', '0.00', '0', '28450.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4480, '928465736472563', '1999134661', '845', NULL, '', '1.00', '850.00', '850', '850.00', '0.00', '', '0.00', '0', '28450.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4479, '893712435472574', '1999134661', '846', NULL, '', '1.00', '50.00', '50', '50.00', '0.00', '', '0.00', '0', '28450.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4478, '689973943144719', '1999134661', '29', NULL, '', '4.00', '60.00', '40', '240.00', '0.00', '', '0.00', '0', '28450.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4477, '664752638986891', '1999134661', '422', NULL, '', '26.00', '60.00', '30', '1560.00', '0.00', '', '0.00', '0', '28450.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3816, '979966358885744', '5892378914', '656', NULL, '', '1.00', '21000.00', '32455', '21000.00', '0.00', '', '0.00', '0', '290530.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3815, '463537658983141', '5892378914', '657', NULL, '', '2.00', '21000.00', '32455', '42000.00', '0.00', '', '0.00', '0', '290530.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3825, '674313213175169', '3529147678', '109', NULL, '', '1.00', '620.00', '600', '620.00', '0.00', '', '0.00', '0', '202852.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3824, '433516216338418', '3529147678', '121', NULL, '', '1.00', '300.00', '300', '300.00', '0.00', '', '0.00', '0', '202852.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3823, '211572196218538', '3529147678', '277', NULL, '', '1.00', '240.00', '240', '240.00', '0.00', '', '0.00', '0', '202852.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3822, '265239622335285', '3529147678', '275', NULL, '', '2.00', '140.00', '100', '280.00', '0.00', '', '0.00', '0', '202852.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3821, '965692776825242', '3529147678', '89', NULL, '', '2.00', '320.00', '280', '640.00', '0.00', '', '0.00', '0', '202852.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3820, '414336244596522', '3529147678', '494', NULL, '', '2.00', '320.00', '290', '640.00', '0.00', '', '0.00', '0', '202852.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3819, '883449453686961', '3529147678', '1', NULL, '', '2.00', '440.00', '370', '880.00', '0.00', '', '0.00', '0', '202852.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3818, '111671789315193', '3529147678', '810', NULL, '', '40.00', '105.00', '103', '4200.00', '0.00', '', '0.00', '0', '202852.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3567, '279188835179236', '3213317312', '295', NULL, '', '1.00', '4200.00', '3936', '4200.00', '0.00', '', '0.00', '0', '620541.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3566, '164482321275168', '3213317312', '650', NULL, '', '2.00', '3000.00', '4555', '6000.00', '0.00', '', '0.00', '0', '620541.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3565, '668127427381249', '3213317312', '649', NULL, '', '2.00', '3000.00', '4555', '6000.00', '0.00', '', '0.00', '0', '620541.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3568, '831619292292823', '3213317312', '35', NULL, '', '3.00', '350.00', '542.5', '1050.00', '0.00', '', '0.00', '0', '620541.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3569, '491568893552148', '2152271745', '650', NULL, '', '10.00', '4555.00', '4555', '45550.00', '0.00', '', NULL, '0', '455522.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3570, '255638233252554', '2152271745', '654', NULL, '', '2.00', '4555.00', '4555', '9110.00', '0.00', '', NULL, '0', '455522.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3571, '856944974219693', '2152271745', '649', NULL, '', '3.00', '4555.00', '4555', '13665.00', '0.00', '', NULL, '0', '455522.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3572, '584652735925637', '6726515132', '294', NULL, '', '2.00', '7250.00', '7121', '14500.00', '0.00', '', NULL, '0', '47630.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4505, '455254926785567', '3798734435', '383', NULL, '', '1.00', '50.00', '30', '50.00', '0.00', '', '0.00', '0', '1640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4504, '872713431439812', '3798734435', '835', NULL, '', '2.00', '50.00', '50', '100.00', '0.00', '', '0.00', '0', '1640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4503, '756638627946935', '3798734435', '380', NULL, '', '1.00', '50.00', '25', '50.00', '0.00', '', '0.00', '0', '1640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4502, '713422137479235', '3798734435', '837', NULL, '', '6.00', '90.00', '70', '540.00', '0.00', '', '0.00', '0', '1640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4501, '318281312354916', '3798734435', '833', NULL, '', '1.00', '50.00', '25', '50.00', '0.00', '', '0.00', '0', '1640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4514, '358584272163848', '1995273414', '842', NULL, '', '2.00', '50.00', '25', '100.00', '0.00', '', '0.00', '0', '4550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4513, '477524161127257', '1995273414', '693', NULL, '', '5.00', '200.00', '130', '1000.00', '0.00', '', '0.00', '0', '4550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4512, '421656465611333', '1995273414', '270', NULL, '', '10.00', '130.00', '160', '1300.00', '0.00', '', '0.00', '0', '4550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4511, '949493386751775', '1995273414', '217', NULL, '', '1.00', '200.00', '180', '200.00', '0.00', '', '0.00', '0', '4550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4510, '971818729724584', '1995273414', '89', NULL, '', '2.00', '275.00', '280', '550.00', '0.00', '', '0.00', '0', '4550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4509, '638875183845638', '1995273414', '494', NULL, '', '2.00', '275.00', '290', '550.00', '0.00', '', '0.00', '0', '4550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4508, '821534853428673', '1995273414', '380', NULL, '', '1.00', '50.00', '25', '50.00', '0.00', '', '0.00', '0', '4550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4507, '587681535286371', '1995273414', '9', NULL, '', '1.00', '450.00', '430', '450.00', '0.00', '', '0.00', '0', '4550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4506, '658458695596587', '1995273414', '699', NULL, '', '1.00', '350.00', '320', '350.00', '0.00', '', '0.00', '0', '4550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4500, '489185572687791', '3798734435', '236', NULL, '', '1.00', '850.00', '920', '850.00', '0.00', '', '0.00', '0', '1640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3598, '662243821593289', '5218857126', '847', NULL, '', '1.00', '1500.00', '900', '1500.00', '0.00', '', NULL, '0', '362800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3639, '794767967883237', '9793391551', '766', NULL, '', '1.00', '2700.00', '2700', '2700.00', '0.00', '', '0.00', '0', '42705.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3657, '625422485188148', '9793391551', '785', NULL, '', '5.00', '250.00', '175', '1250.00', '0.00', '', '0.00', '0', '42705.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4476, '464488546366821', '1999134661', '421', NULL, '', '4.00', '70.00', '36', '280.00', '0.00', '', '0.00', '0', '28450.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4475, '426197554419187', '1999134661', '489', NULL, '', '2.00', '240.00', '125', '480.00', '0.00', '', '0.00', '0', '28450.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3702, '253695199115657', '3978355951', '398', NULL, '', '4.00', '525.00', '486', '2100.00', '0.00', '', '0.00', '0', '53600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3703, '672229731845577', '3978355951', '399', NULL, '', '2.00', '350.00', '287', '700.00', '0.00', '', '0.00', '0', '53600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3704, '546294779898751', '3978355951', '855', NULL, '', '2.00', '350.00', '285', '700.00', '0.00', '', '0.00', '0', '53600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3719, '651985122522955', '2943739531', '300', NULL, '', '1.00', '9200.00', '8707', '9200.00', '0.00', '', '0.00', '0', '485891.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3722, '672835326965324', '2943739531', '331', NULL, '', '1.00', '11700.00', '11671', '11700.00', '0.00', '', '0.00', '0', '485891.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3723, '395616497321899', '2943739531', '332', NULL, '', '2.00', '11700.00', '11671', '23400.00', '0.00', '', '0.00', '0', '485891.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3760, '496854587562674', '1181438141', '398', NULL, '', '5.00', '600.00', '486', '3000.00', '0.00', '', '0.00', '0', '16500.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3759, '181146613692794', '1181438141', '697', NULL, '', '3.00', '400.00', '400', '1200.00', '0.00', '', '0.00', '0', '16500.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3758, '347191645958821', '1181438141', '213', NULL, '', '1.00', '250.00', '170', '250.00', '0.00', '', '0.00', '0', '16500.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3763, '169413862194443', '1181438141', '679', NULL, '', '7.00', '300.00', '259', '2100.00', '0.00', '', '0.00', '0', '16500.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3764, '554327752536635', '1181438141', '678', NULL, '', '7.00', '350.00', '286', '2450.00', '0.00', '', '0.00', '0', '16500.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3784, '142882944534191', '3653113769', '283', NULL, '', '1.00', '50.00', '30', '50.00', '0.00', '', '0.00', '0', '4700.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3783, '282886898689884', '3653113769', '724', NULL, '', '1.00', '300.00', '240', '300.00', '0.00', '', '0.00', '0', '4700.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3782, '429774635853131', '3653113769', '263', NULL, '', '1.00', '450.00', '350', '450.00', '0.00', '', '0.00', '0', '4700.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3781, '578734497189248', '3653113769', '12', NULL, '', '5.00', '130.00', '135', '650.00', '0.00', '', '0.00', '0', '4700.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3780, '813336428595322', '3653113769', '625', NULL, '', '2.00', '50.00', '41', '100.00', '0.00', '', '0.00', '0', '4700.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3779, '324611764723655', '3653113769', '835', NULL, '', '3.00', '50.00', '50', '150.00', '0.00', '', '0.00', '0', '4700.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3778, '592547434717853', '3653113769', '600', NULL, '', '2.00', '50.00', '221', '100.00', '0.00', '', '0.00', '0', '4700.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3777, '381683883485336', '3653113769', '218', NULL, '', '1.00', '200.00', '170', '200.00', '0.00', '', '0.00', '0', '4700.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3776, '464945889477967', '3653113769', '221', NULL, '', '1.00', '700.00', '500', '700.00', '0.00', '', '0.00', '0', '4700.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3775, '913719463469915', '3653113769', '402', NULL, '', '5.00', '350.00', '250', '1750.00', '0.00', '', '0.00', '0', '4700.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3785, '241923615225481', '3653113769', '860', NULL, '', '1.00', '250.00', '170', '250.00', '0.00', '', '0.00', '0', '4700.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3786, '435928884963772', '3286836845', '861', NULL, '', '12.00', '430.00', '450', '5160.00', '0.00', '', NULL, '0', '22940.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3787, '872686237739974', '3286836845', '855', NULL, '', '20.00', '250.00', '285', '5000.00', '0.00', '', NULL, '0', '22940.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3788, '387261591488494', '3286836845', '854', NULL, '', '3.00', '280.00', '290', '840.00', '0.00', '', NULL, '0', '22940.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3789, '235971489887145', '3286836845', '700', NULL, '', '36.00', '150.00', '160', '5400.00', '0.00', '', NULL, '0', '22940.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3790, '356366716971795', '3286836845', '495', NULL, '', '1.00', '780.00', '650', '780.00', '0.00', '', NULL, '0', '22940.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3791, '125882999331613', '3286836845', '600', NULL, '', '8.00', '50.00', '221', '400.00', '0.00', '', NULL, '0', '22940.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3792, '139496713796522', '3286836845', '862', NULL, '', '4.00', '190.00', '155', '760.00', '0.00', '', NULL, '0', '22940.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3793, '128145263358787', '3286836845', '863', NULL, '', '3.00', '400.00', '347', '1200.00', '0.00', '', NULL, '0', '22940.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3794, '727186761784724', '3286836845', '219', NULL, '', '1.00', '400.00', '380', '400.00', '0.00', '', NULL, '0', '22940.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3795, '489725815872945', '3286836845', '220', NULL, '', '15.00', '200.00', '180', '3000.00', '0.00', '', NULL, '0', '22940.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3796, '994287636275353', '4247543232', '859', NULL, '', '2.00', '16000.00', '14200', '32000.00', '0.00', '', NULL, '0', '1341770.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6213, '998278279353186', '9652589483', '817', NULL, '', '3.00', '8300.00', '6300', '24900.00', '0.00', '', '0.00', '0', '1379570.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6212, '773991513393645', '9652589483', '816', NULL, '', '2.00', '6300.00', '5300', '12600.00', '0.00', '', '0.00', '0', '1379570.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3799, '339255152623645', '3755764352', '818', NULL, '', '12.00', '780.00', '484', '9360.00', '0.00', '', NULL, '0', '1388630.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3800, '563262188756618', '7279214426', '826', NULL, '', '1.00', '13400.00', '10000', '13400.00', '0.00', '', NULL, '0', '1402030.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3801, '823278586837432', '2181869592', '311', NULL, '', '6.00', '3050.00', '2961', '18300.00', '0.00', '', NULL, '0', '95530.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3802, '436818465412183', '2181869592', '649', NULL, '', '6.00', '3050.00', '4555', '18300.00', '0.00', '', NULL, '0', '95530.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3803, '412526727668331', '2181869592', '141', NULL, '', '1.00', '9800.00', '6146', '9800.00', '0.00', '', NULL, '0', '95530.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3804, '998581816258673', '2181869592', '577', NULL, '', '1.00', '1500.00', '1250', '1500.00', '0.00', '', NULL, '0', '95530.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3805, '215533965547144', '2433914368', '825', NULL, '', '100.00', '115.00', '115', '11500.00', '0.00', '', NULL, '0', '572655.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3806, '994743138654272', '2433914368', '494', NULL, '', '1.00', '320.00', '290', '320.00', '0.00', '', NULL, '0', '572655.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3807, '657497396262432', '2433914368', '323', NULL, '', '1.00', '4100.00', '4092', '4100.00', '0.00', '', NULL, '0', '572655.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5040, '675792153635682', '3718624612', '335', NULL, '', '1.00', '2500.00', '2376', '2500.00', '0.00', '', '0.00', '0', '76670.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5039, '873752529483395', '3718624612', '336', NULL, '', '1.00', '2500.00', '2376', '2500.00', '0.00', '', '0.00', '0', '76670.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5038, '212645116299526', '3718624612', '333', NULL, '', '1.00', '16000.00', '16689', '16000.00', '0.00', '', '0.00', '0', '76670.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5037, '231376458517134', '3718624612', '490', NULL, '', '2.00', '250.00', '85', '500.00', '0.00', '', '0.00', '0', '76670.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5036, '412189729576894', '3718624612', '213', NULL, '', '2.00', '200.00', '170', '400.00', '0.00', '', '0.00', '0', '76670.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3817, '712973823345759', '5892378914', '866', NULL, '', '104.00', '120.00', '120', '12480.00', '0.00', '', '0.00', '0', '290530.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3826, '591491858566989', '3529147678', '99', NULL, '', '1.00', '360.00', '360', '360.00', '0.00', '', '0.00', '0', '202852.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3827, '922367277267493', '2625175392', '238', NULL, '', '1.00', '350.00', '320', '350.00', '0.00', '', NULL, '0', '10050.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3828, '122382454468617', '2625175392', '247', NULL, '', '1.00', '600.00', '650', '600.00', '0.00', '', NULL, '0', '10050.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3829, '797385769873332', '2625175392', '366', NULL, '', '1.00', '70.00', '46', '70.00', '0.00', '', NULL, '0', '10050.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3830, '312299674485919', '2625175392', '365', NULL, '', '1.00', '80.00', '70', '80.00', '0.00', '', NULL, '0', '10050.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3831, '698976522292569', '2625175392', '92', NULL, '', '4.00', '240.00', '260', '960.00', '0.00', '', NULL, '0', '10050.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3832, '298255112733783', '2625175392', '68', NULL, '', '1.00', '2500.00', '2600', '2500.00', '0.00', '', NULL, '0', '10050.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3833, '719669255964164', '2625175392', '78', NULL, '', '1.00', '150.00', '160', '150.00', '0.00', '', NULL, '0', '10050.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3834, '684925244691759', '2625175392', '379', NULL, '', '10.00', '30.00', '25', '300.00', '0.00', '', NULL, '0', '10050.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3835, '245565684352168', '2625175392', '363', NULL, '', '1.00', '350.00', '320', '350.00', '0.00', '', NULL, '0', '10050.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3836, '721257818555118', '2625175392', '238', NULL, '', '8.00', '330.00', '320', '2640.00', '0.00', '', NULL, '0', '10050.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3837, '142222852462424', '2625175392', '833', NULL, '', '8.00', '35.00', '25', '280.00', '0.00', '', NULL, '0', '10050.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3838, '277878916714867', '2625175392', '171', NULL, '', '3.00', '480.00', '300', '1440.00', '0.00', '', NULL, '0', '10050.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3839, '315775356458325', '2625175392', '834', NULL, '', '1.00', '50.00', '75', '50.00', '0.00', '', NULL, '0', '10050.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3840, '328287328436172', '2625175392', '374', NULL, '', '2.00', '40.00', '40', '80.00', '0.00', '', NULL, '0', '10050.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (3841, '275397486693735', '2625175392', '860', NULL, '', '1.00', '200.00', '170', '200.00', '0.00', '', NULL, '0', '10050.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4522, '828773176716421', '6637133796', '61', NULL, '', '1.00', '200.00', '160', '200.00', '0.00', '', '0.00', '0', '4000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4521, '427443134265586', '6637133796', '235', NULL, '', '1.00', '1250.00', '1100', '1250.00', '0.00', '', '0.00', '0', '4000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4520, '229434526673348', '6637133796', '693', NULL, '', '3.00', '150.00', '130', '450.00', '0.00', '', '0.00', '0', '4000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4519, '599391927125795', '6637133796', '57', NULL, '', '1.00', '150.00', '140', '150.00', '0.00', '', '0.00', '0', '4000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4535, '111263227671427', '1371539249', '374', NULL, '', '1.00', '50.00', '40', '50.00', '0.00', '', '0.00', '0', '7840.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4534, '461223461884746', '1371539249', '370', NULL, '', '30.00', '30.00', '22', '900.00', '0.00', '', '0.00', '0', '7840.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4533, '567634876556538', '1371539249', '835', NULL, '', '1.00', '90.00', '50', '90.00', '0.00', '', '0.00', '0', '7840.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4532, '529122235912629', '1371539249', '91', NULL, '', '1.00', '50.00', '540', '50.00', '0.00', '', '0.00', '0', '7840.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4531, '696141789574669', '1371539249', '179', NULL, '', '3.00', '40.00', '36', '120.00', '0.00', '', '0.00', '0', '7840.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4530, '538415389199167', '1371539249', '57', NULL, '', '12.00', '120.00', '140', '1440.00', '0.00', '', '0.00', '0', '7840.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4529, '588197836497872', '1371539249', '490', NULL, '', '12.00', '120.00', '90', '1440.00', '0.00', '', '0.00', '0', '7840.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4528, '374852411441973', '1371539249', '196', NULL, '', '1.00', '400.00', '380', '400.00', '0.00', '', '0.00', '0', '7840.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4527, '464579694195238', '1371539249', '100', NULL, '', '5.00', '300.00', '300', '1500.00', '0.00', '', '0.00', '0', '7840.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4526, '699537435288358', '1371539249', '837', NULL, '', '10.00', '90.00', '70', '900.00', '0.00', '', '0.00', '0', '7840.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4525, '523831283727923', '1371539249', '718', NULL, '', '2.00', '250.00', '220', '500.00', '0.00', '', '0.00', '0', '7840.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4524, '864734345696718', '1371539249', '713', NULL, '', '1.00', '350.00', '310', '350.00', '0.00', '', '0.00', '0', '7840.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4559, '754782319862474', '4738635783', '490', NULL, '', '1.00', '150.00', '90', '150.00', '0.00', '', '0.00', '0', '25100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4558, '195511627411255', '4738635783', '378', NULL, '', '1.00', '50.00', '20', '50.00', '0.00', '', '0.00', '0', '25100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4557, '883669856855175', '4738635783', '225', NULL, '', '1.00', '500.00', '480', '500.00', '0.00', '', '0.00', '0', '25100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4556, '981244689876573', '4738635783', '379', NULL, '', '4.00', '30.00', '25', '120.00', '0.00', '', '0.00', '0', '25100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4555, '422672598492532', '4738635783', '381', NULL, '', '7.00', '40.00', '34', '280.00', '0.00', '', '0.00', '0', '25100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4554, '959419497811459', '4738635783', '892', NULL, '', '30.00', '150.00', '150', '4500.00', '0.00', '', '0.00', '0', '25100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4553, '275614945484161', '4738635783', '578', NULL, '', '1.00', '2100.00', '2000', '2100.00', '0.00', '', '0.00', '0', '25100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4552, '141367765327776', '4738635783', '8', NULL, '', '12.00', '530.00', '550', '6360.00', '0.00', '', '0.00', '0', '25100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4551, '848548451825932', '4738635783', '374', NULL, '', '3.00', '50.00', '40', '150.00', '0.00', '', '0.00', '0', '25100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4550, '923335329467534', '4738635783', '248', NULL, '', '1.00', '400.00', '320', '400.00', '0.00', '', '0.00', '0', '25100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4549, '846669588224867', '4738635783', '842', NULL, '', '1.00', '50.00', '25', '50.00', '0.00', '', '0.00', '0', '25100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4548, '369888114217343', '4738635783', '382', NULL, '', '7.00', '70.00', '46', '490.00', '0.00', '', '0.00', '0', '25100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4547, '799974268991687', '4738635783', '700', NULL, '', '6.00', '160.00', '160', '960.00', '0.00', '', '0.00', '0', '25100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4546, '955687611816378', '4738635783', '843', NULL, '', '6.00', '15.00', '13', '90.00', '0.00', '', '0.00', '0', '25100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4545, '935871562549375', '4738635783', '715', NULL, '', '4.00', '120.00', '120', '480.00', '0.00', '', '0.00', '0', '25100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4544, '756947393331947', '4738635783', '856', NULL, '', '1.00', '500.00', '480', '500.00', '0.00', '', '0.00', '0', '25100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4543, '754641524724232', '4738635783', '887', NULL, '', '1.00', '350.00', '297', '350.00', '0.00', '', '0.00', '0', '25100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4248, '268966757979164', '8143852489', '914', NULL, '', '4.00', '160.00', '90', '640.00', '0.00', '', '0.00', '0', '20145.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4247, '568612184862511', '8143852489', '913', NULL, '', '2.00', '150.00', '80', '300.00', '0.00', '', '0.00', '0', '20145.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4246, '255451594898256', '8143852489', '55', NULL, '', '5.00', '300.00', '280', '1500.00', '0.00', '', '0.00', '0', '20145.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4245, '184451847777782', '8143852489', '810', NULL, '', '5.00', '120.00', '103', '600.00', '0.00', '', '0.00', '0', '20145.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4244, '812128251966938', '8143852489', '900', NULL, '', '2.00', '1400.00', '1350', '2800.00', '0.00', '', '0.00', '0', '20145.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4243, '243868186736168', '8143852489', '842', NULL, '', '1.00', '50.00', '25', '50.00', '0.00', '', '0.00', '0', '20145.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4242, '727366459375593', '8143852489', '449', NULL, '', '3.00', '120.00', '90', '360.00', '0.00', '', '0.00', '0', '20145.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4241, '149347669581948', '8143852489', '843', NULL, '', '3.00', '15.00', '13', '45.00', '0.00', '', '0.00', '0', '20145.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4240, '166944252783611', '8143852489', '234', NULL, '', '1.00', '900.00', '920', '900.00', '0.00', '', '0.00', '0', '20145.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4239, '313263537659969', '8143852489', '102', NULL, '', '2.00', '400.00', '450', '800.00', '0.00', '', '0.00', '0', '20145.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4238, '945336386272916', '8143852489', '715', NULL, '', '10.00', '125.00', '120', '1250.00', '0.00', '', '0.00', '0', '20145.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4237, '315272199323169', '8143852489', '380', NULL, '', '1.00', '50.00', '25', '50.00', '0.00', '', '0.00', '0', '20145.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4236, '121586994143149', '8143852489', '218', NULL, '', '1.00', '200.00', '170', '200.00', '0.00', '', '0.00', '0', '20145.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4235, '155431559124575', '8143852489', '224', NULL, '', '1.00', '800.00', '550', '800.00', '0.00', '', '0.00', '0', '20145.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4234, '753121923968445', '8143852489', '600', NULL, '', '3.00', '50.00', '221', '150.00', '0.00', '', '0.00', '0', '20145.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4233, '383523648386586', '8143852489', '374', NULL, '', '3.00', '50.00', '40', '150.00', '0.00', '', '0.00', '0', '20145.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4464, '122574539721348', '1797695428', '697', NULL, '', '4.00', '435.00', '400', '1740.00', '0.00', '', NULL, '0', '14550.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4463, '291925436289828', '9445627595', '920', NULL, '', '2.00', '30.00', '20', '60.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4462, '113593123234453', '9445627595', '382', NULL, '', '2.00', '70.00', '46', '140.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4461, '558793831749253', '9445627595', '102', NULL, '', '1.00', '300.00', '450', '300.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4460, '711137118416998', '9445627595', '489', NULL, '', '1.00', '120.00', '125', '120.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4459, '384145454747676', '9445627595', '175', NULL, '', '1.00', '120.00', '125', '120.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4458, '143872589813661', '9445627595', '913', NULL, '', '1.00', '120.00', '80', '120.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4457, '347177313323434', '9445627595', '912', NULL, '', '1.00', '100.00', '70', '100.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4456, '833827461923969', '9445627595', '60', NULL, '', '1.00', '200.00', '200', '200.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4455, '722727441499376', '9445627595', '834', NULL, '', '1.00', '120.00', '75', '120.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4454, '813482115937234', '9445627595', '121', NULL, '', '2.00', '320.00', '300', '640.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4453, '872558952554148', '9445627595', '837', NULL, '', '6.00', '90.00', '70', '540.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4452, '723948738452494', '9445627595', '667', NULL, '', '1.00', '4600.00', '6445', '4600.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4451, '877657582538482', '9445627595', '247', NULL, '', '1.00', '1500.00', '650', '1500.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4450, '372969348588253', '9445627595', '372', NULL, '', '10.00', '50.00', '40', '500.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4449, '651324988398899', '9445627595', '829', NULL, '', '12.00', '300.00', '280', '3600.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4448, '586865942749432', '9445627595', '322', NULL, '', '1.00', '14500.00', '14986', '14500.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4447, '571678869757444', '9445627595', '1', NULL, '', '3.00', '440.00', '370', '1320.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4446, '484426447166739', '9445627595', '86', NULL, '', '3.00', '430.00', '390', '1290.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4445, '253838578854541', '9445627595', '89', NULL, '', '3.00', '320.00', '280', '960.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4444, '599799357517661', '9445627595', '494', NULL, '', '3.00', '300.00', '290', '900.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4443, '171482542851551', '9445627595', '109', NULL, '', '2.00', '600.00', '600', '1200.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4442, '717764536933665', '9445627595', '492', NULL, '', '4.00', '260.00', '235', '1040.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4441, '826347615853933', '9445627595', '122', NULL, '', '2.00', '300.00', '340', '600.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4440, '831545863423336', '9445627595', '711', NULL, '', '24.00', '66.00', '62', '1584.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4439, '872331538734748', '9445627595', '101', NULL, '', '2.00', '600.00', '550', '1200.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4438, '632772497579742', '9445627595', '723', NULL, '', '1.00', '220.00', '200', '220.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4437, '739344672345248', '9445627595', '501', NULL, '', '1.00', '250.00', '240', '250.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4436, '336846341981847', '9445627595', '794', NULL, '', '2.00', '150.00', '140', '300.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4431, '324899338555659', '9445627595', '374', NULL, '', '2.00', '50.00', '40', '100.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4432, '764135212143994', '9445627595', '883', NULL, '', '2.00', '500.00', '460', '1000.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4433, '721689394488644', '9445627595', '886', NULL, '', '2.00', '300.00', '277', '600.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4434, '981452174519881', '9445627595', '74', NULL, '', '1.00', '7000.00', '6500', '7000.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4435, '652367993956157', '9445627595', '715', NULL, '', '1.00', '130.00', '120', '130.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4430, '736969581778353', '9445627595', '381', NULL, '', '9.00', '50.00', '34', '450.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5420, '847453374936654', '9123418226', '648', NULL, '', '22.00', '380.00', '300', '8360.00', '0.00', '', '0.00', '0', '1410390.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4074, '781522139365955', '2968542394', '311', NULL, '', '1.00', '3000.00', '2961', '3000.00', '0.00', '', NULL, '0', '697666.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4075, '429913341412625', '2968542394', '142', NULL, '', '1.00', '6400.00', '6146', '6400.00', '0.00', '', NULL, '0', '697666.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4076, '887641785831816', '2968542394', '322', NULL, '', '2.00', '16000.00', '14986', '32000.00', '0.00', '', NULL, '0', '697666.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4077, '974141945961898', '2968542394', '715', NULL, '', '5.00', '125.00', '120', '625.00', '0.00', '', NULL, '0', '697666.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5045, '599276752218699', '6863289674', '96', NULL, '', '6.00', '260.00', '260', '1560.00', '0.00', '', '0.00', '0', '207592.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5044, '475186167313479', '6863289674', '866', NULL, '', '3.00', '140.00', '120', '420.00', '0.00', '', '0.00', '0', '207592.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5043, '549715153224249', '6863289674', '264', NULL, '', '3.00', '120.00', '80', '360.00', '0.00', '', '0.00', '0', '207592.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5042, '632696489187227', '6863289674', '127', NULL, '', '2.00', '360.00', '400', '720.00', '0.00', '', '0.00', '0', '207592.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5041, '612912664746414', '6863289674', '121', NULL, '', '1.00', '300.00', '300', '300.00', '0.00', '', '0.00', '0', '207592.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5049, '178433779764785', '5225826333', '322', NULL, '', '1.00', '14500.00', '14986', '14500.00', '0.00', '', '0.00', '0', '41120.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4728, '917289258439853', '6333182967', '57', NULL, '', '0.00', '0.00', '140', '0.00', '0.00', '', '0.00', '0', '26620.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5051, '191955335333225', '2839568685', '758', NULL, '', '3.00', '1400.00', '1100', '4200.00', '0.00', '', '0.00', '0', '296530.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5050, '361171293234135', '2839568685', '794', NULL, '', '10.00', '150.00', '140', '1500.00', '0.00', '', '0.00', '0', '296530.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5144, '757399528348284', '5543697839', '177', NULL, '', '3.00', '250.00', '165', '750.00', '0.00', '', '0.00', '0', '465790.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5143, '781497131252897', '5543697839', '994', NULL, '', '100.00', '300.00', '165', '30000.00', '0.00', '', '0.00', '0', '465790.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5140, '298797253625564', '8614186355', '787', NULL, '', '40.00', '33.00', '25', '1320.00', '0.00', '', '0.00', '0', '221172.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5131, '137579135328735', '7976169977', '297', NULL, '', '1.00', '16000.00', '15761', '16000.00', '0.00', '', '0.00', '0', '162266.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5130, '778142879313723', '7976169977', '154', NULL, '', '1.00', '2350.00', '2292', '2350.00', '0.00', '', '0.00', '0', '162266.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5089, '286231353519639', '9495862115', '728', NULL, '', '3.00', '280.00', '260', '840.00', '0.00', '', '0.00', '0', '67600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5081, '228137312439362', '5725871419', '898', NULL, '', '96.00', '15.00', '5', '1440.00', '0.00', '', '0.00', '0', '246480.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5080, '693255685417494', '5725871419', '175', NULL, '', '4.00', '240.00', '125', '960.00', '0.00', '', '0.00', '0', '246480.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5079, '651882673721947', '5725871419', '208', NULL, '', '1.00', '1450.00', '1500', '1450.00', '0.00', '', '0.00', '0', '246480.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5078, '623528488694593', '5725871419', '896', NULL, '', '20.00', '4400.00', '4667', '88000.00', '0.00', '', '0.00', '0', '246480.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5077, '784845637972672', '5725871419', '897', NULL, '', '8.00', '10800.00', '10033', '86400.00', '0.00', '', '0.00', '0', '246480.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4542, '565759917583667', '4738635783', '395', NULL, '', '1.00', '50.00', '50', '50.00', '0.00', '', '0.00', '0', '25100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4541, '632825568726228', '4738635783', '396', NULL, '', '1.00', '40.00', '40', '40.00', '0.00', '', '0.00', '0', '25100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4540, '192476533756345', '4738635783', '410', NULL, '', '1.00', '1600.00', '1650', '1600.00', '0.00', '', '0.00', '0', '25100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4539, '422467982767753', '4738635783', '649', NULL, '', '1.00', '2900.00', '4555', '2900.00', '0.00', '', '0.00', '0', '25100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4538, '512617537648844', '4738635783', '311', NULL, '', '1.00', '2900.00', '2961', '2900.00', '0.00', '', '0.00', '0', '25100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4537, '419141768389386', '4738635783', '833', NULL, '', '1.00', '40.00', '25', '40.00', '0.00', '', '0.00', '0', '25100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4232, '799813378441542', '8143852489', '829', NULL, '', '4.00', '350.00', '280', '1400.00', '0.00', '', '0.00', '0', '20145.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4231, '696539322627185', '8143852489', '219', NULL, '', '1.00', '700.00', '380', '700.00', '0.00', '', '0.00', '0', '20145.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4230, '172189177968974', '8143852489', '603', NULL, '', '6.00', '350.00', '250', '2100.00', '0.00', '', '0.00', '0', '20145.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4229, '576661977334132', '8143852489', '886', NULL, '', '7.00', '350.00', '277', '2450.00', '0.00', '', '0.00', '0', '20145.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4228, '574451926912397', '8143852489', '883', NULL, '', '5.00', '550.00', '460', '2750.00', '0.00', '', '0.00', '0', '20145.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4227, '432942371487263', '8143852489', '903', NULL, '', '3.00', '50.00', '40', '150.00', '0.00', '', '0.00', '0', '20145.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4429, '173354959451873', '9445627595', '884', NULL, '', '1.00', '480.00', '452', '480.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4428, '131131743799761', '9445627595', '858', NULL, '', '2.00', '150.00', '115', '300.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4427, '279127223487875', '9445627595', '57', NULL, '', '1.00', '150.00', '140', '150.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4426, '348134615247199', '9445627595', '56', NULL, '', '2.00', '1000.00', '1000', '2000.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4425, '693442689575389', '9445627595', '479', NULL, '', '4.00', '1200.00', '1100', '4800.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4424, '514683135234519', '9445627595', '663', NULL, '', '1.00', '2100.00', '3525', '2100.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4423, '796751769296269', '9445627595', '664', NULL, '', '2.00', '2100.00', '3525', '4200.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4422, '119635962252554', '9445627595', '668', NULL, '', '1.00', '4600.00', '6445', '4600.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4421, '693864446994848', '9445627595', '4', NULL, '', '10.00', '320.00', '290', '3200.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4420, '383491938941185', '9445627595', '235', NULL, '', '4.00', '1100.00', '1100', '4400.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4419, '989545412399711', '9445627595', '902', NULL, '', '2.00', '360.00', '380', '720.00', '0.00', '', '0.00', '0', '74254.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4465, '819796267377149', '1797695428', '603', NULL, '', '1.00', '350.00', '250', '350.00', '0.00', '', NULL, '0', '14550.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4466, '322486629553138', '1797695428', '900', NULL, '', '1.00', '1500.00', '1350', '1500.00', '0.00', '', NULL, '0', '14550.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4467, '427799427179332', '1797695428', '667', NULL, '', '1.00', '4800.00', '6445', '4800.00', '0.00', '', NULL, '0', '14550.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4468, '174256211868442', '1797695428', '362', NULL, '', '1.00', '4800.00', '3800', '4800.00', '0.00', '', NULL, '0', '14550.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4469, '462185669612245', '1797695428', '371', NULL, '', '12.00', '80.00', '34', '960.00', '0.00', '', NULL, '0', '14550.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4470, '955695665878539', '1797695428', '860', NULL, '', '1.00', '200.00', '170', '200.00', '0.00', '', NULL, '0', '14550.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4471, '327675381883495', '1797695428', '834', NULL, '', '1.00', '50.00', '75', '50.00', '0.00', '', NULL, '0', '14550.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4472, '636255395971633', '1797695428', '396', NULL, '', '1.00', '50.00', '40', '50.00', '0.00', '', NULL, '0', '14550.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4473, '543324442251934', '1797695428', '374', NULL, '', '1.00', '50.00', '40', '50.00', '0.00', '', NULL, '0', '14550.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4474, '436815892694222', '1797695428', '905', NULL, '', '1.00', '50.00', '4', '50.00', '0.00', '', NULL, '0', '14550.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4523, '926315112135626', '6637133796', '257', NULL, '', '3.00', '650.00', '550', '1950.00', '0.00', '', '0.00', '0', '4000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4536, '443632871968667', '1371539249', '905', NULL, '', '2.00', '50.00', '4', '100.00', '0.00', '', '0.00', '0', '7840.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4560, '374661424268794', '4738635783', '904', NULL, '', '2.00', '20.00', '3', '40.00', '0.00', '', '0.00', '0', '25100.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4800, '872637114964635', '7123693583', '235', NULL, '', '6.00', '1100.00', '1100', '6600.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4799, '884839988118248', '7123693583', '499', NULL, '', '1.00', '150.00', '152', '150.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4798, '557277994653237', '7123693583', '515', NULL, '', '1.00', '300.00', '75', '300.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4797, '894769942622842', '7123693583', '497', NULL, '', '1.00', '200.00', '160', '200.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4796, '531368675445183', '7123693583', '272', NULL, '', '1.00', '300.00', '220', '300.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4795, '357591369839266', '7123693583', '382', NULL, '', '12.00', '65.00', '46', '780.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4794, '758263222198738', '7123693583', '223', NULL, '', '1.00', '1400.00', '1250', '1400.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4793, '946686796639839', '7123693583', '218', NULL, '', '1.00', '200.00', '170', '200.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4792, '578582512912852', '7123693583', '600', NULL, '', '3.00', '50.00', '221', '150.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4711, '342891497921411', '3897865422', '243', NULL, '', '1.00', '0.00', '430', '0.00', '0.00', '', '0.00', '0', '0.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4576, '181398836634684', '9294923342', '242', NULL, '', '50.00', '525.00', '490', '26250.00', '0.00', '', NULL, '0', '33930.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4577, '241917371615315', '9294923342', '240', NULL, '', '12.00', '320.00', '260', '3840.00', '0.00', '', NULL, '0', '33930.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4578, '957166612529559', '9294923342', '19', NULL, '', '7.00', '90.00', '70', '630.00', '0.00', '', NULL, '0', '33930.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4579, '597821593961196', '9294923342', '422', NULL, '', '1.00', '50.00', '30', '50.00', '0.00', '', NULL, '0', '33930.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4580, '731355693884676', '9294923342', '176', NULL, '', '1.00', '90.00', '65', '90.00', '0.00', '', NULL, '0', '33930.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4581, '298619647367189', '9294923342', '378', NULL, '', '1.00', '30.00', '20', '30.00', '0.00', '', NULL, '0', '33930.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4582, '171531956399387', '9294923342', '381', NULL, '', '4.00', '50.00', '34', '200.00', '0.00', '', NULL, '0', '33930.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4583, '374289256721523', '9294923342', '241', NULL, '', '8.00', '180.00', '160', '1440.00', '0.00', '', NULL, '0', '33930.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4584, '221329985172873', '9294923342', '235', NULL, '', '1.00', '1100.00', '1100', '1100.00', '0.00', '', NULL, '0', '33930.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4585, '478153779938656', '9294923342', '684', NULL, '', '1.00', '300.00', '360', '300.00', '0.00', '', NULL, '0', '33930.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4586, '963973212996216', '6172987557', '810', NULL, '', '100.00', '105.00', '103', '10500.00', '0.00', '', NULL, '0', '218032.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4587, '856699896581464', '6172987557', '363', NULL, '', '4.00', '330.00', '320', '1320.00', '0.00', '', NULL, '0', '218032.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4591, '592547882588443', '8676718682', '311', NULL, '', '2.00', '4555.00', '2961', '9110.00', '0.00', '', '0.00', '0', '609375.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4590, '938918751345732', '8676718682', '649', NULL, '', '1.00', '4555.00', '4555', '4555.00', '0.00', '', '0.00', '0', '609375.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4592, '554725425645126', '8676718682', '292', NULL, '', '1.00', '23055.00', '14986', '23055.00', '0.00', '', '0.00', '0', '609375.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4621, '795434183526738', '2124638789', '295', NULL, '', '1.00', '4200.00', '3936', '4200.00', '0.00', '', '0.00', '0', '794641.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4620, '997729654347573', '2124638789', '142', NULL, '', '2.00', '6400.00', '6146', '12800.00', '0.00', '', '0.00', '0', '794641.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4619, '849235251587855', '2124638789', '290', NULL, '', '4.00', '6400.00', '6146', '25600.00', '0.00', '', '0.00', '0', '794641.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4618, '517441622292242', '2124638789', '225', NULL, '', '1.00', '500.00', '480', '500.00', '0.00', '', '0.00', '0', '794641.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4617, '881169634913526', '2124638789', '715', NULL, '', '55.00', '125.00', '120', '6875.00', '0.00', '', '0.00', '0', '794641.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4616, '219943999185577', '2124638789', '316', NULL, '', '2.00', '6400.00', '6146', '12800.00', '0.00', '', '0.00', '0', '794641.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4615, '278642151371237', '2124638789', '292', NULL, '', '1.00', '16000.00', '14986', '16000.00', '0.00', '', '0.00', '0', '794641.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4622, '838392786862949', '2124638789', '488', NULL, '', '1.00', '200.00', '200', '200.00', '0.00', '', '0.00', '0', '794641.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4623, '154398991776695', '2124638789', '311', NULL, '', '3.00', '3000.00', '2961', '9000.00', '0.00', '', '0.00', '0', '794641.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4624, '944714194765317', '2124638789', '649', NULL, '', '3.00', '3000.00', '4555', '9000.00', '0.00', '', '0.00', '0', '794641.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5088, '148119913225787', '9495862115', '9', NULL, '', '6.00', '400.00', '430', '2400.00', '0.00', '', '0.00', '0', '67600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5087, '639952233238154', '9495862115', '715', NULL, '', '50.00', '120.00', '120', '6000.00', '0.00', '', '0.00', '0', '67600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5086, '299562176199181', '9495862115', '264', NULL, '', '4.00', '100.00', '80', '400.00', '0.00', '', '0.00', '0', '67600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5085, '897945329996895', '9495862115', '265', NULL, '', '5.00', '120.00', '120', '600.00', '0.00', '', '0.00', '0', '67600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5084, '818898695561289', '9495862115', '78', NULL, '', '1.00', '160.00', '160', '160.00', '0.00', '', '0.00', '0', '67600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5083, '813466864174182', '9495862115', '269', NULL, '', '4.00', '120.00', '110', '480.00', '0.00', '', '0.00', '0', '67600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5082, '354347372573329', '9495862115', '261', NULL, '', '2.00', '550.00', '600', '1100.00', '0.00', '', '0.00', '0', '67600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4655, '421641959923613', '6343288937', '884', NULL, '', '4.00', '550.00', '452', '2200.00', '0.00', '', '0.00', '0', '403810.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4654, '553925415737284', '6343288937', '915', NULL, '', '4.00', '150.00', '150', '600.00', '0.00', '', '0.00', '0', '403810.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4653, '239692293322533', '6343288937', '283', NULL, '', '2.00', '60.00', '30', '120.00', '0.00', '', '0.00', '0', '403810.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4652, '281685448962175', '6343288937', '72', NULL, '', '1.00', '2500.00', '2250', '2500.00', '0.00', '', '0.00', '0', '403810.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4651, '596328341624972', '6343288937', '382', NULL, '', '8.00', '75.00', '46', '600.00', '0.00', '', '0.00', '0', '403810.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4650, '821346812249363', '6343288937', '715', NULL, '', '10.00', '130.00', '120', '1300.00', '0.00', '', '0.00', '0', '403810.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4649, '567191458684627', '6343288937', '886', NULL, '', '2.00', '350.00', '277', '700.00', '0.00', '', '0.00', '0', '403810.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4648, '366793587248199', '6343288937', '448', NULL, '', '2.00', '180.00', '120', '360.00', '0.00', '', '0.00', '0', '403810.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4656, '246983488812765', '6343288937', '284', NULL, '', '10.00', '70.00', '40', '700.00', '0.00', '', '0.00', '0', '403810.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5129, '887593526629123', '7976169977', '153', NULL, '', '1.00', '2350.00', '2292', '2350.00', '0.00', '', '0.00', '0', '162266.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5128, '313479418763375', '7976169977', '151', NULL, '', '1.00', '1850.00', '1557', '1850.00', '0.00', '', '0.00', '0', '162266.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5127, '945162199672365', '7976169977', '152', NULL, '', '1.00', '1850.00', '1557', '1850.00', '0.00', '', '0.00', '0', '162266.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5126, '613725466847876', '7976169977', '918', NULL, '', '4.00', '180.00', '155', '720.00', '0.00', '', '0.00', '0', '162266.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5125, '288464833475948', '7976169977', '862', NULL, '', '6.00', '180.00', '155', '1080.00', '0.00', '', '0.00', '0', '162266.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5124, '732495299291384', '7976169977', '600', NULL, '', '10.00', '45.00', '221', '450.00', '0.00', '', '0.00', '0', '162266.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5123, '649344734598524', '7976169977', '917', NULL, '', '10.00', '45.00', '40', '450.00', '0.00', '', '0.00', '0', '162266.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5122, '146764565553788', '7976169977', '260', NULL, '', '1.00', '750.00', '850', '750.00', '0.00', '', '0.00', '0', '162266.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5121, '178786397252341', '7976169977', '261', NULL, '', '1.00', '600.00', '600', '600.00', '0.00', '', '0.00', '0', '162266.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5120, '852477871862745', '7976169977', '263', NULL, '', '2.00', '400.00', '350', '800.00', '0.00', '', '0.00', '0', '162266.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5119, '948834256455222', '7976169977', '715', NULL, '', '50.00', '125.00', '120', '6250.00', '0.00', '', '0.00', '0', '162266.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5118, '256519319143983', '7976169977', '194', NULL, '', '1.00', '1600.00', '1500', '1600.00', '0.00', '', '0.00', '0', '162266.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5117, '563272243914169', '7976169977', '193', NULL, '', '1.00', '2200.00', '1700', '2200.00', '0.00', '', '0.00', '0', '162266.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5116, '658452819657743', '7976169977', '311', NULL, '', '2.00', '3000.00', '2961', '6000.00', '0.00', '', '0.00', '0', '162266.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5115, '285597431194616', '7976169977', '649', NULL, '', '3.00', '3000.00', '2961', '9000.00', '0.00', '', '0.00', '0', '162266.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5114, '728828261934287', '7976169977', '410', NULL, '', '10.00', '1600.00', '1650', '16000.00', '0.00', '', '0.00', '0', '162266.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5113, '712866216245825', '7976169977', '211', NULL, '', '50.00', '100.00', '100', '5000.00', '0.00', '', '0.00', '0', '162266.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5112, '753849393265573', '7976169977', '728', NULL, '', '2.00', '300.00', '260', '600.00', '0.00', '', '0.00', '0', '162266.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5111, '364286335457836', '7976169977', '901', NULL, '', '1.00', '1080.00', '450', '1080.00', '0.00', '', '0.00', '0', '162266.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4694, '198752649529478', '2588954467', '410', NULL, '', '6.00', '1700.00', '1650', '10200.00', '0.00', '', NULL, '0', '11550.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4695, '648366639643417', '2588954467', '81', NULL, '', '3.00', '90.00', '80', '270.00', '0.00', '', NULL, '0', '11550.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4696, '336918787633675', '2588954467', '496', NULL, '', '3.00', '60.00', '38', '180.00', '0.00', '', NULL, '0', '11550.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4697, '772473839274214', '2588954467', '913', NULL, '', '6.00', '150.00', '80', '900.00', '0.00', '', NULL, '0', '11550.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4698, '567233912998213', '3799993359', '829', NULL, '', '5.00', '320.00', '280', '1600.00', '0.00', '', NULL, '0', '12340.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4699, '926943915659584', '3799993359', '941', NULL, '', '2.00', '70.00', '50', '140.00', '0.00', '', NULL, '0', '12340.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4700, '786959161685662', '3799993359', '382', NULL, '', '1.00', '70.00', '46', '70.00', '0.00', '', NULL, '0', '12340.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4701, '452591826289889', '3799993359', '221', NULL, '', '2.00', '600.00', '500', '1200.00', '0.00', '', NULL, '0', '12340.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4702, '241137755471474', '3799993359', '265', NULL, '', '1.00', '150.00', '120', '150.00', '0.00', '', NULL, '0', '12340.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4703, '391346436118432', '3799993359', '150', NULL, '', '2.00', '1400.00', '1044', '2800.00', '0.00', '', NULL, '0', '12340.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4704, '187948112773861', '3799993359', '381', NULL, '', '1.00', '50.00', '34', '50.00', '0.00', '', NULL, '0', '12340.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4705, '251593999742522', '3799993359', '238', NULL, '', '2.00', '350.00', '320', '700.00', '0.00', '', NULL, '0', '12340.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4706, '723191211221313', '3799993359', '649', NULL, '', '1.00', '2950.00', '4555', '2950.00', '0.00', '', NULL, '0', '12340.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4707, '869975799934845', '3799993359', '905', NULL, '', '2.00', '50.00', '4', '100.00', '0.00', '', NULL, '0', '12340.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4708, '917853489979676', '3799993359', '693', NULL, '', '4.00', '150.00', '130', '600.00', '0.00', '', NULL, '0', '12340.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4709, '275165765973152', '3799993359', '693', NULL, '', '12.00', '165.00', '130', '1980.00', '0.00', '', NULL, '0', '12340.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4791, '742865858617441', '7123693583', '221', NULL, '', '1.00', '700.00', '500', '700.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4790, '666291778999797', '7123693583', '222', NULL, '', '10.00', '350.00', '230', '3500.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4789, '685536164426753', '7123693583', '693', NULL, '', '1.00', '150.00', '130', '150.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4788, '898785126571876', '7123693583', '238', NULL, '', '1.00', '350.00', '320', '350.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4787, '369973364819299', '7123693583', '625', NULL, '', '1.00', '50.00', '41', '50.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4786, '477315315441868', '7123693583', '837', NULL, '', '4.00', '50.00', '70', '200.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4785, '581326597566123', '7123693583', '250', NULL, '', '1.00', '250.00', '250', '250.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4729, '189248413961711', '2855145682', '963', NULL, '', '100.00', '2500.00', '2500', '250000.00', '0.00', '', NULL, '0', '844272.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4730, '419885615765722', '2855145682', '961', NULL, '', '15.00', '2050.00', '2050', '30750.00', '0.00', '', NULL, '0', '844272.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4731, '439147161691292', '2855145682', '962', NULL, '', '15.00', '4100.00', '4100', '61500.00', '0.00', '', NULL, '0', '844272.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4732, '781283351887586', '2855145682', '960', NULL, '', '15.00', '3100.00', '3100', '46500.00', '0.00', '', NULL, '0', '844272.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4784, '363399473647441', '7123693583', '374', NULL, '', '2.00', '50.00', '40', '100.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4783, '787253442253963', '7123693583', '381', NULL, '', '1.00', '70.00', '34', '70.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4782, '914431541866714', '7123693583', '843', NULL, '', '1.00', '70.00', '13', '70.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4781, '695864822971371', '7123693583', '490', NULL, '', '1.00', '150.00', '90', '150.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4780, '774737914163337', '7123693583', '293', NULL, '', '1.00', '4000.00', '4391', '4000.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4779, '877413233742173', '7123693583', '711', NULL, '', '6.00', '60.00', '62', '360.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4778, '933117379879731', '7123693583', '363', NULL, '', '1.00', '350.00', '320', '350.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4777, '428264132393152', '7123693583', '921', NULL, '', '2.00', '75.00', '50', '150.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4776, '995138783531329', '7123693583', '773', NULL, '', '1.00', '100.00', '80', '100.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4775, '396821522752378', '7123693583', '379', NULL, '', '2.00', '50.00', '25', '100.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4774, '562595483477667', '7123693583', '245', NULL, '', '2.00', '3250.00', '2800', '6500.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4773, '147717248512611', '7123693583', '68', NULL, '', '1.00', '2750.00', '2600', '2750.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4772, '313755857478498', '7123693583', '378', NULL, '', '3.00', '50.00', '20', '150.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4771, '633946287912879', '7123693583', '883', NULL, '', '8.00', '500.00', '460', '4000.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4770, '615173567451172', '7123693583', '886', NULL, '', '7.00', '350.00', '277', '2450.00', '0.00', '', '0.00', '0', '51460.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5890, '663193766982854', '2684671283', '375', NULL, '', '3.00', '40.00', '15', '120.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5889, '215482863116242', '2684671283', '835', NULL, '', '1.00', '50.00', '50', '50.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5888, '152979149775144', '2684671283', '366', NULL, '', '1.00', '70.00', '46', '70.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5887, '253735265588419', '2684671283', '837', NULL, '', '2.00', '100.00', '70', '200.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5886, '614439989764735', '2684671283', '372', NULL, '', '4.00', '50.00', '40', '200.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5885, '191127551714113', '2684671283', '918', NULL, '', '1.00', '200.00', '155', '200.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5884, '192237344699362', '2684671283', '625', NULL, '', '2.00', '50.00', '41', '100.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5883, '767143314535249', '2684671283', '283', NULL, '', '1.00', '60.00', '30', '60.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5882, '395543736961393', '2684671283', '284', NULL, '', '2.00', '70.00', '40', '140.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5881, '279747247968766', '2684671283', '888', NULL, '', '1.00', '300.00', '322', '300.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5880, '934281785697767', '2684671283', '221', NULL, '', '1.00', '600.00', '500', '600.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5879, '827769262896321', '2684671283', '222', NULL, '', '3.00', '300.00', '230', '900.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5878, '123346646461363', '2684671283', '883', NULL, '', '2.00', '500.00', '460', '1000.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5877, '463296781474249', '2684671283', '490', NULL, '', '2.00', '150.00', '85', '300.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5876, '871916964386843', '2684671283', '913', NULL, '', '1.00', '50.00', '80', '50.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5875, '974897562825319', '2684671283', '711', NULL, '', '24.00', '65.00', '62', '1560.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5874, '828942385623239', '2684671283', '57', NULL, '', '36.00', '118.00', '140', '4248.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5873, '585725918664351', '2684671283', '494', NULL, '', '2.00', '300.00', '290', '600.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5872, '858857816229891', '2684671283', '930', NULL, '', '2.00', '260.00', '260', '520.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5871, '782762624226338', '2684671283', '89', NULL, '', '2.00', '300.00', '280', '600.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5870, '654335299816815', '2684671283', '86', NULL, '', '3.00', '430.00', '390', '1290.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5869, '247497323476931', '2684671283', '1', NULL, '', '3.00', '430.00', '370', '1290.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5868, '868547267449628', '2684671283', '495', NULL, '', '1.00', '600.00', '650', '600.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5867, '364569564391961', '2684671283', '929', NULL, '', '10.00', '160.00', '150', '1600.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5866, '381953197295363', '2684671283', '928', NULL, '', '10.00', '45.00', '35', '450.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5865, '759849347928961', '2684671283', '926', NULL, '', '2.00', '330.00', '320', '660.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5864, '512573218379332', '2684671283', '122', NULL, '', '1.00', '300.00', '340', '300.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5863, '998731969694637', '2684671283', '693', NULL, '', '50.00', '130.00', '130', '6500.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5862, '511469994795289', '2684671283', '93', NULL, '', '2.00', '320.00', '270', '640.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5861, '244735451895211', '2684671283', '105', NULL, '', '2.00', '720.00', '510', '1440.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9405, '136784417783398', '6667973681', '836', NULL, '', '2.00', '50.00', '30', '100.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9404, '711725657624833', '6667973681', '1041', NULL, '', '6.00', '50.00', '25', '300.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9403, '588398676219435', '6667973681', '979', NULL, '', '12.00', '650.00', '550', '7800.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9402, '325185765242267', '6667973681', '698', NULL, '', '10.00', '320.00', '290', '3200.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9401, '594163653735484', '6667973681', '886', NULL, '', '6.00', '350.00', '277', '2100.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9400, '123327769958414', '6667973681', '935', NULL, '', '4.00', '70.00', '35', '280.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9399, '272895932959393', '6667973681', '883', NULL, '', '4.00', '550.00', '466.6', '2200.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9398, '957592612666512', '6667973681', '152', NULL, '', '1.00', '1750.00', '1557', '1750.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9397, '541116647279782', '6667973681', '151', NULL, '', '1.00', '1750.00', '1557', '1750.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9396, '349776457655618', '6667973681', '417', NULL, '', '1.00', '4700.00', '4300', '4700.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9395, '854519928532767', '6667973681', '72', NULL, '', '1.00', '2750.00', '2250', '2750.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9394, '498896849948481', '6667973681', '961', NULL, '', '2.00', '2750.00', '2050', '5500.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9393, '858917165177259', '6667973681', '372', NULL, '', '8.00', '50.00', '40', '400.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9392, '356425377487421', '6667973681', '693', NULL, '', '6.00', '140.00', '130', '840.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9391, '538531567725951', '6667973681', '57', NULL, '', '1.00', '150.00', '140', '150.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9390, '249742652373781', '6667973681', '837', NULL, '', '8.00', '80.00', '70', '640.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9389, '687335184252256', '6667973681', '662', NULL, '', '2.00', '1900.00', '1557', '3800.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9388, '366263548795858', '6667973681', '603', NULL, '', '1.00', '300.00', '250', '300.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9387, '519437748538899', '6667973681', '422', NULL, '', '14.00', '60.00', '30', '840.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9386, '757439419734362', '6667973681', '921', NULL, '', '6.00', '70.00', '50', '420.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5139, '369817994859611', '8614186355', '93', NULL, '', '2.00', '360.00', '270', '720.00', '0.00', '', '0.00', '0', '221172.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5138, '861996682217596', '8614186355', '654', NULL, '', '1.00', '3000.00', '2961', '3000.00', '0.00', '', '0.00', '0', '221172.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5137, '987252751296229', '8614186355', '131', NULL, '', '2.00', '300.00', '240', '600.00', '0.00', '', '0.00', '0', '221172.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5136, '291414358588528', '8614186355', '92', NULL, '', '6.00', '240.00', '260', '1440.00', '0.00', '', '0.00', '0', '221172.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5135, '986331657284742', '8614186355', '492', NULL, '', '4.00', '260.00', '235', '1040.00', '0.00', '', '0.00', '0', '221172.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5134, '741112273975361', '8614186355', '86', NULL, '', '2.00', '440.00', '390', '880.00', '0.00', '', '0.00', '0', '221172.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5133, '166667124164178', '8614186355', '410', NULL, '', '2.00', '1700.00', '1650', '3400.00', '0.00', '', '0.00', '0', '221172.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5132, '197333798559141', '8614186355', '860', NULL, '', '6.00', '190.00', '170', '1140.00', '0.00', '', '0.00', '0', '221172.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5142, '839712985659122', '5543697839', '975', NULL, '', '1.00', '600.00', '540', '600.00', '0.00', '', '0.00', '0', '465790.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5141, '837472734875187', '5543697839', '794', NULL, '', '100.00', '200.00', '140', '20000.00', '0.00', '', '0.00', '0', '465790.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5151, '456524686341276', '2624183513', '758', NULL, '', '2.00', '1950.00', '1100', '3900.00', '0.00', '', '0.00', '0', '434850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4883, '167663676623385', '2985475614', '238', NULL, '', '2.00', '350.00', '320', '700.00', '0.00', '', NULL, '0', '5070.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4884, '855552471468539', '2985475614', '422', NULL, '', '2.00', '60.00', '30', '120.00', '0.00', '', NULL, '0', '5070.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4885, '672536137456556', '2985475614', '891', NULL, '', '1.00', '350.00', '253', '350.00', '0.00', '', NULL, '0', '5070.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4886, '883127358223412', '3689542297', '19', NULL, '', '5.00', '80.00', '70', '400.00', '0.00', '', NULL, '0', '12720.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4887, '896154916156832', '3689542297', '715', NULL, '', '7.00', '110.00', '120', '770.00', '0.00', '', NULL, '0', '12720.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4888, '242973717411977', '9855185474', '283', NULL, '', '20.00', '35.00', '30', '700.00', '0.00', '', NULL, '0', '2060764.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4889, '829888716394991', '3253157469', '649', NULL, '', '5.00', '4555.00', '2961', '22775.00', '0.00', '', NULL, '0', '867047.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4890, '318329882649588', '5241153453', '825', NULL, '', '100.00', '120.00', '115', '12000.00', '0.00', '', NULL, '0', '621375.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4891, '621161983349861', '4636966543', '986', NULL, '', '1.00', '1200.00', '900', '1200.00', '0.00', '', NULL, '0', '245070.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4892, '852167149744637', '4636966543', '987', NULL, '', '1.00', '1500.00', '1200', '1500.00', '0.00', '', NULL, '0', '245070.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4893, '628815267753629', '4636966543', '988', NULL, '', '4.00', '380.00', '350', '1520.00', '0.00', '', NULL, '0', '245070.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4894, '962522242669343', '4636966543', '989', NULL, '', '18.00', '70.00', '60', '1260.00', '0.00', '', NULL, '0', '245070.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4918, '379327571766366', '9432582367', '290', NULL, '', '4.00', '6400.00', '6146', '25600.00', '0.00', '', '0.00', '0', '889776.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4917, '262368828434864', '9432582367', '116', NULL, '', '2.00', '700.00', '550', '1400.00', '0.00', '', '0.00', '0', '889776.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4916, '145552866793145', '9432582367', '283', NULL, '', '4.00', '40.00', '30', '160.00', '0.00', '', '0.00', '0', '889776.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4915, '299856183494463', '9432582367', '247', NULL, '', '1.00', '700.00', '650', '700.00', '0.00', '', '0.00', '0', '889776.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4914, '226934773527855', '9432582367', '715', NULL, '', '25.00', '125.00', '120', '3125.00', '0.00', '', '0.00', '0', '889776.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4913, '146925462595267', '9432582367', '742', NULL, '', '50.00', '115.00', '110', '5750.00', '0.00', '', '0.00', '0', '889776.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4912, '579312983567727', '9432582367', '193', NULL, '', '1.00', '2200.00', '1700', '2200.00', '0.00', '', '0.00', '0', '889776.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4911, '294849883164957', '9432582367', '323', NULL, '', '1.00', '4100.00', '4092', '4100.00', '0.00', '', '0.00', '0', '889776.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4910, '368821959933725', '9432582367', '299', NULL, '', '1.00', '4100.00', '4092', '4100.00', '0.00', '', '0.00', '0', '889776.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4909, '111856119864546', '9432582367', '654', NULL, '', '3.00', '3000.00', '2961', '9000.00', '0.00', '', '0.00', '0', '889776.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4908, '513393431432579', '9432582367', '650', NULL, '', '3.00', '3000.00', '2961', '9000.00', '0.00', '', '0.00', '0', '889776.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4907, '988888116236561', '9432582367', '649', NULL, '', '10.00', '3000.00', '2961', '30000.00', '0.00', '', '0.00', '0', '889776.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4924, '493145776686215', '9272887417', '992', NULL, '', '2.00', '26200.00', '25200', '52400.00', '0.00', '', '0.00', '0', '53600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4923, '182541248261637', '9272887417', '625', NULL, '', '12.00', '50.00', '41', '600.00', '0.00', '', '0.00', '0', '53600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4922, '269488576681682', '9272887417', '895', NULL, '', '12.00', '50.00', '45', '600.00', '0.00', '', '0.00', '0', '53600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4936, '488486833316169', '4167744585', '382', NULL, '', '3.00', '60.00', '46', '180.00', '0.00', '', '0.00', '0', '15250.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5155, '132725932126145', '3648649638', '395', NULL, '', '3.00', '40.00', '50', '120.00', '0.00', '', '0.00', '0', '26800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4946, '536146526442913', '3828982476', '372', NULL, '', '19.00', '60.00', '40', '1140.00', '0.00', '', '0.00', '0', '233106.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (4986, '337465935213729', '7122648312', '888', NULL, '', '1.00', '325.00', '322', '325.00', '0.00', '', '0.00', '0', '268990.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5046, '495256419674336', '6863289674', '122', NULL, '', '1.00', '360.00', '340', '360.00', '0.00', '', '0.00', '0', '207592.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5047, '598557567977783', '6863289674', '924', NULL, '', '1.00', '480.00', '480', '480.00', '0.00', '', '0.00', '0', '207592.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5048, '915647125837699', '6863289674', '834', NULL, '', '6.00', '90.00', '75', '540.00', '0.00', '', '0.00', '0', '207592.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5052, '664982351927134', '2839568685', '1011', NULL, '', '12.00', '15.00', '11', '180.00', '0.00', '', '0.00', '0', '296530.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5053, '584586985523883', '2839568685', '1012', NULL, '', '12.00', '10.00', '5', '120.00', '0.00', '', '0.00', '0', '296530.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5076, '435222837332537', '5725871419', '893', NULL, '', '30.00', '210.00', '220', '6300.00', '0.00', '', '0.00', '0', '246480.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5075, '342181746525248', '5725871419', '86', NULL, '', '8.00', '625.00', '390', '5000.00', '0.00', '', '0.00', '0', '246480.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5074, '391625134678857', '5725871419', '488', NULL, '', '8.00', '240.00', '200', '1920.00', '0.00', '', '0.00', '0', '246480.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5073, '373753228955289', '5725871419', '894', NULL, '', '1.00', '3000.00', '1400', '3000.00', '0.00', '', '0.00', '0', '246480.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5072, '563867566298792', '5725871419', '895', NULL, '', '10.00', '70.00', '45', '700.00', '0.00', '', '0.00', '0', '246480.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5071, '376665599422675', '5725871419', '722', NULL, '', '1.00', '360.00', '264', '360.00', '0.00', '', '0.00', '0', '246480.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5145, '182825441495336', '5543697839', '178', NULL, '', '3.00', '240.00', '80', '720.00', '0.00', '', '0.00', '0', '465790.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5146, '531813818381852', '5543697839', '176', NULL, '', '8.00', '120.00', '65', '960.00', '0.00', '', '0.00', '0', '465790.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5147, '351782128481144', '5543697839', '175', NULL, '', '4.00', '284.00', '125', '960.00', '0.00', '', '0.00', '0', '465790.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5148, '792169483577754', '5543697839', '722', NULL, '', '9.00', '360.00', '264', '3240.00', '0.00', '', '0.00', '0', '465790.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5149, '412977749527854', '5543697839', '25', NULL, '', '1.00', '3750.00', '1800', '3750.00', '0.00', '', '0.00', '0', '465790.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5150, '253559745675948', '5543697839', '714', NULL, '', '2.00', '500.00', '325', '1000.00', '0.00', '', '0.00', '0', '465790.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5152, '654964865558465', '2624183513', '994', NULL, '', '20.00', '300.00', '165', '6000.00', '0.00', '', '0.00', '0', '434850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5153, '735343154681286', '2624183513', '177', NULL, '', '1.00', '300.00', '165', '300.00', '0.00', '', '0.00', '0', '434850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5154, '629676625354546', '2624183513', '178', NULL, '', '1.00', '240.00', '80', '240.00', '0.00', '', '0.00', '0', '434850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5158, '742367836453636', '3648649638', '91', NULL, '', '1.00', '50.00', '540', '50.00', '0.00', '', '0.00', '0', '26800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5159, '692963524388296', '7748257852', '899', NULL, '', '8.00', '90.00', '73', '720.00', '0.00', '', NULL, '0', '12570.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5160, '131184463359992', '7748257852', '366', NULL, '', '1.00', '50.00', '46', '50.00', '0.00', '', NULL, '0', '12570.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5161, '835683854613978', '7748257852', '236', NULL, '', '4.00', '950.00', '920', '3800.00', '0.00', '', NULL, '0', '12570.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5162, '671572492145767', '7748257852', '237', NULL, '', '12.00', '550.00', '530', '6600.00', '0.00', '', NULL, '0', '12570.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5163, '158767195515863', '7748257852', '247', NULL, '', '2.00', '700.00', '650', '1400.00', '0.00', '', NULL, '0', '12570.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5164, '545813226926393', '2698538637', '9', NULL, '', '2.00', '450.00', '430', '900.00', '0.00', '', NULL, '0', '383660.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5174, '927146192172495', '7473123694', '264', NULL, '', '6.00', '100.00', '80', '600.00', '0.00', '', '0.00', '0', '99480.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5173, '775973352251225', '7473123694', '649', NULL, '', '1.00', '3000.00', '2961', '3000.00', '0.00', '', '0.00', '0', '99480.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5167, '666132274551927', '9329421995', '71', NULL, '', '2.00', '2200.00', '2250', '4400.00', '0.00', '', NULL, '0', '26820.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5168, '741877867764944', '9329421995', '72', NULL, '', '1.00', '2200.00', '2250', '2200.00', '0.00', '', NULL, '0', '26820.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5169, '213722395216535', '9329421995', '417', NULL, '', '1.00', '4500.00', '4300', '4500.00', '0.00', '', NULL, '0', '26820.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5170, '316964988569139', '9329421995', '418', NULL, '', '1.00', '4500.00', '4300', '4500.00', '0.00', '', NULL, '0', '26820.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5171, '973571567259686', '9329421995', '270', NULL, '', '4.00', '180.00', '160', '720.00', '0.00', '', NULL, '0', '26820.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5172, '367992747295997', '9329421995', '810', NULL, '', '100.00', '105.00', '103', '10500.00', '0.00', '', NULL, '0', '26820.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5175, '547529536929559', '7473123694', '100', NULL, '', '1.00', '350.00', '300', '350.00', '0.00', '', '0.00', '0', '99480.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5176, '818851721677687', '9997275465', '292', NULL, '', '1.00', '15500.00', '14986', '15500.00', '0.00', '', NULL, '0', '340830.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5177, '987968245131987', '9997275465', '147', NULL, '', '1.00', '15500.00', '14986', '15500.00', '0.00', '', NULL, '0', '340830.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5178, '256481319218198', '9997275465', '718', NULL, '', '40.00', '250.00', '220', '10000.00', '0.00', '', NULL, '0', '340830.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5179, '771763184593957', '9997275465', '794', NULL, '', '16.00', '150.00', '140', '2400.00', '0.00', '', NULL, '0', '340830.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5180, '728461193773666', '9997275465', '23', NULL, '', '1.00', '180.00', '1500', '180.00', '0.00', '', NULL, '0', '340830.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5181, '476875973997935', '9997275465', '24', NULL, '', '1.00', '120.00', '750', '120.00', '0.00', '', NULL, '0', '340830.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5182, '511525525925351', '9997275465', '269', NULL, '', '4.00', '150.00', '110', '600.00', '0.00', '', NULL, '0', '340830.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5195, '371969655711974', '5672426756', '363', NULL, '', '1.00', '350.00', '320', '350.00', '0.00', '', '0.00', '0', '928616.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5194, '774586463672657', '5672426756', '823', NULL, '', '3.00', '1250.00', '1000', '3750.00', '0.00', '', '0.00', '0', '928616.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5193, '898286293544927', '5672426756', '994', NULL, '', '50.00', '180.00', '165', '9000.00', '0.00', '', '0.00', '0', '928616.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5192, '342778933516244', '5672426756', '295', NULL, '', '1.00', '4200.00', '3936', '4200.00', '0.00', '', '0.00', '0', '928616.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5191, '243917243888265', '5672426756', '410', NULL, '', '1.00', '1700.00', '1650', '1700.00', '0.00', '', '0.00', '0', '928616.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5190, '661797588721484', '5672426756', '290', NULL, '', '1.00', '6400.00', '6146', '6400.00', '0.00', '', '0.00', '0', '928616.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5189, '848317216819324', '3826793642', '742', NULL, '', '6.00', '110.00', '110', '660.00', '0.00', '', NULL, '0', '13380.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5196, '317295713425481', '5672426756', '299', NULL, '', '3.00', '4100.00', '4092', '12300.00', '0.00', '', '0.00', '0', '928616.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5419, '385841666169595', '5434657383', '488', NULL, '', '2.00', '240.00', '200', '480.00', '0.00', '', '0.00', '0', '40060.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5418, '256427177939634', '5434657383', '24', NULL, '', '1.00', '120.00', '750', '120.00', '0.00', '', '0.00', '0', '40060.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5417, '591399379178685', '5434657383', '23', NULL, '', '2.00', '180.00', '1500', '360.00', '0.00', '', '0.00', '0', '40060.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5416, '245129469718841', '5434657383', '583', NULL, '', '1.00', '2500.00', '2300', '2500.00', '0.00', '', '0.00', '0', '40060.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5415, '574974777879318', '5434657383', '922', NULL, '', '10.00', '50.00', '40', '500.00', '0.00', '', '0.00', '0', '40060.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5414, '644718885983893', '5434657383', '921', NULL, '', '10.00', '60.00', '50', '600.00', '0.00', '', '0.00', '0', '40060.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5413, '782324223536861', '5434657383', '349', NULL, '', '1.00', '6500.00', '6000', '6500.00', '0.00', '', '0.00', '0', '40060.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5412, '761923232578362', '5434657383', '309', NULL, '', '1.00', '6500.00', '6000', '6500.00', '0.00', '', '0.00', '0', '40060.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5411, '446424732614284', '5434657383', '964', NULL, '', '3.00', '5000.00', '5000', '15000.00', '0.00', '', '0.00', '0', '40060.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5410, '328361666478378', '5434657383', '68', NULL, '', '1.00', '2500.00', '2600', '2500.00', '0.00', '', '0.00', '0', '40060.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5409, '638258196722626', '5434657383', '963', NULL, '', '2.00', '2500.00', '2500', '5000.00', '0.00', '', '0.00', '0', '40060.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5471, '217127788373136', '4937312758', '788', NULL, '', '1.00', '2000.00', '1050', '2000.00', '0.00', '', '0.00', '0', '635375.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5243, '721984855714878', '1747957241', '752', NULL, '', '24.00', '180.00', '88', '4320.00', '0.00', '', '0.00', '0', '794170.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5242, '562547598362967', '1747957241', '718', NULL, '', '288.00', '300.00', '220', '86400.00', '0.00', '', '0.00', '0', '794170.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5241, '797779956483143', '1747957241', '8', NULL, '', '48.00', '700.00', '550', '33600.00', '0.00', '', '0.00', '0', '794170.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5240, '557866675461355', '1747957241', '270', NULL, '', '10.00', '240.00', '160', '2400.00', '0.00', '', '0.00', '0', '794170.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5239, '612385875793571', '1747957241', '86', NULL, '', '10.00', '540.00', '390', '5400.00', '0.00', '', '0.00', '0', '794170.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5238, '683418543597867', '1747957241', '125', NULL, '', '30.00', '480.00', '375', '14400.00', '0.00', '', '0.00', '0', '794170.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5237, '585465692289383', '1747957241', '575', NULL, '', '3.00', '4350.00', '3500', '13050.00', '0.00', '', '0.00', '0', '794170.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5236, '875428832797445', '1747957241', '821', NULL, '', '20.00', '7500.00', '6500', '150000.00', '0.00', '', '0.00', '0', '794170.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5235, '186231412743126', '1747957241', '882', NULL, '', '24.00', '300.00', '271', '7200.00', '0.00', '', '0.00', '0', '794170.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9385, '377437745679691', '6667973681', '284', NULL, '', '6.00', '70.00', '33.5', '420.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9384, '118961658172224', '6667973681', '283', NULL, '', '3.00', '60.00', '30', '180.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9383, '838711331586985', '6667973681', '981', NULL, '', '4.00', '625.00', '550', '2500.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9382, '939338183976823', '6667973681', '980', NULL, '', '10.00', '1000.00', '980', '10000.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9381, '759688439675634', '6667973681', '983', NULL, '', '1.00', '2600.00', '1800', '2600.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5286, '323483682455748', '2733712729', '783', NULL, '', '1.00', '240.00', '110', '240.00', '0.00', '', '0.00', '0', '8920.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5285, '392754516375166', '2733712729', '858', NULL, '', '1.00', '150.00', '115', '150.00', '0.00', '', '0.00', '0', '8920.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5284, '361893986372658', '2733712729', '410', NULL, '', '1.00', '2000.00', '1650', '2000.00', '0.00', '', '0.00', '0', '8920.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5283, '754857415988423', '2733712729', '598 ', NULL, '', '1.00', '150.00', '130', '150.00', '0.00', '', '0.00', '0', '8920.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5282, '558919479354258', '2733712729', '378', NULL, '', '1.00', '50.00', '20', '50.00', '0.00', '', '0.00', '0', '8920.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5281, '615981223386668', '2733712729', '372', NULL, '', '3.00', '50.00', '40', '150.00', '0.00', '', '0.00', '0', '8920.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5280, '779139789614554', '2733712729', '703', NULL, '', '3.00', '900.00', '900', '2700.00', '0.00', '', '0.00', '0', '8920.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5279, '269268234949562', '2733712729', '701', NULL, '', '2.00', '1100.00', '1080', '2200.00', '0.00', '', '0.00', '0', '8920.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5278, '268788128894129', '2733712729', '715', NULL, '', '3.00', '130.00', '120', '390.00', '0.00', '', '0.00', '0', '8920.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5287, '794128829614976', '2733712729', '442', NULL, '', '7.00', '110.00', '120', '770.00', '0.00', '', '0.00', '0', '8920.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5288, '183211245289878', '2733712729', '715', NULL, '', '1.00', '120.00', '120', '120.00', '0.00', '', '0.00', '0', '8920.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9376, '268982619284184', '6351564964', '866', NULL, '', '1.00', '150.00', '120', '150.00', '0.00', '', '0.00', '0', '5040.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9375, '123576789992172', '6351564964', '369', NULL, '', '6.00', '105.00', '84', '630.00', '0.00', '', '0.00', '0', '5040.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9374, '579779993716816', '6351564964', '714', NULL, '', '1.00', '410.00', '325', '410.00', '0.00', '', '0.00', '0', '5040.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9373, '566881436294265', '6351564964', '92', NULL, '', '4.00', '210.00', '260', '840.00', '0.00', '', '0.00', '0', '5040.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9372, '169712465288374', '6351564964', '886', NULL, '', '2.00', '300.00', '277', '600.00', '0.00', '', '0.00', '0', '5040.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9371, '786686589217187', '6351564964', '883', NULL, '', '1.00', '500.00', '466.6', '500.00', '0.00', '', '0.00', '0', '5040.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9370, '787281923526337', '6351564964', '442', NULL, '', '5.00', '100.00', '120', '500.00', '0.00', '', '0.00', '0', '5040.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9369, '872873872581788', '6351564964', '837', NULL, '', '3.00', '90.00', '70', '270.00', '0.00', '', '0.00', '0', '5040.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9360, '428152994335355', '8398991967', '840', NULL, '', '1.00', '40.00', '20', '40.00', '0.00', '', '0.00', '0', '21800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9359, '883985939145768', '8398991967', '904', NULL, '', '2.00', '25.00', '3', '50.00', '0.00', '', '0.00', '0', '21800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9358, '349236761979469', '8398991967', '218', NULL, '', '1.00', '200.00', '160', '200.00', '0.00', '', '0.00', '0', '21800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9357, '269827169352748', '8398991967', '860', NULL, '', '1.00', '300.00', '170', '300.00', '0.00', '', '0.00', '0', '21800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9356, '334397377858648', '8398991967', '970', NULL, '', '1.00', '3000.00', '3200', '3000.00', '0.00', '', '0.00', '0', '21800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9355, '531872395445122', '8398991967', '649', NULL, '', '1.00', '2900.00', '2961', '2900.00', '0.00', '', '0.00', '0', '21800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9354, '717172144434822', '8398991967', '442', NULL, '', '4.00', '110.00', '120', '440.00', '0.00', '', '0.00', '0', '21800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9353, '326187721979557', '8398991967', '990', NULL, '', '1.00', '1800.00', '1600', '1800.00', '0.00', '', '0.00', '0', '21800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9352, '568488252619478', '8398991967', '269', NULL, '', '1.00', '200.00', '110', '200.00', '0.00', '', '0.00', '0', '21800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9351, '198611988259855', '8398991967', '311', NULL, '', '1.00', '3000.00', '2961', '3000.00', '0.00', '', '0.00', '0', '21800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9350, '588756267879954', '8398991967', '883', NULL, '', '1.00', '500.00', '466.6', '500.00', '0.00', '', '0.00', '0', '21800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9349, '399594774952189', '8398991967', '886', NULL, '', '4.00', '300.00', '277', '1200.00', '0.00', '', '0.00', '0', '21800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9348, '354641858697423', '8398991967', '27', NULL, '', '5.00', '60.00', '33', '300.00', '0.00', '', '0.00', '0', '21800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9347, '293584644516112', '8398991967', '284', NULL, '', '1.00', '70.00', '33.5', '70.00', '0.00', '', '0.00', '0', '21800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9346, '298196247664843', '8398991967', '381', NULL, '', '9.00', '40.00', '34', '360.00', '0.00', '', '0.00', '0', '21800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9345, '152541924778499', '8398991967', '903', NULL, '', '2.00', '40.00', '40', '80.00', '0.00', '', '0.00', '0', '21800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9344, '457623439551118', '8398991967', '263', NULL, '', '1.00', '400.00', '350', '400.00', '0.00', '', '0.00', '0', '21800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9343, '913417264886265', '8398991967', '220', NULL, '', '2.00', '200.00', '180', '400.00', '0.00', '', '0.00', '0', '21800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9342, '173321637476295', '8398991967', '600', NULL, '', '2.00', '50.00', '160.667', '100.00', '0.00', '', '0.00', '0', '21800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9341, '393263219466763', '8398991967', '225', NULL, '', '1.00', '500.00', '465', '500.00', '0.00', '', '0.00', '0', '21800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9340, '797854172979273', '8398991967', '715', NULL, '', '8.00', '120.00', '120', '960.00', '0.00', '', '0.00', '0', '21800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9339, '598852427579118', '8398991967', '625', NULL, '', '4.00', '50.00', '39.75', '200.00', '0.00', '', '0.00', '0', '21800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9338, '392323715781186', '8398991967', '1027', NULL, '', '20.00', '70.00', '65', '1400.00', '0.00', '', '0.00', '0', '21800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6227, '316925299421581', '5732915468', '714', NULL, '', '2.00', '350.00', '325', '700.00', '0.00', '', '0.00', '0', '13280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6226, '825552613116599', '5732915468', '284', NULL, '', '5.00', '345.00', '33.5', '250.00', '0.00', '', '0.00', '0', '13280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6225, '833475459433688', '5732915468', '602', NULL, '', '1.00', '1600.00', '1500', '1600.00', '0.00', '', '0.00', '0', '13280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6224, '383161331961991', '5732915468', '968', NULL, '', '1.00', '1600.00', '1550', '1600.00', '0.00', '', '0.00', '0', '13280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6223, '957541738776131', '5732915468', '92', NULL, '', '2.00', '250.00', '260', '500.00', '0.00', '', '0.00', '0', '13280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6222, '244376739511965', '5732915468', '86', NULL, '', '2.00', '440.00', '390', '880.00', '0.00', '', '0.00', '0', '13280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6221, '348353934371155', '5732915468', '495', NULL, '', '1.00', '660.00', '650', '660.00', '0.00', '', '0.00', '0', '13280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6220, '459363748834336', '5732915468', '264', NULL, '', '1.00', '150.00', '80', '150.00', '0.00', '', '0.00', '0', '13280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6219, '294948527674424', '5732915468', '265', NULL, '', '1.00', '200.00', '120', '200.00', '0.00', '', '0.00', '0', '13280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6218, '419454691318919', '5732915468', '57', NULL, '', '1.00', '150.00', '140', '150.00', '0.00', '', '0.00', '0', '13280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6217, '419544927117354', '5732915468', '411', NULL, '', '1.00', '3500.00', '3300', '3500.00', '0.00', '', '0.00', '0', '13280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6216, '666859532116197', '5732915468', '372', NULL, '', '10.00', '50.00', '40', '500.00', '0.00', '', '0.00', '0', '13280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6215, '944733293928362', '5732915468', '946', NULL, '', '1.00', '2400.00', '2500', '2400.00', '0.00', '', '0.00', '0', '13280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5395, '457732599136811', '3586992742', '813', NULL, '', '8.00', '90.00', '79', '720.00', '0.00', '', '0.00', '0', '57010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5394, '122847869639854', '3586992742', '175', NULL, '', '1.00', '180.00', '125', '180.00', '0.00', '', '0.00', '0', '57010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5393, '991732425681716', '3586992742', '489', NULL, '', '1.00', '180.00', '125', '180.00', '0.00', '', '0.00', '0', '57010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5392, '836213381448577', '3586992742', '935', NULL, '', '3.00', '50.00', '35', '150.00', '0.00', '', '0.00', '0', '57010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5391, '799773713384523', '3586992742', '37', NULL, '', '4.00', '40.00', '10', '160.00', '0.00', '', '0.00', '0', '57010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5390, '797552562246355', '3586992742', '417', NULL, '', '1.00', '4300.00', '4300', '4300.00', '0.00', '', '0.00', '0', '57010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5389, '636979189118723', '3586992742', '71', NULL, '', '3.00', '2000.00', '2250', '6000.00', '0.00', '', '0.00', '0', '57010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5388, '366634438184442', '3586992742', '625', NULL, '', '1.00', '50.00', '41', '50.00', '0.00', '', '0.00', '0', '57010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5387, '295994899787657', '3586992742', '963', NULL, '', '1.00', '2700.00', '2500', '2700.00', '0.00', '', '0.00', '0', '57010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5386, '169521879561755', '3586992742', '239', NULL, '', '4.00', '350.00', '360', '1400.00', '0.00', '', '0.00', '0', '57010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5385, '137783149213185', '3586992742', '221', NULL, '', '1.00', '600.00', '500', '600.00', '0.00', '', '0.00', '0', '57010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5384, '656395113281248', '3586992742', '1014', NULL, '', '6.00', '180.00', '160', '1080.00', '0.00', '', '0.00', '0', '57010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5383, '378363416768776', '3586992742', '584', NULL, '', '2.00', '2500.00', '2600', '5000.00', '0.00', '', '0.00', '0', '57010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5382, '775875588167243', '3586992742', '583', NULL, '', '1.00', '2000.00', '2300', '2000.00', '0.00', '', '0.00', '0', '57010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5381, '778133515634934', '3586992742', '993', NULL, '', '1.00', '9200.00', '9200', '9200.00', '0.00', '', '0.00', '0', '57010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5380, '119121933486634', '3586992742', '1025', NULL, '', '1.00', '6300.00', '5800', '6300.00', '0.00', '', '0.00', '0', '57010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5379, '476295875561797', '3586992742', '220', NULL, '', '5.00', '450.00', '180', '2250.00', '0.00', '', '0.00', '0', '57010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5378, '539954117341888', '3586992742', '369', NULL, '', '5.00', '130.00', '84', '650.00', '0.00', '', '0.00', '0', '57010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5377, '539985962477838', '3586992742', '920', NULL, '', '6.00', '25.00', '20', '150.00', '0.00', '', '0.00', '0', '57010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5376, '172926297192926', '3586992742', '684', NULL, '', '5.00', '400.00', '360', '2000.00', '0.00', '', '0.00', '0', '57010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5375, '657195187525571', '3586992742', '243', NULL, '', '15.00', '450.00', '430', '6750.00', '0.00', '', '0.00', '0', '57010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5374, '824538364276852', '3586992742', '649', NULL, '', '1.00', '3000.00', '2961', '3000.00', '0.00', '', '0.00', '0', '57010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5396, '876251443731876', '3586992742', '366', NULL, '', '2.00', '65.00', '46', '130.00', '0.00', '', '0.00', '0', '57010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5397, '439574682912329', '3586992742', '19', NULL, '', '8.00', '54.00', '70', '560.00', '0.00', '', '0.00', '0', '57010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5398, '298133229382762', '3586992742', '371', NULL, '', '30.00', '50.00', '34', '1500.00', '0.00', '', '0.00', '0', '57010.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9368, '737683583635638', '6351564964', '918', NULL, '', '1.00', '150.00', '155', '150.00', '0.00', '', '0.00', '0', '5040.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9367, '623111262457379', '6351564964', '675', NULL, '', '1.00', '50.00', '50', '50.00', '0.00', '', '0.00', '0', '5040.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5421, '719864717246761', '6658398886', '560', NULL, '', '11.00', '380.00', '310', '4180.00', '0.00', '', NULL, '0', '1411870.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5578, '546148526315813', '5744799622', '555', NULL, '', '1.00', '1800.00', '1525', '1800.00', '0.00', '', '0.00', '0', '1440950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5577, '294463311186336', '5744799622', '535', NULL, '', '3.00', '200.00', '140', '600.00', '0.00', '', '0.00', '0', '1440950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5576, '725265665386816', '5744799622', '534', NULL, '', '3.00', '250.00', '130', '750.00', '0.00', '', '0.00', '0', '1440950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5575, '945687311483788', '5744799622', '532', NULL, '', '1.00', '1800.00', '1550', '1800.00', '0.00', '', '0.00', '0', '1440950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5574, '271527416773368', '5744799622', '585', NULL, '', '1.00', '2700.00', '2200', '2700.00', '0.00', '', '0.00', '0', '1440950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5573, '822847169374616', '5744799622', '792', NULL, '', '1.00', '3400.00', '3050', '3400.00', '0.00', '', '0.00', '0', '1440950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5572, '143346959417721', '5744799622', '541 ', NULL, '', '8.00', '850.00', '625', '6800.00', '0.00', '', '0.00', '0', '1440950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5571, '569734758264669', '5744799622', '996', NULL, '', '27.00', '50.00', '30', '1350.00', '0.00', '', '0.00', '0', '1440950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5570, '119272187179695', '5744799622', '546', NULL, '', '16.00', '60.00', '37.5', '960.00', '0.00', '', '0.00', '0', '1440950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5569, '315716799447344', '5744799622', '543', NULL, '', '16.00', '40.00', '30', '640.00', '0.00', '', '0.00', '0', '1440950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5568, '554269272678583', '5744799622', '560', NULL, '', '8.00', '380.00', '310', '3040.00', '0.00', '', '0.00', '0', '1440950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5433, '654447539831282', '2817362753', '972', NULL, '', '1.00', '12500.00', '10000', '12500.00', '0.00', '', NULL, '0', '1456510.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5434, '513167149636985', '2817362753', '974', NULL, '', '2.00', '3600.00', '2800', '7200.00', '0.00', '', NULL, '0', '1456510.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5435, '496368535328743', '2817362753', '973', NULL, '', '1.00', '600.00', '300', '600.00', '0.00', '', NULL, '0', '1456510.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5436, '318484282768382', '2925755632', '560', NULL, '', '15.00', '380.00', '310', '5700.00', '0.00', '', NULL, '0', '1462210.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5470, '762915938775835', '4937312758', '825', NULL, '', '100.00', '120.00', '115', '12000.00', '0.00', '', '0.00', '0', '635375.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5439, '538471326838158', '2465779867', '291', NULL, '', '1.00', '9500.00', '9331', '9500.00', '0.00', '', NULL, '0', '647875.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5440, '782637376778258', '2465779867', '650', NULL, '', '1.00', '3000.00', '2961', '3000.00', '0.00', '', NULL, '0', '647875.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5441, '389992396249526', '7855113342', '116', NULL, '', '2.00', '840.00', '550', '1680.00', '0.00', '', NULL, '0', '19200.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5442, '767474935729472', '7855113342', '382', NULL, '', '1.00', '70.00', '46', '70.00', '0.00', '', NULL, '0', '19200.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5443, '466674934354366', '7855113342', '921', NULL, '', '6.00', '60.00', '50', '360.00', '0.00', '', NULL, '0', '19200.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5444, '888336861781796', '7855113342', '422', NULL, '', '24.00', '50.00', '30', '1200.00', '0.00', '', NULL, '0', '19200.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5445, '367952711111117', '7855113342', '489', NULL, '', '1.00', '240.00', '125', '240.00', '0.00', '', NULL, '0', '19200.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5446, '874864415325111', '7855113342', '579', NULL, '', '1.00', '3000.00', '2200', '3000.00', '0.00', '', NULL, '0', '19200.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5447, '158233227881183', '7855113342', '304', NULL, '', '2.00', '2400.00', '2000', '4800.00', '0.00', '', NULL, '0', '19200.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5448, '675522332679857', '7855113342', '305', NULL, '', '1.00', '3300.00', '2900', '3300.00', '0.00', '', NULL, '0', '19200.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5449, '588411171365169', '5929568811', '649', NULL, '', '2.00', '3000.00', '2961', '6000.00', '0.00', '', NULL, '0', '944916.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5450, '361593437517937', '5929568811', '116', NULL, '', '2.00', '650.00', '550', '1300.00', '0.00', '', NULL, '0', '944916.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5451, '792853571227155', '5929568811', '295', NULL, '', '1.00', '4200.00', '3936', '4200.00', '0.00', '', NULL, '0', '944916.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5452, '393778795448282', '5929568811', '824', NULL, '', '1.00', '4800.00', '4000', '4800.00', '0.00', '', NULL, '0', '944916.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6608, '431648692919876', '8429856221', '811', NULL, '', '100.00', '105.00', '103', '10500.00', '0.00', '', '0.00', '0', '261832.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6607, '634942614174851', '8429856221', '363', NULL, '', '2.00', '330.00', '320', '660.00', '0.00', '', '0.00', '0', '261832.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6606, '351511878812365', '8429856221', '494', NULL, '', '3.00', '300.00', '290', '900.00', '0.00', '', '0.00', '0', '261832.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6605, '982515914624481', '8429856221', '653', NULL, '', '1.00', '3000.00', '2961', '3000.00', '0.00', '', '0.00', '0', '261832.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6604, '673678347851421', '8429856221', '654', NULL, '', '1.00', '3000.00', '2961', '3000.00', '0.00', '', '0.00', '0', '261832.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6603, '243432951118715', '8429856221', '411', NULL, '', '2.00', '3500.00', '3300', '7000.00', '0.00', '', '0.00', '0', '261832.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6602, '781924528383296', '8429856221', '410', NULL, '', '3.00', '1700.00', '1650', '5100.00', '0.00', '', '0.00', '0', '261832.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6601, '822288111371156', '8429856221', '1034', NULL, '', '10.00', '150.00', '155', '1500.00', '0.00', '', '0.00', '0', '261832.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6600, '793625731831637', '8429856221', '2', NULL, '', '4.00', '260.00', '190', '1040.00', '0.00', '', '0.00', '0', '261832.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6599, '395149738379959', '8429856221', '700', NULL, '', '9.00', '160.00', '160', '1440.00', '0.00', '', '0.00', '0', '261832.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6598, '256726861494114', '8429856221', '61', NULL, '', '1.00', '160.00', '160', '160.00', '0.00', '', '0.00', '0', '261832.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6597, '729255411484572', '8429856221', '1', NULL, '', '3.00', '440.00', '370', '1320.00', '0.00', '', '0.00', '0', '261832.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6596, '775139786324799', '8429856221', '100', NULL, '', '10.00', '330.00', '300', '3300.00', '0.00', '', '0.00', '0', '261832.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5656, '831216339726387', '9922541324', '218', NULL, '', '10.00', '190.00', '170', '1900.00', '0.00', '', '0.00', '0', '249220.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5655, '523698923831556', '9922541324', '224', NULL, '', '2.00', '650.00', '550', '1300.00', '0.00', '', '0.00', '0', '249220.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5654, '342352555313265', '9922541324', '110', NULL, '', '1.00', '1250.00', '1296', '1250.00', '0.00', '', '0.00', '0', '249220.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5653, '533836596646944', '9922541324', '728', NULL, '', '2.00', '300.00', '260', '600.00', '0.00', '', '0.00', '0', '249220.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5650, '271886367462144', '4493439377', '1042', NULL, '', '1.00', '14400.00', '14400', '14400.00', '0.00', '', '0.00', '0', '81910.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5649, '125247852237793', '4493439377', '600', NULL, '', '3.00', '50.00', '221', '150.00', '0.00', '', '0.00', '0', '81910.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5648, '882496339145252', '4493439377', '334', NULL, '', '1.00', '16500.00', '16689', '16500.00', '0.00', '', '0.00', '0', '81910.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5647, '385759562231426', '4493439377', '625', NULL, '', '4.00', '50.00', '41', '200.00', '0.00', '', '0.00', '0', '81910.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5646, '244338134328599', '4493439377', '1033', NULL, '', '4.00', '2700.00', '2400', '10800.00', '0.00', '', '0.00', '0', '81910.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5645, '487182524418532', '4493439377', '735', NULL, '', '1.00', '200.00', '150', '200.00', '0.00', '', '0.00', '0', '81910.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5644, '135689616495742', '4493439377', '736', NULL, '', '1.00', '300.00', '250', '300.00', '0.00', '', '0.00', '0', '81910.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5643, '827957959165515', '4493439377', '995', NULL, '', '15.00', '120.00', '106', '1800.00', '0.00', '', '0.00', '0', '81910.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5642, '562834724772115', '4493439377', '175', NULL, '', '2.00', '180.00', '125', '360.00', '0.00', '', '0.00', '0', '81910.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5641, '777111114565123', '4493439377', '24', NULL, '', '1.00', '120.00', '750', '120.00', '0.00', '', '0.00', '0', '81910.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5640, '515562597137581', '4493439377', '1012', NULL, '', '6.00', '10.00', '5', '60.00', '0.00', '', '0.00', '0', '81910.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5639, '184249324436385', '4493439377', '1028', NULL, '', '2.00', '1550.00', '1300', '3100.00', '0.00', '', '0.00', '0', '81910.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5638, '361655722652199', '4493439377', '1030', NULL, '', '20.00', '320.00', '275', '6400.00', '0.00', '', '0.00', '0', '81910.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5637, '281992848155268', '4493439377', '1029', NULL, '', '1.00', '1050.00', '900', '1050.00', '0.00', '', '0.00', '0', '81910.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5636, '314879574667631', '4493439377', '1031', NULL, '', '1.00', '4500.00', '4200', '4500.00', '0.00', '', '0.00', '0', '81910.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5635, '744589191497278', '4493439377', '1035', NULL, '', '36.00', '10.00', '6', '360.00', '0.00', '', '0.00', '0', '81910.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5634, '111741681444175', '4493439377', '221', NULL, '', '3.00', '750.00', '500', '2250.00', '0.00', '', '0.00', '0', '81910.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5502, '956641852613878', '3675182878', '963', NULL, '', '4.00', '2500.00', '2500', '10000.00', '0.00', '', NULL, '0', '927047.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5503, '819248128735534', '3675182878', '68', NULL, '', '4.00', '2500.00', '2600', '10000.00', '0.00', '', NULL, '0', '927047.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5504, '491782575163826', '3675182878', '964', NULL, '', '8.00', '5000.00', '5000', '40000.00', '0.00', '', NULL, '0', '927047.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5546, '333619621518697', '9631931262', '824', NULL, '', '1.00', '4800.00', '4000', '4800.00', '0.00', '', '0.00', '0', '420420.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5545, '774546199888141', '9631931262', '207', NULL, '', '1.00', '1400.00', '1300', '1400.00', '0.00', '', '0.00', '0', '420420.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5544, '853179743366723', '9631931262', '759', NULL, '', '1.00', '1200.00', '1000', '1200.00', '0.00', '', '0.00', '0', '420420.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5543, '982354152364523', '9631931262', '93', NULL, '', '2.00', '300.00', '270', '600.00', '0.00', '', '0.00', '0', '420420.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5542, '881835252522261', '9631931262', '103', NULL, '', '1.00', '360.00', '320', '360.00', '0.00', '', '0.00', '0', '420420.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5541, '953332718621462', '9631931262', '2', NULL, '', '4.00', '260.00', '190', '1040.00', '0.00', '', '0.00', '0', '420420.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5540, '294464968682575', '9631931262', '222', NULL, '', '12.00', '250.00', '230', '3000.00', '0.00', '', '0.00', '0', '420420.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5539, '259885487181458', '9631931262', '221', NULL, '', '2.00', '500.00', '500', '1000.00', '0.00', '', '0.00', '0', '420420.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5538, '478881645847387', '9631931262', '420', NULL, '', '1.00', '4200.00', '3936', '4200.00', '0.00', '', '0.00', '0', '420420.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5537, '476195235647188', '9631931262', '150', NULL, '', '2.00', '1250.00', '1044', '2500.00', '0.00', '', '0.00', '0', '420420.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5536, '423921367768783', '9631931262', '149', NULL, '', '2.00', '1250.00', '1044', '2500.00', '0.00', '', '0.00', '0', '420420.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5535, '678922862246462', '9631931262', '152', NULL, '', '2.00', '1850.00', '1557', '3700.00', '0.00', '', '0.00', '0', '420420.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5534, '243126942251529', '9631931262', '156', NULL, '', '5.00', '3300.00', '3208', '16500.00', '0.00', '', '0.00', '0', '420420.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5533, '458128637958736', '9631931262', '155', NULL, '', '6.00', '3300.00', '3208', '19800.00', '0.00', '', '0.00', '0', '420420.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5532, '125464566472584', '9631931262', '151', NULL, '', '6.00', '2400.00', '1557', '14400.00', '0.00', '', '0.00', '0', '420420.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5531, '215167323966666', '9631931262', '154', NULL, '', '5.00', '2400.00', '2292', '12000.00', '0.00', '', '0.00', '0', '420420.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5530, '919777935128883', '9631931262', '321', NULL, '', '1.00', '9600.00', '9331', '9600.00', '0.00', '', '0.00', '0', '420420.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5529, '475543622255438', '9631931262', '291', NULL, '', '1.00', '9600.00', '9331', '9600.00', '0.00', '', '0.00', '0', '420420.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5528, '629331536851177', '9631931262', '290', NULL, '', '4.00', '6200.00', '6146', '24800.00', '0.00', '', '0.00', '0', '420420.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5527, '819938332937279', '9631931262', '650', NULL, '', '6.00', '3000.00', '2961', '18000.00', '0.00', '', '0.00', '0', '420420.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5526, '555594267936348', '9631931262', '649', NULL, '', '6.00', '3000.00', '2961', '18000.00', '0.00', '', '0.00', '0', '420420.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5547, '113618375638351', '9631931262', '151', NULL, '', '2.00', '1850.00', '1557', '3700.00', '0.00', '', '0.00', '0', '420420.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5548, '281664577889962', '8381957215', '410', NULL, '', '1.00', '1700.00', '1650', '1700.00', '0.00', '', NULL, '0', '968076.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5549, '366671897464954', '8381957215', '295', NULL, '', '1.00', '4200.00', '3936', '4200.00', '0.00', '', NULL, '0', '968076.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5550, '383243959395894', '8381957215', '932', NULL, '', '2.00', '1200.00', '1200', '2400.00', '0.00', '', NULL, '0', '968076.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5551, '741145699195538', '8381957215', '294', NULL, '', '1.00', '7300.00', '7121', '7300.00', '0.00', '', NULL, '0', '968076.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5552, '873493422767769', '8381957215', '295', NULL, '', '1.00', '4200.00', '3936', '4200.00', '0.00', '', NULL, '0', '968076.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5553, '183246291518242', '8381957215', '270', NULL, '', '2.00', '180.00', '160', '360.00', '0.00', '', NULL, '0', '968076.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5554, '478445887144524', '8381957215', '649', NULL, '', '1.00', '3000.00', '2961', '3000.00', '0.00', '', NULL, '0', '968076.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5567, '529584593668278', '5744799622', '538', NULL, '', '10.00', '230.00', '160', '2300.00', '0.00', '', '0.00', '0', '1440950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5579, '494516395419754', '5744799622', '537', NULL, '', '14.00', '210.00', '160', '2940.00', '0.00', '', '0.00', '0', '1440950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5581, '587985354413744', '3253633293', '560', NULL, '', '25.00', '380.00', '310', '9500.00', '0.00', '', '0.00', '0', '1476450.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5582, '236336784471378', '6194973291', '974', NULL, '', '4.00', '3600.00', '2800', '14400.00', '0.00', '', NULL, '0', '1490850.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5584, '647378393919697', '5777367333', '812', NULL, '', '10.00', '200.00', '90', '2000.00', '0.00', '', '0.00', '0', '78850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6201, '564767379161669', '2271855841', '714', NULL, '', '2.00', '350.00', '325', '700.00', '0.00', '', '0.00', '0', '171556.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6200, '345821296636587', '2271855841', '699', NULL, '', '4.00', '340.00', '320', '1360.00', '0.00', '', '0.00', '0', '171556.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6199, '324128748417136', '2271855841', '238', NULL, '', '2.00', '340.00', '320', '680.00', '0.00', '', '0.00', '0', '171556.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6198, '357942868682118', '2271855841', '237', NULL, '', '2.00', '575.00', '530', '1150.00', '0.00', '', '0.00', '0', '171556.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5633, '367552658152493', '4493439377', '218', NULL, '', '3.00', '180.00', '170', '540.00', '0.00', '', '0.00', '0', '81910.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5632, '292972338323884', '4493439377', '1041', NULL, '', '20.00', '10.00', '25', '200.00', '0.00', '', '0.00', '0', '81910.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5631, '658524929746727', '4493439377', '1036', NULL, '', '1.00', '2800.00', '2800', '2800.00', '0.00', '', '0.00', '0', '81910.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5630, '664219828553528', '4493439377', '1016', NULL, '', '24.00', '40.00', '30', '960.00', '0.00', '', '0.00', '0', '81910.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5651, '555463247793499', '4493439377', '375', NULL, '', '3.00', '40.00', '15', '120.00', '0.00', '', '0.00', '0', '81910.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5652, '287277629744155', '4493439377', '1043', NULL, '', '3.00', '60.00', '20', '180.00', '0.00', '', '0.00', '0', '81910.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5657, '614758745465989', '9922541324', '224', NULL, '', '2.00', '750.00', '550', '1500.00', '0.00', '', '0.00', '0', '249220.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5658, '968342449815621', '1231988793', '193', NULL, '', '2.00', '1750.00', '1700', '3500.00', '0.00', '', NULL, '0', '8000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5659, '377636437477298', '1231988793', '700', NULL, '', '3.00', '170.00', '160', '510.00', '0.00', '', NULL, '0', '8000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5660, '727951528441961', '1231988793', '812', NULL, '', '20.00', '115.00', '90', '2300.00', '0.00', '', NULL, '0', '8000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5661, '237516233862731', '1231988793', '93', NULL, '', '1.00', '350.00', '270', '350.00', '0.00', '', NULL, '0', '8000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5662, '459174929647184', '1231988793', '2', NULL, '', '2.00', '180.00', '190', '360.00', '0.00', '', NULL, '0', '8000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5663, '263497553399999', '1231988793', '38', NULL, '', '10.00', '35.00', '20', '350.00', '0.00', '', NULL, '0', '8000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5664, '386441464852884', '1231988793', '241', NULL, '', '1.00', '190.00', '160', '190.00', '0.00', '', NULL, '0', '8000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5665, '185315487212973', '1231988793', '284', NULL, '', '10.00', '45.00', '40', '450.00', '0.00', '', NULL, '0', '8000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5731, '126193251781464', '6677889362', '709', NULL, '', '1.00', '600.00', '500', '600.00', '0.00', '', '0.00', '0', '14850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5730, '225382865855118', '6677889362', '1039', NULL, '', '8.00', '25.00', '12', '200.00', '0.00', '', '0.00', '0', '14850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5729, '268225969186556', '6677889362', '773', NULL, '', '1.00', '150.00', '80', '150.00', '0.00', '', '0.00', '0', '14850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5728, '222359683737342', '6677889362', '625', NULL, '', '2.00', '50.00', '41', '100.00', '0.00', '', '0.00', '0', '14850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5727, '717422445868948', '6677889362', '649', NULL, '', '1.00', '2910.00', '2961', '2910.00', '0.00', '', '0.00', '0', '14850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5726, '983923489367634', '6677889362', '784', NULL, '', '1.00', '200.00', '135', '200.00', '0.00', '', '0.00', '0', '14850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5725, '921198149414553', '6677889362', '813', NULL, '', '35.00', '90.00', '79', '3150.00', '0.00', '', '0.00', '0', '14850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5724, '553552425459492', '6677889362', '886', NULL, '', '1.00', '300.00', '277', '300.00', '0.00', '', '0.00', '0', '14850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5723, '669127816527213', '6677889362', '1027', NULL, '', '12.00', '70.00', '65', '840.00', '0.00', '', '0.00', '0', '14850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5722, '532899936663965', '6677889362', '699', NULL, '', '5.00', '350.00', '320', '1750.00', '0.00', '', '0.00', '0', '14850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5721, '379789866351432', '6677889362', '1037', NULL, '', '10.00', '10.00', '9', '100.00', '0.00', '', '0.00', '0', '14850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5720, '185132517918816', '6677889362', '78', NULL, '', '1.00', '150.00', '160', '150.00', '0.00', '', '0.00', '0', '14850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5719, '764144718598365', '6677889362', '60', NULL, '', '8.00', '250.00', '200', '2000.00', '0.00', '', '0.00', '0', '14850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5718, '357273327721532', '6677889362', '217', NULL, '', '1.00', '150.00', '180', '150.00', '0.00', '', '0.00', '0', '14850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5717, '372697593545776', '6677889362', '263', NULL, '', '2.00', '450.00', '350', '900.00', '0.00', '', '0.00', '0', '14850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5716, '438943652622686', '6677889362', '377', NULL, '', '4.00', '25.00', '30', '100.00', '0.00', '', '0.00', '0', '14850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5715, '458494988244825', '6677889362', '372', NULL, '', '15.00', '50.00', '40', '750.00', '0.00', '', '0.00', '0', '14850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5732, '168586791233121', '6677889362', '377', NULL, '', '10.00', '50.00', '30', '500.00', '0.00', '', '0.00', '0', '14850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9335, '783756856315384', '2243328791', '1047', NULL, '', '1.00', '20.00', '24', '20.00', '0.00', '', '0.00', '0', '46600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9334, '676157495137744', '2243328791', '841', NULL, '', '1.00', '30.00', '25', '30.00', '0.00', '', '0.00', '0', '46600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9333, '378696933786252', '2243328791', '833', NULL, '', '4.00', '50.00', '25', '200.00', '0.00', '', '0.00', '0', '46600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9332, '248281344674348', '2243328791', '363', NULL, '', '1.00', '300.00', '320', '300.00', '0.00', '', '0.00', '0', '46600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9331, '165777313734379', '2243328791', '904', NULL, '', '2.00', '25.00', '3', '50.00', '0.00', '', '0.00', '0', '46600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9330, '874665594346873', '2243328791', '373', NULL, '', '10.00', '20.00', '17', '200.00', '0.00', '', '0.00', '0', '46600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9329, '167375927357733', '2243328791', '372', NULL, '', '7.00', '50.00', '40', '350.00', '0.00', '', '0.00', '0', '46600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9328, '237392864486716', '2243328791', '57', NULL, '', '4.00', '150.00', '140', '600.00', '0.00', '', '0.00', '0', '46600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9327, '675828167211515', '2243328791', '239', NULL, '', '2.00', '400.00', '360', '800.00', '0.00', '', '0.00', '0', '46600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9326, '122159456257813', '2243328791', '247', NULL, '', '2.00', '650.00', '665', '1300.00', '0.00', '', '0.00', '0', '46600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9325, '959493398153111', '2243328791', '377', NULL, '', '5.00', '30.00', '30', '150.00', '0.00', '', '0.00', '0', '46600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9324, '548653641193328', '2243328791', '1029', NULL, '', '1.00', '850.00', '900', '850.00', '0.00', '', '0.00', '0', '46600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9312, '291521368582824', '4883297114', '375', NULL, '', '2.00', '40.00', '15', '80.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9311, '891235482623167', '4883297114', '57', NULL, '', '9.00', '150.00', '140', '1350.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9310, '598522897757794', '4883297114', '1055', NULL, '', '2.00', '750.00', '666.667', '1500.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9309, '111523664912836', '4883297114', '1093', NULL, '', '36.00', '230.00', '220', '8280.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9308, '435246447783845', '4883297114', '481', NULL, '', '2.00', '50.00', '90', '100.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9307, '282261174172268', '4883297114', '1028', NULL, '', '2.00', '1750.00', '1333.33', '3500.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9306, '918171233522756', '4883297114', '380', NULL, '', '1.00', '50.00', '25', '50.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9305, '632229486787316', '4883297114', '372', NULL, '', '10.00', '50.00', '40', '500.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9304, '358759578173395', '4883297114', '377', NULL, '', '10.00', '30.00', '30', '300.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9303, '345278736939115', '4883297114', '969', NULL, '', '1.00', '2400.00', '2100', '2400.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9302, '583269914929617', '4883297114', '381', NULL, '', '5.00', '50.00', '34', '250.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9301, '131296359233989', '4883297114', '843', NULL, '', '5.00', '20.00', '13', '100.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9300, '869644191127977', '4883297114', '812', NULL, '', '5.00', '150.00', '90', '750.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9299, '837484451221513', '4883297114', '57', NULL, '', '2.00', '150.00', '140', '300.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9298, '857576256242632', '4883297114', '1000', NULL, '', '8.00', '150.00', '140', '1200.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9297, '512283694197282', '4883297114', '711', NULL, '', '12.00', '62.50', '62', '750.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9296, '271341756551993', '4883297114', '92', NULL, '', '2.00', '250.00', '260', '500.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9295, '369521354454784', '4883297114', '420', NULL, '', '1.00', '3700.00', '3936', '3700.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9294, '542823868344825', '4883297114', '295', NULL, '', '1.00', '3700.00', '3936', '3700.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9293, '788224798398499', '4883297114', '694', NULL, '', '4.00', '150.00', '130', '600.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9292, '291313997928632', '4883297114', '259', NULL, '', '1.00', '1550.00', '1200', '1550.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9291, '462468985615628', '4883297114', '1050', NULL, '', '1.00', '850.00', '850', '850.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9290, '352269924291396', '4883297114', '773', NULL, '', '1.00', '150.00', '80', '150.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9289, '479364583423512', '4883297114', '841', NULL, '', '1.00', '40.00', '25', '40.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9288, '912414435223444', '4883297114', '839', NULL, '', '3.00', '20.00', '14', '60.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9287, '236198419275387', '4883297114', '1027', NULL, '', '54.00', '70.00', '65', '3780.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9286, '917822661954119', '4883297114', '625', NULL, '', '2.00', '50.00', '39.75', '100.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9285, '312511971486462', '4883297114', '1049', NULL, '', '1.00', '700.00', '750', '700.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9284, '226876919137284', '4883297114', '1016', NULL, '', '6.00', '40.00', '30', '240.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9283, '169352272554127', '4883297114', '1017', NULL, '', '2.00', '50.00', '45', '100.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9282, '121396667845186', '4883297114', '715', NULL, '', '25.00', '125.00', '120', '3125.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9281, '814413711914821', '4883297114', '959', NULL, '', '2.00', '1700.00', '1550', '3400.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9280, '376325858771281', '4883297114', '410', NULL, '', '1.00', '1700.00', '1650', '1700.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9279, '191729397156131', '4883297114', '411', NULL, '', '1.00', '3500.00', '3300', '3500.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9278, '665656266196727', '4883297114', '86', NULL, '', '1.00', '600.00', '390', '600.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9277, '147345946773298', '4883297114', '748', NULL, '', '1.00', '540.00', '530', '540.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9276, '831836564479413', '4883297114', '270', NULL, '', '2.00', '240.00', '160', '480.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9275, '313747487813911', '4883297114', '883', NULL, '', '3.00', '500.00', '466.6', '1500.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9274, '999943285517238', '4883297114', '884', NULL, '', '1.00', '480.00', '458.667', '480.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9273, '576519866126696', '4883297114', '886', NULL, '', '4.00', '350.00', '277', '1400.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9272, '814891875752288', '4883297114', '659', NULL, '', '2.00', '1300.00', '1044', '2600.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9271, '853661373599183', '4883297114', '663', NULL, '', '2.00', '2400.00', '2292', '4800.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9270, '171539157162881', '4883297114', '263', NULL, '', '1.00', '450.00', '350', '450.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9269, '455276297872948', '4883297114', '600', NULL, '', '1.00', '50.00', '160.667', '50.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9268, '433999465844222', '4883297114', '220', NULL, '', '4.00', '250.00', '180', '1000.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9267, '972966658986292', '4883297114', '284', NULL, '', '4.00', '70.00', '33.5', '280.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9266, '256613136264978', '4883297114', '283', NULL, '', '4.00', '60.00', '30', '240.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9265, '922877626166989', '4883297114', '1132', NULL, '', '5.00', '20.00', '20', '100.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9264, '695255879494155', '4883297114', '1133', NULL, '', '2.00', '30.00', '30', '60.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9263, '149272199698314', '4883297114', '1177', NULL, '', '2.00', '40.00', '30', '80.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9262, '992497798925357', '4883297114', '375', NULL, '', '3.00', '40.00', '15', '120.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5891, '822391312918974', '2684671283', '1046', NULL, '', '2.00', '90.00', '50', '180.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5892, '677255311865758', '2684671283', '999', NULL, '', '1.00', '3600.00', '3600', '3600.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5893, '621879277473426', '2684671283', '266', NULL, '', '1.00', '350.00', '220', '350.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5894, '681856694939974', '2684671283', '377', NULL, '', '6.00', '50.00', '30', '300.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5895, '436515315142266', '2684671283', '830', NULL, '', '12.00', '3020.00', '87.5', '1080.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5896, '953838262445957', '2684671283', '966', NULL, '', '1.00', '3300.00', '3000', '3300.00', '0.00', '', '0.00', '0', '35398.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9380, '478397918634562', '6667973681', '982', NULL, '', '4.00', '100.00', '60', '400.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9379, '417717676732452', '6667973681', '978', NULL, '', '4.00', '4450.00', '4400', '17800.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5986, '582243249577125', '7681616844', '551', NULL, '', '16.00', '0.00', '150', '0.00', '0.00', '', '0.00', '0', '0.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5985, '232222745836569', '7681616844', '648', NULL, '', '1.00', '0.00', '300', '0.00', '0.00', '', '0.00', '0', '0.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5984, '823731194527736', '7681616844', '540', NULL, '', '108.00', '0.00', '15', '0.00', '0.00', '', '0.00', '0', '0.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5983, '646581657421869', '7681616844', '514', NULL, '', '11.00', '0.00', '50', '0.00', '0.00', '', '0.00', '0', '0.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5982, '238864826932395', '7681616844', '1044', NULL, '', '8.00', '0.00', '25', '0.00', '0.00', '', '0.00', '0', '0.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5981, '537878815572523', '7681616844', '517', NULL, '', '1.00', '0.00', '12', '0.00', '0.00', '', '0.00', '0', '0.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5980, '785592914231495', '7681616844', '792', NULL, '', '1.00', '0.00', '3050', '0.00', '0.00', '', '0.00', '0', '0.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5979, '458929175679878', '7681616844', '516', NULL, '', '2.00', '0.00', '30', '0.00', '0.00', '', '0.00', '0', '0.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5978, '636753479829443', '7681616844', '515', NULL, '', '4.00', '0.00', '75', '0.00', '0.00', '', '0.00', '0', '0.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (5977, '455277234373552', '7681616844', '556', NULL, '', '0.20', '0.00', '3100', '0.00', '0.00', '', '0.00', '0', '0.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6098, '832791844137647', '4275369827', '284', NULL, '', '1.00', '60.00', '40', '60.00', '0.00', '', '0.00', '0', '97340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6097, '123682272745381', '4275369827', '27', NULL, '', '1.00', '50.00', '33', '50.00', '0.00', '', '0.00', '0', '97340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6096, '168981565455121', '4275369827', '481', NULL, '', '2.00', '50.00', '156.5', '100.00', '0.00', '', '0.00', '0', '97340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6095, '232975253667233', '4275369827', '993', NULL, '', '8.00', '8200.00', '9200', '65600.00', '0.00', '', '0.00', '0', '97340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6094, '711868718812543', '4275369827', '584', NULL, '', '1.00', '4000.00', '2600', '4000.00', '0.00', '', '0.00', '0', '97340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6093, '316529361458314', '4275369827', '714', NULL, '', '2.00', '400.00', '325', '800.00', '0.00', '', '0.00', '0', '97340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6092, '863738268411297', '4275369827', '85', NULL, '', '4.00', '720.00', '660', '2880.00', '0.00', '', '0.00', '0', '97340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6091, '631769738566921', '4275369827', '398', NULL, '', '12.00', '530.00', '486', '6360.00', '0.00', '', '0.00', '0', '97340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6090, '989973896825617', '4275369827', '886', NULL, '', '5.00', '350.00', '277', '1750.00', '0.00', '', '0.00', '0', '97340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6089, '495789824613923', '4275369827', '888', NULL, '', '4.00', '350.00', '322', '1400.00', '0.00', '', '0.00', '0', '97340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6088, '948692875419273', '4275369827', '222', NULL, '', '12.00', '300.00', '230', '3600.00', '0.00', '', '0.00', '0', '97340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6087, '352852545579656', '4275369827', '221', NULL, '', '2.00', '600.00', '500', '1200.00', '0.00', '', '0.00', '0', '97340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6086, '849132458929816', '4275369827', '928', NULL, '', '3.00', '50.00', '35', '150.00', '0.00', '', '0.00', '0', '97340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6085, '912644376173691', '4275369827', '213', NULL, '', '1.00', '200.00', '170', '200.00', '0.00', '', '0.00', '0', '97340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6084, '367894741634338', '4275369827', '363', NULL, '', '1.00', '350.00', '320', '350.00', '0.00', '', '0.00', '0', '97340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6083, '219992347212247', '4275369827', '86', NULL, '', '1.00', '480.00', '390', '480.00', '0.00', '', '0.00', '0', '97340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6082, '788689944658932', '4275369827', '270', NULL, '', '1.00', '180.00', '160', '180.00', '0.00', '', '0.00', '0', '97340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6081, '238156795374753', '4275369827', '105', NULL, '', '3.00', '600.00', '510', '1800.00', '0.00', '', '0.00', '0', '97340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6080, '791443264856211', '4275369827', '1050', NULL, '', '1.00', '650.00', '850', '650.00', '0.00', '', '0.00', '0', '97340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6079, '123138328268175', '4275369827', '1072', NULL, '', '1.00', '150.00', '150', '150.00', '0.00', '', '0.00', '0', '97340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6078, '999217674151954', '4275369827', '272', NULL, '', '1.00', '180.00', '220', '180.00', '0.00', '', '0.00', '0', '97340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6077, '111642439719245', '4275369827', '693', NULL, '', '12.00', '150.00', '130', '1800.00', '0.00', '', '0.00', '0', '97340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6099, '175182718169467', '4275369827', '441', NULL, '', '12.00', '300.00', '300', '3600.00', '0.00', '', '0.00', '0', '97340.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6111, '913412239969848', '4167923813', '994', NULL, '', '30.00', '200.00', '165', '6000.00', '0.00', '', '0.00', '0', '377230.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6110, '815164873497756', '4167923813', '9', NULL, '', '12.00', '450.00', '430', '5400.00', '0.00', '', '0.00', '0', '377230.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6109, '724311858781412', '4167923813', '758', NULL, '', '3.00', '1400.00', '1100', '4200.00', '0.00', '', '0.00', '0', '377230.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6108, '329546979538683', '4167923813', '337', NULL, '', '1.00', '5000.00', '4911', '5000.00', '0.00', '', '0.00', '0', '377230.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6107, '198552659611288', '4167923813', '65', NULL, '', '1.00', '9500.00', '10300', '9500.00', '0.00', '', '0.00', '0', '377230.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6112, '926615275736659', '4167923813', '177', NULL, '', '2.00', '300.00', '165', '600.00', '0.00', '', '0.00', '0', '377230.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6113, '844394755139937', '4167923813', '178', NULL, '', '2.00', '225.00', '80', '450.00', '0.00', '', '0.00', '0', '377230.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6114, '315681445452278', '4167923813', '995', NULL, '', '30.00', '150.00', '106', '4500.00', '0.00', '', '0.00', '0', '377230.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6115, '536465147928366', '4167923813', '175', NULL, '', '2.00', '225.00', '125', '450.00', '0.00', '', '0.00', '0', '377230.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6116, '666519439795295', '4167923813', '176', NULL, '', '2.00', '150.00', '65', '300.00', '0.00', '', '0.00', '0', '377230.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6140, '677695138778215', '5791754729', '178', NULL, '', '1.00', '90.00', '80', '90.00', '0.00', '', '0.00', '0', '392865.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6139, '888429311213575', '5791754729', '177', NULL, '', '1.00', '300.00', '165', '300.00', '0.00', '', '0.00', '0', '392865.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6138, '516724153324947', '5791754729', '1074', NULL, '', '1.00', '185.00', '850', '850.00', '0.00', '', '0.00', '0', '392865.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6137, '768445948723331', '5791754729', '17', NULL, '', '12.00', '200.00', '180', '2400.00', '0.00', '', '0.00', '0', '392865.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6136, '697112477222546', '5791754729', '718', NULL, '', '12.00', '250.00', '220', '3000.00', '0.00', '', '0.00', '0', '392865.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6135, '516683751598166', '5791754729', '176', NULL, '', '1.00', '100.00', '65', '60.00', '0.00', '', '0.00', '0', '392865.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6134, '665616566551214', '5791754729', '995', NULL, '', '6.00', '150.00', '106', '900.00', '0.00', '', '0.00', '0', '392865.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6133, '432135256531123', '5791754729', '1053', NULL, '', '2.00', '200.00', '130', '400.00', '0.00', '', '0.00', '0', '392865.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6132, '113294877776416', '5791754729', '177', NULL, '', '1.00', '120.00', '165', '120.00', '0.00', '', '0.00', '0', '392865.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6131, '159522695647652', '5791754729', '758', NULL, '', '3.00', '1400.00', '1100', '4200.00', '0.00', '', '0.00', '0', '392865.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6130, '327441165168674', '5791754729', '178', NULL, '', '1.00', '225.00', '80', '225.00', '0.00', '', '0.00', '0', '392865.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6129, '248312251312793', '5791754729', '15', NULL, '', '15.00', '200.00', '135', '3000.00', '0.00', '', '0.00', '0', '392865.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6141, '913629511573123', '5791754729', '175', NULL, '', '1.00', '90.00', '125', '90.00', '0.00', '', '0.00', '0', '392865.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6157, '589884891731793', '1512924365', '650', NULL, '', '6.00', '3000.00', '2961', '18000.00', '0.00', '', '0.00', '0', '1028636.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6156, '481695941299439', '1512924365', '654', NULL, '', '2.00', '3000.00', '2961', '6000.00', '0.00', '', '0.00', '0', '1028636.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6155, '711637786329532', '1512924365', '649', NULL, '', '3.00', '3000.00', '2961', '9000.00', '0.00', '', '0.00', '0', '1028636.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6154, '994462365982738', '1512924365', '652', NULL, '', '5.00', '3000.00', '2961', '15000.00', '0.00', '', '0.00', '0', '1028636.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6153, '551926912459843', '1512924365', '420', NULL, '', '2.00', '4200.00', '3936', '8400.00', '0.00', '', '0.00', '0', '1028636.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6152, '134572652871711', '1512924365', '363', NULL, '', '8.00', '350.00', '320', '2800.00', '0.00', '', '0.00', '0', '1028636.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6151, '437948263582974', '1512924365', '270', NULL, '', '2.00', '180.00', '160', '360.00', '0.00', '', '0.00', '0', '1028636.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6150, '689282479577594', '1512924365', '201', NULL, '', '1.00', '1000.00', '800', '1000.00', '0.00', '', '0.00', '0', '1028636.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6158, '847545765541967', '4698376251', '136', NULL, '', '2.00', '3000.00', '2961', '6000.00', '0.00', '', NULL, '0', '447340.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6159, '242452327386122', '4698376251', '665', NULL, '', '2.00', '3400.00', '3208', '6800.00', '0.00', '', NULL, '0', '447340.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6160, '488112445995988', '4698376251', '883', NULL, '', '6.00', '490.00', '467.667', '2940.00', '0.00', '', NULL, '0', '447340.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6161, '835771729247395', '4698376251', '884', NULL, '', '6.00', '480.00', '463', '2880.00', '0.00', '', NULL, '0', '447340.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6162, '249622599715775', '4698376251', '886', NULL, '', '10.00', '300.00', '277', '3000.00', '0.00', '', NULL, '0', '447340.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6163, '442849184866976', '4698376251', '967', NULL, '', '1.00', '3800.00', '3500', '3800.00', '0.00', '', NULL, '0', '447340.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6196, '138883163935531', '4224926148', '811', NULL, '', '12.00', '105.00', '103', '1260.00', '0.00', '', '0.00', '0', '66285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6195, '393572771232218', '4224926148', '19', NULL, '', '12.00', '80.00', '70', '960.00', '0.00', '', '0.00', '0', '66285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6194, '515646235613117', '4224926148', '713', NULL, '', '3.00', '350.00', '310', '1050.00', '0.00', '', '0.00', '0', '66285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6193, '381113267531549', '4224926148', '271', NULL, '', '1.00', '120.00', '120', '120.00', '0.00', '', '0.00', '0', '66285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6192, '797927158443599', '4224926148', '9', NULL, '', '6.00', '400.00', '430', '2400.00', '0.00', '', '0.00', '0', '66285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6191, '837651581461955', '4224926148', '263', NULL, '', '1.00', '370.00', '350', '370.00', '0.00', '', '0.00', '0', '66285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6190, '565161941855225', '4224926148', '715', NULL, '', '25.00', '119.00', '120', '2975.00', '0.00', '', '0.00', '0', '66285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6189, '932279431332688', '4224926148', '837', NULL, '', '14.00', '80.00', '70', '1120.00', '0.00', '', '0.00', '0', '66285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6188, '251536477376491', '4224926148', '1014', NULL, '', '11.00', '150.00', '160', '1650.00', '0.00', '', '0.00', '0', '66285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6173, '813616641394238', '7732694976', '716', NULL, '', '4.00', '200.00', '190', '800.00', '0.00', '', NULL, '0', '15040.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6174, '632535293374977', '7732694976', '19', NULL, '', '6.00', '85.00', '70', '510.00', '0.00', '', NULL, '0', '15040.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6175, '874842873778759', '7732694976', '279', NULL, '', '1.00', '300.00', '260', '300.00', '0.00', '', NULL, '0', '15040.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6176, '823575359477131', '7732694976', '840', NULL, '', '2.00', '25.00', '20', '50.00', '0.00', '', NULL, '0', '15040.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6177, '684136366249237', '6597638334', '17', NULL, '', '24.00', '200.00', '180', '4800.00', '0.00', '', NULL, '0', '398505.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6178, '877695865316187', '6597638334', '175', NULL, '', '2.00', '240.00', '125', '480.00', '0.00', '', NULL, '0', '398505.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6179, '846928735118494', '6597638334', '176', NULL, '', '2.00', '180.00', '65', '360.00', '0.00', '', NULL, '0', '398505.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6180, '746628671613552', '6212555628', '495', NULL, '', '1.00', '700.00', '650', '700.00', '0.00', '', NULL, '0', '265962.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6181, '479486569282431', '6212555628', '121', NULL, '', '2.00', '320.00', '300', '640.00', '0.00', '', NULL, '0', '265962.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6182, '515146998648993', '6212555628', '38', NULL, '', '10.00', '35.00', '20', '350.00', '0.00', '', NULL, '0', '265962.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6183, '583852213838637', '6212555628', '2', NULL, '', '2.00', '240.00', '190', '480.00', '0.00', '', NULL, '0', '265962.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6184, '942656221874113', '6212555628', '95', NULL, '', '3.00', '420.00', '390', '1260.00', '0.00', '', NULL, '0', '265962.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6185, '234563237766456', '6212555628', '272', NULL, '', '1.00', '240.00', '220', '240.00', '0.00', '', NULL, '0', '265962.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6186, '614838647698835', '6212555628', '225', NULL, '', '2.00', '500.00', '480', '1000.00', '0.00', '', NULL, '0', '265962.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6187, '984361588333229', '4131963676', '420', NULL, '', '1.00', '4000.00', '3936', '4000.00', '0.00', '', NULL, '0', '387660.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6197, '321872824151114', '4224926148', '372', NULL, '', '22.00', '50.00', '40', '1100.00', '0.00', '', '0.00', '0', '66285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6202, '725483327612664', '2271855841', '236', NULL, '', '2.00', '950.00', '935', '1900.00', '0.00', '', '0.00', '0', '171556.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6203, '335534851835992', '2271855841', '1068', NULL, '', '2.00', '850.00', '770', '1700.00', '0.00', '', '0.00', '0', '171556.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6204, '139717433954813', '2271855841', '249', NULL, '', '1.00', '1800.00', '1750', '1800.00', '0.00', '', '0.00', '0', '171556.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6205, '582853516399468', '6821617226', '974', NULL, '', '2.00', '3600.00', '2800', '7200.00', '0.00', '', NULL, '0', '1529050.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6206, '134915722618952', '6821617226', '1048', NULL, '', '1.00', '31000.00', '25000', '31000.00', '0.00', '', NULL, '0', '1529050.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7993, '548364974221885', '1971361776', '1052', NULL, '', '2.00', '8700.00', '4200', '17400.00', '0.00', '', '0.00', '1555300', '1800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7992, '377649764314897', '1971361776', '532', NULL, '', '1.00', '1800.00', '1566.67', '1800.00', '0.00', '', '0.00', '1555300', '1800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7991, '813978161946847', '1971361776', '1051', NULL, '', '1.00', '2800.00', '1800', '2800.00', '0.00', '', '0.00', '1555300', '1800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7990, '942182238431795', '1971361776', '541 ', NULL, '', '5.00', '850.00', '616.667', '4250.00', '0.00', '', '0.00', '1555300', '1800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6211, '816971141159355', '6865261646', '712', NULL, '', '100.00', '380.00', '320', '38000.00', '0.00', '', NULL, '0', '38000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6214, '632271581413557', '9652589483', '636', NULL, '', '1.00', '300.00', '300', '300.00', '0.00', '', '0.00', '0', '1379570.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6228, '164891729781563', '5732915468', '176', NULL, '', '2.00', '95.00', '65', '190.00', '0.00', '', '0.00', '0', '13280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8555, '762598693927938', '2343991432', '1164', NULL, '', '1.00', '50.00', '50', '50.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8554, '883611688929214', '2343991432', '389', NULL, '', '1.00', '350.00', '336', '350.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8553, '899757498898628', '2343991432', '989', NULL, '', '1.00', '70.00', '60', '70.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8552, '435758935218843', '2343991432', '966', NULL, '', '1.00', '3400.00', '3000', '3400.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8551, '823238916966219', '2343991432', '837', NULL, '', '8.00', '90.00', '70', '720.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8550, '235347413568918', '2343991432', '54', NULL, '', '1.00', '300.00', '255', '300.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8549, '546981135713146', '2343991432', '224', NULL, '', '1.00', '550.00', '550', '550.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8548, '392976635621568', '2343991432', '269', NULL, '', '1.00', '150.00', '110', '150.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8547, '264232659441621', '2343991432', '1061', NULL, '', '2.00', '50.00', '50', '100.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8546, '366481519578278', '2343991432', '57', NULL, '', '1.00', '150.00', '140', '150.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8545, '386111692767998', '2343991432', '880', NULL, '', '3.00', '267.00', '220', '801.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8544, '962665679237822', '2343991432', '842', NULL, '', '1.00', '50.00', '25', '50.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8543, '155928576578858', '2343991432', '1055', NULL, '', '1.00', '1500.00', '666.667', '1500.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8542, '356664273666469', '2343991432', '730', NULL, '', '50.00', '160.00', '148', '8000.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8541, '142862925383451', '2343991432', '1038', NULL, '', '15.00', '15.00', '10', '225.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8540, '347611632439743', '2343991432', '995', NULL, '', '2.00', '150.00', '106', '300.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8539, '323647416863196', '2343991432', '1011', NULL, '', '3.00', '20.00', '11', '60.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8538, '333126117596193', '2343991432', '1012', NULL, '', '2.00', '15.00', '5', '30.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8537, '724823458856444', '2343991432', '838', NULL, '', '3.00', '30.00', '18', '90.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8536, '597252123973562', '2343991432', '625', NULL, '', '1.00', '50.00', '41', '50.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8535, '479292785987727', '2343991432', '266', NULL, '', '1.00', '450.00', '220', '450.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8534, '252993455748182', '2343991432', '1058', NULL, '', '4.00', '250.00', '200', '1000.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8533, '558635218297967', '2343991432', '909', NULL, '', '12.00', '10.00', '8', '120.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8532, '683752959895565', '2343991432', '375', NULL, '', '1.00', '40.00', '15', '40.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8531, '663686733156551', '2343991432', '1030', NULL, '', '7.00', '320.00', '273.333', '2240.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8530, '831975264417495', '2343991432', '1016', NULL, '', '4.00', '40.00', '30', '160.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8529, '471538839742717', '2343991432', '773', NULL, '', '1.00', '150.00', '80', '150.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8528, '656974259236142', '2343991432', '895', NULL, '', '1.00', '50.00', '45', '50.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8527, '331651733258375', '2343991432', '71', NULL, '', '1.00', '2100.00', '2250', '2100.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8526, '959613243155795', '2343991432', '72', NULL, '', '1.00', '2100.00', '2250', '2100.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8525, '348819693597852', '2343991432', '962', NULL, '', '1.00', '4300.00', '4100', '4300.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8524, '294988461289755', '2343991432', '284', NULL, '', '1.00', '50.00', '33.5', '50.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8523, '288112723389689', '2343991432', '836', NULL, '', '2.00', '50.00', '30', '100.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6262, '892843734676353', '3668139334', '265', NULL, '', '2.00', '200.00', '120', '400.00', '0.00', '', NULL, '0', '19360.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6263, '845956131466829', '3668139334', '833', NULL, '', '1.00', '50.00', '25', '50.00', '0.00', '', NULL, '0', '19360.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6264, '531965552293918', '3668139334', '837', NULL, '', '7.00', '90.00', '70', '630.00', '0.00', '', NULL, '0', '19360.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6265, '747413266413956', '3668139334', '895', NULL, '', '1.00', '50.00', '45', '50.00', '0.00', '', NULL, '0', '19360.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6266, '644865297919414', '3668139334', '21', NULL, '', '100.00', '140.00', '130', '14000.00', '0.00', '', NULL, '0', '19360.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6267, '636221625493445', '3668139334', '175', NULL, '', '6.00', '180.00', '125', '1080.00', '0.00', '', NULL, '0', '19360.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6268, '781989955118163', '3668139334', '176', NULL, '', '6.00', '120.00', '65', '720.00', '0.00', '', NULL, '0', '19360.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6269, '382321297989591', '3668139334', '865', NULL, '', '2.00', '390.00', '280', '780.00', '0.00', '', NULL, '0', '19360.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6270, '535146381657478', '3668139334', '947', NULL, '', '2.00', '750.00', '750', '1500.00', '0.00', '', NULL, '0', '19360.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6271, '492345984714741', '3668139334', '57', NULL, '', '1.00', '150.00', '140', '150.00', '0.00', '', NULL, '0', '19360.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6297, '187421629477771', '3373792943', '91', NULL, '', '1.00', '70.00', '540', '70.00', '0.00', '', '0.00', '0', '7280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6296, '419156172274944', '3373792943', '895', NULL, '', '1.00', '50.00', '45', '50.00', '0.00', '', '0.00', '0', '7280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6295, '853974592768472', '3373792943', '884', NULL, '', '4.00', '520.00', '463', '2080.00', '0.00', '', '0.00', '0', '7280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6294, '213868744228383', '3373792943', '404', NULL, '', '2.00', '150.00', '125', '300.00', '0.00', '', '0.00', '0', '7280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6293, '898386226188721', '3373792943', '707', NULL, '', '1.00', '250.00', '150', '250.00', '0.00', '', '0.00', '0', '7280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6292, '673548766235365', '3373792943', '217', NULL, '', '1.00', '200.00', '180', '200.00', '0.00', '', '0.00', '0', '7280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6291, '788911237312762', '3373792943', '57', NULL, '', '1.00', '150.00', '140', '150.00', '0.00', '', '0.00', '0', '7280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6290, '682742459834622', '3373792943', '382', NULL, '', '1.00', '50.00', '46', '50.00', '0.00', '', '0.00', '0', '7280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6289, '671141466651814', '3373792943', '1068', NULL, '', '1.00', '850.00', '770', '850.00', '0.00', '', '0.00', '0', '7280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6288, '695927251341588', '3373792943', '699', NULL, '', '1.00', '330.00', '320', '330.00', '0.00', '', '0.00', '0', '7280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6287, '799342721827242', '3373792943', '372', NULL, '', '7.00', '50.00', '40', '350.00', '0.00', '', '0.00', '0', '7280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6286, '735329682279414', '3373792943', '625', NULL, '', '1.00', '50.00', '41', '50.00', '0.00', '', '0.00', '0', '7280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6285, '995867222587277', '3373792943', '378', NULL, '', '4.00', '30.00', '20', '120.00', '0.00', '', '0.00', '0', '7280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6298, '937923694927636', '3373792943', '1066', NULL, '', '9.00', '270.00', '280', '2430.00', '0.00', '', '0.00', '0', '7280.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7966, '172845364126996', '1948967738', '843', NULL, '', '8.00', '20.00', '13', '160.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8177, '954851394695756', '8951253458', '833', NULL, '', '5.00', '50.00', '25', '250.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8176, '662462435572537', '8951253458', '843', NULL, '', '2.00', '20.00', '13', '40.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8175, '223118196642831', '8951253458', '836', NULL, '', '2.00', '50.00', '30', '100.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8174, '895431227432141', '8951253458', '715', NULL, '', '25.00', '120.00', '120', '3000.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8173, '776735461988941', '8951253458', '490', NULL, '', '6.00', '130.00', '85', '780.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8172, '973797421885486', '8951253458', '381', NULL, '', '5.00', '50.00', '34', '250.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8171, '194483844991317', '8951253458', '1038', NULL, '', '30.00', '14.00', '10', '420.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8170, '697889978454438', '8951253458', '794', NULL, '', '2.00', '150.00', '140', '300.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8169, '657513279988715', '8951253458', '1067', NULL, '', '1.00', '1100.00', '1075', '1100.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8168, '652187782134118', '8951253458', '373', NULL, '', '20.00', '20.00', '17', '400.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8167, '575827787164419', '8951253458', '375', NULL, '', '4.00', '50.00', '15', '200.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8166, '419711448124987', '8951253458', '237', NULL, '', '1.00', '550.00', '530', '550.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8165, '444815412681375', '8951253458', '241', NULL, '', '3.00', '200.00', '160', '600.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8164, '541529977976678', '8951253458', '928', NULL, '', '3.00', '50.00', '35', '150.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8163, '869147594428587', '8951253458', '213', NULL, '', '1.00', '200.00', '166.667', '200.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8162, '734785761698685', '8951253458', '1055', NULL, '', '1.00', '700.00', '666.667', '700.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8161, '411611379574599', '8951253458', '222', NULL, '', '4.00', '350.00', '230', '1400.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8160, '339822221555711', '8951253458', '1092', NULL, '', '1.00', '500.00', '500', '500.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8159, '675869173844559', '8951253458', '1091', NULL, '', '2.00', '700.00', '700', '1400.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8158, '264865216724945', '8951253458', '1090', NULL, '', '5.00', '800.00', '800', '4000.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8157, '997991812628676', '8951253458', '684', NULL, '', '2.00', '400.00', '360', '800.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8156, '924583446148242', '8951253458', '697', NULL, '', '12.00', '400.00', '390', '4800.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6364, '483116362984536', '1299158818', '17', NULL, '', '50.00', '200.00', '180', '10000.00', '0.00', '', NULL, '0', '412705.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6365, '627517298664724', '1299158818', '1076', NULL, '', '10.00', '240.00', '192', '2400.00', '0.00', '', NULL, '0', '412705.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6366, '447131224136212', '1299158818', '1077', NULL, '', '10.00', '180.00', '98', '1800.00', '0.00', '', NULL, '0', '412705.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8263, '572251619237497', '9826454685', '1124', NULL, '', '1.00', '95000.00', '88000', '95000.00', '0.00', '', NULL, '0', '428300.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8262, '611157392289164', '9826454685', '1085', NULL, '', '2.00', '55000.00', '53500', '110000.00', '0.00', '', NULL, '0', '428300.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8261, '772714266445376', '9826454685', '1086', NULL, '', '6.00', '25740.00', '26100', '154440.00', '0.00', '', NULL, '0', '428300.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8260, '543768897273976', '2634181175', '1127', NULL, '', '41.00', '220.00', '220', '9020.00', '0.00', '', '0.00', '0', '72300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8259, '726421713319277', '2634181175', '1058', NULL, '', '4.00', '350.00', '200', '1400.00', '0.00', '', '0.00', '0', '72300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8258, '331483858925846', '2634181175', '1074', NULL, '', '1.00', '800.00', '850', '800.00', '0.00', '', '0.00', '0', '72300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8257, '338737344361349', '2634181175', '1030', NULL, '', '20.00', '325.00', '273.333', '6500.00', '0.00', '', '0.00', '0', '72300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8256, '283389495877881', '2634181175', '1087', NULL, '', '3.00', '1850.00', '1350', '5550.00', '0.00', '', '0.00', '0', '72300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8255, '167191687996565', '2634181175', '794', NULL, '', '15.00', '160.00', '140', '2400.00', '0.00', '', '0.00', '0', '72300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8254, '818436974862629', '2634181175', '31', NULL, '', '2.00', '240.00', '916', '480.00', '0.00', '', '0.00', '0', '72300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8253, '219615431448411', '2634181175', '488', NULL, '', '1.00', '300.00', '200', '300.00', '0.00', '', '0.00', '0', '72300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8252, '239357744121674', '2634181175', '331', NULL, '', '1.00', '13500.00', '11760.5', '13500.00', '0.00', '', '0.00', '0', '72300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8251, '944644668223573', '2634181175', '1070', NULL, '', '1.00', '1750.00', '1500', '1750.00', '0.00', '', '0.00', '0', '72300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6392, '897919957169825', '5173269616', '1088', NULL, '', '62.00', '580.00', '480', '35960.00', '0.00', '', NULL, '0', '76360.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6393, '264182615889898', '5173269616', '1089', NULL, '', '700.00', '3.00', '2', '2100.00', '0.00', '', NULL, '0', '76360.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8155, '548218434327286', '8951253458', '243', NULL, '', '3.00', '400.00', '415', '1200.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8154, '674597147271466', '8951253458', '257', NULL, '', '2.00', '600.00', '583.333', '1200.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8153, '298211388427872', '8951253458', '258', NULL, '', '2.00', '500.00', '450', '1000.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8152, '522338537589768', '8951253458', '221', NULL, '', '1.00', '800.00', '480', '800.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8151, '479191667768461', '8951253458', '264', NULL, '', '1.00', '100.00', '80', '100.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8150, '323631684228899', '8951253458', '895', NULL, '', '1.00', '50.00', '45', '50.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8149, '774527647451328', '8951253458', '1066', NULL, '', '3.00', '350.00', '280', '1050.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8148, '394983446668217', '8951253458', '370', NULL, '', '20.00', '40.00', '22', '800.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8147, '294922397998233', '8951253458', '269', NULL, '', '1.00', '150.00', '110', '150.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8146, '268237462481236', '8951253458', '224', NULL, '', '1.00', '1000.00', '550', '1000.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8145, '498138262795272', '8951253458', '1061', NULL, '', '2.00', '50.00', '50', '100.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8144, '666286544832398', '8951253458', '218', NULL, '', '1.00', '200.00', '160', '200.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8143, '566514426919164', '8951253458', '891', NULL, '', '1.00', '300.00', '253', '300.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8142, '668274448619118', '8951253458', '752', NULL, '', '1.00', '50.00', '88', '50.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8141, '273666878615388', '8951253458', '198', NULL, '', '1.00', '2300.00', '2100', '2300.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8140, '376913966217691', '8951253458', '57', NULL, '', '1.00', '150.00', '140', '150.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8139, '411695557824354', '8951253458', '995', NULL, '', '10.00', '150.00', '106', '1500.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8138, '623174619165349', '8951253458', '365', NULL, '', '4.00', '100.00', '70', '400.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8137, '489199986559361', '8951253458', '72', NULL, '', '1.00', '3000.00', '2250', '3000.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8136, '893636798196993', '8951253458', '1013', NULL, '', '4.00', '25.00', '16', '100.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8135, '712248831628588', '8951253458', '54', NULL, '', '4.00', '300.00', '255', '1200.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8134, '182862723694734', '8951253458', '5', NULL, '', '1.00', '500.00', '450', '500.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8133, '649146359583275', '8951253458', '1112', NULL, '', '8.00', '70.00', '66', '560.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7965, '263124763718928', '1948967738', '381', NULL, '', '8.00', '50.00', '34', '400.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7964, '288778842721429', '1948967738', '1132', NULL, '', '6.00', '30.00', '20', '180.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7963, '812548569481664', '1948967738', '93', NULL, '', '2.00', '350.00', '270', '700.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7962, '997935796891275', '1948967738', '836', NULL, '', '2.00', '75.00', '30', '150.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7961, '578174769763321', '1948967738', '1027', NULL, '', '30.00', '80.00', '65', '2400.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7960, '411372196266823', '1948967738', '178', NULL, '', '1.00', '180.00', '80', '180.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7959, '237333831454759', '1948967738', '183', NULL, '', '1.00', '240.00', '1600', '240.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7958, '127638848273711', '1948967738', '175', NULL, '', '1.00', '180.00', '125', '180.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7957, '224192779635288', '1948967738', '895', NULL, '', '4.00', '50.00', '45', '200.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7956, '447263315883384', '1948967738', '19', NULL, '', '10.00', '100.00', '70', '1000.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7955, '646393184647898', '1948967738', '666', NULL, '', '2.00', '3400.00', '3208', '6800.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7954, '766824297743844', '1948967738', '665', NULL, '', '2.00', '3400.00', '3208', '6800.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7953, '735711673775276', '1948967738', '668', NULL, '', '2.00', '4400.00', '4190', '8800.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7952, '685167337477196', '1948967738', '667', NULL, '', '2.00', '4400.00', '4190', '8800.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7951, '348485778995546', '1948967738', '964', NULL, '', '3.00', '5500.00', '5000', '16500.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7950, '518679297655683', '1948967738', '963', NULL, '', '6.00', '2500.00', '2500', '15000.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7949, '389285586889283', '1948967738', '258', NULL, '', '1.00', '500.00', '450', '500.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7948, '289668878344341', '1948967738', '254', NULL, '', '6.00', '250.00', '230', '1500.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7947, '927437152927499', '1948967738', '1068', NULL, '', '1.00', '800.00', '770', '800.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7946, '639283364293582', '1948967738', '200', NULL, '', '1.00', '700.00', '900', '700.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7945, '374555854946669', '1948967738', '715', NULL, '', '8.00', '130.00', '120', '1040.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7944, '984135984379237', '1948967738', '474', NULL, '', '1.00', '150.00', '100', '150.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7943, '221646621886824', '1948967738', '888', NULL, '', '1.00', '350.00', '322', '350.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7942, '371311887212878', '1948967738', '883', NULL, '', '1.00', '550.00', '468.25', '550.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7941, '537599911476667', '1948967738', '885', NULL, '', '1.00', '480.00', '440.5', '480.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7940, '469535136741793', '1948967738', '284', NULL, '', '2.00', '70.00', '33.5', '140.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6609, '475548464343861', '8429856221', '176', NULL, '', '5.00', '120.00', '65', '600.00', '0.00', '', '0.00', '0', '261832.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8017, '864489949524373', '5989899254', '846', NULL, '', '2.00', '50.00', '50', '100.00', '0.00', '', '0.00', '0', '82295.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8016, '838124379815141', '5989899254', '989', NULL, '', '1.00', '200.00', '60', '200.00', '0.00', '', '0.00', '0', '82295.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6742, '545233964724821', '2375654761', '32', NULL, '', '48.00', '71.00', '411', '3408.00', '0.00', '', NULL, '0', '173900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6741, '328156185146841', '2375654761', '31', NULL, '', '60.00', '142.00', '916', '8520.00', '0.00', '', NULL, '0', '173900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6740, '622375958855468', '2375654761', '137', NULL, '', '1.00', '3000.00', '2938.1', '3000.00', '0.00', '', NULL, '0', '173900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6739, '993719811765369', '2375654761', '671', NULL, '', '1.00', '3000.00', '2961', '3000.00', '0.00', '', NULL, '0', '173900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6738, '857658833855178', '2375654761', '138', NULL, '', '1.00', '3000.00', '2938.1', '3000.00', '0.00', '', NULL, '0', '173900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6737, '535851936198359', '2375654761', '139', NULL, '', '1.00', '3000.00', '2938.1', '3000.00', '0.00', '', NULL, '0', '173900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6736, '288215583742385', '2375654761', '136', NULL, '', '10.00', '3000.00', '2961', '30000.00', '0.00', '', NULL, '0', '173900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6735, '438189275952894', '2375654761', '135', NULL, '', '10.00', '3000.00', '2938.1', '30000.00', '0.00', '', NULL, '0', '173900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6734, '493223849984354', '2166655947', '860', NULL, '', '2.00', '200.00', '170', '400.00', '0.00', '', '0.00', '0', '650825.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6733, '886934892277981', '2166655947', '656', NULL, '', '3.00', '21500.00', '20933.6', '64500.00', '0.00', '', '0.00', '0', '650825.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6732, '685978622881165', '2166655947', '657', NULL, '', '2.00', '21500.00', '20933.6', '43000.00', '0.00', '', '0.00', '0', '650825.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6731, '475792482243812', '2166655947', '321', NULL, '', '2.00', '9200.00', '9331', '18400.00', '0.00', '', '0.00', '0', '650825.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6730, '116997379925176', '2166655947', '147', NULL, '', '3.00', '15500.00', '14870.6', '46500.00', '0.00', '', '0.00', '0', '650825.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6729, '797174136187348', '2166655947', '148', NULL, '', '2.00', '15500.00', '14870.6', '31000.00', '0.00', '', '0.00', '0', '650825.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6728, '697985597291355', '2166655947', '17', NULL, '', '50.00', '200.00', '180', '10000.00', '0.00', '', '0.00', '0', '650825.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6727, '435556735386988', '2166655947', '794', NULL, '', '50.00', '150.00', '140', '7500.00', '0.00', '', '0.00', '0', '650825.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6726, '435426735217147', '2166655947', '269', NULL, '', '16.00', '150.00', '110', '2400.00', '0.00', '', '0.00', '0', '650825.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6725, '463182322933722', '2166655947', '27', NULL, '', '2.00', '60.00', '33', '120.00', '0.00', '', '0.00', '0', '650825.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6724, '324629345932112', '2166655947', '1033', NULL, '', '4.00', '2800.00', '2400', '11200.00', '0.00', '', '0.00', '0', '650825.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6723, '744581384218496', '2166655947', '1074', NULL, '', '2.00', '850.00', '850', '1700.00', '0.00', '', '0.00', '0', '650825.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6722, '922249631171915', '2166655947', '1094', NULL, '', '2.00', '350.00', '280', '700.00', '0.00', '', '0.00', '0', '650825.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6721, '599545574456153', '2166655947', '1095', NULL, '', '2.00', '350.00', '280', '700.00', '0.00', '', '0.00', '0', '650825.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6707, '244219751511549', '1938912735', '241', NULL, '', '0.00', '0.00', '160', '0.00', '0.00', '', '0.00', '0', '246480.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7624, '458579666193582', '4979853171', '449', NULL, '', '2.00', '120.00', '95', '240.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7623, '435584554216943', '4979853171', '441', NULL, '', '12.00', '300.00', '285', '3600.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7474, '112347668223759', '6792891529', '26', NULL, '', '1.00', '60.00', '15', '60.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7473, '572595799737926', '6792891529', '837', NULL, '', '30.00', '80.00', '70', '2400.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7472, '787874564223998', '6792891529', '971', NULL, '', '3.00', '3600.00', '3700', '10800.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7471, '319589662447956', '6792891529', '969', NULL, '', '1.00', '2300.00', '2100', '2300.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7470, '754366715263814', '6792891529', '271', NULL, '', '3.00', '120.00', '120', '360.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7469, '829939129979351', '6792891529', '472 ', NULL, '', '1.00', '70.00', '150', '150.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7468, '275569412486443', '6792891529', '395', NULL, '', '3.00', '70.00', '50', '210.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7467, '797436757827732', '6792891529', '284', NULL, '', '2.00', '70.00', '33.5', '140.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7466, '894298961362191', '6792891529', '19', NULL, '', '4.00', '90.00', '70', '360.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7465, '327417551317476', '6792891529', '481', NULL, '', '4.00', '50.00', '127', '200.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7464, '579649863371657', '6792891529', '147', NULL, '', '2.00', '14300.00', '14870.6', '28600.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7463, '813794217243512', '6792891529', '269', NULL, '', '2.00', '150.00', '110', '300.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7462, '358655291454586', '6792891529', '693', NULL, '', '6.00', '200.00', '130', '1200.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7461, '124395913446939', '6792891529', '59', NULL, '', '1.00', '200.00', '165', '200.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7460, '746687489938515', '6792891529', '1037', NULL, '', '30.00', '10.00', '9', '300.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7459, '485671491393256', '6792891529', '794', NULL, '', '2.00', '150.00', '140', '300.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7458, '342673553149294', '6792891529', '714', NULL, '', '1.00', '500.00', '325', '500.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7457, '394823926232887', '6792891529', '86', NULL, '', '2.00', '450.00', '390', '900.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7456, '527654144867451', '6792891529', '1022', NULL, '', '1.00', '950.00', '780', '950.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7455, '745391799252548', '6792891529', '57', NULL, '', '1.00', '150.00', '140', '150.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7454, '443139649167571', '6792891529', '370', NULL, '', '6.00', '25.00', '22', '150.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7453, '882931423195571', '6792891529', '837', NULL, '', '7.00', '90.00', '70', '630.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7452, '399911184187538', '6792891529', '420', NULL, '', '1.00', '4300.00', '3936', '4300.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8015, '187172321235574', '5989899254', '734', NULL, '', '1.00', '150.00', '120', '150.00', '0.00', '', '0.00', '0', '82295.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8014, '844843189372895', '5989899254', '736', NULL, '', '1.00', '250.00', '250', '250.00', '0.00', '', '0.00', '0', '82295.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8013, '384527669818656', '5989899254', '794', NULL, '', '6.00', '150.00', '140', '900.00', '0.00', '', '0.00', '0', '82295.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8012, '947242813565438', '5989899254', '366', NULL, '', '10.00', '75.00', '46', '750.00', '0.00', '', '0.00', '0', '82295.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8011, '235449316244526', '5989899254', '60', NULL, '', '25.00', '220.00', '200', '5500.00', '0.00', '', '0.00', '0', '82295.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8010, '332525699549275', '5989899254', '244', NULL, '', '1.00', '5500.00', '5500', '5500.00', '0.00', '', '0.00', '0', '82295.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8009, '898312478956811', '5989899254', '993', NULL, '', '3.00', '8500.00', '9200', '25500.00', '0.00', '', '0.00', '0', '82295.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8008, '837885634564581', '5989899254', '895', NULL, '', '4.00', '50.00', '45', '200.00', '0.00', '', '0.00', '0', '82295.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8007, '316475821319831', '5989899254', '821', NULL, '', '3.00', '6500.00', '6500', '19500.00', '0.00', '', '0.00', '0', '82295.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8006, '657829974292439', '5989899254', '888', NULL, '', '25.00', '325.00', '322', '8125.00', '0.00', '', '0.00', '0', '82295.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8005, '951998316595935', '5989899254', '396', NULL, '', '21.00', '60.00', '40', '1260.00', '0.00', '', '0.00', '0', '82295.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8004, '159614982455176', '5989899254', '283', NULL, '', '4.00', '60.00', '30', '240.00', '0.00', '', '0.00', '0', '82295.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8003, '486956829755965', '5989899254', '922', NULL, '', '6.00', '60.00', '40', '360.00', '0.00', '', '0.00', '0', '82295.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8002, '854799914254974', '5989899254', '1113', NULL, '', '2.00', '250.00', '165', '500.00', '0.00', '', '0.00', '0', '82295.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8001, '277131676217544', '5989899254', '783', NULL, '', '2.00', '150.00', '110', '300.00', '0.00', '', '0.00', '0', '82295.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8000, '446474697817727', '5989899254', '715', NULL, '', '25.00', '120.00', '120', '3000.00', '0.00', '', '0.00', '0', '82295.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7999, '562165115367854', '5989899254', '1038', NULL, '', '8.00', '50.00', '10', '400.00', '0.00', '', '0.00', '0', '82295.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6775, '836965299425426', '8628978864', '335', NULL, '', '2.00', '2400.00', '2376', '4800.00', '0.00', '', NULL, '0', '92010.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6776, '225697159958736', '8628978864', '336', NULL, '', '1.00', '2400.00', '2376', '2400.00', '0.00', '', NULL, '0', '92010.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6777, '857764132767729', '8628978864', '159', NULL, '', '1.00', '5400.00', '5126', '5400.00', '0.00', '', NULL, '0', '92010.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6778, '789417314712966', '8628978864', '687', NULL, '', '2.00', '280.00', '230', '560.00', '0.00', '', NULL, '0', '92010.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6779, '122283919967622', '5481418892', '813', NULL, '', '34.00', '90.00', '79', '3060.00', '0.00', '', NULL, '0', '18430.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6780, '668266493218825', '5481418892', '366', NULL, '', '6.00', '50.00', '46', '300.00', '0.00', '', NULL, '0', '18430.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6781, '866526283246586', '5481418892', '1057', NULL, '', '1.00', '2100.00', '2100', '2100.00', '0.00', '', NULL, '0', '18430.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6782, '367253778535817', '5481418892', '363', NULL, '', '1.00', '350.00', '320', '350.00', '0.00', '', NULL, '0', '18430.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6783, '312917431675215', '5481418892', '895', NULL, '', '1.00', '50.00', '45', '50.00', '0.00', '', NULL, '0', '18430.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6784, '477987547749964', '4913417498', '963', NULL, '', '5.00', '2500.00', '2500', '12500.00', '0.00', '', NULL, '0', '939547.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6785, '836495983775443', '5268985181', '299', NULL, '', '10.00', '4000.00', '4123.5', '40000.00', '0.00', '', NULL, '0', '1126436.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6786, '255676759812693', '5268985181', '323', NULL, '', '5.00', '4000.00', '4123.5', '20000.00', '0.00', '', NULL, '0', '1126436.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6787, '454964992357645', '5268985181', '135', NULL, '', '5.00', '3000.00', '2938.1', '15000.00', '0.00', '', NULL, '0', '1126436.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6788, '417864273376251', '5268985181', '650', NULL, '', '5.00', '3000.00', '2938.1', '15000.00', '0.00', '', NULL, '0', '1126436.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6789, '831319154462318', '5268985181', '420', NULL, '', '1.00', '4200.00', '3936', '4200.00', '0.00', '', NULL, '0', '1126436.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6790, '344644711588767', '5268985181', '1082', NULL, '', '1.00', '2200.00', '2000', '2200.00', '0.00', '', NULL, '0', '1126436.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6791, '755932697871675', '5268985181', '495', NULL, '', '1.00', '700.00', '650', '700.00', '0.00', '', NULL, '0', '1126436.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6792, '614956649235662', '5268985181', '363', NULL, '', '2.00', '350.00', '320', '700.00', '0.00', '', NULL, '0', '1126436.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6793, '726981354515442', '9849939218', '1080', NULL, '', '2.00', '1800.00', '1400', '3600.00', '0.00', '', NULL, '0', '103530.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6794, '468157732274924', '9849939218', '707', NULL, '', '3.00', '150.00', '150', '450.00', '0.00', '', NULL, '0', '103530.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6795, '958936472144991', '4695875524', '993', NULL, '', '1.00', '8400.00', '9200', '8400.00', '0.00', '', NULL, '0', '8400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8250, '564264299444178', '2634181175', '1033', NULL, '', '2.00', '2900.00', '2400', '5800.00', '0.00', '', '0.00', '0', '72300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8249, '734786116678142', '2634181175', '918', NULL, '', '3.00', '200.00', '155', '600.00', '0.00', '', '0.00', '0', '72300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7344, '427937536236771', '5176459998', '366', NULL, '', '6.00', '80.00', '46', '480.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7343, '211366343436111', '5176459998', '1134', NULL, '', '6.00', '60.00', '45', '360.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7342, '744912772183386', '5176459998', '578', NULL, '', '1.00', '2200.00', '2000', '2200.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7341, '544365481779594', '5176459998', '941', NULL, '', '6.00', '70.00', '50', '420.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7340, '116376182481251', '5176459998', '895', NULL, '', '2.00', '50.00', '45', '100.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7339, '445194113231626', '5176459998', '955', NULL, '', '12.00', '20.00', '20', '240.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7338, '487357518414795', '5176459998', '886', NULL, '', '6.00', '350.00', '277', '2100.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7337, '919689439689915', '5176459998', '700', NULL, '', '4.00', '190.00', '160', '760.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7336, '396577272295941', '5176459998', '1069', NULL, '', '1.00', '640.00', '600', '640.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7335, '963527427162231', '5176459998', '947', NULL, '', '2.00', '750.00', '750', '1500.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7334, '841662513756372', '5176459998', '369', NULL, '', '10.00', '100.00', '84', '1000.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7333, '893669864184121', '5176459998', '1066', NULL, '', '32.00', '310.00', '280', '9920.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7332, '211632644494611', '5176459998', '808', NULL, '', '3.00', '300.00', '260', '900.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7331, '544668216875924', '5176459998', '813', NULL, '', '51.00', '100.00', '79', '5100.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7330, '476194314943546', '5176459998', '963', NULL, '', '1.00', '2600.00', '2500', '2600.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7329, '637266611683691', '5176459998', '821', NULL, '', '1.00', '6800.00', '6500', '6800.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7328, '612138736584592', '5176459998', '234', NULL, '', '3.00', '900.00', '920', '2700.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7327, '527152879846137', '5176459998', '378', NULL, '', '1.00', '20.00', '20', '20.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7326, '932491299139851', '5176459998', '773', NULL, '', '2.00', '150.00', '80', '300.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7325, '249147588517191', '5176459998', '1000', NULL, '', '1.00', '200.00', '140', '200.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7324, '927389795135797', '5176459998', '812', NULL, '', '2.00', '150.00', '90', '300.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7323, '139812773373935', '5176459998', '135', NULL, '', '3.00', '2850.00', '2938.1', '8550.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7322, '311841772233212', '5176459998', '650', NULL, '', '2.00', '2850.00', '2938.1', '5700.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7321, '165296825171264', '5176459998', '141', NULL, '', '2.00', '6000.00', '6098.6', '12000.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7320, '661454162336539', '5176459998', '284', NULL, '', '6.00', '60.00', '33.5', '360.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7319, '792738891493645', '5176459998', '936', NULL, '', '10.00', '50.00', '30', '500.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7318, '872386625624724', '5176459998', '883', NULL, '', '6.00', '550.00', '467.667', '3300.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7317, '222364611478718', '5176459998', '888', NULL, '', '2.00', '350.00', '322', '700.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7316, '851427928783485', '5176459998', '890', NULL, '', '1.00', '300.00', '222', '300.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7315, '445672489487824', '5176459998', '887', NULL, '', '1.00', '350.00', '297', '350.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6866, '666524466237492', '2216479258', '560', NULL, '', '40.00', '380.00', '310', '15200.00', '0.00', '', NULL, '0', '91560.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8248, '357291127251867', '2634181175', '895', NULL, '', '4.00', '50.00', '45', '200.00', '0.00', '', '0.00', '0', '72300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8247, '324686298564621', '2634181175', '1016', NULL, '', '12.00', '50.00', '30', '600.00', '0.00', '', '0.00', '0', '72300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8246, '538523425549223', '2634181175', '1053', NULL, '', '2.00', '200.00', '130', '400.00', '0.00', '', '0.00', '0', '72300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8245, '559588638256867', '2634181175', '1038', NULL, '', '30.00', '15.00', '10', '450.00', '0.00', '', '0.00', '0', '72300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8244, '891141843239287', '2634181175', '375', NULL, '', '5.00', '40.00', '15', '200.00', '0.00', '', '0.00', '0', '72300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8243, '889554694281636', '2634181175', '1122', NULL, '', '1.00', '4850.00', '3500', '4850.00', '0.00', '', '0.00', '0', '72300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8242, '889469836943122', '2634181175', '1049', NULL, '', '1.00', '900.00', '750', '900.00', '0.00', '', '0.00', '0', '72300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8241, '655817319389437', '2634181175', '1123', NULL, '', '1.00', '8800.00', '7500', '8800.00', '0.00', '', '0.00', '0', '72300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8240, '755994574571949', '2634181175', '1100', NULL, '', '1.00', '3700.00', '2500', '3700.00', '0.00', '', '0.00', '0', '72300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8239, '573247855564359', '2634181175', '777', NULL, '', '1.00', '150.00', '20', '150.00', '0.00', '', '0.00', '0', '72300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8238, '623373175694543', '2634181175', '1097', NULL, '', '3.00', '150.00', '80', '450.00', '0.00', '', '0.00', '0', '72300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8237, '844417935654219', '2634181175', '1125', NULL, '', '1.00', '3500.00', '1800', '3500.00', '0.00', '', '0.00', '0', '72300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6933, '492949314118517', '6839949824', '560', NULL, '', '30.00', '380.00', '310', '11400.00', '0.00', '', NULL, '0', '102960.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6934, '287862925539663', '4823786759', '247', NULL, '', '5.00', '650.00', '665', '3250.00', '0.00', '', NULL, '0', '9410.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6935, '488933872952626', '4823786759', '372', NULL, '', '15.00', '30.00', '40', '450.00', '0.00', '', NULL, '0', '9410.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6936, '174973985456154', '4823786759', '865', NULL, '', '1.00', '300.00', '280', '300.00', '0.00', '', NULL, '0', '9410.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6937, '543539276126619', '4823786759', '284', NULL, '', '1.00', '50.00', '33.5', '50.00', '0.00', '', NULL, '0', '9410.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6938, '581546345662726', '4823786759', '773', NULL, '', '3.00', '150.00', '80', '450.00', '0.00', '', NULL, '0', '9410.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6939, '199747166146466', '4823786759', '699', NULL, '', '12.00', '330.00', '320', '3960.00', '0.00', '', NULL, '0', '9410.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6940, '334662165834822', '4823786759', '885', NULL, '', '1.00', '500.00', '431', '500.00', '0.00', '', NULL, '0', '9410.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6941, '663838987813366', '4823786759', '1000', NULL, '', '1.00', '150.00', '140', '150.00', '0.00', '', NULL, '0', '9410.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6942, '679466765886598', '4823786759', '241', NULL, '', '1.00', '150.00', '160', '150.00', '0.00', '', NULL, '0', '9410.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (6943, '954319829575256', '4823786759', '693', NULL, '', '1.00', '150.00', '130', '150.00', '0.00', '', NULL, '0', '9410.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7345, '575626523277194', '5176459998', '969', NULL, '', '1.00', '33.00', '2100', '2300.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7314, '749994429153912', '1954183663', '834', NULL, '', '1.00', '150.00', '75', '150.00', '0.00', '', '0.00', '0', '36370.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7313, '489123736149781', '1954183663', '773', NULL, '', '1.00', '150.00', '80', '150.00', '0.00', '', '0.00', '0', '36370.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7312, '393125468197622', '1954183663', '960', NULL, '', '1.00', '2800.00', '3100', '2800.00', '0.00', '', '0.00', '0', '36370.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7311, '798298422125646', '1954183663', '860', NULL, '', '4.00', '200.00', '170', '800.00', '0.00', '', '0.00', '0', '36370.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7310, '884592875256376', '1954183663', '225', NULL, '', '1.00', '150.00', '465', '150.00', '0.00', '', '0.00', '0', '36370.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7309, '254618546725593', '1954183663', '270', NULL, '', '1.00', '180.00', '160', '180.00', '0.00', '', '0.00', '0', '36370.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7308, '421349475294318', '1954183663', '1033', NULL, '', '1.00', '2180.00', '2400', '2180.00', '0.00', '', '0.00', '0', '36370.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7307, '164564831489271', '1954183663', '219', NULL, '', '1.00', '400.00', '380', '400.00', '0.00', '', '0.00', '0', '36370.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7306, '217189531125879', '1954183663', '220', NULL, '', '6.00', '200.00', '180', '1200.00', '0.00', '', '0.00', '0', '36370.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7305, '664377999827275', '1954183663', '260', NULL, '', '1.00', '600.00', '850', '600.00', '0.00', '', '0.00', '0', '36370.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7304, '283475163932759', '1954183663', '600', NULL, '', '3.00', '40.00', '160.667', '120.00', '0.00', '', '0.00', '0', '36370.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7303, '229511919689364', '1954183663', '895', NULL, '', '3.00', '50.00', '45', '150.00', '0.00', '', '0.00', '0', '36370.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7302, '947553395569515', '1954183663', '914', NULL, '', '1.00', '130.00', '90', '130.00', '0.00', '', '0.00', '0', '36370.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7301, '693916229586196', '1954183663', '913', NULL, '', '2.00', '120.00', '80', '240.00', '0.00', '', '0.00', '0', '36370.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7300, '742586384543467', '1954183663', '141', NULL, '', '2.00', '5800.00', '6098.6', '11600.00', '0.00', '', '0.00', '0', '36370.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7299, '897549348654716', '1954183663', '650', NULL, '', '2.00', '2800.00', '2938.1', '5600.00', '0.00', '', '0.00', '0', '36370.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7298, '345771477187737', '1954183663', '135', NULL, '', '2.00', '2800.00', '2938.1', '5600.00', '0.00', '', '0.00', '0', '36370.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7297, '268756431967817', '1954183663', '78', NULL, '', '5.00', '140.00', '160', '700.00', '0.00', '', '0.00', '0', '36370.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7296, '751756768894633', '1954183663', '377', NULL, '', '6.00', '25.00', '30', '150.00', '0.00', '', '0.00', '0', '36370.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7295, '497636872522998', '1954183663', '100', NULL, '', '4.00', '300.00', '300', '1200.00', '0.00', '', '0.00', '0', '36370.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7294, '948265154943551', '1954183663', '711', NULL, '', '3.00', '80.00', '62', '240.00', '0.00', '', '0.00', '0', '36370.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7293, '454722311256296', '1954183663', '693', NULL, '', '6.00', '130.00', '130', '780.00', '0.00', '', '0.00', '0', '36370.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7292, '871272512226282', '1954183663', '116', NULL, '', '1.00', '700.00', '550', '700.00', '0.00', '', '0.00', '0', '36370.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7182, '617526957268191', '4648594853', '812', NULL, '', '1.00', '150.00', '90', '150.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7181, '684921558694369', '4648594853', '125', NULL, '', '1.00', '350.00', '375', '350.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7180, '763388553423254', '4648594853', '370', NULL, '', '50.00', '30.00', '22', '1500.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7179, '973456658218281', '4648594853', '156', NULL, '', '2.00', '3350.00', '3208', '6700.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7178, '156998483851169', '4648594853', '155', NULL, '', '2.00', '3350.00', '3208', '6700.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7177, '838755969916946', '4648594853', '242', NULL, '', '3.00', '500.00', '492.5', '1500.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7176, '398794166116255', '4648594853', '833', NULL, '', '3.00', '40.00', '25', '120.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7175, '529284879694754', '4648594853', '57', NULL, '', '2.00', '150.00', '140', '300.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7174, '363111648548673', '4648594853', '235', NULL, '', '1.00', '1150.00', '1100', '1150.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7173, '928247915542559', '4648594853', '1079', NULL, '', '1.00', '1400.00', '1100', '1400.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7172, '379845859618749', '4648594853', '239', NULL, '', '1.00', '350.00', '360', '350.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7171, '139718753657447', '4648594853', '773', NULL, '', '4.00', '125.00', '80', '500.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7170, '533618256946197', '4648594853', '707', NULL, '', '2.00', '200.00', '150', '400.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7169, '551361272111211', '4648594853', '663', NULL, '', '2.00', '2200.00', '2292', '4400.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7168, '243521177865522', '4648594853', '884', NULL, '', '1.00', '500.00', '458.667', '500.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7167, '587723444515692', '4648594853', '883', NULL, '', '1.00', '550.00', '467.667', '550.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7166, '955177374565382', '4648594853', '855', NULL, '', '4.00', '300.00', '286.667', '1200.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7165, '174627593558937', '4648594853', '43', NULL, '', '2.00', '350.00', '220', '700.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7164, '389874829229442', '4648594853', '943', NULL, '', '1.00', '270.00', '280', '270.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7163, '723749546549941', '4648594853', '251', NULL, '', '2.00', '270.00', '275', '540.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7162, '783322962419165', '4648594853', '705', NULL, '', '3.00', '270.00', '250', '810.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7161, '113167693699381', '4648594853', '880', NULL, '', '2.00', '300.00', '220', '600.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7160, '226579979954929', '4648594853', '284', NULL, '', '2.00', '60.00', '33.5', '120.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7159, '937561293325312', '4648594853', '1060', NULL, '', '4.00', '50.00', '38', '200.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7158, '171252956127542', '4648594853', '86', NULL, '', '1.00', '600.00', '390', '600.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7157, '656946498921645', '4648594853', '271', NULL, '', '1.00', '240.00', '120', '240.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7156, '448931238962846', '4648594853', '1043', NULL, '', '4.00', '40.00', '20', '160.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7155, '174328189813869', '4648594853', '715', NULL, '', '6.00', '130.00', '120', '780.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7154, '163596246885525', '4648594853', '481', NULL, '', '2.00', '50.00', '127', '100.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7153, '615123275375442', '4648594853', '711', NULL, '', '2.00', '75.00', '62', '150.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7152, '136543944736369', '4648594853', '693', NULL, '', '4.00', '150.00', '130', '600.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7151, '864959958645974', '4648594853', '694', NULL, '', '24.00', '130.00', '130', '3120.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7150, '463856824619261', '4648594853', '2', NULL, '', '2.00', '240.00', '190', '480.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7149, '518561146412546', '4648594853', '93', NULL, '', '2.00', '350.00', '270', '700.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7148, '631349898921922', '4648594853', '885', NULL, '', '4.00', '500.00', '431', '2000.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7147, '124676678936219', '4648594853', '1131', NULL, '', '1.00', '150.00', '100', '150.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7146, '926733383634473', '4648594853', '375', NULL, '', '4.00', '30.00', '15', '120.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7183, '823924429586385', '4648594853', '1132', NULL, '', '4.00', '20.00', '20', '80.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7184, '146168165885816', '4648594853', '812', NULL, '', '5.00', '250.00', '90', '1250.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7185, '986143991719811', '4648594853', '57', NULL, '', '12.00', '120.00', '140', '1440.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7186, '878587589863715', '4648594853', '156', NULL, '', '2.00', '3200.00', '3208', '6400.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7187, '541398783517151', '4648594853', '855', NULL, '', '5.00', '300.00', '286.667', '1500.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7188, '524657181435113', '4648594853', '284', NULL, '', '2.00', '60.00', '33.5', '120.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7189, '497284166168373', '4648594853', '1060', NULL, '', '4.00', '50.00', '38', '200.00', '0.00', '', '0.00', '0', '51200.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7190, '134663177581283', '6586445994', '490', NULL, '', '10.00', '130.00', '85', '1300.00', '0.00', '', NULL, '0', '22200.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7191, '331764455795979', '6586445994', '715', NULL, '', '1.00', '150.00', '120', '150.00', '0.00', '', NULL, '0', '22200.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7192, '115382281463445', '6586445994', '716', NULL, '', '1.00', '250.00', '190', '250.00', '0.00', '', NULL, '0', '22200.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7193, '937496287831835', '6586445994', '372', NULL, '', '10.00', '50.00', '40', '500.00', '0.00', '', NULL, '0', '22200.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7194, '478947569556679', '6586445994', '373', NULL, '', '10.00', '80.00', '17', '800.00', '0.00', '', NULL, '0', '22200.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7195, '232174319619396', '1196229697', '187', NULL, '', '1.00', '7500.00', '6500', '7500.00', '0.00', '', NULL, '0', '950247.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7196, '758824232792629', '1196229697', '650', NULL, '', '1.00', '3200.00', '2938.1', '3200.00', '0.00', '', NULL, '0', '950247.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7197, '136529788726716', '7873299185', '419', NULL, '', '1.00', '7400.00', '7121', '7400.00', '0.00', '', NULL, '0', '283502.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7198, '255743593895344', '7873299185', '700', NULL, '', '20.00', '170.00', '160', '3400.00', '0.00', '', NULL, '0', '283502.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7199, '663253747754534', '7873299185', '715', NULL, '', '50.00', '124.00', '120', '6200.00', '0.00', '', NULL, '0', '283502.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7998, '432449414417178', '5989899254', '1039', NULL, '', '4.00', '60.00', '12', '240.00', '0.00', '', '0.00', '0', '82295.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7997, '464784877993637', '5989899254', '1035', NULL, '', '12.00', '10.00', '6', '120.00', '0.00', '', '0.00', '0', '82295.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7996, '437885467951299', '5989899254', '235', NULL, '', '1.00', '1200.00', '1100', '1200.00', '0.00', '', '0.00', '0', '82295.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7291, '387637499243216', '1954183663', '8', NULL, '', '1.00', '550.00', '550', '550.00', '0.00', '', '0.00', '0', '36370.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7346, '437321778232624', '5176459998', '92', NULL, '', '2.00', '45.00', '260', '500.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7347, '853252296919946', '5176459998', '843', NULL, '', '2.00', '35.00', '13', '70.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7348, '363643517467492', '5176459998', '833', NULL, '', '2.00', '35.00', '25', '70.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7349, '431794442358223', '5176459998', '1066', NULL, '', '6.00', '300.00', '280', '1800.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7350, '882378134131671', '5176459998', '963', NULL, '', '5.00', '2700.00', '2500', '13500.00', '0.00', '', '0.00', '0', '88640.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7451, '245677648488323', '6792891529', '375', NULL, '', '2.00', '60.00', '15', '120.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7450, '456555667298745', '6792891529', '1043', NULL, '', '2.00', '60.00', '20', '120.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7449, '228874197629711', '6792891529', '1132', NULL, '', '4.00', '30.00', '20', '120.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7448, '652465456332296', '6792891529', '1136', NULL, '', '4.00', '130.00', '110', '520.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7447, '427532599754831', '6792891529', '1137', NULL, '', '17.00', '130.00', '120', '2210.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7446, '971264163552896', '6792891529', '834', NULL, '', '1.00', '150.00', '75', '150.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7445, '668689619481426', '6792891529', '270', NULL, '', '1.00', '200.00', '160', '200.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7444, '144755697412741', '6792891529', '1113', NULL, '', '1.00', '150.00', '165', '150.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7443, '917264119962351', '6792891529', '784', NULL, '', '1.00', '150.00', '135', '150.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7442, '363361226662191', '6792891529', '1139', NULL, '', '19.00', '50.00', '40', '950.00', '0.00', '', '0.00', '0', '60150.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7622, '563532353156812', '4979853171', '236', NULL, '', '3.00', '1200.00', '935', '3600.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7621, '671525711556754', '4979853171', '699', NULL, '', '12.00', '350.00', '320', '4200.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7620, '432487671454491', '4979853171', '496', NULL, '', '30.00', '60.00', '38', '1800.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7619, '159683336661323', '4979853171', '975', NULL, '', '0.50', '400.00', '540', '200.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7618, '193299772655932', '4979853171', '382', NULL, '', '3.00', '75.00', '46', '225.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7617, '419376131795693', '4979853171', '600', NULL, '', '3.00', '50.00', '160.667', '150.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7616, '229595356153997', '4979853171', '1055', NULL, '', '1.00', '705.00', '700', '705.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7615, '995498142924834', '4979853171', '603', NULL, '', '10.00', '350.00', '250', '3500.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7614, '384162294221988', '4979853171', '481', NULL, '', '3.00', '50.00', '127', '150.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7613, '547156486588643', '4979853171', '710', NULL, '', '1.00', '50.00', '270', '50.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7612, '153117181834259', '4979853171', '737', NULL, '', '1.00', '70.00', '50', '70.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7611, '741129497896123', '4979853171', '1095', NULL, '', '1.00', '330.00', '280', '330.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7610, '774717434111231', '4979853171', '91', NULL, '', '1.00', '50.00', '540', '50.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7609, '476889581273697', '4979853171', '860', NULL, '', '1.00', '250.00', '170', '250.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7608, '815433721181739', '4979853171', '78', NULL, '', '10.00', '180.00', '160', '1800.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7607, '351448915937239', '4979853171', '379', NULL, '', '8.00', '40.00', '25', '320.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7606, '971569184958486', '4979853171', '102', NULL, '', '9.00', '480.00', '450', '4320.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7605, '286154944286394', '4979853171', '727', NULL, '', '1.00', '4800.00', '4800', '4800.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7604, '543782554139237', '4979853171', '350', NULL, '', '1.00', '9500.00', '8700', '9500.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7603, '317732777296625', '4979853171', '71', NULL, '', '2.00', '2000.00', '2250', '4000.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7602, '357887587981213', '4979853171', '72', NULL, '', '3.00', '2000.00', '2250', '6000.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7601, '417223198338836', '4979853171', '948', NULL, '', '1.00', '2000.00', '2350', '2000.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7600, '488567441922917', '4979853171', '912', NULL, '', '2.00', '120.00', '85', '240.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7599, '951779647112489', '4979853171', '257', NULL, '', '1.00', '900.00', '583.333', '900.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7625, '935112587119837', '4979853171', '418', NULL, '', '2.00', '4000.00', '4300', '8000.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7626, '113812471514127', '4979853171', '962', NULL, '', '2.00', '4000.00', '4100', '8000.00', '0.00', '', '0.00', '0', '69000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7707, '414456127373433', '8841984599', '707', NULL, '', '1.00', '200.00', '150', '200.00', '0.00', '', '0.00', '0', '22610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7706, '319278218643643', '8841984599', '380', NULL, '', '1.00', '50.00', '25', '50.00', '0.00', '', '0.00', '0', '22610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7705, '446991733725758', '8841984599', '705', NULL, '', '1.00', '250.00', '250', '250.00', '0.00', '', '0.00', '0', '22610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7704, '266617539373978', '8841984599', '34', NULL, '', '1.00', '135.00', '350', '135.00', '0.00', '', '0.00', '0', '22610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7703, '152513877217362', '8841984599', '33', NULL, '', '1.00', '135.00', '700', '135.00', '0.00', '', '0.00', '0', '22610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7702, '143858174299454', '8841984599', '18', NULL, '', '3.00', '90.00', '75', '270.00', '0.00', '', '0.00', '0', '22610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7701, '964435841896162', '8841984599', '860', NULL, '', '1.00', '200.00', '170', '200.00', '0.00', '', '0.00', '0', '22610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7700, '773863278513291', '8841984599', '750', NULL, '', '1.00', '480.00', '530', '480.00', '0.00', '', '0.00', '0', '22610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7699, '241183694693381', '8841984599', '78', NULL, '', '1.00', '180.00', '160', '180.00', '0.00', '', '0.00', '0', '22610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7698, '816766818515788', '8841984599', '914', NULL, '', '1.00', '150.00', '90', '150.00', '0.00', '', '0.00', '0', '22610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7697, '211394891171281', '8841984599', '1141', NULL, '', '2.00', '130.00', '120', '260.00', '0.00', '', '0.00', '0', '22610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7696, '557324378138276', '8841984599', '379', NULL, '', '6.00', '40.00', '25', '240.00', '0.00', '', '0.00', '0', '22610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7695, '984556769131155', '8841984599', '102', NULL, '', '2.00', '480.00', '450', '960.00', '0.00', '', '0.00', '0', '22610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7694, '694675742354845', '8841984599', '372', NULL, '', '35.00', '70.00', '40', '2450.00', '0.00', '', '0.00', '0', '22610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7693, '233277767254756', '8841984599', '141', NULL, '', '1.00', '6500.00', '6098.6', '6500.00', '0.00', '', '0.00', '0', '22610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7692, '867653663393195', '8841984599', '1140', NULL, '', '4.00', '40.00', '35', '160.00', '0.00', '', '0.00', '0', '22610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7691, '146481588999678', '8841984599', '750', NULL, '', '3.00', '480.00', '530', '1440.00', '0.00', '', '0.00', '0', '22610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7690, '858714198239941', '8841984599', '694', NULL, '', '40.00', '150.00', '130', '6000.00', '0.00', '', '0.00', '0', '22610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7689, '285223737937231', '8841984599', '242', NULL, '', '5.00', '500.00', '492.5', '2500.00', '0.00', '', '0.00', '0', '22610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7708, '834136167637213', '8841984599', '1140', NULL, '', '1.00', '50.00', '35', '50.00', '0.00', '', '0.00', '0', '22610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7939, '764638879569537', '1948967738', '283', NULL, '', '1.00', '60.00', '30', '60.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7938, '178293658829413', '1948967738', '840', NULL, '', '1.00', '50.00', '20', '50.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7937, '423178959198628', '1948967738', '775', NULL, '', '1.00', '50.00', '30', '50.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7936, '436334246521841', '1948967738', '716', NULL, '', '1.00', '250.00', '190', '250.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7935, '386826513462738', '1948967738', '379', NULL, '', '3.00', '50.00', '25', '150.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7934, '638373434228259', '1948967738', '1154', NULL, '', '3.00', '150.00', '110', '450.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7933, '125229726159117', '1948967738', '954', NULL, '', '2.00', '150.00', '80', '300.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7932, '556582131268926', '1948967738', '583', NULL, '', '1.00', '2950.00', '2300', '2950.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7857, '476173743173911', '7653135536', '694', NULL, '', '10.00', '200.00', '130', '2000.00', '0.00', '', '0.00', '0', '75050.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7856, '973338495511243', '7653135536', '441', NULL, '', '10.00', '350.00', '282.5', '3500.00', '0.00', '', '0.00', '0', '75050.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7855, '173491857824667', '7653135536', '777', NULL, '', '2.00', '75.00', '20', '150.00', '0.00', '', '0.00', '0', '75050.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7854, '685628521249187', '7653135536', '213', NULL, '', '1.00', '200.00', '166.667', '200.00', '0.00', '', '0.00', '0', '75050.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7853, '364177276145864', '7653135536', '221', NULL, '', '1.00', '850.00', '480', '850.00', '0.00', '', '0.00', '0', '75050.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7852, '571843385834146', '7653135536', '603', NULL, '', '10.00', '375.00', '250', '3750.00', '0.00', '', '0.00', '0', '75050.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7851, '661769328958256', '7653135536', '1143', NULL, '', '8.00', '900.00', '820', '7200.00', '0.00', '', '0.00', '0', '75050.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7850, '962367637937259', '7653135536', '1145', NULL, '', '1.00', '800.00', '550', '800.00', '0.00', '', '0.00', '0', '75050.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7849, '111363374369885', '7653135536', '1144', NULL, '', '18.00', '550.00', '430', '9900.00', '0.00', '', '0.00', '0', '75050.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7848, '241672345619571', '7653135536', '1146', NULL, '', '6.00', '650.00', '530', '3900.00', '0.00', '', '0.00', '0', '75050.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7847, '429793744911676', '7653135536', '1148', NULL, '', '3.00', '650.00', '530', '1950.00', '0.00', '', '0.00', '0', '75050.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7846, '414337762664814', '7653135536', '1147', NULL, '', '6.00', '500.00', '430', '3000.00', '0.00', '', '0.00', '0', '75050.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7845, '472196429854895', '7653135536', '1096', NULL, '', '2.00', '900.00', '784', '1800.00', '0.00', '', '0.00', '0', '75050.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7844, '289816378666142', '7653135536', '243', NULL, '', '60.00', '480.00', '415', '28800.00', '0.00', '', '0.00', '0', '75050.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7843, '817155872768568', '7653135536', '235', NULL, '', '5.00', '1250.00', '1100', '6250.00', '0.00', '', '0.00', '0', '75050.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7842, '418444441728435', '7653135536', '895', NULL, '', '4.00', '50.00', '45', '200.00', '0.00', '', '0.00', '0', '75050.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7841, '768482663143117', '7653135536', '448', NULL, '', '1.00', '150.00', '120', '150.00', '0.00', '', '0.00', '0', '75050.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7840, '985795532655758', '7653135536', '497', NULL, '', '1.00', '200.00', '160', '200.00', '0.00', '', '0.00', '0', '75050.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7839, '618528158491171', '7653135536', '498', NULL, '', '1.00', '250.00', '250', '250.00', '0.00', '', '0.00', '0', '75050.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7858, '466484269735958', '7653135536', '920', NULL, '', '8.00', '25.00', '20', '200.00', '0.00', '', '0.00', '0', '75050.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7859, '598121499837466', '7865327862', '974', NULL, '', '4.00', '3600.00', '2800', '14400.00', '0.00', '', NULL, '0', '182360.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7860, '993117189376392', '7865327862', '1048', NULL, '', '1.00', '35000.00', '23750', '35000.00', '0.00', '', NULL, '0', '182360.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7861, '785715992528793', '7865327862', '1048', NULL, '', '1.00', '30000.00', '23750', '30000.00', '0.00', '', NULL, '0', '182360.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7930, '682282273915185', '3395545996', '1129', NULL, '', '1.00', '2700.00', '1950', '2700.00', '0.00', '', '0.00', '0', '24430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7929, '326158848881841', '3395545996', '1031', NULL, '', '1.00', '4500.00', '4200', '4500.00', '0.00', '', '0.00', '0', '24430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7928, '299956421161887', '3395545996', '836', NULL, '', '4.00', '50.00', '30', '200.00', '0.00', '', '0.00', '0', '24430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7927, '222413146315826', '3395545996', '694', NULL, '', '5.00', '150.00', '130', '750.00', '0.00', '', '0.00', '0', '24430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7926, '647279457598874', '3395545996', '860', NULL, '', '1.00', '250.00', '170', '250.00', '0.00', '', '0.00', '0', '24430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7925, '332285378842889', '3395545996', '372', NULL, '', '20.00', '50.00', '40', '1000.00', '0.00', '', '0.00', '0', '24430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7924, '523164616954718', '3395545996', '441', NULL, '', '1.00', '290.00', '282.5', '290.00', '0.00', '', '0.00', '0', '24430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7923, '556768699494476', '3395545996', '490', NULL, '', '2.00', '150.00', '85', '300.00', '0.00', '', '0.00', '0', '24430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7922, '447874346377512', '3395545996', '904', NULL, '', '2.00', '25.00', '3', '50.00', '0.00', '', '0.00', '0', '24430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7921, '639953756211157', '3395545996', '381', NULL, '', '3.00', '60.00', '34', '180.00', '0.00', '', '0.00', '0', '24430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7920, '378789287779638', '3395545996', '258', NULL, '', '1.00', '400.00', '450', '400.00', '0.00', '', '0.00', '0', '24430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7919, '137868727838455', '3395545996', '257', NULL, '', '1.00', '600.00', '583.333', '600.00', '0.00', '', '0.00', '0', '24430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7918, '212277545111131', '3395545996', '237', NULL, '', '2.00', '500.00', '530', '1000.00', '0.00', '', '0.00', '0', '24430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7917, '112159382389649', '3395545996', '1027', NULL, '', '5.00', '80.00', '65', '400.00', '0.00', '', '0.00', '0', '24430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7916, '221219775124957', '3395545996', '895', NULL, '', '2.00', '50.00', '45', '100.00', '0.00', '', '0.00', '0', '24430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7915, '941863442728422', '3395545996', '481', NULL, '', '1.00', '50.00', '109.3', '50.00', '0.00', '', '0.00', '0', '24430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7914, '244815855854675', '3395545996', '1033', NULL, '', '2.00', '2700.00', '2400', '5400.00', '0.00', '', '0.00', '0', '24430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7913, '846412596282629', '3395545996', '1029', NULL, '', '1.00', '1000.00', '900', '1000.00', '0.00', '', '0.00', '0', '24430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7912, '513959463687736', '3395545996', '218', NULL, '', '3.00', '200.00', '160', '600.00', '0.00', '', '0.00', '0', '24430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7911, '454557422731386', '3395545996', '851', NULL, '', '1.00', '300.00', '250', '300.00', '0.00', '', '0.00', '0', '24430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7910, '736746843972618', '3395545996', '1070', NULL, '', '1.00', '1350.00', '1500', '1350.00', '0.00', '', '0.00', '0', '24430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7909, '844395495849839', '3395545996', '840', NULL, '', '2.00', '20.00', '20', '40.00', '0.00', '', '0.00', '0', '24430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7908, '952949841983113', '3395545996', '903', NULL, '', '2.00', '50.00', '40', '100.00', '0.00', '', '0.00', '0', '24430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7907, '295421133862747', '3395545996', '373', NULL, '', '5.00', '30.00', '17', '150.00', '0.00', '', '0.00', '0', '24430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7931, '418498852198585', '3395545996', '1084', NULL, '', '16.00', '170.00', '141', '2720.00', '0.00', '', '0.00', '0', '24430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7967, '471958121523218', '1948967738', '963', NULL, '', '1.00', '2850.00', '2500', '2850.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7968, '996879367129525', '1948967738', '481', NULL, '', '2.00', '50.00', '109.3', '100.00', '0.00', '', '0.00', '0', '81550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7969, '213982583132957', '3454739466', '420', NULL, '', '2.00', '4200.00', '3936', '8400.00', '0.00', '', NULL, '0', '1504316.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7970, '924112945153639', '3454739466', '213', NULL, '', '2.00', '190.00', '166.667', '380.00', '0.00', '', NULL, '0', '1504316.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7971, '197666821864672', '3454739466', '334', NULL, '', '2.00', '17000.00', '16817', '34000.00', '0.00', '', NULL, '0', '1504316.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7972, '345963528428761', '3454739466', '1119', NULL, '', '1.00', '17000.00', '16000', '17000.00', '0.00', '', NULL, '0', '1504316.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7973, '841787357389826', '3454739466', '333', NULL, '', '1.00', '17000.00', '16817', '17000.00', '0.00', '', NULL, '0', '1504316.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7974, '557876168416895', '3454739466', '650', NULL, '', '10.00', '3000.00', '2938.1', '30000.00', '0.00', '', NULL, '0', '1504316.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7975, '481425932759183', '3454739466', '135', NULL, '', '10.00', '3000.00', '2938.1', '30000.00', '0.00', '', NULL, '0', '1504316.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7976, '669543991634437', '3454739466', '141', NULL, '', '4.00', '6200.00', '6098.6', '24800.00', '0.00', '', NULL, '0', '1504316.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7977, '848279633694597', '3454739466', '144', NULL, '', '4.00', '6200.00', '6098.6', '24800.00', '0.00', '', NULL, '0', '1504316.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7978, '369633765596966', '3454739466', '299', NULL, '', '3.00', '4200.00', '4134', '12600.00', '0.00', '', NULL, '0', '1504316.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7979, '348782924713643', '3454739466', '323', NULL, '', '2.00', '4200.00', '4134', '8400.00', '0.00', '', NULL, '0', '1504316.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7980, '398667496347853', '3454739466', '283', NULL, '', '5.00', '60.00', '30', '300.00', '0.00', '', NULL, '0', '1504316.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7981, '482665237652875', '3454739466', '299', NULL, '', '10.00', '4200.00', '4134', '42000.00', '0.00', '', NULL, '0', '1504316.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7982, '922942517995695', '3454739466', '323', NULL, '', '5.00', '4200.00', '4134', '21000.00', '0.00', '', NULL, '0', '1504316.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7983, '495322195382734', '3454739466', '300', NULL, '', '5.00', '8950.00', '8740.5', '44750.00', '0.00', '', NULL, '0', '1504316.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7984, '283887348267289', '3454739466', '327', NULL, '', '5.00', '8950.00', '8751.67', '44750.00', '0.00', '', NULL, '0', '1504316.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7985, '499928989394465', '3454739466', '307', NULL, '', '1.00', '6700.00', '6000', '6700.00', '0.00', '', NULL, '0', '1504316.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7986, '743235248919763', '3454739466', '347', NULL, '', '1.00', '6700.00', '6000', '6700.00', '0.00', '', NULL, '0', '1504316.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7987, '273289798937816', '3454739466', '361', NULL, '', '1.00', '4300.00', '3800', '4300.00', '0.00', '', NULL, '0', '1504316.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7988, '495148275712473', '1897354479', '1157', NULL, '', '1.00', '2500.00', '1800', '2500.00', '0.00', '', NULL, '0', '190560.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7989, '491916942511535', '1897354479', '508', NULL, '', '15.00', '380.00', '305', '5700.00', '0.00', '', NULL, '0', '190560.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7994, '477694816682624', '1971361776', '555', NULL, '', '1.00', '1800.00', '1533.33', '1800.00', '0.00', '', '0.00', '1555300', '1800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (7995, '774376539943826', '1331473321', '690', NULL, '', '30.00', '1060.00', '840', '31800.00', '0.00', '', NULL, '0', '224160.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8018, '158314722392848', '5989899254', '249', NULL, '', '4.00', '2000.00', '1783.33', '8000.00', '0.00', '', '0.00', '0', '82295.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8311, '217877641815691', '4181161449', '490', NULL, '', '7.00', '105.00', '85', '735.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8310, '891775728786384', '4181161449', '694', NULL, '', '30.00', '135.00', '130', '4050.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8309, '598958784786562', '4181161449', '155', NULL, '', '2.00', '3250.00', '3208', '6500.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8308, '733662283785756', '4181161449', '276', NULL, '', '1.00', '200.00', '180', '200.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8307, '919588462644818', '4181161449', '114', NULL, '', '1.00', '1300.00', '480', '1300.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8306, '772223984954331', '4181161449', '481', NULL, '', '1.00', '50.00', '97.5', '50.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8305, '793286815652295', '4181161449', '284', NULL, '', '1.00', '50.00', '33.5', '50.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8304, '591137961574591', '4181161449', '885', NULL, '', '1.00', '500.00', '440.5', '500.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8303, '291488267384561', '4181161449', '661', NULL, '', '1.00', '2000.00', '1557', '2000.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8302, '568778191279581', '4181161449', '784', NULL, '', '1.00', '200.00', '135', '200.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8301, '545698497639892', '4181161449', '441', NULL, '', '2.00', '300.00', '276.667', '600.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8300, '869753544179528', '4181161449', '62', NULL, '', '1.00', '1600.00', '1500', '1600.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8299, '257498847836675', '4181161449', '407', NULL, '', '1.00', '350.00', '330', '350.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8298, '222138978764327', '4181161449', '1158', NULL, '', '1.00', '50.00', '30', '50.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8297, '754782598577833', '4181161449', '381', NULL, '', '2.00', '50.00', '34', '100.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8296, '148829148269688', '4181161449', '715', NULL, '', '5.00', '130.00', '120', '650.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8295, '359993524883215', '4181161449', '694', NULL, '', '2.00', '160.00', '130', '320.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8294, '741467891827137', '4181161449', '700', NULL, '', '9.00', '170.00', '160', '1530.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8293, '895359321233375', '4181161449', '56', NULL, '', '2.00', '1000.00', '1000', '2000.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8292, '695529484144165', '4181161449', '91', NULL, '', '1.00', '50.00', '540', '50.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8291, '479285648677693', '4181161449', '860', NULL, '', '1.00', '250.00', '170', '250.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8290, '913667928115468', '4181161449', '888', NULL, '', '3.00', '300.00', '322', '900.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8289, '292542345455651', '4181161449', '399', NULL, '', '7.00', '280.00', '286.5', '1960.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8288, '561436659768352', '4181161449', '883', NULL, '', '5.00', '480.00', '468.25', '2400.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8287, '871286672679254', '4181161449', '786', NULL, '', '1.00', '200.00', '250', '200.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8286, '167181514823387', '4181161449', '785', NULL, '', '1.00', '200.00', '175', '200.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8285, '233282279818483', '4181161449', '375', NULL, '', '2.00', '30.00', '15', '60.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8284, '586213921298311', '4181161449', '1044', NULL, '', '2.00', '60.00', '25', '120.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8283, '838434851222985', '4181161449', '1132', NULL, '', '2.00', '75.00', '20', '150.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8282, '689528853511764', '4181161449', '270', NULL, '', '1.00', '240.00', '160', '240.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8281, '585246351155875', '4181161449', '98', NULL, '', '1.00', '720.00', '850', '720.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8280, '399425124948965', '4181161449', '441', NULL, '', '4.00', '300.00', '276.667', '1200.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8279, '593188656238177', '4181161449', '694', NULL, '', '8.00', '200.00', '130', '1600.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8278, '516496728271575', '4181161449', '603', NULL, '', '4.00', '350.00', '250', '1400.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8277, '763212278451193', '4181161449', '221', NULL, '', '1.00', '700.00', '480', '700.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8276, '441745297591853', '4181161449', '218', NULL, '', '1.00', '200.00', '160', '200.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8275, '454375344541567', '4181161449', '600', NULL, '', '3.00', '50.00', '160.667', '150.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8274, '399188627888712', '4181161449', '912', NULL, '', '1.00', '100.00', '85', '100.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8273, '541979759364271', '4181161449', '78', NULL, '', '2.00', '150.00', '160', '300.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8272, '166667364836495', '4181161449', '1155', NULL, '', '2.00', '600.00', '450', '1200.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8271, '345642354367243', '4181161449', '223', NULL, '', '1.00', '1500.00', '1250', '1500.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8270, '243734332457193', '4181161449', '259', NULL, '', '1.00', '1200.00', '1200', '1200.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8269, '846919231583485', '4181161449', '650', NULL, '', '1.00', '3000.00', '2938.1', '3000.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8268, '364575111892989', '4181161449', '135', NULL, '', '1.00', '3000.00', '2938.1', '3000.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8267, '865464471144988', '4181161449', '141', NULL, '', '1.00', '6000.00', '6098.6', '6000.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8266, '418428363333693', '4181161449', '283', NULL, '', '4.00', '50.00', '30', '200.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8265, '338427242957751', '4181161449', '886', NULL, '', '4.00', '300.00', '277', '1200.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8178, '817212799326399', '8951253458', '481', NULL, '', '2.00', '50.00', '109.3', '100.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8179, '645543923172883', '8951253458', '833', NULL, '', '1.00', '50.00', '25', '50.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8180, '265559844844174', '8951253458', '490', NULL, '', '1.00', '250.00', '85', '250.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8181, '246495151443965', '8951253458', '381', NULL, '', '1.00', '30.00', '34', '30.00', '0.00', '', '0.00', '0', '40080.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8522, '782522719328174', '2343991432', '1027', NULL, '', '5.00', '70.00', '65', '350.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8521, '387926477332266', '2343991432', '244', NULL, '', '1.00', '5700.00', '5500', '5700.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9366, '623472271924436', '6351564964', '221', NULL, '', '1.00', '500.00', '480', '500.00', '0.00', '', '0.00', '0', '5040.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9365, '426131998292518', '6351564964', '888', NULL, '', '1.00', '250.00', '322', '250.00', '0.00', '', '0.00', '0', '5040.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8229, '185526211619857', '3687215118', '974', NULL, '', '3.00', '3600.00', '2800', '10800.00', '0.00', '', NULL, '0', '234960.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8230, '129171888813299', '3352983635', '291', NULL, '', '3.00', '9500.00', '9402.5', '28500.00', '0.00', '', NULL, '0', '698325.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8231, '589281737473957', '3352983635', '321', NULL, '', '2.00', '9500.00', '9402.5', '19000.00', '0.00', '', NULL, '0', '698325.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8232, '961698251265628', '7953851285', '420', NULL, '', '1.00', '4200.00', '3936', '4200.00', '0.00', '', NULL, '0', '391860.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8233, '986895853492486', '6742371245', '102', NULL, '', '6.00', '600.00', '450', '3600.00', '0.00', '', NULL, '0', '393500.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8234, '437485583932692', '6742371245', '699', NULL, '', '18.00', '400.00', '320', '7200.00', '0.00', '', NULL, '0', '393500.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8235, '884612256414285', '6742371245', '694', NULL, '', '12.00', '200.00', '130', '2400.00', '0.00', '', NULL, '0', '393500.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8236, '871923336447642', '6742371245', '718', NULL, '', '50.00', '350.00', '220', '17500.00', '0.00', '', NULL, '0', '393500.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8312, '619271985164633', '4181161449', '104', NULL, '', '1.00', '300.00', '300', '300.00', '0.00', '', '0.00', '0', '53285.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8430, '852868384918699', '4754231575', '836', NULL, '', '2.00', '2420.00', '30', '100.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8429, '596534622863335', '4754231575', '38', NULL, '', '1.00', '60.00', '20', '50.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8428, '336492773885995', '4754231575', '839', NULL, '', '1.00', '30.00', '14', '30.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8427, '391414937247966', '4754231575', '840', NULL, '', '4.00', '40.00', '20', '160.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8426, '642225337823555', '4754231575', '86', NULL, '', '1.00', '600.00', '390', '600.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8425, '731741691231158', '4754231575', '102', NULL, '', '1.00', '480.00', '450', '480.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8424, '762477781195327', '4754231575', '1043', NULL, '', '3.00', '30.00', '20', '90.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8423, '871979556826459', '4754231575', '1161', NULL, '', '6.00', '10.00', '10', '60.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8422, '996358735867953', '4754231575', '375', NULL, '', '3.00', '30.00', '15', '90.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8421, '792983875199525', '4754231575', '113', NULL, '', '2.00', '850.00', '840', '1700.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8420, '934788956335476', '4754231575', '224', NULL, '', '2.00', '550.00', '550', '1100.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8419, '422952249939492', '4754231575', '715', NULL, '', '50.00', '120.00', '120', '6000.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8418, '437462324592845', '4754231575', '135', NULL, '', '1.00', '3000.00', '2938.1', '3000.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8417, '714972862346123', '4754231575', '773', NULL, '', '1.00', '150.00', '80', '150.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8416, '374164585131888', '4754231575', '694', NULL, '', '6.00', '150.00', '130', '900.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8415, '165752189797672', '4754231575', '496', NULL, '', '8.00', '60.00', '38', '480.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8414, '187714145955247', '4754231575', '89', NULL, '', '1.00', '300.00', '280', '300.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8413, '764175533351654', '4754231575', '699', NULL, '', '4.00', '330.00', '320', '1320.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8412, '574177262623182', '4754231575', '963', NULL, '', '2.00', '2850.00', '2500', '5700.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8411, '188981479545911', '4754231575', '600', NULL, '', '3.00', '50.00', '160.667', '150.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8410, '628671478434455', '4754231575', '918', NULL, '', '1.00', '200.00', '155', '200.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8409, '784624866954954', '4754231575', '218', NULL, '', '2.00', '200.00', '160', '400.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8408, '739166372975294', '4754231575', '921', NULL, '', '2.00', '60.00', '50', '120.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8407, '196377212759674', '4754231575', '222', NULL, '', '6.00', '350.00', '230', '2100.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8400, '979727533665455', '4754231575', '270', NULL, '', '1.00', '240.00', '160', '240.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8401, '264961214155626', '4754231575', '399', NULL, '', '1.00', '300.00', '286.5', '300.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8402, '537539387485691', '4754231575', '369', NULL, '', '2.00', '100.00', '84', '200.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8403, '453443268637836', '4754231575', '837', NULL, '', '30.00', '90.00', '70', '2700.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8404, '491449595977656', '4754231575', '1079', NULL, '', '1.00', '90.00', '1100', '1000.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8405, '361223724435978', '4754231575', '9', NULL, '', '1.00', '900.00', '430', '900.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8406, '285394219742983', '4754231575', '1055', NULL, '', '1.00', '750.00', '666.667', '750.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8520, '867575122523786', '2343991432', '1056', NULL, '', '3.00', '80.00', '450', '1650.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8445, '974416199622962', '4187574224', '773', NULL, '', '6.00', '130.00', '80', '780.00', '0.00', '', NULL, '0', '18320.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8444, '284822199416239', '4187574224', '849', NULL, '', '50.00', '15.00', '10', '750.00', '0.00', '', NULL, '0', '18320.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8443, '832812756963722', '4187574224', '715', NULL, '', '100.00', '120.00', '120', '12000.00', '0.00', '', NULL, '0', '18320.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8442, '251485581997226', '4187574224', '59', NULL, '', '1.00', '150.00', '165', '150.00', '0.00', '', NULL, '0', '18320.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8441, '986126641298245', '4187574224', '448', NULL, '', '1.00', '150.00', '120', '150.00', '0.00', '', NULL, '0', '18320.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8440, '876657479699345', '4187574224', '837', NULL, '', '4.00', '90.00', '70', '360.00', '0.00', '', NULL, '0', '18320.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8439, '575277853798175', '4187574224', '836', NULL, '', '1.00', '50.00', '30', '50.00', '0.00', '', NULL, '0', '18320.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8438, '321569476654578', '4187574224', '411', NULL, '', '1.00', '3600.00', '3300', '3600.00', '0.00', '', NULL, '0', '18320.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8437, '575864457791245', '4187574224', '490', NULL, '', '1.00', '230.00', '85', '230.00', '0.00', '', NULL, '0', '18320.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8436, '735766883998841', '4187574224', '373', NULL, '', '10.00', '25.00', '17', '250.00', '0.00', '', NULL, '0', '18320.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8435, '119352615698922', '4754231575', '481', NULL, '', '2.00', '50.00', '97.5', '100.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8434, '594779211925895', '4754231575', '837', NULL, '', '7.00', '90.00', '70', '630.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8433, '535655217871476', '4754231575', '422', NULL, '', '2.00', '50.00', '30', '100.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8432, '883951576147828', '4754231575', '1159', NULL, '', '3.00', '2500.00', '2400', '7500.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8431, '239793643473842', '4754231575', '1139', NULL, '', '3.00', '40.00', '40', '120.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8398, '964488597331943', '7943379429', '248', NULL, '', '0.00', '0.00', '320', '0.00', '0.00', '', '0.00', '0', '0.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8363, '561339642552338', '5253343437', '715', NULL, '', '24.00', '250.00', '120', '6000.00', '0.00', '', NULL, '0', '253960.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8364, '333351943326785', '5253343437', '100', NULL, '', '6.00', '600.00', '300', '3600.00', '0.00', '', NULL, '0', '253960.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8365, '381614953958859', '5253343437', '270', NULL, '', '2.00', '360.00', '160', '720.00', '0.00', '', NULL, '0', '253960.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8366, '221578284659816', '5253343437', '843', NULL, '', '6.00', '30.00', '13', '180.00', '0.00', '', NULL, '0', '253960.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8367, '435278758517969', '5253343437', '580', NULL, '', '1.00', '8000.00', '5500', '8000.00', '0.00', '', NULL, '0', '253960.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8368, '513183876535558', '5253343437', '481', NULL, '', '10.00', '50.00', '97.5', '500.00', '0.00', '', NULL, '0', '253960.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8369, '837843542154228', '8378298814', '135', NULL, '', '1.00', '3100.00', '2938.1', '3100.00', '0.00', '', NULL, '0', '654075.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8370, '284312219392743', '8378298814', '650', NULL, '', '1.00', '3100.00', '2938.1', '3100.00', '0.00', '', NULL, '0', '654075.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8399, '281425112897356', '4754231575', '422', NULL, '', '1.00', '40.00', '30', '40.00', '0.00', '', '0.00', '0', '39860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8519, '625982684218246', '2343991432', '221', NULL, '', '2.00', '750.00', '480', '1500.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8556, '378426182611126', '2343991432', '730', NULL, '', '18.00', '160.00', '148', '2880.00', '0.00', '', '0.00', '0', '2367804.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8793, '231473996655789', '1929867449', '1132', NULL, '', '4.00', '30.00', '20', '120.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8792, '449826728176578', '1929867449', '693', NULL, '', '1.00', '200.00', '130', '200.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8791, '711472522696859', '1929867449', '441', NULL, '', '1.00', '350.00', '275', '350.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8790, '354368435321839', '1929867449', '481', NULL, '', '2.00', '50.00', '97.5', '100.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8789, '472712959849992', '1929867449', '135', NULL, '', '2.00', '3050.00', '2938.1', '6100.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8788, '865345419363319', '1929867449', '650', NULL, '', '1.00', '3050.00', '2938.1', '3050.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8787, '374767527369965', '1929867449', '270', NULL, '', '1.00', '240.00', '160', '240.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8786, '882812194727756', '1929867449', '217', NULL, '', '1.00', '200.00', '180', '200.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8785, '161279896511825', '1929867449', '842', NULL, '', '2.00', '50.00', '25', '100.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8784, '952787992463144', '1929867449', '1175', NULL, '', '1.00', '70.00', '45.9', '70.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8783, '749224793195224', '1929867449', '1037', NULL, '', '12.00', '15.00', '9', '180.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8782, '161329937452946', '1929867449', '283', NULL, '', '1.00', '60.00', '30', '60.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8781, '184541356516822', '1929867449', '1177', NULL, '', '1.00', '50.00', '30', '50.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8780, '685329715986513', '1929867449', '1176', NULL, '', '4.00', '50.00', '40', '200.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8779, '195626539418149', '1929867449', '1174', NULL, '', '1.00', '150.00', '120', '150.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8778, '191883411489336', '1929867449', '449', NULL, '', '4.00', '130.00', '95', '520.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8777, '332262934927848', '1929867449', '843', NULL, '', '4.00', '20.00', '13', '80.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8776, '663898544536983', '1929867449', '381', NULL, '', '2.00', '50.00', '34', '100.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8775, '599593342123755', '1929867449', '86', NULL, '', '1.00', '550.00', '390', '550.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8774, '181895179395164', '1929867449', '481', NULL, '', '1.00', '50.00', '97.5', '50.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8773, '973384235556789', '1929867449', '1132', NULL, '', '2.00', '30.00', '20', '60.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8772, '818163993671178', '1929867449', '1044', NULL, '', '1.00', '35.00', '25', '35.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8771, '796273262279951', '1929867449', '1043', NULL, '', '1.00', '35.00', '20', '35.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8770, '834287758134493', '1929867449', '701', NULL, '', '3.00', '1100.00', '1065', '3300.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8769, '542486261243454', '1929867449', '100', NULL, '', '2.00', '420.00', '300', '840.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8768, '781896582199158', '1929867449', '603', NULL, '', '1.00', '350.00', '250', '350.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8767, '936845636647771', '1929867449', '363', NULL, '', '1.00', '350.00', '320', '350.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8766, '196271985267234', '1929867449', '218', NULL, '', '1.00', '200.00', '160', '200.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8765, '972974467498449', '1929867449', '600', NULL, '', '2.00', '50.00', '160.667', '100.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8764, '125296551789721', '1929867449', '225', NULL, '', '1.00', '550.00', '465', '550.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8763, '552453443446715', '1929867449', '283', NULL, '', '2.00', '60.00', '30', '120.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8762, '489619734198797', '1929867449', '1173', NULL, '', '2.00', '250.00', '150', '500.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8761, '476357544542293', '1929867449', '716', NULL, '', '2.00', '250.00', '190', '500.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8760, '326556538138895', '1929867449', '715', NULL, '', '5.00', '130.00', '120', '650.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8759, '493651252265195', '1929867449', '584', NULL, '', '1.00', '3200.00', '2600', '3200.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8758, '828218511315934', '1929867449', '579', NULL, '', '1.00', '2600.00', '2200', '2600.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8757, '263491251877594', '1929867449', '837', NULL, '', '4.00', '90.00', '70', '360.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8756, '723625617346869', '1929867449', '967', NULL, '', '1.00', '3500.00', '3500', '3500.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8755, '293162883759957', '1929867449', '1162', NULL, '', '1.00', '20000.00', '17533', '20000.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8754, '876977516827631', '1929867449', '1079', NULL, '', '1.00', '1600.00', '1100', '1600.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8753, '321119959273136', '1929867449', '481', NULL, '', '1.00', '50.00', '97.5', '50.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8752, '598691688462187', '1929867449', '490', NULL, '', '1.00', '250.00', '85', '250.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8751, '739499158775426', '1929867449', '490', NULL, '', '2.00', '200.00', '85', '400.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8750, '757175297538271', '1929867449', '700', NULL, '', '10.00', '170.00', '160', '1700.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8749, '435917314816711', '1929867449', '1026', NULL, '', '1.00', '50.00', '30', '50.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8602, '739672846728135', '2696397343', '712', NULL, '', '200.00', '380.00', '320', '76000.00', '0.00', '', NULL, '0', '329960.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8748, '995414165717522', '1929867449', '9', NULL, '', '1.00', '450.00', '430', '450.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8747, '724183799181345', '1929867449', '135', NULL, '', '1.00', '4000.00', '2938.1', '4000.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8746, '314286852617538', '1929867449', '665', NULL, '', '2.00', '3350.00', '3208', '6700.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8745, '469653277452329', '1929867449', '481', NULL, '', '1.00', '50.00', '97.5', '50.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8744, '842541491398631', '1929867449', '694', NULL, '', '2.00', '200.00', '130', '400.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8743, '288153174838133', '1929867449', '363', NULL, '', '1.00', '300.00', '320', '300.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8742, '674295419627558', '1929867449', '1120', NULL, '', '1.00', '5300.00', '5400', '5300.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8794, '535712751329852', '1929867449', '1133', NULL, '', '2.00', '40.00', '30', '80.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8795, '776652757786513', '1929867449', '221', NULL, '', '1.00', '750.00', '480', '750.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8796, '156447529831517', '1929867449', '866', NULL, '', '1.00', '200.00', '120', '200.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8797, '787947857482168', '1929867449', '884', NULL, '', '2.00', '500.00', '458.667', '1000.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8798, '234232879711536', '1929867449', '399', NULL, '', '2.00', '350.00', '286.5', '700.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8799, '988838548483385', '1929867449', '855', NULL, '', '1.00', '350.00', '286.667', '350.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8800, '346253513652351', '1929867449', '854', NULL, '', '1.00', '350.00', '290', '350.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8801, '421275412591869', '1929867449', '284', NULL, '', '2.00', '60.00', '33.5', '120.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8802, '969941538748966', '1929867449', '283', NULL, '', '4.00', '50.00', '30', '200.00', '0.00', '', '0.00', '0', '74720.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8803, '253427733744957', '7592546738', '1139', NULL, '', '6.00', '30.00', '40', '180.00', '0.00', '', NULL, '0', '300.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8804, '133569762653477', '7592546738', '382', NULL, '', '2.00', '60.00', '46', '120.00', '0.00', '', NULL, '0', '300.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8848, '671191569453633', '7225778361', '1038', NULL, '', '30.00', '165200.00', '10', '450.00', '0.00', '', '0.00', '0', '345172.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8847, '173588173426175', '7225778361', '1086', NULL, '', '4.00', '21368.00', '23456.5', '85472.00', '0.00', '', '0.00', '0', '345172.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8846, '298547267177438', '7225778361', '448', NULL, '', '1.00', '150.00', '120', '150.00', '0.00', '', '0.00', '0', '345172.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8845, '527112622332434', '7225778361', '497', NULL, '', '1.00', '200.00', '160', '200.00', '0.00', '', '0.00', '0', '345172.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8844, '782494941293899', '7225778361', '1170', NULL, '', '20.00', '450.00', '370', '9000.00', '0.00', '', '0.00', '0', '345172.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8843, '245388645469262', '7225778361', '1017', NULL, '', '12.00', '60.00', '45', '720.00', '0.00', '', '0.00', '0', '345172.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8842, '272238156769264', '7225778361', '481', NULL, '', '4.00', '50.00', '97.5', '200.00', '0.00', '', '0.00', '0', '345172.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8841, '197254888995616', '7225778361', '1058', NULL, '', '4.00', '300.00', '225', '1200.00', '0.00', '', '0.00', '0', '345172.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8840, '844111738555883', '7225778361', '794', NULL, '', '10.00', '170.00', '140', '1700.00', '0.00', '', '0.00', '0', '345172.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8839, '577635149644831', '7225778361', '175', NULL, '', '1.00', '180.00', '125', '180.00', '0.00', '', '0.00', '0', '345172.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8838, '591716356892568', '7225778361', '955', NULL, '', '6.00', '30.00', '20', '180.00', '0.00', '', '0.00', '0', '345172.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8837, '947172784552762', '7225778361', '734', NULL, '', '1.00', '200.00', '120', '200.00', '0.00', '', '0.00', '0', '345172.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8836, '429239659364311', '7225778361', '851', NULL, '', '1.00', '200.00', '250', '200.00', '0.00', '', '0.00', '0', '345172.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8835, '868494955686755', '7225778361', '909', NULL, '', '50.00', '10.00', '8', '500.00', '0.00', '', '0.00', '0', '345172.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8834, '924697717223836', '7225778361', '1084', NULL, '', '46.00', '170.00', '147', '7820.00', '0.00', '', '0.00', '0', '345172.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8849, '451859863851293', '7225778361', '1169', NULL, '', '1.00', '168000.00', '165000', '168000.00', '0.00', '', '0.00', '0', '345172.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9931, '225783916923448', '2926266512', '243', NULL, '', '0.00', '0.00', '415', '0.00', '0.00', '', '0.00', '0', '345172.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8851, '998852577385411', '5411671834', '9', NULL, '', '12.00', '450.00', '430', '5400.00', '0.00', '', NULL, '0', '718925.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8852, '744161362573891', '5411671834', '17', NULL, '', '50.00', '200.00', '180', '10000.00', '0.00', '', NULL, '0', '718925.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8853, '238114228859777', '5411671834', '160', NULL, '', '1.00', '5200.00', '5126', '5200.00', '0.00', '', NULL, '0', '718925.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8854, '384571311593545', '5613664541', '72', NULL, '', '1.00', '2200.00', '2250', '2200.00', '0.00', '', NULL, '0', '105730.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8855, '269138457995157', '1464127388', '72', NULL, '', '2.00', '2200.00', '2250', '4400.00', '0.00', '', NULL, '0', '1636336.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8856, '919359586446724', '1464127388', '961', NULL, '', '3.00', '2200.00', '2050', '6600.00', '0.00', '', NULL, '0', '1636336.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8857, '321614356294985', '1464127388', '300', NULL, '', '2.00', '9200.00', '8740.5', '18400.00', '0.00', '', NULL, '0', '1636336.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8858, '866478154755586', '1464127388', '327', NULL, '', '2.00', '9200.00', '8751.67', '18400.00', '0.00', '', NULL, '0', '1636336.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8859, '335951233421252', '1464127388', '1149', NULL, '', '2.00', '10000.00', '10000', '20000.00', '0.00', '', NULL, '0', '1636336.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8860, '946644438822851', '1464127388', '419', NULL, '', '1.00', '7500.00', '7121', '7500.00', '0.00', '', NULL, '0', '1636336.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8861, '948723148682923', '1464127388', '962', NULL, '', '1.00', '4700.00', '4100', '4700.00', '0.00', '', NULL, '0', '1636336.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8862, '377568131436877', '1464127388', '418', NULL, '', '1.00', '4700.00', '4300', '4700.00', '0.00', '', NULL, '0', '1636336.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8863, '857468287716141', '1464127388', '650', NULL, '', '2.00', '3000.00', '2938.1', '6000.00', '0.00', '', NULL, '0', '1636336.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8864, '756633895996231', '1464127388', '135', NULL, '', '3.00', '3000.00', '2938.1', '9000.00', '0.00', '', NULL, '0', '1636336.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8865, '347896358255394', '1464127388', '141', NULL, '', '1.00', '6300.00', '6098.6', '6300.00', '0.00', '', NULL, '0', '1636336.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8866, '732441242718624', '1464127388', '144', NULL, '', '1.00', '6300.00', '6098.6', '6300.00', '0.00', '', NULL, '0', '1636336.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8867, '966813776939937', '1464127388', '322', NULL, '', '1.00', '16500.00', '15101', '16500.00', '0.00', '', NULL, '0', '1636336.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8868, '462393663126894', '1464127388', '2', NULL, '', '6.00', '260.00', '190', '1560.00', '0.00', '', NULL, '0', '1636336.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8869, '394455574951632', '1464127388', '264', NULL, '', '2.00', '130.00', '80', '260.00', '0.00', '', NULL, '0', '1636336.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8870, '396447295874263', '1464127388', '265', NULL, '', '2.00', '160.00', '120', '320.00', '0.00', '', NULL, '0', '1636336.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8871, '211192618725894', '1464127388', '270', NULL, '', '6.00', '180.00', '160', '1080.00', '0.00', '', NULL, '0', '1636336.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8872, '381978398923235', '7252192761', '811', NULL, '', '100.00', '105.00', '103', '10500.00', '0.00', '', NULL, '0', '295202.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8873, '372632263688545', '7252192761', '1034', NULL, '', '10.00', '120.00', '155', '1200.00', '0.00', '', NULL, '0', '295202.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8874, '955692571772533', '2238345531', '650', NULL, '', '3.00', '3000.00', '2938.1', '9000.00', '0.00', '', NULL, '0', '1723136.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8875, '934591838534779', '2238345531', '135', NULL, '', '5.00', '3000.00', '2938.1', '15000.00', '0.00', '', NULL, '0', '1723136.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8876, '426446911583121', '2238345531', '139', NULL, '', '2.00', '3000.00', '2938.1', '6000.00', '0.00', '', NULL, '0', '1723136.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8877, '876182956216186', '2238345531', '144', NULL, '', '3.00', '6300.00', '6098.6', '18900.00', '0.00', '', NULL, '0', '1723136.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8878, '439611781916222', '2238345531', '141', NULL, '', '3.00', '6300.00', '6098.6', '18900.00', '0.00', '', NULL, '0', '1723136.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8879, '379986592532148', '2238345531', '321', NULL, '', '2.00', '9500.00', '9402.5', '19000.00', '0.00', '', NULL, '0', '1723136.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8914, '474284925511239', '7455412952', '282', NULL, '', '10.00', '30.00', '32', '300.00', '0.00', '', '0.00', '0', '28630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8913, '778999834932546', '7455412952', '37', NULL, '', '10.00', '25.00', '10', '250.00', '0.00', '', '0.00', '0', '28630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8912, '759557116581269', '7455412952', '962', NULL, '', '1.00', '4400.00', '4100', '4400.00', '0.00', '', '0.00', '0', '28630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8911, '395429991379145', '7455412952', '418', NULL, '', '1.00', '4400.00', '4300', '4400.00', '0.00', '', '0.00', '0', '28630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8910, '456647719788194', '7455412952', '961', NULL, '', '5.00', '2200.00', '2050', '11000.00', '0.00', '', '0.00', '0', '28630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8909, '769795234342821', '7455412952', '715', NULL, '', '2.00', '125.00', '120', '250.00', '0.00', '', '0.00', '0', '28630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8908, '193832447719854', '7455412952', '363', NULL, '', '1.00', '350.00', '320', '350.00', '0.00', '', '0.00', '0', '28630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8907, '771872667919377', '7455412952', '884', NULL, '', '1.00', '600.00', '458.667', '600.00', '0.00', '', '0.00', '0', '28630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8906, '881742479911797', '7455412952', '1022', NULL, '', '1.00', '850.00', '780', '850.00', '0.00', '', '0.00', '0', '28630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8905, '181492971988721', '7455412952', '811', NULL, '', '40.00', '105.00', '103', '4200.00', '0.00', '', '0.00', '0', '28630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8904, '775122359387928', '7455412952', '773', NULL, '', '1.00', '150.00', '80', '150.00', '0.00', '', '0.00', '0', '28630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8903, '413278835666853', '7455412952', '8', NULL, '', '1.00', '550.00', '550', '550.00', '0.00', '', '0.00', '0', '28630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8902, '814687347739818', '7455412952', '363', NULL, '', '2.00', '300.00', '320', '600.00', '0.00', '', '0.00', '0', '28630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8901, '485638281143814', '7455412952', '715', NULL, '', '1.00', '130.00', '120', '130.00', '0.00', '', '0.00', '0', '28630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8915, '612147242358676', '7455412952', '47', NULL, '', '2.00', '300.00', '320', '600.00', '0.00', '', '0.00', '0', '28630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8927, '928247957156546', '8997478542', '938', NULL, '', '1.00', '280.00', '300', '280.00', '0.00', '', '0.00', '0', '7430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8926, '367571321915579', '8997478542', '363', NULL, '', '1.00', '320.00', '320', '320.00', '0.00', '', '0.00', '0', '7430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8925, '759565165356537', '8997478542', '600', NULL, '', '3.00', '50.00', '160.667', '150.00', '0.00', '', '0.00', '0', '7430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8924, '241521675293914', '8997478542', '269', NULL, '', '1.00', '200.00', '110', '200.00', '0.00', '', '0.00', '0', '7430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8923, '416841783784299', '8997478542', '715', NULL, '', '1.00', '120.00', '120', '120.00', '0.00', '', '0.00', '0', '7430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8922, '821814388713236', '8997478542', '224', NULL, '', '1.00', '600.00', '550', '600.00', '0.00', '', '0.00', '0', '7430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8928, '546832997542128', '8997478542', '224', NULL, '', '1.00', '600.00', '550', '600.00', '0.00', '', '0.00', '0', '7430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8929, '366472249114414', '8997478542', '824', NULL, '', '1.00', '4800.00', '4000', '4800.00', '0.00', '', '0.00', '0', '7430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8930, '441476734656364', '8997478542', '715', NULL, '', '3.00', '120.00', '120', '360.00', '0.00', '', '0.00', '0', '7430.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8938, '588129954259117', '7981551788', '1199', NULL, '', '3.00', '300.00', '200', '900.00', '0.00', '', '0.00', '0', '15950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8937, '575673827489557', '7981551788', '1200', NULL, '', '3.00', '150.00', '120', '450.00', '0.00', '', '0.00', '0', '15950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8936, '688361623178556', '7981551788', '1197', NULL, '', '2.00', '500.00', '1071', '1000.00', '0.00', '', '0.00', '0', '15950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8935, '669347785696488', '7981551788', '1195', NULL, '', '3.00', '1200.00', '2900', '3600.00', '0.00', '', '0.00', '0', '15950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8939, '881193335563667', '7981551788', '1198', NULL, '', '4.00', '550.00', '1150', '2200.00', '0.00', '', '0.00', '0', '15950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8940, '984289383211698', '7981551788', '1206', NULL, '', '1.00', '7800.00', '7400', '7800.00', '0.00', '', '0.00', '0', '15950.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8941, '846739982558965', '8413576871', '412', NULL, '', '1.00', '9500.00', '8800', '9500.00', '0.00', '', NULL, '0', '31700.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8942, '245496127337411', '5236541338', '1208', NULL, '', '1.00', '5900.00', '5400', '5900.00', '0.00', '', NULL, '0', '28750.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8943, '576381659415195', '5236541338', '1207', NULL, '', '1.00', '6900.00', '6500', '6900.00', '0.00', '', NULL, '0', '28750.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8953, '719643183111886', '2279338767', '885', NULL, '', '1.00', '450.00', '440.5', '450.00', '0.00', '', '0.00', '0', '1731036.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8952, '955247578277479', '2279338767', '363', NULL, '', '8.00', '350.00', '320', '2800.00', '0.00', '', '0.00', '0', '1731036.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8951, '983351494343637', '2279338767', '650', NULL, '', '1.00', '3000.00', '2938.1', '3000.00', '0.00', '', '0.00', '0', '1731036.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8947, '279651463515382', '8827832273', '650', NULL, '', '3.00', '3000.00', '2938.1', '9000.00', '0.00', '', NULL, '0', '477740.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8948, '795895687241635', '8827832273', '135', NULL, '', '3.00', '3000.00', '2938.1', '9000.00', '0.00', '', NULL, '0', '477740.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8949, '793435634568669', '8827832273', '141', NULL, '', '1.00', '6200.00', '6098.6', '6200.00', '0.00', '', NULL, '0', '477740.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8950, '919983788898928', '8827832273', '144', NULL, '', '1.00', '6200.00', '6098.6', '6200.00', '0.00', '', NULL, '0', '477740.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8954, '322162611567934', '2279338767', '959', NULL, '', '1.00', '1650.00', '1550', '1650.00', '0.00', '', '0.00', '0', '1731036.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8958, '788856452736173', '9958959772', '109', NULL, '', '1.00', '960.00', '600', '960.00', '0.00', '', '0.00', '0', '37810.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8957, '433757255558864', '9958959772', '419', NULL, '', '1.00', '7500.00', '7121', '7500.00', '0.00', '', '0.00', '0', '37810.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8959, '558254457571571', '9958959772', '84', NULL, '', '1.00', '600.00', '450', '600.00', '0.00', '', '0.00', '0', '37810.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9017, '982567428848662', '7143127461', '1122', NULL, '', '1.00', '8000.00', '3500', '8000.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9016, '942944283921277', '7143127461', '888', NULL, '', '10.00', '320.00', '322', '3200.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9015, '681794482774839', '7143127461', '886', NULL, '', '3.00', '300.00', '277', '900.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9014, '223445656258437', '7143127461', '738', NULL, '', '1.00', '3600.00', '3610', '3600.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9013, '151499621463672', '7143127461', '489', NULL, '', '2.00', '240.00', '125', '480.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9012, '387836563326341', '7143127461', '823', NULL, '', '1.00', '1200.00', '1000', '1200.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9011, '511732174863298', '7143127461', '1032', NULL, '', '3.00', '1400.00', '1400', '4200.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9010, '861822957239928', '7143127461', '243', NULL, '', '5.00', '320.00', '415', '1600.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9009, '564283428919354', '7143127461', '283', NULL, '', '13.00', '50.00', '30', '650.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9008, '321877982486361', '7143127461', '284', NULL, '', '9.00', '60.00', '33.5', '540.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9007, '175883583139572', '7143127461', '481', NULL, '', '12.00', '50.00', '90', '600.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9006, '157534747824496', '7143127461', '748', NULL, '', '4.00', '480.00', '530', '1920.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9005, '918424162861443', '7143127461', '270', NULL, '', '5.00', '180.00', '160', '900.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9004, '165154341289386', '7143127461', '883', NULL, '', '9.00', '500.00', '466.6', '4500.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9003, '383853574442886', '7143127461', '1205', NULL, '', '1.00', '3600.00', '3600', '3600.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9002, '896463944735946', '7143127461', '715', NULL, '', '75.00', '120.00', '120', '9000.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9001, '489216137869232', '7143127461', '962', NULL, '', '4.00', '4500.00', '4100', '18000.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9000, '794968598287498', '7143127461', '961', NULL, '', '8.00', '2250.00', '2050', '18000.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8999, '552316712838922', '7143127461', '600', NULL, '', '3.00', '50.00', '160.667', '150.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8998, '447755134987131', '7143127461', '1039', NULL, '', '20.00', '25.00', '12', '500.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8997, '856656894579124', '7143127461', '788', NULL, '', '3.00', '1850.00', '1050', '5550.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8996, '123973642823914', '7143127461', '1203', NULL, '', '1.00', '5500.00', '3500', '5500.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8995, '936724423841887', '7143127461', '448', NULL, '', '2.00', '200.00', '120', '400.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8994, '989212867894147', '7143127461', '363', NULL, '', '6.00', '375.00', '320', '2250.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8993, '826111882221485', '7143127461', '339', NULL, '', '2.00', '8000.00', '7381', '16000.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8992, '566264332592513', '7143127461', '340', NULL, '', '1.00', '8000.00', '7381', '8000.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8991, '216142834831793', '7143127461', '716', NULL, '', '30.00', '200.00', '190', '6000.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8990, '494421252141934', '7143127461', '57', NULL, '', '1.00', '150.00', '140', '150.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (8989, '981569144183627', '7143127461', '830', NULL, '', '4.00', '150.00', '87.5', '600.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9018, '755849316169846', '7143127461', '1204', NULL, '', '21.00', '1400.00', '1350', '29400.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9019, '693468193251583', '7143127461', '945', NULL, '', '10.00', '70.00', '70', '700.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9020, '168421964888548', '7143127461', '714', NULL, '', '1.00', '500.00', '325', '500.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9021, '286831331177752', '7143127461', '603', NULL, '', '8.00', '350.00', '250', '2800.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9022, '345949446157693', '7143127461', '1054', NULL, '', '1.00', '2200.00', '1600', '2200.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9023, '465434656458272', '7143127461', '340', NULL, '', '1.00', '210.00', '7381', '8000.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9024, '492176156727185', '7143127461', '716', NULL, '', '30.00', '200.00', '190', '6000.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9025, '145898555588276', '7143127461', '600', NULL, '', '3.00', '50.00', '160.667', '150.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9026, '674554856941863', '7143127461', '883', NULL, '', '2.00', '500.00', '466.6', '1000.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9027, '354276173231927', '7143127461', '284', NULL, '', '2.00', '60.00', '33.5', '120.00', '0.00', '', '0.00', '0', '176860.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9053, '464118793463961', '3499562843', '1192', NULL, '', '1.00', '150.00', '120', '150.00', '0.00', '', '0.00', '0', '37930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9052, '281315651649927', '3499562843', '1193', NULL, '', '6.00', '30.00', '30', '180.00', '0.00', '', '0.00', '0', '37930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9051, '551574443857578', '3499562843', '830', NULL, '', '1.00', '150.00', '87.5', '150.00', '0.00', '', '0.00', '0', '37930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9050, '964933144944225', '3499562843', '716', NULL, '', '1.00', '200.00', '190', '200.00', '0.00', '', '0.00', '0', '37930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9049, '435454957399237', '3499562843', '823', NULL, '', '1.00', '1200.00', '1000', '1200.00', '0.00', '', '0.00', '0', '37930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9048, '176797167826136', '3499562843', '577', NULL, '', '1.00', '1300.00', '1250', '1300.00', '0.00', '', '0.00', '0', '37930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9047, '616781475243582', '3499562843', '282', NULL, '', '24.00', '30.00', '32', '720.00', '0.00', '', '0.00', '0', '37930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9046, '533655978297999', '3499562843', '281', NULL, '', '24.00', '25.00', '25', '600.00', '0.00', '', '0.00', '0', '37930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9045, '693166574364226', '3499562843', '964', NULL, '', '2.00', '5600.00', '5000', '11200.00', '0.00', '', '0.00', '0', '37930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9044, '429384236942366', '3499562843', '67', NULL, '', '2.00', '2800.00', '2600', '5600.00', '0.00', '', '0.00', '0', '37930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9043, '653943661499695', '3499562843', '68', NULL, '', '2.00', '2800.00', '2600', '5600.00', '0.00', '', '0.00', '0', '37930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9042, '575688713155142', '3499562843', '190', NULL, '', '1.00', '4500.00', '2500', '4500.00', '0.00', '', '0.00', '0', '37930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9041, '235211548365367', '4469798727', '1212', NULL, '', '10.00', '270.00', '270', '2700.00', '0.00', '', '0.00', '0', '2700.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9054, '792533532138743', '3499562843', '1186', NULL, '', '1.00', '2400.00', '2000', '2400.00', '0.00', '', '0.00', '0', '37930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9055, '533513133998268', '3499562843', '1066', NULL, '', '13.00', '280.00', '280', '3640.00', '0.00', '', '0.00', '0', '37930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9056, '834359147796941', '3499562843', '1137', NULL, '', '3.50', '140.00', '120', '490.00', '0.00', '', '0.00', '0', '37930.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9086, '239174841263497', '9818532272', '694', NULL, '', '1.00', '250.00', '130', '250.00', '0.00', '', '0.00', '0', '48000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9085, '262221487982458', '9818532272', '625', NULL, '', '20.00', '42.00', '39.75', '840.00', '0.00', '', '0.00', '0', '48000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9084, '427447917626611', '9818532272', '85', NULL, '', '1.00', '700.00', '660', '700.00', '0.00', '', '0.00', '0', '48000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9083, '139348117239539', '9818532272', '811', NULL, '', '24.00', '110.00', '103', '2640.00', '0.00', '', '0.00', '0', '48000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9082, '521159225482732', '9818532272', '323', NULL, '', '1.00', '4500.00', '4134', '4500.00', '0.00', '', '0.00', '0', '48000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9081, '755747863143544', '9818532272', '299', NULL, '', '2.00', '4500.00', '4134', '9000.00', '0.00', '', '0.00', '0', '48000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9080, '297377962887987', '9818532272', '109', NULL, '', '1.00', '550.00', '600', '550.00', '0.00', '', '0.00', '0', '48000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9079, '788844264196888', '9818532272', '131', NULL, '', '2.00', '330.00', '240', '660.00', '0.00', '', '0.00', '0', '48000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9078, '318542531768993', '9818532272', '93', NULL, '', '2.00', '330.00', '270', '660.00', '0.00', '', '0.00', '0', '48000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9077, '348629248986147', '9818532272', '104', NULL, '', '3.00', '300.00', '300', '900.00', '0.00', '', '0.00', '0', '48000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9076, '597613482225116', '9818532272', '89', NULL, '', '3.00', '280.00', '280', '840.00', '0.00', '', '0.00', '0', '48000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9075, '885631777728921', '9818532272', '753', NULL, '', '3.00', '80.00', '100', '240.00', '0.00', '', '0.00', '0', '48000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9074, '787842779266595', '9818532272', '752', NULL, '', '2.00', '70.00', '88', '140.00', '0.00', '', '0.00', '0', '48000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9073, '721871177696329', '9818532272', '57', NULL, '', '1.00', '150.00', '140', '150.00', '0.00', '', '0.00', '0', '48000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9072, '644459889448494', '9818532272', '1025', NULL, '', '1.00', '7500.00', '5800', '7500.00', '0.00', '', '0.00', '0', '48000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9087, '498991717736354', '9818532272', '1131', NULL, '', '10.00', '120.00', '100', '1200.00', '0.00', '', '0.00', '0', '48000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9088, '528291543373465', '9818532272', '1219', NULL, '', '2.00', '4700.00', '4400', '9400.00', '0.00', '', '0.00', '0', '48000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9089, '284812236884642', '9818532272', '1220', NULL, '', '1.00', '4700.00', '4000', '4700.00', '0.00', '', '0.00', '0', '48000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9090, '839771677789816', '9818532272', '1221', NULL, '', '1.00', '1200.00', '1000', '1200.00', '0.00', '', '0.00', '0', '48000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9091, '231982231763163', '9818532272', '1027', NULL, '', '20.00', '80.00', '65', '1600.00', '0.00', '', '0.00', '0', '48000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9092, '278131694816328', '9818532272', '93', NULL, '', '1.00', '330.00', '270', '330.00', '0.00', '', '0.00', '0', '48000.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9093, '143148222684196', '6311557677', '1093', NULL, '', '238.00', '216.00', '220', '51408.00', '0.00', '', NULL, '0', '807608.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9094, '188736765662642', '6311557677', '1084', NULL, '', '213.00', '175.00', '149', '37275.00', '0.00', '', NULL, '0', '807608.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9100, '924299116782159', '9414891438', '1077', NULL, '', '6.00', '240.00', '98', '1440.00', '0.00', '', '0.00', '0', '886786.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9099, '962731532262162', '9414891438', '1076', NULL, '', '6.00', '240.00', '192', '1440.00', '0.00', '', '0.00', '0', '886786.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9098, '118892478856784', '9414891438', '1084', NULL, '', '142.00', '175.00', '149', '24850.00', '0.00', '', '0.00', '0', '886786.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9101, '937541587796112', '9414891438', '1093', NULL, '', '236.00', '218.00', '220', '51448.00', '0.00', '', '0.00', '0', '886786.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9102, '151914398881746', '4787487136', '758', NULL, '', '2.00', '1400.00', '1100', '2800.00', '0.00', '', NULL, '0', '889586.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9103, '789179556256235', '1789273916', '135', NULL, '', '8.00', '4555.00', '2938.1', '36440.00', '0.00', '', NULL, '0', '1085102.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9104, '553359825693353', '1789273916', '650', NULL, '', '5.00', '4555.00', '2938.1', '22775.00', '0.00', '', NULL, '0', '1085102.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9105, '373153457634128', '1789273916', '141', NULL, '', '4.00', '9455.00', '6098.6', '37820.00', '0.00', '', NULL, '0', '1085102.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9106, '163184524543291', '1789273916', '144', NULL, '', '4.00', '9455.00', '6098.6', '37820.00', '0.00', '', NULL, '0', '1085102.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9107, '855647788328699', '5253653148', '17', NULL, '', '50.00', '200.00', '180', '10000.00', '0.00', '', NULL, '0', '899586.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9108, '946958338195254', '8257478766', '299', NULL, '', '8.00', '4250.00', '4134', '34000.00', '0.00', '', NULL, '0', '1849986.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9109, '947973227771693', '8257478766', '323', NULL, '', '7.00', '4250.00', '4134', '29750.00', '0.00', '', NULL, '0', '1849986.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9110, '314692384995274', '8257478766', '300', NULL, '', '3.00', '9200.00', '8740.5', '27600.00', '0.00', '', NULL, '0', '1849986.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9111, '845365122547858', '8257478766', '327', NULL, '', '3.00', '9200.00', '8751.67', '27600.00', '0.00', '', NULL, '0', '1849986.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9112, '252862968691848', '6294569947', '961', NULL, '', '4.00', '2200.00', '2050', '8800.00', '0.00', '', NULL, '0', '114530.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9113, '393884454232286', '5534821822', '9', NULL, '', '10.00', '450.00', '420', '4500.00', '0.00', '', NULL, '0', '15080.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9114, '222512465356238', '5534821822', '135', NULL, '', '1.00', '3000.00', '2938.1', '3000.00', '0.00', '', NULL, '0', '15080.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9115, '124619382269422', '1651433367', '566', NULL, '', '6.00', '4000.00', '2600', '24000.00', '0.00', '', NULL, '0', '399510.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9116, '926656666885532', '1651433367', '565', NULL, '', '6.00', '4000.00', '2600', '24000.00', '0.00', '', NULL, '0', '399510.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9117, '555793658962536', '1651433367', '1218', NULL, '', '3.00', '350.00', '165', '1050.00', '0.00', '', NULL, '0', '399510.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9118, '322587151765337', '1651433367', '564', NULL, '', '50.00', '410.00', '295', '20500.00', '0.00', '', NULL, '0', '399510.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9128, '643396587962547', '3851685395', '1210', NULL, '', '20.00', '50.00', '27', '1000.00', '0.00', '', '0.00', '0', '404630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9127, '767969884764569', '3851685395', '1211', NULL, '', '4.00', '180.00', '125', '720.00', '0.00', '', '0.00', '0', '404630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9126, '777481666452579', '3851685395', '1182', NULL, '', '2.00', '350.00', '294', '700.00', '0.00', '', '0.00', '0', '404630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9125, '729854138838147', '3851685395', '1183', NULL, '', '2.00', '850.00', '215', '1700.00', '0.00', '', '0.00', '0', '404630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9124, '575151253463234', '3851685395', '1181', NULL, '', '2.00', '500.00', '375', '1000.00', '0.00', '', '0.00', '0', '404630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9129, '727969331727849', '6876312951', '638', NULL, '', '20.00', '4400.00', '4150', '88000.00', '0.00', '', NULL, '0', '492630.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9153, '467439456557887', '5651135711', '1133', NULL, '', '1.00', '50.00', '30', '50.00', '0.00', '', '0.00', '0', '22300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9152, '189599146775346', '5651135711', '1132', NULL, '', '1.00', '50.00', '20', '50.00', '0.00', '', '0.00', '0', '22300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9151, '274917186737663', '5651135711', '481', NULL, '', '1.00', '50.00', '90', '50.00', '0.00', '', '0.00', '0', '22300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9150, '432443696474837', '5651135711', '715', NULL, '', '6.00', '130.00', '120', '780.00', '0.00', '', '0.00', '0', '22300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9149, '729826143645952', '5651135711', '843', NULL, '', '5.00', '20.00', '13', '100.00', '0.00', '', '0.00', '0', '22300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9148, '178347277427123', '5651135711', '490', NULL, '', '5.00', '250.00', '85', '1250.00', '0.00', '', '0.00', '0', '22300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9147, '352885987121282', '5651135711', '883', NULL, '', '1.00', '550.00', '466.6', '550.00', '0.00', '', '0.00', '0', '22300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9146, '754435832212958', '5651135711', '284', NULL, '', '1.00', '70.00', '33.5', '70.00', '0.00', '', '0.00', '0', '22300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9145, '474942164113839', '5651135711', '966', NULL, '', '1.00', '3500.00', '3000', '3500.00', '0.00', '', '0.00', '0', '22300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9144, '979874129231241', '5651135711', '650', NULL, '', '2.00', '3000.00', '2938.1', '6000.00', '0.00', '', '0.00', '0', '22300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9143, '243851628275413', '5651135711', '135', NULL, '', '3.00', '3000.00', '2938.1', '9000.00', '0.00', '', '0.00', '0', '22300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9142, '763851695283996', '5651135711', '8', NULL, '', '1.00', '550.00', '550', '550.00', '0.00', '', '0.00', '0', '22300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9154, '777311338384691', '5651135711', '381', NULL, '', '5.00', '50.00', '34', '250.00', '0.00', '', '0.00', '0', '22300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9155, '112641948652531', '5651135711', '375', NULL, '', '1.00', '50.00', '15', '50.00', '0.00', '', '0.00', '0', '22300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9156, '581748884113244', '5651135711', '1043', NULL, '', '1.00', '50.00', '20', '50.00', '0.00', '', '0.00', '0', '22300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9261, '171566935365721', '4883297114', '1043', NULL, '', '3.00', '50.00', '20', '150.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9260, '969945284766518', '4883297114', '221', NULL, '', '2.00', '500.00', '480', '1000.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9313, '344419615931625', '4883297114', '1043', NULL, '', '2.00', '60.00', '20', '120.00', '0.00', '', '0.00', '0', '65255.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9322, '754336269675778', '6185919946', '481', NULL, '', '40.00', '50.00', '83.5625', '2000.00', '0.00', '', '0.00', '0', '61300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9321, '931675495886747', '6185919946', '1225', NULL, '', '50.00', '20.00', '16', '1000.00', '0.00', '', '0.00', '0', '61300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9320, '214867384199484', '6185919946', '1224', NULL, '', '50.00', '22.00', '20', '1100.00', '0.00', '', '0.00', '0', '61300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9323, '632146865944693', '6185919946', '1016', NULL, '', '60.00', '60.00', '30', '3600.00', '0.00', '', '0.00', '0', '61300.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9336, '547643523552247', '2243328791', '1226', NULL, '', '1.00', '41000.00', '41000', '41000.00', '0.00', '', '0.00', '0', '46600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9337, '264333731148461', '2243328791', '363', NULL, '', '2.00', '375.00', '320', '750.00', '0.00', '', '0.00', '0', '46600.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9361, '733783214293548', '8398991967', '839', NULL, '', '1.00', '20.00', '14', '20.00', '0.00', '', '0.00', '0', '21800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9362, '485269918987851', '8398991967', '135', NULL, '', '1.00', '3000.00', '2938.1', '3000.00', '0.00', '', '0.00', '0', '21800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9363, '261658889236274', '8398991967', '860', NULL, '', '1.00', '200.00', '170', '200.00', '0.00', '', '0.00', '0', '21800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9364, '456147941824681', '8398991967', '379', NULL, '', '6.00', '30.00', '25', '180.00', '0.00', '', '0.00', '0', '21800.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9377, '699171269175729', '6351564964', '1228', NULL, '', '1.00', '40.00', '20', '40.00', '0.00', '', '0.00', '0', '5040.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9378, '549962875884267', '6351564964', '1227', NULL, '', '2.00', '75.00', '40', '150.00', '0.00', '', '0.00', '0', '5040.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9406, '253965436134962', '6667973681', '1065', NULL, '', '1.00', '100.00', '100', '100.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9407, '519136923834771', '6667973681', '784', NULL, '', '1.00', '200.00', '135', '200.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9408, '471438743528615', '6667973681', '422', NULL, '', '6.00', '60.00', '30', '360.00', '0.00', '', '0.00', '0', '74380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9409, '935428836925112', '9947344679', '67', NULL, '', '1.00', '2600.00', '2600', '2600.00', '0.00', '', NULL, '0', '1873536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9410, '471591984752311', '9947344679', '68', NULL, '', '1.00', '2600.00', '2600', '2600.00', '0.00', '', NULL, '0', '1873536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9411, '862218517165661', '9947344679', '69', NULL, '', '1.00', '5300.00', '5200', '5300.00', '0.00', '', NULL, '0', '1873536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9412, '423274344562496', '9947344679', '419', NULL, '', '1.00', '7500.00', '7121', '7500.00', '0.00', '', NULL, '0', '1873536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9413, '339647132972623', '9947344679', '1082', NULL, '', '1.00', '2000.00', '2000', '2000.00', '0.00', '', NULL, '0', '1873536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9414, '288223327411134', '9947344679', '1081', NULL, '', '1.00', '1800.00', '1700', '1800.00', '0.00', '', NULL, '0', '1873536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9415, '448222189413167', '9947344679', '363', NULL, '', '5.00', '350.00', '320', '1750.00', '0.00', '', NULL, '0', '1873536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9416, '523539856144578', '6352547424', '335', NULL, '', '1.00', '2600.00', '2376', '2600.00', '0.00', '', NULL, '0', '1880906.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9417, '873969111618294', '6352547424', '175', NULL, '', '6.00', '180.00', '125', '1080.00', '0.00', '', NULL, '0', '1880906.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9418, '693871695412382', '6352547424', '176', NULL, '', '12.00', '120.00', '65', '1440.00', '0.00', '', NULL, '0', '1880906.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9419, '989548227986464', '6352547424', '262', NULL, '', '5.00', '450.00', '450', '2250.00', '0.00', '', NULL, '0', '1880906.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9420, '322182228583285', '8958612741', '1239', NULL, '', '1.00', '700.00', '450', '700.00', '0.00', '', NULL, '0', '515400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9421, '615126244538938', '8958612741', '513', NULL, '', '1.00', '200.00', '135', '200.00', '0.00', '', NULL, '0', '515400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9422, '981977256865269', '8958612741', '1240', NULL, '', '2.00', '180.00', '90', '360.00', '0.00', '', NULL, '0', '515400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9423, '578183547128583', '8958612741', '512', NULL, '', '4.00', '120.00', '75', '480.00', '0.00', '', NULL, '0', '515400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9424, '256152994361197', '8958612741', '1241', NULL, '', '12.00', '90.00', '60', '1080.00', '0.00', '', NULL, '0', '515400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9425, '229955444732536', '8958612741', '1242', NULL, '', '1.00', '300.00', '220', '300.00', '0.00', '', NULL, '0', '515400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9426, '465982867193557', '8958612741', '1243', NULL, '', '2.00', '100.00', '50', '200.00', '0.00', '', NULL, '0', '515400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9427, '678814452843844', '8958612741', '1244', NULL, '', '4.00', '150.00', '50', '600.00', '0.00', '', NULL, '0', '515400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9428, '343198886668497', '8958612741', '554', NULL, '', '3.00', '700.00', '500', '2100.00', '0.00', '', NULL, '0', '515400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9429, '238974948323213', '8958612741', '1236', NULL, '', '1.00', '550.00', '430', '550.00', '0.00', '', NULL, '0', '515400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9430, '898328826837652', '8958612741', '1237', NULL, '', '1.00', '350.00', '200', '350.00', '0.00', '', NULL, '0', '515400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9431, '553857732919322', '8958612741', '645', NULL, '', '1.00', '950.00', '516.667', '950.00', '0.00', '', NULL, '0', '515400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9432, '348542392759213', '8958612741', '1238', NULL, '', '1.00', '750.00', '500', '750.00', '0.00', '', NULL, '0', '515400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9433, '281999581779753', '8958612741', '541 ', NULL, '', '4.00', '850.00', '612.5', '3400.00', '0.00', '', NULL, '0', '515400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9434, '785284249751132', '8958612741', '546', NULL, '', '3.00', '80.00', '36.6667', '240.00', '0.00', '', NULL, '0', '515400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9435, '579566797629546', '8958612741', '540', NULL, '', '24.00', '25.00', '15', '600.00', '0.00', '', NULL, '0', '515400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9436, '494944659578122', '8958612741', '1229', NULL, '', '1.00', '950.00', '700', '950.00', '0.00', '', NULL, '0', '515400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9437, '132461258422928', '8958612741', '527', NULL, '', '1.00', '1000.00', '705', '1000.00', '0.00', '', NULL, '0', '515400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9438, '642242314715442', '8958612741', '996', NULL, '', '12.00', '60.00', '30', '720.00', '0.00', '', NULL, '0', '515400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9439, '331613481486113', '8958612741', '1230', NULL, '', '3.00', '260.00', '150', '780.00', '0.00', '', NULL, '0', '515400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9440, '347678511443179', '8958612741', '1231', NULL, '', '3.00', '850.00', '850', '2550.00', '0.00', '', NULL, '0', '515400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9441, '744429949511685', '8958612741', '1232', NULL, '', '1.00', '600.00', '400', '600.00', '0.00', '', NULL, '0', '515400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9442, '497361164929655', '8958612741', '1233', NULL, '', '1.00', '300.00', '200', '300.00', '0.00', '', NULL, '0', '515400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9443, '593258538932443', '8958612741', '1234', NULL, '', '2.00', '280.00', '150', '560.00', '0.00', '', NULL, '0', '515400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9444, '818766431199595', '8958612741', '1235', NULL, '', '1.00', '1800.00', '1550', '1800.00', '0.00', '', NULL, '0', '515400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9445, '775268819141164', '8958612741', '1245', NULL, '', '1.00', '100.00', '70', '100.00', '0.00', '', NULL, '0', '515400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9446, '236948882446257', '8958612741', '563', NULL, '', '1.00', '550.00', '380', '550.00', '0.00', '', NULL, '0', '515400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9447, '478735549861639', '1292926993', '333', NULL, '', '1.00', '17000.00', '16817', '17000.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9448, '942683959572826', '1292926993', '188', NULL, '', '1.00', '5000.00', '5600', '5000.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9449, '232949926416948', '1292926993', '490', NULL, '', '1.00', '120.00', '85', '120.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9450, '364897254495278', '1292926993', '836', NULL, '', '1.00', '50.00', '30', '50.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9451, '316871225157149', '1292926993', '833', NULL, '', '1.00', '30.00', '25', '30.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9452, '856935566373437', '1292926993', '833', NULL, '', '6.00', '30.00', '25', '180.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9453, '588253224755477', '1292926993', '700', NULL, '', '1.00', '200.00', '160', '200.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9454, '373731859266893', '1292926993', '1175', NULL, '', '1.00', '50.00', '45.9', '50.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9455, '638334921698866', '1292926993', '836', NULL, '', '1.00', '30.00', '30', '30.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9456, '551749884973381', '1292926993', '382', NULL, '', '1.00', '70.00', '46', '70.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9457, '879219235673156', '1292926993', '961', NULL, '', '2.00', '2350.00', '2050', '4700.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9458, '646279895519463', '1292926993', '962', NULL, '', '1.00', '4700.00', '4100', '4700.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9459, '587263347874725', '1292926993', '1140', NULL, '', '7.00', '60.00', '35', '420.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9460, '822933228943133', '1292926993', '903', NULL, '', '3.00', '60.00', '40', '180.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9461, '486411391241751', '1292926993', '270', NULL, '', '1.00', '240.00', '160', '240.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9462, '631832343658134', '1292926993', '843', NULL, '', '6.00', '20.00', '13', '120.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9463, '664333266893855', '1292926993', '884', NULL, '', '3.00', '500.00', '458.667', '1500.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9464, '317173866516881', '1292926993', '885', NULL, '', '1.00', '450.00', '440.5', '450.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9465, '714415322463771', '1292926993', '883', NULL, '', '1.00', '550.00', '466.6', '550.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9466, '244259931517683', '1292926993', '47', NULL, '', '3.00', '300.00', '320', '900.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9467, '425271448165783', '1292926993', '854', NULL, '', '1.00', '350.00', '290', '350.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9468, '918766895675641', '1292926993', '921', NULL, '', '3.00', '70.00', '50', '210.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9469, '653391833671691', '1292926993', '283', NULL, '', '3.00', '60.00', '30', '180.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9470, '312248227331234', '1292926993', '700', NULL, '', '10.00', '200.00', '160', '2000.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9471, '472788511877759', '1292926993', '262', NULL, '', '1.00', '450.00', '450', '450.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9472, '978899644194167', '1292926993', '603', NULL, '', '6.00', '350.00', '250', '2100.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9473, '282476176554654', '1292926993', '221', NULL, '', '1.00', '700.00', '480', '700.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9474, '721933524737473', '1292926993', '225', NULL, '', '1.00', '700.00', '465', '700.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9475, '942893234163433', '1292926993', '600', NULL, '', '3.00', '50.00', '160.667', '150.00', '0.00', '', NULL, '0', '43330.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9476, '564771119999762', '8221687361', '419', NULL, '', '1.00', '7400.00', '7121', '7400.00', '0.00', '', NULL, '0', '62850.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9477, '785469211244827', '8221687361', '299', NULL, '', '3.00', '4200.00', '4134', '12600.00', '0.00', '', NULL, '0', '62850.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9478, '493244381251863', '8221687361', '323', NULL, '', '3.00', '4200.00', '4134', '12600.00', '0.00', '', NULL, '0', '62850.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9479, '213595757583397', '8221687361', '300', NULL, '', '1.00', '8800.00', '8740.5', '8800.00', '0.00', '', NULL, '0', '62850.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9480, '769277758345859', '8221687361', '327', NULL, '', '1.00', '8800.00', '8751.67', '8800.00', '0.00', '', NULL, '0', '62850.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9481, '744899878189654', '8221687361', '135', NULL, '', '1.00', '2800.00', '2938.1', '2800.00', '0.00', '', NULL, '0', '62850.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9482, '679911528194359', '8221687361', '650', NULL, '', '1.00', '2800.00', '2938.1', '2800.00', '0.00', '', NULL, '0', '62850.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9483, '181832635694247', '8221687361', '224', NULL, '', '2.00', '600.00', '550', '1200.00', '0.00', '', NULL, '0', '62850.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9484, '797941281473776', '8221687361', '113', NULL, '', '2.00', '900.00', '840', '1800.00', '0.00', '', NULL, '0', '62850.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9485, '564697163633469', '8221687361', '772', NULL, '', '6.00', '50.00', '30', '300.00', '0.00', '', NULL, '0', '62850.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9486, '677962856393478', '8221687361', '660', NULL, '', '3.00', '1250.00', '1044', '3750.00', '0.00', '', NULL, '0', '62850.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9487, '569816649679918', '1459596594', '135', NULL, '', '8.00', '3000.00', '2938.1', '24000.00', '0.00', '', NULL, '0', '1974506.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9488, '137396439955847', '1459596594', '139', NULL, '', '4.00', '3000.00', '2938.1', '12000.00', '0.00', '', NULL, '0', '1974506.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9489, '575816752449497', '1459596594', '138', NULL, '', '4.00', '3000.00', '2938.1', '12000.00', '0.00', '', NULL, '0', '1974506.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9490, '815232319556947', '1459596594', '141', NULL, '', '1.00', '6200.00', '6098.6', '6200.00', '0.00', '', NULL, '0', '1974506.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9491, '888919831422463', '1459596594', '144', NULL, '', '6.00', '6200.00', '6098.6', '37200.00', '0.00', '', NULL, '0', '1974506.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9492, '179393925264724', '1459596594', '961', NULL, '', '1.00', '2200.00', '2050', '2200.00', '0.00', '', NULL, '0', '1974506.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9493, '916151142421598', '9727844627', '603', NULL, '', '50.00', '350.00', '250', '17500.00', '0.00', '', NULL, '0', '78800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9494, '353259695161511', '9688352243', '9', NULL, '', '6.00', '450.00', '420', '2700.00', '0.00', '', NULL, '0', '1092286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9495, '717763227748214', '9688352243', '17', NULL, '', '50.00', '200.00', '180', '10000.00', '0.00', '', NULL, '0', '1092286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9496, '712943127895734', '9688352243', '1247', NULL, '', '1100.00', '164.00', '150', '180400.00', '0.00', '', NULL, '0', '1092286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9497, '414561561436598', '9912837861', '299', NULL, '', '6.00', '6295.00', '4134', '37770.00', '0.00', '', NULL, '0', '787967.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9498, '248388979688952', '9912837861', '323', NULL, '', '4.00', '6295.00', '4134', '25180.00', '0.00', '', NULL, '0', '787967.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9499, '939389735564733', '9912837861', '327', NULL, '', '4.00', '13395.00', '8751.67', '53580.00', '0.00', '', NULL, '0', '787967.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9500, '398481571881479', '9912837861', '300', NULL, '', '6.00', '13395.00', '8740.5', '80370.00', '0.00', '', NULL, '0', '787967.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9554, '995365257789752', '5213434265', '1259', NULL, '', '2.00', '4282.00', '4155', '8564.00', '0.00', '', '0.00', '0', '1261809.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9553, '465538718725762', '5213434265', '1258', NULL, '', '3.00', '4282.00', '4155', '12846.00', '0.00', '', '0.00', '0', '1261809.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9552, '888143777913179', '5213434265', '299', NULL, '', '10.00', '6295.00', '4134', '62950.00', '0.00', '', '0.00', '0', '1261809.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9551, '331571117576425', '5213434265', '323', NULL, '', '5.00', '6295.00', '4134', '31475.00', '0.00', '', '0.00', '0', '1261809.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9550, '274797332157549', '5213434265', '300', NULL, '', '3.00', '13395.00', '8740.5', '40185.00', '0.00', '', '0.00', '0', '1261809.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9549, '123234266312254', '5213434265', '327', NULL, '', '5.00', '13395.00', '8751.67', '66975.00', '0.00', '', '0.00', '0', '1261809.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9919, '642566342416459', '1547115985', '1246', NULL, '', '3.00', '300.00', '185', '900.00', '0.00', '', '0.00', '0', '45530.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9918, '582488447842912', '1547115985', '1200', NULL, '', '4.00', '150.00', '120.5', '600.00', '0.00', '', '0.00', '0', '45530.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9917, '564436341887873', '1547115985', '699', NULL, '', '4.00', '350.00', '320', '1400.00', '0.00', '', '0.00', '0', '45530.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9916, '791811476674687', '1547115985', '694', NULL, '', '2.00', '200.00', '130', '400.00', '0.00', '', '0.00', '0', '45530.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9915, '432134436168883', '1547115985', '27', NULL, '', '3.00', '70.00', '33', '210.00', '0.00', '', '0.00', '0', '45530.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9914, '914352727884554', '1547115985', '1255', NULL, '', '3.00', '550.00', '550', '1650.00', '0.00', '', '0.00', '0', '45530.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9913, '449564292982496', '1547115985', '284', NULL, '', '2.00', '80.00', '33.5', '160.00', '0.00', '', '0.00', '0', '45530.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9912, '638766684989888', '1547115985', '363', NULL, '', '2.00', '350.00', '320', '700.00', '0.00', '', '0.00', '0', '45530.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9519, '296173822717953', '9152678989', '711', NULL, '', '2.00', '80.00', '62', '160.00', '0.00', '', NULL, '0', '38350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9520, '423443628588884', '9152678989', '805', NULL, '', '2.00', '750.00', '830', '1500.00', '0.00', '', NULL, '0', '38350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9521, '244373692356258', '9152678989', '474', NULL, '', '1.00', '100.00', '100', '100.00', '0.00', '', NULL, '0', '38350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9522, '167419292365865', '9152678989', '373', NULL, '', '10.00', '20.00', '17', '200.00', '0.00', '', NULL, '0', '38350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9523, '631136152112629', '9152678989', '920', NULL, '', '3.00', '30.00', '20', '90.00', '0.00', '', NULL, '0', '38350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9524, '183328821427249', '9152678989', '961', NULL, '', '3.00', '2250.00', '2050', '6750.00', '0.00', '', NULL, '0', '38350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9525, '555137622168535', '9152678989', '603', NULL, '', '12.00', '350.00', '250', '4200.00', '0.00', '', NULL, '0', '38350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9526, '847835675398381', '9152678989', '62', NULL, '', '2.00', '1400.00', '1500', '2800.00', '0.00', '', NULL, '0', '38350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9527, '585137337513276', '9152678989', '714', NULL, '', '1.00', '4120.00', '325', '500.00', '0.00', '', NULL, '0', '38350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9528, '152483974551657', '9152678989', '962', NULL, '', '2.00', '4500.00', '4100', '9000.00', '0.00', '', NULL, '0', '38350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9529, '984745222627685', '9152678989', '448', NULL, '', '2.00', '200.00', '120', '400.00', '0.00', '', NULL, '0', '38350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9530, '247533398866741', '9152678989', '775', NULL, '', '1.00', '50.00', '30', '50.00', '0.00', '', NULL, '0', '38350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9531, '435992834912753', '9152678989', '811', NULL, '', '120.00', '105.00', '103', '12600.00', '0.00', '', NULL, '0', '38350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9719, '557222273128937', '5736277861', '254', NULL, '', '70.00', '250.00', '223.75', '17500.00', '0.00', '', '0.00', '0', '41485.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9718, '398563132676721', '5736277861', '351', NULL, '', '1.00', '3250.00', '2800', '3250.00', '0.00', '', '0.00', '0', '41485.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9717, '151456463552461', '5736277861', '284', NULL, '', '2.00', '70.00', '33.5', '140.00', '0.00', '', '0.00', '0', '41485.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9716, '228439677781495', '5736277861', '366', NULL, '', '10.00', '75.00', '46', '750.00', '0.00', '', '0.00', '0', '41485.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9715, '817876285724679', '5736277861', '47', NULL, '', '2.00', '350.00', '320', '700.00', '0.00', '', '0.00', '0', '41485.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9714, '925587662771894', '5736277861', '883', NULL, '', '2.00', '550.00', '469.333', '1100.00', '0.00', '', '0.00', '0', '41485.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9713, '651189871413244', '5736277861', '813', NULL, '', '51.00', '95.00', '79', '4845.00', '0.00', '', '0.00', '0', '41485.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9712, '414762682783434', '5736277861', '381', NULL, '', '1.00', '50.00', '34', '50.00', '0.00', '', '0.00', '0', '41485.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9711, '788859455392765', '5736277861', '840', NULL, '', '1.00', '40.00', '20', '40.00', '0.00', '', '0.00', '0', '41485.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9710, '524991794856156', '5736277861', '839', NULL, '', '2.00', '20.00', '14', '40.00', '0.00', '', '0.00', '0', '41485.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9709, '699375239971637', '5736277861', '102', NULL, '', '1.00', '440.00', '450.667', '440.00', '0.00', '', '0.00', '0', '41485.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9708, '114471331651224', '5736277861', '490', NULL, '', '1.00', '200.00', '85', '200.00', '0.00', '', '0.00', '0', '41485.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9707, '267313724591213', '5736277861', '837', NULL, '', '25.00', '88.00', '70', '2200.00', '0.00', '', '0.00', '0', '41485.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9706, '193642675358327', '5736277861', '1094', NULL, '', '1.00', '350.00', '280', '350.00', '0.00', '', '0.00', '0', '41485.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9705, '993146211451118', '5736277861', '9', NULL, '', '5.00', '424.00', '420', '2120.00', '0.00', '', '0.00', '0', '41485.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9704, '745665522812734', '5736277861', '711', NULL, '', '1.00', '80.00', '62', '80.00', '0.00', '', '0.00', '0', '41485.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9703, '752328619222634', '5736277861', '481', NULL, '', '4.00', '45.00', '78.6111', '180.00', '0.00', '', '0.00', '0', '41485.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9555, '726843161655695', '5213434265', '1261', NULL, '', '1.00', '9110.00', '8841', '9110.00', '0.00', '', '0.00', '0', '1261809.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9556, '166531293328755', '5213434265', '1262', NULL, '', '1.00', '9110.00', '8841', '9110.00', '0.00', '', '0.00', '0', '1261809.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9557, '844855928277845', '6341328237', '1162', NULL, '', '4.00', '18000.00', '17533', '72000.00', '0.00', '', NULL, '0', '72000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9558, '168684568617626', '1521546399', '1258', NULL, '', '18.00', '4250.00', '4155', '76500.00', '0.00', '', NULL, '0', '2306006.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9559, '677728997234269', '1521546399', '1259', NULL, '', '12.00', '4250.00', '4155', '51000.00', '0.00', '', NULL, '0', '2306006.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9560, '951122837781244', '1521546399', '1262', NULL, '', '6.00', '9200.00', '8841', '55200.00', '0.00', '', NULL, '0', '2306006.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9561, '318668166332558', '1521546399', '1261', NULL, '', '4.00', '9200.00', '8841', '36800.00', '0.00', '', NULL, '0', '2306006.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9562, '967417153419798', '1521546399', '302', NULL, '', '3.00', '17000.00', '16945', '51000.00', '0.00', '', NULL, '0', '2306006.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9563, '619526977433251', '1521546399', '135', NULL, '', '2.00', '3000.00', '2938.1', '6000.00', '0.00', '', NULL, '0', '2306006.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9564, '123234635171725', '1521546399', '649', NULL, '', '1.00', '3000.00', '2961', '3000.00', '0.00', '', NULL, '0', '2306006.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9565, '218511535639557', '1521546399', '139', NULL, '', '7.00', '3000.00', '2938.1', '21000.00', '0.00', '', NULL, '0', '2306006.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9566, '712716264489778', '1521546399', '142', NULL, '', '5.00', '6200.00', '6098.6', '31000.00', '0.00', '', NULL, '0', '2306006.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9606, '818164647894825', '9695696422', '1033', NULL, '', '3.00', '2800.00', '2400', '8400.00', '0.00', '', '0.00', '0', '19400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9605, '278233716537736', '9695696422', '8', NULL, '', '3.00', '550.00', '550', '1650.00', '0.00', '', '0.00', '0', '19400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9604, '994762272318141', '9695696422', '481', NULL, '', '1.00', '50.00', '83.5625', '50.00', '0.00', '', '0.00', '0', '19400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9603, '796463884267376', '9695696422', '837', NULL, '', '8.00', '100.00', '70', '800.00', '0.00', '', '0.00', '0', '19400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9602, '937639795235327', '9695696422', '773', NULL, '', '2.00', '150.00', '80', '300.00', '0.00', '', '0.00', '0', '19400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9601, '572569529937211', '9695696422', '1009', NULL, '', '1.00', '400.00', '340', '400.00', '0.00', '', '0.00', '0', '19400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9600, '955113989375721', '9695696422', '234', NULL, '', '2.00', '950.00', '920', '1900.00', '0.00', '', '0.00', '0', '19400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9599, '267345941216231', '9695696422', '9', NULL, '', '2.00', '450.00', '420', '900.00', '0.00', '', '0.00', '0', '19400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9598, '478282519466764', '9695696422', '109', NULL, '', '2.00', '550.00', '600', '1100.00', '0.00', '', '0.00', '0', '19400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9597, '658992165168714', '9695696422', '684', NULL, '', '5.00', '400.00', '360', '2000.00', '0.00', '', '0.00', '0', '19400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9596, '788137415867183', '9695696422', '714', NULL, '', '1.00', '400.00', '325', '400.00', '0.00', '', '0.00', '0', '19400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9607, '265555274248553', '9695696422', '4', NULL, '', '4.00', '350.00', '290', '1400.00', '0.00', '', '0.00', '0', '19400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9608, '537586513153366', '9695696422', '448', NULL, '', '1.00', '100.00', '120', '100.00', '0.00', '', '0.00', '0', '19400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9609, '964734671221868', '8717124365', '1268', NULL, '', '3.00', '250.00', '200', '750.00', '0.00', '', NULL, '0', '517200.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9610, '196848532142718', '8717124365', '1269', NULL, '', '3.00', '350.00', '300', '1050.00', '0.00', '', NULL, '0', '517200.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10154, '453574451777967', '9746361644', '489', NULL, '', '3.00', '240.00', '125', '720.00', '0.00', '', '0.00', '0', '68770.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10153, '116143689975869', '9746361644', '772', NULL, '', '1.00', '50.00', '30', '50.00', '0.00', '', '0.00', '0', '68770.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10152, '384968287484998', '9746361644', '666', NULL, '', '1.00', '3400.00', '3208', '3400.00', '0.00', '', '0.00', '0', '68770.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10151, '858731661851938', '9746361644', '155', NULL, '', '2.00', '3400.00', '3208', '6800.00', '0.00', '', '0.00', '0', '68770.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10150, '484192156185731', '9746361644', '714', NULL, '', '1.00', '400.00', '325', '400.00', '0.00', '', '0.00', '0', '68770.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10149, '175465934523392', '9746361644', '481', NULL, '', '4.00', '50.00', '78.6111', '200.00', '0.00', '', '0.00', '0', '68770.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10148, '192416983318668', '9746361644', '176', NULL, '', '2.00', '180.00', '65', '360.00', '0.00', '', '0.00', '0', '68770.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10147, '841582772974683', '9746361644', '175', NULL, '', '3.00', '240.00', '125', '720.00', '0.00', '', '0.00', '0', '68770.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10146, '258478284993999', '9746361644', '19', NULL, '', '25.00', '80.00', '70', '2000.00', '0.00', '', '0.00', '0', '68770.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10145, '754941645366348', '9746361644', '582', NULL, '', '1.00', '1550.00', '1500', '1550.00', '0.00', '', '0.00', '0', '68770.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10144, '396392621657436', '9746361644', '281', NULL, '', '10.00', '60.00', '25', '600.00', '0.00', '', '0.00', '0', '68770.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10143, '157476545325918', '9746361644', '282', NULL, '', '6.00', '70.00', '32', '420.00', '0.00', '', '0.00', '0', '68770.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10142, '295329473927242', '9746361644', '74', NULL, '', '1.00', '7000.00', '6500', '7000.00', '0.00', '', '0.00', '0', '68770.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10141, '697371388739739', '9746361644', '962', NULL, '', '1.00', '5200.00', '4100', '5200.00', '0.00', '', '0.00', '0', '68770.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10140, '811286498518691', '9746361644', '961', NULL, '', '6.00', '2450.00', '2050', '14700.00', '0.00', '', '0.00', '0', '68770.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10139, '379573719441972', '9746361644', '357', NULL, '', '1.00', '8600.00', '8800', '8600.00', '0.00', '', '0.00', '0', '68770.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10138, '798583323371422', '9746361644', '883', NULL, '', '13.00', '950.00', '469.333', '12350.00', '0.00', '', '0.00', '0', '68770.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10137, '652247177178254', '9746361644', '884', NULL, '', '4.00', '875.00', '462.75', '3500.00', '0.00', '', '0.00', '0', '68770.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10178, '118526822211239', '6655196876', '697', NULL, '', '55.00', '450.00', '390', '24750.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10177, '265646672671516', '6655196876', '1022', NULL, '', '10.00', '1150.00', '780', '11500.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10176, '149222281858383', '6655196876', '1279', NULL, '', '10.00', '650.00', '495', '6500.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10175, '954935747918296', '6655196876', '1280', NULL, '', '10.00', '650.00', '485', '6500.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10174, '547382952111169', '6655196876', '1283', NULL, '', '1.00', '350.00', '290', '350.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10173, '969816769313454', '6655196876', '1281', NULL, '', '7.00', '450.00', '495', '3150.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10172, '675438667665623', '6655196876', '1282', NULL, '', '2.00', '650.00', '460', '1300.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10171, '722575223578661', '6655196876', '752', NULL, '', '2.00', '60.00', '88', '120.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10170, '298218127128628', '6655196876', '422', NULL, '', '2.00', '70.00', '30', '140.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10169, '785666499165177', '6655196876', '603', NULL, '', '6.00', '375.00', '250', '2250.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10168, '121729714674863', '6655196876', '1055', NULL, '', '2.00', '850.00', '666.667', '1700.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10167, '594651432679778', '6655196876', '1032', NULL, '', '2.00', '1550.00', '1400', '3100.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10166, '896522684867111', '6655196876', '1204', NULL, '', '5.00', '1550.00', '1337.5', '7750.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10165, '783354718921972', '6655196876', '1014', NULL, '', '60.00', '200.00', '160', '12000.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10164, '492378942351447', '6655196876', '213', NULL, '', '2.00', '200.00', '166.667', '400.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10163, '937482732367392', '6655196876', '794', NULL, '', '6.00', '200.00', '140', '1200.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10162, '838471151376655', '6655196876', '448', NULL, '', '1.00', '150.00', '120', '150.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10161, '841257149854361', '6655196876', '497', NULL, '', '4.00', '200.00', '160', '800.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10160, '935411251682496', '6655196876', '498', NULL, '', '1.00', '250.00', '250', '250.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10159, '165854658948913', '6655196876', '1039', NULL, '', '10.00', '30.00', '12', '300.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10158, '296888447978762', '6655196876', '1276', NULL, '', '1.00', '4050.00', '3400', '4050.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10371, '632826441579435', '3258566874', '1304', NULL, '', '10.00', '15.00', '6', '150.00', '0.00', '', '0.00', '0', '14900.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10370, '174554611621795', '3258566874', '181', NULL, '', '1.00', '150.00', '165', '150.00', '0.00', '', '0.00', '0', '14900.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10369, '498611322862583', '3258566874', '179', NULL, '', '8.00', '50.00', '36', '400.00', '0.00', '', '0.00', '0', '14900.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10368, '755242227224165', '3258566874', '68', NULL, '', '1.00', '2850.00', '2583.33', '2850.00', '0.00', '', '0.00', '0', '14900.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10367, '457138913547828', '3258566874', '67', NULL, '', '1.00', '2850.00', '2583.33', '2850.00', '0.00', '', '0.00', '0', '14900.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10366, '292229286783441', '3258566874', '175', NULL, '', '1.00', '240.00', '125', '240.00', '0.00', '', '0.00', '0', '14900.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10365, '363396953218994', '3258566874', '1012', NULL, '', '12.00', '15.00', '5', '180.00', '0.00', '', '0.00', '0', '14900.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10364, '976727885949171', '3258566874', '19', NULL, '', '4.00', '80.00', '70', '320.00', '0.00', '', '0.00', '0', '14900.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10363, '792643526584821', '3258566874', '422', NULL, '', '6.00', '70.00', '30', '420.00', '0.00', '', '0.00', '0', '14900.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10362, '825238415489154', '3258566874', '921', NULL, '', '4.00', '60.00', '50', '240.00', '0.00', '', '0.00', '0', '14900.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10361, '457429652379287', '3258566874', '1038', NULL, '', '3.00', '20.00', '10', '60.00', '0.00', '', '0.00', '0', '14900.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10360, '964246598911568', '3258566874', '481', NULL, '', '3.00', '50.00', '78.6111', '150.00', '0.00', '', '0.00', '0', '14900.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10462, '448472378798571', '8482417873', '1262', NULL, '', '1.00', '9000.00', '8841', '9000.00', '0.00', '', '0.00', '0', '122610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10461, '574258239779343', '8482417873', '1261', NULL, '', '1.00', '9000.00', '8841', '9000.00', '0.00', '', '0.00', '0', '122610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10460, '631292721969247', '8482417873', '336', NULL, '', '1.00', '2500.00', '2376', '2500.00', '0.00', '', '0.00', '0', '122610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10459, '238971781822839', '8482417873', '335', NULL, '', '1.00', '2500.00', '2376', '2500.00', '0.00', '', '0.00', '0', '122610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10458, '312753393821134', '8482417873', '491', NULL, '', '2.00', '250.00', '190', '500.00', '0.00', '', '0.00', '0', '122610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10457, '887221261196129', '8482417873', '179', NULL, '', '100.00', '35.00', '36', '3500.00', '0.00', '', '0.00', '0', '122610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10456, '545579287746186', '8482417873', '713', NULL, '', '2.00', '350.00', '310', '700.00', '0.00', '', '0.00', '0', '122610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10455, '328353752113583', '8482417873', '787', NULL, '', '6.00', '50.00', '25', '300.00', '0.00', '', '0.00', '0', '122610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10333, '252921757725567', '6879251196', '481', NULL, '', '1.00', '50.00', '78.6111', '50.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10332, '538521516211337', '6879251196', '1032', NULL, '', '1.00', '1450.00', '1400', '1450.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10331, '883869589565179', '6879251196', '349', NULL, '', '1.00', '6000.00', '6000', '6000.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9689, '372164953443962', '5482914316', '1027', NULL, '', '14.00', '90.00', '65', '1260.00', '0.00', '', NULL, '0', '17540.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9690, '145939662916465', '5482914316', '1227', NULL, '', '1.00', '40.00', '40', '40.00', '0.00', '', NULL, '0', '17540.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9691, '376322295857335', '5482914316', '1015', NULL, '', '6.00', '30.00', '20', '180.00', '0.00', '', NULL, '0', '17540.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9692, '746719692527996', '5482914316', '1117', NULL, '', '4.00', '25.00', '17', '100.00', '0.00', '', NULL, '0', '17540.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9693, '684671465235228', '5482914316', '158', NULL, '', '1.00', '5000.00', '4190', '5000.00', '0.00', '', NULL, '0', '17540.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9694, '373971386736186', '5482914316', '68', NULL, '', '1.00', '2400.00', '2583.33', '2400.00', '0.00', '', NULL, '0', '17540.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9695, '542433528594391', '5482914316', '1179', NULL, '', '1.00', '350.00', '281', '350.00', '0.00', '', NULL, '0', '17540.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9696, '781949679382873', '5482914316', '1095', NULL, '', '1.00', '350.00', '280', '350.00', '0.00', '', NULL, '0', '17540.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9697, '473521371325419', '5482914316', '1223', NULL, '', '1.00', '3800.00', '3900', '3800.00', '0.00', '', NULL, '0', '17540.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9698, '764188446881638', '5482914316', '481', NULL, '', '1.00', '40.00', '78.6111', '40.00', '0.00', '', NULL, '0', '17540.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9699, '873137638332683', '5482914316', '1047', NULL, '', '1.00', '20.00', '24', '20.00', '0.00', '', NULL, '0', '17540.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9700, '592981167649173', '5482914316', '19', NULL, '', '35.00', '80.00', '70', '2800.00', '0.00', '', NULL, '0', '17540.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9701, '475916248935513', '5482914316', '175', NULL, '', '2.00', '240.00', '125', '480.00', '0.00', '', NULL, '0', '17540.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9702, '585266658615844', '5482914316', '489', NULL, '', '3.00', '240.00', '125', '720.00', '0.00', '', NULL, '0', '17540.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9720, '656926946293921', '5736277861', '705', NULL, '', '30.00', '250.00', '255', '7500.00', '0.00', '', '0.00', '0', '41485.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10157, '943514818412157', '6655196876', '481', NULL, '', '4.00', '50.00', '78.6111', '200.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10156, '928747285965447', '6655196876', '837', NULL, '', '5.00', '90.00', '70', '450.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9762, '792227123819685', '9859657466', '577', NULL, '', '1.00', '1550.00', '1250', '1550.00', '0.00', '', NULL, '0', '46350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9763, '622632294263468', '9859657466', '222', NULL, '', '4.00', '350.00', '230', '1400.00', '0.00', '', NULL, '0', '46350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9764, '779827991399466', '9859657466', '221', NULL, '', '2.00', '850.00', '480', '1700.00', '0.00', '', NULL, '0', '46350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9765, '113749157372977', '9859657466', '67', NULL, '', '2.00', '2800.00', '2583.33', '5600.00', '0.00', '', NULL, '0', '46350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9766, '335211841686378', '9859657466', '964', NULL, '', '2.00', '6000.00', '5000', '12000.00', '0.00', '', NULL, '0', '46350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9767, '633519951785184', '9859657466', '144', NULL, '', '1.00', '6000.00', '6098.6', '6000.00', '0.00', '', NULL, '0', '46350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9768, '548482326276828', '9859657466', '143', NULL, '', '1.00', '6000.00', '6098.6', '6000.00', '0.00', '', NULL, '0', '46350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9769, '491729473917687', '9859657466', '68', NULL, '', '1.00', '2850.00', '2583.33', '2850.00', '0.00', '', NULL, '0', '46350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9770, '827287524197218', '9859657466', '67', NULL, '', '1.00', '2850.00', '2583.33', '2850.00', '0.00', '', NULL, '0', '46350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9771, '984772685425664', '9859657466', '68', NULL, '', '1.00', '2300.00', '2583.33', '2300.00', '0.00', '', NULL, '0', '46350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9772, '588389384319589', '9859657466', '67', NULL, '', '1.00', '2300.00', '2583.33', '2300.00', '0.00', '', NULL, '0', '46350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9773, '665852759561181', '9859657466', '837', NULL, '', '5.00', '90.00', '70', '450.00', '0.00', '', NULL, '0', '46350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9774, '354718556555889', '9859657466', '481', NULL, '', '4.00', '50.00', '78.6111', '200.00', '0.00', '', NULL, '0', '46350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9775, '348695994411798', '9859657466', '714', NULL, '', '1.00', '400.00', '325', '400.00', '0.00', '', NULL, '0', '46350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9776, '453581382643582', '9859657466', '600', NULL, '', '2.00', '50.00', '160.667', '100.00', '0.00', '', NULL, '0', '46350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9777, '986639679511855', '9859657466', '213', NULL, '', '1.00', '200.00', '166.667', '200.00', '0.00', '', NULL, '0', '46350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9778, '398816326652249', '9859657466', '1184', NULL, '', '1.00', '450.00', '350', '450.00', '0.00', '', NULL, '0', '46350.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9808, '718389549122937', '9266641739', '1251', NULL, '', '5.00', '550.00', '500', '2750.00', '0.00', '', '0.00', '0', '260556.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9807, '214126817335497', '9266641739', '271', NULL, '', '5.00', '140.00', '120', '700.00', '0.00', '', '0.00', '0', '260556.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9806, '978316951625669', '9266641739', '270', NULL, '', '5.00', '180.00', '160', '900.00', '0.00', '', '0.00', '0', '260556.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9805, '697634622237271', '9266641739', '715', NULL, '', '50.00', '125.00', '120', '6250.00', '0.00', '', '0.00', '0', '260556.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9804, '684483685494482', '9266641739', '1172', NULL, '', '50.00', '310.00', '300', '15500.00', '0.00', '', '0.00', '0', '260556.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9803, '117389435683862', '9266641739', '965', NULL, '', '3.00', '1600.00', '1700', '4800.00', '0.00', '', '0.00', '0', '260556.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9802, '595935915174356', '9266641739', '1083', NULL, '', '3.00', '1900.00', '2100', '5700.00', '0.00', '', '0.00', '0', '260556.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9801, '771666934574379', '9266641739', '1257', NULL, '', '1.00', '3700.00', '4000', '3700.00', '0.00', '', '0.00', '0', '260556.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9800, '572326415655228', '9266641739', '59215232', NULL, '', '1.00', '4200.00', '3500', '4200.00', '0.00', '', '0.00', '0', '260556.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9799, '286339291566789', '9266641739', '161', NULL, '', '1.00', '4700.00', '4391', '4700.00', '0.00', '', '0.00', '0', '260556.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9798, '225838415317557', '9266641739', '1081', NULL, '', '3.00', '1800.00', '1700', '5400.00', '0.00', '', '0.00', '0', '260556.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9797, '885281671728921', '9266641739', '1082', NULL, '', '3.00', '2000.00', '2000', '6000.00', '0.00', '', '0.00', '0', '260556.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9796, '811193364517663', '9266641739', '1079', NULL, '', '3.00', '1400.00', '1100', '4200.00', '0.00', '', '0.00', '0', '260556.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9795, '183511667947499', '9266641739', '411', NULL, '', '4.00', '3500.00', '3300', '14000.00', '0.00', '', '0.00', '0', '260556.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9794, '818956988462956', '9266641739', '959', NULL, '', '6.00', '1700.00', '1550', '10200.00', '0.00', '', '0.00', '0', '260556.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9924, '238114875292125', '5866451357', '278', NULL, '', '5.00', '180.00', '180', '900.00', '0.00', '', '0.00', '0', '2347186.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9923, '696434458834322', '5866451357', '270', NULL, '', '6.00', '180.00', '160', '1080.00', '0.00', '', '0.00', '0', '2347186.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9922, '181781228314787', '5866451357', '322', NULL, '', '2.00', '16500.00', '15101', '33000.00', '0.00', '', '0.00', '0', '2347186.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9921, '548163946374586', '5866451357', '139', NULL, '', '1.00', '3000.00', '2938.1', '3000.00', '0.00', '', '0.00', '0', '2347186.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9927, '283755834358967', '9277318726', '716', NULL, '', '1.00', '200.00', '190', '200.00', '0.00', '', '0.00', '0', '117630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9926, '238328396666622', '9277318726', '351', NULL, '', '1.00', '2900.00', '2800', '2900.00', '0.00', '', '0.00', '0', '117630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10330, '992326865624711', '6879251196', '1303', NULL, '', '1.00', '10000.00', '10000', '10000.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10233, '774752288662725', '4199745195', '62', NULL, '', '0.00', '0.00', '1500', '0.00', '0.00', '', '0.00', '0', '0.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9920, '157195471951514', '1547115985', '1286', NULL, '', '2.00', '850.00', '750', '1700.00', '0.00', '', '0.00', '0', '45530.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9925, '532566542936895', '5866451357', '269', NULL, '', '20.00', '160.00', '110', '3200.00', '0.00', '', '0.00', '0', '2347186.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9928, '251421492997814', '8199273583', '139', NULL, '', '1.00', '3000.00', '2938.1', '3000.00', '0.00', '', NULL, '0', '3000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9929, '679852512231382', '3293275968', '254', NULL, '', '200.00', '255.00', '223.75', '51000.00', '0.00', '', NULL, '0', '191400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9930, '759347581525194', '3293275968', '1202', NULL, '', '8.00', '7700.00', '6700', '61600.00', '0.00', '', NULL, '0', '191400.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9932, '535846919646162', '6727268952', '68', NULL, '', '10.00', '2550.00', '2583.33', '25500.00', '0.00', '', NULL, '0', '295500.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9933, '482891455855511', '6727268952', '67', NULL, '', '10.00', '2550.00', '2583.33', '25500.00', '0.00', '', NULL, '0', '295500.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9934, '256926452577643', '6727268952', '964', NULL, '', '10.00', '5200.00', '5000', '52000.00', '0.00', '', NULL, '0', '295500.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9935, '381713333332927', '6727268952', '138', NULL, '', '3.00', '3100.00', '2938.1', '9300.00', '0.00', '', NULL, '0', '295500.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9936, '447269669924436', '6727268952', '140', NULL, '', '3.00', '3100.00', '2938.1', '9300.00', '0.00', '', NULL, '0', '295500.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9937, '672549896541655', '9192112764', '1162', NULL, '', '2.00', '18000.00', '17533', '36000.00', '0.00', '', NULL, '0', '108000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9967, '171377328721521', '9512576366', '837', NULL, '', '20.00', '80.00', '70', '1600.00', '0.00', '', '0.00', '0', '3850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9966, '252463697825934', '9512576366', '1291', NULL, '', '7.00', '20.00', '14', '140.00', '0.00', '', '0.00', '0', '3850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9965, '314858429452321', '9512576366', '904', NULL, '', '48.00', '2.50', '3', '120.00', '0.00', '', '0.00', '0', '3850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9964, '322382232849764', '9512576366', '481', NULL, '', '2.00', '50.00', '78.6111', '100.00', '0.00', '', '0.00', '0', '3850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9963, '983385583651698', '9512576366', '240', NULL, '', '2.00', '250.00', '256.667', '500.00', '0.00', '', '0.00', '0', '3850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9962, '812493322424735', '9512576366', '1139', NULL, '', '1.00', '50.00', '40', '50.00', '0.00', '', '0.00', '0', '3850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9961, '458939827515549', '9512576366', '373', NULL, '', '2.00', '30.00', '17', '60.00', '0.00', '', '0.00', '0', '3850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9960, '578452644352427', '9512576366', '711', NULL, '', '1.00', '80.00', '62', '80.00', '0.00', '', '0.00', '0', '3850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9959, '659585362889538', '9512576366', '830', NULL, '', '1.00', '150.00', '87.5', '150.00', '0.00', '', '0.00', '0', '3850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9958, '814343396837681', '9512576366', '1035', NULL, '', '20.00', '10.00', '6', '200.00', '0.00', '', '0.00', '0', '3850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9957, '116133694441921', '9512576366', '269', NULL, '', '4.00', '125.00', '110', '500.00', '0.00', '', '0.00', '0', '3850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (9968, '355992651749324', '9512576366', '1014', NULL, '', '2.00', '175.00', '160', '350.00', '0.00', '', '0.00', '0', '3850.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10048, '328344987692729', '3942454311', '665', NULL, '', '1.00', '3303.00', '3208', '3303.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10047, '818815267687344', '3942454311', '666', NULL, '', '1.00', '3300.00', '3208', '3300.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10046, '523137286655111', '3942454311', '153', NULL, '', '1.00', '2300.00', '2292', '2300.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10045, '769123157921786', '3942454311', '664', NULL, '', '1.00', '2300.00', '2292', '2300.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10044, '454435251864325', '3942454311', '659', NULL, '', '1.00', '1200.00', '1044', '1200.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10043, '149216423365697', '3942454311', '660', NULL, '', '2.00', '1200.00', '1044', '2400.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10042, '823895865727764', '3942454311', '843', NULL, '', '6.00', '20.00', '13', '120.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10041, '235177681555649', '3942454311', '903', NULL, '', '6.00', '45.00', '40', '270.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10040, '256786742359272', '3942454311', '1043', NULL, '', '2.00', '40.00', '20', '80.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10039, '361375697414555', '3942454311', '1044', NULL, '', '2.00', '50.00', '25', '100.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10038, '546529759393918', '3942454311', '481', NULL, '', '2.00', '50.00', '78.6111', '100.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10037, '321232195787569', '3942454311', '625', NULL, '', '2.00', '50.00', '39.75', '100.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10036, '379375263728491', '3942454311', '1132', NULL, '', '12.00', '33.50', '20', '402.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10035, '294363455668989', '3942454311', '715', NULL, '', '35.00', '125.00', '120', '4375.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10034, '311183977136328', '3942454311', '1275', NULL, '', '4.00', '180.00', '128', '720.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10033, '433147769357115', '3942454311', '1272', NULL, '', '9.00', '150.00', '94', '1350.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10032, '259678414945516', '3942454311', '843', NULL, '', '1.00', '20.00', '13', '20.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10031, '569264533547478', '3942454311', '270', NULL, '', '1.00', '240.00', '160', '240.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10030, '691868111171184', '3942454311', '381', NULL, '', '1.00', '45.00', '34', '45.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10029, '663831726823917', '3942454311', '86', NULL, '', '1.00', '540.00', '390', '540.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10028, '915451759734197', '3942454311', '379', NULL, '', '6.00', '45.00', '25', '270.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10027, '866892716386917', '3942454311', '102', NULL, '', '1.00', '540.00', '450.667', '540.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10026, '283162938959193', '3942454311', '379', NULL, '', '2.00', '45.00', '25', '90.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10025, '991795991168767', '3942454311', '102', NULL, '', '4.00', '540.00', '450.667', '2160.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10024, '447874789383198', '3942454311', '960', NULL, '', '2.00', '3500.00', '3100', '7000.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10023, '118726961549836', '3942454311', '959', NULL, '', '2.00', '1750.00', '1550', '3500.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10022, '118181789241456', '3942454311', '711', NULL, '', '1.00', '100.00', '62', '100.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10021, '559266525667846', '3942454311', '830', NULL, '', '20.00', '110.00', '87.5', '2200.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10020, '978848542511148', '3942454311', '773', NULL, '', '12.00', '130.00', '80', '1560.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10019, '958922893783175', '3942454311', '837', NULL, '', '3.00', '90.00', '70', '270.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10018, '743312448257929', '3942454311', '836', NULL, '', '1.00', '50.00', '30', '50.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10017, '872454666464951', '3942454311', '1293', NULL, '', '2.00', '90.00', '80', '180.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10016, '999123521529199', '3942454311', '481', NULL, '', '1.00', '50.00', '78.6111', '50.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10015, '281974614772491', '3942454311', '1014', NULL, '', '1.00', '180.00', '160', '180.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10014, '246836423261272', '3942454311', '662', NULL, '', '1.00', '1850.00', '1557', '1850.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10013, '727332472131473', '3942454311', '660', NULL, '', '1.00', '1250.00', '1044', '1250.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10049, '456843683582498', '3942454311', '715', NULL, '', '12.00', '130.00', '120', '1560.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10050, '937164634464365', '3942454311', '784', NULL, '', '2.00', '200.00', '135', '400.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10051, '159911465315514', '3942454311', '270', NULL, '', '1.00', '240.00', '160', '240.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10052, '925584378584381', '3942454311', '381', NULL, '', '6.00', '50.00', '34', '300.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10053, '659386929437616', '3942454311', '903', NULL, '', '6.00', '50.00', '40', '300.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10054, '721934571374523', '3942454311', '1287', NULL, '', '6.00', '350.00', '280', '2100.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10055, '256646967223321', '3942454311', '102', NULL, '', '2.00', '600.00', '450.667', '1200.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10056, '858826646669575', '3942454311', '1272', NULL, '', '6.00', '150.00', '94', '900.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10057, '531729189959534', '3942454311', '481', NULL, '', '2.00', '50.00', '78.6111', '100.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10058, '843554476142864', '3942454311', '1132', NULL, '', '2.00', '30.00', '20', '60.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10059, '551164212662612', '3942454311', '1133', NULL, '', '2.00', '40.00', '30', '80.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10060, '433198979192165', '3942454311', '375', NULL, '', '2.00', '30.00', '15', '60.00', '0.00', '', '0.00', '0', '51813.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10061, '192994891828751', '1187151677', '282', NULL, '', '60.00', '70.00', '32', '4200.00', '0.00', '', NULL, '0', '798370.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10062, '181558563856659', '7938173624', '125', NULL, '', '12.00', '540.00', '375', '6480.00', '0.00', '', NULL, '0', '849940.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10063, '566343971614839', '7938173624', '125', NULL, '', '12.00', '540.00', '375', '6480.00', '0.00', '', NULL, '0', '849940.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10064, '953341176586527', '7938173624', '205', NULL, '', '5.00', '1250.00', '900', '6250.00', '0.00', '', NULL, '0', '849940.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10065, '343266141659113', '7938173624', '206', NULL, '', '5.00', '1550.00', '1200', '7750.00', '0.00', '', NULL, '0', '849940.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10066, '492855277778426', '7938173624', '207', NULL, '', '5.00', '1850.00', '1150', '9250.00', '0.00', '', NULL, '0', '849940.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10067, '236514349444922', '7938173624', '1272', NULL, '', '48.00', '150.00', '94', '7200.00', '0.00', '', NULL, '0', '849940.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10068, '991418592937332', '7938173624', '1270', NULL, '', '24.00', '100.00', '85', '2400.00', '0.00', '', NULL, '0', '849940.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10069, '335334355433863', '7938173624', '492', NULL, '', '12.00', '480.00', '235', '5760.00', '0.00', '', NULL, '0', '849940.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10077, '463153785346496', '2415214152', '1266', NULL, '', '3.00', '43000.00', '43725', '129000.00', '0.00', '', NULL, '0', '1425286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10452, '318354816365847', '1614719538', '1129', NULL, '', '1.00', '2850.00', '2025', '2850.00', '0.00', '', '0.00', '0', '16550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10451, '421469125441654', '1614719538', '1314', NULL, '', '1.00', '350.00', '290', '350.00', '0.00', '', '0.00', '0', '16550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10450, '635214351295176', '1614719538', '102', NULL, '', '1.00', '600.00', '450.667', '600.00', '0.00', '', '0.00', '0', '16550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10078, '933163257125312', '2415214152', '1267', NULL, '', '2.00', '43000.00', '43725', '86000.00', '0.00', '', NULL, '0', '1425286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10079, '398711464556579', '2415214152', '1265', NULL, '', '2.00', '28000.00', '27625', '56000.00', '0.00', '', NULL, '0', '1425286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10080, '528233581656143', '2415214152', '322', NULL, '', '1.00', '15500.00', '15101', '15500.00', '0.00', '', NULL, '0', '1425286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10081, '846726757517527', '2415214152', '148', NULL, '', '3.00', '15500.00', '14870.6', '46500.00', '0.00', '', NULL, '0', '1425286.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10082, '791131483371355', '2515197159', '694', NULL, '', '2.00', '150.00', '130', '300.00', '0.00', '', NULL, '0', '55590.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10083, '584782652191266', '2515197159', '481', NULL, '', '2.00', '50.00', '78.6111', '100.00', '0.00', '', NULL, '0', '55590.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10084, '176951513878449', '2515197159', '773', NULL, '', '1.00', '60.00', '80', '60.00', '0.00', '', NULL, '0', '55590.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10085, '492872497968631', '2515197159', '1223', NULL, '', '2.00', '4000.00', '3900', '8000.00', '0.00', '', NULL, '0', '55590.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10086, '811628138766556', '2515197159', '773', NULL, '', '1.00', '150.00', '80', '150.00', '0.00', '', NULL, '0', '55590.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10087, '546617924143382', '2515197159', '1083', NULL, '', '1.00', '1500.00', '2100', '1500.00', '0.00', '', NULL, '0', '55590.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10088, '483129135523994', '2515197159', '8', NULL, '', '1.00', '580.00', '550', '580.00', '0.00', '', NULL, '0', '55590.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10089, '685291157555234', '2515197159', '9', NULL, '', '1.00', '450.00', '420', '450.00', '0.00', '', NULL, '0', '55590.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10090, '467851622833744', '2515197159', '366', NULL, '', '10.00', '65.00', '46', '650.00', '0.00', '', NULL, '0', '55590.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10091, '833526246619979', '2515197159', '835', NULL, '', '5.00', '50.00', '50', '250.00', '0.00', '', NULL, '0', '55590.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10092, '615322726138953', '2515197159', '1292', NULL, '', '55.00', '700.00', '600', '38500.00', '0.00', '', NULL, '0', '55590.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10093, '186885287865397', '2515197159', '888', NULL, '', '6.00', '350.00', '327.667', '2100.00', '0.00', '', NULL, '0', '55590.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10094, '766164764543348', '2515197159', '247', NULL, '', '3.00', '850.00', '665', '2550.00', '0.00', '', NULL, '0', '55590.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10095, '873365176217242', '2515197159', '1038', NULL, '', '20.00', '20.00', '10', '400.00', '0.00', '', NULL, '0', '55590.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10096, '252614354368125', '5942324735', '851', NULL, '', '1.00', '550.00', '250', '550.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10097, '446552471388169', '5942324735', '773', NULL, '', '3.00', '150.00', '80', '450.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10098, '965873339968112', '5942324735', '1066', NULL, '', '3.00', '300.00', '280', '900.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10099, '795119692969976', '5942324735', '837', NULL, '', '5.00', '90.00', '70', '450.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10100, '583936943994269', '5942324735', '239', NULL, '', '1.00', '350.00', '360', '350.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10101, '734453843963843', '5942324735', '694', NULL, '', '2.00', '150.00', '130', '300.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10102, '786192624916689', '5942324735', '419', NULL, '', '1.00', '7500.00', '7121', '7500.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10103, '478715794715678', '5942324735', '773', NULL, '', '12.00', '120.00', '80', '1440.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10104, '152295965794235', '5942324735', '837', NULL, '', '10.00', '90.00', '70', '900.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10105, '663595713265381', '5942324735', '160', NULL, '', '1.00', '4800.00', '5126', '4800.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10106, '632558142418792', '5942324735', '663', NULL, '', '1.00', '2200.00', '2292', '2200.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10107, '431924432711879', '5942324735', '331', NULL, '', '1.00', '12200.00', '11760.5', '12200.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10108, '428457142644422', '5942324735', '1272', NULL, '', '6.00', '120.00', '94', '720.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10109, '378968535444868', '5942324735', '257', NULL, '', '1.00', '600.00', '583.333', '600.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10110, '829593939696637', '5942324735', '1022', NULL, '', '2.00', '900.00', '780', '1800.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10111, '663221717253294', '5942324735', '700', NULL, '', '3.00', '180.00', '160', '540.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10112, '133299165681927', '5942324735', '730', NULL, '', '150.00', '150.00', '147.667', '22500.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10113, '465988723811136', '5942324735', '1029', NULL, '', '1.00', '1100.00', '916.667', '1100.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10114, '782627217557179', '5942324735', '1217', NULL, '', '1.00', '900.00', '560', '900.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10115, '592667652616475', '5942324735', '1033', NULL, '', '3.00', '2400.00', '2300', '7200.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10116, '263737729951986', '5942324735', '1295', NULL, '', '3.00', '1500.00', '950', '4500.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10117, '789231647661628', '5942324735', '1123', NULL, '', '1.00', '6300.00', '7000', '6300.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10118, '929615386266633', '5942324735', '1162', NULL, '', '1.00', '18000.00', '17533', '18000.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10119, '637948345172862', '5942324735', '794', NULL, '', '15.00', '180.00', '140', '2700.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10120, '844679392672263', '5942324735', '1129', NULL, '', '1.00', '3500.00', '2025', '3500.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10121, '624229713412375', '5942324735', '1038', NULL, '', '30.00', '30.00', '10', '900.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10122, '277717291199816', '5942324735', '1118', NULL, '', '1.00', '1000.00', '650', '1000.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10123, '643618339681956', '5942324735', '175', NULL, '', '1.00', '240.00', '125', '240.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10124, '841212668235342', '5942324735', '489', NULL, '', '1.00', '360.00', '125', '360.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10125, '973567927257285', '5942324735', '1053', NULL, '', '1.00', '150.00', '130', '150.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10126, '214366228645657', '5942324735', '481', NULL, '', '4.00', '50.00', '78.6111', '200.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10127, '896779961928727', '5942324735', '1031', NULL, '', '1.00', '4500.00', '4300', '4500.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10128, '894286428861162', '5942324735', '1201', NULL, '', '1.00', '700.00', '600', '700.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10129, '931937316825112', '5942324735', '600', NULL, '', '3.00', '100.00', '160.667', '300.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10130, '287642524836266', '5942324735', '218', NULL, '', '3.00', '200.00', '160', '600.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10131, '614826785877494', '5942324735', '1058', NULL, '', '6.00', '300.00', '210', '1800.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10132, '791955911192839', '5942324735', '1170', NULL, '', '20.00', '630.00', '375', '12600.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10133, '447734564346859', '5942324735', '1294', NULL, '', '200.00', '80.00', '70', '16000.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10134, '195518749697992', '5942324735', '1017', NULL, '', '24.00', '60.00', '45', '1440.00', '0.00', '', NULL, '0', '143190.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10135, '284329483321583', '6973986361', '1178', NULL, '', '1.00', '700.00', '746', '700.00', '0.00', '', NULL, '0', '109000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10136, '529664884811272', '6973986361', '265', NULL, '', '2.00', '150.00', '120', '300.00', '0.00', '', NULL, '0', '109000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10155, '222457564812234', '9746361644', '1251', NULL, '', '0.50', '400.00', '500', '200.00', '0.00', '', '0.00', '0', '68770.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10179, '595777124877179', '6655196876', '1011', NULL, '', '6.00', '20.00', '11', '120.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10180, '465966141687318', '6655196876', '1285', NULL, '', '40.00', '40.00', '30', '1600.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10181, '456979963349535', '6655196876', '1075', NULL, '', '36.00', '15.00', '8', '540.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10182, '975441698663628', '6655196876', '919', NULL, '', '1.00', '250.00', '260', '250.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10183, '556825966685946', '6655196876', '1139', NULL, '', '1.00', '50.00', '40', '50.00', '0.00', '', '0.00', '0', '91470.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10329, '211794438157262', '6879251196', '711', NULL, '', '24.00', '63.00', '62', '1512.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10328, '341179171199253', '6879251196', '349', NULL, '', '1.00', '6020.00', '6000', '6200.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10327, '735489755496261', '6879251196', '309', NULL, '', '1.00', '6200.00', '6000', '6200.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10326, '339185698818646', '6879251196', '1032', NULL, '', '1.00', '1500.00', '1400', '1500.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10325, '483352833467291', '6879251196', '921', NULL, '', '6.00', '70.00', '50', '420.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10324, '739981195539288', '6879251196', '422', NULL, '', '6.00', '60.00', '30', '360.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10323, '236695518698521', '6879251196', '686', NULL, '', '6.00', '290.00', '250', '1740.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10322, '391189645694815', '6879251196', '59215232', NULL, '', '1.00', '4300.00', '3500', '4300.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10321, '649844165913469', '6879251196', '834', NULL, '', '1.00', '150.00', '75', '150.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10320, '324424616419814', '6879251196', '58', NULL, '', '7.00', '150.00', '115', '1050.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10319, '692346235422343', '6879251196', '961', NULL, '', '3.00', '2350.00', '2050', '7050.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10318, '968197831497863', '6879251196', '73', NULL, '', '2.00', '2350.00', '2250', '4700.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10317, '749647952721591', '6879251196', '962', NULL, '', '2.00', '5000.00', '4100', '10000.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10316, '784758591775293', '6879251196', '348', NULL, '', '1.00', '3000.00', '2700', '3000.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10315, '488979722739384', '6879251196', '308', NULL, '', '1.00', '3000.00', '2700', '3000.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10314, '179548669136876', '6879251196', '860', NULL, '', '1.00', '360.00', '170', '360.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10313, '311841936154655', '6879251196', '270', NULL, '', '3.00', '240.00', '160', '720.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10312, '516942733795919', '6879251196', '107', NULL, '', '2.00', '600.00', '460', '1200.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10311, '933541366437959', '6879251196', '86', NULL, '', '1.00', '600.00', '390', '600.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10310, '264661616316717', '6879251196', '748', NULL, '', '1.00', '600.00', '530', '600.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10309, '538791197534778', '6879251196', '448', NULL, '', '1.00', '200.00', '120', '200.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10308, '494814263621425', '6879251196', '714', NULL, '', '1.00', '400.00', '325', '400.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10307, '939954336864875', '6879251196', '481', NULL, '', '6.00', '50.00', '78.6111', '300.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10306, '685918868772877', '6879251196', '883', NULL, '', '10.00', '550.00', '469.333', '5500.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10305, '686271848313464', '6879251196', '1133', NULL, '', '5.00', '40.00', '30', '200.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10304, '618281584329566', '6879251196', '775', NULL, '', '1.00', '50.00', '30', '50.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10303, '571114657745782', '6879251196', '222', NULL, '', '6.00', '350.00', '230', '2100.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10302, '837495352642273', '6879251196', '1055', NULL, '', '1.00', '850.00', '666.667', '850.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10301, '551747312112195', '6879251196', '213', NULL, '', '1.00', '200.00', '166.667', '200.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10300, '312984993258788', '6879251196', '600', NULL, '', '3.00', '50.00', '160.667', '150.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10299, '527198975231234', '6879251196', '284', NULL, '', '10.00', '70.00', '33.5', '700.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10298, '517574753244613', '6879251196', '283', NULL, '', '1.00', '60.00', '30', '60.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10297, '295718649386458', '6879251196', '888', NULL, '', '1.00', '350.00', '327.667', '350.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10296, '795436217847239', '6879251196', '715', NULL, '', '40.00', '125.00', '120', '5000.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10295, '588982221947731', '6879251196', '694', NULL, '', '24.00', '200.00', '130', '4800.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10294, '618423231531639', '6879251196', '1287', NULL, '', '12.00', '350.00', '280', '4200.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10293, '626414385448667', '6879251196', '139', NULL, '', '1.00', '3050.00', '2938.1', '3050.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10292, '218922158149612', '6879251196', '474', NULL, '', '1.00', '200.00', '100', '200.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10291, '938953693119558', '6879251196', '773', NULL, '', '1.00', '100.00', '80', '100.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10290, '551945745213637', '6879251196', '239', NULL, '', '1.00', '300.00', '360', '300.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10289, '881434425631948', '6879251196', '1301', NULL, '', '1.00', '6000.00', '5800', '6000.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10288, '166196679318615', '6879251196', '371', NULL, '', '20.00', '45.00', '34', '900.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10287, '975197213933938', '6879251196', '491', NULL, '', '4.00', '400.00', '190', '1600.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10286, '747384567722733', '6879251196', '1066', NULL, '', '4.00', '350.00', '280', '1400.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10285, '561569914867592', '6879251196', '260', NULL, '', '1.00', '1550.00', '850', '1550.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10284, '664316742928914', '6879251196', '1302', NULL, '', '15.00', '120.00', '100', '1800.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10283, '846595161758289', '6879251196', '1289', NULL, '', '1.00', '1400.00', '900', '1400.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10282, '992837115741328', '6879251196', '920', NULL, '', '6.00', '20.00', '20', '120.00', '0.00', '', '0.00', '0', '115630.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10359, '966748321576453', '3258566874', '823', NULL, '', '1.00', '1350.00', '1000', '1350.00', '0.00', '', '0.00', '0', '14900.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10358, '856911461861378', '3258566874', '1013', NULL, '', '4.00', '20.00', '16', '80.00', '0.00', '', '0.00', '0', '14900.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10357, '749752433956766', '3258566874', '995', NULL, '', '6.00', '160.00', '106', '960.00', '0.00', '', '0.00', '0', '14900.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10372, '334197737999776', '3258566874', '1027', NULL, '', '50.00', '90.00', '65', '4500.00', '0.00', '', '0.00', '0', '14900.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10411, '692917134864235', '1435241757', '699', NULL, '', '2.00', '350.00', '320', '700.00', '0.00', '', '0.00', '0', '20550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10410, '181432326521555', '1435241757', '884', NULL, '', '3.00', '500.00', '462.75', '1500.00', '0.00', '', '0.00', '0', '20550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10409, '145168231593296', '1435241757', '866', NULL, '', '5.00', '120.00', '120', '600.00', '0.00', '', '0.00', '0', '20550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10408, '334285574547341', '1435241757', '1140', NULL, '', '1.00', '50.00', '35', '50.00', '0.00', '', '0.00', '0', '20550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10407, '332122345863242', '1435241757', '811', NULL, '', '5.00', '130.00', '103', '650.00', '0.00', '', '0.00', '0', '20550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10406, '681814976436461', '1435241757', '699', NULL, '', '1.00', '350.00', '320', '350.00', '0.00', '', '0.00', '0', '20550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10405, '354793178773352', '1435241757', '68', NULL, '', '1.00', '2300.00', '2583.33', '2300.00', '0.00', '', '0.00', '0', '20550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10404, '489199222943577', '1435241757', '963', NULL, '', '2.00', '2300.00', '2500', '4600.00', '0.00', '', '0.00', '0', '20550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10403, '226314834242669', '1435241757', '1272', NULL, '', '1.00', '120.00', '94', '120.00', '0.00', '', '0.00', '0', '20550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10402, '637681224331219', '1435241757', '481', NULL, '', '20.00', '45.00', '78.6111', '900.00', '0.00', '', '0.00', '0', '20550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10401, '379122913129852', '1435241757', '837', NULL, '', '8.00', '90.00', '70', '720.00', '0.00', '', '0.00', '0', '20550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10400, '272676196685494', '1435241757', '372', NULL, '', '3.00', '70.00', '40', '210.00', '0.00', '', '0.00', '0', '20550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10399, '244727448649239', '1435241757', '775', NULL, '', '1.00', '50.00', '30', '50.00', '0.00', '', '0.00', '0', '20550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10398, '372464385624735', '1435241757', '729', NULL, '', '30.00', '134.00', '102.667', '4020.00', '0.00', '', '0.00', '0', '20550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10397, '139188183549655', '1435241757', '909', NULL, '', '12.00', '10.00', '8', '120.00', '0.00', '', '0.00', '0', '20550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10396, '126247168459426', '1435241757', '1039', NULL, '', '15.00', '30.00', '12', '450.00', '0.00', '', '0.00', '0', '20550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10395, '233746433558238', '1435241757', '715', NULL, '', '16.00', '130.00', '120', '2080.00', '0.00', '', '0.00', '0', '20550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10394, '872774558991961', '1435241757', '1139', NULL, '', '6.00', '50.00', '40', '300.00', '0.00', '', '0.00', '0', '20550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10393, '143631928496783', '1435241757', '1026', NULL, '', '2.00', '50.00', '30', '100.00', '0.00', '', '0.00', '0', '20550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10412, '534788993266795', '1435241757', '784', NULL, '', '1.00', '550.00', '135', '200.00', '0.00', '', '0.00', '0', '20550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10413, '695835852264644', '1435241757', '237', NULL, '', '1.00', '550.00', '530', '550.00', '0.00', '', '0.00', '0', '20550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10414, '677639498236551', '1217289937', '1308', NULL, '', '5.00', '400.00', '200', '2000.00', '0.00', '', NULL, '0', '47530.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10415, '323358512492828', '1471919258', '825', NULL, '', '100.00', '125.00', '115', '12500.00', '0.00', '', NULL, '0', '803567.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10416, '699795243284828', '2714463447', '299', NULL, '', '1.00', '4300.00', '4134', '4300.00', '0.00', '', NULL, '0', '396160.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10417, '483131141995415', '8246258379', '299', NULL, '', '8.00', '4350.00', '4134', '34800.00', '0.00', '', NULL, '0', '2584536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10418, '838725218567417', '8246258379', '1259', NULL, '', '7.00', '4350.00', '4155', '30450.00', '0.00', '', NULL, '0', '2584536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10419, '278185728818535', '8246258379', '1262', NULL, '', '1.00', '9300.00', '8841', '9300.00', '0.00', '', NULL, '0', '2584536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10420, '784769993255651', '8246258379', '1261', NULL, '', '1.00', '9300.00', '8841', '9300.00', '0.00', '', NULL, '0', '2584536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10421, '645992151719256', '8246258379', '331', NULL, '', '1.00', '14000.00', '11760.5', '14000.00', '0.00', '', NULL, '0', '2584536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10422, '531278123555671', '8246258379', '332', NULL, '', '1.00', '14000.00', '11760.5', '14000.00', '0.00', '', NULL, '0', '2584536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10423, '431211974384518', '8246258379', '961', NULL, '', '2.00', '2100.00', '2050', '4200.00', '0.00', '', NULL, '0', '2584536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10424, '237925852944783', '8246258379', '663', NULL, '', '4.00', '2400.00', '2292', '9600.00', '0.00', '', NULL, '0', '2584536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10425, '994154199235114', '8246258379', '664', NULL, '', '4.00', '2400.00', '2292', '9600.00', '0.00', '', NULL, '0', '2584536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10426, '355595489337252', '8246258379', '152', NULL, '', '3.00', '1850.00', '1557', '5550.00', '0.00', '', NULL, '0', '2584536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10427, '713376354644164', '8246258379', '661', NULL, '', '3.00', '1850.00', '1557', '5550.00', '0.00', '', NULL, '0', '2584536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10428, '756267316739244', '8246258379', '666', NULL, '', '3.00', '3400.00', '3208', '10200.00', '0.00', '', NULL, '0', '2584536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10429, '146882261495954', '8246258379', '155', NULL, '', '3.00', '3400.00', '3208', '10200.00', '0.00', '', NULL, '0', '2584536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10430, '696961887813373', '8246258379', '660', NULL, '', '2.00', '1250.00', '1044', '2500.00', '0.00', '', NULL, '0', '2584536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10431, '899179224316248', '8246258379', '659', NULL, '', '2.00', '1250.00', '1044', '2500.00', '0.00', '', NULL, '0', '2584536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10432, '351647423423373', '8246258379', '1262', NULL, '', '3.00', '9300.00', '8841', '27900.00', '0.00', '', NULL, '0', '2584536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10433, '242347578621117', '8246258379', '1261', NULL, '', '2.00', '9300.00', '8841', '18600.00', '0.00', '', NULL, '0', '2584536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10434, '611439758941684', '8246258379', '161', NULL, '', '1.00', '4850.00', '4391', '4850.00', '0.00', '', NULL, '0', '2584536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10435, '795241994852226', '8246258379', '140', NULL, '', '2.00', '3100.00', '2938.1', '6200.00', '0.00', '', NULL, '0', '2584536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10436, '697833255238978', '8246258379', '961', NULL, '', '2.00', '2100.00', '2050', '4200.00', '0.00', '', NULL, '0', '2584536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10437, '722783571856456', '8246258379', '270', NULL, '', '11.00', '180.00', '160', '1980.00', '0.00', '', NULL, '0', '2584536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10438, '778694478647828', '8246258379', '269', NULL, '', '4.00', '150.00', '110', '600.00', '0.00', '', NULL, '0', '2584536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10439, '274267517299467', '8246258379', '1274', NULL, '', '3.00', '150.00', '107', '450.00', '0.00', '', NULL, '0', '2584536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10440, '478773571538475', '8246258379', '495', NULL, '', '1.00', '700.00', '650', '700.00', '0.00', '', NULL, '0', '2584536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10441, '862619464879793', '8246258379', '985', NULL, '', '1.00', '120.00', '110', '120.00', '0.00', '', NULL, '0', '2584536.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10442, '883252617821938', '2173489285', '1311', NULL, '', '30.00', '1060.00', '850', '31800.00', '0.00', '', NULL, '0', '549000.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10449, '252831692575146', '1614719538', '1274', NULL, '', '3.00', '150.00', '107', '450.00', '0.00', '', '0.00', '0', '16550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10448, '285996427293812', '1614719538', '66', NULL, '', '1.00', '12000.00', '10300', '12000.00', '0.00', '', '0.00', '0', '16550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10453, '832975455938865', '1614719538', '1139', NULL, '', '6.00', '50.00', '40', '300.00', '0.00', '', '0.00', '0', '16550.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10454, '529597677694252', '7771648352', '1318', NULL, '', '1.00', '5900.00', '5400', '5900.00', '0.00', '', NULL, '0', '53430.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10463, '251961812737996', '8482417873', '1319', NULL, '', '1.00', '2600.00', '2400', '2600.00', '0.00', '', '0.00', '0', '122610.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10471, '197921371125863', '7425241919', '888', NULL, '', '5.00', '340.00', '327.667', '1700.00', '0.00', '', '0.00', '0', '272936.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10470, '516315354535225', '7425241919', '886', NULL, '', '10.00', '295.00', '284', '2950.00', '0.00', '', '0.00', '0', '272936.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10469, '274672444642512', '7425241919', '884', NULL, '', '6.00', '485.00', '462.75', '2910.00', '0.00', '', '0.00', '0', '272936.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10468, '677716118275271', '7425241919', '883', NULL, '', '6.00', '495.00', '469.333', '2970.00', '0.00', '', '0.00', '0', '272936.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10472, '949895142124174', '7425241919', '887', NULL, '', '5.00', '370.00', '297.25', '1850.00', '0.00', '', '0.00', '0', '272936.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10510, '672715996389379', '2269286568', '1315', NULL, '', '6.00', '350.00', '320', '2100.00', '0.00', '', '0.00', '0', '60400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10509, '471842348163456', '2269286568', '250', NULL, '', '16.00', '350.00', '250', '5600.00', '0.00', '', '0.00', '0', '60400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10508, '922237821266262', '2269286568', '729', NULL, '', '100.00', '115.00', '102.667', '11500.00', '0.00', '', '0.00', '0', '60400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10507, '256672845922439', '2269286568', '1317', NULL, '', '1.00', '15500.00', '13000', '15500.00', '0.00', '', '0.00', '0', '60400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10506, '116169494877842', '2269286568', '59', NULL, '', '4.00', '200.00', '165', '800.00', '0.00', '', '0.00', '0', '60400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10505, '158851987896352', '2269286568', '246', NULL, '', '3.00', '5500.00', '4000', '16500.00', '0.00', '', '0.00', '0', '60400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10504, '316491428468541', '2269286568', '885', NULL, '', '1.00', '500.00', '446.75', '500.00', '0.00', '', '0.00', '0', '60400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10503, '136796168685746', '2269286568', '750', NULL, '', '2.00', '540.00', '530', '1080.00', '0.00', '', '0.00', '0', '60400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10502, '339755117839717', '2269286568', '270', NULL, '', '2.00', '300.00', '160', '600.00', '0.00', '', '0.00', '0', '60400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10501, '639982235529463', '2269286568', '86', NULL, '', '2.00', '600.00', '390', '1200.00', '0.00', '', '0.00', '0', '60400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10500, '791244385917839', '2269286568', '284', NULL, '', '20.00', '40.00', '33.5', '800.00', '0.00', '', '0.00', '0', '60400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10499, '274426391669344', '2269286568', '243', NULL, '', '6.00', '400.00', '415', '2400.00', '0.00', '', '0.00', '0', '60400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10498, '443788771136633', '2269286568', '481', NULL, '', '1.00', '50.00', '78.6111', '50.00', '0.00', '', '0.00', '0', '60400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10497, '667642439846446', '2269286568', '125', NULL, '', '1.00', '400.00', '375', '400.00', '0.00', '', '0.00', '0', '60400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10496, '523942271331733', '2269286568', '773', NULL, '', '1.00', '100.00', '80', '100.00', '0.00', '', '0.00', '0', '60400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10495, '244486564895549', '2269286568', '1272', NULL, '', '3.00', '100.00', '94', '300.00', '0.00', '', '0.00', '0', '60400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10494, '996981616418158', '2269286568', '1270', NULL, '', '6.00', '100.00', '85', '600.00', '0.00', '', '0.00', '0', '60400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10493, '946487148789431', '2269286568', '915', NULL, '', '1.00', '150.00', '135', '150.00', '0.00', '', '0.00', '0', '60400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10492, '676496726521111', '2269286568', '1112', NULL, '', '2.00', '75.00', '66', '150.00', '0.00', '', '0.00', '0', '60400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10511, '169581366959811', '2269286568', '284', NULL, '', '1.00', '70.00', '33.5', '70.00', '0.00', '', '0.00', '0', '60400.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10512, '413123591341334', '7132322579', '2021', NULL, '', '12.00', '800.00', '700', '9600.00', '0.00', '', NULL, '0', '4259717.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10513, '364342463186651', '7531931292', '1320', NULL, '', '1.00', '31000.00', '28000', '31000.00', '0.00', '', NULL, '0', '31710.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10514, '822416976164299', '7531931292', '283', NULL, '', '1.00', '60.00', '30', '60.00', '0.00', '', NULL, '0', '31710.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10515, '725866231172644', '7531931292', '1095', NULL, '', '1.00', '350.00', '280', '350.00', '0.00', '', NULL, '0', '31710.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10516, '462966372765355', '7531931292', '1246', NULL, '', '1.00', '300.00', '185', '300.00', '0.00', '', NULL, '0', '31710.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10517, '813635763538866', '9425431332', '1308', NULL, '', '5.00', '400.00', '200', '2000.00', '0.00', '', NULL, '0', '55430.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10518, '396135724696758', '2441147954', '1202', NULL, '', '2.00', '7700.00', '6700', '15400.00', '0.00', '', NULL, '0', '206800.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10519, '786847325915812', '5141413266', '661', NULL, '', '2.00', '1800.00', '1557', '3600.00', '0.00', '', NULL, '0', '33900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10520, '341613464958352', '5141413266', '152', NULL, '', '1.00', '1800.00', '1557', '1800.00', '0.00', '', NULL, '0', '33900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10521, '814835959716422', '5141413266', '663', NULL, '', '2.00', '2400.00', '2292', '4800.00', '0.00', '', NULL, '0', '33900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10522, '452746944114974', '5141413266', '664', NULL, '', '1.00', '2400.00', '2292', '2400.00', '0.00', '', NULL, '0', '33900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10523, '149564291568179', '5141413266', '666', NULL, '', '2.00', '3400.00', '3208', '6800.00', '0.00', '', NULL, '0', '33900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10524, '484969935826153', '5141413266', '668', NULL, '', '1.00', '5100.00', '4190', '5100.00', '0.00', '', NULL, '0', '33900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10525, '586885719152561', '5141413266', '600', NULL, '', '1.00', '40.00', '160.667', '40.00', '0.00', '', NULL, '0', '33900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10526, '859955785156853', '5141413266', '699', NULL, '', '1.00', '350.00', '320', '350.00', '0.00', '', NULL, '0', '33900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10527, '971758573864792', '5141413266', '694', NULL, '', '1.00', '150.00', '130', '150.00', '0.00', '', NULL, '0', '33900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10528, '175296537293724', '5141413266', '481', NULL, '', '1.00', '50.00', '78.6111', '50.00', '0.00', '', NULL, '0', '33900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10529, '951216781824293', '5141413266', '884', NULL, '', '2.00', '500.00', '462.75', '1000.00', '0.00', '', NULL, '0', '33900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10530, '128767734183942', '5141413266', '372', NULL, '', '17.00', '70.00', '40', '1190.00', '0.00', '', NULL, '0', '33900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10531, '331485233615275', '5141413266', '448', NULL, '', '1.00', '150.00', '120', '150.00', '0.00', '', NULL, '0', '33900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10532, '736798364312612', '5141413266', '1066', NULL, '', '3.00', '450.00', '280', '1350.00', '0.00', '', NULL, '0', '33900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10533, '529748628468334', '5141413266', '140', NULL, '', '1.00', '3500.00', '2938.1', '3500.00', '0.00', '', NULL, '0', '33900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10534, '884595185538395', '5141413266', '715', NULL, '', '6.00', '120.00', '120', '720.00', '0.00', '', NULL, '0', '33900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10535, '483991494296722', '5141413266', '283', NULL, '', '2.00', '50.00', '30', '100.00', '0.00', '', NULL, '0', '33900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10536, '834286933121647', '5141413266', '784', NULL, '', '1.00', '200.00', '135', '200.00', '0.00', '', NULL, '0', '33900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10537, '298122489961892', '5141413266', '1000', NULL, '', '3.00', '200.00', '140', '600.00', '0.00', '', NULL, '0', '33900.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10538, '239291561658342', '4629916718', '17', NULL, '', '50.00', '200.00', '180', '10000.00', '0.00', '', NULL, '0', '1437806.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10539, '567721485721651', '4629916718', '1076', NULL, '', '6.00', '240.00', '192', '1440.00', '0.00', '', NULL, '0', '1437806.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10540, '751724619115597', '4629916718', '1077', NULL, '', '6.00', '180.00', '98', '1080.00', '0.00', '', NULL, '0', '1437806.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10541, '625227296438291', '9233426983', '323', NULL, '', '10.00', '6825.00', '4134', '68250.00', '0.00', '', NULL, '0', '985359.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10542, '678158831964393', '9233426983', '1258', NULL, '', '10.00', '6825.00', '4155', '68250.00', '0.00', '', NULL, '0', '985359.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10543, '877582686112187', '9233426983', '1262', NULL, '', '5.00', '14755.00', '8841', '73775.00', '0.00', '', NULL, '0', '985359.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10544, '398518664895232', '9233426983', '1261', NULL, '', '5.00', '14755.00', '8841', '73775.00', '0.00', '', NULL, '0', '985359.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10545, '824734199445291', '3543812978', '323', NULL, '', '10.00', '4350.00', '4134', '43500.00', '0.00', '', NULL, '0', '2721576.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10546, '416522566299998', '3543812978', '299', NULL, '', '2.00', '4350.00', '4134', '8700.00', '0.00', '', NULL, '0', '2721576.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10547, '742145249679888', '3543812978', '1258', NULL, '', '8.00', '4350.00', '4155', '34800.00', '0.00', '', NULL, '0', '2721576.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10548, '257111164581337', '3543812978', '1262', NULL, '', '3.00', '9300.00', '8841', '27900.00', '0.00', '', NULL, '0', '2721576.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10549, '766826934563464', '3543812978', '1261', NULL, '', '2.00', '9300.00', '8841', '18600.00', '0.00', '', NULL, '0', '2721576.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10550, '721779554271333', '3543812978', '961', NULL, '', '1.00', '2100.00', '2050', '2100.00', '0.00', '', NULL, '0', '2721576.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10551, '581735846969447', '3543812978', '718', NULL, '', '6.00', '240.00', '220', '1440.00', '0.00', '', NULL, '0', '2721576.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10644, '392494111321486', '9815267139', '1285', NULL, '', '8.00', '35.00', '30', '280.00', '0.00', '', '0.00', '0', '126840.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10643, '293523864512611', '9815267139', '100', NULL, '', '1.00', '360.00', '300', '360.00', '0.00', '', '0.00', '0', '126840.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10605, '593177811284814', '1712444644', '98', NULL, '', '0.00', '0.00', '850', '0.00', '0.00', '', '0.00', '0', '14900.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10555, '799926117675214', '4751468166', '67', NULL, '', '1.00', '2850.00', '2583.33', '2850.00', '0.00', '', NULL, '0', '17990.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10556, '944869787488786', '4751468166', '19', NULL, '', '2.00', '80.00', '70', '160.00', '0.00', '', NULL, '0', '17990.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10557, '476537932595814', '4751468166', '955', NULL, '', '4.00', '20.00', '20', '80.00', '0.00', '', NULL, '0', '17990.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10624, '666958946521555', '9112277419', '1337', NULL, '', '25.00', '140.00', '130', '3500.00', '0.00', '', '0.00', '0', '36380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10623, '658135794654979', '9112277419', '727', NULL, '', '3.00', '4800.00', '4800', '14400.00', '0.00', '', '0.00', '0', '36380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10622, '969631463342569', '9112277419', '481', NULL, '', '3.00', '70.00', '78.6111', '210.00', '0.00', '', '0.00', '0', '36380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10621, '514341541198362', '9112277419', '1201', NULL, '', '1.00', '850.00', '600', '850.00', '0.00', '', '0.00', '0', '36380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10620, '785657239142385', '9112277419', '920', NULL, '', '6.00', '40.00', '20', '240.00', '0.00', '', '0.00', '0', '36380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10619, '768761881189279', '9112277419', '272', NULL, '', '2.00', '480.00', '220', '960.00', '0.00', '', '0.00', '0', '36380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10618, '595246415338639', '9112277419', '283', NULL, '', '18.00', '70.00', '30', '1260.00', '0.00', '', '0.00', '0', '36380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10617, '617333836296384', '9112277419', '448', NULL, '', '1.00', '150.00', '120', '150.00', '0.00', '', '0.00', '0', '36380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10616, '944117519881758', '9112277419', '45', NULL, '', '6.00', '300.00', '180', '1800.00', '0.00', '', '0.00', '0', '36380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10615, '184828543833366', '9112277419', '49', NULL, '', '3.00', '250.00', '160', '750.00', '0.00', '', '0.00', '0', '36380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10614, '271991298515491', '9112277419', '215', NULL, '', '1.00', '150.00', '150', '150.00', '0.00', '', '0.00', '0', '36380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10613, '814883996371429', '9112277419', '686', NULL, '', '4.00', '290.00', '250', '1160.00', '0.00', '', '0.00', '0', '36380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10612, '157788144183356', '9112277419', '886', NULL, '', '1.00', '350.00', '284', '350.00', '0.00', '', '0.00', '0', '36380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10611, '863525588485239', '9112277419', '884', NULL, '', '1.00', '500.00', '462.75', '500.00', '0.00', '', '0.00', '0', '36380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10610, '916587937591112', '9112277419', '833', NULL, '', '1.00', '50.00', '25', '50.00', '0.00', '', '0.00', '0', '36380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10609, '777256422844813', '9112277419', '830', NULL, '', '1.00', '150.00', '87.5', '150.00', '0.00', '', '0.00', '0', '36380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10608, '687287846343159', '9112277419', '104', NULL, '', '1.00', '300.00', '300', '300.00', '0.00', '', '0.00', '0', '36380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10607, '818395482536868', '9112277419', '664', NULL, '', '2.00', '2400.00', '2292', '4800.00', '0.00', '', '0.00', '0', '36380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10606, '938211297584187', '9112277419', '663', NULL, '', '2.00', '2400.00', '2292', '4800.00', '0.00', '', '0.00', '0', '36380.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10577, '123115648339443', '4525769244', '68', NULL, '', '1.00', '2300.00', '2583.33', '2300.00', '0.00', '', NULL, '0', '43920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10578, '197278841654353', '4525769244', '67', NULL, '', '1.00', '2300.00', '2583.33', '2300.00', '0.00', '', NULL, '0', '43920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10579, '554532345926364', '4525769244', '837', NULL, '', '4.00', '90.00', '70', '360.00', '0.00', '', NULL, '0', '43920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10580, '343296244714682', '4525769244', '152', NULL, '', '1.00', '1800.00', '1557', '1800.00', '0.00', '', NULL, '0', '43920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10581, '815789547885254', '4525769244', '59215232', NULL, '', '1.00', '3500.00', '3500', '3500.00', '0.00', '', NULL, '0', '43920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10582, '798258985281943', '4525769244', '378', NULL, '', '1.00', '30.00', '20', '30.00', '0.00', '', NULL, '0', '43920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10583, '316551247415947', '4525769244', '27', NULL, '', '1.00', '60.00', '33', '60.00', '0.00', '', NULL, '0', '43920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10584, '411124342524757', '4525769244', '284', NULL, '', '1.00', '70.00', '33.5', '70.00', '0.00', '', NULL, '0', '43920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10585, '592757534136271', '4525769244', '1180', NULL, '', '1.00', '350.00', '281', '350.00', '0.00', '', NULL, '0', '43920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10586, '973827511418623', '4525769244', '808', NULL, '', '12.00', '280.00', '255', '3360.00', '0.00', '', NULL, '0', '43920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10587, '357776842676679', '4525769244', '1246', NULL, '', '1.00', '300.00', '185', '300.00', '0.00', '', NULL, '0', '43920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10588, '831244579796595', '4525769244', '772', NULL, '', '2.00', '50.00', '30', '100.00', '0.00', '', NULL, '0', '43920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10589, '772594322665185', '4525769244', '858', NULL, '', '1.00', '150.00', '115', '150.00', '0.00', '', NULL, '0', '43920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10590, '424459193619195', '4525769244', '378', NULL, '', '1.00', '50.00', '20', '50.00', '0.00', '', NULL, '0', '43920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10591, '139186442397838', '4525769244', '966', NULL, '', '1.00', '3200.00', '3000', '3200.00', '0.00', '', NULL, '0', '43920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10592, '117599339174612', '4525769244', '963', NULL, '', '1.00', '2300.00', '2500', '2300.00', '0.00', '', NULL, '0', '43920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10593, '553663658532317', '4525769244', '187', NULL, '', '1.00', '7500.00', '6500', '7500.00', '0.00', '', NULL, '0', '43920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10594, '488983777867963', '4525769244', '57', NULL, '', '1.00', '120.00', '140', '120.00', '0.00', '', NULL, '0', '43920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10595, '898618571153957', '4525769244', '1331', NULL, '', '5.00', '550.00', '500', '2750.00', '0.00', '', NULL, '0', '43920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10596, '498417289584347', '4525769244', '1330', NULL, '', '5.00', '450.00', '450', '2250.00', '0.00', '', NULL, '0', '43920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10597, '438399965312891', '4525769244', '1333', NULL, '', '2.00', '200.00', '110', '400.00', '0.00', '', NULL, '0', '43920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10598, '674693683824867', '4525769244', '1334', NULL, '', '3.00', '300.00', '200', '900.00', '0.00', '', NULL, '0', '43920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10599, '259358429872966', '4525769244', '1332', NULL, '', '3.00', '280.00', '240', '840.00', '0.00', '', NULL, '0', '43920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10600, '515632762245333', '4525769244', '1335', NULL, '', '10.00', '200.00', '150', '2000.00', '0.00', '', NULL, '0', '43920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10601, '162838832244894', '4525769244', '1274', NULL, '', '18.00', '120.00', '107', '2160.00', '0.00', '', NULL, '0', '43920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10602, '959521669561952', '4525769244', '1272', NULL, '', '18.00', '105.00', '94', '1890.00', '0.00', '', NULL, '0', '43920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10603, '626592973699378', '4525769244', '1270', NULL, '', '36.00', '80.00', '85', '2880.00', '0.00', '', NULL, '0', '43920.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10642, '213765885788795', '9815267139', '666', NULL, '', '1.00', '3400.00', '3208', '3400.00', '0.00', '', '0.00', '0', '126840.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10641, '321961495528147', '9815267139', '663', NULL, '', '1.00', '2400.00', '2292', '2400.00', '0.00', '', '0.00', '0', '126840.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10640, '428745674768756', '9815267139', '152', NULL, '', '1.00', '1900.00', '1557', '1900.00', '0.00', '', '0.00', '0', '126840.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10639, '652342438683396', '9815267139', '323', NULL, '', '1.00', '4400.00', '4134', '4400.00', '0.00', '', '0.00', '0', '126840.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10638, '151477993856127', '9815267139', '1258', NULL, '', '1.00', '4400.00', '4155', '4400.00', '0.00', '', '0.00', '0', '126840.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10637, '975918853364841', '9815267139', '715', NULL, '', '2.00', '125.00', '120', '250.00', '0.00', '', '0.00', '0', '126840.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10636, '767699272719687', '9815267139', '129', NULL, '', '1.00', '250.00', '275', '250.00', '0.00', '', '0.00', '0', '126840.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10635, '738767541329533', '9815267139', '1166', NULL, '', '1.00', '100.00', '70', '100.00', '0.00', '', '0.00', '0', '126840.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10645, '926856641283579', '9815267139', '1338', NULL, '', '1.00', '100.00', '90', '100.00', '0.00', '', '0.00', '0', '126840.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10646, '847277171676538', '8532293273', '1261', NULL, '', '1.00', '9300.00', '8841', '9300.00', '0.00', '', NULL, '0', '1486456.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10647, '649831358646333', '8532293273', '301', NULL, '', '3.00', '12500.00', '11850', '37500.00', '0.00', '', NULL, '0', '1486456.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10648, '613771268553746', '8532293273', '269', NULL, '', '12.00', '125.00', '110', '1500.00', '0.00', '', NULL, '0', '1486456.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10649, '991133632835268', '8532293273', '1094', NULL, '', '1.00', '350.00', '280', '350.00', '0.00', '', NULL, '0', '1486456.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10650, '652758597816811', '9827253319', '1084', NULL, '', '112.00', '175.00', '149', '19600.00', '0.00', '', NULL, '0', '1506056.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10706, '936518384356464', '6261171199', '1350', NULL, '', '6.00', '50.00', '34', '300.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10705, '292978369776557', '6261171199', '1047', NULL, '', '1.00', '20.00', '24', '20.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10704, '275252893927972', '6261171199', '837', NULL, '', '6.00', '80.00', '70', '480.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10703, '737642776383558', '6261171199', '713', NULL, '', '1.00', '350.00', '310', '350.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10702, '272885925359347', '6261171199', '665', NULL, '', '2.00', '3350.00', '3208', '6700.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10701, '889433634618788', '6261171199', '666', NULL, '', '2.00', '3350.00', '3208', '6700.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10700, '645868677748263', '6261171199', '1044', NULL, '', '3.00', '35.00', '25', '105.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10699, '111343328119913', '6261171199', '714', NULL, '', '1.00', '495.00', '325', '495.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10698, '779499237267679', '6261171199', '19', NULL, '', '20.00', '100.00', '70', '2000.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10697, '593738882187913', '6261171199', '1251', NULL, '', '0.50', '400.00', '500', '200.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10696, '278144619312847', '6261171199', '1011', NULL, '', '6.00', '20.00', '11', '120.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10695, '797896172599652', '6261171199', '31', NULL, '', '2.00', '240.00', '916', '480.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10694, '986845999887992', '6261171199', '1077', NULL, '', '1.00', '240.00', '98', '240.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10693, '413463989495995', '6261171199', '32', NULL, '', '1.00', '180.00', '411', '180.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10692, '667651884253845', '6261171199', '722', NULL, '', '2.00', '300.00', '264', '600.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10691, '627531673274276', '6261171199', '422', NULL, '', '18.00', '50.00', '30', '900.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10690, '718696989161463', '6261171199', '921', NULL, '', '10.00', '60.00', '50', '600.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10689, '166118346384888', '6261171199', '143', NULL, '', '3.00', '6200.00', '6098.6', '18600.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10688, '363618885653196', '6261171199', '137', NULL, '', '1.00', '3100.00', '2938.1', '3100.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10687, '789853862362175', '6261171199', '138', NULL, '', '3.00', '3100.00', '2938.1', '9300.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10686, '547232788852182', '6261171199', '481', NULL, '', '1.00', '50.00', '78.6111', '50.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10685, '651311744443586', '6261171199', '839', NULL, '', '3.00', '30.00', '14', '90.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10684, '492483579831336', '6261171199', '840', NULL, '', '2.00', '50.00', '20', '100.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10683, '122385631937952', '6261171199', '57', NULL, '', '4.00', '150.00', '140', '600.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10682, '419444217849227', '6261171199', '102', NULL, '', '1.00', '600.00', '450.667', '600.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10681, '942789468687736', '6261171199', '964', NULL, '', '1.00', '6000.00', '5000', '6000.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10680, '258366192315148', '6261171199', '969', NULL, '', '1.00', '2400.00', '2100', '2400.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10679, '133378948244794', '6261171199', '1033', NULL, '', '1.00', '2000.00', '2300', '2000.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10707, '963124561323551', '6261171199', '1013', NULL, '', '28.00', '20.00', '16', '560.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10708, '521738251617724', '6261171199', '955', NULL, '', '2.00', '20.00', '20', '40.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10709, '142895196943448', '6261171199', '1351', NULL, '', '6.00', '20.00', '16', '120.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10710, '371816135479615', '6261171199', '1076', NULL, '', '1.00', '240.00', '192', '240.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10711, '789946876437345', '6261171199', '584', NULL, '', '1.00', '3000.00', '2600', '3000.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10712, '746712832878946', '6261171199', '137', NULL, '', '2.00', '3250.00', '2938.1', '6500.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10713, '289175484142926', '6261171199', '143', NULL, '', '1.00', '6500.00', '6098.6', '6500.00', '0.00', '', '0.00', '0', '80270.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10714, '791432877626412', '9163299722', '728', NULL, '', '2.00', '280.00', '260', '560.00', '0.00', '', NULL, '0', '81115.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10715, '928167537756338', '9163299722', '263', NULL, '', '1.00', '350.00', '350', '350.00', '0.00', '', NULL, '0', '81115.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10716, '275263388671515', '9163299722', '261', NULL, '', '5.00', '550.00', '600', '2750.00', '0.00', '', NULL, '0', '81115.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10717, '199922744598982', '9163299722', '811', NULL, '', '10.00', '105.00', '103', '1050.00', '0.00', '', NULL, '0', '81115.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10718, '493891542988985', '9163299722', '866', NULL, '', '10.00', '120.00', '120', '1200.00', '0.00', '', NULL, '0', '81115.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10719, '331769843121796', '9163299722', '8', NULL, '', '4.00', '500.00', '550', '2000.00', '0.00', '', NULL, '0', '81115.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10720, '311537711753111', '9163299722', '17', NULL, '', '34.00', '180.00', '180', '6120.00', '0.00', '', NULL, '0', '81115.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10721, '343519368328265', '9163299722', '1329', NULL, '', '1.00', '350.00', '375', '350.00', '0.00', '', NULL, '0', '81115.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10722, '372133476936561', '9163299722', '490', NULL, '', '1.00', '150.00', '85', '150.00', '0.00', '', NULL, '0', '81115.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10723, '262948965293686', '9163299722', '1041', NULL, '', '10.00', '30.00', '25', '300.00', '0.00', '', NULL, '0', '81115.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10724, '751771283641424', '1223415297', '728', NULL, '', '2.00', '280.00', '260', '560.00', '0.00', '', NULL, '0', '81115.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10725, '299496214538674', '1223415297', '263', NULL, '', '1.00', '350.00', '350', '350.00', '0.00', '', NULL, '0', '81115.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10726, '799861862169434', '1223415297', '261', NULL, '', '5.00', '550.00', '600', '2750.00', '0.00', '', NULL, '0', '81115.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10727, '684725655935174', '1223415297', '811', NULL, '', '10.00', '105.00', '103', '1050.00', '0.00', '', NULL, '0', '81115.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10728, '484758839814265', '1223415297', '866', NULL, '', '10.00', '120.00', '120', '1200.00', '0.00', '', NULL, '0', '81115.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10729, '344893928182272', '1223415297', '8', NULL, '', '4.00', '500.00', '550', '2000.00', '0.00', '', NULL, '0', '81115.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10730, '869781814398811', '1223415297', '17', NULL, '', '34.00', '180.00', '180', '6120.00', '0.00', '', NULL, '0', '81115.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10731, '355576371756669', '1223415297', '1329', NULL, '', '1.00', '350.00', '375', '350.00', '0.00', '', NULL, '0', '81115.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10732, '247237198163536', '1223415297', '490', NULL, '', '1.00', '150.00', '85', '150.00', '0.00', '', NULL, '0', '81115.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10733, '962195195635646', '1223415297', '1041', NULL, '', '10.00', '30.00', '25', '300.00', '0.00', '', NULL, '0', '81115.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10835, '795169351266565', '4745111666', '1029', NULL, '', '1.00', '1000.00', '912.5', '1000.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10834, '237438346136258', '4745111666', '1139', NULL, '', '1.00', '50.00', '40', '50.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10833, '866259416717762', '4745111666', '903', NULL, '', '4.00', '45.00', '40', '180.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10832, '219154648645467', '4745111666', '381', NULL, '', '10.00', '50.00', '34', '500.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10831, '813159415432696', '4745111666', '1372', NULL, '', '1.00', '9000.00', '11000', '9000.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10830, '383352416635351', '4745111666', '54', NULL, '', '10.00', '320.00', '255', '3200.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10829, '428181623529322', '4745111666', '1292', NULL, '', '24.00', '650.00', '600', '15600.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10828, '625771283943561', '4745111666', '276', NULL, '', '1.00', '150.00', '180', '150.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10827, '859127619825554', '4745111666', '221', NULL, '', '1.00', '700.00', '475', '700.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10826, '754582661358634', '4745111666', '1032', NULL, '', '1.00', '1450.00', '1400', '1450.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10825, '489972546952829', '4745111666', '1130', NULL, '', '1.00', '1550.00', '1750', '1550.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10824, '647225379639297', '4745111666', '730', NULL, '', '36.00', '160.00', '147.667', '5760.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10823, '862651897134212', '4745111666', '370', NULL, '', '2.00', '25.00', '22', '50.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10822, '874314791768274', '4745111666', '496', NULL, '', '4.00', '50.00', '38', '200.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10821, '335687811691119', '4745111666', '694', NULL, '', '4.00', '150.00', '130', '600.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10820, '722178237623377', '4745111666', '835', NULL, '', '2.00', '50.00', '50', '100.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10819, '744198757242281', '4745111666', '218', NULL, '', '1.00', '200.00', '160', '200.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10818, '258994784856779', '4745111666', '600', NULL, '', '3.00', '50.00', '160.667', '150.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10817, '246893479941274', '4745111666', '263', NULL, '', '1.00', '450.00', '350', '450.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10816, '599218597881369', '4745111666', '1022', NULL, '', '4.00', '850.00', '780', '3400.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10815, '642661129539429', '4745111666', '247', NULL, '', '2.00', '800.00', '665', '1600.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10814, '442668658234798', '4745111666', '775', NULL, '', '1.00', '50.00', '30', '50.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10813, '652873356146417', '4745111666', '379', NULL, '', '1.00', '50.00', '25', '50.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10812, '231937767647373', '4745111666', '1139', NULL, '', '6.00', '50.00', '40', '300.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10811, '161564818635544', '4745111666', '102', NULL, '', '1.00', '600.00', '450.667', '600.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10810, '873863324964762', '4745111666', '441', NULL, '', '3.00', '350.00', '275', '1050.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10809, '214856852445537', '4745111666', '222', NULL, '', '3.00', '250.00', '230', '750.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10808, '971618915934827', '4745111666', '261', NULL, '', '1.00', '650.00', '600', '650.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10807, '487321465612284', '4745111666', '714', NULL, '', '1.00', '400.00', '325', '400.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10806, '722635547629584', '4745111666', '843', NULL, '', '4.00', '20.00', '13', '80.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10805, '153836683794772', '4745111666', '715', NULL, '', '12.00', '130.00', '120', '1560.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10804, '114362462676164', '4745111666', '1190', NULL, '', '10.00', '20.00', '17.5', '200.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10803, '952851611333415', '4745111666', '1272', NULL, '', '2.00', '120.00', '94', '240.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10802, '136518772238941', '4745111666', '1274', NULL, '', '2.00', '150.00', '107', '300.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10801, '683898557989478', '4745111666', '137', NULL, '', '1.00', '3000.00', '2938.1', '3000.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10800, '581721327748137', '4745111666', '378', NULL, '', '1.00', '40.00', '20', '40.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10799, '141218695159946', '4745111666', '713', NULL, '', '3.00', '350.00', '310', '1050.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10798, '224568677271343', '4745111666', '381', NULL, '', '3.00', '40.00', '34', '120.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10797, '694423329882883', '4745111666', '811', NULL, '', '5.00', '110.00', '103', '550.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10796, '842975954638836', '4745111666', '57', NULL, '', '1.00', '150.00', '140', '150.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10795, '423326818721714', '4745111666', '1043', NULL, '', '2.00', '25.00', '20', '50.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10794, '635429773439189', '4745111666', '481', NULL, '', '2.00', '50.00', '78.6111', '100.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10793, '427999446533816', '4745111666', '1162', NULL, '', '1.00', '19500.00', '17533', '19500.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10792, '497184439657539', '4745111666', '1365', NULL, '', '1.00', '5000.00', '4000', '5000.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10791, '522764791443819', '4745111666', '820', NULL, '', '6.00', '490.00', '400', '2940.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10790, '453527181682148', '4745111666', '1011', NULL, '', '6.00', '20.00', '11', '120.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10789, '578987892277175', '4745111666', '32', NULL, '', '1.00', '90.00', '411', '90.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10788, '243999495695787', '4745111666', '794', NULL, '', '10.00', '150.00', '140', '1500.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10787, '881316335476563', '4745111666', '1033', NULL, '', '3.00', '2600.00', '2300', '7800.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10786, '768393511694242', '4745111666', '8', NULL, '', '1.00', '530.00', '550', '530.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10785, '348526694512248', '4745111666', '17', NULL, '', '5.00', '180.00', '180', '900.00', '0.00', '', '0.00', '0', '95560.00', 0);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10836, '533965842436636', '9131447689', '715', NULL, '', '25.00', '120.00', '120', '3000.00', '0.00', '', NULL, '0', '9810.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10837, '444974696376761', '9131447689', '666', NULL, '', '1.00', '3400.00', '3208', '3400.00', '0.00', '', NULL, '0', '9810.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10838, '129928255232272', '9131447689', '837', NULL, '', '10.00', '90.00', '70', '900.00', '0.00', '', NULL, '0', '9810.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10839, '759832992741757', '9131447689', '904', NULL, '', '1.00', '40.00', '3', '40.00', '0.00', '', NULL, '0', '9810.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10840, '826183125369674', '9131447689', '713', NULL, '', '2.00', '350.00', '310', '700.00', '0.00', '', NULL, '0', '9810.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10841, '451345897288496', '9131447689', '715', NULL, '', '6.00', '120.00', '120', '720.00', '0.00', '', NULL, '0', '9810.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10842, '172378267344784', '9131447689', '1246', NULL, '', '2.00', '300.00', '185', '600.00', '0.00', '', NULL, '0', '9810.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10843, '685245285978461', '9131447689', '1095', NULL, '', '1.00', '300.00', '280', '300.00', '0.00', '', NULL, '0', '9810.00', 1);
INSERT INTO `invoice_details` (`id`, `invoice_details_id`, `invoice_id`, `product_id`, `serial_no`, `description`, `quantity`, `rate`, `supplier_rate`, `total_price`, `discount`, `discount_per`, `tax`, `paid_amount`, `due_amount`, `status`) VALUES (10844, '479575319781539', '9131447689', '773', NULL, '', '1.00', '150.00', '80', '150.00', '0.00', '', NULL, '0', '9810.00', 1);


#
# TABLE STRUCTURE FOR: language
#

DROP TABLE IF EXISTS `language`;

CREATE TABLE `language` (
  `id` int unsigned NOT NULL AUTO_INCREMENT,
  `phrase` text NOT NULL,
  `english` text,
  `bangla` text,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=919 DEFAULT CHARSET=utf8mb3;

INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (1, 'user_profile', 'User Profile', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (2, 'setting', 'Setting', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (3, 'language', 'Language', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (4, 'manage_users', 'Manage Users', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (5, 'add_user', 'Add User', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (6, 'manage_company', 'Manage Company', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (7, 'web_settings', 'Software Settings', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (8, 'manage_accounts', 'Manage Accounts', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (9, 'create_accounts', 'Create Account', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (10, 'manage_bank', 'Manage Bank', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (11, 'add_new_bank', 'Add New Bank', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (12, 'settings', 'Settings', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (13, 'closing_report', 'Closing Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (14, 'closing', 'Closing', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (15, 'cheque_manager', 'Cheque Manager', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (16, 'accounts_summary', 'Accounts Summary', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (17, 'expense', 'Expense', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (18, 'income', 'Income', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (19, 'accounts', 'Accounts', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (20, 'stock_report', 'Stock Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (21, 'stock', 'Stock', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (22, 'pos_invoice', 'POS Sale', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (23, 'manage_invoice', 'Manage Sale', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (24, 'new_invoice', 'New Sale', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (25, 'invoice', 'Sale', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (26, 'manage_purchase', 'Manage Purchase', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (27, 'add_purchase', 'Add Purchase', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (28, 'purchase', 'Purchase', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (29, 'paid_customer', 'Paid Customer', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (30, 'manage_customer', 'Manage Customer', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (31, 'add_customer', 'Add Customer', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (32, 'customer', 'Customer', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (33, 'supplier_payment_actual', 'Supplier Payment Ledger', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (34, 'supplier_sales_summary', 'Supplier Sales Summary', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (35, 'supplier_sales_details', 'Supplier Sales Details', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (36, 'supplier_ledger', 'Supplier Ledger', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (37, 'manage_supplier', 'Manage Supplier', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (38, 'add_supplier', 'Add Supplier', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (39, 'supplier', 'Supplier', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (40, 'product_statement', 'Product Statement', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (41, 'manage_product', 'Manage Product', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (42, 'add_product', 'Add Product', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (43, 'product', 'Product', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (44, 'manage_category', 'Manage Category', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (45, 'add_category', 'Add Category', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (46, 'category', 'Category', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (47, 'sales_report_product_wise', 'Sales Report (Product Wise)', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (48, 'purchase_report', 'Purchase Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (49, 'sales_report', 'Sales Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (50, 'todays_report', 'Todays Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (51, 'report', 'Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (52, 'dashboard', 'Dashboard', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (53, 'online', 'Online', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (54, 'logout', 'Logout', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (55, 'change_password', 'Change Password', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (56, 'total_purchase', 'Total Purchase', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (57, 'total_amount', 'Total Amount', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (58, 'supplier_name', 'Supplier Name', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (59, 'invoice_no', 'Invoice No', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (60, 'purchase_date', 'Purchase Date', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (61, 'todays_purchase_report', 'Todays Purchase Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (62, 'total_sales', 'Total Sales', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (63, 'customer_name', 'Customer Name', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (64, 'sales_date', 'Sales Date', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (65, 'todays_sales_report', 'Todays Sales Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (66, 'home', 'Home', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (67, 'todays_sales_and_purchase_report', 'Todays sales and purchase report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (68, 'total_ammount', 'Total Amount', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (69, 'rate', 'Rate', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (70, 'product_model', 'Product Model', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (71, 'product_name', 'Product Name', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (72, 'search', 'Search', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (73, 'end_date', 'End Date', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (74, 'start_date', 'Start Date', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (75, 'total_purchase_report', 'Total Purchase Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (76, 'total_sales_report', 'Total Sales Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (77, 'total_seles', 'Total Sales', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (78, 'all_stock_report', 'All Stock Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (79, 'search_by_product', 'Search By Product', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (80, 'date', 'Date', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (81, 'print', 'Print', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (82, 'stock_date', 'Stock Date', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (83, 'print_date', 'Print Date', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (84, 'sales', 'Sales', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (85, 'price', 'Price', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (86, 'sl', 'SL.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (87, 'add_new_category', 'Add new category', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (88, 'category_name', 'Category Name', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (89, 'save', 'Save', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (90, 'delete', 'Delete', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (91, 'update', 'Update', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (92, 'action', 'Action', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (93, 'manage_your_category', 'Manage your category ', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (94, 'category_edit', 'Category Edit', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (95, 'status', 'Status', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (96, 'active', 'Active', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (97, 'inactive', 'Inactive', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (98, 'save_changes', 'Save Changes', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (99, 'save_and_add_another', 'Save And Add Another', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (100, 'model', 'Model', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (101, 'supplier_price', 'Supplier Price', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (102, 'sell_price', 'Sale Price', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (103, 'image', 'Image', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (104, 'select_one', 'Select One', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (105, 'details', 'Details', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (106, 'new_product', 'New Product', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (107, 'add_new_product', 'Add new product', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (108, 'barcode', 'Barcode', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (109, 'qr_code', 'Qr-Code', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (110, 'product_details', 'Product Details', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (111, 'manage_your_product', 'Manage your product', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (112, 'product_edit', 'Product Edit', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (113, 'edit_your_product', 'Edit your product', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (114, 'cancel', 'Cancel', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (115, 'incl_vat', 'Incl. Vat', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (116, 'money', 'TK', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (117, 'grand_total', 'Grand Total', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (118, 'quantity', 'Qnty', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (119, 'product_report', 'Product Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (120, 'product_sales_and_purchase_report', 'Product sales and purchase report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (121, 'previous_stock', 'Previous Stock', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (122, 'out', 'Out', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (123, 'in', 'In', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (124, 'to', 'To', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (125, 'previous_balance', 'Previous Credit Balance', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (126, 'customer_address', 'Customer Address', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (127, 'customer_mobile', 'Customer Mobile', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (128, 'customer_email', 'Customer Email', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (129, 'add_new_customer', 'Add new customer', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (130, 'balance', 'Balance', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (131, 'mobile', 'Mobile', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (132, 'address', 'Address', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (133, 'manage_your_customer', 'Manage your customer', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (134, 'customer_edit', 'Customer Edit', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (135, 'paid_customer_list', 'Paid Customer List', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (136, 'ammount', 'Amount', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (137, 'customer_ledger', 'Customer Ledger', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (138, 'manage_customer_ledger', 'Manage Customer Ledger', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (139, 'customer_information', 'Customer Information', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (140, 'debit_ammount', 'Debit Amount', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (141, 'credit_ammount', 'Credit Amount', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (142, 'balance_ammount', 'Balance Amount', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (143, 'receipt_no', 'Receipt NO', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (144, 'description', 'Description', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (145, 'debit', 'Debit', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (146, 'credit', 'Credit', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (147, 'item_information', 'Item Information', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (148, 'total', 'Total', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (149, 'please_select_supplier', 'Please Select Supplier', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (150, 'submit', 'Submit', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (151, 'submit_and_add_another', 'Submit And Add Another One', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (152, 'add_new_item', 'Add New Item', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (153, 'manage_your_purchase', 'Manage your purchase', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (154, 'purchase_edit', 'Purchase Edit', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (155, 'purchase_ledger', 'Purchase Ledger', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (156, 'invoice_information', 'Sale Information', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (157, 'paid_ammount', 'Paid Amount', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (158, 'discount', 'Dis./Pcs.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (159, 'save_and_paid', 'Save And Paid', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (160, 'payee_name', 'Payee Name', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (161, 'manage_your_invoice', 'Manage your Sale', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (162, 'invoice_edit', 'Sale Edit', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (163, 'new_pos_invoice', 'New POS Sale', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (164, 'add_new_pos_invoice', 'Add new pos Sale', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (165, 'product_id', 'Product ID', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (166, 'paid_amount', 'Paid Amount', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (167, 'authorised_by', 'Authorised By', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (168, 'checked_by', 'Checked By', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (169, 'received_by', 'Received By', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (170, 'prepared_by', 'Prepared By', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (171, 'memo_no', 'Memo No', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (172, 'website', 'Website', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (173, 'email', 'Email', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (174, 'invoice_details', 'Sale Details', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (175, 'reset', 'Reset', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (176, 'payment_account', 'Payment Account', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (177, 'bank_name', 'Bank Name', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (178, 'cheque_or_pay_order_no', 'Cheque/Pay Order No', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (179, 'payment_type', 'Payment Type', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (180, 'payment_from', 'Payment From', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (181, 'payment_date', 'Payment Date', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (182, 'add_income', 'Add Income', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (183, 'cash', 'Cash', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (184, 'cheque', 'Cheque', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (185, 'pay_order', 'Pay Order', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (186, 'payment_to', 'Payment To', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (187, 'total_outflow_ammount', 'Total Expense Amount', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (188, 'transections', 'Transections', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (189, 'accounts_name', 'Accounts Name', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (190, 'outflow_report', 'Expense Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (191, 'inflow_report', 'Income Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (192, 'all', 'All', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (193, 'account', 'Account', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (194, 'from', 'From', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (195, 'account_summary_report', 'Account Summary Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (196, 'search_by_date', 'Search By Date', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (197, 'cheque_no', 'Cheque No', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (198, 'name', 'Name', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (199, 'closing_account', 'Closing Account', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (200, 'close_your_account', 'Close your account', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (201, 'last_day_closing', 'Last Day Closing', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (202, 'cash_in', 'Cash In', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (203, 'cash_out', 'Cash Out', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (204, 'cash_in_hand', 'Cash In Hand', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (205, 'add_new_bank', 'Add New Bank', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (206, 'day_closing', 'Day Closing', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (207, 'account_closing_report', 'Account Closing Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (208, 'last_day_ammount', 'Last Day Amount', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (209, 'adjustment', 'Adjustment', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (210, 'pay_type', 'Pay Type', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (211, 'customer_or_supplier', 'Customer,Supplier Or Others', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (212, 'transection_id', 'Transections ID', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (213, 'accounts_summary_report', 'Accounts Summary Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (214, 'bank_list', 'Bank List', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (215, 'bank_edit', 'Bank Edit', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (216, 'debit_plus', 'Debit (+)', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (217, 'credit_minus', 'Credit (-)', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (218, 'account_name', 'Account Name', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (219, 'account_type', 'Account Type', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (220, 'account_real_name', 'Account Real Name', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (221, 'manage_account', 'Manage Account', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (222, 'company_name', 'Niha International', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (223, 'edit_your_company_information', 'Edit your company information', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (224, 'company_edit', 'Company Edit', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (225, 'admin', 'Admin', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (226, 'user', 'User', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (227, 'password', 'Password', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (228, 'last_name', 'Last Name', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (229, 'first_name', 'First Name', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (230, 'add_new_user_information', 'Add new user information', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (231, 'user_type', 'User Type', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (232, 'user_edit', 'User Edit', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (233, 'rtr', 'RTR', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (234, 'ltr', 'LTR', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (235, 'ltr_or_rtr', 'LTR/RTR', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (236, 'footer_text', 'Footer Text', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (237, 'favicon', 'Favicon', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (238, 'logo', 'Logo', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (239, 'update_setting', 'Update Setting', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (240, 'update_your_web_setting', 'Update your web setting', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (241, 'login', 'Login', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (242, 'your_strong_password', 'Your strong password', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (243, 'your_unique_email', 'Your unique email', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (244, 'please_enter_your_login_information', 'Please enter your login information.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (245, 'update_profile', 'Update Profile', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (246, 'your_profile', 'Your Profile', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (247, 're_type_password', 'Re-Type Password', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (248, 'new_password', 'New Password', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (249, 'old_password', 'Old Password', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (250, 'new_information', 'New Information', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (251, 'old_information', 'Old Information', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (252, 'change_your_information', 'Change your information', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (253, 'change_your_profile', 'Change your profile', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (254, 'profile', 'Profile', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (255, 'wrong_username_or_password', 'Wrong User Name Or Password !', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (256, 'successfully_updated', 'Successfully Updated.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (257, 'blank_field_does_not_accept', 'Blank Field Does Not Accept !', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (258, 'successfully_changed_password', 'Successfully changed password.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (259, 'you_are_not_authorised_person', 'You are not authorised person !', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (260, 'password_and_repassword_does_not_match', 'Passwor and re-password does not match !', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (261, 'new_password_at_least_six_character', 'New Password At Least 6 Character.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (262, 'you_put_wrong_email_address', 'You put wrong email address !', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (263, 'cheque_ammount_asjusted', 'Cheque amount adjusted.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (264, 'successfully_payment_paid', 'Successfully Payment Paid.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (265, 'successfully_added', 'Successfully Added.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (266, 'successfully_updated_2_closing_ammount_not_changeale', 'Successfully Updated -2. Note: Closing Amount Not Changeable.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (267, 'successfully_payment_received', 'Successfully Payment Received.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (268, 'already_inserted', 'Already Inserted !', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (269, 'successfully_delete', 'Successfully Delete.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (270, 'successfully_created', 'Successfully Created.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (271, 'logo_not_uploaded', 'Logo not uploaded !', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (272, 'favicon_not_uploaded', 'Favicon not uploaded !', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (273, 'supplier_mobile', 'Supplier Mobile', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (274, 'supplier_address', 'Supplier Address', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (275, 'supplier_details', 'Supplier Details', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (276, 'add_new_supplier', 'Add New Supplier', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (277, 'manage_suppiler', 'Manage Supplier', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (278, 'manage_your_supplier', 'Manage your supplier', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (279, 'manage_supplier_ledger', 'Manage supplier ledger', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (280, 'invoice_id', 'Invoice ID', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (281, 'deposite_id', 'Deposite ID', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (282, 'supplier_actual_ledger', 'Supplier Payment Ledger', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (283, 'supplier_information', 'Supplier Information', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (284, 'event', 'Event', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (285, 'add_new_income', 'Add New Income', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (286, 'add_expese', 'Add Expense', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (287, 'add_new_expense', 'Add New Expense', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (288, 'total_inflow_ammount', 'Total Income Amount', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (289, 'create_new_invoice', 'Create New Sale', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (290, 'create_pos_invoice', 'Create POS Sale', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (291, 'total_profit', 'Total Profit', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (292, 'monthly_progress_report', 'Monthly Progress Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (293, 'total_invoice', 'Total Sale', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (294, 'account_summary', 'Account Summary', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (295, 'total_supplier', 'Total Supplier', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (296, 'total_product', 'Total Product', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (297, 'total_customer', 'Total Customer', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (298, 'supplier_edit', 'Supplier Edit', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (299, 'add_new_invoice', 'Add New Sale', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (300, 'add_new_purchase', 'Add new purchase', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (301, 'currency', 'Currency', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (302, 'currency_position', 'Currency Position', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (303, 'left', 'Left', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (304, 'right', 'Right', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (305, 'add_tax', 'Add Tax', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (306, 'manage_tax', 'Manage Tax', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (307, 'add_new_tax', 'Add new tax', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (308, 'enter_tax', 'Enter Tax', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (309, 'already_exists', 'Already Exists !', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (310, 'successfully_inserted', 'Successfully Inserted.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (311, 'tax', 'Tax', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (312, 'tax_edit', 'Tax Edit', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (313, 'product_not_added', 'Product not added !', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (314, 'total_tax', 'Total Tax', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (315, 'manage_your_supplier_details', 'Manage your supplier details.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (316, 'invoice_description', 'Lorem Ipsum is sim ply dummy Lorem Ipsum is simply dummy Lorem Ipsum is simply dummy Lorem Ipsum is simply dummy Lorem Ipsum is simply dummy Lorem Ipsum is sim ply dummy Lorem Ipsum is simply dummy Lorem Ipsum is simply dummy Lorem Ipsum is simply dummy Lorem Ipsum is simply dummy', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (317, 'thank_you_for_choosing_us', 'Thank you very much for choosing us.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (318, 'billing_date', 'Billing Date', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (319, 'billing_to', 'Billing To', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (320, 'billing_from', 'Billing From', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (321, 'you_cant_delete_this_product', 'Sorry !!  You can\'t delete this product.This product already used in calculation system!', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (322, 'old_customer', 'Old Customer', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (323, 'new_customer', 'New Customer', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (324, 'new_supplier', 'New Supplier', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (325, 'old_supplier', 'Old Supplier', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (326, 'credit_customer', 'Credit Customer', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (327, 'account_already_exists', 'This Account Already Exists !', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (328, 'edit_income', 'Edit Income', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (329, 'you_are_not_access_this_part', 'You are not authorised person !', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (330, 'account_edit', 'Account Edit', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (331, 'due', 'Due', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (332, 'expense_edit', 'Expense Edit', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (333, 'please_select_customer', 'Please select customer !', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (334, 'profit_report', 'Profit Report (Sale Wise)', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (335, 'total_profit_report', 'Total profit report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (336, 'please_enter_valid_captcha', 'Please enter valid captcha.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (337, 'category_not_selected', 'Category not selected.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (338, 'supplier_not_selected', 'Supplier not selected.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (339, 'please_select_product', 'Please select product.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (340, 'product_model_already_exist', 'Product model already exist !', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (341, 'invoice_logo', 'Sale Logo', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (342, 'available_qnty', 'Av. Qnty.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (343, 'you_can_not_buy_greater_than_available_cartoon', 'You can not select grater than available cartoon !', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (344, 'customer_details', 'Customer details', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (345, 'manage_customer_details', 'Manage customer details.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (346, 'site_key', 'Captcha Site Key', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (347, 'secret_key', 'Captcha Secret Key', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (348, 'captcha', 'Captcha', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (349, 'cartoon_quantity', 'Cartoon Quantity', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (350, 'total_cartoon', 'Total Cartoon', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (351, 'cartoon', 'Cartoon', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (352, 'item_cartoon', 'Item/Cartoon', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (353, 'product_and_supplier_did_not_match', 'Product and supplier did not match !', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (354, 'if_you_update_purchase_first_select_supplier_then_product_and_then_quantity', 'If you update purchase,first select supplier then product and then update qnty.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (355, 'item', 'Item', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (356, 'manage_your_credit_customer', 'Manage your credit customer', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (357, 'total_quantity', 'Total Quantity', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (358, 'quantity_per_cartoon', 'Quantity per cartoon', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (359, 'barcode_qrcode_scan_here', 'Barcode or QR-code scan here', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (360, 'synchronizer_setting', 'Synchronizer Setting', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (361, 'data_synchronizer', 'Data Synchronizer', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (362, 'hostname', 'Host name', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (363, 'username', 'User Name', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (364, 'ftp_port', 'FTP Port', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (365, 'ftp_debug', 'FTP Debug', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (366, 'project_root', 'Project Root', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (367, 'please_try_again', 'Please try again', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (368, 'save_successfully', 'Save successfully', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (369, 'synchronize', 'Synchronize', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (370, 'internet_connection', 'Internet Connection', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (371, 'outgoing_file', 'Outgoing File', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (372, 'incoming_file', 'Incoming File', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (373, 'ok', 'Ok', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (374, 'not_available', 'Not Available', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (375, 'available', 'Available', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (376, 'download_data_from_server', 'Download data from server', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (377, 'data_import_to_database', 'Data import to database', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (378, 'data_upload_to_server', 'Data uplod to server', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (379, 'please_wait', 'Please Wait', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (380, 'ooops_something_went_wrong', 'Oooops Something went wrong !', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (381, 'upload_successfully', 'Upload successfully', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (382, 'unable_to_upload_file_please_check_configuration', 'Unable to upload file please check configuration', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (383, 'please_configure_synchronizer_settings', 'Please configure synchronizer settings', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (384, 'download_successfully', 'Download successfully', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (385, 'unable_to_download_file_please_check_configuration', 'Unable to download file please check configuration', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (386, 'data_import_first', 'Data import past', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (387, 'data_import_successfully', 'Data import successfully', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (388, 'unable_to_import_data_please_check_config_or_sql_file', 'Unable to import data please check config or sql file', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (389, 'total_sale_ctn', 'Total Sale Ctn', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (390, 'in_qnty', 'In Qnty.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (391, 'out_qnty', 'Out Qnty.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (392, 'stock_report_supplier_wise', 'Stock Report (Supplier Wise)', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (393, 'all_stock_report_supplier_wise', 'Stock Report (Suppler Wise)', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (394, 'select_supplier', 'Select Supplier', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (395, 'stock_report_product_wise', 'Stock Report (Product Wise)', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (396, 'phone', 'Phone', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (397, 'select_product', 'Select Product', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (398, 'in_quantity', 'In Qnty.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (399, 'out_quantity', 'Out Qnty.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (400, 'in_taka', 'In TK.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (401, 'out_taka', 'Out TK.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (402, 'commission', 'Commission', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (403, 'generate_commission', 'Generate Commssion', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (404, 'commission_rate', 'Commission Rate', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (405, 'total_ctn', 'Total Ctn.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (406, 'per_pcs_commission', 'Per PCS Commission', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (407, 'total_commission', 'Total Commission', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (408, 'enter', 'Enter', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (409, 'please_add_walking_customer_for_default_customer', 'Please add \'Walking Customer\' for default customer.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (410, 'supplier_ammount', 'Supplier Amount', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (411, 'my_sale_ammount', 'My Sale Amount', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (412, 'signature_pic', 'Signature Picture', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (413, 'branch', 'Branch', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (414, 'ac_no', 'A/C Number', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (415, 'ac_name', 'A/C Name', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (416, 'bank_transaction', 'Bank Transaction', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (417, 'bank', 'Bank', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (418, 'withdraw_deposite_id', 'Withdraw / Deposite ID', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (419, 'bank_ledger', 'Bank Ledger', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (420, 'note_name', 'Note Name', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (421, 'pcs', 'Pcs.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (422, '1', '1', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (423, '2', '2', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (424, '5', '5', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (425, '10', '10', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (426, '20', '20', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (427, '50', '50', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (428, '100', '100', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (429, '500', '500', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (430, '1000', '1000', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (431, 'total_discount', 'Total Discount', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (432, 'product_not_found', 'Product not found !', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (433, 'this_is_not_credit_customer', 'This is not credit customer !', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (434, 'personal_loan', 'Personal Loan', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (435, 'add_person', 'Add Person', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (436, 'add_loan', 'Add Loan', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (437, 'add_payment', 'Add Payment', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (438, 'manage_person', 'Manage Person', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (439, 'personal_edit', 'Person Edit', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (440, 'person_ledger', 'Person Ledger', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (441, 'backup_restore', 'Backup ', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (442, 'database_backup', 'Database backup', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (443, 'file_information', 'File information', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (444, 'filename', 'Filename', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (445, 'size', 'Size', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (446, 'backup_date', 'Backup date', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (447, 'backup_now', 'Backup now', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (448, 'restore_now', 'Restore now', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (449, 'are_you_sure', 'Are you sure ?', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (450, 'download', 'Download', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (451, 'backup_and_restore', 'Backup', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (452, 'backup_successfully', 'Backup successfully', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (453, 'delete_successfully', 'Delete successfully', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (454, 'stock_ctn', 'Stock/Qnt', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (455, 'unit', 'Unit', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (456, 'meter_m', 'Meter (M)', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (457, 'piece_pc', 'Piece (Pc)', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (458, 'kilogram_kg', 'Kilogram (Kg)', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (459, 'stock_cartoon', 'Stock Cartoon', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (460, 'add_product_csv', 'Add Product (CSV)', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (461, 'import_product_csv', 'Import product (CSV)', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (462, 'close', 'Close', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (463, 'download_example_file', 'Download example file.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (464, 'upload_csv_file', 'Upload CSV File', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (465, 'csv_file_informaion', 'CSV File Information', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (466, 'out_of_stock', 'Out Of Stock', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (467, 'others', 'Others', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (468, 'full_paid', 'Full Paid', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (469, 'successfully_saved', 'Your Data Successfully Saved', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (470, 'manage_loan', 'Manage Loan', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (471, 'receipt', 'Receipt', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (472, 'payment', 'Payment', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (473, 'cashflow', 'Daily Cash Flow', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (474, 'signature', 'Signature', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (475, 'supplier_reports', 'Supplier Reports', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (476, 'generate', 'Generate', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (477, 'todays_overview', 'Todays Overview', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (478, 'last_sales', 'Last Sales', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (479, 'manage_transaction', 'Manage Transaction', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (480, 'daily_summary', 'Daily Summary', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (481, 'daily_cash_flow', 'Daily Cash Flow', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (482, 'custom_report', 'Custom Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (483, 'transaction', 'Transaction', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (484, 'receipt_amount', 'Receipt Amount', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (485, 'transaction_details_datewise', 'Transaction Details Datewise', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (486, 'cash_closing', 'Cash Closing', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (487, 'you_can_not_buy_greater_than_available_qnty', 'You can not buy greater than available qnty.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (488, 'supplier_id', 'Supplier ID', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (489, 'category_id', 'Category ID', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (490, 'select_report', 'Select Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (491, 'supplier_summary', 'Supplier summary', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (492, 'sales_payment_actual', 'Sales payment actual', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (493, 'today_already_closed', 'Today already closed.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (494, 'root_account', 'Root Account', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (495, 'office', 'Office', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (496, 'loan', 'Loan', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (497, 'transaction_mood', 'Transaction Mood', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (498, 'select_account', 'Select Account', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (499, 'add_receipt', 'Add Receipt', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (500, 'update_transaction', 'Update Transaction', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (501, 'no_stock_found', 'No Stock Found !', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (502, 'admin_login_area', 'Admin Login Area', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (503, 'print_qr_code', 'Print QR Code', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (504, 'discount_type', 'Discount Type', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (505, 'discount_percentage', 'Discount', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (506, 'fixed_dis', 'Fixed Dis.', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (507, 'return', 'Return', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (508, 'stock_return_list', 'Stock Return List', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (509, 'wastage_return_list', 'Wastage Return List', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (510, 'return_invoice', 'Sale Return', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (511, 'sold_qty', 'Sold Qty', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (512, 'ret_quantity', 'Return Qty', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (513, 'deduction', 'Deduction', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (514, 'check_return', 'Check Return', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (515, 'reason', 'Reason', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (516, 'usablilties', 'Usability', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (517, 'adjs_with_stck', 'Adjust With Stock', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (518, 'return_to_supplier', 'Return To Supplier', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (519, 'wastage', 'Wastage', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (520, 'to_deduction', 'Total Deduction ', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (521, 'nt_return', 'Net Return Amount', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (522, 'return_list', 'Return List', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (523, 'add_return', 'Add Return', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (524, 'per_qty', 'Purchase Qty', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (525, 'return_supplier', 'Supplier Return', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (526, 'stock_purchase', 'Stock Purchase Price', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (527, 'stock_sale', 'Stock Sale Price', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (528, 'supplier_return', 'Supplier Return', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (529, 'purchase_id', 'Purchase ID', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (530, 'return_id', 'Return ID', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (531, 'supplier_return_list', 'Supplier Return List', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (532, 'c_r_slist', 'Stock Return Stock', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (533, 'wastage_list', 'Wastage List', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (534, 'please_input_correct_invoice_id', 'Please Input a Correct Sale ID', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (535, 'please_input_correct_purchase_id', 'Please Input Your Correct  Purchase ID', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (536, 'add_more', 'Add More', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (537, 'prouct_details', 'Product Details', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (538, 'prouct_detail', 'Product Details', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (539, 'stock_return', 'Stock Return', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (540, 'choose_transaction', 'Select Transaction', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (541, 'transection_category', 'Select  Category', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (542, 'transaction_categry', 'Select Category', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (543, 'search_supplier', 'Search Supplier', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (544, 'customer_id', 'Customer ID', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (545, 'search_customer', 'Search Customer Invoice', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (546, 'serial_no', 'SN', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (547, 'item_discount', 'Item Discount', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (548, 'invoice_discount', 'Sale Discount', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (549, 'add_unit', 'Add Unit', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (550, 'manage_unit', 'Manage Unit', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (551, 'add_new_unit', 'Add New Unit', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (552, 'unit_name', 'Unit Name', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (553, 'payment_amount', 'Payment Amount', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (554, 'manage_your_unit', 'Manage Your Unit', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (555, 'unit_id', 'Unit ID', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (556, 'unit_edit', 'Unit Edit', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (557, 'vat', 'Vat', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (558, 'sales_report_category_wise', 'Sales Report (Category wise)', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (559, 'purchase_report_category_wise', 'Purchase Report (Category wise)', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (560, 'category_wise_purchase_report', 'Category wise purchase report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (561, 'category_wise_sales_report', 'Category wise sales report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (562, 'best_sale_product', 'Best Sale Product', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (563, 'all_best_sales_product', 'All Best Sales Products', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (564, 'todays_customer_receipt', 'Todays Customer Receipt', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (565, 'not_found', 'Record not found', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (566, 'collection', 'Collection', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (567, 'increment', 'Increment', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (568, 'accounts_tree_view', 'Accounts Tree View', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (569, 'debit_voucher', 'Debit Voucher', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (570, 'voucher_no', 'Voucher No', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (571, 'credit_account_head', 'Credit Account Head', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (572, 'remark', 'Remark', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (573, 'code', 'Code', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (574, 'amount', 'Amount', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (575, 'approved', 'Approved', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (576, 'debit_account_head', 'Debit Account Head', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (577, 'credit_voucher', 'Credit Voucher', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (578, 'find', 'Find', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (579, 'transaction_date', 'Transaction Date', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (580, 'voucher_type', 'Voucher Type', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (581, 'particulars', 'Particulars', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (582, 'with_details', 'With Details', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (583, 'general_ledger', 'General Ledger', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (584, 'general_ledger_of', 'General ledger of', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (585, 'pre_balance', 'Pre Balance', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (586, 'current_balance', 'Current Balance', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (587, 'to_date', 'To Date', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (588, 'from_date', 'From Date', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (589, 'trial_balance', 'Trial Balance', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (590, 'authorized_signature', 'Authorized Signature', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (591, 'chairman', 'Chairman', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (592, 'total_income', 'Total Income', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (593, 'statement_of_comprehensive_income', 'Statement of Comprehensive Income', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (594, 'profit_loss', 'Profit Loss', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (595, 'cash_flow_report', 'Cash Flow Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (596, 'cash_flow_statement', 'Cash Flow Statement', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (597, 'amount_in_dollar', 'Amount In Dollar', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (598, 'opening_cash_and_equivalent', 'Opening Cash and Equivalent', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (599, 'coa_print', 'Coa Print', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (600, 'cash_flow', 'Cash Flow', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (601, 'cash_book', 'Cash Book', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (602, 'bank_book', 'Bank Book', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (603, 'c_o_a', 'Chart of Account', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (604, 'journal_voucher', 'Journal Voucher', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (605, 'contra_voucher', 'Contra Voucher', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (606, 'voucher_approval', 'Vouchar Approval', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (607, 'supplier_payment', 'Supplier Payment', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (608, 'customer_receive', 'Customer Receive', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (609, 'gl_head', 'General Head', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (610, 'account_code', 'Account Head', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (611, 'opening_balance', 'Opening Balance', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (612, 'head_of_account', 'Head of Account', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (613, 'inventory_ledger', 'Inventory Ledger', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (614, 'newpassword', 'New Password', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (615, 'password_recovery', 'Password Recovery', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (616, 'forgot_password', 'Forgot Password ??', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (617, 'send', 'Send', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (618, 'due_report', 'Due Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (619, 'due_amount', 'Due Amount', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (620, 'download_sample_file', 'Download Sample File', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (621, 'customer_csv_upload', 'Customer Csv Upload', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (622, 'csv_supplier', 'Csv Upload Supplier', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (623, 'csv_upload_supplier', 'Csv Upload Supplier', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (624, 'previous', 'Previous', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (625, 'net_total', 'Net Total', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (626, 'currency_list', 'Currency List', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (627, 'currency_name', 'Currency Name', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (628, 'currency_icon', 'Currency Symbol', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (629, 'add_currency', 'Add Currency', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (630, 'role_permission', 'Role Permission', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (631, 'role_list', 'Role List', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (632, 'user_assign_role', 'User Assign Role', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (633, 'permission', 'Permission', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (634, 'add_role', 'Add Role', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (635, 'add_module', 'Add Module', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (636, 'module_name', 'Module Name', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (637, 'office_loan', 'Office Loan', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (638, 'add_menu', 'Add Menu', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (639, 'menu_name', 'Menu Name', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (640, 'sl_no', 'Sl No', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (641, 'create', 'Create', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (642, 'read', 'Read', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (643, 'role_name', 'Role Name', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (644, 'qty', 'Quantity', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (645, 'max_rate', 'Max Rate', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (646, 'min_rate', 'Min Rate', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (647, 'avg_rate', 'Average Rate', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (648, 'role_permission_added_successfully', 'Role Permission Successfully Added', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (649, 'update_successfully', 'Successfully Updated', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (650, 'role_permission_updated_successfully', 'Role Permission Successfully Updated ', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (651, 'shipping_cost', 'Shipping Cost', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (652, 'in_word', 'In Word ', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (653, 'shipping_cost_report', 'Shipping Cost Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (654, 'cash_book_report', 'Cash Book Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (655, 'inventory_ledger_report', 'Inventory Ledger Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (656, 'trial_balance_with_opening_as_on', 'Trial Balance With Opening As On', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (657, 'type', 'Type', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (658, 'taka_only', 'Taka Only', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (659, 'item_description', 'Desc', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (660, 'sold_by', 'Sold By', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (661, 'user_wise_sales_report', 'User Wise Sales Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (662, 'user_name', 'User Name', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (663, 'total_sold', 'Total Sold', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (664, 'user_wise_sale_report', 'User Wise Sales Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (665, 'barcode_or_qrcode', 'Barcode/QR-code', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (666, 'category_csv_upload', 'Category Csv  Upload', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (667, 'unit_csv_upload', 'Unit Csv Upload', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (668, 'invoice_return_list', 'Sales Return list', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (669, 'invoice_return', 'Sales Return', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (670, 'tax_report', 'Tax Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (671, 'select_tax', 'Select Tax', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (672, 'hrm', 'HRM', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (673, 'employee', 'Employee', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (674, 'add_employee', 'Add Employee', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (675, 'manage_employee', 'Manage Employee', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (676, 'attendance', 'Attendance', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (677, 'add_attendance', 'Attendance', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (678, 'manage_attendance', 'Manage Attendance', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (679, 'payroll', 'Payroll', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (680, 'add_payroll', 'Payroll', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (681, 'manage_payroll', 'Manage Payroll', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (682, 'employee_type', 'Employee Type', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (683, 'employee_designation', 'Employee Designation', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (684, 'designation', 'Designation', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (685, 'add_designation', 'Add Designation', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (686, 'manage_designation', 'Manage Designation', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (687, 'designation_update_form', 'Designation Update form', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (688, 'picture', 'Picture', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (689, 'country', 'Country', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (690, 'blood_group', 'Blood Group', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (691, 'address_line_1', 'Address Line 1', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (692, 'address_line_2', 'Address Line 2', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (693, 'zip', 'Zip code', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (694, 'city', 'City', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (695, 'hour_rate_or_salary', 'Houre Rate/Salary', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (696, 'rate_type', 'Rate Type', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (697, 'hourly', 'Hourly', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (698, 'salary', 'Salary', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (699, 'employee_update', 'Employee Update', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (700, 'checkin', 'Check In', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (701, 'employee_name', 'Employee Name', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (702, 'checkout', 'Check Out', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (703, 'confirm_clock', 'Confirm Clock', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (704, 'stay', 'Stay Time', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (705, 'sign_in', 'Sign In', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (706, 'check_in', 'Check In', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (707, 'single_checkin', 'Single Check In', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (708, 'bulk_checkin', 'Bulk Check In', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (709, 'successfully_checkout', 'Successfully Checkout', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (710, 'attendance_report', 'Attendance Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (711, 'datewise_report', 'Date Wise Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (712, 'employee_wise_report', 'Employee Wise Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (713, 'date_in_time_report', 'Date In Time Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (714, 'request', 'Request', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (715, 'sign_out', 'Sign Out', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (716, 'work_hour', 'Work Hours', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (717, 's_time', 'Start Time', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (718, 'e_time', 'In Time', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (719, 'salary_benefits_type', 'Benefits Type', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (720, 'salary_benefits', 'Salary Benefits', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (721, 'beneficial_list', 'Benefit List', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (722, 'add_beneficial', 'Add Benefits', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (723, 'add_benefits', 'Add Benefits', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (724, 'benefits_list', 'Benefit List', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (725, 'benefit_type', 'Benefit Type', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (726, 'benefits', 'Benefit', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (727, 'manage_benefits', 'Manage Benefits', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (728, 'deduct', 'Deduct', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (729, 'add', 'Add', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (730, 'add_salary_setup', 'Add Salary Setup', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (731, 'manage_salary_setup', 'Manage Salary Setup', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (732, 'basic', 'Basic', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (733, 'salary_type', 'Salary Type', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (734, 'addition', 'Addition', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (735, 'gross_salary', 'Gross Salary', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (736, 'set', 'Set', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (737, 'salary_generate', 'Salary Generate', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (738, 'manage_salary_generate', 'Manage Salary Generate', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (739, 'sal_name', 'Salary Name', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (740, 'gdate', 'Generated Date', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (741, 'generate_by', 'Generated By', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (742, 'the_salary_of', 'The Salary of ', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (743, 'already_generated', ' Already Generated', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (744, 'salary_month', 'Salary Month', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (745, 'successfully_generated', 'Successfully Generated', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (746, 'salary_payment', 'Salary Payment', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (747, 'employee_salary_payment', 'Employee Salary Payment', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (748, 'total_salary', 'Total Salary', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (749, 'total_working_minutes', 'Total Working Hours', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (750, 'working_period', 'Working Period', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (751, 'paid_by', 'Paid By', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (752, 'pay_now', 'Pay Now ', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (753, 'confirm', 'Confirm', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (754, 'successfully_paid', 'Successfully Paid', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (755, 'add_incometax', 'Add Income Tax', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (756, 'setup_tax', 'Setup Tax', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (757, 'start_amount', 'Start Amount', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (758, 'end_amount', 'End Amount', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (759, 'tax_rate', 'Tax Rate', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (760, 'setup', 'Setup', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (761, 'manage_income_tax', 'Manage Income Tax', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (762, 'income_tax_updateform', 'Income tax Update form', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (763, 'positional_information', 'Positional Information', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (764, 'personal_information', 'Personal Information', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (765, 'timezone', 'Time Zone', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (766, 'sms', 'SMS', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (767, 'sms_configure', 'SMS Configure', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (768, 'url', 'URL', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (769, 'sender_id', 'Sender ID', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (770, 'api_key', 'Api Key', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (771, 'gui_pos', 'GUI POS', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (772, 'manage_service', 'Manage Service', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (773, 'service', 'Service', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (774, 'add_service', 'Add Service', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (775, 'service_edit', 'Service Edit', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (776, 'service_csv_upload', 'Service CSV Upload', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (777, 'service_name', 'Service Name', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (778, 'charge', 'Charge', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (779, 'service_invoice', 'Service Invoice', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (780, 'service_discount', 'Service Discount', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (781, 'hanging_over', 'ETD', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (782, 'service_details', 'Service Details', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (783, 'tax_settings', 'Tax Settings', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (784, 'default_value', 'Default Value', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (785, 'number_of_tax', 'Number of Tax', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (786, 'please_select_employee', 'Please Select Employee', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (787, 'manage_service_invoice', 'Manage Service Invoice', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (788, 'update_service_invoice', 'Update Service Invoice', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (789, 'customer_wise_tax_report', 'Customer Wise  Tax Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (790, 'service_id', 'Service Id', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (791, 'invoice_wise_tax_report', 'Invoice Wise Tax Report', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (792, 'reg_no', 'Reg No', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (793, 'update_now', 'Update Now', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (794, 'import', 'Import', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (795, 'add_expense_item', 'Add Expense Item', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (796, 'manage_expense_item', 'Manage Expense Item', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (797, 'add_expense', 'Add Expense', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (798, 'manage_expense', 'Manage Expense', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (799, 'expense_statement', 'Expense Statement', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (800, 'expense_type', 'Expense Type', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (801, 'expense_item_name', 'Expense Item Name', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (802, 'stock_purchase_price', 'Stock Purchase Price', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (803, 'purchase_price', 'Purchase Price', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (804, 'customer_advance', 'Customer Advance', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (805, 'advance_type', 'Advance Type', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (806, 'restore', 'Restore', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (807, 'supplier_advance', 'Supplier Advance', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (808, 'please_input_correct_invoice_no', 'Please Input Correct Invoice NO', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (809, 'backup', 'Back Up', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (810, 'app_setting', 'App Settings', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (811, 'local_server_url', 'Local Server Url', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (812, 'online_server_url', 'Online Server Url', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (813, 'connet_url', 'Connected Hotspot Ip/url', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (814, 'update_your_app_setting', 'Update Your App Setting', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (815, 'select_category', 'Select Category', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (816, 'mini_invoice', 'Mini Invoice', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (817, 'purchase_details', 'Purchase Details', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (818, 'disc', 'Dis %', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (819, 'serial', 'Serial', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (820, 'transaction_head', 'Transaction Head', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (821, 'transaction_type', 'Transaction Type', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (822, 'return_details', 'Return Details', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (823, 'return_to_customer', 'Return To Customer', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (824, 'sales_and_purchase_report_summary', 'Sales And Purchase Report Summary', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (825, 'add_person_officeloan', 'Add Person (Office Loan)', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (826, 'add_loan_officeloan', 'Add Loan (Office Loan)', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (827, 'add_payment_officeloan', 'Add Payment (Office Loan)', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (828, 'manage_loan_officeloan', 'Manage Loan (Office Loan)', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (829, 'add_person_personalloan', 'Add Person (Personal Loan)', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (830, 'add_loan_personalloan', 'Add Loan (Personal Loan)', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (831, 'add_payment_personalloan', 'Add Payment (Personal Loan)', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (832, 'manage_loan_personalloan', 'Manage Loan (Personal)', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (833, 'hrm_management', 'Human Resource', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (834, 'cash_adjustment', 'Cash Adjustment', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (835, 'adjustment_type', 'Adjustment Type', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (836, 'change', 'Change', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (837, 'sale_by', 'Sale By', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (838, 'salary_date', 'Salary Date', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (839, 'earnings', 'Earnings', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (840, 'total_addition', 'Total Addition', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (841, 'total_deduction', 'Total Deduction', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (842, 'net_salary', 'Net Salary', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (843, 'ref_number', 'Reference Number', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (844, 'name_of_bank', 'Name Of Bank', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (845, 'salary_slip', 'Salary Slip', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (846, 'basic_salary', 'Basic Salary', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (847, 'return_from_customer', 'Return From Customer', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (848, 'quotation', 'Quotation', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (849, 'add_quotation', 'Add Quotation', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (850, 'manage_quotation', 'Manage Quotation', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (851, 'terms', 'Terms', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (852, 'send_to_customer', 'Sent To Customer', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (853, 'quotation_no', 'Quotation No', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (854, 'quotation_date', 'Quotation Date', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (855, 'total_service_tax', 'Total Service Tax', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (856, 'totalservicedicount', 'Total Service Discount', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (857, 'item_total', 'Item Total', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (858, 'service_total', 'Service Total', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (859, 'quot_description', 'Quotation Description', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (860, 'sub_total', 'Sub Total', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (861, 'mail_setting', 'Mail Setting', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (862, 'mail_configuration', 'Mail Configuration', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (863, 'mail', 'Mail', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (864, 'protocol', 'Protocol', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (865, 'smtp_host', 'SMTP Host', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (866, 'smtp_port', 'SMTP Port', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (867, 'sender_mail', 'Sender Mail', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (868, 'mail_type', 'Mail Type', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (869, 'html', 'HTML', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (870, 'text', 'TEXT', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (871, 'expiry_date', 'Expiry Date', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (872, 'api_secret', 'Api Secret', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (873, 'please_config_your_mail_setting', NULL, NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (874, 'quotation_successfully_added', 'Quotation Successfully Added', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (875, 'add_to_invoice', 'Add To Invoice', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (876, 'added_to_invoice', 'Added To Invoice', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (877, 'closing_balance', 'Closing Balance', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (878, 'contact', 'Contact', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (879, 'fax', 'Fax', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (880, 'state', 'State', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (881, 'discounts', 'Discount', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (882, 'address1', 'Address1', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (883, 'address2', 'Address2', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (884, 'receive', 'Receive', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (885, 'purchase_history', 'Purchase History', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (886, 'cash_payment', 'Cash Payment', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (887, 'bank_payment', 'Bank Payment', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (888, 'do_you_want_to_print', 'Do You Want to Print', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (889, 'yes', 'Yes', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (890, 'no', 'No', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (891, 'todays_sale', 'Today\'s Sales', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (892, 'or', 'OR', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (893, 'no_result_found', 'No Result Found', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (894, 'add_service_quotation', 'Add Service Quotation', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (895, 'add_to_invoice', 'Add To Invoice', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (896, 'item_quotation', 'Item Quotation', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (897, 'service_quotation', 'Service Quotation', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (898, 'return_from', 'Return Form', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (899, 'customer_return_list', 'Customer Return List', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (900, 'pdf', 'Pdf', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (901, 'note', 'Note', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (902, 'update_debit_voucher', 'Update Debit Voucher', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (903, 'update_credit_voucher', 'Update Credit voucher', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (904, 'on', 'On', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (905, '', '', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (906, 'total_expenses', 'Total Expense', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (907, 'already_exist', 'Already Exist', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (908, 'checked_out', 'Checked Out', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (909, 'update_salary_setup', 'Update Salary Setup', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (910, 'employee_signature', 'Employee Signature', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (911, 'payslip', 'Payslip', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (912, 'exsisting_role', 'Existing Role', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (913, 'filter', 'Filter', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (914, 'testinput', NULL, NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (915, 'update_quotation', 'Update Quotation', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (916, 'quotation_successfully_updated', 'Quotation Successfully Updated', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (917, 'successfully_approved', 'Successfully Approved', NULL);
INSERT INTO `language` (`id`, `phrase`, `english`, `bangla`) VALUES (918, 'expiry', 'Expiry', NULL);


#
# TABLE STRUCTURE FOR: module
#

DROP TABLE IF EXISTS `module`;

CREATE TABLE `module` (
  `id` int NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL,
  `description` text,
  `image` varchar(255) DEFAULT NULL,
  `directory` varchar(100) DEFAULT NULL,
  `status` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=17 DEFAULT CHARSET=utf8mb3;

INSERT INTO `module` (`id`, `name`, `description`, `image`, `directory`, `status`) VALUES (1, 'invoice', NULL, NULL, NULL, 1);
INSERT INTO `module` (`id`, `name`, `description`, `image`, `directory`, `status`) VALUES (2, 'customer', NULL, NULL, NULL, 1);
INSERT INTO `module` (`id`, `name`, `description`, `image`, `directory`, `status`) VALUES (3, 'product', NULL, NULL, NULL, 1);
INSERT INTO `module` (`id`, `name`, `description`, `image`, `directory`, `status`) VALUES (4, 'supplier', NULL, NULL, NULL, 1);
INSERT INTO `module` (`id`, `name`, `description`, `image`, `directory`, `status`) VALUES (5, 'purchase', NULL, NULL, NULL, 1);
INSERT INTO `module` (`id`, `name`, `description`, `image`, `directory`, `status`) VALUES (6, 'stock', NULL, NULL, NULL, 1);
INSERT INTO `module` (`id`, `name`, `description`, `image`, `directory`, `status`) VALUES (7, 'return', NULL, NULL, NULL, 1);
INSERT INTO `module` (`id`, `name`, `description`, `image`, `directory`, `status`) VALUES (8, 'report', NULL, NULL, NULL, 1);
INSERT INTO `module` (`id`, `name`, `description`, `image`, `directory`, `status`) VALUES (9, 'accounts', NULL, NULL, NULL, 1);
INSERT INTO `module` (`id`, `name`, `description`, `image`, `directory`, `status`) VALUES (10, 'bank', NULL, NULL, NULL, 1);
INSERT INTO `module` (`id`, `name`, `description`, `image`, `directory`, `status`) VALUES (11, 'tax', NULL, NULL, NULL, 1);
INSERT INTO `module` (`id`, `name`, `description`, `image`, `directory`, `status`) VALUES (12, 'hrm_management', NULL, NULL, NULL, 1);
INSERT INTO `module` (`id`, `name`, `description`, `image`, `directory`, `status`) VALUES (13, 'service', NULL, NULL, NULL, 1);
INSERT INTO `module` (`id`, `name`, `description`, `image`, `directory`, `status`) VALUES (14, 'commission', NULL, NULL, NULL, 1);
INSERT INTO `module` (`id`, `name`, `description`, `image`, `directory`, `status`) VALUES (15, 'setting', NULL, NULL, NULL, 1);
INSERT INTO `module` (`id`, `name`, `description`, `image`, `directory`, `status`) VALUES (16, 'quotation', NULL, NULL, NULL, 1);


#
# TABLE STRUCTURE FOR: payroll_tax_setup
#

DROP TABLE IF EXISTS `payroll_tax_setup`;

CREATE TABLE `payroll_tax_setup` (
  `tax_setup_id` int unsigned NOT NULL AUTO_INCREMENT,
  `start_amount` decimal(12,2) NOT NULL DEFAULT '0.00',
  `end_amount` decimal(12,2) NOT NULL DEFAULT '0.00',
  `rate` decimal(12,2) NOT NULL DEFAULT '0.00',
  `status` varchar(30) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  PRIMARY KEY (`tax_setup_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

#
# TABLE STRUCTURE FOR: person_information
#

DROP TABLE IF EXISTS `person_information`;

CREATE TABLE `person_information` (
  `id` int NOT NULL AUTO_INCREMENT,
  `person_id` varchar(50) NOT NULL,
  `person_name` varchar(50) NOT NULL,
  `person_phone` varchar(50) NOT NULL,
  `person_address` text NOT NULL,
  `status` int NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

#
# TABLE STRUCTURE FOR: person_ledger
#

DROP TABLE IF EXISTS `person_ledger`;

CREATE TABLE `person_ledger` (
  `id` int NOT NULL AUTO_INCREMENT,
  `transaction_id` varchar(50) NOT NULL,
  `person_id` varchar(50) NOT NULL,
  `date` varchar(50) NOT NULL,
  `debit` decimal(12,2) NOT NULL DEFAULT '0.00',
  `credit` decimal(12,2) NOT NULL DEFAULT '0.00',
  `details` text NOT NULL,
  `status` int NOT NULL COMMENT '1=no paid,2=paid',
  PRIMARY KEY (`id`),
  KEY `person_id` (`person_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

#
# TABLE STRUCTURE FOR: personal_loan
#

DROP TABLE IF EXISTS `personal_loan`;

CREATE TABLE `personal_loan` (
  `per_loan_id` int NOT NULL AUTO_INCREMENT,
  `transaction_id` varchar(30) NOT NULL,
  `person_id` varchar(30) NOT NULL,
  `debit` decimal(12,2) DEFAULT '0.00',
  `credit` decimal(12,2) NOT NULL DEFAULT '0.00',
  `date` varchar(30) NOT NULL,
  `details` varchar(100) NOT NULL,
  `status` int NOT NULL COMMENT '1=no paid,2=paid',
  PRIMARY KEY (`per_loan_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

#
# TABLE STRUCTURE FOR: pesonal_loan_information
#

DROP TABLE IF EXISTS `pesonal_loan_information`;

CREATE TABLE `pesonal_loan_information` (
  `id` int NOT NULL AUTO_INCREMENT,
  `person_id` varchar(50) NOT NULL,
  `person_name` varchar(50) NOT NULL,
  `person_phone` varchar(30) NOT NULL,
  `person_address` text NOT NULL,
  `status` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `person_id` (`person_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

#
# TABLE STRUCTURE FOR: product_category
#

DROP TABLE IF EXISTS `product_category`;

CREATE TABLE `product_category` (
  `id` int NOT NULL AUTO_INCREMENT,
  `category_id` varchar(255) DEFAULT NULL,
  `category_name` varchar(255) DEFAULT NULL,
  `status` int NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

#
# TABLE STRUCTURE FOR: product_information
#

DROP TABLE IF EXISTS `product_information`;

CREATE TABLE `product_information` (
  `id` int NOT NULL AUTO_INCREMENT,
  `product_id` varchar(100) NOT NULL,
  `category_id` varchar(255) DEFAULT NULL,
  `product_name` varchar(255) NOT NULL,
  `price` float DEFAULT NULL,
  `unit` varchar(50) DEFAULT NULL,
  `tax` float DEFAULT NULL COMMENT 'Tax in %',
  `serial_no` varchar(200) DEFAULT NULL,
  `product_model` varchar(100) DEFAULT NULL,
  `product_details` varchar(255) DEFAULT NULL,
  `image` varchar(255) DEFAULT NULL,
  `status` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `category_id` (`category_id`),
  KEY `product_id` (`product_id`)
) ENGINE=MyISAM AUTO_INCREMENT=1349 DEFAULT CHARSET=utf8mb3;

INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1, '1', '0', 'Button holder huawei Ashraf', '390', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (2, '2', '0', 'Two pin k huawei Ashraf ', '210', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (3, '3 ', '0', 'Holder pendent huawei Ashraf', '320', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (4, '4', '0', 'Ice light 12w Ge ArsLan', '310', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (5, '5', '0', 'Ice light 15w G e ArsLan', '470', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (6, '6', '0', ' 5w Diachi bulb ArsLan', '170', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (7, '7', '0', 'Cob 7w G e ArsLan', '340', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (8, '8', '0', 'Duck patti Aqua 60/60 Yayha', '570', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (9, '9', '0', 'Duck patti Aqua 40/40 Yayha', '450', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (10, '10', '0', 'Duck patti Aqua 1 inch Yayha', '230', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (11, '11', '0', 'Duck patti Aqua 3/4 Yayha', '125', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (12, '12', '0', 'Duck patti Aqua 3/4 Pak ', '155', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (13, '13', '0', 'Nail steel Mix yayha', '420', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (14, '14', '0', 'Pipe Galco 3/4 Safan ', '185', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (15, '15', '0', 'Pipe zenco 1 inch Qureshi', '155', 'pcs', '0', '', '', 'ppippip', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (16, '16', '0', 'Pipe new nawab 1inch Qureshi', '130', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (17, '17', '0', 'Pipe vital 1 inch Qureshi', '200', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (18, '18', '0', 'Pipe new star 1/2 inch Qureshi', '95', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (19, '19', '0', 'Pipe Time star 3/4 inch Qureshi', '90', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (20, '20', '0', 'Pipe Mastar 3/4 Qureshi', '135', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (21, '21', '0', 'Pipe Jadha 3/4 inch Qureshi', '150', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (22, '22', '0', 'light box grey Mixx', '35', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (23, '23', '0', 'Band 3/4 Decent Mixx', '145', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (24, '24', '0', 'Socket 3/4 Decent Mixx', '85', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (25, '25', '0', 'Jungtion box 3/4 (B) Mixx', '1820', '', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (26, '26', '0', '3 hole and 4 hole (B) Mixx', '35', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (27, '27', '0', 'Faram 4x4 (B) Mixx', '53', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (28, '28', '0', 'Round block (B) Mixx', '140', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (29, '29', '0', 'Conciled Board 4x4 (A) Mixx', '60', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (30, '30', '0', 'P.V.C Band 1 Inch Mixx', '180', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (31, '31', '0', 'Band 3/4 AA Akram', '165', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (32, '32', '0', 'socket 3/4 AA Akram', '92', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (33, '33', '0', 'PVC Bend 1/2 Akram', '80', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (34, '34', '0', 'socket 1/2 Akram', '370', '', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (35, '35', '0', 'Lanter 3/4 Box (B) Akram', '105', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (36, '36', '0', 'Lanter Box 3/4 (A) Akram', '230', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (37, '37', '0', 'conciled Box 4x4 B Akram', '30', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (38, '38', '0', 'fram 4x4 (B) Akram', '40', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (39, '39', '0', 'Light Box Lanter 4 Inch Akram', '40', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (40, '40', '0', 'Light Box 4 Inch Grey Akram', '35', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (41, '41', '0', 'China Switch Socket Mix Nasir', '65', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (42, '42', '0', '1+1 China sheet Nasir', '190', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (43, '43', '0', 'M+F China Sheet Nasir', '240', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (44, '45', '0', 'TF+TV China sheet Nasir', '200', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (45, '46', '0', 'China sheet 2Gang Nasir', '170', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (46, '47', '0', '2+2  China sheet Nasir', '340', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (47, '48', '0', 'China sheet 1Gang Nasir', '170', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (48, '49', '0', 'China sheet Bell Push Nasir', '180', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (49, '50', '0', 'China sheet Dimmer Mix Nasir', '140', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (50, '51', '0', 'China sheet Power Plug Nasir', '270', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (51, '52', '0', '6+2 Mesco China sheet Nasir', '470', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (52, '53', '0', '(16w) Ice Light 3000k Memon ', '500', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (53, '54', '0', '(12w) Ice Light D.c Memon ', '275', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (54, '55', '0', '(12) Ice Light Brighttex Memon ', '300', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (55, '56', '0', '(50 W) Led Blub factor Memon ', '1020', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (56, '57', '0', ' (12w) LED Bulb Ultra Memon', '160', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (57, '58', '0', 'Led Colour Bulb trend Memon ', '135', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (58, '59', '0', '(12w) Multi colour bulb trend Memon ', '185', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (59, '60', '0', ' (7w) Down Light Mix Memon ', '220', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (60, '61', '0', ' (7w) Down Light B.J Memon ', '180', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (61, '62', '0', ' (60w) Tube Light Factor Memon ', '1520', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (62, '63', '0', '3/29 H.M Red Safan', '4920', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (63, '64', '0', '3/29 H.M Black Safan', '4920', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (64, '65', '0', '7/29 H.M Red Safan', '10320', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (65, '66', '0', '7/29 H.M Black Safan', '10320', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (66, '67', '0', '3/29 Pak 26% Red Safan', '2620', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (67, '68', '0', '3/29 Pak 26% Black Safan', '2620', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (68, '69', '0', '7/29 Pak 26% Red Safan', '5220', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (69, '70', '0', '7/29 Pak 26% Black Safan', '5220', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (70, '71', '0', '3/29 Pak 23% Red Safan', '2270', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (71, '72', '0', '3/29 Pak 23% Black Safan', '2270', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (72, '73', '0', '3/29 Pak 23% White Safan', '2270', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (73, '74', '0', '7/36 Pak 27% Red Safan', '6520', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (74, '75', '0', '7/36 Pak 27% Black Safan', '6520', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (75, '76', '0', '7/44 Pak 27% Red Safan', '9120', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (76, '77', '0', '7/44 Pak 27% Black Safan', '9120', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (77, '78', '0', 'Olympic 10 hol Faram ', '180', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (78, '79', '0', 'Olympic 06 Hol Faram', '140', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (79, '80', '0', 'Olympic 01 Hol Faram', '100', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (80, '81', '0', 'Olympic 03 Hol Faram', '100', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (81, '82', '0', 'Olympic 10 Hol Faram 6=6', '190', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (82, '83', '0', ' (Abid) Button Holder B22 Olympic', '470', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (83, '84', '0', 'Bed Switch Huda Olympic', '470', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (84, '85', '0', 'ARY Jumbo Holder B22', '680', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (85, '86', '0', 'ARY Button Holder E27', '410', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (87, '88 ', '0', 'ARY Multi Plug (B)', '1340', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (191, '89', '0', 'ARY Pendent holder b22', '300', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (93, '90', '0', ' ARY 3 Pin top 40Amp', '920', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (94, '91', '0', 'ARY 3 Pin (MF) 5Amp', '65', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (91, '92', '0', 'ARY Switch Socket (B)', '280', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (92, '93', '0', 'ARY 2 Pin Shoo porceline ', '290', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (95, '94', '0', 'Almezan Jumbo Holder (B22)', '605', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (96, '95', '0', ' Almezan Button Holder (B22)', '410', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (97, '96', '0', 'Almezan Switch Socket (B)', '280', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (98, '97', '0', 'M.S Jumbo Holder (2in 1) Almezan ', '820', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (99, '98', '0', ' (Abid) Jumbo Holder B22 Almezan', '870', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (100, '99', '0', 'Almezan Bad Switch (B)', '380', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (107, '101', '0', 'Asim Teddy switch porcelain base 10Amp', '570', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (106, '100', '0', 'Asim Pino Switch Socket', '320', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (103, '102', '0', ' perfect Pino switch socket', '470', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (104, '103', '0', 'perfect 2 pin shoo porclian', '340', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (105, '104', '0', 'Perfect Computer Multi Plug', '320', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (190, '87', '0', 'ARY 2 pin shoo generator ', '290', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (110, '105', '0', 'EM Jumbo ciling rose', '530', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (111, '106', '0', 'EM Small ciling rose', '400', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (112, '107', '0', 'EM Button Holder B22', '480', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (113, '108', '0', 'EM Paino Light', '320', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (114, '109', '0', 'EM Male Female (A) ', '620', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (115, '110', '0', 'EM switch Socket 40Amp', '1316', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (116, '111', '0', 'EM 3 pin top 40Amp', '1020', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (117, '112', '0', 'EM 2 pin porcelian ', '300', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (118, '113', '', 'Sonex Change over switch (30Amp)', '860', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (119, '114', '', 'Sonex change over switch (15Amp)', '500', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (120, '115', '', 'Sonex cut out 10Amp', '640', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (121, '116', '0', 'Sahar Jumbo Holder B22', '570', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (122, '117', '0', ' Shiline rose small Sahar', '320', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (123, '118', '0', 'Sahar Male Female Timepey (B)', '320', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (124, '119', '0', 'Sahar 3 pin top 40Amp', '620', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (125, '120', '0', '3 pin top 40Amp Sahar', '720', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (126, '121', '0', 'Sahar Multi plug (Samsung B)', '320', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (127, '122', '', 'Sahar computer Multi plug ', '360', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (128, '123', '0', ' sahar 2 pin Royal', '320', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (129, '124', '0', 'Burq Button Holder B22', '520', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (130, '125', '0', 'Burq Switch Socket (A)', '395', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (131, '126', '0', 'Burq Pin Peral', '480', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (132, '127', '0', 'Burq Piano Holder B22', '420', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (133, '128', '0', 'Burq Piano Holder E27', '420', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (134, '129', '0', 'Burq Main Switch 40Amp open', '295', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (135, '130', '0', 'Burq B22 to E27 Convertor', '380', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (136, '131', '0', 'Burq 2 Pin Shoo (110)', '260', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (137, '132', '0', 'Burq Men Switch (30Amp) open', '260', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (138, '133', '0', ' Burq Men Switch conciled 30Amp', '260', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (139, '134', '0', ' Burq Multi plug 15Amp porcelian', '180', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (140, '135', '0', '3/29 Million Extreme Red Fareed', '2981', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (141, '136', '0', '3/29 Million Extreme Black Fareed ', '2981', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (142, '137', '0', '3/29 Million Extreme Yellow Fareed', '2981', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (143, '138', '0', '3/29 Million Extreme Green Fareed', '2981', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (144, '139', '0', '3/29 Million Extreme Blue Fareed', '2981', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (145, '140', '0', '3/29 Million Extreme White Fareed', '2981', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (146, '141', '0', '7/29 Million Extreme Red Fareed', '6166', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (147, '142', '0', '7/29 Million Extreme Yellow Fareed', '6166', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (148, '143', '0', '7/29 Million Extreme Green Fareed', '6166', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (149, '144', '0', '7/29 Million Extreme Black Fareed', '6166', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (150, '145', '0', '7/36 Million Extreme Red Fareed', '9351', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (151, '146', '0', '7/36 Million Extreme Black Fareed', '9351', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (152, '147', '0', '7/44 Million Extreme Red Fareed ', '15006', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (153, '148', '0', '7/44 Million Extreme Black Fareed ', '15006', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (154, '149', '0', 'Classic Auto Wire 12 no 30 Meter Fareed ', '1064', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (155, '150', '0', 'Classic Auto Wire 12 no Blue 30 Meter Fareed ', '1064', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (156, '151', '0', 'Classic Auto Wire18 no Red 30 Meter Fareed ', '1577', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (157, '152', '0', 'Classic Auto Wire 18 no Blue 30 Meter Fareed ', '1577', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (158, '153', '0', 'Classic Auto Wire 28 no Red 30 Meter Fareed ', '2312', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (159, '154', '0', 'Classic Auto Wire 28 no Blue Fareed ', '2312', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (160, '155', '0', 'Classic Auto Wire 42 no Red 30 Meter Fareed ', '3228', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (161, '156', '0', 'Classic Auto Wire 42 no Blue 30 Meter Fareed ', '3228', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (162, '157', '0', 'Classic Auto Wire 55 no Red 30 Meter Fareed ', '4210', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (163, '158', '0', 'Classic Auto 55 no Blue 30 Meter Fareed ', '4210', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (164, '159', '0', 'Classic Auto Wire 70 no Red 30 Meter Fareed ', '5080', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (165, '160', '0', 'Classic Auto Wire 70 no Blue 30 meter Fareed ', '5080', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (166, '161', '0', '23/76 Million Extreme Round Fareed ', '4411', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (167, '162', '0', '23/76 Million Extreme Flexible Fareed ', '3371', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (168, '163', '0', 'Wood Board 10x12 (B) Aijaz', '600', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (169, '164', '0', 'Wood Board 8x10 (B) Aijaz', '520', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (170, '165', '0', 'Wood Board 6x8 (B) Aijaz', '400', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (171, '166', '0', 'Wood Board 4x7 (B) Aijaz', '350', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (172, '167', '0', 'wood Board (B) Aijaz', '260', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (173, '168', '0', 'Wood Board no 1 10x12 (A) Aijaz', '820', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (174, '169', '0', 'Wood Board 8x10 (A) Aijaz', '720', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (175, '170', '0', 'Wood Board 6x8 (A) Aijaz', '470', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (176, '171', '0', 'Fan pipe Rod 3 Fot Aijaz', '320', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (177, '172', '0', 'Fan pipe  Rod 2 Fot Aijaz', '170', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (178, '173', '0', 'Fan pipe Rod 2x1/2 Fot Aijaz', '230', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (179, '174', '0', 'PVC pipe 1x1/4 inch Desent Aijaz', '320', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (180, '175', '0', 'PVC Bend 3/4 Desent Aijaz', '145', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (181, '176', '0', 'PVC Bend Socket 3/4 Desent Aijaz', '85', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (182, '177', '0', 'PVC Bend 1 inch Desent Aijaz', '185', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (183, '178', '0', 'PVC Socket 1 Inch Desent Aijaz', '100', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (184, '179', '0', 'Light Box 3 Inch (A) Aijaz', '56', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (185, '180', '0', 'Light Box 3 Inch (B) Decent Aijaz', '47', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (186, '181', '0', 'Fan box (A) Aijaz', '185', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (187, '182', '0', 'Fan box (B) Aijaz', '110', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (188, '183', '0', 'Junction Box 3/4 (A) Aijaz', '155', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (189, '184', '0', 'Junction Box 3/4 (B) Aijaz', '140', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (192, '185', '0', '7/64 Services Wire (A) Safan', '8520', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (193, '186', '0', '7/64 Services Wire (B) Safan', '5520', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (194, '187', '0', '7/52 Services Wire D1 Safan', '6520', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (195, '188', '0', '7/52 Services Wire D2 Safan', '5620', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (196, '189', '0', '7/44 Services Wire 10KG Safan', '3370', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (197, '190', '0', 'Telephone Silver Wire 200 No Jawaid', '2520', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (198, '191', '0', 'Telephone Wire 80 No Jawaid', '1720', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (199, '192', '0', 'Telephone Wire 50 No Jawaid', '1120', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (200, '193', '0', '7/64 Single Silver Wire Jawaid', '1720', '', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (201, '194', '0', '7/52 Single Silver wire Jawaid', '1520', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (202, '195', '0', '7/44 Single silver Wire Jawaid', '1320', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (203, '196', '0', '23/76 Flat Wire Silver Red & Black Jawaid', '400', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (204, '197', '0', '40/76 Flat wire Silver White Jawaid', '1520', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (205, '198', '0', 'Solar Wire Double 3mm Red & Blue Jawaid', '2120', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (206, '199', '0', 'Solar Wire double 3mm Orange Jawaid', '1920', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (207, '200', '0', 'Flexable Pipe 1/2 inch (B) salman', '920', 'Bundel', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (208, '201', '0', 'Flexable Pipe 3/4 Inch (B) salman', '820', 'Bundel', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (209, '202', '0', 'Flexable Pipe 1 Inch (B) salman', '920', 'Bundel', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (210, '203', '0', 'Flexable Pipe 1 1/2 inch (B) salman', '1120', 'Bundel', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (211, '204', '0', 'Flexable Pipe 2 Inch (B) salman', '1320', 'Bundel', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (212, '205', '0', 'Flexable 1/2 Inch (A) white salman', '920', 'Bundel', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (213, '206', '0', 'Flexable 3/4 Inch (A) salman', '1220', 'Bundel', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (214, '207', '0', 'Flexable Pipe 1 Inch (A) salman', '1320', 'Bundel', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (215, '208', '0', 'Flexable Pipe 1 1/2 Inch (A) salman', '1520', 'Bundel', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (216, '209', '0', 'Flexable Pipe 2 Inch (A) salman', '1720', 'Bundel', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (217, '210', '0', 'Pipei 3/4 Inch (C) Hi Denci Salman', '90', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (218, '211', '0', 'Pipe 3/4 Inch (B) Hi Denci Salman', '120', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (219, '212', '0', 'Pipe 3/4 Inch (A) Hi Denci salman', '125', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (220, '213', '0', 'Digital Volt Meter Fizan', '190', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (221, '214', '0', 'Amper + Volt Meter Fizan', '500', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (222, '215', '0', 'Candle Bulb E 14 Fizan', '170', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (223, '216', '0', '63 AMP Volt Proctector Fizan', '1620', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (224, '217', '0', 'Door Bell Fizan', '200', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (225, '218', '0', 'Panal Light Digital+Volt Meter Fizan', '190', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (226, '219', '0', ' D.P 63 AMP Panal Brekar (B) Fizan', '400', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (227, '220', '0', 'S.P 10.16.20.32 AMP Panal Brekar Fizan', '200', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (228, '221', '0', 'D.P 63 AMP Panal Brekar (A) Fizan', '520', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (229, '222', '0', 'S.P 10 AMP Panal Brekar (A Fizan', '250', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (230, '223', '0', 'Change Over (Oppas) 32 Amp Fizan', '1270', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (231, '224', '0', 'Change Over (Yoyo) 32 Amp Fizan', '570', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (232, '225', '0', 'Change Over (Hager) 32Amp (B) Fizan', '500', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (233, '226', '0', 'Change Over (Hager) 50Amp (B) Fizan', '1620', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (234, '227', '0', 'Wapda Clip Single Fizan', '120', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (235, '228', '0', '3/29 Wire Sogo Black Fizan', '3520', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (236, '229', '0', '3/29 Wire Pakistan cable Red Fizan', '5020', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (237, '230', '0', '7/29  Wire Afr Cable Red Fizan', '4620', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (238, '231', '0', 'Button Holder Mesco B22 Fizan', '570', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (239, '232', '0', 'Jumbo Holder Mesco B22 Fizan', '770', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (240, '233', '0', '200w Bulb General Fizan', '108', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (241, '234', '0', 'Tube Light single 30 watt G.1', '940', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (242, '235', '0', 'Tube Light (40 W) Double G.1', '1120', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (243, '236', '0', ' (50 W) LED Bulb Brightit G.1', '940', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (244, '237', '0', '(30 W) LED Bulb Brightit G.1', '550', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (245, '238', '0', '(18 W) LED Bulb G.1', '340', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (246, '239', '0', ' (20 W) LED Bulb Brightit G.1', '380', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (247, '240', '0', ' (15 W) LED Bulb Brightit G.1', '280', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (248, '241', '0', ' (12 W) LED Bulb Lifi G.1', '180', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (249, '242', '0', ' (25 W) LED Bulb G.1', '510', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (250, '243', '0', ' (12 W) Ice Light G.1', '450', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (251, '244', '', 'Fox Light (100 W) Zarcon G.1', '5520', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (252, '245', '', 'Fox Light (50 W) Tiger G.1', '2820', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (253, '246', '0', 'Fox Light (100 W) Lumax G.1', '4020', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (254, '247', '0', 'Fox Light (50 W) Brightit Casit G.1', '670', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (255, '248', '0', ' (18 W) Golden Bulb G.1', '340', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (256, '249', '0', 'Fox Light (50 W) Brightit Black G.1', '1620', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (257, '250', '0', 'LED Light Colour Brightit G.1', '270', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (258, '251', '', 'COB (3 W) G.1', '295', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (259, '252', '', 'COB (5 W) G.1', '330', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (260, '253', '', 'COB (1 W) G.1', '300', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (261, '254', '', 'Down Light (7 W) Laster G.1', '250', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (262, '255', '', 'Ice Light (22 W) G.1', '770', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (263, '256', '0', 'Open Light (18 W) Sangam G.1', '820', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (264, '257', '', 'Open Light (12 W) G.1', '570', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (265, '258', '', 'Open light (6 W) G.1', '470', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (266, '259', '0', 'Panal PVC 10x12 (A) Moin', '1220', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (267, '260', '0', 'Panal PVC 10x12 (B) Moin', '870', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (268, '261', '0', 'Panal PVC 10x12 (C) Moin', '620', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (269, '262', '0', 'Panal PVC 8x10 (A) Moin', '470', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (270, '263', '0', 'Panal PVC 8x10 (B) Moin', '370', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (271, '264', '0', 'Brekar Box 2 hol (A) Moin', '100', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (272, '265', '0', 'Brekar Box 4 Hol Moin', '140', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (273, '266', '0', 'Braker Box 6 Hol Moin', '240', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (274, '267', '0', 'Braker Box 8 Hol (B) Moin', '380', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (275, '268', '0', 'Penal Box 12x15 Plastic Moin', '2120', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (276, '269', '0', 'Change Over Box 102 Moin', '130', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (277, '270', '0', 'Round Block (A) Moin', '180', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (278, '271', '0', 'Round Block (B) Moin', '140', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (279, '272', '0', 'Fan Cover Plate Moin', '240', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (280, '273', '0', 'Cover Plate 4 Inch Moin', '820', 'Gross', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (281, '274', '0', 'PVC Board 6 Hol 6x6 (B) Moin', '380', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (282, '275', '0', 'PVC Board 1.2 Hol (B) Moin', '120', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (283, '276', '0', 'PVC Board 3.4 Hol (B) Moin', '200', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (284, '277', '0', 'PVC Board 5.6 Hol (B) Moin', '260', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (285, '278', '0', 'PVC Board 1.2 Hol (A) Moin', '200', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (286, '279', '0', 'PVC Board 3.4 Hol (A) Moin', '280', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (287, '280', '0', 'PVC Board 5.6 Hol (A) Moin', '380', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (288, '281', '0', 'Concelied Board 4x4 Orange Moin', '45', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (289, '282', '0', 'Concelied Box 4x7 Orange Moin', '52', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (290, '283', '0', 'Open Faram 4x4 (B) Moin', '50', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (291, '284', '0', 'Open Faram 4x7 (B) Moin', '60', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (292, '285', '0', 'PVC Board M.F (A) Moin', '260', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (293, '286', '0', 'PVC Board M.F (B) Moin', '200', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (294, '287', '0', 'PVC Board Power Plug (B) Moin', '300', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (295, '288', '0', 'Brekar Box 2 Hol (B )Moin', '90', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (296, '289', '0', '3/29 Million Extreme Red Arfeen', '2981', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (297, '290', '0', '7/29 Million Extreme Red Arfeen', '6166', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (298, '291', '0', '7/36 Million Extreme Red Arfeen', '9351', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (299, '292', '0', '7/44 Million Extreme Black Arfeen', '15006', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (300, '293', '0', '23/76 Million Extreme Round Arfeen', '4411', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (301, '294', '0', '40/76 Million Extreme Round Arfeen', '7141', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (302, '295', '0', '23/76 Flat Million Extreme Arfeen', '3956', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (303, '296', '0', ' 23/76 Million Extreme Flexible Arfeen', '3371', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (304, '297', '0', '110/76 Million Extreme 2 Core Arfeen', '15781', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (305, '298', '0', '70/76 Million Extreme 2 Core Arfeen', '10781', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (306, '299', '0', '3/29 Million Classic  Red Arfeen', '4112', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (307, '300', '0', '7/29 Million Classic Red Arfeen', '8727', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (308, '301', '0', '7/36 Million Classic Arfeen', '11691', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (309, '302', '0', '6 MM Million Classic Arfeen', '16709', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (310, '303', '0', 'Solar Wire 18 No Solar Link 30 mtr Red Arfeen', '1520', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (311, '304', '0', 'Solar Wire 28 No Solar Link 30 mtr Red Arfeen', '2020', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (312, '305', '0', 'Solar Wire 42 No Solar Link 30 mtr Red Arfeen', '2920', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (313, '306', '0', 'Solar Wire 70 No Solar Link 30 Mtr Red Arfeen', '4620', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (314, '307', '0', 'Solar Wire 85 No Solar Link 30 Mtr Red Arfeen', '6020', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (315, '308', '0', 'Solar Wire 12 No 9o Mtr Red Arfeen', '2720', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (316, '309', '0', 'Solar Wire 28 No 90 Mtr Red Arfeen', '6020', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (317, '310', '0', 'Solar wire 42 No 90 Mtr Red Arfeen', '8720', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (318, '311', '0', '3/29 Million Extreme Black Arfeen', '2981', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (319, '312', '0', '3/29 Million Extreme yellow Arfeen', '2981', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (320, '313', '0', '3/29 Million Extreme Green Arfeen', '2981', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (321, '314', '0', '3/29 Million Extreme Blue Arfeen', '2981', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (322, '315', '0', '3/29  Million Extreme white Arfeen', '2981', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (323, '316', '0', ' 7/29 Million Extreme Black Arfeen', '6166', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (324, '317', '0', '7/29  Million Extreme yellow Arfeen', '6166', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (325, '318', '0', ' 7/29 Million Extreme Blue Arfeen', '6166', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (326, '319', '0', '7/29 Million Extreme White Arfeen', '6166', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (327, '320', '0', ' 7/29 Million Extreme Green Arfeen', '6166', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (328, '321', '0', '7/36 Million Extreme Black Arfeen', '9351', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (329, '322', '0', '7/44 Million Extreme Black Arfeen', '15006', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (330, '323', '0', '3/29 Million Classic Black Arfeen', '4112', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (331, '324', '0', '3/29  Million Classic Yellow Arfeen', '4112', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (332, '325', '0', '3/29 Million Classic Blue Arfeen', '4112', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (333, '326', '0', '3/29  Million Classic White Arfeen', '4112', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (334, '327', '0', '7/29 Million Classic Black Arfeen', '8727', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (335, '328', '0', '7/29 Million Classic Yellow Arfeen', '8727', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (336, '329', '0', '7/29 Million Classic Green Arfeen', '8727', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (337, '330', '0', '7/29 Million Classic Blue Arfeen', '8727', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (338, '331', '0', '4MM Million Classic Red Arfeen', '11691', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (339, '332', '0', '4MM Million Classic Black Arfeen', '11691', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (340, '333', '0', '6MM Million Classic Red Arfeen', '16709', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (341, '334', '0', '6MM Million Classic Black Arfeen', '16709', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (342, '335', '0', '3/29 Million MM Red Arfeen', '2396', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (343, '336', '0', '3/29 Million MM Black Arfeen', '2396', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (344, '337', '0', '7/29 Million MM Red Arfeen', '4931', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (345, '338', '0', '7/29 Million MM Black Arfeen', '4931', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (346, '339', '0', '7/36 Million MM  Red Arfeen', '7401', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (347, '340', '0', '7/36 Million MM Black Arfeen', '7401', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (348, '341', '0', '7/44 Million MM Red Arfeen', '10911', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (349, '342', '0', '7/44  Million MM Black Arfeen', '10911', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (350, '343', '0', 'Solar wire 18 No Solar link 30mtr Blue Arfeen', '1520', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (351, '344', '0', 'Solar wire 28 No Solar Link 30Mtr Blue Arfeen', '2020', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (352, '345', '0', 'Solar wire 42No Solar link 30Mtr Blue Arfeen', '2920', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (353, '346', '0', 'Solar Wire 70 No Solar link 30Mtr Blue Arfeen', '4620', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (354, '347', '0', 'Solar Wire 85 No Solar Link 30Mtr Blue Arfeen', '6020', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (355, '348', '0', 'Solar Wire 12 No 90 Mtr Black Arfeen', '2720', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (356, '349', '0', 'Solar Wire 28 No 90 Mtr Black Arfeen', '6020', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (357, '350', '0', 'Solar wire 42 No 90 Mtr Black Arfeen', '8720', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (358, '351', '0', '3/29 Tip Top 27% Red Arfeen', '2820', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (359, '352', '0', '3/29 Tip Top 27% Black Arfeen', '2820', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (360, '353', '0', '3/29 Tip Top 27% Colours Arfeen', '2820', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (361, '354', '0', '7/29 Tip Top 27% Red Arfeen', '5820', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (362, '355', '0', '7/29 Tip Top 27% Black Arfeen', '5820', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (363, '356', '0', '7/29 Tip Top 27% Colours Arfeen', '5820', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (364, '357', '0', '7/36 Tip Top Red Arfeen', '8820', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (365, '358', '0', '7/36 Tip Top Black Arfeen', '8820', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (366, '359', '0', '7/44 Tip Top Red Arfeen', '14420', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (367, '360', '0', '7/44 Tip Top Black Arfeen', '14420', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (368, '361', '0', 'Solar Wire 55 No  30 Mtr Solar link Red Arfeen', '3820', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (369, '362', '0', 'Solar Wire 55 No 30 mtr Solar Link Blue Arfeen', '3820', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (370, '363', '0', 'A.C Brekar Belco Mix Arfeen', '340', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (371, '364', '0', 'Pipe Light Double Mix Arfeen', '170', 'Meter', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (372, '365', '0', 'Pipe Light Connector Double Arfeen', '90', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (373, '366', '0', 'Pipe Light Connector Single Arfeen', '66', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (374, '367', '0', 'Conceled Box 4/4 Arfeen', '50', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (375, '368', '0', 'Fan Box Orange Arfeen', '140', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (376, '369', '0', '7/36 Tip Top loose item Millat ', '104', 'Yard', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (377, '370', '0', '3/29 23% Loose Item Millat ', '42', 'Yard', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (378, '371', '0', '7/29 19% losz Millat ', '54', 'Yard', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (379, '372', '0', '23/76 (Falt) Million Losz Millat ', '60', 'Yard', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (380, '373', '0', '40/76 (Flat) silver losz Millat ', '37', 'Yard', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (381, '374', '0', 'osaka PVC Tape lose Millat ', '60', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (382, '375', '0', 'Scrow 1 Losz Millat ', '35', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (383, '376', '0', 'Steel Nial (Mix) Losz Millat ', '1520', '', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (384, '377', '0', 'Switch Socket Asim Losz Millat ', '50', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (385, '378', '0', 'Shoo 2 Pin (Mix) Losz Millat ', '40', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (386, '379', '0', 'Panio Switch Socket (Mix) Losz Millat ', '45', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (387, '380', '0', 'Computer Multi (Mix) Losz Millat ', '45', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (388, '381', '0', 'Button Holder (Mix) Losz Millat ', '54', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (389, '382', '0', 'Jumbo Holder (Mix) Losz Millat ', '66', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (390, '383', '0', 'Multi Plug (Mix) Losz Millat ', '50', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (391, '384', '0', 'Solar Wire 70 No Solar Link 30 Mtr Red (2) Arfeen', '4620', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (392, '385', '0', 'Fox Light 50 W (D.P) Emaan', '2770', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (393, '386', '0', 'SMD 7 W Osaka AC Emaan', '320', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (394, '387', '0', '8+2 Mesco Sheet Emaan', '506', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (410, '403', '0', 'open light 18w 4k Emaan', '470', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (396, '389', '0', 'Sheet PowerPlug Mesco Emaan', '356', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (397, '390', '0', '12 w Ice Light 3in1 G 1 Emaan', '580', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (398, '391', '0', 'Ice Light 12w Venus Emaan', '290', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (399, '392', '0', 'SMD 7W Daichi Emaan', '300', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (400, '393', '0', 'Ice Light 12W 3in1 G 1 Emaan', '580', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (401, '394', '0', 'Power Plug 40Amp ARY Emaan', '320', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (402, '395', '0', 'Open Fram 4x7 (B) Emaan', '70', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (403, '396', '0', 'Open Farm 4x4 (B) Emaan', '60', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (404, '397', '0', 'Panal Light Emaan', '70', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (405, '398', '0', '9+1 Mesco Sheet Emaan', '506', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (406, '399', '0', '2+2 Mesco Sheet Emaan', '307', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (407, '400', '0', 'Sheet Bell Push Mesco Emaan', '246', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (408, '401', '0', '6+2 Mesco China sheet Emaan', '495', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (409, '402', '0', 'Singal Pol Brekar Globe Emaan', '270', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (411, '404', '0', '12w Led Bulb Ultra Emaan', '145', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (412, '405', '0', '28w Led Tube Light Emaan', '870', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (413, '406', '0', 'Sheet Multiplug Mesco Emaan', '356', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (414, '407', '0', '18w Led bulb G.one E27 Emaan', '350', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (415, '408', '0', '12w DC Bulb Trend Emaan', '120', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (416, '409', '0', '36w Tube Light Factor Emaan', '840', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (417, '410', '0', '3/29 pak 19% Safan', '1670', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (418, '411', '0', '7/29 Pak 19% Safan', '3320', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (419, '412', '0', '7/64 Service Double Alfa Full Safan', '8820', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (420, '413', '0', '7/64 Service Double Alfa 55% Safan', '7770', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (421, '414', '0', '7/52 Service Double 48% Safan', '6920', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (422, '415', '0', '7/52 Service Double 38% Safan', '5820', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (423, '416', '0', '7/52 Service Double 33% Safan', '5020', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (424, '417', '0', '7/29 Pak 23% Red Safan ', '4320', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (425, '418', '0', '7/29 Pak 23% Black Safan', '4320', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (426, '419', '0', '40/76 Million Extreme Round Fareed ', '7141', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (427, '420', '0', '23/76 Flat Million Extreme Fareed ', '3956', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (428, '421', '0', 'Conclied Box 4x7 (A) Moin', '56', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (429, '422', '0', 'Conciled Box 4x4 (A) Moin', '50', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (430, '423', '0', '15x20 Panel Special Cash', '4120', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (431, '424', '0', 'Pipe 2inch PVC Cash', '920', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (432, '425', '0', 'Bath Set Cash', '1620', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (433, '426', '0', 'Comboat Set Cash', '8020', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (434, '427', '0', 'Comboat Set IIL Cash', '1220', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (435, '428', '0', 'Beson Set Cash', '5520', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (436, '429', '0', 'Flash Tank Cash', '2020', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (437, '430', '0', 'West Pipe Cash', '170', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (438, '431', '0', 'Bolt Kit Cash', '170', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (439, '432', '0', 'Beson Set (A) Cash', '4020', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (440, '433', '0', 'Muslim Shawar Cash', '1070', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (441, '434', '0', 'Wall Shawar Cash', '6520', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (442, '435', '0', 'C.P Nipel Cash', '170', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (443, '436', '0', 'Hand Shawar Cash', '1520', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (444, '437', '0', 'Comboat Kit Cash', '220', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (445, '438', '0', 'Elbow 4inch UPVC Cash', '320', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (446, '439', '0', 'Pipe 4inch UPVC Cash', '270', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (447, '440', '0', 'Thamball Comboat Cash', '470', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (448, '441', '0', '12W Bulb Osaka Cash', '290', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (449, '442', '0', 'Wire Solar Double 5MM R/B Losz Millat ', '140', 'Yard', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (450, '443', '0', 'Tile Cutter Cash', '320', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (451, '444', '0', 'Lota  cash', '170', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (452, '445', '0', 'PVC Jug Cash', '170', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (453, '446', '0', 'Tile Cash', '1470', 'Meter', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (454, '447', '0', 'Sodoium Rod 400W Cash', '870', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (455, '448', '0', 'Scrow 1inch Black Paremount', '140', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (456, '449', '0', 'Sheet Frame NS 4 Hole Paremount', '110', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (457, '450', '0', 'Sheet Frame NS 8 Hole Paremount', '170', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (458, '451', '0', 'Sheet Frame NS 2 Hole Paremount', '90', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (459, '452 ', '0', 'Wire Clip 6MM Taiwan Paremount', '312', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (460, '453', '0', 'Cupsul Light Normal Cash', '270', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (461, '454', '0', '8+2 grande China Sheet Cash', '390', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (462, '455', '0', '3+1 grande China Sheet Cash', '250', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (463, '456', '0', 'Hole Punch machine Cash', '430', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (464, '457', '0', 'Steplar Machine Cash', '470', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (465, '458', '0', 'Steplar Pin Cash', '80', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (466, '459', '0', 'Calculatar 14 Digget Cash', '1120', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (467, '460', '0', 'Balty PVC Cash', '1020', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (468, '461', '0', 'Cloth Pardha Cash', '1520', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (469, '462', '0', '23/76 Million 4 Core Cash', '8670', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (470, '463', '0', 'Battery Cell large Cash', '440', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (471, '464', '0', 'Pad Lock  63MM Cash', '520', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (472, '465', '0', 'Jugg Lota Patara Cash', '1120', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (473, '466', '0', 'Fuse 3AMP Cash', '370', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (474, '467', '0', 'Nail Iron 1/2*14 Cash', '355', 'KG', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (475, '468', '0', 'Register 200 Page Cash', '245', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (476, '469', '0', 'Photo copy Cash', '1070', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (477, '470 ', '0', 'Whito pin Cash', '80', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (478, '471 ', '0', 'Steplar Pin  Large Cash', '1200', 'Bundel', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (479, '472 ', '0', 'Scrow 1/14 Cash', '170', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (480, '473', '0', 'Nail Steel 1inch Cash', '370', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (481, '474', '0', 'Wire Clip 4MM (A) Cash', '120', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (482, '475', '0', 'Empty Bag Cash', '44', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (483, '476', '0', 'Sheet frame NS 4Hole Cash', '110', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (484, '479', '0', 'Classic Auto Wire  12 NO 30 meter Cash', '1120', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (485, '480 ', '0', 'Duplicate Book 1/6 Cash', '520', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (486, '481', '0', 'PVC Tape  Roll Osaka Cash', '61', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (487, '482', '0', 'Solding Wire Cash', '1270', 'Roll', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (488, '483', '0', 'Multty Lead Cash', '120', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (489, '484', '0', 'China Sheet Single TV  ECM Cash', '295', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (490, '488', '0', 'Junction Box 3/4  (A) Moin', '220', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (491, '489', '0', 'Junction Box 3/4 (B) Moin', '145', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (492, '490', '0', ' Led Bulb D.C GN ArsLan', '110', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (493, '491', '0', 'Ice Light D.C SEA Light ArsLan', '210', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (494, '492', '0', '(ARY) 2 Pin Shoo K ', '255', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (495, '493', '0', 'ARY Multi Plug (A) ', '1820', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (496, '494', '0', 'ARY Pendent holder E27', '310', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (497, '495', '0', 'ARY E27 Jumbo holder', '670', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (498, '496', '0', 'ARY Down Holder E27', '58', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (499, '497', '0', 'Scrow 1/1.2 Black Paremount', '180', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (500, '498', '0', 'Scrow 2inch Black Paremount', '270', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (501, '499', '0', 'Plastic gitti barni Paremount', '172', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (502, '500', '0', 'Candle Bulb 0 W Paremount', '670', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (503, '501', '0', 'Wire Clip 8MM (A) Paremount', '260', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (504, '502', '0', 'Magnate contector 100AMP Royal Electric', '10020', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (505, '503', '0', 'Magnate contector 85AMP Royal Electric', '12020', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (506, '504', '0', 'Luxs 50MM Royal Electric', '80', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (507, '505', '0', 'Breaker T.P Shenrider 100 AMP Royal Electric', '11020', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (508, '506', '0', 'Luxs 300MM Royal Electric', '1340', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (509, '507', '0', 'Luxs 1.5MM Royal Electric', '23', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (510, '508', '0', 'Kerosine oil Zahid', '320', '', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (511, '509', '0', 'Oil Pant Corona 3.64 Liter Zahid', '4620', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (512, '510', '0', 'plaster Paris Zahid', '53', 'KG', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (513, '511', '0', 'Distemper Drum (A) Zahid', '8720', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (514, '512', '0', 'Door handle Zahid', '100', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (515, '513', '0', 'Tower Bolt 6 inch Zahid', '160', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (516, '514', '0', 'Scrow 1/1.2 Zahid', '70', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (517, '515', '0', 'Scrow 2 inch Zahid', '195', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (518, '516', '0', 'Steel Nail  1/1.2 inch Zahid', '50', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (519, '517', '0', 'Steel Nail 1 inch Zahid', '22', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (520, '518', '0', 'C.P county Steel Zahid', '620', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (521, '519', '0', 'Cloth pipe Zahid', '920', 'Foot', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (522, '520', '0', 'Breaket Parada Zahid', '140', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (523, '521', '0', 'Flower Parada Zahid', '140', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (524, '522', '0', 'Gas pipe Zahid', '70', 'Foot', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (525, '523', '0', 'Gas Pipe Clip Zahid', '30', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (526, '524', '0', 'M.S NET 5x3 Zahid', '720', 'Foot', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (527, '525', '0', 'M.S NET 5x5 Zahid', '1170', 'Foot', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (528, '526', '0', 'M.S NET 8x4 Zahid', '1465', 'Foot', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (529, '527', '0', 'Handle Wall 3/4 GI Zahid', '680', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (530, '528', '0', 'Handle Wall 1/1.2  GI Zahid', '570', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (531, '529', '0', 'Bib Cock Zahid', '870', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (532, '530', '0', 'Tee Cock Zahid', '870', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (533, '531 ', '0', 'C.P.P Cock Zahid', '720', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (534, '532', '0', 'Sidepilar Cock Zahid', '1620', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (535, '533', '0', 'Shawar C.P Zahid', '500', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (536, '534', '0', 'West Pipe Zahid', '150', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (537, '535', '0', 'Nynol connection 36 inch Zahid', '150', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (538, '536', '0', 'Bolt Kit Zahid', '200', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (539, '537', '0', 'Elbow 34 x 1/2 Zahid', '180', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (540, '538', '0', 'Tee 3/4 x 1/2 Zahid', '180', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (541, '539', '0', 'unioun 3/4 Zahid', '110', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (542, '540', '0', 'Pipe Hock 3/4 Zahid', '35', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (543, '541 ', '0', 'PPR pipe 3/4 Zahid', '670', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (544, '542', '0', 'Complete beson set Zahid', '3520', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (545, '543', '0', 'Soket plan  3/4 Zahid', '50', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (546, '544', '0', 'C.P Chain Zahid', '470', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (547, '545', '0', 'Pad Lock 50 MM Zahid', '270', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (548, '546', '0', 'Tee plan 3/4 Zahid', '55', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (549, '547', '0', 'Beson Mixture GI Zahid', '3120', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (550, '548', '0', 'Beson set white Zahid', '3520', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (551, '549', '0', 'Bib cock  double Zahid', '1720', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (552, '550', '0', 'Wall socket 3/4x1/2 Zahid', '220', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (553, '551', '0', 'Bras socket 3/4x1/2 Zahid', '160', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (554, '552', '0', 'Flash tank (A) Zahid', '1820', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (555, '553', '0', 'Tee cock 3/4 Zahid', '870', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (556, '554', '0', 'P Trip UPVC 4 inch Zahid', '520', 'nos', '0', '', ' ', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (557, '555', '0', 'W.C Big size Zahid', '1570', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (558, '556', '0', 'Pipe 4 inch (A) Zahid', '3120', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (559, '557', '0', 'Elbow 4 inch Zahid', '250', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (560, '558', '0', 'Pipe solution 500ML Zahid', '870', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (561, '559', '0', 'REE balde Zahid', '70', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (562, '560', '0', 'kerosine coil Zahid', '330', 'KG', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (563, '561', '0', 'Bath set Zahid', '2170', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (564, '562', '0', 'Conciled Wall 1/2 Zahid', '720', 'nos', '0', '', '  ', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (565, '563', '0', 'Shawar Rod 1/2 Zahid', '400', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (566, '564', '0', 'tenter green Haroon', '310', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (567, '565', '0', 'Oil pant yellow  rozi lake Haroon', '2520', 'gallan ', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (568, '566', '0', 'Oil pant black rozi lake Haroon ', '2520', 'gallan ', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (569, '567', '0', 'Oil pant red oxide Brito Haroon', '1270', 'gallan ', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (570, '568', '0', 'Distemper brush 4 inch Haroon ', '220', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (571, '569', '0', 'Distemper brush 4 inch Haroon ', '220', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (572, '570', '0', 'Distemper drum 17 KG Naeem', '620', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (573, '571', '0', 'Capister power factor 50 KVR Sindh Electric', '39520', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (574, '572', '0', 'Ice light DC SEA light Riaz ', '270', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (575, '573', '0', 'Fan box (B) Riaz', '120', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (576, '574', '0', 'Electric giser Cash', '14520', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (577, '575', '0', 'Exasast fan metal 10 inch S.K', '3520', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (578, '576', '0', 'Test meter Digital 1500 MPR Chilton Karachi', '15520', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (579, '577', '0', 'Panel Loha 10x12 (B) Abdul Hammed', '1270', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (580, '578', '0', 'Panel Loha 12x15 (B) Abdul Hammed', '2020', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (581, '579', '0', 'Panel Loha 12x18 (B) Abdul Hammed', '2220', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (582, '580', '0', 'Panel Loha 18x24 (B) Abdul Hammed', '5520', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (583, '581', '0', 'Panel Enter com Abdul Hammed', '1020', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (584, '582', '0', 'Panel Loha 10x12 (A) Abdul Hammed', '1520', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (585, '583', '0', 'Panel Loha 12x15 (A) Abdul Hammed', '2320', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (586, '584', '0', 'Panel Loha 12x18 (A) Abdul Hammed', '2620', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (587, '585', '0', 'Bowl  Sink 14x19 Zahid', '2220', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (588, '586', '0', 'H Nital 2x1 GI Zahid', '140', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (589, '587', '0', 'TGI Zahid', '270', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (590, '588', '0', 'Union GI 1 inch Zahid', '260', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (591, '589', '0', 'Sink Cock 1 inch GI Zahid', '1670', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (592, '590', '0', 'Handle wall GI 1 inch Zahid', '1270', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (593, '591 ', '0', 'Wall socket GI 1 inch Zahid', '370', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (594, '592', '0', '8+2 ECM China sheet Fizan', '502', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (595, '593', '0', '6+2 China sheet ECM Fizan', '470', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (596, '594', '0', '2+2  China sheet ECM Fizan', '310', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (597, '595', '0', 'M+F ECM China sheet Fizan', '343', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (598, '596', '0', ' P+P ECM  China sheet Fizan', '356', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (599, '597', '0', 'B+P ECM China sheet Fizan', '270', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (600, '598 ', '0', 'China sheet demer Fizan', '150', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (601, '599', '0', 'Piano demer Fizan', '140', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (602, '600', '0', 'Panel light sada Fizan', '62', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (603, '601', '0', 'Wapda Clip double Fizan', '250', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (604, '602', '0', '40/76 Wire Silver Round Arfeen', '1520', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (605, '603', '0', 'Single breaker 10.16.20 Ternd Arfeen', '270', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (606, '604', '0', 'PVC pipe 1 inch vitel Qureshi', '195', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (607, '606', '0', 'Duplicate Book 1/6 Cash', '520', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (608, '607', '0', 'COB  2 watt SE Cash', '305', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (609, '608', '0', 'Shoping bag 10 KG Cash', '438', 'KG', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (610, '609', '0', 'Led 12 watt Open SE Cash', '820', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (611, '610', '0', 'Led 18 watt open SE Cash', '1045', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (612, '611', '0', 'Led  55 Cash', '320', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (613, '612', '0', 'Led 22 Cash', '320', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (614, '613', '0', 'Led wire Cash', '1470', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (615, '614', '0', 'Led Stand Small Cash', '220', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (616, '615', '0', 'Lcd 19 inch Cash', '4820', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (617, '617', '0', 'Brekit keybord Cash', '620', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (618, '618', '0', 'Mouse Cash', '320', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (619, '619', '0', 'D.v.d Led Cash', '120', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (620, '620', '0', 'L.C.C Connector Cash', '25', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (621, '621', '0', 'Telephone Set C.I.L Cash', '4820', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (622, '622', '0', 'Internet Connector Cash', '30', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (623, '623', '0', 'CAT 6 Cash', '46', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (624, '624', '0', 'Router Antina Cash', '3720', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (625, '625', '0', 'PVC tape Osaka 8 gazz Cash', '61', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (626, '627', '0', 'Pipe G.I  2/12 inch Cash', '920', 'Foot', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (627, '628', '0', 'H Nipal Gi 2/12 inch Cash', '920', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (628, '629', '0', 'Socket G.I 2/12 inch Cash', '720', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (629, '630', '0', 'Elbow G.I 2/12 inch Cash', '1270', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (630, '631', '0', 'union G.I 2/12 inch Cash', '1820', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (631, '632', '0', 'Tee G.I 2/12 inch Cash', '1500', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (632, '633', '0', 'Band G.I 2/12 inch Cash', '2220', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (633, '634', '0', 'Gat wall G.I 2/12 inch Cash', '8260', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (634, '635', '0', 'Nute Bolt 3 inch Cash', '140', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (635, '636', '0', 'C.C.P Connector Cash', '320', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (636, '637', '0', 'D.V.D RB TB Cash', '2020', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (637, '638', '0', 'P.P.R pipe 2 inch Zahid', '4170', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (638, '639', '0', 'P.P.R Socket 2 inch Zahid', '180', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (639, '640', '0', 'P.P.R Elbow Zahid', '280', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (640, '641', '0', 'P.P.R T 2x1 Zahid', '325', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (641, '642', '0', 'Handle wall G.I 2 inch Zahid', '6220', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (642, '643', '0', 'Handle wall G.I 1 inch Zahid', '1470', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (643, '644', '0', 'P TRIP UPVC 4 inch Zahid', '520', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (644, '645', '0', 'Pipe Solution 300 ML Zahid', '370', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (645, '646', '0', 'Pipe 3 inch UPVC Zahid', '165', 'Foot', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (646, '647', '0', 'Tile Bond Zahid', '290', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (647, '648', '0', 'Kerosine oil Zahid', '320', 'Liter', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (648, '649', '0', '3/29 Million Extreme Red Fareed', '2981', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (649, '650', '0', '3/29 Million Extreme Black Fareed', '2981', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (650, '651', '0', '3/29 Million Extreme white Fareed', '2981', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (651, '652', '0', '3/29 Million Extreme Blue Fareed', '2981', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (652, '653', '0', '3/29 Million Extreme Yellow Fareed', '2981', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (653, '654', '0', '3/29 Million Extreme Green Fareed', '2981', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (654, '656', '0', '7/52 Million Extreme Red Fareed', '21116', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (655, '657', '0', '7/52 Million Extreme Black Fareed', '21116', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (656, '658', '0', '7/64 Million Extreme Black Fareed ', '29761', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (657, '659', '0', 'Classic Auto Wire 12 NO Red 30 Meter Fareed ', '1064', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (658, '660', '0', 'Classic Auto Wire 12 NO  Blue 30 Meter Fareed ', '1064', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (659, '661', '0', 'Classic Auto Wire 18 NO Red 30 Meter Fareed ', '1577', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (660, '662', '0', 'Classic Auto Wire 18 NO Blue 30 Meter Fareed ', '1577', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (661, '663', '0', 'Classic Auto Wire 28 NO 30 Meter Red Fareed ', '2312', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (662, '664', '0', 'Classic Auto Wire 28 NO Blue 30 Meter Fareed ', '2312', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (663, '665', '0', 'Classic Auto Wire 42 NO Red 30 Meter Fareed ', '3192', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (664, '666', '0', 'Classic Auto Wire 42 NO Blue 30 Meter Fareed ', '3192', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (665, '667', '0', 'Classic Auto Wire 55 NO Red 30 Meter Fareed ', '4145', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (666, '668', '0', 'Classic Auto Wire 55 NO Blue 30 Meter Fareed ', '4145', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (667, '669', '0', 'Classic Auto Wire 70 NO Red 30 Meter Fareed ', '5080', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (668, '670', '0', 'Classic Auto Wire 70 NO Blue 30 Meter Fareed ', '5080', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (669, '671', '0', '3/29 Million Extreme white Fareed', '2981', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (670, '672', '0', 'D.C Blub Trend Emaan', '120', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (671, '673', '0', ' 12 Watt Led Conciled Emaan', '600', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (672, '674', '0', 'Led 18 watt counciled Emaan', '800', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (673, '675', '0', 'Panel Light Sada Emaan', '70', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (674, '776', '0', '8+2 Mesco China Sheet Emaan', '506', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (675, '677', '0', '6+2 mesco China Sheet Emaan', '495', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (676, '678', '0', '2+2 masco China Sheet Emaan', '306', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (677, '679', '0', ' 2+1 masco China Sheet Emaan', '279', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (678, '680', '0', 'M+F masco China Sheet Emaan', '356', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (679, '681', '0', 'P+P masco China Sheet Emaan', '330', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (680, '682', '0', 'B+P masco China Sheet Emaan', '270', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (681, '683', '0', '18 Watt Led Blub G.1 Emaan', '350', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (682, '684', '0', 'Daichi Ice Light 11 Watt D.C Emaan', '380', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (683, '685', '0', 'Daichi Ice Light 12 Watt Emaan', '380', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (684, '686', '0', 'Daichi Down Light 7 Watt Emaan', '270', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (685, '687', '0', 'Daichi Down Light 7 Watt D.C Emaan', '250', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (686, '688', '', 'Daichi down Light A.C 11 Watt', '380', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (687, '689', '0', '4+2 Masco China sheet Emaan', '306', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (688, '690', '0', 'Tube light 36 Watt single factor G.1', '850', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (689, '691', '0', '36w Open light ice  G.1', '1420', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (690, '692', '0', '24w Open ice light G.1', '1120', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (691, '693', '0', ' 12 watt Led Bulb lifi B 22 G.1', '150', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (692, '694', '0', '12 watt Led bulb lifi E 27 G.1', '150', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (693, '695', '0', 'Down light 7 watt 3in1 brightit G.1', '300', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (694, '696', '0', '10w 6+3 Ice light G.1', '620', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (695, '697', '0', '12w Ice light G.1 ', '420', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (696, '698', '0', 'Ice light royal G.1', '310', 'pcs', '0', '', ' ', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (697, '699', '0', '18 watt Led bulb E 27 G.1', '340', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (698, '700', '0', 'Down light 8 watt B.J G.1', '180', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (699, '701', '0', 'Tube Light (40 W) Double G.1', '1100', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (700, '703', '', 'Tube light single 30 watt G.1 ', '920', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (701, '704 ', '0', '30 watt Led bulb brightit G.1', '570', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (702, '705', '', 'COB 3 watt G.1 ', '270', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (703, '706 ', '', 'Open light 7 watt G.1', '470', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (704, '707', '0', '12 watt golden lifi G.1', '170', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (705, '708', '0', 'FOX light 100 watt brightit G.1', '2570', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (706, '709', '0', 'Tube Light Double 2 Foot 20w G.1', '520', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (707, '710', '0', 'PVC Tape (B) Paremount', '50', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (708, '711', '0', '100 Watt Blub Paremount', '82', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (709, '712', '0', 'Loha kil 1/12x14 F Ali', '340', 'KG', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (710, '713', '0', 'Loha kil 5 inch 6 inch F Ali', '330', 'KG', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (711, '714', '0', 'Steel Kil China Mix F Ali', '345', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (712, '715', '0', 'Duck pati 3/4 aqua Yayha', '140', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (713, '716', '0', 'Duck pati 1 inch aqua Yayha', '210', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (714, '717', '0', 'Duck pati 25x 40 aqua Yayha', '290', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (715, '718', '0', 'Duck pati 25x25 aqua Yayha', '240', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (716, '720', '0', 'Pipe light single golden Memon ', '100', 'Meter', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (717, '721', '0', 'AC+DC Fan farass 56 inch S.k', '6270', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (718, '722', '0', 'Jungtion box 1 inch (A) Akram', '284', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (719, '723', '0', 'Wire clip 7 MM (A) Cash', '220', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (720, '724', '0', 'Wire clip 8 MM (A) Cash', '260', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (721, '725', '0', 'Wire Clip 6 MM (A) Cash', '200', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (722, '726', '0', 'Solar wire 18 NO 90 meter red Arfeen', '4820', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (723, '727', '0', 'Solar wire 18 NO 90 meter black Arfeen', '4820', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (724, '728', '0', 'PVC Panel 8x10 (C) Moin', '280', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (725, '729', '0', 'Solar Wire Double 4MM Black Chilton  Karachi', '120', 'Foot', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (726, '730', '0', 'Solar Wire Double Core 6MM Black Chilton Karachi', '170', 'Foot', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (727, '731', '0', 'Breaker khangee Fizan', '30', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (728, '732', '0', 'Fan Rod 1/12 Foot (A) Aijaz', '370', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (729, '733', '0', '100MM Cable Tie Fizan', '100', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (730, '734', '0', 'Cable Tie 150 MM Fizan', '140', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (731, '735', '0', 'Cable Tie 200 MM Fizan', '170', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (732, '736', '0', 'Cable Tie 300 MM Fizan', '270', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (733, '737', '0', 'Open Frame power plug Moin', '70', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (734, '738', '0', '2 Pair Million Arfeen', '3630', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (735, '739', '0', '16w Tube Light Dai Sheida Memon ', '420', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (736, '740', '0', 'Solar Plate 180 Watt Cash', '13020', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (737, '741', '0', 'Controler 10 MP Cash', '800', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (738, '742', '0', 'Duck patti  3/4 pak', '130', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (739, '743', '0', 'Comboat Completed Zahid', '9020', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (740, '744', '0', 'Comboat Sit Zahid', '1220', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (741, '745', '0', 'Muslim Shawar Zahid', '1170', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (742, '746', '0', 'Beson Bolt Kit Zahid', '220', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (743, '747', '0', 'West Pipe Zahid', '150', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (744, '748', '0', 'EM Ciling rose small', '550', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (745, '749', '0', 'EM Pendent Holder B22', '510', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (746, '750', '0', 'EM Pendent Holder E27', '550', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (747, '751', '0', 'Fan Box (A) EM', '265', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (748, '752', '0', 'Open Frame 4x4 EM', '108', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (749, '753', '0', 'Open Frame 4x7 EM', '120', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (750, '754', '0', 'EM Piano Switch ', '587', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (751, '755', '0', 'EM Piano Socket', '616', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (752, '756', '0', 'EM Computer Multi', '720', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (755, '759', '0', 'Flexable pipe 3/4 inch (A) salman', '1020', 'Bundel', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (754, '758', '0', 'Flexable Pipe 1 inch (A) salman', '1120', 'Bundel', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (756, '760', '0', 'Shopping Bag  5 KG Cash', '370', 'KG', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (757, '761', '0', 'Dori gitta Cash', '340', 'KG', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (758, '762', '0', ' Cooking Oil Cash', '360', 'KG', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (759, '763', '0', 'Relley 120 Cash', '1070', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (760, '764', '0', 'Panel 11x14 Aqua Cash', '3220', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (761, '765', '0', 'Panel Light  AMP+VOLT Cash', '470', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (762, '766', '0', 'Main Breaker Mora 125 AMP Cash', '2720', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (763, '767', '0', 'Digital Timer Cash', '2520', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (764, '768', '0', '3/29 Pak 26% Safan', '2520', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (765, '769 ', '0', 'Pipe 3/4 Galco Safan', '193', 'Length', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (766, '770', '0', 'Pipe 1 inch Galco Safan', '240', 'Length', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (767, '771', '0', '6 MM Double Black Solar Chilton Karachi', '166', 'Foot', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (768, '777', '0', 'Plastic gitti M.S', '70', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (769, '778', '0', 'Breaker kangee M.S', '30', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (770, '779', '0', '8 MM wire clip (B) M.S', '220', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (771, '780', '0', '5 MM Double red & blue M.S', '118', 'Meter', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (772, '781', '0', 'Earth Breaker 63 M.S', '1120', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (773, '782', '0', '4+2 messco China Sheet Emaan', '471', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (774, '783', '0', 'Wire Clip 4MM (B )Fizan', '130', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (775, '784', '0', 'Wire Clip 6MM (B) Fizan', '155', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (776, '785', '0', 'wire Clip 8MM (B )Fizan', '195', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (777, '786', '0', 'Wire Clip 10MM (B) Fizan', '270', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (778, '787', '0', '0 watt Bulb Fizan', '45', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (779, '788', '0', 'Change over 50 AMP Clipsal Fizan', '1070', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (780, '789', '0', 'Tool Bage + Plass Cash', '1320', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (781, '790', '0', 'Fan Hoke G.I Cash', '110', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (782, '791', '0', 'Plass + Cutter Cash', '1020', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (783, '792', '0', 'UPVC Pipe 4 inch (A) Zahid', '3120', 'Length', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (784, '772', '0', 'Bettry Water Cash', '50', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (785, '773', '0', 'Capisiter 3.5 Fuji Qureshi', '100', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (786, '774', '0', 'Steel Wire Cash', '480', 'KG', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (787, '775', '0', 'Wood Gitti Jumbo Cash', '50', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (788, '793', '0', '7/36 Service Double Alfa 10 KG Jawaid', '3370', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (789, '800', '0', ' 7/64 Service Double (C) Jawaid', '5520', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (790, '801 ', '0', '4w Tube Light Memon ', '370', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (791, '802', '0', '7 Watt Anda Down Light G.1', '300', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (792, '803', '0', '15 WAtt Ice Light G.1', '570', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (793, '805', '0', '22 WAtt Ice Light G.1', '850', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (794, '806', '0', 'Ice Light 15 Watt 3 in1 G.1', '720', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (795, '807', '0', '12 Watt Ice Light 3 in 1 G.1', '600', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (796, '808', '0', '1 Watt Cob G.1', '280', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (797, '809', '0', 'Shadhall 3/4 PVC Fizan', '30', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (798, '810', '0', ' 12 WAtt Bulb Classicon B22 Memon ', '123', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (799, '811', '0', '12 Watt Bulb Classicon E27 Memon ', '123', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (800, '812', '0', '12 Wat D.C Blub AA Memon ', '110', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (801, '813', '0', 'Pipe Light Single Mix Color Memon ', '99', 'Meter', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (802, '814', '0', '12 Watt Blub Golden Nice B22 Memon ', '155', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (803, '815', '0', '12 Watt Blub Golden Nice E27 Memon ', '155', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (804, '816', '0', 'Camera 2 Mega pixel Cash', '5320', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (805, '817', '0', 'Camera 5 mega pixel Cash', '6320', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (806, '818', '0', 'Pilala S.S Cash', '504', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (807, '819', '0', '120 Telephone Double Paremount', '2220', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (808, '820', '0', '18w Ice light brightex Emaan', '420', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (809, '821', '0', '56 Inch Millat Fan A.C Millat Chilton Karachi', '6520', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (810, '822', '0', '8 hole Frame N.S Cash', '140', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (811, '823', '0', '8x10 Panel Loha (B) Abdul Hammed', '1020', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (812, '824', '0', '15x20 Panel Loha Abdul Hammed', '4020', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (813, '825', '0', 'Pipe light Double Mix Colour Memon ', '135', 'Meter', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (814, '826', '0', 'Photo Wall 4 inch Baras Cash', '10020', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (815, '794', '0', 'Pipe 3/4 Vital Qureshi', '160', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (816, '827', '0', 'Pipe 3/4 Imperial New Shahid ', '135', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (817, '828', '0', 'Pipe 1 Inch Imperial New Shahid ', '175', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (818, '829', '0', ' 12 Watt Ice Light Royal Emaan', '300', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (819, '830', '0', ' 200 Watt Bulb General Paremount ', '110', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (820, '831', '0', 'R.G.6 Cable Wire Fizan', '970', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (821, '832 ', '0', '5 MM Double Solar Red/Blue 30 Meter Jawaid', '3220', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (822, '833', '0', ' ARY Pendent Holder B22 E27  Losz Millat ', '45', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (823, '834', '0', '3 Pin shoo 40 AMP Losz Millat ', '95', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (824, '835', '0', 'Male Female EM Losz Millat ', '70', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (825, '836', '0', 'Bed Switch Almezan Losz Millat ', '50', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (826, '837', '0', '40/76 Million Round Losz Millat ', '90', 'Yard', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (827, '838', '0', '3/29 Pak 19% Losz Millat ', '38', 'Yard', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (828, '839', '0', 'PVC Board 1.2 Hol losz Millat ', '34', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (829, '840', '0', 'PVC Board 3.4 Losz Millat ', '40', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (830, '841', '0', 'PVC Board 5.6 Losz Millat ', '45', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (831, '842', '0', '0 Candle Bulb Losz Millat ', '45', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (832, '843', '0', 'Round Block A losz Millat ', '33', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (833, '844', '0', 'Fox Light 100 Watt Orange Cash', '1270', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (834, '845', '0', 'Pipe Solution 300 ML Cash', '870', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (835, '846', '0', 'Ree Blade Cash', '70', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (836, '847', '0', 'Bettry 9 volt Cash', '920', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (837, '848', '0', 'Fan Box (B) White Delux ', '120', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (838, '849', '0', 'Hospital Shadal 3/4 PVC Delux ', '30', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (839, '850', '0', 'Wire Clip 22 MM (B) Delux ', '770', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (840, '851', '0', 'Cable Tie 300 MM (B) Delux ', '270', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (841, '852', '0', '9+1 China Sheet Grande Delux ', '370', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (842, '853', '0', 'Lanter Box 1 inch (B) Losz Delux ', '50', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (843, '854', '0', 'M+F China Sheet Mesco Delux ', '310', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (844, '855', '0', '2+2 China Sheet Mesco Delux ', '305', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (845, '856', '0', '8+2 China Sheet Mesco Delux ', '500', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (846, '857', '0', 'China Demer Grande Delux ', '140', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (847, '858', '0', 'Piano Demer M.s Delux ', '135', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (848, '859', '0', 'Ball Baring 33/11.2 SKF Cash', '14220', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (849, '860', '0', 'ARY MF Loosz Millat ', '190', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (850, '861', '0', '6+2 China Sheet Mesco Delux ', '470', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (851, '862', '0', 'Panel Light Digital Delux ', '175', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (852, '863', '0', 'Panel Breaker D.P 63 (B) Delux ', '377', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (853, '864', '0', 'Fan Rod 1 1/2 Foot  (A) Cash', '240', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (854, '865', '0', 'Fan Rod 2 Foot (A) Cash', '300', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (855, '866', '0', 'Breaker Box (3+4) (A) Moin', '140', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (990, '1014', '', '7/44 Tip Top losz Millat ', '180', 'Yard', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (856, '880', '0', 'Fan Rod 1/12 Fot (A) Majid', '240', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (857, '881', '0', 'Fan Rod 2 Fot (A) Majid', '300', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (858, '882', '', 'Sahar Power Plug 40 AMP Delux', '291', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (859, '883', '', '8+2 Mesco Sheet Delux', '480', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (860, '884', '', '6+2 Mesco Sheet Delux ', '482', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (861, '885', '', '4+2 Mesco Sheet Delux ', '451', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (862, '886', '', '2+2 Mesco Sheet Delux', '297', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (863, '887', '', 'P+P Mesco Sheet Delux ', '317', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (864, '888', '0', 'M+F Mesco Sheet  Delux ', '342', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (865, '889', '', 'TV Mesco Sheet Delux ', '251', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (866, '890', '', 'B+P Mesco Sheet Delux ', '242', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (867, '891', '', '2+1 Mesco Sheet Delux ', '273', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (868, '892', '', '16 MM Silver Flat Chilton Karachi ', '170', 'Meter', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (869, '893', '', '3/4 Pipe GM M.K', '240', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (870, '894', '', 'Pvc Connector 15 AMP M.K ', '1420', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (871, '895', '', 'Pvc Tape Colour M.K  ', '65', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (872, '896', '', '3//29 New Age Chilton Karachi ', '4687', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (873, '897', '', '7/29 New Age Chilton Karachi ', '10053', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (874, '898', '', 'Pvc Elbow 3/4 Old Losz  Millat', '25', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (875, '899', '', 'Pipe Light Single Mix Colour G.1', '93', 'Meter', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (876, '900', '', 'Ice Light Open 32 Watt G.1', '1370', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (877, '901', '', 'Flash Socket 15 AMP  Paramount', '470', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (878, '902', '', 'Bed Switch N tec Paremount ', '400', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (879, '903', '', 'EM Ciling Roz Small Losz Millat ', '60', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (880, '904', '', 'Wire Clip 6 MM Losz Millat', '23', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (881, '905', '', 'Wire Clip 8 MM Losz Millat ', '24', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (882, '906', '', 'Wire Clip 10 MM Losz Millat', '25', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (883, '907', '', 'Wire Clip 14 MM Losz Millat  ', '26', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (884, '908', '', 'Wire Clip 14 MM Losz Millat ', '27', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (885, '909', '', 'Wire Clip 22 MM losz Millat ', '28', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (886, '910', '', 'Band 3/4 White Delux ', '200', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (887, '911', '', 'Junction 1 Inch White Delux', '260', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (888, '912', '', 'Sheet Frame 4 Hole NS Delux', '90', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (889, '913', '', 'Sheet Frame 6 Hole NS Delux ', '100', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (890, '914', '', 'Sheet Frame 8 Hole NS Delux', '110', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (891, '915', '', 'Demer Mesco Delux', '170', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (892, '916', '', 'Flash Socket 30 AMP Delux', '120', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (893, '917', '', 'Panel Light Sada Delux ', '60', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (894, '918', '', 'Panel Light Digital Delux ', '175', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (895, '919', '', 'Door Bell Famous Delux', '170', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (896, '920', '', 'Fan Cover Plate Losz Millat', '40', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (897, '921', '', 'Conciled Box 4x7 (A) Moin ', '70', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (898, '922', '', 'Conciled Box 4x4 (A) Moin ', '60', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (899, '923', '', 'ARY Pendent Holder E27 Return ', '250', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (900, '924', '', 'ARY 3 Pin top 5 AMP Return ', '500', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (901, '925', '', 'Sahar 3 pin top 40 AMP Return ', '820', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (902, '926', '', 'Burq Piano holder B22 Return ', '340', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (903, '927', '', 'Sahar Piano Holder Return', '340', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (904, '928', '', 'Panel light Sada Return ', '55', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (905, '929', '', 'Panel light Digital Return', '170', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (906, '930', '', 'ARY Piano Switch B Return ', '280', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (907, '931', '', 'ARY Piano Socket B Return ', '280', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (908, '932', '', 'Panel Loha 8x10 B Return ', '1220', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (909, '933', '', 'Panel Loha 10x12 B Return ', '1470', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (910, '934', '', 'Panel Loha 12x15 B Return ', '1820', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (911, '935', '', 'Conciled Box 4x7 B Return ', '55', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (912, '936', '', 'conciled Box 4x4 B Return ', '50', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (913, '937', '', 'light Box B Return ', '45', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (914, '938', '', '3w Led COB G.One Return ', '320', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (915, '939', '', '8+2 ECM China sheet Return', '500', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (916, '940', '', '6+2 China sheet ECM Return', '480', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (917, '941', '', 'ARY Jumbo Holder B22 Losz Return ', '70', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (918, '942', '', 'Shiline rose Jumbo Sahar Losz Return', '65', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (919, '943', '', 'COB (3 W) G.1 Return ', '300', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (920, '944', '', '8+2 China Sheet Mesco Return', '570', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (921, '945', '', 'Pipei 3/4 Inch (C) Hi Denci Return ', '90', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (922, '946', '', '3/29 Pak 26% Red Return ', '2520', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (923, '947', '', '100 Watt Blub General Return ', '770', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (924, '948', '', '3/29 Pak 23% Red Return', '2370', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (925, '949', '', '(20 W) LED Bulb Brightit Return', '470', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (926, '950', '', 'Conciled Box 4x7 (A) Return', '90', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (927, '951', '', 'Panel Light Sada Return', '70', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (928, '952', '', '8+2 Mesco Sheet Return', '550', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (929, '953', '', 'Pipe Time star 3/4 inch Return ', '110', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (930, '954', '', 'Pipe new nawab 1inch Return', '100', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (931, '955', '0', 'Junction Box 3/4 (A)  Return ', '40', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (932, '956', '0', 'Junction Box 1/2 (A) Moin Return', '30', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (933, '957', '0', 'Bend 3/4 Decent Return ', '35', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (935, '959', '', '3/29 pak 19% Safan', '1570', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (934, '958', '', 'Bend 1/2 Decent Return', '30', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (936, '960', '', '7/29 pak 19% Safan', '3120', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (937, '961', '', '3/29 Pak 23% Red Safan', '2070', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (938, '962', '', '7/29 Pak 23% Red Safan ', '4120', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (939, '963', '', '3/29 Pak 26% Red Safan ', '2520', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (940, '964', '', '7/29 Pak 26% Red Safan', '5020', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (941, '965', '', 'Telephone Wire 70 No Silver Jawaid', '1720', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (942, '966', '0', '5MM Double Silver Orange Jawaid', '3020', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (943, '967', '0', '6MM Double Silver Wire Orange Jawaid', '3520', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (944, '968', '0', '40/76 Flat Silver Wire Jawaid', '1570', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (945, '969', '0', '3MM Solar Wire Jawaid ', '2120', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (946, '970', '0', '5MM Solar Wire Jawaid', '3220', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (947, '971', '0', '6MM Solar Wire Jawaid R/B', '3720', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (948, '972', '', 'A.c Downlance Iner Cash', '10020', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (949, '973', '', 'Compreser Oil Cash', '320', 'Liter', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (950, '974', '', 'A.C Gass Cash', '2820', 'KG', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (951, '975', '', 'Steel Wire Cash', '560', '', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (952, '976', '0', 'Shopping Bag Cash', '520', 'KG', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (953, '977', '0', 'Duplicate Book Cash', '420', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (954, '978', '', '3/29 G.M Cash', '4420', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (955, '979', '0', 'M+F Opal Cash', '570', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (956, '980', '0', '9+1 Opal Cash', '1000', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (957, '981', '', '3+1 Opal Cash', '570', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (958, '982', '', 'Lux 50 mm Cash', '80', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (959, '983', '', 'Connector Strip 15 AMP Cash', '1820', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (960, '984', '', 'Wood Board 12x15 (A) Cash', '270', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (961, '985', '', 'Wood Board 10x12 (A) Cash', '130', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (962, '986', '', 'Cut Out 15 AMP Delux ', '920', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (963, '987', '', 'Cut Out 30 AMP Delux', '1220', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (964, '988', '', 'Cut Out 60 AMP Delux', '370', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (965, '989', '0', 'Connector 60 AMP Porcelain Delux', '80', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (966, '990', '', 'Telephone Wire 100 No Delux', '1620', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (967, '991', '', 'Telephone Wire 80 No Delux', '1420', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (968, '992', '', 'Change Over 200 AMP Victory Cash', '25220', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (969, '993', '', '56 Inch Millat Fan D.C Millat Chilton Karachi', '9220', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (970, '994', '', '1 Inch Pipe United Shahid', '185', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (971, '995', '', 'pipe 3/4 Zenco Shahid', '126', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (972, '996', '', 'Elbow Plan 3/4 Zahid', '50', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (973, '997', '', '18 Watt Led XAA G.1', '745', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (974, '998', '0', '24 Watt Led XAA G.1', '1120', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (975, '999', '', 'Panel Light 24x24 G.1', '3620', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (976, '1000', '', '5 Watt Led Bulb G.1', '160', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (977, '1001', '0', 'Solar Wire 42 No 90 Meter Return ', '8520', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (978, '1002', '', '28 No 90 Meter Return', '5520', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (979, '1003', '', '7/29 26% Return', '5020', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (980, '1004', '', 'Flexable Pipe 1/14 Inch (A) salman', '1620', 'Bundel', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (981, '1005', '', 'Flexable Pipe 1/12 Inch (A) salman', '1820', 'Bundel', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (982, '1006', '', 'Flexable Pipe 2 Inch (A) salman', '2220', 'Bundel', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (983, '1007', '', 'Brekar Box 8 Hole Salman', '435', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (984, '1008', '', 'Brekar Box 12 Hole Salman', '540', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (985, '1009', '0', 'change over Box Double (B) Salman', '360', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (986, '1010', '0', 'change over Box Double (A) Salman', '460', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (987, '1011', '', 'Band 3/4 Decent Losz Millat', '31', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (988, '1012', '', 'Socket 3/4 Decent  Losz Millat ', '25', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (989, '1013', '0', 'Junction 3/4 (A) Losz Millat', '36', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (991, '1117', '0', 'Lux 10 MM Royal Electric', '37', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (992, '1015', '0', 'Lux 16 MM Royal Electric', '40', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (993, '1016', '0', 'Lux 25 MM Royal Electric', '50', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (994, '1017', '0', 'Lux 35 MM Royal Electric', '65', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (995, '1018', '0', 'Lux 50 MM Royal Electric', '85', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (996, '1019', '0', 'Lux 70 MM Royal Electric', '115', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (997, '1020', '0', 'Lux 150 MM Royal  Electric', '240', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (998, '2021', '0', 'Lux 300 MM Royal Electric', '720', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (999, '1021', '0', 'Lux 120 MM Royal Electric', '200', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1000, '1022', '0', 'Tube Light Double 40 Watt (B) Memon', '800', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1001, '1023', '', 'Tube Light 18 Watt Factor Memon', '670', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1002, '1024', '', 'Ice Light Golden Zeco Memon', '300', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1003, '1025', '', 'Fan G.M.C A.C D.C Memon', '5900', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1004, '1026', '', 'Bettry Water M.ALi', '50', 'Liter', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1005, '1027', '', '7/29 Tip Top Red Losz Millat ', '85', 'Yard', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1006, '                           ', '', '    ', '0', '', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1007, '1028', '', 'D.C Brekar 63 AMP Qadir ', '1320', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1008, '1029', '', 'Chanal Patti 60x60 Qadir', '920', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1009, '1030', '', '25 MM Solar Wire Qadir', '295', 'Foot', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1010, '1031', '', 'panel Open 12x18 Qadir ', '4220', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1011, '1032', '', 'Opass Change Over 32 102 Delux', '1420', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1012, '1033', '', 'Opass Change over 50 A 102 Delux', '2420', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1013, '1034', '', 'Piano Demer Sahar Delux', '175', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1014, '1035', '', 'Wire Clip 20 MM Losz Millat ', '26', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1015, '1036', '', 'Voltage Protector Mora Qadir', '2820', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1016, '1037', '', 'Flexible Pipe 1/2 Losz Millat ', '29', 'Foot', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1017, '1038', '', 'Flexible Pipe 3/4 Losz Millat ', '30', 'Foot', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1018, '1039', '', 'Flexible Pipe 1 Inch Losz Millat ', '32', 'Foot', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1019, '1040', '', 'Flexible Pipe 1x1/2 Losz Millat ', '38', 'Foot', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1020, '1041', '', 'Flexible Pipe 2 Inch Losz Millat ', '45', 'Foot', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1021, '1042', '0', '4 MM Solar Wire Single Chilton Karachi', '13790', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1022, '1043', '', 'Scrow 1x1/2 Losz Millat ', '40', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1023, '1044', '', 'Scrow 2 Losz Millat ', '45', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1024, '1045', '', 'Scrow 2x1/2 Losz Millat ', '50', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1025, '1046', '', 'Scrow 3 Inch Losz Millat ', '70', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1026, '1047', '', 'Wire Clip 4 MM Losz Millat', '44', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1027, '1048', '', 'A.C AutorCash', '25020', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1028, '1049', '', 'Duck Patti 40x40 Qadir', '770', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1029, '1050', '0', 'Change Over 102 Globe Fizan', '570', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1030, '1051', '', 'Bowl Sink 14x17 Zahid ', '1820', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1031, '1052', '', 'Wash Besson Set Zahid ', '4220', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1032, '1053', '', 'Cable Tie 150 No Delux', '150', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1033, '1054', '', 'T.P Brekar 3 Phase 100 AMP Delux', '1620', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1034, '1055', '', 'D.P Brekar 63 AMP (A) Delux ', '720', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1035, '1056', '', 'AMP+ Volt Meter Digital ', '470', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1036, '1057', '', 'Protector Mora Qadir ', '2120', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1037, '1058', '', 'Connector Mc4 Qadir', '220', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1038, '1059', '', 'Solar Wire 25 MM Single Qadir ', '295', 'Foot', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1039, '1060', '', 'Open Frame 4x7 M.s', '58', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1040, '1061', '', 'Panel Light Sada M.s', '70', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1041, '1062', '', '8+2 Sheet Sangam M.s', '491', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1042, '1063', '', '2+2 Sheet Sangam M.s', '340', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1043, '1064', '', 'M+F Sheet Sangam M.s', '370', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1044, '1065', '', 'Iron Connector M.s', '120', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1045, '1066', '', 'Ice Light 12 watt Berg G.1 ', '300', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1046, '1067', '', '60 Watt Led Bulb Brightit G.1', '1095', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1047, '1068', '', '40 Watt Led Bulb Brightit G.1', '790', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1048, '1069', '', 'Open Light 12 Watt Chapati G.1', '620', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1049, '1070', '', 'D.C D.P63 AMP Brekar Cash', '1520', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1050, '1071', '', 'AMP+Volt Meter Digital Cash', '570', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1051, '1072', '', 'Washer Cash', '170', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1052, '1073 ', '', '3 MM Solar Wire Red Cash', '2020', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1053, '1074', '0', 'Wire Clip 25 MM Fizan', '870', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1054, '1075', '0', 'Wire Clip 25 MM Losz Milat ', '28', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1055, '1076', '', 'Band 1 Inch A Akram ', '212', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1056, '1077', '', 'Socket 1 Inch A Akram ', '118', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1057, '1078', '', 'Socket 1 Inch B Akram', '98', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1058, '1079', '', '7/52 Single silver (B) Fawad', '1120', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1059, '1080', '', '7/64 Single silver (B) Fawad', '1420', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1060, '1081', '', '7/75 Single silver (B) Fawad', '1720', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1061, '1082', '', '7/85 Single silver (B) Fawad', '2020', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1062, '1083', '', 'Telephone 100 no silver (B) Fawad ', '2120', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1063, '1084', '0', '4 MM single Solar Core  XLP/PVC Chilton Karachi', '173', 'Meter', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1064, '1085', '0', 'Bettry 1800 AMP Cash', '53520', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1065, '1086', '0', 'Solar Plate 585 Cash ', '20833', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1066, '1087', '', '63 AMP Brekar A chint M.K ', '1370', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1067, '1088', '', 'Sweet Balushahi Cash', '500', 'KG', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1068, '1089', '', 'Invlup small Cash', '22', '', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1069, '1090', '', '8+2 Sheet Vitti Delux', '820', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1070, '1091', '', '6+2 Sheet Vitti Delux', '720', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1071, '1092', '', 'M+F Sheet Vitti Delux', '520', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1072, '1093', '0', '6 MM Single Solar Core XLP/PVC Chilton Karachi', '240', 'Meter', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1073, '1094', '0', 'Power Plug 40 AMP Big Burq ', '300', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1074, '1095', '', 'Power Plug 40 AMP Small Burq', '300', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1075, '1096', '', 'Jumbo Holder E27 Burq', '804', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1076, '1097', '', 'Panel Light (A)', '100', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1077, '1098', '', 'D.p Brekar 63 AMP M.K', '1470', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1078, '1099', '', 'T.P Brekar Cash', '720', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1079, '1100', '', 'Panel Loha 20x25 Cash ', '2520', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1080, '1111', '', 'Fox Light Stand S.E', '670', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1081, '1112', '', 'Jumbo Holder E27 Burq Losz Millat', '86', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1082, '1113', '', 'Wire Clip 7MM (B) Fizan', '185', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1083, '1114', '', 'Wire Clip 12MM (B) Fizan', '320', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1084, '1115', '0', 'Wire Clip 14MM (B) Fizan', '445', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1085, '1116', '', 'Wire Clip 16MM (B) Fizan', '545', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1086, '1118', '', 'Wire Clip 20MM (B) Fizan', '670', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1087, '1119', '', '6MM Million Classic Red Return', '16020', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1088, '1120', '', 'Classic Auto Wire 70 NO Red 30 Meter Return', '5420', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1089, '1121', '', 'Change Over 200 AMP Return', '26220', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1090, '1122', '', 'panel Open Loha 14x18 Qadir ', '3520', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1091, '1123', '', 'T.P Brekar 200 AMP Qadir', '7520', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1092, '1124', '0', 'Inverter Crown 3KV Qadir', '88020', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1093, '1125', '', 'Voltage Protector (B) Qadir ', '1820', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1094, '1126', '0', 'AMP+Volt Meter Qadir ', '470', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1095, '1127', '', '4 MM Single Wire Cash', '240', 'Yard', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1096, '1129', '', 'Voltage Protector (A) Qadir ', '1970', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1097, '1130', '', '63 AMP D.C Brekar Qadir ', '1770', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1098, '1131', '', 'Iron Lead Paremount', '120', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1099, '1132', '', 'Kil 1 inch China Losz Millat', '42', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1100, '1133', '', 'Kil 1/12 inch China Losz Millat', '50', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1101, '1134', '', 'EM Jumbo ciling rose Losz Millat', '65', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1102, '1135', '', 'Washer Cash', '170', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1103, '1136', '', 'PVC pipe 1 inch (B) M.S ', '130', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1104, '1137', '', '6MM Double Orange Losz Millat ', '140', 'Yard', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1105, '1138', '', 'EM switch Socket 40Amp() losz Millat', '120', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1106, '1139', '', 'Piano switch socket Losz Millat', '60', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1107, '1140', '', 'EM Pendent Holder E27 Losz Millat ', '55', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1108, '1141', '', 'Olympic 06 Hol Faram M.s', '140', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1109, '1142', '', 'Wire Clip 5 MM (B) Delux', '140', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1110, '1143', '', '8+2 sheet visi Delux', '840', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1111, '1144', '', '2+2 sheet visi Delux', '450', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1112, '1145', '', '4+2 sheet visi Delux', '570', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1113, '1146', '', 'M+F sheet visi Delux', '550', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1114, '1147', '', '3+G sheet visi Delux', '450', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1115, '1148', '', 'P+P sheet visi Delux', '550', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1116, '1149', '', '7/29 Pakistan Cable Cash ', '10020', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1117, '1151', '', 'Fox Light (200 W) Zarcon G.1()', '11520', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1118, '1152', '', 'Fox Light (100 W) Moon G.1', '5020', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1119, '1153', '', 'Ice Light 9 Watt 6+3 G.1', '620', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1120, '1154', '', 'Pipe 1 Inch New Nawab M.S', '130', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1121, '1155', '', 'Switch Socket Abid Cash ', '470', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1122, '1156', '', 'Button Holder Abid Cash', '70', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1123, '1157', '', 'Terali Tyre Completed Zahid', '1820', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1124, '1158', '', 'Burq B22 to E27 Convertor Losz Millat ', '50', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1125, '1159', '', 'Opass Change over 50 AMP 102 Qadir ', '2420', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1126, '1160', '', 'Open Panel 12x15 G.i Abdul Hammed', '2420', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1127, '1161', '', 'Wood Gitti Losz Millat ', '30', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1128, '1162', '', '6 MM H.M Standard Chilton Karachi', '17553', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1129, '1163', '', 'Wood Board 4x4 Loose Millat ', '20', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1130, '1164', '', 'Wood Board 4x7 loose Millat ', '30', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1131, '1165', '', 'Wood Board 6x8 Loose Millat ', '40', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1132, '1166', '', 'Wood Board 8x10 Loose Millat ', '50', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1133, '1167', '', 'Wood Board 10x12 Loose Millat ', '70', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1134, '1168', '', 'Wood Board 12x15 Loose Millat ', '250', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1135, '1169', '0', 'Inverter 5.6 KG Crown Qadir ', '165200', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1136, '1170', '', 'Solar Wire 35 MM Qadir ', '390', 'Foot', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1137, '1172', '0', 'Loha Kil 2x12 F Ali', '320', 'KG', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1138, '1173', '', 'ARY Multi Plug (A) losz Millat', '170', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1139, '1174', '', 'Sheet Frame 6 Hole NS paremount', '140', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1140, '1175', '', 'Asim switch porcelain base 10Amp Losz Millat ', '66', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1141, '1176', '', 'China Socket Delux', '60', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1142, '1177', '', 'Kil 2 Inch China Losz Millat', '50', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1143, '1178', '0', 'EM Jumbo Holder E27', '765', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1144, '1179', '', 'EM Jumbo power Plug ', '301', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1145, '1180', '', 'EM Small power Plug ', '301', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1146, '1181', '', 'Viper Cash', '395', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1147, '1182', '', 'Surf XL1/2 KG Cash', '314', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1148, '1183', '', 'Bleach Bottle Cash', '235', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1149, '1184', '', 'AMP+VOLT Meter Cash ', '370', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1150, '1185', '', 'D.C Men Brekar Shinider  Cash ', '1170', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1151, '1186', '', 'Protector  Sahara Cash', '2020', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1152, '1187', '', 'Frame 4x4 B Return ', '80', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1153, '1188', '', 'ARY Button Holder losz Return ', '70', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1154, '1189', '', 'Brekar 16 AMP Trend Return ', '370', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1155, '1190', '', 'Round Block losz Return ', '40', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1156, '1191', '0', 'Open Frame 6 Hole Return ', '170', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1157, '1192', '', 'Olympic Frame 6 Hole Return ', '140', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1158, '1193', '', 'Asim Switch Socket  losz Return ', '50', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1159, '1194', '', 'Change over 200 AMP Victory Return ', '25170', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1160, '1195', '', 'M+F Double Sheet Clipsal M.K', '2920', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1161, '1197', '', 'M+F Single Sheet Clipsal M.K', '1091', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1162, '1198', '', 'M+F Power Plug Clipsal M.K', '1170', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1163, '1199', '', '3 Pin 30 AMP Jeeko M.K', '220', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1164, '1200', '', '3 Pin 10 AMP Jeeko M.K', '140', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1165, '1201', '', 'Connector Strip 100 AMP M.K ', '620', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1166, '1202', '', 'T.P Change Over 60 AMP Victory M.K ', '6720', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1167, '1203', '', 'Open Panel 15x20 Cash', '3520', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1168, '1204', '', '60 Watt Tube Light Osaka Cash ', '1370', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1169, '1205', '', '2 pair Million Cash', '3620', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1170, '1206', '', 'Breakit Fan Royal M.Z', '7420', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1171, '1207', '', 'Breakit Fan 12 Inch S.K', '6520', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1172, '1208', '', 'Breakit Fan 12 Inch Royal S.K ', '5420', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1173, '1209', '', 'Solar Wire 12 No 90 Mtr Black Return', '4820', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1174, '1210', '', 'Plastic Paris Cash ', '47', 'KG', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1175, '1211', '', 'Scriper Cash', '45', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1176, '1212', '', 'Pipe 1 inch Jadda  ', '290', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1177, '1213', '0', '2 Pin Mesco Alfa', '350', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1178, '1214', '', '2 Pin Super Alfa', '330', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1179, '1215', '', 'Tester AFCO 888 Alfa', '360', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1180, '1216', '', 'Solar wire 12 No Solar Link 30Mtr Blue Arfeen', '920', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1181, ' 1217', '', 'Solar wire 12 No Solar Link 30Mtr Red Arfeen', '920', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1182, '1217', '', 'Duck patti Aqua 40/40 Cut Yayha', '580', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1183, '1218', '', 'Distemper brush 3 inch Haroon', '185', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1184, '1219', '', 'Telephone Silver Wire 200 No Cash', '4420', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1185, '1220', '', 'Telephone Silver Wire 200 No Fizan', '4020', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1186, '1221', '0', 'Sab Meter Cash', '1020', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1187, '1222', '', 'Wire Clip 32 MM M.K', '1370', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1188, '1223', '', '6MM Solar Wire R/B Fawad ', '3920', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1189, '1224', '', 'Nut Bolt 1 1/2 Inch Cash ', '40', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1190, '1225', '', 'Nut Bolt 1 Inch Cash ', '36', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1191, '1226', '', 'Cash Sale Mix Item Cash', '41020', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1192, '1227', '', 'ARY 3 Pin Shoo 5 AMP Losz Millat ', '60', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1193, '1228', '', 'PVC Board M.F Losz Millat ', '40', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1194, '1229', '', 'Conciled Wall 3/4 Zahid', '720', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1195, '1230', '0', 'Elbow Brass 3/4x12 Zahid', '170', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1196, '1231', '', 'Cock Brass Zahid ', '770', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1197, '1232', '', 'Steel Kil Zahid', '420', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1198, '1233', '', 'Washer Zahid', '220', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1199, '1234', '', 'Tee Brass 3/4x12 Zahid', '170', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1200, '1235', '', 'W.C Small Zahid ', '1570', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1201, '1236', '', 'Tee Y UPVC 4 Inch Zahid', '450', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1202, '1237', '', 'Elbow 45c% Zahid', '220', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1203, '1238', '', 'Shawar Steel Zahid ', '520', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1204, '1239', '', 'Al daraf Zahid ', '470', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1205, '1240', '', 'Tower Bolt Zahid ', '110', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1206, '1241', '', 'Patti Zahid', '80', 'Foot', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1207, '1242', '', 'Scrow 1 Inch Zahid ', '240', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1208, '1243', '', 'Slide Zahid', '70', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1209, '1244', '', 'Weel Zahid ', '70', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1210, '1245', '', 'Ring Zahid ', '90', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1211, '1246', '', '3 Pin 20 AMP Jeeko M.K', '205', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1212, '1247', '', '4 MM Single Flexible Universal ', '170', 'Meter', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1213, '1248', '', '7/36 Million MM Red Return', '8020', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1214, '1249', '0', 'Change over 50 AMP Clipsal Return', '1870', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1215, '1250', '', 'Setring Wire F Ali', '322', 'KG', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1216, '1251', '', 'Steel Wire F Ali ', '520', 'KG', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1217, '1252', '', 'Panel Brekar Small Moin ', '370', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1218, '1253', '', '1+1 Sheet Clipsal Universal', '384', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1219, '1254', '', 'M+F Sheet Clipsal Universal', '520', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1220, '1255', '', 'P+P Sheet Clipsal Universal', '570', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1221, '1256', '', 'A.C Breaker Wintop Fawad ', '340', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1222, '59215232', '', 'Telephone 200 no silver Fawad', '3520', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1223, '1257', '', 'Telephone 250 no silver Fawad', '4020', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1224, '1258', '', '3/29 Million Classic Red Fareed', '4175', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1225, '1259', '', '3/29 Million Classic Black  Fareed', '4175', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1226, '1260', '', '3/29 Million Classic Mix Colour Fareed', '4175', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1227, '1261', '', '7/29 Million Classic Red Fareed', '8861', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1228, '1262', '', '7/29 Million Classic Black Fareed', '8861', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1229, '1263', '', '7/29 Million Classic Colour Fareed', '8861', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1230, '1264', '0', '7/52 Million Classic Red Fareed', '27645', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1231, '1265', '0', '7/52 Million Classic Black Fareed', '27645', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1232, '1266', '0', '7/64 Million Classic Red Fareed', '43745', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1233, '1267', '0', '7/64 Million Classic Black Fareed', '43745', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1234, '1268', '', '4 hol Mesco Sheet Frame Zahid ', '220', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1235, '1269', '', '6 Hol Mesco Sheet Frame Zahid', '320', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1236, '1270', '', 'Olympic 2 hol Sheet Frame ', '105', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1237, '1271', '', 'Olympic 3 Hol Sheet Frame ', '114', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1238, '1272', '', 'Olympic 4 hol Sheet Frame ', '114', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1239, '1273', '', 'Olympic 5 Hol Sheet Frame ', '127', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1240, '1274', '', 'Olympic 6 Hol Sheet Frame ', '127', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1241, '1275', '', 'Olympic 8 Hol Sheet Frame ', '148', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1242, '1276', '', '12x15 base ', '3420', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1243, '1277', '', 'Visit Sheet 8+2  ', '850', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1244, '1278', '0', 'Visit Sheet 6+2 Delux', '850', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1245, '1279', '0', 'Visit M+F Sheet Frame Delux', '515', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1246, '1280', '0', 'Visit P+P Sheet Frame Delux', '505', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1247, '1281', '0', 'Visit TV Sheet Frame Delux', '515', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1248, '1282', '0', 'Visit 2+2 Sheet Frame Delux', '480', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1249, '1283', '0', 'Visit 1 Gang Sheet Frame Delux', '310', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1250, '1284', '', '40w Tube light single G.One ', '1070', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1251, '1285', '', '3/29 Tip Top 27 % losz Millat ', '50', 'Yard', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1252, '1286', '', 'M+F Double K.M Delux', '770', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1253, '1287', '', 'D.C Bulb Osaka Universal ', '300', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1254, '1288', '', 'P.V.C Tape Osaka Universal ', '63', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1255, '1289', '0', 'Tube light Double 54 W Universal', '1420', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1258, '1292', '0', '25 MM X4 Silver Wire Chilton Karachi', '620', 'Meter', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1257, '1291', '0', 'Wire Clip 32 MM Losz Millat', '34', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1259, '1293', '', '3 MM Solar Wire Red Losz Millat ', '100', 'Yard', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1260, '1294', '', '6 MM Single Wire Qadir', '90', 'Foot', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1261, '1295', '', 'A.C Brekar 63 AMP Qadir', '970', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1262, '1296', '0', 'Scrow 2x1/2 Inch Paremount', '220', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1263, '1297', '', 'Breakit Fan 12 Inch S.K Cash', '6520', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1264, '1298', '', 'I Lux Cash', '620', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1265, '1299', '', '3/29 Million Classic Return', '4520', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1266, '1300', '', 'Pipe Light Blue Return ', '106', 'Meter', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1267, '1301', '', '12MM Double Solar Wire R/B Jawaid', '5820', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1268, '1302', '', '5MM Double Orange Losz Millat ', '120', 'Yard', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1269, '1303', '', 'Cash Sale Bill Farq Bill No 9 Cash', '10020', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1270, '1304', '0', 'Loha kil 5 inch losz Millat ', '26', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1271, '1305', '', 'Loha kil 6 inch losz Millat ', '28', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1272, '1306', '', 'Breaker kangee losz Millat ', '20', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1273, '1307', '', 'Cable Tie 14 Inch Fizan', '300', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1274, '1308', '', 'Cable Tie 12 Inch Fizan', '220', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1275, '1309', '', 'Cable Tie 6 Inch M.K ', '170', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1276, '1310', '', 'A.C Brekar Bush Arfeen', '470', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1277, '1311', '', 'Tube Light 36 Watt Trend G.1', '870', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1278, '1312', '', 'CoB 1 Watt S.E', '230', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1279, '1313', '', 'Wire Clip 22 MM Paremount', '870', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1280, '1314', '', 'Scrow 3 Inch Black Paremount', '310', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1281, '1315', '0', 'Wire Clip 10 MM Paremount', '340', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1282, '1317', '', 'Mega Breakit Fan 24 Inch S.K Cash', '13020', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1283, '1318', '0', 'Breakit Fan 12 Inch Royal M.S', '5420', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1284, '1319', '0', 'Solar Wire Single 70 No (B) Fizan', '2420', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1285, '1320', '', 'Stabilizer 10000 W Universal Cash', '28020', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1286, '1321', '', 'Lusx Bio Metal 300 MM Royal', '1340', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1287, '1322', '', 'Lusx Bio Metal 150 MM Royal', '680', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1288, '1323', '', 'Lusx Bio Metal 120 MM Royal ', '620', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1289, '1324', '', 'Lusx J.m 6 MM Royal', '35', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1290, '1325', '', 'I Lusx 6 MM Royal ', '680', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1291, '1326', '', '6 MM 2 Core R/B Cash', '3920', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1292, '1327', '', 'Fan Box (B) Akram', '1340', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1293, '1328', '', '25 MM X 4 Core Silver Wire Return', '720', 'Meter', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1294, '1329', '', 'A.C Brekar Belco 20 AMP Return', '395', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1295, '1330', '', 'Junction Box G.M 3/4 M.K', '470', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1296, '1331', '', 'Junction Box G.M 1 Inch M.K', '520', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1297, '1332', '0', 'Bend 3/4 G.M M.K', '260', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1298, '1333', '', 'Socket 3/4 G.M M.K', '130', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1299, '1334', '', 'Socket 1Inch G.M M.K ', '220', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1300, '1335', '', 'Connector Strip 30 AMP M.K ', '170', 'dozen', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1301, '1336', '', 'Open Panel 12x18 Return', '4520', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1302, '1337', '', '6MM Solar Wire R/B Losz Millat', '150', 'Yard', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1303, '1338', '', 'Cut Out 30 AMP losz millat', '110', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1304, '1339', '', 'Brekar 4x4 20 AMP Aqua Cash', '1020', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1305, '1340', '', 'Oil Paint C Green Cash', '3520', 'gallan ', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1306, '1341', '', '4 MM single P.V.C P.V.C Chilton Karachi', '167', 'Meter', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1307, '1342', '', '4 MM Single P.V.C Chilton Karachi ', '152', 'Meter', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1308, '1343', '', 'Band 3/4 G.M Return', '44', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1309, '1344', '', 'Socket 1 Inch G.M Return', '45', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1310, '1345', '', 'Socket 3/4 G.M Return', '37', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1311, '1346', '', 'Junction 1 Inch G.M Return', '66', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1312, '1347', '0', 'Shadal 3/4 (A) Return', '1020', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1313, '1348', '', 'Flexible Pipe 1/2 (A) Return', '1020', 'Bundel', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1314, '1349', '', '1 MM Wire G.M Return', '3520', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1315, '1350', '', 'Burq Piano Holder B22 Losz Millat ', '54', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1316, '1351', '', 'Band 1 Inch A Losz Millat', '36', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1317, '1352', '', '12 Watt Bulb Oshan Memon', '130', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1318, '1353', '', '4 hol faram Olymphic M.S ', '110', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1319, '1354', '', 'Abid Pendent Holder E27 M.S', '80', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1320, '1355', '', 'Connector 100 AMP Porcelian M.S', '120', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1321, '1356', '', 'Connector 100 AMP Plastic M.S', '520', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1322, '1357', '', 'Pipe 1 Inch (B) M.S', '140', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1323, '1358', '', 'Band 1 Inch White M.S', '2020', 'Gross', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1324, '1359', '', 'Socket 1 Inch White M.S', '1020', 'Gross', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1325, '1360', '', 'Pipe 1/12 G.M M.K', '620', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1326, '1361', '', 'Socket 1/12 G.M M.K ', '50', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1327, '1362', '', 'Band 1/12 G.M M.K ', '90', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1328, '1363', '', 'PVC Pipe Clip 1/12 (A) G.M M.K ', '80', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1329, '1364', '', '7/29 G.M M.K ', '10570', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1330, '1365', '', 'Change over Victory 60 AMP 102 M.K ', '4020', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1331, '1366', '', 'Glue Zahid', '370', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1332, '1367', '', 'Brush Oil Paint Zahid ', '220', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1333, '1368', '', 'Steel Jali 4 Inch Zahid', '150', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1334, '1369', '', 'Wire Clip 7 MM Paremount', '220', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1335, '1370', '', 'T.P Brekar 63 AMP Trend Paremount', '1020', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1336, '1371', '', 'Motor Pamp Complete Cash', '14520', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1337, '1372', '', 'Breaker T.P Shenrider 100 AMP Return', '11020', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1338, '1101', '', 'Solding Iron cash item', '420', 'nos', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1339, '1102', '', 'Wood gutty cash item', '50', 'packet', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1340, '1103', '', 'Solding pest', '70', 'pcs', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1341, '1104', '', '23/76 Round Aziz', '8451', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1342, '1105', '', '40/76 Round Aziz ', '13350', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1343, '1106', '', '110/76 Round 3core Aziz', '32309', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1344, '1107', '', '3/29 Dynamic Aziz', '4523', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1345, '1108', '0', '7/29 Dynamic  Aziz ', '9538', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1346, '1109', '', '6 mm Dynamic Aziz', '18295', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);
INSERT INTO `product_information` (`id`, `product_id`, `category_id`, `product_name`, `price`, `unit`, `tax`, `serial_no`, `product_model`, `product_details`, `image`, `status`) VALUES (1347, '1110', '', '6 mm Flex Dynamic Aziz', '20228', 'coil', '0', '', '', '', 'http://millattraders.com/saleserp/my-assets/image/product.png', 1);


#
# TABLE STRUCTURE FOR: product_purchase
#

DROP TABLE IF EXISTS `product_purchase`;

CREATE TABLE `product_purchase` (
  `id` int NOT NULL AUTO_INCREMENT,
  `purchase_id` bigint NOT NULL,
  `chalan_no` varchar(100) NOT NULL,
  `supplier_id` bigint NOT NULL,
  `grand_total_amount` decimal(12,2) NOT NULL DEFAULT '0.00',
  `paid_amount` decimal(10,2) DEFAULT '0.00',
  `due_amount` decimal(10,2) DEFAULT '0.00',
  `total_discount` decimal(10,2) DEFAULT NULL,
  `purchase_date` varchar(50) DEFAULT NULL,
  `purchase_details` text,
  `status` int NOT NULL,
  `bank_id` varchar(30) DEFAULT NULL,
  `payment_type` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `purchase_id` (`purchase_id`),
  KEY `supplier_id` (`supplier_id`)
) ENGINE=MyISAM AUTO_INCREMENT=233 DEFAULT CHARSET=utf8mb3;

INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (1, '20240124145509', '1', '1', '26880.00', '0.00', '26880.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (2, '20240124145800', '2', '2', '71200.00', '0.00', '71200.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (3, '20240124152118', '3', '3', '142910.00', '0.00', '142910.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (4, '20240124154656', '4', '4', '152500.00', '0.00', '152500.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (5, '20240127150504', '5', '7', '30350.00', '30350.00', '0.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (6, '20240127152129', '6', '8', '94560.00', '0.00', '94560.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (7, '20240127161005', '7', '9', '47450.00', '0.00', '47450.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (8, '20240128104627', '8', '10', '210085.00', '0.00', '210085.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (9, '20240128113240', '9', '11', '809650.00', '0.00', '809650.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (10, '20240128115259', '10', '13', '26960.00', '0.00', '26960.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (11, '20240128122919', '11', '14', '181350.00', '0.00', '181350.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (12, '20240128140222', '12', '15', '43245.00', '0.00', '43245.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (13, '20240128141713', '14', '18', '44450.00', '0.00', '44450.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (14, '20240128142633', '13', '16', '80500.00', '0.00', '80500.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (15, '20240128145546', '16', '20', '33020.00', '0.00', '33020.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (16, '20240128150010', '15', '19', '73276.00', '0.00', '73276.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (17, '20240128151840', '17', '22', '75630.00', '0.00', '75630.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (18, '20240129142817', '18', '23', '187760.00', '0.00', '187760.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (19, '20240129154322', '19', '24', '1996120.00', '0.00', '1996120.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (20, '20240130154304', '20', '25', '207610.00', '0.00', '207610.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (21, '20240130155908', '11', '14', '15870.00', '0.00', '15870.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (22, '20240131144117', '21', '26', '66780.00', '0.00', '66780.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (23, '20240131153527', '22', '27', '79750.00', '0.00', '79750.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (24, '20240201145453', '23', '28', '123946.00', '0.00', '123946.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (25, '20240201155743', '28', '29', '204765.00', '0.00', '204765.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (26, '20240203141705', '25', '30', '296170.00', '0.00', '296170.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (27, '20240203150856', '26', '31', '321600.00', '0.00', '321600.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (28, '20240204162308', '26', '31', '1686807.00', '0.00', '1686807.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (29, '20240205145350', '26', '31', '297401.00', '0.00', '297401.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (30, '20240205154059', '26', '31', '436300.00', '0.00', '436300.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (31, '20240205160956', '27', '32', '145946.00', '0.00', '145946.00', '0.80', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (32, '20240205171507', '26', '31', '89600.00', '0.00', '89600.00', '0.00', '2023-12-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (33, '20240210151559', '42', '33', '76311.00', '0.00', '76311.00', '0.00', '2024-01-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (34, '20240210154644', '42', '33', '7612.00', '0.00', '7612.00', '0.00', '2024-01-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (35, '20240210161624', '42', '33', '38250.00', '0.00', '38250.00', '0.00', '2024-01-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (36, '20240213150708', '28', '49', '168120.00', '0.00', '168120.00', '0.00', '2024-01-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (37, '20240213163024', '29', '40', '11310.00', '0.00', '11310.00', '0.00', '2024-01-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (38, '20240214120913', '36', '43', '124880.00', '0.00', '124880.00', '0.00', '2024-01-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (39, '20240214131722', '38', '45', '142269.00', '0.00', '142269.00', '0.00', '2024-01-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (40, '20240217152346', '40', '47', '441900.00', '0.00', '441900.00', '0.00', '2024-01-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (41, '20240217153045', '39', '46', '30000.00', '0.00', '30000.00', '0.00', '2024-01-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (42, '20240217153659', '37', '44', '158000.00', '0.00', '158000.00', '0.00', '2024-01-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (43, '20240217154738', '27', '39', '10750.00', '0.00', '10750.00', '0.00', '2024-01-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (44, '20240217164057', '41', '48', '126000.00', '0.00', '126000.00', '0.00', '2024-01-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (45, '20240218074400', '43', '34', '45800.00', '0.00', '45800.00', '0.00', '2024-01-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (46, '20240218081020', '44', '50', '83550.00', '0.00', '83550.00', '0.00', '2024-01-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (47, '20240218112422', '38/2', '45', '163360.00', '0.00', '163360.00', '0.00', '2024-02-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (48, '20240218121742', '19/2', '24', '738339.00', '0.00', '738339.00', '824391.00', '2024-02-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (49, '20240218132207', '42/2', '33', '132796.00', '0.00', '132796.00', '0.00', '2024-02-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (50, '20240218143236', '28/2', '29', '435590.00', '0.00', '435590.00', '0.00', '2024-02-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (51, '20240219081530', '29/2', '40', '19790.00', '0.00', '19790.00', '0.00', '2024-02-1', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (52, '20240219083123', '45', '51', '162970.00', '0.00', '162970.00', '0.00', '2024-02-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (53, '20240219084954', '3/2', '3', '0.00', '0.00', '0.00', '0.00', '2024-02-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (54, '20240219094915', '28/2', '49', '177133.00', '0.00', '177133.00', '640.00', '2024-02-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (55, '20240219100856', '8/2', '10', '375560.00', '0.00', '375560.00', '0.00', '2024-02-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (56, '20240219101122', '41/2', '48', '34900.00', '0.00', '34900.00', '0.00', '2024-03-12', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (57, '20240219101430', '6/2', '8', '6336.00', '0.00', '6336.00', '0.00', '2024-02-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (58, '20240224141452', '15/2', '19', '91806.00', '0.00', '91806.00', '0.00', '2024-02-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (59, '20240224143946', '22//2', '42', '25000.00', '0.00', '25000.00', '0.00', '2024-02-24', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (60, '20240224152146', '23/2', '28', '47460.00', '0.00', '47460.00', '0.00', '2024-02-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (61, '20240225073613', '26/2', '31', '320572.00', '0.00', '320572.00', '0.00', '2024-02-22', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (62, '20240229132112', '25/2', '30', '11040.00', '0.00', '11040.00', '0.00', '2024-02-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (63, '20240302094323', '40/2', '37', '61750.00', '0.00', '61750.00', '0.00', '2024-02-29', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (64, '20240303134455', '42/3', '49', '20600.00', '0.00', '20600.00', '0.00', '2024-03-02', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (65, '20240304101147', '43/3', '53', '14735.00', '0.00', '14735.00', '0.00', '2024-03-04', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (66, '20240304150336', '35/3', '49', '28400.00', '0.00', '28400.00', '0.00', '2024-03-04', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (67, '20240306080604', '21/3', '31', '0.00', '0.00', '0.00', '0.00', '2024-03-05', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (68, '20240306081108', '43/3', '53', '14561.00', '0.00', '14561.00', '0.00', '2024-03-06', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (69, '20240306115339', '35/3', '49', '6000.00', '0.00', '6000.00', '0.00', '2024-03-06', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (70, '20240306120253', '25/3', '30', '49320.00', '0.00', '49320.00', '0.00', '2024-03-06', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (71, '20240311094742', '46/3', '54', '6000.00', '0.00', '6000.00', '0.00', '2024-03-07', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (72, '20240311101341', '43/3', '53', '98633.00', '0.00', '98633.00', '0.00', '2024-03-10', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (73, '20240311101927', '47/3', '34', '178104.00', '0.00', '178104.00', '0.00', '2024-03-09', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (74, '20240311102140', '26/3', '31', '44958.00', '0.00', '44958.00', '0.00', '2024-03-09', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (75, '20240311102859', '48/3', '55', '14300.00', '0.00', '14300.00', '0.00', '2024-03-10', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (76, '20240313074325', '28/3', '29', '69100.00', '0.00', '69100.00', '0.00', '2024-03-13', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (77, '20240314145625', '00', '56', '26285.00', '0.00', '26285.00', '0.00', '2024-03-14', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (78, '20240316092326', '00/3', '56', '19695.00', '0.00', '19695.00', '0.00', '2024-03-16', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (79, '20240316123506', '9/3', '11', '2253750.00', '0.00', '2253750.00', '0.00', '2024-03-04', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (80, '20240319123514', '2/3', '2', '22800.00', '0.00', '22800.00', '0.00', '2024-03-16', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (81, '20240319123802', '43/3', '34', '260000.00', '0.00', '260000.00', '0.00', '2024-03-16', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (82, '20240319124136', '29/3', '40', '20200.00', '0.00', '20200.00', '0.00', '2024-03-17', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (83, '20240319154902', '21/3', '26', '57600.00', '0.00', '57600.00', '0.00', '2024-03-17', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (84, '20240319160121', '35/3', '49', '20700.00', '0.00', '20700.00', '0.00', '2024-03-17', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (85, '20240319161245', '35/3', '49', '38240.00', '0.00', '38240.00', '0.00', '2024-03-18', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (86, '20240320073005', '35/3', '49', '53220.00', '0.00', '53220.00', '0.00', '2024-03-19', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (87, '20240320074828', '43/3', '53', '14084.00', '0.00', '14084.00', '0.00', '2024-03-19', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (88, '20240320075630', '42/3', '34', '92000.00', '0.00', '92000.00', '0.00', '2024-03-19', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (89, '20240320092434', '40/3', '37', '43600.00', '0.00', '43600.00', '0.00', '2024-03-20', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (90, '20240320121954', '38/3', '45', '42520.00', '0.00', '42520.00', '0.00', '2024-03-20', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (91, '20240320123450', '28/3', '29', '117250.00', '0.00', '117250.00', '0.00', '2024-03-20', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (92, '20240320152200', '00/3', '56', '38000.00', '0.00', '38000.00', '0.00', '2024-03-20', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (93, '20240321101318', '2/3', '2', '8000.00', '0.00', '8000.00', '0.00', '2024-03-21', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (94, '20240321101603', '35/3', '49', '820.00', '0.00', '820.00', '0.00', '2024-03-21', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (95, '20240321102419', '22/3', '42', '86425.00', '0.00', '86425.00', '0.00', '2024-03-21', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (96, '20240321103010', '44/3', '50', '36050.00', '0.00', '36050.00', '0.00', '2024-03-21', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (97, '20240324153957', '26/3 ', '31', '198280.00', '0.00', '198280.00', '0.00', '2024-04-07', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (98, '20240324160052', '36/3', '43', '45780.00', '0.00', '45780.00', '0.00', '2024-03-24', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (99, '20240324162105', '8/3', '10', '76900.00', '0.00', '76900.00', '0.00', '2024-03-24', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (100, '20240324162713', '49/3', '57', '4550.00', '0.00', '4550.00', '130.00', '2024-03-24', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (101, '20240325082455', '3/3', '3', '0.00', '0.00', '0.00', '0.00', '2024-03-25', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (102, '20240326154004', '50/3', '58', '16900.00', '0.00', '16900.00', '0.00', '2024-03-26', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (103, '20240326154749', '43/3', '53', '62100.00', '0.00', '62100.00', '0.00', '2024-03-26', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (104, '20240327125544', '42/3', '34', '106400.00', '0.00', '106400.00', '0.00', '2024-03-27', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (105, '20240327160150', '35/3', '49', '11200.00', '0.00', '11200.00', '0.00', '2024-03-27', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (106, '20240330073127', '35/3', '49', '30600.00', '0.00', '30600.00', '0.00', '2024-03-28', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (107, '20240330073749', '50/3', '58', '3350.00', '0.00', '3350.00', '0.00', '2024-03-28', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (108, '20240330131005', '38/3', '45', '16350.00', '0.00', '16350.00', '0.00', '2024-03-30', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (109, '20240331160955', '43/3', '53', '16972.00', '0.00', '16972.00', '0.00', '2024-03-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (110, '20240331161838', '50/3', '58', '5625.00', '0.00', '5625.00', '0.00', '2024-03-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (111, '20240331163350', '51/3', '52', '16518.00', '0.00', '16518.00', '0.00', '2024-03-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (112, '20240331163555', '44/3', '50', '18300.00', '0.00', '18300.00', '0.00', '2024-03-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (113, '20240331164423', '28/3', '29', '136010.00', '0.00', '136010.00', '0.00', '2024-03-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (114, '20240401072026', '42/3', '33', '8626.00', '0.00', '8626.00', '0.00', '2024-03-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (115, '20240401072301', '4/3', '4', '96000.00', '0.00', '96000.00', '0.00', '2024-03-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (116, '20240401074101', '35/3', '49', '6470.00', '0.00', '6470.00', '0.00', '2024-03-31', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (117, '20240402162259', '52/3', '59', '537515.00', '0.00', '537515.00', '0.00', '2024-04-02', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (118, '20240403112716', '6/3', '8', '90396.00', '0.00', '90396.00', '0.00', '2024-04-03', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (119, '20240403120907', '53/3', '36', '42600.00', '0.00', '42600.00', '0.00', '2024-04-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (120, '20240403121740', '42/3', '34', '9928.00', '0.00', '9928.00', '0.00', '2024-04-03', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (121, '20240403122257', '25/3', '30', '4840.00', '0.00', '4840.00', '0.00', '2024-04-03', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (122, '20240404072442', '35/3', '49', '263600.00', '0.00', '263600.00', '0.00', '2024-04-03', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (123, '20240404154945', '35/3', '49', '31160.00', '0.00', '31160.00', '0.00', '2024-04-04', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (124, '20240404160614', '19/3', '24', '991248.00', '0.00', '991248.00', '0.00', '2024-04-04', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (125, '20240404162219', '43/3', '53', '14320.00', '0.00', '14320.00', '0.00', '2024-04-04', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (126, '20240406124316', '42/3', '34', '9516.00', '0.00', '9516.00', '0.00', '2024-04-06', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (127, '20240406152118', '18/4', '23', '23240.00', '0.00', '23240.00', '0.00', '2024-04-06', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (128, '20240406152913', '48/3', '55', '5150.00', '0.00', '5150.00', '0.00', '2024-04-06', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (129, '20240406155718', '35/4', '49', '19130.00', '0.00', '19130.00', '0.00', '2024-04-06', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (130, '20240407074527', '54', '60', '19500.00', '0.00', '19500.00', '0.00', '2024-04-06', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (131, '20240408075159', '23/4', '28', '56635.00', '0.00', '56635.00', '0.00', '2024-04-07', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (132, '20240408094723', '00/4', '56', '47600.00', '0.00', '47600.00', '0.00', '2024-04-08', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (133, '20240409075717', '38/4', '45', '12400.00', '0.00', '12400.00', '0.00', '2024-04-08', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (134, '20240409092240', '50/4', '58', '120000.00', '0.00', '120000.00', '300.00', '2024-04-09', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (135, '20240409144517', '45/4', '51', '32000.00', '0.00', '32000.00', '0.00', '2024-04-09', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (136, '20240409144806', '38/4', '45', '9300.00', '0.00', '9300.00', '0.00', '2024-04-09', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (137, '20240414075130', '50/4', '58', '15100.00', '0.00', '15100.00', '0.00', '2024-04-13', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (138, '20240414075501', '43/4', '4', '25400.00', '0.00', '25400.00', '0.00', '2024-04-13', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (139, '20240415103944', '29/4', '40', '8230.00', '0.00', '8230.00', '0.00', '2024-04-15', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (140, '20240415104929', '43/4', '53', '41856.00', '0.00', '41856.00', '0.00', '2024-04-15', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (141, '20240415122939', '35/4', '49', '28190.00', '0.00', '28190.00', '0.00', '2024-04-15', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (142, '20240415132224', '28/4', '29', '83750.00', '0.00', '83750.00', '0.00', '2024-04-15', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (143, '20240416121046', '26/4', '31', '1032340.00', '0.00', '1032340.00', '0.00', '2024-04-16', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (144, '20240416122251', '35/4', '49', '59820.00', '0.00', '59820.00', '0.00', '2024-04-16', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (145, '20240417115239', '38/4', '45', '6300.00', '0.00', '6300.00', '0.00', '2024-04-17', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (146, '20240418073307', '35/4', '49', '9170.00', '0.00', '9170.00', '0.00', '2024-04-17', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (147, '20240420075013', '44/4', '50', '9800.00', '0.00', '9800.00', '0.00', '2024-04-18', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (148, '20240420101648', '42/4', '34', '42104.00', '0.00', '42104.00', '0.00', '2024-04-20', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (149, '20240421120511', '50/4', '58', '173400.00', '0.00', '173400.00', '0.00', '2024-04-21', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (150, '20240421122720', '35/4', '49', '83520.00', '0.00', '83520.00', '2.00', '2024-04-21', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (151, '20240421124629', '45/4', '51', '94000.00', '0.00', '94000.00', '0.00', '2024-04-21', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (152, '20240421160133', '28/4', '29', '1900.00', '0.00', '1900.00', '0.00', '2024-04-21', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (153, '20240422114228', '14/4', '18', '37804.00', '0.00', '37804.00', '52.00', '2024-04-22', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (154, '20240422120615', '15/4', '19', '42314.00', '0.00', '42314.00', '37.00', '2024-04-22', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (155, '20240422151035', '35/4', '49', '1768.00', '0.00', '1768.00', '0.00', '2024-04-22', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (156, '20240423112445', '35/4', '49', '25150.00', '0.00', '25150.00', '0.00', '2024-04-23', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (157, '20240423120446', '00/4', '56', '6980.00', '0.00', '6980.00', '0.00', '2024-04-23', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (158, '20240423120732', '00/4', '56', '25150.00', '0.00', '25150.00', '0.00', '2024-04-23', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (159, '20240423125430', '48/4', '55', '71802.00', '0.00', '71802.00', '0.00', '2024-04-23', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (160, '20240424091801', '35/4', '49', '39850.00', '0.00', '39850.00', '0.00', '2024-04-23', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (161, '20240424105426', '55/4', '61', '7400.00', '0.00', '7400.00', '0.00', '2024-04-24', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (162, '20240425085739', '00/4', '56', '14300.00', '0.00', '14300.00', '0.00', '2024-04-24', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (163, '20240425090059', '9/4', '11', '156000.00', '0.00', '156000.00', '0.00', '2024-04-24', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (164, '20240425091617', '35/4', '49', '11610.00', '0.00', '11610.00', '0.00', '2024-04-24', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (165, '20240425123443', '56', '62', '5600.00', '0.00', '5600.00', '0.00', '2024-04-25', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (166, '20240425130633', '26/4', '31', '87716.00', '0.00', '87716.00', '0.00', '2024-04-25', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (167, '20240425141147', '42/4', '34', '176391.00', '0.00', '176391.00', '0.00', '2024-04-25', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (168, '20240427092247', '52/4', '59', '172400.00', '0.00', '172400.00', '0.00', '2024-04-25', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (169, '20240427093052', '42/4', '34', '70132.00', '0.00', '70132.00', '0.00', '2024-04-25', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (170, '20240427093547', '38/4', '45', '83000.00', '0.00', '83000.00', '0.00', '2024-04-27', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (171, '20240427094225', '40/4', '47', '47895.00', '0.00', '47895.00', '0.00', '2024-04-27', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (172, '20240427104625', '48/4', '55', '0.00', '0.00', '0.00', '0.00', '2024-04-27', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (173, '20240428083925', '53/4', '36', '15600.00', '0.00', '15600.00', '0.00', '2024-04-27', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (174, '20240428134254', '35/4', '49', '44340.00', '0.00', '44340.00', '0.00', '2024-04-28', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (175, '20240430093515', '38/4', '45', '15800.00', '0.00', '15800.00', '535.00', '2024-04-29', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (176, '20240501090900', '48/4', '55', '3055.00', '0.00', '3055.00', '5.00', '2024-04-30', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (177, '20240501122409', '57', '63', '165000.00', '0.00', '165000.00', '0.00', '2024-05-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (178, '20240501124216', '00/4', '56', '13550.00', '0.00', '13550.00', '0.00', '2024-05-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (179, '20240501133112', '45/5', '51', '41350.00', '0.00', '41350.00', '0.00', '2024-05-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (180, '20240501133131', '45/5', '51', '41340.00', '0.00', '41340.00', '10.00', '2024-05-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (181, '20240501133724', '25/5', '30', '8400.00', '0.00', '8400.00', '0.00', '2024-05-01', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (182, '20240502085246', '22/5', '27', '20000.00', '0.00', '20000.00', '0.00', '2024-05-02', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (183, '20240502085541', '9/5', '11', '178500.00', '0.00', '178500.00', '0.00', '2024-05-02', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (184, '20240502095310', '57/5', '63', '9820.00', '0.00', '9820.00', '0.00', '2024-05-02', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (185, '20240502121023', '53/5', '36', '47420.00', '0.00', '47420.00', '0.00', '2024-05-02', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (186, '20240502125329', '19/5', '24', '3704075.00', '0.00', '3704075.00', '0.00', '2024-05-02', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (187, '20240504134344', '38/5', '45', '1500.00', '0.00', '1500.00', '0.00', '2024-05-04', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (188, '20240505110122', '43/5', '53', '187498.00', '0.00', '187498.00', '0.00', '2024-05-05', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (189, '20240505121803', '10/5', '13', '102244.00', '0.00', '102244.00', '0.00', '2024-05-05', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (190, '20240505121954', '35/5', '49', '11740.00', '0.00', '11740.00', '0.00', '2024-05-05', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (191, '20240506104201', '28/5', '29', '126150.00', '0.00', '126150.00', '0.00', '2024-05-06', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (192, '20240506104755', '42/5', '33', '1544.00', '0.00', '1544.00', '0.00', '2024-05-06', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (193, '20240506145001', '27/5', '32', '36980.00', '0.00', '36980.00', '0.00', '2024-05-06', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (194, '20240507103746', '42/5', '34', '70132.00', '0.00', '70132.00', '0.00', '2024-05-06', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (195, '20240508110100', '57/5', '63', '181500.00', '0.00', '181500.00', '0.00', '2024-05-08', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (196, '20240509085309', '42/5', '34', '39552.00', '0.00', '39552.00', '0.00', '2024-05-09', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (197, '20240511090102', '50/5', '58', '41000.00', '0.00', '41000.00', '680.00', '2024-05-09', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (198, '20240511091033', '42/5', '34', '72641.00', '0.00', '72641.00', '0.00', '2024-05-11', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (199, '20240512083036', '35/5', '49', '11700.00', '0.00', '11700.00', '0.00', '2024-05-11', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (200, '20240512083938', '00/5', '56', '10500.00', '0.00', '10500.00', '20.00', '2024-05-11', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (201, '20240512090322', '21/5', '26', '5800.00', '0.00', '5800.00', '0.00', '2024-05-11', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (202, '20240513113659', '23/5', '28', '24840.00', '0.00', '24840.00', '0.00', '2024-05-13', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (203, '20240513121625', '48/5', '55', '13550.00', '0.00', '13550.00', '0.00', '2024-05-13', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (204, '20240513122220', '26/5', '31', '45000.00', '0.00', '45000.00', '0.00', '2024-05-13', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (205, '20240513123234', '28/5', '29', '36150.00', '0.00', '36150.00', '0.00', '2024-05-13', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (206, '20240513124438', '54/5', '60', '2520.00', '0.00', '2520.00', '0.00', '2024-05-13', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (207, '20240514093845', '29/5', '40', '3600.00', '0.00', '3600.00', '0.00', '2024-05-13', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (208, '20240514100037', '35/5', '49', '13000.00', '0.00', '13000.00', '0.00', '2024-05-13', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (209, '20240514155936', '35/5', '49', '28000.00', '0.00', '28000.00', '0.00', '2024-05-14', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (210, '20240515120704', '36/5', '43', '50460.00', '0.00', '50460.00', '0.00', '2024-05-15', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (211, '20240515133441', '35/5', '49', '5760.20', '0.00', '5760.20', '1.00', '2024-05-15', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (212, '20240515133628', '25/5', '30', '17200.00', '0.00', '17200.00', '0.00', '2024-05-15', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (213, '20240515135425', '6/5', '8', '17160.00', '0.00', '17160.00', '0.00', '2024-05-15', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (214, '20240515140556', '005', '56', '12930.00', '0.00', '12930.00', '0.00', '2024-05-15', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (215, '20240516133700', '48/5', '55', '7790.00', '0.00', '7790.00', '0.00', '2024-05-16', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (216, '20240518090409', '44/5', '50', '17600.00', '0.00', '17600.00', '0.00', '2024-05-16', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (217, '20240518091329', '005', '56', '4500.00', '0.00', '4500.00', '0.00', '2024-05-16', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (218, '20240519083354', '35/54', '49', '23500.00', '0.00', '23500.00', '0.00', '2024-05-18', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (219, '20240519084115', '42/5', '34', '279000.00', '0.00', '279000.00', '0.00', '2024-05-19', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (220, '20240519092005', '005', '56', '15517.00', '0.00', '15517.00', '0.00', '2024-05-19', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (221, '20240519141002', '8/5', '10', '110000.00', '0.00', '110000.00', '0.00', '2024-05-19', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (222, '20240520091034', '51/5', '52', '17950.00', '0.00', '17950.00', '0.00', '2024-05-19', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (223, '20240520091552', '21/5', '26', '22000.00', '0.00', '22000.00', '0.00', '2024-05-19', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (224, '20240520111840', '48/5', '55', '75420.00', '0.00', '75420.00', '0.00', '2024-05-19', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (225, '20240521080304', '38/5', '45', '3200.00', '0.00', '3200.00', '90.00', '2024-05-20', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (226, '20240521081618', '29/5', '40', '3380.00', '0.00', '3380.00', '0.00', '2024-05-20', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (227, '20240521082619', '50/5', '58', '10900.00', '0.00', '10900.00', '0.00', '2024-05-20', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (228, '20240521083132', '35/5', '49', '14500.00', '0.00', '14500.00', '0.00', '2024-05-20', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (229, '20240521083413', '', '34', '14400.00', '0.00', '14400.00', '0.00', '2024-05-21', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (230, '20240521101546', '005', '56', '44000.00', '0.00', '44000.00', '0.00', '2024-05-21', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (231, '20240530060328', '51', '49', '8800.00', '0.00', '8800.00', '0.00', '2024-05-21', '', 1, '', 1);
INSERT INTO `product_purchase` (`id`, `purchase_id`, `chalan_no`, `supplier_id`, `grand_total_amount`, `paid_amount`, `due_amount`, `total_discount`, `purchase_date`, `purchase_details`, `status`, `bank_id`, `payment_type`) VALUES (232, '20240530062723', '52', '34', '295200.00', '0.00', '295200.00', '0.00', '2024-05-22', '', 1, '', 1);


#
# TABLE STRUCTURE FOR: product_purchase_details
#

DROP TABLE IF EXISTS `product_purchase_details`;

CREATE TABLE `product_purchase_details` (
  `id` int NOT NULL AUTO_INCREMENT,
  `purchase_detail_id` varchar(100) DEFAULT NULL,
  `purchase_id` bigint DEFAULT NULL,
  `product_id` varchar(30) DEFAULT NULL,
  `quantity` decimal(10,2) DEFAULT NULL,
  `rate` decimal(10,2) DEFAULT NULL,
  `total_amount` decimal(10,2) DEFAULT NULL,
  `discount` float DEFAULT NULL,
  `status` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `purchase_id` (`purchase_id`),
  KEY `product_id` (`product_id`)
) ENGINE=MyISAM AUTO_INCREMENT=14470 DEFAULT CHARSET=utf8mb3;

INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (1, 'h85zoxxpPmzqVnX', '20240124145509', '1', '38.00', '370.00', '14060.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2, 'Cup9SzKVczRmjTg', '20240124145509', '2', '58.00', '190.00', '11020.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (3, '2sXKQafeibCO1RG', '20240124145509', '3 ', '6.00', '300.00', '1800.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5174, 'AOPgb5IG2Phyc0Z', '20240124145800', '490', '200.00', '90.00', '18000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5173, 'A5y3Ve1Ov0smnm4', '20240124145800', '7', '16.00', '320.00', '5120.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5172, 'SykgLm3Sa0hnzOE', '20240124145800', '6', '2.00', '150.00', '300.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5171, '5ToUIDgSDd3vEyr', '20240124145800', '5', '40.00', '450.00', '18000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10099, 'a74u4iZ8OKmgJKM', '20240402162259', '10', '18.00', '210.00', '3780.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10098, 'FhPs1yQBxvTQaqx', '20240402162259', '13', '50.00', '400.00', '20000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10097, 'yprHAWPQL86nhhD', '20240402162259', '9', '97.00', '430.00', '41710.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10096, '6TgBhHtMXYKnhF6', '20240402162259', '8', '169.00', '550.00', '92950.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12432, 'O0W9VSAGv2z3lmg', '20240316123506', '964', '50.00', '5000.00', '250000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10056, '62pPb7B7tcyoC7c', '20240124152118', '12', '80.00', '135.00', '10800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10055, '528COL1w8Qf3Kle', '20240124152118', '742', '156.00', '110.00', '17160.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5678, 'JcRbM78UyHoGDdo', '20240124154656', '773', '200.00', '80.00', '16000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5677, 'AAFtBPU5Gh9sb00', '20240124154656', '604', '50.00', '175.00', '8750.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5676, 'Bo1iAo3FttSOzXW', '20240124154656', '15', '80.00', '135.00', '10800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5675, 'f18g8LpVtgIKCOV', '20240124154656', '16', '20.00', '110.00', '2200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5674, '5RxcDgu2PjSm1FK', '20240124154656', '17', '25.00', '180.00', '4500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5673, 'HPNBfuiDjKuvpX0', '20240124154656', '18', '10.00', '75.00', '750.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5672, 'jBwt641VJM8YSLi', '20240124154656', '19', '300.00', '70.00', '21000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (108, 'xrX6BDatTSR8nhJ', '20240127150504', '30', '2.00', '1900.00', '3800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (107, 'NCrD5u3GKDOhA4t', '20240127150504', '29', '45.00', '40.00', '1800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (106, 'cTPCL5TlJjiMixH', '20240127150504', '28', '20.00', '120.00', '2400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (105, 'Bum3S9d0diPBS96', '20240127150504', '27', '100.00', '33.00', '3300.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (104, 'cepB6yJWUskwVHo', '20240127150504', '26', '200.00', '15.00', '3000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (103, 'B5jyRc7FotftbbO', '20240127150504', '25', '1.00', '1800.00', '1800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (102, 'MJdwzFHtDlEnbxh', '20240127150504', '24', '5.00', '750.00', '3750.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (101, 'KNZEbLoFoCk5Sg1', '20240127150504', '23', '5.00', '1500.00', '7500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (100, 'OA3XVvijsnhYEhD', '20240127150504', '22', '200.00', '15.00', '3000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6004, 'gKKQCpSauotLK07', '20240127152129', '31', '36.00', '1700.00', '61200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6003, 'GkMrvjYEQz4JmXJ', '20240127152129', '32', '14.00', '750.00', '10500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6002, 'gt6w6HaM9KnBFGa', '20240127152129', '33', '2.00', '700.00', '1400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6001, '8UfWXKw9VhdqPFQ', '20240127152129', '34', '2.00', '350.00', '700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6000, 'wa5UIu8ZyuQjlRC', '20240127152129', '35', '2.00', '1000.00', '2000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5999, 'peaYz2PGZ4gEvCV', '20240127152129', '36', '1.00', '2500.00', '2500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5998, '65SVTeHXDxHbRVF', '20240127152129', '37', '200.00', '10.00', '2000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5997, 'oQJIkvxfMyqGu6N', '20240127152129', '38', '200.00', '20.00', '4000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5996, 'SIDMqIuNulINxMq', '20240127152129', '39', '60.00', '20.00', '1200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5995, 'RJHTgBUHQ52HSU', '20240127152129', '40', '300.00', '15.00', '4500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (176, 'FNjU0wz2iCUV2UI', '20240127161005', '51', '9.00', '250.00', '2250.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (175, 'Xi8A9GJwJA6EfQt', '20240127161005', '50', '100.00', '120.00', '12000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (174, '8EkwCvzHhblGtRw', '20240127161005', '49', '20.00', '160.00', '3200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (173, 'UOuzwhKqaJnwJx9', '20240127161005', '48', '9.00', '150.00', '1350.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (172, 'y3Y9hH4IqIrW3BG', '20240127161005', '47', '10.00', '320.00', '3200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (171, 'oWh2MjekN9H4FZd', '20240127161005', '52', '8.00', '450.00', '3600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (170, '72Fi06BwRPy4Qv2', '20240127161005', '46', '7.00', '150.00', '1050.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (169, 'drYL7CDgPfe2I3c', '20240127161005', '45', '10.00', '180.00', '1800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (168, 'Gp8ODhZapIV4Fes', '20240127161005', '43', '30.00', '220.00', '6600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (167, 'up4Lar6jVMyr9XV', '20240127161005', '42', '20.00', '170.00', '3400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (166, '9ETONHUu9Uv8mmK', '20240127161005', '41', '200.00', '45.00', '9000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (208, 'j8vItuXcZp7zBJB', '20240128104627', '62', '3.00', '1500.00', '4500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (207, 'bRPKAV3d9CWl9Mo', '20240128104627', '61', '72.00', '160.00', '11520.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (206, 'Jqge6vtnLBv6202', '20240128104627', '60', '85.00', '200.00', '17000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (205, 'GliP2duwmSNm8JP', '20240128104627', '59', '127.00', '165.00', '20955.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (204, 'hcScf7AqB55KwNL', '20240128104627', '58', '584.00', '115.00', '67160.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (203, 'UJVlE2R4wbz39Wv', '20240128104627', '57', '400.00', '140.00', '56000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (202, '5nt9GPTvbPJzm3p', '20240128104627', '56', '11.00', '1000.00', '11000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (201, '6UhpXPl1k6rywH2', '20240128104627', '55', '23.00', '280.00', '6440.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (200, 'OwpAVQS509NBQkD', '20240128104627', '54', '42.00', '255.00', '10710.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (199, 'NkNKM6BHV6GkESh', '20240128104627', '53', '10.00', '480.00', '4800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9866, 'MLc7nDVe4vFvGx9', '20240128113240', '416', '2.00', '5000.00', '10000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9865, '8pCFmFOPABRwP6B', '20240128113240', '412', '3.00', '8800.00', '26400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9864, 'JTKtaewE7oJ8kWo', '20240128113240', '415', '3.00', '5800.00', '17400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9863, 'KmsUAXR3xe66VOr', '20240128113240', '414', '0.00', '6900.00', '0.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9862, 'Vj158YLsUGOyi3a', '20240128113240', '413', '1.00', '7750.00', '7750.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9861, 'sf45vv95eTThz3h', '20240128113240', '418', '7.00', '4300.00', '30100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9860, 'qSPsJoXZTH0q8QW', '20240128113240', '417', '8.00', '4300.00', '34400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9859, 'C2yaX6xAvz4NMF4', '20240128113240', '63', '6.00', '4900.00', '29400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9858, 'yironMp300r31bX', '20240128113240', '64', '5.00', '4900.00', '24500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9857, 'Sri8YvUhVUV02cQ', '20240128113240', '65', '3.00', '10300.00', '30900.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9856, '7Wxkmz0wpC3Wozg', '20240128113240', '66', '2.00', '10300.00', '20600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9855, 'wUHslNlYQ42OVZX', '20240128113240', '67', '17.00', '2600.00', '44200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9854, '1MX550WjV9RBm6M', '20240128113240', '68', '33.00', '2600.00', '85800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9853, 'boi7rHzYIo3p0Or', '20240128113240', '69', '12.00', '5200.00', '62400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9852, 'RCh3EdI4MG3W0Sj', '20240128113240', '70', '8.00', '5200.00', '41600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12444, 'JTi9cFCqEvsQyKu', '20240128115259', '78', '70.00', '160.00', '11200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12443, 'rqSARYHYRfALOTo', '20240128115259', '79', '23.00', '120.00', '2760.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12442, 'NPbv4b89940ATbS', '20240128115259', '80', '61.00', '80.00', '4880.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12441, 'Ebt1Xo829MDakVH', '20240128115259', '81', '12.00', '80.00', '960.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12440, 'Dhdwa7dbm6b7XSo', '20240128115259', '82', '13.00', '170.00', '2210.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12439, 'dD07OhyL7g7vvJI', '20240128115259', '83', '6.00', '450.00', '2700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12438, 'xuO9zZ2DqSZEe84', '20240128115259', '84', '5.00', '450.00', '2250.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6209, 'ltGP9oebTH6Fsjs', '20240128140222', '98', '3.00', '850.00', '2550.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14302, 'zKEG0rk4SUH5CU2', '20240128122919', '88 ', '3.00', '1320.00', '3960.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14301, '3xZVYxAnRGy7bWI', '20240128122919', '91', '4.00', '540.00', '2160.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14300, 't7A7aSaBau6ZUNs', '20240128122919', '86', '71.00', '390.00', '27690.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14299, 'NDgfEcwunfKyNqL', '20240128122919', '85', '24.00', '660.00', '15840.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14298, '9FwvmQwgwKppM2L', '20240128122919', '90', '20.50', '900.00', '18450.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14297, '7DGSOobGnN8sT8O', '20240128122919', '92', '128.00', '260.00', '33280.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14296, 'Sf7DtQpjJFUkycn', '20240128122919', '93', '24.00', '270.00', '6480.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6208, 'KEDwIQH3tsBCbRo', '20240128140222', '97', '5.00', '800.00', '4000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6207, 'WBCmVTuuYDof6nT', '20240128140222', '96', '28.00', '260.00', '7280.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6206, 'kZACmKc6znYc3UK', '20240128140222', '99', '14.00', '360.00', '5040.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6205, 'bK8mJNEMVt6MU7V', '20240128140222', '95', '31.00', '390.00', '12090.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6204, 'QcKYRinC0UhhGWn', '20240128140222', '94', '21.00', '585.00', '12285.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12294, 'NPsGAnIAdKiqCLk', '20240128141713', '104', '26.00', '300.00', '7800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12293, '434ggnevMpY5Huh', '20240128141713', '103', '40.00', '320.00', '12800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12292, '6AtH2mJELExfdJk', '20240128141713', '102', '53.00', '450.00', '23850.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12067, 'MVHhW3JQEJfx0zX', '20240128142633', '100', '107.00', '300.00', '32100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12066, 'FVRfWS75pQ0kfJX', '20240128142633', '101', '88.00', '550.00', '48400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (3788, '5pbDGPgdlO5JiFU', '20240128145546', '113', '17.00', '840.00', '14280.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (3787, 'NNMQhazAKom3YzN', '20240128145546', '114', '30.00', '480.00', '14400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (3786, 'XfixnPmfpv5HFxg', '20240128145546', '115', '7.00', '620.00', '4340.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9191, 'lrJUjG1pMHhi2DM', '20240128150010', '105', '8.00', '510.00', '4080.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9190, 'faEFI0NFBcdIcCM', '20240128150010', '106', '17.00', '380.00', '6460.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9189, 'D0gdNrb1kT0eI7F', '20240128150010', '107', '33.00', '460.00', '15180.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9188, 'Kdc33uH6zxi9vAF', '20240128150010', '108', '15.00', '300.00', '4500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9187, '2lR8JT3yFa219eB', '20240128150010', '109', '22.00', '600.00', '13200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9186, 'hDlnA9h4sAYoSjf', '20240128150010', '110', '16.00', '1296.00', '20736.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9185, '82WHM6AoAt1uN8N', '20240128150010', '111', '8.00', '1000.00', '8000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9184, 'LyrG603L1RPqdzL', '20240128150010', '112', '4.00', '280.00', '1120.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7629, 'Dx0486zRufw9Nlv', '20240128151840', '123', '38.00', '300.00', '11400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7628, 'dQZ0PZXwIWZYEor', '20240128151840', '122', '27.00', '340.00', '9180.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7627, 'frgA0KqKRWQXEVY', '20240128151840', '121', '22.00', '300.00', '6600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7626, 'TBhh2FichQGyUFH', '20240128151840', '120', '27.00', '700.00', '18900.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7625, '4eQD5HttFq2rndw', '20240128151840', '119', '17.00', '600.00', '10200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7624, 'xyUa3jbjcybDcRF', '20240128151840', '118', '12.00', '300.00', '3600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7623, 'wrEfg6vzuio9yaJ', '20240128151840', '117', '3.00', '300.00', '900.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7622, 'ejeSjIM6Pz1ZmsA', '20240128151840', '116', '27.00', '550.00', '14850.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14189, 'DpNIuYqq5lnj82t', '20240129142817', '134', '6.00', '160.00', '960.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14188, 'ipRf21FhEyxvncL', '20240129142817', '133', '26.00', '240.00', '6240.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14187, 'MIDPesM7eIArp51', '20240129142817', '132', '13.00', '240.00', '3120.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14186, 'gJdrG3Jotv7gO4g', '20240129142817', '131', '12.00', '240.00', '2880.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14185, 'ouQVgS4vvzIkhFK', '20240129142817', '130', '210.00', '360.00', '75600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14184, 'Bclr4MxANI0L38j', '20240129142817', '129', '16.00', '275.00', '4400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14183, 'mWuOb811eiIaBmT', '20240129142817', '128', '2.00', '400.00', '800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14182, 'XhXL0sG4mQ6fWXT', '20240129142817', '127', '17.00', '400.00', '6800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14181, 'B3ukAiTnX4KZhGE', '20240129142817', '126', '51.00', '460.00', '23460.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14180, 'EzAT7m30ETCh5I6', '20240129142817', '125', '156.00', '375.00', '58500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14179, '6JbonJfVixMQVrW', '20240129142817', '124', '10.00', '500.00', '5000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9132, 'TTJTKw1ozQj6S17', '20240331160955', '1053', '6.00', '130.00', '780.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9810, 'vCfk28hj523zhzW', '20240129154322', '420', '18.00', '3936.00', '70848.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9809, 'dKXP9pPhcdV0XYZ', '20240129154322', '419', '27.00', '7121.00', '192267.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9808, 'hbaQJLpBd69aBND', '20240129154322', '135', '101.00', '2961.00', '299061.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9807, 'ZI65ljQGRQAUsYq', '20240129154322', '136', '74.00', '2961.00', '219114.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9806, 'M4yXHanzsdlxXdE', '20240129154322', '137', '10.00', '2961.00', '29610.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9805, 'BJ7xsnX06YhefUt', '20240129154322', '138', '9.00', '2961.00', '26649.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9804, 'ruNqFjXay7GOuv0', '20240129154322', '139', '19.00', '2961.00', '56259.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9803, 'jTB7QW5Y7Z9m444', '20240129154322', '140', '6.00', '2961.00', '17766.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9802, 'w4TpUAYBgYyGMPc', '20240129154322', '141', '38.00', '6146.00', '233548.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9801, 'b3o4U5SLaRMXWw1', '20240129154322', '142', '5.00', '6146.00', '30730.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9800, 'v0WPdeFRQEeefRt', '20240129154322', '143', '5.00', '6146.00', '30730.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9799, 'LXaBFhui1fxIFnB', '20240129154322', '144', '30.00', '6146.00', '184380.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9798, 'v35soNZC8WkD0Kr', '20240129154322', '145', '3.00', '9331.00', '27993.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9797, 'hWXSRq1y2lwc04r', '20240129154322', '147', '4.00', '14986.00', '59944.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9796, 'NGN1fXZvoQLSpRO', '20240129154322', '148', '2.00', '14986.00', '29972.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9795, 'W3QLLZ0AiK7BODn', '20240129154322', '149', '10.00', '1044.00', '10440.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9794, 'AaFtiYTPaZkZdW', '20240129154322', '150', '10.00', '1044.00', '10440.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9793, 'rphs4IdMTN49uQ3', '20240129154322', '151', '16.00', '1557.00', '24912.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9792, 'rRQs30gaY04fxGy', '20240129154322', '152', '22.00', '1557.00', '34254.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9791, '9kWc04sRPlwUvrz', '20240129154322', '153', '16.00', '2292.00', '36672.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9790, 'oUzCYdM3X2kR7U1', '20240129154322', '154', '15.00', '2292.00', '34380.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9789, 'ZNOf5OReeffveep', '20240129154322', '155', '19.00', '3208.00', '60952.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9788, 't6cEmeJ01OSgA6T', '20240129154322', '156', '15.00', '3208.00', '48120.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9787, 'gYpAQvWpCednF3a', '20240129154322', '159', '8.00', '5126.00', '41008.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9786, 'QeTmuhCi6I3j5OA', '20240129154322', '160', '8.00', '5126.00', '41008.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9785, '9FNsehif5Kcdz7c', '20240129154322', '161', '13.00', '4391.00', '57083.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9784, 'fk8ruSg9kp8wMU1', '20240129154322', '162', '10.00', '3351.00', '33510.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5755, '4NrCaetedcgZ4MM', '20240130154304', '163', '4.00', '580.00', '2320.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5754, 'cgdfXe5lKaJZa72', '20240130154304', '164', '6.00', '500.00', '3000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5753, '4WpqDOlxCVkdDdR', '20240130154304', '165', '7.00', '380.00', '2660.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5752, 'l7ZNABd8DpBO8Za', '20240130154304', '166', '11.00', '330.00', '3630.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5751, 'QgAJuqjy0SH8qAQ', '20240130154304', '167', '9.00', '240.00', '2160.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5750, 'wdussg6MliE8zib', '20240130154304', '168', '1.00', '800.00', '800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5749, 'HUXMtXcqC5NrA3b', '20240130154304', '169', '1.00', '700.00', '700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5748, '9vJrVQTgERvZ7Dl', '20240130154304', '170', '2.00', '450.00', '900.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5747, 'ZrSoLOU5SLwl520', '20240130154304', '171', '12.00', '300.00', '3600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5746, 'WlAytGC2DVKAgaR', '20240130154304', '172', '13.00', '150.00', '1950.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5745, 'jG0xrVzqB9Bs5pq', '20240130154304', '173', '6.00', '210.00', '1260.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5744, 'GtNGNCN7cogh9FM', '20240130154304', '174', '35.00', '300.00', '10500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5743, 'PVoabQ6ZMq6Heq9', '20240130154304', '179', '1000.00', '36.00', '36000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5742, 'BryA3arbSukRDzm', '20240130154304', '180', '900.00', '27.00', '24300.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5741, '3jG5N9vtB6wGshd', '20240130154304', '181', '50.00', '165.00', '8250.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5740, 'ALPcmGvTSuWn2Aj', '20240130154304', '182', '300.00', '90.00', '27000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5739, '1muveT5yzekiNZW', '20240130154304', '183', '4.00', '1600.00', '6400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5738, 'xlI1xaS1ZZHLZqz', '20240130154304', '184', '3.00', '1400.00', '4200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5737, 'NDefurEa6ZP6K4k', '20240130154304', '175', '324.00', '125.00', '40500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5736, '9vYdyIvpD3uNqo0', '20240130154304', '176', '120.00', '65.00', '7800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5735, 'OzGiN9zAi1b5R8K', '20240130154304', '177', '96.00', '165.00', '15840.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5734, 'WRRDnB7FQlQpaK0', '20240130154304', '178', '48.00', '80.00', '3840.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (1710, '9RvnZArtX8Xww9q', '20240130155908', '89', '48.00', '280.00', '13440.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (1709, 'FxGU25vGEdcHJqD', '20240130155908', '87', '9.00', '270.00', '2430.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10081, 'AZo3l0AvkPdAukZ', '20240131144117', '971', '3.00', '3700.00', '11100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12431, 'jaIz0YhtgHN1tTz', '20240316123506', '963', '149.00', '2500.00', '372500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12430, 'OORaZ2whWnovbWW', '20240316123506', '962', '106.00', '4100.00', '434600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12429, '4brISFGruazkjw4', '20240316123506', '961', '209.00', '2050.00', '428450.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12428, 'xkqlVlOXAJy6q7U', '20240316123506', '960', '101.00', '3100.00', '313100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10080, 'Cv3KZgdw3vQZ6s6', '20240131144117', '832 ', '1.00', '3200.00', '3200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10079, 'ZnqI13GzdqYC0Qk', '20240131144117', '199', '3.00', '1900.00', '5700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10078, 'iDGM6qbCJky9t6E', '20240131144117', '198', '4.00', '2100.00', '8400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10077, 'sq5hqYdUUUZjNFm', '20240131144117', '197', '2.00', '1500.00', '3000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10076, 'fXUU8uqRwkpO2k5', '20240131144117', '196', '11.00', '380.00', '4180.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10075, 'EVx2LQVzAlIqCMx', '20240131144117', '195', '4.00', '1300.00', '5200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10074, 'fD5KtnogLWxGQOn', '20240131144117', '194', '7.00', '1500.00', '10500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10073, '57OyxNVZS3oJtae', '20240131144117', '193', '6.00', '1700.00', '10200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10072, 'wbhpzFWbx6LxSdf', '20240131144117', '192', '1.00', '1100.00', '1100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10071, 'sep073yEaGzQvK8', '20240131144117', '191', '1.00', '1700.00', '1700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (1346, 'Vr29RRf4kixnSxC', '20240131153527', '212', '50.00', '105.00', '5250.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (1345, 'FXP3RCgJhfPMVOq', '20240131153527', '211', '50.00', '100.00', '5000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (1344, 'bTwrBTydfmZSjlL', '20240131153527', '210', '50.00', '70.00', '3500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (1343, 'bVtdrfNz5ntE8iy', '20240131153527', '209', '1.00', '1700.00', '1700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (1342, 'WDp2aAjdEZQbRuM', '20240131153527', '208', '1.00', '1500.00', '1500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (1341, 'sPNodNVWTCN3Obv', '20240131153527', '207', '3.00', '1300.00', '3900.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (1340, 'NhfQxYL6spGUuyP', '20240131153527', '206', '13.00', '1200.00', '15600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (1339, 'cCwzHSBYna6sO8F', '20240131153527', '205', '6.00', '900.00', '5400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (1338, 'kcLtgH3wzR6Uycp', '20240131153527', '204', '1.00', '1300.00', '1300.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (1337, 'YOyASuLBwxCgp8U', '20240131153527', '203', '1.00', '1100.00', '1100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (1336, 'ESrwStVZwMZHeKe', '20240131153527', '202', '5.00', '900.00', '4500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (1335, 'jsishCmM7ULpInr', '20240131153527', '201', '5.00', '800.00', '4000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (1334, 'BrnC56KHnYfjB4X', '20240131153527', '200', '30.00', '900.00', '27000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2645, 'NVwoSBlD8YTQZWj', '20240201145453', '598 ', '40.00', '130.00', '5200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2644, 'jUy134wlcRcinnr', '20240201145453', '599', '20.00', '120.00', '2400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2643, 'sdBEKZr7rt4XYs9', '20240201145453', '597', '1.00', '250.00', '250.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2642, 'upqLmSNCNzkrwK4', '20240201145453', '596', '4.00', '336.00', '1344.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2641, 'uDMlh86I3DYkUd5', '20240201145453', '595', '2.00', '323.00', '646.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2640, 'vWAB6AWJ7Ug4cya', '20240201145453', '594', '12.00', '290.00', '3480.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2639, '2bUqF0SKkCf0VLT', '20240201145453', '593', '2.00', '450.00', '900.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2638, 'k137ZM8cge5n5XQ', '20240201145453', '592', '8.00', '482.00', '3856.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2637, 'fcV2IyqBlGbxrSN', '20240201145453', '233', '2.00', '1050.00', '2100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2636, 'Q7scMoEFYOhGFoZ', '20240201145453', '232', '2.00', '750.00', '1500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2635, 'YNlayYhaFUQ6pJa', '20240201145453', '231', '3.00', '550.00', '1650.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2634, 'RBL4vVqVn1rHUSg', '20240201145453', '230', '1.00', '4600.00', '4600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2633, 'dCQU6kaUbIwHa0f', '20240201145453', '229', '1.00', '5000.00', '5000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2632, 'ustyYK00FPESB3h', '20240201145453', '228', '3.00', '3500.00', '10500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2631, 'oHJc4HHGBpw6kRd', '20240201145453', '227', '30.00', '100.00', '3000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2630, '5OugrZ3cII2Q4Ia', '20240201145453', '226', '2.00', '1600.00', '3200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2629, 'dCndcDpWn2Po36G', '20240201145453', '225', '16.00', '480.00', '7680.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2628, 'Ntn7fThFzvNHRsy', '20240201145453', '224', '10.00', '550.00', '5500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2627, 'tskvZCpuoYRyEzp', '20240201145453', '223', '6.00', '1250.00', '7500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2626, 'tkwUYVevpawk95w', '20240201145453', '222', '95.00', '230.00', '21850.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2625, 'KOuQHLZDrf74TAG', '20240201145453', '221', '6.00', '500.00', '3000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13345, 'PZjJX80BUprs5BE', '20240201155743', '709', '3.00', '500.00', '1500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13344, 'yze0VHeui2ux1hG', '20240201155743', '234', '8.00', '920.00', '7360.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13343, 'jkUjkn3PtmgnnIc', '20240201155743', '235', '25.00', '1100.00', '27500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13342, 'OycwamMXOzT6nSr', '20240201155743', '236', '10.00', '920.00', '9200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13341, 'SMbxr18Egc6jKfY', '20240201155743', '237', '20.00', '530.00', '10600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13340, 'DdB9MJ2K0D5bIMN', '20240201155743', '238', '34.00', '320.00', '10880.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13339, 'bBPmZ7jt8X1mVC6', '20240201155743', '239', '38.00', '360.00', '13680.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13338, '4SARbeXwEXZLQEJ', '20240201155743', '240', '9.00', '260.00', '2340.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13337, 'Ux38k88oqmUlItb', '20240201155743', '241', '18.00', '160.00', '2880.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13336, 'lW2prvPrgEGCG7Q', '20240201155743', '242', '13.00', '490.00', '6370.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13335, 'fz5eomikP3jOr1A', '20240201155743', '243', '19.00', '430.00', '8170.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13334, 'aubVwsD8yXLXayC', '20240201155743', '244', '2.00', '5500.00', '11000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13333, 'WI2ZxkrED2DOlfz', '20240201155743', '245', '5.00', '2800.00', '14000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13332, '4r7MtmjxdCvczlV', '20240201155743', '246', '4.00', '4000.00', '16000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13331, 'GID6If5YtNVPg1o', '20240201155743', '247', '13.00', '650.00', '8450.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13330, 'AH3uv1569OiSrGt', '20240201155743', '248', '41.00', '320.00', '13120.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13329, 'NTr67DN4b6Zz4kw', '20240201155743', '249', '1.00', '1600.00', '1600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13328, '1ks79V9zK2quQef', '20240201155743', '250', '25.00', '250.00', '6250.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13327, 'ci9flvQzPxUn0Bk', '20240201155743', '251', '29.00', '275.00', '7975.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13326, 'VUM064LCIKyCE47', '20240201155743', '252', '9.00', '310.00', '2790.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13325, 'd3Az08AlrrQvnWW', '20240201155743', '253', '5.00', '280.00', '1400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13324, '2jn3ZTVnlmp1270', '20240201155743', '254', '80.00', '230.00', '18400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13323, 'mH8c52feAKoTjQu', '20240201155743', '255', '2.00', '750.00', '1500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13322, 'lSzg0coXj3orcsW', '20240201155743', '256', '1.00', '800.00', '800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13321, 'xj1iauDvkd59gs1', '20240201155743', '257', '1.00', '550.00', '550.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13745, 'tUcLJyw0hUnOv61', '20240203141705', '488', '12.00', '200.00', '2400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13744, 'YwdH3ek21wLuOiW', '20240203141705', '422', '350.00', '30.00', '10500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13743, '1plcu1Qgrpxs8jj', '20240203141705', '421', '250.00', '36.00', '9000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13742, 'rX8FyZMbDARbIQk', '20240203141705', '259', '3.00', '1200.00', '3600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13741, 'ocCtUVCDsodJtak', '20240203141705', '260', '28.00', '850.00', '23800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13740, 'EbGAqQiTgxQtSsd', '20240203141705', '261', '22.00', '600.00', '13200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13739, 'qPn1zEU7eXroyOY', '20240203141705', '262', '26.00', '450.00', '11700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13738, 'ozdGMZSkeIkJxQ2', '20240203141705', '263', '38.00', '350.00', '13300.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13737, 'YxWhMJnm9heVAux', '20240203141705', '264', '34.00', '80.00', '2720.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13736, 'Y99GZG96MeCgx9y', '20240203141705', '265', '14.00', '120.00', '1680.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13735, 'TB5VqOYptR7JIEx', '20240203141705', '266', '13.00', '220.00', '2860.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13734, 'tafDS7UoHILJr2E', '20240203141705', '267', '3.00', '360.00', '1080.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13733, '5kGvXBrQ7KUzs1F', '20240203141705', '268', '3.00', '2100.00', '6300.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13732, 'FKQD6iDYnehaFe3', '20240203141705', '269', '118.00', '110.00', '12980.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13731, 'tuUaka5RHJ7fQJq', '20240203141705', '270', '50.00', '160.00', '8000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13730, 'IcT2e6L4hVFsura', '20240203141705', '271', '160.00', '120.00', '19200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13729, 'OJ4sVJ4hVN1XSmR', '20240203141705', '272', '58.00', '220.00', '12760.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13728, 's3cRdOoZCDeBHLQ', '20240203141705', '273', '2.00', '800.00', '1600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13727, 'AFSFcLl5vdsdft9', '20240203141705', '274', '21.00', '360.00', '7560.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13726, 'mFDkWHA4QEdeP1m', '20240203141705', '275', '48.00', '100.00', '4800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13725, 'MIgCT71h5IAinx2', '20240203141705', '276', '112.00', '180.00', '20160.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13724, 'UigbmgfMzmvQs3', '20240203141705', '277', '16.00', '240.00', '3840.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13723, 'b3bnhw0rouLkP1Q', '20240203141705', '278', '61.00', '180.00', '10980.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13722, 'gsFLGX1VWK4iPwe', '20240203141705', '279', '58.00', '260.00', '15080.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13721, '8EwbxjfFfFjomK9', '20240203141705', '280', '31.00', '360.00', '11160.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13720, 'EEcZCM4SIoqgtnt', '20240203141705', '281', '570.00', '25.00', '14250.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13719, 'rjJ7DMY8pPGqPap', '20240203141705', '282', '240.00', '32.00', '7680.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13718, '8lLwkRuBfGTOKCv', '20240203141705', '283', '210.00', '30.00', '6300.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13717, 'cu7Re02qbkNVSf7', '20240203141705', '284', '80.00', '40.00', '3200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13716, 'JE3IBUABEpI87vD', '20240203141705', '285', '84.00', '240.00', '20160.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9589, 'wuZVxSKjKBjO0O3', '20240203150856', '347', '3.00', '6000.00', '18000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13525, 'qTWxiozYSrx1xlY', '20240204162308', '312', '0.00', '2961.00', '0.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13524, '3bGVDZlMHSpcbvp', '20240204162308', '289', '34.00', '2961.00', '100674.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9588, 'SC8QlmtS4jWkquj', '20240203150856', '307', '3.00', '6000.00', '18000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13523, 'JBdYIFFmHzls6qx', '20240204162308', '311', '40.00', '2961.00', '118440.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13522, 'vz48VWRtWQWAf77', '20240204162308', '313', '0.00', '2961.00', '0.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13521, 'FRaVHGEtJCpNOiR', '20240204162308', '314', '0.00', '2961.00', '0.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13520, 's93KzXw6KM5fxG5', '20240204162308', '315', '0.00', '2961.00', '0.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13519, 'DRoXeMydv4VlAUI', '20240204162308', '290', '14.00', '6146.00', '86044.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13518, 'dcBvFz6Uc0XjJcW', '20240204162308', '316', '15.00', '6146.00', '92190.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13517, 'kMpj3fLmF2dmi36', '20240204162308', '317', '0.00', '6146.00', '0.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13516, 'UujWqFiAcA3ILlR', '20240204162308', '318', '0.00', '6146.00', '0.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13515, 'ibapt7IBHWjhI4g', '20240204162308', '319', '0.00', '6146.00', '0.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13514, 'pDOUiCYqA0pBemX', '20240204162308', '320', '0.00', '6146.00', '0.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13513, 'x9dz9CIUrAyxqBj', '20240204162308', '291', '4.00', '9331.00', '37324.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13512, 'mOkc3GtINVtNMXU', '20240204162308', '321', '6.00', '9331.00', '55986.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13511, 'hSCZkDAQMRMxMMz', '20240204162308', '322', '12.00', '14986.00', '179832.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13510, 'zM4rvPxPtXMl2Fd', '20240204162308', '292', '9.00', '14986.00', '134874.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13509, 'tqyHoFy1AICNRYD', '20240204162308', '293', '1.00', '4391.00', '4391.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13508, 'E1muUuUCO8MHkut', '20240204162308', '294', '3.00', '7121.00', '21363.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13507, 'GrRrYkz7sLywSPD', '20240204162308', '295', '9.00', '3936.00', '35424.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13506, 'I7COxPCAHd6FU4p', '20240204162308', '296', '10.00', '3351.00', '33510.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13505, 'jnsiNvOebTGIvL8', '20240204162308', '297', '3.00', '15761.00', '47283.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13504, 'DBjVa4p8kIOofIl', '20240204162308', '298', '2.00', '10761.00', '21522.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13503, 'wjXrlDL7EtMXwCY', '20240204162308', '299', '32.00', '4092.00', '130944.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13502, 'BE2nIhSVmzQfqGB', '20240204162308', '323', '23.00', '4092.00', '94116.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13501, '7vfeamJ68dR4vqq', '20240204162308', '324', '2.00', '4092.00', '8184.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13500, 'pk6s66OccFBAJtj', '20240204162308', '325', '3.00', '4092.00', '12276.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13499, '6XgxqjGzphrShy0', '20240204162308', '326', '0.00', '4092.00', '0.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13498, 'x7DDoNARgwwPKGF', '20240204162308', '300', '5.00', '8707.00', '43535.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13497, 'iKIpQPfTIS7MwHY', '20240204162308', '327', '5.00', '8707.00', '43535.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13496, 'mNyBWFfxasiEwEu', '20240204162308', '328', '0.00', '8707.00', '0.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13495, 'Ei9CCHWSExsuQ4x', '20240204162308', '329', '0.00', '8707.00', '0.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13494, 'I7w2mZmo23fpfCG', '20240204162308', '330', '0.00', '8707.00', '0.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13493, 'FVIrcBaah6QXsur', '20240204162308', '331', '6.00', '11671.00', '70026.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13492, 'lK5WDg5j1HHVvvy', '20240204162308', '332', '5.00', '11671.00', '58355.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13491, 'cnmTjxpghfHPWUS', '20240204162308', '333', '6.00', '16689.00', '100134.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13490, 's7i2pski6kkz7NR', '20240204162308', '334', '5.00', '16689.00', '83445.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13489, 'YgDYu7kZCUqp6BJ', '20240204162308', '303', '7.00', '1500.00', '10500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13488, 'Ru4wtdEhyJmGq3i', '20240204162308', '343', '7.00', '1500.00', '10500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13487, 'mRdXj51EPZu7WD8', '20240204162308', '304', '5.00', '2000.00', '10000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13486, 'UFbnJpeQPSqv2bW', '20240204162308', '344', '5.00', '2000.00', '10000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13485, 'qpaKnlE3ZZ3oTbL', '20240204162308', '305', '4.00', '2900.00', '11600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13484, 'jllvlFYkcjJLGk9', '20240204162308', '345', '4.00', '2900.00', '11600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13483, 'xDhZUkHYxK6fyj1', '20240204162308', '346', '2.00', '4600.00', '9200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9587, 'jSNvFkr1yeDSgEc', '20240203150856', '308', '5.00', '2700.00', '13500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9586, '7lTRY1Yr73v4DQL', '20240203150856', '348', '5.00', '2700.00', '13500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9585, 'yfDjt5H0I9NAZNu', '20240203150856', '309', '9.00', '6000.00', '54000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9584, 'tvlerUZdDPFALr7', '20240203150856', '349', '8.00', '6000.00', '48000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9583, 'iovzLNjU0w4jCnX', '20240203150856', '310', '9.00', '8700.00', '78300.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9582, 'iCGG1FZohJ1auwv', '20240203150856', '350', '9.00', '8700.00', '78300.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9545, 'YNtQFo0LDmwVVAr', '20240205145350', '738', '1.00', '3610.00', '3610.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9544, 'm7WUh40axWCh2os', '20240205145350', '306', '3.00', '4600.00', '13800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9543, 'Jed20GFVMnvT1uH', '20240205145350', '335', '20.00', '2376.00', '47520.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9542, 'c6v1J6UcuXdYIlC', '20240205145350', '336', '18.00', '2376.00', '42768.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9541, '2K2wdIG84E2wjYe', '20240205145350', '337', '7.00', '4911.00', '34377.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9540, 'fO9ADTNvzO4QSY1', '20240205145350', '338', '6.00', '4911.00', '29466.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9539, '6MNxuWk6Ul4Moy1', '20240205145350', '340', '2.00', '7381.00', '14762.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9538, 'iWaHIaQeWxqeJB6', '20240205145350', '339', '3.00', '7381.00', '22143.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9537, 'W0J45S8VGGObDA1', '20240205145350', '341', '3.00', '10891.00', '32673.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (3891, 'ooVg1xZW6LkWkEY', '20240205171507', '726', '6.00', '4800.00', '28800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13794, 'SVEiO91mZl2BaCq', '20240205154059', '364', '1.00', '15000.00', '15000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13793, 'tUOdYUfZw39BMax', '20240205154059', '368', '50.00', '120.00', '6000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13792, 'bkvKRtVUmTg3A0D', '20240205154059', '367', '1000.00', '30.00', '30000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13791, '9IJxJGA8AzkmAji', '20240205154059', '365', '200.00', '70.00', '14000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13790, '7VyY9c5OsjiOJVr', '20240205154059', '366', '200.00', '46.00', '9200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13789, 'O74KjgoSvX1JFFg', '20240205154059', '362', '3.00', '3800.00', '11400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13788, 'feV8NG7NOihpQ78', '20240205154059', '361', '1.00', '3800.00', '3800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13787, 'pnKmJz5syomJGiR', '20240205154059', '360', '2.00', '14400.00', '28800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13786, 'gxrWfEM18MTainE', '20240205154059', '359', '1.00', '14400.00', '14400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13785, '3n8Dbml6Ng1eaL6', '20240205154059', '358', '1.00', '8800.00', '8800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13784, 'NccS9bhyFB0XX58', '20240205154059', '357', '1.00', '8800.00', '8800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13783, 'UqiacNIlRuNsQS2', '20240205154059', '356', '7.00', '5800.00', '40600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13782, 'lUNjfVxyDRonSLk', '20240205154059', '355', '9.00', '5800.00', '52200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13781, 'IapjrMkK6NLsczO', '20240205154059', '354', '5.00', '5800.00', '29000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13780, 'e0hZuVCOAX19Kgp', '20240205154059', '353', '0.00', '2800.00', '0.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13779, 'uwFKEmHImxBIvcZ', '20240205154059', '352', '1.00', '2800.00', '2800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13778, 'RZBXy4YOoPOk5Xy', '20240205154059', '351', '20.00', '2800.00', '56000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11763, 'dp6LzI6TWkzrQy4', '20240414075130', '1129', '1.00', '1950.00', '1950.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14313, 'yByWp7zXP1YkcFB', '20240422114228', '102', '49.00', '449.00', '22001.00', '2', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12956, 'i1GeMrtd3zxWswm', '20240428134254', '481', '40.00', '38.50', '1540.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14229, 'hXhTRuva8JFZoIr', '20240506145001', '1013', '12.00', '16.00', '192.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14385, 'HUmF2pJgGbKxUNt', '20240521101546', '1372', '4.00', '11000.00', '44000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14455, 'jqsWgj3HlwToovv', '20240205160956', '442', '30.00', '120.00', '3600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14454, 'Pt87ZVwCFjstRq7', '20240205160956', '1177', '12.00', '30.00', '360.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14453, 'THP6Tih0n7Y8Icq', '20240205160956', '1132', '40.00', '20.00', '800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14452, 'B0hYKVZ7uwccuaV', '20240205160956', '1027', '290.00', '65.00', '18850.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14451, '6Tj3o9sUHXVZdw9', '20240205160956', '1173', '12.00', '150.00', '1800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14450, 'aDFLXrEA18Y1QVO', '20240205160956', '1112', '12.00', '66.00', '792.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14449, 'JvJClyUVM1latzw', '20240205160956', '1168', '12.00', '270.00', '3240.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14448, 'Wa29WUXdSz1lOJ2', '20240205160956', '1167', '12.00', '90.00', '1080.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (3890, 'k1PDLoZ9BnNRMXo', '20240205171507', '363', '100.00', '320.00', '32000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2384, 'xBEEe07j6CwXvYB', '20240210151559', '398', '24.00', '486.00', '11664.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2383, 'Tiv5O5ECoXpvRo1', '20240210151559', '402', '16.00', '250.00', '4000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2382, 't326kr2DLuoNjRL', '20240210151559', '401', '8.00', '475.00', '3800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2381, 'osGZPfP3c9bzyHB', '20240210151559', '397', '10.00', '50.00', '500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2380, 'xaoYlFq5ZXmUdiX', '20240210151559', '396', '30.00', '40.00', '1200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2379, 'Njw7w200DQmDgfA', '20240210151559', '395', '24.00', '50.00', '1200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2378, 'SN3of0NVqtME19K', '20240210151559', '392', '1.00', '280.00', '280.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2377, 'LVOTrdZJO5hHL0n', '20240210151559', '391', '32.00', '270.00', '8640.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2376, 'JrYsCFA8LTm0Pu2', '20240210151559', '390', '22.00', '560.00', '12320.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2375, 'AVHFOvGc1H5N4VJ', '20240210151559', '389', '6.00', '336.00', '2016.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2374, 'bN2gzLcAnKjGOp', '20240210151559', '399', '37.00', '287.00', '10619.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2373, 'NSG4VbaxM6mxQan', '20240210151559', '385', '1.00', '2750.00', '2750.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2372, 'RvIwuaXoEVyHVv9', '20240210151559', '386', '14.00', '300.00', '4200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2371, 's26eJpgQOSnxcvv', '20240210151559', '387', '27.00', '486.00', '13122.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2389, '3AfMUtmcRbLnuWW', '20240210154644', '400', '5.00', '226.00', '1130.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2388, 'NVTyJ26ZuUpDPVJ', '20240210154644', '394', '12.00', '300.00', '3600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2387, '1eIe8Fd545sdZSD', '20240210154644', '393', '1.00', '560.00', '560.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2370, 'IeRcsS52uoGEfE1', '20240210161624', '409', '30.00', '820.00', '24600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2369, 'ipQ70mds0f6CkDC', '20240210161624', '408', '10.00', '100.00', '1000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2368, 'o3I07LVCSCDXzDl', '20240210161624', '403', '1.00', '450.00', '450.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2386, '6G3ksEaRnwFjlNK', '20240210154644', '406', '2.00', '336.00', '672.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2385, '8XRSseaKBeTKGhD', '20240210154644', '407', '5.00', '330.00', '1650.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2367, 'vVBQ8WxHaXD2zh5', '20240210161624', '404', '50.00', '125.00', '6250.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2366, 'GCbQnyCKaWL7Mx4', '20240210161624', '405', '7.00', '850.00', '5950.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9851, 'RwrVzMkNpDYuhho', '20240128113240', '71', '30.00', '2250.00', '67500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9850, 's85Omhw4Cr8tg8M', '20240128113240', '72', '25.00', '2250.00', '56250.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9849, 'mwdcFZtNFGUt9OV', '20240128113240', '73', '5.00', '2250.00', '11250.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9848, 'uMj3bt3AD6rhUAJ', '20240128113240', '74', '3.00', '6500.00', '19500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9847, 'pMUJLnRCg6vFVtM', '20240128113240', '75', '1.00', '6500.00', '6500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9846, '8sSwBvvuY5Cv8No', '20240128113240', '76', '1.00', '9100.00', '9100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9845, 'kRpC9YgfhIhpWPW', '20240128113240', '77', '1.00', '9100.00', '9100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9844, 'ToCq3RaI3U068Lo', '20240128113240', '410', '50.00', '1650.00', '82500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9843, 'OGLJHi1HaEAFdFd', '20240128113240', '411', '25.00', '3300.00', '82500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9783, 'RljGmvmoNKle8N6', '20240129154322', '157', '7.00', '4190.00', '29330.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9782, 'lNWuUbTbMH7EZEz', '20240129154322', '158', '6.00', '4190.00', '25140.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13715, '8i1LwbK2DqaNu20', '20240203141705', '286', '10.00', '180.00', '1800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13714, 'XIhn9IS2YPTVCj2', '20240203141705', '287', '12.00', '280.00', '3360.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5041, '4EnW6dgiQoekivZ', '20240218112422', '534', '2.00', '130.00', '260.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9536, 'uYS8w7N3wEO0rD0', '20240205145350', '342', '2.00', '10891.00', '21782.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7176, 'WeC4740HGCJK6aM', '20240219094915', '817', '3.00', '6300.00', '18900.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7175, 'YykI5R3iWSDOQTC', '20240219094915', '826', '1.00', '10000.00', '10000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7174, 'JzOYHteWnUyxB5C', '20240219094915', '762', '10.00', '340.00', '3400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7173, '7s5QLWlf1Dwga7Z', '20240219094915', '766', '1.00', '2700.00', '2700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7172, 'f1yrSTqL7fWp2I7', '20240219094915', '633', '2.00', '2200.00', '4400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7171, '8hC9YXLFTMfn66F', '20240219094915', '765', '3.00', '450.00', '1350.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7170, '6GvX6lbaw1XZ6VC', '20240219094915', '789', '2.00', '1300.00', '2600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7169, '4Nrpye1OXnt94Qa', '20240219094915', '628', '3.00', '900.00', '2700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7168, 'zw0vjSLtsso6tIL', '20240219094915', '632', '2.00', '1480.00', '2960.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7167, 'VDrpSQGpabzUMWl', '20240219094915', '625', '140.00', '41.00', '5740.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7166, 'rgA4RZepnFwmZ2r', '20240219094915', '631', '3.00', '1800.00', '5400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7165, 'LzQXYUjKJ0mV8G9', '20240219094915', '630', '2.00', '1250.00', '2500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7164, 'fb6R2xhoyJeutgL', '20240219094915', '629', '4.00', '700.00', '2800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7163, 'vH0slPEuWLTC9Hu', '20240219094915', '615', '1.00', '4800.00', '4800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7162, 'mlwFAVLNgsvxN5S', '20240219094915', '627', '10.00', '900.00', '9000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7161, 'QEtDiiIW5gzZyJR', '20240219094915', '637', '1.00', '2000.00', '2000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7160, 'SbQqZr8wKbquSX2', '20240219094915', '611', '10.00', '300.00', '3000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12857, 'TNi9beWDvXf0oOp', '20240213163024', '501', '5.00', '240.00', '1200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12856, 'b7nWAAqotMqZkXJ', '20240213163024', '499', '1.00', '152.00', '152.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12855, '4tWG6g2U7Zd35oG', '20240213163024', '450', '6.00', '150.00', '900.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12854, 'BU45CSHEDJCJoP5', '20240213163024', '452 ', '4.00', '292.00', '1168.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7159, 'ICq4SAGluDLU2Yq', '20240219094915', '612', '1.00', '300.00', '300.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7158, 'QJDtGN1r5P9OvPC', '20240219094915', '613', '1.00', '1450.00', '1450.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9298, 'X4F9Kd3wGE0B3tW', '20240213150708', '574', '1.00', '14500.00', '14500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9297, 'Ug72AAS6mxuHqz9', '20240213150708', '453', '7.00', '250.00', '1750.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9296, 'TCbIO0rbFXCq8Vv', '20240213150708', '446', '6.00', '1450.00', '8700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9295, 'LxhClB4rgfOIpZ9', '20240213150708', '444', '1.00', '150.00', '150.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9294, 'nETjzfPedWDoKhw', '20240213150708', '445', '1.00', '150.00', '150.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9293, 'xpVjSWXdw6g9mYS', '20240213150708', '424', '4.00', '900.00', '3600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9292, 'svHOK2Ifpw5EhgI', '20240213150708', '442', '10.00', '120.00', '1200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9291, 'GLvMSqrMkmkeQwK', '20240213150708', '443', '1.00', '300.00', '300.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9290, 'DWBCSzMiyEPULmZ', '20240213150708', '426', '1.00', '8000.00', '8000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9289, '5MKQm1ZpCwEU4O7', '20240213150708', '441', '12.00', '300.00', '3600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9288, 'lmRNHhPJ3Gc9IOf', '20240213150708', '423', '2.00', '4100.00', '8200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9287, 'fG6cfh6vS5igI8q', '20240213150708', '427', '1.00', '1200.00', '1200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9286, 'fx5GWxldN8xsVhx', '20240213150708', '425', '1.00', '1600.00', '1600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9285, 'KhZ7hugeivIFdT9', '20240213150708', '428', '1.00', '5500.00', '5500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9284, 'WZoC503nXjZASBt', '20240213150708', '429', '1.00', '2000.00', '2000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9283, 'zrRRoXunySDLMIC', '20240213150708', '430', '2.00', '150.00', '300.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9282, 'fLQfHhFus2mzE0s', '20240213150708', '431', '2.00', '150.00', '300.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9281, 'LHCgbEvRnDkVOQ5', '20240213150708', '432', '1.00', '4000.00', '4000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9280, 's0tO81keuoMlxOV', '20240213150708', '433', '1.00', '1050.00', '1050.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9279, 'WtNqvTweBKhEMtf', '20240213150708', '434', '1.00', '6500.00', '6500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9277, 'Zq7ru3nMh5rdx7n', '20240213150708', '436', '1.00', '1500.00', '1500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13713, 'NwcRivbpXGBUmAG', '20240203141705', '288', '18.00', '70.00', '1260.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13712, 'ZuxZoGhN0k0VrY3', '20240203141705', '737', '20.00', '50.00', '1000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5170, 'zCvfcVI4gmb67FR', '20240124145800', '4', '47.00', '290.00', '13630.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5169, 'UR4NOFiMj17qCrQ', '20240124145800', '491', '35.00', '190.00', '6650.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14295, 'K9a8TDYunagtCSf', '20240128122919', '492', '52.00', '235.00', '12220.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14294, '3giHhyBTiNdQuI9', '20240128122919', '493', '6.00', '1800.00', '10800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14293, 'WqtkKYatm2a2y5G', '20240128122919', '494', '35.00', '290.00', '10150.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14292, 'pfCFTPtI2DTrM3e', '20240128122919', '495', '48.00', '650.00', '31200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14291, 'oV3i01hf8p4RMbg', '20240128122919', '496', '240.00', '38.00', '9120.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12853, 'PIKaYHkLjFbshk9', '20240213163024', '451', '6.00', '70.00', '420.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12852, 't30Tbi9uTLZZbM1', '20240213163024', '449', '12.00', '90.00', '1080.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12850, 'ASTHMgmbnbDeKnh', '20240213163024', '497', '12.00', '160.00', '1920.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12851, '90AmXDtdo0bVPUU', '20240213163024', '448', '11.00', '120.00', '1320.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12849, '4q9ia3XvQoNYfxj', '20240213163024', '498', '10.00', '250.00', '2500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2775, '8tbWVXox6Qlkf8Z', '20240214120913', '502', '3.00', '10000.00', '30000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2774, 'PjfH2EZL92CSXj7', '20240214120913', '503', '1.00', '12000.00', '12000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2773, 'ibzAigvm0wPYCAQ', '20240214120913', '504', '100.00', '60.00', '6000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2772, 'Q45eXpFSFGWlPPf', '20240214120913', '505', '4.00', '11000.00', '44000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2771, 'WaKL9SAUhW9GjrN', '20240214120913', '506', '24.00', '1320.00', '31680.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2770, 'SI1IEm61JBYMVir', '20240214120913', '507', '400.00', '3.00', '1200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8964, 'tGCbarTzD4sd0sS', '20240214131722', '590', '2.00', '1250.00', '2500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8963, 'bODxroPeszwUyk6', '20240214131722', '589', '1.00', '1650.00', '1650.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8962, 'E35C1Az9f3a7fN9', '20240214131722', '587', '2.00', '250.00', '500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8961, 'S2UQzRFAmBfv96Y', '20240214131722', '588', '2.00', '240.00', '480.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8960, 'HcnGTeXsy3HcLBS', '20240214131722', '586', '2.00', '120.00', '240.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8959, 'yZfQtkzOkZqoxMN', '20240214131722', '585', '1.00', '2200.00', '2200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8958, 'eWG6nvPLVvXznXW', '20240214131722', '556', '4.20', '3100.00', '13020.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8957, '2vFZfGTZjhJ8zn8', '20240214131722', '563', '1.00', '380.00', '380.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8956, 'jgowBWlHwE2xilo', '20240214131722', '508', '42.00', '310.00', '13020.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8955, 'xIy2SfZxzxlhdcW', '20240214131722', '509', '1.00', '4600.00', '4600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8954, 'q2aN4EBopssphJF', '20240214131722', '510', '9.00', '33.00', '297.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8953, '5INahJ6e2EjxybQ', '20240214131722', '511', '3.00', '8700.00', '26100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8952, 'oGmYfjeGVXH4oOb', '20240214131722', '512', '10.00', '80.00', '800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8951, 'I87FEAoQG4bXoQn', '20240214131722', '513', '12.00', '140.00', '1680.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8950, '1vgzAcT8kKNg37N', '20240214131722', '514', '11.00', '50.00', '550.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8949, 'ePHfSluKiKrkimB', '20240214131722', '515', '5.00', '75.00', '375.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8948, '6kWpOHYZ00WmBJv', '20240214131722', '516', '2.00', '30.00', '60.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8947, 'FcsQhdkqooLamuN', '20240214131722', '517', '1.00', '12.00', '12.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8946, 'urxw00QxjyCi3c4', '20240214131722', '518', '2.00', '600.00', '1200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8945, 't3mGNXOzel5rJlh', '20240214131722', '519', '1.00', '900.00', '900.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8944, 'DVVheDkOsDkGQHk', '20240214131722', '520', '4.00', '120.00', '480.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8943, 'U8V7D0sIxi3THPJ', '20240214131722', '521', '4.00', '120.00', '480.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8942, '6JTNvIy1lRUFABL', '20240214131722', '525', '1.00', '1150.00', '1150.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8941, 'Pcj33jnsJw79UYK', '20240214131722', '528', '5.00', '550.00', '2750.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8940, '10bgQ0SJZ8Noi3j', '20240214131722', '523', '2.00', '10.00', '20.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8939, 'VCVxrZ5cYzqkmAh', '20240214131722', '522', '60.00', '50.00', '3000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8938, 'DyFoucCPOkIxJL4', '20240214131722', '524', '1.00', '700.00', '700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8937, 'CZPaK37soLZLnab', '20240214131722', '527', '2.00', '660.00', '1320.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8936, 'JBAM9sR6oNWrgFT', '20240214131722', '529', '3.00', '850.00', '2550.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8935, 'hzQHW2bD7RPLCTd', '20240214131722', '534', '4.00', '130.00', '520.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8934, 'gH5Zics2vbOvdvv', '20240214131722', '526', '1.00', '1445.00', '1445.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8933, 'H1kFbMabER70NlG', '20240214131722', '531 ', '1.00', '700.00', '700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8932, 'AUu4TwPtbjPjO9i', '20240214131722', '530', '1.00', '850.00', '850.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8931, 'D1uIxM9QWgqVtdT', '20240214131722', '533', '1.00', '480.00', '480.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8930, 'IOgl4qsxuQ3Xmot', '20240214131722', '532', '1.00', '1600.00', '1600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8929, 'V1jiPOwSRGoEOdr', '20240214131722', '536', '2.00', '180.00', '360.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8928, 'KyEhXOEPM9MQQUS', '20240214131722', '535', '2.00', '130.00', '260.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8927, 'afgczPc9SrepnUV', '20240214131722', '538', '10.00', '160.00', '1600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8926, '3C0QPvt1pKwP1Pd', '20240214131722', '537', '25.00', '160.00', '4000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8925, 'yO65oYJ529J2z3N', '20240214131722', '541 ', '8.00', '650.00', '5200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8924, 'H0uViiTGH0WJIT4', '20240214131722', '539', '1.00', '90.00', '90.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8923, 'urmH0oxOrD6dauR', '20240214131722', '540', '84.00', '15.00', '1260.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8922, 'S0kEWTQNloCwloc', '20240214131722', '544', '2.00', '450.00', '900.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9278, '8rCiEsPTDoCqrAQ', '20240213150708', '435', '1.00', '150.00', '150.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9275, 'UTEhg1euNuoyNA0', '20240213150708', '437', '1.00', '200.00', '200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12848, 'vJ0CsTrKS1O0lo0', '20240213163024', '500', '1.00', '650.00', '650.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8921, 's3bGonqov4DGjRR', '20240214131722', '543', '4.00', '30.00', '120.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8920, 'ppNvRZZ2X72FLpT', '20240214131722', '545', '2.00', '250.00', '500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8919, 'ephbJ7ZL5j9IC4F', '20240214131722', '546', '4.00', '35.00', '140.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8918, '3IFBzWcNZrJiYNa', '20240214131722', '547', '1.00', '3100.00', '3100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2452, 'qVSjfpLat6YGpu3', '20240217152346', '568', '12.00', '200.00', '2400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2451, '69iM63tv04Unq0j', '20240217152346', '567', '300.00', '1250.00', '375000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2450, 'qvwZLSaB1ZKfdYW', '20240217152346', '566', '10.00', '2500.00', '25000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2449, 'THEN2eO4nAbwLaY', '20240217152346', '565', '10.00', '2500.00', '25000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2448, '6S6mjJO4GOs0rb9', '20240217152346', '564', '50.00', '290.00', '14500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2455, 'Wn8qvxyzC7TeU8y', '20240217153045', '570', '50.00', '600.00', '30000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2456, 'yYzcAjf9AQOaQYy', '20240217153659', '571', '4.00', '39500.00', '158000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2454, 'B7OLTIdfHCwpVTa', '20240217154738', '573', '20.00', '100.00', '2000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2453, 'w9rmMxnKDgRnBmZ', '20240217154738', '572', '35.00', '250.00', '8750.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9276, 'xaBxnXDZPSIgg12', '20240213150708', '438', '2.00', '300.00', '600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9274, 'VBR6kb0lNhTToAw', '20240213150708', '439', '2.00', '250.00', '500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9273, 'DqOdVmJa0TyI39w', '20240213150708', '454', '5.00', '370.00', '1850.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9272, 'El3UoJtEfGpEXq6', '20240213150708', '440', '1.00', '450.00', '450.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2447, 'C3trKPvJzdNbguM', '20240217164057', '575', '36.00', '3500.00', '126000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5432, 'JFzDvElakOtt3yr', '20240218074400', '730', '172.00', '150.00', '25800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9201, '2YQevorafruh6Xf', '20240218081020', '823', '4.00', '1000.00', '4000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9200, 't15GZqMlEuacW5U', '20240218081020', '824', '1.00', '4000.00', '4000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9199, 'R6ytRBnLAbKOl1Q', '20240218081020', '584', '4.00', '2600.00', '10400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9198, 'TcsIIifcccolFgg', '20240218081020', '583', '3.00', '2300.00', '6900.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9197, 'Teg1NLoma31Iwuy', '20240218081020', '582', '3.00', '1500.00', '4500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9196, '2Kh3xIkUC6UVK3j', '20240218081020', '581', '8.00', '1000.00', '8000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9195, 'ngJsit8pAx9X7ym', '20240218081020', '580', '2.00', '5500.00', '11000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9194, 'S16X4HTM2ENl520', '20240218081020', '579', '5.00', '2200.00', '11000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8917, 'kfUzOFSgEYt2APj', '20240214131722', '548', '2.00', '3500.00', '7000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8916, 'lDYuZvnsTzWMinc', '20240214131722', '549', '1.00', '1700.00', '1700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8915, '89vWbdql68F7nbm', '20240214131722', '550', '7.00', '200.00', '1400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8914, 'JZ0MkX1GUPcC1YL', '20240214131722', '551', '5.00', '140.00', '700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8913, 'IVSU3gJNSAebdXJ', '20240214131722', '552', '1.00', '1800.00', '1800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8912, 'lcZyqn1o0qMDqAr', '20240214131722', '530', '2.00', '850.00', '1700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8911, 'IQ9lEEZaXT5rZjU', '20240214131722', '554', '9.00', '500.00', '4500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8910, 'H5BvH1vqWd4CUrj', '20240214131722', '555', '2.00', '1550.00', '3100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2624, 'sHLTFanLbFBBItQ', '20240201145453', '220', '51.00', '180.00', '9180.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2623, 'uuJqG9807LcS0EH', '20240201145453', '219', '13.00', '380.00', '4940.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2622, '2qMYUboK4BjdJjl', '20240201145453', '218', '6.00', '170.00', '1020.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2621, 'oOcRaekP4zBvywY', '20240201145453', '217', '6.00', '180.00', '1080.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2620, 'vfLAgdIncpcmhGi', '20240201145453', '216', '2.00', '1600.00', '3200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2619, 'zysI5ftNZeBr1lc', '20240201145453', '215', '12.00', '150.00', '1800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2618, 'hwmqZUdxAUFCDAH', '20240201145453', '214', '2.00', '480.00', '960.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2617, '9fXrvvW3J2b8xtN', '20240201145453', '213', '14.00', '170.00', '2380.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2646, 'BKW4k96Nc7tHXM', '20240201145453', '600', '10.00', '400.00', '4000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (2647, 'fcZqtpans2r7RmR', '20240201145453', '601', '1.00', '230.00', '230.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5671, 'laNCTvuSVaRd7rt', '20240124154656', '20', '300.00', '115.00', '34500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9271, 'dqzyVlG6ngRsXCn', '20240213150708', '447', '4.00', '850.00', '3400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9270, '17XPjOGFMBO4Bi4', '20240213150708', '455', '7.00', '230.00', '1610.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9269, 'EJp2R1OLbVq2mtu', '20240213150708', '457', '1.00', '450.00', '450.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9268, 'rMWWv79NjjpS3mA', '20240213150708', '458', '2.00', '60.00', '120.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9267, 'nZWsMFrYJrt4UQM', '20240213150708', '456', '1.00', '410.00', '410.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9266, 'm5ZU80xI3x0Nbso', '20240213150708', '462', '1.00', '8650.00', '8650.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9265, 'Yn0o49bmwchBCoz', '20240213150708', '460', '1.00', '1000.00', '1000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9264, '6nnQAzjyGd6mh3e', '20240213150708', '463', '2.00', '420.00', '840.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9263, 'wUn0q7GATukMY51', '20240213150708', '461', '6.00', '1500.00', '9000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9262, 'uLiDZiEAak8zz3f', '20240213150708', '459', '1.00', '1100.00', '1100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9261, '4z68bIaubko7xHc', '20240213150708', '465', '1.00', '1100.00', '1100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9260, 'BwBmJvXHUQBPMTW', '20240213150708', '464', '4.00', '500.00', '2000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9259, '9p6C7aFxDqott6G', '20240213150708', '468', '12.00', '225.00', '2700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9258, 'LBR9avgt38zDUGy', '20240213150708', '471 ', '1.00', '1180.00', '1180.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9257, 'XYNTBY7RXyvA3vL', '20240213150708', '466', '1.00', '350.00', '350.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9256, '5OEBKtAfxRTAETU', '20240213150708', '467', '12.00', '335.00', '4020.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9255, 'Ot285MMMI3nW0Xu', '20240213150708', '470 ', '12.00', '60.00', '720.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9254, 'ukLUhpqzo447olD', '20240213150708', '469', '14.00', '1050.00', '14700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9253, '3SSTPIwFw070TTS', '20240213150708', '472 ', '6.00', '150.00', '900.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9252, 'XicEab7cU1KlqAO', '20240213150708', '474', '6.00', '100.00', '600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9251, 'Pxz0q3CdSfv3dgE', '20240213150708', '473', '1.00', '350.00', '350.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9250, 'Ni43e3s2ZxkYeuC', '20240213150708', '475', '500.00', '24.00', '12000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9249, '15h5eaqYmmsgRub', '20240213150708', '480 ', '5.00', '200.00', '1000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9248, 'WgD2KlsSOCefdHd', '20240213150708', '476', '5.00', '90.00', '450.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9247, 'dHJ6uxNYIYSFLd0', '20240213150708', '479', '4.00', '1100.00', '4400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9246, '8XJBkezPhpyISW9', '20240213150708', '481', '1.00', '390.00', '390.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9245, 'DlUNZmzrFYx1WI9', '20240213150708', '482', '1.00', '1250.00', '1250.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9244, '81hwJLKWCMnMGfS', '20240213150708', '484', '4.00', '275.00', '1100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9243, '64kx8yXXhSrFWhp', '20240213150708', '483', '2.00', '100.00', '200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5040, 'rtiaGBSxIDFdY9Z', '20240218112422', '746', '1.00', '200.00', '200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5039, 'OhrCZcXrkSpbmm7', '20240218112422', '745', '1.00', '1150.00', '1150.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5038, 'te0MxAPWW5ybMcl', '20240218112422', '744', '1.00', '1200.00', '1200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5037, 'MDlmTRjLXfEU4tl', '20240218112422', '743', '1.00', '9000.00', '9000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5036, 'UlRhtlNFY2tmX5V', '20240218112422', '648', '30.00', '300.00', '9000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5035, 'rO0ZiaNm9qijTsd', '20240218112422', '647', '2.00', '270.00', '540.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5034, 'gd9HO089M7aSG3A', '20240218112422', '646', '10.00', '145.00', '1450.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5033, 'ajJPwMvR9qF6gDA', '20240218112422', '645', '1.00', '350.00', '350.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5032, 'AQNgxGjabNu4uOd', '20240218112422', '554', '1.00', '500.00', '500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5031, 'xLYNUfYJBbGis2W', '20240218112422', '643', '10.00', '1450.00', '14500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5679, '5QYCHoArPMipwNj', '20240124154656', '794', '200.00', '140.00', '28000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9781, 'Wd0gstF6zzwqC2n', '20240218121742', '656', '2.00', '21096.00', '42192.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9780, 'rR99Yc3RU2kqUJR', '20240218121742', '671', '2.00', '2961.00', '5922.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9779, 'RXtqqFOwOWZASeK', '20240218121742', '660', '31.00', '1044.00', '32364.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9778, 'Sy6SH6zzYkezKkl', '20240218121742', '658', '1.00', '29741.00', '29741.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9777, '8s76vtlFzPdAC3t', '20240218121742', '657', '2.00', '21096.00', '42192.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9776, 'stt1i1jckNHMpwd', '20240218121742', '664', '40.00', '2292.00', '91680.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9775, '4YOkYmg16uFE9gv', '20240218121742', '661', '31.00', '1557.00', '48267.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9774, 'wUeq2GxEatelxll', '20240218121742', '659', '29.00', '1044.00', '30276.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9773, 'JEMGLZgl8adgzMC', '20240218121742', '666', '40.00', '3208.00', '128320.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9769, '1snUtrIzJn38NMC', '20240218121742', '663', '40.00', '2292.00', '91680.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9770, 'Hr2fO1a9hGcO4r2', '20240218121742', '665', '40.00', '3208.00', '128320.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9771, 'HZUjiK7TvLLcUHF', '20240218121742', '667', '10.00', '4190.00', '41900.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9772, 'qDtDDp4du9efThD', '20240218121742', '662', '29.00', '1557.00', '45153.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9768, '2C0DcAa3fpK2RQf', '20240218121742', '670', '10.00', '5126.00', '51260.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9767, '8lBnFCfawD0fGT5', '20240218121742', '669', '10.00', '5126.00', '51260.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9766, 'M5apVRCvtbRREz9', '20240218121742', '668', '10.00', '4190.00', '41900.00', '1', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9765, 'E2lOXeTsewcHsHl', '20240218121742', '653', '5.00', '2961.00', '14805.00', '9', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9764, 'FzGbGJcPccQorno', '20240218121742', '652', '10.00', '2961.00', '29610.00', '3', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9763, 'lyFZaYxAme5tXjI', '20240218121742', '654', '15.00', '2961.00', '44415.00', '4', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9762, 'voEDjJ0lzqak7nR', '20240218121742', '650', '75.00', '2961.00', '222075.00', '2', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6070, 'tMHfi1HATlIr8JY', '20240218132207', '829', '100.00', '280.00', '28000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6069, 'z9w309BUqN9C5w1', '20240218132207', '782', '1.00', '451.00', '451.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6068, 'jHveHzoHeQSORFO', '20240218132207', '688', '20.00', '360.00', '7200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6067, 'ozwREz8c38lQxkl', '20240218132207', '689', '4.00', '286.00', '1144.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6066, 'puXXPir0syh47HZ', '20240218132207', '407', '5.00', '330.00', '1650.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6065, 'xgUKIlDR4kWaF1B', '20240218132207', '682', '2.00', '250.00', '500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6064, 'iapEJqovDovFqDQ', '20240218132207', '681', '6.00', '310.00', '1860.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6063, 'HOxKPuy5h7UjoO9', '20240218132207', '680', '10.00', '336.00', '3360.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6062, 'EsrKV6rcP0KlTK8', '20240218132207', '679', '8.00', '259.00', '2072.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6061, 'LyD0Lt8h8hMdkrR', '20240218132207', '678', '47.00', '286.00', '13442.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6060, 'aRFuwbwYyBCMvbp', '20240218132207', '401', '9.00', '475.00', '4275.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6059, 'KRA7tucXfU3PR3J', '20240218132207', '776', '77.00', '486.00', '37422.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6058, '5wtm7l2Jp5CZnN6', '20240218132207', '672', '12.00', '100.00', '1200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6057, 'lFlNgFijuI0IyVX', '20240218132207', '673', '6.00', '580.00', '3480.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6056, 'TGdqESRJPwGoqpH', '20240218132207', '674', '3.00', '780.00', '2340.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6055, '6RHL7dzULbOdSER', '20240218132207', '675', '8.00', '50.00', '400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6054, 'SZ2FtbCc0nEeVSF', '20240218132207', '684', '20.00', '360.00', '7200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6509, '1Xxnf4XGy9IRkkn', '20240313074325', '242', '105.00', '490.00', '51450.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6505, '3bbKVtf4MzviQL4', '20240218143236', '700', '200.00', '160.00', '32000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6504, 'AwhM9QQQ0o5GYAV', '20240218143236', '698', '180.00', '290.00', '52200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6503, 'KEptI3KcFXFT0q', '20240218143236', '699', '100.00', '320.00', '32000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6502, '5Zuj7oTjlUAVPXF', '20240218143236', '696', '2.00', '600.00', '1200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6501, 'H6wa6brQ5zfCa6b', '20240218143236', '697', '80.00', '400.00', '32000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6500, 'mHgnT9StSTTzTVG', '20240218143236', '695', '15.00', '280.00', '4200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6499, 'OSQrUcyCEOI0RMp', '20240218143236', '694', '410.00', '130.00', '53300.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6498, 'ibPT8ZgWUqxDTQn', '20240218143236', '691', '1.00', '1400.00', '1400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6497, 'NWyur0Bs5FliMqg', '20240218143236', '693', '400.00', '130.00', '52000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6496, 'PRSxdvETO7YfNQp', '20240218143236', '704 ', '50.00', '550.00', '27500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6495, 'NxtYZnFIsrVvvCS', '20240218143236', '692', '1.00', '1100.00', '1100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6493, '2Jq27SIq9Mw9ln6', '20240218143236', '707', '10.00', '150.00', '1500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6490, 't4p9LTKBS2Zj5bf', '20240218143236', '706 ', '2.00', '450.00', '900.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9761, 'o3vCylmOrnrwQTY', '20240218121742', '649', '118.00', '2961.00', '349398.00', '8', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6494, 'GW7ScOOdu6SQ9qX', '20240218143236', '703', '30.00', '900.00', '27000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6492, 'crkd7bhml8pCvIg', '20240218143236', '701', '20.00', '1080.00', '21600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13320, 'D2uWsuDvOwjcLCE', '20240201155743', '258', '1.00', '450.00', '450.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6417, 'QTdiHtVotmcMPUV', '20240219081530', '819', '1.00', '1900.00', '1900.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13764, 'ZaqGkTugInYj57m', '20240219083123', '712', '100.00', '320.00', '32000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13763, 'uLSkyBVLYAYLVN5', '20240219083123', '712', '150.00', '320.00', '48000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13762, 'cZiYFZsGnxMdvfY', '20240219083123', '713', '98.00', '310.00', '30380.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6416, 'TY4kak1fzYkNH8n', '20240219081530', '710', '1.00', '270.00', '270.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10095, '9Nq9zapnDIAQvyh', '20240402162259', '716', '304.00', '190.00', '57760.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10094, 'abhBpoT3tQWnMcS', '20240402162259', '717', '26.00', '270.00', '7020.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10093, 'bo3covY9Eu9JMLu', '20240402162259', '718', '498.00', '220.00', '109560.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9940, 'iLIiT1q7P4YTEFD', '20240219084954', '742', '0.00', '0.00', '0.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7157, 'p39WzMKsCHa8LtT', '20240219094915', '609', '2.00', '800.00', '1600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7156, 'AUwpgc1vuDyQyUU', '20240219094915', '614', '1.00', '200.00', '200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7155, 'U7sn7yhBwVYEmti', '20240219094915', '608', '10.00', '418.00', '4180.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7154, 'TxJxak0w6psXOQl', '20240219094915', '610', '1.00', '1025.00', '1025.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7153, 'HrRgnfIxNW7hlf1', '20240219094915', '617', '1.00', '600.00', '600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7152, 'YsDrn7pNubBZNtr', '20240219094915', '618', '2.00', '300.00', '600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7151, '5WfLMtIq6LuwuvY', '20240219094915', '480 ', '10.00', '500.00', '5000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7150, 'RAxUV4HhdH51XQE', '20240219094915', '607', '6.00', '285.00', '1710.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5645, 'sQ76SzMayBUw3eb', '20240219100856', '801 ', '2.00', '350.00', '700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12435, 'nxnPZ7e2NHsSMGT', '20240219101122', '575', '3.00', '3500.00', '10500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5994, 'aMIBJQ97Od7F65w', '20240219101430', '722', '24.00', '264.00', '6336.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7148, 'HjHp8h0GgDaejxT', '20240219094915', '622', '12.00', '10.00', '120.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7149, 'ZsLnNMZST2HRX85', '20240219094915', '619', '1.00', '100.00', '100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7147, 'jsj9ZhRFiAxbi6', '20240219094915', '620', '24.00', '5.00', '120.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7146, 'SlLlDLcJsdG54xg', '20240219094915', '621', '1.00', '4800.00', '4800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13777, 'cdQQm1UScgDs4fY', '20240205154059', '603', '422.00', '250.00', '105500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (3892, 'MnUIRRYUhtePrC2', '20240205171507', '727', '6.00', '4800.00', '28800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7145, '8tuQxlMtN6vAIRT', '20240219094915', '623', '90.00', '26.00', '2340.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13711, '1JUk6kguXtFIQpd', '20240203141705', '489', '24.00', '125.00', '3000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8909, 'GAZeVEL8GUfWQh7', '20240214131722', '557', '6.00', '230.00', '1380.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8908, 'zIQvTrma0gdmNqS', '20240214131722', '558', '2.00', '800.00', '1600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8907, '9GEwxAyNZfse0KA', '20240214131722', '559', '2.00', '50.00', '100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9242, '4qdluOqjK2isJHo', '20240213150708', '740', '1.00', '13000.00', '13000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9241, 'sxdgQH64cdsDhtA', '20240213150708', '741', '1.00', '780.00', '780.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9240, 'geFNPwfL77Kttjc', '20240213150708', '474', '5.00', '100.00', '500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5644, '7oCDZryBF4ULQHL', '20240219100856', '720', '1.00', '5500.00', '5500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9535, 'd4TvRxNEA5SL8NO', '20240205145350', '602', '23.00', '1500.00', '34500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5030, 'ZJtjgoxJ4HVoATV', '20240218112422', '642', '4.00', '6200.00', '24800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5029, 'GbgeEQsYNc7exhi', '20240218112422', '641', '12.00', '305.00', '3660.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5028, 'ZsSW87S0FwVxAA3', '20240218112422', '640', '25.00', '260.00', '6500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5027, 'xWWNZcYqyEikFlv', '20240218112422', '639', '40.00', '160.00', '6400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5026, 'KZMRDfJoxI4b5XI', '20240218112422', '638', '20.00', '4150.00', '83000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14311, 'g7WxL56Qup3ffzl', '20240224141452', '756', '1.00', '700.00', '700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14310, 'LTZlD62ciRqqo8U', '20240224141452', '755', '2.00', '596.00', '1192.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14309, '5cufTK1FuRu03HJ', '20240224141452', '754', '2.00', '567.00', '1134.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14308, '7VKdnrYEJZpNL6B', '20240224141452', '753', '100.00', '100.00', '10000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14307, 'MB33OyGQvPlCCG', '20240224141452', '752', '100.00', '88.00', '8800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14306, 'HoFVkBN78gIn96S', '20240224141452', '751', '104.00', '245.00', '25480.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14305, 'FJl2jv8ccMCfJUV', '20240224141452', '750', '39.00', '530.00', '20670.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14304, 'udrfK5OovpylWp7', '20240224141452', '749', '27.00', '490.00', '13230.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14303, 'Ft5Vzc6cWQwwQl5', '20240224141452', '748', '20.00', '530.00', '10600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12383, 'HtCYPn37SHKVEfK', '20240224143946', '758', '10.00', '1100.00', '11000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12382, 'lUm9ZLNvIki8W15', '20240224143946', '759', '14.00', '1000.00', '14000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6053, 'oPigkHnfj1poty8', '20240218132207', '686', '20.00', '250.00', '5000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9317, 'eCXMZ3Gf6OrbGcz', '20240224152146', '1050', '3.00', '850.00', '2550.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9316, 'feYwyzh6DSQkiXZ', '20240224152146', '809', '100.00', '10.00', '1000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9315, 'BEhE3xAzRIHMoBy', '20240224152146', '736', '2.00', '250.00', '500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9314, 'ik4gZF6nxrLlfxH', '20240224152146', '735', '2.00', '150.00', '300.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9313, 'O3Dewrrekd6MiH9', '20240224152146', '734', '2.00', '120.00', '240.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9312, 'mRnGS3B7VprNF2c', '20240224152146', '733', '2.00', '80.00', '160.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9311, 'BFqaOaVGwtsxTxg', '20240224152146', '786', '5.00', '250.00', '1250.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9310, 'RuET56aV939rEsN', '20240224152146', '785', '5.00', '175.00', '875.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5816, 'RMVeZu8L311LovH', '20240225073613', '727', '2.00', '4800.00', '9600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5815, 'Atl7WBaK6KZOihf', '20240225073613', '726', '3.00', '4800.00', '14400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5814, 'CFzwbatzvB73qa1', '20240225073613', '327', '8.00', '8707.00', '69656.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5813, 'ouCNHSSNxIHMh0F', '20240225073613', '300', '8.00', '8707.00', '69656.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7144, 'R7XUykR1gQD5o0q', '20240219094915', '723', '1.00', '200.00', '200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7143, 'pMXMwVXSz16ABbi', '20240219094915', '636', '1.00', '300.00', '300.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8905, '4sCKuwDX9ftW5SU', '20240214131722', '562', '1.00', '700.00', '700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13761, 'PHxJlmW5zMwgJaJ', '20240219083123', '714', '150.00', '325.00', '48750.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7142, 'KlInJb634Dmi4vO', '20240219094915', '634', '4.00', '8240.00', '32960.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5042, 'aJ7INOk6QBAJPsg', '20240218112422', '644', '1.00', '500.00', '500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5043, 'mRTa3VNnilUMh2s', '20240218112422', '645', '1.00', '350.00', '350.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5812, 'GR2tqF8wKKrF036', '20240225073613', '738', '1.00', '3610.00', '3610.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9309, 'rzCRmYSR3wzaCiL', '20240224152146', '784', '11.00', '135.00', '1485.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9308, 'cQNQZid6dPo61p9', '20240224152146', '783', '5.00', '110.00', '550.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9307, 'zBU3uTLGNCPVYFl', '20240224152146', '787', '90.00', '25.00', '2250.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7141, 'Hvf92SvvLn2TKLv', '20240219094915', '624', '1.00', '3700.00', '3700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7140, 'GVin9JZWT2I8TVu', '20240219094915', '725', '1.00', '180.00', '180.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5670, '3LJTF51RsBWAKHp', '20240124154656', '21', '200.00', '130.00', '26000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5643, 'dvJ4TikaO59owwi', '20240219100856', '810', '500.00', '103.00', '51500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5431, 'l2VOCVSpTAJbKBf', '20240218074400', '729', '45.00', '100.00', '4500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5430, 'eK4gh2p21s6GdAc', '20240218074400', '576', '1.00', '15500.00', '15500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9306, 'JClaJKUtFxsuUXb', '20240224152146', '788', '5.00', '1050.00', '5250.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9305, 'qZwYyhgr5GnslNa', '20240224152146', '213', '20.00', '170.00', '3400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9304, '74AcmGIk3H9LmvD', '20240224152146', '224', '5.00', '550.00', '2750.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9303, '6vgq0pfoZOH5U9v', '20240224152146', '221', '24.00', '500.00', '12000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5175, 'MDGeXijCqzuDhCw', '20240124145800', '491', '50.00', '190.00', '9500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7139, 'w0MjhpPIpp4nTM9', '20240219094915', '724', '1.00', '240.00', '240.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9302, 'SYG7SbClppRVIJL', '20240224152146', '600', '50.00', '42.00', '2100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6491, 'AUr2iXR7lU73Fl8', '20240218143236', '705', '40.00', '250.00', '10000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6489, '4VUOspXwHfu3FF6', '20240218143236', '690', '30.00', '830.00', '24900.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6488, 'x7evVoLnSU4lKif', '20240218143236', '242', '20.00', '490.00', '9800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6487, '3DbYEPXWdNvy2nc', '20240218143236', '802', '20.00', '280.00', '5600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6486, 'RCpLAKPokBkvme4', '20240218143236', '803', '36.00', '550.00', '19800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6485, '2YcLTrcJB7GIhom', '20240218143236', '805', '20.00', '830.00', '16600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6484, 'DkooIGeQW50NmB9', '20240218143236', '807', '3.00', '580.00', '1740.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6483, 'IsxYBVH4sxkLTdH', '20240218143236', '806', '3.00', '700.00', '2100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6482, 'axprV3FVTn8hKpz', '20240218143236', '808', '10.00', '260.00', '2600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9301, 'KEWkwa30osRYjoF', '20240224152146', '218', '50.00', '170.00', '8500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5642, 'bbcpk2IEe1n16kE', '20240219100856', '739', '30.00', '400.00', '12000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5641, 'QXQSvislboD3LTB', '20240219100856', '812', '1000.00', '90.00', '90000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5640, '2JzCJMcaG7ZCre1', '20240219100856', '811', '500.00', '103.00', '51500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5639, 'F0vbNrXeaGrEGOR', '20240219100856', '814', '200.00', '135.00', '27000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5637, '4jzpowQTkON9CCG', '20240219100856', '815', '100.00', '135.00', '13500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5638, 'WcxAgDvPXaWK4Yv', '20240219100856', '813', '840.00', '79.00', '66360.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6481, 'SkW5gfg3vCcPj08', '20240218143236', '708', '1.00', '2550.00', '2550.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7138, 'WXGcbgsbI1i9hHU', '20240219094915', '791', '1.00', '1000.00', '1000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7137, 'ynoXppJHA3oeFHc', '20240219094915', '790', '5.00', '90.00', '450.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7136, 'UsUFEEdTzLe87n4', '20240219094915', '774', '5.00', '460.00', '2300.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7135, '6EhzidfnzaKbsvn', '20240219094915', '635', '16.00', '120.00', '1920.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7133, 'XmJ8WiMgDOZmo7G', '20240219094915', '775', '39.00', '30.00', '1170.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7134, 's4QCgzF7Gq7aB20', '20240219094915', '764', '1.00', '3200.00', '3200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7132, 'NbYvJt5w8hE1az1', '20240219094915', '772', '60.00', '30.00', '1800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13634, 'RDb7788sEkuyl2e', '20240229132112', '270', '69.00', '160.00', '11040.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9193, 'EdhKze5o3JgveC1', '20240218081020', '578', '5.00', '2000.00', '10000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9192, '51WJZwHqMeZWrRt', '20240218081020', '577', '11.00', '1250.00', '13750.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5646, 'r2Zr1Hhb1vAWg6A', '20240219100856', '825', '500.00', '115.00', '57500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5647, '2Q7C7zpuc300Al8', '20240302094323', '828', '250.00', '155.00', '38750.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5648, 'Iuktprg73JBr48X', '20240302094323', '827', '200.00', '115.00', '23000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6052, 'HUz8XegEkKztrgO', '20240218132207', '687', '20.00', '230.00', '4600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6051, '4ajuqNyvothtL7c', '20240218132207', '820', '18.00', '400.00', '7200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6415, 'px7vyaSux7ULbuM', '20240219081530', '711', '240.00', '62.00', '14880.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5817, 'aasR3VZ2cvu49cV', '20240225073613', '290', '20.00', '6146.00', '122920.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5818, '3Y0UCJsvGy9C6EM', '20240225073613', '316', '5.00', '6146.00', '30730.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6414, 'tFoBLdEvCMutzs0', '20240219081530', '830', '17.00', '90.00', '1530.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9300, 'mdVD8Xqnp9vEtqy', '20240224152146', '731', '50.00', '10.00', '500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10070, 'HocLCmqloITmlcd', '20240131144117', '190', '1.00', '2500.00', '2500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14447, 'JNT1IqPfBA3kbn4', '20240205160956', '1158', '12.00', '30.00', '360.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14446, 'r2ZRKMMIHHGouqr', '20240205160956', '1133', '12.00', '30.00', '360.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14445, 'ZnDeHJHKmyaJplb', '20240205160956', '1046', '8.00', '50.00', '400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14444, 'hxlmcE90E249d36', '20240205160956', '1041', '100.00', '25.00', '2500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14443, 'CG3LEy3YZ9SLtYd', '20240205160956', '1040', '100.00', '18.00', '1800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5990, 'sulsTXMZNwUI5nd', '20240303134455', '844', '15.00', '1250.00', '18750.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5991, 'EeE2ACDcVklAhTs', '20240303134455', '845', '1.00', '850.00', '850.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5992, 'e75Yzb7duQFHwfh', '20240303134455', '846', '2.00', '50.00', '100.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (5993, 'x4dZQxSW78MW1vl', '20240303134455', '847', '1.00', '900.00', '900.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6005, 'vFAnYr2lautNeyi', '20240127152129', '35', '24.00', '85.00', '2040.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6006, '4L21DbfWylZeIDn', '20240127152129', '36', '12.00', '210.00', '2520.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14442, 'V1bnqQcYoXu5gcd', '20240205160956', '1038', '200.00', '10.00', '2000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6031, 'tWGZ0gJAVSHrMED', '20240304101147', '848', '20.00', '100.00', '2000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6032, 'mxEhAht0LBAhfco', '20240304101147', '857', '24.00', '120.00', '2880.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6033, 'JA1fGd67tDxhAqv', '20240304101147', '858', '10.00', '115.00', '1150.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6034, 'KH8kwk8luAMasx6', '20240304101147', '849', '72.00', '10.00', '720.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6035, 'VHwiIILysZtZxQo', '20240304101147', '850', '3.00', '750.00', '2250.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6036, '3xHrfGdE4TD4oV6', '20240304101147', '856', '4.00', '480.00', '1920.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6037, 'LapaUXsmMVjBBug', '20240304101147', '855', '3.00', '285.00', '855.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6038, 'qIw2bYiVjaH95II', '20240304101147', '854', '2.00', '290.00', '580.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6039, 'PQp7503U1YDOdzN', '20240304101147', '851', '6.00', '250.00', '1500.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6040, 'Rbgp9Pa1RJkTF3Y', '20240304101147', '852', '2.00', '350.00', '700.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6041, 'J8Thfz9SgMRv1pF', '20240304101147', '853', '6.00', '30.00', '180.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6265, '7Dq4aZUgOEEyyVm', '20240304150336', '859', '2.00', '14200.00', '28400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6818, 'UWa2WXZmn4rxK7o', '20240306080604', '300', '0.00', '8707.00', '0.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6100, 'QeIIKALGpTbjIHS', '20240306081108', '854', '3.00', '290.00', '870.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6099, 'v7wFYpNFl5aMPO9', '20240306081108', '855', '20.00', '285.00', '5700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6101, 'Sf172zkSNcnREC7', '20240306081108', '861', '12.00', '450.00', '5400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6102, 'y5QBT3KORtIBS9h', '20240306081108', '862', '10.00', '155.00', '1550.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6103, '6SlAtcRGvgl9grt', '20240306081108', '863', '3.00', '347.00', '1041.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7130, '4RHSXsjlo4hwjd7', '20240219094915', '767', '1.00', '2500.00', '2500.00', '4', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7131, 'hIh2T9Y18qJyaQn', '20240219094915', '763', '1.00', '1050.00', '1050.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7129, 'OWsVOqZuu4LI3GH', '20240219094915', '816', '2.00', '5300.00', '10600.00', '6', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6201, 'cLwclEQIMkS8arw', '20240306115339', '864', '12.00', '220.00', '2640.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6202, 'dYR9XSp061jOz8Y', '20240306115339', '865', '12.00', '280.00', '3360.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13184, 'm5sytZY7KY4h7a', '20240306120253', '921', '252.00', '50.00', '12600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6245, 'xSkeYUCUCX5ugM8', '20240311094742', '880', '12.00', '220.00', '2640.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6246, '22tToamAf83oFqq', '20240311094742', '881', '12.00', '280.00', '3360.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6370, 'w33V8AWasUNMrxv', '20240311101341', '891', '20.00', '253.00', '5060.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6369, 't8xSMiovJk6Lr0u', '20240311101341', '890', '20.00', '222.00', '4440.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6368, 'd0wWEbwANf0dcxq', '20240311101341', '889', '10.00', '231.00', '2310.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6367, '5Y9KvFmXQi1rAV', '20240311101341', '888', '40.00', '322.00', '12880.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6366, 'N5JMgxWBzF9qFNu', '20240311101341', '887', '20.00', '297.00', '5940.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6365, 'hwUJuHAdJffymp3', '20240311101341', '886', '60.00', '277.00', '16620.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6364, 'nX5Gp5uKi2oDVNN', '20240311101341', '885', '24.00', '431.00', '10344.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6363, 'K0YF9uEbFVnXpOo', '20240311101341', '884', '36.00', '452.00', '16272.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6362, 'dgNs2xhTvCTk0BT', '20240311101341', '883', '36.00', '460.00', '16560.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6262, 'yggU3l3l12Ld6lg', '20240311101927', '892', '30.00', '150.00', '4500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7647, 'jqLhXt3rSO5KRtx', '20240314145625', '937', '-41.00', '25.00', '-1025.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7646, 'HVoCPc7SnbouAOD', '20240314145625', '937', '-41.00', '25.00', '-1025.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10201, 'FS1EWM9l5QFAXmz', '20240311102859', '895', '50.00', '45.00', '2250.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10200, 'rIfrkgfTdAnQf1o', '20240311102859', '894', '1.00', '1400.00', '1400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10199, 'NicfWAd6wxSowCE', '20240311102859', '893', '30.00', '220.00', '6600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6263, 'RGGuMS4nrjJqQOf', '20240311101927', '896', '20.00', '4667.00', '93340.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6264, 'l4XcXkOeP7mLIZR', '20240311101927', '897', '8.00', '10033.00', '80264.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14441, 'mCz4eHSp5XRvfJs', '20240205160956', '1137', '30.00', '120.00', '3600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12434, 'rvRlaItR8Gkvu9U', '20240219101122', '721', '2.00', '6250.00', '12500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6508, 'xC88T40TGWyZDZT', '20240313074325', '257', '2.00', '550.00', '1100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6507, 'io3ddks2IsGClnl', '20240313074325', '900', '3.00', '1350.00', '4050.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14438, 'baF7tPY4LunEfHi', '20240205160956', '1037', '100.00', '9.00', '900.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14440, 'ZmEn2Uc2whlmsol', '20240205160956', '1013', '24.00', '16.00', '384.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14439, 'aJVd9fHnJsBuxK4', '20240205160956', '1014', '100.00', '160.00', '16000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6371, 'GzVfodcOrN4wSNJ', '20240311101341', '883', '1.00', '460.00', '460.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6372, 'j7tWz4uXnnbaLIC', '20240311101341', '887', '1.00', '297.00', '297.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6373, 'hDzY1P10jxKcPwk', '20240311101341', '910', '4.00', '180.00', '720.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6374, 'K4DQX1K0HcHRKr5', '20240311101341', '911', '4.00', '240.00', '960.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6375, '3QOgZ5VbfpmTycV', '20240311101341', '912', '4.00', '70.00', '280.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6376, 'tLyAFLhBSN18lMB', '20240311101341', '914', '12.00', '90.00', '1080.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6377, 'xlVt1nrDy9yO37h', '20240311101341', '913', '12.00', '80.00', '960.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6378, 'v9KyY2bmgj9FVRl', '20240311101341', '915', '4.00', '150.00', '600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6379, 'UzCSiYxJPvSC9Qs', '20240311101341', '917', '10.00', '40.00', '400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6380, 'oPtPazf4ytRUnFQ', '20240311101341', '918', '10.00', '155.00', '1550.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6381, 'Zlj4W14GCxs0x20', '20240311101341', '919', '6.00', '150.00', '900.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14437, 'qX9kdnFmtfV45LP', '20240205160956', '1039', '100.00', '12.00', '1200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6418, 'mYmyXwix6NHFNxZ', '20240219081530', '902', '2.00', '380.00', '760.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6419, 'Z5FOzcH0QznlFut', '20240219081530', '901', '1.00', '450.00', '450.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14436, '1BA7L650RfeourB', '20240205160956', '898', '120.00', '5.00', '600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6506, 'FK9tTV8XDEqOxkh', '20240313074325', '899', '100.00', '73.00', '7300.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6510, 'nCtkHTna5mKC3sR', '20240313074325', '240', '20.00', '260.00', '5200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13183, 'HA6mTxWZ2zD8lFB', '20240306120253', '922', '360.00', '40.00', '14400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13182, '5iVGk4gR2oR35sz', '20240306120253', '866', '186.00', '120.00', '22320.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6517, 'oWpcrBLPqRF6tGj', '20240311102140', '292', '3.00', '14986.00', '44958.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7645, 'QX9oEDfFEDt2fn2', '20240314145625', '938', '6.00', '300.00', '1800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7644, 'Dyu5XYGlHAQ38qy', '20240314145625', '924', '4.00', '480.00', '1920.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7643, 'EwlKno3mBoXI06C', '20240314145625', '923', '3.00', '230.00', '690.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7642, 'elIHM5FGrOSDQaw', '20240314145625', '925', '2.00', '800.00', '1600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7641, 'LhKDXW6UpTOWZ0A', '20240314145625', '926', '2.00', '320.00', '640.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7640, '6cmeH3WXeQfRZGl', '20240314145625', '927', '14.00', '320.00', '4480.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7639, 'frlI2TzRciSsFyg', '20240314145625', '928', '29.00', '35.00', '1015.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7638, 'WSUjKw6iQOO4HDw', '20240314145625', '929', '10.00', '150.00', '1500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7637, 'fkngxxWNQ62KZGt', '20240314145625', '930', '7.00', '260.00', '1820.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7636, 'zFzYpFkQkXhdPS', '20240314145625', '931', '9.00', '260.00', '2340.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7635, 'kRg33qrdXRneo81', '20240314145625', '932', '2.00', '1200.00', '2400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7634, 'VZIgCEG4ochHLs8', '20240314145625', '933', '2.00', '1450.00', '2900.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7633, 'UomAvcoqhrP5hvH', '20240314145625', '934', '2.00', '1800.00', '3600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7632, 'ByGTmpFLhGrr1DB', '20240314145625', '935', '7.00', '35.00', '245.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7631, 'W709ajyq3s4J2eL', '20240314145625', '936', '12.00', '30.00', '360.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7630, 'uoOVceclYSCEkrO', '20240314145625', '937', '41.00', '25.00', '1025.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6592, 'aCaC1AE7EnC28fV', '20240316092326', '952', '1.00', '530.00', '530.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6591, 'Bbsx8OASeJ2AkDv', '20240316092326', '951', '3.00', '50.00', '150.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6590, '6izki7UWt639Dsg', '20240316092326', '950', '1.00', '70.00', '70.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6589, '8Ln3PzEXqet7qhp', '20240316092326', '949', '4.00', '450.00', '1800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6588, 'zb288UXkUlWT5xs', '20240316092326', '948', '1.00', '2350.00', '2350.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6587, 'Ymz3NQXc3iSntvW', '20240316092326', '947', '4.00', '750.00', '3000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6586, 'LFQQAXWNcncID7e', '20240316092326', '946', '1.00', '2500.00', '2500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6585, '4pDa4n46Ou5ZZua', '20240316092326', '943', '1.00', '280.00', '280.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6584, 'hpnklkBRdlmFqBC', '20240316092326', '940', '2.00', '460.00', '920.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6583, 'CS75B5czlowPNsw', '20240316092326', '939', '2.00', '480.00', '960.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6582, '7tS26dYZ9ux7Kez', '20240316092326', '942', '2.00', '45.00', '90.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6581, 'zhR2scoRzPM5CcU', '20240316092326', '941', '8.00', '50.00', '400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6580, 'YsKzT1bce0x3rfJ', '20240316092326', '944', '4.00', '550.00', '2200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6579, 'otVTTAUn7UHjLSu', '20240316092326', '945', '39.00', '70.00', '2730.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6593, 'PjrewEOpsaggPUL', '20240316092326', '953', '4.00', '90.00', '360.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6594, 'QQhIITpiv3IBAnE', '20240316092326', '954', '2.00', '80.00', '160.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6595, 'yDYSLyzb1AaFIvy', '20240316092326', '955', '25.00', '20.00', '500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6596, 'Nn6TIyMEnRYDA0Q', '20240316092326', '956', '23.00', '10.00', '230.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6597, 'i1EDB3NU7mUOX1Y', '20240316092326', '957', '25.00', '15.00', '375.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (6598, 'MBu4Mq8dk1rGDX5', '20240316092326', '958', '9.00', '10.00', '90.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12427, 'NIFppbKxU0mMkwL', '20240316123506', '959', '202.00', '1550.00', '313100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12426, 'hM8KDbKMMzB7Di1', '20240316123506', '769 ', '200.00', '173.00', '34600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12425, '2v5hM83ePeeVjkY', '20240316123506', '770', '100.00', '220.00', '22000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12424, 'iAHOUP5XGFLFFOS', '20240316123506', '189', '1.00', '3350.00', '3350.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12423, 'nYDY89JGUVXszV', '20240316123506', '187', '4.00', '6500.00', '26000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12422, 'kOd6PbnznCvsaVd', '20240316123506', '188', '5.00', '5600.00', '28000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7085, 'iE59ragbBXSUfJ1', '20240319123514', '491', '120.00', '190.00', '22800.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9938, 'eYzJyCz6LXyhhLK', '20240319123802', '821', '40.00', '6500.00', '260000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11229, 'yir6m7DE3KbY6y5', '20240319124136', '711', '200.00', '62.00', '12400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11228, 'ZEBA3gCZ2VX4TzE', '20240319124136', '830', '80.00', '85.00', '6800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10092, 'WgSrvKFZWzkfCcZ', '20240402162259', '715', '1525.00', '120.00', '183000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13709, 'deOTnOO6HDWI0bo', '20240319154902', '970', '1.00', '3200.00', '3200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13708, 'AWRkosEzYifnb5r', '20240319154902', '965', '4.00', '1700.00', '6800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13707, 'jhVpIdlw9WAZolZ', '20240319154902', '966', '4.00', '3000.00', '12000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13706, 'OvE2g6AJOGcZwR0', '20240319154902', '967', '6.00', '3500.00', '21000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13705, 'HKrTz9PvLTOqSxE', '20240319154902', '968', '4.00', '1550.00', '6200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13704, 'YNh0CzEL1irMlxB', '20240319154902', '969', '4.00', '2100.00', '8400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8066, 'GK71WpPzcxDRAw', '20240319160121', '977', '1.00', '400.00', '400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8065, 'DTa0p6f8fogOcS0', '20240319160121', '976', '1.00', '500.00', '500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8064, 'xPPbcYhnl8f3PhF', '20240319160121', '975', '5.00', '540.00', '2700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8063, 'VGgSCmAOh5h8tAC', '20240319160121', '974', '2.00', '2800.00', '5600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8062, 'XEZyiUxsvSCEPFe', '20240319160121', '973', '5.00', '300.00', '1500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8061, 'M9bQmkNILP6IYJg', '20240319160121', '972', '1.00', '10000.00', '10000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7108, 'GqdOX5CcZqNnakO', '20240319161245', '978', '4.00', '4400.00', '17600.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7109, 'WydBtpop77TBOyw', '20240319161245', '979', '12.00', '550.00', '6600.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7110, 'BWvoMtccV2xvbhH', '20240319161245', '980', '10.00', '980.00', '9800.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7111, 'nwvp1wCVIBf4gkc', '20240319161245', '981', '4.00', '550.00', '2200.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7112, 'H7kfXyZhbJJkkFk', '20240319161245', '982', '4.00', '60.00', '240.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7113, 'U2tXbZBnGsnJj3U', '20240319161245', '983', '1.00', '1800.00', '1800.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7123, 'hVPWn1caG1AGOXE', '20240320073005', '985', '12.00', '110.00', '1320.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7122, 'MrjVcW5zfupjqDt', '20240320073005', '984', '6.00', '250.00', '1500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7751, '25G8ifjQy6mBKIk', '20240320074828', '991', '1.00', '1400.00', '1400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7750, 'owJE0wDu7EQeO8O', '20240320074828', '990', '1.00', '1600.00', '1600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7749, 'LzPgB4c1sbaWDi7', '20240320074828', '989', '18.00', '60.00', '1080.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7748, 'Or184s0ov7SqKzK', '20240320074828', '988', '4.00', '350.00', '1400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7747, 'pwV0y4amn5qOthv', '20240320074828', '987', '1.00', '1200.00', '1200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7746, 'EAZV0Ic5Xoe9dF0', '20240320074828', '986', '1.00', '900.00', '900.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7124, 'SmsB05GNO5WGH14', '20240320073005', '992', '2.00', '25200.00', '50400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7125, 'SkUSBHUv1utxJUa', '20240320075630', '993', '10.00', '9200.00', '92000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7127, 'TAzgd9S0udQdWCp', '20240320092434', '994', '200.00', '165.00', '33000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7128, 'zXO0gGviO2aGd2s', '20240320092434', '995', '100.00', '106.00', '10600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7177, 'wSRWzTSkBsesW9W', '20240219094915', '818', '12.00', '484.00', '5808.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8060, 'CfFkE3sAAKvrdmW', '20240320121954', '996', '27.00', '30.00', '810.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8059, 'JVmDJRJP0XJz4vC', '20240320121954', '560', '59.00', '310.00', '18290.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8058, 'BF3B0VDghjLwaIP', '20240320121954', '534', '3.00', '130.00', '390.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8057, 'krkeMYoJt4DH3zz', '20240320121954', '535', '3.00', '150.00', '450.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8056, 'k0HsVxq3ZdKDgm8', '20240320121954', '555', '3.00', '1500.00', '4500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8055, 'ozpde1lLAMJuKio', '20240320121954', '532', '1.00', '1500.00', '1500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8054, 'wYcGDa6O1oIR5hU', '20240320121954', '792', '1.00', '3000.00', '3000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8053, 'yAsddMiLo71f6Vw', '20240320121954', '540', '108.00', '15.00', '1620.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8052, 'oYn7yog5c0Xv4Jr', '20240320121954', '585', '1.00', '2200.00', '2200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8051, 'cCks9UzzwpAo1PP', '20240320121954', '541 ', '8.00', '600.00', '4800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8050, '5YXHgrZAk3hkwcj', '20240320121954', '546', '16.00', '40.00', '640.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8049, 'ATmfmaFFksTigw4', '20240320121954', '543', '16.00', '30.00', '480.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8048, 'pz0p4WcXqcDSd1c', '20240320121954', '551', '14.00', '160.00', '2240.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8047, '21y9loo2rA5XDoc', '20240320121954', '538', '10.00', '160.00', '1600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7218, 'sg70ZtHAy6dUBSA', '20240320123450', '691', '1.00', '1350.00', '1350.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7217, '5NCGD9PCIRxtICB', '20240320123450', '240', '20.00', '250.00', '5000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7216, 'f36WfQ8ngdvFJVD', '20240320123450', '242', '105.00', '500.00', '52500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7215, 'mks7W93BeWnYbf5', '20240320123450', '700', '100.00', '160.00', '16000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7214, 'jr2MtL98jhjMyzP', '20240320123450', '256', '10.00', '820.00', '8200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7213, 'd0oKGYOMkS1QzH8', '20240320123450', '257', '13.00', '650.00', '8450.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7212, 'Duhmyt7n7M9oeEg', '20240320123450', '258', '10.00', '450.00', '4500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7219, 'M47nksPQt73Zbmy', '20240320123450', '997', '2.00', '725.00', '1450.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7220, '2WkoNB3VqVD6ZQp', '20240320123450', '998', '2.00', '1100.00', '2200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7221, 'wjqOpoy36GAbKgS', '20240320123450', '999', '1.00', '3600.00', '3600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7222, 'IvMTbfd7kMBWjmQ', '20240320123450', '1000', '100.00', '140.00', '14000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13680, 'sjpWTmFIOXgBItM', '20240403112716', '1077', '120.00', '98.00', '11760.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13679, 'GpHiOktJcA2RJAM', '20240403112716', '32', '83.00', '72.00', '5976.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9516, 'EuYV0c1KD0Sq2ZC', '20240320152200', '1003', '2.00', '5000.00', '10000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7228, 'V1GSHKo6mKDSu6Y', '20240321101318', '490', '100.00', '80.00', '8000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7229, '77yAvQndDhC36YB', '20240321101603', '481', '20.00', '41.00', '820.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7236, 'phRQ9aN6LWHCcuw', '20240321102419', '758', '10.00', '1100.00', '11000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7235, 'ZtdUmMVuoT3Dr0b', '20240321102419', '759', '20.00', '1000.00', '20000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7954, 'OVcheYAWqWVP30P', '20240321103010', '579', '4.00', '2200.00', '8800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7953, 'wCFNTPXELmFHuxa', '20240321103010', '823', '5.00', '1000.00', '5000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7952, '5ySB9pSrXLXnRjX', '20240321103010', '577', '5.00', '1250.00', '6250.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7237, 'izHG6mC9795KDBB', '20240321102419', '1004', '4.00', '1600.00', '6400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7238, '9vnMAoezJGVYd9m', '20240321102419', '1005', '4.00', '1800.00', '7200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7239, 'ufNMk0IX31V1abE', '20240321102419', '1006', '2.00', '2200.00', '4400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7240, 'dpJeYODeOcIoYgV', '20240321102419', '1007', '15.00', '415.00', '6225.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7241, 'ncSieT1FZdZCTCg', '20240321102419', '1008', '15.00', '520.00', '7800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7242, 'OxIMTRyQYlILfPJ', '20240321102419', '1009', '30.00', '340.00', '10200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7243, 'UtTtcaOf0ViSjwa', '20240321102419', '1010', '30.00', '440.00', '13200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14435, 'xvGt434h3a0KSJX', '20240205160956', '909', '100.00', '8.00', '800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14434, 'JTKihuhvzZcy43t', '20240205160956', '920', '24.00', '20.00', '480.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14433, 'ngvYn2lsGqn8L9E', '20240205160956', '905', '100.00', '4.00', '400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13710, 'xXUWDwQoWLVUdJm', '20240203141705', '728', '15.00', '260.00', '3900.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12421, 'UovPL9ctEcrPZTn', '20240316123506', '186', '2.00', '5500.00', '11000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12420, 'CTjiBSJ7iqBvhlO', '20240316123506', '14', '50.00', '165.00', '8250.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14432, '4QslK7OngvYy5JY', '20240205160956', '907', '100.00', '6.00', '600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14430, 'f2loDV0JtmUdbYz', '20240205160956', '860', '24.00', '170.00', '4080.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10531, '6XqKS3GrnPBESb5', '20240324153957', '299', '13.00', '4155.00', '54015.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12953, '433ZymrzEy55Dvy', '20240324160052', '1021', '24.00', '180.00', '4320.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12952, 'nxEobOQK0UVlNSl', '20240324160052', '2021', '24.00', '700.00', '16800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12951, 'CTxEpjC343ZifY8', '20240324160052', '1020', '24.00', '220.00', '5280.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12950, 'dGLtwINCPO320pE', '20240324160052', '1019', '50.00', '95.00', '4750.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12949, 'VqeJLhU4AT8n8gb', '20240324160052', '1018', '50.00', '65.00', '3250.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12948, 'qKxDOE5ld6RGttO', '20240324160052', '1017', '100.00', '45.00', '4500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12947, '9wkmeVkrfwq4g7i', '20240324160052', '1016', '106.00', '30.00', '3180.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12946, 'jnUsq1UJT9jy7Zc', '20240324160052', '1015', '100.00', '20.00', '2000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12945, 'vabMIGnuJgC2gCe', '20240324160052', '1117', '100.00', '17.00', '1700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7741, 'IwhXrLAIcIXcXLD', '20240324162105', '1023', '2.00', '650.00', '1300.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7742, 'ghdBfa1CPkonJho', '20240324162105', '1022', '60.00', '780.00', '46800.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7743, 'duuD7BaHO9Z41w8', '20240324162105', '1024', '20.00', '280.00', '5600.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7744, 'OWEzaZH7MIb7aDw', '20240324162105', '1025', '4.00', '5800.00', '23200.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7745, 'Oete0G1uAma3eoQ', '20240324162713', '1026', '156.00', '30.00', '4680.00', '1', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7752, 'pHlQwcklkTM4nRi', '20240320074828', '882', '24.00', '271.00', '6504.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10091, 'UWb7tSgt1bXhFB9', '20240402162259', '11', '207.00', '105.00', '21735.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9939, 'Eeh7Mf72HjjipPE', '20240325082455', '742', '0.00', '0.00', '0.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14431, 'oaMiPCpq3BHp27u', '20240205160956', '904', '100.00', '3.00', '300.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14429, 'BzR1ysBAkf85ohF', '20240205160956', '843', '48.00', '13.00', '624.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8228, 'tBAdra0mptk0xrs', '20240326154004', '1036', '1.00', '2800.00', '2800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8227, 'x38zGPRgbrKZWNo', '20240326154004', '1028', '2.00', '1300.00', '2600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8226, 'snD3rPaGkg9KUpu', '20240326154004', '1029', '2.00', '900.00', '1800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8225, 'iPsodruy1TNCOg3', '20240326154004', '1030', '20.00', '275.00', '5500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13228, 'vS4DTbzsd76Ejno', '20240326154749', '1034', '20.00', '155.00', '3100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13227, 'lOhbjCDZnNaij73', '20240326154749', '1033', '17.00', '2400.00', '40800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13226, 'yyKQlX8WAFSyE5P', '20240326154749', '1032', '13.00', '1400.00', '18200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14428, 'E1WH3YpHHiCuMBj', '20240205160956', '840', '24.00', '20.00', '480.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (7955, '4qRSZQw9v66Vukx', '20240321103010', '824', '4.00', '4000.00', '16000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8119, 'xTAoz6gD5xChAi0', '20240327125544', '993', '10.00', '9200.00', '92000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8067, 'fM1HhqjjFbSyNyl', '20240327160150', '974', '4.00', '2800.00', '11200.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8224, 'MABCm8vOEQOVuZi', '20240326154004', '1031', '1.00', '4200.00', '4200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14427, 'lFOnGdamJ6eAZz7', '20240205160956', '839', '24.00', '14.00', '336.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14426, '4zspoW92aiuFzN7', '20240205160956', '841', '24.00', '25.00', '600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14425, 'RpsSf4TGd5meVIR', '20240205160956', '837', '290.00', '70.00', '20300.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14424, 'wkEX6ccfp8NZlOU', '20240205160956', '842', '30.00', '25.00', '750.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8120, 'MdynA56DTlGRzWi', '20240327125544', '1042', '1.00', '14400.00', '14400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14423, '2E8UzLCAVGfFsPd', '20240205160956', '834', '12.00', '75.00', '900.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14422, 'zMEw03Jt4Rxd1GJ', '20240205160956', '833', '48.00', '25.00', '1200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14421, 'JiWEFqZReGK2JSa', '20240205160956', '373', '180.00', '17.00', '3060.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14420, 'a1MZfhyYHhTsRk5', '20240205160956', '370', '180.00', '22.00', '3960.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14419, 'GnGI1AD0bnxP1tP', '20240205160956', '369', '90.00', '84.00', '7560.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14418, '9IAYjOTszjtaWyt', '20240205160956', '372', '200.00', '40.00', '8000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14417, 'piaTYeVAFGxqCYl', '20240205160956', '371', '90.00', '34.00', '3060.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8332, 'M6rPxwOPx46T8Sg', '20240330073127', '1048', '1.00', '25000.00', '25000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8333, 'jD5lpc3awJ2KoF8', '20240330073127', '974', '2.00', '2800.00', '5600.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8334, 'oW19Hd8cXHUmDef', '20240330073749', '1049', '1.00', '750.00', '750.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8335, 'JIZW45iYBrNug8a', '20240330073749', '1028', '2.00', '1300.00', '2600.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9299, 'hIL2rNRwVP4FN9C', '20240224152146', '831', '1.00', '950.00', '950.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8906, 'XWLvWnxHAck9e6S', '20240214131722', '561', '1.00', '2150.00', '2150.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8904, 'shEvlE4jIPUfaCX', '20240214131722', '792', '2.00', '3100.00', '6200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8903, 'WkkzS2fB5m4kxAE', '20240214131722', '591 ', '6.00', '350.00', '2100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8965, '50aCUrzcVVfY1Ie', '20240330131005', '541 ', '5.00', '600.00', '3000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8966, 'uCfEM3y3cfhawmp', '20240330131005', '1051', '1.00', '1800.00', '1800.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8967, 'oK0gOFhrlaSJdNf', '20240330131005', '532', '1.00', '1600.00', '1600.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8968, 'SgzIsjDjz6jLPlj', '20240330131005', '555', '1.00', '1550.00', '1550.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (8969, '5BPGYkJhmHvmGbw', '20240330131005', '1052', '2.00', '4200.00', '8400.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9133, 'JPDRfLAMTuBKqQR', '20240331160955', '1054', '3.00', '1600.00', '4800.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9134, '14M38HbxT41gnGD', '20240331160955', '883', '6.00', '483.00', '2898.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9135, '1xXNIAcIZvesQwa', '20240331160955', '855', '10.00', '290.00', '2900.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9136, 'puvqEPMIkh2m6UC', '20240331160955', '884', '6.00', '474.00', '2844.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9137, 'gsC7CKisbgpPuxz', '20240331160955', '1055', '2.00', '700.00', '1400.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9138, 'LGnUY3cfBHC9rHq', '20240331160955', '1056', '3.00', '450.00', '1350.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10612, 'PriOChjKWNy2wL1', '20240331161838', '1030', '7.00', '275.00', '1925.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10611, 'SO92gKR1Y7Z1p0D', '20240331161838', '1058', '8.00', '200.00', '1600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10610, 'YMPCKgz3tzTLuk7', '20240331161838', '1057', '1.00', '2100.00', '2100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13986, '6WL7fgBsPti93E3', '20240331163350', '1154', '3.00', '110.00', '330.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13985, 'qDblPm3UadomuYY', '20240331163350', '1141', '2.00', '120.00', '240.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13984, 'wmZnoXBh51Rh1qL', '20240331163350', '1136', '4.00', '110.00', '440.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13983, 'zDNMBargZjDhpke', '20240331163350', '1060', '12.00', '38.00', '456.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13982, 'bsWD6ZLA8ZZaPm8', '20240331163350', '1061', '4.00', '50.00', '200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13981, '8k6pbjuQDn4cEZV', '20240331163350', '1062', '12.00', '471.00', '5652.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13980, 'WMnx201o9LmGB3n', '20240331163350', '1063', '5.00', '320.00', '1600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13979, 'SOPAxG57zfoXrlD', '20240331163350', '1064', '4.00', '350.00', '1400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11280, '8EnyrZfgzl6pDz0', '20240331163555', '823', '5.00', '1000.00', '5000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11279, 'tmrWp2L6YQZCrmj', '20240331163555', '579', '5.00', '2200.00', '11000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10144, 'c6aJKsEr3U5FTan', '20240331164423', '1068', '15.00', '770.00', '11550.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10143, 'Qdn7gbeBwRNzmLQ', '20240331164423', '1067', '20.00', '1075.00', '21500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10142, 'bqSYavDSi3HRZeg', '20240331164423', '1066', '130.00', '280.00', '36400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10141, 'kZcxIcG6FbYnHS0', '20240331164423', '254', '42.00', '230.00', '9660.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10140, 'j0su4uNGzfDpv4s', '20240331164423', '247', '15.00', '680.00', '10200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10139, 'p4eXi8P5Q2lTs1S', '20240331164423', '236', '20.00', '950.00', '19000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10138, 'xiOjBS5Ng5RBqlV', '20240331164423', '700', '100.00', '160.00', '16000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10137, '8gQXdZ1you6CfYq', '20240331164423', '249', '2.00', '1900.00', '3800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9174, '3S2vUgatCMYctuI', '20240401072026', '387', '6.00', '486.00', '2916.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9175, 'h7Od9Hwgduy3qZe', '20240401072026', '677', '6.00', '475.00', '2850.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9176, 'aNGCWeXL8oKZZbk', '20240401072026', '399', '10.00', '286.00', '2860.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9177, 'ZJvCHW8D8Z8xPWO', '20240401072301', '794', '300.00', '140.00', '42000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9178, 'H9cjuFj3BqMqPNx', '20240401072301', '17', '300.00', '180.00', '54000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9179, 'LeiswlhU9pwTF7u', '20240401074101', '1070', '2.00', '1500.00', '3000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9180, 'XBDXStrGiiGBowL', '20240401074101', '1071', '1.00', '550.00', '550.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9181, 'jzrIGLxFoSa1wNk', '20240401074101', '1072', '1.00', '150.00', '150.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9182, 'sDfRKpfbODnT8HP', '20240401074101', '481', '20.00', '38.50', '770.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9183, '8deTlV88VOdrlIH', '20240401074101', '1073 ', '1.00', '2000.00', '2000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (9318, 'Ohaq5ZVfleNpBwk', '20240224152146', '1074', '1.00', '850.00', '850.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14416, 'JmnBuP0YG6bnp1f', '20240205160956', '374', '20.00', '40.00', '800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13760, 'iDxJnxXc1ytSI4m', '20240219083123', '712', '12.00', '320.00', '3840.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13678, 'c9pdG0SpcGENqal', '20240403112716', '1078', '84.00', '78.00', '6552.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13677, 'D0UW1FvfpysdFZt', '20240403112716', '31', '239.00', '132.00', '31548.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13676, 'lRfaKadPfvfLIqG', '20240403112716', '1076', '180.00', '192.00', '34560.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13366, 's7PcUr0lLhS7qg8', '20240403120907', '1083', '5.00', '2100.00', '10500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13365, 'yBuPjn5aVJsd0pf', '20240403120907', '1082', '5.00', '2000.00', '10000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13364, 'DnunV1PMKjA7NCb', '20240403120907', '1081', '5.00', '1700.00', '8500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13363, 'dFMCcXBWkDtVm57', '20240403120907', '1080', '5.00', '1400.00', '7000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13362, 'YdA7KHTFHcJWVsZ', '20240403120907', '1079', '6.00', '1100.00', '6600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11609, '6F7ccY8S1sASp1i', '20240406124316', '1084', '16.00', '141.00', '2256.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13186, 'PY3XhhOe9uUV1kq', '20240403122257', '264', '20.00', '80.00', '1600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13185, 'XMagbQ6WcX1Ku3w', '20240403122257', '284', '120.00', '27.00', '3240.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10122, 'fT7FwmEJoXSJp2', '20240404072442', '1086', '6.00', '26100.00', '156600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10123, 'KW8ISCeT1fMCg8Y', '20240404072442', '1085', '2.00', '53500.00', '107000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11966, 'kwUegcPzDFPObYA', '20240403121740', '730', '68.00', '146.00', '9928.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10136, 'jWM65YY7E9h9DvT', '20240331164423', '1069', '10.00', '600.00', '6000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10145, 'hDpDccRm63QGOyW', '20240331164423', '697', '5.00', '380.00', '1900.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10202, 'WrIhDemrYlmh1XF', '20240311102859', '1087', '3.00', '1350.00', '4050.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10203, 'Q22uxmPZK8bTY2j', '20240404154945', '1088', '62.00', '480.00', '29760.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10204, 'B9hFhl19pekelK1', '20240404154945', '1089', '700.00', '2.00', '1400.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10205, 'YUy5weJ02RZ4LRn', '20240404160614', '135', '70.00', '2915.20', '204064.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10206, 'BVLXlk1Cupo1vS6', '20240404160614', '650', '40.00', '2915.20', '116608.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10207, 'u9D8gIRaD2iQdH9', '20240404160614', '139', '10.00', '2915.20', '29152.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10208, 'fD2TGUFn3ugbfG0', '20240404160614', '138', '10.00', '2915.20', '29152.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10209, 'te9VfQJ1B3jiDPA', '20240404160614', '140', '10.00', '2915.20', '29152.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10210, 'XZrNM8xuPpxG7rd', '20240404160614', '137', '10.00', '2915.20', '29152.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10211, 'l4qkiMr8uusI6hy', '20240404160614', '141', '20.00', '6051.20', '121024.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10212, 'LyV2VpPLURBkDIW', '20240404160614', '144', '20.00', '6051.20', '121024.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10213, 'caQIbepOvIk4hdJ', '20240404160614', '143', '5.00', '6051.20', '30256.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10214, 'D47u79reMy8R6T', '20240404160614', '142', '5.00', '6051.20', '30256.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10215, 'rRjk8PhyCFHLuRq', '20240404160614', '147', '5.00', '14755.20', '73776.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10216, '7vBly9XoRpBTEil', '20240404160614', '148', '5.00', '14755.20', '73776.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10217, 'qwj0XtwgG6li5mL', '20240404160614', '656', '3.00', '20771.20', '62313.60', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10218, 'RtMUEtcjvLXoj9m', '20240404160614', '657', '2.00', '20771.20', '41542.40', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11139, 'v3UDhlVrX4gD66Y', '20240404162219', '1055', '9.00', '700.00', '6300.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11138, 'LgtYMtBddngFzHg', '20240404162219', '884', '4.00', '450.00', '1800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11137, 'ymWVHncaUEMMmre', '20240404162219', '1090', '5.00', '800.00', '4000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11136, 'HQyNzFpGvq4axEZ', '20240404162219', '1091', '2.00', '700.00', '1400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11608, 'PAQcHwM65ygoMfv', '20240406124316', '1093', '33.00', '220.00', '7260.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10437, 'utC8YtTL4CpGbuh', '20240406152118', '1094', '27.00', '280.00', '7560.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10438, '386elCUCGdbzTSZ', '20240406152118', '1095', '28.00', '280.00', '7840.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10439, 'dKL4dws3TrM5Ic6', '20240406152118', '1096', '10.00', '784.00', '7840.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10440, 'eeszxr2LLHXTDYI', '20240406152913', '1097', '10.00', '80.00', '800.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10441, 'mvY5Xn3kHwRz75L', '20240406152913', '1098', '3.00', '1450.00', '4350.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11277, 'hBrEFiHIOdA3hf7', '20240415132224', '1152', '1.00', '5000.00', '5000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11257, 'NpRn0DReCCxEyXT', '20240406155718', '1072', '1.00', '150.00', '150.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11256, 'CFA5m5CHsxvvnCa', '20240406155718', '1127', '41.00', '220.00', '9020.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10445, 'nY6kXJHn0Ie6bl', '20240407074527', '1111', '30.00', '650.00', '19500.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14415, 'oLSVzOW7PToc4qG', '20240205160956', '379', '48.00', '25.00', '1200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14290, 'LSCoObP3tAQmzUR', '20240408075159', '1220', '1.00', '4000.00', '4000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14289, 'rvqctWPpdcbnTjY', '20240408075159', '600', '100.00', '40.00', '4000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14288, 'ITsVe9B3VwhDvY9', '20240408075159', '788', '3.00', '1050.00', '3150.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14287, 'NLK8HwbyEoqly2h', '20240408075159', '224', '8.00', '550.00', '4400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14286, '3xPgLBCxIHuEoC7', '20240408075159', '225', '5.00', '450.00', '2250.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14285, 'xbUOmp2aTfI5eq3', '20240408075159', '787', '50.00', '25.00', '1250.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14284, 'DLwT1hdw8AofD1o', '20240408075159', '1074', '6.00', '850.00', '5100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14283, 'ej5gu8mpvcFUYYV', '20240408075159', '786', '3.00', '250.00', '750.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14282, '3SEtHWd9BhKZGja', '20240408075159', '785', '5.00', '175.00', '875.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14281, 'fxzjMNnOhMnMlqg', '20240408075159', '784', '5.00', '135.00', '675.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14280, '2jpbucTBAfgsXE', '20240408075159', '783', '5.00', '110.00', '550.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14279, 'GuNCEFFUjrqOtUU', '20240408075159', '221', '24.00', '440.00', '10560.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14278, 'PpOXKewYJDDfYqf', '20240408075159', '218', '60.00', '140.00', '8400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14277, 'xwdfuyL0emEylbE', '20240408075159', '213', '30.00', '160.00', '4800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14276, 'D7eEPEsTUIJXl6P', '20240408075159', '1113', '5.00', '165.00', '825.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14275, 'ILm9cJ1wH2spala', '20240408075159', '1114', '3.00', '300.00', '900.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14274, 'tj41pTVa2HHRUwj', '20240408075159', '1115', '3.00', '425.00', '1275.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14273, '7DEWaUYrJ8pLpFR', '20240408075159', '1116', '3.00', '525.00', '1575.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10532, 'Svwef2vRHp2cNyi', '20240324153957', '323', '7.00', '4155.00', '29085.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10533, 'MpyPk8dfAdYO251', '20240324153957', '334', '2.00', '16945.00', '33890.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10534, 'Up0X6Bff3EmNo21', '20240324153957', '333', '2.00', '16945.00', '33890.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10535, 'lJrMtlyGZLu4Mno', '20240324153957', '331', '2.00', '11850.00', '23700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10536, 'tpQEhkXuNQkzVc0', '20240324153957', '332', '2.00', '11850.00', '23700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10595, 'j6jWscKCygujyAK', '20240408094723', '1120', '1.00', '5400.00', '5400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10594, 'qeCHJxkDfku2BnW', '20240408094723', '1119', '1.00', '16000.00', '16000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10593, 'KK6RLlznSey5B2A', '20240409075717', '560', '40.00', '310.00', '12400.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10596, 'd6dalqmWPrkQYWS', '20240408094723', '1121', '1.00', '26200.00', '26200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10626, 'X1bBTiDDZ5iQ1JK', '20240409092240', '1125', '2.00', '1800.00', '3600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10625, 'vo3gwZirbMAVFEL', '20240409092240', '1124', '1.00', '88000.00', '88000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10624, '2wy1SqSejCFgD4b', '20240409092240', '1123', '1.00', '7500.00', '7500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10623, 'QJSiSs7YPwe9hEl', '20240409092240', '1122', '3.00', '3500.00', '10500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10622, 'abalgh8gsaondW3', '20240409092240', '1030', '20.00', '270.00', '5400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10621, 'YyYseNNxCy0wxDl', '20240409092240', '1028', '1.00', '1400.00', '1400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10620, 'eGpiIhyBskdz4za', '20240409092240', '1029', '2.00', '900.00', '1800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10619, 'iWxar6472GxWtlR', '20240409092240', '1049', '1.00', '750.00', '750.00', '3', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11255, 'f4cuyAeAsuG3hEx', '20240406155718', '846', '1.00', '50.00', '50.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10617, 'n9YKDfFLJyTqKgs', '20240409144517', '712', '100.00', '320.00', '32000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10618, 'tks8IBiu8RjwTfm', '20240409144806', '560', '30.00', '310.00', '9300.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10627, 'KED7YU09YsDMehz', '20240409092240', '1126', '3.00', '450.00', '1350.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11762, 'Eb4gJqxeURIud3O', '20240414075130', '1130', '1.00', '1750.00', '1750.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11761, 'ST2CPTM1uq9SsK9', '20240414075130', '1031', '1.00', '4200.00', '4200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10630, 'sBIp3Bt5EyVzMED', '20240414075501', '794', '40.00', '140.00', '5600.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (10631, 'a0pg8HKeLXNrDpP', '20240414075501', '17', '110.00', '180.00', '19800.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14414, 'yIhec3BEY2H8SW4', '20240205160956', '381', '96.00', '34.00', '3264.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14413, 'ltfTPd4JpJqqbq', '20240205160956', '380', '24.00', '25.00', '600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11135, 'jPwUhMQVOwZtqEU', '20240404162219', '1092', '1.00', '500.00', '500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14412, 'eCU0phWzK4e7KTx', '20240205160956', '836', '24.00', '30.00', '720.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11254, 'qy1T55wXkWQWNhL', '20240406155718', '481', '20.00', '38.50', '770.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13978, 'oSBe2ZsScAVxydL', '20240331163350', '777', '10.00', '20.00', '200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14411, 'fPGHbW8eEF37bhF', '20240205160956', '382', '60.00', '46.00', '2760.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14410, 'AFQWmK4lcgWV9Lh', '20240205160956', '383', '24.00', '30.00', '720.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14409, 'XRkImmI5lbVlfzs', '20240205160956', '378', '48.00', '20.00', '960.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11253, 'c2vEBouwWZSV5hC', '20240406155718', '1099', '1.00', '700.00', '700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11140, 'jQcB2lVePtPjsfZ', '20240404162219', '989', '2.00', '60.00', '120.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11141, 'KotJf8QbiKpDjhO', '20240404162219', '912', '2.00', '100.00', '200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11227, 'q4G2t1uozXPjbPY', '20240319124136', '1131', '8.00', '100.00', '800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11252, 'acsUZ3gxtpxMUY9', '20240406155718', '1100', '1.00', '2500.00', '2500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14408, 'cUSgqQKuNbf0wzD', '20240205160956', '835', '24.00', '50.00', '1200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13977, 'HNAUH13R0ToR2gj', '20240331163350', '1065', '1.00', '100.00', '100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13674, 'hSM25uIDCzImb55', '20240415103944', '1131', '10.00', '100.00', '1000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13673, 'uQA0b0kgvMyQTWh', '20240415103944', '448', '24.00', '120.00', '2880.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13672, '9uSN9ObD6DcSpKN', '20240415103944', '497', '23.00', '160.00', '3680.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13245, '8zxLaKkeRAyxug5', '20240415104929', '883', '10.00', '460.00', '4600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13244, 'toecjQL7qX6QloK', '20240415104929', '1148', '3.00', '530.00', '1590.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13243, 'slhKQeZH4nZek18', '20240415104929', '1147', '6.00', '430.00', '2580.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13242, 'He8BgvA9ITdpmhJ', '20240415104929', '1146', '6.00', '530.00', '3180.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13241, 'Zhdt8RptADhwpoM', '20240415104929', '1145', '1.00', '550.00', '550.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13240, 'YeG3Qp5CRJZx1YJ', '20240415104929', '1144', '18.00', '430.00', '7740.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13239, 'bw5gEYXc1xf8EP5', '20240415104929', '1143', '8.00', '820.00', '6560.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13238, 'pSSIXo8uxb3fJQ9', '20240415104929', '1142', '5.00', '120.00', '600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13237, 'G3QH0ravUxqEFpW', '20240415104929', '883', '12.00', '470.00', '5640.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13236, 'ax3p4JLgmtOElE0', '20240415104929', '887', '10.00', '290.00', '2900.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13235, 'jY0qIl246znFbC4', '20240415104929', '890', '1.00', '175.00', '175.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13234, '6D2MXDq1ypkUeZy', '20240415104929', '885', '1.00', '450.00', '450.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13233, '2kOLGOusgFZL86U', '20240415104929', '915', '4.00', '120.00', '480.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11249, 'htTT4G06uEpWnGe', '20240415122939', '441', '28.00', '265.00', '7420.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11250, 'YsYPz0L8rJBNBLz', '20240415122939', '481', '20.00', '38.50', '770.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11251, 'nfj3qkwLHlNxtf0', '20240415122939', '1149', '2.00', '10000.00', '20000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11276, 'THZSgCM1UnpkHgY', '20240415132224', '690', '30.00', '850.00', '25500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11275, 'fGbSnToWggiQEnK', '20240415132224', '1151', '1.00', '11500.00', '11500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11274, 'IvH8Kf4rzsi1ftD', '20240415132224', '701', '1.00', '1050.00', '1050.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11273, 'cO666dGwylUlVwT', '20240415132224', '806', '1.00', '700.00', '700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11272, 'HCp5NhcOM3FvdUg', '20240415132224', '249', '4.00', '1850.00', '7400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11271, 'PJjwc9iIskRjeXi', '20240415132224', '243', '80.00', '400.00', '32000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11278, 'lG2fQroVRvTISHB', '20240415132224', '1153', '1.00', '600.00', '600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11281, 'qMkF2gVXgeMzI6T', '20240331163555', '583', '1.00', '2300.00', '2300.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13976, 'xfVF6QvaHpG1Vm9', '20240331163350', '778', '50.00', '10.00', '500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14407, 'P3AKmoW3H5l2yYT', '20240205160956', '898', '96.00', '5.00', '480.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12941, '38TLLUD2wxxRU2z', '20240425141147', '1093', '477.00', '220.00', '104940.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12584, 'tFElYmAYWMTaFBw', '20240416121046', '321', '2.00', '9474.00', '18948.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12583, 'i6Sib5Rz0R0tLlZ', '20240416121046', '291', '3.00', '9474.00', '28422.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12582, 'Wy5oaycMACkX8V1', '20240416121046', '322', '4.00', '15216.00', '60864.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12581, 'xOnNSQ5RWQ1DO7h', '20240416121046', '302', '5.00', '16945.00', '84725.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12580, 'AVsvZxTGU6gEgQC', '20240416121046', '301', '5.00', '11850.00', '59250.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12579, '7wAGM9ejNnQaEwI', '20240416121046', '327', '20.00', '8841.00', '176820.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12578, 'D5zHnDtHBITf6rr', '20240416121046', '300', '20.00', '8841.00', '176820.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12577, 'AYNIBmVaKLNwCzS', '20240416121046', '323', '50.00', '4155.00', '207750.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11758, 'AXBdUDDZ1EDmOLA', '20240416122251', '1156', '3.00', '50.00', '150.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11757, 'bwN6ly9jIHlJhbr', '20240416122251', '1155', '3.00', '450.00', '1350.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11756, 'cykb4mW2HFlVELR', '20240416122251', '974', '4.00', '2800.00', '11200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11755, '5hEK0cbYJLMvDyw', '20240416122251', '1048', '2.00', '22500.00', '45000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11754, 'RFQbpZFU60Zw7jw', '20240416122251', '441', '8.00', '265.00', '2120.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11618, 'UibueEnuO3vdvX8', '20240417115239', '1157', '1.00', '1800.00', '1800.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11619, '7umKb21OcUDzeUd', '20240417115239', '508', '15.00', '300.00', '4500.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14406, 'cuzE5MbBV15eZRN', '20240205160956', '838', '90.00', '18.00', '1620.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14405, 'qDKpQlFwLk1FG7f', '20240205160956', '1012', '24.00', '5.00', '120.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11759, 'QjwhvgB2YR7wTDV', '20240418073307', '974', '3.00', '2800.00', '8400.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11760, 'CEM9JzgvxtOZrtX', '20240418073307', '481', '20.00', '38.50', '770.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11764, 'yEy7NviqbqjuD4L', '20240414075130', '1159', '3.00', '2400.00', '7200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12060, '6tluLKoEMYM3t51', '20240420075013', '1160', '3.00', '2400.00', '7200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14404, 'KwscA6MLZ8CmI3d', '20240205160956', '1035', '200.00', '6.00', '1200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14403, 'qEq9vsysFBC0erT', '20240205160956', '1011', '24.00', '11.00', '264.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14402, 'roKusxEBQDtqtEV', '20240205160956', '1047', '8.00', '24.00', '192.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12384, 'WBDb2JSRXWeQZ8U', '20240420101648', '1162', '2.00', '17533.00', '35066.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14401, 'sZS8REDKkRsK5zg', '20240205160956', '375', '40.00', '15.00', '600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14400, 'uBuCuEimFMO6Fjp', '20240205160956', '903', '24.00', '40.00', '960.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14399, 'IiXOcJrYbrS2epS', '20240205160956', '1161', '50.00', '10.00', '500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14398, 'DJVQoMW6S1M4aTa', '20240205160956', '1075', '100.00', '8.00', '800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14397, 'r2MLxDO0z6CkSHv', '20240205160956', '1134', '12.00', '45.00', '540.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14396, 'QiWh2tDPizSgqEG', '20240205160956', '1044', '16.00', '25.00', '400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14395, '3FIimtRHiW2z2FD', '20240205160956', '1164', '12.00', '50.00', '600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11972, 'GZy2D7KQMnIvU6L', '20240421120511', '1169', '1.00', '165000.00', '165000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11971, 'L8hcdSUnUb7jLbg', '20240421120511', '1170', '20.00', '370.00', '7400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11970, 'xH6NeXmQ2TaSA59', '20240421120511', '1058', '4.00', '250.00', '1000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11973, 'NJjP1wJV9OGfjga', '20240421122720', '1086', '4.00', '20813.00', '83252.00', '2', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11974, 'IksnAGx8tnuCQuG', '20240421122720', '441', '1.00', '270.00', '270.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11975, 'MnyBscVrhnznXkX', '20240421124629', '1172', '100.00', '300.00', '30000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11976, 'sttzOXmYeXwzAk1', '20240421124629', '712', '200.00', '320.00', '64000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (11977, 't2RYjIC35l1Oowd', '20240421160133', '697', '5.00', '380.00', '1900.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14393, 'ZbNq46AWFszZWfs', '20240205160956', '1043', '24.00', '20.00', '480.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14394, 'zvIdRBChvhILXOU', '20240205160956', '1163', '12.00', '40.00', '480.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12061, 'uP8mN4PKbR8Nexg', '20240420075013', '584', '1.00', '2600.00', '2600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13671, 'nb2Gn3Oc72l6mdf', '20240415103944', '449', '2.00', '100.00', '200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14392, 'KIiuZezK2tJHSjF', '20240205160956', '1140', '12.00', '35.00', '420.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14391, 'K1T2j7TzuikQzdQ', '20240205160956', '1139', '48.00', '40.00', '1920.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14312, 'YZcmOGRzXC2hep1', '20240422114228', '102', '35.00', '453.00', '15855.00', '5', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12309, 'Er55iYAMXVHVrwx', '20240422120615', '1178', '24.00', '746.00', '17904.00', '3', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12310, 'kjrJWeGr03YuDfU', '20240422120615', '1179', '50.00', '281.00', '14050.00', '7', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12311, 'af1knnqYwCagIAs', '20240422120615', '1180', '37.00', '281.00', '10397.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12385, 'vmaUyxyPHE9phCf', '20240420101648', '1084', '46.00', '153.00', '7038.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12386, 'qmU9OsYnuKyycgk', '20240422151035', '1181', '2.00', '375.00', '750.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12387, 'MuumOBk0hNUKKOm', '20240422151035', '1183', '2.00', '215.00', '430.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12388, 'sCzbIyvJjYvOYJ2', '20240422151035', '1182', '2.00', '294.00', '588.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12389, 'lI2AjnutZJKK2fK', '20240423112445', '1184', '44.00', '350.00', '15400.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12390, 'YdIWvLA4VGB2eDu', '20240423112445', '1185', '5.00', '1150.00', '5750.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12391, 'IKfZOeQImTR0aDs', '20240423112445', '1186', '2.00', '2000.00', '4000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12392, 'DmjQtQXJUD7wPCq', '20240423120446', '1187', '2.00', '60.00', '120.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12393, 'F8r5GwpkVY14ZWH', '20240423120446', '1188', '1.00', '50.00', '50.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12394, 'cRAKiLxKB67PYcb', '20240423120446', '1189', '1.00', '350.00', '350.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12395, 'xnz4yUPmn6b7rB', '20240423120446', '1190', '2.00', '20.00', '40.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12396, '7vw5FLBHqpUV5LR', '20240423120446', '946', '2.00', '2850.00', '5700.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12397, '4tQtyoBLtaWB8LJ', '20240423120446', '1191', '2.00', '150.00', '300.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12398, 'LqfqHJhi8i35klD', '20240423120446', '1192', '1.00', '120.00', '120.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12399, 'vycEygy7Ky9ybce', '20240423120446', '1193', '10.00', '30.00', '300.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12400, 'N3mA4BRp1DDWads', '20240423120732', '1194', '1.00', '25150.00', '25150.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12419, '4F28eb4GEMIU5vw', '20240423125430', '1202', '8.00', '6700.00', '53600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12418, 'vL19opJceHqdMOB', '20240423125430', '1201', '3.00', '600.00', '1800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12417, 'nIznEhKR6F3XlO9', '20240423125430', '1200', '3.00', '120.00', '360.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12416, 'm1H3fWybUq9xI91', '20240423125430', '1199', '3.00', '200.00', '600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12415, '8druaU4NbU8n3WR', '20240423125430', '1198', '4.00', '1150.00', '4600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12414, 'Se3TM9wu6kaXQIb', '20240423125430', '1197', '2.00', '1071.00', '2142.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12413, 'LUarlzWjYliO253', '20240423125430', '1195', '3.00', '2900.00', '8700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12408, 'qG0TZIRXCOIRgs', '20240424091801', '1203', '2.00', '3500.00', '7000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12409, 'f6SvaCCodH7KsDD', '20240424091801', '1204', '21.00', '1350.00', '28350.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12410, 'VQTWQMjKQtwDQbQ', '20240424091801', '481', '20.00', '45.00', '900.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12411, 'nf1wgagHU5K8uO9', '20240424091801', '1205', '1.00', '3600.00', '3600.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12412, '7o4PsdAI93YOx4m', '20240424105426', '1206', '1.00', '7400.00', '7400.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12433, 'jRfYEV5FVNujIca', '20240316123506', '412', '1.00', '8800.00', '8800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12436, 'oXjs84lTxkqHHb8', '20240219101122', '1208', '1.00', '5400.00', '5400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12437, 'P93yqlv45hy7IGM', '20240219101122', '1207', '1.00', '6500.00', '6500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12576, 'L0EzTQVglSq1RMH', '20240416121046', '299', '50.00', '4155.00', '207750.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12575, 'PsdSE4ZVzHQAV4u', '20240416121046', '738', '1.00', '3610.00', '3610.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14390, 'Pr4squIsglzyIv8', '20240205160956', '1138', '12.00', '100.00', '1200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12536, 'N8Auf6XH0QBXmo1', '20240425085739', '1001', '1.00', '9500.00', '9500.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12537, 'ZnrhOeGn70sEXOP', '20240425085739', '1209', '1.00', '4800.00', '4800.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12538, 'ct5FzvJETBhXyIO', '20240425090059', '67', '30.00', '2600.00', '78000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12539, 'rypHfLZlspUGPje', '20240425090059', '68', '30.00', '2600.00', '78000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12636, 'xYTMxB8weBuDcPQ', '20240425091617', '1219', '2.00', '4400.00', '8800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12635, 'EzgpCBbyFVRZCTK', '20240425091617', '1221', '1.00', '1000.00', '1000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12634, 'zMRaLlKwgbzuVIO', '20240425091617', '625', '20.00', '38.50', '770.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13232, 'RcQPDrpBlVb5DaX', '20240415104929', '1055', '1.00', '600.00', '600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13231, 'JdN2VAUQNoz5O0r', '20240415104929', '1176', '4.00', '40.00', '160.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12561, 'aIPkPxhKmFmPoGo', '20240425123443', '1212', '10.00', '270.00', '2700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12562, 'fjrCa4eFPjLeGUy', '20240425123443', '1213', '4.00', '330.00', '1320.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12563, 'xdjYJcSlJtm4WVK', '20240425123443', '1214', '4.00', '310.00', '1240.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12564, 'RJrrhHMG5uBp90c', '20240425123443', '1215', '1.00', '340.00', '340.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12565, 'Gn02JzmF66iM5Sr', '20240425130633', '1216', '5.00', '900.00', '4500.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12566, 'YiA01X3z2EYieqD', '20240425130633', ' 1217', '5.00', '900.00', '4500.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12567, 'ejkb5eqObGXLoFA', '20240425130633', '303', '5.00', '1400.00', '7000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12568, 'ynLqbZLKUP5ipqB', '20240425130633', '343', '5.00', '1400.00', '7000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12569, 'T2dbwDNb5K60rPP', '20240425130633', '304', '5.00', '2100.00', '10500.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12570, '2dMKTlVFwzhfmYl', '20240425130633', '344', '5.00', '2100.00', '10500.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12571, 'sKeWTFDDooeV7QD', '20240425130633', '305', '5.00', '2850.00', '14250.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12572, '5GLP6ZponLRbSA', '20240425130633', '345', '5.00', '2850.00', '14250.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12573, 'bgtYZEgxYa3XTzm', '20240425130633', '340', '1.00', '7608.00', '7608.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12574, 'VL4IizTLmPmGX3N', '20240425130633', '339', '1.00', '7608.00', '7608.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12957, 'i0HzrEiolJEyqQT', '20240428134254', '1226', '1.00', '41000.00', '41000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12940, '3Y0BJUb21VdHicN', '20240425141147', '1084', '467.00', '153.00', '71451.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12592, 'WhAiWji6xL55alD', '20240427092247', '9', '120.00', '410.00', '49200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12591, 'ublhRrK8Wrxey0b', '20240427092247', '718', '160.00', '220.00', '35200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12590, 'QA0ofWUbiY5DPrm', '20240427092247', '715', '500.00', '120.00', '60000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12593, 'GoQ5r2M7wUPWUeB', '20240427092247', '1217', '50.00', '560.00', '28000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12594, 'tTrILIL3KUp6Kai', '20240427093052', '1162', '4.00', '17533.00', '70132.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12595, 'mBgSNQ5NHBN0nuq', '20240427093547', '638', '20.00', '4150.00', '83000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12596, 'HLActOGSvRgIIqE', '20240427094225', '564', '50.00', '300.00', '15000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12597, '4VcLUdQO4cPE1wE', '20240427094225', '566', '6.00', '2700.00', '16200.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12598, 'pxXe25yht0X1reA', '20240427094225', '565', '6.00', '2700.00', '16200.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12599, 'Yqagtlyv5kUPWkH', '20240427094225', '1218', '3.00', '165.00', '495.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13670, '89hRkyX3agdfVhW', '20240415103944', '1174', '1.00', '120.00', '120.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12633, 'vBMy4HJg1RVsdcE', '20240425091617', '1210', '20.00', '27.00', '540.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12632, 'tsvxs0yBxMflU3u', '20240425091617', '1211', '4.00', '125.00', '500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14272, '3ypp4N38NQxzebi', '20240408075159', '1118', '2.00', '650.00', '1300.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13597, 'q7ohUTULIRZcKKG', '20240427104625', '1222', '0.00', '1350.00', '0.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14129, '3kzvXBy9KKOuoJE', '20240428083925', '1223', '4.00', '3900.00', '15600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12955, '7aU6uc8lKaHoKxz', '20240428134254', '1225', '50.00', '16.00', '800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (12954, 'GKgLPcvIo7Qp5eI', '20240428134254', '1224', '50.00', '20.00', '1000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14388, 'HhQRkMIO7GP3ojx', '20240205160956', '1166', '12.00', '70.00', '840.00', '8', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14389, 'AZYe7gH9B6c9YhU', '20240205160956', '1165', '12.00', '60.00', '720.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13167, 'YAwzTAx74VyoU5O', '20240430093515', '1242', '1.00', '220.00', '220.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13166, 'qY17JPasNGUN3gi', '20240430093515', '1241', '12.00', '60.00', '720.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13165, 'bWwdN3EqMHJU3Uy', '20240430093515', '512', '4.00', '70.00', '280.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13164, 'Q7oT765HmT3XGoU', '20240430093515', '1240', '2.00', '90.00', '180.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13163, '3Z16jZbYBnkDDDy', '20240430093515', '513', '1.00', '130.00', '130.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13162, 'tmtEMfuFDgMn494', '20240430093515', '1239', '1.00', '450.00', '450.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13161, '2QDrg0Y8P3fgJ0j', '20240430093515', '563', '1.00', '380.00', '380.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13160, 'r4wTlZkw85ZYWye', '20240430093515', '1238', '1.00', '500.00', '500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13159, 'tCB4GlAhl31m4Tc', '20240430093515', '645', '1.00', '850.00', '850.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13158, 'O4lrUTzqA3HUy2a', '20240430093515', '1237', '1.00', '200.00', '200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13157, 'EYvvgy2xeMXpMic', '20240430093515', '1236', '1.00', '430.00', '430.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13156, 'HcnYf4tCWT8BAW9', '20240430093515', '554', '3.00', '500.00', '1500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13155, 'QVarXQfXuzGlhqw', '20240430093515', '1235', '1.00', '1550.00', '1550.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13153, 'xE5UUc6u5Ms0K8x', '20240430093515', '1233', '1.00', '200.00', '200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13154, 'gsJAPLD14Ns7Kpf', '20240430093515', '1234', '2.00', '150.00', '300.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13151, 'miGPqgZ4NhIRMtK', '20240430093515', '1231', '3.00', '850.00', '2550.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13152, 'mnJa1aEatSRo40N', '20240430093515', '1232', '1.00', '400.00', '400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13150, '7oxQqhNklZuplcD', '20240430093515', '1230', '3.00', '150.00', '450.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13149, 'DJDiJM2SXyCe60M', '20240430093515', '996', '12.00', '30.00', '360.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13148, '6mr4MEtuUPayeAp', '20240430093515', '527', '1.00', '750.00', '750.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13147, '9vF4m5rlAERfjiW', '20240430093515', '1229', '1.00', '700.00', '700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13146, 'm8iYx8mp4wWcgB', '20240430093515', '540', '24.00', '15.00', '360.00', '5', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13145, 'soIaXxRBAR2a7CF', '20240430093515', '546', '3.00', '35.00', '105.00', '3', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13144, 'yA1GBu1M6v4QZC6', '20240430093515', '541 ', '4.00', '600.00', '2400.00', '5', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13168, 'ndAQXLobSZzB1r5', '20240430093515', '1244', '4.00', '50.00', '200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13169, 'yguNg81SpgBOz92', '20240430093515', '1245', '1.00', '70.00', '70.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13170, '4iKuzknoMp1R0Id', '20240430093515', '1243', '2.00', '50.00', '100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13171, 'LguQWtj9zlk9W1Z', '20240501090900', '1200', '10.00', '121.00', '1210.00', '5', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13172, 'uwhKP5HUzPf8hV9', '20240501090900', '1246', '10.00', '185.00', '1850.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13173, '17EKUYc1j9un0Q0', '20240501122409', '1247', '1100.00', '150.00', '165000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13174, 'A2OxO3mvDvoRVW6', '20240501124216', '1248', '1.00', '8000.00', '8000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13175, 'J26b0QUaFRY9zLj', '20240501124216', '1249', '3.00', '1850.00', '5550.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13176, 'b6mYuGIxasV8BIQ', '20240501133112', '714', '50.00', '325.00', '16250.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13177, 'xx9uhya97AowsK7', '20240501133112', '1250', '50.00', '302.00', '15100.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13178, 'fGRHG0kNOlIrFnp', '20240501133112', '1251', '20.00', '500.00', '10000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13179, 'emu5oHfsbckZmEu', '20240501133131', '714', '50.00', '325.00', '16250.00', '1', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13180, 'UZJcVk2eYTPpcXD', '20240501133131', '1250', '50.00', '302.00', '15100.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13181, 'dFPHOndUDP1Byit', '20240501133131', '1251', '20.00', '500.00', '10000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13187, '5maw0xrNhtAaqll', '20240501133724', '1252', '24.00', '350.00', '8400.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13188, 'mIO6XQ43jRI2XWo', '20240502085246', '207', '20.00', '1000.00', '20000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13189, 'NKQAYI9IfM24IpU', '20240502085541', '67', '35.00', '2550.00', '89250.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13190, 'Jjtva1iySqvnQ5o', '20240502085541', '68', '35.00', '2550.00', '89250.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13191, 'uMEFYPeDDTCO8pg', '20240502095310', '1253', '5.00', '364.00', '1820.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13192, 'qxW6E0ACVi9wVVw', '20240502095310', '1254', '5.00', '500.00', '2500.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13193, 'Dh6o6klDTXUv2A2', '20240502095310', '1255', '10.00', '550.00', '5500.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13194, 'wiY0RPyDWBsPdbX', '20240502121023', '1256', '31.00', '320.00', '9920.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13195, 'lGdpTjgF61cim8r', '20240502121023', '59215232', '5.00', '3500.00', '17500.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13196, 'sn8LvSRAAlA7hi9', '20240502121023', '1257', '5.00', '4000.00', '20000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13229, 'OB6wnI3Mc0Sa7pb', '20240504134344', '1268', '3.00', '200.00', '600.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13225, 'q6Bi7AGpQAiOrMu', '20240502125329', '1267', '2.00', '43725.00', '87450.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13224, 'LWjKBIppCwEnP4c', '20240502125329', '1266', '3.00', '43725.00', '131175.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13223, 'qxtdtC87hAIjxJw', '20240502125329', '1265', '2.00', '27625.00', '55250.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13222, 'FeWc5ojFFK85GIC', '20240502125329', '1263', '20.00', '8841.00', '176820.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13221, 'rRU0HTAg4Wj5wlV', '20240502125329', '1262', '80.00', '8841.00', '707280.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13220, 'vXHiryqrtE0PrH8', '20240502125329', '1261', '100.00', '8841.00', '884100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13219, 'AS5h8frU6Xl1lo3', '20240502125329', '1260', '50.00', '4155.00', '207750.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13218, 'OD041cupE4SVQzc', '20240502125329', '1259', '150.00', '4155.00', '623250.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13217, 'F6KPs1BoMQ9hYQj', '20240502125329', '1258', '200.00', '4155.00', '831000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13230, 'SHRU0GOmi3Lpw41', '20240504134344', '1269', '3.00', '300.00', '900.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13246, 'zQeEYSztBJU2ahm', '20240415104929', '886', '3.00', '277.00', '831.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13247, 'eVYhFd436doshEy', '20240415104929', '888', '10.00', '322.00', '3220.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13477, 'oBfMMtlIfLqlNf2', '20240505110122', '1278', '4.00', '770.00', '3080.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13476, 'Ru9GOI56Zcvjdxv', '20240505110122', '1277', '13.00', '830.00', '10790.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13475, 'XUwmbLYk2qFjJKk', '20240505110122', '1281', '7.00', '495.00', '3465.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13474, '52clmhyidry7bbG', '20240505110122', '885', '24.00', '453.00', '10872.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13473, 'CqJrcfplE7DD0xF', '20240505110122', '886', '100.00', '291.00', '29100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13253, 'ShTcrZJvUxlLQ4n', '20240505121803', '1270', '162.00', '85.00', '13770.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13254, 'c0TL0im1RYT3Pvp', '20240505121803', '1275', '201.00', '128.00', '25728.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13255, 'vWWLbyiie6qvjwz', '20240505121803', '1274', '246.00', '107.00', '26322.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13256, 'WlaiubodhLmoFm6', '20240505121803', '1271', '160.00', '94.00', '15040.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13257, 'LXy0PcAf8EeDNn3', '20240505121803', '1272', '100.00', '94.00', '9400.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13258, 'mdKKHwDe9BaG6JL', '20240505121803', '1273', '112.00', '107.00', '11984.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13459, 'rg4zAtDqUQWIdcR', '20240505121954', '1276', '1.00', '3400.00', '3400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13458, 'XgUDorVkuosJKuX', '20240505121954', '1204', '6.00', '1325.00', '7950.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13457, 'XxYe0ByCTPYW8ZY', '20240505121954', '481', '10.00', '39.00', '390.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13471, 'KNGxtAgRCRzmOnd', '20240505110122', '884', '60.00', '475.00', '28500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13472, 'VYeHiGcyTg4duX5', '20240505110122', '888', '70.00', '339.00', '23730.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13470, 'EHB5a3RJxD5F5wd', '20240505110122', '883', '69.00', '483.00', '33327.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13469, 'loTd1SOPidDnzNj', '20240505110122', '886', '7.00', '291.00', '2037.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13468, 'NtT4DLqeXxUYtCb', '20240505110122', '885', '4.00', '453.00', '1812.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13467, 'XCGk8hXWqdisSAg', '20240505110122', '887', '1.00', '305.00', '305.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13466, 'DAMKmkh5xyGunIR', '20240505110122', '1033', '10.00', '2200.00', '22000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13465, 'qTeDw4pOqsMOz4B', '20240505110122', '1032', '4.00', '1400.00', '5600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13464, 'XisQsHbCgR0ydGt', '20240505110122', '919', '1.00', '370.00', '370.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13463, 'asK1VSin8A73fsX', '20240505110122', '1282', '2.00', '460.00', '920.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13462, 'hPViTntuBvA4NbA', '20240505110122', '1283', '1.00', '290.00', '290.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13461, 'LQuJaCyJy5lCSir', '20240505110122', '1279', '10.00', '495.00', '4950.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13460, 'LLanNc77oV1nhNS', '20240505110122', '1280', '10.00', '485.00', '4850.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13359, 'NF8CP0LB2k5UK96', '20240506104201', '697', '55.00', '400.00', '22000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13358, 'R2rd5xzgeEKwjkm', '20240506104201', '705', '40.00', '260.00', '10400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13357, 'JiQkvchX3UMpqum', '20240506104201', '245', '3.00', '3000.00', '9000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13356, 'tVuADLn8FDLC0IN', '20240506104201', '805', '2.00', '850.00', '1700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13355, '5KfMnxhfq38Xa2O', '20240506104201', '700', '100.00', '160.00', '16000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13354, 'TtX3CtRO4Nhixoz', '20240506104201', '254', '280.00', '235.00', '65800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13352, 'xpT9WCytBH1xFR4', '20240506104755', '387', '2.00', '486.00', '972.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13353, 'JUqVtPkTSZIXJdt', '20240506104755', '399', '2.00', '286.00', '572.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13360, 'p8sWlVFPeWZDAk6', '20240506104201', '1284', '1.00', '1050.00', '1050.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13361, 'Q3ncjG31xE3DkD4', '20240506104201', '254', '1.00', '200.00', '200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14228, 'tE88KJM0UdqYT5J', '20240506145001', '1338', '12.00', '90.00', '1080.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14387, 'AJWoaPlwIR5KGTr', '20240205160956', '1228', '12.00', '20.00', '240.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13478, 'xSXJdnJaxlAP50X', '20240505110122', '1286', '2.00', '750.00', '1500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13479, 'BVSHWQvdBeh7KAX', '20240507103746', '1162', '4.00', '17533.00', '70132.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13480, '7ycjusGqaAyYw4k', '20240508110100', '1287', '200.00', '280.00', '56000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13481, 'KK9IEmUd5qcW97P', '20240508110100', '1288', '2500.00', '43.00', '107500.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13482, 'PuH2np9ucudWCRm', '20240508110100', '1289', '20.00', '900.00', '18000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14227, 'L3NZkdy0efVtNWK', '20240506145001', '1140', '12.00', '35.00', '420.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14226, 'Bo7LWZ7dB3vmqUv', '20240506145001', '1337', '30.00', '130.00', '3900.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13652, 'B6Zghu7DEJdVM3T', '20240509085309', '1292', '55.00', '600.00', '33000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14225, 'ZPaYrnQjeFrHjqL', '20240506145001', '1139', '12.00', '40.00', '480.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14224, '4ovktflcSCMsJHP', '20240506145001', '1306', '50.00', '10.00', '500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14223, 'kdNjycEVge5h4Zy', '20240506145001', '1305', '60.00', '8.00', '480.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13653, '6hAtnehSbNqwTfL', '20240509085309', '729', '63.00', '104.00', '6552.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13665, 'wmvJUKlqXnTCyfE', '20240511090102', '1123', '1.00', '6500.00', '6500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13664, 'LXEPlgu4zhNl7zU', '20240511090102', '1058', '6.00', '180.00', '1080.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13663, 'yBDwYhj888qS5a4', '20240511090102', '1031', '1.00', '4500.00', '4500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13662, 'QJVnt19iiv0uThx', '20240511090102', '1129', '2.00', '2100.00', '4200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13661, '2Ft1R9S3rAyyyov', '20240511090102', '1029', '1.00', '950.00', '950.00', '8', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13660, 'I2K74WgV9QvSrpC', '20240511090102', '1170', '20.00', '380.00', '7600.00', '6', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13666, '7yUrKje8t6l1C0k', '20240511090102', '1294', '200.00', '70.00', '14000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13667, 'jS42PW7qJXWExTO', '20240511090102', '1295', '3.00', '950.00', '2850.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13668, 'Df9p2ApIHrGA5gD', '20240511091033', '730', '243.00', '147.00', '35721.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13669, 'yQEgC9Ly4eruiur', '20240511091033', '729', '355.00', '104.00', '36920.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13675, 'uNVVmmhcvuciG5m', '20240415103944', '1296', '1.00', '350.00', '350.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14219, 'Ovr00hFkgDjyfP4', '20240506145001', '1285', '90.00', '30.00', '2700.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14222, 'QXdewjMuHAXMBFu', '20240506145001', '1304', '60.00', '6.00', '360.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13884, 'yWsd0eDVB5VpZrm', '20240512083036', '1303', '1.00', '10000.00', '10000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13883, 'vgITzJmbcJSfMVI', '20240512083036', '1298', '1.00', '600.00', '600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13692, 'tAAciRHhkCFUy9M', '20240512083938', '1299', '1.00', '4500.00', '4500.00', '2', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13693, 'A6sgFOhUNrIYXZ8', '20240512083938', '1300', '70.00', '86.00', '6020.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13694, 'XgLsGgaU72PQlR7', '20240512090322', '1301', '1.00', '5800.00', '5800.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14221, 'TEOkU17yLBz7Ggj', '20240506145001', '1302', '30.00', '100.00', '3000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13882, 'dY6F9Pxft3c6PUq', '20240512083036', '469', '1.00', '1100.00', '1100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14220, '7mIQBLUI65PEwOA', '20240506145001', '1293', '30.00', '80.00', '2400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14218, 'NKGTn3Ak9D7MPWu', '20240506145001', '1014', '90.00', '160.00', '14400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14217, 'wsjJ3oN8QvaFv2F', '20240506145001', '903', '12.00', '40.00', '480.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14216, 'xEAKxFuzrhrZZUf', '20240506145001', '843', '12.00', '13.00', '156.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14215, 'Z16FTUzXb3Ww1bV', '20240506145001', '920', '12.00', '20.00', '240.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13993, 'Ie5wsz6uEz2R9NU', '20240513113659', '221', '12.00', '460.00', '5520.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13992, 'KLfIxfkMLDGO8La', '20240513113659', '1050', '5.00', '550.00', '2750.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13991, 'epZkXw05ihKdH0t', '20240513113659', '225', '5.00', '450.00', '2250.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13990, 'dWkb8K8Tq12Ehxr', '20240513113659', '1220', '1.00', '4000.00', '4000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13989, 'GbjZgGMdHkz2VrA', '20240513113659', '1307', '9.00', '280.00', '2520.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13988, 'laGlj4mQrImpdmX', '20240513113659', '1308', '27.00', '200.00', '5400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13939, 'kV9RTMW94CL0F97', '20240513121625', '1202', '2.00', '6700.00', '13400.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13940, 'tkJl55KoZlN4bdr', '20240513121625', '1309', '1.00', '150.00', '150.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13941, 'Es84nl9Kt4MoxXN', '20240513122220', '1310', '100.00', '450.00', '45000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13950, 'pbWGnqa7V0MbXUL', '20240513123234', '244', '1.00', '5500.00', '5500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13949, 'Y2UtlERyKNKbgM2', '20240513123234', '251', '15.00', '260.00', '3900.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13948, '11oC1ZuiITnJPmu', '20240513123234', '808', '5.00', '250.00', '1250.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13951, 'N8HJb5HUgGVfAhB', '20240513123234', '1311', '30.00', '850.00', '25500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13952, 'uTrSS5AoNyf8l2F', '20240513124438', '1312', '12.00', '210.00', '2520.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14002, 'Z2PkcQpGj74ZGxm', '20240514093845', '1313', '1.00', '850.00', '850.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14001, 'Zh2vvotnEvpJQq7', '20240514093845', '1296', '1.00', '250.00', '250.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14000, 'D7M5OqpJPjBqMlB', '20240514093845', '1314', '2.00', '290.00', '580.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13999, 'hgaeFexraa2Iccn', '20240514093845', '1315', '6.00', '320.00', '1920.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13957, 'esCcsiawQJner0X', '20240514100037', '1317', '1.00', '13000.00', '13000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14214, 'ntF835E5BIJ1vkc', '20240506145001', '1291', '100.00', '14.00', '1400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13987, 'EoF2hyUmTfWnnL3', '20240331163350', '1318', '1.00', '5400.00', '5400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (13994, '39aCwi47GOD16cq', '20240513113659', '1319', '1.00', '2400.00', '2400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14003, 'Dytg9U3GLO0A2aO', '20240514155936', '1320', '1.00', '28000.00', '28000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14386, 'd3R89gP0ZYjGGor', '20240205160956', '1227', '12.00', '40.00', '480.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14087, '3VIu7Xd6T8OoNtt', '20240515120704', '1321', '12.00', '1320.00', '15840.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14088, 'eC9tFoWh4sWjfOp', '20240515120704', '1322', '12.00', '660.00', '7920.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14089, 'vmCiAvGJtBqZqaC', '20240515120704', '1323', '24.00', '600.00', '14400.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14090, 'iLrsyzoKAbNlQ2', '20240515120704', '1017', '100.00', '45.00', '4500.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14091, 'YsWsOgBvNuUjjHd', '20240515120704', '1016', '100.00', '30.00', '3000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14092, 'iWQqYi4hA4F6iV4', '20240515120704', '1324', '100.00', '15.00', '1500.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14093, 'btqNOXX4QHiPCgu', '20240515120704', '1325', '5.00', '660.00', '3300.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14094, 'MPn92cOywlln0rn', '20240515133441', '1326', '1.00', '3900.00', '3900.00', '1', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14095, 'Gwo8eorK8NwyR7d', '20240515133441', '1156', '36.00', '51.70', '1861.20', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14099, 'mhMzbCw2rK14ji5', '20240515133628', '263', '24.00', '350.00', '8400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14098, 'X2ismko8SoCYfGG', '20240515133628', '269', '80.00', '110.00', '8800.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14100, 'bCqj21QxLQh9a9F', '20240515135425', '1327', '13.00', '1320.00', '17160.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14101, 'cUEuJFTTWvkiKqL', '20240515140556', '1328', '15.00', '700.00', '10500.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14102, 'ZA4WYN7IOQzvapm', '20240515140556', '1329', '6.00', '375.00', '2250.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14103, 'aOfrMsEM0XXI4eV', '20240515140556', '1190', '12.00', '15.00', '180.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14104, 'VW5O1qKYYOC7sZI', '20240516133700', '1330', '5.00', '450.00', '2250.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14105, 'U2nGYDbC9Do0fNu', '20240516133700', '1331', '5.00', '500.00', '2500.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14106, '8QjwAAoSgeOFUDj', '20240516133700', '1332', '3.00', '240.00', '720.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14107, 'TYVVncT37d5qms8', '20240516133700', '1333', '2.00', '110.00', '220.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14108, 'pw0rKe60MavW8e2', '20240516133700', '1334', '3.00', '200.00', '600.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14109, 'N402bliacJZsMRo', '20240516133700', '1335', '10.00', '150.00', '1500.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14231, 'LCDshwGoFBoerhX', '20240518090409', '824', '3.00', '5000.00', '15000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14111, 'U6burdEUeWWQmva', '20240518091329', '1336', '1.00', '4500.00', '4500.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14213, 'QRiRxO4NwQ3X2Fb', '20240506145001', '1011', '12.00', '11.00', '132.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14212, '7adduvmjr73DIPk', '20240506145001', '1012', '12.00', '5.00', '60.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14148, 'qUnOyNG4X34vpiP', '20240519083354', '1339', '2.00', '1000.00', '2000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14149, '9Qkulzh8QvwiTCq', '20240519083354', '1340', '2.00', '3500.00', '7000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14150, '8r3HCMbB688KdHo', '20240519083354', '740', '1.00', '14500.00', '14500.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14151, 'jf6zO36YMwKkXMT', '20240519084115', '1341', '1000.00', '147.00', '147000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14152, 'BXJvQmI2oZUDcVn', '20240519084115', '1342', '1000.00', '132.00', '132000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14153, 'xiPjCXDsMKwDjPP', '20240519092005', '1343', '27.00', '24.00', '648.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14154, 'Zmkns0VdfQDBtCg', '20240519092005', '1344', '19.00', '25.00', '475.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14155, '5NYVCihGwgtgROm', '20240519092005', '1345', '14.00', '17.00', '238.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14156, 'vJNoayVc03mg7tf', '20240519092005', '1346', '36.00', '46.00', '1656.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14157, 'HbtdVFTFmg9mmdu', '20240519092005', '1347', '1.00', '1000.00', '1000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14158, '8ENeSPZZuTdfkm', '20240519092005', '1348', '1.00', '1000.00', '1000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14159, 'svOh70graD6VvXf', '20240519092005', '1349', '3.00', '3500.00', '10500.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14211, 'QNWK9e4KNWRaz9p', '20240506145001', '372', '100.00', '40.00', '4000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14210, 'iY2Hp1yFh43gveR', '20240506145001', '1350', '12.00', '34.00', '408.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14230, 'dJ3zFrTNrTV9i2n', '20240506145001', '1351', '12.00', '16.00', '192.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14232, 'ZlAj35dZLI5RtAz', '20240518090409', '584', '1.00', '2600.00', '2600.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14233, '8FjnlBqFbp4E5YL', '20240519141002', '1352', '1000.00', '110.00', '110000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14234, 'NRY3s3zN3W3fDJO', '20240520091034', '777', '1.00', '120.00', '120.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14235, 'AOTZd6owTLOQW3x', '20240520091034', '1353', '1.00', '90.00', '90.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14236, 'hGkpmJAnmSr8NTi', '20240520091034', '1354', '41.00', '60.00', '2460.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14237, 'pAqzpHXNDVWBr6B', '20240520091034', '1141', '4.00', '100.00', '400.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14238, 'pVYV9DVwDXBdSRE', '20240520091034', '1355', '1.00', '100.00', '100.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14239, 'xk3wdbym0qb5LUZ', '20240520091034', '1356', '1.00', '500.00', '500.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14240, 'vAsUZ4bNdHjt9iI', '20240520091034', '1357', '4.00', '120.00', '480.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14241, 'QfpwWJ8vcMuwdYy', '20240520091034', '1358', '1.00', '2000.00', '2000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14242, 'X1b8Hl7f9DOM6Uz', '20240520091034', '1359', '1.00', '1000.00', '1000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14243, 'FIlGbcWI8qbA0gl', '20240520091034', '1318', '2.00', '5400.00', '10800.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14244, 'EI0DIWtMh3iqOLW', '20240520091552', '198', '10.00', '2200.00', '22000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14245, 'w04aeytFr3n89nD', '20240520111840', '1360', '22.00', '600.00', '13200.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14246, 'uDnGdEwN5XtobGA', '20240520111840', '1361', '15.00', '30.00', '450.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14247, 'dkcV3enSarN1dC0', '20240520111840', '1362', '10.00', '70.00', '700.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14248, 'z9bIbQJ66xnGQ27', '20240520111840', '1363', '72.00', '60.00', '4320.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14249, 'Nxos4v8lDXejIah', '20240520111840', '1364', '5.00', '10550.00', '52750.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14250, 'mcXX0DxQ4zopwzX', '20240520111840', '1365', '1.00', '4000.00', '4000.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14255, '9sawAV2MlvCF9dJ', '20240521080304', '530', '1.00', '850.00', '850.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14254, '8KkrOyNbuKXgzdN', '20240521080304', '1240', '2.00', '90.00', '180.00', '9', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14256, 'yc8pXFRtNgdVaSa', '20240521080304', '746', '1.00', '200.00', '200.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14257, 'DjzDq8wialv0kp0', '20240521080304', '1366', '4.00', '350.00', '1400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14258, 't34bdJ3pW9nPbIK', '20240521080304', '1367', '2.00', '200.00', '400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14259, 'Ioh9EtnDSZo0ME8', '20240521080304', '1368', '2.00', '130.00', '260.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14263, 'xESTvhZYrkVoYKz', '20240521081618', '501', '2.00', '240.00', '480.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14262, '3Ah56nLO8p7MhrP', '20240521081618', '1315', '5.00', '300.00', '1500.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14264, '702WGPtzSvdHhDc', '20240521081618', '1369', '2.00', '200.00', '400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14265, 'xfZ6OQNNJL0LVtv', '20240521081618', '1370', '1.00', '1000.00', '1000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14266, '2jUIayxiOiQvA8x', '20240521082619', '1029', '3.00', '900.00', '2700.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14267, 'LKOypcrasV5LONc', '20240521082619', '1125', '1.00', '1500.00', '1500.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14268, '9kaauKlN59SJBVD', '20240521082619', '1028', '4.00', '1300.00', '5200.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14269, 'FBYn3GgpRDBbrwc', '20240521082619', '1125', '1.00', '1500.00', '1500.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14270, 'lZ6a9DfBfDmtURn', '20240521083132', '1371', '1.00', '14500.00', '14500.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14271, 'sSYD4J22kr77aiJ', '20240521083413', '1292', '24.00', '600.00', '14400.00', '0', 1);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14456, 'KZlUpiwrQOKxBhR', '20240205160956', '1175', '12.00', '45.90', '550.80', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14466, '8vT8r9g8XFHwVUG', '20240530060328', '1102', '100.00', '30.00', '3000.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14465, 'tlSyKjlTuqpurGh', '20240530060328', '1101', '1.00', '400.00', '400.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14464, 'ta2yId6AXpFG5op', '20240530060328', '482', '1.00', '100.00', '100.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14463, 'NlpOw5MBjoemsMF', '20240530060328', '980', '5.00', '1050.00', '5250.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14467, 'Q9CN6XrdgWQ1TIz', '20240530060328', '1103', '1.00', '50.00', '50.00', '0', NULL);
INSERT INTO `product_purchase_details` (`id`, `purchase_detail_id`, `purchase_id`, `product_id`, `quantity`, `rate`, `total_amount`, `discount`, `status`) VALUES (14469, '7J0seAJ4pJGkpXb', '20240530062723', '993', '36.00', '8200.00', '295200.00', '0', NULL);


#
# TABLE STRUCTURE FOR: product_return
#

DROP TABLE IF EXISTS `product_return`;

CREATE TABLE `product_return` (
  `return_id` varchar(30) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `product_id` varchar(20) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `invoice_id` varchar(20) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `purchase_id` varchar(30) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `date_purchase` varchar(20) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `date_return` varchar(30) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `byy_qty` float NOT NULL,
  `ret_qty` float NOT NULL,
  `customer_id` varchar(20) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `supplier_id` varchar(30) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `product_rate` decimal(10,2) NOT NULL DEFAULT '0.00',
  `deduction` float NOT NULL,
  `total_deduct` decimal(10,2) NOT NULL DEFAULT '0.00',
  `total_tax` decimal(10,2) NOT NULL DEFAULT '0.00',
  `total_ret_amount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `net_total_amount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `reason` text CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `usablity` int NOT NULL,
  KEY `product_id` (`product_id`),
  KEY `invoice_id` (`invoice_id`),
  KEY `purchase_id` (`purchase_id`),
  KEY `customer_id` (`customer_id`),
  KEY `supplier_id` (`supplier_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

#
# TABLE STRUCTURE FOR: product_service
#

DROP TABLE IF EXISTS `product_service`;

CREATE TABLE `product_service` (
  `service_id` int NOT NULL AUTO_INCREMENT,
  `service_name` varchar(250) NOT NULL,
  `description` text NOT NULL,
  `charge` decimal(10,2) NOT NULL DEFAULT '0.00',
  PRIMARY KEY (`service_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

#
# TABLE STRUCTURE FOR: quot_products_used
#

DROP TABLE IF EXISTS `quot_products_used`;

CREATE TABLE `quot_products_used` (
  `id` int NOT NULL AUTO_INCREMENT,
  `quot_id` varchar(100) NOT NULL,
  `product_id` varchar(100) NOT NULL,
  `serial_no` varchar(30) DEFAULT NULL,
  `description` varchar(250) DEFAULT NULL,
  `used_qty` decimal(10,2) DEFAULT NULL,
  `rate` decimal(10,2) DEFAULT NULL,
  `supplier_rate` float DEFAULT NULL,
  `total_price` decimal(12,2) DEFAULT NULL,
  `discount` decimal(10,2) DEFAULT NULL,
  `discount_per` varchar(15) DEFAULT NULL,
  `tax` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `product_id` (`product_id`),
  KEY `quot_id` (`quot_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb3;

#
# TABLE STRUCTURE FOR: quotation
#

DROP TABLE IF EXISTS `quotation`;

CREATE TABLE `quotation` (
  `id` int NOT NULL AUTO_INCREMENT,
  `quotation_id` varchar(30) NOT NULL,
  `quot_description` text NOT NULL,
  `customer_id` varchar(30) NOT NULL,
  `quotdate` date NOT NULL,
  `expire_date` date DEFAULT NULL,
  `item_total_amount` decimal(12,2) NOT NULL,
  `item_total_dicount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `item_total_tax` decimal(10,2) NOT NULL DEFAULT '0.00',
  `service_total_amount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `service_total_discount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `service_total_tax` decimal(10,2) NOT NULL DEFAULT '0.00',
  `quot_dis_item` decimal(10,2) NOT NULL DEFAULT '0.00',
  `quot_dis_service` decimal(10,2) NOT NULL DEFAULT '0.00',
  `quot_no` varchar(50) NOT NULL,
  `create_by` varchar(30) NOT NULL,
  `create_date` date NOT NULL,
  `update_by` varchar(30) DEFAULT NULL,
  `update_date` date DEFAULT NULL,
  `status` tinyint NOT NULL,
  `cust_show` tinyint DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `quot_no` (`quot_no`),
  KEY `quotation_id` (`quotation_id`),
  KEY `customer_id` (`customer_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

#
# TABLE STRUCTURE FOR: quotation_service_used
#

DROP TABLE IF EXISTS `quotation_service_used`;

CREATE TABLE `quotation_service_used` (
  `id` int NOT NULL AUTO_INCREMENT,
  `quot_id` varchar(20) NOT NULL,
  `service_id` int NOT NULL,
  `qty` decimal(10,2) NOT NULL DEFAULT '0.00',
  `charge` decimal(10,2) NOT NULL DEFAULT '0.00',
  `discount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `discount_amount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `tax` decimal(10,2) NOT NULL DEFAULT '0.00',
  `total` decimal(10,2) NOT NULL DEFAULT '0.00',
  PRIMARY KEY (`id`),
  KEY `quot_id` (`quot_id`),
  KEY `service_id` (`service_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

#
# TABLE STRUCTURE FOR: quotation_taxinfo
#

DROP TABLE IF EXISTS `quotation_taxinfo`;

CREATE TABLE `quotation_taxinfo` (
  `id` int NOT NULL AUTO_INCREMENT,
  `date` date NOT NULL,
  `customer_id` int NOT NULL,
  `relation_id` varchar(30) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `customer_id` (`customer_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

#
# TABLE STRUCTURE FOR: role_permission
#

DROP TABLE IF EXISTS `role_permission`;

CREATE TABLE `role_permission` (
  `id` int NOT NULL AUTO_INCREMENT,
  `fk_module_id` int NOT NULL,
  `role_id` int NOT NULL,
  `create` tinyint(1) DEFAULT NULL,
  `read` tinyint(1) DEFAULT NULL,
  `update` tinyint(1) DEFAULT NULL,
  `delete` tinyint(1) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_module_id` (`fk_module_id`),
  KEY `fk_user_id` (`role_id`)
) ENGINE=InnoDB AUTO_INCREMENT=346 DEFAULT CHARSET=utf8mb3;

INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (116, 1, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (117, 2, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (118, 3, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (119, 114, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (120, 25, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (121, 26, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (122, 27, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (123, 28, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (124, 111, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (125, 113, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (126, 21, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (127, 22, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (128, 23, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (129, 24, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (130, 30, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (131, 31, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (132, 32, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (133, 33, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (134, 112, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (135, 35, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (136, 36, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (137, 43, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (138, 37, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (139, 38, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (140, 39, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (141, 40, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (142, 46, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (143, 47, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (144, 48, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (145, 49, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (146, 50, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (147, 51, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (148, 52, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (149, 53, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (150, 54, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (151, 55, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (152, 97, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (153, 98, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (154, 99, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (155, 100, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (156, 101, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (157, 102, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (158, 4, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (159, 5, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (160, 6, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (161, 7, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (162, 8, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (163, 9, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (164, 10, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (165, 11, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (166, 12, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (167, 13, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (168, 14, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (169, 15, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (170, 16, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (171, 17, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (172, 18, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (173, 19, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (174, 56, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (175, 57, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (176, 58, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (177, 41, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (178, 103, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (179, 104, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (180, 109, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (181, 110, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (182, 60, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (183, 61, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (184, 62, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (185, 63, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (186, 64, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (187, 65, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (188, 66, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (189, 67, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (190, 68, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (191, 69, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (192, 70, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (193, 71, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (194, 72, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (195, 73, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (196, 74, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (197, 75, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (198, 76, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (199, 77, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (200, 78, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (201, 79, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (202, 80, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (203, 81, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (204, 82, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (205, 83, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (206, 84, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (207, 85, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (208, 86, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (209, 105, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (210, 106, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (211, 107, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (212, 108, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (213, 59, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (214, 87, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (215, 88, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (216, 89, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (217, 90, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (218, 91, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (219, 92, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (220, 93, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (221, 94, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (222, 95, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (223, 96, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (224, 115, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (225, 116, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (226, 117, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (227, 118, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (228, 119, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (229, 120, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (230, 121, 1, 1, 1, 1, 1);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (231, 1, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (232, 2, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (233, 3, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (234, 114, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (235, 25, 2, 0, 0, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (236, 26, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (237, 27, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (238, 28, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (239, 111, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (240, 113, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (241, 21, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (242, 22, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (243, 23, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (244, 24, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (245, 30, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (246, 31, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (247, 32, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (248, 33, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (249, 112, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (250, 35, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (251, 36, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (252, 43, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (253, 37, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (254, 38, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (255, 39, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (256, 40, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (257, 46, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (258, 47, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (259, 48, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (260, 49, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (261, 50, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (262, 51, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (263, 52, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (264, 53, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (265, 54, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (266, 55, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (267, 97, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (268, 98, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (269, 99, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (270, 100, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (271, 101, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (272, 102, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (273, 4, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (274, 5, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (275, 6, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (276, 7, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (277, 8, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (278, 9, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (279, 10, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (280, 11, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (281, 12, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (282, 13, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (283, 14, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (284, 15, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (285, 16, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (286, 17, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (287, 18, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (288, 19, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (289, 56, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (290, 57, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (291, 58, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (292, 41, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (293, 103, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (294, 104, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (295, 109, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (296, 110, 2, 1, 1, 1, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (297, 60, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (298, 61, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (299, 62, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (300, 63, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (301, 64, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (302, 65, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (303, 66, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (304, 67, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (305, 68, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (306, 69, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (307, 70, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (308, 71, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (309, 72, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (310, 73, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (311, 74, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (312, 75, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (313, 76, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (314, 77, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (315, 78, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (316, 79, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (317, 80, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (318, 81, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (319, 82, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (320, 83, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (321, 84, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (322, 85, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (323, 86, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (324, 105, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (325, 106, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (326, 107, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (327, 108, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (328, 59, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (329, 87, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (330, 88, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (331, 89, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (332, 90, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (333, 91, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (334, 92, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (335, 93, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (336, 94, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (337, 95, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (338, 96, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (339, 115, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (340, 116, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (341, 117, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (342, 118, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (343, 119, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (344, 120, 2, 0, 0, 0, 0);
INSERT INTO `role_permission` (`id`, `fk_module_id`, `role_id`, `create`, `read`, `update`, `delete`) VALUES (345, 121, 2, 0, 0, 0, 0);


#
# TABLE STRUCTURE FOR: salary_sheet_generate
#

DROP TABLE IF EXISTS `salary_sheet_generate`;

CREATE TABLE `salary_sheet_generate` (
  `ssg_id` int unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(30) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `gdate` varchar(30) DEFAULT NULL,
  `start_date` varchar(30) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `end_date` varchar(30) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `generate_by` varchar(30) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  PRIMARY KEY (`ssg_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

#
# TABLE STRUCTURE FOR: salary_type
#

DROP TABLE IF EXISTS `salary_type`;

CREATE TABLE `salary_type` (
  `salary_type_id` int NOT NULL AUTO_INCREMENT,
  `sal_name` varchar(100) NOT NULL,
  `salary_type` varchar(50) NOT NULL,
  `status` varchar(30) NOT NULL,
  PRIMARY KEY (`salary_type_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

#
# TABLE STRUCTURE FOR: sec_role
#

DROP TABLE IF EXISTS `sec_role`;

CREATE TABLE `sec_role` (
  `id` int NOT NULL AUTO_INCREMENT,
  `type` varchar(100) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;

INSERT INTO `sec_role` (`id`, `type`) VALUES (1, 'ADMIN');
INSERT INTO `sec_role` (`id`, `type`) VALUES (2, 'millat');


#
# TABLE STRUCTURE FOR: sec_userrole
#

DROP TABLE IF EXISTS `sec_userrole`;

CREATE TABLE `sec_userrole` (
  `id` int NOT NULL AUTO_INCREMENT,
  `user_id` varchar(50) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci NOT NULL,
  `roleid` int NOT NULL,
  `createby` varchar(50) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci NOT NULL,
  `createdate` datetime NOT NULL,
  UNIQUE KEY `ID` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

INSERT INTO `sec_userrole` (`id`, `user_id`, `roleid`, `createby`, `createdate`) VALUES (1, '1', 2, '2', '2024-01-12 12:21:07');
INSERT INTO `sec_userrole` (`id`, `user_id`, `roleid`, `createby`, `createdate`) VALUES (2, '1', 2, '2', '2024-01-12 12:22:12');
INSERT INTO `sec_userrole` (`id`, `user_id`, `roleid`, `createby`, `createdate`) VALUES (3, '1', 2, '2', '2024-01-18 11:59:59');
INSERT INTO `sec_userrole` (`id`, `user_id`, `roleid`, `createby`, `createdate`) VALUES (4, '2', 1, '2', '2024-01-18 12:01:42');


#
# TABLE STRUCTURE FOR: service_invoice
#

DROP TABLE IF EXISTS `service_invoice`;

CREATE TABLE `service_invoice` (
  `id` int NOT NULL AUTO_INCREMENT,
  `voucher_no` varchar(30) NOT NULL,
  `date` date NOT NULL,
  `employee_id` varchar(100) DEFAULT NULL,
  `customer_id` varchar(30) NOT NULL,
  `total_amount` decimal(20,2) NOT NULL DEFAULT '0.00',
  `total_discount` decimal(20,2) NOT NULL DEFAULT '0.00',
  `invoice_discount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `total_tax` decimal(10,2) NOT NULL DEFAULT '0.00',
  `paid_amount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `due_amount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `shipping_cost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `previous` decimal(10,2) NOT NULL DEFAULT '0.00',
  `details` varchar(250) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `customer_id` (`customer_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

#
# TABLE STRUCTURE FOR: service_invoice_details
#

DROP TABLE IF EXISTS `service_invoice_details`;

CREATE TABLE `service_invoice_details` (
  `id` int NOT NULL AUTO_INCREMENT,
  `service_id` int NOT NULL,
  `service_inv_id` varchar(30) NOT NULL,
  `qty` decimal(10,2) NOT NULL DEFAULT '0.00',
  `charge` decimal(10,2) NOT NULL DEFAULT '0.00',
  `discount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `discount_amount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `total` decimal(10,2) NOT NULL DEFAULT '0.00',
  PRIMARY KEY (`id`),
  KEY `service_id` (`service_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

#
# TABLE STRUCTURE FOR: sms_settings
#

DROP TABLE IF EXISTS `sms_settings`;

CREATE TABLE `sms_settings` (
  `id` int NOT NULL AUTO_INCREMENT,
  `api_key` varchar(100) DEFAULT NULL,
  `api_secret` varchar(100) DEFAULT NULL,
  `from` varchar(100) DEFAULT NULL,
  `isinvoice` int NOT NULL DEFAULT '0',
  `isservice` int NOT NULL DEFAULT '0',
  `isreceive` int NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3;

INSERT INTO `sms_settings` (`id`, `api_key`, `api_secret`, `from`, `isinvoice`, `isservice`, `isreceive`) VALUES (1, '5d6db102011', '456452dfgdf', '8801645452', 0, 0, 0);


#
# TABLE STRUCTURE FOR: sub_module
#

DROP TABLE IF EXISTS `sub_module`;

CREATE TABLE `sub_module` (
  `id` int NOT NULL AUTO_INCREMENT,
  `mid` int NOT NULL,
  `name` varchar(100) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL,
  `description` text CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci,
  `image` varchar(100) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL,
  `directory` varchar(50) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL,
  `status` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=122 DEFAULT CHARSET=latin1;

INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (1, 1, 'new_invoice', NULL, NULL, 'new_invoice', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (2, 1, 'manage_invoice', NULL, NULL, 'manage_invoice', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (3, 1, 'pos_invoice', NULL, NULL, 'pos_invoice', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (4, 9, 'c_o_a', NULL, NULL, 'show_tree', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (5, 9, 'supplier_payment', NULL, NULL, 'supplier_payment', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (6, 9, 'customer_receive', NULL, NULL, 'customer_receive', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (7, 9, 'debit_voucher', NULL, NULL, 'debit_voucher', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (8, 9, 'credit_voucher', NULL, NULL, 'credit_voucher', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (9, 9, 'voucher_approval', NULL, NULL, 'aprove_v', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (10, 9, 'contra_voucher', NULL, NULL, 'contra_voucher', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (11, 9, 'journal_voucher', NULL, NULL, 'journal_voucher', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (12, 9, 'report', NULL, NULL, 'ac_report', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (13, 9, 'cash_book', NULL, NULL, 'cash_book', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (14, 9, 'Inventory_ledger', NULL, NULL, 'inventory_ledger', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (15, 9, 'bank_book', NULL, NULL, 'bank_book', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (16, 9, 'general_ledger', NULL, NULL, 'general_ledger', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (17, 9, 'trial_balance', NULL, NULL, 'trial_balance', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (18, 9, 'cash_flow', NULL, NULL, 'cash_flow_report', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (19, 9, 'coa_print', NULL, NULL, 'coa_print', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (21, 3, 'category', NULL, NULL, 'manage_category', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (22, 3, 'add_product', NULL, NULL, 'create_product', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (23, 3, 'import_product_csv', NULL, NULL, 'add_product_csv', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (24, 3, 'manage_product', NULL, NULL, 'manage_product', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (25, 2, 'add_customer', NULL, NULL, 'add_customer', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (26, 2, 'manage_customer', NULL, NULL, 'manage_customer', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (27, 2, 'credit_customer', NULL, NULL, 'credit_customer', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (28, 2, 'paid_customer', NULL, NULL, 'paid_customer', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (30, 3, 'unit', NULL, NULL, 'manage_unit', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (31, 4, 'add_supplier', NULL, NULL, 'add_supplier', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (32, 4, 'manage_supplier', NULL, NULL, 'manage_supplier', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (33, 4, 'supplier_ledger', NULL, NULL, 'supplier_ledger_report', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (35, 5, 'add_purchase', NULL, NULL, 'add_purchase', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (36, 5, 'manage_purchase', NULL, NULL, 'manage_purchase', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (37, 7, 'return', NULL, NULL, 'add_return', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (38, 7, 'stock_return_list', NULL, NULL, 'return_list', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (39, 7, 'supplier_return_list', NULL, NULL, 'supplier_return_list', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (40, 7, 'wastage_return_list', NULL, NULL, 'wastage_return_list', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (41, 11, 'tax_settings', NULL, NULL, 'tax_settings', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (43, 6, 'stock_report', NULL, NULL, 'stock_report', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (46, 8, 'closing', NULL, NULL, 'add_closing', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (47, 8, 'closing_report', NULL, NULL, 'closing_report', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (48, 8, 'todays_report', NULL, NULL, 'all_report', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (49, 8, 'todays_customer_receipt', NULL, NULL, 'todays_customer_receipt', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (50, 8, 'sales_report', NULL, NULL, 'todays_sales_report', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (51, 8, 'due_report', NULL, NULL, 'retrieve_dateWise_DueReports', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (52, 8, 'purchase_report', NULL, NULL, 'todays_purchase_report', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (53, 8, 'purchase_report_category_wise', NULL, NULL, 'purchase_report_category_wise', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (54, 8, 'sales_report_product_wise', NULL, NULL, 'product_sales_reports_date_wise', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (55, 8, 'sales_report_category_wise', NULL, NULL, 'sales_report_category_wise', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (56, 10, 'add_new_bank', NULL, NULL, 'add_bank', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (57, 10, 'bank_transaction', NULL, NULL, 'bank_transaction', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (58, 10, 'manage_bank', NULL, NULL, 'bank_list', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (59, 14, 'generate_commission', NULL, NULL, 'commission', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (60, 12, 'add_designation', NULL, NULL, 'add_designation', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (61, 12, 'manage_designation', NULL, NULL, 'manage_designation', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (62, 12, 'add_employee', NULL, NULL, 'add_employee', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (63, 12, 'manage_employee', NULL, NULL, 'manage_employee', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (64, 12, 'add_attendance', NULL, NULL, 'add_attendance', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (65, 12, 'manage_attendance', NULL, NULL, 'manage_attendance', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (66, 12, 'attendance_report', NULL, NULL, 'attendance_report', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (67, 12, 'add_benefits', NULL, NULL, 'add_benefits', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (68, 12, 'manage_benefits', NULL, NULL, 'manage_benefits', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (69, 12, 'add_salary_setup', NULL, NULL, 'add_salary_setup', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (70, 12, 'manage_salary_setup', NULL, NULL, 'manage_salary_setup', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (71, 12, 'salary_generate', NULL, NULL, 'salary_generate', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (72, 12, 'manage_salary_generate', NULL, NULL, 'manage_salary_generate', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (73, 12, 'salary_payment', NULL, NULL, 'salary_payment', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (74, 12, 'add_expense_item', NULL, NULL, 'add_expense_item', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (75, 12, 'manage_expense_item', NULL, NULL, 'manage_expense_item', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (76, 12, 'add_expense', NULL, NULL, 'add_expense', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (77, 12, 'manage_expense', NULL, NULL, 'manage_expense', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (78, 12, 'expense_statement', NULL, NULL, 'expense_statement', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (79, 12, 'add_person_officeloan', NULL, NULL, 'add1_person', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (80, 12, 'add_loan_officeloan', NULL, NULL, 'add_office_loan', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (81, 12, 'add_payment_officeloan', NULL, NULL, 'add_loan_payment', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (82, 12, 'manage_loan_officeloan', NULL, NULL, 'manage1_person', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (83, 12, 'add_person_personalloan', NULL, NULL, 'add_person', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (84, 12, 'add_loan_personalloan', NULL, NULL, 'add_loan', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (85, 12, 'add_payment_personalloan', NULL, NULL, 'add_payment', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (86, 12, 'manage_loan_personalloan', NULL, NULL, 'manage_person', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (87, 15, 'manage_company', NULL, NULL, 'manage_company', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (88, 15, 'add_user', NULL, NULL, 'add_user', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (89, 15, 'manage_users', NULL, NULL, 'manage_user', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (90, 15, 'language', NULL, NULL, 'add_language', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (91, 15, 'currency', NULL, NULL, 'add_currency', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (92, 15, 'setting', NULL, NULL, 'soft_setting', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (93, 15, 'add_role', NULL, NULL, 'add_role', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (94, 15, 'role_list', NULL, NULL, 'role_list', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (95, 15, 'user_assign_role', NULL, NULL, 'user_assign', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (96, 15, 'Permission', NULL, NULL, NULL, 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (97, 8, 'shipping_cost_report', NULL, NULL, 'shipping_cost_report', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (98, 8, 'user_wise_sales_report', NULL, NULL, 'user_wise_sales_report', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (99, 8, 'invoice_return', NULL, NULL, 'invoice_return', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (100, 8, 'supplier_return', NULL, NULL, 'supplier_return', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (101, 8, 'tax_report', NULL, NULL, 'tax_report', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (102, 8, 'profit_report', NULL, NULL, 'profit_report', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (103, 11, 'add_incometax', NULL, NULL, 'add_incometax', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (104, 11, 'manage_income_tax', NULL, NULL, 'manage_income_tax', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (105, 13, 'add_service', NULL, NULL, 'create_service', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (106, 13, 'manage_service', NULL, NULL, 'manage_service', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (107, 13, 'service_invoice', NULL, NULL, 'service_invoice', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (108, 13, 'manage_service_invoice', NULL, NULL, 'manage_service_invoice', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (109, 11, 'tax_report', NULL, NULL, 'tax_report', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (110, 11, 'invoice_wise_tax_report', NULL, NULL, 'invoice_wise_tax_report', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (111, 2, 'customer_advance', NULL, NULL, 'customer_advance', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (112, 4, 'supplier_advance', NULL, NULL, 'supplier_advance', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (113, 2, 'customer_ledger', NULL, NULL, 'customer_ledger', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (114, 1, 'gui_pos', NULL, NULL, 'gui_pos', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (115, 15, 'sms_configure', NULL, NULL, 'sms_configure', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (116, 15, 'backup_restore', NULL, NULL, 'back_up', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (117, 15, 'import', NULL, NULL, 'sql_import', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (118, 15, 'restore', NULL, NULL, 'restore', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (119, 16, 'add_quotation', NULL, NULL, 'add_quotation', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (120, 16, 'manage_quotation', NULL, NULL, 'manage_quotation', 1);
INSERT INTO `sub_module` (`id`, `mid`, `name`, `description`, `image`, `directory`, `status`) VALUES (121, 16, 'add_to_invoice', NULL, NULL, 'add_to_invoice', 1);


#
# TABLE STRUCTURE FOR: supplier_information
#

DROP TABLE IF EXISTS `supplier_information`;

CREATE TABLE `supplier_information` (
  `supplier_id` bigint NOT NULL AUTO_INCREMENT,
  `supplier_name` varchar(255) NOT NULL,
  `address` varchar(255) DEFAULT NULL,
  `address2` text NOT NULL,
  `mobile` varchar(100) DEFAULT NULL,
  `emailnumber` varchar(200) DEFAULT NULL,
  `email_address` varchar(200) DEFAULT NULL,
  `contact` varchar(100) DEFAULT NULL,
  `phone` varchar(50) DEFAULT NULL,
  `fax` varchar(100) DEFAULT NULL,
  `city` text,
  `state` text,
  `zip` varchar(50) DEFAULT NULL,
  `country` varchar(250) DEFAULT NULL,
  `details` varchar(255) DEFAULT NULL,
  `status` int NOT NULL,
  PRIMARY KEY (`supplier_id`),
  KEY `supplier_id` (`supplier_id`)
) ENGINE=MyISAM AUTO_INCREMENT=66 DEFAULT CHARSET=utf8mb3;

INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('1', 'Ashraf surgoda', '', '', '0311950561', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('2', 'Arslan LED', '', '', '03123017790', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('3', 'Pak E \\ S Khi', '', '', '03352353814', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('4', 'Qureshi pipe wala', '', '', '03112118590', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('7', 'P.V.C Mix item', '', '', '03153569005', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('8', 'Akram PVC', '', '', '03163068742', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('9', 'Nasir Electric', '', '', '03133587094', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('10', 'Memon LAD Light', '', '', '03414470445', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('11', 'Chilton Safan', '', '', '03133310784', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('14', 'ARY Sargodah', '', '', '03157181663', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('13', 'Olympic Sargodah', '', '', '03347424229', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('15', 'Al Mezan Sargodah', '', '', '03437533744', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('16', 'Asim Sargodah', '', '', '03006027729', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('19', 'E M Sargodah', '', '', '03117073265', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('18', 'Perfect Sargodah', '', '', '03007012962', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('20', 'Sonex Sargodah', '', '', '03016600770', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('23', 'Burq Sargodah', '', '', '03006040486', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('22', 'Sahar Al Fazal Sargodah', '', '', '03176010149', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('24', 'Fareed Qasim', '', '', '03003579515', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('25', 'Aijaz PCV Karachi', '', '', '03113286212', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('26', 'Jawaid Wire', '', '', '03009370350', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('27', 'Haji salman Karachi', '', '', '03152432410', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('28', 'Fizan Wire', '', '', '03362528446', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('29', 'G.One LED Light', '', '', '03331287548', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('30', 'Moin PVC Karachi', '', '', '03432655809', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('31', 'Arfeen Wire (Million)', '', '', '03163227838', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('32', 'Millat Traders Loose Item', '', '', '03323888201', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('33', 'Emaan Light House', '', '', '03070321705', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('34', 'Chilton Traders Karachi', '', '', '03002601096', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('35', 'Hameed Panel', '', '', '03332724775', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('36', 'Fawad Wire', '', '', '03133587094', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('37', 'New Shahid Pipe', '', '', '03322068992', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('38', 'HUawei ', '', '', '03004165651', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('39', 'Riaz Delux', '', '', '03313637625', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('40', 'Paremount General', '', '', '', '', '', '', '0222784103', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('41', 'Muneer Shop', '', '', '03201396554', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('42', 'Haji Salman Karachi', '', '', '03152432410', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('43', 'Royal Electri Karachi', '', '', '03219260234', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('44', 'Sindh Electri Hyderabad', '', '', '03463932532', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('45', 'Zahid Soomro Kotri', '', '', '03123828189', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('46', 'Naeem Pant', '', '', '03473534934', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('47', 'Haroon Pant', '', '', '03423515803', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('48', 'S.K Fan', '', '', '03453584812', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('49', 'Cash Item ', '', '', '03433669338', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('50', 'Abdul Hammed Panel wala', '', '', '03332724775', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('51', 'F Ali Iddress Karachi', '', '', '03219244001', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('52', 'M.S Electric Purchase ', '', '', '03233000462', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('53', 'Delux Electric Purchase ', '', '', '03133587094', '', '', '', '', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('54', 'Majid Fan Rod ', '', '', '', '', '', '', '03133587094', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('55', 'M.K Electric Purchase', '', '', '', '', '', '', '0222728027', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('56', 'Sale Return ', '', '', '', '', '', '', '03173998131', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('57', 'M.Ali Doctor', '', '', '', '', '', '', '03133587094', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('58', 'Abdul Qadir Purchase ', '', '', '', '', '', '', '03133587094', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('59', 'Yayha Karachi', '', '', '', '', '', '', '03173998131', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('60', 'Usman S.E ', '', '', '', '', '', '', '03133587094', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('61', 'M.Z Purchase ', '', '', '', '', '', '', '03333333333', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('62', 'Alfa Purchase ', '', '', '', '', '', '', '03333333333', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('63', 'Universal Karachi', '', '', '', '', '', '', '0333333333333', '', '', '', '', '', '', 1);
INSERT INTO `supplier_information` (`supplier_id`, `supplier_name`, `address`, `address2`, `mobile`, `emailnumber`, `email_address`, `contact`, `phone`, `fax`, `city`, `state`, `zip`, `country`, `details`, `status`) VALUES ('65', 'Abdul Aziz Shikh', '', '', '03212556036', '', '', '', '', '', '', '', '', '', '', 1);


#
# TABLE STRUCTURE FOR: supplier_product
#

DROP TABLE IF EXISTS `supplier_product`;

CREATE TABLE `supplier_product` (
  `supplier_pr_id` int NOT NULL AUTO_INCREMENT,
  `product_id` varchar(30) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL,
  `products_model` varchar(30) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `supplier_id` bigint NOT NULL,
  `supplier_price` float DEFAULT NULL,
  PRIMARY KEY (`supplier_pr_id`),
  KEY `product_id` (`product_id`),
  KEY `supplier_id` (`supplier_id`)
) ENGINE=InnoDB AUTO_INCREMENT=2663 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (128, '113', '', '20', '840');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (129, '114', '', '20', '480');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (130, '115', '', '20', '620');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (137, '122', '', '22', '340');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (272, '244', '', '29', '5500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (273, '245', '', '29', '2800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (279, '251', '', '29', '275');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (280, '252', '', '29', '310');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (281, '253', '', '29', '280');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (282, '254', '', '29', '230');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (283, '255', '', '29', '750');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (285, '257', '', '29', '550');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (286, '258', '', '29', '450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (747, '688', '', '33', '360');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (761, '703', '', '29', '900');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (763, '705', '', '29', '250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (764, '706 ', '', '29', '450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1005, '697', NULL, '29', '400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1008, '692', NULL, '29', '1100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1009, '691', NULL, '29', '1400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1010, '696', NULL, '29', '600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1086, '311', NULL, '31', '2961');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1089, '139', NULL, '24', '2961');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1090, '314', NULL, '31', '2961');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1092, '138', NULL, '24', '2961');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1093, '313', NULL, '31', '2961');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1095, '135', NULL, '24', '2961');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1096, '289', NULL, '31', '2961');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1099, '140', NULL, '24', '2961');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1100, '137', NULL, '24', '2961');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1101, '312', NULL, '31', '2961');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1103, '316', NULL, '31', '6146');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1104, '318', NULL, '31', '6146');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1105, '320', NULL, '31', '6146');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1107, '143', NULL, '24', '6146');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1109, '290', NULL, '31', '6146');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1110, '319', NULL, '31', '6146');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1111, '142', NULL, '24', '6146');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1112, '146', NULL, '24', '9331');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1113, '321', NULL, '31', '9331');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1114, '145', NULL, '24', '9331');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1115, '291', NULL, '31', '9331');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1129, '80', NULL, '13', '80');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1130, '81', NULL, '13', '80');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1131, '79', NULL, '13', '120');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1132, '78', NULL, '13', '160');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1133, '82', NULL, '13', '170');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1134, '112', NULL, '19', '280');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1135, '123', NULL, '22', '300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1137, '87', NULL, '14', '270');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1139, '492', NULL, '14', '235');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1140, '93', NULL, '14', '270');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1141, '103', NULL, '18', '320');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1143, '111', NULL, '19', '1000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1144, '90', NULL, '14', '900');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1146, '119', NULL, '22', '600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1147, '130', NULL, '23', '360');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1148, '99', NULL, '15', '360');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1149, '131', NULL, '23', '240');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1151, '95', NULL, '15', '390');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1152, '86', NULL, '14', '390');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1153, '124', NULL, '23', '500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1154, '107', NULL, '19', '460');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1155, '748', NULL, '19', '530');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1156, '756', NULL, '19', '700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1157, '104', NULL, '18', '300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1158, '496', NULL, '14', '38');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1159, '105', NULL, '19', '510');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1163, '94', NULL, '15', '585');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1164, '85', NULL, '14', '660');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1166, '116', NULL, '22', '550');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1167, '109', NULL, '19', '600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1168, '129', NULL, '23', '275');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1169, '132', NULL, '23', '240');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1170, '118', NULL, '22', '300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1171, '133', NULL, '23', '240');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1172, '493', NULL, '14', '1800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1173, '121', NULL, '22', '300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1174, '134', NULL, '23', '160');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1175, '88 ', NULL, '14', '1320');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1176, '495', NULL, '14', '650');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1177, '108', NULL, '19', '300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1178, '749', NULL, '19', '490');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1179, '89', NULL, '14', '280');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1180, '750', NULL, '19', '530');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1181, '494', NULL, '14', '290');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1182, '127', NULL, '23', '400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1183, '128', NULL, '23', '400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1184, '755', NULL, '19', '596');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1185, '754', NULL, '19', '567');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1186, '126', NULL, '23', '460');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1187, '100', NULL, '16', '300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1188, '102', NULL, '18', '450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1190, '106', NULL, '19', '380');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1191, '92', NULL, '14', '260');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1192, '110', NULL, '19', '1296');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1193, '96', NULL, '15', '260');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1194, '125', NULL, '23', '375');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1195, '101', NULL, '16', '550');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1196, '243', NULL, '29', '430');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1206, '248', NULL, '29', '320');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1208, '238', NULL, '29', '320');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1210, '242', NULL, '29', '490');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1222, '234', NULL, '29', '920');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1223, '235', NULL, '29', '1100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1224, '701', NULL, '29', '1080');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1240, '296', NULL, '31', '3351');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1241, '297', NULL, '31', '15761');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1242, '738', NULL, '31', '3610');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1243, '295', NULL, '31', '3936');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1244, '293', NULL, '31', '4391');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1245, '326', NULL, '31', '4092');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1246, '324', NULL, '31', '4092');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1247, '315', NULL, '31', '2961');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1248, '299', NULL, '31', '4092');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1249, '323', NULL, '31', '4092');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1250, '325', NULL, '31', '4092');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1251, '336', NULL, '31', '2376');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1252, '335', NULL, '31', '2376');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1253, '352', NULL, '31', '2800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1254, '353', NULL, '31', '2800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1255, '351', NULL, '31', '2800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1256, '294', NULL, '31', '7121');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1257, '602', NULL, '31', '1500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1258, '332', NULL, '31', '11671');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1259, '331', NULL, '31', '11671');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1260, '334', NULL, '31', '16689');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1261, '333', NULL, '31', '16689');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1262, '317', NULL, '31', '6146');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1263, '327', NULL, '31', '8707');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1264, '330', NULL, '31', '8707');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1265, '329', NULL, '31', '8707');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1266, '300', NULL, '31', '8707');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1267, '328', NULL, '31', '8707');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1268, '338', NULL, '31', '4911');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1269, '337', NULL, '31', '4911');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1270, '355', NULL, '31', '5800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1271, '356', NULL, '31', '5800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1272, '354', NULL, '31', '5800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1273, '339', NULL, '31', '7381');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1274, '340', NULL, '31', '7381');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1275, '358', NULL, '31', '8800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1276, '357', NULL, '31', '8800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1278, '301', NULL, '31', '11671');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1280, '292', NULL, '31', '14986');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1281, '341', NULL, '31', '10891');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1282, '322', NULL, '31', '14986');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1283, '360', NULL, '31', '14400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1284, '359', NULL, '31', '14400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1285, '298', NULL, '31', '10761');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1286, '347', NULL, '31', '6000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1287, '307', NULL, '31', '6000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1288, '346', NULL, '31', '4600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1289, '384', NULL, '31', '4600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1290, '306', NULL, '31', '4600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1291, '362', NULL, '31', '3800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1292, '361', NULL, '31', '3800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1293, '345', NULL, '31', '2900');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1294, '305', NULL, '31', '2900');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1295, '310', NULL, '31', '8700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1296, '350', NULL, '31', '8700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1297, '344', NULL, '31', '2000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1298, '304', NULL, '31', '2000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1299, '309', NULL, '31', '6000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1300, '349', NULL, '31', '6000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1301, '343', NULL, '31', '1500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1302, '303', NULL, '31', '1500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1303, '727', NULL, '31', '4800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1304, '726', NULL, '31', '4800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1305, '308', NULL, '31', '2700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1306, '348', NULL, '31', '2700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1307, '363', NULL, '31', '320');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1308, '367', NULL, '31', '30');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1309, '368', NULL, '31', '120');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1310, '365', NULL, '31', '70');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1311, '366', NULL, '31', '46');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1312, '364', NULL, '31', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1314, '603', NULL, '31', '250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1315, '420', NULL, '24', '3936');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1316, '162', NULL, '24', '3351');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1317, '161', NULL, '24', '4391');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1318, '136', NULL, '24', '2961');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1320, '148', NULL, '24', '14986');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1321, '147', NULL, '24', '14986');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1327, '144', NULL, '24', '6146');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1329, '141', NULL, '24', '6146');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1350, '42', NULL, '9', '170');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1351, '47', NULL, '9', '320');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1352, '52', NULL, '9', '450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1353, '48', NULL, '9', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1354, '46', NULL, '9', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1355, '49', NULL, '9', '160');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1356, '50', NULL, '9', '120');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1357, '51', NULL, '9', '250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1358, '41', NULL, '9', '45');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1359, '43', NULL, '9', '220');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1360, '45', NULL, '9', '180');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1361, '833', NULL, '32', '25');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1362, '842', NULL, '32', '25');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1363, '372', NULL, '32', '40');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1364, '834', NULL, '32', '75');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1365, '370', NULL, '32', '22');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1366, '838', NULL, '32', '18');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1367, '373', NULL, '32', '17');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1368, '837', NULL, '32', '70');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1370, '371', NULL, '32', '34');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1371, '369', NULL, '32', '84');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1372, '860', NULL, '32', '170');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1373, '836', NULL, '32', '30');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1374, '381', NULL, '32', '34');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1375, '380', NULL, '32', '25');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1376, '382', NULL, '32', '46');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1377, '835', NULL, '32', '50');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1378, '383', NULL, '32', '30');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1379, '374', NULL, '32', '40');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1380, '379', NULL, '32', '25');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1384, '843', NULL, '32', '13');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1386, '378', NULL, '32', '20');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1387, '376', NULL, '32', '1500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1388, '377', NULL, '32', '30');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1389, '31', NULL, '8', '145');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1390, '37', NULL, '8', '10');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1391, '38', NULL, '8', '20');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1393, '35', NULL, '8', '85');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1394, '36', NULL, '8', '210');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1395, '40', NULL, '8', '15');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1396, '39', NULL, '8', '20');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1397, '33', NULL, '8', '60');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1398, '34', NULL, '8', '350');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1400, '773', NULL, '4', '80');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1401, '794', NULL, '4', '140');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1402, '21', NULL, '4', '130');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1403, '20', NULL, '4', '115');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1404, '16', NULL, '4', '110');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1405, '18', NULL, '4', '75');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1406, '19', NULL, '4', '70');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1408, '15', NULL, '4', '135');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1409, '604', NULL, '4', '175');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1410, '205', NULL, '27', '900');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1411, '206', NULL, '27', '1200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1412, '208', NULL, '27', '1500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1413, '203', NULL, '27', '1100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1414, '207', NULL, '27', '1300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1415, '202', NULL, '27', '900');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1416, '758', NULL, '42', '1100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1417, '200', NULL, '27', '900');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1418, '209', NULL, '27', '1700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1419, '204', NULL, '27', '1300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1420, '759', NULL, '42', '1000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1421, '201', NULL, '27', '800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1425, '181', NULL, '25', '165');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1426, '182', NULL, '25', '90');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1427, '172', NULL, '25', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1428, '173', NULL, '25', '210');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1429, '171', NULL, '25', '300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1430, '732', NULL, '25', '350');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1431, '183', NULL, '25', '135');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1432, '184', NULL, '25', '120');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1433, '179', NULL, '25', '36');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1434, '180', NULL, '25', '27');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1435, '177', NULL, '25', '165');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1436, '175', NULL, '25', '125');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1437, '176', NULL, '25', '65');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1438, '174', NULL, '25', '300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1439, '178', NULL, '25', '80');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1440, '167', NULL, '25', '240');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1441, '163', NULL, '25', '580');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1442, '166', NULL, '25', '330');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1443, '170', NULL, '25', '450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1444, '165', NULL, '25', '380');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1445, '169', NULL, '25', '700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1446, '164', NULL, '25', '500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1447, '168', NULL, '25', '800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1448, '219', NULL, '28', '380');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1449, '596', NULL, '28', '336');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1450, '733', NULL, '28', '80');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1451, '594', NULL, '28', '290');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1452, '233', NULL, '28', '88');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1453, '229', NULL, '28', '5000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1454, '228', NULL, '28', '3500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1455, '593', NULL, '28', '450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1456, '216', NULL, '28', '1600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1457, '230', NULL, '28', '4600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1458, '592', NULL, '28', '482');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1459, '214', NULL, '28', '480');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1460, '597', NULL, '28', '250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1461, '731', NULL, '28', '10');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1463, '231', NULL, '28', '550');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1464, '734', NULL, '28', '120');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1465, '735', NULL, '28', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1466, '736', NULL, '28', '250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1467, '215', NULL, '28', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1468, '225', NULL, '28', '480');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1469, '226', NULL, '28', '1600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1470, '223', NULL, '28', '1250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1471, '224', NULL, '28', '550');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1472, '788', NULL, '28', '1050');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1473, '598 ', NULL, '28', '130');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1474, '221', NULL, '28', '500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1475, '213', NULL, '28', '170');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1476, '217', NULL, '28', '180');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1477, '232', NULL, '28', '750');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1478, '595', NULL, '28', '323');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1479, '218', NULL, '28', '170');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1480, '600', NULL, '28', '42');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1481, '599', NULL, '28', '120');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1482, '831', NULL, '28', '950');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1483, '222', NULL, '28', '230');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1484, '220', NULL, '28', '180');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1485, '809', NULL, '28', '10');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1486, '601', NULL, '28', '230');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1487, '227', NULL, '28', '100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1488, '786', NULL, '28', '250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1489, '783', NULL, '28', '110');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1490, '784', NULL, '28', '135');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1491, '785', NULL, '28', '175');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1492, '6', NULL, '2', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1493, '490', NULL, '2', '90');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1494, '7', NULL, '2', '320');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1495, '4', NULL, '2', '290');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1496, '5', NULL, '2', '450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1497, '491', NULL, '2', '190');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1498, '800', NULL, '26', '5500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1499, '196', NULL, '26', '380');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1500, '197', NULL, '26', '1500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1501, '832 ', NULL, '26', '3200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1502, '793', NULL, '26', '3350');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1504, '195', NULL, '26', '1300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1507, '194', NULL, '26', '1500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1510, '193', NULL, '26', '1700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1511, '199', NULL, '26', '1900');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1512, '198', NULL, '26', '2100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1514, '192', NULL, '26', '1100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1515, '191', NULL, '26', '1700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1521, '12', NULL, '3', '135');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1524, '742', NULL, '3', '110');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1528, '266', NULL, '30', '220');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1529, '267', NULL, '30', '360');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1530, '866', NULL, '30', '120');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1531, '264', NULL, '30', '80');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1532, '288', NULL, '30', '70');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1533, '265', NULL, '30', '120');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1534, '269', NULL, '30', '110');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1535, '281', NULL, '30', '25');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1536, '282', NULL, '30', '32');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1537, '422', NULL, '30', '30');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1538, '421', NULL, '30', '36');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1539, '273', NULL, '30', '800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1540, '272', NULL, '30', '220');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1541, '488', NULL, '30', '200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1542, '489', NULL, '30', '125');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1543, '283', NULL, '30', '30');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1544, '284', NULL, '30', '40');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1545, '737', NULL, '30', '50');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1546, '259', NULL, '30', '1200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1547, '260', NULL, '30', '850');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1548, '261', NULL, '30', '600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1549, '262', NULL, '30', '450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1550, '263', NULL, '30', '350');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1551, '268', NULL, '30', '2100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1552, '278', NULL, '30', '180');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1553, '275', NULL, '30', '100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1554, '279', NULL, '30', '260');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1555, '276', NULL, '30', '180');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1556, '280', NULL, '30', '360');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1557, '277', NULL, '30', '240');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1558, '274', NULL, '30', '360');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1559, '285', NULL, '30', '240');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1560, '286', NULL, '30', '180');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1561, '287', NULL, '30', '280');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1562, '728', NULL, '30', '260');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1563, '270', NULL, '30', '160');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1564, '271', NULL, '30', '120');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1565, '57', NULL, '10', '140');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1566, '62', NULL, '10', '1500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1567, '61', NULL, '10', '160');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1568, '60', NULL, '10', '200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1569, '810', NULL, '10', '103');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1570, '55', NULL, '10', '280');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1571, '54', NULL, '10', '255');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1572, '59', NULL, '10', '165');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1573, '53', NULL, '10', '480');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1574, '56', NULL, '10', '1000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1575, '812', NULL, '10', '90');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1576, '814', NULL, '10', '135');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1577, '815', NULL, '10', '135');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1578, '811', NULL, '10', '103');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1579, '739', NULL, '10', '400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1580, '801 ', NULL, '10', '350');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1581, '58', NULL, '10', '115');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1582, '825', NULL, '10', '115');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1583, '720', NULL, '10', '80');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1584, '813', NULL, '10', '79');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1585, '241', NULL, '29', '160');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1586, '699', NULL, '29', '320');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1587, '240', NULL, '29', '260');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1588, '239', NULL, '29', '360');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1589, '236', NULL, '29', '920');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1590, '693', NULL, '29', '130');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1591, '237', NULL, '29', '530');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1592, '808', NULL, '29', '260');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1593, '707', NULL, '29', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1594, '807', NULL, '29', '580');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1595, '694', NULL, '29', '130');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1596, '803', NULL, '29', '550');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1597, '805', NULL, '29', '830');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1598, '704 ', NULL, '29', '550');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1599, '802', NULL, '29', '280');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1601, '695', NULL, '29', '280');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1602, '700', NULL, '29', '160');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1603, '246', NULL, '29', '4000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1604, '249', NULL, '29', '1600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1605, '806', NULL, '29', '700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1606, '247', NULL, '29', '650');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1607, '708', NULL, '29', '2550');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1608, '250', NULL, '29', '250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1609, '698', NULL, '29', '290');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1610, '256', NULL, '29', '800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1611, '690', NULL, '29', '830');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1612, '762', NULL, '49', '340');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1614, '423', NULL, '49', '4100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1615, '462', NULL, '49', '8650');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1616, '455', NULL, '49', '230');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1617, '822', NULL, '49', '120');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1618, '454', NULL, '49', '370');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1619, '859', NULL, '49', '14200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1620, '460', NULL, '49', '1000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1621, '633', NULL, '49', '2200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1622, '425', NULL, '49', '1600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1623, '463', NULL, '49', '420');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1624, '428', NULL, '49', '5500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1625, '432', NULL, '49', '4000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1626, '847', NULL, '49', '900');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1627, '772', NULL, '49', '30');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1628, '431', NULL, '49', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1629, '617', NULL, '49', '600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1630, '636', NULL, '49', '300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1631, '761', NULL, '49', '320');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1632, '435', NULL, '49', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1633, '459', NULL, '49', '1100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1634, '816', NULL, '49', '5300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1635, '817', NULL, '49', '6300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1636, '623', NULL, '49', '26');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1637, '484', NULL, '49', '275');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1639, '461', NULL, '49', '1500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1640, '607', NULL, '49', '285');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1641, '437', NULL, '49', '200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1642, '426', NULL, '49', '8000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1643, '427', NULL, '49', '1200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1644, '741', NULL, '49', '780');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1645, '453', NULL, '49', '250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1646, '619', NULL, '49', '100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1647, '637', NULL, '49', '2000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1648, '767', NULL, '49', '2500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1649, '480 ', NULL, '49', '500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1650, '606', NULL, '49', '500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1651, '438', NULL, '49', '300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1652, '630', NULL, '49', '1250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1653, '574', NULL, '49', '14500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1654, '475', NULL, '49', '24');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1655, '790', NULL, '49', '90');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1656, '864', NULL, '49', '220');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1657, '865', NULL, '49', '280');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1658, '429', NULL, '49', '2000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1659, '466', NULL, '49', '350');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1660, '634', NULL, '49', '8240');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1661, '844', NULL, '49', '1250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1662, '628', NULL, '49', '900');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1663, '436', NULL, '49', '1500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1664, '456', NULL, '49', '410');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1665, '622', NULL, '49', '10');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1666, '465', NULL, '49', '1100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1667, '620', NULL, '49', '5');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1668, '615', NULL, '49', '4800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1669, '611', NULL, '49', '300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1670, '609', NULL, '49', '800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1671, '610', NULL, '49', '1025');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1672, '612', NULL, '49', '300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1673, '614', NULL, '49', '200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1674, '613', NULL, '49', '1450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1675, '444', NULL, '49', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1676, '766', NULL, '49', '2700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1677, '618', NULL, '49', '300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1678, '483', NULL, '49', '100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1679, '433', NULL, '49', '1050');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1680, '467', NULL, '49', '335');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1681, '473', NULL, '49', '350');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1682, '635', NULL, '49', '120');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1683, '464', NULL, '49', '500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1684, '764', NULL, '49', '3200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1685, '765', NULL, '49', '450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1686, '469', NULL, '49', '1050');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1687, '826', NULL, '49', '10000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1688, '818', NULL, '49', '484');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1689, '424', NULL, '49', '900');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1690, '439', NULL, '49', '250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1691, '627', NULL, '49', '900');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1692, '845', NULL, '49', '850');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1693, '791', NULL, '49', '1000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1694, '445', NULL, '49', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1695, '481', NULL, '49', '41');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1696, '625', NULL, '49', '41');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1697, '846', NULL, '49', '50');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1698, '468', NULL, '49', '225');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1699, '763', NULL, '49', '1050');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1700, '624', NULL, '49', '3700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1701, '472 ', NULL, '49', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1702, '476', NULL, '49', '90');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1703, '608', NULL, '49', '418');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1704, '760', NULL, '49', '350');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1705, '629', NULL, '49', '700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1706, '447', NULL, '49', '850');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1707, '740', NULL, '49', '13000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1708, '482', NULL, '49', '1250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1709, '774', NULL, '49', '460');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1710, '457', NULL, '49', '450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1711, '458', NULL, '49', '60');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1712, '471 ', NULL, '49', '1180');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1713, '621', NULL, '49', '4800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1714, '440', NULL, '49', '450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1715, '632', NULL, '49', '1480');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1716, '446', NULL, '49', '1450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1717, '443', NULL, '49', '300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1718, '789', NULL, '49', '1300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1719, '631', NULL, '49', '1800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1720, '434', NULL, '49', '6500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1721, '430', NULL, '49', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1722, '470 ', NULL, '49', '60');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1723, '474', NULL, '49', '100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1724, '725', NULL, '49', '180');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1725, '723', NULL, '49', '200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1726, '724', NULL, '49', '240');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1728, '775', NULL, '49', '30');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1729, '561', NULL, '45', '2150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1730, '746', NULL, '45', '200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1731, '547', NULL, '45', '3100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1732, '548', NULL, '45', '3500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1733, '529', NULL, '45', '850');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1734, '549', NULL, '45', '1700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1735, '536', NULL, '45', '180');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1736, '585', NULL, '45', '2200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1737, '551', NULL, '45', '140');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1738, '520', NULL, '45', '120');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1739, '544', NULL, '45', '450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1740, '518', NULL, '45', '600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1741, '531 ', NULL, '45', '700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1742, '519', NULL, '45', '900');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1744, '743', NULL, '45', '9000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1745, '744', NULL, '45', '1200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1746, '542', NULL, '45', '3500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1747, '562', NULL, '45', '700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1748, '511', NULL, '45', '8700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1749, '512', NULL, '45', '80');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1750, '537', NULL, '45', '160');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1751, '557', NULL, '45', '230');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1752, '552', NULL, '45', '1800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1753, '521', NULL, '45', '120');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1754, '522', NULL, '45', '50');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1755, '523', NULL, '45', '10');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1756, '586', NULL, '45', '120');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1757, '528', NULL, '45', '550');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1758, '527', NULL, '45', '660');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1759, '643', NULL, '45', '1450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1760, '642', NULL, '45', '6200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1761, '590', NULL, '45', '1250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1762, '560', NULL, '45', '310');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1763, '508', NULL, '45', '300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1764, '648', NULL, '45', '300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1765, '524', NULL, '45', '700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1766, '525', NULL, '45', '1150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1767, '526', NULL, '45', '1445');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1768, '745', NULL, '45', '1150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1769, '535', NULL, '45', '130');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1770, '509', NULL, '45', '4600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1771, '554', NULL, '45', '500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1772, '644', NULL, '45', '500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1773, '640', NULL, '45', '260');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1774, '638', NULL, '45', '4150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1775, '639', NULL, '45', '160');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1776, '641', NULL, '45', '305');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1777, '545', NULL, '45', '250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1778, '646', NULL, '45', '145');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1779, '556', NULL, '45', '3100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1780, '645', NULL, '45', '350');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1781, '558', NULL, '45', '800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1782, '540', NULL, '45', '15');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1783, '510', NULL, '45', '33');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1784, '541 ', NULL, '45', '650');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1785, '559', NULL, '45', '50');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1786, '514', NULL, '45', '50');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1787, '515', NULL, '45', '175');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1788, '533', NULL, '45', '480');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1789, '563', NULL, '45', '380');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1790, '532', NULL, '45', '1600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1791, '589', NULL, '45', '1650');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1792, '543', NULL, '45', '30');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1794, '516', NULL, '45', '30');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1795, '517', NULL, '45', '12');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1796, '538', NULL, '45', '160');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1797, '530', NULL, '45', '850');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1798, '553', NULL, '45', '850');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1799, '546', NULL, '45', '35');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1800, '587', NULL, '45', '250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1801, '647', NULL, '45', '270');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1802, '513', NULL, '45', '140');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1803, '588', NULL, '45', '240');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1804, '539', NULL, '45', '90');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1805, '792', NULL, '45', '3100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1806, '555', NULL, '45', '1500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1807, '550', NULL, '45', '200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1808, '591 ', NULL, '45', '350');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1809, '534', NULL, '45', '130');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1810, '747', NULL, '45', '130');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1811, '91', NULL, '14', '45');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1821, '829', NULL, '33', '280');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1822, '673', NULL, '33', '580');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1823, '679', NULL, '33', '259');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1824, '390', NULL, '33', '560');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1825, '408', NULL, '33', '100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1826, '404', NULL, '33', '125');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1827, '683', NULL, '33', '330');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1828, '820', NULL, '33', '400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1829, '407', NULL, '33', '330');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1830, '678', NULL, '33', '286');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1831, '399', NULL, '33', '287');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1832, '405', NULL, '33', '850');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1833, '409', NULL, '33', '820');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1834, '689', NULL, '33', '286');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1835, '782', NULL, '33', '451');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1836, '401', NULL, '33', '475');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1837, '677', NULL, '33', '475');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1838, '776', NULL, '33', '486');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1839, '387', NULL, '33', '486');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1840, '398', NULL, '33', '486');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1841, '682', NULL, '33', '250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1842, '672', NULL, '33', '100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1843, '686', NULL, '33', '250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1844, '687', NULL, '33', '230');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1845, '684', NULL, '33', '360');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1846, '685', NULL, '33', '360');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1847, '385', NULL, '33', '2750');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1848, '393', NULL, '33', '560');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1849, '391', NULL, '33', '270');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1850, '674', NULL, '33', '780');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1851, '680', NULL, '33', '336');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1852, '396', NULL, '33', '40');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1853, '395', NULL, '33', '50');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1854, '403', NULL, '33', '450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1855, '681', NULL, '33', '310');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1856, '397', NULL, '33', '50');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1857, '675', NULL, '33', '50');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1858, '394', NULL, '33', '300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1859, '400', NULL, '33', '226');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1860, '406', NULL, '33', '336');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1861, '389', NULL, '33', '336');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1862, '402', NULL, '33', '250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1863, '386', NULL, '33', '300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1864, '392', NULL, '33', '280');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1867, '410', NULL, '11', '1650');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1868, '64', NULL, '11', '4900');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1869, '63', NULL, '11', '4900');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1870, '72', NULL, '11', '2250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1871, '71', NULL, '11', '2250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1872, '73', NULL, '11', '2250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1873, '768', NULL, '11', '2500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1874, '68', NULL, '11', '2600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1875, '67', NULL, '11', '2600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1876, '66', NULL, '11', '10300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1877, '65', NULL, '11', '10300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1878, '411', NULL, '11', '3300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1879, '418', NULL, '11', '4300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1880, '417', NULL, '11', '4300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1881, '70', NULL, '11', '5200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1882, '69', NULL, '11', '5200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1883, '75', NULL, '11', '6500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1884, '74', NULL, '11', '6500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1885, '77', NULL, '11', '9100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1886, '76', NULL, '11', '9100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1887, '416', NULL, '11', '5000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1889, '414', NULL, '11', '6900');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1890, '413', NULL, '11', '7750');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1891, '412', NULL, '11', '8800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1892, '770', NULL, '11', '220');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1893, '769 ', NULL, '11', '173');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1894, '830', NULL, '40', '90');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1895, '711', NULL, '40', '62');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1896, '819', NULL, '40', '2200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1897, '500', NULL, '40', '650');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1898, '499', NULL, '40', '152');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1899, '710', NULL, '40', '30');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1901, '497', NULL, '40', '160');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1903, '498', NULL, '40', '250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1904, '451', NULL, '40', '70');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1905, '449', NULL, '40', '90');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1906, '450', NULL, '40', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1907, '452 ', NULL, '40', '292');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1908, '501', NULL, '40', '240');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1909, '824', NULL, '50', '4000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1910, '823', NULL, '50', '1000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1911, '580', NULL, '50', '5500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1912, '581', NULL, '50', '1000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1913, '582', NULL, '50', '1500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1914, '577', NULL, '50', '1250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1915, '583', NULL, '50', '2300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1916, '578', NULL, '50', '2000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1917, '584', NULL, '50', '2600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1918, '579', NULL, '50', '2200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1919, '780', NULL, '52', '98');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1920, '779', NULL, '52', '200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1921, '778', NULL, '52', '10');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1922, '781', NULL, '52', '1100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1923, '777', NULL, '52', '50');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1924, '83', NULL, '13', '450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1925, '98', NULL, '15', '850');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1926, '855', NULL, '53', '285');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1927, '861', NULL, '53', '450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1928, '856', NULL, '53', '480');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1929, '852', NULL, '53', '350');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1930, '851', NULL, '53', '250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1931, '857', NULL, '53', '120');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1932, '848', NULL, '53', '100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1933, '849', NULL, '53', '10');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1934, '853', NULL, '53', '30');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1935, '854', NULL, '53', '290');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1936, '863', NULL, '53', '347');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1937, '862', NULL, '53', '155');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1938, '858', NULL, '53', '115');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1939, '850', NULL, '53', '750');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1940, '721', NULL, '48', '6250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1941, '575', NULL, '48', '3500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1942, '570', NULL, '46', '600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1943, '572', NULL, '39', '250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1944, '573', NULL, '39', '100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1946, '507', NULL, '43', '3');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1947, '506', NULL, '43', '1320');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1948, '504', NULL, '43', '60');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1949, '502', NULL, '43', '10000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1950, '503', NULL, '43', '12000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1951, '712', NULL, '51', '320');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1952, '713', NULL, '51', '310');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1953, '714', NULL, '51', '325');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1954, '821', NULL, '34', '6500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1955, '771', NULL, '34', '146');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1956, '729', NULL, '34', '100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1958, '576', NULL, '34', '15500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1961, '117', NULL, '22', '300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1962, '120', NULL, '22', '700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1963, '1', NULL, '1', '370');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1964, '3 ', NULL, '1', '300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1965, '2', NULL, '1', '190');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1967, '568', NULL, '47', '200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1968, '569', NULL, '47', '200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1969, '566', NULL, '47', '2500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1970, '567', NULL, '47', '1250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1971, '565', NULL, '47', '2500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1972, '564', NULL, '47', '290');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1973, '97', NULL, '15', '800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1974, '828', NULL, '37', '155');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1975, '827', NULL, '37', '115');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1976, '571', NULL, '44', '39500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1977, '84', NULL, '13', '450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1978, '751', NULL, '19', '245');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1979, '752', NULL, '19', '88');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1980, '753', NULL, '19', '100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1983, '882', '', '53', '271');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1984, '883', '', '53', '460');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1985, '884', '', '53', '452');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1986, '885', '', '53', '431');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1987, '886', '', '53', '277');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1988, '887', '', '53', '297');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1990, '889', '', '53', '231');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1991, '890', '', '53', '222');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1992, '891', '', '53', '253');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1993, '888', NULL, '53', '322');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1994, '892', '', '34', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1995, '893', '', '55', '220');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1996, '894', '', '55', '1400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1997, '895', '', '55', '45');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1998, '896', '', '34', '4667');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (1999, '897', '', '34', '10033');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2000, '898', '', '32', '5');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2001, '722', NULL, '8', '264');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2002, '899', '', '29', '73');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2003, '900', '', '29', '1350');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2004, '901', '', '40', '450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2005, '902', '', '40', '380');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2006, '903', '', '32', '40');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2007, '904', '', '32', '3');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2008, '905', '', '32', '4');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2009, '906', '', '32', '5');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2010, '907', '', '32', '6');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2011, '908', '', '32', '7');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2012, '909', '', '32', '8');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2013, '910', '', '53', '180');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2014, '911', '', '53', '240');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2015, '912', '', '53', '70');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2016, '913', '', '53', '80');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2017, '914', '', '53', '90');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2018, '915', '', '53', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2019, '916', '', '53', '100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2020, '917', '', '53', '40');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2021, '918', '', '53', '155');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2022, '919', '', '53', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2023, '920', '', '32', '20');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2024, '921', '', '30', '50');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2025, '922', '', '30', '40');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2026, '212', NULL, '27', '105');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2027, '211', NULL, '27', '100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2029, '210', NULL, '27', '70');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2030, '923', '', '56', '230');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2031, '924', '', '56', '480');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2032, '925', '', '56', '800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2033, '926', '', '56', '320');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2034, '927', '', '56', '320');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2035, '928', '', '56', '35');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2036, '929', '', '56', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2037, '930', '', '56', '260');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2038, '931', '', '56', '260');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2039, '932', '', '56', '1200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2040, '933', '', '56', '1450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2041, '934', '', '56', '1800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2042, '935', '', '56', '35');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2043, '936', '', '56', '30');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2044, '937', '', '56', '25');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2045, '938', '', '56', '300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2046, '939', '', '56', '480');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2047, '940', '', '56', '460');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2048, '941', '', '56', '50');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2049, '942', '', '56', '45');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2050, '943', '', '56', '280');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2051, '944', '', '56', '550');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2052, '945', '', '56', '70');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2053, '946', '', '56', '2500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2054, '947', '', '56', '750');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2055, '948', '', '56', '2350');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2056, '949', '', '56', '450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2057, '950', '', '56', '70');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2058, '951', '', '56', '50');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2059, '952', '', '56', '530');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2060, '953', '', '56', '90');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2061, '954', '', '56', '80');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2067, '958', '', '56', '10');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2068, '955', NULL, '56', '20');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2070, '957', NULL, '56', '15');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2071, '959', '', '11', '1550');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2072, '960', '', '11', '3100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2073, '961', '', '11', '2050');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2074, '962', '', '11', '4100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2075, '963', '', '11', '2500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2076, '964', '', '11', '5000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2077, '342', NULL, '31', '10891');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2078, '650', NULL, '24', '2961');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2079, '652', NULL, '24', '2961');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2080, '654', NULL, '24', '2961');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2081, '649', NULL, '24', '2961');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2082, '651', NULL, '24', '2961');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2083, '671', NULL, '24', '2961');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2084, '653', NULL, '24', '2961');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2085, '419', NULL, '24', '7121');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2086, '658', NULL, '24', '29741');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2087, '657', NULL, '24', '21096');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2088, '656', NULL, '24', '21096');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2089, '660', NULL, '24', '1044');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2090, '659', NULL, '24', '1044');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2091, '662', NULL, '24', '1557');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2092, '661', NULL, '24', '1557');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2093, '663', NULL, '24', '2292');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2094, '664', NULL, '24', '2292');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2097, '965', '', '26', '1700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2104, '969', NULL, '26', '2100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2106, '968', NULL, '26', '1550');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2107, '967', NULL, '26', '3500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2109, '966', NULL, '26', '3000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2110, '970', NULL, '26', '3200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2111, '972', '', '49', '10000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2112, '973', '', '49', '300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2113, '974', '', '49', '2800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2114, '975', '', '49', '540');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2117, '978', '', '49', '4400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2120, '981', '', '49', '550');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2121, '982', '', '49', '60');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2122, '983', '', '49', '1800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2123, '980', NULL, '49', '980');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2124, '979', NULL, '49', '550');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2125, '984', '', '49', '250');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2126, '985', '', '49', '110');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2127, '986', '', '53', '900');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2128, '987', '', '53', '1200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2129, '988', '', '53', '350');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2131, '989', NULL, '53', '60');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2132, '990', '', '53', '1600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2133, '991', '', '53', '1400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2134, '992', '', '49', '25200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2135, '993', '', '34', '9200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2136, '994', '', '37', '165');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2137, '995', '', '37', '106');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2138, '996', '', '45', '30');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2139, '997', '', '29', '725');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2141, '999', '', '29', '3600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2142, '1000', '', '29', '140');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2144, '1002', '', '56', '5500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2145, '1003', '', '56', '5000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2146, '977', NULL, '49', '400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2147, '1004', '', '42', '1600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2148, '1005', '', '42', '1800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2149, '1006', '', '42', '2200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2150, '1007', '', '42', '415');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2151, '1008', '', '42', '520');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2154, '1011', '', '32', '11');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2155, '1012', '', '32', '5');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2157, '1013', NULL, '32', '16');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2158, '787', NULL, '28', '25');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2164, '1014', '', '32', '160');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2180, '1021', NULL, '43', '180');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2182, '1023', '', '10', '650');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2183, '1022', NULL, '10', '780');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2184, '1024', '', '10', '280');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2185, '1025', '', '10', '5800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2186, '1026', '', '57', '30');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2187, '442', NULL, '32', '120');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2188, '1027', '', '32', '65');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2189, '                           ', '', '54', '0');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2190, '880', NULL, '54', '220');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2191, '881', NULL, '54', '280');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2192, '1117', NULL, '43', '17');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2193, '1020', NULL, '43', '220');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2194, '505', NULL, '43', '11000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2195, '1015', NULL, '43', '20');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2196, '1016', NULL, '43', '30');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2197, '2021', NULL, '43', '700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2198, '1017', NULL, '43', '45');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2199, '1018', NULL, '43', '65');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2200, '1019', NULL, '43', '95');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2201, '956', NULL, '56', '10');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2202, '26', NULL, '7', '15');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2203, '23', NULL, '7', '125');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2204, '29', NULL, '7', '40');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2205, '27', NULL, '7', '33');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2206, '25', NULL, '7', '1800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2207, '22', NULL, '7', '15');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2208, '30', NULL, '7', '160');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2209, '28', NULL, '7', '120');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2210, '24', NULL, '7', '65');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2211, '1028', '', '58', '1300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2212, '1029', '', '58', '900');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2213, '1030', '', '58', '275');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2214, '1031', '', '58', '4200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2215, '1032', '', '53', '1400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2216, '1033', '', '53', '2400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2217, '1034', '', '53', '155');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2218, '998', NULL, '29', '1100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2219, '1010', NULL, '42', '440');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2220, '1009', NULL, '42', '340');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2221, '976', NULL, '49', '500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2222, '1035', '', '32', '6');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2225, '1036', '', '58', '2800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2226, '1037', '', '32', '9');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2227, '1038', '', '32', '10');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2228, '1039', '', '32', '12');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2229, '1040', '', '32', '18');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2230, '1041', '', '32', '25');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2233, '448', NULL, '40', '120');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2234, '375', NULL, '32', '15');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2235, '1043', '', '32', '20');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2236, '1044', '', '32', '25');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2237, '1045', '', '32', '30');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2238, '1046', '', '32', '50');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2239, '1042', NULL, '34', '13770');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2240, '709', NULL, '29', '500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2241, '1047', '', '32', '24');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2242, '1048', '', '49', '25000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2243, '1049', '', '58', '750');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2245, '1050', NULL, '28', '550');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2246, '1051', '', '45', '1800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2247, '1052', '', '45', '4200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2248, '1053', '', '53', '130');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2249, '1054', '', '53', '1600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2250, '1055', '', '53', '700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2251, '1056', '', '53', '450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2252, '1057', '', '58', '2100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2253, '1058', '', '58', '200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2254, '1059', '', '58', '275');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2255, '1060', '', '52', '38');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2256, '1061', '', '52', '50');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2257, '1062', '', '52', '471');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2258, '1063', '', '52', '320');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2259, '1064', '', '52', '350');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2260, '1065', '', '52', '100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2261, '1066', '', '29', '280');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2262, '1067', '', '29', '1075');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2263, '1068', '', '29', '770');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2264, '1069', '', '29', '600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2266, '1070', '', '49', '1500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2267, '1071', '', '49', '550');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2268, '1072', '', '49', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2269, '1073 ', '', '49', '2000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2272, '1074', NULL, '28', '850');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2273, '1075', NULL, '32', '8');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2274, '665', NULL, '24', '4172');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2275, '666', NULL, '24', '3172');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2276, '668', NULL, '24', '4125');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2277, '667', NULL, '24', '4125');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2278, '670', NULL, '24', '5060');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2279, '669', NULL, '24', '5060');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2282, '187', NULL, '11', '6500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2283, '189', NULL, '11', '3350');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2284, '415', NULL, '11', '5800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2285, '188', NULL, '11', '5600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2286, '185', NULL, '11', '8500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2287, '186', NULL, '11', '5500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2288, '14', NULL, '11', '165');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2289, '13', NULL, '59', '400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2290, '716', NULL, '59', '190');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2291, '717', NULL, '59', '270');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2292, '718', NULL, '59', '220');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2293, '715', NULL, '59', '120');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2294, '10', NULL, '59', '210');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2295, '11', NULL, '59', '105');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2296, '8', NULL, '59', '550');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2297, '9', NULL, '59', '430');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2298, '190', NULL, '26', '2500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2299, '971', NULL, '26', '3700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2301, '1076', '', '8', '192');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2302, '1077', '', '8', '98');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2303, '1078', '', '8', '78');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2304, '32', NULL, '8', '72');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2305, '1079', '', '36', '1100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2306, '1080', '', '36', '1400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2307, '1081', '', '36', '1700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2308, '1082', '', '36', '2000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2309, '1083', '', '36', '2100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2314, '1087', '', '55', '1350');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2315, '1088', '', '49', '480');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2316, '1089', '', '49', '2');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2317, '1090', '', '53', '800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2318, '1091', '', '53', '700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2319, '1092', '', '53', '500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2322, '1095', '', '23', '280');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2323, '1096', '', '23', '784');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2324, '1094', NULL, '23', '280');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2325, '1097', '', '55', '80');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2326, '1098', '', '55', '1450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2327, '1099', '', '49', '700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2328, '1100', '', '49', '2500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2329, '1111', '', '60', '650');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2330, '1112', '', '32', '66');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2331, '1113', '', '28', '165');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2332, '1114', '', '28', '300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2334, '1116', '', '28', '525');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2335, '1118', '', '28', '650');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2336, '160', NULL, '24', '5060');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2337, '149', NULL, '24', '1044');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2338, '150', NULL, '24', '1044');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2339, '152', NULL, '24', '1557');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2340, '151', NULL, '24', '1557');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2341, '154', NULL, '24', '2292');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2342, '153', NULL, '24', '2292');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2343, '156', NULL, '24', '3208');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2344, '155', NULL, '24', '3208');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2345, '158', NULL, '24', '4190');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2346, '157', NULL, '24', '4190');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2347, '159', NULL, '24', '5060');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2348, '479', NULL, '49', '1100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2349, '1119', '', '56', '16000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2350, '1120', '', '56', '5400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2351, '1121', '', '56', '26200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2352, '1122', '', '58', '3500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2353, '1123', '', '58', '7500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2355, '1125', '', '58', '1800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2357, '1124', NULL, '58', '88000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2358, '1126', NULL, '58', '450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2359, '1085', NULL, '49', '53500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2360, '1127', '', '49', '220');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2361, '1129', '', '58', '1950');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2362, '1130', '', '58', '1750');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2363, '1131', '', '40', '100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2364, '1132', '', '32', '20');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2365, '1133', '', '32', '30');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2366, '1134', '', '32', '45');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2367, '1135', '', '49', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2368, '1136', '', '52', '110');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2369, '1137', '', '32', '120');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2370, '1138', '', '32', '100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2371, '1139', '', '32', '40');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2372, '441', NULL, '49', '270');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2373, '1140', '', '32', '35');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2374, '1141', '', '52', '120');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2375, '1142', '', '53', '120');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2376, '1143', '', '53', '820');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2377, '1144', '', '53', '430');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2378, '1145', '', '53', '550');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2379, '1146', '', '53', '530');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2380, '1147', '', '53', '430');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2381, '1148', '', '53', '530');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2382, '1149', '', '49', '10000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2383, '1151', '', '29', '11500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2384, '1152', '', '29', '5000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2385, '1153', '', '29', '600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2386, '1154', '', '52', '110');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2387, '1155', '', '49', '450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2388, '1156', '', '49', '50');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2389, '1157', '', '45', '1800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2390, '1158', '', '32', '30');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2391, '1159', '', '58', '2400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2392, '1160', '', '50', '2400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2393, '1161', '', '32', '10');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2395, '840', NULL, '32', '20');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2396, '841', NULL, '32', '25');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2397, '839', NULL, '32', '14');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2398, '1162', '', '34', '17533');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2399, '1163', '', '32', '40');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2400, '1164', '', '32', '50');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2401, '1165', '', '32', '60');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2402, '1166', '', '32', '70');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2403, '1167', '', '32', '90');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2404, '1168', '', '32', '270');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2406, '1170', '', '58', '370');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2407, '1169', NULL, '58', '165000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2409, '1172', NULL, '51', '300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2410, '1173', '', '32', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2411, '1174', '', '40', '120');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2412, '1175', '', '32', '46');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2413, '1176', '', '53', '40');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2414, '1177', '', '32', '30');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2416, '1179', '', '19', '281');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2417, '1180', '', '19', '281');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2418, '1178', NULL, '19', '746');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2419, '1086', NULL, '49', '20813');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2420, '17', NULL, '4', '180');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2421, '1181', '', '49', '375');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2422, '1182', '', '49', '294');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2423, '1183', '', '49', '215');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2424, '1184', '', '49', '350');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2425, '1185', '', '49', '1150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2426, '1186', '', '49', '2000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2427, '1187', '', '56', '60');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2428, '1188', '', '56', '50');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2429, '1189', '', '56', '350');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2430, '1190', '', '56', '20');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2432, '1192', '', '56', '120');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2433, '1193', '', '56', '30');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2434, '1194', '', '56', '25150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2435, '1191', NULL, '56', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2436, '1195', '', '55', '2900');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2437, '1197', '', '55', '1071');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2438, '1198', '', '55', '1150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2439, '1199', '', '55', '200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2440, '1200', '', '55', '120');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2441, '1201', '', '55', '600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2442, '1202', '', '55', '6700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2443, '1203', '', '49', '3500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2444, '1204', '', '49', '1350');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2445, '1205', '', '49', '3600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2446, '1206', '', '61', '7400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2447, '1207', '', '48', '6500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2448, '1208', '', '48', '5400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2449, '1001', NULL, '56', '8500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2450, '1209', '', '56', '4800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2451, '1210', '', '49', '27');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2452, '1211', '', '49', '125');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2453, '1212', '', '62', '270');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2455, '1214', '', '62', '310');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2456, '1215', '', '62', '340');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2457, '1213', NULL, '62', '330');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2458, '1216', '', '31', '900');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2459, ' 1217', '', '31', '900');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2460, '1093', NULL, '34', '220');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2461, '1084', NULL, '34', '153');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2462, '1217', '', '59', '560');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2463, '1218', '', '47', '165');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2464, '1219', '', '49', '4400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2465, '1220', '', '28', '4000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2467, '1221', NULL, '49', '1000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2468, '1222', '', '55', '1350');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2469, '1223', '', '36', '3900');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2470, '1224', '', '49', '20');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2471, '1225', '', '49', '16');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2472, '1226', '', '49', '41000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2473, '1227', '', '32', '40');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2474, '1228', '', '32', '20');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2477, '302', NULL, '31', '16689');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2478, '1229', '', '45', '700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2480, '1231', '', '45', '750');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2481, '1232', '', '45', '400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2482, '1233', '', '45', '200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2483, '1234', '', '45', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2484, '1235', '', '45', '1550');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2485, '1230', NULL, '45', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2486, '1236', '', '45', '430');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2487, '1237', '', '45', '200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2488, '1238', '', '45', '500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2489, '1239', '', '45', '450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2490, '1240', '', '45', '90');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2491, '1241', '', '45', '60');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2492, '1242', '', '45', '220');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2493, '1243', '', '45', '50');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2494, '1244', '', '45', '50');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2495, '1245', '', '45', '70');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2496, '1246', '', '55', '185');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2497, '1247', '', '63', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2498, '1248', '', '56', '8000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2500, '1249', NULL, '56', '1850');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2501, '1250', '', '51', '302');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2502, '1251', '', '51', '500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2503, '1252', '', '30', '350');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2504, '1253', '', '63', '364');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2505, '1254', '', '63', '500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2506, '1255', '', '63', '550');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2507, '1256', '', '36', '320');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2508, '59215232', '', '36', '3500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2509, '1257', '', '36', '4000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2510, '1258', '', '24', '4155');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2511, '1259', '', '24', '4155');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2512, '1260', '', '24', '4155');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2513, '1261', '', '24', '8841');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2514, '1262', '', '24', '8841');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2515, '1263', '', '24', '8841');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2521, '1265', NULL, '24', '27625');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2522, '1264', NULL, '24', '27625');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2525, '1267', NULL, '24', '43725');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2526, '1266', NULL, '24', '43725');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2527, '1268', '', '45', '200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2528, '1269', '', '45', '300');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2529, '1270', '', '13', '85');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2530, '1271', '', '13', '94');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2531, '1272', '', '13', '94');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2532, '1273', '', '13', '107');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2533, '1274', '', '13', '107');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2534, '1275', '', '13', '128');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2535, '1276', '', '49', '3400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2536, '1277', '', '53', '830');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2543, '1283', NULL, '53', '290');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2544, '1282', NULL, '53', '460');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2545, '1279', NULL, '53', '495');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2546, '1280', NULL, '53', '485');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2547, '1278', NULL, '53', '830');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2548, '1281', NULL, '53', '495');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2549, '1284', '', '29', '1050');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2550, '1285', '', '32', '30');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2551, '1286', '', '53', '750');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2552, '1287', '', '63', '280');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2553, '1288', '', '63', '43');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2557, '1291', NULL, '32', '14');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2559, '1293', '', '32', '80');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2560, '730', NULL, '34', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2561, '1294', '', '58', '70');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2562, '1295', '', '58', '950');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2564, '1296', NULL, '40', '200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2565, '1297', '', '49', '6500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2566, '1298', '', '49', '600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2567, '1299', '', '56', '4500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2568, '1300', '', '56', '86');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2569, '1301', '', '26', '5800');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2570, '1302', '', '32', '100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2572, '1289', NULL, '63', '1400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2573, '1303', '', '49', '10000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2575, '1304', NULL, '32', '6');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2576, '1305', '', '32', '8');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2577, '1306', '', '32', '10');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2578, '1307', '', '28', '280');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2579, '1308', '', '28', '200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2580, '1309', '', '55', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2581, '1310', '', '31', '450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2582, '1311', '', '29', '850');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2583, '1312', '', '60', '210');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2584, '1313', '', '40', '850');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2585, '1314', '', '40', '290');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2587, '1315', NULL, '40', '320');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2588, '1317', '', '49', '13000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2590, '1318', NULL, '52', '5400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2592, '1319', NULL, '28', '2400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2593, '1320', '', '49', '28000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2594, '1321', '', '43', '1320');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2595, '1322', '', '43', '660');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2596, '1323', '', '43', '600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2597, '1324', '', '43', '15');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2598, '1325', '', '43', '660');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2599, '1326', '', '49', '3900');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2600, '1327', '', '8', '1320');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2601, '1328', '', '56', '700');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2602, '1329', '', '56', '375');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2603, '1330', '', '55', '450');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2604, '1331', '', '55', '500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2606, '1333', '', '55', '110');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2607, '1334', '', '55', '200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2608, '1335', '', '55', '150');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2609, '1336', '', '56', '4500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2610, '1332', NULL, '55', '240');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2611, '1337', '', '32', '130');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2612, '1338', '', '32', '90');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2613, '1339', '', '49', '1000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2614, '1340', '', '49', '3500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2615, '1341', '', '34', '147');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2616, '1342', '', '34', '132');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2617, '1343', '', '56', '24');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2618, '1344', '', '56', '25');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2619, '1345', '', '56', '17');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2620, '1346', '', '56', '46');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2622, '1348', '', '56', '1000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2623, '1349', '', '56', '3500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2624, '1347', NULL, '56', '1000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2625, '1350', '', '32', '34');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2626, '1351', '', '32', '16');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2627, '1352', '', '10', '110');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2628, '1353', '', '52', '90');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2629, '1354', '', '52', '60');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2630, '1355', '', '52', '100');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2631, '1356', '', '52', '500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2632, '1357', '', '52', '120');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2633, '1358', '', '52', '2000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2634, '1359', '', '52', '1000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2635, '1360', '', '55', '600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2636, '1361', '', '55', '30');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2637, '1362', '', '55', '70');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2638, '1363', '', '55', '60');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2639, '1364', '', '55', '10550');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2640, '1365', '', '55', '4000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2641, '1366', '', '45', '350');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2642, '1367', '', '45', '200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2643, '1368', '', '45', '130');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2644, '1369', '', '40', '200');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2645, '1370', '', '40', '1000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2646, '1371', '', '49', '14500');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2647, '1292', NULL, '34', '600');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2648, '1372', '', '56', '11000');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2649, '1101', '', '49', '400');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2650, '1102', '', '49', '30');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2651, '1103', '', '49', '50');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2652, '1104', '', '65', '8431');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2653, '1105', '', '65', '13330');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2654, '1106', '', '65', '32289');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2655, '1107', '', '65', '4503');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2657, '1109', '', '65', '18275');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2658, '1110', '', '65', '20208');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2659, '1108', NULL, '65', '9518');
INSERT INTO `supplier_product` (`supplier_pr_id`, `product_id`, `products_model`, `supplier_id`, `supplier_price`) VALUES (2660, '1115', NULL, '28', '425');


#
# TABLE STRUCTURE FOR: synchronizer_setting
#

DROP TABLE IF EXISTS `synchronizer_setting`;

CREATE TABLE `synchronizer_setting` (
  `id` int NOT NULL,
  `hostname` varchar(100) NOT NULL,
  `username` varchar(100) NOT NULL,
  `password` varchar(100) NOT NULL,
  `port` varchar(10) NOT NULL,
  `debug` varchar(10) NOT NULL,
  `project_root` varchar(100) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

#
# TABLE STRUCTURE FOR: tax_collection
#

DROP TABLE IF EXISTS `tax_collection`;

CREATE TABLE `tax_collection` (
  `id` int NOT NULL AUTO_INCREMENT,
  `date` date NOT NULL,
  `customer_id` varchar(30) NOT NULL,
  `relation_id` varchar(30) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `customer_id` (`customer_id`)
) ENGINE=InnoDB AUTO_INCREMENT=974 DEFAULT CHARSET=utf8mb3;

INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (1, '2024-01-12', '1', '1825555996');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (2, '2024-01-14', '1', '4716432385');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (3, '2024-01-14', '1', '9569935962');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (4, '2024-01-15', '1', '7817721484');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (5, '2024-01-15', '1', '8174999964');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (6, '2024-01-15', '1', '3436178181');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (7, '2024-01-15', '1', '3176418784');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (8, '2024-01-17', '1', '5259796836');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (9, '2024-01-17', '1', '8476852622');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (10, '2024-01-17', '1', '6952439647');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (11, '2024-01-21', '1', '3772222985');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (12, '2024-01-21', '1', '6757221714');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (13, '2024-01-21', '1', '6598314449');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (14, '2024-01-21', '1', '9612173125');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (15, '2023-12-24', '2', '5845776228');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (16, '2023-12-24', '2', '6124985648');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (22, '2023-12-25', '2', '4977174268');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (23, '2023-12-25', '2', '4612744893');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (24, '2023-12-26', '2', '2567782964');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (25, '2023-12-27', '2', '9779858312');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (27, '2023-12-28', '2', '3284257142');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (28, '2023-12-30', '2', '9175169491');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (31, '2024-01-01', '2', '8115955164');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (32, '2024-01-02', '2', '6448414167');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (33, '2024-01-03', '2', '7816741612');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (35, '2023-12-31', '2', '5669212287');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (37, '2024-01-04', '2', '4995667463');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (40, '2024-01-06', '2', '7328171614');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (41, '2024-01-07', '2', '6686419811');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (43, '2024-01-08', '2', '4856684174');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (44, '2024-01-09', '2', '1826916967');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (45, '2024-01-10', '2', '5976692598');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (46, '2024-01-11', '2', '3371369953');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (48, '2024-01-11', '2', '7976724629');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (50, '2024-01-13', '2', '1249729836');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (52, '2024-01-14', '2', '9759274115');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (55, '2024-01-15', '2', '7677745934');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (59, '2024-01-17', '2', '6139664445');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (60, '2024-01-18', '2', '9814175468');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (61, '2024-01-20', '2', '8729851784');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (64, '2024-01-16', '2', '4651242384');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (68, '2024-01-23', '2', '7644324833');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (69, '2024-01-24', '2', '1345623824');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (70, '2024-01-25', '2', '5144393325');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (73, '2024-01-27', '2', '4148625191');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (76, '2024-01-28', '2', '4365216877');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (77, '2024-01-29', '2', '4863552591');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (78, '2024-01-31', '2', '1589449478');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (79, '2024-01-30', '2', '4687811218');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (93, '2024-01-03', '6', '1246899298');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (95, '2024-01-31', '2', '9619147336');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (97, '2024-01-06', '6', '6671999227');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (98, '2024-01-07', '6', '6776515978');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (99, '2024-01-13', '6', '5329238352');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (100, '2024-01-13', '6', '3187145389');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (101, '2024-01-13', '6', '9741378871');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (103, '2024-01-04', '6', '4732574941');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (105, '2024-01-14', '6', '3215962328');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (106, '2024-01-16', '6', '1844216916');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (107, '2024-01-16', '6', '5337563468');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (108, '2024-01-18', '6', '2824924738');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (111, '2024-01-19', '6', '6524154835');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (113, '2024-01-19', '6', '2892979613');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (115, '2024-01-20', '6', '3895873329');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (116, '2024-01-22', '6', '2769281188');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (117, '2024-01-23', '6', '3928135646');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (118, '2024-01-24', '6', '2496582565');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (120, '2024-01-24', '6', '5243247132');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (121, '2024-01-25', '6', '1537578668');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (122, '2024-01-30', '6', '7242458569');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (123, '2024-01-31', '6', '8155338425');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (125, '2024-01-24', '6', '4495791598');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (127, '2024-01-31', '6', '9184796385');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (128, '2024-01-31', '6', '2153462153');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (130, '2023-12-30', '12', '1389596898');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (131, '2023-12-31', '12', '2976925275');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (132, '2024-01-06', '12', '9441918497');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (134, '2024-01-09', '12', '7267276659');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (135, '2024-01-20', '12', '9363166494');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (136, '2024-01-04', '23', '9644382867');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (139, '2024-01-29', '23', '1961533534');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (140, '2024-01-29', '23', '7978897387');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (142, '2024-01-06', '23', '1694367774');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (143, '2024-01-07', '7', '7318964635');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (144, '2024-01-09', '7', '6569258597');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (145, '2024-01-11', '7', '7317117295');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (146, '2024-01-13', '7', '3346761442');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (147, '2024-01-17', '7', '6777296441');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (149, '2024-01-20', '7', '5633688734');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (150, '2024-01-23', '7', '1145742434');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (151, '2024-01-28', '7', '5345941923');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (152, '2024-01-16', '10', '8647385565');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (153, '2024-01-21', '10', '1512229224');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (154, '2024-01-22', '10', '5198483319');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (155, '2024-01-23', '10', '1247375455');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (156, '2024-01-27', '10', '8442146984');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (157, '2024-01-28', '10', '6457347775');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (158, '2024-01-30', '10', '8951465191');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (159, '2024-01-04', '18', '3846623832');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (160, '2024-01-17', '18', '7939478389');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (161, '2024-01-21', '18', '9574331962');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (162, '2024-01-23', '18', '4474956213');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (163, '2024-01-23', '18', '5827966316');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (164, '2024-01-23', '18', '3629774983');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (165, '2024-01-25', '18', '7537392644');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (166, '2024-01-31', '18', '5814974916');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (167, '2024-01-04', '24', '3887523765');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (174, '2024-01-09', '24', '3978519419');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (175, '2024-01-04', '24', '1216835466');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (182, '2024-01-09', '13', '3174111365');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (183, '2024-01-10', '13', '6686827297');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (184, '2024-01-17', '13', '5956241346');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (185, '2024-01-18', '13', '5917543216');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (186, '2024-02-01', '13', '8875543688');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (187, '2024-01-11', '25', '1353652854');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (189, '2024-01-06', '28', '2558616487');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (190, '2024-01-07', '14', '5312784753');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (191, '2024-01-11', '27', '9453311658');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (192, '2024-01-16', '27', '1224191136');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (193, '2024-01-25', '27', '2784477898');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (194, '2024-01-25', '27', '5821247238');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (195, '2024-01-17', '30', '8636229268');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (198, '2024-01-28', '17', '9721211439');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (199, '2024-01-23', '21', '5445939478');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (200, '2024-01-25', '19', '7438387912');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (201, '2024-01-29', '34', '6659953793');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (202, '2024-02-24', '26', '1345872945');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (203, '2024-01-25', '32', '9837819267');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (204, '2024-01-30', '22', '8421377642');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (206, '2024-01-21', '31', '1775667854');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (207, '2024-01-29', '19', '3455599945');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (208, '2024-01-21', '25', '4299693644');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (210, '2024-01-06', '20', '2687949442');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (212, '2024-01-06', '25', '4876678161');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (215, '2024-01-06', '16', '6845814617');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (216, '2024-01-06', '7', '2212879286');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (220, '2024-01-04', '24', '4247718784');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (221, '2024-01-04', '24', '5137841171');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (224, '2024-01-04', '24', '7435381842');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (225, '2024-01-04', '24', '3491818584');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (229, '2024-01-04', '24', '9293972658');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (231, '2024-01-01', '6', '7315183996');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (232, '2024-02-02', '6', '3261562757');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (234, '2024-02-07', '6', '6295972662');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (235, '2024-02-07', '6', '6258163824');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (236, '2024-02-11', '6', '5148215591');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (237, '2024-02-12', '6', '3911836699');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (238, '2024-02-15', '6', '1753277465');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (239, '2024-02-16', '6', '1413256793');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (240, '2024-02-05', '6', '1556349912');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (241, '2024-02-19', '6', '2823655468');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (244, '2024-02-03', '18', '9844494798');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (245, '2024-02-03', '26', '5993242736');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (250, '2024-02-07', '27', '5862996656');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (253, '2024-02-07', '10', '8583371169');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (254, '2024-02-10', '7', '2635796229');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (255, '2024-02-10', '18', '6266215734');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (257, '2024-02-11', '21', '2947285344');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (258, '2024-02-13', '18', '1197737314');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (261, '2024-02-13', '21', '7979943364');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (262, '2024-02-13', '20', '4611418728');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (264, '2024-02-13', '20', '7638831343');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (265, '2024-02-13', '32', '9149799129');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (266, '2024-02-13', '32', '9259517748');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (267, '2024-02-14', '7', '2832617851');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (270, '2024-02-15', '18', '4722732758');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (271, '2024-02-18', '10', '7327496538');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (274, '2024-02-18', '29', '2347643624');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (292, '2024-02-10', '20', '8461482622');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (299, '2024-02-18', '7', '5217114917');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (304, '2024-02-13', '39', '5891635397');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (309, '2024-02-21', '18', '6262367751');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (310, '2024-02-21', '10', '3817238736');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (311, '2024-02-22', '21', '4626259438');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (312, '2024-02-22', '10', '2752246514');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (314, '2024-02-24', '10', '6727539696');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (315, '2024-02-27', '12', '1358638581');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (317, '2024-02-03', '15', '9555192325');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (323, '2024-02-03', '25', '3233778328');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (333, '2024-02-12', '2', '8668857166');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (342, '2024-02-18', '2', '5233818293');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (350, '2024-02-22', '2', '3317182685');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (355, '2024-01-21', '2', '2724633553');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (357, '2024-02-27', '2', '9994122257');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (359, '2024-02-28', '2', '2185662296');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (361, '2024-02-04', '2', '6284454277');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (365, '2024-02-19', '2', '1981932215');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (372, '2024-02-29', '2', '7551413551');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (373, '2024-02-22', '7', '2184931446');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (377, '2024-02-24', '27', '8439691471');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (381, '2024-02-25', '18', '8411284899');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (382, '2024-02-27', '13', '8876911595');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (383, '2024-02-28', '7', '9518822344');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (384, '2024-02-28', '17', '6853249324');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (385, '2024-02-28', '7', '2813146579');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (389, '2024-02-28', '27', '1515783136');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (391, '2024-02-28', '17', '3487797747');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (392, '2024-02-29', '32', '2767374889');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (393, '2024-02-29', '21', '4739166969');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (395, '2024-02-03', '2', '6197141427');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (396, '2024-02-06', '2', '8517813777');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (402, '2024-02-24', '2', '3655828734');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (406, '2024-02-07', '2', '7446617154');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (410, '2024-02-11', '2', '9845441218');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (411, '2024-02-14', '2', '8588781131');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (412, '2024-02-15', '2', '2737884135');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (418, '2024-02-17', '2', '1115919194');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (419, '2024-02-01', '2', '2744992295');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (420, '2024-02-05', '2', '5323971621');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (421, '2024-02-10', '2', '7214457359');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (422, '2024-02-13', '2', '7567791142');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (428, '2024-03-03', '18', '3213317312');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (429, '2024-02-03', '32', '2152271745');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (430, '2024-03-03', '25', '6726515132');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (435, '2024-03-04', '13', '5218857126');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (436, '2024-01-22', '2', '8125379816');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (438, '2024-02-21', '2', '9793391551');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (440, '2024-02-25', '2', '3978355951');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (441, '2024-02-20', '2', '2968574474');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (443, '2024-02-24', '18', '2943739531');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (445, '2024-02-18', '20', '6754142711');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (447, '2024-02-18', '36', '1181438141');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (449, '2024-02-21', '40', '3653113769');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (450, '2024-03-05', '41', '3286836845');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (451, '2024-03-05', '6', '4247543232');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (453, '2024-02-27', '6', '3755764352');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (454, '2024-02-29', '6', '7279214426');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (455, '2024-03-06', '25', '2181869592');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (456, '2024-03-06', '27', '2433914368');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (459, '2024-03-02', '17', '5892378914');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (460, '2024-03-03', '7', '3529147678');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (461, '2024-03-05', '2', '2625175392');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (475, '2024-03-07', '18', '2968542394');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (490, '2024-03-10', '2', '8143852489');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (495, '2024-03-11', '2', '9445627595');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (496, '2024-03-12', '2', '1797695428');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (497, '2024-03-02', '2', '1999134661');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (498, '2024-03-03', '2', '3798734435');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (499, '2024-03-04', '2', '1995273414');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (501, '2024-03-06', '2', '6637133796');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (502, '2024-03-07', '2', '1371539249');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (503, '2024-03-09', '2', '4738635783');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (506, '2024-03-13', '2', '9294923342');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (507, '2024-03-10', '7', '6172987557');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (509, '2024-03-10', '27', '8676718682');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (514, '2024-03-10', '18', '2124638789');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (518, '2024-03-10', '12', '6343288937');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (521, '2024-03-13', '42', '2588954467');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (522, '2024-03-14', '2', '3799993359');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (524, '2024-01-04', '24', '3897865422');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (526, '2024-03-07', '24', '6333182967');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (527, '2024-03-14', '32', '2855145682');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (529, '2024-01-17', '24', '7418519547');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (531, '2024-03-16', '2', '7123693583');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (538, '2024-03-17', '12', '2985475614');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (539, '2024-03-19', '42', '3689542297');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (540, '2024-03-20', '2', '9855185474');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (541, '2024-03-19', '32', '3253157469');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (542, '2024-03-20', '27', '5241153453');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (543, '2024-03-19', '10', '4636966543');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (545, '2024-03-19', '18', '9432582367');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (547, '2024-03-19', '43', '9272887417');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (548, '2024-02-03', '7', '6128491668');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (549, '2024-02-03', '20', '4167744585');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (551, '2024-02-07', '10', '1916531934');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (552, '2024-02-07', '18', '3828982476');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (553, '2024-02-04', '38', '4177459154');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (554, '2024-02-12', '37', '7122648312');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (555, '2024-02-15', '12', '9653111997');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (556, '2024-02-21', '35', '8243172374');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (557, '2024-02-24', '12', '5566655768');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (558, '2024-02-24', '7', '3266869518');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (559, '2024-02-28', '18', '7317298758');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (560, '2024-03-06', '20', '3718624612');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (561, '2024-03-07', '7', '6863289674');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (562, '2024-03-07', '22', '5225826333');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (563, '2024-03-07', '17', '2839568685');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (565, '2024-03-09', '24', '5725871419');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (566, '2024-03-10', '22', '9495862115');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (568, '2024-03-11', '23', '7976169977');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (569, '2024-03-16', '7', '8614186355');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (570, '2024-03-17', '12', '5543697839');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (571, '2024-03-17', '12', '2624183513');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (572, '2024-02-06', '22', '3648649638');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (573, '2024-03-21', '44', '7748257852');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (574, '2024-03-21', '21', '2698538637');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (576, '2024-03-21', '2', '9329421995');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (577, '2024-03-21', '25', '7473123694');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (578, '2024-03-21', '17', '9997275465');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (580, '2024-03-21', '42', '3826793642');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (581, '2024-03-21', '18', '5672426756');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (587, '2024-03-07', '12', '1747957241');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (590, '2024-03-19', '2', '2733712729');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (596, '2024-03-24', '2', '3586992742');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (598, '2024-03-07', '45', '5434657383');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (599, '2024-03-07', '6', '9123418226');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (600, '2024-03-14', '6', '6658398886');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (602, '2024-03-17', '6', '2817362753');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (603, '2024-03-19', '6', '2925755632');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (605, '2024-03-24', '27', '2465779867');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (606, '2024-03-25', '40', '7855113342');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (607, '2024-03-25', '18', '5929568811');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (610, '2024-03-24', '27', '4937312758');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (613, '2024-03-26', '32', '3675182878');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (615, '2024-03-27', '10', '9631931262');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (616, '2024-03-27', '18', '8381957215');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (618, '2024-03-16', '6', '5744799622');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (620, '2024-03-14', '6', '3253633293');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (621, '2024-03-27', '6', '6194973291');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (623, '2024-03-27', '20', '5777367333');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (627, '2024-03-25', '28', '4493439377');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (628, '2024-03-25', '10', '9922541324');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (629, '2024-03-25', '2', '1231988793');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (633, '2024-03-26', '2', '6677889362');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (641, '2024-03-17', '2', '2684671283');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (649, '2024-03-30', '46', '7681616844');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (656, '2024-03-30', '47', '4275369827');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (659, '2024-03-30', '17', '4167923813');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (661, '2024-03-30', '17', '5791754729');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (663, '2024-03-31', '18', '1512924365');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (664, '2024-03-31', '10', '4698376251');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (666, '2024-03-31', '42', '7732694976');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (667, '2024-03-31', '17', '6597638334');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (668, '2024-03-31', '7', '6212555628');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (669, '2024-03-31', '21', '4131963676');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (670, '2024-03-31', '22', '4224926148');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (671, '2024-03-27', '23', '2271855841');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (672, '2024-03-28', '6', '6821617226');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (674, '2024-03-30', '6', '6865261646');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (675, '2024-02-25', '6', '9652589483');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (676, '2024-03-23', '2', '5732915468');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (678, '2024-03-31', '2', '3668139334');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (680, '2024-04-02', '2', '3373792943');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (684, '2024-04-03', '17', '1299158818');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (687, '2024-04-04', '6', '5173269616');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (694, '2024-03-25', '7', '8429856221');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (699, '2024-01-04', '24', '2135868574');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (700, '2024-01-04', '24', '1938912735');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (702, '2024-04-06', '17', '2166655947');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (703, '2024-04-06', '15', '2375654761');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (706, '2024-04-07', '20', '8628978864');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (707, '2024-04-07', '44', '5481418892');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (708, '2024-04-07', '32', '4913417498');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (709, '2024-04-08', '18', '5268985181');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (710, '2024-04-08', '25', '9849939218');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (711, '2024-04-08', '50', '4695875524');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (715, '2024-04-08', '6', '2216479258');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (719, '2024-04-09', '6', '6839949824');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (720, '2024-04-08', '2', '4823786759');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (727, '2024-04-13', '2', '4648594853');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (728, '2024-04-14', '40', '6586445994');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (729, '2024-04-14', '32', '1196229697');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (730, '2024-04-14', '7', '7873299185');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (735, '2024-04-09', '2', '1954183663');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (736, '2024-04-07', '2', '5176459998');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (740, '2024-04-06', '2', '6792891529');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (746, '2024-04-15', '51', '4979853171');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (753, '2024-04-14', '2', '8841984599');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (759, '2024-04-15', '52', '7653135536');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (760, '2024-04-16', '6', '7865327862');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (763, '2024-04-15', '2', '3395545996');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (764, '2024-04-04', '2', '1948967738');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (765, '2024-04-17', '18', '3454739466');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (766, '2024-04-17', '6', '1897354479');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (767, '2024-03-28', '6', '1971361776');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (768, '2024-04-02', '6', '1331473321');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (769, '2024-04-06', '49', '5989899254');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (773, '2024-04-03', '2', '8951253458');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (776, '2024-04-17', '6', '3687215118');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (777, '2024-04-17', '17', '3352983635');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (778, '2024-04-17', '21', '7953851285');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (779, '2024-04-17', '13', '6742371245');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (780, '2024-04-04', '48', '2634181175');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (781, '2024-04-04', '48', '9826454685');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (783, '2024-04-16', '2', '4181161449');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (786, '2024-04-18', '6', '5253343437');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (787, '2024-04-18', '27', '8378298814');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (790, '2024-01-04', '24', '7943379429');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (791, '2024-04-17', '2', '4754231575');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (792, '2024-04-18', '2', '4187574224');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (795, '2024-03-30', '2', '2343991432');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (797, '2024-04-20', '6', '2696397343');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (802, '2024-04-20', '2', '1929867449');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (803, '2024-04-20', '2', '7592546738');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (806, '2024-04-18', '51', '7225778361');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (808, '2024-04-20', '17', '5411671834');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (809, '2024-04-21', '25', '5613664541');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (810, '2024-04-21', '18', '1464127388');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (811, '2024-04-21', '7', '7252192761');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (812, '2024-04-21', '18', '2238345531');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (815, '2024-04-21', '2', '7455412952');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (817, '2024-04-22', '2', '8997478542');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (819, '2024-04-21', '53', '7981551788');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (820, '2024-04-21', '40', '8413576871');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (821, '2024-04-23', '53', '5236541338');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (823, '2024-04-24', '10', '8827832273');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (824, '2024-04-24', '18', '2279338767');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (826, '2024-04-22', '53', '9958959772');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (828, '2024-04-23', '2', '7143127461');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (831, '2024-04-25', '54', '4469798727');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (832, '2024-04-24', '2', '3499562843');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (834, '2024-04-25', '2', '9818532272');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (835, '2024-04-21', '17', '6311557677');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (837, '2024-04-23', '17', '9414891438');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (838, '2024-04-24', '17', '4787487136');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (839, '2024-04-24', '32', '1789273916');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (840, '2024-04-27', '17', '5253653148');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (841, '2024-04-27', '18', '8257478766');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (842, '2024-04-27', '25', '6294569947');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (843, '2024-04-27', '29', '5534821822');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (844, '2024-04-22', '6', '1651433367');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (846, '2024-04-24', '6', '3851685395');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (847, '2024-04-26', '6', '6876312951');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (849, '2024-04-27', '2', '5651135711');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (852, '2024-03-28', '2', '4883297114');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (855, '2024-04-27', '43', '6185919946');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (856, '2024-03-27', '2', '2243328791');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (857, '2024-03-21', '2', '8398991967');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (858, '2024-03-20', '2', '6351564964');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (859, '2024-03-18', '2', '6667973681');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (860, '2024-04-29', '18', '9947344679');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (861, '2024-04-29', '18', '6352547424');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (862, '2024-04-29', '6', '8958612741');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (863, '2024-04-28', '2', '1292926993');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (864, '2024-04-29', '2', '8221687361');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (865, '2024-04-30', '18', '1459596594');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (866, '2024-04-30', '43', '9727844627');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (867, '2024-05-02', '17', '9688352243');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (868, '2024-05-02', '27', '9912837861');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (872, '2024-04-30', '2', '9152678989');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (874, '2024-05-02', '32', '5213434265');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (875, '2024-05-02', '55', '6341328237');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (876, '2024-05-02', '18', '1521546399');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (880, '2024-05-02', '2', '9695696422');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (881, '2024-05-02', '6', '8717124365');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (886, '2024-05-05', '2', '5482914316');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (887, '2024-05-01', '2', '5736277861');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (890, '2024-05-06', '2', '9859657466');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (892, '2024-05-05', '23', '9266641739');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (899, '2024-04-29', '53', '1547115985');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (900, '2024-05-06', '18', '5866451357');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (901, '2024-05-06', '27', '9277318726');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (902, '2024-05-06', '56', '8199273583');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (903, '2024-04-20', '43', '3293275968');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (904, '2024-04-20', '51', '2926266512');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (905, '2024-05-07', '15', '6727268952');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (906, '2024-05-07', '55', '9192112764');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (909, '2024-05-06', '2', '9512576366');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (913, '2024-05-07', '2', '3942454311');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (914, '2024-05-09', '12', '1187151677');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (915, '2024-05-09', '12', '7938173624');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (918, '2024-05-09', '17', '2415214152');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (919, '2024-05-08', '2', '2515197159');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (920, '2024-05-09', '2', '5942324735');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (921, '2024-05-07', '55', '6973986361');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (922, '2024-05-04', '2', '9746361644');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (923, '2024-05-04', '2', '6655196876');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (926, '2024-01-04', '24', '4199745195');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (928, '2024-05-11', '2', '6879251196');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (931, '2024-05-11', '58', '3258566874');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (934, '2024-05-12', '2', '1435241757');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (935, '2024-05-13', '53', '1217289937');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (936, '2024-05-13', '27', '1471919258');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (937, '2024-05-13', '21', '2714463447');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (938, '2024-05-13', '18', '8246258379');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (939, '2024-05-09', '6', '2173489285');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (941, '2024-05-09', '57', '1614719538');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (942, '2024-05-11', '53', '7771648352');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (943, '2024-05-11', '20', '8482417873');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (945, '2024-05-13', '23', '7425241919');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (947, '2024-05-13', '2', '2269286568');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (948, '2024-05-14', '59', '7132322579');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (949, '2024-05-14', '60', '7531931292');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (950, '2024-05-14', '53', '9425431332');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (951, '2024-05-14', '43', '2441147954');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (952, '2024-05-14', '2', '5141413266');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (953, '2024-05-15', '17', '4629916718');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (954, '2024-05-15', '27', '9233426983');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (955, '2024-05-15', '18', '3543812978');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (957, '2024-05-15', '58', '4751468166');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (959, '2024-05-16', '2', '4525769244');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (961, '2024-01-24', '24', '1712444644');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (962, '2024-05-15', '2', '9112277419');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (964, '2024-05-16', '55', '9815267139');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (965, '2024-05-16', '17', '8532293273');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (966, '2024-04-19', '17', '9827253319');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (968, '2024-05-18', '2', '6261171199');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (969, '2024-05-19', '22', '9163299722');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (970, '2024-05-19', '22', '1223415297');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (972, '2024-05-19', '2', '4745111666');
INSERT INTO `tax_collection` (`id`, `date`, `customer_id`, `relation_id`) VALUES (973, '2024-05-20', '2', '9131447689');


#
# TABLE STRUCTURE FOR: tax_settings
#

DROP TABLE IF EXISTS `tax_settings`;

CREATE TABLE `tax_settings` (
  `id` int NOT NULL AUTO_INCREMENT,
  `default_value` float NOT NULL,
  `tax_name` varchar(250) NOT NULL,
  `nt` int NOT NULL,
  `reg_no` varchar(100) NOT NULL,
  `is_show` tinyint NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

#
# TABLE STRUCTURE FOR: units
#

DROP TABLE IF EXISTS `units`;

CREATE TABLE `units` (
  `id` int NOT NULL AUTO_INCREMENT,
  `unit_id` varchar(255) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `unit_name` varchar(255) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `status` int NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=26 DEFAULT CHARSET=utf8mb3;

INSERT INTO `units` (`id`, `unit_id`, `unit_name`, `status`) VALUES (1, '554B64LDTEA571S', 'dozen', 1);
INSERT INTO `units` (`id`, `unit_id`, `unit_name`, `status`) VALUES (2, 'GFCTN46CE6PZ2SH', 'nos', 1);
INSERT INTO `units` (`id`, `unit_id`, `unit_name`, `status`) VALUES (3, 'XQUIMX4EV7T4PVG', 'pcs', 1);
INSERT INTO `units` (`id`, `unit_id`, `unit_name`, `status`) VALUES (4, '2IQ189F3L74CCT7', 'coil', 1);
INSERT INTO `units` (`id`, `unit_id`, `unit_name`, `status`) VALUES (15, '7VGWJJ8Z298COL3', 'Gross', 1);
INSERT INTO `units` (`id`, `unit_id`, `unit_name`, `status`) VALUES (16, '4845PL714PSLOZJ', 'Bundel', 1);
INSERT INTO `units` (`id`, `unit_id`, `unit_name`, `status`) VALUES (17, 'Q92AWJBZYQNQWBW', 'Roll', 1);
INSERT INTO `units` (`id`, `unit_id`, `unit_name`, `status`) VALUES (18, 'K5IOJGVF3GPPSNN', 'Foot', 1);
INSERT INTO `units` (`id`, `unit_id`, `unit_name`, `status`) VALUES (19, 'JFICGLTJM1L5VYO', 'Yard', 1);
INSERT INTO `units` (`id`, `unit_id`, `unit_name`, `status`) VALUES (20, 'AES5RKWHDD7VGO5', 'Meter', 1);
INSERT INTO `units` (`id`, `unit_id`, `unit_name`, `status`) VALUES (21, 'L7T4THSPFH7YKGG', 'packet', 1);
INSERT INTO `units` (`id`, `unit_id`, `unit_name`, `status`) VALUES (22, '2RK37AIXMF8WTGP', 'KG', 1);
INSERT INTO `units` (`id`, `unit_id`, `unit_name`, `status`) VALUES (23, 'M31KEYFECM3B6DJ', 'Liter', 1);
INSERT INTO `units` (`id`, `unit_id`, `unit_name`, `status`) VALUES (24, '66P5CWHVWTRL1ZJ', 'gallan ', 1);
INSERT INTO `units` (`id`, `unit_id`, `unit_name`, `status`) VALUES (25, '81C37CGRWOPSSN7', 'Length', 1);


#
# TABLE STRUCTURE FOR: user_login
#

DROP TABLE IF EXISTS `user_login`;

CREATE TABLE `user_login` (
  `id` int NOT NULL AUTO_INCREMENT,
  `user_id` varchar(15) NOT NULL,
  `username` varchar(255) NOT NULL,
  `password` varchar(255) DEFAULT NULL,
  `user_type` int DEFAULT NULL,
  `security_code` varchar(255) DEFAULT NULL,
  `status` int NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3;

INSERT INTO `user_login` (`id`, `user_id`, `username`, `password`, `user_type`, `security_code`, `status`) VALUES (1, '2', 'admin@example.com', '6b35440c019a130a39fb51deaaf663d8', 1, NULL, 1);
INSERT INTO `user_login` (`id`, `user_id`, `username`, `password`, `user_type`, `security_code`, `status`) VALUES (2, '1', 'admin@admin.com', '4023fd6260a66a8b7f77d5a15657d21a', 1, NULL, 1);


#
# TABLE STRUCTURE FOR: users
#

DROP TABLE IF EXISTS `users`;

CREATE TABLE `users` (
  `id` int NOT NULL AUTO_INCREMENT,
  `user_id` varchar(15) NOT NULL,
  `last_name` varchar(255) NOT NULL,
  `first_name` varchar(255) NOT NULL,
  `company_name` varchar(250) DEFAULT NULL,
  `address` text,
  `phone` varchar(20) DEFAULT NULL,
  `gender` int DEFAULT NULL,
  `date_of_birth` varchar(255) DEFAULT NULL,
  `logo` varchar(250) DEFAULT NULL,
  `status` int NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3;

INSERT INTO `users` (`id`, `user_id`, `last_name`, `first_name`, `company_name`, `address`, `phone`, `gender`, `date_of_birth`, `logo`, `status`) VALUES (1, '2', 'DEV', 'ALHAMD', NULL, NULL, NULL, NULL, NULL, 'http://localhost/saleserp_v9.8/assets/dist/img/profile_picture/profile.jpg', 1);
INSERT INTO `users` (`id`, `user_id`, `last_name`, `first_name`, `company_name`, `address`, `phone`, `gender`, `date_of_birth`, `logo`, `status`) VALUES (2, '1', 'Millat traders', 'Yazdan', NULL, NULL, NULL, NULL, NULL, 'https://millattraders.com/saleserp/assets/dist/img/profile_picture/6a6282455b5294136625407ce091c455.jpg', 1);


#
# TABLE STRUCTURE FOR: web_setting
#

DROP TABLE IF EXISTS `web_setting`;

CREATE TABLE `web_setting` (
  `setting_id` int NOT NULL AUTO_INCREMENT,
  `logo` varchar(255) DEFAULT NULL,
  `invoice_logo` varchar(255) DEFAULT NULL,
  `favicon` varchar(255) DEFAULT NULL,
  `currency` varchar(10) DEFAULT NULL,
  `timezone` varchar(150) NOT NULL,
  `currency_position` varchar(10) DEFAULT NULL,
  `footer_text` varchar(255) DEFAULT NULL,
  `language` varchar(255) DEFAULT NULL,
  `rtr` varchar(255) DEFAULT NULL,
  `captcha` int DEFAULT '1' COMMENT '0=active,1=inactive',
  `site_key` varchar(250) DEFAULT NULL,
  `secret_key` varchar(250) DEFAULT NULL,
  `discount_type` int DEFAULT '1',
  PRIMARY KEY (`setting_id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3;

INSERT INTO `web_setting` (`setting_id`, `logo`, `invoice_logo`, `favicon`, `currency`, `timezone`, `currency_position`, `footer_text`, `language`, `rtr`, `captcha`, `site_key`, `secret_key`, `discount_type`) VALUES (1, 'http://localhost/saleserp_v9.5/./my-assets/image/logo/b9', 'http://localhost/saleserp_v9.5/./my-assets/image/logo/b98567c5bfbbd1a6709a9b6ae5ff279a.png', 'https://softest8.bdtask.com/saleserp_sas_v-2/my-assets/image/logo/0bb2ee8377d8672d55b553ef11f07d69.png', 'PKR', 'Asia/Karachi', '0', 'CopyrightÂ© 2018-2019 ALHAMDDEVELOPERS. CONTACT : 03153855234-03161309746. All rights reserved.', 'english', '0', 1, '6LdiKhsUAAAAAMV4jQRmNYdZy2kXEuFe1HrdP5tt', '6LdiKhsUAAAAAMV4jQRmNYdZy2kXEuFe1HrdP5tt', 1);


