DROP TABLE acc_coa;

CREATE TABLE `acc_coa` (
  `HeadCode` varchar(50) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci NOT NULL,
  `HeadName` varchar(100) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci NOT NULL,
  `PHeadName` varchar(50) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci NOT NULL,
  `HeadLevel` int NOT NULL,
  `IsActive` tinyint(1) NOT NULL,
  `IsTransaction` tinyint(1) NOT NULL,
  `IsGL` tinyint(1) NOT NULL,
  `HeadType` char(1) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci NOT NULL,
  `IsBudget` tinyint(1) NOT NULL,
  `IsDepreciation` tinyint(1) NOT NULL,
  `customer_id` int DEFAULT NULL,
  `supplier_id` int DEFAULT NULL,
  `DepreciationRate` decimal(18,2) NOT NULL,
  `CreateBy` varchar(50) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci NOT NULL,
  `CreateDate` datetime NOT NULL,
  `UpdateBy` varchar(50) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci NOT NULL,
  `UpdateDate` datetime NOT NULL,
  PRIMARY KEY (`HeadName`),
  KEY `HeadCode` (`HeadCode`),
  KEY `customer_id` (`customer_id`),
  KEY `supplier_id` (`supplier_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

INSERT INTO acc_coa VALUES("502000001","1-Ashraf surgoda","Account Payable","3","1","1","0","L","0","0","","1","0.00","1","2024-01-24 14:20:39","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("102030000001","1-Cash Sale","Customer Receivable","4","1","1","0","A","0","0","1","","0.00","1","2024-01-23 16:54:00","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000008","10-Memon LAD Light","Account Payable","3","1","1","0","L","0","0","","10","0.00","1","2024-01-27 16:16:31","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000009","11-Chilton Safan","Account Payable","3","1","1","0","L","0","0","","11","0.00","1","2024-01-28 10:48:05","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000011","13-Olympic Sargodah","Account Payable","3","1","1","0","L","0","0","","13","0.00","1","2024-01-28 11:35:38","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000012","14-ARY Sargodah","Account Payable","3","1","1","0","L","0","0","","14","0.00","1","2024-01-28 12:12:46","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000013","15-Al Mezan Sargodah","Account Payable","3","1","1","0","L","0","0","","15","0.00","1","2024-01-28 13:50:09","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000014","16-Asim Sargodah","Account Payable","3","1","1","0","L","0","0","","16","0.00","1","2024-01-28 14:03:52","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000016","18-Perfect Sargodah","Account Payable","3","1","1","0","L","0","0","","18","0.00","1","2024-01-28 14:07:37","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000017","19-E M Sargodah","Account Payable","3","1","1","0","L","0","0","","19","0.00","1","2024-01-28 14:39:02","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000002","2-Arslan LED","Account Payable","3","1","1","0","L","0","0","","2","0.00","1","2024-01-24 14:39:42","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("102030000002","2-Walking Customer","Customer Receivable","4","1","1","0","A","0","0","2","","0.00","1","2024-01-23 17:38:03","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000018","20-Sonex Sargodah","Account Payable","3","1","1","0","L","0","0","","20","0.00","1","2024-01-28 14:40:14","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000020","22-Sahar Al Fazal Sargodah","Account Payable","3","1","1","0","L","0","0","","22","0.00","1","2024-01-28 15:02:32","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000021","23-Burq Sargodah","Account Payable","3","1","1","0","L","0","0","","23","0.00","1","2024-01-28 15:20:23","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000022","24-Fareed Qasim","Account Payable","3","1","1","0","L","0","0","","24","0.00","1","2024-01-29 14:39:55","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000023","25-Aijaz PCV Karachi","Account Payable","3","1","1","0","L","0","0","","25","0.00","1","2024-01-30 14:46:43","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000024","26-Jawaid Wire","Account Payable","3","1","1","0","L","0","0","","26","0.00","1","2024-01-30 16:11:07","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000025","27-Haji salman Karachi","Account Payable","3","1","1","0","L","0","0","","27","0.00","1","2024-01-31 14:43:53","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000026","28-Fizan Wire","Account Payable","3","1","1","0","L","0","0","","28","0.00","1","2024-01-31 15:47:57","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000027","29-G.One LED Light","Account Payable","3","1","1","0","L","0","0","","29","0.00","1","2024-02-01 15:00:06","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000003","3-Pak E \\ S Khi","Account Payable","3","1","1","0","L","0","0","","3","0.00","1","2024-01-24 15:02:37","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000028","30-Moin PVC Karachi","Account Payable","3","1","1","0","L","0","0","","30","0.00","1","2024-02-01 16:05:09","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000029","31-Arfeen Wire (Million)","Account Payable","3","1","1","0","L","0","0","","31","0.00","1","2024-02-03 14:28:32","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000030","32-Millat Traders Loose Item","Account Payable","3","1","1","0","L","0","0","","32","0.00","1","2024-02-05 15:44:44","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000031","33-Emaan Light House","Account Payable","3","1","1","0","L","0","0","","33","0.00","1","2024-02-07 15:58:07","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000032","34-Chilton Traders Karachi","Account Payable","3","1","1","0","L","0","0","","34","0.00","1","2024-02-07 16:33:53","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000033","35-Hameed Panel","Account Payable","3","1","1","0","L","0","0","","35","0.00","1","2024-02-07 16:34:48","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000034","36-Fawad Wire","Account Payable","3","1","1","0","L","0","0","","36","0.00","1","2024-02-07 16:35:35","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000035","37-New Shahid Pipe","Account Payable","3","1","1","0","L","0","0","","37","0.00","1","2024-02-07 16:36:33","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000036","38-HUawei ","Account Payable","3","1","1","0","L","0","0","","38","0.00","1","2024-02-07 16:37:33","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000037","39-Riaz Delux","Account Payable","3","1","1","0","L","0","0","","39","0.00","1","2024-02-07 16:38:26","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000004","4-Qureshi pipe wala","Account Payable","3","1","1","0","L","0","0","","4","0.00","1","2024-01-24 15:27:10","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000038","40-Paremount General","Account Payable","3","1","1","0","L","0","0","","40","0.00","1","2024-02-07 16:41:56","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000039","41-Muneer Shop","Account Payable","3","1","1","0","L","0","0","","41","0.00","1","2024-02-07 16:43:58","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000040","42-Haji Salman Karachi","Account Payable","3","1","1","0","L","0","0","","42","0.00","1","2024-02-07 16:45:04","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000041","43-Royal Electri Karachi","Account Payable","3","1","1","0","L","0","0","","43","0.00","1","2024-02-07 16:46:29","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000042","44-Sindh Electri Hyderabad","Account Payable","3","1","1","0","L","0","0","","44","0.00","1","2024-02-07 16:47:05","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000043","45-Zahid Soomro Kotri","Account Payable","3","1","1","0","L","0","0","","45","0.00","1","2024-02-07 16:48:05","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000044","46-Naeem Pant","Account Payable","3","1","1","0","L","0","0","","46","0.00","1","2024-02-07 16:48:43","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000045","47-Haroon Pant","Account Payable","3","1","1","0","L","0","0","","47","0.00","1","2024-02-07 16:49:14","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000046","48-S.K Fan","Account Payable","3","1","1","0","L","0","0","","48","0.00","1","2024-02-07 16:49:58","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000047","49-Cash Item ","Account Payable","3","1","1","0","L","0","0","","49","0.00","1","2024-02-13 14:54:06","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("102030000004","5-Credit Customer","Customer Receivable","4","1","1","0","A","0","0","5","","0.00","1","2024-02-20 14:33:58","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000048","50-Abdul Hammed Panel wala","Account Payable","3","1","1","0","L","0","0","","50","0.00","1","2024-02-18 07:53:51","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000049","51-F Ali Iddress Karachi","Account Payable","3","1","1","0","L","0","0","","51","0.00","1","2024-02-19 08:22:20","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("102030000005","6-H.M CABLES","Customer Receivable","4","1","1","0","A","0","0","6","","0.00","1","2024-02-20 15:35:45","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000005","7-P.V.C Mix item","Account Payable","3","1","1","0","L","0","0","","7","0.00","1","2024-01-27 14:40:54","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000006","8-Akram PVC","Account Payable","3","1","1","0","L","0","0","","8","0.00","1","2024-01-27 15:06:21","","0000-00-00 00:00:00");
INSERT INTO acc_coa VALUES("502000007","9-Nasir Electric","Account Payable","3","1","1","0","L","0","0","","9","0.00","1","2024-01-27 15:23:09","","0000-00-00 00:00:00");



DROP TABLE acc_transaction;

CREATE TABLE `acc_transaction` (
  `ID` int NOT NULL AUTO_INCREMENT,
  `VNo` varchar(50) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `Vtype` varchar(50) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `VDate` date DEFAULT NULL,
  `COAID` varchar(50) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci NOT NULL,
  `Narration` text CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci,
  `Debit` decimal(18,2) DEFAULT NULL,
  `Credit` decimal(18,2) DEFAULT NULL,
  `IsPosted` char(10) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `CreateBy` varchar(50) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `CreateDate` datetime DEFAULT NULL,
  `UpdateBy` varchar(50) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `UpdateDate` datetime DEFAULT NULL,
  `IsAppove` char(10) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  UNIQUE KEY `ID` (`ID`),
  KEY `COAID` (`COAID`)
) ENGINE=InnoDB AUTO_INCREMENT=1418 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

INSERT INTO acc_transaction VALUES("1","20240124145509","Purchase","2023-12-31","10107","Inventory Debit For Supplier Ashraf surgoda","26880.00","0.00","1","1","2024-01-24 14:55:09","","","1");
INSERT INTO acc_transaction VALUES("2","20240124145509","Purchase","2023-12-31","502000001","Supplier .Ashraf surgoda","0.00","26880.00","1","1","2024-01-24 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("3","20240124145509","Purchase","2023-12-31","402","Company Credit For  Ashraf surgoda","26880.00","0.00","1","1","2024-01-24 14:55:09","","","1");
INSERT INTO acc_transaction VALUES("23","A3T5KT2DQS","PR Balance","2024-01-25","502000005","supplier debit For P.V.C Mix Item","0.00","30350.00","1","1","2024-01-25 15:15:14","","","1");
INSERT INTO acc_transaction VALUES("24","A3T5KT2DQS","PR Balance","2024-01-25","10107","Inventory credit For  P.V.C Mix Item","30350.00","0.00","1","1","2024-01-25 15:15:14","","","1");
INSERT INTO acc_transaction VALUES("25","HORIUJS9UU","PR Balance","2024-01-27","502000005","supplier debit For P.V.C Mix Item","0.00","30350.00","1","1","2024-01-27 14:34:32","","","1");
INSERT INTO acc_transaction VALUES("26","HORIUJS9UU","PR Balance","2024-01-27","10107","Inventory credit For  P.V.C Mix Item","30350.00","0.00","1","1","2024-01-27 14:34:32","","","1");
INSERT INTO acc_transaction VALUES("27","BXRMILQTIZ","PR Balance","2024-01-27","502000005","supplier debit For P.V.C Mix item","0.00","30350.00","1","1","2024-01-27 14:40:54","","","1");
INSERT INTO acc_transaction VALUES("28","BXRMILQTIZ","PR Balance","2024-01-27","10107","Inventory credit For  P.V.C Mix item","30350.00","0.00","1","1","2024-01-27 14:40:54","","","1");
INSERT INTO acc_transaction VALUES("34","5DQ5V4T98C","PR Balance","2024-01-27","502000006","supplier debit For Akram PVC","0.00","90000.00","1","1","2024-01-27 15:06:21","","","1");
INSERT INTO acc_transaction VALUES("35","5DQ5V4T98C","PR Balance","2024-01-27","10107","Inventory credit For  Akram PVC","90000.00","0.00","1","1","2024-01-27 15:06:21","","","1");
INSERT INTO acc_transaction VALUES("39","SYC9FM1LA4","PR Balance","2024-01-27","502000007","supplier debit For Nasir Electric","0.00","47450.00","1","1","2024-01-27 15:23:09","","","1");
INSERT INTO acc_transaction VALUES("40","SYC9FM1LA4","PR Balance","2024-01-27","10107","Inventory credit For  Nasir Electric","47450.00","0.00","1","1","2024-01-27 15:23:09","","","1");
INSERT INTO acc_transaction VALUES("56","20240127152129","Purchase","2023-12-31","10107","Inventory Devit Supplier Akram PVC","90000.00","0.00","1","1","2024-01-27 15:46:49","","","1");
INSERT INTO acc_transaction VALUES("57","20240127152129","Purchase","2023-12-31","502000006","Supplier -Akram PVC","0.00","90000.00","1","1","2024-01-27 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("58","20240127152129","Purchase","2023-12-31","402","Company Credit For SupplierAkram PVC","90000.00","0.00","1","1","2024-01-27 15:46:49","","","1");
INSERT INTO acc_transaction VALUES("59","20240127152129","Purchase","2023-12-31","1020101","Cash in Hand For Supplier Akram PVC","0.00","0.00","1","1","2024-01-27 15:46:49","","","1");
INSERT INTO acc_transaction VALUES("60","20240127152129","Purchase","2023-12-31","502000006","Supplier . Akram PVC","0.00","0.00","1","1","2024-01-27 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("66","20240127150504","Purchase","2023-12-31","10107","Inventory Devit Supplier P.V.C Mix item","30350.00","0.00","1","1","2024-01-27 15:48:04","","","1");
INSERT INTO acc_transaction VALUES("67","20240127150504","Purchase","2023-12-31","502000005","Supplier -P.V.C Mix item","0.00","30350.00","1","1","2024-01-27 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("68","20240127150504","Purchase","2023-12-31","402","Company Credit For SupplierP.V.C Mix item","30350.00","0.00","1","1","2024-01-27 15:48:04","","","1");
INSERT INTO acc_transaction VALUES("69","20240127150504","Purchase","2023-12-31","1020101","Cash in Hand For Supplier P.V.C Mix item","0.00","30350.00","1","1","2024-01-27 15:48:04","","","1");
INSERT INTO acc_transaction VALUES("70","20240127150504","Purchase","2023-12-31","502000005","Supplier . P.V.C Mix item","30350.00","0.00","1","1","2024-01-27 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("93","20240127161005","Purchase","2023-12-31","10107","Inventory Devit Supplier Nasir Electric","47450.00","0.00","1","1","2024-01-28 11:54:51","","","1");
INSERT INTO acc_transaction VALUES("94","20240127161005","Purchase","2023-12-31","502000007","Supplier -Nasir Electric","0.00","47450.00","1","1","2024-01-28 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("95","20240127161005","Purchase","2023-12-31","402","Company Credit For SupplierNasir Electric","47450.00","0.00","1","1","2024-01-28 11:54:51","","","1");
INSERT INTO acc_transaction VALUES("96","20240127161005","Purchase","2023-12-31","1020101","Cash in Hand For Supplier Nasir Electric","0.00","0.00","1","1","2024-01-28 11:54:51","","","1");
INSERT INTO acc_transaction VALUES("97","20240127161005","Purchase","2023-12-31","502000007","Supplier . Nasir Electric","0.00","0.00","1","1","2024-01-28 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("98","20240128115259","Purchase","2023-12-31","10107","Inventory Devit Supplier OLympic Sargodah","26510.00","0.00","1","1","2024-01-28 11:55:42","","","1");
INSERT INTO acc_transaction VALUES("99","20240128115259","Purchase","2023-12-31","502000011","Supplier -OLympic Sargodah","0.00","26510.00","1","1","2024-01-28 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("100","20240128115259","Purchase","2023-12-31","402","Company Credit For SupplierOLympic Sargodah","26510.00","0.00","1","1","2024-01-28 11:55:42","","","1");
INSERT INTO acc_transaction VALUES("101","20240128115259","Purchase","2023-12-31","1020101","Cash in Hand For Supplier OLympic Sargodah","0.00","0.00","1","1","2024-01-28 11:55:42","","","1");
INSERT INTO acc_transaction VALUES("102","20240128115259","Purchase","2023-12-31","502000011","Supplier . OLympic Sargodah","0.00","0.00","1","1","2024-01-28 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("108","20240128104627","Purchase","2023-12-31","10107","Inventory Devit Supplier Memon LAD Light","210085.00","0.00","1","1","2024-01-28 11:56:36","","","1");
INSERT INTO acc_transaction VALUES("109","20240128104627","Purchase","2023-12-31","502000008","Supplier -Memon LAD Light","0.00","210085.00","1","1","2024-01-28 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("110","20240128104627","Purchase","2023-12-31","402","Company Credit For SupplierMemon LAD Light","210085.00","0.00","1","1","2024-01-28 11:56:36","","","1");
INSERT INTO acc_transaction VALUES("111","20240128104627","Purchase","2023-12-31","1020101","Cash in Hand For Supplier Memon LAD Light","0.00","0.00","1","1","2024-01-28 11:56:36","","","1");
INSERT INTO acc_transaction VALUES("112","20240128104627","Purchase","2023-12-31","502000008","Supplier . Memon LAD Light","0.00","0.00","1","1","2024-01-28 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("176","20240128140222","Purchase","2023-12-31","10107","Inventory Debit For Supplier Al Mezan Sargodah","42885.00","0.00","1","1","2024-01-28 14:02:22","","","1");
INSERT INTO acc_transaction VALUES("177","20240128140222","Purchase","2023-12-31","502000013","Supplier .Al Mezan Sargodah","0.00","42885.00","1","1","2024-01-28 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("178","20240128140222","Purchase","2023-12-31","402","Company Credit For  Al Mezan Sargodah","42885.00","0.00","1","1","2024-01-28 14:02:22","","","1");
INSERT INTO acc_transaction VALUES("179","20240128141713","Purchase","2023-12-31","10107","Inventory Debit For Supplier Perfect Sargodah","44900.00","0.00","1","1","2024-01-28 14:17:13","","","1");
INSERT INTO acc_transaction VALUES("180","20240128141713","Purchase","2023-12-31","502000016","Supplier .Perfect Sargodah","0.00","44900.00","1","1","2024-01-28 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("181","20240128141713","Purchase","2023-12-31","402","Company Credit For  Perfect Sargodah","44900.00","0.00","1","1","2024-01-28 14:17:13","","","1");
INSERT INTO acc_transaction VALUES("196","20240128151840","Purchase","2023-12-31","10107","Inventory Debit For Supplier Sahar Al Fazal Sargodah","83800.00","0.00","1","1","2024-01-28 15:18:40","","","1");
INSERT INTO acc_transaction VALUES("197","20240128151840","Purchase","2023-12-31","502000020","Supplier .Sahar Al Fazal Sargodah","0.00","83800.00","1","1","2024-01-28 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("198","20240128151840","Purchase","2023-12-31","402","Company Credit For  Sahar Al Fazal Sargodah","83800.00","0.00","1","1","2024-01-28 15:18:40","","","1");
INSERT INTO acc_transaction VALUES("199","20240129142817","Purchase","2023-12-31","10107","Inventory Debit For Supplier Burq Sargodah","195905.00","0.00","1","1","2024-01-29 14:28:17","","","1");
INSERT INTO acc_transaction VALUES("200","20240129142817","Purchase","2023-12-31","502000021","Supplier .Burq Sargodah","0.00","195905.00","1","1","2024-01-29 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("201","20240129142817","Purchase","2023-12-31","402","Company Credit For  Burq Sargodah","195905.00","0.00","1","1","2024-01-29 14:28:17","","","1");
INSERT INTO acc_transaction VALUES("225","20240128142633","Purchase","2023-12-31","10107","Inventory Devit Supplier Asim Sargodah","81050.00","0.00","1","1","2024-01-29 15:54:46","","","1");
INSERT INTO acc_transaction VALUES("226","20240128142633","Purchase","2023-12-31","502000014","Supplier -Asim Sargodah","0.00","81050.00","1","1","2024-01-29 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("227","20240128142633","Purchase","2023-12-31","402","Company Credit For SupplierAsim Sargodah","81050.00","0.00","1","1","2024-01-29 15:54:46","","","1");
INSERT INTO acc_transaction VALUES("228","20240128142633","Purchase","2023-12-31","1020101","Cash in Hand For Supplier Asim Sargodah","0.00","0.00","1","1","2024-01-29 15:54:46","","","1");
INSERT INTO acc_transaction VALUES("229","20240128142633","Purchase","2023-12-31","502000014","Supplier . Asim Sargodah","0.00","0.00","1","1","2024-01-29 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("240","20240128150010","Purchase","2023-12-31","10107","Inventory Devit Supplier E M Sargodah","71566.00","0.00","1","1","2024-01-29 15:56:15","","","1");
INSERT INTO acc_transaction VALUES("241","20240128150010","Purchase","2023-12-31","502000017","Supplier -E M Sargodah","0.00","71566.00","1","1","2024-01-29 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("242","20240128150010","Purchase","2023-12-31","402","Company Credit For SupplierE M Sargodah","71566.00","0.00","1","1","2024-01-29 15:56:15","","","1");
INSERT INTO acc_transaction VALUES("243","20240128150010","Purchase","2023-12-31","1020101","Cash in Hand For Supplier E M Sargodah","0.00","0.00","1","1","2024-01-29 15:56:15","","","1");
INSERT INTO acc_transaction VALUES("244","20240128150010","Purchase","2023-12-31","502000017","Supplier . E M Sargodah","0.00","0.00","1","1","2024-01-29 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("273","20240131144117","Purchase","2023-12-31","10107","Inventory Devit Supplier Jawaid Wire","116480.00","0.00","1","1","2024-02-01 15:59:15","","","1");
INSERT INTO acc_transaction VALUES("274","20240131144117","Purchase","2023-12-31","502000024","Supplier -Jawaid Wire","0.00","116480.00","1","1","2024-02-01 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("275","20240131144117","Purchase","2023-12-31","402","Company Credit For SupplierJawaid Wire","116480.00","0.00","1","1","2024-02-01 15:59:15","","","1");
INSERT INTO acc_transaction VALUES("276","20240131144117","Purchase","2023-12-31","1020101","Cash in Hand For Supplier Jawaid Wire","0.00","0.00","1","1","2024-02-01 15:59:15","","","1");
INSERT INTO acc_transaction VALUES("277","20240131144117","Purchase","2023-12-31","502000024","Supplier . Jawaid Wire","0.00","0.00","1","1","2024-02-01 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("348","20240205160956","Purchase","2023-12-31","10107","Inventory Debit For Supplier Millat Traders Loose Item","31400.00","0.00","1","1","2024-02-05 16:09:56","","","1");
INSERT INTO acc_transaction VALUES("349","20240205160956","Purchase","2023-12-31","502000030","Supplier .Millat Traders Loose Item","0.00","31400.00","1","1","2024-02-05 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("350","20240205160956","Purchase","2023-12-31","402","Company Credit For  Millat Traders Loose Item","31400.00","0.00","1","1","2024-02-05 16:09:56","","","1");
INSERT INTO acc_transaction VALUES("463","20240129154322","Purchase","2023-12-31","10107","Inventory Devit Supplier Fareed Qasim","1740965.00","0.00","1","1","2024-02-12 15:43:37","","","1");
INSERT INTO acc_transaction VALUES("464","20240129154322","Purchase","2023-12-31","502000022","Supplier -Fareed Qasim","0.00","1740965.00","1","1","2024-02-12 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("465","20240129154322","Purchase","2023-12-31","402","Company Credit For SupplierFareed Qasim","1740965.00","0.00","1","1","2024-02-12 15:43:37","","","1");
INSERT INTO acc_transaction VALUES("466","20240129154322","Purchase","2023-12-31","1020101","Cash in Hand For Supplier Fareed Qasim","0.00","0.00","1","1","2024-02-12 15:43:37","","","1");
INSERT INTO acc_transaction VALUES("467","20240129154322","Purchase","2023-12-31","502000022","Supplier . Fareed Qasim","0.00","0.00","1","1","2024-02-12 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("478","20240131153527","Purchase","2023-12-31","10107","Inventory Devit Supplier Haji salman Karachi","79750.00","0.00","1","1","2024-02-12 16:11:03","","","1");
INSERT INTO acc_transaction VALUES("479","20240131153527","Purchase","2023-12-31","502000025","Supplier -Haji salman Karachi","0.00","79750.00","1","1","2024-02-12 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("480","20240131153527","Purchase","2023-12-31","402","Company Credit For SupplierHaji salman Karachi","79750.00","0.00","1","1","2024-02-12 16:11:03","","","1");
INSERT INTO acc_transaction VALUES("481","20240131153527","Purchase","2023-12-31","1020101","Cash in Hand For Supplier Haji salman Karachi","0.00","0.00","1","1","2024-02-12 16:11:03","","","1");
INSERT INTO acc_transaction VALUES("482","20240131153527","Purchase","2023-12-31","502000025","Supplier . Haji salman Karachi","0.00","0.00","1","1","2024-02-12 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("539","20240124145800","Purchase","2023-12-31","10107","Inventory Devit Supplier Arslan LED","64550.00","0.00","1","1","2024-02-14 09:32:13","","","1");
INSERT INTO acc_transaction VALUES("540","20240124145800","Purchase","2023-12-31","502000002","Supplier -Arslan LED","0.00","64550.00","1","1","2024-02-14 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("541","20240124145800","Purchase","2023-12-31","402","Company Credit For SupplierArslan LED","64550.00","0.00","1","1","2024-02-14 09:32:13","","","1");
INSERT INTO acc_transaction VALUES("542","20240124145800","Purchase","2023-12-31","1020101","Cash in Hand For Supplier Arslan LED","0.00","0.00","1","1","2024-02-14 09:32:13","","","1");
INSERT INTO acc_transaction VALUES("543","20240124145800","Purchase","2023-12-31","502000002","Supplier . Arslan LED","0.00","0.00","1","1","2024-02-14 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("569","20240128122919","Purchase","2023-12-31","10107","Inventory Devit Supplier ARY Sargodah","169650.00","0.00","1","1","2024-02-14 10:07:20","","","1");
INSERT INTO acc_transaction VALUES("570","20240128122919","Purchase","2023-12-31","502000012","Supplier -ARY Sargodah","0.00","169650.00","1","1","2024-02-14 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("571","20240128122919","Purchase","2023-12-31","402","Company Credit For SupplierARY Sargodah","169650.00","0.00","1","1","2024-02-14 10:07:20","","","1");
INSERT INTO acc_transaction VALUES("572","20240128122919","Purchase","2023-12-31","1020101","Cash in Hand For Supplier ARY Sargodah","0.00","0.00","1","1","2024-02-14 10:07:20","","","1");
INSERT INTO acc_transaction VALUES("573","20240128122919","Purchase","2023-12-31","502000012","Supplier . ARY Sargodah","0.00","0.00","1","1","2024-02-14 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("574","20240130155908","Purchase","2023-12-31","10107","Inventory Devit Supplier ARY Sargodah","15870.00","0.00","1","1","2024-02-14 10:07:32","","","1");
INSERT INTO acc_transaction VALUES("575","20240130155908","Purchase","2023-12-31","502000012","Supplier -ARY Sargodah","0.00","15870.00","1","1","2024-02-14 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("576","20240130155908","Purchase","2023-12-31","402","Company Credit For SupplierARY Sargodah","15870.00","0.00","1","1","2024-02-14 10:07:32","","","1");
INSERT INTO acc_transaction VALUES("577","20240130155908","Purchase","2023-12-31","1020101","Cash in Hand For Supplier ARY Sargodah","0.00","0.00","1","1","2024-02-14 10:07:32","","","1");
INSERT INTO acc_transaction VALUES("578","20240130155908","Purchase","2023-12-31","502000012","Supplier . ARY Sargodah","0.00","0.00","1","1","2024-02-14 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("702","20240210161624","Purchase","2024-01-01","10107","Inventory Devit Supplier Emaan Light House","38250.00","0.00","1","1","2024-02-17 16:26:04","","","1");
INSERT INTO acc_transaction VALUES("703","20240210161624","Purchase","2024-01-01","502000031","Supplier -Emaan Light House","0.00","38250.00","1","1","2024-02-17 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("704","20240210161624","Purchase","2024-01-01","402","Company Credit For SupplierEmaan Light House","38250.00","0.00","1","1","2024-02-17 16:26:04","","","1");
INSERT INTO acc_transaction VALUES("705","20240210161624","Purchase","2024-01-01","1020101","Cash in Hand For Supplier Emaan Light House","0.00","0.00","1","1","2024-02-17 16:26:04","","","1");
INSERT INTO acc_transaction VALUES("706","20240210161624","Purchase","2024-01-01","502000031","Supplier . Emaan Light House","0.00","0.00","1","1","2024-02-17 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("707","20240210151559","Purchase","2024-01-01","10107","Inventory Devit Supplier Emaan Light House","76311.00","0.00","1","1","2024-02-17 16:27:24","","","1");
INSERT INTO acc_transaction VALUES("708","20240210151559","Purchase","2024-01-01","502000031","Supplier -Emaan Light House","0.00","76311.00","1","1","2024-02-17 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("709","20240210151559","Purchase","2024-01-01","402","Company Credit For SupplierEmaan Light House","76311.00","0.00","1","1","2024-02-17 16:27:24","","","1");
INSERT INTO acc_transaction VALUES("710","20240210151559","Purchase","2024-01-01","1020101","Cash in Hand For Supplier Emaan Light House","0.00","0.00","1","1","2024-02-17 16:27:24","","","1");
INSERT INTO acc_transaction VALUES("711","20240210151559","Purchase","2024-01-01","502000031","Supplier . Emaan Light House","0.00","0.00","1","1","2024-02-17 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("712","20240210154644","Purchase","2024-01-01","10107","Inventory Devit Supplier Emaan Light House","7612.00","0.00","1","1","2024-02-17 16:28:19","","","1");
INSERT INTO acc_transaction VALUES("713","20240210154644","Purchase","2024-01-01","502000031","Supplier -Emaan Light House","0.00","7612.00","1","1","2024-02-17 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("714","20240210154644","Purchase","2024-01-01","402","Company Credit For SupplierEmaan Light House","7612.00","0.00","1","1","2024-02-17 16:28:19","","","1");
INSERT INTO acc_transaction VALUES("715","20240210154644","Purchase","2024-01-01","1020101","Cash in Hand For Supplier Emaan Light House","0.00","0.00","1","1","2024-02-17 16:28:19","","","1");
INSERT INTO acc_transaction VALUES("716","20240210154644","Purchase","2024-01-01","502000031","Supplier . Emaan Light House","0.00","0.00","1","1","2024-02-17 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("725","20240217164057","Purchase","2024-01-01","10107","Inventory Devit Supplier S.K Fan","126000.00","0.00","1","1","2024-02-17 16:41:58","","","1");
INSERT INTO acc_transaction VALUES("726","20240217164057","Purchase","2024-01-01","502000046","Supplier -S.K Fan","0.00","126000.00","1","1","2024-02-17 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("727","20240217164057","Purchase","2024-01-01","402","Company Credit For SupplierS.K Fan","126000.00","0.00","1","1","2024-02-17 16:41:58","","","1");
INSERT INTO acc_transaction VALUES("728","20240217164057","Purchase","2024-01-01","1020101","Cash in Hand For Supplier S.K Fan","0.00","0.00","1","1","2024-02-17 16:41:58","","","1");
INSERT INTO acc_transaction VALUES("729","20240217164057","Purchase","2024-01-01","502000046","Supplier . S.K Fan","0.00","0.00","1","1","2024-02-17 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("730","20240217152346","Purchase","2024-01-01","10107","Inventory Devit Supplier Haroon Pant","441900.00","0.00","1","1","2024-02-17 16:42:24","","","1");
INSERT INTO acc_transaction VALUES("731","20240217152346","Purchase","2024-01-01","502000045","Supplier -Haroon Pant","0.00","441900.00","1","1","2024-02-17 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("732","20240217152346","Purchase","2024-01-01","402","Company Credit For SupplierHaroon Pant","441900.00","0.00","1","1","2024-02-17 16:42:24","","","1");
INSERT INTO acc_transaction VALUES("733","20240217152346","Purchase","2024-01-01","1020101","Cash in Hand For Supplier Haroon Pant","0.00","0.00","1","1","2024-02-17 16:42:24","","","1");
INSERT INTO acc_transaction VALUES("734","20240217152346","Purchase","2024-01-01","502000045","Supplier . Haroon Pant","0.00","0.00","1","1","2024-02-17 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("735","20240217154738","Purchase","2024-01-01","10107","Inventory Devit Supplier Riaz Delux","10750.00","0.00","1","1","2024-02-17 16:43:07","","","1");
INSERT INTO acc_transaction VALUES("736","20240217154738","Purchase","2024-01-01","502000037","Supplier -Riaz Delux","0.00","10750.00","1","1","2024-02-17 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("737","20240217154738","Purchase","2024-01-01","402","Company Credit For SupplierRiaz Delux","10750.00","0.00","1","1","2024-02-17 16:43:07","","","1");
INSERT INTO acc_transaction VALUES("738","20240217154738","Purchase","2024-01-01","1020101","Cash in Hand For Supplier Riaz Delux","0.00","0.00","1","1","2024-02-17 16:43:07","","","1");
INSERT INTO acc_transaction VALUES("739","20240217154738","Purchase","2024-01-01","502000037","Supplier . Riaz Delux","0.00","0.00","1","1","2024-02-17 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("740","20240217153045","Purchase","2024-01-01","10107","Inventory Devit Supplier Naeem Pant","30000.00","0.00","1","1","2024-02-17 16:43:29","","","1");
INSERT INTO acc_transaction VALUES("741","20240217153045","Purchase","2024-01-01","502000044","Supplier -Naeem Pant","0.00","30000.00","1","1","2024-02-17 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("742","20240217153045","Purchase","2024-01-01","402","Company Credit For SupplierNaeem Pant","30000.00","0.00","1","1","2024-02-17 16:43:29","","","1");
INSERT INTO acc_transaction VALUES("743","20240217153045","Purchase","2024-01-01","1020101","Cash in Hand For Supplier Naeem Pant","0.00","0.00","1","1","2024-02-17 16:43:29","","","1");
INSERT INTO acc_transaction VALUES("744","20240217153045","Purchase","2024-01-01","502000044","Supplier . Naeem Pant","0.00","0.00","1","1","2024-02-17 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("745","20240217153659","Purchase","2024-01-01","10107","Inventory Devit Supplier Sindh Electri Hyderabad","158000.00","0.00","1","1","2024-02-17 16:43:50","","","1");
INSERT INTO acc_transaction VALUES("746","20240217153659","Purchase","2024-01-01","502000042","Supplier -Sindh Electri Hyderabad","0.00","158000.00","1","1","2024-02-17 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("747","20240217153659","Purchase","2024-01-01","402","Company Credit For SupplierSindh Electri Hyderabad","158000.00","0.00","1","1","2024-02-17 16:43:50","","","1");
INSERT INTO acc_transaction VALUES("748","20240217153659","Purchase","2024-01-01","1020101","Cash in Hand For Supplier Sindh Electri Hyderabad","0.00","0.00","1","1","2024-02-17 16:43:50","","","1");
INSERT INTO acc_transaction VALUES("749","20240217153659","Purchase","2024-01-01","502000042","Supplier . Sindh Electri Hyderabad","0.00","0.00","1","1","2024-02-17 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("771","20240214131722","Purchase","2024-01-01","10107","Inventory Devit Supplier Zahid Soomro Kotri","113230.00","0.00","1","1","2024-02-18 08:41:38","","","1");
INSERT INTO acc_transaction VALUES("772","20240214131722","Purchase","2024-01-01","502000043","Supplier -Zahid Soomro Kotri","0.00","113230.00","1","1","2024-02-18 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("773","20240214131722","Purchase","2024-01-01","402","Company Credit For SupplierZahid Soomro Kotri","113230.00","0.00","1","1","2024-02-18 08:41:38","","","1");
INSERT INTO acc_transaction VALUES("774","20240214131722","Purchase","2024-01-01","1020101","Cash in Hand For Supplier Zahid Soomro Kotri","0.00","0.00","1","1","2024-02-18 08:41:38","","","1");
INSERT INTO acc_transaction VALUES("775","20240214131722","Purchase","2024-01-01","502000043","Supplier . Zahid Soomro Kotri","0.00","0.00","1","1","2024-02-18 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("781","20240201145453","Purchase","2023-12-31","10107","Inventory Devit Supplier Fizan Wire","123946.00","0.00","1","1","2024-02-18 09:09:45","","","1");
INSERT INTO acc_transaction VALUES("782","20240201145453","Purchase","2023-12-31","502000026","Supplier -Fizan Wire","0.00","123946.00","1","1","2024-02-18 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("783","20240201145453","Purchase","2023-12-31","402","Company Credit For SupplierFizan Wire","123946.00","0.00","1","1","2024-02-18 09:09:45","","","1");
INSERT INTO acc_transaction VALUES("784","20240201145453","Purchase","2023-12-31","1020101","Cash in Hand For Supplier Fizan Wire","0.00","0.00","1","1","2024-02-18 09:09:45","","","1");
INSERT INTO acc_transaction VALUES("785","20240201145453","Purchase","2023-12-31","502000026","Supplier . Fizan Wire","0.00","0.00","1","1","2024-02-18 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("816","20240214120913","Purchase","2024-01-01","10107","Inventory Devit Supplier Royal Electri Karachi","124880.00","0.00","1","1","2024-02-18 09:32:52","","","1");
INSERT INTO acc_transaction VALUES("817","20240214120913","Purchase","2024-01-01","502000041","Supplier -Royal Electri Karachi","0.00","124880.00","1","1","2024-02-18 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("818","20240214120913","Purchase","2024-01-01","402","Company Credit For SupplierRoyal Electri Karachi","124880.00","0.00","1","1","2024-02-18 09:32:52","","","1");
INSERT INTO acc_transaction VALUES("819","20240214120913","Purchase","2024-01-01","1020101","Cash in Hand For Supplier Royal Electri Karachi","0.00","0.00","1","1","2024-02-18 09:32:52","","","1");
INSERT INTO acc_transaction VALUES("820","20240214120913","Purchase","2024-01-01","502000041","Supplier . Royal Electri Karachi","0.00","0.00","1","1","2024-02-18 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("826","20240218074400","Purchase","2024-01-01","10107","Inventory Devit Supplier Chilton Traders Karachi","15500.00","0.00","1","1","2024-02-18 09:34:16","","","1");
INSERT INTO acc_transaction VALUES("827","20240218074400","Purchase","2024-01-01","502000032","Supplier -Chilton Traders Karachi","0.00","15500.00","1","1","2024-02-18 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("828","20240218074400","Purchase","2024-01-01","402","Company Credit For SupplierChilton Traders Karachi","15500.00","0.00","1","1","2024-02-18 09:34:16","","","1");
INSERT INTO acc_transaction VALUES("829","20240218074400","Purchase","2024-01-01","1020101","Cash in Hand For Supplier Chilton Traders Karachi","0.00","0.00","1","1","2024-02-18 09:34:16","","","1");
INSERT INTO acc_transaction VALUES("830","20240218074400","Purchase","2024-01-01","502000032","Supplier . Chilton Traders Karachi","0.00","0.00","1","1","2024-02-18 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("856","20240124154656","Purchase","2023-12-31","10107","Inventory Devit Supplier Qureshi pipe wala","108500.00","0.00","1","1","2024-02-18 11:02:02","","","1");
INSERT INTO acc_transaction VALUES("857","20240124154656","Purchase","2023-12-31","502000004","Supplier -Qureshi pipe wala","0.00","108500.00","1","1","2024-02-18 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("858","20240124154656","Purchase","2023-12-31","402","Company Credit For SupplierQureshi pipe wala","108500.00","0.00","1","1","2024-02-18 11:02:02","","","1");
INSERT INTO acc_transaction VALUES("859","20240124154656","Purchase","2023-12-31","1020101","Cash in Hand For Supplier Qureshi pipe wala","0.00","0.00","1","1","2024-02-18 11:02:02","","","1");
INSERT INTO acc_transaction VALUES("860","20240124154656","Purchase","2023-12-31","502000004","Supplier . Qureshi pipe wala","0.00","0.00","1","1","2024-02-18 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("948","20240218121742","Purchase","2024-02-01","10107","Inventory Devit Supplier Fareed Qasim","1465584.00","0.00","1","1","2024-02-18 14:52:49","","","1");
INSERT INTO acc_transaction VALUES("949","20240218121742","Purchase","2024-02-01","502000022","Supplier -Fareed Qasim","0.00","1465584.00","1","1","2024-02-18 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("950","20240218121742","Purchase","2024-02-01","402","Company Credit For SupplierFareed Qasim","1465584.00","0.00","1","1","2024-02-18 14:52:49","","","1");
INSERT INTO acc_transaction VALUES("951","20240218121742","Purchase","2024-02-01","1020101","Cash in Hand For Supplier Fareed Qasim","0.00","0.00","1","1","2024-02-18 14:52:49","","","1");
INSERT INTO acc_transaction VALUES("952","20240218121742","Purchase","2024-02-01","502000022","Supplier . Fareed Qasim","0.00","0.00","1","1","2024-02-18 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("953","20240218112422","Purchase","2024-02-01","10107","Inventory Devit Supplier Zahid Soomro Kotri","150700.00","0.00","1","1","2024-02-18 14:53:13","","","1");
INSERT INTO acc_transaction VALUES("954","20240218112422","Purchase","2024-02-01","502000043","Supplier -Zahid Soomro Kotri","0.00","150700.00","1","1","2024-02-18 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("955","20240218112422","Purchase","2024-02-01","402","Company Credit For SupplierZahid Soomro Kotri","150700.00","0.00","1","1","2024-02-18 14:53:13","","","1");
INSERT INTO acc_transaction VALUES("956","20240218112422","Purchase","2024-02-01","1020101","Cash in Hand For Supplier Zahid Soomro Kotri","0.00","0.00","1","1","2024-02-18 14:53:13","","","1");
INSERT INTO acc_transaction VALUES("957","20240218112422","Purchase","2024-02-01","502000043","Supplier . Zahid Soomro Kotri","0.00","0.00","1","1","2024-02-18 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("958","5845776228","INV","2024-02-18","10107","Inventory credit For Invoice No1000","0.00","2260.00","1","1","2024-02-18 15:20:19","","","1");
INSERT INTO acc_transaction VALUES("959","5845776228","INV","2024-02-18","102030000002","Customer debit For Invoice No -  1000 Customer Walking Customer","2525.00","0.00","1","1","2024-02-18 15:20:19","","","1");
INSERT INTO acc_transaction VALUES("960","5845776228","INVOICE","2024-02-18","303","Sale Income For Invoice NO - 1000 Customer Walking Customer","0.00","2525.00","1","1","2024-02-18 15:20:19","","","1");
INSERT INTO acc_transaction VALUES("961","20240218143236","Purchase","2024-02-01","10107","Inventory Devit Supplier G.One LED Light","348350.00","0.00","1","1","2024-02-18 15:26:55","","","1");
INSERT INTO acc_transaction VALUES("962","20240218143236","Purchase","2024-02-01","502000027","Supplier -G.One LED Light","0.00","348350.00","1","1","2024-02-18 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("963","20240218143236","Purchase","2024-02-01","402","Company Credit For SupplierG.One LED Light","348350.00","0.00","1","1","2024-02-18 15:26:55","","","1");
INSERT INTO acc_transaction VALUES("964","20240218143236","Purchase","2024-02-01","1020101","Cash in Hand For Supplier G.One LED Light","0.00","0.00","1","1","2024-02-18 15:26:55","","","1");
INSERT INTO acc_transaction VALUES("965","20240218143236","Purchase","2024-02-01","502000027","Supplier . G.One LED Light","0.00","0.00","1","1","2024-02-18 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("966","20240201155743","Purchase","2023-12-31","10107","Inventory Devit Supplier G.One LED Light","203765.00","0.00","1","1","2024-02-18 15:31:18","","","1");
INSERT INTO acc_transaction VALUES("967","20240201155743","Purchase","2023-12-31","502000027","Supplier -G.One LED Light","0.00","203765.00","1","1","2024-02-18 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("968","20240201155743","Purchase","2023-12-31","402","Company Credit For SupplierG.One LED Light","203765.00","0.00","1","1","2024-02-18 15:31:18","","","1");
INSERT INTO acc_transaction VALUES("969","20240201155743","Purchase","2023-12-31","1020101","Cash in Hand For Supplier G.One LED Light","0.00","0.00","1","1","2024-02-18 15:31:18","","","1");
INSERT INTO acc_transaction VALUES("970","20240201155743","Purchase","2023-12-31","502000027","Supplier . G.One LED Light","0.00","0.00","1","1","2024-02-18 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("971","6124985648","INV","2024-02-18","10107","Inventory credit For Invoice No1001","0.00","500.00","1","1","2024-02-18 15:33:11","","","1");
INSERT INTO acc_transaction VALUES("972","6124985648","INV","2024-02-18","102030000002","Customer debit For Invoice No -  1001 Customer Walking Customer","600.00","0.00","1","1","2024-02-18 15:33:11","","","1");
INSERT INTO acc_transaction VALUES("973","6124985648","INVOICE","2024-02-18","303","Sale Income For Invoice NO - 1001 Customer Walking Customer","0.00","600.00","1","1","2024-02-18 15:33:11","","","1");
INSERT INTO acc_transaction VALUES("1003","20240124152118","Purchase","2023-12-31","10107","Inventory Devit Supplier Pak E \\ S Khi","90170.00","0.00","1","1","2024-02-19 08:41:01","","","1");
INSERT INTO acc_transaction VALUES("1004","20240124152118","Purchase","2023-12-31","502000003","Supplier -Pak E \\ S Khi","0.00","90170.00","1","1","2024-02-19 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1005","20240124152118","Purchase","2023-12-31","402","Company Credit For SupplierPak E \\ S Khi","90170.00","0.00","1","1","2024-02-19 08:41:01","","","1");
INSERT INTO acc_transaction VALUES("1006","20240124152118","Purchase","2023-12-31","1020101","Cash in Hand For Supplier Pak E \\ S Khi","0.00","0.00","1","1","2024-02-19 08:41:01","","","1");
INSERT INTO acc_transaction VALUES("1007","20240124152118","Purchase","2023-12-31","502000003","Supplier . Pak E \\ S Khi","0.00","0.00","1","1","2024-02-19 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1008","20240219084954","Purchase","2024-02-01","10107","Inventory Debit For Supplier Pak E \\ S Khi","204320.00","0.00","1","1","2024-02-19 08:49:54","","","1");
INSERT INTO acc_transaction VALUES("1009","20240219084954","Purchase","2024-02-01","502000003","Supplier .Pak E \\ S Khi","0.00","204320.00","1","1","2024-02-19 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1010","20240219084954","Purchase","2024-02-01","402","Company Credit For  Pak E \\ S Khi","204320.00","0.00","1","1","2024-02-19 08:49:54","","","1");
INSERT INTO acc_transaction VALUES("1016","20240213150708","Purchase","2024-01-01","10107","Inventory Devit Supplier Cash Item ","146240.00","0.00","1","1","2024-02-19 09:36:49","","","1");
INSERT INTO acc_transaction VALUES("1017","20240213150708","Purchase","2024-01-01","502000047","Supplier -Cash Item ","0.00","146240.00","1","1","2024-02-19 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1018","20240213150708","Purchase","2024-01-01","402","Company Credit For SupplierCash Item ","146240.00","0.00","1","1","2024-02-19 09:36:49","","","1");
INSERT INTO acc_transaction VALUES("1019","20240213150708","Purchase","2024-01-01","1020101","Cash in Hand For Supplier Cash Item ","0.00","0.00","1","1","2024-02-19 09:36:49","","","1");
INSERT INTO acc_transaction VALUES("1020","20240213150708","Purchase","2024-01-01","502000047","Supplier . Cash Item ","0.00","0.00","1","1","2024-02-19 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1044","20240219100856","Purchase","2024-02-01","10107","Inventory Debit For Supplier Memon LAD Light","5500.00","0.00","1","1","2024-02-19 10:08:56","","","1");
INSERT INTO acc_transaction VALUES("1045","20240219100856","Purchase","2024-02-01","502000008","Supplier .Memon LAD Light","0.00","5500.00","1","1","2024-02-19 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1046","20240219100856","Purchase","2024-02-01","402","Company Credit For  Memon LAD Light","5500.00","0.00","1","1","2024-02-19 10:08:56","","","1");
INSERT INTO acc_transaction VALUES("1047","20240219101122","Purchase","2024-02-01","10107","Inventory Debit For Supplier S.K Fan","12500.00","0.00","1","1","2024-02-19 10:11:22","","","1");
INSERT INTO acc_transaction VALUES("1048","20240219101122","Purchase","2024-02-01","502000046","Supplier .S.K Fan","0.00","12500.00","1","1","2024-02-19 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1049","20240219101122","Purchase","2024-02-01","402","Company Credit For  S.K Fan","12500.00","0.00","1","1","2024-02-19 10:11:22","","","1");
INSERT INTO acc_transaction VALUES("1050","20240219101430","Purchase","2024-02-01","10107","Inventory Debit For Supplier Akram PVC","6336.00","0.00","1","1","2024-02-19 10:14:30","","","1");
INSERT INTO acc_transaction VALUES("1051","20240219101430","Purchase","2024-02-01","502000006","Supplier .Akram PVC","0.00","6336.00","1","1","2024-02-19 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1052","20240219101430","Purchase","2024-02-01","402","Company Credit For  Akram PVC","6336.00","0.00","1","1","2024-02-19 10:14:30","","","1");
INSERT INTO acc_transaction VALUES("1085","4977174268","INV","2024-02-19","10107","Inventory credit For Invoice No1002","0.00","4240.00","1","1","2024-02-19 11:36:21","","","1");
INSERT INTO acc_transaction VALUES("1086","4977174268","INVOICE","2024-02-19","303","Sale Income From Invoice NO - 1002 Customer Walking Customer","0.00","2370.00","1","1","2024-02-19 11:36:21","","","1");
INSERT INTO acc_transaction VALUES("1087","4977174268","INV","2024-02-19","102030000002","Customer debit For Invoice NO - 1002 customer-  Walking Customer","2370.00","0.00","1","1","2024-02-19 11:36:21","","","1");
INSERT INTO acc_transaction VALUES("1098","20240128145546","Purchase","2023-12-31","10107","Inventory Devit Supplier Sonex Sargodah","33020.00","0.00","1","1","2024-02-19 11:39:51","","","1");
INSERT INTO acc_transaction VALUES("1099","20240128145546","Purchase","2023-12-31","502000018","Supplier -Sonex Sargodah","0.00","33020.00","1","1","2024-02-19 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1100","20240128145546","Purchase","2023-12-31","402","Company Credit For SupplierSonex Sargodah","33020.00","0.00","1","1","2024-02-19 11:39:51","","","1");
INSERT INTO acc_transaction VALUES("1101","20240128145546","Purchase","2023-12-31","1020101","Cash in Hand For Supplier Sonex Sargodah","0.00","0.00","1","1","2024-02-19 11:39:51","","","1");
INSERT INTO acc_transaction VALUES("1102","20240128145546","Purchase","2023-12-31","502000018","Supplier . Sonex Sargodah","0.00","0.00","1","1","2024-02-19 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1103","20240204162308","Purchase","2023-12-31","10107","Inventory Devit Supplier Arfeen Wire (Million)","1732885.00","0.00","1","1","2024-02-19 11:40:35","","","1");
INSERT INTO acc_transaction VALUES("1104","20240204162308","Purchase","2023-12-31","502000029","Supplier -Arfeen Wire (Million)","0.00","1732885.00","1","1","2024-02-19 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1105","20240204162308","Purchase","2023-12-31","402","Company Credit For SupplierArfeen Wire (Million)","1732885.00","0.00","1","1","2024-02-19 11:40:35","","","1");
INSERT INTO acc_transaction VALUES("1106","20240204162308","Purchase","2023-12-31","1020101","Cash in Hand For Supplier Arfeen Wire (Million)","0.00","0.00","1","1","2024-02-19 11:40:35","","","1");
INSERT INTO acc_transaction VALUES("1107","20240204162308","Purchase","2023-12-31","502000029","Supplier . Arfeen Wire (Million)","0.00","0.00","1","1","2024-02-19 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1108","20240203150856","Purchase","2023-12-31","10107","Inventory Devit Supplier Arfeen Wire (Million)","204000.00","0.00","1","1","2024-02-19 11:41:00","","","1");
INSERT INTO acc_transaction VALUES("1109","20240203150856","Purchase","2023-12-31","502000029","Supplier -Arfeen Wire (Million)","0.00","204000.00","1","1","2024-02-19 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1110","20240203150856","Purchase","2023-12-31","402","Company Credit For SupplierArfeen Wire (Million)","204000.00","0.00","1","1","2024-02-19 11:41:00","","","1");
INSERT INTO acc_transaction VALUES("1111","20240203150856","Purchase","2023-12-31","1020101","Cash in Hand For Supplier Arfeen Wire (Million)","0.00","0.00","1","1","2024-02-19 11:41:00","","","1");
INSERT INTO acc_transaction VALUES("1112","20240203150856","Purchase","2023-12-31","502000029","Supplier . Arfeen Wire (Million)","0.00","0.00","1","1","2024-02-19 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1113","20240205145350","Purchase","2023-12-31","10107","Inventory Devit Supplier Arfeen Wire (Million)","260050.00","0.00","1","1","2024-02-19 11:43:21","","","1");
INSERT INTO acc_transaction VALUES("1114","20240205145350","Purchase","2023-12-31","502000029","Supplier -Arfeen Wire (Million)","0.00","260050.00","1","1","2024-02-19 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1115","20240205145350","Purchase","2023-12-31","402","Company Credit For SupplierArfeen Wire (Million)","260050.00","0.00","1","1","2024-02-19 11:43:21","","","1");
INSERT INTO acc_transaction VALUES("1116","20240205145350","Purchase","2023-12-31","1020101","Cash in Hand For Supplier Arfeen Wire (Million)","0.00","0.00","1","1","2024-02-19 11:43:21","","","1");
INSERT INTO acc_transaction VALUES("1117","20240205145350","Purchase","2023-12-31","502000029","Supplier . Arfeen Wire (Million)","0.00","0.00","1","1","2024-02-19 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1118","4612744893","INV","2024-02-19","10107","Inventory credit For Invoice No1003","0.00","5910.00","1","1","2024-02-19 12:02:15","","","1");
INSERT INTO acc_transaction VALUES("1119","4612744893","INV","2024-02-19","102030000002","Customer debit For Invoice No -  1003 Customer Walking Customer","5550.00","0.00","1","1","2024-02-19 12:02:15","","","1");
INSERT INTO acc_transaction VALUES("1120","4612744893","INVOICE","2024-02-19","303","Sale Income For Invoice NO - 1003 Customer Walking Customer","0.00","5550.00","1","1","2024-02-19 12:02:15","","","1");
INSERT INTO acc_transaction VALUES("1121","2567782964","INV","2024-02-19","10107","Inventory credit For Invoice No1004","0.00","43551.00","1","1","2024-02-19 12:14:47","","","1");
INSERT INTO acc_transaction VALUES("1122","2567782964","INV","2024-02-19","102030000002","Customer debit For Invoice No -  1004 Customer Walking Customer","31510.00","0.00","1","1","2024-02-19 12:14:47","","","1");
INSERT INTO acc_transaction VALUES("1123","2567782964","INVOICE","2024-02-19","303","Sale Income For Invoice NO - 1004 Customer Walking Customer","0.00","31510.00","1","1","2024-02-19 12:14:47","","","1");
INSERT INTO acc_transaction VALUES("1124","9779858312","INV","2024-02-19","10107","Inventory credit For Invoice No1005","0.00","26190.00","1","1","2024-02-19 12:30:13","","","1");
INSERT INTO acc_transaction VALUES("1125","9779858312","INV","2024-02-19","102030000002","Customer debit For Invoice No -  1005 Customer Walking Customer","10640.00","0.00","1","1","2024-02-19 12:30:13","","","1");
INSERT INTO acc_transaction VALUES("1126","9779858312","INVOICE","2024-02-19","303","Sale Income For Invoice NO - 1005 Customer Walking Customer","0.00","10640.00","1","1","2024-02-19 12:30:13","","","1");
INSERT INTO acc_transaction VALUES("1130","3284257142","INV","2024-02-19","10107","Inventory credit For Invoice No1006","0.00","8040.00","1","1","2024-02-19 12:36:42","","","1");
INSERT INTO acc_transaction VALUES("1131","3284257142","INVOICE","2024-02-19","303","Sale Income From Invoice NO - 1006 Customer Walking Customer","0.00","5996.00","1","1","2024-02-19 12:36:42","","","1");
INSERT INTO acc_transaction VALUES("1132","3284257142","INV","2024-02-19","102030000002","Customer debit For Invoice NO - 1006 customer-  Walking Customer","5996.00","0.00","1","1","2024-02-19 12:36:42","","","1");
INSERT INTO acc_transaction VALUES("1133","9175169491","INV","2024-02-19","10107","Inventory credit For Invoice No1007","0.00","2700.00","1","1","2024-02-19 12:39:47","","","1");
INSERT INTO acc_transaction VALUES("1134","9175169491","INV","2024-02-19","102030000002","Customer debit For Invoice No -  1007 Customer Walking Customer","2500.00","0.00","1","1","2024-02-19 12:39:47","","","1");
INSERT INTO acc_transaction VALUES("1135","9175169491","INVOICE","2024-02-19","303","Sale Income For Invoice NO - 1007 Customer Walking Customer","0.00","2500.00","1","1","2024-02-19 12:39:47","","","1");
INSERT INTO acc_transaction VALUES("1147","8115955164","INV","2024-02-19","10107","Inventory credit For Invoice No1009","0.00","5290.00","1","1","2024-02-19 13:14:41","","","1");
INSERT INTO acc_transaction VALUES("1148","8115955164","INV","2024-02-19","102030000002","Customer debit For Invoice No -  1009 Customer Walking Customer","3300.00","0.00","1","1","2024-02-19 13:14:41","","","1");
INSERT INTO acc_transaction VALUES("1149","8115955164","INVOICE","2024-02-19","303","Sale Income For Invoice NO - 1009 Customer Walking Customer","0.00","3300.00","1","1","2024-02-19 13:14:41","","","1");
INSERT INTO acc_transaction VALUES("1150","6448414167","INV","2024-02-19","10107","Inventory credit For Invoice No1010","0.00","4000.00","1","1","2024-02-19 13:18:55","","","1");
INSERT INTO acc_transaction VALUES("1151","6448414167","INV","2024-02-19","102030000002","Customer debit For Invoice No -  1010 Customer Walking Customer","5000.00","0.00","1","1","2024-02-19 13:18:55","","","1");
INSERT INTO acc_transaction VALUES("1152","6448414167","INVOICE","2024-02-19","303","Sale Income For Invoice NO - 1010 Customer Walking Customer","0.00","5000.00","1","1","2024-02-19 13:18:55","","","1");
INSERT INTO acc_transaction VALUES("1153","7816741612","INV","2024-02-19","10107","Inventory credit For Invoice No1011","0.00","23487.00","1","1","2024-02-19 13:22:02","","","1");
INSERT INTO acc_transaction VALUES("1154","7816741612","INV","2024-02-19","102030000002","Customer debit For Invoice No -  1011 Customer Walking Customer","23100.00","0.00","1","1","2024-02-19 13:22:02","","","1");
INSERT INTO acc_transaction VALUES("1155","7816741612","INVOICE","2024-02-19","303","Sale Income For Invoice NO - 1011 Customer Walking Customer","0.00","23100.00","1","1","2024-02-19 13:22:02","","","1");
INSERT INTO acc_transaction VALUES("1159","5669212287","INV","2024-02-19","10107","Inventory credit For Invoice No1008","0.00","426967.00","1","1","2024-02-19 13:36:05","","","1");
INSERT INTO acc_transaction VALUES("1160","5669212287","INVOICE","2024-02-19","303","Sale Income From Invoice NO - 1008 Customer Walking Customer","0.00","111260.00","1","1","2024-02-19 13:36:05","","","1");
INSERT INTO acc_transaction VALUES("1161","5669212287","INV","2024-02-19","102030000002","Customer debit For Invoice NO - 1008 customer-  Walking Customer","111260.00","0.00","1","1","2024-02-19 13:36:05","","","1");
INSERT INTO acc_transaction VALUES("1175","20240205154059","Purchase","2023-12-31","10107","Inventory Devit Supplier Arfeen Wire (Million)","551500.00","0.00","1","1","2024-02-19 13:40:31","","","1");
INSERT INTO acc_transaction VALUES("1176","20240205154059","Purchase","2023-12-31","502000029","Supplier -Arfeen Wire (Million)","0.00","551500.00","1","1","2024-02-19 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1177","20240205154059","Purchase","2023-12-31","402","Company Credit For SupplierArfeen Wire (Million)","551500.00","0.00","1","1","2024-02-19 13:40:31","","","1");
INSERT INTO acc_transaction VALUES("1178","20240205154059","Purchase","2023-12-31","1020101","Cash in Hand For Supplier Arfeen Wire (Million)","0.00","0.00","1","1","2024-02-19 13:40:31","","","1");
INSERT INTO acc_transaction VALUES("1179","20240205154059","Purchase","2023-12-31","502000029","Supplier . Arfeen Wire (Million)","0.00","0.00","1","1","2024-02-19 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1180","4995667463","INV","2024-02-19","10107","Inventory credit For Invoice No1012","0.00","28408.00","1","1","2024-02-19 13:41:07","","","1");
INSERT INTO acc_transaction VALUES("1181","4995667463","INVOICE","2024-02-19","303","Sale Income From Invoice NO - 1012 Customer Walking Customer","0.00","24320.00","1","1","2024-02-19 13:41:07","","","1");
INSERT INTO acc_transaction VALUES("1182","4995667463","INV","2024-02-19","102030000002","Customer debit For Invoice NO - 1012 customer-  Walking Customer","24320.00","0.00","1","1","2024-02-19 13:41:07","","","1");
INSERT INTO acc_transaction VALUES("1191","20240205171507","Purchase","2023-12-31","10107","Inventory Devit Supplier Arfeen Wire (Million)","89600.00","0.00","1","1","2024-02-19 13:53:46","","","1");
INSERT INTO acc_transaction VALUES("1192","20240205171507","Purchase","2023-12-31","502000029","Supplier -Arfeen Wire (Million)","0.00","89600.00","1","1","2024-02-19 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1193","20240205171507","Purchase","2023-12-31","402","Company Credit For SupplierArfeen Wire (Million)","89600.00","0.00","1","1","2024-02-19 13:53:46","","","1");
INSERT INTO acc_transaction VALUES("1194","20240205171507","Purchase","2023-12-31","1020101","Cash in Hand For Supplier Arfeen Wire (Million)","0.00","0.00","1","1","2024-02-19 13:53:46","","","1");
INSERT INTO acc_transaction VALUES("1195","20240205171507","Purchase","2023-12-31","502000029","Supplier . Arfeen Wire (Million)","0.00","0.00","1","1","2024-02-19 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1199","7328171614","INV","2024-02-19","10107","Inventory credit For Invoice No1013","0.00","157367.00","1","1","2024-02-19 14:12:44","","","1");
INSERT INTO acc_transaction VALUES("1200","7328171614","INVOICE","2024-02-19","303","Sale Income From Invoice NO - 1013 Customer Walking Customer","0.00","50310.00","1","1","2024-02-19 14:12:44","","","1");
INSERT INTO acc_transaction VALUES("1201","7328171614","INV","2024-02-19","102030000002","Customer debit For Invoice NO - 1013 customer-  Walking Customer","50310.00","0.00","1","1","2024-02-19 14:12:44","","","1");
INSERT INTO acc_transaction VALUES("1202","6686419811","INV","2024-02-19","10107","Inventory credit For Invoice No1014","0.00","10541.00","1","1","2024-02-19 14:21:46","","","1");
INSERT INTO acc_transaction VALUES("1203","6686419811","INV","2024-02-19","102030000002","Customer debit For Invoice No -  1014 Customer Walking Customer","6780.00","0.00","1","1","2024-02-19 14:21:46","","","1");
INSERT INTO acc_transaction VALUES("1204","6686419811","INVOICE","2024-02-19","303","Sale Income For Invoice NO - 1014 Customer Walking Customer","0.00","6780.00","1","1","2024-02-19 14:21:46","","","1");
INSERT INTO acc_transaction VALUES("1208","4856684174","INV","2024-02-19","10107","Inventory credit For Invoice No1015","0.00","11498.00","1","1","2024-02-19 14:36:57","","","1");
INSERT INTO acc_transaction VALUES("1209","4856684174","INVOICE","2024-02-19","303","Sale Income From Invoice NO - 1015 Customer Walking Customer","0.00","7650.00","1","1","2024-02-19 14:36:57","","","1");
INSERT INTO acc_transaction VALUES("1210","4856684174","INV","2024-02-19","102030000002","Customer debit For Invoice NO - 1015 customer-  Walking Customer","7650.00","0.00","1","1","2024-02-19 14:36:57","","","1");
INSERT INTO acc_transaction VALUES("1211","1826916967","INV","2024-02-19","10107","Inventory credit For Invoice No1016","0.00","755.00","1","1","2024-02-19 14:41:18","","","1");
INSERT INTO acc_transaction VALUES("1212","1826916967","INV","2024-02-19","102030000002","Customer debit For Invoice No -  1016 Customer Walking Customer","910.00","0.00","1","1","2024-02-19 14:41:18","","","1");
INSERT INTO acc_transaction VALUES("1213","1826916967","INVOICE","2024-02-19","303","Sale Income For Invoice NO - 1016 Customer Walking Customer","0.00","910.00","1","1","2024-02-19 14:41:18","","","1");
INSERT INTO acc_transaction VALUES("1214","5976692598","INV","2024-02-19","10107","Inventory credit For Invoice No1017","0.00","6250.00","1","1","2024-02-19 14:50:25","","","1");
INSERT INTO acc_transaction VALUES("1215","5976692598","INV","2024-02-19","102030000002","Customer debit For Invoice No -  1017 Customer Walking Customer","2500.00","0.00","1","1","2024-02-19 14:50:25","","","1");
INSERT INTO acc_transaction VALUES("1216","5976692598","INVOICE","2024-02-19","303","Sale Income For Invoice NO - 1017 Customer Walking Customer","0.00","2500.00","1","1","2024-02-19 14:50:25","","","1");
INSERT INTO acc_transaction VALUES("1217","3371369953","INV","2024-02-19","10107","Inventory credit For Invoice No1018","0.00","95716.00","1","1","2024-02-19 14:55:12","","","1");
INSERT INTO acc_transaction VALUES("1218","3371369953","INV","2024-02-19","102030000002","Customer debit For Invoice No -  1018 Customer Walking Customer","19820.00","0.00","1","1","2024-02-19 14:55:12","","","1");
INSERT INTO acc_transaction VALUES("1219","3371369953","INVOICE","2024-02-19","303","Sale Income For Invoice NO - 1018 Customer Walking Customer","0.00","19820.00","1","1","2024-02-19 14:55:12","","","1");
INSERT INTO acc_transaction VALUES("1233","7976724629","INV","2024-02-20","10107","Inventory credit For Invoice No1019","0.00","46716.00","1","1","2024-02-20 07:43:26","","","1");
INSERT INTO acc_transaction VALUES("1234","7976724629","INVOICE","2024-02-20","303","Sale Income From Invoice NO - 1019 Customer Walking Customer","0.00","15520.00","1","1","2024-02-20 07:43:26","","","1");
INSERT INTO acc_transaction VALUES("1235","7976724629","INV","2024-02-20","102030000002","Customer debit For Invoice NO - 1019 customer-  Walking Customer","15520.00","0.00","1","1","2024-02-20 07:43:26","","","1");
INSERT INTO acc_transaction VALUES("1251","20240130154304","Purchase","2023-12-31","10107","Inventory Devit Supplier Aijaz PCV Karachi","205690.00","0.00","1","1","2024-02-20 07:58:00","","","1");
INSERT INTO acc_transaction VALUES("1252","20240130154304","Purchase","2023-12-31","502000023","Supplier -Aijaz PCV Karachi","0.00","205690.00","1","1","2024-02-20 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1253","20240130154304","Purchase","2023-12-31","402","Company Credit For SupplierAijaz PCV Karachi","205690.00","0.00","1","1","2024-02-20 07:58:00","","","1");
INSERT INTO acc_transaction VALUES("1254","20240130154304","Purchase","2023-12-31","1020101","Cash in Hand For Supplier Aijaz PCV Karachi","0.00","0.00","1","1","2024-02-20 07:58:00","","","1");
INSERT INTO acc_transaction VALUES("1255","20240130154304","Purchase","2023-12-31","502000023","Supplier . Aijaz PCV Karachi","0.00","0.00","1","1","2024-02-20 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1269","1249729836","INV","2024-02-20","10107","Inventory credit For Invoice No1020","0.00","677616.00","1","1","2024-02-20 08:30:22","","","1");
INSERT INTO acc_transaction VALUES("1270","1249729836","INVOICE","2024-02-20","303","Sale Income From Invoice NO - 1020 Customer Walking Customer","0.00","50010.00","1","1","2024-02-20 08:30:22","","","1");
INSERT INTO acc_transaction VALUES("1271","1249729836","INV","2024-02-20","102030000002","Customer debit For Invoice NO - 1020 customer-  Walking Customer","50010.00","0.00","1","1","2024-02-20 08:30:22","","","1");
INSERT INTO acc_transaction VALUES("1275","20240218081020","Purchase","2024-01-01","10107","Inventory Devit Supplier Abdul Hammed Panel wala","61450.00","0.00","1","1","2024-02-20 08:33:24","","","1");
INSERT INTO acc_transaction VALUES("1276","20240218081020","Purchase","2024-01-01","502000048","Supplier -Abdul Hammed Panel wala","0.00","61450.00","1","1","2024-02-20 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1277","20240218081020","Purchase","2024-01-01","402","Company Credit For SupplierAbdul Hammed Panel wala","61450.00","0.00","1","1","2024-02-20 08:33:24","","","1");
INSERT INTO acc_transaction VALUES("1278","20240218081020","Purchase","2024-01-01","1020101","Cash in Hand For Supplier Abdul Hammed Panel wala","0.00","0.00","1","1","2024-02-20 08:33:24","","","1");
INSERT INTO acc_transaction VALUES("1279","20240218081020","Purchase","2024-01-01","502000048","Supplier . Abdul Hammed Panel wala","0.00","0.00","1","1","2024-02-20 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1280","9759274115","INV","2024-02-20","10107","Inventory credit For Invoice No1021","0.00","20260.00","1","1","2024-02-20 08:34:49","","","1");
INSERT INTO acc_transaction VALUES("1281","9759274115","INVOICE","2024-02-20","303","Sale Income From Invoice NO - 1021 Customer Walking Customer","0.00","11010.00","1","1","2024-02-20 08:34:49","","","1");
INSERT INTO acc_transaction VALUES("1282","9759274115","INV","2024-02-20","102030000002","Customer debit For Invoice NO - 1021 customer-  Walking Customer","11010.00","0.00","1","1","2024-02-20 08:34:49","","","1");
INSERT INTO acc_transaction VALUES("1289","7677745934","INV","2024-02-20","10107","Inventory credit For Invoice No1022","0.00","20455.00","1","1","2024-02-20 08:49:50","","","1");
INSERT INTO acc_transaction VALUES("1290","7677745934","INVOICE","2024-02-20","303","Sale Income From Invoice NO - 1022 Customer Walking Customer","0.00","7960.00","1","1","2024-02-20 08:49:50","","","1");
INSERT INTO acc_transaction VALUES("1291","7677745934","INV","2024-02-20","102030000002","Customer debit For Invoice NO - 1022 customer-  Walking Customer","7960.00","0.00","1","1","2024-02-20 08:49:50","","","1");
INSERT INTO acc_transaction VALUES("1303","20240203141705","Purchase","2023-12-31","10107","Inventory Devit Supplier Moin PVC Karachi","298190.00","0.00","1","1","2024-02-20 09:01:16","","","1");
INSERT INTO acc_transaction VALUES("1304","20240203141705","Purchase","2023-12-31","502000028","Supplier -Moin PVC Karachi","0.00","298190.00","1","1","2024-02-20 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1305","20240203141705","Purchase","2023-12-31","402","Company Credit For SupplierMoin PVC Karachi","298190.00","0.00","1","1","2024-02-20 09:01:16","","","1");
INSERT INTO acc_transaction VALUES("1306","20240203141705","Purchase","2023-12-31","1020101","Cash in Hand For Supplier Moin PVC Karachi","0.00","0.00","1","1","2024-02-20 09:01:16","","","1");
INSERT INTO acc_transaction VALUES("1307","20240203141705","Purchase","2023-12-31","502000028","Supplier . Moin PVC Karachi","0.00","0.00","1","1","2024-02-20 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1311","6139664445","INV","2024-02-20","10107","Inventory credit For Invoice No1024","0.00","35050.00","1","1","2024-02-20 09:06:53","","","1");
INSERT INTO acc_transaction VALUES("1312","6139664445","INV","2024-02-20","102030000002","Customer debit For Invoice No -  1024 Customer Walking Customer","24740.00","0.00","1","1","2024-02-20 09:06:53","","","1");
INSERT INTO acc_transaction VALUES("1313","6139664445","INVOICE","2024-02-20","303","Sale Income For Invoice NO - 1024 Customer Walking Customer","0.00","24740.00","1","1","2024-02-20 09:06:53","","","1");
INSERT INTO acc_transaction VALUES("1314","9814175468","INV","2024-02-20","10107","Inventory credit For Invoice No1025","0.00","260.00","1","1","2024-02-20 09:08:08","","","1");
INSERT INTO acc_transaction VALUES("1315","9814175468","INV","2024-02-20","102030000002","Customer debit For Invoice No -  1025 Customer Walking Customer","400.00","0.00","1","1","2024-02-20 09:08:08","","","1");
INSERT INTO acc_transaction VALUES("1316","9814175468","INVOICE","2024-02-20","303","Sale Income For Invoice NO - 1025 Customer Walking Customer","0.00","400.00","1","1","2024-02-20 09:08:08","","","1");
INSERT INTO acc_transaction VALUES("1317","8729851784","INV","2024-02-20","10107","Inventory credit For Invoice No1026","0.00","2060.00","1","1","2024-02-20 09:09:24","","","1");
INSERT INTO acc_transaction VALUES("1318","8729851784","INV","2024-02-20","102030000002","Customer debit For Invoice No -  1026 Customer Walking Customer","2400.00","0.00","1","1","2024-02-20 09:09:24","","","1");
INSERT INTO acc_transaction VALUES("1319","8729851784","INVOICE","2024-02-20","303","Sale Income For Invoice NO - 1026 Customer Walking Customer","0.00","2400.00","1","1","2024-02-20 09:09:24","","","1");
INSERT INTO acc_transaction VALUES("1320","2724633553","INV","2024-02-20","10107","Inventory credit For Invoice No1027","0.00","50675.00","1","1","2024-02-20 09:12:53","","","1");
INSERT INTO acc_transaction VALUES("1321","2724633553","INV","2024-02-20","102030000002","Customer debit For Invoice No -  1027 Customer Walking Customer","63150.00","0.00","1","1","2024-02-20 09:12:53","","","1");
INSERT INTO acc_transaction VALUES("1322","2724633553","INVOICE","2024-02-20","303","Sale Income For Invoice NO - 1027 Customer Walking Customer","0.00","63150.00","1","1","2024-02-20 09:12:53","","","1");
INSERT INTO acc_transaction VALUES("1326","4651242384","INV","2024-02-20","10107","Inventory credit For Invoice No1023","0.00","135094.00","1","1","2024-02-20 09:37:20","","","1");
INSERT INTO acc_transaction VALUES("1327","4651242384","INVOICE","2024-02-20","303","Sale Income From Invoice NO - 1023 Customer Walking Customer","0.00","19980.00","1","1","2024-02-20 09:37:20","","","1");
INSERT INTO acc_transaction VALUES("1328","4651242384","INV","2024-02-20","102030000002","Customer debit For Invoice NO - 1023 customer-  Walking Customer","19980.00","0.00","1","1","2024-02-20 09:37:20","","","1");
INSERT INTO acc_transaction VALUES("1329","20240219081530","Purchase","2024-02-01","10107","Inventory Devit Supplier Paremount General","15150.00","0.00","1","1","2024-02-20 09:38:09","","","1");
INSERT INTO acc_transaction VALUES("1330","20240219081530","Purchase","2024-02-01","502000038","Supplier -Paremount General","0.00","15150.00","1","1","2024-02-20 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1331","20240219081530","Purchase","2024-02-01","402","Company Credit For SupplierParemount General","15150.00","0.00","1","1","2024-02-20 09:38:09","","","1");
INSERT INTO acc_transaction VALUES("1332","20240219081530","Purchase","2024-02-01","1020101","Cash in Hand For Supplier Paremount General","0.00","0.00","1","1","2024-02-20 09:38:09","","","1");
INSERT INTO acc_transaction VALUES("1333","20240219081530","Purchase","2024-02-01","502000038","Supplier . Paremount General","0.00","0.00","1","1","2024-02-20 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1334","20240213163024","Purchase","2024-01-01","10107","Inventory Devit Supplier Paremount General","11430.00","0.00","1","1","2024-02-20 09:38:35","","","1");
INSERT INTO acc_transaction VALUES("1335","20240213163024","Purchase","2024-01-01","502000038","Supplier -Paremount General","0.00","11430.00","1","1","2024-02-20 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1336","20240213163024","Purchase","2024-01-01","402","Company Credit For SupplierParemount General","11430.00","0.00","1","1","2024-02-20 09:38:35","","","1");
INSERT INTO acc_transaction VALUES("1337","20240213163024","Purchase","2024-01-01","1020101","Cash in Hand For Supplier Paremount General","0.00","0.00","1","1","2024-02-20 09:38:35","","","1");
INSERT INTO acc_transaction VALUES("1338","20240213163024","Purchase","2024-01-01","502000038","Supplier . Paremount General","0.00","0.00","1","1","2024-02-20 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1342","8125379816","INV","2024-02-20","10107","Inventory credit For Invoice No1028","0.00","143109.00","1","1","2024-02-20 09:49:18","","","1");
INSERT INTO acc_transaction VALUES("1343","8125379816","INVOICE","2024-02-20","303","Sale Income From Invoice NO - 1028 Customer Walking Customer","0.00","77005.00","1","1","2024-02-20 09:49:18","","","1");
INSERT INTO acc_transaction VALUES("1344","8125379816","INV","2024-02-20","102030000002","Customer debit For Invoice NO - 1028 customer-  Walking Customer","77005.00","0.00","1","1","2024-02-20 09:49:18","","","1");
INSERT INTO acc_transaction VALUES("1348","20240128113240","Purchase","2023-12-31","10107","Inventory Devit Supplier Chilton Safan","825450.00","0.00","1","1","2024-02-20 09:54:31","","","1");
INSERT INTO acc_transaction VALUES("1349","20240128113240","Purchase","2023-12-31","502000009","Supplier -Chilton Safan","0.00","825450.00","1","1","2024-02-20 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1350","20240128113240","Purchase","2023-12-31","402","Company Credit For SupplierChilton Safan","825450.00","0.00","1","1","2024-02-20 09:54:31","","","1");
INSERT INTO acc_transaction VALUES("1351","20240128113240","Purchase","2023-12-31","1020101","Cash in Hand For Supplier Chilton Safan","0.00","0.00","1","1","2024-02-20 09:54:31","","","1");
INSERT INTO acc_transaction VALUES("1352","20240128113240","Purchase","2023-12-31","502000009","Supplier . Chilton Safan","0.00","0.00","1","1","2024-02-20 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1353","7644324833","INV","2024-02-20","10107","Inventory credit For Invoice No1029","0.00","65157.00","1","1","2024-02-20 10:13:28","","","1");
INSERT INTO acc_transaction VALUES("1354","7644324833","INVOICE","2024-02-20","303","Sale Income From Invoice NO - 1029 Customer Walking Customer","0.00","55610.00","1","1","2024-02-20 10:13:28","","","1");
INSERT INTO acc_transaction VALUES("1355","7644324833","INV","2024-02-20","102030000002","Customer debit For Invoice NO - 1029 customer-  Walking Customer","55610.00","0.00","1","1","2024-02-20 10:13:28","","","1");
INSERT INTO acc_transaction VALUES("1356","1345623824","INV","2024-02-20","10107","Inventory credit For Invoice No1030","0.00","379779.00","1","1","2024-02-20 10:16:35","","","1");
INSERT INTO acc_transaction VALUES("1357","1345623824","INV","2024-02-20","102030000002","Customer debit For Invoice No -  1030 Customer Walking Customer","10730.00","0.00","1","1","2024-02-20 10:16:35","","","1");
INSERT INTO acc_transaction VALUES("1358","1345623824","INVOICE","2024-02-20","303","Sale Income For Invoice NO - 1030 Customer Walking Customer","0.00","10730.00","1","1","2024-02-20 10:16:35","","","1");
INSERT INTO acc_transaction VALUES("1359","5144393325","INV","2024-02-20","10107","Inventory credit For Invoice No1031","0.00","1750.00","1","1","2024-02-20 10:17:14","","","1");
INSERT INTO acc_transaction VALUES("1360","5144393325","INV","2024-02-20","102030000002","Customer debit For Invoice No -  1031 Customer Walking Customer","2000.00","0.00","1","1","2024-02-20 10:17:14","","","1");
INSERT INTO acc_transaction VALUES("1361","5144393325","INVOICE","2024-02-20","303","Sale Income For Invoice NO - 1031 Customer Walking Customer","0.00","2000.00","1","1","2024-02-20 10:17:14","","","1");
INSERT INTO acc_transaction VALUES("1370","20240218132207","Purchase","2024-02-01","10107","Inventory Devit Supplier Emaan Light House","78962.00","0.00","1","1","2024-02-20 10:39:10","","","1");
INSERT INTO acc_transaction VALUES("1371","20240218132207","Purchase","2024-02-01","502000031","Supplier -Emaan Light House","0.00","78962.00","1","1","2024-02-20 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1372","20240218132207","Purchase","2024-02-01","402","Company Credit For SupplierEmaan Light House","78962.00","0.00","1","1","2024-02-20 10:39:10","","","1");
INSERT INTO acc_transaction VALUES("1373","20240218132207","Purchase","2024-02-01","1020101","Cash in Hand For Supplier Emaan Light House","0.00","0.00","1","1","2024-02-20 10:39:10","","","1");
INSERT INTO acc_transaction VALUES("1374","20240218132207","Purchase","2024-02-01","502000031","Supplier . Emaan Light House","0.00","0.00","1","1","2024-02-20 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1378","4148625191","INV","2024-02-20","10107","Inventory credit For Invoice No1032","0.00","204373.00","1","1","2024-02-20 10:59:05","","","1");
INSERT INTO acc_transaction VALUES("1379","4148625191","INVOICE","2024-02-20","303","Sale Income From Invoice NO - 1032 Customer Walking Customer","0.00","177720.00","1","1","2024-02-20 10:59:05","","","1");
INSERT INTO acc_transaction VALUES("1380","4148625191","INV","2024-02-20","102030000002","Customer debit For Invoice NO - 1032 customer-  Walking Customer","177720.00","0.00","1","1","2024-02-20 10:59:05","","","1");
INSERT INTO acc_transaction VALUES("1384","20240219083123","Purchase","2024-02-01","10107","Inventory Devit Supplier F Ali Iddress Karachi","127750.00","0.00","1","1","2024-02-20 11:07:42","","","1");
INSERT INTO acc_transaction VALUES("1385","20240219083123","Purchase","2024-02-01","502000049","Supplier -F Ali Iddress Karachi","0.00","127750.00","1","1","2024-02-20 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1386","20240219083123","Purchase","2024-02-01","402","Company Credit For SupplierF Ali Iddress Karachi","127750.00","0.00","1","1","2024-02-20 11:07:42","","","1");
INSERT INTO acc_transaction VALUES("1387","20240219083123","Purchase","2024-02-01","1020101","Cash in Hand For Supplier F Ali Iddress Karachi","0.00","0.00","1","1","2024-02-20 11:07:42","","","1");
INSERT INTO acc_transaction VALUES("1388","20240219083123","Purchase","2024-02-01","502000049","Supplier . F Ali Iddress Karachi","0.00","0.00","1","1","2024-02-20 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1392","4365216877","INV","2024-02-20","10107","Inventory credit For Invoice No1033","0.00","257386.00","1","1","2024-02-20 12:20:08","","","1");
INSERT INTO acc_transaction VALUES("1393","4365216877","INVOICE","2024-02-20","303","Sale Income From Invoice NO - 1033 Customer Walking Customer","0.00","88130.00","1","1","2024-02-20 12:20:08","","","1");
INSERT INTO acc_transaction VALUES("1394","4365216877","INV","2024-02-20","102030000002","Customer debit For Invoice NO - 1033 customer-  Walking Customer","88130.00","0.00","1","1","2024-02-20 12:20:08","","","1");
INSERT INTO acc_transaction VALUES("1395","4863552591","INV","2024-02-20","10107","Inventory credit For Invoice No1034","0.00","1690.00","1","1","2024-02-20 12:24:07","","","1");
INSERT INTO acc_transaction VALUES("1396","4863552591","INV","2024-02-20","102030000002","Customer debit For Invoice No -  1034 Customer Walking Customer","1500.00","0.00","1","1","2024-02-20 12:24:07","","","1");
INSERT INTO acc_transaction VALUES("1397","4863552591","INVOICE","2024-02-20","303","Sale Income For Invoice NO - 1034 Customer Walking Customer","0.00","1500.00","1","1","2024-02-20 12:24:07","","","1");
INSERT INTO acc_transaction VALUES("1398","1589449478","INV","2024-02-20","10107","Inventory credit For Invoice No1035","0.00","56791.00","1","1","2024-02-20 12:29:54","","","1");
INSERT INTO acc_transaction VALUES("1399","1589449478","INV","2024-02-20","102030000002","Customer debit For Invoice No -  1035 Customer Walking Customer","10700.00","0.00","1","1","2024-02-20 12:29:54","","","1");
INSERT INTO acc_transaction VALUES("1400","1589449478","INVOICE","2024-02-20","303","Sale Income For Invoice NO - 1035 Customer Walking Customer","0.00","10700.00","1","1","2024-02-20 12:29:54","","","1");
INSERT INTO acc_transaction VALUES("1401","4687811218","INV","2024-02-20","10107","Inventory credit For Invoice No1036","0.00","56791.00","1","1","2024-02-20 12:30:10","","","1");
INSERT INTO acc_transaction VALUES("1402","4687811218","INV","2024-02-20","102030000002","Customer debit For Invoice No -  1036 Customer Walking Customer","10700.00","0.00","1","1","2024-02-20 12:30:10","","","1");
INSERT INTO acc_transaction VALUES("1403","4687811218","INVOICE","2024-02-20","303","Sale Income For Invoice NO - 1036 Customer Walking Customer","0.00","10700.00","1","1","2024-02-20 12:30:10","","","1");
INSERT INTO acc_transaction VALUES("1404","9619147336","INV","2024-02-20","10107","Inventory credit For Invoice No1037","0.00","68772.00","1","1","2024-02-20 12:57:59","","","1");
INSERT INTO acc_transaction VALUES("1405","9619147336","INV","2024-02-20","102030000002","Customer debit For Invoice No -  1037 Customer Walking Customer","44520.00","0.00","1","1","2024-02-20 12:57:59","","","1");
INSERT INTO acc_transaction VALUES("1406","9619147336","INVOICE","2024-02-20","303","Sale Income For Invoice NO - 1037 Customer Walking Customer","0.00","44520.00","1","1","2024-02-20 12:57:59","","","1");
INSERT INTO acc_transaction VALUES("1410","2744992295","INV","2024-02-20","10107","Inventory credit For Invoice No1038","0.00","17074.00","1","1","2024-02-20 13:49:20","","","1");
INSERT INTO acc_transaction VALUES("1411","2744992295","INVOICE","2024-02-20","303","Sale Income From Invoice NO - 1038 Customer Walking Customer","0.00","11530.00","1","1","2024-02-20 13:49:20","","","1");
INSERT INTO acc_transaction VALUES("1412","2744992295","INV","2024-02-20","102030000002","Customer debit For Invoice NO - 1038 customer-  Walking Customer","11530.00","0.00","1","1","2024-02-20 13:49:20","","","1");
INSERT INTO acc_transaction VALUES("1413","20240219094915","Purchase","2024-02-01","10107","Inventory Devit Supplier Cash Item ","103495.00","0.00","1","1","2024-02-20 14:10:26","","","1");
INSERT INTO acc_transaction VALUES("1414","20240219094915","Purchase","2024-02-01","502000047","Supplier -Cash Item ","0.00","103495.00","1","1","2024-02-20 00:00:00","","","1");
INSERT INTO acc_transaction VALUES("1415","20240219094915","Purchase","2024-02-01","402","Company Credit For SupplierCash Item ","103495.00","0.00","1","1","2024-02-20 14:10:26","","","1");
INSERT INTO acc_transaction VALUES("1416","20240219094915","Purchase","2024-02-01","1020101","Cash in Hand For Supplier Cash Item ","0.00","0.00","1","1","2024-02-20 14:10:26","","","1");
INSERT INTO acc_transaction VALUES("1417","20240219094915","Purchase","2024-02-01","502000047","Supplier . Cash Item ","0.00","0.00","1","1","2024-02-20 00:00:00","","","1");



DROP TABLE app_setting;

CREATE TABLE `app_setting` (
  `id` int NOT NULL AUTO_INCREMENT,
  `localhserver` varchar(250) DEFAULT NULL,
  `onlineserver` varchar(250) DEFAULT NULL,
  `hotspot` varchar(250) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3;

INSERT INTO app_setting VALUES("1","http://millattraders.com/saleserp","http://millattraders.com/saleserp","http://millattraders.com/saleserp");



DROP TABLE attendance;

CREATE TABLE `attendance` (
  `att_id` int NOT NULL AUTO_INCREMENT,
  `employee_id` int NOT NULL,
  `date` date NOT NULL,
  `sign_in` varchar(30) NOT NULL,
  `sign_out` varchar(30) NOT NULL,
  `staytime` varchar(30) NOT NULL,
  PRIMARY KEY (`att_id`),
  KEY `employee_id` (`employee_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;




DROP TABLE bank_add;

CREATE TABLE `bank_add` (
  `id` int NOT NULL AUTO_INCREMENT,
  `bank_id` varchar(255) NOT NULL,
  `bank_name` varchar(255) NOT NULL,
  `ac_name` varchar(250) DEFAULT NULL,
  `ac_number` varchar(250) DEFAULT NULL,
  `branch` varchar(250) DEFAULT NULL,
  `signature_pic` varchar(250) DEFAULT NULL,
  `status` int DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;




DROP TABLE company_information;

CREATE TABLE `company_information` (
  `company_id` varchar(250) NOT NULL,
  `company_name` varchar(50) NOT NULL,
  `email` varchar(50) NOT NULL,
  `address` text NOT NULL,
  `mobile` varchar(50) NOT NULL,
  `website` varchar(50) NOT NULL,
  `status` int NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

INSERT INTO company_information VALUES("1","MILLAT TRADERS","millattraders@gmail.com","Old Rahat Cinema Road Hyderabad","03433669338","https://www.millattraders.com/","1");



DROP TABLE currency_tbl;

CREATE TABLE `currency_tbl` (
  `id` int NOT NULL AUTO_INCREMENT,
  `currency_name` varchar(50) NOT NULL,
  `icon` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3;

INSERT INTO currency_tbl VALUES("1","Dollar","$");
INSERT INTO currency_tbl VALUES("2","BDT","৳");
INSERT INTO currency_tbl VALUES("3","PAKISTANI","PKR");



DROP TABLE customer_information;

CREATE TABLE `customer_information` (
  `customer_id` bigint NOT NULL AUTO_INCREMENT,
  `customer_name` varchar(255) DEFAULT NULL,
  `customer_address` varchar(255) NOT NULL,
  `address2` text NOT NULL,
  `customer_mobile` varchar(100) NOT NULL,
  `customer_email` varchar(100) DEFAULT NULL,
  `email_address` varchar(200) DEFAULT NULL,
  `contact` varchar(100) DEFAULT NULL,
  `phone` varchar(50) DEFAULT NULL,
  `fax` varchar(100) DEFAULT NULL,
  `city` text,
  `state` text,
  `zip` varchar(50) DEFAULT NULL,
  `country` varchar(250) DEFAULT NULL,
  `status` int NOT NULL COMMENT '1=paid,2=credit',
  `create_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `create_by` varchar(30) DEFAULT NULL,
  PRIMARY KEY (`customer_id`),
  KEY `customer_id` (`customer_id`)
) ENGINE=MyISAM AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb3;

INSERT INTO customer_information VALUES("1","Cash Sale","  ","","01","","","","","fax","","","","","2","2024-01-23 21:54:00","1");
INSERT INTO customer_information VALUES("2","Walking Customer","","","","","","","","","","","","","1","2024-01-23 22:38:03","");
INSERT INTO customer_information VALUES("5","Credit Customer","","","02","","","","","","","","","","2","2024-02-20 19:33:58","1");
INSERT INTO customer_information VALUES("6","H.M CABLES","","","03053902175","hmcable9@gmail.com","","","0223870706","","","","","","2","2024-02-20 20:35:45","1");



DROP TABLE daily_banking_add;

CREATE TABLE `daily_banking_add` (
  `banking_id` varchar(255) NOT NULL,
  `date` datetime DEFAULT NULL,
  `bank_id` varchar(100) DEFAULT NULL,
  `deposit_type` varchar(255) DEFAULT NULL,
  `transaction_type` varchar(255) DEFAULT NULL,
  `description` text,
  `amount` int DEFAULT NULL,
  `status` int DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;




DROP TABLE daily_closing;

CREATE TABLE `daily_closing` (
  `closing_id` varchar(255) NOT NULL,
  `last_day_closing` float NOT NULL,
  `cash_in` float NOT NULL,
  `cash_out` float NOT NULL,
  `date` varchar(250) NOT NULL,
  `amount` float NOT NULL,
  `adjustment` float DEFAULT NULL,
  `status` int NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;




DROP TABLE designation;

CREATE TABLE `designation` (
  `id` int NOT NULL AUTO_INCREMENT,
  `designation` varchar(150) NOT NULL,
  `details` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;




DROP TABLE email_config;

CREATE TABLE `email_config` (
  `id` int NOT NULL AUTO_INCREMENT,
  `protocol` text NOT NULL,
  `smtp_host` text NOT NULL,
  `smtp_port` text NOT NULL,
  `smtp_user` varchar(35) NOT NULL,
  `smtp_pass` varchar(35) NOT NULL,
  `mailtype` varchar(30) DEFAULT NULL,
  `isinvoice` tinyint NOT NULL,
  `isservice` tinyint NOT NULL,
  `isquotation` tinyint NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3;

INSERT INTO email_config VALUES("1","ssmtp","ssl://ssmtp.gmail.com","25","demo@gmail.com","demo123456","html","0","0","0");



DROP TABLE employee_history;

CREATE TABLE `employee_history` (
  `id` int NOT NULL AUTO_INCREMENT,
  `first_name` varchar(50) NOT NULL,
  `last_name` varchar(50) NOT NULL,
  `designation` varchar(100) NOT NULL,
  `phone` varchar(50) NOT NULL,
  `rate_type` int NOT NULL,
  `hrate` float NOT NULL,
  `email` varchar(50) NOT NULL,
  `blood_group` varchar(10) NOT NULL,
  `address_line_1` text NOT NULL,
  `address_line_2` text NOT NULL,
  `image` text,
  `country` varchar(50) NOT NULL,
  `city` varchar(50) NOT NULL,
  `zip` varchar(50) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;




DROP TABLE employee_salary_payment;

CREATE TABLE `employee_salary_payment` (
  `emp_sal_pay_id` int NOT NULL AUTO_INCREMENT,
  `generate_id` int NOT NULL,
  `employee_id` varchar(50) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `total_salary` decimal(18,2) NOT NULL DEFAULT '0.00',
  `total_working_minutes` varchar(50) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `working_period` varchar(50) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `payment_due` varchar(50) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `payment_date` varchar(50) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `paid_by` varchar(50) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `salary_month` varchar(70) DEFAULT NULL,
  PRIMARY KEY (`emp_sal_pay_id`),
  KEY `employee_id` (`employee_id`),
  KEY `generate_id` (`generate_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;




DROP TABLE employee_salary_setup;

CREATE TABLE `employee_salary_setup` (
  `e_s_s_id` int unsigned NOT NULL AUTO_INCREMENT,
  `employee_id` varchar(30) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `sal_type` varchar(30) NOT NULL,
  `salary_type_id` varchar(30) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `amount` decimal(12,2) NOT NULL DEFAULT '0.00',
  `create_date` date DEFAULT NULL,
  `update_date` datetime(6) DEFAULT NULL,
  `update_id` varchar(30) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `gross_salary` float NOT NULL,
  PRIMARY KEY (`e_s_s_id`),
  KEY `employee_id` (`employee_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;




DROP TABLE expense;

CREATE TABLE `expense` (
  `id` int NOT NULL AUTO_INCREMENT,
  `date` date NOT NULL,
  `type` varchar(100) NOT NULL,
  `voucher_no` varchar(50) NOT NULL,
  `amount` float NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;




DROP TABLE expense_item;

CREATE TABLE `expense_item` (
  `id` int NOT NULL AUTO_INCREMENT,
  `expense_item_name` varchar(200) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;




DROP TABLE invoice;

CREATE TABLE `invoice` (
  `id` int NOT NULL AUTO_INCREMENT,
  `invoice_id` bigint NOT NULL,
  `customer_id` bigint NOT NULL,
  `date` varchar(50) DEFAULT NULL,
  `total_amount` decimal(18,2) NOT NULL DEFAULT '0.00',
  `paid_amount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `due_amount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `prevous_due` decimal(20,2) NOT NULL DEFAULT '0.00',
  `shipping_cost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `invoice` bigint NOT NULL,
  `invoice_discount` decimal(10,2) DEFAULT '0.00' COMMENT 'invoice discount',
  `total_discount` decimal(10,2) DEFAULT '0.00' COMMENT 'total invoice discount',
  `total_tax` decimal(10,2) DEFAULT '0.00',
  `sales_by` varchar(50) NOT NULL,
  `invoice_details` text NOT NULL,
  `status` int NOT NULL,
  `bank_id` varchar(30) DEFAULT NULL,
  `payment_type` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `customer_id` (`customer_id`),
  KEY `invoice_id` (`invoice_id`)
) ENGINE=MyISAM AUTO_INCREMENT=40 DEFAULT CHARSET=utf8mb3;

INSERT INTO invoice VALUES("1","5845776228","2","2023-12-24","2525.00","0.00","2525.00","0.00","0.00","1000","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("2","6124985648","2","2023-12-24","600.00","0.00","600.00","0.00","0.00","1001","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("3","4977174268","2","2023-12-25","2370.00","0.00","2370.00","0.00","0.00","1002","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("4","4612744893","2","2023-12-25","5550.00","0.00","5550.00","0.00","0.00","1003","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("5","2567782964","2","2023-12-26","31510.00","0.00","31510.00","0.00","0.00","1004","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("6","9779858312","2","2023-12-27","10640.00","0.00","10640.00","0.00","0.00","1005","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("7","3284257142","2","2023-12-28","5996.00","0.00","5996.00","0.00","0.00","1006","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("8","9175169491","2","2023-12-30","2500.00","0.00","2500.00","0.00","0.00","1007","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("9","5669212287","2","2023-12-31","111260.00","0.00","111260.00","0.00","0.00","1008","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("10","8115955164","2","2024-01-01","3300.00","0.00","3300.00","0.00","0.00","1009","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("11","6448414167","2","2024-01-02","5000.00","0.00","5000.00","0.00","0.00","1010","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("12","7816741612","2","2024-01-03","23100.00","0.00","23100.00","0.00","0.00","1011","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("13","4995667463","2","2024-01-04","24320.00","0.00","24320.00","0.00","0.00","1012","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("14","7328171614","2","2024-01-06","50310.00","0.00","50310.00","0.00","0.00","1013","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("15","6686419811","2","2024-01-07","6780.00","0.00","6780.00","0.00","0.00","1014","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("16","4856684174","2","2024-01-08","7650.00","0.00","7650.00","0.00","0.00","1015","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("17","1826916967","2","2024-01-09","910.00","0.00","910.00","0.00","0.00","1016","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("18","5976692598","2","2024-01-10","2500.00","0.00","2500.00","0.00","0.00","1017","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("19","3371369953","2","2024-01-11","19820.00","0.00","19820.00","0.00","0.00","1018","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("20","7976724629","2","2024-01-11","15520.00","0.00","15520.00","0.00","0.00","1019","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("21","1249729836","2","2024-01-13","50010.00","0.00","50010.00","0.00","0.00","1020","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("22","9759274115","2","2024-01-14","11010.00","0.00","11010.00","0.00","0.00","1021","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("23","7677745934","2","2024-01-15","7960.00","0.00","7960.00","0.00","0.00","1022","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("24","4651242384","2","2024-01-16","19980.00","0.00","19980.00","0.00","0.00","1023","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("25","6139664445","2","2024-01-17","24740.00","0.00","24740.00","0.00","0.00","1024","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("26","9814175468","2","2024-01-18","400.00","0.00","400.00","0.00","0.00","1025","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("27","8729851784","2","2024-01-20","2400.00","0.00","2400.00","0.00","0.00","1026","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("28","2724633553","2","2024-01-21","63150.00","0.00","63150.00","0.00","0.00","1027","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("29","8125379816","2","2024-01-22","77005.00","0.00","77005.00","0.00","0.00","1028","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("30","7644324833","2","2024-01-23","55610.00","0.00","55610.00","0.00","0.00","1029","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("31","1345623824","2","2024-01-24","10730.00","0.00","10730.00","0.00","0.00","1030","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("32","5144393325","2","2024-01-25","2000.00","0.00","2000.00","0.00","0.00","1031","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("33","4148625191","2","2024-01-27","177720.00","0.00","177720.00","0.00","0.00","1032","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("34","4365216877","2","2024-01-28","88130.00","0.00","88130.00","0.00","0.00","1033","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("35","4863552591","2","2024-01-29","1500.00","0.00","1500.00","0.00","0.00","1034","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("36","1589449478","2","2024-01-31","10700.00","0.00","10700.00","0.00","0.00","1035","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("37","4687811218","2","2024-01-30","10700.00","0.00","10700.00","0.00","0.00","1036","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("38","9619147336","2","2024-01-31","44520.00","0.00","44520.00","0.00","0.00","1037","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");
INSERT INTO invoice VALUES("39","2744992295","2","2024-02-01","11530.00","0.00","11530.00","0.00","0.00","1038","0.00","0.00","0.00","1","Thank you for shopping with us","1","","1");



DROP TABLE invoice_details;

CREATE TABLE `invoice_details` (
  `id` int NOT NULL AUTO_INCREMENT,
  `invoice_details_id` varchar(100) NOT NULL,
  `invoice_id` varchar(100) NOT NULL,
  `product_id` varchar(30) NOT NULL,
  `serial_no` varchar(30) DEFAULT NULL,
  `description` varchar(250) DEFAULT NULL,
  `quantity` decimal(10,2) DEFAULT NULL,
  `rate` decimal(10,2) DEFAULT NULL,
  `supplier_rate` float DEFAULT NULL,
  `total_price` decimal(12,2) DEFAULT NULL,
  `discount` decimal(10,2) DEFAULT NULL,
  `discount_per` varchar(15) DEFAULT NULL,
  `tax` decimal(10,2) DEFAULT NULL,
  `paid_amount` decimal(12,0) DEFAULT NULL,
  `due_amount` decimal(10,2) DEFAULT NULL,
  `status` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `invoice_id` (`invoice_id`),
  KEY `product_id` (`product_id`)
) ENGINE=MyISAM AUTO_INCREMENT=577 DEFAULT CHARSET=utf8mb3;

INSERT INTO invoice_details VALUES("1","839389393983864","5845776228","56","","","2.00","1100.00","1000","2200.00","0.00","","","0","2525.00","1");
INSERT INTO invoice_details VALUES("2","967686887555815","5845776228","29","","","5.00","45.00","40","225.00","0.00","","","0","2525.00","1");
INSERT INTO invoice_details VALUES("3","433793495435259","5845776228","421","","","2.00","50.00","36","100.00","0.00","","","0","2525.00","1");
INSERT INTO invoice_details VALUES("4","515976827355894","6124985648","709","","","1.00","600.00","500","600.00","0.00","","","0","600.00","1");
INSERT INTO invoice_details VALUES("15","275589831295255","4977174268","381","","","1.00","50.00","400","420.00","0.00","","0.00","0","2370.00","0");
INSERT INTO invoice_details VALUES("14","846997721244228","4977174268","709","","","1.00","600.00","500","600.00","0.00","","0.00","0","2370.00","0");
INSERT INTO invoice_details VALUES("13","898567895771985","4977174268","57","","","9.00","150.00","140","1350.00","0.00","","0.00","0","2370.00","0");
INSERT INTO invoice_details VALUES("16","898241372863183","4612744893","602","","","1.00","1800.00","1500","1800.00","0.00","","","0","5550.00","1");
INSERT INTO invoice_details VALUES("17","274489216927784","4612744893","490","","","1.00","200.00","90","200.00","0.00","","","0","5550.00","1");
INSERT INTO invoice_details VALUES("18","282799142971449","4612744893","494","","","8.00","300.00","290","2400.00","0.00","","","0","5550.00","1");
INSERT INTO invoice_details VALUES("19","651149459917255","4612744893","490","","","2.00","150.00","90","300.00","0.00","","","0","5550.00","1");
INSERT INTO invoice_details VALUES("20","554759811629266","4612744893","221","","","1.00","850.00","500","850.00","0.00","","","0","5550.00","1");
INSERT INTO invoice_details VALUES("21","482121579539139","2567782964","249","","","1.00","3000.00","1600","3000.00","0.00","","","0","31510.00","1");
INSERT INTO invoice_details VALUES("22","767781713126117","2567782964","419","","","1.00","7300.00","6731","7300.00","0.00","","","0","31510.00","1");
INSERT INTO invoice_details VALUES("23","985862782699412","2567782964","404","","","6.00","130.00","125","780.00","0.00","","","0","31510.00","1");
INSERT INTO invoice_details VALUES("24","848234393687766","2567782964","236","","","1.00","700.00","920","700.00","0.00","","","0","31510.00","1");
INSERT INTO invoice_details VALUES("25","996974799877116","2567782964","776","","","6.00","550.00","486","3300.00","0.00","","","0","31510.00","1");
INSERT INTO invoice_details VALUES("26","541838177328171","2567782964","399","","","4.00","275.00","287","1100.00","0.00","","","0","31510.00","1");
INSERT INTO invoice_details VALUES("27","972894955285838","2567782964","681","","","2.00","350.00","310","700.00","0.00","","","0","31510.00","1");
INSERT INTO invoice_details VALUES("28","723798943148258","2567782964","399","","","2.00","320.00","287","640.00","0.00","","","0","31510.00","1");
INSERT INTO invoice_details VALUES("29","253942834461868","2567782964","390","","","22.00","550.00","560","12100.00","0.00","","","0","31510.00","1");
INSERT INTO invoice_details VALUES("30","546615487387449","2567782964","698","","","5.00","350.00","290","1750.00","0.00","","","0","31510.00","1");
INSERT INTO invoice_details VALUES("31","298272421945446","2567782964","57","","","1.00","140.00","140","140.00","0.00","","","0","31510.00","1");
INSERT INTO invoice_details VALUES("32","526822765573292","9779858312","254","","","20.00","260.00","230","5200.00","0.00","","","0","10640.00","1");
INSERT INTO invoice_details VALUES("33","564137457187356","9779858312","251","","","3.00","250.00","275","750.00","0.00","","","0","10640.00","1");
INSERT INTO invoice_details VALUES("34","661667718864522","9779858312","366","","","4.00","60.00","46","240.00","0.00","","","0","10640.00","1");
INSERT INTO invoice_details VALUES("35","344263629619382","9779858312","678","","","1.00","300.00","286","300.00","0.00","","","0","10640.00","1");
INSERT INTO invoice_details VALUES("36","581485192368619","9779858312","235","","","3.00","1050.00","1100","3150.00","0.00","","","0","10640.00","1");
INSERT INTO invoice_details VALUES("37","377627555172341","9779858312","41","","","8.00","50.00","45","400.00","0.00","","","0","10640.00","1");
INSERT INTO invoice_details VALUES("38","815298815434397","9779858312","57","","","4.00","150.00","140","600.00","0.00","","","0","10640.00","1");
INSERT INTO invoice_details VALUES("46","356253728127843","3284257142","373","","","1.00","1500.00","1500","1500.00","0.00","","0.00","0","5996.00","0");
INSERT INTO invoice_details VALUES("45","667533664915413","3284257142","410","","","1.00","1800.00","1650","1800.00","0.00","","0.00","0","5996.00","0");
INSERT INTO invoice_details VALUES("44","135198835368782","3284257142","251","","","2.00","250.00","275","500.00","0.00","","0.00","0","5996.00","0");
INSERT INTO invoice_details VALUES("43","763728188872889","3284257142","490","","","12.00","183.00","90","2196.00","0.00","","0.00","0","5996.00","0");
INSERT INTO invoice_details VALUES("47","846796548571395","9175169491","254","","","3.00","200.00","230","600.00","0.00","","","0","2500.00","1");
INSERT INTO invoice_details VALUES("48","134153886452179","9175169491","253","","","2.00","250.00","280","500.00","0.00","","","0","2500.00","1");
INSERT INTO invoice_details VALUES("49","171855522334312","9175169491","57","","","6.00","150.00","140","900.00","0.00","","","0","2500.00","1");
INSERT INTO invoice_details VALUES("50","562268159237749","9175169491","241","","","2.00","250.00","160","500.00","0.00","","","0","2500.00","1");
INSERT INTO invoice_details VALUES("119","113891451557286","5669212287","603","","","39.00","320.00","250","12480.00","0.00","","0.00","0","111260.00","0");
INSERT INTO invoice_details VALUES("118","663928358686782","5669212287","283","","","24.00","40.00","30","960.00","0.00","","0.00","0","111260.00","0");
INSERT INTO invoice_details VALUES("117","184474861449985","5669212287","678","","","12.00","290.00","286","3480.00","0.00","","0.00","0","111260.00","0");
INSERT INTO invoice_details VALUES("116","122952642292298","5669212287","776","","","24.00","500.00","486","12000.00","0.00","","0.00","0","111260.00","0");
INSERT INTO invoice_details VALUES("115","615873471779433","5669212287","418","","","2.00","4300.00","4300","8600.00","0.00","","0.00","0","111260.00","0");
INSERT INTO invoice_details VALUES("114","547974748476538","5669212287","417","","","3.00","4300.00","4300","12900.00","0.00","","0.00","0","111260.00","0");
INSERT INTO invoice_details VALUES("113","973151694985756","5669212287","68","","","5.00","2150.00","2600","10750.00","0.00","","0.00","0","111260.00","0");
INSERT INTO invoice_details VALUES("112","382185969539811","5669212287","71","","","5.00","2150.00","2250","10750.00","0.00","","0.00","0","111260.00","0");
INSERT INTO invoice_details VALUES("111","547462747382147","5669212287","12","","","50.00","130.00","135","6500.00","0.00","","0.00","0","111260.00","0");
INSERT INTO invoice_details VALUES("110","171635922286377","5669212287","19","","","6.00","80.00","70","480.00","0.00","","0.00","0","111260.00","0");
INSERT INTO invoice_details VALUES("109","981134698598221","5669212287","473","","","1.00","500.00","350","500.00","0.00","","0.00","0","111260.00","0");
INSERT INTO invoice_details VALUES("108","648453613514982","5669212287","29","","","6.00","60.00","40","360.00","0.00","","0.00","0","111260.00","0");
INSERT INTO invoice_details VALUES("107","443574415325159","5669212287","421","","","10.00","60.00","36","600.00","0.00","","0.00","0","111260.00","0");
INSERT INTO invoice_details VALUES("106","275369558528271","5669212287","144","","","1.00","6300.00","6146","6300.00","0.00","","0.00","0","111260.00","0");
INSERT INTO invoice_details VALUES("105","631419955448628","5669212287","141","","","1.00","6300.00","6146","6300.00","0.00","","0.00","0","111260.00","0");
INSERT INTO invoice_details VALUES("104","923128239996347","5669212287","136","","","2.00","3050.00","2961","6100.00","0.00","","0.00","0","111260.00","0");
INSERT INTO invoice_details VALUES("103","641163846616395","5669212287","135","","","4.00","3050.00","2961","12200.00","0.00","","0.00","0","111260.00","0");
INSERT INTO invoice_details VALUES("84","234162181384552","8115955164","222","","","5.00","180.00","230","900.00","0.00","","","0","3300.00","1");
INSERT INTO invoice_details VALUES("85","713423429736182","8115955164","57","","","10.00","120.00","140","1200.00","0.00","","","0","3300.00","1");
INSERT INTO invoice_details VALUES("86","485644882175947","8115955164","239","","","2.00","400.00","360","800.00","0.00","","","0","3300.00","1");
INSERT INTO invoice_details VALUES("87","926879137534578","8115955164","694","","","2.00","200.00","130","400.00","0.00","","","0","3300.00","1");
INSERT INTO invoice_details VALUES("88","439678757222877","6448414167","251","","","4.00","250.00","275","1000.00","0.00","","","0","5000.00","1");
INSERT INTO invoice_details VALUES("89","638643831683452","6448414167","401","","","6.00","500.00","475","3000.00","0.00","","","0","5000.00","1");
INSERT INTO invoice_details VALUES("90","329763255314885","6448414167","28","","","4.00","150.00","120","600.00","0.00","","","0","5000.00","1");
INSERT INTO invoice_details VALUES("91","759911862932649","6448414167","57","","","2.00","200.00","140","400.00","0.00","","","0","5000.00","1");
INSERT INTO invoice_details VALUES("92","385984619746189","7816741612","135","","","1.00","3100.00","2961","3100.00","0.00","","","0","23100.00","1");
INSERT INTO invoice_details VALUES("93","949862787112821","7816741612","206","","","1.00","1900.00","1200","1900.00","0.00","","","0","23100.00","1");
INSERT INTO invoice_details VALUES("94","411867448784556","7816741612","57","","","2.00","150.00","140","300.00","0.00","","","0","23100.00","1");
INSERT INTO invoice_details VALUES("95","214898361575745","7816741612","303","","","1.00","1650.00","1500","1650.00","0.00","","","0","23100.00","1");
INSERT INTO invoice_details VALUES("96","425718353794821","7816741612","343","","","1.00","1650.00","1500","1650.00","0.00","","","0","23100.00","1");
INSERT INTO invoice_details VALUES("97","872494828237715","7816741612","147","","","1.00","14500.00","14986","14500.00","0.00","","","0","23100.00","1");
INSERT INTO invoice_details VALUES("131","982264386784453","4995667463","363","","","3.00","340.00","320","1020.00","0.00","","0.00","0","24320.00","0");
INSERT INTO invoice_details VALUES("130","623396777746993","4995667463","141","","","1.00","6300.00","6146","6300.00","0.00","","0.00","0","24320.00","0");
INSERT INTO invoice_details VALUES("129","821626443899344","4995667463","144","","","1.00","6300.00","6146","6300.00","0.00","","0.00","0","24320.00","0");
INSERT INTO invoice_details VALUES("128","489933145723954","4995667463","694","","","2.00","200.00","130","400.00","0.00","","0.00","0","24320.00","0");
INSERT INTO invoice_details VALUES("127","974666687416646","4995667463","57","","","2.00","150.00","140","300.00","0.00","","0.00","0","24320.00","0");
INSERT INTO invoice_details VALUES("126","663897399591753","4995667463","412","","","1.00","10000.00","8800","10000.00","0.00","","0.00","0","24320.00","0");
INSERT INTO invoice_details VALUES("157","574292484641591","7328171614","693","","","2.00","200.00","130","400.00","0.00","","0.00","0","50310.00","0");
INSERT INTO invoice_details VALUES("156","993881668428611","7328171614","697","","","1.00","400.00","400","400.00","0.00","","0.00","0","50310.00","0");
INSERT INTO invoice_details VALUES("155","968472347194219","7328171614","698","","","4.00","350.00","290","1400.00","0.00","","0.00","0","50310.00","0");
INSERT INTO invoice_details VALUES("154","574521829522268","7328171614","442","","","10.00","140.00","120","1400.00","0.00","","0.00","0","50310.00","0");
INSERT INTO invoice_details VALUES("153","124894363972692","7328171614","715","","","5.00","135.00","120","675.00","0.00","","0.00","0","50310.00","0");
INSERT INTO invoice_details VALUES("152","397825487327713","7328171614","283","","","1.00","60.00","30","60.00","0.00","","0.00","0","50310.00","0");
INSERT INTO invoice_details VALUES("151","595223161397594","7328171614","395","","","2.00","70.00","50","140.00","0.00","","0.00","0","50310.00","0");
INSERT INTO invoice_details VALUES("150","549247268872682","7328171614","678","","","1.00","350.00","286","350.00","0.00","","0.00","0","50310.00","0");
INSERT INTO invoice_details VALUES("149","368593236435689","7328171614","776","","","2.00","550.00","486","1100.00","0.00","","0.00","0","50310.00","0");
INSERT INTO invoice_details VALUES("148","749121364817112","7328171614","726","","","1.00","4700.00","4800","4700.00","0.00","","0.00","0","50310.00","0");
INSERT INTO invoice_details VALUES("147","225457635726388","7328171614","707","","","1.00","250.00","150","250.00","0.00","","0.00","0","50310.00","0");
INSERT INTO invoice_details VALUES("146","657517693482148","7328171614","71","","","1.00","2450.00","2250","2450.00","0.00","","0.00","0","50310.00","0");
INSERT INTO invoice_details VALUES("158","463729624525221","7328171614","67","","","4.00","2600.00","2600","10400.00","0.00","","0.00","0","50310.00","0");
INSERT INTO invoice_details VALUES("159","217395898578677","7328171614","72","","","3.00","2600.00","2250","7800.00","0.00","","0.00","0","50310.00","0");
INSERT INTO invoice_details VALUES("160","331751747575241","7328171614","69","","","1.00","5200.00","5200","5200.00","0.00","","0.00","0","50310.00","0");
INSERT INTO invoice_details VALUES("161","887536492676354","7328171614","70","","","1.00","5200.00","5200","5200.00","0.00","","0.00","0","50310.00","0");
INSERT INTO invoice_details VALUES("162","564298944389399","7328171614","387","","","6.00","490.00","486","2940.00","0.00","","0.00","0","50310.00","0");
INSERT INTO invoice_details VALUES("163","462483396591755","7328171614","401","","","6.00","480.00","475","2880.00","0.00","","0.00","0","50310.00","0");
INSERT INTO invoice_details VALUES("164","658129377397779","7328171614","399","","","6.00","280.00","287","1680.00","0.00","","0.00","0","50310.00","0");
INSERT INTO invoice_details VALUES("165","638427685856997","7328171614","682","","","1.00","200.00","250","200.00","0.00","","0.00","0","50310.00","0");
INSERT INTO invoice_details VALUES("166","976282556561647","7328171614","281","","","7.00","25.00","25","175.00","0.00","","0.00","0","50310.00","0");
INSERT INTO invoice_details VALUES("167","918733169387693","7328171614","282","","","12.00","30.00","32","360.00","0.00","","0.00","0","50310.00","0");
INSERT INTO invoice_details VALUES("168","452749681187878","7328171614","217","","","1.00","150.00","180","150.00","0.00","","0.00","0","50310.00","0");
INSERT INTO invoice_details VALUES("169","379593745279776","6686419811","251","","","2.00","300.00","275","600.00","0.00","","","0","6780.00","1");
INSERT INTO invoice_details VALUES("170","276287493128343","6686419811","240","","","2.00","300.00","260","600.00","0.00","","","0","6780.00","1");
INSERT INTO invoice_details VALUES("171","859873522133459","6686419811","20","","","12.00","180.00","115","2160.00","0.00","","","0","6780.00","1");
INSERT INTO invoice_details VALUES("172","576239325766441","6686419811","497","","","1.00","200.00","160","200.00","0.00","","","0","6780.00","1");
INSERT INTO invoice_details VALUES("173","997194613866521","6686419811","207","","","1.00","1600.00","1300","1600.00","0.00","","","0","6780.00","1");
INSERT INTO invoice_details VALUES("174","142914258156767","6686419811","711","","","1.00","70.00","62","70.00","0.00","","","0","6780.00","1");
INSERT INTO invoice_details VALUES("175","195289453792295","6686419811","474","","","1.00","200.00","100","200.00","0.00","","","0","6780.00","1");
INSERT INTO invoice_details VALUES("176","754492964838771","6686419811","224","","","1.00","750.00","550","750.00","0.00","","","0","6780.00","1");
INSERT INTO invoice_details VALUES("177","416534289783943","6686419811","693","","","3.00","200.00","130","600.00","0.00","","","0","6780.00","1");
INSERT INTO invoice_details VALUES("193","874177596597332","4856684174","452 ","","","1.00","100.00","292","100.00","0.00","","0.00","0","7650.00","0");
INSERT INTO invoice_details VALUES("192","619544667432253","4856684174","263","","","1.00","350.00","350","350.00","0.00","","0.00","0","7650.00","0");
INSERT INTO invoice_details VALUES("191","785937424862916","4856684174","221","","","1.00","400.00","500","400.00","0.00","","0.00","0","7650.00","0");
INSERT INTO invoice_details VALUES("190","784175347599831","4856684174","603","","","4.00","200.00","250","800.00","0.00","","0.00","0","7650.00","0");
INSERT INTO invoice_details VALUES("189","313758462677353","4856684174","703","","","4.00","700.00","900","2800.00","0.00","","0.00","0","7650.00","0");
INSERT INTO invoice_details VALUES("188","682598322717165","4856684174","490","","","6.00","120.00","90","720.00","0.00","","0.00","0","7650.00","0");
INSERT INTO invoice_details VALUES("187","387215845399525","4856684174","404","","","6.00","120.00","125","720.00","0.00","","0.00","0","7650.00","0");
INSERT INTO invoice_details VALUES("186","392637921544583","4856684174","693","","","2.00","230.00","130","460.00","0.00","","0.00","0","7650.00","0");
INSERT INTO invoice_details VALUES("194","981965699468663","4856684174","99","","","1.00","300.00","360","300.00","0.00","","0.00","0","7650.00","0");
INSERT INTO invoice_details VALUES("195","667649731283262","4856684174","197","","","1.00","1000.00","1500","1000.00","0.00","","0.00","0","7650.00","0");
INSERT INTO invoice_details VALUES("196","157397334925388","1826916967","58","","","1.00","200.00","115","200.00","0.00","","","0","910.00","1");
INSERT INTO invoice_details VALUES("197","252127939613425","1826916967","699","","","2.00","355.00","320","710.00","0.00","","","0","910.00","1");
INSERT INTO invoice_details VALUES("198","617555925867992","5976692598","263","","","2.00","300.00","350","600.00","0.00","","","0","2500.00","1");
INSERT INTO invoice_details VALUES("199","628874689684419","5976692598","11","","","17.00","105.00","105","1785.00","0.00","","","0","2500.00","1");
INSERT INTO invoice_details VALUES("200","437943381354114","5976692598","490","","","1.00","115.00","90","115.00","0.00","","","0","2500.00","1");
INSERT INTO invoice_details VALUES("201","435988785166142","3371369953","19","","","2.00","80.00","70","160.00","0.00","","","0","19820.00","1");
INSERT INTO invoice_details VALUES("202","883712584166146","3371369953","421","","","2.00","60.00","36","120.00","0.00","","","0","19820.00","1");
INSERT INTO invoice_details VALUES("203","122723725863538","3371369953","29","","","2.00","50.00","40","100.00","0.00","","","0","19820.00","1");
INSERT INTO invoice_details VALUES("204","495664939836439","3371369953","254","","","2.00","250.00","230","500.00","0.00","","","0","19820.00","1");
INSERT INTO invoice_details VALUES("205","612645787434546","3371369953","63","","","1.00","5000.00","4900","5000.00","0.00","","","0","19820.00","1");
INSERT INTO invoice_details VALUES("206","913184843127287","3371369953","64","","","1.00","5000.00","4900","5000.00","0.00","","","0","19820.00","1");
INSERT INTO invoice_details VALUES("207","892991452625819","3371369953","697","","","18.00","430.00","400","7740.00","0.00","","","0","19820.00","1");
INSERT INTO invoice_details VALUES("208","571348914553264","3371369953","100","","","1.00","300.00","300","300.00","0.00","","","0","19820.00","1");
INSERT INTO invoice_details VALUES("209","918137679234137","3371369953","84","","","2.00","450.00","450","900.00","0.00","","","0","19820.00","1");
INSERT INTO invoice_details VALUES("227","133338489352491","7976724629","84","","","2.00","450.00","450","900.00","0.00","","0.00","0","15520.00","0");
INSERT INTO invoice_details VALUES("226","991642798697137","7976724629","100","","","1.00","300.00","300","300.00","0.00","","0.00","0","15520.00","0");
INSERT INTO invoice_details VALUES("225","462117447557359","7976724629","697","","","8.00","430.00","400","3440.00","0.00","","0.00","0","15520.00","0");
INSERT INTO invoice_details VALUES("224","315234468696583","7976724629","64","","","1.00","5000.00","4900","5000.00","0.00","","0.00","0","15520.00","0");
INSERT INTO invoice_details VALUES("223","937217965628367","7976724629","63","","","1.00","5000.00","4900","5000.00","0.00","","0.00","0","15520.00","0");
INSERT INTO invoice_details VALUES("222","936977523379468","7976724629","254","","","2.00","250.00","230","500.00","0.00","","0.00","0","15520.00","0");
INSERT INTO invoice_details VALUES("221","365855782776966","7976724629","29","","","2.00","50.00","40","100.00","0.00","","0.00","0","15520.00","0");
INSERT INTO invoice_details VALUES("220","715746522968734","7976724629","421","","","2.00","60.00","36","120.00","0.00","","0.00","0","15520.00","0");
INSERT INTO invoice_details VALUES("219","183518366965255","7976724629","19","","","2.00","80.00","70","160.00","0.00","","0.00","0","15520.00","0");
INSERT INTO invoice_details VALUES("235","991275555846692","1249729836","49","","","1.00","200.00","160","200.00","0.00","","0.00","0","50010.00","0");
INSERT INTO invoice_details VALUES("234","937986376213583","1249729836","455","","","7.00","250.00","230","1750.00","0.00","","0.00","0","50010.00","0");
INSERT INTO invoice_details VALUES("233","457761929655437","1249729836","454","","","5.00","380.00","370","1900.00","0.00","","0.00","0","50010.00","0");
INSERT INTO invoice_details VALUES("232","222246756133925","1249729836","61","","","40.00","150.00","160","6000.00","0.00","","0.00","0","50010.00","0");
INSERT INTO invoice_details VALUES("236","362464766861258","1249729836","220","","","5.00","200.00","180","1000.00","0.00","","0.00","0","50010.00","0");
INSERT INTO invoice_details VALUES("237","184274855435962","1249729836","219","","","1.00","400.00","380","400.00","0.00","","0.00","0","50010.00","0");
INSERT INTO invoice_details VALUES("238","366511792482375","1249729836","720","","","1.00","5500.00","5500","5500.00","0.00","","0.00","0","50010.00","0");
INSERT INTO invoice_details VALUES("239","876733469819743","1249729836","57","","","11.00","120.00","140","1320.00","0.00","","0.00","0","50010.00","0");
INSERT INTO invoice_details VALUES("240","599316591641317","1249729836","366","","","4.00","60.00","46","240.00","0.00","","0.00","0","50010.00","0");
INSERT INTO invoice_details VALUES("241","568381964925828","1249729836","254","","","6.00","250.00","230","1500.00","0.00","","0.00","0","50010.00","0");
INSERT INTO invoice_details VALUES("242","869954188555841","1249729836","407","","","2.00","350.00","330","700.00","0.00","","0.00","0","50010.00","0");
INSERT INTO invoice_details VALUES("243","919693681688297","1249729836","579","","","1.00","2500.00","2200","2500.00","0.00","","0.00","0","50010.00","0");
INSERT INTO invoice_details VALUES("244","155466913614966","1249729836","698","","","3.00","300.00","290","900.00","0.00","","0.00","0","50010.00","0");
INSERT INTO invoice_details VALUES("245","477384397185238","1249729836","693","","","1.00","200.00","130","200.00","0.00","","0.00","0","50010.00","0");
INSERT INTO invoice_details VALUES("246","346265766536699","1249729836","56","","","1.00","1200.00","1000","1200.00","0.00","","0.00","0","50010.00","0");
INSERT INTO invoice_details VALUES("247","737874231743167","1249729836","148","","","1.00","14500.00","14986","14500.00","0.00","","0.00","0","50010.00","0");
INSERT INTO invoice_details VALUES("248","272837215692646","1249729836","263","","","1.00","350.00","350","350.00","0.00","","0.00","0","50010.00","0");
INSERT INTO invoice_details VALUES("249","286291295119583","1249729836","462","","","1.00","9100.00","8650","9100.00","0.00","","0.00","0","50010.00","0");
INSERT INTO invoice_details VALUES("250","646145343246352","1249729836","572","","","2.00","375.00","250","750.00","0.00","","0.00","0","50010.00","0");
INSERT INTO invoice_details VALUES("256","977838441612412","9759274115","235","","","1.00","1150.00","1100","1150.00","0.00","","0.00","0","11010.00","0");
INSERT INTO invoice_details VALUES("255","516799392282633","9759274115","693","","","10.00","160.00","130","1600.00","0.00","","0.00","0","11010.00","0");
INSERT INTO invoice_details VALUES("254","741574344529477","9759274115","254","","","12.00","230.00","230","2760.00","0.00","","0.00","0","11010.00","0");
INSERT INTO invoice_details VALUES("257","687574852371844","9759274115","581","","","4.00","1200.00","1000","4800.00","0.00","","0.00","0","11010.00","0");
INSERT INTO invoice_details VALUES("258","279423951748177","9759274115","8","","","1.00","550.00","550","550.00","0.00","","0.00","0","11010.00","0");
INSERT INTO invoice_details VALUES("259","184615719325667","9759274115","264","","","1.00","150.00","80","150.00","0.00","","0.00","0","11010.00","0");
INSERT INTO invoice_details VALUES("277","633733972124326","7677745934","2","","","2.00","220.00","190","440.00","0.00","","0.00","0","7960.00","0");
INSERT INTO invoice_details VALUES("276","131467142238997","7677745934","103","","","1.00","320.00","320","320.00","0.00","","0.00","0","7960.00","0");
INSERT INTO invoice_details VALUES("275","416881818275698","7677745934","659","","","1.00","1200.00","1605","1200.00","0.00","","0.00","0","7960.00","0");
INSERT INTO invoice_details VALUES("274","577556122456884","7677745934","197","","","1.00","1600.00","1500","1600.00","0.00","","0.00","0","7960.00","0");
INSERT INTO invoice_details VALUES("273","325743679495484","7677745934","490","","","10.00","120.00","90","1200.00","0.00","","0.00","0","7960.00","0");
INSERT INTO invoice_details VALUES("272","789835843179914","7677745934","57","","","10.00","120.00","140","1200.00","0.00","","0.00","0","7960.00","0");
INSERT INTO invoice_details VALUES("278","395968142326326","7677745934","127","","","3.00","300.00","400","900.00","0.00","","0.00","0","7960.00","0");
INSERT INTO invoice_details VALUES("279","414441179449222","7677745934","110","","","1.00","1100.00","1296","1100.00","0.00","","0.00","0","7960.00","0");
INSERT INTO invoice_details VALUES("336","748415757548717","4651242384","416","","","2.00","5300.00","5000","10600.00","0.00","","0.00","0","19980.00","0");
INSERT INTO invoice_details VALUES("335","372199586711297","4651242384","139","","","1.00","2900.00","2961","2900.00","0.00","","0.00","0","19980.00","0");
INSERT INTO invoice_details VALUES("334","184178932935468","4651242384","728","","","3.00","280.00","260","840.00","0.00","","0.00","0","19980.00","0");
INSERT INTO invoice_details VALUES("333","526254827757169","4651242384","57","","","24.00","120.00","140","2880.00","0.00","","0.00","0","19980.00","0");
INSERT INTO invoice_details VALUES("332","349574273462936","4651242384","579","","","1.00","2280.00","2200","2280.00","0.00","","0.00","0","19980.00","0");
INSERT INTO invoice_details VALUES("331","415617539539687","4651242384","269","","","4.00","120.00","110","480.00","0.00","","0.00","0","19980.00","0");
INSERT INTO invoice_details VALUES("292","744742792766774","6139664445","420","","","1.00","3700.00","3936","3700.00","0.00","","","0","24740.00","1");
INSERT INTO invoice_details VALUES("293","596256551617536","6139664445","156","","","2.00","3060.00","3208","6120.00","0.00","","","0","24740.00","1");
INSERT INTO invoice_details VALUES("294","377619983296593","6139664445","665","","","2.00","3060.00","4935","6120.00","0.00","","","0","24740.00","1");
INSERT INTO invoice_details VALUES("295","456896119976381","6139664445","663","","","2.00","2200.00","3525","4400.00","0.00","","","0","24740.00","1");
INSERT INTO invoice_details VALUES("296","614386744414836","6139664445","664","","","2.00","2200.00","3525","4400.00","0.00","","","0","24740.00","1");
INSERT INTO invoice_details VALUES("297","892961548464737","9814175468","693","","","2.00","200.00","130","400.00","0.00","","","0","400.00","1");
INSERT INTO invoice_details VALUES("298","156695971178574","8729851784","248","","","3.00","400.00","320","1200.00","0.00","","","0","2400.00","1");
INSERT INTO invoice_details VALUES("299","932992459653421","8729851784","251","","","4.00","300.00","275","1200.00","0.00","","","0","2400.00","1");
INSERT INTO invoice_details VALUES("300","133242964988389","2724633553","57","","","2.00","125.00","140","250.00","0.00","","","0","63150.00","1");
INSERT INTO invoice_details VALUES("301","575829799913739","2724633553","625","","","1.00","50.00","41","50.00","0.00","","","0","63150.00","1");
INSERT INTO invoice_details VALUES("302","821333593228568","2724633553","157","","","5.00","3995.00","4190","19975.00","0.00","","","0","63150.00","1");
INSERT INTO invoice_details VALUES("303","357542639512544","2724633553","158","","","5.00","3995.00","4190","19975.00","0.00","","","0","63150.00","1");
INSERT INTO invoice_details VALUES("304","676819654982725","2724633553","659","","","5.00","970.00","1605","4850.00","0.00","","","0","63150.00","1");
INSERT INTO invoice_details VALUES("305","883891725575176","2724633553","660","","","5.00","970.00","1605","4850.00","0.00","","","0","63150.00","1");
INSERT INTO invoice_details VALUES("306","257676121275263","2724633553","663","","","3.00","2200.00","3525","6600.00","0.00","","","0","63150.00","1");
INSERT INTO invoice_details VALUES("307","358186167283778","2724633553","664","","","3.00","2200.00","3525","6600.00","0.00","","","0","63150.00","1");
INSERT INTO invoice_details VALUES("383","167929826192936","7644324833","72","","","4.00","2150.00","2250","8600.00","0.00","","0.00","0","55610.00","0");
INSERT INTO invoice_details VALUES("379","539653674178864","8125379816","213","","","2.00","200.00","170","400.00","0.00","","0.00","0","77005.00","0");
INSERT INTO invoice_details VALUES("378","331516948476838","8125379816","194","","","1.00","1500.00","1500","1500.00","0.00","","0.00","0","77005.00","0");
INSERT INTO invoice_details VALUES("377","274296789679919","8125379816","16","","","12.00","125.00","110","1500.00","0.00","","0.00","0","77005.00","0");
INSERT INTO invoice_details VALUES("376","611939117349953","8125379816","265","","","1.00","150.00","120","150.00","0.00","","0.00","0","77005.00","0");
INSERT INTO invoice_details VALUES("375","281197461638925","8125379816","387","","","19.00","500.00","486","9500.00","0.00","","0.00","0","77005.00","0");
INSERT INTO invoice_details VALUES("374","461773916119363","8125379816","399","","","15.00","325.00","287","4875.00","0.00","","0.00","0","77005.00","0");
INSERT INTO invoice_details VALUES("373","544532599481164","8125379816","681","","","4.00","375.00","310","1500.00","0.00","","0.00","0","77005.00","0");
INSERT INTO invoice_details VALUES("372","443938747917914","8125379816","680","","","4.00","350.00","336","1400.00","0.00","","0.00","0","77005.00","0");
INSERT INTO invoice_details VALUES("371","914391911324384","8125379816","254","","","10.00","250.00","230","2500.00","0.00","","0.00","0","77005.00","0");
INSERT INTO invoice_details VALUES("370","111372233373118","8125379816","698","","","10.00","350.00","290","3500.00","0.00","","0.00","0","77005.00","0");
INSERT INTO invoice_details VALUES("369","248957621752585","8125379816","359","","","1.00","16600.00","14400","16600.00","0.00","","0.00","0","77005.00","0");
INSERT INTO invoice_details VALUES("368","476816388285376","8125379816","57","","","10.00","130.00","140","1300.00","0.00","","0.00","0","77005.00","0");
INSERT INTO invoice_details VALUES("367","139586613749732","8125379816","412","","","1.00","12500.00","8800","12500.00","0.00","","0.00","0","77005.00","0");
INSERT INTO invoice_details VALUES("366","954936637478735","8125379816","625","","","12.00","50.00","41","600.00","0.00","","0.00","0","77005.00","0");
INSERT INTO invoice_details VALUES("365","384559855872819","8125379816","448","","","1.00","250.00","120","250.00","0.00","","0.00","0","77005.00","0");
INSERT INTO invoice_details VALUES("364","574263145924589","8125379816","11","","","15.00","110.00","105","1650.00","0.00","","0.00","0","77005.00","0");
INSERT INTO invoice_details VALUES("363","856213975947237","8125379816","72","","","2.00","2300.00","2250","4600.00","0.00","","0.00","0","77005.00","0");
INSERT INTO invoice_details VALUES("362","248698423298297","8125379816","71","","","1.00","2300.00","2250","2300.00","0.00","","0.00","0","77005.00","0");
INSERT INTO invoice_details VALUES("361","983631231248712","8125379816","199","","","2.00","1800.00","1900","3600.00","0.00","","0.00","0","77005.00","0");
INSERT INTO invoice_details VALUES("360","765715156211668","8125379816","198","","","3.00","2000.00","2100","6000.00","0.00","","0.00","0","77005.00","0");
INSERT INTO invoice_details VALUES("359","112165153326166","8125379816","114","","","1.00","500.00","480","500.00","0.00","","0.00","0","77005.00","0");
INSERT INTO invoice_details VALUES("358","743359196279167","8125379816","395","","","4.00","70.00","50","280.00","0.00","","0.00","0","77005.00","0");
INSERT INTO invoice_details VALUES("382","647324991112274","7644324833","71","","","5.00","2150.00","2250","10750.00","0.00","","0.00","0","55610.00","0");
INSERT INTO invoice_details VALUES("384","617441975256142","7644324833","411","","","3.00","3750.00","3300","11250.00","0.00","","0.00","0","55610.00","0");
INSERT INTO invoice_details VALUES("385","133891481499685","7644324833","304","","","1.00","2200.00","2000","2200.00","0.00","","0.00","0","55610.00","0");
INSERT INTO invoice_details VALUES("386","555358399826463","7644324833","344","","","1.00","2200.00","2000","2200.00","0.00","","0.00","0","55610.00","0");
INSERT INTO invoice_details VALUES("387","426929958517511","7644324833","305","","","1.00","3000.00","2900","3000.00","0.00","","0.00","0","55610.00","0");
INSERT INTO invoice_details VALUES("388","216857821935933","7644324833","345","","","1.00","3000.00","2900","3000.00","0.00","","0.00","0","55610.00","0");
INSERT INTO invoice_details VALUES("389","864283539733492","7644324833","776","","","4.00","500.00","486","2000.00","0.00","","0.00","0","55610.00","0");
INSERT INTO invoice_details VALUES("390","835362237983287","7644324833","678","","","5.00","300.00","286","1500.00","0.00","","0.00","0","55610.00","0");
INSERT INTO invoice_details VALUES("391","545864851355787","7644324833","495","","","1.00","780.00","650","780.00","0.00","","0.00","0","55610.00","0");
INSERT INTO invoice_details VALUES("392","318423189335773","7644324833","596","","","1.00","350.00","336","350.00","0.00","","0.00","0","55610.00","0");
INSERT INTO invoice_details VALUES("393","834135962214664","7644324833","680","","","1.00","350.00","336","350.00","0.00","","0.00","0","55610.00","0");
INSERT INTO invoice_details VALUES("394","346333663326486","7644324833","597","","","1.00","250.00","250","250.00","0.00","","0.00","0","55610.00","0");
INSERT INTO invoice_details VALUES("395","359692873214792","7644324833","219","","","1.00","400.00","380","400.00","0.00","","0.00","0","55610.00","0");
INSERT INTO invoice_details VALUES("396","718779994635147","7644324833","220","","","6.00","250.00","180","1500.00","0.00","","0.00","0","55610.00","0");
INSERT INTO invoice_details VALUES("397","831446893428635","7644324833","675","","","3.00","50.00","50","150.00","0.00","","0.00","0","55610.00","0");
INSERT INTO invoice_details VALUES("398","367136273621665","7644324833","213","","","1.00","200.00","170","200.00","0.00","","0.00","0","55610.00","0");
INSERT INTO invoice_details VALUES("399","687562815984531","7644324833","60","","","30.00","200.00","200","6000.00","0.00","","0.00","0","55610.00","0");
INSERT INTO invoice_details VALUES("400","265936958339557","7644324833","16","","","8.00","110.00","110","880.00","0.00","","0.00","0","55610.00","0");
INSERT INTO invoice_details VALUES("401","245761633748245","7644324833","693","","","1.00","200.00","130","200.00","0.00","","0.00","0","55610.00","0");
INSERT INTO invoice_details VALUES("402","641696785195719","7644324833","625","","","1.00","50.00","41","50.00","0.00","","0.00","0","55610.00","0");
INSERT INTO invoice_details VALUES("403","641245322219526","1345623824","695","","","12.00","270.00","280","3240.00","0.00","","","0","10730.00","1");
INSERT INTO invoice_details VALUES("404","739674345852764","1345623824","58","","","1.00","150.00","115","150.00","0.00","","","0","10730.00","1");
INSERT INTO invoice_details VALUES("405","776918189264319","1345623824","179","","","96.00","30.00","36","2880.00","0.00","","","0","10730.00","1");
INSERT INTO invoice_details VALUES("406","854927224594746","1345623824","420","","","1.00","3760.00","3936","3760.00","0.00","","","0","10730.00","1");
INSERT INTO invoice_details VALUES("407","835777831611949","1345623824","387","","","1.00","550.00","486","550.00","0.00","","","0","10730.00","1");
INSERT INTO invoice_details VALUES("408","576953745116387","1345623824","675","","","3.00","50.00","50","150.00","0.00","","","0","10730.00","1");
INSERT INTO invoice_details VALUES("409","762455895748679","5144393325","19","","","25.00","80.00","70","2000.00","0.00","","","0","2000.00","1");
INSERT INTO invoice_details VALUES("470","613249217274236","4148625191","679","","","1.00","300.00","259","300.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("469","395651317212299","4148625191","776","","","7.00","650.00","486","4550.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("468","961745127573834","4148625191","693","","","5.00","200.00","130","1000.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("467","336663834226666","4148625191","699","","","1.00","300.00","320","300.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("466","128386678466379","4148625191","19","","","12.00","100.00","70","1200.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("465","564989651862846","4148625191","366","","","1.00","50.00","46","50.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("464","149568735812428","4148625191","67","","","5.00","2650.00","2600","13250.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("463","665322178489437","4148625191","68","","","5.00","2650.00","2600","13250.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("462","327729741191341","4148625191","69","","","3.00","5800.00","5200","17400.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("461","844692951379881","4148625191","70","","","3.00","5800.00","5200","17400.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("460","548857425426989","4148625191","310","","","2.00","9800.00","8700","19600.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("459","516946555442881","4148625191","350","","","2.00","9800.00","8700","19600.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("458","152132744197124","4148625191","349","","","1.00","6800.00","6000","6800.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("457","157478632738781","4148625191","309","","","1.00","6800.00","6000","6800.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("456","885837968954648","4148625191","726","","","2.00","5200.00","4800","10400.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("455","981971915521131","4148625191","727","","","2.00","5200.00","4800","10400.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("454","931356426834123","4148625191","572","","","30.00","400.00","250","12000.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("453","394338771842659","4148625191","698","","","25.00","350.00","290","8750.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("452","822128337864741","4148625191","680","","","4.00","375.00","336","1500.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("451","434659329628628","4148625191","399","","","5.00","350.00","287","1750.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("450","798325627572243","4148625191","401","","","3.00","600.00","475","1800.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("471","296749377951571","4148625191","600","","","3.00","50.00","400","150.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("472","837928958396575","4148625191","213","","","1.00","250.00","170","250.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("473","225137717358869","4148625191","603","","","7.00","375.00","250","2625.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("474","148493185589418","4148625191","221","","","1.00","850.00","500","850.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("475","365942231211852","4148625191","448","","","1.00","250.00","120","250.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("476","221996651279368","4148625191","497","","","1.00","350.00","160","350.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("477","334317526671489","4148625191","625","","","8.00","50.00","41","400.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("478","646318193759319","4148625191","495","","","1.00","900.00","650","900.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("479","354817297369547","4148625191","254","","","4.00","250.00","230","1000.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("480","676679322684674","4148625191","693","","","2.00","200.00","130","400.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("481","949715813117994","4148625191","693","","","1.00","165.00","130","165.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("482","243724235359299","4148625191","448","","","1.00","180.00","120","180.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("483","683249735918718","4148625191","248","","","3.00","700.00","320","2100.00","0.00","","0.00","0","177720.00","0");
INSERT INTO invoice_details VALUES("497","318376959726294","4365216877","714","","","3.00","480.00","325","1440.00","0.00","","0.00","0","88130.00","0");
INSERT INTO invoice_details VALUES("496","287752375843539","4365216877","407","","","6.00","320.00","330","1920.00","0.00","","0.00","0","88130.00","0");
INSERT INTO invoice_details VALUES("495","126639754828849","4365216877","58","","","12.00","120.00","115","1440.00","0.00","","0.00","0","88130.00","0");
INSERT INTO invoice_details VALUES("494","962568889628874","4365216877","1","","","1.00","430.00","370","430.00","0.00","","0.00","0","88130.00","0");
INSERT INTO invoice_details VALUES("493","856247355895453","4365216877","494","","","1.00","300.00","290","300.00","0.00","","0.00","0","88130.00","0");
INSERT INTO invoice_details VALUES("498","163664638873521","4365216877","448","","","2.00","115.00","120","230.00","0.00","","0.00","0","88130.00","0");
INSERT INTO invoice_details VALUES("499","879942771595128","4365216877","497","","","1.00","160.00","160","160.00","0.00","","0.00","0","88130.00","0");
INSERT INTO invoice_details VALUES("500","257435847617927","4365216877","498","","","1.00","170.00","250","170.00","0.00","","0.00","0","88130.00","0");
INSERT INTO invoice_details VALUES("501","873825548996939","4365216877","419","","","1.00","6700.00","6731","6700.00","0.00","","0.00","0","88130.00","0");
INSERT INTO invoice_details VALUES("502","312976164647413","4365216877","660","","","3.00","1000.00","1605","3000.00","0.00","","0.00","0","88130.00","0");
INSERT INTO invoice_details VALUES("503","988768558217541","4365216877","659","","","3.00","1000.00","1605","3000.00","0.00","","0.00","0","88130.00","0");
INSERT INTO invoice_details VALUES("504","579193217367878","4365216877","662","","","3.00","1450.00","2395","4350.00","0.00","","0.00","0","88130.00","0");
INSERT INTO invoice_details VALUES("505","876745343147993","4365216877","661","","","3.00","1450.00","2395","4350.00","0.00","","0.00","0","88130.00","0");
INSERT INTO invoice_details VALUES("506","484658974418489","4365216877","663","","","2.00","2150.00","3525","4300.00","0.00","","0.00","0","88130.00","0");
INSERT INTO invoice_details VALUES("507","996918338926212","4365216877","664","","","2.00","2150.00","3525","4300.00","0.00","","0.00","0","88130.00","0");
INSERT INTO invoice_details VALUES("508","142243961815359","4365216877","670","","","3.00","4850.00","7885","14550.00","0.00","","0.00","0","88130.00","0");
INSERT INTO invoice_details VALUES("509","485318612265265","4365216877","669","","","3.00","4850.00","7885","14550.00","0.00","","0.00","0","88130.00","0");
INSERT INTO invoice_details VALUES("510","425358499139486","4365216877","102","","","16.00","480.00","450","7680.00","0.00","","0.00","0","88130.00","0");
INSERT INTO invoice_details VALUES("511","446123386913518","4365216877","57","","","12.00","130.00","140","1560.00","0.00","","0.00","0","88130.00","0");
INSERT INTO invoice_details VALUES("512","448781815488162","4365216877","238","","","12.00","330.00","320","3960.00","0.00","","0.00","0","88130.00","0");
INSERT INTO invoice_details VALUES("513","432699312252287","4365216877","219","","","6.00","540.00","380","3240.00","0.00","","0.00","0","88130.00","0");
INSERT INTO invoice_details VALUES("514","778277656971621","4365216877","2","","","2.00","240.00","190","480.00","0.00","","0.00","0","88130.00","0");
INSERT INTO invoice_details VALUES("515","671118995542676","4365216877","28","","","6.00","120.00","120","720.00","0.00","","0.00","0","88130.00","0");
INSERT INTO invoice_details VALUES("516","662138142722867","4365216877","68","","","1.00","2650.00","2600","2650.00","0.00","","0.00","0","88130.00","0");
INSERT INTO invoice_details VALUES("517","246487255714243","4365216877","67","","","1.00","2650.00","2600","2650.00","0.00","","0.00","0","88130.00","0");
INSERT INTO invoice_details VALUES("518","594682558159366","4863552591","9","","","2.00","450.00","430","900.00","0.00","","","0","1500.00","1");
INSERT INTO invoice_details VALUES("519","344428588461457","4863552591","60","","","3.00","200.00","200","600.00","0.00","","","0","1500.00","1");
INSERT INTO invoice_details VALUES("520","966227341517178","1589449478","15","","","6.00","125.00","135","750.00","0.00","","","0","10700.00","1");
INSERT INTO invoice_details VALUES("521","562786482724972","1589449478","57","","","1.00","150.00","140","150.00","0.00","","","0","10700.00","1");
INSERT INTO invoice_details VALUES("522","371543186745352","1589449478","145","","","1.00","9200.00","9331","9200.00","0.00","","","0","10700.00","1");
INSERT INTO invoice_details VALUES("523","318182547854388","1589449478","269","","","4.00","150.00","110","600.00","0.00","","","0","10700.00","1");
INSERT INTO invoice_details VALUES("524","237491866822533","4687811218","15","","","6.00","125.00","135","750.00","0.00","","","0","10700.00","1");
INSERT INTO invoice_details VALUES("525","659935231643578","4687811218","57","","","1.00","150.00","140","150.00","0.00","","","0","10700.00","1");
INSERT INTO invoice_details VALUES("526","635532726596783","4687811218","145","","","1.00","9200.00","9331","9200.00","0.00","","","0","10700.00","1");
INSERT INTO invoice_details VALUES("527","676268254434679","4687811218","269","","","4.00","150.00","110","600.00","0.00","","","0","10700.00","1");
INSERT INTO invoice_details VALUES("528","432727455393977","9619147336","71","","","1.00","2500.00","2250","2500.00","0.00","","","0","44520.00","1");
INSERT INTO invoice_details VALUES("529","736778111625657","9619147336","698","","","2.00","200.00","290","400.00","0.00","","","0","44520.00","1");
INSERT INTO invoice_details VALUES("530","215736467143313","9619147336","135","","","2.00","3000.00","2961","6000.00","0.00","","","0","44520.00","1");
INSERT INTO invoice_details VALUES("531","969424673879234","9619147336","136","","","1.00","3000.00","2961","3000.00","0.00","","","0","44520.00","1");
INSERT INTO invoice_details VALUES("532","267226753298424","9619147336","421","","","2.00","50.00","36","100.00","0.00","","","0","44520.00","1");
INSERT INTO invoice_details VALUES("533","126943181957561","9619147336","625","","","5.00","50.00","41","250.00","0.00","","","0","44520.00","1");
INSERT INTO invoice_details VALUES("534","936584637179862","9619147336","193","","","1.00","4200.00","1700","4200.00","0.00","","","0","44520.00","1");
INSERT INTO invoice_details VALUES("535","476239163334884","9619147336","247","","","1.00","850.00","650","850.00","0.00","","","0","44520.00","1");
INSERT INTO invoice_details VALUES("536","623281281368668","9619147336","236","","","1.00","900.00","920","900.00","0.00","","","0","44520.00","1");
INSERT INTO invoice_details VALUES("537","569941283262566","9619147336","700","","","50.00","150.00","160","7500.00","0.00","","","0","44520.00","1");
INSERT INTO invoice_details VALUES("538","293274575799194","9619147336","495","","","2.00","600.00","650","1200.00","0.00","","","0","44520.00","1");
INSERT INTO invoice_details VALUES("539","945231555312237","9619147336","219","","","1.00","340.00","380","340.00","0.00","","","0","44520.00","1");
INSERT INTO invoice_details VALUES("540","958593282898959","9619147336","220","","","7.00","170.00","180","1190.00","0.00","","","0","44520.00","1");
INSERT INTO invoice_details VALUES("541","446246664575654","9619147336","600","","","3.00","50.00","400","150.00","0.00","","","0","44520.00","1");
INSERT INTO invoice_details VALUES("542","338839442595469","9619147336","213","","","1.00","200.00","170","200.00","0.00","","","0","44520.00","1");
INSERT INTO invoice_details VALUES("543","549429248227212","9619147336","366","","","10.00","50.00","46","500.00","0.00","","","0","44520.00","1");
INSERT INTO invoice_details VALUES("544","566835751276982","9619147336","448","","","1.00","150.00","120","150.00","0.00","","","0","44520.00","1");
INSERT INTO invoice_details VALUES("545","152421358383824","9619147336","498","","","1.00","200.00","250","200.00","0.00","","","0","44520.00","1");
INSERT INTO invoice_details VALUES("546","744473465229468","9619147336","725","","","1.00","200.00","180","200.00","0.00","","","0","44520.00","1");
INSERT INTO invoice_details VALUES("547","273118136843458","9619147336","251","","","6.00","280.00","275","1680.00","0.00","","","0","44520.00","1");
INSERT INTO invoice_details VALUES("548","178774483624597","9619147336","67","","","1.00","2200.00","2600","2200.00","0.00","","","0","44520.00","1");
INSERT INTO invoice_details VALUES("549","645917326354893","9619147336","592","","","8.00","480.00","482","3840.00","0.00","","","0","44520.00","1");
INSERT INTO invoice_details VALUES("550","978833711891327","9619147336","594","","","12.00","280.00","290","3360.00","0.00","","","0","44520.00","1");
INSERT INTO invoice_details VALUES("551","165287159763269","9619147336","596","","","3.00","350.00","336","1050.00","0.00","","","0","44520.00","1");
INSERT INTO invoice_details VALUES("552","554182538121546","9619147336","484","","","4.00","250.00","275","1000.00","0.00","","","0","44520.00","1");
INSERT INTO invoice_details VALUES("553","956896686388129","9619147336","595","","","2.00","320.00","323","640.00","0.00","","","0","44520.00","1");
INSERT INTO invoice_details VALUES("554","933757953377588","9619147336","593","","","2.00","460.00","450","920.00","0.00","","","0","44520.00","1");
INSERT INTO invoice_details VALUES("576","357986172565187","2744992295","","","","1.00","0.00","0","0.00","0.00","","0.00","0","11530.00","0");
INSERT INTO invoice_details VALUES("575","853713682651148","2744992295","501","","","1.00","250.00","240","250.00","0.00","","0.00","0","11530.00","0");
INSERT INTO invoice_details VALUES("574","338639441361725","2744992295","271","","","1.00","240.00","120","240.00","0.00","","0.00","0","11530.00","0");
INSERT INTO invoice_details VALUES("573","732128831626718","2744992295","86","","","1.00","600.00","390","600.00","0.00","","0.00","0","11530.00","0");
INSERT INTO invoice_details VALUES("572","275126321894968","2744992295","284","","","4.00","50.00","40","200.00","0.00","","0.00","0","11530.00","0");
INSERT INTO invoice_details VALUES("571","238232375378274","2744992295","776","","","1.00","480.00","486","480.00","0.00","","0.00","0","11530.00","0");
INSERT INTO invoice_details VALUES("570","215937968819362","2744992295","625","","","3.00","50.00","41","150.00","0.00","","0.00","0","11530.00","0");
INSERT INTO invoice_details VALUES("569","176554313289555","2744992295","448","","","1.00","150.00","120","150.00","0.00","","0.00","0","11530.00","0");
INSERT INTO invoice_details VALUES("568","635964164626438","2744992295","399","","","3.00","320.00","287","960.00","0.00","","0.00","0","11530.00","0");
INSERT INTO invoice_details VALUES("567","927185432555559","2744992295","417","","","1.00","4500.00","4300","4500.00","0.00","","0.00","0","11530.00","0");
INSERT INTO invoice_details VALUES("566","847275216523113","2744992295","251","","","6.00","300.00","275","1800.00","0.00","","0.00","0","11530.00","0");



DROP TABLE language;

CREATE TABLE `language` (
  `id` int unsigned NOT NULL AUTO_INCREMENT,
  `phrase` text NOT NULL,
  `english` text,
  `bangla` text,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=919 DEFAULT CHARSET=utf8mb3;

INSERT INTO language VALUES("1","user_profile","User Profile","");
INSERT INTO language VALUES("2","setting","Setting","");
INSERT INTO language VALUES("3","language","Language","");
INSERT INTO language VALUES("4","manage_users","Manage Users","");
INSERT INTO language VALUES("5","add_user","Add User","");
INSERT INTO language VALUES("6","manage_company","Manage Company","");
INSERT INTO language VALUES("7","web_settings","Software Settings","");
INSERT INTO language VALUES("8","manage_accounts","Manage Accounts","");
INSERT INTO language VALUES("9","create_accounts","Create Account","");
INSERT INTO language VALUES("10","manage_bank","Manage Bank","");
INSERT INTO language VALUES("11","add_new_bank","Add New Bank","");
INSERT INTO language VALUES("12","settings","Settings","");
INSERT INTO language VALUES("13","closing_report","Closing Report","");
INSERT INTO language VALUES("14","closing","Closing","");
INSERT INTO language VALUES("15","cheque_manager","Cheque Manager","");
INSERT INTO language VALUES("16","accounts_summary","Accounts Summary","");
INSERT INTO language VALUES("17","expense","Expense","");
INSERT INTO language VALUES("18","income","Income","");
INSERT INTO language VALUES("19","accounts","Accounts","");
INSERT INTO language VALUES("20","stock_report","Stock Report","");
INSERT INTO language VALUES("21","stock","Stock","");
INSERT INTO language VALUES("22","pos_invoice","POS Sale","");
INSERT INTO language VALUES("23","manage_invoice","Manage Sale","");
INSERT INTO language VALUES("24","new_invoice","New Sale","");
INSERT INTO language VALUES("25","invoice","Sale","");
INSERT INTO language VALUES("26","manage_purchase","Manage Purchase","");
INSERT INTO language VALUES("27","add_purchase","Add Purchase","");
INSERT INTO language VALUES("28","purchase","Purchase","");
INSERT INTO language VALUES("29","paid_customer","Paid Customer","");
INSERT INTO language VALUES("30","manage_customer","Manage Customer","");
INSERT INTO language VALUES("31","add_customer","Add Customer","");
INSERT INTO language VALUES("32","customer","Customer","");
INSERT INTO language VALUES("33","supplier_payment_actual","Supplier Payment Ledger","");
INSERT INTO language VALUES("34","supplier_sales_summary","Supplier Sales Summary","");
INSERT INTO language VALUES("35","supplier_sales_details","Supplier Sales Details","");
INSERT INTO language VALUES("36","supplier_ledger","Supplier Ledger","");
INSERT INTO language VALUES("37","manage_supplier","Manage Supplier","");
INSERT INTO language VALUES("38","add_supplier","Add Supplier","");
INSERT INTO language VALUES("39","supplier","Supplier","");
INSERT INTO language VALUES("40","product_statement","Product Statement","");
INSERT INTO language VALUES("41","manage_product","Manage Product","");
INSERT INTO language VALUES("42","add_product","Add Product","");
INSERT INTO language VALUES("43","product","Product","");
INSERT INTO language VALUES("44","manage_category","Manage Category","");
INSERT INTO language VALUES("45","add_category","Add Category","");
INSERT INTO language VALUES("46","category","Category","");
INSERT INTO language VALUES("47","sales_report_product_wise","Sales Report (Product Wise)","");
INSERT INTO language VALUES("48","purchase_report","Purchase Report","");
INSERT INTO language VALUES("49","sales_report","Sales Report","");
INSERT INTO language VALUES("50","todays_report","Todays Report","");
INSERT INTO language VALUES("51","report","Report","");
INSERT INTO language VALUES("52","dashboard","Dashboard","");
INSERT INTO language VALUES("53","online","Online","");
INSERT INTO language VALUES("54","logout","Logout","");
INSERT INTO language VALUES("55","change_password","Change Password","");
INSERT INTO language VALUES("56","total_purchase","Total Purchase","");
INSERT INTO language VALUES("57","total_amount","Total Amount","");
INSERT INTO language VALUES("58","supplier_name","Supplier Name","");
INSERT INTO language VALUES("59","invoice_no","Invoice No","");
INSERT INTO language VALUES("60","purchase_date","Purchase Date","");
INSERT INTO language VALUES("61","todays_purchase_report","Todays Purchase Report","");
INSERT INTO language VALUES("62","total_sales","Total Sales","");
INSERT INTO language VALUES("63","customer_name","Customer Name","");
INSERT INTO language VALUES("64","sales_date","Sales Date","");
INSERT INTO language VALUES("65","todays_sales_report","Todays Sales Report","");
INSERT INTO language VALUES("66","home","Home","");
INSERT INTO language VALUES("67","todays_sales_and_purchase_report","Todays sales and purchase report","");
INSERT INTO language VALUES("68","total_ammount","Total Amount","");
INSERT INTO language VALUES("69","rate","Rate","");
INSERT INTO language VALUES("70","product_model","Product Model","");
INSERT INTO language VALUES("71","product_name","Product Name","");
INSERT INTO language VALUES("72","search","Search","");
INSERT INTO language VALUES("73","end_date","End Date","");
INSERT INTO language VALUES("74","start_date","Start Date","");
INSERT INTO language VALUES("75","total_purchase_report","Total Purchase Report","");
INSERT INTO language VALUES("76","total_sales_report","Total Sales Report","");
INSERT INTO language VALUES("77","total_seles","Total Sales","");
INSERT INTO language VALUES("78","all_stock_report","All Stock Report","");
INSERT INTO language VALUES("79","search_by_product","Search By Product","");
INSERT INTO language VALUES("80","date","Date","");
INSERT INTO language VALUES("81","print","Print","");
INSERT INTO language VALUES("82","stock_date","Stock Date","");
INSERT INTO language VALUES("83","print_date","Print Date","");
INSERT INTO language VALUES("84","sales","Sales","");
INSERT INTO language VALUES("85","price","Price","");
INSERT INTO language VALUES("86","sl","SL.","");
INSERT INTO language VALUES("87","add_new_category","Add new category","");
INSERT INTO language VALUES("88","category_name","Category Name","");
INSERT INTO language VALUES("89","save","Save","");
INSERT INTO language VALUES("90","delete","Delete","");
INSERT INTO language VALUES("91","update","Update","");
INSERT INTO language VALUES("92","action","Action","");
INSERT INTO language VALUES("93","manage_your_category","Manage your category ","");
INSERT INTO language VALUES("94","category_edit","Category Edit","");
INSERT INTO language VALUES("95","status","Status","");
INSERT INTO language VALUES("96","active","Active","");
INSERT INTO language VALUES("97","inactive","Inactive","");
INSERT INTO language VALUES("98","save_changes","Save Changes","");
INSERT INTO language VALUES("99","save_and_add_another","Save And Add Another","");
INSERT INTO language VALUES("100","model","Model","");
INSERT INTO language VALUES("101","supplier_price","Supplier Price","");
INSERT INTO language VALUES("102","sell_price","Sale Price","");
INSERT INTO language VALUES("103","image","Image","");
INSERT INTO language VALUES("104","select_one","Select One","");
INSERT INTO language VALUES("105","details","Details","");
INSERT INTO language VALUES("106","new_product","New Product","");
INSERT INTO language VALUES("107","add_new_product","Add new product","");
INSERT INTO language VALUES("108","barcode","Barcode","");
INSERT INTO language VALUES("109","qr_code","Qr-Code","");
INSERT INTO language VALUES("110","product_details","Product Details","");
INSERT INTO language VALUES("111","manage_your_product","Manage your product","");
INSERT INTO language VALUES("112","product_edit","Product Edit","");
INSERT INTO language VALUES("113","edit_your_product","Edit your product","");
INSERT INTO language VALUES("114","cancel","Cancel","");
INSERT INTO language VALUES("115","incl_vat","Incl. Vat","");
INSERT INTO language VALUES("116","money","TK","");
INSERT INTO language VALUES("117","grand_total","Grand Total","");
INSERT INTO language VALUES("118","quantity","Qnty","");
INSERT INTO language VALUES("119","product_report","Product Report","");
INSERT INTO language VALUES("120","product_sales_and_purchase_report","Product sales and purchase report","");
INSERT INTO language VALUES("121","previous_stock","Previous Stock","");
INSERT INTO language VALUES("122","out","Out","");
INSERT INTO language VALUES("123","in","In","");
INSERT INTO language VALUES("124","to","To","");
INSERT INTO language VALUES("125","previous_balance","Previous Credit Balance","");
INSERT INTO language VALUES("126","customer_address","Customer Address","");
INSERT INTO language VALUES("127","customer_mobile","Customer Mobile","");
INSERT INTO language VALUES("128","customer_email","Customer Email","");
INSERT INTO language VALUES("129","add_new_customer","Add new customer","");
INSERT INTO language VALUES("130","balance","Balance","");
INSERT INTO language VALUES("131","mobile","Mobile","");
INSERT INTO language VALUES("132","address","Address","");
INSERT INTO language VALUES("133","manage_your_customer","Manage your customer","");
INSERT INTO language VALUES("134","customer_edit","Customer Edit","");
INSERT INTO language VALUES("135","paid_customer_list","Paid Customer List","");
INSERT INTO language VALUES("136","ammount","Amount","");
INSERT INTO language VALUES("137","customer_ledger","Customer Ledger","");
INSERT INTO language VALUES("138","manage_customer_ledger","Manage Customer Ledger","");
INSERT INTO language VALUES("139","customer_information","Customer Information","");
INSERT INTO language VALUES("140","debit_ammount","Debit Amount","");
INSERT INTO language VALUES("141","credit_ammount","Credit Amount","");
INSERT INTO language VALUES("142","balance_ammount","Balance Amount","");
INSERT INTO language VALUES("143","receipt_no","Receipt NO","");
INSERT INTO language VALUES("144","description","Description","");
INSERT INTO language VALUES("145","debit","Debit","");
INSERT INTO language VALUES("146","credit","Credit","");
INSERT INTO language VALUES("147","item_information","Item Information","");
INSERT INTO language VALUES("148","total","Total","");
INSERT INTO language VALUES("149","please_select_supplier","Please Select Supplier","");
INSERT INTO language VALUES("150","submit","Submit","");
INSERT INTO language VALUES("151","submit_and_add_another","Submit And Add Another One","");
INSERT INTO language VALUES("152","add_new_item","Add New Item","");
INSERT INTO language VALUES("153","manage_your_purchase","Manage your purchase","");
INSERT INTO language VALUES("154","purchase_edit","Purchase Edit","");
INSERT INTO language VALUES("155","purchase_ledger","Purchase Ledger","");
INSERT INTO language VALUES("156","invoice_information","Sale Information","");
INSERT INTO language VALUES("157","paid_ammount","Paid Amount","");
INSERT INTO language VALUES("158","discount","Dis./Pcs.","");
INSERT INTO language VALUES("159","save_and_paid","Save And Paid","");
INSERT INTO language VALUES("160","payee_name","Payee Name","");
INSERT INTO language VALUES("161","manage_your_invoice","Manage your Sale","");
INSERT INTO language VALUES("162","invoice_edit","Sale Edit","");
INSERT INTO language VALUES("163","new_pos_invoice","New POS Sale","");
INSERT INTO language VALUES("164","add_new_pos_invoice","Add new pos Sale","");
INSERT INTO language VALUES("165","product_id","Product ID","");
INSERT INTO language VALUES("166","paid_amount","Paid Amount","");
INSERT INTO language VALUES("167","authorised_by","Authorised By","");
INSERT INTO language VALUES("168","checked_by","Checked By","");
INSERT INTO language VALUES("169","received_by","Received By","");
INSERT INTO language VALUES("170","prepared_by","Prepared By","");
INSERT INTO language VALUES("171","memo_no","Memo No","");
INSERT INTO language VALUES("172","website","Website","");
INSERT INTO language VALUES("173","email","Email","");
INSERT INTO language VALUES("174","invoice_details","Sale Details","");
INSERT INTO language VALUES("175","reset","Reset","");
INSERT INTO language VALUES("176","payment_account","Payment Account","");
INSERT INTO language VALUES("177","bank_name","Bank Name","");
INSERT INTO language VALUES("178","cheque_or_pay_order_no","Cheque/Pay Order No","");
INSERT INTO language VALUES("179","payment_type","Payment Type","");
INSERT INTO language VALUES("180","payment_from","Payment From","");
INSERT INTO language VALUES("181","payment_date","Payment Date","");
INSERT INTO language VALUES("182","add_income","Add Income","");
INSERT INTO language VALUES("183","cash","Cash","");
INSERT INTO language VALUES("184","cheque","Cheque","");
INSERT INTO language VALUES("185","pay_order","Pay Order","");
INSERT INTO language VALUES("186","payment_to","Payment To","");
INSERT INTO language VALUES("187","total_outflow_ammount","Total Expense Amount","");
INSERT INTO language VALUES("188","transections","Transections","");
INSERT INTO language VALUES("189","accounts_name","Accounts Name","");
INSERT INTO language VALUES("190","outflow_report","Expense Report","");
INSERT INTO language VALUES("191","inflow_report","Income Report","");
INSERT INTO language VALUES("192","all","All","");
INSERT INTO language VALUES("193","account","Account","");
INSERT INTO language VALUES("194","from","From","");
INSERT INTO language VALUES("195","account_summary_report","Account Summary Report","");
INSERT INTO language VALUES("196","search_by_date","Search By Date","");
INSERT INTO language VALUES("197","cheque_no","Cheque No","");
INSERT INTO language VALUES("198","name","Name","");
INSERT INTO language VALUES("199","closing_account","Closing Account","");
INSERT INTO language VALUES("200","close_your_account","Close your account","");
INSERT INTO language VALUES("201","last_day_closing","Last Day Closing","");
INSERT INTO language VALUES("202","cash_in","Cash In","");
INSERT INTO language VALUES("203","cash_out","Cash Out","");
INSERT INTO language VALUES("204","cash_in_hand","Cash In Hand","");
INSERT INTO language VALUES("205","add_new_bank","Add New Bank","");
INSERT INTO language VALUES("206","day_closing","Day Closing","");
INSERT INTO language VALUES("207","account_closing_report","Account Closing Report","");
INSERT INTO language VALUES("208","last_day_ammount","Last Day Amount","");
INSERT INTO language VALUES("209","adjustment","Adjustment","");
INSERT INTO language VALUES("210","pay_type","Pay Type","");
INSERT INTO language VALUES("211","customer_or_supplier","Customer,Supplier Or Others","");
INSERT INTO language VALUES("212","transection_id","Transections ID","");
INSERT INTO language VALUES("213","accounts_summary_report","Accounts Summary Report","");
INSERT INTO language VALUES("214","bank_list","Bank List","");
INSERT INTO language VALUES("215","bank_edit","Bank Edit","");
INSERT INTO language VALUES("216","debit_plus","Debit (+)","");
INSERT INTO language VALUES("217","credit_minus","Credit (-)","");
INSERT INTO language VALUES("218","account_name","Account Name","");
INSERT INTO language VALUES("219","account_type","Account Type","");
INSERT INTO language VALUES("220","account_real_name","Account Real Name","");
INSERT INTO language VALUES("221","manage_account","Manage Account","");
INSERT INTO language VALUES("222","company_name","Niha International","");
INSERT INTO language VALUES("223","edit_your_company_information","Edit your company information","");
INSERT INTO language VALUES("224","company_edit","Company Edit","");
INSERT INTO language VALUES("225","admin","Admin","");
INSERT INTO language VALUES("226","user","User","");
INSERT INTO language VALUES("227","password","Password","");
INSERT INTO language VALUES("228","last_name","Last Name","");
INSERT INTO language VALUES("229","first_name","First Name","");
INSERT INTO language VALUES("230","add_new_user_information","Add new user information","");
INSERT INTO language VALUES("231","user_type","User Type","");
INSERT INTO language VALUES("232","user_edit","User Edit","");
INSERT INTO language VALUES("233","rtr","RTR","");
INSERT INTO language VALUES("234","ltr","LTR","");
INSERT INTO language VALUES("235","ltr_or_rtr","LTR/RTR","");
INSERT INTO language VALUES("236","footer_text","Footer Text","");
INSERT INTO language VALUES("237","favicon","Favicon","");
INSERT INTO language VALUES("238","logo","Logo","");
INSERT INTO language VALUES("239","update_setting","Update Setting","");
INSERT INTO language VALUES("240","update_your_web_setting","Update your web setting","");
INSERT INTO language VALUES("241","login","Login","");
INSERT INTO language VALUES("242","your_strong_password","Your strong password","");
INSERT INTO language VALUES("243","your_unique_email","Your unique email","");
INSERT INTO language VALUES("244","please_enter_your_login_information","Please enter your login information.","");
INSERT INTO language VALUES("245","update_profile","Update Profile","");
INSERT INTO language VALUES("246","your_profile","Your Profile","");
INSERT INTO language VALUES("247","re_type_password","Re-Type Password","");
INSERT INTO language VALUES("248","new_password","New Password","");
INSERT INTO language VALUES("249","old_password","Old Password","");
INSERT INTO language VALUES("250","new_information","New Information","");
INSERT INTO language VALUES("251","old_information","Old Information","");
INSERT INTO language VALUES("252","change_your_information","Change your information","");
INSERT INTO language VALUES("253","change_your_profile","Change your profile","");
INSERT INTO language VALUES("254","profile","Profile","");
INSERT INTO language VALUES("255","wrong_username_or_password","Wrong User Name Or Password !","");
INSERT INTO language VALUES("256","successfully_updated","Successfully Updated.","");
INSERT INTO language VALUES("257","blank_field_does_not_accept","Blank Field Does Not Accept !","");
INSERT INTO language VALUES("258","successfully_changed_password","Successfully changed password.","");
INSERT INTO language VALUES("259","you_are_not_authorised_person","You are not authorised person !","");
INSERT INTO language VALUES("260","password_and_repassword_does_not_match","Passwor and re-password does not match !","");
INSERT INTO language VALUES("261","new_password_at_least_six_character","New Password At Least 6 Character.","");
INSERT INTO language VALUES("262","you_put_wrong_email_address","You put wrong email address !","");
INSERT INTO language VALUES("263","cheque_ammount_asjusted","Cheque amount adjusted.","");
INSERT INTO language VALUES("264","successfully_payment_paid","Successfully Payment Paid.","");
INSERT INTO language VALUES("265","successfully_added","Successfully Added.","");
INSERT INTO language VALUES("266","successfully_updated_2_closing_ammount_not_changeale","Successfully Updated -2. Note: Closing Amount Not Changeable.","");
INSERT INTO language VALUES("267","successfully_payment_received","Successfully Payment Received.","");
INSERT INTO language VALUES("268","already_inserted","Already Inserted !","");
INSERT INTO language VALUES("269","successfully_delete","Successfully Delete.","");
INSERT INTO language VALUES("270","successfully_created","Successfully Created.","");
INSERT INTO language VALUES("271","logo_not_uploaded","Logo not uploaded !","");
INSERT INTO language VALUES("272","favicon_not_uploaded","Favicon not uploaded !","");
INSERT INTO language VALUES("273","supplier_mobile","Supplier Mobile","");
INSERT INTO language VALUES("274","supplier_address","Supplier Address","");
INSERT INTO language VALUES("275","supplier_details","Supplier Details","");
INSERT INTO language VALUES("276","add_new_supplier","Add New Supplier","");
INSERT INTO language VALUES("277","manage_suppiler","Manage Supplier","");
INSERT INTO language VALUES("278","manage_your_supplier","Manage your supplier","");
INSERT INTO language VALUES("279","manage_supplier_ledger","Manage supplier ledger","");
INSERT INTO language VALUES("280","invoice_id","Invoice ID","");
INSERT INTO language VALUES("281","deposite_id","Deposite ID","");
INSERT INTO language VALUES("282","supplier_actual_ledger","Supplier Payment Ledger","");
INSERT INTO language VALUES("283","supplier_information","Supplier Information","");
INSERT INTO language VALUES("284","event","Event","");
INSERT INTO language VALUES("285","add_new_income","Add New Income","");
INSERT INTO language VALUES("286","add_expese","Add Expense","");
INSERT INTO language VALUES("287","add_new_expense","Add New Expense","");
INSERT INTO language VALUES("288","total_inflow_ammount","Total Income Amount","");
INSERT INTO language VALUES("289","create_new_invoice","Create New Sale","");
INSERT INTO language VALUES("290","create_pos_invoice","Create POS Sale","");
INSERT INTO language VALUES("291","total_profit","Total Profit","");
INSERT INTO language VALUES("292","monthly_progress_report","Monthly Progress Report","");
INSERT INTO language VALUES("293","total_invoice","Total Sale","");
INSERT INTO language VALUES("294","account_summary","Account Summary","");
INSERT INTO language VALUES("295","total_supplier","Total Supplier","");
INSERT INTO language VALUES("296","total_product","Total Product","");
INSERT INTO language VALUES("297","total_customer","Total Customer","");
INSERT INTO language VALUES("298","supplier_edit","Supplier Edit","");
INSERT INTO language VALUES("299","add_new_invoice","Add New Sale","");
INSERT INTO language VALUES("300","add_new_purchase","Add new purchase","");
INSERT INTO language VALUES("301","currency","Currency","");
INSERT INTO language VALUES("302","currency_position","Currency Position","");
INSERT INTO language VALUES("303","left","Left","");
INSERT INTO language VALUES("304","right","Right","");
INSERT INTO language VALUES("305","add_tax","Add Tax","");
INSERT INTO language VALUES("306","manage_tax","Manage Tax","");
INSERT INTO language VALUES("307","add_new_tax","Add new tax","");
INSERT INTO language VALUES("308","enter_tax","Enter Tax","");
INSERT INTO language VALUES("309","already_exists","Already Exists !","");
INSERT INTO language VALUES("310","successfully_inserted","Successfully Inserted.","");
INSERT INTO language VALUES("311","tax","Tax","");
INSERT INTO language VALUES("312","tax_edit","Tax Edit","");
INSERT INTO language VALUES("313","product_not_added","Product not added !","");
INSERT INTO language VALUES("314","total_tax","Total Tax","");
INSERT INTO language VALUES("315","manage_your_supplier_details","Manage your supplier details.","");
INSERT INTO language VALUES("316","invoice_description","Lorem Ipsum is sim ply dummy Lorem Ipsum is simply dummy Lorem Ipsum is simply dummy Lorem Ipsum is simply dummy Lorem Ipsum is simply dummy Lorem Ipsum is sim ply dummy Lorem Ipsum is simply dummy Lorem Ipsum is simply dummy Lorem Ipsum is simply dummy Lorem Ipsum is simply dummy","");
INSERT INTO language VALUES("317","thank_you_for_choosing_us","Thank you very much for choosing us.","");
INSERT INTO language VALUES("318","billing_date","Billing Date","");
INSERT INTO language VALUES("319","billing_to","Billing To","");
INSERT INTO language VALUES("320","billing_from","Billing From","");
INSERT INTO language VALUES("321","you_cant_delete_this_product","Sorry !!  You can\'t delete this product.This product already used in calculation system!","");
INSERT INTO language VALUES("322","old_customer","Old Customer","");
INSERT INTO language VALUES("323","new_customer","New Customer","");
INSERT INTO language VALUES("324","new_supplier","New Supplier","");
INSERT INTO language VALUES("325","old_supplier","Old Supplier","");
INSERT INTO language VALUES("326","credit_customer","Credit Customer","");
INSERT INTO language VALUES("327","account_already_exists","This Account Already Exists !","");
INSERT INTO language VALUES("328","edit_income","Edit Income","");
INSERT INTO language VALUES("329","you_are_not_access_this_part","You are not authorised person !","");
INSERT INTO language VALUES("330","account_edit","Account Edit","");
INSERT INTO language VALUES("331","due","Due","");
INSERT INTO language VALUES("332","expense_edit","Expense Edit","");
INSERT INTO language VALUES("333","please_select_customer","Please select customer !","");
INSERT INTO language VALUES("334","profit_report","Profit Report (Sale Wise)","");
INSERT INTO language VALUES("335","total_profit_report","Total profit report","");
INSERT INTO language VALUES("336","please_enter_valid_captcha","Please enter valid captcha.","");
INSERT INTO language VALUES("337","category_not_selected","Category not selected.","");
INSERT INTO language VALUES("338","supplier_not_selected","Supplier not selected.","");
INSERT INTO language VALUES("339","please_select_product","Please select product.","");
INSERT INTO language VALUES("340","product_model_already_exist","Product model already exist !","");
INSERT INTO language VALUES("341","invoice_logo","Sale Logo","");
INSERT INTO language VALUES("342","available_qnty","Av. Qnty.","");
INSERT INTO language VALUES("343","you_can_not_buy_greater_than_available_cartoon","You can not select grater than available cartoon !","");
INSERT INTO language VALUES("344","customer_details","Customer details","");
INSERT INTO language VALUES("345","manage_customer_details","Manage customer details.","");
INSERT INTO language VALUES("346","site_key","Captcha Site Key","");
INSERT INTO language VALUES("347","secret_key","Captcha Secret Key","");
INSERT INTO language VALUES("348","captcha","Captcha","");
INSERT INTO language VALUES("349","cartoon_quantity","Cartoon Quantity","");
INSERT INTO language VALUES("350","total_cartoon","Total Cartoon","");
INSERT INTO language VALUES("351","cartoon","Cartoon","");
INSERT INTO language VALUES("352","item_cartoon","Item/Cartoon","");
INSERT INTO language VALUES("353","product_and_supplier_did_not_match","Product and supplier did not match !","");
INSERT INTO language VALUES("354","if_you_update_purchase_first_select_supplier_then_product_and_then_quantity","If you update purchase,first select supplier then product and then update qnty.","");
INSERT INTO language VALUES("355","item","Item","");
INSERT INTO language VALUES("356","manage_your_credit_customer","Manage your credit customer","");
INSERT INTO language VALUES("357","total_quantity","Total Quantity","");
INSERT INTO language VALUES("358","quantity_per_cartoon","Quantity per cartoon","");
INSERT INTO language VALUES("359","barcode_qrcode_scan_here","Barcode or QR-code scan here","");
INSERT INTO language VALUES("360","synchronizer_setting","Synchronizer Setting","");
INSERT INTO language VALUES("361","data_synchronizer","Data Synchronizer","");
INSERT INTO language VALUES("362","hostname","Host name","");
INSERT INTO language VALUES("363","username","User Name","");
INSERT INTO language VALUES("364","ftp_port","FTP Port","");
INSERT INTO language VALUES("365","ftp_debug","FTP Debug","");
INSERT INTO language VALUES("366","project_root","Project Root","");
INSERT INTO language VALUES("367","please_try_again","Please try again","");
INSERT INTO language VALUES("368","save_successfully","Save successfully","");
INSERT INTO language VALUES("369","synchronize","Synchronize","");
INSERT INTO language VALUES("370","internet_connection","Internet Connection","");
INSERT INTO language VALUES("371","outgoing_file","Outgoing File","");
INSERT INTO language VALUES("372","incoming_file","Incoming File","");
INSERT INTO language VALUES("373","ok","Ok","");
INSERT INTO language VALUES("374","not_available","Not Available","");
INSERT INTO language VALUES("375","available","Available","");
INSERT INTO language VALUES("376","download_data_from_server","Download data from server","");
INSERT INTO language VALUES("377","data_import_to_database","Data import to database","");
INSERT INTO language VALUES("378","data_upload_to_server","Data uplod to server","");
INSERT INTO language VALUES("379","please_wait","Please Wait","");
INSERT INTO language VALUES("380","ooops_something_went_wrong","Oooops Something went wrong !","");
INSERT INTO language VALUES("381","upload_successfully","Upload successfully","");
INSERT INTO language VALUES("382","unable_to_upload_file_please_check_configuration","Unable to upload file please check configuration","");
INSERT INTO language VALUES("383","please_configure_synchronizer_settings","Please configure synchronizer settings","");
INSERT INTO language VALUES("384","download_successfully","Download successfully","");
INSERT INTO language VALUES("385","unable_to_download_file_please_check_configuration","Unable to download file please check configuration","");
INSERT INTO language VALUES("386","data_import_first","Data import past","");
INSERT INTO language VALUES("387","data_import_successfully","Data import successfully","");
INSERT INTO language VALUES("388","unable_to_import_data_please_check_config_or_sql_file","Unable to import data please check config or sql file","");
INSERT INTO language VALUES("389","total_sale_ctn","Total Sale Ctn","");
INSERT INTO language VALUES("390","in_qnty","In Qnty.","");
INSERT INTO language VALUES("391","out_qnty","Out Qnty.","");
INSERT INTO language VALUES("392","stock_report_supplier_wise","Stock Report (Supplier Wise)","");
INSERT INTO language VALUES("393","all_stock_report_supplier_wise","Stock Report (Suppler Wise)","");
INSERT INTO language VALUES("394","select_supplier","Select Supplier","");
INSERT INTO language VALUES("395","stock_report_product_wise","Stock Report (Product Wise)","");
INSERT INTO language VALUES("396","phone","Phone","");
INSERT INTO language VALUES("397","select_product","Select Product","");
INSERT INTO language VALUES("398","in_quantity","In Qnty.","");
INSERT INTO language VALUES("399","out_quantity","Out Qnty.","");
INSERT INTO language VALUES("400","in_taka","In TK.","");
INSERT INTO language VALUES("401","out_taka","Out TK.","");
INSERT INTO language VALUES("402","commission","Commission","");
INSERT INTO language VALUES("403","generate_commission","Generate Commssion","");
INSERT INTO language VALUES("404","commission_rate","Commission Rate","");
INSERT INTO language VALUES("405","total_ctn","Total Ctn.","");
INSERT INTO language VALUES("406","per_pcs_commission","Per PCS Commission","");
INSERT INTO language VALUES("407","total_commission","Total Commission","");
INSERT INTO language VALUES("408","enter","Enter","");
INSERT INTO language VALUES("409","please_add_walking_customer_for_default_customer","Please add \'Walking Customer\' for default customer.","");
INSERT INTO language VALUES("410","supplier_ammount","Supplier Amount","");
INSERT INTO language VALUES("411","my_sale_ammount","My Sale Amount","");
INSERT INTO language VALUES("412","signature_pic","Signature Picture","");
INSERT INTO language VALUES("413","branch","Branch","");
INSERT INTO language VALUES("414","ac_no","A/C Number","");
INSERT INTO language VALUES("415","ac_name","A/C Name","");
INSERT INTO language VALUES("416","bank_transaction","Bank Transaction","");
INSERT INTO language VALUES("417","bank","Bank","");
INSERT INTO language VALUES("418","withdraw_deposite_id","Withdraw / Deposite ID","");
INSERT INTO language VALUES("419","bank_ledger","Bank Ledger","");
INSERT INTO language VALUES("420","note_name","Note Name","");
INSERT INTO language VALUES("421","pcs","Pcs.","");
INSERT INTO language VALUES("422","1","1","");
INSERT INTO language VALUES("423","2","2","");
INSERT INTO language VALUES("424","5","5","");
INSERT INTO language VALUES("425","10","10","");
INSERT INTO language VALUES("426","20","20","");
INSERT INTO language VALUES("427","50","50","");
INSERT INTO language VALUES("428","100","100","");
INSERT INTO language VALUES("429","500","500","");
INSERT INTO language VALUES("430","1000","1000","");
INSERT INTO language VALUES("431","total_discount","Total Discount","");
INSERT INTO language VALUES("432","product_not_found","Product not found !","");
INSERT INTO language VALUES("433","this_is_not_credit_customer","This is not credit customer !","");
INSERT INTO language VALUES("434","personal_loan","Personal Loan","");
INSERT INTO language VALUES("435","add_person","Add Person","");
INSERT INTO language VALUES("436","add_loan","Add Loan","");
INSERT INTO language VALUES("437","add_payment","Add Payment","");
INSERT INTO language VALUES("438","manage_person","Manage Person","");
INSERT INTO language VALUES("439","personal_edit","Person Edit","");
INSERT INTO language VALUES("440","person_ledger","Person Ledger","");
INSERT INTO language VALUES("441","backup_restore","Backup ","");
INSERT INTO language VALUES("442","database_backup","Database backup","");
INSERT INTO language VALUES("443","file_information","File information","");
INSERT INTO language VALUES("444","filename","Filename","");
INSERT INTO language VALUES("445","size","Size","");
INSERT INTO language VALUES("446","backup_date","Backup date","");
INSERT INTO language VALUES("447","backup_now","Backup now","");
INSERT INTO language VALUES("448","restore_now","Restore now","");
INSERT INTO language VALUES("449","are_you_sure","Are you sure ?","");
INSERT INTO language VALUES("450","download","Download","");
INSERT INTO language VALUES("451","backup_and_restore","Backup","");
INSERT INTO language VALUES("452","backup_successfully","Backup successfully","");
INSERT INTO language VALUES("453","delete_successfully","Delete successfully","");
INSERT INTO language VALUES("454","stock_ctn","Stock/Qnt","");
INSERT INTO language VALUES("455","unit","Unit","");
INSERT INTO language VALUES("456","meter_m","Meter (M)","");
INSERT INTO language VALUES("457","piece_pc","Piece (Pc)","");
INSERT INTO language VALUES("458","kilogram_kg","Kilogram (Kg)","");
INSERT INTO language VALUES("459","stock_cartoon","Stock Cartoon","");
INSERT INTO language VALUES("460","add_product_csv","Add Product (CSV)","");
INSERT INTO language VALUES("461","import_product_csv","Import product (CSV)","");
INSERT INTO language VALUES("462","close","Close","");
INSERT INTO language VALUES("463","download_example_file","Download example file.","");
INSERT INTO language VALUES("464","upload_csv_file","Upload CSV File","");
INSERT INTO language VALUES("465","csv_file_informaion","CSV File Information","");
INSERT INTO language VALUES("466","out_of_stock","Out Of Stock","");
INSERT INTO language VALUES("467","others","Others","");
INSERT INTO language VALUES("468","full_paid","Full Paid","");
INSERT INTO language VALUES("469","successfully_saved","Your Data Successfully Saved","");
INSERT INTO language VALUES("470","manage_loan","Manage Loan","");
INSERT INTO language VALUES("471","receipt","Receipt","");
INSERT INTO language VALUES("472","payment","Payment","");
INSERT INTO language VALUES("473","cashflow","Daily Cash Flow","");
INSERT INTO language VALUES("474","signature","Signature","");
INSERT INTO language VALUES("475","supplier_reports","Supplier Reports","");
INSERT INTO language VALUES("476","generate","Generate","");
INSERT INTO language VALUES("477","todays_overview","Todays Overview","");
INSERT INTO language VALUES("478","last_sales","Last Sales","");
INSERT INTO language VALUES("479","manage_transaction","Manage Transaction","");
INSERT INTO language VALUES("480","daily_summary","Daily Summary","");
INSERT INTO language VALUES("481","daily_cash_flow","Daily Cash Flow","");
INSERT INTO language VALUES("482","custom_report","Custom Report","");
INSERT INTO language VALUES("483","transaction","Transaction","");
INSERT INTO language VALUES("484","receipt_amount","Receipt Amount","");
INSERT INTO language VALUES("485","transaction_details_datewise","Transaction Details Datewise","");
INSERT INTO language VALUES("486","cash_closing","Cash Closing","");
INSERT INTO language VALUES("487","you_can_not_buy_greater_than_available_qnty","You can not buy greater than available qnty.","");
INSERT INTO language VALUES("488","supplier_id","Supplier ID","");
INSERT INTO language VALUES("489","category_id","Category ID","");
INSERT INTO language VALUES("490","select_report","Select Report","");
INSERT INTO language VALUES("491","supplier_summary","Supplier summary","");
INSERT INTO language VALUES("492","sales_payment_actual","Sales payment actual","");
INSERT INTO language VALUES("493","today_already_closed","Today already closed.","");
INSERT INTO language VALUES("494","root_account","Root Account","");
INSERT INTO language VALUES("495","office","Office","");
INSERT INTO language VALUES("496","loan","Loan","");
INSERT INTO language VALUES("497","transaction_mood","Transaction Mood","");
INSERT INTO language VALUES("498","select_account","Select Account","");
INSERT INTO language VALUES("499","add_receipt","Add Receipt","");
INSERT INTO language VALUES("500","update_transaction","Update Transaction","");
INSERT INTO language VALUES("501","no_stock_found","No Stock Found !","");
INSERT INTO language VALUES("502","admin_login_area","Admin Login Area","");
INSERT INTO language VALUES("503","print_qr_code","Print QR Code","");
INSERT INTO language VALUES("504","discount_type","Discount Type","");
INSERT INTO language VALUES("505","discount_percentage","Discount","");
INSERT INTO language VALUES("506","fixed_dis","Fixed Dis.","");
INSERT INTO language VALUES("507","return","Return","");
INSERT INTO language VALUES("508","stock_return_list","Stock Return List","");
INSERT INTO language VALUES("509","wastage_return_list","Wastage Return List","");
INSERT INTO language VALUES("510","return_invoice","Sale Return","");
INSERT INTO language VALUES("511","sold_qty","Sold Qty","");
INSERT INTO language VALUES("512","ret_quantity","Return Qty","");
INSERT INTO language VALUES("513","deduction","Deduction","");
INSERT INTO language VALUES("514","check_return","Check Return","");
INSERT INTO language VALUES("515","reason","Reason","");
INSERT INTO language VALUES("516","usablilties","Usability","");
INSERT INTO language VALUES("517","adjs_with_stck","Adjust With Stock","");
INSERT INTO language VALUES("518","return_to_supplier","Return To Supplier","");
INSERT INTO language VALUES("519","wastage","Wastage","");
INSERT INTO language VALUES("520","to_deduction","Total Deduction ","");
INSERT INTO language VALUES("521","nt_return","Net Return Amount","");
INSERT INTO language VALUES("522","return_list","Return List","");
INSERT INTO language VALUES("523","add_return","Add Return","");
INSERT INTO language VALUES("524","per_qty","Purchase Qty","");
INSERT INTO language VALUES("525","return_supplier","Supplier Return","");
INSERT INTO language VALUES("526","stock_purchase","Stock Purchase Price","");
INSERT INTO language VALUES("527","stock_sale","Stock Sale Price","");
INSERT INTO language VALUES("528","supplier_return","Supplier Return","");
INSERT INTO language VALUES("529","purchase_id","Purchase ID","");
INSERT INTO language VALUES("530","return_id","Return ID","");
INSERT INTO language VALUES("531","supplier_return_list","Supplier Return List","");
INSERT INTO language VALUES("532","c_r_slist","Stock Return Stock","");
INSERT INTO language VALUES("533","wastage_list","Wastage List","");
INSERT INTO language VALUES("534","please_input_correct_invoice_id","Please Input a Correct Sale ID","");
INSERT INTO language VALUES("535","please_input_correct_purchase_id","Please Input Your Correct  Purchase ID","");
INSERT INTO language VALUES("536","add_more","Add More","");
INSERT INTO language VALUES("537","prouct_details","Product Details","");
INSERT INTO language VALUES("538","prouct_detail","Product Details","");
INSERT INTO language VALUES("539","stock_return","Stock Return","");
INSERT INTO language VALUES("540","choose_transaction","Select Transaction","");
INSERT INTO language VALUES("541","transection_category","Select  Category","");
INSERT INTO language VALUES("542","transaction_categry","Select Category","");
INSERT INTO language VALUES("543","search_supplier","Search Supplier","");
INSERT INTO language VALUES("544","customer_id","Customer ID","");
INSERT INTO language VALUES("545","search_customer","Search Customer Invoice","");
INSERT INTO language VALUES("546","serial_no","SN","");
INSERT INTO language VALUES("547","item_discount","Item Discount","");
INSERT INTO language VALUES("548","invoice_discount","Sale Discount","");
INSERT INTO language VALUES("549","add_unit","Add Unit","");
INSERT INTO language VALUES("550","manage_unit","Manage Unit","");
INSERT INTO language VALUES("551","add_new_unit","Add New Unit","");
INSERT INTO language VALUES("552","unit_name","Unit Name","");
INSERT INTO language VALUES("553","payment_amount","Payment Amount","");
INSERT INTO language VALUES("554","manage_your_unit","Manage Your Unit","");
INSERT INTO language VALUES("555","unit_id","Unit ID","");
INSERT INTO language VALUES("556","unit_edit","Unit Edit","");
INSERT INTO language VALUES("557","vat","Vat","");
INSERT INTO language VALUES("558","sales_report_category_wise","Sales Report (Category wise)","");
INSERT INTO language VALUES("559","purchase_report_category_wise","Purchase Report (Category wise)","");
INSERT INTO language VALUES("560","category_wise_purchase_report","Category wise purchase report","");
INSERT INTO language VALUES("561","category_wise_sales_report","Category wise sales report","");
INSERT INTO language VALUES("562","best_sale_product","Best Sale Product","");
INSERT INTO language VALUES("563","all_best_sales_product","All Best Sales Products","");
INSERT INTO language VALUES("564","todays_customer_receipt","Todays Customer Receipt","");
INSERT INTO language VALUES("565","not_found","Record not found","");
INSERT INTO language VALUES("566","collection","Collection","");
INSERT INTO language VALUES("567","increment","Increment","");
INSERT INTO language VALUES("568","accounts_tree_view","Accounts Tree View","");
INSERT INTO language VALUES("569","debit_voucher","Debit Voucher","");
INSERT INTO language VALUES("570","voucher_no","Voucher No","");
INSERT INTO language VALUES("571","credit_account_head","Credit Account Head","");
INSERT INTO language VALUES("572","remark","Remark","");
INSERT INTO language VALUES("573","code","Code","");
INSERT INTO language VALUES("574","amount","Amount","");
INSERT INTO language VALUES("575","approved","Approved","");
INSERT INTO language VALUES("576","debit_account_head","Debit Account Head","");
INSERT INTO language VALUES("577","credit_voucher","Credit Voucher","");
INSERT INTO language VALUES("578","find","Find","");
INSERT INTO language VALUES("579","transaction_date","Transaction Date","");
INSERT INTO language VALUES("580","voucher_type","Voucher Type","");
INSERT INTO language VALUES("581","particulars","Particulars","");
INSERT INTO language VALUES("582","with_details","With Details","");
INSERT INTO language VALUES("583","general_ledger","General Ledger","");
INSERT INTO language VALUES("584","general_ledger_of","General ledger of","");
INSERT INTO language VALUES("585","pre_balance","Pre Balance","");
INSERT INTO language VALUES("586","current_balance","Current Balance","");
INSERT INTO language VALUES("587","to_date","To Date","");
INSERT INTO language VALUES("588","from_date","From Date","");
INSERT INTO language VALUES("589","trial_balance","Trial Balance","");
INSERT INTO language VALUES("590","authorized_signature","Authorized Signature","");
INSERT INTO language VALUES("591","chairman","Chairman","");
INSERT INTO language VALUES("592","total_income","Total Income","");
INSERT INTO language VALUES("593","statement_of_comprehensive_income","Statement of Comprehensive Income","");
INSERT INTO language VALUES("594","profit_loss","Profit Loss","");
INSERT INTO language VALUES("595","cash_flow_report","Cash Flow Report","");
INSERT INTO language VALUES("596","cash_flow_statement","Cash Flow Statement","");
INSERT INTO language VALUES("597","amount_in_dollar","Amount In Dollar","");
INSERT INTO language VALUES("598","opening_cash_and_equivalent","Opening Cash and Equivalent","");
INSERT INTO language VALUES("599","coa_print","Coa Print","");
INSERT INTO language VALUES("600","cash_flow","Cash Flow","");
INSERT INTO language VALUES("601","cash_book","Cash Book","");
INSERT INTO language VALUES("602","bank_book","Bank Book","");
INSERT INTO language VALUES("603","c_o_a","Chart of Account","");
INSERT INTO language VALUES("604","journal_voucher","Journal Voucher","");
INSERT INTO language VALUES("605","contra_voucher","Contra Voucher","");
INSERT INTO language VALUES("606","voucher_approval","Vouchar Approval","");
INSERT INTO language VALUES("607","supplier_payment","Supplier Payment","");
INSERT INTO language VALUES("608","customer_receive","Customer Receive","");
INSERT INTO language VALUES("609","gl_head","General Head","");
INSERT INTO language VALUES("610","account_code","Account Head","");
INSERT INTO language VALUES("611","opening_balance","Opening Balance","");
INSERT INTO language VALUES("612","head_of_account","Head of Account","");
INSERT INTO language VALUES("613","inventory_ledger","Inventory Ledger","");
INSERT INTO language VALUES("614","newpassword","New Password","");
INSERT INTO language VALUES("615","password_recovery","Password Recovery","");
INSERT INTO language VALUES("616","forgot_password","Forgot Password ??","");
INSERT INTO language VALUES("617","send","Send","");
INSERT INTO language VALUES("618","due_report","Due Report","");
INSERT INTO language VALUES("619","due_amount","Due Amount","");
INSERT INTO language VALUES("620","download_sample_file","Download Sample File","");
INSERT INTO language VALUES("621","customer_csv_upload","Customer Csv Upload","");
INSERT INTO language VALUES("622","csv_supplier","Csv Upload Supplier","");
INSERT INTO language VALUES("623","csv_upload_supplier","Csv Upload Supplier","");
INSERT INTO language VALUES("624","previous","Previous","");
INSERT INTO language VALUES("625","net_total","Net Total","");
INSERT INTO language VALUES("626","currency_list","Currency List","");
INSERT INTO language VALUES("627","currency_name","Currency Name","");
INSERT INTO language VALUES("628","currency_icon","Currency Symbol","");
INSERT INTO language VALUES("629","add_currency","Add Currency","");
INSERT INTO language VALUES("630","role_permission","Role Permission","");
INSERT INTO language VALUES("631","role_list","Role List","");
INSERT INTO language VALUES("632","user_assign_role","User Assign Role","");
INSERT INTO language VALUES("633","permission","Permission","");
INSERT INTO language VALUES("634","add_role","Add Role","");
INSERT INTO language VALUES("635","add_module","Add Module","");
INSERT INTO language VALUES("636","module_name","Module Name","");
INSERT INTO language VALUES("637","office_loan","Office Loan","");
INSERT INTO language VALUES("638","add_menu","Add Menu","");
INSERT INTO language VALUES("639","menu_name","Menu Name","");
INSERT INTO language VALUES("640","sl_no","Sl No","");
INSERT INTO language VALUES("641","create","Create","");
INSERT INTO language VALUES("642","read","Read","");
INSERT INTO language VALUES("643","role_name","Role Name","");
INSERT INTO language VALUES("644","qty","Quantity","");
INSERT INTO language VALUES("645","max_rate","Max Rate","");
INSERT INTO language VALUES("646","min_rate","Min Rate","");
INSERT INTO language VALUES("647","avg_rate","Average Rate","");
INSERT INTO language VALUES("648","role_permission_added_successfully","Role Permission Successfully Added","");
INSERT INTO language VALUES("649","update_successfully","Successfully Updated","");
INSERT INTO language VALUES("650","role_permission_updated_successfully","Role Permission Successfully Updated ","");
INSERT INTO language VALUES("651","shipping_cost","Shipping Cost","");
INSERT INTO language VALUES("652","in_word","In Word ","");
INSERT INTO language VALUES("653","shipping_cost_report","Shipping Cost Report","");
INSERT INTO language VALUES("654","cash_book_report","Cash Book Report","");
INSERT INTO language VALUES("655","inventory_ledger_report","Inventory Ledger Report","");
INSERT INTO language VALUES("656","trial_balance_with_opening_as_on","Trial Balance With Opening As On","");
INSERT INTO language VALUES("657","type","Type","");
INSERT INTO language VALUES("658","taka_only","Taka Only","");
INSERT INTO language VALUES("659","item_description","Desc","");
INSERT INTO language VALUES("660","sold_by","Sold By","");
INSERT INTO language VALUES("661","user_wise_sales_report","User Wise Sales Report","");
INSERT INTO language VALUES("662","user_name","User Name","");
INSERT INTO language VALUES("663","total_sold","Total Sold","");
INSERT INTO language VALUES("664","user_wise_sale_report","User Wise Sales Report","");
INSERT INTO language VALUES("665","barcode_or_qrcode","Barcode/QR-code","");
INSERT INTO language VALUES("666","category_csv_upload","Category Csv  Upload","");
INSERT INTO language VALUES("667","unit_csv_upload","Unit Csv Upload","");
INSERT INTO language VALUES("668","invoice_return_list","Sales Return list","");
INSERT INTO language VALUES("669","invoice_return","Sales Return","");
INSERT INTO language VALUES("670","tax_report","Tax Report","");
INSERT INTO language VALUES("671","select_tax","Select Tax","");
INSERT INTO language VALUES("672","hrm","HRM","");
INSERT INTO language VALUES("673","employee","Employee","");
INSERT INTO language VALUES("674","add_employee","Add Employee","");
INSERT INTO language VALUES("675","manage_employee","Manage Employee","");
INSERT INTO language VALUES("676","attendance","Attendance","");
INSERT INTO language VALUES("677","add_attendance","Attendance","");
INSERT INTO language VALUES("678","manage_attendance","Manage Attendance","");
INSERT INTO language VALUES("679","payroll","Payroll","");
INSERT INTO language VALUES("680","add_payroll","Payroll","");
INSERT INTO language VALUES("681","manage_payroll","Manage Payroll","");
INSERT INTO language VALUES("682","employee_type","Employee Type","");
INSERT INTO language VALUES("683","employee_designation","Employee Designation","");
INSERT INTO language VALUES("684","designation","Designation","");
INSERT INTO language VALUES("685","add_designation","Add Designation","");
INSERT INTO language VALUES("686","manage_designation","Manage Designation","");
INSERT INTO language VALUES("687","designation_update_form","Designation Update form","");
INSERT INTO language VALUES("688","picture","Picture","");
INSERT INTO language VALUES("689","country","Country","");
INSERT INTO language VALUES("690","blood_group","Blood Group","");
INSERT INTO language VALUES("691","address_line_1","Address Line 1","");
INSERT INTO language VALUES("692","address_line_2","Address Line 2","");
INSERT INTO language VALUES("693","zip","Zip code","");
INSERT INTO language VALUES("694","city","City","");
INSERT INTO language VALUES("695","hour_rate_or_salary","Houre Rate/Salary","");
INSERT INTO language VALUES("696","rate_type","Rate Type","");
INSERT INTO language VALUES("697","hourly","Hourly","");
INSERT INTO language VALUES("698","salary","Salary","");
INSERT INTO language VALUES("699","employee_update","Employee Update","");
INSERT INTO language VALUES("700","checkin","Check In","");
INSERT INTO language VALUES("701","employee_name","Employee Name","");
INSERT INTO language VALUES("702","checkout","Check Out","");
INSERT INTO language VALUES("703","confirm_clock","Confirm Clock","");
INSERT INTO language VALUES("704","stay","Stay Time","");
INSERT INTO language VALUES("705","sign_in","Sign In","");
INSERT INTO language VALUES("706","check_in","Check In","");
INSERT INTO language VALUES("707","single_checkin","Single Check In","");
INSERT INTO language VALUES("708","bulk_checkin","Bulk Check In","");
INSERT INTO language VALUES("709","successfully_checkout","Successfully Checkout","");
INSERT INTO language VALUES("710","attendance_report","Attendance Report","");
INSERT INTO language VALUES("711","datewise_report","Date Wise Report","");
INSERT INTO language VALUES("712","employee_wise_report","Employee Wise Report","");
INSERT INTO language VALUES("713","date_in_time_report","Date In Time Report","");
INSERT INTO language VALUES("714","request","Request","");
INSERT INTO language VALUES("715","sign_out","Sign Out","");
INSERT INTO language VALUES("716","work_hour","Work Hours","");
INSERT INTO language VALUES("717","s_time","Start Time","");
INSERT INTO language VALUES("718","e_time","In Time","");
INSERT INTO language VALUES("719","salary_benefits_type","Benefits Type","");
INSERT INTO language VALUES("720","salary_benefits","Salary Benefits","");
INSERT INTO language VALUES("721","beneficial_list","Benefit List","");
INSERT INTO language VALUES("722","add_beneficial","Add Benefits","");
INSERT INTO language VALUES("723","add_benefits","Add Benefits","");
INSERT INTO language VALUES("724","benefits_list","Benefit List","");
INSERT INTO language VALUES("725","benefit_type","Benefit Type","");
INSERT INTO language VALUES("726","benefits","Benefit","");
INSERT INTO language VALUES("727","manage_benefits","Manage Benefits","");
INSERT INTO language VALUES("728","deduct","Deduct","");
INSERT INTO language VALUES("729","add","Add","");
INSERT INTO language VALUES("730","add_salary_setup","Add Salary Setup","");
INSERT INTO language VALUES("731","manage_salary_setup","Manage Salary Setup","");
INSERT INTO language VALUES("732","basic","Basic","");
INSERT INTO language VALUES("733","salary_type","Salary Type","");
INSERT INTO language VALUES("734","addition","Addition","");
INSERT INTO language VALUES("735","gross_salary","Gross Salary","");
INSERT INTO language VALUES("736","set","Set","");
INSERT INTO language VALUES("737","salary_generate","Salary Generate","");
INSERT INTO language VALUES("738","manage_salary_generate","Manage Salary Generate","");
INSERT INTO language VALUES("739","sal_name","Salary Name","");
INSERT INTO language VALUES("740","gdate","Generated Date","");
INSERT INTO language VALUES("741","generate_by","Generated By","");
INSERT INTO language VALUES("742","the_salary_of","The Salary of ","");
INSERT INTO language VALUES("743","already_generated"," Already Generated","");
INSERT INTO language VALUES("744","salary_month","Salary Month","");
INSERT INTO language VALUES("745","successfully_generated","Successfully Generated","");
INSERT INTO language VALUES("746","salary_payment","Salary Payment","");
INSERT INTO language VALUES("747","employee_salary_payment","Employee Salary Payment","");
INSERT INTO language VALUES("748","total_salary","Total Salary","");
INSERT INTO language VALUES("749","total_working_minutes","Total Working Hours","");
INSERT INTO language VALUES("750","working_period","Working Period","");
INSERT INTO language VALUES("751","paid_by","Paid By","");
INSERT INTO language VALUES("752","pay_now","Pay Now ","");
INSERT INTO language VALUES("753","confirm","Confirm","");
INSERT INTO language VALUES("754","successfully_paid","Successfully Paid","");
INSERT INTO language VALUES("755","add_incometax","Add Income Tax","");
INSERT INTO language VALUES("756","setup_tax","Setup Tax","");
INSERT INTO language VALUES("757","start_amount","Start Amount","");
INSERT INTO language VALUES("758","end_amount","End Amount","");
INSERT INTO language VALUES("759","tax_rate","Tax Rate","");
INSERT INTO language VALUES("760","setup","Setup","");
INSERT INTO language VALUES("761","manage_income_tax","Manage Income Tax","");
INSERT INTO language VALUES("762","income_tax_updateform","Income tax Update form","");
INSERT INTO language VALUES("763","positional_information","Positional Information","");
INSERT INTO language VALUES("764","personal_information","Personal Information","");
INSERT INTO language VALUES("765","timezone","Time Zone","");
INSERT INTO language VALUES("766","sms","SMS","");
INSERT INTO language VALUES("767","sms_configure","SMS Configure","");
INSERT INTO language VALUES("768","url","URL","");
INSERT INTO language VALUES("769","sender_id","Sender ID","");
INSERT INTO language VALUES("770","api_key","Api Key","");
INSERT INTO language VALUES("771","gui_pos","GUI POS","");
INSERT INTO language VALUES("772","manage_service","Manage Service","");
INSERT INTO language VALUES("773","service","Service","");
INSERT INTO language VALUES("774","add_service","Add Service","");
INSERT INTO language VALUES("775","service_edit","Service Edit","");
INSERT INTO language VALUES("776","service_csv_upload","Service CSV Upload","");
INSERT INTO language VALUES("777","service_name","Service Name","");
INSERT INTO language VALUES("778","charge","Charge","");
INSERT INTO language VALUES("779","service_invoice","Service Invoice","");
INSERT INTO language VALUES("780","service_discount","Service Discount","");
INSERT INTO language VALUES("781","hanging_over","ETD","");
INSERT INTO language VALUES("782","service_details","Service Details","");
INSERT INTO language VALUES("783","tax_settings","Tax Settings","");
INSERT INTO language VALUES("784","default_value","Default Value","");
INSERT INTO language VALUES("785","number_of_tax","Number of Tax","");
INSERT INTO language VALUES("786","please_select_employee","Please Select Employee","");
INSERT INTO language VALUES("787","manage_service_invoice","Manage Service Invoice","");
INSERT INTO language VALUES("788","update_service_invoice","Update Service Invoice","");
INSERT INTO language VALUES("789","customer_wise_tax_report","Customer Wise  Tax Report","");
INSERT INTO language VALUES("790","service_id","Service Id","");
INSERT INTO language VALUES("791","invoice_wise_tax_report","Invoice Wise Tax Report","");
INSERT INTO language VALUES("792","reg_no","Reg No","");
INSERT INTO language VALUES("793","update_now","Update Now","");
INSERT INTO language VALUES("794","import","Import","");
INSERT INTO language VALUES("795","add_expense_item","Add Expense Item","");
INSERT INTO language VALUES("796","manage_expense_item","Manage Expense Item","");
INSERT INTO language VALUES("797","add_expense","Add Expense","");
INSERT INTO language VALUES("798","manage_expense","Manage Expense","");
INSERT INTO language VALUES("799","expense_statement","Expense Statement","");
INSERT INTO language VALUES("800","expense_type","Expense Type","");
INSERT INTO language VALUES("801","expense_item_name","Expense Item Name","");
INSERT INTO language VALUES("802","stock_purchase_price","Stock Purchase Price","");
INSERT INTO language VALUES("803","purchase_price","Purchase Price","");
INSERT INTO language VALUES("804","customer_advance","Customer Advance","");
INSERT INTO language VALUES("805","advance_type","Advance Type","");
INSERT INTO language VALUES("806","restore","Restore","");
INSERT INTO language VALUES("807","supplier_advance","Supplier Advance","");
INSERT INTO language VALUES("808","please_input_correct_invoice_no","Please Input Correct Invoice NO","");
INSERT INTO language VALUES("809","backup","Back Up","");
INSERT INTO language VALUES("810","app_setting","App Settings","");
INSERT INTO language VALUES("811","local_server_url","Local Server Url","");
INSERT INTO language VALUES("812","online_server_url","Online Server Url","");
INSERT INTO language VALUES("813","connet_url","Connected Hotspot Ip/url","");
INSERT INTO language VALUES("814","update_your_app_setting","Update Your App Setting","");
INSERT INTO language VALUES("815","select_category","Select Category","");
INSERT INTO language VALUES("816","mini_invoice","Mini Invoice","");
INSERT INTO language VALUES("817","purchase_details","Purchase Details","");
INSERT INTO language VALUES("818","disc","Dis %","");
INSERT INTO language VALUES("819","serial","Serial","");
INSERT INTO language VALUES("820","transaction_head","Transaction Head","");
INSERT INTO language VALUES("821","transaction_type","Transaction Type","");
INSERT INTO language VALUES("822","return_details","Return Details","");
INSERT INTO language VALUES("823","return_to_customer","Return To Customer","");
INSERT INTO language VALUES("824","sales_and_purchase_report_summary","Sales And Purchase Report Summary","");
INSERT INTO language VALUES("825","add_person_officeloan","Add Person (Office Loan)","");
INSERT INTO language VALUES("826","add_loan_officeloan","Add Loan (Office Loan)","");
INSERT INTO language VALUES("827","add_payment_officeloan","Add Payment (Office Loan)","");
INSERT INTO language VALUES("828","manage_loan_officeloan","Manage Loan (Office Loan)","");
INSERT INTO language VALUES("829","add_person_personalloan","Add Person (Personal Loan)","");
INSERT INTO language VALUES("830","add_loan_personalloan","Add Loan (Personal Loan)","");
INSERT INTO language VALUES("831","add_payment_personalloan","Add Payment (Personal Loan)","");
INSERT INTO language VALUES("832","manage_loan_personalloan","Manage Loan (Personal)","");
INSERT INTO language VALUES("833","hrm_management","Human Resource","");
INSERT INTO language VALUES("834","cash_adjustment","Cash Adjustment","");
INSERT INTO language VALUES("835","adjustment_type","Adjustment Type","");
INSERT INTO language VALUES("836","change","Change","");
INSERT INTO language VALUES("837","sale_by","Sale By","");
INSERT INTO language VALUES("838","salary_date","Salary Date","");
INSERT INTO language VALUES("839","earnings","Earnings","");
INSERT INTO language VALUES("840","total_addition","Total Addition","");
INSERT INTO language VALUES("841","total_deduction","Total Deduction","");
INSERT INTO language VALUES("842","net_salary","Net Salary","");
INSERT INTO language VALUES("843","ref_number","Reference Number","");
INSERT INTO language VALUES("844","name_of_bank","Name Of Bank","");
INSERT INTO language VALUES("845","salary_slip","Salary Slip","");
INSERT INTO language VALUES("846","basic_salary","Basic Salary","");
INSERT INTO language VALUES("847","return_from_customer","Return From Customer","");
INSERT INTO language VALUES("848","quotation","Quotation","");
INSERT INTO language VALUES("849","add_quotation","Add Quotation","");
INSERT INTO language VALUES("850","manage_quotation","Manage Quotation","");
INSERT INTO language VALUES("851","terms","Terms","");
INSERT INTO language VALUES("852","send_to_customer","Sent To Customer","");
INSERT INTO language VALUES("853","quotation_no","Quotation No","");
INSERT INTO language VALUES("854","quotation_date","Quotation Date","");
INSERT INTO language VALUES("855","total_service_tax","Total Service Tax","");
INSERT INTO language VALUES("856","totalservicedicount","Total Service Discount","");
INSERT INTO language VALUES("857","item_total","Item Total","");
INSERT INTO language VALUES("858","service_total","Service Total","");
INSERT INTO language VALUES("859","quot_description","Quotation Description","");
INSERT INTO language VALUES("860","sub_total","Sub Total","");
INSERT INTO language VALUES("861","mail_setting","Mail Setting","");
INSERT INTO language VALUES("862","mail_configuration","Mail Configuration","");
INSERT INTO language VALUES("863","mail","Mail","");
INSERT INTO language VALUES("864","protocol","Protocol","");
INSERT INTO language VALUES("865","smtp_host","SMTP Host","");
INSERT INTO language VALUES("866","smtp_port","SMTP Port","");
INSERT INTO language VALUES("867","sender_mail","Sender Mail","");
INSERT INTO language VALUES("868","mail_type","Mail Type","");
INSERT INTO language VALUES("869","html","HTML","");
INSERT INTO language VALUES("870","text","TEXT","");
INSERT INTO language VALUES("871","expiry_date","Expiry Date","");
INSERT INTO language VALUES("872","api_secret","Api Secret","");
INSERT INTO language VALUES("873","please_config_your_mail_setting","","");
INSERT INTO language VALUES("874","quotation_successfully_added","Quotation Successfully Added","");
INSERT INTO language VALUES("875","add_to_invoice","Add To Invoice","");
INSERT INTO language VALUES("876","added_to_invoice","Added To Invoice","");
INSERT INTO language VALUES("877","closing_balance","Closing Balance","");
INSERT INTO language VALUES("878","contact","Contact","");
INSERT INTO language VALUES("879","fax","Fax","");
INSERT INTO language VALUES("880","state","State","");
INSERT INTO language VALUES("881","discounts","Discount","");
INSERT INTO language VALUES("882","address1","Address1","");
INSERT INTO language VALUES("883","address2","Address2","");
INSERT INTO language VALUES("884","receive","Receive","");
INSERT INTO language VALUES("885","purchase_history","Purchase History","");
INSERT INTO language VALUES("886","cash_payment","Cash Payment","");
INSERT INTO language VALUES("887","bank_payment","Bank Payment","");
INSERT INTO language VALUES("888","do_you_want_to_print","Do You Want to Print","");
INSERT INTO language VALUES("889","yes","Yes","");
INSERT INTO language VALUES("890","no","No","");
INSERT INTO language VALUES("891","todays_sale","Today\'s Sales","");
INSERT INTO language VALUES("892","or","OR","");
INSERT INTO language VALUES("893","no_result_found","No Result Found","");
INSERT INTO language VALUES("894","add_service_quotation","Add Service Quotation","");
INSERT INTO language VALUES("895","add_to_invoice","Add To Invoice","");
INSERT INTO language VALUES("896","item_quotation","Item Quotation","");
INSERT INTO language VALUES("897","service_quotation","Service Quotation","");
INSERT INTO language VALUES("898","return_from","Return Form","");
INSERT INTO language VALUES("899","customer_return_list","Customer Return List","");
INSERT INTO language VALUES("900","pdf","Pdf","");
INSERT INTO language VALUES("901","note","Note","");
INSERT INTO language VALUES("902","update_debit_voucher","Update Debit Voucher","");
INSERT INTO language VALUES("903","update_credit_voucher","Update Credit voucher","");
INSERT INTO language VALUES("904","on","On","");
INSERT INTO language VALUES("905","","","");
INSERT INTO language VALUES("906","total_expenses","Total Expense","");
INSERT INTO language VALUES("907","already_exist","Already Exist","");
INSERT INTO language VALUES("908","checked_out","Checked Out","");
INSERT INTO language VALUES("909","update_salary_setup","Update Salary Setup","");
INSERT INTO language VALUES("910","employee_signature","Employee Signature","");
INSERT INTO language VALUES("911","payslip","Payslip","");
INSERT INTO language VALUES("912","exsisting_role","Existing Role","");
INSERT INTO language VALUES("913","filter","Filter","");
INSERT INTO language VALUES("914","testinput","","");
INSERT INTO language VALUES("915","update_quotation","Update Quotation","");
INSERT INTO language VALUES("916","quotation_successfully_updated","Quotation Successfully Updated","");
INSERT INTO language VALUES("917","successfully_approved","Successfully Approved","");
INSERT INTO language VALUES("918","expiry","Expiry","");



DROP TABLE module;

CREATE TABLE `module` (
  `id` int NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL,
  `description` text,
  `image` varchar(255) DEFAULT NULL,
  `directory` varchar(100) DEFAULT NULL,
  `status` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=17 DEFAULT CHARSET=utf8mb3;

INSERT INTO module VALUES("1","invoice","","","","1");
INSERT INTO module VALUES("2","customer","","","","1");
INSERT INTO module VALUES("3","product","","","","1");
INSERT INTO module VALUES("4","supplier","","","","1");
INSERT INTO module VALUES("5","purchase","","","","1");
INSERT INTO module VALUES("6","stock","","","","1");
INSERT INTO module VALUES("7","return","","","","1");
INSERT INTO module VALUES("8","report","","","","1");
INSERT INTO module VALUES("9","accounts","","","","1");
INSERT INTO module VALUES("10","bank","","","","1");
INSERT INTO module VALUES("11","tax","","","","1");
INSERT INTO module VALUES("12","hrm_management","","","","1");
INSERT INTO module VALUES("13","service","","","","1");
INSERT INTO module VALUES("14","commission","","","","1");
INSERT INTO module VALUES("15","setting","","","","1");
INSERT INTO module VALUES("16","quotation","","","","1");



DROP TABLE payroll_tax_setup;

CREATE TABLE `payroll_tax_setup` (
  `tax_setup_id` int unsigned NOT NULL AUTO_INCREMENT,
  `start_amount` decimal(12,2) NOT NULL DEFAULT '0.00',
  `end_amount` decimal(12,2) NOT NULL DEFAULT '0.00',
  `rate` decimal(12,2) NOT NULL DEFAULT '0.00',
  `status` varchar(30) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  PRIMARY KEY (`tax_setup_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;




DROP TABLE person_information;

CREATE TABLE `person_information` (
  `id` int NOT NULL AUTO_INCREMENT,
  `person_id` varchar(50) NOT NULL,
  `person_name` varchar(50) NOT NULL,
  `person_phone` varchar(50) NOT NULL,
  `person_address` text NOT NULL,
  `status` int NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;




DROP TABLE person_ledger;

CREATE TABLE `person_ledger` (
  `id` int NOT NULL AUTO_INCREMENT,
  `transaction_id` varchar(50) NOT NULL,
  `person_id` varchar(50) NOT NULL,
  `date` varchar(50) NOT NULL,
  `debit` decimal(12,2) NOT NULL DEFAULT '0.00',
  `credit` decimal(12,2) NOT NULL DEFAULT '0.00',
  `details` text NOT NULL,
  `status` int NOT NULL COMMENT '1=no paid,2=paid',
  PRIMARY KEY (`id`),
  KEY `person_id` (`person_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;




DROP TABLE personal_loan;

CREATE TABLE `personal_loan` (
  `per_loan_id` int NOT NULL AUTO_INCREMENT,
  `transaction_id` varchar(30) NOT NULL,
  `person_id` varchar(30) NOT NULL,
  `debit` decimal(12,2) DEFAULT '0.00',
  `credit` decimal(12,2) NOT NULL DEFAULT '0.00',
  `date` varchar(30) NOT NULL,
  `details` varchar(100) NOT NULL,
  `status` int NOT NULL COMMENT '1=no paid,2=paid',
  PRIMARY KEY (`per_loan_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;




DROP TABLE pesonal_loan_information;

CREATE TABLE `pesonal_loan_information` (
  `id` int NOT NULL AUTO_INCREMENT,
  `person_id` varchar(50) NOT NULL,
  `person_name` varchar(50) NOT NULL,
  `person_phone` varchar(30) NOT NULL,
  `person_address` text NOT NULL,
  `status` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `person_id` (`person_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;




DROP TABLE product_category;

CREATE TABLE `product_category` (
  `id` int NOT NULL AUTO_INCREMENT,
  `category_id` varchar(255) DEFAULT NULL,
  `category_name` varchar(255) DEFAULT NULL,
  `status` int NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;




DROP TABLE product_information;

CREATE TABLE `product_information` (
  `id` int NOT NULL AUTO_INCREMENT,
  `product_id` varchar(100) NOT NULL,
  `category_id` varchar(255) DEFAULT NULL,
  `product_name` varchar(255) NOT NULL,
  `price` float DEFAULT NULL,
  `unit` varchar(50) DEFAULT NULL,
  `tax` float DEFAULT NULL COMMENT 'Tax in %',
  `serial_no` varchar(200) DEFAULT NULL,
  `product_model` varchar(100) DEFAULT NULL,
  `product_details` varchar(255) DEFAULT NULL,
  `image` varchar(255) DEFAULT NULL,
  `status` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `category_id` (`category_id`),
  KEY `product_id` (`product_id`)
) ENGINE=MyISAM AUTO_INCREMENT=729 DEFAULT CHARSET=utf8mb3;

INSERT INTO product_information VALUES("1","1","","Button holder huawei","390","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("2","2","","Two pin k huawei ","210","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("3","3 ","0","Holder pendent huawei","320","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("4","4","","Ice light 12w Ge","310","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("5","5","","Ice light 15w G e","470","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("6","6","","Diachi 5w bulb","170","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("7","7","","Cob 7w G e","340","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("8","8","","Duck patti Aqua 60/60","570","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("9","9","","Duck patti Aqua 40/40","450","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("10","10","","Duck patti Aqua 1 inch","230","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("11","11","0","Duck patti Aqua pak 3/4","125","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("12","12","","Duck patti Aqua 3/4","155","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("13","13","","Nail steel Mix","420","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("14","14","","Pipe Galco 3/4","185","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("15","15","","Pipe zenco 1 inch","155","pcs","0","","","ppippip","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("16","16","","Pipe new nawab 1inch","130","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("17","17","","Pipe vitail 1 inch","200","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("18","18","","Pipe new star 1/2 inch","95","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("19","19","","Pipe Time star 3/4 inch","90","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("20","20","","Pipe Mastar 3/4","135","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("21","21","","Pipe Jadha 3/4 inch","150","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("22","22","","light box grey","35","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("23","23","","Band 3/4 Decent ","1520","gross","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("24","24","","Socket 3/4 Decent","770","gross","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("25","25","","Jungtion box 3/4 (B)","1820","gross","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("26","26","","3 hole and 4 hole (B)","35","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("27","27","","Faram 4x4 (B)","53","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("28","28","","Round block (B)","140","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("29","29","","Conciled Board 4x4 (A)","60","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("30","30","","P.V.C Band 1 Inch","1920","gross","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("31","31","","Band 3/4 AA","1720","gross","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("32","32","","sockit 3/4 AA","770","gross","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("33","33","","Band 1/2 ","720","gross","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("34","34","","socket 1/2 ","370","gross","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("35","35","","Lanter 3/4 Box (B)","1020","gross","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("36","36","","Lanter Box 3/4 (A)","2520","gross","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("37","37","","conciled Box 4x4 B","30","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("38","38","","fram 4x4 (B)","40","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("39","39","","Light Box Lanter 4 Inch","40","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("40","40","","Light Box 4 Inch Grey","35","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("41","41","","China Switch Socket Mix","65","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("42","42","","China sheet 1+1 ","190","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("43","43","","China Sheet M+F","240","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("44","45","","China sheet TF+TV","200","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("45","46","","China sheet 2Gang","170","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("46","47","0","China sheet 2+2 ","340","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("47","48","","China sheet 1Gang","170","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("48","49","","China sheet Bell Push","180","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("49","50","","China sheet Dimmer Mix","140","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("50","51","","China sheet Power Plug","270","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("51","52","","China sheet 6+2","470","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("52","53","","ice Light (16 w) 3000k","500","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("53","54","","Ice Light (12w) D.c","275","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("54","55","","Ice Light (12) Brighttex","300","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("55","56","","LAD Blub (50 W) factor","1020","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("56","57","","LAD Bulb (12 w) Ultra","160","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("57","58","","LAD Colour Bulb trend","135","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("58","59","","Multi colour bulb (12 w) trend","185","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("59","60","","Down Light (7 W) Mix ","220","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("60","61","","Down Light (7 w) B.J","180","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("61","62","","Tube Light (60 W) Factor","1520","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("62","63","","3/29 H.M Red","4920","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("63","64","","3/29 H.M Black","4920","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("64","65","","7/29 H.M Red","10320","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("65","66","","7/29 H.M Black","10320","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("66","67","","3/29 Pak 26% Red","2620","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("67","68","","3/29 Pak 26% Black","2620","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("68","69","","7/29 Pak 26% Red","5220","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("69","70","","7/29 Pak 26% Black ","5220","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("70","71","","3/29 Pak 23% Red","2270","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("71","72","","3/29 Pak 23% Black ","2270","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("72","73","","3/29 Pak 23% White","2270","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("73","74","","7/36 Pak 27% Red","6520","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("74","75","","7/36 Pak 27% Black","6520","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("75","76","","7/44 Pak 27% Red","9120","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("76","77","","7/44 Pak 27% Black","9120","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("77","78","","10 hol Faram olympic","180","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("78","79","","06 Hol Faram Olympic","140","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("79","80","","01 Hol Faram Olympic","100","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("80","81","","03 Hol Faram Olympic","100","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("81","82","","10 Hol Faram Olympic 6=6","190","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("82","83","0","Button Holder (Abid) B22","470","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("83","84","","Bed Switch Huda","470","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("84","85","","Jumbo Holder ARY B22","680","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("85","86","","Button Holder ARY E27","410","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("87","88 ","0","Multi Plug ARY (B)","1340","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("191","89","","Pendent holder b22 Ary","300","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("93","90","0","3 Pin top 40Amp ARY","920","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("94","91","0","3 Pin (MF) 5Amp ARY","560","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("91","92","","Switch Socket (B) ARY","280","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("92","93","0","2 Pin Shoo porceline ARY ","290","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("95","94","","Jumbo Holder almezan (B22)","605","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("96","95","","Button Holder Almezan (B22)","410","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("97","96","","Switch Socket Almezan (B)","280","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("98","97","","Jumbo Holder (M.S 2in 1)","820","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("99","98","","Jumbo Holder (Abid B22)","870","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("100","99","0","Bed Switch Almezan (B)","380","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("107","101","","Teddy switch porcelain base 10Amp","570","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("106","100","","Pino Switch Socket Asim","320","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("103","102","","Pino switch socket perfect","470","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("104","103","","2 pin shoo porclian perfect","340","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("105","104","","Computer Multi Plug Perfect","320","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("190","87","","2 pin shoo generator ","290","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("110","105","","Jumbo ciling rose EM","530","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("111","106","","Small ciling rose EM","400","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("112","107","","Button Holder EM B22","480","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("113","108","","Paino Light EM","320","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("114","109","","Male Female EM (A) ","620","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("115","110","","switch Socket 40Amp Em","1316","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("116","111","","3 pin top 40Amp","1020","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("117","112","","2 pin porcelian ","300","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("118","113","","Sonex Change over switch (30Amp)","860","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("119","114","","Sonex change over switch (15Amp)","500","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("120","115","","Sonex cut out 10Amp","640","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("121","116","","Jumbo Holder Sahar B22","570","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("122","117","","Shiline rose small Alfazal","320","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("123","118","","Male Female Timepey (B)","320","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("124","119","","3 pin top Sahar 40Amp","620","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("125","120","","3 pin top Al fatal 40Amp","720","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("126","121","","Multi plug (Samsung B)","320","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("127","122","","Sahar computer Multi plug ","360","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("128","123","","2 pin Royal sahar","320","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("129","124","","Button Holder Burq B22","520","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("130","125","","Switch Socket Burq (A)","395","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("131","126","","Pin Peral Burq","480","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("132","127","0","Piano Holder B22","420","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("133","128","0","Piano Holder E27 Burq","420","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("134","129","","Main Switch 40Amp open","295","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("135","130","","B22 to E27 Convertor Burq","380","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("136","131","","2 Pin Shoo (110) Burq","260","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("137","132","","Men Switch (30Amp) open Burq","260","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("138","133","","Men Switch conciled 30Amp Burq","260","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("139","134","","Multi plug 15Amp porcelian Burq","180","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("140","135","","3/29 Million Extreme Red","2981","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("141","136","","3/29 Million Extreme Black","2981","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("142","137","","3/29 Million Extreme Yellow","2981","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("143","138","","3/29 Million Extreme Green","2981","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("144","139","","3/29 Million Extreme Blue","2981","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("145","140","","3/29 Million Extreme White","2981","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("146","141","","7/29 Million Extreme Red","6166","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("147","142","","7/29 Million Extreme Yellow","6166","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("148","143","","7/29 Million Extreme Green","6166","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("149","144","","7/29 Million Extreme Black","6166","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("150","145","","7/36 Million Extreme Red","9351","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("151","146","","7/36 Million Extreme Black","9351","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("152","147","","7/44 Million Extreme Red","15006","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("153","148","","7/44 Million Extreme Black ","15006","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("154","149","","Classic Solar 12 no 30 Meter","1064","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("155","150","","Classic Solar 12 no Blue 30 Meter","1064","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("156","151","","Classic Solar 18 no Red 30 Meter","1577","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("157","152","","Classic Solar 18 no Blue 30 Meter","1577","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("158","153","","Classic Solar 28 no Red 30 Meter","2312","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("159","154","","Classic Solar 28 no Blue","2312","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("160","155","","Classic Solar 42 no Red 30 Meter","3228","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("161","156","","Classic Solar 42 no Blue 30 Meter","3228","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("162","157","","Classic Solar 55 no Red 30 Meter","4210","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("163","158","","Classic Solar 55 no Blue 30 Meter","4210","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("164","159","","Classic Solar 70 no Red 30 Meter","5146","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("165","160","","Classic Solar 70 no Blue 30 meter","5146","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("166","161","","23/76 Million Extreme Round ","4411","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("167","162","","23/76 Million Extreme Flexible","3371","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("168","163","","Wood Board 10x12 (B)","600","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("169","164","","Wood Board 8x10 (B)","520","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("170","165","","Wood Board 6x8 (B)","400","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("171","166","","Wood Board 4x7 (B)","350","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("172","167","","wood Board (B)","260","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("173","168","","Wood Board no 1 10x12 (A)","820","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("174","169","","Wood Board 8x10 (A)","720","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("175","170","","Wood Board 6x8 (A)","470","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("176","171","","Fan pipe Rod 3 Fot ","320","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("177","172","","Fan pipe  Rod 2 Fot ","170","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("178","173","","Fan pipe Rod 2x1/2 Fot","230","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("179","174","","PVC pipe 1x1/4 inch Desent","320","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("180","175","0","PVC Bend 3/4 Desent","145","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("181","176","0","PVC Bend Socket 3/4 Desent","85","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("182","177","0","PVC Bend 1 inch Desent","185","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("183","178","0","PVC Socket 1 Inch Desent","100","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("184","179","","Light Box 3 Inch (A)","56","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("185","180","","Light Box 3 Inch (B) Decent","47","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("186","181","","Fan box (A)","185","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("187","182","","Fan box (B)","110","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("188","183","0","Junction Box 3/4 (A)","155","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("189","184","0","Junction Box 3/4 (B)","140","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("192","185","","Services Wire 7/64 (A) ","8520","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("193","186","","Services Wire 7/64 (B)","5520","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("194","187","0","Services Wire 7/52 D1","6520","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("195","188","","Services Wire 7/52 D2","5620","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("196","189","","Services Wire 7/44 10KG","3370","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("197","190","","Telephone Silver Wire 150 No ","2520","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("198","191","","Telephone Wire 80 No","1720","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("199","192","","Telephone Wire 50 No","1120","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("200","193","0","Single Silver Wire 7/64","1720","","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("201","194","0","Single Silver wire 7/52","1520","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("202","195","0","Single silver Wire 7/44","1320","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("203","196","","Flat Wire 23/76 Silver Red & Black ","400","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("204","197","","Flat wire 40/76 Silver White","1520","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("205","198","","Solar Wire Double 3mm Red & Blue","2120","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("206","199","","Solar Wire double 3mm Orange","1920","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("207","200","","Flexable Pipe 1/2 inch (B)","920","Bundel","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("208","201","","Flexable Pipe 3/4 Inch (B)","820","Bundel","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("209","202","","Flexable Pipe 1 Inch (B)","920","Bundel","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("210","203","","Flexable Pipe 1 1/2 inch (B)","1120","Bundel","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("211","204","","Flexable Pipe 2 Inch (B)","1320","Bundel","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("212","205","","Flexable 1/2 Inch (A) white ","920","Bundel","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("213","206","","Flexable 3/4 Inch (A)","1220","Bundel","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("214","207","","Flexable Pipe 1 Inch (A)","1320","Bundel","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("215","208","","Flexable Pipe 1 1/2 Inch (A)","1520","Bundel","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("216","209","","Flexable Pipe 2 Inch (A)","1720","Bundel","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("217","210","0","Hi Denci 3/4 Inch Pipe (C)","90","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("218","211","","Hi Denci 3/4 Inch Pipe (B)","120","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("219","212","","Hi Denci 3/4 Inch Pipe (A)","125","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("220","213","","Digital Volt Meter ","190","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("221","214","","Amper + Volt Meter","500","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("222","215","","Candle Bulb E 14","170","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("223","216","","Volt Proctector 63 Amp","1620","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("224","217","","Door Bell","200","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("225","218","","Panal Light Digital+Volt Meter","190","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("226","219","","Panal Brekar D.P 63 Amp (B)","400","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("227","220","","Panal Brekar S.P 10.16.20.32 Amp","200","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("228","221","","Panal Brekar D.P 63 Amp (A)","520","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("229","222","","Panal Brekar S.P 10 Amp (A)","250","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("230","223","","Change Over (Oppas) 32 Amp","1270","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("231","224","","Change Over (Yoyo) 32 Amp ","570","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("232","225","","Change Over (Hager) 32Amp (B)","500","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("233","226","","Change Over (Hager) 50Amp (B)","1620","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("234","227","","Wapda Clip Single","120","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("235","228","","Wire 3/29 Sogo Black","3520","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("236","229","","Wire 3/29 Pakistan cable Red","5020","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("237","230","","Wire 7/29 Afr Cable Red","4620","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("238","231","","Button Holder Mesco B22","570","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("239","232","","Jumbo Holder Mesco B22","770","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("240","233","0","Bulb 200w General","108","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("241","234","","Tub Light (30 W) Signal","940","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("242","235","","Tub Light (40 W) Double","1120","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("243","236","","LED Bulb (50 W) Brightit","940","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("244","237","","LED Bulb (30 W) Brightit","550","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("245","238","","LED Bulb (18 W) G.1","340","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("246","239","","LED Bulb (20 W) Brightit ","380","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("247","240","","LED Bulb (15 W) Brightit ","280","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("248","241","","LED Bulb (12 W) Lifi","180","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("249","242","","LED Bulb (25 W) G.1","510","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("250","243","","Ice Light (12 W) G.1","450","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("251","244","","Fox Light (100 W) Zarcon G.1","5520","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("252","245","","Fox Light (50 W) Tiger G.1","2820","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("253","246","","Fox Light (100 W) Lumax","4020","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("254","247","","Fox Light (50 W) Brightit Casit","670","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("255","248","","Golden Bulb (18 W) G.1","340","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("256","249","","Fox Light (50 W) Brightit Black","1620","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("257","250","","LED Light Colour Brightit","270","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("258","251","","COB (3 W) G.1","295","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("259","252","","COB (5 W) G.1","330","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("260","253","","COB (1 W) G.1","300","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("261","254","","Down Light (7 W) Laster G.1","250","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("262","255","","Ice Light (22 W) G.1","770","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("263","256","","Open Light (18 W) Sangam","820","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("264","257","","Open Light (12 W) G.1","570","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("265","258","","Open light (6 W) G.1","470","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("266","259","","Panal PVC 10x12 (A)","1220","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("267","260","","Panal PVC 10x12 (B)","870","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("268","261","","Panal PVC 10x12 (C)","620","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("269","262","","Panal PVC 8x10 (A)","470","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("270","263","","Panal PVC 8x10 (B)","370","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("271","264","","Brekar Box 2 hol (A)","100","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("272","265","","Brekar Box 4 Hol","140","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("273","266","","Braker Box 6 Hol","240","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("274","267","","Braker Box 8 Hol (B)","380","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("275","268","","Penal Box 12x15 Plastic ","2120","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("276","269","","Change Over Box 102","130","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("277","270","","Round Block (A)","180","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("278","271","","Round Block (B)","140","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("279","272","","Fan Cover Plate ","240","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("280","273","","Cover Plate 4 Inch","820","Gross","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("281","274","","PVC Board 6 Hol 6x6 (B)","380","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("282","275","","PVC Board 1.2 Hol (B) ","120","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("283","276","","PVC Board 3.4 Hol (B)","200","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("284","277","","PVC Board 5.6 Hol (B)","260","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("285","278","","PVC Board 1.2 Hol (A)","200","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("286","279","","PVC Board 3.4 Hol (A)","280","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("287","280","","PVC Board 5.6 Hol (A)","380","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("288","281","","Concelied Board 4x4 Orange","45","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("289","282","","Concelied Box 4x7 Orange","52","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("290","283","","Open Faram 4x4 (B)","50","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("291","284","","Open Faram 4x7 (B)","60","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("292","285","","PVC Board M.F (A)","260","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("293","286","","PVC Board M.F (B)","200","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("294","287","","PVC Board Power Plug (B)","300","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("295","288","","Brekar Box 2 Hol (B)","90","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("296","289","0","Extreme 3/29 Red","2981","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("297","290","0","Extreme 7/29 Red","6166","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("298","291","0","Extreme 7/36 Red","9351","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("299","292","0","Extreme 7/44 Red","15006","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("300","293","","Million Extreme 23/76 Round","4411","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("301","294","","Million Extreme 40/76","7141","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("302","295","","Million Extreme 23/76 Flat","3956","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("303","296","","Million Extreme 23/76 Flexible","3371","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("304","297","","Million Extreme 110/76 2 Core","15781","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("305","298","","Million Extreme 70/76 2 Core ","10781","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("306","299","0","Million Classic 3/29 Red","4112","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("307","300","0","Million Classic 7/29 Red","8727","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("308","301","","Million Classic 7/36","11691","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("309","302","","Million Classic 7/44","16709","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("310","303","0","Solar Wire 18 No Solar Link 30 mtr Red","1520","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("311","304","0","Solar Wire 28 No Solar Link 30 mtr Red","2020","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("312","305","0","Solar Wire 42 No Solar Link 30 mtr Red","2920","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("313","306","0","Solar Wire 70 No Solar Link 30 Mtr Red","4620","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("314","307","0","Solar Wire 85 No Solar Link 30 Mtr Red","6020","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("315","308","0","Solar Wire 12 No 9o Mtr Red","2720","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("316","309","0","Solar Wire 28 No 90 Mtr Red","6020","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("317","310","0","Solar wire 42 No 90 Mtr Red","8720","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("318","311","","Extreme 3/29 Black","2981","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("319","312","","Extreme 3/29 Yellow","2981","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("320","313","","Extreme 3/29 Green","2981","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("321","314","","Extreme 3/29 Blue","2981","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("322","315","","Extreme 3/29 White","2981","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("323","316","","Extreme 7/29 Black","6166","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("324","317","","Extreme 7/29 Yellow","6166","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("325","318","","Extreme 7/29 Blue","6166","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("326","319","","Extreme 7/29 White","6166","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("327","320","","Extreme 7/29 Green","6166","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("328","321","","Extreme 7/36 Black","9351","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("329","322","","Extreme 7/44 Black","15006","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("330","323","","Million Classic 3/29 Black","4112","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("331","324","","Million Classic 3/29 Yellow","4112","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("332","325","","Million Classic 3/29 Blue","4112","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("333","326","","Million Classic 3/29 White","4112","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("334","327","","Million Classic 7/29 Black","8727","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("335","328","","Million Classic 7/29 Yellow ","8727","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("336","329","","Million Classic 7/29 Green","8727","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("337","330","","Million Classic 7/29 Blue","8727","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("338","331","","Million Classic 4mm Red","11691","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("339","332","","Million Classic 4mm Black ","11691","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("340","333","","Million Classic 6mm Red","16709","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("341","334","","Million Classic 6mm Black","16709","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("342","335","","Million 3/29 mm Red","2396","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("343","336","","Million 3/29 mm Black","2396","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("344","337","","Million 7/29 mm Red","4931","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("345","338","","Million 7/29 mm Black","4931","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("346","339","","Million 7/36 mm Red","7401","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("347","340","","Million 7/36 mm Black","7401","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("348","341","","Million 7/44 mm Red","10911","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("349","342","","Million 7/44 Black","10911","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("350","343","","Solar wire 18 No Solar link 30mtr Blue","1520","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("351","344","","Solar wire 28 No Solar Link 30Mtr Blue ","2020","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("352","345","","Solar wire 42No Solar link 30Mtr Blue","2920","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("353","346","","Solar Wire 70 No Solar link 30Mtr Blue","4620","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("354","347","","Solar Wire 85 No Solar Link 30Mtr Blue","6020","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("355","348","","Solar Wire 12 No 90 Mtr Black","2720","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("356","349","","Solar Wire 28 No 90 Mtr Black","6020","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("357","350","","Solar wire 42 No 90 Mtr Black","8720","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("358","351","","3/29 Tip Top 27% Red","2820","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("359","352","","3/29 Tip Top 27% Black","2820","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("360","353","","3/29 Tip Top 27% Colours","2820","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("361","354","","7/29 Tip Top 27% Red","5820","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("362","355","","7/29 Tip Top 27% Black","5820","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("363","356","","7/29 Tip Top 27% Colours","5820","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("364","357","","7/36 Tip Top Red","8820","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("365","358","","7/36 Tip Top Black","8820","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("366","359","","7/44 Tip Top Red","14420","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("367","360","","7/44 Tip Top Black","14420","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("368","361","0","Solar Wire 55 No  30 Mtr Solar link Red","3820","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("369","362","","Solar Wire 55 No 30 mtr Solar Link Blue","3820","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("370","363","0","A.C Brekar Belco Mix","340","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("371","364","","Pipe Light Double Mix ","15020","Bundel","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("372","365","","Pipe Light Connector Double","90","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("373","366","","Pipe Light Connector Single","66","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("374","367","","Conceled Box 4/4","50","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("375","368","","Fan Box Orange ","140","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("376","369","","7/36 Tip Top loose item","7520","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("377","370","","3/29 23% Loose Item","2020","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("378","371","","7/29 19% losz","3020","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("379","372","","23/76 (Falt) Million Losz","4020","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("380","373","","40/76 (Flat) silver losz","1520","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("381","374","","Usaka PVC Tape losz","420","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("382","375","","Scrow (Mix) Losz","2020","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("383","376","","Steel Nial (Mix) Losz","1520","","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("384","377","","Switch Socket Asim Losz","320","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("385","378","","Shoo 2 Pin (Mix) Losz ","220","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("386","379","","Panio Switch Socket (Mix) Losz","320","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("387","380","","Computer Multi (Mix) Losz","320","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("388","381","","Button Holder (Mix) Losz","420","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("389","382","","Jumbo Holder (Mix) Losz","570","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("390","383","","Multi Plug (Mix) Losz","370","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("391","384","","Solar Wire 70 No Solar Link 30 Mtr Red (2)","4620","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("392","385","","Fox Light 50 W (D.P)","2770","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("393","386","","SMD 7 W Osaka AC","320","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("394","387","0","Sheet 8+2 Mesco","506","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("410","403","","open light 18w 4k","470","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("396","389","","Sheet PowerPlug Mesco","356","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("397","390","","Ice Light 12 w 3in1 G 1","580","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("398","391","","Ice Light 12w Venus","290","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("399","392","","SMD 7W Daichi","300","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("400","393","","Ice Light 12W 3in1 G 1","580","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("401","394","","Power Plug 40Amp ARY","320","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("402","395","","Open Fram 4x7 (B)","70","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("403","396","","Open Farm 4x4 (B)","60","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("404","397","","Panal Light ","70","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("405","398","","Sheet 9+1 Mesco","506","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("406","399","","Sheet 2+2 Mesco","307","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("407","400","","Sheet Bell Push Mesco","246","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("408","401","","Sheet 6+2 Mesco","495","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("409","402","","Singal Pol Brekar Globe","270","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("411","404","","LAD Bulb 12w Ultra","145","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("412","405","","LAD Tube Light 28w","870","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("413","406","","Sheet Multiplug Mesco ","356","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("414","407","","LAD bulb 18w G 1 E27","350","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("415","408","","12w DC Bulb Trend","120","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("416","409","","36w Tube Light Factor","840","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("417","410","","3/29 pak 19%","1670","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("418","411","","7/29 Pak 19%","3320","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("419","412","0","7/64 Service Double Alfa Full","8820","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("420","413","","7/64 Service Double Alfa 55%","7770","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("421","414","","7/52 Service Double 48%","6920","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("422","415","","7/52 Service Double 45%","5820","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("423","416","","7/52 Service Double 33%","5020","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("424","417","","7/29 Pak 23% Red","4320","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("425","418","","7/29 Pak 23% Black","4320","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("426","419","","40/76 Round Million Extreme Red","6751","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("427","420","","23/76 Flat Million Extreme","3956","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("428","421","","Conclied Box 4x7 (A)","56","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("429","422","","Conciled Box 4x4 (A) ","50","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("430","423","","15x20 Panel Special ","4120","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("431","424","","Pipe 2inch PVC ","920","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("432","425","","Bath Set ","1620","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("433","426","","Comboat Set","8020","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("434","427","","Comboat Set IIL","1220","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("435","428","","Beson Set","5520","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("436","429","","Flash Tank","2020","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("437","430","","West Pipe","170","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("438","431","","Bolt Kit","170","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("439","432","","Beson Set","4020","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("440","433","","Muslim Shawar","1070","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("441","434","","Wall Shawar","6520","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("442","435","","C.P Nipel","170","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("443","436","","Hand Shawar","1520","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("444","437","","Comboat Kit","220","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("445","438","","Elbow 4inch UPVC","320","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("446","439","","Pipe 4inch UPVC","270","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("447","440","","Thamball Comboat","470","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("448","441","","Bulb 12W Osaka","320","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("449","442","","Wire Solar Double 5MM R/B","140","Yard","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("450","443","","Tile Cutter","320","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("451","444","","Lota ","170","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("452","445","","PVC Jug ","170","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("453","446","","Tile ","1470","Meter","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("454","447","","Sodoium Rod 400W","870","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("455","448","","Scrow 1inch Black","140","packet","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("456","449","0","Sheet Frame NS 4 Hole","110","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("457","450","","Sheet Frame NS 8 Hole","170","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("458","451","","Sheet Frame NS 2 Hole ","90","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("459","452 ","","Wire Clip 6MM Taiwan","312","packet","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("460","453","","Cupsul Light Normal","270","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("461","454","","China Sheet 8+2 grande ","390","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("462","455","","China Sheet 3+1 grande ","250","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("463","456","","Hole Punch machine ","430","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("464","457","","Steplar Machine","470","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("465","458","","Steplar Pin ","80","packet","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("466","459","","Calculatar 14 Digget ","1120","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("467","460","","Balty PVC","1020","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("468","461","","Cloth Pardha ","1520","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("469","462","","23/76 Million 4 Core ","8670","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("470","463","","Battery Cell large ","440","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("471","464","","Pad Lock  63MM","520","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("472","465","","Jugg Lota Patara ","1120","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("473","466","","Fuse 3AMP ","370","packet","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("474","467","","Nail Iron 1/2*14","355","KG","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("475","468","","Register 200 Page ","245","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("476","469","","Photo copy","1070","packet","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("477","470 ","","Whito pin ","80","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("478","471 ","","Steplar Pin  Large ","1200","Bundel","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("479","472 ","","Scrow 1*14","170","packet","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("480","473","","Nail Steel 1inch ","370","packet","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("481","474","","Wire Clip 4MM (A)","120","packet","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("482","475","","Empty Bag ","44","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("483","476","","Sheet frame NS 4Hole ","110","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("484","479","","Solar wire Classic 12 NO 30 meter ","1120","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("485","480 ","0","Duplicate Book 1/6","520","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("486","481","0","PVC Tape  Roll Osaka ","61","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("487","482","","Solding Wire ","1270","Roll","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("488","483","","Multty Lead ","120","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("489","484","","China Sheet Single TV  ECM ","295","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("490","488","","Junction Box 3/4  (A)","2420","Gross","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("491","489","","Junction Box 3/4 (B)","1520","Gross","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("492","490",""," Led Bulb D.C GN","110","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("493","491","","Ice Light D.C SEA Light","210","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("494","492","","2 Pin Shoo K (ARY)","255","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("495","493","","Multi Plug (A) ARY ","1820","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("496","494","","Pendent holder E27 ARY","310","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("497","495","0","Jumbo holder E27 ARY","670","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("498","496","","Down Holder E27 ARY","58","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("499","497","","Scrow 1/1.2 Black ","180","packet","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("500","498","","Scrow 2inch Black ","270","packet","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("501","499","","Plastic gitti barni ","172","packet","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("502","500","","Candle Bulb 0 W","670","packet","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("503","501","","Wire Clip 8MM (A)","260","packet","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("504","502","","Magnate contector 100AMP","10020","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("505","503","","Magnate contector 85AMP","12020","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("506","504","","Luxs 50MM","80","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("507","505","","Breaker T.P Shenrider 100 AMP","11020","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("508","506","","Luxs 300MM","1340","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("509","507","","Luxs 1.5MM","23","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("510","508","","Kerosine oil","320","","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("511","509","","Oil Pant Corona 3.64 Liter","4620","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("512","510","","plaster Paris ","53","KG","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("513","511","","Distemper Drum (A)","8720","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("514","512","","Door handle ","100","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("515","513","","Tower Bolt 6 inch ","160","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("516","514","","Scrow 1/1.2","70","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("517","515","","Scrow 2 inch ","195","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("518","516","","Steel Nail  1/1.2 inch ","50","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("519","517","","Steel Nail 1 inch ","22","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("520","518","","C.P county Steel ","620","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("521","519","","Cloth pipe ","920","Foot","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("522","520","","Breaket Parada ","140","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("523","521","","Flower Parada","140","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("524","522","","Gas pipe ","70","Foot","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("525","523","","Gas Pipe Clip ","30","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("526","524","0","M.S NET 5x3","720","Foot","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("527","525","0","M.S NET 5x5","1170","Foot","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("528","526","0","M.S NET 8x4","1465","Foot","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("529","527","","Handle Wall 3/4 GI","680","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("530","528","","Handle Wall 1/1.2  GI","570","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("531","529","","Bib Cock","870","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("532","530","","Tee Cock ","870","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("533","531 ","","C.P.P Cock ","720","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("534","532","","Sidepilar Cock","1620","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("535","533","","Shawar C.P","500","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("536","534","","West Pipe ","150","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("537","535","","Nynol connection 36 inch ","150","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("538","536","","Bolt Kit","200","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("539","537","0","Elbow 34 x 1/2","180","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("540","538","0","Tee 3/4 x 1/2","180","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("541","539","","unioun 3/4 ","110","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("542","540","","Pipe Hock 3/4 ","35","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("543","541 ","","PPR pipe 3/4 ","670","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("544","542","","Complete beson set ","3520","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("545","543","","Soket plan  3/4","50","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("546","544","","C.P Chain ","470","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("547","545","","Pad Lock 50 MM ","270","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("548","546","","Tee plan 3/4 ","55","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("549","547","","Beson Mixture GI","3120","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("550","548","","Beson set white ","3520","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("551","549","","Bib cock  double ","1720","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("552","550","0","Wall socket 3/4x1/2","220","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("553","551","0","Bras socket 3/4x1/2 ","160","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("554","552","","Flash tank (A)","1820","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("555","553","","Tee cock 3/4","870","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("556","554","","P Trip UPVC 4 inch ","520","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("557","555","","W.C Big size ","1570","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("558","556","","Pipe 4 inch (A) ","3120","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("559","557","","Elbow 4 inch","250","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("560","558","","Pipe solution 500ML ","870","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("561","559","","REE balde ","70","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("562","560","","kerosine coil ","330","KG","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("563","561","","Bath set ","2170","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("564","562","","Conciled Wall 1/2","720","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("565","563","","Shawar Rod 1/2","400","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("566","564","","tenter green ","310","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("567","565","","Oil pant yellow  rozi lake ","2520","gallan ","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("568","566","","Oil pant black rozi lake ","2520","gallan ","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("569","567","","Oil pant red oxide Brito","1270","gallan ","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("570","568","","Distemper brush 4 inch ","220","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("571","569","","Distemper brush 4 inch ","220","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("572","570","","Distemper drum 17 KG","620","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("573","571","","Capister power factor 50 KVR","39520","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("574","572","","Iced light DC SEA light ","270","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("575","573","","Fan box (B) ","120","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("576","574","","Electric giser ","14520","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("577","575","0","Exasast fan metal 10 inch","3520","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("578","576","","Test meter Digital 1500 MPR","15520","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("579","577","","Panel Loha 10x12 (B)","1270","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("580","578","","Panel Loha 12x15 (B)","2020","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("581","579","","Panel Loha 12x18 (B)","2220","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("582","580","","Panel Loha 18x24 (B)","5520","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("583","581","","Panel Enter com ","1020","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("584","582","","Panel Loha 10x12 (A)","1520","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("585","583","","Panel Loha 12x15 (A)","2320","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("586","584","","Panel Loha 12x18 (A)","2620","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("587","585","","Bowl  Sink 14x19 ","2220","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("588","586","0","H Nital 2x1 GI","140","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("589","587","","TGI ","270","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("590","588","","Union GI 1 inch ","260","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("591","589","","Sink Cock 1 inch GI","1670","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("592","590","","Handle wall GI 1 inch ","1270","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("593","591 ","","Wall socket GI 1 inch ","370","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("594","592","","China sheet 8+2 ECM ","502","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("595","593","","China sheet 6+2 ECM","470","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("596","594","","China sheet 2+2 ECM","310","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("597","595","","China sheet M+F ECM","343","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("598","596","","China sheet P+P ECM ","356","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("599","597","","China sheet B+P ECM","270","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("600","598 ","0","China sheet demer ","150","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("601","599","","Piano demer ","140","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("602","600","0","Panel light sada ","62","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("603","601","","Wapda Clip double","250","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("604","602","","40/76 Wire Silver Round","1520","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("605","603","","Single breaker 10.16.20 Ternd","270","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("606","604","0","PVC pipe 1 inch vitel","195","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("607","606","","Duplicate Book 1/6","520","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("608","607","","COB  2 watt SE","305","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("609","608","0","Shoping bag 10 KG","438","KG","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("610","609","","Led 12 watt Open SE","820","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("611","610","","Led 18 watt open SE","1045","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("612","611","","Led  55","320","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("613","612","","Led 22 ","320","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("614","613","","Led wire ","1470","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("615","614","","Led Stand Small","220","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("616","615","","Lcd 19 inch","4820","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("617","617","","Brekit keybord ","620","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("618","618","","Mouse ","320","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("619","619","","D.v.d Led ","120","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("620","620","","L.C.C Connector","25","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("621","621","","Telephone Set C.I.L","4820","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("622","622","","Internet Connector ","30","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("623","623","","CAT 6","46","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("624","624","","Router Antina ","3720","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("625","625","0","PVC tape Osaka 8 gazz ","61","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("626","627","","Pipe G.I  2/12 inch ","920","Foot","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("627","628","","H Nipal Gi 2/12 inch","920","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("628","629","","Socket G.I 2/12 inch","720","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("629","630","","Elbow G.I 2/12 inch","1270","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("630","631","","union G.I 2/12 inch","1820","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("631","632","","Tee G.I 2/12 inch","1500","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("632","633","0","Band G.I 2/12 inch ","2220","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("633","634","","Gat wall G.I 2/12 inch ","8260","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("634","635","0","Nute Bolt 3 inch","140","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("635","636","","C.C.P Connector","320","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("636","637","","D.V.D RB TB ","2020","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("637","638","","P.P.R pipe 2 inch ","4170","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("638","639","","P.P.R Socket 2 inch","180","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("639","640","","P.P.R Elbow","280","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("640","641","","P.P.R T 2x1","325","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("641","642","","Handle wall G.I 2 inch","6220","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("642","643","","Handle wall G.I 1 inch","1470","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("643","644","","P TRIP UPVC 4 inch","520","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("644","645","","Pipe Solution 300 ML","370","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("645","646","","Pipe 3 inch UPVC","165","Foot","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("646","647","","Tile Bond ","290","packet","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("647","648","","Kerosine oil  ","320","Liter","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("648","649","","Million Extreme 3/29 Red ","4575","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("649","650","","Million Extreme 3/29 Black ","4575","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("650","651","","Milllion Extreme 3/29 white ","4575","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("651","652","","Million Extreme 3/29 Blue","4575","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("652","653","","Million Extreme 3/29 yellow","4575","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("653","654","","Million Extreme 3/29 Green ","4575","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("654","656","","Million Extreme 7/52 Red","32475","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("655","657","","Million Extreme 7/52 Black ","32475","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("656","658","","Million Extreme 7/64 Black","45775","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("657","659","0","Classic Auto Wire 12 NO Red 30 Meter","1625","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("658","660","0","Classic Auto Wire 12 NO  Blue 30 Meter","1625","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("659","661","","Classic Auto Wire 18 NO Red 30 Meter ","2415","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("660","662","","Classic Auto Wire 18 NO Blue 30 Meter ","2415","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("661","663","","Classic Auto Wire 28 NO 30 Meter Red","3545","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("662","664","","Classic Auto Wire 28 NO Blue 30 Meter ","3545","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("663","665","","Classic Auto Wire 42 NO Red 30 Meter ","4955","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("664","666","","Classic Auto Wire 42 NO Blue 30 Meter ","4955","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("665","667","","Classic Auto Wire 55 NO Red 30 Meter ","6465","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("666","668","","Classic Auto Wire 55 NO Blue 30 Meter","6465","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("667","669","","Classic Auto Wire 70 NO Red 30 Meter ","7905","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("668","670","","Classic Auto Wire 70 NO Blue 30 Meter ","7905","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("669","671","","Million Extreme  3/29 White ","4575","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("670","672","","D.C Blub Trend ","120","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("671","673","","Led 12 Watt Conciled","600","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("672","674","","Led 18 watt counciled","800","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("673","675","","Panel Light Sada","70","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("674","776","","China Sheet Mesco 8+2","506","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("675","677","","China Sheet 6+2 masco","495","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("676","678","","China Sheet 2+2 masco","306","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("677","679","","China Sheet 2+1 masco","279","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("678","680","","China Sheet M+F masco","356","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("679","681","","China Sheet P+P masco","330","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("680","682","","China Sheet B+P  masco","270","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("681","683","","Led Blub 18 Watt G.1","350","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("682","684","","Daichi Ice Light 11 Watt D.C","380","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("683","685","","Daichi Ice Light 12 Watt","380","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("684","686","","Daichi Down Light 7 Watt ","270","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("685","687","","Daichi Down Light 7 Watt D.C","250","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("686","688","","Daichi down Light A.C 11 Watt","380","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("687","689","","China sheet 4+2 Masco","306","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("688","690","","Tube light 36 Watt single factor ","850","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("689","691","","Open light iced 36 watt G.1","1420","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("690","692","","Open iced light 24 watt G.1","1120","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("691","693","","Led Bulb 12 watt lifi B 22","150","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("692","694","","Led bulb 12 watt lifi E 27 ","150","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("693","695","","Down light 7 watt 3in1 brightit ","300","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("694","696","","Iced light 10 watt 6+3 G.1","620","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("695","697","","Iced light 12 watt G.1 ","420","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("696","698","","Iced light royal ","310","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("697","699","","Led bulb 18 watt G.1 E 27","340","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("698","700","","down light 8 watt B.J ","180","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("699","701","","Tube light 40 watt G.1","1100","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("700","703","","Tube light single 30 watt G.1 ","920","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("701","704 ","","Led bulb 30 watt brightit ","570","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("702","705","","COB 3 watt G.1 ","270","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("703","706 ","","Open light 7 watt G.1","470","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("704","707","","12 watt golden lifi","170","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("705","708","","FOX light 100 watt brightit","2570","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("706","709","","Double Tube Light 20w G.One","520","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("707","710","","PVC Tape (B) ","290","Roll","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("708","711","","Blub 100 Watt ","82","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("709","712","0","Loha kil 1/12x14","340","KG","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("710","713","","Loha kil 5 inch 6 inch ","330","KG","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("711","714","","Steel Kil China Mix ","345","packet","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("712","715","","Duck pati 3/4 aqua ","140","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("713","716","","Duck pati 1 inch aqua ","210","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("714","717","","Duck pati 25x 40 aqua ","290","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("715","718","","Duck pati 25x25 aqua ","240","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("716","720","","Pipe light single golden ","5520","Roll","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("717","721","","AC+DC Fan farass 56 inch ","6270","nos","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("718","722","","Jangtion box 1 inch (A)","284","dozen","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("719","723","","Wire clip 7 MM (A)","220","packet","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("720","724","","Wire clip 8 MM (A)","260","packet","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("721","725","","Wire Clip 6 MM (A)","200","packet","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("722","726","","Solar wire 18 NO 90 meter  red","4820","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("723","727","","Solar wire 18 NO 90 meter black ","4820","coil","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("724","728","","PVC Panel 8x10 (C)","280","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("725","729","","Solar Wire Double 4MM Black ","120","Foot","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("726","730","","Solar Wire Double 6MM Black ","170","Foot","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("727","731","","Breaker khangee ","30","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");
INSERT INTO product_information VALUES("728","732","","Fan Rod 1/12  (A) ","370","pcs","0","","","","http://millattraders.com/saleserp/my-assets/image/product.png","1");



DROP TABLE product_purchase;

CREATE TABLE `product_purchase` (
  `id` int NOT NULL AUTO_INCREMENT,
  `purchase_id` bigint NOT NULL,
  `chalan_no` varchar(100) NOT NULL,
  `supplier_id` bigint NOT NULL,
  `grand_total_amount` decimal(12,2) NOT NULL DEFAULT '0.00',
  `paid_amount` decimal(10,2) DEFAULT '0.00',
  `due_amount` decimal(10,2) DEFAULT '0.00',
  `total_discount` decimal(10,2) DEFAULT NULL,
  `purchase_date` varchar(50) DEFAULT NULL,
  `purchase_details` text,
  `status` int NOT NULL,
  `bank_id` varchar(30) DEFAULT NULL,
  `payment_type` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `purchase_id` (`purchase_id`),
  KEY `supplier_id` (`supplier_id`)
) ENGINE=MyISAM AUTO_INCREMENT=58 DEFAULT CHARSET=utf8mb3;

INSERT INTO product_purchase VALUES("1","20240124145509","1","1","26880.00","0.00","26880.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("2","20240124145800","2","2","64550.00","0.00","64550.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("3","20240124152118","3","3","90170.00","0.00","90170.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("4","20240124154656","4","4","108500.00","0.00","108500.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("5","20240127150504","5","7","30350.00","30350.00","0.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("6","20240127152129","6","8","90000.00","0.00","90000.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("7","20240127161005","7","9","47450.00","0.00","47450.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("8","20240128104627","8","10","210085.00","0.00","210085.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("9","20240128113240","9","11","825450.00","0.00","825450.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("10","20240128115259","10","13","26510.00","0.00","26510.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("11","20240128122919","11","14","169650.00","0.00","169650.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("12","20240128140222","12","15","42885.00","0.00","42885.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("13","20240128141713","14","18","44900.00","0.00","44900.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("14","20240128142633","13","16","81050.00","0.00","81050.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("15","20240128145546","16","20","33020.00","0.00","33020.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("16","20240128150010","15","19","71566.00","0.00","71566.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("17","20240128151840","17","22","83800.00","0.00","83800.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("18","20240129142817","18","23","195905.00","0.00","195905.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("19","20240129154322","19","24","1740965.00","0.00","1740965.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("20","20240130154304","20","25","205690.00","0.00","205690.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("21","20240130155908","11","14","15870.00","0.00","15870.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("22","20240131144117","21","26","116480.00","0.00","116480.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("23","20240131153527","22","27","79750.00","0.00","79750.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("24","20240201145453","23","28","123946.00","0.00","123946.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("25","20240201155743","24","29","203765.00","0.00","203765.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("26","20240203141705","25","30","298190.00","0.00","298190.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("27","20240203150856","26","31","204000.00","0.00","204000.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("28","20240204162308","26","31","1732885.00","0.00","1732885.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("29","20240205145350","26","31","260050.00","0.00","260050.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("30","20240205154059","26","31","551500.00","0.00","551500.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("31","20240205160956","27","32","31400.00","0.00","31400.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("32","20240205171507","26","31","89600.00","0.00","89600.00","0.00","2023-12-31","","1","","1");
INSERT INTO product_purchase VALUES("33","20240210151559","42","33","76311.00","0.00","76311.00","0.00","2024-01-01","","1","","1");
INSERT INTO product_purchase VALUES("34","20240210154644","42","33","7612.00","0.00","7612.00","0.00","2024-01-01","","1","","1");
INSERT INTO product_purchase VALUES("35","20240210161624","42","33","38250.00","0.00","38250.00","0.00","2024-01-01","","1","","1");
INSERT INTO product_purchase VALUES("36","20240213150708","28","49","146240.00","0.00","146240.00","0.00","2024-01-01","","1","","1");
INSERT INTO product_purchase VALUES("37","20240213163024","29","40","11430.00","0.00","11430.00","0.00","2024-01-01","","1","","1");
INSERT INTO product_purchase VALUES("38","20240214120913","36","43","124880.00","0.00","124880.00","0.00","2024-01-01","","1","","1");
INSERT INTO product_purchase VALUES("39","20240214131722","38","45","113230.00","0.00","113230.00","0.00","2024-01-01","","1","","1");
INSERT INTO product_purchase VALUES("40","20240217152346","40","47","441900.00","0.00","441900.00","0.00","2024-01-01","","1","","1");
INSERT INTO product_purchase VALUES("41","20240217153045","39","46","30000.00","0.00","30000.00","0.00","2024-01-01","","1","","1");
INSERT INTO product_purchase VALUES("42","20240217153659","37","44","158000.00","0.00","158000.00","0.00","2024-01-01","","1","","1");
INSERT INTO product_purchase VALUES("43","20240217154738","27","39","10750.00","0.00","10750.00","0.00","2024-01-01","","1","","1");
INSERT INTO product_purchase VALUES("44","20240217164057","41","48","126000.00","0.00","126000.00","0.00","2024-01-01","","1","","1");
INSERT INTO product_purchase VALUES("45","20240218074400","43","34","15500.00","0.00","15500.00","0.00","2024-01-01","","1","","1");
INSERT INTO product_purchase VALUES("46","20240218081020","44","50","61450.00","0.00","61450.00","0.00","2024-01-01","","1","","1");
INSERT INTO product_purchase VALUES("47","20240218112422","38/2","45","150700.00","0.00","150700.00","0.00","2024-02-01","","1","","1");
INSERT INTO product_purchase VALUES("48","20240218121742","19/2","24","1465584.00","0.00","1465584.00","824391.00","2024-02-01","","1","","1");
INSERT INTO product_purchase VALUES("49","20240218132207","42/2","33","78962.00","0.00","78962.00","0.00","2024-02-01","","1","","1");
INSERT INTO product_purchase VALUES("50","20240218143236","28/2","29","348350.00","0.00","348350.00","0.00","2024-02-01","","1","","1");
INSERT INTO product_purchase VALUES("51","20240219081530","29/2","40","15150.00","0.00","15150.00","0.00","2024-02-1","","1","","1");
INSERT INTO product_purchase VALUES("52","20240219083123","45","51","127750.00","0.00","127750.00","0.00","2024-02-01","","1","","1");
INSERT INTO product_purchase VALUES("53","20240219084954","3/2","3","204320.00","0.00","204320.00","0.00","2024-02-01","","1","","1");
INSERT INTO product_purchase VALUES("54","20240219094915","28/2","49","103495.00","0.00","103495.00","640.00","2024-02-01","","1","","1");
INSERT INTO product_purchase VALUES("55","20240219100856","8/2","10","5500.00","0.00","5500.00","0.00","2024-02-01","","1","","1");
INSERT INTO product_purchase VALUES("56","20240219101122","41/2","48","12500.00","0.00","12500.00","0.00","2024-02-01","","1","","1");
INSERT INTO product_purchase VALUES("57","20240219101430","6/2","8","6336.00","0.00","6336.00","0.00","2024-02-01","","1","","1");



DROP TABLE product_purchase_details;

CREATE TABLE `product_purchase_details` (
  `id` int NOT NULL AUTO_INCREMENT,
  `purchase_detail_id` varchar(100) DEFAULT NULL,
  `purchase_id` bigint DEFAULT NULL,
  `product_id` varchar(30) DEFAULT NULL,
  `quantity` decimal(10,2) DEFAULT NULL,
  `rate` decimal(10,2) DEFAULT NULL,
  `total_amount` decimal(10,2) DEFAULT NULL,
  `discount` float DEFAULT NULL,
  `status` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `purchase_id` (`purchase_id`),
  KEY `product_id` (`product_id`)
) ENGINE=MyISAM AUTO_INCREMENT=4274 DEFAULT CHARSET=utf8mb3;

INSERT INTO product_purchase_details VALUES("1","h85zoxxpPmzqVnX","20240124145509","1","38.00","370.00","14060.00","0","1");
INSERT INTO product_purchase_details VALUES("2","Cup9SzKVczRmjTg","20240124145509","2","58.00","190.00","11020.00","0","1");
INSERT INTO product_purchase_details VALUES("3","2sXKQafeibCO1RG","20240124145509","3 ","6.00","300.00","1800.00","0","1");
INSERT INTO product_purchase_details VALUES("1669","A8d2wo0qSsMGGJQ","20240124145800","4","47.00","290.00","13630.00","0","");
INSERT INTO product_purchase_details VALUES("1668","ZwWpJNAdsqJ9sOQ","20240124145800","5","40.00","450.00","18000.00","0","");
INSERT INTO product_purchase_details VALUES("1667","9USLPbXKT4kXEEO","20240124145800","6","2.00","150.00","300.00","0","");
INSERT INTO product_purchase_details VALUES("1666","bFCUm3nyjbIQ3A3","20240124145800","7","16.00","320.00","5120.00","0","");
INSERT INTO product_purchase_details VALUES("3466","rY0XMHNJ1i4hauy","20240124152118","8","9.00","550.00","4950.00","0","");
INSERT INTO product_purchase_details VALUES("3465","HBrpVwaKHeLkXT8","20240124152118","9","18.00","430.00","7740.00","0","");
INSERT INTO product_purchase_details VALUES("3464","fzW6BJohx0eOrfd","20240124152118","10","18.00","210.00","3780.00","0","");
INSERT INTO product_purchase_details VALUES("3463","ymV220FkNVXqhOz","20240124152118","11","330.00","105.00","34650.00","0","");
INSERT INTO product_purchase_details VALUES("3462","1M8DYrJVetK8XiG","20240124152118","12","80.00","135.00","10800.00","0","");
INSERT INTO product_purchase_details VALUES("3461","mKC57Srizw3Hpf2","20240124152118","13","50.00","400.00","20000.00","0","");
INSERT INTO product_purchase_details VALUES("3460","5xzn11t9r7UauYe","20240124152118","14","50.00","165.00","8250.00","0","");
INSERT INTO product_purchase_details VALUES("3129","SYXp9k5qVbplV7s","20240124154656","604","50.00","175.00","8750.00","0","");
INSERT INTO product_purchase_details VALUES("3128","NYWaoB6SCWJaGZ4","20240124154656","15","80.00","135.00","10800.00","0","");
INSERT INTO product_purchase_details VALUES("3127","iGvhgnAY5WnCT67","20240124154656","16","20.00","110.00","2200.00","0","");
INSERT INTO product_purchase_details VALUES("3126","3Q9t7Mij2hABwWc","20240124154656","17","25.00","180.00","4500.00","0","");
INSERT INTO product_purchase_details VALUES("3125","2SRytTiQQRgUevA","20240124154656","18","10.00","75.00","750.00","0","");
INSERT INTO product_purchase_details VALUES("3124","2in52gEXl89hM76","20240124154656","19","300.00","70.00","21000.00","0","");
INSERT INTO product_purchase_details VALUES("3123","gALSZBcOqJGHdXJ","20240124154656","20","300.00","115.00","34500.00","0","");
INSERT INTO product_purchase_details VALUES("108","xrX6BDatTSR8nhJ","20240127150504","30","2.00","1900.00","3800.00","0","");
INSERT INTO product_purchase_details VALUES("107","NCrD5u3GKDOhA4t","20240127150504","29","45.00","40.00","1800.00","0","");
INSERT INTO product_purchase_details VALUES("106","cTPCL5TlJjiMixH","20240127150504","28","20.00","120.00","2400.00","0","");
INSERT INTO product_purchase_details VALUES("105","Bum3S9d0diPBS96","20240127150504","27","100.00","33.00","3300.00","0","");
INSERT INTO product_purchase_details VALUES("104","cepB6yJWUskwVHo","20240127150504","26","200.00","15.00","3000.00","0","");
INSERT INTO product_purchase_details VALUES("103","B5jyRc7FotftbbO","20240127150504","25","1.00","1800.00","1800.00","0","");
INSERT INTO product_purchase_details VALUES("102","MJdwzFHtDlEnbxh","20240127150504","24","5.00","750.00","3750.00","0","");
INSERT INTO product_purchase_details VALUES("101","KNZEbLoFoCk5Sg1","20240127150504","23","5.00","1500.00","7500.00","0","");
INSERT INTO product_purchase_details VALUES("100","OA3XVvijsnhYEhD","20240127150504","22","200.00","15.00","3000.00","0","");
INSERT INTO product_purchase_details VALUES("90","H0J0yvKbvhMCJXF","20240127152129","40","300.00","15.00","4500.00","0","");
INSERT INTO product_purchase_details VALUES("89","6DnCh7H9OgK0qSC","20240127152129","39","60.00","20.00","1200.00","0","");
INSERT INTO product_purchase_details VALUES("88","qw5VjKiBGwqgYAp","20240127152129","38","200.00","20.00","4000.00","0","");
INSERT INTO product_purchase_details VALUES("87","BpBtAj0AqIYn5Q5","20240127152129","37","200.00","10.00","2000.00","0","");
INSERT INTO product_purchase_details VALUES("86","ANSMWKZmtKQVFUx","20240127152129","36","1.00","2500.00","2500.00","0","");
INSERT INTO product_purchase_details VALUES("85","y6YfI6cPwGG1nCF","20240127152129","35","2.00","1000.00","2000.00","0","");
INSERT INTO product_purchase_details VALUES("84","OQUQCmkdpp9vivC","20240127152129","34","2.00","350.00","700.00","0","");
INSERT INTO product_purchase_details VALUES("83","afhzDGDOdAqJ6Di","20240127152129","33","2.00","700.00","1400.00","0","");
INSERT INTO product_purchase_details VALUES("82","ZAvDpBra4lpmf3k","20240127152129","32","14.00","750.00","10500.00","0","");
INSERT INTO product_purchase_details VALUES("81","1lq2T0L4B7En4jR","20240127152129","31","36.00","1700.00","61200.00","0","");
INSERT INTO product_purchase_details VALUES("176","FNjU0wz2iCUV2UI","20240127161005","51","9.00","250.00","2250.00","0","");
INSERT INTO product_purchase_details VALUES("175","Xi8A9GJwJA6EfQt","20240127161005","50","100.00","120.00","12000.00","0","");
INSERT INTO product_purchase_details VALUES("174","8EkwCvzHhblGtRw","20240127161005","49","20.00","160.00","3200.00","0","");
INSERT INTO product_purchase_details VALUES("173","UOuzwhKqaJnwJx9","20240127161005","48","9.00","150.00","1350.00","0","");
INSERT INTO product_purchase_details VALUES("172","y3Y9hH4IqIrW3BG","20240127161005","47","10.00","320.00","3200.00","0","");
INSERT INTO product_purchase_details VALUES("171","oWh2MjekN9H4FZd","20240127161005","52","8.00","450.00","3600.00","0","");
INSERT INTO product_purchase_details VALUES("170","72Fi06BwRPy4Qv2","20240127161005","46","7.00","150.00","1050.00","0","");
INSERT INTO product_purchase_details VALUES("169","drYL7CDgPfe2I3c","20240127161005","45","10.00","180.00","1800.00","0","");
INSERT INTO product_purchase_details VALUES("168","Gp8ODhZapIV4Fes","20240127161005","43","30.00","220.00","6600.00","0","");
INSERT INTO product_purchase_details VALUES("167","up4Lar6jVMyr9XV","20240127161005","42","20.00","170.00","3400.00","0","");
INSERT INTO product_purchase_details VALUES("166","9ETONHUu9Uv8mmK","20240127161005","41","200.00","45.00","9000.00","0","");
INSERT INTO product_purchase_details VALUES("208","j8vItuXcZp7zBJB","20240128104627","62","3.00","1500.00","4500.00","0","");
INSERT INTO product_purchase_details VALUES("207","bRPKAV3d9CWl9Mo","20240128104627","61","72.00","160.00","11520.00","0","");
INSERT INTO product_purchase_details VALUES("206","Jqge6vtnLBv6202","20240128104627","60","85.00","200.00","17000.00","0","");
INSERT INTO product_purchase_details VALUES("205","GliP2duwmSNm8JP","20240128104627","59","127.00","165.00","20955.00","0","");
INSERT INTO product_purchase_details VALUES("204","hcScf7AqB55KwNL","20240128104627","58","584.00","115.00","67160.00","0","");
INSERT INTO product_purchase_details VALUES("203","UJVlE2R4wbz39Wv","20240128104627","57","400.00","140.00","56000.00","0","");
INSERT INTO product_purchase_details VALUES("202","5nt9GPTvbPJzm3p","20240128104627","56","11.00","1000.00","11000.00","0","");
INSERT INTO product_purchase_details VALUES("201","6UhpXPl1k6rywH2","20240128104627","55","23.00","280.00","6440.00","0","");
INSERT INTO product_purchase_details VALUES("200","OwpAVQS509NBQkD","20240128104627","54","42.00","255.00","10710.00","0","");
INSERT INTO product_purchase_details VALUES("199","NkNKM6BHV6GkESh","20240128104627","53","10.00","480.00","4800.00","0","");
INSERT INTO product_purchase_details VALUES("4203","HDTqxm4q3pylJQg","20240128113240","416","2.00","5000.00","10000.00","0","");
INSERT INTO product_purchase_details VALUES("4202","qAD5V7xeygKQfc7","20240128113240","412","3.00","8800.00","26400.00","0","");
INSERT INTO product_purchase_details VALUES("4201","2fpDQwv6yenv2tZ","20240128113240","415","3.00","5800.00","17400.00","0","");
INSERT INTO product_purchase_details VALUES("4200","c0xhaAOyvM98tMm","20240128113240","414","3.00","6900.00","20700.00","0","");
INSERT INTO product_purchase_details VALUES("4199","LC6LNXyfvk9msCd","20240128113240","413","1.00","7750.00","7750.00","0","");
INSERT INTO product_purchase_details VALUES("4198","aCwDnwKfSiHaPy5","20240128113240","418","7.00","4300.00","30100.00","0","");
INSERT INTO product_purchase_details VALUES("4197","nkcHP4kGooMwdkY","20240128113240","417","8.00","4300.00","34400.00","0","");
INSERT INTO product_purchase_details VALUES("4196","Oidkmp2EW7JOIuL","20240128113240","63","5.00","4900.00","24500.00","0","");
INSERT INTO product_purchase_details VALUES("4195","hvX8CsAaY0wTMkE","20240128113240","64","5.00","4900.00","24500.00","0","");
INSERT INTO product_purchase_details VALUES("4194","ljnxHtc1seY1CCp","20240128113240","65","3.00","10300.00","30900.00","0","");
INSERT INTO product_purchase_details VALUES("4193","KXuXwee94ZBDDRD","20240128113240","66","2.00","10300.00","20600.00","0","");
INSERT INTO product_purchase_details VALUES("4192","vbp84nsceFSSRnZ","20240128113240","67","17.00","2600.00","44200.00","0","");
INSERT INTO product_purchase_details VALUES("4191","FAqhuQjneNDjJ3X","20240128113240","68","33.00","2600.00","85800.00","0","");
INSERT INTO product_purchase_details VALUES("4190","BDAid8YnD1dWEBx","20240128113240","69","12.00","5200.00","62400.00","0","");
INSERT INTO product_purchase_details VALUES("4189","i7ZJJ7vwVbOplQ1","20240128113240","70","8.00","5200.00","41600.00","0","");
INSERT INTO product_purchase_details VALUES("183","AMOStib9QjnM0lp","20240128115259","84","4.00","450.00","1800.00","0","");
INSERT INTO product_purchase_details VALUES("182","owlsGjCwRbOjuta","20240128115259","83","6.00","450.00","2700.00","0","");
INSERT INTO product_purchase_details VALUES("181","ebhJXec6yIoQDhs","20240128115259","82","13.00","170.00","2210.00","0","");
INSERT INTO product_purchase_details VALUES("180","D7qyEoEW6D0aCSp","20240128115259","81","12.00","80.00","960.00","0","");
INSERT INTO product_purchase_details VALUES("179","iaBdSrRHuE7gyE7","20240128115259","80","61.00","80.00","4880.00","0","");
INSERT INTO product_purchase_details VALUES("178","de1pbuDryZdzLvi","20240128115259","79","23.00","120.00","2760.00","0","");
INSERT INTO product_purchase_details VALUES("177","Zuszqg4oo4Kqzj","20240128115259","78","70.00","160.00","11200.00","0","");
INSERT INTO product_purchase_details VALUES("288","Zx7tmeH1SxYz59o","20240128140222","94","21.00","585.00","12285.00","0","1");
INSERT INTO product_purchase_details VALUES("1703","ciMeiFBVVaGUp5R","20240128122919","88 ","3.00","1320.00","3960.00","0","");
INSERT INTO product_purchase_details VALUES("1702","Bc7oMSsAlG3X7yb","20240128122919","91","5.00","540.00","2700.00","0","");
INSERT INTO product_purchase_details VALUES("1701","vJXIMSOwEgT0hO9","20240128122919","86","75.00","390.00","29250.00","0","");
INSERT INTO product_purchase_details VALUES("1700","uz6snpY2oonb8t1","20240128122919","85","24.00","660.00","15840.00","0","");
INSERT INTO product_purchase_details VALUES("1699","R0zVZIXxmYplD5l","20240128122919","90","20.50","900.00","18450.00","0","");
INSERT INTO product_purchase_details VALUES("1698","ZAjjdT5IK8tEzAm","20240128122919","92","128.00","260.00","33280.00","0","");
INSERT INTO product_purchase_details VALUES("1697","SmxIDIEyJjNI5K9","20240128122919","93","24.00","270.00","6480.00","0","");
INSERT INTO product_purchase_details VALUES("289","TP1fKnP4RJfly5R","20240128140222","95","31.00","390.00","12090.00","0","1");
INSERT INTO product_purchase_details VALUES("290","ACiHmpOswPnjqJj","20240128140222","99","13.00","360.00","4680.00","0","1");
INSERT INTO product_purchase_details VALUES("291","l9wZ6etj851CntV","20240128140222","96","28.00","260.00","7280.00","0","1");
INSERT INTO product_purchase_details VALUES("292","40niYVpLZCinULa","20240128140222","97","5.00","800.00","4000.00","0","1");
INSERT INTO product_purchase_details VALUES("293","ja6GWxo3AUVaoUY","20240128140222","98","3.00","850.00","2550.00","0","1");
INSERT INTO product_purchase_details VALUES("294","70XIrEO7Tt2CeGG","20240128141713","102","54.00","450.00","24300.00","0","1");
INSERT INTO product_purchase_details VALUES("295","bmkyUveU7dnZSTv","20240128141713","103","40.00","320.00","12800.00","0","1");
INSERT INTO product_purchase_details VALUES("296","e24vcEGMYKU5b5g","20240128141713","104","26.00","300.00","7800.00","0","1");
INSERT INTO product_purchase_details VALUES("393","CO1ln9OLr06KHgW","20240128142633","101","89.00","550.00","48950.00","0","");
INSERT INTO product_purchase_details VALUES("392","vQuDKPzuXMfpH7b","20240128142633","100","107.00","300.00","32100.00","0","");
INSERT INTO product_purchase_details VALUES("3788","5pbDGPgdlO5JiFU","20240128145546","113","17.00","840.00","14280.00","0","");
INSERT INTO product_purchase_details VALUES("3787","NNMQhazAKom3YzN","20240128145546","114","30.00","480.00","14400.00","0","");
INSERT INTO product_purchase_details VALUES("3786","XfixnPmfpv5HFxg","20240128145546","115","7.00","620.00","4340.00","0","");
INSERT INTO product_purchase_details VALUES("432","n7MboiqbnJXwqzT","20240128150010","112","4.00","280.00","1120.00","0","");
INSERT INTO product_purchase_details VALUES("431","PL7xi0Eln4RSam2","20240128150010","111","8.00","1000.00","8000.00","0","");
INSERT INTO product_purchase_details VALUES("430","p9bs5AuydWzJHfq","20240128150010","110","16.00","1296.00","20736.00","0","");
INSERT INTO product_purchase_details VALUES("429","paGJa7Wv0m29o4K","20240128150010","109","20.00","600.00","12000.00","0","");
INSERT INTO product_purchase_details VALUES("428","QouPo43aDWVow7C","20240128150010","108","15.00","300.00","4500.00","0","");
INSERT INTO product_purchase_details VALUES("427","FAljEPEsk7vVW53","20240128150010","107","33.00","460.00","15180.00","0","");
INSERT INTO product_purchase_details VALUES("426","Sv8NH7CK0twucur","20240128150010","106","17.00","380.00","6460.00","0","");
INSERT INTO product_purchase_details VALUES("425","cGXrTHP7qiBmXxR","20240128150010","105","7.00","510.00","3570.00","0","");
INSERT INTO product_purchase_details VALUES("317","D28eaPppvnZWR3g","20240128151840","116","40.00","550.00","22000.00","0","1");
INSERT INTO product_purchase_details VALUES("318","OeRFjBYTQ3vjPaJ","20240128151840","117","3.00","300.00","900.00","0","1");
INSERT INTO product_purchase_details VALUES("319","Vhyj7o9B8WD7xPq","20240128151840","118","12.00","300.00","3600.00","0","1");
INSERT INTO product_purchase_details VALUES("320","zhWEacc8xnp1fRY","20240128151840","119","17.00","600.00","10200.00","0","1");
INSERT INTO product_purchase_details VALUES("321","5NDrnf5zQJsmEfc","20240128151840","120","27.00","700.00","18900.00","0","1");
INSERT INTO product_purchase_details VALUES("322","j3cbC9eEvK5ViFp","20240128151840","121","22.00","300.00","6600.00","0","1");
INSERT INTO product_purchase_details VALUES("323","LG0hHFqQXDuySBg","20240128151840","122","30.00","340.00","10200.00","0","1");
INSERT INTO product_purchase_details VALUES("324","UoQX2LUphZqSAbt","20240128151840","123","38.00","300.00","11400.00","0","1");
INSERT INTO product_purchase_details VALUES("325","p20CVonnkhyX3ov","20240129142817","124","10.00","500.00","5000.00","0","1");
INSERT INTO product_purchase_details VALUES("326","ck6gW2b1jO6Hq2q","20240129142817","125","156.00","375.00","58500.00","0","1");
INSERT INTO product_purchase_details VALUES("327","PYh5o4ghS1w6Tqm","20240129142817","126","51.00","460.00","23460.00","0","1");
INSERT INTO product_purchase_details VALUES("328","oYIa39pk7prg7Qj","20240129142817","127","17.00","400.00","6800.00","0","1");
INSERT INTO product_purchase_details VALUES("329","Z7l65K6d9ADJoMO","20240129142817","128","17.00","400.00","6800.00","0","1");
INSERT INTO product_purchase_details VALUES("330","RerbQnHaXjLslYD","20240129142817","129","19.00","275.00","5225.00","0","1");
INSERT INTO product_purchase_details VALUES("331","5Z4K8lAQ1D8LIqq","20240129142817","130","211.00","360.00","75960.00","0","1");
INSERT INTO product_purchase_details VALUES("332","KPjtBUMtiAxFLFs","20240129142817","131","12.00","240.00","2880.00","0","1");
INSERT INTO product_purchase_details VALUES("333","LEvyJPNRjofaSVf","20240129142817","132","13.00","240.00","3120.00","0","1");
INSERT INTO product_purchase_details VALUES("334","ghQJv09l23cvKn5","20240129142817","133","26.00","240.00","6240.00","0","1");
INSERT INTO product_purchase_details VALUES("335","ZyB6LEMIl73IViD","20240129142817","134","12.00","160.00","1920.00","0","1");
INSERT INTO product_purchase_details VALUES("1269","XHnDAkpt8eAbNgZ","20240129154322","158","5.00","4190.00","20950.00","0","");
INSERT INTO product_purchase_details VALUES("1268","tNiaVxLToawU8lk","20240129154322","157","5.00","4190.00","20950.00","0","");
INSERT INTO product_purchase_details VALUES("1267","exiA18iNyfshVZv","20240129154322","162","10.00","3351.00","33510.00","0","");
INSERT INTO product_purchase_details VALUES("1266","sgbLNtGn48o1EBy","20240129154322","161","10.00","4391.00","43910.00","0","");
INSERT INTO product_purchase_details VALUES("1265","EUHEswAWtLTB60d","20240129154322","160","5.00","5126.00","25630.00","0","");
INSERT INTO product_purchase_details VALUES("1264","udqjB7sx1UASCfl","20240129154322","159","5.00","5126.00","25630.00","0","");
INSERT INTO product_purchase_details VALUES("1263","bcRS73R24YadVLN","20240129154322","156","8.00","3208.00","25664.00","0","");
INSERT INTO product_purchase_details VALUES("1262","AyEyh7HQRODioJA","20240129154322","155","12.00","3208.00","38496.00","0","");
INSERT INTO product_purchase_details VALUES("1261","WSeFtwUa34Vsx0c","20240129154322","154","10.00","2292.00","22920.00","0","");
INSERT INTO product_purchase_details VALUES("1260","Mw3bJs2rQkTYU3s","20240129154322","153","10.00","2292.00","22920.00","0","");
INSERT INTO product_purchase_details VALUES("1259","8n3iDJbYZGHXGgV","20240129154322","152","13.00","1557.00","20241.00","0","");
INSERT INTO product_purchase_details VALUES("1258","5b0P153UKasxxou","20240129154322","151","7.00","1557.00","10899.00","0","");
INSERT INTO product_purchase_details VALUES("1257","R4NXSt9v9ZfFfVJ","20240129154322","150","5.00","1044.00","5220.00","0","");
INSERT INTO product_purchase_details VALUES("1256","5y0MImWe0ln8H02","20240129154322","149","5.00","1044.00","5220.00","0","");
INSERT INTO product_purchase_details VALUES("1255","5f1CYpYhxx2ZG3O","20240129154322","148","2.00","14986.00","29972.00","0","");
INSERT INTO product_purchase_details VALUES("1254","rT5B9C2dBkDhsG7","20240129154322","147","3.00","14986.00","44958.00","0","");
INSERT INTO product_purchase_details VALUES("1253","epVNtWwbSVaB790","20240129154322","146","2.00","9331.00","18662.00","0","");
INSERT INTO product_purchase_details VALUES("1252","qcnP01hCCOHfeAN","20240129154322","145","3.00","9331.00","27993.00","0","");
INSERT INTO product_purchase_details VALUES("1251","2YmgVDJrDN6e0M5","20240129154322","144","30.00","6146.00","184380.00","0","");
INSERT INTO product_purchase_details VALUES("1250","VHVeP4LmwQ8ZDMr","20240129154322","143","5.00","6146.00","30730.00","0","");
INSERT INTO product_purchase_details VALUES("1249","qa3W0Yf75IasPvY","20240129154322","142","5.00","6146.00","30730.00","0","");
INSERT INTO product_purchase_details VALUES("1248","4Eu63xIWpvJW9WS","20240129154322","141","40.00","6146.00","245840.00","0","");
INSERT INTO product_purchase_details VALUES("1247","qvk5q9to2geZx5F","20240129154322","140","4.00","2961.00","11844.00","0","");
INSERT INTO product_purchase_details VALUES("1246","rYUJHzJFb3Rmrtw","20240129154322","139","12.00","2961.00","35532.00","0","");
INSERT INTO product_purchase_details VALUES("1245","NswEXnnh2qeA2dQ","20240129154322","138","8.00","2961.00","23688.00","0","");
INSERT INTO product_purchase_details VALUES("1244","FzofJ3MtTGJ45UT","20240129154322","137","12.00","2961.00","35532.00","0","");
INSERT INTO product_purchase_details VALUES("1243","FP7TNCBGt4K771H","20240129154322","136","64.00","2961.00","189504.00","0","");
INSERT INTO product_purchase_details VALUES("1242","mbZIzj3Vi98kOwh","20240129154322","135","100.00","2961.00","296100.00","0","");
INSERT INTO product_purchase_details VALUES("4024","aWb6WDKzO2q0kaP","20240130154304","178","24.00","80.00","1920.00","0","");
INSERT INTO product_purchase_details VALUES("4023","aFc4NMkgZ0wDDtt","20240130154304","177","96.00","165.00","15840.00","0","");
INSERT INTO product_purchase_details VALUES("4022","dNJDtTV3mDD4Loq","20240130154304","176","120.00","65.00","7800.00","0","");
INSERT INTO product_purchase_details VALUES("4021","cnuMO6AnYFJJK3D","20240130154304","175","324.00","125.00","40500.00","0","");
INSERT INTO product_purchase_details VALUES("4020","uKPfOQbaGFF5GvS","20240130154304","184","3.00","1400.00","4200.00","0","");
INSERT INTO product_purchase_details VALUES("4019","E52WVoaP0mr1N2R","20240130154304","183","4.00","1600.00","6400.00","0","");
INSERT INTO product_purchase_details VALUES("4018","EG0WUq1ViYcecD8","20240130154304","182","300.00","90.00","27000.00","0","");
INSERT INTO product_purchase_details VALUES("4017","SEGPMb7IUNQfWv0","20240130154304","181","50.00","165.00","8250.00","0","");
INSERT INTO product_purchase_details VALUES("4016","wOEsfRUxh0FtQ5c","20240130154304","180","900.00","27.00","24300.00","0","");
INSERT INTO product_purchase_details VALUES("4015","O9DhqFIUjTwOevS","20240130154304","179","1000.00","36.00","36000.00","0","");
INSERT INTO product_purchase_details VALUES("4014","mUlQiHGWG0E8e9B","20240130154304","174","35.00","300.00","10500.00","0","");
INSERT INTO product_purchase_details VALUES("4013","aSsP7I9jVS4f4rA","20240130154304","173","6.00","210.00","1260.00","0","");
INSERT INTO product_purchase_details VALUES("4012","v3TxLJoSM6tlVil","20240130154304","172","13.00","150.00","1950.00","0","");
INSERT INTO product_purchase_details VALUES("4011","aFqKCupZLakdrhI","20240130154304","171","12.00","300.00","3600.00","0","");
INSERT INTO product_purchase_details VALUES("4010","p2KyU6bTZm0kXd4","20240130154304","170","2.00","450.00","900.00","0","");
INSERT INTO product_purchase_details VALUES("4009","xFXDY85nh7QIsAa","20240130154304","169","1.00","700.00","700.00","0","");
INSERT INTO product_purchase_details VALUES("4008","VBJyc0W3x0VCxUH","20240130154304","168","1.00","800.00","800.00","0","");
INSERT INTO product_purchase_details VALUES("4007","CVu4SNXoRmG9LVs","20240130154304","167","9.00","240.00","2160.00","0","");
INSERT INTO product_purchase_details VALUES("4006","vVwgUJ2ygI0byMk","20240130154304","166","11.00","330.00","3630.00","0","");
INSERT INTO product_purchase_details VALUES("4005","wnItbNIGLHU0MjT","20240130154304","165","7.00","380.00","2660.00","0","");
INSERT INTO product_purchase_details VALUES("4004","5RcyDBPyCJCmMzi","20240130154304","164","6.00","500.00","3000.00","0","");
INSERT INTO product_purchase_details VALUES("4003","YD3H25BMNBe6D8l","20240130154304","163","4.00","580.00","2320.00","0","");
INSERT INTO product_purchase_details VALUES("1710","9RvnZArtX8Xww9q","20240130155908","89","48.00","280.00","13440.00","0","");
INSERT INTO product_purchase_details VALUES("1709","FxGU25vGEdcHJqD","20240130155908","87","9.00","270.00","2430.00","0","");
INSERT INTO product_purchase_details VALUES("573","rqcVjwbNRxn0WJs","20240131144117","199","3.00","1900.00","5700.00","0","");
INSERT INTO product_purchase_details VALUES("572","GzOgRlJB4vQcqxt","20240131144117","198","3.00","2100.00","6300.00","0","");
INSERT INTO product_purchase_details VALUES("571","5XRWJ8sF4lXk0P2","20240131144117","197","2.00","1500.00","3000.00","0","");
INSERT INTO product_purchase_details VALUES("570","15zmPK8sYMCiAkj","20240131144117","196","11.00","380.00","4180.00","0","");
INSERT INTO product_purchase_details VALUES("569","fHj9F6fRw7Ew6B4","20240131144117","195","4.00","1300.00","5200.00","0","");
INSERT INTO product_purchase_details VALUES("568","nfhcJTVhx9OKj5I","20240131144117","194","7.00","1500.00","10500.00","0","");
INSERT INTO product_purchase_details VALUES("567","LbIZrmmQG4TuhMW","20240131144117","193","6.00","1700.00","10200.00","0","");
INSERT INTO product_purchase_details VALUES("566","6szcZWCizA6MVJa","20240131144117","192","1.00","1100.00","1100.00","0","");
INSERT INTO product_purchase_details VALUES("565","vysXou0YKzsSJjQ","20240131144117","191","1.00","1700.00","1700.00","0","");
INSERT INTO product_purchase_details VALUES("564","L3ClndBp0kEbrC8","20240131144117","190","2.00","2500.00","5000.00","0","");
INSERT INTO product_purchase_details VALUES("563","uHXC6QjwP247Mst","20240131144117","189","2.00","3350.00","6700.00","0","");
INSERT INTO product_purchase_details VALUES("562","PTsJghnH9OTNd4N","20240131144117","188","4.00","5600.00","22400.00","0","");
INSERT INTO product_purchase_details VALUES("561","Whiq0M3t1xr1iyu","20240131144117","187","1.00","6500.00","6500.00","0","");
INSERT INTO product_purchase_details VALUES("560","ryhSv37LlCqIfli","20240131144117","186","2.00","5500.00","11000.00","0","");
INSERT INTO product_purchase_details VALUES("559","aa0nFYP0mfYTDgt","20240131144117","185","2.00","8500.00","17000.00","0","");
INSERT INTO product_purchase_details VALUES("1346","Vr29RRf4kixnSxC","20240131153527","212","50.00","105.00","5250.00","0","");
INSERT INTO product_purchase_details VALUES("1345","FXP3RCgJhfPMVOq","20240131153527","211","50.00","100.00","5000.00","0","");
INSERT INTO product_purchase_details VALUES("1344","bTwrBTydfmZSjlL","20240131153527","210","50.00","70.00","3500.00","0","");
INSERT INTO product_purchase_details VALUES("1343","bVtdrfNz5ntE8iy","20240131153527","209","1.00","1700.00","1700.00","0","");
INSERT INTO product_purchase_details VALUES("1342","WDp2aAjdEZQbRuM","20240131153527","208","1.00","1500.00","1500.00","0","");
INSERT INTO product_purchase_details VALUES("1341","sPNodNVWTCN3Obv","20240131153527","207","3.00","1300.00","3900.00","0","");
INSERT INTO product_purchase_details VALUES("1340","NhfQxYL6spGUuyP","20240131153527","206","13.00","1200.00","15600.00","0","");
INSERT INTO product_purchase_details VALUES("1339","cCwzHSBYna6sO8F","20240131153527","205","6.00","900.00","5400.00","0","");
INSERT INTO product_purchase_details VALUES("1338","kcLtgH3wzR6Uycp","20240131153527","204","1.00","1300.00","1300.00","0","");
INSERT INTO product_purchase_details VALUES("1337","YOyASuLBwxCgp8U","20240131153527","203","1.00","1100.00","1100.00","0","");
INSERT INTO product_purchase_details VALUES("1336","ESrwStVZwMZHeKe","20240131153527","202","5.00","900.00","4500.00","0","");
INSERT INTO product_purchase_details VALUES("1335","jsishCmM7ULpInr","20240131153527","201","5.00","800.00","4000.00","0","");
INSERT INTO product_purchase_details VALUES("1334","BrnC56KHnYfjB4X","20240131153527","200","30.00","900.00","27000.00","0","");
INSERT INTO product_purchase_details VALUES("2645","NVwoSBlD8YTQZWj","20240201145453","598 ","40.00","130.00","5200.00","0","");
INSERT INTO product_purchase_details VALUES("2644","jUy134wlcRcinnr","20240201145453","599","20.00","120.00","2400.00","0","");
INSERT INTO product_purchase_details VALUES("2643","sdBEKZr7rt4XYs9","20240201145453","597","1.00","250.00","250.00","0","");
INSERT INTO product_purchase_details VALUES("2642","upqLmSNCNzkrwK4","20240201145453","596","4.00","336.00","1344.00","0","");
INSERT INTO product_purchase_details VALUES("2641","uDMlh86I3DYkUd5","20240201145453","595","2.00","323.00","646.00","0","");
INSERT INTO product_purchase_details VALUES("2640","vWAB6AWJ7Ug4cya","20240201145453","594","12.00","290.00","3480.00","0","");
INSERT INTO product_purchase_details VALUES("2639","2bUqF0SKkCf0VLT","20240201145453","593","2.00","450.00","900.00","0","");
INSERT INTO product_purchase_details VALUES("2638","k137ZM8cge5n5XQ","20240201145453","592","8.00","482.00","3856.00","0","");
INSERT INTO product_purchase_details VALUES("2637","fcV2IyqBlGbxrSN","20240201145453","233","2.00","1050.00","2100.00","0","");
INSERT INTO product_purchase_details VALUES("2636","Q7scMoEFYOhGFoZ","20240201145453","232","2.00","750.00","1500.00","0","");
INSERT INTO product_purchase_details VALUES("2635","YNlayYhaFUQ6pJa","20240201145453","231","3.00","550.00","1650.00","0","");
INSERT INTO product_purchase_details VALUES("2634","RBL4vVqVn1rHUSg","20240201145453","230","1.00","4600.00","4600.00","0","");
INSERT INTO product_purchase_details VALUES("2633","dCQU6kaUbIwHa0f","20240201145453","229","1.00","5000.00","5000.00","0","");
INSERT INTO product_purchase_details VALUES("2632","ustyYK00FPESB3h","20240201145453","228","3.00","3500.00","10500.00","0","");
INSERT INTO product_purchase_details VALUES("2631","oHJc4HHGBpw6kRd","20240201145453","227","30.00","100.00","3000.00","0","");
INSERT INTO product_purchase_details VALUES("2630","5OugrZ3cII2Q4Ia","20240201145453","226","2.00","1600.00","3200.00","0","");
INSERT INTO product_purchase_details VALUES("2629","dCndcDpWn2Po36G","20240201145453","225","16.00","480.00","7680.00","0","");
INSERT INTO product_purchase_details VALUES("2628","Ntn7fThFzvNHRsy","20240201145453","224","10.00","550.00","5500.00","0","");
INSERT INTO product_purchase_details VALUES("2627","tskvZCpuoYRyEzp","20240201145453","223","6.00","1250.00","7500.00","0","");
INSERT INTO product_purchase_details VALUES("2626","tkwUYVevpawk95w","20240201145453","222","95.00","230.00","21850.00","0","");
INSERT INTO product_purchase_details VALUES("2625","KOuQHLZDrf74TAG","20240201145453","221","6.00","500.00","3000.00","0","");
INSERT INTO product_purchase_details VALUES("3448","DvC1RFt56k5YaNR","20240201155743","258","1.00","450.00","450.00","0","");
INSERT INTO product_purchase_details VALUES("3447","XExnk4eWjXHvxAz","20240201155743","257","1.00","550.00","550.00","0","");
INSERT INTO product_purchase_details VALUES("3446","OIo5TVmk0nTN7du","20240201155743","256","1.00","800.00","800.00","0","");
INSERT INTO product_purchase_details VALUES("3445","KmFNTYlJOEfIL2Y","20240201155743","255","2.00","750.00","1500.00","0","");
INSERT INTO product_purchase_details VALUES("3444","yEI5mEINFJb6N2G","20240201155743","254","80.00","230.00","18400.00","0","");
INSERT INTO product_purchase_details VALUES("3443","MpvtX6xODFG3cS","20240201155743","253","5.00","280.00","1400.00","0","");
INSERT INTO product_purchase_details VALUES("3442","ulDGScSr5XRqerP","20240201155743","252","9.00","310.00","2790.00","0","");
INSERT INTO product_purchase_details VALUES("3441","vvf3uWEPAlQtNnu","20240201155743","251","29.00","275.00","7975.00","0","");
INSERT INTO product_purchase_details VALUES("3440","HmVLy3FcpLPnjHG","20240201155743","250","25.00","250.00","6250.00","0","");
INSERT INTO product_purchase_details VALUES("3439","pESdB8WVW4XSwLr","20240201155743","249","1.00","1600.00","1600.00","0","");
INSERT INTO product_purchase_details VALUES("3438","pxM4If1mwgmZqZ1","20240201155743","248","41.00","320.00","13120.00","0","");
INSERT INTO product_purchase_details VALUES("3437","ie0Opnkd5E9kIAf","20240201155743","247","13.00","650.00","8450.00","0","");
INSERT INTO product_purchase_details VALUES("3436","xAs2zsBXzK1SOwY","20240201155743","246","4.00","4000.00","16000.00","0","");
INSERT INTO product_purchase_details VALUES("3435","ppFZdEd7seIR623","20240201155743","245","5.00","2800.00","14000.00","0","");
INSERT INTO product_purchase_details VALUES("3434","DMRlgsLUIyU9qTC","20240201155743","244","2.00","5500.00","11000.00","0","");
INSERT INTO product_purchase_details VALUES("3433","PUZ3n8hourulNsr","20240201155743","243","19.00","430.00","8170.00","0","");
INSERT INTO product_purchase_details VALUES("3432","7tmAEqZz5vCnyMo","20240201155743","242","13.00","490.00","6370.00","0","");
INSERT INTO product_purchase_details VALUES("3431","CMYAmPR5FVmm1Cm","20240201155743","241","18.00","160.00","2880.00","0","");
INSERT INTO product_purchase_details VALUES("3430","MGMXT85qRAaVLXp","20240201155743","240","9.00","260.00","2340.00","0","");
INSERT INTO product_purchase_details VALUES("3429","HM2CHr97TD2RzvH","20240201155743","239","38.00","360.00","13680.00","0","");
INSERT INTO product_purchase_details VALUES("3428","vbZt4i1q6xPrjKO","20240201155743","238","34.00","320.00","10880.00","0","");
INSERT INTO product_purchase_details VALUES("3427","swJgDzrGciz9ghl","20240201155743","237","20.00","530.00","10600.00","0","");
INSERT INTO product_purchase_details VALUES("3426","QcKYwhUblqCBI1G","20240201155743","236","10.00","920.00","9200.00","0","");
INSERT INTO product_purchase_details VALUES("3425","eiqqeKCOaJthUbb","20240201155743","235","25.00","1100.00","27500.00","0","");
INSERT INTO product_purchase_details VALUES("3424","Uik8yxEdnlosmKy","20240201155743","234","8.00","920.00","7360.00","0","");
INSERT INTO product_purchase_details VALUES("4166","yyct7Ut6lF6EBZs","20240203141705","489","2.00","1500.00","3000.00","0","");
INSERT INTO product_purchase_details VALUES("4165","Qa0ZtmgiunUvB3A","20240203141705","488","1.00","2400.00","2400.00","0","");
INSERT INTO product_purchase_details VALUES("4164","92tll0P1w1qzrAY","20240203141705","422","350.00","30.00","10500.00","0","");
INSERT INTO product_purchase_details VALUES("4163","P6wBQEdR2yQQaD7","20240203141705","421","250.00","36.00","9000.00","0","");
INSERT INTO product_purchase_details VALUES("4162","xwVEvW9wLD9PgL7","20240203141705","259","3.00","1200.00","3600.00","0","");
INSERT INTO product_purchase_details VALUES("4161","kP25g6yYAqygZwY","20240203141705","260","28.00","850.00","23800.00","0","");
INSERT INTO product_purchase_details VALUES("4160","lboLygsTRHTVkC7","20240203141705","261","22.00","600.00","13200.00","0","");
INSERT INTO product_purchase_details VALUES("4159","w9k1bFw9CQHRjwV","20240203141705","262","26.00","450.00","11700.00","0","");
INSERT INTO product_purchase_details VALUES("4158","qdZoI890mysJ4i1","20240203141705","263","38.00","350.00","13300.00","0","");
INSERT INTO product_purchase_details VALUES("4157","bTMBjjPz9599uP4","20240203141705","264","34.00","80.00","2720.00","0","");
INSERT INTO product_purchase_details VALUES("4156","hpxtOfw9mJB74dn","20240203141705","265","14.00","120.00","1680.00","0","");
INSERT INTO product_purchase_details VALUES("4155","G8joLuqcOAUYLG0","20240203141705","266","13.00","220.00","2860.00","0","");
INSERT INTO product_purchase_details VALUES("4154","BA7kmMP7EeHIN02","20240203141705","267","3.00","360.00","1080.00","0","");
INSERT INTO product_purchase_details VALUES("4153","gadnjWcIzUDJKfZ","20240203141705","268","3.00","2100.00","6300.00","0","");
INSERT INTO product_purchase_details VALUES("4152","h4UPEK4e4u8JBNl","20240203141705","269","118.00","110.00","12980.00","0","");
INSERT INTO product_purchase_details VALUES("4151","PyqJnpaSws54uTn","20240203141705","270","50.00","160.00","8000.00","0","");
INSERT INTO product_purchase_details VALUES("4150","4Mqc8nrbaUMrx6U","20240203141705","271","160.00","120.00","19200.00","0","");
INSERT INTO product_purchase_details VALUES("4149","anAiEMqQUwmVaSj","20240203141705","272","60.00","220.00","13200.00","0","");
INSERT INTO product_purchase_details VALUES("4148","qxxQOf9UVh9wPSW","20240203141705","273","2.00","800.00","1600.00","0","");
INSERT INTO product_purchase_details VALUES("4147","I78M3SXtcs1ZYht","20240203141705","274","21.00","360.00","7560.00","0","");
INSERT INTO product_purchase_details VALUES("4146","ReZCs8EAG7qxSql","20240203141705","275","48.00","100.00","4800.00","0","");
INSERT INTO product_purchase_details VALUES("4145","R9og2xldPXLv0nH","20240203141705","276","112.00","180.00","20160.00","0","");
INSERT INTO product_purchase_details VALUES("4144","eHdwpIm305qkUFX","20240203141705","277","16.00","240.00","3840.00","0","");
INSERT INTO product_purchase_details VALUES("4143","gZjK2W0MxmRbgKq","20240203141705","278","61.00","180.00","10980.00","0","");
INSERT INTO product_purchase_details VALUES("4142","raZ9Ab0cCOAf4KT","20240203141705","279","58.00","260.00","15080.00","0","");
INSERT INTO product_purchase_details VALUES("4141","qITsc0PNN06qnlP","20240203141705","280","31.00","360.00","11160.00","0","");
INSERT INTO product_purchase_details VALUES("4140","gbXrAKzE0sTf9J6","20240203141705","281","570.00","25.00","14250.00","0","");
INSERT INTO product_purchase_details VALUES("4139","s1rPtUO9svd1eVr","20240203141705","282","240.00","32.00","7680.00","0","");
INSERT INTO product_purchase_details VALUES("4138","u9ClE54ZvmyyYH3","20240203141705","283","210.00","30.00","6300.00","0","");
INSERT INTO product_purchase_details VALUES("4137","y9FFglnPy6CxVrL","20240203141705","284","80.00","40.00","3200.00","0","");
INSERT INTO product_purchase_details VALUES("3839","ArrSMQT1CazvhOG","20240203150856","350","5.00","8700.00","43500.00","0","");
INSERT INTO product_purchase_details VALUES("3831","frBdpKvrWmalxuM","20240204162308","346","2.00","4600.00","9200.00","0","");
INSERT INTO product_purchase_details VALUES("3830","5nt0JEiRggBipjc","20240204162308","345","5.00","2900.00","14500.00","0","");
INSERT INTO product_purchase_details VALUES("3838","fWbDTwOdRgcIb2n","20240203150856","310","5.00","8700.00","43500.00","0","");
INSERT INTO product_purchase_details VALUES("3829","ubdkn9UabfeEZpE","20240204162308","305","5.00","2900.00","14500.00","0","");
INSERT INTO product_purchase_details VALUES("3828","2loI767dpsKJonN","20240204162308","344","5.00","2000.00","10000.00","0","");
INSERT INTO product_purchase_details VALUES("3827","cJfqTjXPRTRt1AV","20240204162308","304","5.00","2000.00","10000.00","0","");
INSERT INTO product_purchase_details VALUES("3826","yjqKxbjf8OTueVl","20240204162308","343","5.00","1500.00","7500.00","0","");
INSERT INTO product_purchase_details VALUES("3825","4TEXjHZRBjZDDpx","20240204162308","303","5.00","1500.00","7500.00","0","");
INSERT INTO product_purchase_details VALUES("3824","VTamN0lbpAsqaFU","20240204162308","334","4.00","16689.00","66756.00","0","");
INSERT INTO product_purchase_details VALUES("3823","uVP66IrTqAwUThA","20240204162308","333","6.00","16689.00","100134.00","0","");
INSERT INTO product_purchase_details VALUES("3822","DcwEM8a3LmWtM3w","20240204162308","332","5.00","11671.00","58355.00","0","");
INSERT INTO product_purchase_details VALUES("3821","HKTa8JM4HwBgKSC","20240204162308","331","6.00","11671.00","70026.00","0","");
INSERT INTO product_purchase_details VALUES("3820","dTs2y8C3WM1qiom","20240204162308","330","0.00","8707.00","0.00","0","");
INSERT INTO product_purchase_details VALUES("3819","BAqwl87bAmU0m1G","20240204162308","329","0.00","8707.00","0.00","0","");
INSERT INTO product_purchase_details VALUES("3818","bhINTHXP9dbFmSe","20240204162308","328","0.00","8707.00","0.00","0","");
INSERT INTO product_purchase_details VALUES("3817","ytVyXOo10UYVFKf","20240204162308","327","5.00","8707.00","43535.00","0","");
INSERT INTO product_purchase_details VALUES("3816","9saOkDdIk9u9YDs","20240204162308","300","5.00","8707.00","43535.00","0","");
INSERT INTO product_purchase_details VALUES("3815","rp0kD6AClTqAz9W","20240204162308","326","0.00","4092.00","0.00","0","");
INSERT INTO product_purchase_details VALUES("3814","mTEeoWQeCgr9yim","20240204162308","325","3.00","4092.00","12276.00","0","");
INSERT INTO product_purchase_details VALUES("3813","G3rbsH33DPCdQTO","20240204162308","324","2.00","4092.00","8184.00","0","");
INSERT INTO product_purchase_details VALUES("3812","55fOvSaUBt8aFiY","20240204162308","323","25.00","4092.00","102300.00","0","");
INSERT INTO product_purchase_details VALUES("3811","3GEvroWThMZmjfT","20240204162308","299","30.00","4092.00","122760.00","0","");
INSERT INTO product_purchase_details VALUES("3810","zKJV3Rq9kETvo1r","20240204162308","298","2.00","10761.00","21522.00","0","");
INSERT INTO product_purchase_details VALUES("3809","SVXmBnd8v4bptPx","20240204162308","297","2.00","15761.00","31522.00","0","");
INSERT INTO product_purchase_details VALUES("3808","Bf9WHTmTSu4EHnX","20240204162308","296","10.00","3351.00","33510.00","0","");
INSERT INTO product_purchase_details VALUES("3807","FHSq4bsKdFbHeN5","20240204162308","295","9.00","3936.00","35424.00","0","");
INSERT INTO product_purchase_details VALUES("3806","5eoWDjAw2oz37kv","20240204162308","294","9.00","7121.00","64089.00","0","");
INSERT INTO product_purchase_details VALUES("3805","Lnq80NojIkK1p4B","20240204162308","293","5.00","4391.00","21955.00","0","");
INSERT INTO product_purchase_details VALUES("3804","5F0dG9qKb7ILydM","20240204162308","292","9.00","14986.00","134874.00","0","");
INSERT INTO product_purchase_details VALUES("3803","deRzLKLrjOcS9ny","20240204162308","322","12.00","14986.00","179832.00","0","");
INSERT INTO product_purchase_details VALUES("3802","cY2m7Z2zVMde6Zp","20240204162308","321","5.00","9331.00","46655.00","0","");
INSERT INTO product_purchase_details VALUES("3801","oRROewChkknXY7M","20240204162308","291","5.00","9331.00","46655.00","0","");
INSERT INTO product_purchase_details VALUES("3800","AiGDsqdFd59fmyh","20240204162308","320","0.00","6146.00","0.00","0","");
INSERT INTO product_purchase_details VALUES("3799","uavG9APSbTZVe7O","20240204162308","319","0.00","6146.00","0.00","0","");
INSERT INTO product_purchase_details VALUES("3798","8FhAiviVghAe86O","20240204162308","318","0.00","6146.00","0.00","0","");
INSERT INTO product_purchase_details VALUES("3797","31tea6dqXgU12Tx","20240204162308","317","0.00","6146.00","0.00","0","");
INSERT INTO product_purchase_details VALUES("3796","Rme3pRS2ciu5fYS","20240204162308","316","16.00","6146.00","98336.00","0","");
INSERT INTO product_purchase_details VALUES("3795","utcQB4SXQVseesk","20240204162308","290","16.00","6146.00","98336.00","0","");
INSERT INTO product_purchase_details VALUES("3794","zT3uLZpk36dbcvH","20240204162308","315","0.00","2961.00","0.00","0","");
INSERT INTO product_purchase_details VALUES("3793","kqHkOn6FaXPa00x","20240204162308","314","0.00","2961.00","0.00","0","");
INSERT INTO product_purchase_details VALUES("3792","R7xtpmUOsl0nll3","20240204162308","313","0.00","2961.00","0.00","0","");
INSERT INTO product_purchase_details VALUES("3791","jeWCzdOQakneYbv","20240204162308","311","40.00","2961.00","118440.00","0","");
INSERT INTO product_purchase_details VALUES("3790","zXBRkDE7TVvg2wZ","20240204162308","289","34.00","2961.00","100674.00","0","");
INSERT INTO product_purchase_details VALUES("3789","TifleHFv9qwT8h9","20240204162308","312","0.00","2961.00","0.00","0","");
INSERT INTO product_purchase_details VALUES("3837","AvtfEaD2kqNLwo5","20240203150856","349","5.00","6000.00","30000.00","0","");
INSERT INTO product_purchase_details VALUES("3836","3nVjf18k173S5e9","20240203150856","309","5.00","6000.00","30000.00","0","");
INSERT INTO product_purchase_details VALUES("3835","5IUwvWJ0PC8DTT9","20240203150856","348","5.00","2700.00","13500.00","0","");
INSERT INTO product_purchase_details VALUES("3834","rRHmuweQROhN5on","20240203150856","308","5.00","2700.00","13500.00","0","");
INSERT INTO product_purchase_details VALUES("3833","yoJi7D3B26XAVEy","20240203150856","307","3.00","6000.00","18000.00","0","");
INSERT INTO product_purchase_details VALUES("3832","X82PleoSrqwVsxq","20240203150856","347","2.00","6000.00","12000.00","0","");
INSERT INTO product_purchase_details VALUES("3848","o720og6FhEexGz1","20240205145350","306","3.00","4600.00","13800.00","0","");
INSERT INTO product_purchase_details VALUES("3847","jEg0F1MTjhMggNu","20240205145350","335","15.00","2376.00","35640.00","0","");
INSERT INTO product_purchase_details VALUES("3846","Ik10N68jFPhIisf","20240205145350","336","15.00","2376.00","35640.00","0","");
INSERT INTO product_purchase_details VALUES("3845","ctmtlJ1ShzGHh3M","20240205145350","337","4.00","4911.00","19644.00","0","");
INSERT INTO product_purchase_details VALUES("3844","v58PTaOZoXwIDgH","20240205145350","338","6.00","4911.00","29466.00","0","");
INSERT INTO product_purchase_details VALUES("3843","btfXkTaUS5h5kiv","20240205145350","340","1.00","7381.00","7381.00","0","");
INSERT INTO product_purchase_details VALUES("3842","IXXXyKZr0z6H1I9","20240205145350","339","4.00","7381.00","29524.00","0","");
INSERT INTO product_purchase_details VALUES("3841","KbK7xJt2wfzwyqZ","20240205145350","341","3.00","10891.00","32673.00","0","");
INSERT INTO product_purchase_details VALUES("3840","rwZBbaMIBN2tXrF","20240205145350","342","2.00","10891.00","21782.00","0","");
INSERT INTO product_purchase_details VALUES("3891","ooVg1xZW6LkWkEY","20240205171507","726","6.00","4800.00","28800.00","0","");
INSERT INTO product_purchase_details VALUES("3888","EXtz6iMfc9Ulq8z","20240205154059","603","422.00","250.00","105500.00","0","");
INSERT INTO product_purchase_details VALUES("3887","lOnrvNQdPrzj5E6","20240205154059","351","21.00","2800.00","58800.00","0","");
INSERT INTO product_purchase_details VALUES("3886","YiELYojs0blQ49","20240205154059","352","1.00","2800.00","2800.00","0","");
INSERT INTO product_purchase_details VALUES("3885","evCHMFx9erMtGFa","20240205154059","353","0.00","2800.00","0.00","0","");
INSERT INTO product_purchase_details VALUES("3884","DbL2HgXGd1nbLmK","20240205154059","354","5.00","5800.00","29000.00","0","");
INSERT INTO product_purchase_details VALUES("3883","Em0RoLDsUNsYUF7","20240205154059","355","15.00","5800.00","87000.00","0","");
INSERT INTO product_purchase_details VALUES("3882","rCcgR4KZCwHYRwQ","20240205154059","356","7.00","5800.00","40600.00","0","");
INSERT INTO product_purchase_details VALUES("3881","cy7OmDzQ8sIQkxn","20240205154059","357","1.00","8800.00","8800.00","0","");
INSERT INTO product_purchase_details VALUES("3880","HNhfMIIfZe6nbv3","20240205154059","358","2.00","8800.00","17600.00","0","");
INSERT INTO product_purchase_details VALUES("3879","jioADGNdZxhcBJd","20240205154059","359","1.00","14400.00","14400.00","0","");
INSERT INTO product_purchase_details VALUES("3878","snz4q95ipJO4tlg","20240205154059","360","3.00","14400.00","43200.00","0","");
INSERT INTO product_purchase_details VALUES("3877","UG8P3mTkLjeEbs0","20240205154059","361","1.00","3800.00","3800.00","0","");
INSERT INTO product_purchase_details VALUES("3876","CPiBhJ0Hs8YxeeG","20240205154059","362","1.00","3800.00","3800.00","0","");
INSERT INTO product_purchase_details VALUES("3875","lMOS1mSMSdC44J7","20240205154059","366","200.00","46.00","9200.00","0","");
INSERT INTO product_purchase_details VALUES("3874","Bs7tfTqxhPAzWuO","20240205154059","365","200.00","70.00","14000.00","0","");
INSERT INTO product_purchase_details VALUES("3873","lZyeoD2L0iZXLPn","20240205154059","367","1000.00","30.00","30000.00","0","");
INSERT INTO product_purchase_details VALUES("3872","YBRLauPHsOHhgSC","20240205154059","368","50.00","120.00","6000.00","0","");
INSERT INTO product_purchase_details VALUES("909","wM8cKTRuCBiEPFh","20240205160956","371","1.00","3000.00","3000.00","0","1");
INSERT INTO product_purchase_details VALUES("910","tazkdJbmshHRG28","20240205160956","370","1.00","2000.00","2000.00","0","1");
INSERT INTO product_purchase_details VALUES("911","ajTS7FNvWxrhMM4","20240205160956","369","1.00","7500.00","7500.00","0","1");
INSERT INTO product_purchase_details VALUES("912","cJ1Ns1u1mfpNDmN","20240205160956","372","1.00","4000.00","4000.00","0","1");
INSERT INTO product_purchase_details VALUES("913","YaF2SPSJ1nFvkcI","20240205160956","373","1.00","1500.00","1500.00","0","1");
INSERT INTO product_purchase_details VALUES("914","RwZThXS1COUUqUA","20240205160956","374","4.00","400.00","1600.00","0","1");
INSERT INTO product_purchase_details VALUES("915","7cRPjQjaBl3PF6h","20240205160956","375","1.00","2000.00","2000.00","0","1");
INSERT INTO product_purchase_details VALUES("916","1vS3Ryhdph8XqOw","20240205160956","376","1.00","1500.00","1500.00","0","1");
INSERT INTO product_purchase_details VALUES("917","S2VS5jCZjkGGZLr","20240205160956","377","6.00","300.00","1800.00","0","1");
INSERT INTO product_purchase_details VALUES("918","w8k2gFrAvJUFDA0","20240205160956","378","4.00","200.00","800.00","0","1");
INSERT INTO product_purchase_details VALUES("919","lmKB1zxe6a5UFln","20240205160956","379","2.00","300.00","600.00","0","1");
INSERT INTO product_purchase_details VALUES("920","wEzXUnVsSGh9FMi","20240205160956","380","2.00","300.00","600.00","0","1");
INSERT INTO product_purchase_details VALUES("921","s11ZZpglzNziwMj","20240205160956","381","4.00","400.00","1600.00","0","1");
INSERT INTO product_purchase_details VALUES("922","cGYW1diAOKHyTa","20240205160956","382","4.00","550.00","2200.00","0","1");
INSERT INTO product_purchase_details VALUES("923","Yy0YmbUFQnG571M","20240205160956","383","2.00","350.00","700.00","0","1");
INSERT INTO product_purchase_details VALUES("3890","k1PDLoZ9BnNRMXo","20240205171507","363","100.00","320.00","32000.00","0","");
INSERT INTO product_purchase_details VALUES("2384","xBEEe07j6CwXvYB","20240210151559","398","24.00","486.00","11664.00","0","");
INSERT INTO product_purchase_details VALUES("2383","Tiv5O5ECoXpvRo1","20240210151559","402","16.00","250.00","4000.00","0","");
INSERT INTO product_purchase_details VALUES("2382","t326kr2DLuoNjRL","20240210151559","401","8.00","475.00","3800.00","0","");
INSERT INTO product_purchase_details VALUES("2381","osGZPfP3c9bzyHB","20240210151559","397","10.00","50.00","500.00","0","");
INSERT INTO product_purchase_details VALUES("2380","xaoYlFq5ZXmUdiX","20240210151559","396","30.00","40.00","1200.00","0","");
INSERT INTO product_purchase_details VALUES("2379","Njw7w200DQmDgfA","20240210151559","395","24.00","50.00","1200.00","0","");
INSERT INTO product_purchase_details VALUES("2378","SN3of0NVqtME19K","20240210151559","392","1.00","280.00","280.00","0","");
INSERT INTO product_purchase_details VALUES("2377","LVOTrdZJO5hHL0n","20240210151559","391","32.00","270.00","8640.00","0","");
INSERT INTO product_purchase_details VALUES("2376","JrYsCFA8LTm0Pu2","20240210151559","390","22.00","560.00","12320.00","0","");
INSERT INTO product_purchase_details VALUES("2375","AVHFOvGc1H5N4VJ","20240210151559","389","6.00","336.00","2016.00","0","");
INSERT INTO product_purchase_details VALUES("2374","bN2gzLcAnKjGOp","20240210151559","399","37.00","287.00","10619.00","0","");
INSERT INTO product_purchase_details VALUES("2373","NSG4VbaxM6mxQan","20240210151559","385","1.00","2750.00","2750.00","0","");
INSERT INTO product_purchase_details VALUES("2372","RvIwuaXoEVyHVv9","20240210151559","386","14.00","300.00","4200.00","0","");
INSERT INTO product_purchase_details VALUES("2371","s26eJpgQOSnxcvv","20240210151559","387","27.00","486.00","13122.00","0","");
INSERT INTO product_purchase_details VALUES("2389","3AfMUtmcRbLnuWW","20240210154644","400","5.00","226.00","1130.00","0","");
INSERT INTO product_purchase_details VALUES("2388","NVTyJ26ZuUpDPVJ","20240210154644","394","12.00","300.00","3600.00","0","");
INSERT INTO product_purchase_details VALUES("2387","1eIe8Fd545sdZSD","20240210154644","393","1.00","560.00","560.00","0","");
INSERT INTO product_purchase_details VALUES("2370","IeRcsS52uoGEfE1","20240210161624","409","30.00","820.00","24600.00","0","");
INSERT INTO product_purchase_details VALUES("2369","ipQ70mds0f6CkDC","20240210161624","408","10.00","100.00","1000.00","0","");
INSERT INTO product_purchase_details VALUES("2368","o3I07LVCSCDXzDl","20240210161624","403","1.00","450.00","450.00","0","");
INSERT INTO product_purchase_details VALUES("2386","6G3ksEaRnwFjlNK","20240210154644","406","2.00","336.00","672.00","0","");
INSERT INTO product_purchase_details VALUES("2385","8XRSseaKBeTKGhD","20240210154644","407","5.00","330.00","1650.00","0","");
INSERT INTO product_purchase_details VALUES("2367","vVBQ8WxHaXD2zh5","20240210161624","404","50.00","125.00","6250.00","0","");
INSERT INTO product_purchase_details VALUES("2366","GCbQnyCKaWL7Mx4","20240210161624","405","7.00","850.00","5950.00","0","");
INSERT INTO product_purchase_details VALUES("4188","YxHx9S6ZcWpoDOb","20240128113240","71","30.00","2250.00","67500.00","0","");
INSERT INTO product_purchase_details VALUES("4187","HxFSVuwCuHWTp0N","20240128113240","72","25.00","2250.00","56250.00","0","");
INSERT INTO product_purchase_details VALUES("4186","2xmFlfQUAY9riWM","20240128113240","73","5.00","2250.00","11250.00","0","");
INSERT INTO product_purchase_details VALUES("4185","oqF2tgk1CH3oqdA","20240128113240","74","3.00","6500.00","19500.00","0","");
INSERT INTO product_purchase_details VALUES("4184","qQeYPHNVufJnS70","20240128113240","75","1.00","6500.00","6500.00","0","");
INSERT INTO product_purchase_details VALUES("4183","DMlwzukkL1lxGZp","20240128113240","76","1.00","9100.00","9100.00","0","");
INSERT INTO product_purchase_details VALUES("4182","WRT6Vfq7K72mfr3","20240128113240","77","1.00","9100.00","9100.00","0","");
INSERT INTO product_purchase_details VALUES("4181","tsrKVct8gPIqcSU","20240128113240","410","50.00","1650.00","82500.00","0","");
INSERT INTO product_purchase_details VALUES("4180","gc5kdZ77hKM9LKw","20240128113240","411","25.00","3300.00","82500.00","0","");
INSERT INTO product_purchase_details VALUES("1270","hvCKTVOs7SgLRBd","20240129154322","419","20.00","6731.00","134620.00","0","");
INSERT INTO product_purchase_details VALUES("1271","HapV8xiDpn2aLQs","20240129154322","420","20.00","3936.00","78720.00","0","");
INSERT INTO product_purchase_details VALUES("4136","UQnXgsysj4751","20240203141705","285","85.00","240.00","20400.00","0","");
INSERT INTO product_purchase_details VALUES("4135","U6aheRdhR3DwTmq","20240203141705","286","10.00","180.00","1800.00","0","");
INSERT INTO product_purchase_details VALUES("3405","uN4o7LcxAXhb65m","20240218112422","648","30.00","300.00","9000.00","0","");
INSERT INTO product_purchase_details VALUES("3849","7PmnwfbVoM7kUoJ","20240205145350","602","23.00","1500.00","34500.00","0","");
INSERT INTO product_purchase_details VALUES("4273","5yHMM7u91M3GZyP","20240219094915","625","30.00","41.00","1230.00","0","");
INSERT INTO product_purchase_details VALUES("4272","20PMfEGPsMIHuDH","20240219094915","632","2.00","1480.00","2960.00","0","");
INSERT INTO product_purchase_details VALUES("4271","girnIcznLSfqlDy","20240219094915","633","2.00","2200.00","4400.00","0","");
INSERT INTO product_purchase_details VALUES("4270","WWWom0ibBwWDSAu","20240219094915","628","3.00","900.00","2700.00","0","");
INSERT INTO product_purchase_details VALUES("4269","NSDTwxuPpvc2cfx","20240219094915","627","10.00","900.00","9000.00","0","");
INSERT INTO product_purchase_details VALUES("4268","AZSkqje9TiBi6of","20240219094915","629","4.00","700.00","2800.00","0","");
INSERT INTO product_purchase_details VALUES("4267","aXNFC3rtaCiX6vd","20240219094915","630","2.00","1250.00","2500.00","0","");
INSERT INTO product_purchase_details VALUES("4266","SY4nqbrwyLLKSaa","20240219094915","631","3.00","1800.00","5400.00","0","");
INSERT INTO product_purchase_details VALUES("4265","w2qiqOK6MDiKqgU","20240219094915","615","1.00","4800.00","4800.00","0","");
INSERT INTO product_purchase_details VALUES("4264","8Au64cWUUNQ24mS","20240219094915","637","1.00","2000.00","2000.00","0","");
INSERT INTO product_purchase_details VALUES("4263","RvLK8XJJQMqpjV2","20240219094915","611","10.00","300.00","3000.00","0","");
INSERT INTO product_purchase_details VALUES("4262","DhFKA4QN6anrnyN","20240219094915","614","1.00","200.00","200.00","0","");
INSERT INTO product_purchase_details VALUES("4261","XqHM4ofYJTcuUaQ","20240219094915","612","1.00","300.00","300.00","0","");
INSERT INTO product_purchase_details VALUES("4260","JfyadQQN14gjW0m","20240219094915","613","1.00","1450.00","1450.00","0","");
INSERT INTO product_purchase_details VALUES("4259","A0sww4TOxTRg0jS","20240219094915","609","2.00","800.00","1600.00","0","");
INSERT INTO product_purchase_details VALUES("4257","cnzwjUCgFbsnf6M","20240219094915","610","1.00","1025.00","1025.00","0","");
INSERT INTO product_purchase_details VALUES("4258","dySPqO2KACHgTPf","20240219094915","608","10.00","418.00","4180.00","0","");
INSERT INTO product_purchase_details VALUES("4179","6x2F16oCm2WfHiN","20240213163024","501","5.00","240.00","1200.00","0","");
INSERT INTO product_purchase_details VALUES("4178","1xWoOqtqQM8fhzu","20240213163024","499","1.00","152.00","152.00","0","");
INSERT INTO product_purchase_details VALUES("4177","vFosyHGWQKssJjG","20240213163024","452 ","4.00","292.00","1168.00","0","");
INSERT INTO product_purchase_details VALUES("4176","572Amx2YQJ9A0c8","20240213163024","450","6.00","150.00","900.00","0","");
INSERT INTO product_purchase_details VALUES("4256","eHiRyaIFg2kPekj","20240219094915","480 ","10.00","500.00","5000.00","0","");
INSERT INTO product_purchase_details VALUES("4255","54Qhv2dodmcu6sK","20240219094915","617","1.00","600.00","600.00","0","");
INSERT INTO product_purchase_details VALUES("3543","mtlOOqMoj8BpFmS","20240213150708","574","1.00","14500.00","14500.00","0","");
INSERT INTO product_purchase_details VALUES("3542","cs0xvi6pZanmpak","20240213150708","453","7.00","250.00","1750.00","0","");
INSERT INTO product_purchase_details VALUES("3541","toVUaMYq8BTaXVu","20240213150708","446","6.00","1450.00","8700.00","0","");
INSERT INTO product_purchase_details VALUES("3540","KnV9rvIqbjpN9Eh","20240213150708","444","1.00","150.00","150.00","0","");
INSERT INTO product_purchase_details VALUES("3539","ijmwcOAK0gly12y","20240213150708","445","1.00","150.00","150.00","0","");
INSERT INTO product_purchase_details VALUES("3538","BG7us6yRWGzYgED","20240213150708","442","10.00","120.00","1200.00","0","");
INSERT INTO product_purchase_details VALUES("3537","CEPDqZNkbU6CGg5","20240213150708","424","4.00","900.00","3600.00","0","");
INSERT INTO product_purchase_details VALUES("3536","pZ6RjFTkSF1reKd","20240213150708","443","1.00","300.00","300.00","0","");
INSERT INTO product_purchase_details VALUES("3535","aUdIAPT8A4QzrUW","20240213150708","426","1.00","8000.00","8000.00","0","");
INSERT INTO product_purchase_details VALUES("3534","f7u7EOyV9nPYXJQ","20240213150708","423","1.00","4100.00","4100.00","0","");
INSERT INTO product_purchase_details VALUES("3533","2cNffel1HGR5OyH","20240213150708","441","2.00","300.00","600.00","0","");
INSERT INTO product_purchase_details VALUES("3532","KHIv4v2V241sPhl","20240213150708","425","1.00","1600.00","1600.00","0","");
INSERT INTO product_purchase_details VALUES("3531","v1pwLEHd0idhEyQ","20240213150708","427","1.00","1200.00","1200.00","0","");
INSERT INTO product_purchase_details VALUES("3530","bXW8C0pVRNkVZDT","20240213150708","428","1.00","5500.00","5500.00","0","");
INSERT INTO product_purchase_details VALUES("3529","514dbW9O5s3YSj0","20240213150708","430","2.00","150.00","300.00","0","");
INSERT INTO product_purchase_details VALUES("3528","WQMypQV38OV6To6","20240213150708","429","1.00","2000.00","2000.00","0","");
INSERT INTO product_purchase_details VALUES("3527","DUmsrLwVDp87U6m","20240213150708","431","2.00","150.00","300.00","0","");
INSERT INTO product_purchase_details VALUES("3526","JdztagBVwbL6MEf","20240213150708","432","1.00","4000.00","4000.00","0","");
INSERT INTO product_purchase_details VALUES("3525","3LvmzBngtXwpnrn","20240213150708","433","1.00","1050.00","1050.00","0","");
INSERT INTO product_purchase_details VALUES("3524","eQZqPQ7N7SmexKQ","20240213150708","434","1.00","6500.00","6500.00","0","");
INSERT INTO product_purchase_details VALUES("3522","eKCWiNmPdzcMniN","20240213150708","436","1.00","1500.00","1500.00","0","");
INSERT INTO product_purchase_details VALUES("4134","DR1kYj55CwnHIhA","20240203141705","287","12.00","280.00","3360.00","0","");
INSERT INTO product_purchase_details VALUES("4133","2HBMSc5KSt4DTwp","20240203141705","288","18.00","70.00","1260.00","0","");
INSERT INTO product_purchase_details VALUES("1670","ok0yx1wUtvyTNK6","20240124145800","491","50.00","190.00","9500.00","0","");
INSERT INTO product_purchase_details VALUES("1671","Ykjprijd5pMlP0I","20240124145800","490","200.00","90.00","18000.00","0","");
INSERT INTO product_purchase_details VALUES("1704","PjK7Ozdgi8HZww9","20240128122919","492","52.00","235.00","12220.00","0","");
INSERT INTO product_purchase_details VALUES("1705","WsNF9QjEHJiZP3D","20240128122919","493","7.00","1800.00","12600.00","0","");
INSERT INTO product_purchase_details VALUES("1706","IM5CMdTtrUxaTcH","20240128122919","494","35.00","290.00","10150.00","0","");
INSERT INTO product_purchase_details VALUES("1707","TgTuZnpDTvJTBjQ","20240128122919","495","24.00","650.00","15600.00","0","");
INSERT INTO product_purchase_details VALUES("1708","lSVN8CEKkZltzH0","20240128122919","496","240.00","38.00","9120.00","0","");
INSERT INTO product_purchase_details VALUES("4175","zZBiMIYjZdbQWQg","20240213163024","451","6.00","70.00","420.00","0","");
INSERT INTO product_purchase_details VALUES("4174","bRTRvaHJ9JxA1FM","20240213163024","449","12.00","90.00","1080.00","0","");
INSERT INTO product_purchase_details VALUES("4172","J3LektOIiZAbfyx","20240213163024","448","12.00","120.00","1440.00","0","");
INSERT INTO product_purchase_details VALUES("4173","7LKN8bpvbOV7jkQ","20240213163024","497","12.00","160.00","1920.00","0","");
INSERT INTO product_purchase_details VALUES("4171","BBLPVgE24oGeVAE","20240213163024","498","10.00","250.00","2500.00","0","");
INSERT INTO product_purchase_details VALUES("2775","8tbWVXox6Qlkf8Z","20240214120913","502","3.00","10000.00","30000.00","0","");
INSERT INTO product_purchase_details VALUES("2774","PjfH2EZL92CSXj7","20240214120913","503","1.00","12000.00","12000.00","0","");
INSERT INTO product_purchase_details VALUES("2773","ibzAigvm0wPYCAQ","20240214120913","504","100.00","60.00","6000.00","0","");
INSERT INTO product_purchase_details VALUES("2772","Q45eXpFSFGWlPPf","20240214120913","505","4.00","11000.00","44000.00","0","");
INSERT INTO product_purchase_details VALUES("2771","WaKL9SAUhW9GjrN","20240214120913","506","24.00","1320.00","31680.00","0","");
INSERT INTO product_purchase_details VALUES("2770","SI1IEm61JBYMVir","20240214120913","507","400.00","3.00","1200.00","0","");
INSERT INTO product_purchase_details VALUES("2584","dCJMh0hIjxUAB68","20240214131722","588","2.00","240.00","480.00","0","");
INSERT INTO product_purchase_details VALUES("2583","87GwWiYksq3g6Qm","20240214131722","587","2.00","250.00","500.00","0","");
INSERT INTO product_purchase_details VALUES("2582","3sysvMcknme1P2L","20240214131722","586","2.00","120.00","240.00","0","");
INSERT INTO product_purchase_details VALUES("2581","LEp3TEDRFUNy1By","20240214131722","585","1.00","2200.00","2200.00","0","");
INSERT INTO product_purchase_details VALUES("2580","27QjxIpSUWOt1bB","20240214131722","556","2.00","3100.00","6200.00","0","");
INSERT INTO product_purchase_details VALUES("2579","ElKRj1cVsWM2auE","20240214131722","563","1.00","380.00","380.00","0","");
INSERT INTO product_purchase_details VALUES("2578","9CszjfNKZ9oeG4i","20240214131722","508","42.00","310.00","13020.00","0","");
INSERT INTO product_purchase_details VALUES("2577","gaXeasqb84DCfWi","20240214131722","509","1.00","4600.00","4600.00","0","");
INSERT INTO product_purchase_details VALUES("2576","k6DmBPcd6P05obu","20240214131722","510","6.00","33.00","198.00","0","");
INSERT INTO product_purchase_details VALUES("2575","cHCPEnpFgjee2Xc","20240214131722","511","2.00","8700.00","17400.00","0","");
INSERT INTO product_purchase_details VALUES("2574","Lo50ESaBBx9tNf","20240214131722","512","10.00","80.00","800.00","0","");
INSERT INTO product_purchase_details VALUES("2573","T2wBN5FNCQ9S8xl","20240214131722","513","12.00","140.00","1680.00","0","");
INSERT INTO product_purchase_details VALUES("2572","EJMoD92RiP5tPOV","20240214131722","514","11.00","50.00","550.00","0","");
INSERT INTO product_purchase_details VALUES("2571","1IriKO0r9cNZERW","20240214131722","515","5.00","75.00","375.00","0","");
INSERT INTO product_purchase_details VALUES("2570","wp0yiBAV0AIiVyu","20240214131722","516","2.00","30.00","60.00","0","");
INSERT INTO product_purchase_details VALUES("2569","Pxidq4Co14e7cNS","20240214131722","517","1.00","12.00","12.00","0","");
INSERT INTO product_purchase_details VALUES("2568","eDVX9GQV6PkEHVC","20240214131722","518","2.00","600.00","1200.00","0","");
INSERT INTO product_purchase_details VALUES("2566","ECP2jdvjitBjIrK","20240214131722","520","4.00","120.00","480.00","0","");
INSERT INTO product_purchase_details VALUES("2567","KdK5QAqXcU7t5m2","20240214131722","519","1.00","900.00","900.00","0","");
INSERT INTO product_purchase_details VALUES("2565","qdEZOYiizieP68o","20240214131722","521","4.00","120.00","480.00","0","");
INSERT INTO product_purchase_details VALUES("2564","uUMnwJtrv2dcUAp","20240214131722","525","1.00","1150.00","1150.00","0","");
INSERT INTO product_purchase_details VALUES("2563","GEhEUFIsLQDu3R2","20240214131722","523","2.00","10.00","20.00","0","");
INSERT INTO product_purchase_details VALUES("2562","yIvjmCz9X5ilCLE","20240214131722","528","2.00","550.00","1100.00","0","");
INSERT INTO product_purchase_details VALUES("2561","Rm6BpjecnhFpcAF","20240214131722","522","60.00","50.00","3000.00","0","");
INSERT INTO product_purchase_details VALUES("2560","pJqFQnfFgXGtRpE","20240214131722","524","1.00","700.00","700.00","0","");
INSERT INTO product_purchase_details VALUES("2559","dGMZ77EI6AMOrPT","20240214131722","527","2.00","660.00","1320.00","0","");
INSERT INTO product_purchase_details VALUES("2558","Gbaj1eneo7sglBk","20240214131722","529","3.00","850.00","2550.00","0","");
INSERT INTO product_purchase_details VALUES("2557","rQzpzBiUMHy0nea","20240214131722","526","1.00","1445.00","1445.00","0","");
INSERT INTO product_purchase_details VALUES("2556","XDH5GDv6F75e7tq","20240214131722","531 ","1.00","700.00","700.00","0","");
INSERT INTO product_purchase_details VALUES("2555","sacLlS5KMmtSlYa","20240214131722","534","4.00","130.00","520.00","0","");
INSERT INTO product_purchase_details VALUES("2554","tk3g6JTJ9TG2wod","20240214131722","530","1.00","850.00","850.00","0","");
INSERT INTO product_purchase_details VALUES("2553","CpXh73K91doBluN","20240214131722","533","1.00","480.00","480.00","0","");
INSERT INTO product_purchase_details VALUES("2552","iAkEpc7wc3Ce6pD","20240214131722","532","1.00","1600.00","1600.00","0","");
INSERT INTO product_purchase_details VALUES("2551","mvUH2wLEalf0CFn","20240214131722","536","2.00","180.00","360.00","0","");
INSERT INTO product_purchase_details VALUES("2550","lICZ9SCk1x6IsYp","20240214131722","535","2.00","130.00","260.00","0","");
INSERT INTO product_purchase_details VALUES("2549","X7bF6x4igyo8yyL","20240214131722","537","11.00","160.00","1760.00","0","");
INSERT INTO product_purchase_details VALUES("2548","bVjGVJkoFJWpbBe","20240214131722","538","6.00","160.00","960.00","0","");
INSERT INTO product_purchase_details VALUES("2547","rwNO4nEm0ut66cv","20240214131722","539","1.00","90.00","90.00","0","");
INSERT INTO product_purchase_details VALUES("2546","2LVhitshAcy2N22","20240214131722","540","84.00","15.00","1260.00","0","");
INSERT INTO product_purchase_details VALUES("2545","8UqE9nh1yK2n8zi","20240214131722","541 ","8.00","650.00","5200.00","0","");
INSERT INTO product_purchase_details VALUES("2544","Oc7BfhcC9J5bdOS","20240214131722","543","4.00","30.00","120.00","0","");
INSERT INTO product_purchase_details VALUES("2543","NZXW0OdzxSjP3Kw","20240214131722","544","2.00","450.00","900.00","0","");
INSERT INTO product_purchase_details VALUES("2542","dgbNOgfmNjOmnAd","20240214131722","545","2.00","250.00","500.00","0","");
INSERT INTO product_purchase_details VALUES("2541","2DnvgRHM2nC7Joo","20240214131722","546","4.00","35.00","140.00","0","");
INSERT INTO product_purchase_details VALUES("2540","BnJUCp1Nw1kiHXH","20240214131722","547","1.00","3100.00","3100.00","0","");
INSERT INTO product_purchase_details VALUES("2539","5QS2yx5XQLRcb1","20240214131722","548","2.00","3500.00","7000.00","0","");
INSERT INTO product_purchase_details VALUES("2538","SRTRmh6JMx7wDwf","20240214131722","549","1.00","1700.00","1700.00","0","");
INSERT INTO product_purchase_details VALUES("2537","84XrCSvCmXP8Ryz","20240214131722","550","7.00","200.00","1400.00","0","");
INSERT INTO product_purchase_details VALUES("2536","8hmRS0pFKO4BuUK","20240214131722","551","5.00","140.00","700.00","0","");
INSERT INTO product_purchase_details VALUES("3523","jdy5I4jDoXfClI6","20240213150708","435","1.00","150.00","150.00","0","");
INSERT INTO product_purchase_details VALUES("3520","OtIr5nAXRO0TjEQ","20240213150708","437","1.00","200.00","200.00","0","");
INSERT INTO product_purchase_details VALUES("4170","KXaZiiVngsvAr2J","20240213163024","500","1.00","650.00","650.00","0","");
INSERT INTO product_purchase_details VALUES("2535","5JWbkaJFVZRTZQt","20240214131722","552","1.00","1800.00","1800.00","0","");
INSERT INTO product_purchase_details VALUES("2534","pRlZMdc485X7vHK","20240214131722","530","2.00","850.00","1700.00","0","");
INSERT INTO product_purchase_details VALUES("2533","IUdkwEmbVokACz1","20240214131722","554","5.00","500.00","2500.00","0","");
INSERT INTO product_purchase_details VALUES("2532","2H1awMcDj9hEmls","20240214131722","555","2.00","1550.00","3100.00","0","");
INSERT INTO product_purchase_details VALUES("2452","qVSjfpLat6YGpu3","20240217152346","568","12.00","200.00","2400.00","0","");
INSERT INTO product_purchase_details VALUES("2451","69iM63tv04Unq0j","20240217152346","567","300.00","1250.00","375000.00","0","");
INSERT INTO product_purchase_details VALUES("2450","qvwZLSaB1ZKfdYW","20240217152346","566","10.00","2500.00","25000.00","0","");
INSERT INTO product_purchase_details VALUES("2449","THEN2eO4nAbwLaY","20240217152346","565","10.00","2500.00","25000.00","0","");
INSERT INTO product_purchase_details VALUES("2448","6S6mjJO4GOs0rb9","20240217152346","564","50.00","290.00","14500.00","0","");
INSERT INTO product_purchase_details VALUES("2455","Wn8qvxyzC7TeU8y","20240217153045","570","50.00","600.00","30000.00","0","");
INSERT INTO product_purchase_details VALUES("2456","yYzcAjf9AQOaQYy","20240217153659","571","4.00","39500.00","158000.00","0","");
INSERT INTO product_purchase_details VALUES("2454","B7OLTIdfHCwpVTa","20240217154738","573","20.00","100.00","2000.00","0","");
INSERT INTO product_purchase_details VALUES("2453","w9rmMxnKDgRnBmZ","20240217154738","572","35.00","250.00","8750.00","0","");
INSERT INTO product_purchase_details VALUES("3521","GvytV3ld2dgWHiq","20240213150708","438","2.00","300.00","600.00","0","");
INSERT INTO product_purchase_details VALUES("3519","osV5VOsqvvIvnB","20240213150708","439","2.00","250.00","500.00","0","");
INSERT INTO product_purchase_details VALUES("3518","G2a69PLWgs1Nsig","20240213150708","454","5.00","370.00","1850.00","0","");
INSERT INTO product_purchase_details VALUES("3517","X1ENVbfXoXuYPhy","20240213150708","440","1.00","450.00","450.00","0","");
INSERT INTO product_purchase_details VALUES("2447","C3trKPvJzdNbguM","20240217164057","575","36.00","3500.00","126000.00","0","");
INSERT INTO product_purchase_details VALUES("2784","DKJ9p5bnKu7pYjg","20240218074400","576","1.00","15500.00","15500.00","0","");
INSERT INTO product_purchase_details VALUES("4098","fLv5kQgonq8JJpS","20240218081020","577","5.00","1250.00","6250.00","0","");
INSERT INTO product_purchase_details VALUES("4097","yt5KvnMXvR6lIfR","20240218081020","578","5.00","2000.00","10000.00","0","");
INSERT INTO product_purchase_details VALUES("4096","oD7nI0GYOg5Mv40","20240218081020","579","5.00","2200.00","11000.00","0","");
INSERT INTO product_purchase_details VALUES("4095","xE5TFDF77ak5Gt1","20240218081020","580","2.00","5500.00","11000.00","0","");
INSERT INTO product_purchase_details VALUES("4094","70rz1qoSYcyA0qn","20240218081020","581","4.00","1000.00","4000.00","0","");
INSERT INTO product_purchase_details VALUES("4093","ig9itQzjAKh9sMp","20240218081020","582","3.00","1500.00","4500.00","0","");
INSERT INTO product_purchase_details VALUES("4092","jAg0xfkfhjNu51o","20240218081020","583","3.00","2300.00","6900.00","0","");
INSERT INTO product_purchase_details VALUES("4091","FEo72keUWcwDBf0","20240218081020","584","3.00","2600.00","7800.00","0","");
INSERT INTO product_purchase_details VALUES("2531","MVWxGkPWNjLWUqR","20240214131722","557","3.00","230.00","690.00","0","");
INSERT INTO product_purchase_details VALUES("2530","CKwiGRv81IAhkGI","20240214131722","558","2.00","800.00","1600.00","0","");
INSERT INTO product_purchase_details VALUES("2529","wSjVDdCQEOdsvso","20240214131722","559","2.00","50.00","100.00","0","");
INSERT INTO product_purchase_details VALUES("2528","lsIaRPNbskvj3Oh","20240214131722","561","1.00","2150.00","2150.00","0","");
INSERT INTO product_purchase_details VALUES("2527","eA8tVg43psz89SV","20240214131722","562","1.00","700.00","700.00","0","");
INSERT INTO product_purchase_details VALUES("2585","vzz3cunaDxp2lKW","20240214131722","589","1.00","1650.00","1650.00","0","");
INSERT INTO product_purchase_details VALUES("2586","pxqB2JWLWkH19Hi","20240214131722","590","2.00","1250.00","2500.00","0","");
INSERT INTO product_purchase_details VALUES("2587","73cZiZ5GoSXOCxA","20240214131722","591 ","6.00","350.00","2100.00","0","");
INSERT INTO product_purchase_details VALUES("2624","sHLTFanLbFBBItQ","20240201145453","220","51.00","180.00","9180.00","0","");
INSERT INTO product_purchase_details VALUES("2623","uuJqG9807LcS0EH","20240201145453","219","13.00","380.00","4940.00","0","");
INSERT INTO product_purchase_details VALUES("2622","2qMYUboK4BjdJjl","20240201145453","218","6.00","170.00","1020.00","0","");
INSERT INTO product_purchase_details VALUES("2621","oOcRaekP4zBvywY","20240201145453","217","6.00","180.00","1080.00","0","");
INSERT INTO product_purchase_details VALUES("2620","vfLAgdIncpcmhGi","20240201145453","216","2.00","1600.00","3200.00","0","");
INSERT INTO product_purchase_details VALUES("2619","zysI5ftNZeBr1lc","20240201145453","215","12.00","150.00","1800.00","0","");
INSERT INTO product_purchase_details VALUES("2618","hwmqZUdxAUFCDAH","20240201145453","214","2.00","480.00","960.00","0","");
INSERT INTO product_purchase_details VALUES("2617","9fXrvvW3J2b8xtN","20240201145453","213","14.00","170.00","2380.00","0","");
INSERT INTO product_purchase_details VALUES("2646","BKW4k96Nc7tHXM","20240201145453","600","10.00","400.00","4000.00","0","");
INSERT INTO product_purchase_details VALUES("2647","fcZqtpans2r7RmR","20240201145453","601","1.00","230.00","230.00","0","");
INSERT INTO product_purchase_details VALUES("3122","MKtGgsV49QK6ZOn","20240124154656","21","200.00","130.00","26000.00","0","");
INSERT INTO product_purchase_details VALUES("3516","LPkvsChCtMBseVl","20240213150708","447","4.00","850.00","3400.00","0","");
INSERT INTO product_purchase_details VALUES("3515","m36SRHvQiE5003B","20240213150708","455","7.00","230.00","1610.00","0","");
INSERT INTO product_purchase_details VALUES("3514","I1VcOoamIlytag4","20240213150708","457","1.00","450.00","450.00","0","");
INSERT INTO product_purchase_details VALUES("3512","lwc1hEJHZSTXYIR","20240213150708","458","2.00","60.00","120.00","0","");
INSERT INTO product_purchase_details VALUES("3513","JlEqtD69p0PTEn8","20240213150708","456","1.00","410.00","410.00","0","");
INSERT INTO product_purchase_details VALUES("3511","jLBFeS7ZoozNCmR","20240213150708","460","1.00","1000.00","1000.00","0","");
INSERT INTO product_purchase_details VALUES("3510","X1IBN2dtWpZSc5O","20240213150708","462","1.00","8650.00","8650.00","0","");
INSERT INTO product_purchase_details VALUES("3509","5we2TaZe9yKBEk9","20240213150708","459","1.00","1100.00","1100.00","0","");
INSERT INTO product_purchase_details VALUES("3508","FlhqJXixfn8bu0i","20240213150708","463","2.00","420.00","840.00","0","");
INSERT INTO product_purchase_details VALUES("3507","giTkczjPSR4Z9gO","20240213150708","461","6.00","1500.00","9000.00","0","");
INSERT INTO product_purchase_details VALUES("3506","TPWNIDojFfAyfeL","20240213150708","464","4.00","500.00","2000.00","0","");
INSERT INTO product_purchase_details VALUES("3505","S6YU3arMorLTWF9","20240213150708","465","1.00","1100.00","1100.00","0","");
INSERT INTO product_purchase_details VALUES("3504","aR9tecHXGok4fki","20240213150708","468","12.00","225.00","2700.00","0","");
INSERT INTO product_purchase_details VALUES("3503","7YQ48RKJ5cEEFDH","20240213150708","466","1.00","350.00","350.00","0","");
INSERT INTO product_purchase_details VALUES("3502","kGLDnxKB5EVYvSt","20240213150708","471 ","1.00","1180.00","1180.00","0","");
INSERT INTO product_purchase_details VALUES("3501","J3Bleuc2ZL45KFi","20240213150708","467","12.00","335.00","4020.00","0","");
INSERT INTO product_purchase_details VALUES("3500","GRe0omXpAdfCPq3","20240213150708","469","14.00","1050.00","14700.00","0","");
INSERT INTO product_purchase_details VALUES("3499","Dq7W0er6Vx0y1bF","20240213150708","470 ","12.00","60.00","720.00","0","");
INSERT INTO product_purchase_details VALUES("3498","V9mddSgeu3njD8x","20240213150708","474","1.00","100.00","100.00","0","");
INSERT INTO product_purchase_details VALUES("3497","oo9DEvNMWmG6OgR","20240213150708","472 ","6.00","150.00","900.00","0","");
INSERT INTO product_purchase_details VALUES("3496","eVjKgjqijuRSUFi","20240213150708","473","1.00","350.00","350.00","0","");
INSERT INTO product_purchase_details VALUES("3495","lohpxhY60vyV1S9","20240213150708","475","500.00","24.00","12000.00","0","");
INSERT INTO product_purchase_details VALUES("3494","VGd0LbCU5ZeiSQq","20240213150708","476","5.00","90.00","450.00","0","");
INSERT INTO product_purchase_details VALUES("3493","2QOPY96wYBasdtI","20240213150708","480 ","5.00","200.00","1000.00","0","");
INSERT INTO product_purchase_details VALUES("3492","lsFFiPHkxbvGssT","20240213150708","479","4.00","1100.00","4400.00","0","");
INSERT INTO product_purchase_details VALUES("3491","GMiZ9aoDdype6yZ","20240213150708","481","1.00","390.00","390.00","0","");
INSERT INTO product_purchase_details VALUES("3490","hFhsqdVstzY5VBY","20240213150708","482","1.00","1250.00","1250.00","0","");
INSERT INTO product_purchase_details VALUES("3489","GZ5xLoN5jVe37n6","20240213150708","484","4.00","275.00","1100.00","0","");
INSERT INTO product_purchase_details VALUES("3488","sxHuO6r5RNsPhyO","20240213150708","483","2.00","100.00","200.00","0","");
INSERT INTO product_purchase_details VALUES("3404","neXqoVmxbMjD2jd","20240218112422","647","2.00","270.00","540.00","0","");
INSERT INTO product_purchase_details VALUES("3403","1MeayERFvuEgKQI","20240218112422","646","10.00","145.00","1450.00","0","");
INSERT INTO product_purchase_details VALUES("3402","F043DMZ96MyC1sV","20240218112422","645","1.00","350.00","350.00","0","");
INSERT INTO product_purchase_details VALUES("3401","wY4KwXy7fMYSK1V","20240218112422","554","1.00","500.00","500.00","0","");
INSERT INTO product_purchase_details VALUES("3400","qBGQKfek8uZ4O43","20240218112422","643","10.00","1450.00","14500.00","0","");
INSERT INTO product_purchase_details VALUES("3399","nmHRy6xVzNx70Gn","20240218112422","642","4.00","6200.00","24800.00","0","");
INSERT INTO product_purchase_details VALUES("3398","ViEtJz5gC1BOLvK","20240218112422","641","12.00","305.00","3660.00","0","");
INSERT INTO product_purchase_details VALUES("3397","m8kEHVMC0xs0hY3","20240218112422","640","25.00","260.00","6500.00","0","");
INSERT INTO product_purchase_details VALUES("3396","mkVotpo3U0ka2lQ","20240218112422","639","40.00","160.00","6400.00","0","");
INSERT INTO product_purchase_details VALUES("3395","AGh2AdYMfSrgZHV","20240218112422","638","20.00","4150.00","83000.00","0","");
INSERT INTO product_purchase_details VALUES("3393","zSrqE0ltBSJk3qC","20240218121742","649","100.00","4555.00","455500.00","0","");
INSERT INTO product_purchase_details VALUES("3392","T4qPpe49AxxlCGB","20240218121742","650","60.00","4555.00","273300.00","0","");
INSERT INTO product_purchase_details VALUES("3391","U1peSNbIxWLb0Ao","20240218121742","652","10.00","4555.00","45550.00","0","");
INSERT INTO product_purchase_details VALUES("3390","mnvkHpQlsyzghCT","20240218121742","654","10.00","4555.00","45550.00","0","");
INSERT INTO product_purchase_details VALUES("3389","yTXenm1HE32jLvo","20240218121742","653","10.00","4555.00","45550.00","0","");
INSERT INTO product_purchase_details VALUES("3388","u45K6M9z3KK6DRd","20240218121742","670","10.00","7885.00","78850.00","0","");
INSERT INTO product_purchase_details VALUES("3387","NjB8gfuPOn8EYod","20240218121742","669","10.00","7885.00","78850.00","0","");
INSERT INTO product_purchase_details VALUES("3386","Qs03UAmQEuNOFHz","20240218121742","668","10.00","6445.00","64450.00","0","");
INSERT INTO product_purchase_details VALUES("3384","SB3CuONmJBq21gQ","20240218121742","666","40.00","4935.00","197400.00","0","");
INSERT INTO product_purchase_details VALUES("3385","7KLXTHp2NiD18zX","20240218121742","667","10.00","6445.00","64450.00","0","");
INSERT INTO product_purchase_details VALUES("3383","Cp3EAN3d9kQoLnV","20240218121742","665","40.00","4935.00","197400.00","0","");
INSERT INTO product_purchase_details VALUES("3381","p836tEXtOrW2sHq","20240218121742","663","40.00","3525.00","141000.00","0","");
INSERT INTO product_purchase_details VALUES("3382","bl0sVwTkgKdCq8T","20240218121742","664","40.00","3525.00","141000.00","0","");
INSERT INTO product_purchase_details VALUES("3380","IGtaLWtl2GCLNBe","20240218121742","662","29.00","2395.00","69455.00","0","");
INSERT INTO product_purchase_details VALUES("3379","LGeyW1QA9REwIdy","20240218121742","661","31.00","2395.00","74245.00","1","");
INSERT INTO product_purchase_details VALUES("3377","c236YowKLdTFsdv","20240218121742","659","29.00","1605.00","46545.00","3","");
INSERT INTO product_purchase_details VALUES("3378","iytWtM3wOxwanmO","20240218121742","660","31.00","1605.00","49755.00","9","");
INSERT INTO product_purchase_details VALUES("3376","rPm3uKvmml98LHv","20240218121742","658","1.00","45755.00","45755.00","4","");
INSERT INTO product_purchase_details VALUES("3375","ZTB3LiRtMPNaQCx","20240218121742","657","2.00","32455.00","64910.00","2","");
INSERT INTO product_purchase_details VALUES("3374","koDaiogKc6Uzf9h","20240218121742","656","2.00","32455.00","64910.00","8","");
INSERT INTO product_purchase_details VALUES("4237","lXcG8BdACf7PXPr","20240218132207","687","20.00","230.00","4600.00","0","");
INSERT INTO product_purchase_details VALUES("4236","56txYyxSG3L71Z1","20240218132207","686","20.00","250.00","5000.00","0","");
INSERT INTO product_purchase_details VALUES("4235","G0UZ2x6m6RCkFH1","20240218132207","684","20.00","360.00","7200.00","0","");
INSERT INTO product_purchase_details VALUES("4234","VaDCmpy3ghwKppD","20240218132207","675","8.00","50.00","400.00","0","");
INSERT INTO product_purchase_details VALUES("4233","cWtHMNnIRDYcS9m","20240218132207","674","3.00","780.00","2340.00","0","");
INSERT INTO product_purchase_details VALUES("4232","Z3l6Wy8pnrC2xKS","20240218132207","673","6.00","580.00","3480.00","0","");
INSERT INTO product_purchase_details VALUES("4231","1LqevXjZ6s7CBky","20240218132207","672","12.00","100.00","1200.00","0","");
INSERT INTO product_purchase_details VALUES("4230","jvqYTxRE3EP1H90","20240218132207","776","61.00","486.00","29646.00","0","");
INSERT INTO product_purchase_details VALUES("4229","S2Fs6eucg3zrGxQ","20240218132207","401","9.00","475.00","4275.00","0","");
INSERT INTO product_purchase_details VALUES("4228","Nj3r68K3qTtZRNM","20240218132207","678","19.00","286.00","5434.00","0","");
INSERT INTO product_purchase_details VALUES("4227","pKSp1Tg7dnI8zLS","20240218132207","679","1.00","259.00","259.00","0","");
INSERT INTO product_purchase_details VALUES("4226","fbSvYywGqmb2f0m","20240218132207","680","9.00","336.00","3024.00","0","");
INSERT INTO product_purchase_details VALUES("4225","CfaC92hYpz8MbpT","20240218132207","681","6.00","310.00","1860.00","0","");
INSERT INTO product_purchase_details VALUES("4224","dn2IlcI374pZ78k","20240218132207","682","1.00","250.00","250.00","0","");
INSERT INTO product_purchase_details VALUES("4223","mgkjQqFWF1WX21P","20240218132207","407","5.00","330.00","1650.00","0","");
INSERT INTO product_purchase_details VALUES("4222","IvvAAMnovRKbpTz","20240218132207","689","4.00","286.00","1144.00","0","");
INSERT INTO product_purchase_details VALUES("4221","12q8HkAYf5BYNL1","20240218132207","688","20.00","360.00","7200.00","0","");
INSERT INTO product_purchase_details VALUES("3421","1isEtJKdqBpr83p","20240218143236","690","30.00","830.00","24900.00","0","");
INSERT INTO product_purchase_details VALUES("3422","jPOdGtDKRhqzeR1","20240218143236","707","10.00","150.00","1500.00","0","");
INSERT INTO product_purchase_details VALUES("3419","TWhE8lpmmQWeKyX","20240218143236","692","1.00","1100.00","1100.00","0","");
INSERT INTO product_purchase_details VALUES("3420","x7sOZTC1dfbGxxT","20240218143236","691","1.00","1400.00","1400.00","0","");
INSERT INTO product_purchase_details VALUES("3418","w8AHr8pMqcpTgI9","20240218143236","693","400.00","130.00","52000.00","0","");
INSERT INTO product_purchase_details VALUES("3417","VTwt82g2ddYKfqJ","20240218143236","694","410.00","130.00","53300.00","0","");
INSERT INTO product_purchase_details VALUES("3416","T1WG4Zpcj9pB4ig","20240218143236","695","15.00","280.00","4200.00","0","");
INSERT INTO product_purchase_details VALUES("3415","KtpGm3vhYij52Vm","20240218143236","696","2.00","600.00","1200.00","0","");
INSERT INTO product_purchase_details VALUES("3414","vEqSoCGA09BxKRN","20240218143236","697","80.00","400.00","32000.00","0","");
INSERT INTO product_purchase_details VALUES("3413","xg4Y538QkM79TLj","20240218143236","698","80.00","290.00","23200.00","0","");
INSERT INTO product_purchase_details VALUES("3412","NdR6SntnHEStUdN","20240218143236","699","100.00","320.00","32000.00","0","");
INSERT INTO product_purchase_details VALUES("3411","lCLMFEqnBfKGb62","20240218143236","700","200.00","160.00","32000.00","0","");
INSERT INTO product_purchase_details VALUES("3410","fhNLYc4bWZgVkBa","20240218143236","701","20.00","1080.00","21600.00","0","");
INSERT INTO product_purchase_details VALUES("3409","P09YXWObXR3qrJx","20240218143236","703","30.00","900.00","27000.00","0","");
INSERT INTO product_purchase_details VALUES("3408","Jzz2MbVdm0GtpaB","20240218143236","704 ","50.00","550.00","27500.00","0","");
INSERT INTO product_purchase_details VALUES("3407","apqqz7muTsacSgX","20240218143236","705","40.00","250.00","10000.00","0","");
INSERT INTO product_purchase_details VALUES("3406","inkCGBkge7pBgvG","20240218143236","706 ","2.00","450.00","900.00","0","");
INSERT INTO product_purchase_details VALUES("3394","Xd8uP1JHObjYLCk","20240218121742","671","10.00","4555.00","45550.00","0","");
INSERT INTO product_purchase_details VALUES("3423","uUGF2RzcbLxVPV5","20240218143236","708","1.00","2550.00","2550.00","0","");
INSERT INTO product_purchase_details VALUES("3449","Dl6mEUGL32fXdWU","20240201155743","709","1.00","500.00","500.00","0","");
INSERT INTO product_purchase_details VALUES("4169","TzextU3kVcJuC6x","20240219081530","710","1.00","270.00","270.00","0","");
INSERT INTO product_purchase_details VALUES("4240","zk1G6xedJpOnYmk","20240219083123","714","150.00","325.00","48750.00","0","");
INSERT INTO product_purchase_details VALUES("4239","bNwKu9c389cwKoM","20240219083123","713","100.00","310.00","31000.00","0","");
INSERT INTO product_purchase_details VALUES("4238","n3PiOyZmwE2vuLU","20240219083123","712","150.00","320.00","48000.00","0","");
INSERT INTO product_purchase_details VALUES("4168","tiCUWMdVsJi0qB7","20240219081530","711","240.00","62.00","14880.00","0","");
INSERT INTO product_purchase_details VALUES("3467","78pspN69sOriWBT","20240219084954","715","1000.00","120.00","120000.00","0","1");
INSERT INTO product_purchase_details VALUES("3468","syoJ2qPurDAl910","20240219084954","716","300.00","190.00","57000.00","0","1");
INSERT INTO product_purchase_details VALUES("3469","nNy5IwMgCx7nAS9","20240219084954","717","36.00","270.00","9720.00","0","1");
INSERT INTO product_purchase_details VALUES("3470","k2WA8OTM4T4jP5l","20240219084954","718","80.00","220.00","17600.00","0","1");
INSERT INTO product_purchase_details VALUES("4254","GWhrLuVBWju0HOW","20240219094915","607","6.00","285.00","1710.00","0","");
INSERT INTO product_purchase_details VALUES("4253","ZLG7ZFHHIYl7XRT","20240219094915","618","1.00","300.00","300.00","0","");
INSERT INTO product_purchase_details VALUES("4252","ZtVGLqOny5aW3Am","20240219094915","619","1.00","100.00","100.00","0","");
INSERT INTO product_purchase_details VALUES("4251","xZtzkLBrSbxfuuU","20240219094915","620","24.00","5.00","120.00","0","");
INSERT INTO product_purchase_details VALUES("4250","Ho6ZUKZAgfcuYtc","20240219094915","621","1.00","4800.00","4800.00","0","");
INSERT INTO product_purchase_details VALUES("4249","uGJT44r7FCricim","20240219094915","622","12.00","10.00","120.00","0","");
INSERT INTO product_purchase_details VALUES("4248","6q9UXwRjRZdwF4l","20240219094915","623","90.00","26.00","2340.00","0","");
INSERT INTO product_purchase_details VALUES("4247","J4QMMtET4ASItM","20240219094915","624","1.00","3700.00","3700.00","0","");
INSERT INTO product_purchase_details VALUES("4246","a7ELSPIZcMdpN29","20240219094915","636","1.00","300.00","300.00","0","");
INSERT INTO product_purchase_details VALUES("4245","8BMFQ0MX3ounS29","20240219094915","634","4.00","8240.00","32960.00","0","");
INSERT INTO product_purchase_details VALUES("3624","i36T4UWC3oAGbsh","20240219100856","720","1.00","5500.00","5500.00","0","1");
INSERT INTO product_purchase_details VALUES("3625","zEHsEVst9jbCOzK","20240219101122","721","2.00","6250.00","12500.00","0","1");
INSERT INTO product_purchase_details VALUES("3626","gDqMmjQREa1qmtO","20240219101430","722","24.00","264.00","6336.00","0","1");
INSERT INTO product_purchase_details VALUES("4244","fyitDPFrR8Zurgy","20240219094915","723","1.00","200.00","200.00","0","");
INSERT INTO product_purchase_details VALUES("4243","zpwSQn73loOhYz6","20240219094915","635","16.00","120.00","1920.00","0","");
INSERT INTO product_purchase_details VALUES("4242","6FKda5izeBm3Gq0","20240219094915","724","1.00","240.00","240.00","4","");
INSERT INTO product_purchase_details VALUES("3871","bYsKWrxQRT1RsSO","20240205154059","364","3.00","15000.00","45000.00","0","");
INSERT INTO product_purchase_details VALUES("3892","MnUIRRYUhtePrC2","20240205171507","727","6.00","4800.00","28800.00","0","");
INSERT INTO product_purchase_details VALUES("4241","HXSHqBVTeY8oLax","20240219094915","725","1.00","180.00","180.00","6","");
INSERT INTO product_purchase_details VALUES("4167","f0IYjBPwYLJsPA5","20240203141705","728","24.00","260.00","6240.00","0","");



DROP TABLE product_return;

CREATE TABLE `product_return` (
  `return_id` varchar(30) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `product_id` varchar(20) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `invoice_id` varchar(20) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `purchase_id` varchar(30) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `date_purchase` varchar(20) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `date_return` varchar(30) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `byy_qty` float NOT NULL,
  `ret_qty` float NOT NULL,
  `customer_id` varchar(20) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `supplier_id` varchar(30) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `product_rate` decimal(10,2) NOT NULL DEFAULT '0.00',
  `deduction` float NOT NULL,
  `total_deduct` decimal(10,2) NOT NULL DEFAULT '0.00',
  `total_tax` decimal(10,2) NOT NULL DEFAULT '0.00',
  `total_ret_amount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `net_total_amount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `reason` text CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `usablity` int NOT NULL,
  KEY `product_id` (`product_id`),
  KEY `invoice_id` (`invoice_id`),
  KEY `purchase_id` (`purchase_id`),
  KEY `customer_id` (`customer_id`),
  KEY `supplier_id` (`supplier_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;




DROP TABLE product_service;

CREATE TABLE `product_service` (
  `service_id` int NOT NULL AUTO_INCREMENT,
  `service_name` varchar(250) NOT NULL,
  `description` text NOT NULL,
  `charge` decimal(10,2) NOT NULL DEFAULT '0.00',
  PRIMARY KEY (`service_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;




DROP TABLE quot_products_used;

CREATE TABLE `quot_products_used` (
  `id` int NOT NULL AUTO_INCREMENT,
  `quot_id` varchar(100) NOT NULL,
  `product_id` varchar(100) NOT NULL,
  `serial_no` varchar(30) DEFAULT NULL,
  `description` varchar(250) DEFAULT NULL,
  `used_qty` decimal(10,2) DEFAULT NULL,
  `rate` decimal(10,2) DEFAULT NULL,
  `supplier_rate` float DEFAULT NULL,
  `total_price` decimal(12,2) DEFAULT NULL,
  `discount` decimal(10,2) DEFAULT NULL,
  `discount_per` varchar(15) DEFAULT NULL,
  `tax` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `product_id` (`product_id`),
  KEY `quot_id` (`quot_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb3;




DROP TABLE quotation;

CREATE TABLE `quotation` (
  `id` int NOT NULL AUTO_INCREMENT,
  `quotation_id` varchar(30) NOT NULL,
  `quot_description` text NOT NULL,
  `customer_id` varchar(30) NOT NULL,
  `quotdate` date NOT NULL,
  `expire_date` date DEFAULT NULL,
  `item_total_amount` decimal(12,2) NOT NULL,
  `item_total_dicount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `item_total_tax` decimal(10,2) NOT NULL DEFAULT '0.00',
  `service_total_amount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `service_total_discount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `service_total_tax` decimal(10,2) NOT NULL DEFAULT '0.00',
  `quot_dis_item` decimal(10,2) NOT NULL DEFAULT '0.00',
  `quot_dis_service` decimal(10,2) NOT NULL DEFAULT '0.00',
  `quot_no` varchar(50) NOT NULL,
  `create_by` varchar(30) NOT NULL,
  `create_date` date NOT NULL,
  `update_by` varchar(30) DEFAULT NULL,
  `update_date` date DEFAULT NULL,
  `status` tinyint NOT NULL,
  `cust_show` tinyint DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `quot_no` (`quot_no`),
  KEY `quotation_id` (`quotation_id`),
  KEY `customer_id` (`customer_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;




DROP TABLE quotation_service_used;

CREATE TABLE `quotation_service_used` (
  `id` int NOT NULL AUTO_INCREMENT,
  `quot_id` varchar(20) NOT NULL,
  `service_id` int NOT NULL,
  `qty` decimal(10,2) NOT NULL DEFAULT '0.00',
  `charge` decimal(10,2) NOT NULL DEFAULT '0.00',
  `discount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `discount_amount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `tax` decimal(10,2) NOT NULL DEFAULT '0.00',
  `total` decimal(10,2) NOT NULL DEFAULT '0.00',
  PRIMARY KEY (`id`),
  KEY `quot_id` (`quot_id`),
  KEY `service_id` (`service_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;




DROP TABLE quotation_taxinfo;

CREATE TABLE `quotation_taxinfo` (
  `id` int NOT NULL AUTO_INCREMENT,
  `date` date NOT NULL,
  `customer_id` int NOT NULL,
  `relation_id` varchar(30) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `customer_id` (`customer_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;




DROP TABLE role_permission;

CREATE TABLE `role_permission` (
  `id` int NOT NULL AUTO_INCREMENT,
  `fk_module_id` int NOT NULL,
  `role_id` int NOT NULL,
  `create` tinyint(1) DEFAULT NULL,
  `read` tinyint(1) DEFAULT NULL,
  `update` tinyint(1) DEFAULT NULL,
  `delete` tinyint(1) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_module_id` (`fk_module_id`),
  KEY `fk_user_id` (`role_id`)
) ENGINE=InnoDB AUTO_INCREMENT=346 DEFAULT CHARSET=utf8mb3;

INSERT INTO role_permission VALUES("116","1","1","1","1","1","1");
INSERT INTO role_permission VALUES("117","2","1","1","1","1","1");
INSERT INTO role_permission VALUES("118","3","1","1","1","1","1");
INSERT INTO role_permission VALUES("119","114","1","1","1","1","1");
INSERT INTO role_permission VALUES("120","25","1","1","1","1","1");
INSERT INTO role_permission VALUES("121","26","1","1","1","1","1");
INSERT INTO role_permission VALUES("122","27","1","1","1","1","1");
INSERT INTO role_permission VALUES("123","28","1","1","1","1","1");
INSERT INTO role_permission VALUES("124","111","1","1","1","1","1");
INSERT INTO role_permission VALUES("125","113","1","1","1","1","1");
INSERT INTO role_permission VALUES("126","21","1","1","1","1","1");
INSERT INTO role_permission VALUES("127","22","1","1","1","1","1");
INSERT INTO role_permission VALUES("128","23","1","1","1","1","1");
INSERT INTO role_permission VALUES("129","24","1","1","1","1","1");
INSERT INTO role_permission VALUES("130","30","1","1","1","1","1");
INSERT INTO role_permission VALUES("131","31","1","1","1","1","1");
INSERT INTO role_permission VALUES("132","32","1","1","1","1","1");
INSERT INTO role_permission VALUES("133","33","1","1","1","1","1");
INSERT INTO role_permission VALUES("134","112","1","1","1","1","1");
INSERT INTO role_permission VALUES("135","35","1","1","1","1","1");
INSERT INTO role_permission VALUES("136","36","1","1","1","1","1");
INSERT INTO role_permission VALUES("137","43","1","1","1","1","1");
INSERT INTO role_permission VALUES("138","37","1","1","1","1","1");
INSERT INTO role_permission VALUES("139","38","1","1","1","1","1");
INSERT INTO role_permission VALUES("140","39","1","1","1","1","1");
INSERT INTO role_permission VALUES("141","40","1","1","1","1","1");
INSERT INTO role_permission VALUES("142","46","1","1","1","1","1");
INSERT INTO role_permission VALUES("143","47","1","1","1","1","1");
INSERT INTO role_permission VALUES("144","48","1","1","1","1","1");
INSERT INTO role_permission VALUES("145","49","1","1","1","1","1");
INSERT INTO role_permission VALUES("146","50","1","1","1","1","1");
INSERT INTO role_permission VALUES("147","51","1","1","1","1","1");
INSERT INTO role_permission VALUES("148","52","1","1","1","1","1");
INSERT INTO role_permission VALUES("149","53","1","1","1","1","1");
INSERT INTO role_permission VALUES("150","54","1","1","1","1","1");
INSERT INTO role_permission VALUES("151","55","1","1","1","1","1");
INSERT INTO role_permission VALUES("152","97","1","1","1","1","1");
INSERT INTO role_permission VALUES("153","98","1","1","1","1","1");
INSERT INTO role_permission VALUES("154","99","1","1","1","1","1");
INSERT INTO role_permission VALUES("155","100","1","1","1","1","1");
INSERT INTO role_permission VALUES("156","101","1","1","1","1","1");
INSERT INTO role_permission VALUES("157","102","1","1","1","1","1");
INSERT INTO role_permission VALUES("158","4","1","1","1","1","1");
INSERT INTO role_permission VALUES("159","5","1","1","1","1","1");
INSERT INTO role_permission VALUES("160","6","1","1","1","1","1");
INSERT INTO role_permission VALUES("161","7","1","1","1","1","1");
INSERT INTO role_permission VALUES("162","8","1","1","1","1","1");
INSERT INTO role_permission VALUES("163","9","1","1","1","1","1");
INSERT INTO role_permission VALUES("164","10","1","1","1","1","1");
INSERT INTO role_permission VALUES("165","11","1","1","1","1","1");
INSERT INTO role_permission VALUES("166","12","1","1","1","1","1");
INSERT INTO role_permission VALUES("167","13","1","1","1","1","1");
INSERT INTO role_permission VALUES("168","14","1","1","1","1","1");
INSERT INTO role_permission VALUES("169","15","1","1","1","1","1");
INSERT INTO role_permission VALUES("170","16","1","1","1","1","1");
INSERT INTO role_permission VALUES("171","17","1","1","1","1","1");
INSERT INTO role_permission VALUES("172","18","1","1","1","1","1");
INSERT INTO role_permission VALUES("173","19","1","1","1","1","1");
INSERT INTO role_permission VALUES("174","56","1","1","1","1","1");
INSERT INTO role_permission VALUES("175","57","1","1","1","1","1");
INSERT INTO role_permission VALUES("176","58","1","1","1","1","1");
INSERT INTO role_permission VALUES("177","41","1","1","1","1","1");
INSERT INTO role_permission VALUES("178","103","1","1","1","1","1");
INSERT INTO role_permission VALUES("179","104","1","1","1","1","1");
INSERT INTO role_permission VALUES("180","109","1","1","1","1","1");
INSERT INTO role_permission VALUES("181","110","1","1","1","1","1");
INSERT INTO role_permission VALUES("182","60","1","1","1","1","1");
INSERT INTO role_permission VALUES("183","61","1","1","1","1","1");
INSERT INTO role_permission VALUES("184","62","1","1","1","1","1");
INSERT INTO role_permission VALUES("185","63","1","1","1","1","1");
INSERT INTO role_permission VALUES("186","64","1","1","1","1","1");
INSERT INTO role_permission VALUES("187","65","1","1","1","1","1");
INSERT INTO role_permission VALUES("188","66","1","1","1","1","1");
INSERT INTO role_permission VALUES("189","67","1","1","1","1","1");
INSERT INTO role_permission VALUES("190","68","1","1","1","1","1");
INSERT INTO role_permission VALUES("191","69","1","1","1","1","1");
INSERT INTO role_permission VALUES("192","70","1","1","1","1","1");
INSERT INTO role_permission VALUES("193","71","1","1","1","1","1");
INSERT INTO role_permission VALUES("194","72","1","1","1","1","1");
INSERT INTO role_permission VALUES("195","73","1","1","1","1","1");
INSERT INTO role_permission VALUES("196","74","1","1","1","1","1");
INSERT INTO role_permission VALUES("197","75","1","1","1","1","1");
INSERT INTO role_permission VALUES("198","76","1","1","1","1","1");
INSERT INTO role_permission VALUES("199","77","1","1","1","1","1");
INSERT INTO role_permission VALUES("200","78","1","1","1","1","1");
INSERT INTO role_permission VALUES("201","79","1","1","1","1","1");
INSERT INTO role_permission VALUES("202","80","1","1","1","1","1");
INSERT INTO role_permission VALUES("203","81","1","1","1","1","1");
INSERT INTO role_permission VALUES("204","82","1","1","1","1","1");
INSERT INTO role_permission VALUES("205","83","1","1","1","1","1");
INSERT INTO role_permission VALUES("206","84","1","1","1","1","1");
INSERT INTO role_permission VALUES("207","85","1","1","1","1","1");
INSERT INTO role_permission VALUES("208","86","1","1","1","1","1");
INSERT INTO role_permission VALUES("209","105","1","1","1","1","1");
INSERT INTO role_permission VALUES("210","106","1","1","1","1","1");
INSERT INTO role_permission VALUES("211","107","1","1","1","1","1");
INSERT INTO role_permission VALUES("212","108","1","1","1","1","1");
INSERT INTO role_permission VALUES("213","59","1","1","1","1","1");
INSERT INTO role_permission VALUES("214","87","1","1","1","1","1");
INSERT INTO role_permission VALUES("215","88","1","1","1","1","1");
INSERT INTO role_permission VALUES("216","89","1","1","1","1","1");
INSERT INTO role_permission VALUES("217","90","1","1","1","1","1");
INSERT INTO role_permission VALUES("218","91","1","1","1","1","1");
INSERT INTO role_permission VALUES("219","92","1","1","1","1","1");
INSERT INTO role_permission VALUES("220","93","1","1","1","1","1");
INSERT INTO role_permission VALUES("221","94","1","1","1","1","1");
INSERT INTO role_permission VALUES("222","95","1","1","1","1","1");
INSERT INTO role_permission VALUES("223","96","1","1","1","1","1");
INSERT INTO role_permission VALUES("224","115","1","1","1","1","1");
INSERT INTO role_permission VALUES("225","116","1","1","1","1","1");
INSERT INTO role_permission VALUES("226","117","1","1","1","1","1");
INSERT INTO role_permission VALUES("227","118","1","1","1","1","1");
INSERT INTO role_permission VALUES("228","119","1","1","1","1","1");
INSERT INTO role_permission VALUES("229","120","1","1","1","1","1");
INSERT INTO role_permission VALUES("230","121","1","1","1","1","1");
INSERT INTO role_permission VALUES("231","1","2","0","0","0","0");
INSERT INTO role_permission VALUES("232","2","2","0","0","0","0");
INSERT INTO role_permission VALUES("233","3","2","0","0","0","0");
INSERT INTO role_permission VALUES("234","114","2","0","0","0","0");
INSERT INTO role_permission VALUES("235","25","2","0","0","1","0");
INSERT INTO role_permission VALUES("236","26","2","1","1","1","0");
INSERT INTO role_permission VALUES("237","27","2","1","1","1","0");
INSERT INTO role_permission VALUES("238","28","2","1","1","1","0");
INSERT INTO role_permission VALUES("239","111","2","1","1","1","0");
INSERT INTO role_permission VALUES("240","113","2","1","1","1","0");
INSERT INTO role_permission VALUES("241","21","2","1","1","1","0");
INSERT INTO role_permission VALUES("242","22","2","1","1","1","0");
INSERT INTO role_permission VALUES("243","23","2","0","0","0","0");
INSERT INTO role_permission VALUES("244","24","2","1","1","1","0");
INSERT INTO role_permission VALUES("245","30","2","1","1","1","0");
INSERT INTO role_permission VALUES("246","31","2","1","1","1","0");
INSERT INTO role_permission VALUES("247","32","2","1","1","1","0");
INSERT INTO role_permission VALUES("248","33","2","1","1","1","0");
INSERT INTO role_permission VALUES("249","112","2","1","1","1","0");
INSERT INTO role_permission VALUES("250","35","2","1","1","1","0");
INSERT INTO role_permission VALUES("251","36","2","1","1","1","0");
INSERT INTO role_permission VALUES("252","43","2","1","1","1","0");
INSERT INTO role_permission VALUES("253","37","2","1","1","1","0");
INSERT INTO role_permission VALUES("254","38","2","1","1","1","0");
INSERT INTO role_permission VALUES("255","39","2","1","1","1","0");
INSERT INTO role_permission VALUES("256","40","2","1","1","1","0");
INSERT INTO role_permission VALUES("257","46","2","1","1","1","0");
INSERT INTO role_permission VALUES("258","47","2","1","1","1","0");
INSERT INTO role_permission VALUES("259","48","2","1","1","1","0");
INSERT INTO role_permission VALUES("260","49","2","1","1","1","0");
INSERT INTO role_permission VALUES("261","50","2","1","1","1","0");
INSERT INTO role_permission VALUES("262","51","2","1","1","1","0");
INSERT INTO role_permission VALUES("263","52","2","1","1","1","0");
INSERT INTO role_permission VALUES("264","53","2","1","1","1","0");
INSERT INTO role_permission VALUES("265","54","2","1","1","1","0");
INSERT INTO role_permission VALUES("266","55","2","1","1","1","0");
INSERT INTO role_permission VALUES("267","97","2","0","0","0","0");
INSERT INTO role_permission VALUES("268","98","2","1","1","1","0");
INSERT INTO role_permission VALUES("269","99","2","1","1","1","0");
INSERT INTO role_permission VALUES("270","100","2","1","1","1","0");
INSERT INTO role_permission VALUES("271","101","2","1","1","1","0");
INSERT INTO role_permission VALUES("272","102","2","1","1","1","0");
INSERT INTO role_permission VALUES("273","4","2","1","1","1","0");
INSERT INTO role_permission VALUES("274","5","2","1","1","1","0");
INSERT INTO role_permission VALUES("275","6","2","1","1","1","0");
INSERT INTO role_permission VALUES("276","7","2","1","1","1","0");
INSERT INTO role_permission VALUES("277","8","2","1","1","1","0");
INSERT INTO role_permission VALUES("278","9","2","1","1","1","0");
INSERT INTO role_permission VALUES("279","10","2","1","1","1","0");
INSERT INTO role_permission VALUES("280","11","2","1","1","1","0");
INSERT INTO role_permission VALUES("281","12","2","1","1","1","0");
INSERT INTO role_permission VALUES("282","13","2","1","1","1","0");
INSERT INTO role_permission VALUES("283","14","2","1","1","1","0");
INSERT INTO role_permission VALUES("284","15","2","1","1","1","0");
INSERT INTO role_permission VALUES("285","16","2","1","1","1","0");
INSERT INTO role_permission VALUES("286","17","2","1","1","1","0");
INSERT INTO role_permission VALUES("287","18","2","1","1","1","0");
INSERT INTO role_permission VALUES("288","19","2","1","1","1","0");
INSERT INTO role_permission VALUES("289","56","2","1","1","1","0");
INSERT INTO role_permission VALUES("290","57","2","1","1","1","0");
INSERT INTO role_permission VALUES("291","58","2","1","1","1","0");
INSERT INTO role_permission VALUES("292","41","2","1","1","1","0");
INSERT INTO role_permission VALUES("293","103","2","1","1","1","0");
INSERT INTO role_permission VALUES("294","104","2","1","1","1","0");
INSERT INTO role_permission VALUES("295","109","2","1","1","1","0");
INSERT INTO role_permission VALUES("296","110","2","1","1","1","0");
INSERT INTO role_permission VALUES("297","60","2","0","0","0","0");
INSERT INTO role_permission VALUES("298","61","2","0","0","0","0");
INSERT INTO role_permission VALUES("299","62","2","0","0","0","0");
INSERT INTO role_permission VALUES("300","63","2","0","0","0","0");
INSERT INTO role_permission VALUES("301","64","2","0","0","0","0");
INSERT INTO role_permission VALUES("302","65","2","0","0","0","0");
INSERT INTO role_permission VALUES("303","66","2","0","0","0","0");
INSERT INTO role_permission VALUES("304","67","2","0","0","0","0");
INSERT INTO role_permission VALUES("305","68","2","0","0","0","0");
INSERT INTO role_permission VALUES("306","69","2","0","0","0","0");
INSERT INTO role_permission VALUES("307","70","2","0","0","0","0");
INSERT INTO role_permission VALUES("308","71","2","0","0","0","0");
INSERT INTO role_permission VALUES("309","72","2","0","0","0","0");
INSERT INTO role_permission VALUES("310","73","2","0","0","0","0");
INSERT INTO role_permission VALUES("311","74","2","0","0","0","0");
INSERT INTO role_permission VALUES("312","75","2","0","0","0","0");
INSERT INTO role_permission VALUES("313","76","2","0","0","0","0");
INSERT INTO role_permission VALUES("314","77","2","0","0","0","0");
INSERT INTO role_permission VALUES("315","78","2","0","0","0","0");
INSERT INTO role_permission VALUES("316","79","2","0","0","0","0");
INSERT INTO role_permission VALUES("317","80","2","0","0","0","0");
INSERT INTO role_permission VALUES("318","81","2","0","0","0","0");
INSERT INTO role_permission VALUES("319","82","2","0","0","0","0");
INSERT INTO role_permission VALUES("320","83","2","0","0","0","0");
INSERT INTO role_permission VALUES("321","84","2","0","0","0","0");
INSERT INTO role_permission VALUES("322","85","2","0","0","0","0");
INSERT INTO role_permission VALUES("323","86","2","0","0","0","0");
INSERT INTO role_permission VALUES("324","105","2","0","0","0","0");
INSERT INTO role_permission VALUES("325","106","2","0","0","0","0");
INSERT INTO role_permission VALUES("326","107","2","0","0","0","0");
INSERT INTO role_permission VALUES("327","108","2","0","0","0","0");
INSERT INTO role_permission VALUES("328","59","2","0","0","0","0");
INSERT INTO role_permission VALUES("329","87","2","0","0","0","0");
INSERT INTO role_permission VALUES("330","88","2","0","0","0","0");
INSERT INTO role_permission VALUES("331","89","2","0","0","0","0");
INSERT INTO role_permission VALUES("332","90","2","0","0","0","0");
INSERT INTO role_permission VALUES("333","91","2","0","0","0","0");
INSERT INTO role_permission VALUES("334","92","2","0","0","0","0");
INSERT INTO role_permission VALUES("335","93","2","0","0","0","0");
INSERT INTO role_permission VALUES("336","94","2","0","0","0","0");
INSERT INTO role_permission VALUES("337","95","2","0","0","0","0");
INSERT INTO role_permission VALUES("338","96","2","0","0","0","0");
INSERT INTO role_permission VALUES("339","115","2","0","0","0","0");
INSERT INTO role_permission VALUES("340","116","2","0","0","0","0");
INSERT INTO role_permission VALUES("341","117","2","0","0","0","0");
INSERT INTO role_permission VALUES("342","118","2","0","0","0","0");
INSERT INTO role_permission VALUES("343","119","2","0","0","0","0");
INSERT INTO role_permission VALUES("344","120","2","0","0","0","0");
INSERT INTO role_permission VALUES("345","121","2","0","0","0","0");



DROP TABLE salary_sheet_generate;

CREATE TABLE `salary_sheet_generate` (
  `ssg_id` int unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(30) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `gdate` varchar(30) DEFAULT NULL,
  `start_date` varchar(30) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `end_date` varchar(30) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `generate_by` varchar(30) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  PRIMARY KEY (`ssg_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;




DROP TABLE salary_type;

CREATE TABLE `salary_type` (
  `salary_type_id` int NOT NULL AUTO_INCREMENT,
  `sal_name` varchar(100) NOT NULL,
  `salary_type` varchar(50) NOT NULL,
  `status` varchar(30) NOT NULL,
  PRIMARY KEY (`salary_type_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;




DROP TABLE sec_role;

CREATE TABLE `sec_role` (
  `id` int NOT NULL AUTO_INCREMENT,
  `type` varchar(100) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;

INSERT INTO sec_role VALUES("1","ADMIN");
INSERT INTO sec_role VALUES("2","millat");



DROP TABLE sec_userrole;

CREATE TABLE `sec_userrole` (
  `id` int NOT NULL AUTO_INCREMENT,
  `user_id` varchar(50) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci NOT NULL,
  `roleid` int NOT NULL,
  `createby` varchar(50) CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci NOT NULL,
  `createdate` datetime NOT NULL,
  UNIQUE KEY `ID` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

INSERT INTO sec_userrole VALUES("1","1","2","2","2024-01-12 12:21:07");
INSERT INTO sec_userrole VALUES("2","1","2","2","2024-01-12 12:22:12");
INSERT INTO sec_userrole VALUES("3","1","2","2","2024-01-18 11:59:59");
INSERT INTO sec_userrole VALUES("4","2","1","2","2024-01-18 12:01:42");



DROP TABLE service_invoice;

CREATE TABLE `service_invoice` (
  `id` int NOT NULL AUTO_INCREMENT,
  `voucher_no` varchar(30) NOT NULL,
  `date` date NOT NULL,
  `employee_id` varchar(100) DEFAULT NULL,
  `customer_id` varchar(30) NOT NULL,
  `total_amount` decimal(20,2) NOT NULL DEFAULT '0.00',
  `total_discount` decimal(20,2) NOT NULL DEFAULT '0.00',
  `invoice_discount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `total_tax` decimal(10,2) NOT NULL DEFAULT '0.00',
  `paid_amount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `due_amount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `shipping_cost` decimal(10,2) NOT NULL DEFAULT '0.00',
  `previous` decimal(10,2) NOT NULL DEFAULT '0.00',
  `details` varchar(250) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `customer_id` (`customer_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;




DROP TABLE service_invoice_details;

CREATE TABLE `service_invoice_details` (
  `id` int NOT NULL AUTO_INCREMENT,
  `service_id` int NOT NULL,
  `service_inv_id` varchar(30) NOT NULL,
  `qty` decimal(10,2) NOT NULL DEFAULT '0.00',
  `charge` decimal(10,2) NOT NULL DEFAULT '0.00',
  `discount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `discount_amount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `total` decimal(10,2) NOT NULL DEFAULT '0.00',
  PRIMARY KEY (`id`),
  KEY `service_id` (`service_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;




DROP TABLE sms_settings;

CREATE TABLE `sms_settings` (
  `id` int NOT NULL AUTO_INCREMENT,
  `api_key` varchar(100) DEFAULT NULL,
  `api_secret` varchar(100) DEFAULT NULL,
  `from` varchar(100) DEFAULT NULL,
  `isinvoice` int NOT NULL DEFAULT '0',
  `isservice` int NOT NULL DEFAULT '0',
  `isreceive` int NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3;

INSERT INTO sms_settings VALUES("1","5d6db102011","456452dfgdf","8801645452","0","0","0");



DROP TABLE sub_module;

CREATE TABLE `sub_module` (
  `id` int NOT NULL AUTO_INCREMENT,
  `mid` int NOT NULL,
  `name` varchar(100) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL,
  `description` text CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci,
  `image` varchar(100) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL,
  `directory` varchar(50) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci DEFAULT NULL,
  `status` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=122 DEFAULT CHARSET=latin1;

INSERT INTO sub_module VALUES("1","1","new_invoice","","","new_invoice","1");
INSERT INTO sub_module VALUES("2","1","manage_invoice","","","manage_invoice","1");
INSERT INTO sub_module VALUES("3","1","pos_invoice","","","pos_invoice","1");
INSERT INTO sub_module VALUES("4","9","c_o_a","","","show_tree","1");
INSERT INTO sub_module VALUES("5","9","supplier_payment","","","supplier_payment","1");
INSERT INTO sub_module VALUES("6","9","customer_receive","","","customer_receive","1");
INSERT INTO sub_module VALUES("7","9","debit_voucher","","","debit_voucher","1");
INSERT INTO sub_module VALUES("8","9","credit_voucher","","","credit_voucher","1");
INSERT INTO sub_module VALUES("9","9","voucher_approval","","","aprove_v","1");
INSERT INTO sub_module VALUES("10","9","contra_voucher","","","contra_voucher","1");
INSERT INTO sub_module VALUES("11","9","journal_voucher","","","journal_voucher","1");
INSERT INTO sub_module VALUES("12","9","report","","","ac_report","1");
INSERT INTO sub_module VALUES("13","9","cash_book","","","cash_book","1");
INSERT INTO sub_module VALUES("14","9","Inventory_ledger","","","inventory_ledger","1");
INSERT INTO sub_module VALUES("15","9","bank_book","","","bank_book","1");
INSERT INTO sub_module VALUES("16","9","general_ledger","","","general_ledger","1");
INSERT INTO sub_module VALUES("17","9","trial_balance","","","trial_balance","1");
INSERT INTO sub_module VALUES("18","9","cash_flow","","","cash_flow_report","1");
INSERT INTO sub_module VALUES("19","9","coa_print","","","coa_print","1");
INSERT INTO sub_module VALUES("21","3","category","","","manage_category","1");
INSERT INTO sub_module VALUES("22","3","add_product","","","create_product","1");
INSERT INTO sub_module VALUES("23","3","import_product_csv","","","add_product_csv","1");
INSERT INTO sub_module VALUES("24","3","manage_product","","","manage_product","1");
INSERT INTO sub_module VALUES("25","2","add_customer","","","add_customer","1");
INSERT INTO sub_module VALUES("26","2","manage_customer","","","manage_customer","1");
INSERT INTO sub_module VALUES("27","2","credit_customer","","","credit_customer","1");
INSERT INTO sub_module VALUES("28","2","paid_customer","","","paid_customer","1");
INSERT INTO sub_module VALUES("30","3","unit","","","manage_unit","1");
INSERT INTO sub_module VALUES("31","4","add_supplier","","","add_supplier","1");
INSERT INTO sub_module VALUES("32","4","manage_supplier","","","manage_supplier","1");
INSERT INTO sub_module VALUES("33","4","supplier_ledger","","","supplier_ledger_report","1");
INSERT INTO sub_module VALUES("35","5","add_purchase","","","add_purchase","1");
INSERT INTO sub_module VALUES("36","5","manage_purchase","","","manage_purchase","1");
INSERT INTO sub_module VALUES("37","7","return","","","add_return","1");
INSERT INTO sub_module VALUES("38","7","stock_return_list","","","return_list","1");
INSERT INTO sub_module VALUES("39","7","supplier_return_list","","","supplier_return_list","1");
INSERT INTO sub_module VALUES("40","7","wastage_return_list","","","wastage_return_list","1");
INSERT INTO sub_module VALUES("41","11","tax_settings","","","tax_settings","1");
INSERT INTO sub_module VALUES("43","6","stock_report","","","stock_report","1");
INSERT INTO sub_module VALUES("46","8","closing","","","add_closing","1");
INSERT INTO sub_module VALUES("47","8","closing_report","","","closing_report","1");
INSERT INTO sub_module VALUES("48","8","todays_report","","","all_report","1");
INSERT INTO sub_module VALUES("49","8","todays_customer_receipt","","","todays_customer_receipt","1");
INSERT INTO sub_module VALUES("50","8","sales_report","","","todays_sales_report","1");
INSERT INTO sub_module VALUES("51","8","due_report","","","retrieve_dateWise_DueReports","1");
INSERT INTO sub_module VALUES("52","8","purchase_report","","","todays_purchase_report","1");
INSERT INTO sub_module VALUES("53","8","purchase_report_category_wise","","","purchase_report_category_wise","1");
INSERT INTO sub_module VALUES("54","8","sales_report_product_wise","","","product_sales_reports_date_wise","1");
INSERT INTO sub_module VALUES("55","8","sales_report_category_wise","","","sales_report_category_wise","1");
INSERT INTO sub_module VALUES("56","10","add_new_bank","","","add_bank","1");
INSERT INTO sub_module VALUES("57","10","bank_transaction","","","bank_transaction","1");
INSERT INTO sub_module VALUES("58","10","manage_bank","","","bank_list","1");
INSERT INTO sub_module VALUES("59","14","generate_commission","","","commission","1");
INSERT INTO sub_module VALUES("60","12","add_designation","","","add_designation","1");
INSERT INTO sub_module VALUES("61","12","manage_designation","","","manage_designation","1");
INSERT INTO sub_module VALUES("62","12","add_employee","","","add_employee","1");
INSERT INTO sub_module VALUES("63","12","manage_employee","","","manage_employee","1");
INSERT INTO sub_module VALUES("64","12","add_attendance","","","add_attendance","1");
INSERT INTO sub_module VALUES("65","12","manage_attendance","","","manage_attendance","1");
INSERT INTO sub_module VALUES("66","12","attendance_report","","","attendance_report","1");
INSERT INTO sub_module VALUES("67","12","add_benefits","","","add_benefits","1");
INSERT INTO sub_module VALUES("68","12","manage_benefits","","","manage_benefits","1");
INSERT INTO sub_module VALUES("69","12","add_salary_setup","","","add_salary_setup","1");
INSERT INTO sub_module VALUES("70","12","manage_salary_setup","","","manage_salary_setup","1");
INSERT INTO sub_module VALUES("71","12","salary_generate","","","salary_generate","1");
INSERT INTO sub_module VALUES("72","12","manage_salary_generate","","","manage_salary_generate","1");
INSERT INTO sub_module VALUES("73","12","salary_payment","","","salary_payment","1");
INSERT INTO sub_module VALUES("74","12","add_expense_item","","","add_expense_item","1");
INSERT INTO sub_module VALUES("75","12","manage_expense_item","","","manage_expense_item","1");
INSERT INTO sub_module VALUES("76","12","add_expense","","","add_expense","1");
INSERT INTO sub_module VALUES("77","12","manage_expense","","","manage_expense","1");
INSERT INTO sub_module VALUES("78","12","expense_statement","","","expense_statement","1");
INSERT INTO sub_module VALUES("79","12","add_person_officeloan","","","add1_person","1");
INSERT INTO sub_module VALUES("80","12","add_loan_officeloan","","","add_office_loan","1");
INSERT INTO sub_module VALUES("81","12","add_payment_officeloan","","","add_loan_payment","1");
INSERT INTO sub_module VALUES("82","12","manage_loan_officeloan","","","manage1_person","1");
INSERT INTO sub_module VALUES("83","12","add_person_personalloan","","","add_person","1");
INSERT INTO sub_module VALUES("84","12","add_loan_personalloan","","","add_loan","1");
INSERT INTO sub_module VALUES("85","12","add_payment_personalloan","","","add_payment","1");
INSERT INTO sub_module VALUES("86","12","manage_loan_personalloan","","","manage_person","1");
INSERT INTO sub_module VALUES("87","15","manage_company","","","manage_company","1");
INSERT INTO sub_module VALUES("88","15","add_user","","","add_user","1");
INSERT INTO sub_module VALUES("89","15","manage_users","","","manage_user","1");
INSERT INTO sub_module VALUES("90","15","language","","","add_language","1");
INSERT INTO sub_module VALUES("91","15","currency","","","add_currency","1");
INSERT INTO sub_module VALUES("92","15","setting","","","soft_setting","1");
INSERT INTO sub_module VALUES("93","15","add_role","","","add_role","1");
INSERT INTO sub_module VALUES("94","15","role_list","","","role_list","1");
INSERT INTO sub_module VALUES("95","15","user_assign_role","","","user_assign","1");
INSERT INTO sub_module VALUES("96","15","Permission","","","","1");
INSERT INTO sub_module VALUES("97","8","shipping_cost_report","","","shipping_cost_report","1");
INSERT INTO sub_module VALUES("98","8","user_wise_sales_report","","","user_wise_sales_report","1");
INSERT INTO sub_module VALUES("99","8","invoice_return","","","invoice_return","1");
INSERT INTO sub_module VALUES("100","8","supplier_return","","","supplier_return","1");
INSERT INTO sub_module VALUES("101","8","tax_report","","","tax_report","1");
INSERT INTO sub_module VALUES("102","8","profit_report","","","profit_report","1");
INSERT INTO sub_module VALUES("103","11","add_incometax","","","add_incometax","1");
INSERT INTO sub_module VALUES("104","11","manage_income_tax","","","manage_income_tax","1");
INSERT INTO sub_module VALUES("105","13","add_service","","","create_service","1");
INSERT INTO sub_module VALUES("106","13","manage_service","","","manage_service","1");
INSERT INTO sub_module VALUES("107","13","service_invoice","","","service_invoice","1");
INSERT INTO sub_module VALUES("108","13","manage_service_invoice","","","manage_service_invoice","1");
INSERT INTO sub_module VALUES("109","11","tax_report","","","tax_report","1");
INSERT INTO sub_module VALUES("110","11","invoice_wise_tax_report","","","invoice_wise_tax_report","1");
INSERT INTO sub_module VALUES("111","2","customer_advance","","","customer_advance","1");
INSERT INTO sub_module VALUES("112","4","supplier_advance","","","supplier_advance","1");
INSERT INTO sub_module VALUES("113","2","customer_ledger","","","customer_ledger","1");
INSERT INTO sub_module VALUES("114","1","gui_pos","","","gui_pos","1");
INSERT INTO sub_module VALUES("115","15","sms_configure","","","sms_configure","1");
INSERT INTO sub_module VALUES("116","15","backup_restore","","","back_up","1");
INSERT INTO sub_module VALUES("117","15","import","","","sql_import","1");
INSERT INTO sub_module VALUES("118","15","restore","","","restore","1");
INSERT INTO sub_module VALUES("119","16","add_quotation","","","add_quotation","1");
INSERT INTO sub_module VALUES("120","16","manage_quotation","","","manage_quotation","1");
INSERT INTO sub_module VALUES("121","16","add_to_invoice","","","add_to_invoice","1");



DROP TABLE supplier_information;

CREATE TABLE `supplier_information` (
  `supplier_id` bigint NOT NULL AUTO_INCREMENT,
  `supplier_name` varchar(255) NOT NULL,
  `address` varchar(255) DEFAULT NULL,
  `address2` text NOT NULL,
  `mobile` varchar(100) DEFAULT NULL,
  `emailnumber` varchar(200) DEFAULT NULL,
  `email_address` varchar(200) DEFAULT NULL,
  `contact` varchar(100) DEFAULT NULL,
  `phone` varchar(50) DEFAULT NULL,
  `fax` varchar(100) DEFAULT NULL,
  `city` text,
  `state` text,
  `zip` varchar(50) DEFAULT NULL,
  `country` varchar(250) DEFAULT NULL,
  `details` varchar(255) DEFAULT NULL,
  `status` int NOT NULL,
  PRIMARY KEY (`supplier_id`),
  KEY `supplier_id` (`supplier_id`)
) ENGINE=MyISAM AUTO_INCREMENT=52 DEFAULT CHARSET=utf8mb3;

INSERT INTO supplier_information VALUES("1","Ashraf surgoda","","","0311950561","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("2","Arslan LED","","","03123017790","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("3","Pak E \\ S Khi","","","03352353814","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("4","Qureshi pipe wala","","","03112118590","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("7","P.V.C Mix item","","","03153569005","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("8","Akram PVC","","","03163068742","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("9","Nasir Electric","","","03133587094","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("10","Memon LAD Light","","","03414470445","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("11","Chilton Safan","","","03133310784","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("14","ARY Sargodah","","","03157181663","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("13","Olympic Sargodah","","","03347424229","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("15","Al Mezan Sargodah","","","03437533744","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("16","Asim Sargodah","","","03006027729","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("19","E M Sargodah","","","03117073265","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("18","Perfect Sargodah","","","03007012962","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("20","Sonex Sargodah","","","03016600770","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("23","Burq Sargodah","","","03006040486","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("22","Sahar Al Fazal Sargodah","","","03176010149","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("24","Fareed Qasim","","","03003579515","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("25","Aijaz PCV Karachi","","","03113286212","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("26","Jawaid Wire","","","03009370350","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("27","Haji salman Karachi","","","03152432410","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("28","Fizan Wire","","","03362528446","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("29","G.One LED Light","","","03331287548","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("30","Moin PVC Karachi","","","03432655809","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("31","Arfeen Wire (Million)","","","03163227838","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("32","Millat Traders Loose Item","","","03323888201","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("33","Emaan Light House","","","03070321705","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("34","Chilton Traders Karachi","","","03002601096","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("35","Hameed Panel","","","03332724775","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("36","Fawad Wire","","","03133587094","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("37","New Shahid Pipe","","","03322068992","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("38","HUawei ","","","03004165651","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("39","Riaz Delux","","","03313637625","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("40","Paremount General","","","","","","","0222784103","","","","","","","1");
INSERT INTO supplier_information VALUES("41","Muneer Shop","","","03201396554","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("42","Haji Salman Karachi","","","03152432410","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("43","Royal Electri Karachi","","","03219260234","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("44","Sindh Electri Hyderabad","","","03463932532","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("45","Zahid Soomro Kotri","","","03123828189","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("46","Naeem Pant","","","03473534934","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("47","Haroon Pant","","","03423515803","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("48","S.K Fan","","","03453584812","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("49","Cash Item ","","","03433669338","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("50","Abdul Hammed Panel wala","","","03332724775","","","","","","","","","","","1");
INSERT INTO supplier_information VALUES("51","F Ali Iddress Karachi","","","03219244001","","","","","","","","","","","1");



DROP TABLE supplier_product;

CREATE TABLE `supplier_product` (
  `supplier_pr_id` int NOT NULL AUTO_INCREMENT,
  `product_id` varchar(30) CHARACTER SET utf8mb3 COLLATE utf8mb3_general_ci NOT NULL,
  `products_model` varchar(30) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `supplier_id` bigint NOT NULL,
  `supplier_price` float DEFAULT NULL,
  PRIMARY KEY (`supplier_pr_id`),
  KEY `product_id` (`product_id`),
  KEY `supplier_id` (`supplier_id`)
) ENGINE=InnoDB AUTO_INCREMENT=807 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

INSERT INTO supplier_product VALUES("1","1","","1","370");
INSERT INTO supplier_product VALUES("2","2","","1","190");
INSERT INTO supplier_product VALUES("4","4","","2","290");
INSERT INTO supplier_product VALUES("5","5","","2","450");
INSERT INTO supplier_product VALUES("6","6","","2","150");
INSERT INTO supplier_product VALUES("7","7","","2","320");
INSERT INTO supplier_product VALUES("8","8","","3","550");
INSERT INTO supplier_product VALUES("9","9","","3","430");
INSERT INTO supplier_product VALUES("10","10","","3","210");
INSERT INTO supplier_product VALUES("12","12","","3","135");
INSERT INTO supplier_product VALUES("13","13","","3","400");
INSERT INTO supplier_product VALUES("14","14","","3","165");
INSERT INTO supplier_product VALUES("15","11","","3","105");
INSERT INTO supplier_product VALUES("16","15","","4","135");
INSERT INTO supplier_product VALUES("17","16","","4","110");
INSERT INTO supplier_product VALUES("18","17","","4","180");
INSERT INTO supplier_product VALUES("19","18","","4","75");
INSERT INTO supplier_product VALUES("20","19","","4","70");
INSERT INTO supplier_product VALUES("21","20","","4","115");
INSERT INTO supplier_product VALUES("22","21","","4","130");
INSERT INTO supplier_product VALUES("23","3 ","","1","300");
INSERT INTO supplier_product VALUES("24","22","","7","15");
INSERT INTO supplier_product VALUES("25","23","","7","1500");
INSERT INTO supplier_product VALUES("26","24","","7","750");
INSERT INTO supplier_product VALUES("27","25","","7","1800");
INSERT INTO supplier_product VALUES("28","26","","7","15");
INSERT INTO supplier_product VALUES("29","27","","7","33");
INSERT INTO supplier_product VALUES("30","28","","7","120");
INSERT INTO supplier_product VALUES("31","29","","7","40");
INSERT INTO supplier_product VALUES("32","30","","7","1900");
INSERT INTO supplier_product VALUES("33","31","","8","1700");
INSERT INTO supplier_product VALUES("34","32","","8","750");
INSERT INTO supplier_product VALUES("35","33","","8","700");
INSERT INTO supplier_product VALUES("36","34","","8","350");
INSERT INTO supplier_product VALUES("37","35","","8","1000");
INSERT INTO supplier_product VALUES("38","36","","8","2500");
INSERT INTO supplier_product VALUES("39","37","","8","10");
INSERT INTO supplier_product VALUES("40","38","","8","20");
INSERT INTO supplier_product VALUES("41","39","","8","20");
INSERT INTO supplier_product VALUES("42","40","","8","15");
INSERT INTO supplier_product VALUES("43","41","","9","45");
INSERT INTO supplier_product VALUES("44","42","","9","170");
INSERT INTO supplier_product VALUES("45","43","","9","220");
INSERT INTO supplier_product VALUES("46","45","","9","180");
INSERT INTO supplier_product VALUES("47","46","","9","150");
INSERT INTO supplier_product VALUES("49","48","","9","150");
INSERT INTO supplier_product VALUES("50","49","","9","160");
INSERT INTO supplier_product VALUES("51","50","","9","120");
INSERT INTO supplier_product VALUES("52","51","","9","250");
INSERT INTO supplier_product VALUES("53","52","","9","450");
INSERT INTO supplier_product VALUES("54","53","","10","480");
INSERT INTO supplier_product VALUES("55","54","","10","255");
INSERT INTO supplier_product VALUES("56","47","","9","320");
INSERT INTO supplier_product VALUES("57","55","","10","280");
INSERT INTO supplier_product VALUES("58","56","","10","1000");
INSERT INTO supplier_product VALUES("59","57","","10","140");
INSERT INTO supplier_product VALUES("60","58","","10","115");
INSERT INTO supplier_product VALUES("61","59","","10","165");
INSERT INTO supplier_product VALUES("62","60","","10","200");
INSERT INTO supplier_product VALUES("63","61","","10","160");
INSERT INTO supplier_product VALUES("64","62","","10","1500");
INSERT INTO supplier_product VALUES("65","63","","11","4900");
INSERT INTO supplier_product VALUES("66","64","","11","4900");
INSERT INTO supplier_product VALUES("67","65","","11","10300");
INSERT INTO supplier_product VALUES("68","66","","11","10300");
INSERT INTO supplier_product VALUES("69","67","","11","2600");
INSERT INTO supplier_product VALUES("70","68","","11","2600");
INSERT INTO supplier_product VALUES("71","69","","11","5200");
INSERT INTO supplier_product VALUES("72","70","","11","5200");
INSERT INTO supplier_product VALUES("73","71","","11","2250");
INSERT INTO supplier_product VALUES("74","72","","11","2250");
INSERT INTO supplier_product VALUES("75","73","","11","2250");
INSERT INTO supplier_product VALUES("76","74","","11","6500");
INSERT INTO supplier_product VALUES("77","75","","11","6500");
INSERT INTO supplier_product VALUES("78","76","","11","9100");
INSERT INTO supplier_product VALUES("79","77","","11","9100");
INSERT INTO supplier_product VALUES("80","78","","13","160");
INSERT INTO supplier_product VALUES("81","79","","13","120");
INSERT INTO supplier_product VALUES("82","80","","13","80");
INSERT INTO supplier_product VALUES("83","81","","13","80");
INSERT INTO supplier_product VALUES("84","82","","13","170");
INSERT INTO supplier_product VALUES("86","84","","13","450");
INSERT INTO supplier_product VALUES("87","83","","13","450");
INSERT INTO supplier_product VALUES("88","85","","14","660");
INSERT INTO supplier_product VALUES("89","86","","14","390");
INSERT INTO supplier_product VALUES("95","92","","14","260");
INSERT INTO supplier_product VALUES("97","88 ","","14","1320");
INSERT INTO supplier_product VALUES("102","93","","14","270");
INSERT INTO supplier_product VALUES("103","90","","14","900");
INSERT INTO supplier_product VALUES("104","91","","14","540");
INSERT INTO supplier_product VALUES("105","94","","15","585");
INSERT INTO supplier_product VALUES("106","95","","15","390");
INSERT INTO supplier_product VALUES("107","96","","15","260");
INSERT INTO supplier_product VALUES("108","97","","15","800");
INSERT INTO supplier_product VALUES("109","98","","15","850");
INSERT INTO supplier_product VALUES("113","102","","18","450");
INSERT INTO supplier_product VALUES("114","103","","18","320");
INSERT INTO supplier_product VALUES("115","104","","18","300");
INSERT INTO supplier_product VALUES("116","100","","16","300");
INSERT INTO supplier_product VALUES("117","101","","16","550");
INSERT INTO supplier_product VALUES("120","105","","19","510");
INSERT INTO supplier_product VALUES("121","106","","19","380");
INSERT INTO supplier_product VALUES("122","107","","19","460");
INSERT INTO supplier_product VALUES("123","108","","19","300");
INSERT INTO supplier_product VALUES("124","109","","19","600");
INSERT INTO supplier_product VALUES("125","110","","19","1296");
INSERT INTO supplier_product VALUES("126","111","","19","1000");
INSERT INTO supplier_product VALUES("127","112","","19","280");
INSERT INTO supplier_product VALUES("128","113","","20","840");
INSERT INTO supplier_product VALUES("129","114","","20","480");
INSERT INTO supplier_product VALUES("130","115","","20","620");
INSERT INTO supplier_product VALUES("131","116","","22","550");
INSERT INTO supplier_product VALUES("132","117","","22","300");
INSERT INTO supplier_product VALUES("133","118","","22","300");
INSERT INTO supplier_product VALUES("134","119","","22","600");
INSERT INTO supplier_product VALUES("135","120","","22","700");
INSERT INTO supplier_product VALUES("136","121","","22","300");
INSERT INTO supplier_product VALUES("137","122","","22","340");
INSERT INTO supplier_product VALUES("138","123","","22","300");
INSERT INTO supplier_product VALUES("139","124","","23","500");
INSERT INTO supplier_product VALUES("140","125","","23","375");
INSERT INTO supplier_product VALUES("141","126","","23","460");
INSERT INTO supplier_product VALUES("144","129","","23","275");
INSERT INTO supplier_product VALUES("145","130","","23","360");
INSERT INTO supplier_product VALUES("146","131","","23","240");
INSERT INTO supplier_product VALUES("147","132","","23","240");
INSERT INTO supplier_product VALUES("148","133","","23","240");
INSERT INTO supplier_product VALUES("149","134","","23","160");
INSERT INTO supplier_product VALUES("150","135","","24","2961");
INSERT INTO supplier_product VALUES("151","136","","24","2961");
INSERT INTO supplier_product VALUES("152","137","","24","2961");
INSERT INTO supplier_product VALUES("153","138","","24","2961");
INSERT INTO supplier_product VALUES("154","139","","24","2961");
INSERT INTO supplier_product VALUES("155","140","","24","2961");
INSERT INTO supplier_product VALUES("156","141","","24","6146");
INSERT INTO supplier_product VALUES("157","142","","24","6146");
INSERT INTO supplier_product VALUES("158","143","","24","6146");
INSERT INTO supplier_product VALUES("159","144","","24","6146");
INSERT INTO supplier_product VALUES("160","145","","24","9331");
INSERT INTO supplier_product VALUES("161","146","","24","9331");
INSERT INTO supplier_product VALUES("162","147","","24","14986");
INSERT INTO supplier_product VALUES("163","148","","24","14986");
INSERT INTO supplier_product VALUES("164","149","","24","1044");
INSERT INTO supplier_product VALUES("165","150","","24","1044");
INSERT INTO supplier_product VALUES("166","151","","24","1557");
INSERT INTO supplier_product VALUES("167","152","","24","1557");
INSERT INTO supplier_product VALUES("168","153","","24","2292");
INSERT INTO supplier_product VALUES("169","154","","24","2292");
INSERT INTO supplier_product VALUES("170","155","","24","3208");
INSERT INTO supplier_product VALUES("171","156","","24","3208");
INSERT INTO supplier_product VALUES("172","157","","24","4190");
INSERT INTO supplier_product VALUES("173","158","","24","4190");
INSERT INTO supplier_product VALUES("174","159","","24","5126");
INSERT INTO supplier_product VALUES("175","160","","24","5126");
INSERT INTO supplier_product VALUES("176","161","","24","4391");
INSERT INTO supplier_product VALUES("177","162","","24","3351");
INSERT INTO supplier_product VALUES("182","163","","25","580");
INSERT INTO supplier_product VALUES("183","164","","25","500");
INSERT INTO supplier_product VALUES("184","165","","25","380");
INSERT INTO supplier_product VALUES("185","166","","25","330");
INSERT INTO supplier_product VALUES("186","167","","25","240");
INSERT INTO supplier_product VALUES("187","168","","25","800");
INSERT INTO supplier_product VALUES("188","169","","25","700");
INSERT INTO supplier_product VALUES("189","170","","25","450");
INSERT INTO supplier_product VALUES("190","171","","25","300");
INSERT INTO supplier_product VALUES("191","172","","25","150");
INSERT INTO supplier_product VALUES("192","173","","25","210");
INSERT INTO supplier_product VALUES("193","174","","25","300");
INSERT INTO supplier_product VALUES("198","179","","25","36");
INSERT INTO supplier_product VALUES("199","180","","25","27");
INSERT INTO supplier_product VALUES("200","181","","25","165");
INSERT INTO supplier_product VALUES("201","182","","25","90");
INSERT INTO supplier_product VALUES("206","87","","14","270");
INSERT INTO supplier_product VALUES("207","89","","14","280");
INSERT INTO supplier_product VALUES("208","185","","26","8500");
INSERT INTO supplier_product VALUES("209","186","","26","5500");
INSERT INTO supplier_product VALUES("211","187","","26","6500");
INSERT INTO supplier_product VALUES("212","188","","26","5600");
INSERT INTO supplier_product VALUES("213","189","","26","3350");
INSERT INTO supplier_product VALUES("214","190","","26","2500");
INSERT INTO supplier_product VALUES("215","191","","26","1700");
INSERT INTO supplier_product VALUES("216","192","","26","1100");
INSERT INTO supplier_product VALUES("220","196","","26","380");
INSERT INTO supplier_product VALUES("221","197","","26","1500");
INSERT INTO supplier_product VALUES("222","198","","26","2100");
INSERT INTO supplier_product VALUES("223","199","","26","1900");
INSERT INTO supplier_product VALUES("224","194","","26","1500");
INSERT INTO supplier_product VALUES("225","193","","26","1700");
INSERT INTO supplier_product VALUES("226","195","","26","1300");
INSERT INTO supplier_product VALUES("227","200","","27","900");
INSERT INTO supplier_product VALUES("228","201","","27","800");
INSERT INTO supplier_product VALUES("229","202","","27","900");
INSERT INTO supplier_product VALUES("230","203","","27","1100");
INSERT INTO supplier_product VALUES("231","204","","27","1300");
INSERT INTO supplier_product VALUES("232","205","","27","900");
INSERT INTO supplier_product VALUES("233","206","","27","1200");
INSERT INTO supplier_product VALUES("234","207","","27","1300");
INSERT INTO supplier_product VALUES("235","208","","27","1500");
INSERT INTO supplier_product VALUES("236","209","","27","1700");
INSERT INTO supplier_product VALUES("238","211","","27","100");
INSERT INTO supplier_product VALUES("239","212","","27","105");
INSERT INTO supplier_product VALUES("240","210","","27","70");
INSERT INTO supplier_product VALUES("241","213","","28","170");
INSERT INTO supplier_product VALUES("242","214","","28","480");
INSERT INTO supplier_product VALUES("243","215","","28","150");
INSERT INTO supplier_product VALUES("244","216","","28","1600");
INSERT INTO supplier_product VALUES("245","217","","28","180");
INSERT INTO supplier_product VALUES("246","218","","28","170");
INSERT INTO supplier_product VALUES("247","219","","28","380");
INSERT INTO supplier_product VALUES("248","220","","28","180");
INSERT INTO supplier_product VALUES("249","221","","28","500");
INSERT INTO supplier_product VALUES("250","222","","28","230");
INSERT INTO supplier_product VALUES("251","223","","28","1250");
INSERT INTO supplier_product VALUES("252","224","","28","550");
INSERT INTO supplier_product VALUES("253","225","","28","480");
INSERT INTO supplier_product VALUES("254","226","","28","1600");
INSERT INTO supplier_product VALUES("255","227","","28","100");
INSERT INTO supplier_product VALUES("256","228","","28","3500");
INSERT INTO supplier_product VALUES("257","229","","28","5000");
INSERT INTO supplier_product VALUES("258","230","","28","4600");
INSERT INTO supplier_product VALUES("259","231","","28","550");
INSERT INTO supplier_product VALUES("260","232","","28","750");
INSERT INTO supplier_product VALUES("262","234","","29","920");
INSERT INTO supplier_product VALUES("263","235","","29","1100");
INSERT INTO supplier_product VALUES("264","236","","29","920");
INSERT INTO supplier_product VALUES("265","237","","29","530");
INSERT INTO supplier_product VALUES("266","238","","29","320");
INSERT INTO supplier_product VALUES("267","239","","29","360");
INSERT INTO supplier_product VALUES("268","240","","29","260");
INSERT INTO supplier_product VALUES("269","241","","29","160");
INSERT INTO supplier_product VALUES("270","242","","29","490");
INSERT INTO supplier_product VALUES("271","243","","29","430");
INSERT INTO supplier_product VALUES("272","244","","29","5500");
INSERT INTO supplier_product VALUES("273","245","","29","2800");
INSERT INTO supplier_product VALUES("274","246","","29","4000");
INSERT INTO supplier_product VALUES("275","247","","29","650");
INSERT INTO supplier_product VALUES("276","248","","29","320");
INSERT INTO supplier_product VALUES("277","249","","29","1600");
INSERT INTO supplier_product VALUES("278","250","","29","250");
INSERT INTO supplier_product VALUES("279","251","","29","275");
INSERT INTO supplier_product VALUES("280","252","","29","310");
INSERT INTO supplier_product VALUES("281","253","","29","280");
INSERT INTO supplier_product VALUES("282","254","","29","230");
INSERT INTO supplier_product VALUES("283","255","","29","750");
INSERT INTO supplier_product VALUES("284","256","","29","800");
INSERT INTO supplier_product VALUES("285","257","","29","550");
INSERT INTO supplier_product VALUES("286","258","","29","450");
INSERT INTO supplier_product VALUES("287","259","","30","1200");
INSERT INTO supplier_product VALUES("288","260","","30","850");
INSERT INTO supplier_product VALUES("289","261","","30","600");
INSERT INTO supplier_product VALUES("290","262","","30","450");
INSERT INTO supplier_product VALUES("291","263","","30","350");
INSERT INTO supplier_product VALUES("292","264","","30","80");
INSERT INTO supplier_product VALUES("293","265","","30","120");
INSERT INTO supplier_product VALUES("294","266","","30","220");
INSERT INTO supplier_product VALUES("295","267","","30","360");
INSERT INTO supplier_product VALUES("296","268","","30","2100");
INSERT INTO supplier_product VALUES("297","269","","30","110");
INSERT INTO supplier_product VALUES("298","270","","30","160");
INSERT INTO supplier_product VALUES("299","271","","30","120");
INSERT INTO supplier_product VALUES("300","272","","30","220");
INSERT INTO supplier_product VALUES("301","273","","30","800");
INSERT INTO supplier_product VALUES("302","274","","30","360");
INSERT INTO supplier_product VALUES("303","275","","30","100");
INSERT INTO supplier_product VALUES("304","276","","30","180");
INSERT INTO supplier_product VALUES("305","277","","30","240");
INSERT INTO supplier_product VALUES("306","278","","30","180");
INSERT INTO supplier_product VALUES("307","279","","30","260");
INSERT INTO supplier_product VALUES("308","280","","30","360");
INSERT INTO supplier_product VALUES("309","281","","30","25");
INSERT INTO supplier_product VALUES("310","282","","30","32");
INSERT INTO supplier_product VALUES("311","283","","30","30");
INSERT INTO supplier_product VALUES("312","284","","30","40");
INSERT INTO supplier_product VALUES("313","285","","30","240");
INSERT INTO supplier_product VALUES("314","286","","30","180");
INSERT INTO supplier_product VALUES("315","287","","30","280");
INSERT INTO supplier_product VALUES("316","288","","30","70");
INSERT INTO supplier_product VALUES("321","293","","31","4391");
INSERT INTO supplier_product VALUES("322","294","","31","7121");
INSERT INTO supplier_product VALUES("323","295","","31","3936");
INSERT INTO supplier_product VALUES("324","296","","31","3351");
INSERT INTO supplier_product VALUES("325","297","","31","15761");
INSERT INTO supplier_product VALUES("326","298","","31","10761");
INSERT INTO supplier_product VALUES("329","301","","31","11671");
INSERT INTO supplier_product VALUES("330","302","","31","16689");
INSERT INTO supplier_product VALUES("340","289","","31","2961");
INSERT INTO supplier_product VALUES("341","290","","31","6146");
INSERT INTO supplier_product VALUES("342","291","","31","9331");
INSERT INTO supplier_product VALUES("343","292","","31","14986");
INSERT INTO supplier_product VALUES("344","299","","31","4092");
INSERT INTO supplier_product VALUES("345","300","","31","8707");
INSERT INTO supplier_product VALUES("346","311","","31","2961");
INSERT INTO supplier_product VALUES("347","312","","31","2961");
INSERT INTO supplier_product VALUES("348","313","","31","2961");
INSERT INTO supplier_product VALUES("349","314","","31","2961");
INSERT INTO supplier_product VALUES("350","315","","31","2961");
INSERT INTO supplier_product VALUES("351","316","","31","6146");
INSERT INTO supplier_product VALUES("352","317","","31","6146");
INSERT INTO supplier_product VALUES("353","318","","31","6146");
INSERT INTO supplier_product VALUES("354","319","","31","6146");
INSERT INTO supplier_product VALUES("355","320","","31","6146");
INSERT INTO supplier_product VALUES("356","321","","31","9331");
INSERT INTO supplier_product VALUES("357","322","","31","14986");
INSERT INTO supplier_product VALUES("358","323","","31","4092");
INSERT INTO supplier_product VALUES("359","324","","31","4092");
INSERT INTO supplier_product VALUES("360","325","","31","4092");
INSERT INTO supplier_product VALUES("361","326","","31","4092");
INSERT INTO supplier_product VALUES("362","327","","31","8707");
INSERT INTO supplier_product VALUES("363","328","","31","8707");
INSERT INTO supplier_product VALUES("364","329","","31","8707");
INSERT INTO supplier_product VALUES("365","330","","31","8707");
INSERT INTO supplier_product VALUES("366","331","","31","11671");
INSERT INTO supplier_product VALUES("367","332","","31","11671");
INSERT INTO supplier_product VALUES("368","333","","31","16689");
INSERT INTO supplier_product VALUES("369","334","","31","16689");
INSERT INTO supplier_product VALUES("370","335","","31","2376");
INSERT INTO supplier_product VALUES("371","336","","31","2376");
INSERT INTO supplier_product VALUES("372","337","","31","4911");
INSERT INTO supplier_product VALUES("373","338","","31","4911");
INSERT INTO supplier_product VALUES("374","339","","31","7381");
INSERT INTO supplier_product VALUES("375","340","","31","7381");
INSERT INTO supplier_product VALUES("376","341","","31","10891");
INSERT INTO supplier_product VALUES("377","342","","31","10891");
INSERT INTO supplier_product VALUES("378","303","","31","1500");
INSERT INTO supplier_product VALUES("379","343","","31","1500");
INSERT INTO supplier_product VALUES("380","304","","31","2000");
INSERT INTO supplier_product VALUES("381","344","","31","2000");
INSERT INTO supplier_product VALUES("382","305","","31","2900");
INSERT INTO supplier_product VALUES("383","345","","31","2900");
INSERT INTO supplier_product VALUES("385","346","","31","4600");
INSERT INTO supplier_product VALUES("386","307","","31","6000");
INSERT INTO supplier_product VALUES("387","347","","31","6000");
INSERT INTO supplier_product VALUES("388","308","","31","2700");
INSERT INTO supplier_product VALUES("389","348","","31","2700");
INSERT INTO supplier_product VALUES("392","309","","31","6000");
INSERT INTO supplier_product VALUES("393","349","","31","6000");
INSERT INTO supplier_product VALUES("394","310","","31","8700");
INSERT INTO supplier_product VALUES("395","350","","31","8700");
INSERT INTO supplier_product VALUES("396","351","","31","2800");
INSERT INTO supplier_product VALUES("397","352","","31","2800");
INSERT INTO supplier_product VALUES("398","353","","31","2800");
INSERT INTO supplier_product VALUES("399","354","","31","5800");
INSERT INTO supplier_product VALUES("400","355","","31","5800");
INSERT INTO supplier_product VALUES("401","356","","31","5800");
INSERT INTO supplier_product VALUES("402","357","","31","8800");
INSERT INTO supplier_product VALUES("403","358","","31","8800");
INSERT INTO supplier_product VALUES("404","359","","31","14400");
INSERT INTO supplier_product VALUES("405","360","","31","14400");
INSERT INTO supplier_product VALUES("407","362","","31","3800");
INSERT INTO supplier_product VALUES("408","361","","31","3800");
INSERT INTO supplier_product VALUES("410","364","","31","15000");
INSERT INTO supplier_product VALUES("411","365","","31","70");
INSERT INTO supplier_product VALUES("412","366","","31","46");
INSERT INTO supplier_product VALUES("413","367","","31","30");
INSERT INTO supplier_product VALUES("414","368","","31","120");
INSERT INTO supplier_product VALUES("415","369","","32","7500");
INSERT INTO supplier_product VALUES("416","370","","32","2000");
INSERT INTO supplier_product VALUES("417","371","","32","3000");
INSERT INTO supplier_product VALUES("418","372","","32","4000");
INSERT INTO supplier_product VALUES("419","373","","32","1500");
INSERT INTO supplier_product VALUES("420","374","","32","400");
INSERT INTO supplier_product VALUES("421","375","","32","2000");
INSERT INTO supplier_product VALUES("422","376","","32","1500");
INSERT INTO supplier_product VALUES("423","377","","32","300");
INSERT INTO supplier_product VALUES("424","378","","32","200");
INSERT INTO supplier_product VALUES("425","379","","32","300");
INSERT INTO supplier_product VALUES("426","380","","32","300");
INSERT INTO supplier_product VALUES("427","381","","32","400");
INSERT INTO supplier_product VALUES("428","382","","32","550");
INSERT INTO supplier_product VALUES("429","383","","32","350");
INSERT INTO supplier_product VALUES("431","306","","31","4600");
INSERT INTO supplier_product VALUES("432","384","","31","4600");
INSERT INTO supplier_product VALUES("433","385","","33","2750");
INSERT INTO supplier_product VALUES("434","386","","33","300");
INSERT INTO supplier_product VALUES("437","389","","33","336");
INSERT INTO supplier_product VALUES("438","390","","33","560");
INSERT INTO supplier_product VALUES("439","391","","33","270");
INSERT INTO supplier_product VALUES("440","392","","33","280");
INSERT INTO supplier_product VALUES("441","393","","33","560");
INSERT INTO supplier_product VALUES("442","394","","33","300");
INSERT INTO supplier_product VALUES("443","395","","33","50");
INSERT INTO supplier_product VALUES("444","396","","33","40");
INSERT INTO supplier_product VALUES("445","397","","33","50");
INSERT INTO supplier_product VALUES("446","398","","33","486");
INSERT INTO supplier_product VALUES("447","399","","33","287");
INSERT INTO supplier_product VALUES("448","400","","33","226");
INSERT INTO supplier_product VALUES("449","401","","33","475");
INSERT INTO supplier_product VALUES("450","402","","33","250");
INSERT INTO supplier_product VALUES("451","387","","33","486");
INSERT INTO supplier_product VALUES("452","403","","33","450");
INSERT INTO supplier_product VALUES("453","404","","33","125");
INSERT INTO supplier_product VALUES("454","405","","33","850");
INSERT INTO supplier_product VALUES("455","406","","33","336");
INSERT INTO supplier_product VALUES("456","407","","33","330");
INSERT INTO supplier_product VALUES("457","408","","33","100");
INSERT INTO supplier_product VALUES("458","409","","33","820");
INSERT INTO supplier_product VALUES("459","410","","11","1650");
INSERT INTO supplier_product VALUES("460","411","","11","3300");
INSERT INTO supplier_product VALUES("462","413","","11","7750");
INSERT INTO supplier_product VALUES("463","414","","11","6900");
INSERT INTO supplier_product VALUES("464","415","","11","5800");
INSERT INTO supplier_product VALUES("465","416","","11","5000");
INSERT INTO supplier_product VALUES("466","417","","11","4300");
INSERT INTO supplier_product VALUES("467","418","","11","4300");
INSERT INTO supplier_product VALUES("468","412","","11","8800");
INSERT INTO supplier_product VALUES("469","419","","24","6731");
INSERT INTO supplier_product VALUES("470","420","","24","3936");
INSERT INTO supplier_product VALUES("471","421","","30","36");
INSERT INTO supplier_product VALUES("472","422","","30","30");
INSERT INTO supplier_product VALUES("473","423","","49","4100");
INSERT INTO supplier_product VALUES("474","424","","49","900");
INSERT INTO supplier_product VALUES("475","425","","49","1600");
INSERT INTO supplier_product VALUES("476","426","","49","8000");
INSERT INTO supplier_product VALUES("477","427","","49","1200");
INSERT INTO supplier_product VALUES("478","428","","49","5500");
INSERT INTO supplier_product VALUES("479","429","","49","2000");
INSERT INTO supplier_product VALUES("480","430","","49","150");
INSERT INTO supplier_product VALUES("481","431","","49","150");
INSERT INTO supplier_product VALUES("482","432","","49","4000");
INSERT INTO supplier_product VALUES("483","433","","49","1050");
INSERT INTO supplier_product VALUES("484","434","","49","6500");
INSERT INTO supplier_product VALUES("485","435","","49","150");
INSERT INTO supplier_product VALUES("486","436","","49","1500");
INSERT INTO supplier_product VALUES("487","437","","49","200");
INSERT INTO supplier_product VALUES("488","438","","49","300");
INSERT INTO supplier_product VALUES("489","439","","49","250");
INSERT INTO supplier_product VALUES("490","440","","49","450");
INSERT INTO supplier_product VALUES("491","441","","49","300");
INSERT INTO supplier_product VALUES("492","442","","49","120");
INSERT INTO supplier_product VALUES("493","443","","49","300");
INSERT INTO supplier_product VALUES("494","444","","49","150");
INSERT INTO supplier_product VALUES("495","445","","49","150");
INSERT INTO supplier_product VALUES("496","446","","49","1450");
INSERT INTO supplier_product VALUES("497","447","","49","850");
INSERT INTO supplier_product VALUES("498","448","","40","120");
INSERT INTO supplier_product VALUES("500","450","","40","150");
INSERT INTO supplier_product VALUES("501","451","","40","70");
INSERT INTO supplier_product VALUES("502","452 ","","40","292");
INSERT INTO supplier_product VALUES("503","449","","40","90");
INSERT INTO supplier_product VALUES("504","453","","49","250");
INSERT INTO supplier_product VALUES("505","454","","49","370");
INSERT INTO supplier_product VALUES("506","455","","49","230");
INSERT INTO supplier_product VALUES("507","456","","49","410");
INSERT INTO supplier_product VALUES("508","457","","49","450");
INSERT INTO supplier_product VALUES("509","458","","49","60");
INSERT INTO supplier_product VALUES("510","459","","49","1100");
INSERT INTO supplier_product VALUES("511","460","","49","1000");
INSERT INTO supplier_product VALUES("512","461","","49","1500");
INSERT INTO supplier_product VALUES("513","462","","49","8650");
INSERT INTO supplier_product VALUES("514","463","","49","420");
INSERT INTO supplier_product VALUES("515","464","","49","500");
INSERT INTO supplier_product VALUES("516","465","","49","1100");
INSERT INTO supplier_product VALUES("517","466","","49","350");
INSERT INTO supplier_product VALUES("518","467","","49","335");
INSERT INTO supplier_product VALUES("519","468","","49","225");
INSERT INTO supplier_product VALUES("520","469","","49","1050");
INSERT INTO supplier_product VALUES("521","470 ","","49","60");
INSERT INTO supplier_product VALUES("522","471 ","","49","1180");
INSERT INTO supplier_product VALUES("523","472 ","","49","150");
INSERT INTO supplier_product VALUES("524","473","","49","350");
INSERT INTO supplier_product VALUES("525","474","","49","100");
INSERT INTO supplier_product VALUES("526","475","","49","24");
INSERT INTO supplier_product VALUES("527","476","","49","90");
INSERT INTO supplier_product VALUES("528","479","","49","1100");
INSERT INTO supplier_product VALUES("531","482","","49","1250");
INSERT INTO supplier_product VALUES("532","483","","49","100");
INSERT INTO supplier_product VALUES("533","484","","49","275");
INSERT INTO supplier_product VALUES("534","488","","30","2400");
INSERT INTO supplier_product VALUES("535","489","","30","1500");
INSERT INTO supplier_product VALUES("536","490","","2","90");
INSERT INTO supplier_product VALUES("537","491","","2","190");
INSERT INTO supplier_product VALUES("538","492","","14","235");
INSERT INTO supplier_product VALUES("539","493","","14","1800");
INSERT INTO supplier_product VALUES("540","494","","14","290");
INSERT INTO supplier_product VALUES("542","496","","14","38");
INSERT INTO supplier_product VALUES("543","495","","14","650");
INSERT INTO supplier_product VALUES("544","497","","40","160");
INSERT INTO supplier_product VALUES("545","498","","40","250");
INSERT INTO supplier_product VALUES("546","499","","40","152");
INSERT INTO supplier_product VALUES("547","500","","40","650");
INSERT INTO supplier_product VALUES("548","501","","40","240");
INSERT INTO supplier_product VALUES("549","502","","43","10000");
INSERT INTO supplier_product VALUES("550","503","","43","12000");
INSERT INTO supplier_product VALUES("551","504","","43","60");
INSERT INTO supplier_product VALUES("552","505","","43","11000");
INSERT INTO supplier_product VALUES("553","506","","43","1320");
INSERT INTO supplier_product VALUES("554","507","","43","3");
INSERT INTO supplier_product VALUES("555","508","","45","300");
INSERT INTO supplier_product VALUES("556","509","","45","4600");
INSERT INTO supplier_product VALUES("557","510","","45","33");
INSERT INTO supplier_product VALUES("558","511","","45","8700");
INSERT INTO supplier_product VALUES("559","512","","45","80");
INSERT INTO supplier_product VALUES("560","513","","45","140");
INSERT INTO supplier_product VALUES("561","514","","45","50");
INSERT INTO supplier_product VALUES("562","515","","45","175");
INSERT INTO supplier_product VALUES("563","516","","45","30");
INSERT INTO supplier_product VALUES("564","517","","45","12");
INSERT INTO supplier_product VALUES("565","518","","45","600");
INSERT INTO supplier_product VALUES("566","519","","45","900");
INSERT INTO supplier_product VALUES("567","520","","45","120");
INSERT INTO supplier_product VALUES("568","521","","45","120");
INSERT INTO supplier_product VALUES("569","522","","45","50");
INSERT INTO supplier_product VALUES("570","523","","45","10");
INSERT INTO supplier_product VALUES("574","527","","45","660");
INSERT INTO supplier_product VALUES("575","528","","45","550");
INSERT INTO supplier_product VALUES("576","529","","45","850");
INSERT INTO supplier_product VALUES("577","530","","45","850");
INSERT INTO supplier_product VALUES("578","531 ","","45","700");
INSERT INTO supplier_product VALUES("579","532","","45","1600");
INSERT INTO supplier_product VALUES("580","533","","45","480");
INSERT INTO supplier_product VALUES("581","534","","45","130");
INSERT INTO supplier_product VALUES("582","535","","45","130");
INSERT INTO supplier_product VALUES("583","536","","45","180");
INSERT INTO supplier_product VALUES("586","539","","45","90");
INSERT INTO supplier_product VALUES("587","540","","45","15");
INSERT INTO supplier_product VALUES("588","541 ","","45","650");
INSERT INTO supplier_product VALUES("589","542","","45","3500");
INSERT INTO supplier_product VALUES("590","543","","45","30");
INSERT INTO supplier_product VALUES("591","544","","45","450");
INSERT INTO supplier_product VALUES("592","545","","45","250");
INSERT INTO supplier_product VALUES("593","546","","45","35");
INSERT INTO supplier_product VALUES("594","547","","45","3100");
INSERT INTO supplier_product VALUES("595","548","","45","3500");
INSERT INTO supplier_product VALUES("596","549","","45","1700");
INSERT INTO supplier_product VALUES("599","552","","45","1800");
INSERT INTO supplier_product VALUES("600","553","","45","850");
INSERT INTO supplier_product VALUES("601","554","","45","500");
INSERT INTO supplier_product VALUES("602","555","","45","1500");
INSERT INTO supplier_product VALUES("603","556","","45","3100");
INSERT INTO supplier_product VALUES("604","557","","45","230");
INSERT INTO supplier_product VALUES("605","558","","45","800");
INSERT INTO supplier_product VALUES("606","559","","45","50");
INSERT INTO supplier_product VALUES("607","560","","45","310");
INSERT INTO supplier_product VALUES("608","561","","45","2150");
INSERT INTO supplier_product VALUES("609","562","","45","700");
INSERT INTO supplier_product VALUES("610","563","","45","380");
INSERT INTO supplier_product VALUES("611","550","","45","200");
INSERT INTO supplier_product VALUES("612","551","","45","140");
INSERT INTO supplier_product VALUES("613","537","","45","160");
INSERT INTO supplier_product VALUES("614","524","","45","700");
INSERT INTO supplier_product VALUES("615","525","","45","1150");
INSERT INTO supplier_product VALUES("616","526","","45","1445");
INSERT INTO supplier_product VALUES("617","538","","45","160");
INSERT INTO supplier_product VALUES("618","564","","47","290");
INSERT INTO supplier_product VALUES("619","565","","47","2500");
INSERT INTO supplier_product VALUES("620","566","","47","2500");
INSERT INTO supplier_product VALUES("621","567","","47","1250");
INSERT INTO supplier_product VALUES("622","568","","47","200");
INSERT INTO supplier_product VALUES("623","569","","47","200");
INSERT INTO supplier_product VALUES("624","570","","46","600");
INSERT INTO supplier_product VALUES("625","571","","44","39500");
INSERT INTO supplier_product VALUES("626","572","","39","250");
INSERT INTO supplier_product VALUES("627","573","","39","100");
INSERT INTO supplier_product VALUES("628","574","","49","14500");
INSERT INTO supplier_product VALUES("630","575","","48","3500");
INSERT INTO supplier_product VALUES("631","576","","34","15500");
INSERT INTO supplier_product VALUES("632","577","","50","1250");
INSERT INTO supplier_product VALUES("633","578","","50","2000");
INSERT INTO supplier_product VALUES("634","579","","50","2200");
INSERT INTO supplier_product VALUES("635","580","","50","5500");
INSERT INTO supplier_product VALUES("636","581","","50","1000");
INSERT INTO supplier_product VALUES("637","582","","50","1500");
INSERT INTO supplier_product VALUES("638","583","","50","2300");
INSERT INTO supplier_product VALUES("639","584","","50","2600");
INSERT INTO supplier_product VALUES("640","585","","45","2200");
INSERT INTO supplier_product VALUES("642","586","","45","120");
INSERT INTO supplier_product VALUES("643","587","","45","250");
INSERT INTO supplier_product VALUES("644","588","","45","240");
INSERT INTO supplier_product VALUES("645","589","","45","1650");
INSERT INTO supplier_product VALUES("646","590","","45","1250");
INSERT INTO supplier_product VALUES("647","591 ","","45","350");
INSERT INTO supplier_product VALUES("648","592","","28","482");
INSERT INTO supplier_product VALUES("649","593","","28","450");
INSERT INTO supplier_product VALUES("650","594","","28","290");
INSERT INTO supplier_product VALUES("651","595","","28","323");
INSERT INTO supplier_product VALUES("652","596","","28","336");
INSERT INTO supplier_product VALUES("653","597","","28","250");
INSERT INTO supplier_product VALUES("655","599","","28","120");
INSERT INTO supplier_product VALUES("656","598 ","","28","130");
INSERT INTO supplier_product VALUES("658","601","","28","230");
INSERT INTO supplier_product VALUES("659","602","","31","1500");
INSERT INTO supplier_product VALUES("660","603","","31","250");
INSERT INTO supplier_product VALUES("662","604","","4","175");
INSERT INTO supplier_product VALUES("663","606","","49","500");
INSERT INTO supplier_product VALUES("664","607","","49","285");
INSERT INTO supplier_product VALUES("666","609","","49","800");
INSERT INTO supplier_product VALUES("667","610","","49","1025");
INSERT INTO supplier_product VALUES("668","611","","49","300");
INSERT INTO supplier_product VALUES("669","612","","49","300");
INSERT INTO supplier_product VALUES("670","613","","49","1450");
INSERT INTO supplier_product VALUES("671","614","","49","200");
INSERT INTO supplier_product VALUES("672","615","","49","4800");
INSERT INTO supplier_product VALUES("673","617","","49","600");
INSERT INTO supplier_product VALUES("674","618","","49","300");
INSERT INTO supplier_product VALUES("675","619","","49","100");
INSERT INTO supplier_product VALUES("676","620","","49","5");
INSERT INTO supplier_product VALUES("677","621","","49","4800");
INSERT INTO supplier_product VALUES("678","622","","49","10");
INSERT INTO supplier_product VALUES("679","623","","49","26");
INSERT INTO supplier_product VALUES("680","624","","49","3700");
INSERT INTO supplier_product VALUES("682","627","","49","900");
INSERT INTO supplier_product VALUES("683","628","","49","900");
INSERT INTO supplier_product VALUES("684","629","","49","700");
INSERT INTO supplier_product VALUES("685","630","","49","1250");
INSERT INTO supplier_product VALUES("686","631","","49","1800");
INSERT INTO supplier_product VALUES("687","632","","49","1480");
INSERT INTO supplier_product VALUES("689","634","","49","8240");
INSERT INTO supplier_product VALUES("691","635","","49","120");
INSERT INTO supplier_product VALUES("692","633","","49","2200");
INSERT INTO supplier_product VALUES("693","636","","49","300");
INSERT INTO supplier_product VALUES("694","637","","49","2000");
INSERT INTO supplier_product VALUES("695","480 ","","49","500");
INSERT INTO supplier_product VALUES("696","638","","45","4150");
INSERT INTO supplier_product VALUES("697","639","","45","160");
INSERT INTO supplier_product VALUES("698","640","","45","260");
INSERT INTO supplier_product VALUES("699","641","","45","305");
INSERT INTO supplier_product VALUES("700","642","","45","6200");
INSERT INTO supplier_product VALUES("701","643","","45","1450");
INSERT INTO supplier_product VALUES("702","644","","45","500");
INSERT INTO supplier_product VALUES("703","645","","45","350");
INSERT INTO supplier_product VALUES("704","646","","45","145");
INSERT INTO supplier_product VALUES("705","647","","45","270");
INSERT INTO supplier_product VALUES("706","648","","45","300");
INSERT INTO supplier_product VALUES("707","649","","24","4555");
INSERT INTO supplier_product VALUES("708","650","","24","4555");
INSERT INTO supplier_product VALUES("709","651","","24","4555");
INSERT INTO supplier_product VALUES("710","652","","24","4555");
INSERT INTO supplier_product VALUES("711","653","","24","4555");
INSERT INTO supplier_product VALUES("712","654","","24","4555");
INSERT INTO supplier_product VALUES("713","656","","24","32455");
INSERT INTO supplier_product VALUES("714","657","","24","32455");
INSERT INTO supplier_product VALUES("715","658","","24","45755");
INSERT INTO supplier_product VALUES("718","661","","24","2395");
INSERT INTO supplier_product VALUES("719","659","","24","1605");
INSERT INTO supplier_product VALUES("720","660","","24","1605");
INSERT INTO supplier_product VALUES("721","662","","24","2395");
INSERT INTO supplier_product VALUES("722","663","","24","3525");
INSERT INTO supplier_product VALUES("723","664","","24","3525");
INSERT INTO supplier_product VALUES("724","665","","24","4935");
INSERT INTO supplier_product VALUES("725","666","","24","4935");
INSERT INTO supplier_product VALUES("726","667","","24","6445");
INSERT INTO supplier_product VALUES("727","668","","24","6445");
INSERT INTO supplier_product VALUES("728","669","","24","7885");
INSERT INTO supplier_product VALUES("729","670","","24","7885");
INSERT INTO supplier_product VALUES("730","671","","24","4555");
INSERT INTO supplier_product VALUES("731","672","","33","100");
INSERT INTO supplier_product VALUES("732","673","","33","580");
INSERT INTO supplier_product VALUES("733","674","","33","780");
INSERT INTO supplier_product VALUES("734","675","","33","50");
INSERT INTO supplier_product VALUES("735","776","","33","486");
INSERT INTO supplier_product VALUES("736","677","","33","475");
INSERT INTO supplier_product VALUES("737","678","","33","286");
INSERT INTO supplier_product VALUES("738","679","","33","259");
INSERT INTO supplier_product VALUES("739","680","","33","336");
INSERT INTO supplier_product VALUES("740","681","","33","310");
INSERT INTO supplier_product VALUES("741","682","","33","250");
INSERT INTO supplier_product VALUES("742","683","","33","330");
INSERT INTO supplier_product VALUES("743","684","","33","360");
INSERT INTO supplier_product VALUES("744","685","","33","360");
INSERT INTO supplier_product VALUES("745","686","","33","250");
INSERT INTO supplier_product VALUES("746","687","","33","230");
INSERT INTO supplier_product VALUES("747","688","","33","360");
INSERT INTO supplier_product VALUES("748","689","","33","286");
INSERT INTO supplier_product VALUES("749","690","","29","830");
INSERT INTO supplier_product VALUES("750","691","","29","1400");
INSERT INTO supplier_product VALUES("751","692","","29","1100");
INSERT INTO supplier_product VALUES("752","693","","29","130");
INSERT INTO supplier_product VALUES("753","694","","29","130");
INSERT INTO supplier_product VALUES("754","695","","29","280");
INSERT INTO supplier_product VALUES("755","696","","29","600");
INSERT INTO supplier_product VALUES("756","697","","29","400");
INSERT INTO supplier_product VALUES("757","698","","29","290");
INSERT INTO supplier_product VALUES("758","699","","29","320");
INSERT INTO supplier_product VALUES("759","700","","29","160");
INSERT INTO supplier_product VALUES("760","701","","29","1080");
INSERT INTO supplier_product VALUES("761","703","","29","900");
INSERT INTO supplier_product VALUES("762","704 ","","29","550");
INSERT INTO supplier_product VALUES("763","705","","29","250");
INSERT INTO supplier_product VALUES("764","706 ","","29","450");
INSERT INTO supplier_product VALUES("765","707","","29","150");
INSERT INTO supplier_product VALUES("766","708","","29","2550");
INSERT INTO supplier_product VALUES("767","709","","29","500");
INSERT INTO supplier_product VALUES("768","710","","40","270");
INSERT INTO supplier_product VALUES("769","711","","40","62");
INSERT INTO supplier_product VALUES("771","712","","51","320");
INSERT INTO supplier_product VALUES("772","713","","51","310");
INSERT INTO supplier_product VALUES("773","714","","51","325");
INSERT INTO supplier_product VALUES("774","715","","3","120");
INSERT INTO supplier_product VALUES("775","716","","3","190");
INSERT INTO supplier_product VALUES("776","717","","3","270");
INSERT INTO supplier_product VALUES("777","718","","3","220");
INSERT INTO supplier_product VALUES("778","608","","49","418");
INSERT INTO supplier_product VALUES("779","720","","10","5500");
INSERT INTO supplier_product VALUES("780","721","","48","6250");
INSERT INTO supplier_product VALUES("781","722","","8","264");
INSERT INTO supplier_product VALUES("782","723","","49","200");
INSERT INTO supplier_product VALUES("783","724","","49","240");
INSERT INTO supplier_product VALUES("784","725","","49","180");
INSERT INTO supplier_product VALUES("785","363","","31","320");
INSERT INTO supplier_product VALUES("786","726","","31","4800");
INSERT INTO supplier_product VALUES("787","727","","31","4800");
INSERT INTO supplier_product VALUES("788","99","","15","360");
INSERT INTO supplier_product VALUES("789","625","","49","41");
INSERT INTO supplier_product VALUES("790","481","","49","41");
INSERT INTO supplier_product VALUES("791","175","","25","125");
INSERT INTO supplier_product VALUES("793","183","","25","135");
INSERT INTO supplier_product VALUES("794","184","","25","120");
INSERT INTO supplier_product VALUES("795","177","","25","165");
INSERT INTO supplier_product VALUES("796","178","","25","80");
INSERT INTO supplier_product VALUES("797","176","","25","65");
INSERT INTO supplier_product VALUES("798","127","","23","400");
INSERT INTO supplier_product VALUES("799","128","","23","400");
INSERT INTO supplier_product VALUES("800","728","","30","260");
INSERT INTO supplier_product VALUES("801","600","","28","42");
INSERT INTO supplier_product VALUES("802","729","","34","100");
INSERT INTO supplier_product VALUES("803","730","","34","150");
INSERT INTO supplier_product VALUES("804","731","","28","10");
INSERT INTO supplier_product VALUES("805","233","","28","88");
INSERT INTO supplier_product VALUES("806","732","","25","350");



DROP TABLE synchronizer_setting;

CREATE TABLE `synchronizer_setting` (
  `id` int NOT NULL,
  `hostname` varchar(100) NOT NULL,
  `username` varchar(100) NOT NULL,
  `password` varchar(100) NOT NULL,
  `port` varchar(10) NOT NULL,
  `debug` varchar(10) NOT NULL,
  `project_root` varchar(100) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;




DROP TABLE tax_collection;

CREATE TABLE `tax_collection` (
  `id` int NOT NULL AUTO_INCREMENT,
  `date` date NOT NULL,
  `customer_id` varchar(30) NOT NULL,
  `relation_id` varchar(30) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `customer_id` (`customer_id`)
) ENGINE=InnoDB AUTO_INCREMENT=83 DEFAULT CHARSET=utf8mb3;

INSERT INTO tax_collection VALUES("1","2024-01-12","1","1825555996");
INSERT INTO tax_collection VALUES("2","2024-01-14","1","4716432385");
INSERT INTO tax_collection VALUES("3","2024-01-14","1","9569935962");
INSERT INTO tax_collection VALUES("4","2024-01-15","1","7817721484");
INSERT INTO tax_collection VALUES("5","2024-01-15","1","8174999964");
INSERT INTO tax_collection VALUES("6","2024-01-15","1","3436178181");
INSERT INTO tax_collection VALUES("7","2024-01-15","1","3176418784");
INSERT INTO tax_collection VALUES("8","2024-01-17","1","5259796836");
INSERT INTO tax_collection VALUES("9","2024-01-17","1","8476852622");
INSERT INTO tax_collection VALUES("10","2024-01-17","1","6952439647");
INSERT INTO tax_collection VALUES("11","2024-01-21","1","3772222985");
INSERT INTO tax_collection VALUES("12","2024-01-21","1","6757221714");
INSERT INTO tax_collection VALUES("13","2024-01-21","1","6598314449");
INSERT INTO tax_collection VALUES("14","2024-01-21","1","9612173125");
INSERT INTO tax_collection VALUES("15","2023-12-24","2","5845776228");
INSERT INTO tax_collection VALUES("16","2023-12-24","2","6124985648");
INSERT INTO tax_collection VALUES("22","2023-12-25","2","4977174268");
INSERT INTO tax_collection VALUES("23","2023-12-25","2","4612744893");
INSERT INTO tax_collection VALUES("24","2023-12-26","2","2567782964");
INSERT INTO tax_collection VALUES("25","2023-12-27","2","9779858312");
INSERT INTO tax_collection VALUES("27","2023-12-28","2","3284257142");
INSERT INTO tax_collection VALUES("28","2023-12-30","2","9175169491");
INSERT INTO tax_collection VALUES("31","2024-01-01","2","8115955164");
INSERT INTO tax_collection VALUES("32","2024-01-02","2","6448414167");
INSERT INTO tax_collection VALUES("33","2024-01-03","2","7816741612");
INSERT INTO tax_collection VALUES("35","2023-12-31","2","5669212287");
INSERT INTO tax_collection VALUES("37","2024-01-04","2","4995667463");
INSERT INTO tax_collection VALUES("40","2024-01-06","2","7328171614");
INSERT INTO tax_collection VALUES("41","2024-01-07","2","6686419811");
INSERT INTO tax_collection VALUES("43","2024-01-08","2","4856684174");
INSERT INTO tax_collection VALUES("44","2024-01-09","2","1826916967");
INSERT INTO tax_collection VALUES("45","2024-01-10","2","5976692598");
INSERT INTO tax_collection VALUES("46","2024-01-11","2","3371369953");
INSERT INTO tax_collection VALUES("48","2024-01-11","2","7976724629");
INSERT INTO tax_collection VALUES("50","2024-01-13","2","1249729836");
INSERT INTO tax_collection VALUES("52","2024-01-14","2","9759274115");
INSERT INTO tax_collection VALUES("55","2024-01-15","2","7677745934");
INSERT INTO tax_collection VALUES("59","2024-01-17","2","6139664445");
INSERT INTO tax_collection VALUES("60","2024-01-18","2","9814175468");
INSERT INTO tax_collection VALUES("61","2024-01-20","2","8729851784");
INSERT INTO tax_collection VALUES("62","2024-01-21","2","2724633553");
INSERT INTO tax_collection VALUES("64","2024-01-16","2","4651242384");
INSERT INTO tax_collection VALUES("66","2024-01-22","2","8125379816");
INSERT INTO tax_collection VALUES("68","2024-01-23","2","7644324833");
INSERT INTO tax_collection VALUES("69","2024-01-24","2","1345623824");
INSERT INTO tax_collection VALUES("70","2024-01-25","2","5144393325");
INSERT INTO tax_collection VALUES("73","2024-01-27","2","4148625191");
INSERT INTO tax_collection VALUES("76","2024-01-28","2","4365216877");
INSERT INTO tax_collection VALUES("77","2024-01-29","2","4863552591");
INSERT INTO tax_collection VALUES("78","2024-01-31","2","1589449478");
INSERT INTO tax_collection VALUES("79","2024-01-30","2","4687811218");
INSERT INTO tax_collection VALUES("80","2024-01-31","2","9619147336");
INSERT INTO tax_collection VALUES("82","2024-02-01","2","2744992295");



DROP TABLE tax_settings;

CREATE TABLE `tax_settings` (
  `id` int NOT NULL AUTO_INCREMENT,
  `default_value` float NOT NULL,
  `tax_name` varchar(250) NOT NULL,
  `nt` int NOT NULL,
  `reg_no` varchar(100) NOT NULL,
  `is_show` tinyint NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;




DROP TABLE units;

CREATE TABLE `units` (
  `id` int NOT NULL AUTO_INCREMENT,
  `unit_id` varchar(255) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `unit_name` varchar(255) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `status` int NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=26 DEFAULT CHARSET=utf8mb3;

INSERT INTO units VALUES("1","554B64LDTEA571S","dozen","1");
INSERT INTO units VALUES("2","GFCTN46CE6PZ2SH","nos","1");
INSERT INTO units VALUES("3","XQUIMX4EV7T4PVG","pcs","1");
INSERT INTO units VALUES("4","2IQ189F3L74CCT7","coil","1");
INSERT INTO units VALUES("15","7VGWJJ8Z298COL3","Gross","1");
INSERT INTO units VALUES("16","4845PL714PSLOZJ","Bundel","1");
INSERT INTO units VALUES("17","Q92AWJBZYQNQWBW","Roll","1");
INSERT INTO units VALUES("18","K5IOJGVF3GPPSNN","Foot","1");
INSERT INTO units VALUES("19","JFICGLTJM1L5VYO","Yard","1");
INSERT INTO units VALUES("20","AES5RKWHDD7VGO5","Meter","1");
INSERT INTO units VALUES("21","L7T4THSPFH7YKGG","packet","1");
INSERT INTO units VALUES("22","2RK37AIXMF8WTGP","KG","1");
INSERT INTO units VALUES("23","M31KEYFECM3B6DJ","Liter","1");
INSERT INTO units VALUES("24","66P5CWHVWTRL1ZJ","gallan ","1");
INSERT INTO units VALUES("25","81C37CGRWOPSSN7","Length","1");



DROP TABLE user_login;

CREATE TABLE `user_login` (
  `id` int NOT NULL AUTO_INCREMENT,
  `user_id` varchar(15) NOT NULL,
  `username` varchar(255) NOT NULL,
  `password` varchar(255) DEFAULT NULL,
  `user_type` int DEFAULT NULL,
  `security_code` varchar(255) DEFAULT NULL,
  `status` int NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3;

INSERT INTO user_login VALUES("1","2","admin@example.com","6b35440c019a130a39fb51deaaf663d8","1","","1");
INSERT INTO user_login VALUES("2","1","admin@admin.com","4023fd6260a66a8b7f77d5a15657d21a","1","","1");



DROP TABLE users;

CREATE TABLE `users` (
  `id` int NOT NULL AUTO_INCREMENT,
  `user_id` varchar(15) NOT NULL,
  `last_name` varchar(255) NOT NULL,
  `first_name` varchar(255) NOT NULL,
  `company_name` varchar(250) DEFAULT NULL,
  `address` text,
  `phone` varchar(20) DEFAULT NULL,
  `gender` int DEFAULT NULL,
  `date_of_birth` varchar(255) DEFAULT NULL,
  `logo` varchar(250) DEFAULT NULL,
  `status` int NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3;

INSERT INTO users VALUES("1","2","DEV","ALHAMD","","","","","","http://localhost/saleserp_v9.8/assets/dist/img/profile_picture/profile.jpg","1");
INSERT INTO users VALUES("2","1","Millat traders","Yazdan","","","","","","https://millattraders.com/saleserp/assets/dist/img/profile_picture/6a6282455b5294136625407ce091c455.jpg","1");



DROP TABLE web_setting;

CREATE TABLE `web_setting` (
  `setting_id` int NOT NULL AUTO_INCREMENT,
  `logo` varchar(255) DEFAULT NULL,
  `invoice_logo` varchar(255) DEFAULT NULL,
  `favicon` varchar(255) DEFAULT NULL,
  `currency` varchar(10) DEFAULT NULL,
  `timezone` varchar(150) NOT NULL,
  `currency_position` varchar(10) DEFAULT NULL,
  `footer_text` varchar(255) DEFAULT NULL,
  `language` varchar(255) DEFAULT NULL,
  `rtr` varchar(255) DEFAULT NULL,
  `captcha` int DEFAULT '1' COMMENT '0=active,1=inactive',
  `site_key` varchar(250) DEFAULT NULL,
  `secret_key` varchar(250) DEFAULT NULL,
  `discount_type` int DEFAULT '1',
  PRIMARY KEY (`setting_id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3;

INSERT INTO web_setting VALUES("1","http://localhost/saleserp_v9.5/./my-assets/image/logo/b9","http://localhost/saleserp_v9.5/./my-assets/image/logo/b98567c5bfbbd1a6709a9b6ae5ff279a.png","https://softest8.bdtask.com/saleserp_sas_v-2/my-assets/image/logo/0bb2ee8377d8672d55b553ef11f07d69.png","PKR","Asia/Karachi","0","CopyrightÂ© 2018-2019 ALHAMDDEVELOPERS. CONTACT : 03153855234-03161309746. All rights reserved.","english","0","1","6LdiKhsUAAAAAMV4jQRmNYdZy2kXEuFe1HrdP5tt","6LdiKhsUAAAAAMV4jQRmNYdZy2kXEuFe1HrdP5tt","1");



